
import com.jdcm.eltrx.*;
import com.jdcm.editors.*;
import java.awt.*;
import java.awt.event.ComponentEvent;
import java.util.Timer;
import java.util.TimerTask;

/**
 * Autorun like use to access any program in the JAR.<br> with &lt applet
 * codebase="." code="ACY.class" archive="4_EltRx.jar" width=100% height=100%&gt
 * optional : &ltPARAM NAME="type" VALUE="XML"&gt<br> &lt/applet&gt <br> TYPE
 * value will start with program.<br> If no PARAM ...=> display a button bar to
 * select <br>
 *
 * @author Marc GIBOIN
 */
public class ACY extends java.applet.Applet {
// for serializable interface

    private static final long serialVersionUID = 1L;
    private Timer timerrepaint;
    private String lbl = "";
    // javax.swing.JScrollPane pedit;
    private javax.swing.JPanel pedit;
    private java.awt.Panel psel;
    private java.awt.Checkbox chk1;
    private String type = null;
    private javax.swing.JRadioButton[] buts;

    @Override
    public void init() {
        //  Font font = new java.awt.Font("Serif", Font.PLAIN, 12);
        //  setFont(font);
        try {
            type = getParameter("type");
        } catch (java.lang.NullPointerException e) {
            System.out.println("Applet stub field seems null");
        }
        if (type == null) {
            type = "empty";
        }
    }

    public String getSelection() {
        for (javax.swing.JRadioButton b : buts) {
            if (b.isSelected()) {
                return b.getText();
            }
        }
        return "";
    }

    public javax.swing.JPanel getPanelEdit() {
        return pedit;
    }

    @Override
    public void start() {
        //pedit = new javax.swing.JScrollPane();
        this.setLayout(new java.awt.BorderLayout());

        pedit = new javax.swing.JPanel();
        pedit.setLayout(new java.awt.BorderLayout());
        pedit.setBackground(java.awt.Color.darkGray);
        if (type.startsWith("empty") == false) {
            add(pedit, java.awt.BorderLayout.CENTER);
            ACY_action a = new ACY_action(this, type);
            a.actionPerformed(null);
            tolog("started with parameter : " + type);
            refresh();
        } else {
            tolog("parameter 'type' not set ");
            psel = new java.awt.Panel();
            psel.setBackground(java.awt.Color.lightGray);
            pedit.setBounds(0, 0, this.getWidth(), this.getHeight() - 50);
            add(psel, java.awt.BorderLayout.NORTH);
            add(pedit, java.awt.BorderLayout.CENTER);
            chk1 = new java.awt.Checkbox("Frame");
            chk1.setState(false);
            psel.add(chk1);
            javax.swing.ButtonGroup butg = new javax.swing.ButtonGroup();
            buts = new javax.swing.JRadioButton[8];
            buts[0] = new javax.swing.JRadioButton("JDataCom");
            buts[1] = new javax.swing.JRadioButton("Editors");
            buts[2] = new javax.swing.JRadioButton("XML");
            buts[3] = new javax.swing.JRadioButton("Obj");
            buts[4] = new javax.swing.JRadioButton("Terminal");
            buts[5] = new javax.swing.JRadioButton("Chart");
            buts[6] = new javax.swing.JRadioButton("USB");
            buts[7] = new javax.swing.JRadioButton("Decode");
            for (javax.swing.JRadioButton but : buts) {
                psel.add(but);
                butg.add(but);
                but.addActionListener(new ACY_action(this));
            }
            buts[5].setSelected(true);
            // should be managed by setSelected & refresh (+ Action Listner) but...
            (new ACY_action(this)).actionPerformed(null);
            refresh();
        }

    }

    /**
     * made because NB6.9=>Out warnings
     *
     */
    public void tolog(String message) {
        System.out.println(message);
    }

    public void refresh() {
        if (timerrepaint == null) {
            timerrepaint = new Timer();
        }
        pedit.repaint();
        //tolog("repainted");
        timerrepaint.schedule(new TimerTask() {
            @Override
            public void run() {
                refresh();
            }
        }, 100);
    }

    public void adaptpanel(Dimension d) {
        pedit.setPreferredSize(d);
    }

    public void setlabel(String txt) {
        lbl = txt;
    }

    public boolean isFrame() {
        if (chk1 == null) {
            return false;
        }
        return chk1.getState();
    }

    public void addPanel(Component c) {
        if (pedit.getComponentCount() > 0) {
            pedit.removeAll();
        }
        //    pedit.setPreferredSize(c.getSize());
        pedit.add(c, -1);
        c.setBounds(120, 10, 700, 700);
        // pedit.setViewportView(c);
        c.setVisible(true);
        //???? Pb repaint()?
        // pedit.setBounds(0,0,this.getWidth(),pedit.getHeight());
        pedit.repaint();

        this.resize(this.getSize());
    }

    @Override
    public void paint(Graphics g) {
        //  g.drawLine(100, 100, 500,300);
    }

    @Override
    public void stop() {
        if (pedit != null) {
            pedit.removeAll();
        }
        if (psel != null) {
            psel.removeAll();
        }
        if (timerrepaint != null) {
            timerrepaint.purge();
            timerrepaint.cancel();
        }
    }

    public static void main(String[] args) {
        System.out.print("test ");
        ACY _ui = new ACY();
        Frame frame = new javax.swing.JFrame();
        frame.add(_ui);
        frame.setBounds(100, 100, 800, 500);
        _ui.init();
        _ui.start();
        frame.setVisible(true);
        // could be better with something like "JFrame.setDaultCloseOperation()"
        frame.addComponentListener(new java.awt.event.ComponentAdapter() {
            @Override
            public void componentHidden(ComponentEvent e) {
                super.componentHidden(e);
                System.exit(0);
            }
        });
    } // end of main (method of MouseRotate2App)
}

class ACY_action implements java.awt.event.ActionListener {

    ACY applet;
    javax.swing.JFrame a;

    public ACY_action(ACY g) {
        super();
        applet = g;
        applet.setlabel("Starting..");
    }

    public ACY_action(ACY g, String txt) {
        super();
        applet = g;
        applet.setlabel("Starting..");
        startApplet(txt);
    }

    @Override
    public void actionPerformed(java.awt.event.ActionEvent evt) {
        // graph.setlabel("Starting.."); 
        //evt is null for start
        try {
            a = null;
            String selector = applet.getSelection();
            System.out.println(" starting selection" + selector);
            if (evt != null && evt.getSource() instanceof javax.swing.JRadioButton) {
                selector = ((javax.swing.JRadioButton) evt.getSource()).getText();
                System.out.println(" starting found on source" + selector);
            }
            startApplet(selector);
            System.out.println(" started with " + selector);
        } catch (Exception ex) {
            //tolog("aplet =>" + ex.toString());
        }
        //  applet.repaint();
    }

    private void startApplet(String selector) {
        boolean isframe = applet.isFrame();
        if (selector.compareTo("JDataCom") == 0) {
            C_Main f = new C_Main(!isframe);
            if (f.getSkin() instanceof javax.swing.JFrame) {
                a = (javax.swing.JFrame) f.getSkin();
            }
        }
        if (selector.compareTo("Editors") == 0) {
            a = new A_editors(!isframe);
        } /*else if (selector.compareTo("XML") == 0) {
            //   c = new F_XML("ETHERNET", "Descriptors");
            a = new F_XML(!isframe, "RFC1086", "Descriptors");
        }*/ else if (selector.compareTo("Obj") == 0) {
            a = new F_Object(!isframe);
        } else if (selector.compareTo("Terminal") == 0) {
            System.out.println("will " + selector);
            a = new F_Terminal(!isframe);
            System.out.println("created " + a.toString());
        } else if (selector.compareTo("Chart") == 0) {
            a = new com.jdcm.charts.F_charts(!isframe);
        } else if (selector.compareTo("USB") == 0) {
            a = new com.jdcm.editors.F_USB(!isframe);
        } else if (selector.compareTo("Decode") == 0) {
            javax.swing.JPanel ce = new com.jdcm.analyse.P_CodeEditor(!isframe, new com.jdcm.analyse.Code_Model(null, "this is an exemple\r\nof a csv file\r\n".getBytes(), "CSV"));
                a=new javax.swing.JFrame("Decoder");
                a.add(ce);
                a.setSize(ce.getPreferredSize());
                a.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
        }
        if (a != null) {
            System.out.println("started " + a.toString());
            a.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
        }
        applet.getPanelEdit().removeAll();
        if (a != null) {
            if (!isframe) {
                applet.getPanelEdit().add(a.getRootPane(), java.awt.BorderLayout.CENTER);
                System.out.println("bounds: " + applet.getSize().toString());
                applet.getPanelEdit().getComponent(0).setPreferredSize(applet.getPanelEdit().getSize());
            }
            a.repaint(10);
        }
        applet.setlabel("end of applet Action");
    }
}
