package com.jdcm.analyse;

import com.jdcm.common.D_Utils;

/**
 * Field of a protocol Decode result a field is a set of byte with
 * description/name/visible<br>ofset/size/first/<br> sproto/nproto/sizecode/Class
 *
 * @author Marc GIBOIN
 */
public class C_Field { //implements Cloneable

    private final D_Utils TUtils = new D_Utils();
    // Name: name of the field
    private final String Name;
// Desc : the field simple description
    private final String Desc;
    // Desc2 : the field extended description
    private final String Desc2;
  //  private final int Level;
   //  private int level;
    // name of the Code used to read the field data
    private final String Code;
    private boolean encode = false;

    // Ofset: the first data byte of the field
    private int Ofset;
    private int Size;
    // number of the first byte of the field in the packet
    private int First;

    // the number of the decoded row
    private int Idx;

    private String Format;
    private boolean Visible;
    private String Val_Desc;
    private Object Val_Value;
    private int SPlevel;
    private String SPname;
    private int SPofset;
    // from encode...
    private String Mand = null;
    private int Finalsize = -1;
    private String SizeCode = null;
    private String[] Values = null;
    private String[] Valdescs = null;
    private String Sizetxt = null;
    private String Class = null;
    private byte[] Fi_buffer = null;
    private boolean Sproto = false;
    private Integer Memin = -1;

    /**
     * create a new field
     *
     * @param Fi_name the field name
     * @param Fi_Desc2 field othe descritption (references/englissh)
     * @param Fi_desc field significations
     * @param Fi_ofset the first data byte of the field
     * @param Fi_size the size of the field
     * @param Fi_first the first byte of the field in the packet
     * @param Fi_code the code to use to display the data
     * @param Fi_visible unvisible is not set in DB and in tree(?)
     * @param Va_Desc the Value as selected item description
     * @param Va_Value the Value as selected item
     *
     */
    public C_Field( String Fi_name, String Fi_desc,
            String Fi_Desc2, int Fi_ofset, int Fi_size, int Fi_first,
            String Fi_code, boolean Fi_visible, String Va_Desc, Object Va_Value) {
        Desc = Fi_desc;
        Val_Value = Va_Value;
        Val_Desc = Va_Desc;
        Desc2 = Fi_Desc2;
        First = Fi_first;
        Ofset = Fi_ofset;
        Size = Fi_size;
        Code = Fi_code;
        Name = Fi_name;
  //      Level = Fi_level;
        Visible = Fi_visible;
    }

    /**
     * create a new field //TODO : feel difference with previous
     *
     * @param Fi_name the name of the field
     * @param Fi_desc the descritption of this field
     * @param Fi_Desc2 the complement description (references)
     * @param sizetxt the size of the field in byte
     * @param sizecode the size of the code
     * @param Fi_code the code of the field (DEC/BYTE/ASCII)
     * @param Fi_format format
     * @param Fi_class the class use to get the final value
     * @param mand manadatory field or optional
     * @param memin store alue
     * @param sproto the sub-protocol name
     * @param values the value of this field
     * @param Vdesc the value description spécific of the field
     */
    public C_Field(String Fi_name, String Fi_desc, String Fi_Desc2,
            String sizetxt, String sizecode, String Fi_code, String Fi_format, String Fi_class,
            String mand, int memin, boolean sproto, String[] values, String[] Vdesc) {
        encode = true;
   //     Level = Fi_level;
        Desc = Fi_desc;
        Desc2 = Fi_Desc2;
        Code = Fi_code;
        Class = Fi_class;
        Name = Fi_name;
        Format = Fi_format;
        Mand = mand;
        Sizetxt = sizetxt;
        SizeCode = sizecode;
        Values = values;
        Sproto = sproto;
        Valdescs = Vdesc;
        Finalsize = 0;
        Memin = memin;
    }

    public void setProto(String name, int lvl, int oft, int idx) {
        SPlevel = lvl;
        SPname = name;
        SPofset = oft;
        Idx = idx;
    }

    /**
     * get the contents of the field
     *
     * @return the byte
     */
    public byte[] getbuffer() {
        return Fi_buffer;
    }

    /**
     * set the contents of the field
     *
     * @param buff
     */
    public void setbuffer(byte[] buff) {
        Fi_buffer = buff;
    }

    /**
     * set a field value for a column name
     *
     * @param headername
     * @param val
     */
    public void setvalue(String headername, Object val) {
        if (headername.compareTo("Value") == 0) {
            Val_Value = val;
        } else if (headername.compareTo("First") == 0) {
            First = (Integer) val;
        } else if (headername.compareTo("Size") == 0) {
            Size = (Integer) val;
        } else if (headername.compareTo("Ofset") == 0) {
            Ofset = (Integer) val;
        }
    }

    public <U> U getvalue(String headername, U obj) {
        return (U) getvalue(headername);
    }

    /**
     * get the value of the headername to be displayer
     *
     * @param headername name of the columnto display
     * @return the Object
     */
    public Object getvalue(String headername) {
        if (headername.compareTo("Nb") == 0) {
            return Idx;
        } else if (headername.compareTo("Description") == 0) {
            return Desc;
        } else if (headername.compareTo("Value") == 0) {
            return Val_Value;
        } else if (headername.compareTo("Choice") == 0) {
            if (encode == false) {
                return null;
            } else {
                if (Sproto) {
                    return null;
                }
                if (Values == null) {
                    if (Val_Value != null) {
                        return Val_Value;
                    }
                    return TUtils.createObj(TUtils.getrealclass(Class));
                } else {
                    String[] res = new String[Values.length];
                    int idx = -1;
                    String txt = null;
                    if (Val_Value instanceof byte[]) {
                        txt = TUtils.tabTostr((byte[]) Val_Value, " ".charAt(0));
                    }
                    for (int i = 0; i < Values.length; i++) {
                        res[i] = Values[i] + "=>" + Valdescs[i];
                        if (txt != null && Values[i].compareTo(txt.trim()) == 0) {
                            idx = i;
                        }
                    }
                    javax.swing.DefaultComboBoxModel<String> box = new javax.swing.DefaultComboBoxModel<>(res);
                    if (idx >= 0) {
                        box.setSelectedItem(res[idx]);
                    }
                    return box;
                }
            }
        } else if (headername.compareTo("VDesc") == 0) {
            return Val_Desc;
        } else if (headername.compareTo("Detail") == 0) {
            return Desc2;
        } else if (headername.compareTo("First") == 0) {
            return (First + SPofset);
        } else if (headername.compareTo("Ofset") == 0) {
            return Ofset;
        } else if (headername.compareTo("Sizetxt") == 0) {
            return Sizetxt;
        } else if (headername.compareTo("Size") == 0) {
            return Size;
        } else if (headername.compareTo("SizeCode") == 0) {
            return SizeCode;
        } else if (headername.compareTo("Code") == 0) {
            return Code;
        } else if (headername.compareTo("Format") == 0) {
            return Format;
        } else if (headername.compareTo("Visible") == 0) {
            return Visible;
        } else if (headername.compareTo("Class") == 0) {
            if (Val_Value == null) {
                return "null";
            }
            return Val_Value.getClass().getSimpleName();
        } else if (headername.compareTo("Name") == 0) {
            return Name;
        } else if (headername.compareTo("Level") == 0) {
            return (SPlevel );//+ level);
        } else if (headername.compareTo("Proto") == 0) {
            return SPname;
        } else if (headername.compareTo("Buffer") == 0) {
            return Fi_buffer;
        } else if (headername.compareTo("Memin") == 0) {
            return Memin;
        } else {
            return null;
        }
    }

    public int getabsfirst() {
        return (First + SPofset);
    }

    public int getSize() {
        return Size;
    }
}
