package com.jdcm.analyse;

import com.jdcm.common.C_Packet;
import com.jdcm.common.D_Utils;
import com.jdcm.common.XMLres;
import com.jdcm.eltrx.C_Main;
import com.jdcm.eltrx.C_Port;
import com.jdcm.eltrx.D_Debug;
import com.jdcm.eltrx.I_Port;
import java.io.File;
import static java.lang.Thread.sleep;
import java.util.*;
import javax.swing.DefaultComboBoxModel;
import javax.swing.table.*;
import javax.swing.tree.*;

/**
 * Code_Model.java Created on 3 aout 2007, 18:19:29
 *
 * Model used to receive Decoding informations<br> !!!!!!!!!!!!!!! un Option
 * Model pour le codeModel....
 *
 * @author Marc GIBOIN
 */
public class Code_Model extends AbstractTableModel implements Cloneable {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private D_Debug TDeb;
    private D_Utils TUtils = new D_Utils();
    private boolean Desc = false;
    private boolean DESC_in = false;
    private boolean DESC_panel = false;
    private File DESC_protofirst = null;
    private File DESC_protolast = null;
    private C_Packet Pack = null;
    private I_Code_Parent Parent = null;
    private java.util.List<C_Field> rows = new java.util.ArrayList<>();
    private String[] columnNames = null;
    private byte[] initbuffer = new byte[0];
    //  fcond are OK; will send on next fdata
    boolean fcondFeel = false;
    private byte[] buffer = null;
    // position in the buffer teached by to decoder
    private int ibuff_pos = 0;
    //name of the used protocol
    private String activ_file = null;
    // list of used protocol decoders
    // list of protocols out of Descripteurs
    private List<java.io.File> proto_custom = new ArrayList<>();
    private D_Utils.simpleListNode<String> protoNames = null;
    private List<String> proto_desc = null;
    private java.util.Map<String,String> proto_files = null;
    //TODO Change to a LinkedHashMap<File,MutableTree> bad idee because String allow ..??Linked to maintain order
    private LinkedHashMap<String, DefaultTreeModel> proto_tree = null;
    // niveau hierachique du sous protocol par rapport au protocol
    private int sprotolevel;
    // offset du (sous) protocole (octet deja decod�s)
    private int sprotooffset;
    // flag to signal if amodel/field is to be send after decode
    private boolean istosend = true;
    // a bitmap array for ISO8583decode
    public boolean[] BMap = null;
    // private boolean autostack = false;
    private java.util.Date starttime = null;
    private java.util.Date endtime = null;
    //  private int source=-1;
    private java.util.Map<Integer, byte[]> memory = null;
    // flag to know if a stop of code thread is asked
    private int stop_decode;
    // buffer of received data from CX (to Wait_answer & check answer)
    private byte[] rcved_buff;
    //encode
    private boolean encode = false;
    // boolean to wait the "next button" to perform a next field
    private boolean encodewaitnext = true;
    // List of protocols_tree to avoid protocol loading to each packets
    // to re organized to get One type...
    //private java.util.List vproto = null;
    // tree that represent curent protocol...
    //index of the current protocol name (!!!tree is next index!!!)
 //   private String proto_curent = null;

    /**
     * Model for Terminal DECODE
     *
     * @param parent port used for model data flow / slider/EOF
     * @param proto name of the protocol xml file
     */
    public Code_Model(I_Code_Parent parent, String proto) {
        Parent = parent;
        Pack = new C_Packet(null);
        encode = false;
        TDeb = new D_Debug("CModel");
        TDeb.setconsole(Parent.getConsole());
        initProtoLabels(proto, null);
        DefaultComboBoxModel<File> cbox = Parent.getCMDOptions().getValuefor("DESC_Protolast", new DefaultComboBoxModel<File>());
        cbox.setSelectedItem(cbox.getElementAt(0));//"0NULL"// decode allsub proto
        initModel();
        TDeb.wri("created with proto : " + protoNames.getUserObjectLastPath().get(0));
    }

    /**
     * Model for Terminal DECODE
     *
     * @param parent port used for model data flow / slider/EOF
     * @param proto name of the protocol xml file
     * @param buff the byte array to decode
     */
    public Code_Model(I_Code_Parent parent, byte[] buff, String proto) {
        Parent = parent;
        Pack = new C_Packet(buff);//,null=>parent...
        encode = false;
        TDeb = new D_Debug("CModel");
        if (Parent != null) {
            TDeb.setconsole(Parent.getConsole());
        }
        initProtoLabels(proto, new C_Packet(buff));
        //  setDESC_autostack(Parent.getOptionsModel().getValuefor("DESC_autostack", true));
        initModel();
        TDeb.wri("created ");
        setbuffer(buff);
        setinitbuffer();
        settosend(false);
        createDec();
    }

    public Code_Model(I_Code_Parent parent, C_Packet pack, String proto) {
        this(parent, pack.getBytes(), proto);
    }

    /**
     * Model for DataStream Idee decoding object => toByte[]?? or Object xml?
     *
     * @param parent port used for model data flow / slider/EOF
     * @param pack Packet to decode
     */
    public Code_Model(I_Code_Parent parent, C_Packet pack) {
        Parent = parent;
        Pack = pack;
        //?? if made in other plaer
        if (parent == null || pack == null) {
            return;
        }
        encode = false;
        Parent.setinitDESCPack(pack);
        TDeb = new D_Debug("CModel");
        if (Parent != null) {
            TDeb.setconsole(Parent.getConsole());
            DefaultComboBoxModel<File> cbox = Parent.getCMDOptions().getValuefor("DESC_Protofirst", new DefaultComboBoxModel<File>());
            setDESC_Protofirst((java.io.File) cbox.getSelectedItem());
            cbox = Parent.getCMDOptions().getValuefor("DESC_Protolast", new DefaultComboBoxModel<File>());
            setDESC_Protolast((java.io.File) cbox.getSelectedItem());
            setDESC_panel(Parent.getCMDOptions().getValuefor("DESC_panel", true));
        }
        initModel();
        TDeb.wri("created with Packet : " + pack.toString());
    }
    // Model for Terminal ENCODE

    public Code_Model(I_Code_Parent parent) {
        Parent = parent;
        encode = true;//??
        if (Parent instanceof I_Port) {
            Pack = new C_Packet(null, (I_Port) Parent);
        } else {
            Pack = new C_Packet(null);
        }
        TDeb = new D_Debug("CModel");
        if (Parent != null) {
            TDeb.setconsole(Parent.getConsole());
        }
        // setDESC_Protolast(getDESC_Protofirst());
        initModel();
    }
    // Model autonomous Form

    public Code_Model() {
        encode = true;
        Pack = new C_Packet(null);
        TDeb = new D_Debug("CModel");
        setDESC_Protolast(getDESC_Protofirst());
        initModel();
    }

    private void initModel() {
        protoNames = new D_Utils.simpleListNode<>();
        proto_desc = new java.util.ArrayList<>();
        proto_files = new java.util.HashMap<>();
        proto_tree = new LinkedHashMap<>();
        starttime = new java.util.Date(System.currentTimeMillis());
        setencode(encode);
        //!0+1(field level)=> first level for forst field
        sprotolevel = 0;
        sprotooffset = 0;
        stop_decode = 0;
        rcved_buff = null;
        memory = new java.util.HashMap<>();
        if (Pack.getBytes() != null && DESC_panel && Parent != null) {
            Parent.setAcc_position(Pack.getBytes().length);
        }
    }

    public int waitCodeEnds(int TO) {
        long loopTO = System.currentTimeMillis() + TO;
        while (getendtime() == null) {
            if (loopTO < System.currentTimeMillis()) {
                // TDeb.wri("Decode Problem TO with packet : " + analysedPack);
                return -1;
            }
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                TDeb.wri("waitCodeEnds()=>"+ex.getMessage());
            }
        }
        return 0;
    }

    private void initProtoLabels(String protocmd, C_Packet pack) {
        java.util.LinkedList<String> res = new java.util.LinkedList<>();
        if (pack != null && pack.isbuffer() == true
                && pack.getBytes().length > 0
                && protocmd != null && protocmd.compareTo("auto") == 0) {
            java.util.LinkedList<String> list = getMatchingStacks(pack);
            if (list != null) {
                res.addAll(list);
                TDeb.wri(" Found protocols : " + res);
            } else {
                TDeb.wri(" no protocols founds");
            }
        } else if (protocmd != null) {
            res.add(protocmd);
        }
        if (res.isEmpty()) {
            res.add("0NULL");
        }
        if (!res.isEmpty()) {
            setDESC_Protofirst(TUtils.getFile(res.get(0) + ".xml", "Descriptors"));
            /*  if (res.size() > 1) {
             setDESC_Protolast(TUtils.getFile(res.getLast() + ".xml", "Descriptors"));
             } else {
             setDESC_Protolast(null);
             }*/
            setDESC_Protolast(new java.io.File("none"));
            TDeb.wri("detected protocols : " + getDESC_Protofirst());
        }
    }

    public void addpCustomProto(java.io.File f) {
        proto_custom.add(f);
    }

    public String getConvSignature(String protoName, int startRow) {
        // care that if IP over IP then signature is ???
        if (protoName == null || protoName.length() == 0) {
            return null;
        }
        String sgn = "";
        DefaultTreeModel tm;
        if (proto_tree.containsKey(getFileProtoName(protoName))) {
            tm = proto_tree.get(getFileProtoName(protoName));
        } else {
            return null;
        }
        DefaultMutableTreeNode ana = (DefaultMutableTreeNode) tm.getRoot();
        for (int i = 0; i < ana.getChildCount(); i++) {
            if (ana.getChildAt(i) instanceof DefaultMutableTreeNode) {
                XMLres x = (XMLres) ((DefaultMutableTreeNode) ana.getChildAt(i)).getUserObject();
                if (x.getEltName().compareTo("protocol") == 0 && x.getAttrVal("convSignature") != null) {
                    sgn = x.getAttrVal("convSignature").toString();
                }
            }
        }
        if (sgn == null || sgn.length() == 0) {
            return null;
        }
        // tcp=> convSignature="'src','dest'"
        for (int i = startRow; i < getRowCount(); i++) {
            if (protoName.compareTo(getValueAt(i, "Proto", "")) == 0) {
                String fname = getValueAt(i, "Name", "");
                if (sgn.contains("'" + fname + "'")) {
                    sgn = sgn.replaceAll("'" + fname + "'", getValueAt(i, "Value").toString());
                } else if (fname.contains(":") && sgn.contains("'" + fname.substring(fname.lastIndexOf(":") + 1) + "'")) {
                 // for subProtocol
                    sgn = sgn.replaceAll("'" + fname.substring(fname.lastIndexOf(":") + 1) + "'", getValueAt(i, "Value").toString());
                }
            }
        }
        if (sgn.contains("'")) {
            TDeb.wri("signature not found for : " + sgn);
            return null;
        }
        return sgn;
    }

    public java.util.LinkedList<String> getNextStacks(byte[] buff) {
        C_Packet packet = new C_Packet(buff);
        for (String txt : getProtoNames()) {
            try {
                com.jdcm.modifiers.stacks.I_stack_elt elt = (com.jdcm.modifiers.stacks.I_stack_elt) Class.forName("com.jdcm.modifiers.stacks.Stack_" + this.getFileProtoName(txt)).newInstance();
                packet.addProtocol(elt);
            } catch (ClassNotFoundException | InstantiationException | IllegalAccessException ex) {
            }

        }
        return getMatchingStacks(packet);
    }

    public java.util.LinkedList<String> getMatchingStacks(C_Packet packet) {
        if (packet == null || packet.isbuffer() == false || packet.getBytes().length == 0 || Parent == null) {
            return null;
        }
        if (Parent.getMain() instanceof C_Main == false) {
            return null;
        }
        java.util.List<com.jdcm.modifiers.stacks.I_stack_elt>  protolist;
        ((C_Main) Parent.getMain()).findPacketStacks(packet);
         protolist=packet.getProtocols();
        if (protolist == null || protolist.isEmpty()) {
            return null;
        } else {
            java.util.LinkedList<String> res = new java.util.LinkedList<>();
            // TODO : if two different proto for this buffer then return last one => Pb 
            for  (com.jdcm.modifiers.stacks.I_stack_elt stack: protolist) {
                String txt = stack.getClass().getSimpleName();
                if (txt.startsWith("Stack_")) {
                    res.add(txt.substring("Stack_".length()));
                }
            }
            return res;
        }
    }

    /**
     * receive protocols from decoder to change it !!! should be ONE type BUT
     * badly organised [title/tree/title/tree/title/tree...]
     *
     *
     * @return the treeMap with matchin protocols names
     */
    public LinkedHashMap<String, DefaultTreeModel> getprotocols() {
        return proto_tree;
    }

    public void setprotocols(LinkedHashMap<String, DefaultTreeModel> v) {
        proto_tree = v;
    }

    public void send_model() {
        if (Parent != null) {
            Parent.write_out(new C_Packet(this));
        }
    }

    public void send_buffer() {
        if (Parent != null && getInitBuffer() != null) {
            Parent.write_out(new C_Packet(getInitBuffer()));
        }
    }

    public boolean isDesc() {
        return Desc;
    }

    public void setDesc(boolean bool) {
        if (isDesc() != bool) {
            Desc = bool;
        }
    }

    public DefaultTreeModel getcurrentprotoTree() {
        if (activ_file == null) {
            return null;
        }
        return getprotocols().get(activ_file);
    }

    /*
     * Look for the color in the (loaded) XML File
     * could be easier (but load) by Stack
     */
    public java.awt.Color getProtoColor(String protoName) {
        java.awt.Color res = java.awt.Color.WHITE;
            String file = getFileProtoName(protoName);
            if (file != null && proto_tree.containsKey(file)) {
                javax.swing.tree.DefaultTreeModel tr = proto_tree.get(file);
                if (tr != null && tr.getRoot() instanceof javax.swing.tree.DefaultMutableTreeNode) {
                    javax.swing.tree.DefaultMutableTreeNode ana = (javax.swing.tree.DefaultMutableTreeNode) tr.getRoot();
                    javax.swing.tree.DefaultMutableTreeNode rt = (javax.swing.tree.DefaultMutableTreeNode) ana.getChildAt(0);
                    if (rt.getUserObject() instanceof XMLres) {
                        XMLres x = (XMLres) rt.getUserObject();
                        java.awt.Color colxml = (java.awt.Color) x.getAttrVal("color");
                        if (colxml != null) {
                            return colxml;
                        }
                    }
                }
        }
        return res;
    }

    /**
     * set the protools tree
     *
     * @param fprotoname
     * @return return true if the current protocol tree
     */
    public boolean addProtoTree(String fprotoname) {

        if (fprotoname == null || getprotocols() == null) {
            return false;
        }
        if (getprotocols().containsKey(fprotoname) == false) {
            java.io.File f = TUtils.getFile(fprotoname + ".xml", "Descriptors");
            if (f == null) {
                for (java.io.File fc : proto_custom) {
                    if (fc.getName().compareTo(fprotoname + ".xml") == 0) {
                        TDeb.wri("found Custom file :" + fc);
                        f = fc;
                    }
                }
            }
            java.io.InputStream io = TUtils.getFileStream(f);
            if (io == null) {
                return false;
            } else {
                proto_tree.put(fprotoname, loadProtoTree(io));
            }
        }
        activ_file = fprotoname;
        return true;
    }

    public DefaultTreeModel loadProtoTree(java.io.InputStream inStream) {
        if (inStream == null) {
            return null;
        }
        com.jdcm.common.XML2tree a = new com.jdcm.common.XML2tree();
        DefaultTreeModel restree;
        //a.setorder(attr_order);
        restree = a.XMLBase(inStream);
        if (restree.getRoot() instanceof DefaultMutableTreeNode) {
            DefaultMutableTreeNode nr = (DefaultMutableTreeNode) restree.getRoot();
            for (int nbchld = 0; nbchld < nr.getChildCount(); nbchld++) {
                DefaultMutableTreeNode nc = (DefaultMutableTreeNode) nr.getChildAt(nbchld);
                if (nc.getUserObject() instanceof XMLres
                        && ((XMLres) nc.getUserObject()).getEltName().compareTo("pdml") == 0) {
                    for (int nbchld2 = 0; nbchld2 < nc.getChildCount(); nbchld2++) {
                        DefaultMutableTreeNode ncc = (DefaultMutableTreeNode) nc.getChildAt(nbchld2);
                        if (ncc.getUserObject() instanceof XMLres
                                && ((XMLres) ncc.getUserObject()).getEltName().compareTo("Analyse") == 0) {
                            return new DefaultTreeModel(ncc);
                        }
                    }

                }
            }
        }
        return null;
    }

    public DefaultTreeModel getTree() {
        int lvl = 0;
        if (getRowCount() == 0) {
            return null;
        }
        DefaultMutableTreeNode top = new DefaultMutableTreeNode("Packet");
        try {
            DefaultMutableTreeNode[] level = new DefaultMutableTreeNode[getRowCount() + 1]; // 1 for protocol node
            DefaultMutableTreeNode[] value = new DefaultMutableTreeNode[getRowCount() + 1];
            level[0] = new DefaultMutableTreeNode(getprotostr());
            top.add(level[0]);
            for (int ligne = 0; ligne < getRowCount(); ligne++) {
                String desc = getValueAt(ligne, "VDesc", "");
                if (desc != null) {
                    if (desc.length() > 0) {
                        desc = " =>" + desc;
                    }
                } else {
                    desc = "";
                }
                String descr = getValueAt(ligne, "Description", "");
                if (descr != null && descr.length() > 0) {
                    lvl = 1 + getValueAt(ligne, "Level", 0);
                    level[lvl] = new DefaultMutableTreeNode(descr + desc);
                    level[lvl - 1].add(level[lvl]);
                }
                if (ligne < getRowCount()) {
                    //getvalue return "" for line after rowcount()
                    if (ligne == getRowCount() - 1) {
                        value[ligne] = new DefaultMutableTreeNode(getValueAt(ligne, "Value"));
                        level[lvl].add(value[ligne]);
                    } else {
                        //if next field desc=""=>no leaf for value.
                        if (descr != null && descr.length() > 0) {
                            value[ligne] = new DefaultMutableTreeNode(getValueAt(ligne, "Value"));
                            level[lvl].add(value[ligne]);
                        }
                    }
                }
            }

        } catch (Exception ex) {
            DefaultMutableTreeNode status = new DefaultMutableTreeNode("ERROR [" + ex.getMessage() + "]");
            top.add(status);
            TDeb.wri("Pb during tree creation [" + ex.getMessage() + "]");
        }
        return new DefaultTreeModel(top);
    }

    /**
     *
     *
     *
     * @param sizetxt
     * @param sizecode
     * @param initbuff
     * @param rownb
     * @return
     */
    private byte[] check_size(String sizestr, String sizecode, byte[] initbuff, int rownb) {
        String sizetxt = sizestr;
        byte[] endbuff = null;
        int size = initbuff.length;
        if (sizetxt == null) {
            return initbuff;
        }
        if (sizetxt.startsWith("T")) {
            return initbuff;
        }
        if (sizetxt.startsWith("$")) {
            int off = Integer.parseInt(sizetxt.substring(1));
            sizetxt = new String(this.getmem(off));
        }
        if (sizetxt.length() > 4) {
            String vardesc = "Var/";
            //size="Var/XX" =>XX=> size of the size field (size NOT inclued)
            if (sizetxt.startsWith(vardesc)) {
                if (sizecode == null) {
                    TDeb.wri("Error: codesize should not be null ");
                    return null;
                }
                try {
                    String tsval = sizetxt.substring(vardesc.length());
                    int tsize = Integer.parseInt(tsval);
                    byte[] sizeval = TDeb.prend(sizecode, "" + (size + tsize));
                    while (sizeval.length < tsize) {
                        sizeval = TUtils.addtab(new byte[]{00}, sizeval);
                    }
                    rows.get(rownb).setvalue("Ofset", tsize);
                    return TUtils.addtab(sizeval, initbuff);
                } catch (NumberFormatException ex) {
                    TDeb.wri("Pb searching size Var/.. [" + ex.getMessage() + "]");
                    return null;
                }

            }
            vardesc = "Var[";
            String sep = "]/";
            if (sizetxt.startsWith(vardesc)) {
                if (sizecode == null) {
                    TDeb.wri("Error: codesize should not be null ");
                    return null;
                }
                try {
                    int off = Integer.parseInt(sizetxt.substring(vardesc.length(), sizetxt.lastIndexOf(sep)));
                    int tsize = Integer.parseInt(sizetxt.substring(sizetxt.lastIndexOf(sep) + sep.length()));
                    byte[] sizeval = TDeb.prend(sizecode, "" + size);
                    while (sizeval.length < tsize) {
                        sizeval = TUtils.addtab(new byte[]{00}, sizeval);
                    }
                    byte[] start = java.util.Arrays.copyOf(initbuff, off);
                    endbuff = TUtils.addtab(start, sizeval);
                    if (start.length < initbuff.length) {
                        return TUtils.addtab(endbuff, java.util.Arrays.copyOfRange(initbuff, off, initbuff.length));
                    } else {
                        return endbuff;
                    }
                } catch (NumberFormatException ex) {
                    TDeb.wri("Pb searching size Var/.. [" + ex.getMessage() + "]");
                    return null;
                }
            }
            vardesc = "Var-";
            sep = "/";
            if (sizetxt.startsWith(vardesc)) {
                if (sizecode == null) {
                    TDeb.wri("Error: codesize should not be null ");
                    return null;
                }
                int off;
                int tsize;
                try {
                    off = Integer.parseInt(sizetxt.substring(vardesc.length(), sizetxt.lastIndexOf(sep)));
                    tsize = Integer.parseInt(sizetxt.substring(sizetxt.lastIndexOf(sep) + sep.length()));
                } catch (NumberFormatException ex) {
                    TDeb.wri("Pb searching size Var-.. [" + ex.getMessage() + "]");
                    return null;
                }
                byte[] sizeval = TDeb.prend(sizecode, "" + ((size + tsize + 1) - off));
                while (sizeval.length < tsize) {
                    sizeval = TUtils.addtab(new byte[]{00}, sizeval);
                }
                rows.get(rownb).setvalue("Ofset", tsize);
                return TUtils.addtab(sizeval, initbuff);
            }
        }
        if (endbuff == null) {
            int sizeval;
            try {
                sizeval = Integer.parseInt(sizetxt);
            } catch (NumberFormatException ex) {
                TDeb.wri("Pb searching size : " + ex.getMessage() + "");
                return null;
            }
            if (sizeval != size) {
                return java.util.Arrays.copyOf(initbuff, sizeval);
            } else {
                return initbuff;
            }
        }
        return endbuff;
    }

    /**
     *
     * @param i
     */
    private void check_field(int i) {
        if (rows.get(i).getvalue("Value") == null) {
            rows.get(i).setbuffer(null);
            return;
        }
        if (rows.get(i).getvalue("Memin") != null
                && rows.get(i).getvalue("Value") != null) {
            int idx = (Integer) rows.get(i).getvalue("Memin");
            if (idx > 0) {
                this.setmem(idx, rows.get(i).getvalue("Value").toString().getBytes());
            }
        }
        String code = null;
        String format = null;
        String sizetxt = null;
        String sizecode = null;
        if (rows.get(i).getvalue("Code") != null) {
            code = rows.get(i).getvalue("Code").toString();
        }
        if (rows.get(i).getvalue("Format") != null) {
            format = rows.get(i).getvalue("Format").toString();
        }
        if (rows.get(i).getvalue("Sizetxt") != null) {
            sizetxt = rows.get(i).getvalue("Sizetxt").toString();
        }
        if (rows.get(i).getvalue("SizeCode") != null) {
            sizecode = rows.get(i).getvalue("SizeCode").toString();
        }
        byte[] res = TUtils.prend(code, rows.get(i).getvalue("Value"));
        res = check_size(sizetxt, sizecode, res, i);
        rows.get(i).setbuffer(res);
    }

    private void check_fields() {
        int pos = 0;
        for (int i = 0; i < rows.size(); i++) {
            rows.get(i).setvalue("First", pos);
            int siz = 0;
            if (rows.get(i).getbuffer() != null) {
                siz = rows.get(i).getbuffer().length;
            }
            rows.get(i).setvalue("Size", siz);
            pos += siz;
        }
        byte[] buff = new byte[0];
        for (int i = 0; i < rows.size(); i++) {
            buff = TUtils.addtab(buff, rows.get(i).getbuffer());
        }
        initbuffer = buff;
        buffer = buff;
    }

    public void setwaitingnext(boolean bool) {
        check_fields();
        encodewaitnext = bool;
    }

    public boolean iswaitingnext() {
        return encodewaitnext;
    }

    public int getencode_selected() {
        if (encode == false) {
            return -1;
        }
        javax.swing.DefaultComboBoxModel<Object> dcbm = rows.get(rows.size() - 1).getvalue("Choice", new javax.swing.DefaultComboBoxModel<>());
        if (dcbm != null) {
            return dcbm.getIndexOf(dcbm.getSelectedItem());
        }
        return -1;
    }

    public boolean isencode() {
        return encode;
    }

    public void setencode(boolean bool) {
        if (isencode() != bool) {
            encode = bool;
        }
        if (encode) {
            columnNames = new String[]{"Nb", "Description", "Choice", "Value", "Buffer", "VDesc", "Detail", "First", "Ofset", "Size", "Code", "Visible", "Class", "Name", "Level", "Proto"};
        } else {
            columnNames = new String[]{"Nb", "Description", "Value", "VDesc", "Detail", "First", "Ofset", "Size", "Code", "Visible", "Class", "Name", "Level", "Proto"};
        }
        this.fireTableStructureChanged();
    }
    /*
     * public void setDESC_autostack(boolean bool) { autostack = bool; }
     *
     * public boolean isDESC_autostack() { return autostack; }
     */

    public final File getDESC_Protofirst() {
        return DESC_protofirst;
    }

    public final void setDESC_Protofirst(File fi) {
        if (DESC_protofirst != fi) {
            DESC_protofirst = fi;
        }
    }

    public File getDESC_Protolast() {
        return DESC_protolast;
    }

    public final void setDESC_Protolast(java.io.File fi) {
        if (DESC_protolast != fi) {
            DESC_protolast = fi;
        }
    }

    public boolean isDESC_in() {
        return DESC_in;
    }

    public final void setDESC_in(boolean bool) {
        if (isDESC_in() != bool) {
            DESC_in = bool;
        }
    }

    public final void setDESC_panel(boolean bool) {
        DESC_panel = bool;
    }

    public String getDESC_fData() {
        try {
            DefaultComboBoxModel<String> cbox_1 = Parent.getCMDOptions().getValuefor("DESC_fdata", new DefaultComboBoxModel<String>());
            return cbox_1.getSelectedItem().toString();
        } catch (Exception ex) {
            return "-N/A-";
        }
    }

    public String getDESC_fcond() {
        try {
            DefaultComboBoxModel<String> cbox_1 = Parent.getCMDOptions().getValuefor("DESC_fcond", new DefaultComboBoxModel<String>());
            return cbox_1.getSelectedItem().toString();
        } catch (Exception ex) {
            return "-N/A-";
        }
    }

    public byte[] getDESC_condval() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_fcondval", new byte[]{});
        } catch (Exception ex) {
            return null;
        }
    }

    public String getDESC_EOLval() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_EOLval", "");
        } catch (Exception ex) {
            return null;
        }
    }

    public boolean isDESC_EOL() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_EOL", true);
        } catch (Exception ex) {
            return false;
        }
    }

    public Integer getDESC_Offset() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_Offset", 1);
        } catch (Exception ex) {
            return 0;
        }
    }

    public boolean getDESC_TIT() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_TIT", true);
        } catch (Exception ex) {
            return false;
        }
    }

    public int getDESC_TITval() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_TITval", 1);
        } catch (Exception ex) {
            return 50;
        }
    }

    public boolean isDESC_CheckAnsw() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_CheckAnsw", false);
        } catch (Exception ex) {
            return false;
        }
    }

    public boolean isDESC_WaitAnsw() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_WaitAnsw", false);
        } catch (Exception ex) {
            return false;
        }
    }

    public boolean isDESC_WaitLimit() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_WaitLimit", false);
        } catch (Exception ex) {
            return false;
        }
    }

    public int getDESC_WaitLimitval() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_WaitLimitval", 0);
        } catch (Exception ex) {
            return 0;
        }
    }

    public String getDESC_sendas() {
        // return the Desc_sendas if specified 
        //else (port & conversation) "ModelKeep"=> model that is kept when EOL..
        if (Parent == null || Parent.getCMDOptions() == null) {
            return "ModelKeep";
        }

        try {
            DefaultComboBoxModel<String> cbox_1 = Parent.getCMDOptions().getValuefor("DESC_sendas", new DefaultComboBoxModel<String>());
            return cbox_1.getSelectedItem().toString();
        } catch (Exception ex) {
            return "ModelKeep";
        }
    }

    public Integer getDESC_PadTOval() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_PadTOval", 1);
        } catch (Exception ex) {
            return 10;
        }
    }

    public boolean isDESC_PadTO() {
        try {
            return Parent.getCMDOptions().getValuefor("DESC_PadTO", true);
        } catch (Exception ex) {
            return false;
        }
    }

    public java.util.Date getstarttime() {
        return new java.util.Date(starttime.getTime());
    }

    public java.util.Date getendtime() {
        if (endtime != null) {
            return new java.util.Date(endtime.getTime());
        } else {
            return null;
        }
    }

    /**
     * Ask to stop the analyse of this packet
     *
     * @param nb cause of the stop<br> -1 : stop manual<br> -2 : stop & send -3
     * : normal end of this protocol only !!! stop if the fisrt protocol -4 :
     * normal stop of all protocols
     */
    public void setstop(int nb) {
        stop_decode = nb;
    }

    public int getstop() {
        return stop_decode;
    }

    public void setmem(int idx, byte[] buff) {
        memory.put(idx, buff);
    }

    public byte[] getmem(int idx) {
        return memory.get(idx);
    }

    public void setactive_file(String proto_file) {
        activ_file = proto_file;
    }

    public String getactive_file() {
        return activ_file;
    }
    // for decode in terminal=> DO NOT SEND

    public final void settosend(boolean bool) {
        istosend = bool;
    }

    public boolean istosend() {
        return istosend;
    }

    public void setspofset(int val) {
        sprotooffset = val;
    }

    public int getspofset() {
        return sprotooffset;
    }

    public void setsplevel(int val) {
        sprotolevel = val;
    }

    public int getsplevel() {
        return sprotolevel;
    }

    public List<String> getProtoNames() {
        return protoNames.getUserObjectLastPath();
    }

    public void setBMap(boolean[] bm) {
        boolean[] bitmap = bm;
        this.BMap = bitmap;
    }

    public boolean isBMap(int index) {
        return BMap[index];
    }

    public byte[] getBuffer() {
        return buffer;
    }

    public byte[] getInitBuffer() {
        return initbuffer;
    }

    public void setrcved_buff(byte[] buff) {
        byte[] b = buff;
        rcved_buff = b;
    }

    public byte[] getrcvedbuff() {
        return rcved_buff;
    }

    public void setrows(List<C_Field> r) {
        rows = r;
    }

    public void addInitbuffer(byte[] supbuff) {
        ///only initbuffer is updated (buffer may be treated by a Codethread) )
        //! if modifier on level 0 protocol=> use modifier on level >=1 ...
        //! on decode on dataflow=> infinite initbuffer...=> initbuffer<=[buff_pos...]
        if (supbuff == null) {
            return;
        }
        initbuffer = TUtils.addtab(initbuffer, supbuff);
        if (Parent != null) {
            Parent.setAcc_position(initbuffer.length);
        }
        TDeb.wri("ADD buffer [" + supbuff.length + "]/[" + initbuffer.length + "]");
        // System.err.println("ADD buffer [" + supbuff.length + "]/[" + initbuffer.length + "]");
    }

    public final void setinitbuffer() {
        if (buffer == null) {
            return;
        }
        initbuffer=new byte[buffer.length];
        System.arraycopy(buffer, 0,  initbuffer, 0,buffer.length);
        TDeb.wri("set initbuffer [" + initbuffer.length + "]");
    }

    public final void setbuffer(byte[] buff) {
        byte[] bs = buff;
        if (buff == null) {
            return;
        }
        buffer = bs;
        TDeb.wri("set buffer [" + buffer.length + "]");
    }

    public byte[] getfrombuffer(int begin, int size) {
        if (buffer == null) {
            TDeb.wri("getfrombuffer() : null buffer");
            return null;
        }
        if (begin > buffer.length || begin + size > buffer.length) {
            TDeb.wri("getfrombuffer() : impossible copy from byte[" + buffer.length + "] start: " + begin + " size: " + size);
            return null;
        } else {
            return java.util.Arrays.copyOfRange(buffer, begin, begin + size);
        }
    }

    /**
     * If protocol is not already stored in the <br> "protocol buffer" (stored
     * in code Model)
     *
     * @param protoname
     * @param protodesc
     * @param fprotoName file name of the proto file (without .XML)
     */
    public void addproto(String protoname, String protodesc, String fprotoName) {
        java.util.List<String> lastlist = protoNames.getUserObjectLastPath();
        while (lastlist.size() > sprotolevel) {
            lastlist.remove(lastlist.size() - 1);
        }
        protoNames.addChild(lastlist, protoname);
        proto_desc.add(protodesc);
        //proto_file shoukd be a tree or a Map<protoname,filename> ..
        proto_files.put(protoname, fprotoName);
        if (encode) {
            // transmit to FEncode??
        }
    }

    public String getFileProtoName(String proto) {
            return proto_files.get(proto);
    }
    public String getNameProtoFile(String protoFile) {
       if (proto_files.containsValue(protoFile)){
           for (java.util.Map.Entry<String,String> en:proto_files.entrySet()){
               if (en.getValue().toString().compareTo(protoFile)==0){
                   return en.getKey();
               }
           }
       }
        return null;
    }
    /**
     * Used for Resresh in Code_Model Editor to avoid several sam protocols
     * 
     * @param withTrees if true remove also trees
     */
    public void removeAllproto(boolean withTrees) {
        if (protoNames != null) {
            protoNames.clear();
        }
        if (proto_desc != null) {
            proto_desc.clear();
        }
        if (proto_files != null) {
            proto_files.clear();
        }
        // try ...05/2012
        if (withTrees && proto_tree != null) {
            proto_tree.clear();
        }
    }

    public void removeLastProto() {
        if (protoNames.isEmpty() || proto_desc.isEmpty()) {
            TDeb.wri("protocols buffer are already empty");
            return;
        }
        protoNames.remove(protoNames.size() - 1);
        proto_desc.remove(proto_desc.size() - 1);
   //     proto_files.remove(proto_files.size() - 1);
    }

    public String getprotostr() {
        String res;
        if (protoNames == null || protoNames.isEmpty()) {
            return "Empty";
        }
        res = protoNames.getUserObjectLastPath().toString();//+ ":" + proto_desc;
        if (res != null && res.length() > 2) {
            res = res.replaceAll(",", "<");
            res = res.substring(1, res.length() - 1);
        }
        return res;
    }

    public void CloseonExit() {
        endtime = new java.util.Date(System.currentTimeMillis());
        if (Parent != null) {
            if (Parent != null) {
                Parent.setAcc_initsize(-1);
            }
            Parent.setinitDESCPack(null);
        }
    }

    /**
     * Close the model for End Of Line or stream
     */
    public void EndModel() {
        TDeb.wri("close model");
        endtime = new java.util.Date(System.currentTimeMillis());
        if (Parent != null) {
            if (Parent != null && !getDESC_sendas().startsWith("Model")) {
                Parent.setAcc_initsize(-1);
            }
            Parent.setinitDESCPack(null);
        }
    }

    /**
     * Used for Resresh in Code_Model <br> and for Streams decoding (then DO NOT
     * clear proto)
     *
     */
    public void clear() {
        starttime = new java.util.Date(System.currentTimeMillis());
        endtime = null;
        sprotolevel = 0;
        sprotooffset = 0;
        stop_decode = 0;
        rows.clear();
        buffer = null;
        initbuffer = null;
    }

    /**
     * Check if this field comply with DESCfdata & DESCcond values
     *
     * @param name field name received to check
     * @param value of the field to check
     * @return true if the field value have to be sent
     */
    private int isallowed(String name, String value) {
        // first => reception of the codition
        if (name == null) {
            return -1;
        }
        if (isDESC_EOL() && name.compareTo("EOL") == 0) {
            return 0;
        }
        String tag = activ_file;
        //remove extention = >HEAVY IN ANALYSE PROCESS
        if (tag.lastIndexOf(".") >= 0) {
            tag = tag.substring(0, tag.lastIndexOf("."));
        }
        if (tag.length() > 4) {
            tag = tag.substring(0, 4);
        }
        tag += ".";
        //remove spname(IP.header:src=>IP.src)= >HEAVY IN ANALYSE PROCESS
        String shortname = name;
        if (shortname.lastIndexOf(":") >= 0) {
            shortname = shortname.substring(shortname.lastIndexOf(":") + 1);
        }
        TDeb.wri("Receving for stream : " + tag + shortname);
        if (getDESC_fcond() != null && getDESC_fcond().compareTo(tag + shortname) == 0) {
            fcondFeel = TUtils.ismatchto(value.getBytes(), getDESC_condval());
        }
        //some fields !after! checking the field to send
        if (getDESC_fData() != null) {
            //  System.err.println("=>"+getDESC_fData()+"===>["+tag + name+"]");
            if ((getDESC_fData().compareTo(tag + shortname) == 0 || getDESC_fData().compareTo("-N/A-") == 0)) {
                if (getDESC_fcond().compareTo("-N/A-") == 0 || getDESC_condval() == null) {
                    return 0;
                } else if (fcondFeel) {
                    fcondFeel = false;
                    return 0;
                } else {
                    return -2;
                }
            }
        }
        return -1;
    }

    public final void createDec() {
        T_Code dec = new T_Code();
        if (Parent != null) {
            dec.setconsole(Parent.getConsole());
        }
        if (getDESC_Protofirst() != null) {
            dec.setproto_file(getDESC_Protofirst().getName().substring(0, getDESC_Protofirst().getName().indexOf(".")));
        } else if (getBuffer() != null && getBuffer().length > 0) {
            byte[] pack = getBuffer();
            java.util.LinkedList<String> list = getNextStacks(pack);
            TDeb.wri(" Found protocols : " + list);
            if (list != null && list.isEmpty() == false) {
                dec.setproto_file(list.get(0));
            } else {
                dec.setproto_file("0NULL");
            }
        } else {
            dec.setproto_file("0NULL");
        }
        dec.setresult(this);
        dec.setSilent(true);
        dec.start();
        while (dec.isAlive()){
            try {
                Thread.sleep(10);
            } catch (InterruptedException ex) {
               TDeb.wri("sleeperror");
            }
        }
    }

    /**
     * if a protocol wait for byte then wil do necessary to provide it.
     * overwrited in P_codeEditor for fragmented packet
     *
     * @param waitedbyte
     * @return true if byte are received
     */
    public boolean askReceive(int waitedbyte) {
        // System.err.println("==<"+waitedbyte);
        if (Parent instanceof C_Port) {
            ((C_Port) Parent).ReadStream(waitedbyte);
            return true;
        }
        return false;
    }

    public void setSlider(int pos) {
        if (Parent != null) {
            if (getsplevel() < 1) {
                Parent.setDESC_slid(pos);
            }
        }
    }
// for encode

    public boolean addrow(int Fi_level, String Fi_name, String Fi_desc, String Fi_Desc2,
            String Fa_size, String sizecode, String Fi_code, String Fi_format,
            String Fi_classe, String mand, String memin, boolean sproto, String[] values, String[] Vdesc, String def) {
        int min = -1;
        if (memin != null) {
            min = new Integer(memin);
        }
        java.util.List<String> protol = protoNames.getUserObjectLastPath();
        C_Field mf = new C_Field( Fi_name, Fi_desc, Fi_Desc2, Fa_size, sizecode,
                Fi_code, Fi_format, Fi_classe, mand, min, sproto, values, Vdesc);
        mf.setProto(protol.get(protol.size() - 1), sprotolevel, sprotooffset, rows.size() + 1);
        if (def != null) {
            Object res = TDeb.To_Obj(Fi_classe, def, Fi_format);
            mf.setvalue("Value", res);
        } else {
            if (values != null) {
                byte[] res = TDeb.prend(Fi_code, values[0]);
                mf.setvalue("Value", res);
            } else {
                if (sproto == false) {
                    mf.setvalue("Value", mf.getvalue("Choice"));
                }
            }
        }
        rows.add(mf);
        check_field(rows.size() - 1);
        check_fields();
        this.fireTableDataChanged();
        return true;
    }

    public boolean addrow( String Fi_name, String Fi_desc, String Fi_Desc2,
            int Fi_ofset, int Fi_size, int Fi_first, String Fi_code, boolean Fi_visible,
            String Va_Desc, Object Va_Value) {
        if (encode) {
            return false;
        }
        boolean res = false;
        if (!getDESC_sendas().startsWith("Model") && istosend) {
            if (Parent != null && !getDESC_sendas().startsWith("Model")) {
                ibuff_pos = sprotooffset + Fi_first;
                Parent.setAcc_position(ibuff_pos);
            }
            String Str_Value = "";
            if (Va_Value != null) {
                Str_Value = Va_Value.toString();
            }
            int sendOrWait = isallowed(Fi_name, Str_Value);
            byte[] HXvalue = getfrombuffer(Fi_first + (Fi_ofset + getDESC_Offset()), Fi_size - (Fi_ofset + getDESC_Offset()));
            if (sendOrWait == 0) {
                //no need to go ahead
                if (getsplevel() > 0) {
                    this.setstop(-3);
                }
                TDeb.wri("Value to send  : " + HXvalue + " formated as " + getDESC_sendas());
                setrcved_buff(null);
                if (isDESC_EOL() && Fi_name.compareTo("EOL") == 0) {
                    HXvalue = getDESC_EOLval().getBytes();
                }
                if (HXvalue != null) {
                    C_Packet p1 = null;
                    if (getDESC_sendas().compareTo("as_buffer") == 0) {
                        p1 = new C_Packet(HXvalue, Pack.getsource());
                    } else if (Va_Value != null && getDESC_sendas().compareTo("as_objval") == 0) {
                        p1 = new C_Packet(Va_Value, Pack.getsource());
                    } else if (Va_Value != null && getDESC_sendas().compareTo("as_strval") == 0) {
                        p1 = new C_Packet(Str_Value.getBytes(), Pack.getsource());
                    } else if (Va_Value != null && getDESC_sendas().compareTo("val2byte") == 0) {
                        byte[] by = null;
                        try {
                            by = TUtils.string2byte(Str_Value);
                        } catch (Exception ex) {
                        }
                        p1 = new C_Packet(by, Pack.getsource());
                    } //-----------!!!! to remove??
                    else if (getDESC_sendas().compareTo("ModelKeep") == 0) {
                        return true;
                    }
                    //---------
                    if (p1 != null && Parent != null) {
                        //  System.out.println("trame : "+p1.getBytes().length);
                        if (isDESC_in()) {
                            Parent.read_in(p1);
                        } else {
                            Parent.read_out(p1);
                        }
                    }
                    if (getDESC_TIT()) {
                        TDeb.wri("Tempo intertrame " + getDESC_TITval());
                        try {
                            Thread.sleep(getDESC_TITval());
                        } catch (InterruptedException ex) {
                            TDeb.wri(ex.getMessage());
                        }
                    }
                    res = true;
                }
            } else if (sendOrWait == -2 && isDESC_WaitAnsw()) {
                TDeb.wri("wait message ");
                // wait for received byte ; Work on message NB => !!! fragmentation !!!
                //
                long start = System.currentTimeMillis();
                while (getrcvedbuff() == null
                        && (isDESC_WaitLimit() == false
                        || getDESC_WaitLimitval() > (System.currentTimeMillis() - start))) {//||HXvalue.length > getrcvedbuff().length) {
                    try {
                        Thread.sleep(1);
                    } catch (InterruptedException ex) {
                        TDeb.wri(ex.getMessage());
                    }
                }
                /*     if (HXvalue.length < getrcvedbuff().length) {
                 byte[] next = new byte[getrcvedbuff().length - HXvalue.length];
                 System.arraycopy(getrcvedbuff(), HXvalue.length, next, 0, next.length);
                 setrcved_buff(next);
                 } else {*/
                setrcved_buff(null);
                //   }
            }
        }
        if (getDESC_sendas().startsWith("Model")) {
            boolean isinmodel = false;
            if (Va_Value instanceof List<?>) {//Va_Value.getClass().isAssignableFrom(List.class)) {
                for (int i = 0; i < rows.size(); i++) {
                    if ((rows.get(i)).getvalue("Name").toString().compareTo(Fi_name) == 0) {
                        C_Field mf = rows.get(i);
                        Object mfval = mf.getvalue("Value");
                        if (mfval instanceof List<?>) {
                            List<Object> v = (List<Object>) mfval;
                            v.add(((List<?>) Va_Value).get(0));
                            mf.setvalue("Value", v);
                        }
                        isinmodel = true;
                    }
                }
            }
            if (isinmodel == false) {
                C_Field mf = new C_Field(Fi_name, Fi_desc, Fi_Desc2, Fi_ofset, Fi_size, Fi_first, Fi_code, Fi_visible, Va_Desc, Va_Value);
                try {
           //         if (sprotolevel == 0) {
                        //TODO: why current is not get(0)?
                    //             mf.setProto(protoNames.get(0), sprotolevel, sprotooffset, rows.size() + 1);
            //        } else {
                        mf.setProto(getNameProtoFile(activ_file), sprotolevel, sprotooffset, rows.size() + 1);
            //        }
                } catch (Exception ex) {
                    TDeb.wri("Pb to get last protoNames");
                }
                rows.add(mf);
            }
            fireTableDataChanged();
            if (getDESC_sendas().startsWith("Model")
                    && Fi_name.compareTo("EOL") == 0
                    && getDESC_sendas().compareTo("ModelKeep") != 0) { // then CodeModel!!! => don't send
                setstop(-2);
                res = true;
            }
        }
        return res;
    }

    /**
     * Send the result model to the port
     *
     * @param position if -1 the original pack, else, a new result form 0 to
     * position
     */
    public void send_model(int position) {
        TDeb.wri("send buffer position : " + position);
        if (istosend == false || Parent == null) {
            return;
        }
        if (!getDESC_sendas().startsWith("Model") || getDESC_sendas().startsWith("ModelKeep")) {
            return;
        }

        if (position == -1) {
            if (getDESC_sendas().startsWith("ModelTr")) {
                Pack.setObj(getTree());
            }
            // Pack.setObj((Code_Model)this.clone());
            if (isDESC_in()) {
                Parent.read_in(Pack);
            } else {
                Parent.read_out(Pack);
            }
            return;
        }
        ibuff_pos += position;
        if (ibuff_pos < Parent.getAcc_initsize()) {
            Parent.setAcc_position(ibuff_pos);
        } else {
            Parent.setAcc_initsize(-1);
        }
        Code_Model result1 = (Code_Model) this.clone();
        java.util.List<C_Field> rows2 = new java.util.ArrayList<>();
        for (C_Field c : rows) {
            rows2.add(c);
        }
        result1.setrows(rows2);
        C_Packet p1 = (C_Packet) Pack.clone();
        result1.setbuffer(result1.getfrombuffer(0, position));
        result1.setinitbuffer();
        result1.EndModel();
        if (getDESC_sendas().startsWith("ModelTr")) {
            p1.setObj(result1.getTree());
        } else {
            p1.setObj(result1);
        }
        if (isDESC_in()) {
            Parent.read_in(p1);
        } else {
            Parent.read_out(p1);
        }

    }

    public void checkEOF() {
        if (Parent != null && Parent.isDESC_EOFstop()) {
            Parent.CXstop();
        }
    }

    public int bufferSize() {
        if (buffer == null) {
            return 0;
        }
        return buffer.length;
    }

    @Override
    public String toString() {
        String res = "Code: [" + this.getRowCount() + "]";
        if (endtime != null) {
            res += (endtime.getTime() - starttime.getTime()) + " ms";
        }
        return res;
    }

    @Override
    public int getRowCount() {
        return rows.size();
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    //  @Override
    //USEFULL ???
    @Override
    public Class<?> getColumnClass(int column) {
        if (column < 0 || column >= getColumnCount()) {
            return null;
        }
        if (encode) {
            //{"Nb", "Description","Choice", "Value", "VDesc", "Detail", "First", "Ofset", "Size", "Code", "Visible", "Class", "Name", "Level", "Proto"};
            Class[] cl = {Integer.class, String.class, Object.class, Object.class, String.class, String.class, Integer.class, Integer.class, Integer.class, String.class, Boolean.class, String.class, String.class, Integer.class, String.class};
            return cl[column];
        } else {
            // {"Nb","Description","Value","VDesc","Detail","First","Ofset","Size","Code","Visible","Class","Name","Level","Proto"};
            Class[] cl = {Integer.class, String.class, Object.class, String.class, String.class, Integer.class, Integer.class, Integer.class, String.class, Boolean.class, String.class, String.class, Integer.class, String.class};
            return cl[column];
        }
    }

    /**
     * null and unused???...
     *
     * @throws Throwable
     */
    @Override
    protected void finalize() throws Throwable {
        super.finalize();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        if (aRow >= 0 & aRow < rows.size()) {
            return getfield(aRow).getvalue(columnNames[aColumn]);
        }
        return null;
    }

    public Object getValueAt(int aRow, String colhdr) {
        if (aRow >= 0 & aRow < rows.size()) {
            return getfield(aRow).getvalue(colhdr);
        }
        return null;
    }

    public <U> U getValueAt(int aRow, String colhdr, U type) {
        if (aRow >= 0 & aRow < rows.size()) {
            try {
                return (U) getfield(aRow).getvalue(colhdr);
            } catch (Exception ex) {
                return null;
            }
        }
        return null;
    }

    public void setValueAt(Object value, int row, String colname) {
        int i = 0;
        while (columnNames[i].compareTo(colname) != 0 || i >= columnNames.length) {
            i++;
        }
        if (columnNames[i].compareTo(colname) == 0) {
            setValueAt(value, row, i);
        } else {
            TDeb.wri("column not found : " + colname);
        }
    }

    @Override
    public void setValueAt(Object value, int row, int column) {
        if ((columnNames[column].compareTo("Choice") != 0 && columnNames[column].compareTo("Value") != 0) || value == null) {
            return;
        }
        C_Field field = rows.get(row);
        if (columnNames[column].compareTo("Value") == 0) {
            field.setvalue("Value", value);
            return;
        }
        if (value instanceof javax.swing.ComboBoxModel) {
            Object ob = ((javax.swing.ComboBoxModel) value).getSelectedItem();
            String val = ob.toString();
            byte[] res = TDeb.prend(field.getvalue("Code", ""), val.split("=>")[0]);
            field.setvalue("Value", res);
            field.setvalue("Choice", value);
        } else {
            field.setvalue("Value", value);
        }
        check_field(row);
        check_fields();
        this.fireTableDataChanged();
    }

    public C_Field getfield(int row) {
        if (row < rows.size() && row >= 0) {
            return rows.get(row);
        } else {
            return null;
        }
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        if (columnNames[column].compareTo("Value") == 0) {
            if (encode) {
                return true;
            } else {
                return true;// false;
            }
        }
        if (columnNames[column].compareTo("Choice") == 0) {
            return encode;
        }else if (columnNames[column].compareTo("Buffer") == 0) {
            return true;
        }
        return false;
    }

    /**
     *copy this model used while sending codemodel
     * @return copied Code_Model
     */
    @Override
    public Object clone() {
        Code_Model res1;
        try {
            List<C_Field> rows1 = rows; //clone
            res1 = (Code_Model) super.clone();
            res1.setrows(rows1);
        } catch (CloneNotSupportedException e) {
            throw new InternalError(e.getMessage());
        }
        return res1;
    }
}
