/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.analyse;

import com.jdcm.common.C_Packet;
import com.jdcm.common.D_Utils;
import javax.swing.tree.DefaultTreeModel;

/**
 * This Event Matrix follow a stream conversation storing states and packets
 *
 * @author M.Marc GIBOIN
 */
public class ProtoEventMatrix extends com.jdcm.diagram.A_Events {
  private static final long serialVersionUID = 1L;
    //   private D_Debug TDeb = new D_Debug("CModel");
    private final D_Utils TUtils = new D_Utils();
    public String protoFileName = "";
    private String signature = "";
    private final javax.swing.table.DefaultTableModel protoModif = new javax.swing.table.DefaultTableModel(new String[]{"packets", "Action", "State", "fragment"}, 0);
    public java.util.LinkedList<C_Packet> packetList = new java.util.LinkedList<>();
    private final java.util.List<C_Packet> fragPacks = new java.util.ArrayList<>();
    private final java.util.List<byte[]> fragBuffs = new java.util.ArrayList<>();
    private javax.swing.tree.DefaultTreeModel protoTree = null;

    public DefaultTreeModel getProtoTree() {
        return protoTree;
    }

    public ProtoEventMatrix() {
        super();
        // TDeb 
    }

    static public ProtoEventMatrix getProtoEventMatrix(String protoFileName) {
        ProtoEventMatrix mx = null;
        if (protoFileName==null){
            return mx;
        }
        // System.out.println("ProtoEventMatrix : Will try to Load : " + protoFileName);
        if (!protoFileName.endsWith(".xml")) {
            protoFileName += ".xml";
        }
        java.io.InputStream io = com.jdcm.common.D_Utils.getFileStream(protoFileName, "Descriptors", null);
        if (io == null) {
            System.err.println("ProtoEventMatrix :  Pb Loading : " + protoFileName + " with stream : " + io);
            return null;
        } else {
            mx = new ProtoEventMatrix(io);
            //System.out.println("ProtoEventMatrix :  Conversation init : Loaded protocol : " + protoFileName);
            mx.setProtoFileName(protoFileName);
            return mx;
        }
    }

    public void addFragment(C_Packet p, byte[] buff) {
        fragPacks.add(p);
        fragBuffs.add(buff);
    }

    public C_Packet[] getFragPackets() {
        return fragPacks.toArray(new C_Packet[]{});
    }

    public void clearFragments() {
        fragPacks.clear();
        fragBuffs.clear();
    }

    private byte[] getAllFragBuffer() {
        if (fragBuffs == null || fragBuffs.isEmpty()) {
            return null;
        }
        byte[] buff = new byte[]{};
        for (byte[] data : fragBuffs) {
            buff = TUtils.addtab(buff, data);
        }
        return buff;
    }

    public C_Packet getDefragPacket() {
        // try to get last protocoled packet and and joined fragments to it 
        if (fragPacks == null || fragPacks.isEmpty() || fragBuffs == null
                || fragBuffs.isEmpty() || packetList.isEmpty()) {// in this case assemble by previous step
            return null;
        }
        C_Packet res = null;
        if (packetList.get(packetList.size() - 1).getProtocols() == null) {
            res = (C_Packet) fragPacks.get(0).clone();
            res.setObj(getAllFragBuffer());
        } else if (packetList.size() < 2) {
            C_Packet lastupperproto = null;
            for (int i = packetList.size() - 2; i >= 0; i--) {
                if (packetList.get(i).getProtocols() != null) {
                    if (packetList.get(i).getProtocols().size() > packetList.get(packetList.size() - 1).getProtocols().size()) {
                        lastupperproto = packetList.get(i);
                    }
                }
            }
            if (lastupperproto == null) {
                return null;
            }
            res = (C_Packet) lastupperproto.clone();
            byte[] buff = TUtils.addtab(res.getBytes(), getAllFragBuffer());
            res.setObj(buff);
        }
        return res;
    }

    public String getSignature() {
        if (signature == null || signature.length() == 0) {
            return getTitle();
        }
        return signature;
    }

    public void setSignature(String signature) {
        this.signature = signature;
    }

    public ProtoEventMatrix(java.io.InputStream inStream) {
        super(inStream);
    }

    public String getProtoFileName() {
        return protoFileName;
    }

    public void setProtoFileName(String FileName) {
        protoFileName = FileName;
        if (protoFileName.endsWith(".xml") == false) {
            protoFileName = protoFileName + ".xml";
        }
        java.io.InputStream io = com.jdcm.common.D_Utils.getFileStream(protoFileName, "Descriptors", null);
        if (io == null) {
            // TDeb.wri("No protocol found for : " + protoFileName);
            System.err.println("=>" + "No protocol found for : " + protoFileName);
        } else {
            protoTree = (new Code_Model()).loadProtoTree(io);
        }
    }

    public void addPacket(C_Packet[] p) {
        if (p == null || p.length == 0) {
            //      TDeb.wri("Packet list add to: " + this.getTitle() + " matrix is null");
        } else if (packetList == null) {
            //        TDeb.wri("Packet listing of " + this.getTitle() + " is null");
        } else if (packetList.isEmpty() || packetList.getLast() != p[p.length - 1]) {
            packetList.addAll(java.util.Arrays.asList(p));
        }
    }

    public void removePacket(C_Packet[] p) {
        if (p == null || p.length == 0) {
            //          TDeb.wri("Packet list add to: " + this.getTitle() + " matrix is null");
        } else if (packetList == null) {
            //          TDeb.wri("Packet listing of " + this.getTitle() + " is null");
        } else if (packetList.isEmpty() || packetList.getLast() != p[p.length - 1]) {
            packetList.removeAll(java.util.Arrays.asList(p));
        }
    }

    public C_Packet getPrevious(C_Packet p) {
        int idx = packetList.indexOf(p);
        if (idx > 0) {
            return packetList.get(idx - 1);
        }
        return null;
    }

    public boolean isFirstPacket(C_Packet p) {
        if (packetList.isEmpty()) {
            return false;
        }
        // should care if packet is an aggregation=> ???
        return packetList.getFirst() == p;
    }

    public void addProtoModif(C_Packet[] packs, java.util.List<com.jdcm.common.C_Actiondef> actions, java.util.List<com.jdcm.diagram.A_Element> states, byte[] fragment) {
        // if fragment, should add only the fragment (choice : store & read easier than decode on getGlobalPacket() )
        if (actions == null || actions.isEmpty() || (actions.size() == 1 && actions.get(0).toString().contains("Empty") == true)) {
            protoModif.addRow(new Object[]{packs, null, states, fragment});
        } else {
            for (com.jdcm.common.C_Actiondef action : actions) {
                protoModif.addRow(new Object[]{packs, action, states, fragment});
            }
        }
    }

    public C_Packet getGlobalPacket(C_Packet pack) {
        for (int i = 0; i < protoModif.getRowCount(); i++) {
            C_Packet[] packs = (C_Packet[]) protoModif.getValueAt(i, 0);
            byte[] fragt = (byte[]) protoModif.getValueAt(i, 3);
            if (packs != null && packs.length > 0
                    && java.util.Arrays.asList(packs).contains(pack)) {
                C_Packet p = (C_Packet) packs[0].clone(); // to get src/dest/times/...
                if (fragt != null) {
                    p.setObj(null);
                    p.setObj(TUtils.addtab(p.getBytes(), fragt));
                }
                return p;
            }
        }
        return pack;
    }

    public void displayActivState(C_Packet pack, com.jdcm.eltrx.F_Terminal parent) {
        for (com.jdcm.diagram.A_Element elt : super.getStatuslist()) {
            elt.setActive(false);
        }
        for (int row = 0; row < protoModif.getRowCount(); row++) {
            C_Packet[] packs = (C_Packet[]) protoModif.getValueAt(row, 0);
            if (java.util.Arrays.asList(packs).contains(pack)) {
                java.util.List<com.jdcm.diagram.A_Element> list = (java.util.List<com.jdcm.diagram.A_Element>) protoModif.getValueAt(row, 2);
                for (com.jdcm.diagram.A_Element elt : list) {
                    //   TDeb.wri("ProtoEventMatrix : set Active " + elt + " for : " + pack);
                    elt.setActive(true);
                }
                if (parent!=null) {
                    if (packs != null && packs.length > 0) {
                        parent.setSelectedPackets(packs);
                    }
                }
            }
        }
    }

    private java.util.List<com.jdcm.common.C_Actiondef> getActionsforPacket(C_Packet pack) {
        java.util.List<com.jdcm.common.C_Actiondef> res = new java.util.ArrayList<>();
        for (int row = 0; row < protoModif.getRowCount(); row++) {
            C_Packet[] packs = (C_Packet[]) protoModif.getValueAt(row, 0);
            if (java.util.Arrays.asList(packs).contains(pack)
                    && protoModif.getValueAt(row, 1) instanceof com.jdcm.common.C_Actiondef) {
                res.add((com.jdcm.common.C_Actiondef) protoModif.getValueAt(row, 1));
            }
        }
        return res;
    }

    public void changeProto(C_Packet pack, Code_Model cm) {
        if (pack == null || cm == null) {
            return;
        }
        if (protoFileName.endsWith(".xml") == false) {
            protoFileName = protoFileName + ".xml";
        }
        cm.getprotocols().remove(protoFileName);//remove proto and after reload base porto then able to modify base proto
        java.io.InputStream io = com.jdcm.common.D_Utils.getFileStream(protoFileName, "Descriptors", null);
        if (io == null) {
            //      TDeb.wri("No protocol found for : " + protoFileName);
            System.err.println("=>" + "No protocol found for : " + protoFileName);
        } else {
            protoTree = cm.loadProtoTree(io);
            for (com.jdcm.common.C_Actiondef modif : getActionsforPacket(pack)) {
                //PROTO|field1,field2,firld3.attribut(value)
                if (modif != null && modif.getDest() != null) {
                    String target = modif.getDest().toString();
                    if (target.startsWith(getTitle())) {
                        com.jdcm.common.XMLres node = getNode(target.substring(target.indexOf("|") + 1),
                                (javax.swing.tree.DefaultMutableTreeNode) protoTree.getRoot());
                        if (node != null) {
                            node.addAttribut(modif.getMethodName(), modif.getParam());
                            /*   TDeb.wri("ProtoEventMatrix : [" + getTitle() + "] change :"
                             + node + " : " + modif.getMethodName() + " => "
                             + modif.getParam() + "for Packet : " + pack);*/
                        }
                    }
                }
            }
            if (protoFileName.endsWith(".xml")) {
                cm.getprotocols().put(protoFileName.substring(0, protoFileName.length() - 4), protoTree);
            } else {
                cm.getprotocols().put(protoFileName, protoTree);
            }
        }
    }

    /**
     * a recursive proces to get the XML TreeNode asked by protocol Change
     * actions.
     */
    private com.jdcm.common.XMLres getNode(String pathAsString, javax.swing.tree.DefaultMutableTreeNode node) {
        String[] fields = pathAsString.split(",");
        for (int i = 0; i < node.getChildCount(); i++) {
            //need deep=2 (protocol / value)
            if (node.getChildAt(i) instanceof javax.swing.tree.DefaultMutableTreeNode) {
                javax.swing.tree.DefaultMutableTreeNode tpv = (javax.swing.tree.DefaultMutableTreeNode) node.getChildAt(i);
                for (int k = 0; k < tpv.getChildCount(); k++) {
                    javax.swing.tree.DefaultMutableTreeNode tn = (javax.swing.tree.DefaultMutableTreeNode) tpv.getChildAt(k);
                    if (tn.getUserObject() instanceof com.jdcm.common.XMLres) {
                        com.jdcm.common.XMLres x = (com.jdcm.common.XMLres) tn.getUserObject();
                        if (fields[0].compareTo(x.getName()) == 0) {
                            if (fields.length > 1) {
                                return getNode(pathAsString.substring(pathAsString.indexOf(",") + 1), tn);
                            } else {
                                return x;
                            }
                        }
                    }
                }
            }
        }
        return null;
    }

    @Override
    public String toString() {
        String res = "[" + getTitle() + "]";
        if (signature != null) {
            res += getSignature();
        }
        if (packetList.size() > 1) {
            res += "/" + packetList.size();
        }
        return res;
    }

    /**
     * Add actions to do on a decoder file for next packet
     *
     * @param convCm the model that will be modified by this action (or not)
     * @param row the row in the model to be checked for actions (or not)
     * @param packs the packets that do the action (or not)
     * @param fragment the other fragment needed for this action
     */
    public void addActions(Code_Model convCm, int row, C_Packet[] packs, byte[] fragment) {
        // how  convCm.getValueAt(row, "Proto") could be null??
        if (packs == null || packs.length == 0 || convCm == null || row < 0 || convCm.getValueAt(row, "Proto") == null) {
            return;
        }
        addPacket(packs);
        String proto = convCm.getValueAt(row, "Proto").toString();
        String field = getFieldName(convCm, row, proto);
        Object val = convCm.getValueAt(row, "Value");
        com.jdcm.common.C_Eventdef evt = new com.jdcm.common.C_Eventdef(proto, field, val);
        // fill the matrix that match
        java.util.List<com.jdcm.common.C_Actiondef> actions = getTask(evt);
        java.util.List<com.jdcm.diagram.A_Element> states = getActivStatusList();//<=== store states for display when used!!
        if (actions != null) {
            //         TDeb.wri("Conversation init : for proto " + proto + ", if : " + evt + "; then : " + actions + " for : " + states);
            addProtoModif(packs, actions, states, fragment);
            changeProto(packs[0], convCm);
        }
    }

    private String getFieldName(Code_Model convCm, int row, String proto) {
        String field = "" + convCm.getValueAt(row, "Name");
        int level = 0;
        if (convCm.getValueAt(row, "Level") instanceof Integer) {
            level = (int) convCm.getValueAt(row, "Level");
        } else {
            //       TDeb.wri("Pb CodeModel Format");
        }
        int i = row - 1;
        while (i >= 0
                && (int) convCm.getValueAt(i, "Level") == level
                && ("" + convCm.getValueAt(i, "Proto")).compareTo(proto) == 0) {
            String txt = "" + convCm.getValueAt(i, "Name");
            if (txt.contains(":")) {
                txt = txt.substring(0, txt.indexOf(":"));
            }
            if (!field.startsWith(txt)) {
                field = convCm.getValueAt(i, "Name") + ":" + field;
            }
            i--;
        }
        return field;
    }
}
