package com.jdcm.analyse;

import com.jdcm.common.D_Utils;
import com.jdcm.common.XMLres;
import com.jdcm.eltrx.D_Debug;
import com.jdcm.eltrx.I_Console;
import javax.swing.tree.*;
import com.jdcm.modifiers.I_modifiers;
import java.io.UnsupportedEncodingException;
import static java.lang.Thread.sleep;

/**
 * T_Code.java Created on 27 aout 2006, 17:34
 *
 * the decoder thread use codeModel as result, descriptor file as input and
 * result.getBuffer() as input
 *
 * @author Marc GIBOIN
 */
public class T_Code extends Thread {

    private final D_Debug TDeb;
    private final D_Utils TUtils = new D_Utils();
    // private C_Port Parent=null;
    //decode output tablemodel & stream
    private Code_Model result = null;    // Encode frame
    //private F_Encode Fencode = null;
    //filename of current protocol descriptor
    private String protoname = null;
    // position of current byte to decode int he buffer
    private int buff_pos = -1;
    // tree that represent protocol path...
    private TreePath proto_path;
    // tree that represent init path...
    private TreePath init_path;
    // taille des element avant les donnees du champs (taille,...)
    private int fieldoffset = -1;
    private int fieldFSsize = -1;
    //default type of the size for "Var/XX"
    private String proto_tsize = null;
    //default field separator for size="FS/"
    private String proto_fssize = null;
    private String val_chp = null;
    //waited value for a field
    private String error_val = null;
    // name of the field creting sub_proto
    private String spname_creator = null;
    // routine used to modify & check lenght of buffer
    private I_modifiers modif = null;
    private boolean silent = false;

    /**
     * Creates a new instance of T_Code Idee : generate .java with XML and
     * on-fly complilation to decode
     */
    public T_Code() {
        TDeb = new D_Debug("Code ");
        setName(this.getClass().getSimpleName() + ":" + getName());
        //if (Parent!=null){TDeb.setconsole(Parent.getMain());}
    }

    public void setconsole(I_Console M) {
        TDeb.setconsole(M);
    }

    public void setSilent(boolean bool) {
        silent = bool;
    }

    /**
     * should (!) check XML proto file !!! protocol buffer :vproto
     *
     * @param label name of the protocol file
     */
    public void setproto_file(String label) {
        if (label == null) {
            return;
        }
        protoname = label;
    }

    public void setsp_name(String name) {
        spname_creator = name;
    }

    public boolean isBuffer() {
        return result.getBuffer() != null;
    }

    public int bufferSize() {
        if (result == null) {
            TDeb.wri("result is null");
        } else if (result.getBuffer() == null) {
            TDeb.wri("result buffer is null");
            try {
                sleep(100);
            } catch (InterruptedException ex) {
                TDeb.wri("buffersize() =>" + ex.getLocalizedMessage());
            }
            if (result.getBuffer() != null) {
                return result.getBuffer().length;
            }
        } else {
            return result.getBuffer().length;
        }
        return -1;
    }

    /**
     * checkBuffer : if pad, wait for data until PAD TO <br>
     * -3 => error<br>
     * -2 => No more data waited & No PAD => Normal end <br>
     * -1 => data waited but No data received util PAD TO 0 => data arrived
     * correctly
     * 
     * 
     * @param askedsize nb of byte waited
     * @param mand is manadtory or optional
     * @return 
     */
    public int checkBuffer(int askedsize, boolean mand) {
        if (bufferSize() < 0) {
            return -3;
        } else if (askedsize <= bufferSize() - buff_pos) {
            return 0;
        }
        if (result.isDESC_PadTO() == false) {
            return -2;
        } else if (bufferSize() == buff_pos && result.getsplevel() > 0) {
            //sprotosize is known by main proto
            //sub protocol size is defined??
            return -1;
        } else if (!mand && bufferSize() == buff_pos) {
            // optional absent file
            return -2;
        }
        TDeb.wri("Wait for " + askedsize + "/ " + bufferSize() + " received.");
        long toPad = System.currentTimeMillis();
        int to = result.getDESC_PadTOval();
        int timepooling = (to / 100) + 1;
        while (askedsize > bufferSize() - buff_pos) {
            // if TO=> end of decode
            //if port closed=> wait for TO!!!
            if (System.currentTimeMillis() > toPad + to) {
                TDeb.wri("Pad TO (" + to + "ms) reached. \r\n and " + askedsize + " not received");
                result.setsplevel(0);
                if (mand) {
                    return -1;
                } else {
                    return -2;
                }
            }
            result.askReceive(askedsize - (bufferSize() - buff_pos));
            try {
                Thread.sleep(timepooling);
            } catch (InterruptedException ex) {
                TDeb.wri("checkBuffer()=>" + ex.getLocalizedMessage());
            }
        }
        return 0;
    }
    /*
     * Structure of the Analyse tree is analyse,protocol,(..subprotocol..valenum..)
     * 
     */

    private TreePath getsubproto(String type, String name) {
        TreePath path = new TreePath(result.getcurrentprotoTree().getRoot());
        try {
            boolean founded = false;
            DefaultMutableTreeNode analysenode = (DefaultMutableTreeNode) path.getLastPathComponent();
            int idx = 0;
            while (idx < analysenode.getChildCount() && founded == false) {
                DefaultMutableTreeNode protnode = (DefaultMutableTreeNode) analysenode.getChildAt(idx);
                if (((XMLres) protnode.getUserObject()).toString().compareTo(type) == 0) {
                    if (type.compareTo("protocol") == 0) {
                        path = path.pathByAddingChild(protnode);
                        founded = true;
                    } else {
                        if (((XMLres) protnode.getUserObject()).getName().compareTo(name) == 0) {
                            path = path.pathByAddingChild(protnode);
                            founded = true;
                        }
                    }
                }
                idx++;
            }
            if (founded == false) {
                TDeb.wri("protocol type: " + type + " named :" + name + " not found in file: " + protoname);
                return null;
            }
        } catch (Exception ex) {
            TDeb.wri("Pb selecting type: " + type + " named :" + name + "in : " + protoname);
            return null;
        }
        return path;
    }

    public void setresult(Code_Model m) {
        result = m;
    }

    /**
     * Initialise proto_pos array & fill with proto description
     *
     * @param init the name of starting point to run <br> the subprotocol or
     * "protocol" for the main part
     *
     * @return True if initialisation is OK
     *
     */
    private boolean initproto(String init) {
        //init="protocol" || sproto...
        if (result == null) {
            TDeb.wri("no result for initialisation with " + init);
            return false;
        }
        if (result.addProtoTree(protoname) == false) {
            TDeb.wri("protocol not found : " + protoname);
            return false;
        }
        String name = init;
        String type;
        if (init.compareTo("protocol") == 0) {
            name = "";
            type = init;
        } else {
            type = "subproto";
        }
        // set the proto_path to the begin of analyse (protocol or sub preotocol)
        proto_path = getsubproto(type, name);
        if (proto_path == null) {
            TDeb.wri("could not find : " + name + " type : " + type);
            return false;
        }
        init_path = proto_path;
        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
        XMLres proto = (XMLres) node0.getUserObject();
        // proto_res=Obj.getorderedvalue(attr_proto);
        proto_tsize = proto.getAttrValAsstring("sizecode");
        proto_fssize = proto.getAttrValAsstring("sizefs");
        if (proto_fssize != null) {
            if (proto_fssize.startsWith("0x")) {
                byte[] by;
                try {
                    by = TUtils.string2byte(proto_fssize.substring(2));
                } catch (Exception ex) {
                    TDeb.wri("Error: as " + protoname + " Field Separator : " + proto_fssize);
                    return false;
                }
                proto_fssize = new java.lang.String(by);
            }
        }
        if (init.compareTo("protocol") == 0) {
            result.addproto(proto.getAttrValAsstring("name"), proto.getAttrValAsstring("desc"), protoname);
            result.setactive_file(protoname);
        }
        if (Suivant_champ(0) < 0) {
            TDeb.wri("Champs suivant non valide : " + Suivant_champ(0));
            return false;
        }
        return true;
    }

    /**
     * Encode/decode packet
     *
     * @param init Nmae of the subprotocol to use <br> OR "protocol" for main
     * protocol in the file : protoname - Ex : "tcpdump"
     * @return true normal terminaison
     */
    public boolean decode_fields(String init) {
        //init="protocol" || sproto=>ETHII,IPV4,......
        error_val = "";
        int Taille_chp;
        boolean isAvoid=false;
        String chp_nom;
        String sproto;
        String nproto;
        String valenum;
        String desc;
        String desc2;
        String stype;
        String tlvdesc = "";
        String tlvdesc2 = "";
        String tlvtag = "";
        int tlvtagsize = 0;
        if (init == null) {
            error_val = "no protocol";
            return false;
        }
        if (initproto(init) == false) {
            error_val = "Pb init protocol";
            return false;
        }
        if (isBuffer() == false) {
            error_val = "buffer is null";
            return false;
        }
        if (protoname == null) {
            error_val = "no valide protocol";
            return false;
        }
        //   TDeb.wri( "Decode : protocol file :  "+protoxml+"buffer /"+buffer.length);
        buff_pos = 0;
        int noend = 1;

        while (noend >= 0) {
            // TO AVOID PROCESSOR OVERLOAD=
            try {
                Thread.sleep(1);
            } catch (InterruptedException ex) {
                TDeb.wri(ex.getMessage());
            }
            // ------------------LOOK FOR FIELD-------------------
            XMLres field = null;
            while (field == null || field.toString().compareTo("field") != 0) {
                DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
                field = (XMLres) node0.getUserObject();
            }
            //proto_res=Obj.getorderedvalue(attr_field);
            if (field == null) {
                error_val = "No field found in protocol descriptor";
                return false;
            } else {
                chp_nom = field.getName();
                String chp_name;
                if (spname_creator != null) {
                    chp_name = spname_creator + ":" + chp_nom;
                } else {
                    chp_name = chp_nom;
                }
                TDeb.wri("begin [" + protoname + "] field :" + chp_name);
                sproto = field.getAttrValAsstring("sproto");
                nproto = field.getAttrValAsstring("nproto");
                valenum = field.getAttrValAsstring("valenum");
                desc = field.getAttrValAsstring("desc");
                desc2 = field.getAttrValAsstring("desc2");
                boolean pvisible = true;
               
                if (field.getAttrVal("visible") != null) {
                    pvisible = field.getAttrValAsstring("visible").toLowerCase().compareTo("true") == 0;
                }
                if (field.getAttrVal("sizecode") == null) {
                    stype = proto_tsize;
                } else {
                    stype = field.getAttrValAsstring("sizecode");
                }
                //----------analyse champ : prensence du champ
                Taille_chp = 0;
                //3=>mand
                if (Pres_champ(field.getAttrValAsstring("mand"), chp_nom, field.getAttrValAsstring("size"))) {
                    //---------------- GET FIELD -------------------
                    // System.err.println("==<<"+field.getAttrVal(4));
                    //4=>size;2=>type
                    Taille_chp = Taille_champ(field.getAttrValAsstring("size"), stype, field.getAttrValAsstring("code"));
                    if (protoname.compareTo("HTTP") == 0 && field.getAttrValAsstring("size").compareTo("$1") == 0) {
                        System.out.print(">" + Taille_chp);
                    }
                    if (Taille_chp == 9998) {
                        return true;
                    } else if (Taille_chp == 9999 || Taille_chp < 0) {
                        //!! neg will be used for return =>9999 no mand data to know the size
                        result.addrow( "Size Err", error_val, "", this.fieldoffset, Taille_chp, buff_pos, "", pvisible, "", "");
                        error_val = "Impossible field size for size : " + field.getAttrVal("size") + "in proto : " + protoname + " at field: " + chp_name;
                        return false;
                    }
                    TDeb.wri("Asking [" + protoname + "] field :" + chp_name + " \\ " + Taille_chp);
                    /// -- get missing bytes for the field from stream
                    // !!??=> optional if not mandatory field
                    // System.err.println("==<<"+Taille_chp);
                    boolean ismand = false;
                    if (field.getAttrVal("mand") != null) {
                        if (field.getAttrValAsstring("mand").compareTo("M") == 0) {
                            ismand = true;
                        }
                    }
                    int chkres = checkBuffer(Taille_chp, ismand);
                    // if buffer is empty but 'memout' then continu
                    if (chkres == -1 && field.getAttrVal("memout") == null) {
                        error_val = "No value after TO.\r\n Waited size :" + Taille_chp;
                        return false;
                    }
                    if (chkres == -2) {
                        TDeb.wri("no PAD_desc asked and size asked(" + Taille_chp + ")> left (" + (bufferSize() - buff_pos) + ")");
                        return true;
                    }
                    TDeb.wri("Received [" + protoname + "] field :" + chp_name + " \\ " + Taille_chp);
                    byte[] field_data = result.getfrombuffer(buff_pos + this.fieldoffset, Taille_chp - this.fieldoffset - this.fieldFSsize);
                    if (Taille_chp > bufferSize() - buff_pos) {
                        TDeb.wri("Size of the field: " + Taille_chp + "missing bytes : " + (bufferSize() - buff_pos));
                        error_val = "missing bytes : " + (bufferSize() - buff_pos);
                        return false;
                    }
                    if (field.getAttrVal("code") == null) {
                        TDeb.wri("no code on field : " + chp_nom);
                    }
                    // value= chp/ if memory=> getmem/ else => default
                    if (Taille_chp == 0 && field.getAttrVal("memout") != null) {
                        //val_chp=TDeb.retire(proto_res[1],result.getmem(Integer.parseInt(proto_res[10])));
                        field_data = result.getmem(Integer.parseInt(field.getAttrValAsstring("memout")));
                    }

                    //---------------- FIND DATA -------------------
                    String val_val = null;
                    String val_desc = null;
                    String val_desc2 = null;
                    // find VAL ENUMERATIONS add values to the node
                    DefaultMutableTreeNode node_f = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
                    if (valenum != null) {
                        TreePath val_path = getsubproto("valenum", valenum);
                        if (val_path==null){
                            // could be softer by "setting an empty valEnum??" but exception..
                            TDeb.wri("valenum not found : '" + valenum + "' in tree : "+result.getcurrentprotoTree());
                             error_val = "valenum not found : '" + valenum + "' in tree : "+result.getcurrentprotoTree();
                            return false;
                        }else{
                        DefaultMutableTreeNode pdmlnode = (DefaultMutableTreeNode) val_path.getLastPathComponent();
                        for (int i = 0; i < pdmlnode.getChildCount(); i++) {
                            DefaultMutableTreeNode child_node = (DefaultMutableTreeNode) pdmlnode.getChildAt(i);
                            DefaultMutableTreeNode a = new DefaultMutableTreeNode(child_node.getUserObject());
                            node_f.add(a);
                        }
                        }
                    }
                    if (node_f.getChildCount() > 0){
                        val_chp = TDeb.retire(field.getAttrValAsstring("code"), field_data);
                        if( val_chp!=null) {
                            if (field.getAttrVal("avoidif") != null) {
                 isAvoid = field.getAttrValAsstring("avoidif").compareTo(val_chp) == 0;
                }
                            boolean searching = true;
                            for (int idx = 0; searching && idx < node_f.getChildCount(); idx++) {
                                DefaultMutableTreeNode node_v = (DefaultMutableTreeNode) node_f.getChildAt(idx);
                                if (node_v.toString().compareTo("value") == 0) {
                                    XMLres value = (XMLres) node_v.getUserObject();
                                    if (value != null && value.getAttrValAsstring("value") != null
                                            && (value.getAttrValAsstring("value").compareTo(val_chp) == 0
                                            || value.getAttrValAsstring("value").compareTo("/*/") == 0)) {
                                        TDeb.wri("Found [" + protoname + "] field :" + chp_name + " \\ " + Taille_chp + " == " + val_chp + " at " + idx + "/" + node_f.getChildCount());
                                        searching = false;
                                        proto_path = proto_path.pathByAddingChild(node_v);
                                        val_val = value.getAttrValAsstring("value");
                                        val_desc = value.getAttrValAsstring("desc");
                                        val_desc2 = value.getAttrValAsstring("desc2");
                                    }
                                }
                            }
                        }
                        //---------------- SEND DATA -------------------
                        if (val_val == null) {
                            TDeb.wri("Unknown value : " + val_chp + " ,Field:" + chp_name + ": " + TUtils.tabTostr(field_data, " ".charAt(0)));
                            result.addrow(chp_name, desc, desc2, this.fieldoffset, Taille_chp, buff_pos, field.getAttrValAsstring("code"), pvisible, "STOP NOT KNOWN", "\"" + val_chp + "\"");
                            // to avoid strong cases, descriptors should be completes
                            error_val = "value:" + val_chp + " not found in the descriptor for field:" + chp_name;
                            return false;
                        } else {
                            TDeb.wri("found value is :" + val_val + " => " + val_desc);
                        }
                    }
                    if (field.getAttrVal("memin") != null) {
                        result.setmem(new Integer(field.getAttrValAsstring("memin")), field_data);
                    }

                    // manage TLV fields :TT(tag=>desc)+(LL/VVV)=> ONE field
                    if (chp_nom.compareTo("TLVt") == 0) {
                        if (val_desc == null) {
                            tlvdesc = "";
                        } else {
                            tlvdesc = val_desc;
                        }
                        if (val_desc2 == null) {
                            tlvdesc2 = "";
                        } else {
                            tlvdesc2 = val_desc2;
                        }
                        tlvtagsize = Taille_chp;
                        tlvtag = TDeb.retire(field.getAttrValAsstring("code"), field_data);
                    } else {
                        if (chp_nom.compareTo("TLVv") == 0) {
                            if (desc != null) {
                                desc = tlvdesc + "-" + desc;
                            } else {
                                desc = tlvdesc;
                            }
                            if (desc2 != null) {
                                desc2 = tlvdesc2 + "-" + desc2;
                            } else {
                                desc2 = tlvdesc2;
                            }
                            tlvdesc = "";
                            tlvdesc2 = "";
                            chp_name = chp_name + "-" + tlvtag;
                        } else {
                            tlvtagsize = 0;
                        }
                        // ---- Check Modifier
                        //field_data modifications with reflect (Methode=proto_res[14]) and insert in result...
                        if (field.getAttrVal("modifier") != null) {
// modif rechagee a chaque foie!!!
                            modif = (I_modifiers) TUtils.getInstanceof("com.jdcm.modifiers." + field.getAttrVal("modifier"));
                            if (modif == null) {
                                TDeb.wri(" Pb loading modifier class : com.jdcm.modifiers." + field.getAttrVal("modifier"));
                                error_val = field.getAttrVal("modifier") + " not valid";
                                return false;
                            }
                            modif.setBuffer(field_data);
                            try {
                                modif.ToClear();
                            } catch (NumberFormatException ex) {
                            }
                            byte[] tab1 = java.util.Arrays.copyOf(result.getBuffer(), buff_pos + this.fieldoffset);
                            byte[] tab3 = java.util.Arrays.copyOfRange(result.getBuffer(), buff_pos + Taille_chp - this.fieldFSsize, result.getBuffer().length);
                            field_data = modif.getBuffer();
                            tab1 = TUtils.addtab(tab1, field_data);
                            result.setbuffer(TUtils.addtab(tab1, tab3));
                            Taille_chp = field_data.length + fieldoffset + fieldFSsize;
                        }
                        //-----------enregistre le chp et sa valeur -2:pdml/cbcom /2 because of field/value=>1 level
                        Object Val_obj = TDeb.To_Obj(field.getAttrValAsstring("class"), field.getAttrValAsstring("code"), field_data, field.getAttrValAsstring("format"));
                        if (!isAvoid){
                            result.addrow( chp_name, desc, desc2, this.fieldoffset + tlvtagsize, Taille_chp + tlvtagsize, buff_pos - tlvtagsize, field.getAttrValAsstring("code"), pvisible, val_desc, Val_obj);
                        }
                        if (chp_nom.compareTo("TLVv") == 0) {
                            tlvtagsize = 0;
                        }
                    }
                    if (field.getAttrValAsstring("code").compareTo("BM") == 0) {
                        if (TDeb.getBM()[1]) {
                            Taille_chp = 16;
                        }
                        result.setBMap(TDeb.getBM());
                    }
                    // changed Suivant_champ() 12 2010, it seem's protopath have no impact bellow
                    noend = Suivant_champ(Taille_chp);
                    // -------- if filed name is 'data' & the protocol is not final then try 'auto'
                    if (nproto == null && sproto == null && field_data.length > 0
                            && chp_name.compareTo("data") == 0) {
                        if (result.getDESC_Protolast() != null
                                && result.getDESC_Protolast().getName().startsWith(protoname) == false) {
                            java.util.LinkedList<String> new_Protocols = result.getNextStacks(field_data);
                            if (new_Protocols != null && !new_Protocols.isEmpty() && new_Protocols.get(0).startsWith("0NULL") == false) {
                                nproto = new_Protocols.get(0);
                                // could not add other (next nproto??)
                            }
                        }
                    }
                    //-------------- CHECK SUB/NEW PROTOCOLS -----------------
                    if ((nproto != null || sproto != null) && field_data.length > 0) {
                        T_Code dec = new T_Code();
                        dec.setconsole(TDeb.getconsole());
                        byte[] buffer = result.getBuffer();
                        int plevel = result.getsplevel();
                        int pofst = result.getspofset();
                        result.setspofset(pofst + buff_pos + this.fieldoffset);
                        if (nproto == null && sproto != null) {
                            dec.setName(dec.getName() + "[" + protoname + "/" + sproto + "]");
                            dec.setproto_file(protoname);
                            result.setsplevel(plevel + 1);
                            dec.setresult(result);
                            result.setbuffer(field_data);
                            dec.setsp_name(chp_name);
                            dec.decode_fields(sproto);
                        } else {
                            /// memin/memout should be deleted!!
                            if (result.getDESC_Protolast() == null || result.getDESC_Protolast().getName().startsWith(protoname) == false) {
                                dec.setName(dec.getName() + "[" + nproto + "]");
                                dec.setproto_file(nproto);
                                result.setsplevel(plevel + 1);
                                dec.setresult(result);
                                result.setbuffer(field_data);
                                result.setprotocols(result.getprotocols());
                                dec.decode_fields("protocol");
                            }
                        }
                        result.setsplevel(plevel);
                        result.setactive_file(protoname);
                        // IF buffer fied_data if modofied during analyse the report it on sub proto (initBuffer still unchanged)
                        byte[] tab1 = java.util.Arrays.copyOf(buffer, buff_pos +fieldoffset);
                            byte[] tab3 = java.util.Arrays.copyOfRange(buffer, buff_pos + fieldoffset+ field_data.length, buffer.length);
                            tab1 = TUtils.addtab(tab1, result.getBuffer());
                            result.setbuffer(TUtils.addtab(tab1, tab3));
                       // result.setbuffer(buffer);//
                   /*
                         if buffer modifications between init and decoded (ex : PPP) => Pb
                         *
                         if (plevel == 0) {
                         result.setbuffer(result.getinitbuffer());
                         } else {
                         result.setbuffer(buffer);
                         }*/
                        result.setspofset(pofst);
                    }
                    buff_pos += Taille_chp;
                } else {
                    noend = Suivant_champ(Taille_chp);
                }
                //-------------- PREPARE NEW FIELD -----------------
                //  buff_pos += Taille_chp;
                //  noend = Suivant_champ(); // modified on 12 2010 for protocol detection

                if (noend < 0 && buff_pos < bufferSize()) {
                    error_val = "no following field for data / " + (buff_pos - bufferSize());
                    return false;
                }
                if (result.getstop() == -1) {
                    error_val = "Stop asked";
                    return true;
                }
                if (getprotolevel() < 2 && buff_pos < bufferSize()) {
                    TDeb.wri("donnees non decodees /" + (buff_pos - bufferSize()));
                    error_val = "too much data /" + (buff_pos - bufferSize());
                    return false;
                }
                if (result.getBuffer() != null && result.getBuffer().length > 0) {
                    result.setSlider(100 * buff_pos / result.getBuffer().length);
                }

                TDeb.wri("field : " + chp_nom + " / " + Taille_chp + " at " + buff_pos + " of " + bufferSize() + ", proto_path : " + proto_path);
                if (result.getstop() == -2) {
                    TDeb.wri("ask to send this model: " + result);
                    //-------- SEND PACKET WITH COPY OF REUSLT----------
                    result.send_model(buff_pos);
                    //--------- PREPARE NEW RESULT--------------- 
                    //PB DESC_pad??
                    byte[] buff = result.getfrombuffer(buff_pos, result.getBuffer().length - (buff_pos));
                    result.clear();
                    //result.removeLastProto();
                    result.setbuffer(buff);
                    result.setinitbuffer();
                    buff_pos = 0;
                }
                if (result.getstop() == -3) {
                    error_val = "normal stop asked for :" + protoname;
                    noend = -1;
                    result.setstop(0);
                }
                if (result.getstop() == -4) {
                    error_val = "normal general stop asked";
                    noend = -1;
                }
            }
        }
        return true;
    }

    private void encode_fields(String init) {

        // if encode from code model => simply add HXvalue fields...

        String sproto;
        String stype;
        if (initproto(init) == false) {
            return;
        }
        buff_pos = 0;
        while (true) {//Fencode.isnotlast()) {

            //init et resultats & sous-element in XML filter

            DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
            XMLres field = (XMLres) node0.getUserObject();
            sproto = field.getAttrValAsstring("sproto");
            if (field.getAttrVal("sizecode") == null) {
                stype = this.proto_tsize;
            } else {
                stype = field.getAttrValAsstring("sizecode");
            }

            //----cherche une value expressive
            String[] F_Val = null;
            String[] F_VDesc = null;
            DefaultMutableTreeNode node_f = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
            if (field.getAttrVal("valenum") != null) {
                TreePath val_path = getsubproto("valenum", field.getAttrValAsstring("valenum"));
                DefaultMutableTreeNode pdmlnode = (DefaultMutableTreeNode) val_path.getLastPathComponent();
                for (int i = 0; i < pdmlnode.getChildCount(); i++) {
                    DefaultMutableTreeNode child_node = (DefaultMutableTreeNode) pdmlnode.getChildAt(i);
                    DefaultMutableTreeNode a = new DefaultMutableTreeNode(child_node.getUserObject());
                    node_f.add(a);
                }
            }
            if (node_f.getChildCount() > 0) {
                for (int idx = 0; idx < node_f.getChildCount(); idx++) {
                    DefaultMutableTreeNode node_v = (DefaultMutableTreeNode) node_f.getChildAt(idx);
                    XMLres value = (XMLres) node_v.getUserObject();
                    // val_res=Obj_v.getorderedvalue(attr_val);
                    String[] a = new String[1];
                    String[] desc = new String[1];
                    a[0] = value.getAttrValAsstring("value");
                    desc[0] = value.getAttrValAsstring("desc");
                    if (F_Val == null) {
                        F_Val = a;
                        F_VDesc = desc;
                    } else {
                        F_Val = TUtils.addtab(F_Val, a);
                        F_VDesc = TUtils.addtab(F_VDesc, desc);
                    }
                }
            }

            //-----------enregistre le chp et sa valeur
            result.addrow((getprotolevel() - 2) / 2, field.getAttrValAsstring("name"), field.getAttrValAsstring("desc"),
                    field.getAttrValAsstring("desc2"), field.getAttrValAsstring("size"), stype, field.getAttrValAsstring("code"),
                    field.getAttrValAsstring("format"), field.getAttrValAsstring("class"), field.getAttrValAsstring("mand"),
                    field.getAttrValAsstring("visible"), field.getAttrVal("sproto") != null, F_Val, F_VDesc, field.getAttrValAsstring("default"));
            TDeb.wri("-+++++++++++++++++++++++++++-");
            if (sproto == null) {
                result.setwaitingnext(true);
                while (result.iswaitingnext()) {
                    //Attente choix et bouton "Next"
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException ex) {
                        TDeb.wri("=>" + ex.getLocalizedMessage());
                    }
                }
                //   Fencode.MajFields();
                if (result.getencode_selected() >= 0) {
                    DefaultMutableTreeNode node_v = (DefaultMutableTreeNode) node_f.getChildAt(result.getencode_selected());
                    proto_path = proto_path.pathByAddingChild(node_v);
                }
            }
            TDeb.wri("---------------------------");

            if (sproto != null) {
                T_Code dec = new T_Code();
                dec.setName(dec.getName() + " / Encode");
                dec.setresult(result);
                dec.setproto_file(protoname);
                result.setsplevel(result.getsplevel() + 1);
                dec.encode_fields(sproto);
                result.setsplevel(result.getsplevel() - 1);
                // Fencode.setlast(false);
            }
            if (Suivant_champ(0) < 0) {
                result.setwaitingnext(true);
                while (result.iswaitingnext()) {
                    //Attente choix et bouton "Next"
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException ex) {
                        TDeb.wri("=>" + ex.getLocalizedMessage());
                    }
                }
                //  Fencode.MajFields();
                return;
            }
        }
        //  Fencode.setlast(false);
        //  return;
    }

    /**
     * check if field is present B => Field if BitMap M => Mandatory O =>
     * Optional
     *
     */
    private boolean Pres_champ(String mand, String nom_chp, String sizetxt) {
        boolean res = false;
        int size;
        try {
            size = Integer.parseInt(sizetxt);
        } catch (NumberFormatException e) {
            size = 0;
        }
        if (mand == null) {
            return true;
        }
        if (mand.compareTo("M") == 0) {
            //-------------------------------03 2013------------------------------
          /*   if (buffersize() == buff_pos) {
             // this is the end of the
             return false;
             }*/
            //------------------------------------------------------------
            return true;

        }
        if (mand.compareTo("B") == 0) {
            //verifer si active...
            int numchp = -1;
            try {
                numchp = Integer.parseInt(nom_chp.substring(1, 4));
            } catch (NumberFormatException ex) {
                TDeb.wri("=>" + ex.getLocalizedMessage());
            }
            if (numchp != -1 && numchp < 128) {
                res = result.isBMap(numchp);
                return res;
            }
        }
        if (mand.compareTo("O") == 0) {
            // present if data left
            //+size=> !!!only avalable from 'big' field 'at the end' 
            //and end of FSXXT size fields
            if (bufferSize() < buff_pos + size) {
                return false;
            }
            // present if no FS following && no FS field
            if (proto_fssize != null && sizetxt != null) {
                if (bufferSize() > buff_pos + proto_fssize.length() && sizetxt.startsWith("FS") == false) {
                    String nx = new String(result.getfrombuffer(buff_pos, proto_fssize.length()));
                    if (nx.compareTo(proto_fssize) == 0) {
                        return false;
                    }
                }
            }
            return true;
        }
        return res;
    }

    /**
     * compute the size of the field
     * <br> X => size is X
     * <br> BM => 16 or 8 if first bit is set
     * <br> $Y => XX if {value="XX"/memin="Y"} in previous field
     * <br> $Y/T => XX if {value="XX"/memin="Y"} in previous field and T if &Y
     * is not feel
     * <br> Var/X => size is defined in X first byte of the field in
     * sizetype="AAAAA" type
     * <br> Var[X]/Y => at byteX, size on Y bytes
     * <br>Var/$Y => size is defined in memorysed X first byte of the field in
     * sizetype="AAAA" type
     * <br> T => T size is at the end of the received data byte
     * <br> FS/AA => size is defined with the end TXT=> AA<br> FS/0xH.. => size
     * is defined with the end charactte(0xHH)
     * <br> FSB => Field separateur at the start of the field
     * <br> FSE => Field separator at the end of the field
     * <br> FSEX => Field separator at the end of the field Exclude
     * <br> FS..T => if no separator found => field is the end of the frame
     * (without waiting).
     */
    private int Taille_champ(String sizetxt, String sizetype, String type) {
        if (sizetxt == null) {
            return 9999;
        }
        sizetxt = sizetxt.trim();
        fieldFSsize = 0;
        fieldoffset = 0;
        int size = 9999;
        if (type == null) {
            error_val = "type should be fixed";
            TDeb.wri(error_val);
            return 9998;
        }
        if (type.compareTo("BM") == 0) {
            // should it be bettrer to use A001? as extention of bitMap? ! size is 0 or 8 if A001 asked
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
            if (((XMLres) node.getUserObject()).getName().compareTo("A000") == 0) {
                // first bit is set => -127<x<0
                if (buff_pos >= result.getBuffer().length) {
                    //append when decoding CB2A_auto=> A000 of CB2A following
                    error_val = "Error: Asking BITMAP at " + buff_pos + " and buffer size is [" + result.getBuffer().length + "].";
                    TDeb.wri(error_val);
                    return 9998;
                }
                if (result.getBuffer()[buff_pos] < 0) {
                    size = 16;
                } else {
                    size = 8;
                }
                return size;
            }
        }
        //if defined by a Field Separator
        if (sizetxt.length() > 1) {
            String vardesc = "$";
            if (sizetxt.substring(0, vardesc.length()).compareTo(vardesc) == 0) {
                String memtxt = sizetxt.substring(vardesc.length());
                boolean tryT = false;
                if (memtxt.endsWith("/T") && memtxt.length() > 2) {
                    memtxt = memtxt.substring(0, memtxt.length() - 2);
                    tryT = true;
                }
                if (sizetype == null) {
                    error_val = "Error: codesize should not be null for " + vardesc + " [" + protoname + "] field : xxx";
                    TDeb.wri(error_val);
                    return 9999;
                }
                int idx;
                try {
                    idx= Integer.parseInt(memtxt);
                }catch(NumberFormatException ex){
                           error_val = "no $" + sizetxt + " [" + ex.getMessage() + "]";
                    TDeb.wri(error_val);
                     return 9999;
                }
                try{
                    byte[] buff = result.getmem(idx);
                    if (buff != null) {
                        return Integer.parseInt(TDeb.retire(sizetype, buff).trim());
                    } else if (tryT) {
                        return Taille_champ("T", sizetype, type);
                    } else {
                        error_val = "no entry for $" + idx + " !";
                        TDeb.wri(error_val);
                        return 9999;
                    }
                } catch (NumberFormatException ex) {
                    error_val = "no $" + sizetxt + " with "+sizetype+ "[" + ex.getMessage() + "]";
                    TDeb.wri(error_val);
                     return 9999;
                }

            }

            vardesc = "FS";
            if (sizetxt.startsWith(vardesc)) {
                //FS => default FS/XX=>"XX en ascii ou byte 0x1e0x1e"
                //used for flag 7e in PPP
                String FSval = proto_fssize;
                if (sizetxt.indexOf("/") > 0) {
                    FSval = sizetxt.substring(sizetxt.indexOf("/") + 1);
                    sizetxt = sizetxt.substring(0, sizetxt.indexOf("/"));
                }

                if (FSval == null) {
                    error_val = "Error: field separator not set (sizefs=) in: " + protoname;
                    TDeb.wri(error_val);
                    return 9999;
                }
                if (FSval.startsWith("0x")) {
                    byte[] by;
                    try {
                        by = TUtils.string2byte(FSval);
                    } catch (Exception ex) {
                        error_val = "Error: " + FSval + " as Fied Separator in : " + protoname;
                        TDeb.wri(error_val);
                        return 9999;
                    }
                    FSval = new java.lang.String(by);
                }
                //need to load streams byte (1/1?)
                // TODO : new string() is not ASCII
                byte[]buffer=result.getfrombuffer(buff_pos, bufferSize() - buff_pos);
                String car;
                try{
                    car = new String(buffer, "US-ASCII");
                }catch(UnsupportedEncodingException ex){
                    car = new String(buffer);
                }
                if (car.length() - FSval.length() < 0) {
                    //9999=>9998 because if FS as until last char => not an error
                    TDeb.wri("FS : field to short :  " + car + " for FS : " + FSval);
                    return 9998;
                }
                if (sizetxt.startsWith("FSB")) {
                    //avoid first occurence to look for next one
                    if (car.substring(0, FSval.length()).compareTo(FSval) != 0) {
                        return 9998;
                    }
                    car = car.substring(FSval.length());
                }
                int i = car.indexOf(FSval);
                if (i < 0) {
                    if (sizetxt.endsWith("T")) {
                        i = car.length();
                        fieldFSsize = 0;
                    }
                    while (i < 0) {
                        /* if FS not found => look for other characters in the buffer/stream as Mandatory*/
                        int chkres = checkBuffer(bufferSize() - buff_pos + 1, true);
                        if (chkres == -1) {
                            TDeb.wri("taillechp : FS : " + FSval + " not found in : " + car);
                            return 9999;
                        } else if (chkres == -3) {
                            TDeb.wri("no buffer or error ");
                            return 9999;
                        } else if (chkres == -2) {
                            if (sizetxt.startsWith("FSB")) {
                                if (bufferSize() - buff_pos == 0) {
                                    return 9998;
                                } else {
                                    fieldoffset = FSval.length();
                                    return bufferSize() - buff_pos;
                                }
                            } else {
                                return 9998;
                            }
                        }
                        car = new String(result.getfrombuffer(buff_pos, bufferSize() - buff_pos));
                        i = car.indexOf(FSval);
                        fieldFSsize = FSval.length();
                    }
                } else {
                    fieldFSsize = FSval.length();
                }
                if (sizetxt.startsWith("FSB")) {
                    TDeb.wri("FSBegin " + sizetxt + " returned =>" + i + " with FS SIZE:" + fieldFSsize);
                } else {
                    TDeb.wri("FSEnd " + sizetxt + " returned =>" + i + " with FS SIZE:" + fieldFSsize);
                }
                if (sizetxt.startsWith("FSEX")) {
                    fieldFSsize=0;
                    return i ;
                }else{
                    return i + fieldFSsize;  
                }
            }
        }
        //if defined as Var/XX ex : TLV
        if (sizetxt.length() > 4) {
            String vardesc = "Var/";
            //size="Var/XX" =>XX=> size of the size field (size NOT inclued)
            if (sizetxt.startsWith(vardesc)) {
                if (sizetype == null) {
                    error_val = "Error: codesize should not be null for " + vardesc + " [" + protoname + "] field :xxxx";
                    TDeb.wri(error_val);
                    return 9999;
                }
                try {
                    String tsval = sizetxt.substring(vardesc.length());
                    int tsize;
                    if (tsval.substring(0, 1).compareTo("$") == 0) {
                        int idx = Integer.parseInt(tsval.substring(1));
                        //we beleve? that the size of the size is the same type as the size.
                        tsize = Integer.parseInt(TDeb.retire(sizetype, result.getmem(idx)));
                    } else {
                        tsize = Integer.parseInt(tsval);
                    }
                    /// -- get missing bytes from stream
                    int chkres = checkBuffer(tsize, true);
                    if (chkres == -1 || chkres == -2) {
                        return 10000 - chkres;
                    }
                    String sizeval = TDeb.retire(sizetype, result.getfrombuffer(buff_pos, tsize));
                    size = tsize + Integer.parseInt(sizeval);
                    fieldoffset = tsize;
                } catch (NumberFormatException ex) {
                    error_val = "Pb searching size Var/.. [" + ex.getMessage() + "]";
                    TDeb.wri(error_val);
                    return 9999;
                }
                return size;
            }
            //size="Var[XX]/YY" => positionXX/YY=>Size of the size field (size include)
            //used for tcp
            vardesc = "Var[";
            String sep = "]/";
            if (sizetxt.startsWith(vardesc)) {
                if (sizetype == null) {
                    error_val = "Error: codesize should not be null for " + vardesc + " [" + protoname + "] field :xxxx";
                    TDeb.wri(error_val);
                    return 9999;
                }
                try {
                    int off = Integer.parseInt(sizetxt.substring(vardesc.length(), sizetxt.lastIndexOf(sep)));
                    int tsize = Integer.parseInt(sizetxt.substring(sizetxt.lastIndexOf(sep) + sep.length()));
                    int chkres = checkBuffer(tsize + off, true);
                    if (chkres == -1) {
                        return 9999;
                    }
                    if (chkres == -2) {
                        return 9998;
                    }
                    size = Integer.parseInt(TDeb.retire(sizetype, result.getfrombuffer(buff_pos + off, tsize)));
                } catch (NumberFormatException ex) {
                    error_val = "Pb searching size Var/.. [" + ex.getMessage() + "]";
                    TDeb.wri(error_val);
                    return 9999;
                }
                if (size >= 0) { //=0 used for RFC1086+
                    return size;
                } else {
                    error_val = "Pb searching size: " + sizetxt + " founded: " + size + "!!";
                    TDeb.wri(error_val);
                    return 9999;
                }

            }
            //size="Var-XX/YY" => XXoffset/YY=>size of real size=value(YY) -XX
            //used for rfc1086
            vardesc = "Var-";
            sep = "/";
            if (sizetxt.startsWith(vardesc)) {
                if (sizetype == null) {
                    error_val = "Error: codesize should not be null for " + vardesc + " [" + protoname + "] field :xxxx";
                    TDeb.wri(error_val);
                    return 9999;
                }
                try {
                    int off = Integer.parseInt(sizetxt.substring(vardesc.length(), sizetxt.lastIndexOf(sep)));
                    int tsize = Integer.parseInt(sizetxt.substring(sizetxt.lastIndexOf(sep) + sep.length()));
                    int chkres = checkBuffer(tsize, true);
                    if (chkres == -1) {
                        return 9999;
                    }
                    if (chkres == -2) {
                        return 9998;
                    }
                    size = Integer.parseInt(TDeb.retire(sizetype, result.getfrombuffer(buff_pos, tsize)));
                    if (size < off) {
                        return 9999;
                    }
                    fieldoffset = tsize;
                    size = size - off + tsize;
                } catch (NumberFormatException ex) {
                    error_val = "Pb searching size Var/.. [" + ex.getMessage() + "]";
                    TDeb.wri(error_val);
                    return 9999;
                }
                return size;
            }
        }
        if (sizetxt.startsWith("T-")) {
            size = bufferSize() - buff_pos - (new Integer(sizetxt.substring("T-".length())));
            return size;
        }
        if (sizetxt.compareTo("T") == 0) {
            size = bufferSize() - buff_pos;
            if (size == 0) {
                return 9998;
            }
            return size;
        }
        try {
            if (size == 9999) {
                size = Integer.parseInt(sizetxt);
                if (size<0){
                    // TODO : for NDC  should be better (subproto...)!!
                    buff_pos+=size;
                    size=0;
                }
            }
        } catch (NumberFormatException ex) {
            TDeb.wri("=>" + ex.getLocalizedMessage());
            return 9999;
        }
        return size;
    }

    /**
     * compute following field by changing proto_path
     *
     */
    private int Suivant_champ(int Taille_chp) {

        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
        DefaultMutableTreeNode node1 = null;
        // could be a field if there are values but field not present.
        if (node0.toString().compareTo("field") != 0 && node0.getChildCount() > 0) {
            int i = 0;
            while (node0.getChildAt(i).toString().compareTo("field") != 0
                    && i < node0.getChildCount()) {
                i++;
            }
            if (i < node0.getChildCount()) {
                // this field follow the value
                proto_path = proto_path.pathByAddingChild(node0.getChildAt(i));
            } else {
                //no field beloww this value.
                return -1;
            }
            return 0;
        }
        // node0 is a leaf.. node 1 will be next slibing node or "next" asked field
        //node 1 is target node
        while (node1 == null) {
            node0 = (DefaultMutableTreeNode) proto_path.getLastPathComponent();
            node1 = node0.getNextSibling();
            if (node1 == null) {
                node1 = getNextNode(node0, Taille_chp);
                //      System.out.println("next :" + node1);
            }
            if (node1 == null || node0.toString().compareTo("value") == 0) {
                //no target found => comme back in the tree
                proto_path = proto_path.getParentPath();
                if (proto_path == init_path) {
                    //arrived on '(sub)protocol' node => exit
                    return -1;
                }
                node1 = null;
            }
        }
        // node1 is found, Assign it
        if (node0 != node1 && node1 != null) {// node1 is not null (while()...)
            proto_path = proto_path.getParentPath();
            proto_path = proto_path.pathByAddingChild(node1);
        }
        if (node1 != null && node1.getUserObject() instanceof XMLres) {
            XMLres Obj_v = (XMLres) node1.getUserObject();
            TDeb.wri(protoname + "=>node1 :" + Obj_v.getName());
        }
        return 0;
    }

    private DefaultMutableTreeNode getNextNode(DefaultMutableTreeNode node, int Taille_chp) {
        TreePath pathtemp = proto_path;
// look if there is a loop (next="field") on the node => if no return null or if yes the "field"
        if (node == null || proto_path == null) {
            return null;
        }
        XMLres field = (XMLres) node.getUserObject();
        //   System.out.println("getNextNode : "+node+"D : " + (buff_pos == buffersize())+">"+field.getAttrVal("next"));
        // CHOICE : if end of buffer & next then end decode...
        if (field.getAttrVal("next") == null || buff_pos + Taille_chp == bufferSize()) {
            return null;
        }
        while (node != node.getRoot()) {
            for (int idx = 0; idx < node.getParent().getChildCount(); idx++) {
                //look if a nodename=next
                DefaultMutableTreeNode nodefam = (DefaultMutableTreeNode) node.getParent().getChildAt(idx);
                XMLres nodefam2 = (XMLres) nodefam.getUserObject();
                if (field.getAttrValAsstring("next").compareTo(nodefam2.getName()) == 0) {
                    proto_path = pathtemp;
                    return (DefaultMutableTreeNode) node.getParent().getChildAt(idx);
                }
            }
            node = (DefaultMutableTreeNode) node.getParent();
            if (pathtemp != null) {
                pathtemp = pathtemp.getParentPath();
            }
        }
        return null;
    }
    //!! count value & field levels

    public int getprotolevel() {
        return proto_path.getPathCount();
    }

    @Override
    public void run() {
        //need to be launched as thread to avoid slow port stream
        if (result == null) {
            return;
        }
        TDeb.wri("--Start Code ---");
        if (result.isencode()) {
            TDeb.wri("start Encode");
            encode_fields("protocol");
        } else {
            TDeb.wri("start Decode");
            if (decode_fields("protocol") == false) {
                result.CloseonExit();
                TDeb.wri("!Error Decode byte at :" + buff_pos + " =>" + error_val);
                if (silent == false) {
                    javax.swing.JOptionPane.showMessageDialog(new javax.swing.JFrame(),
                            "Error: " + error_val, "Error box",
                            javax.swing.JOptionPane.WARNING_MESSAGE);
                }
            } else {
                if (error_val != null && error_val.length() > 0) {
                    TDeb.wri("Ended with " + error_val);
                    if (silent == false) {
                        javax.swing.JOptionPane.showMessageDialog(new javax.swing.JFrame(),
                                "Ended with " + error_val, "Information box",
                                javax.swing.JOptionPane.INFORMATION_MESSAGE);
                    }
                }
                TDeb.wri("---End of thread---");
            }
            if (result.getsplevel() == 0) {
                result.EndModel();
            }

            /*  if (result.getbuffer()==null||result.getbuffer().length==0) {
             result.EndModel();
             }*/
            if (result.getRowCount() > 0) {
                result.send_model(-1);
            }
            result.setSlider(0);
            result.checkEOF();
        }
        TDeb.wri("---End of thread---");
    }
}
