/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * P_LineOGL.java
 *
 * Created on 23 avr. 2009, 12:20:20
 */
package com.jdcm.charts;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.keyboard.KeyNavigatorBehavior;
import com.sun.j3d.utils.behaviors.mouse.MouseWheelZoom;
import com.sun.j3d.utils.behaviors.mouse.MouseRotate;
import java.applet.Applet;

/**
 * An Applet to display 3D Charts as OGL
 * @author Marc GIBOIN
 */

public class A_LineOGL extends Applet {
    // for serializable interface

    private static final long serialVersionUID = 1L;

    private final double zoomx = 1.0;
    private final double zoomy = 1.0;
    private final double depx = 0.0;
    private final double depy = 0.0;
        private final BoundingSphere bounds = new BoundingSphere();
        
            private P_Chartplus Parent = null;
    private SimpleUniverse simpleU = null;
    private BranchGroup scenebg = null;
    private BranchGroup curbbg = null;
    //private TransformGroup curbtg = null;
    private TransformGroup scenetg = null;
    //private Shape3D axes = null;
    private MouseRotate mousNavrot = null;
    //java.applet.Applet screen=null;

    /** Creates new form P_LineOGL */
    /* public A_LineOGL() {
         initialize();
     }*/
    /**
     *  create an OGL Windows
     * @param p 
     */
    public A_LineOGL(P_Chartplus p) {
        Parent = p;
        initComponents();
        initialize();
    }
   private void initialize(){
        Canvas3D canvas3D = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
        add(canvas3D);
        simpleU = new SimpleUniverse(canvas3D);
        scenebg = createSceneGraph();
        Shape3D axes = new Axis();
        scenetg = createTGauto_rot();
        scenetg.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);
        if (Parent.getAxis()!=P_Chartplus.AXIS_NONE){
            scenetg.addChild(axes);
        }
        scenebg.addChild(scenetg);
        scenebg.addChild(mousNavrot);

        MouseWheelZoom weelNavBeh = new MouseWheelZoom(createTGPlatf_trans());
        weelNavBeh.setSchedulingBounds(bounds);
        scenebg.addChild(weelNavBeh);
        
        KeyNavigatorBehavior keyNavBeh = new KeyNavigatorBehavior(createTGPlatf_trans());
        keyNavBeh.setSchedulingBounds(bounds);//new BoundingSphere(new Point3d(),1000.0)
        scenebg.addChild(keyNavBeh);
        
        simpleU.getViewingPlatform().setNominalViewingTransform();
        scenebg.compile();
        simpleU.addBranchGraph(scenebg);
   }
    public void Update() {
        if (Parent == null) {
            return;
        }

        /*  Remove All Curbes & Axes
        }*/
        java.util.Enumeration<?> en =scenetg.getAllChildren();
        while (en.hasMoreElements()) {
            Object node = en.nextElement();
            if (node instanceof BranchGroup) {
                scenetg.removeChild((Node) node);
            }
        }
        curbbg = new BranchGroup();
        curbbg.setCapability(BranchGroup.ALLOW_DETACH);
        java.util.Enumeration<?> e = scenebg.getAllChildren();
        while (e.hasMoreElements()) {
            Object node = e.nextElement();
            if (node instanceof Background) {
                ((Background) node).setColor(getColor3f(Parent.getBackground()));
            }
        }
        // curbtg = createTGauto_rot();
      /*  if (Parent.isaxes()) {
        // need to check before if axis is already set
        scenetg.addChild(new Axis());
        }*/
        for (int i = 0; i < Parent.getcourbsSize(); i++) {
            if (Parent.getcourb(i) != null
                    && Parent.getcourb(i).isVisible()) {
                addCurb(Parent.getcourb(i));
            }
        }

        curbbg.compile();
        scenetg.addChild(curbbg);


    }

    private void addCurb(Donnees vals) {
        // get info from Vals
        int type = vals.gettype();
        vals.settype(2);
        float[] coordinateData = vals.createCoordinateData();
        int[] stripCount = vals.stripData();
        vals.settype(type);
        // do geometry
        if (vals.is3D() == false) {
            LineArray lineArray = new LineArray(stripCount[0], LineArray.COORDINATES | LineArray.COLOR_3);
            lineArray.setCoordinates(0, coordinateData);
            for (int j = 0; j < lineArray.getVertexCount(); j++) {
                lineArray.setColor(j, getColor3f(vals.getcurbcolor()));
            }
            Appearance linesColoringAppearance = new Appearance();
            // ColoringAttributes linesColoring = new ColoringAttributes(getColor3f(vals.getcurbcolor()), ColoringAttributes.SHADE_GOURAUD);
            // linesColoringAppearance.setColoringAttributes(linesColoring);
            LineAttributes lineAttrib = new LineAttributes();
            lineAttrib.setLineWidth(1.0f);
            linesColoringAppearance.setLineAttributes(lineAttrib);

            curbbg.addChild(new Shape3D(lineArray));
            return;
        }
        if (type >= 2) {
            GeometryInfo gi = new GeometryInfo(GeometryInfo.TRIANGLE_ARRAY);
            //coordinateData : 0.0f,0.0f,0.0f (x,y,z)
            gi.setCoordinates(coordinateData);
            if (gi.getCoordinates() != null) {
                gi.recomputeIndices();

                NormalGenerator ng = new NormalGenerator();
                ng.generateNormals(gi);
                gi.recomputeIndices();

                Stripifier st = new Stripifier();
                st.stripify(gi);
                gi.recomputeIndices();
                //-----------SHAPE--------------------------
                Shape3D curb = new Shape3D();
                // if(wireFrame==true)
                //      curb.setAppearance(createWireFrameAppearance(getColor3f(vals.getfeelcolor()));
                // else
                curb.setAppearance(createMaterialAppearance(vals.getfeelcolor()));
                curb.setGeometry(gi.getGeometryArray());
                curbbg.addChild(curb);

            }
        }
        if (type < 2 || type == 3) {
            // if GeometryInfo.TRIANGLE_STRIPS_ARRAY or POLYGON_ARRAY
            //---------------LINE--------------------------------------
            if (stripCount != null) {
                LineStripArray lineArray = new LineStripArray(3 * stripCount.length, LineArray.COORDINATES, stripCount);
                lineArray.setCoordinates(0, coordinateData);
                Appearance linesColoringAppearance = new Appearance();
                ColoringAttributes linesColoring = new ColoringAttributes(getColor3f(vals.getcurbcolor()), ColoringAttributes.SHADE_FLAT);
                linesColoringAppearance.setColoringAttributes(linesColoring);
                LineAttributes lineAttrib = new LineAttributes();
                lineAttrib.setLineWidth(1.0f);
                linesColoringAppearance.setLineAttributes(lineAttrib);
                curbbg.addChild(new Shape3D(lineArray, linesColoringAppearance));
            }
        }

    }

    private Color3f getColor3f(java.awt.Color c) {
        float r = new Float(c.getRed());
        float g = new Float(c.getGreen());
        float b = new Float(c.getBlue());
        //javax.media.j3d.TransparencyAttributes for Alpha...
        //SHADE_GOURAUD is default...
        return new Color3f(r / 255, g / 255, b / 255);
    }

    private TransformGroup createTGPlatf_trans() {
        Vector3f translate = new Vector3f();

        TransformGroup vpTrans = simpleU.getViewingPlatform().getViewPlatformTransform();
        translate.set(0.0f, 0.0f, 0.0f);
        Transform3D T3D = new Transform3D();
        T3D.setTranslation(translate);
        vpTrans.setTransform(T3D);
        return vpTrans;
    }

    private TransformGroup createTGauto_rot() {
        //TransformGroup objSpin = new TransformGroup();
        //objSpin.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        //RotationInterpolator rotator = new RotationInterpolator(new Alpha(-1, 16000), objSpin);
        //objSpin.addChild(rotator);
        //rotator.setSchedulingBounds(bounds);
        TransformGroup objSpin = new TransformGroup();
        objSpin.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        objSpin.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        objSpin.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
        Transform3D T3D = new Transform3D();
        //  T3D.rotY(Math.PI/4);
        T3D.setScale(0.2f);
        //T3D.setRotation(new AxisAngle4d())
        objSpin.setTransform(T3D);
        mousNavrot = new MouseRotate(objSpin);
        mousNavrot.setSchedulingBounds(bounds);//new BoundingSphere()

        return objSpin;
    }

    private BranchGroup createSceneGraph() {
        BranchGroup contentRoot = new BranchGroup();
        Background background = new Background();
        background.setCapability(Background.ALLOW_COLOR_WRITE);
        background.setCapability(Background.ALLOW_COLOR_READ);
        background.setColor(0f, 0f, 0f);
        background.setApplicationBounds(bounds);
        contentRoot.addChild(background);

        //--------------lights-----------------------
        DirectionalLight lightDU = new DirectionalLight();
        lightDU.setDirection(new Vector3f(0.0f, -100.0f, -100f));
        lightDU.setEnable(true);
        lightDU.setInfluencingBounds(bounds);
        contentRoot.addChild(lightDU);



        return contentRoot;
    } // end of CreateSceneGraph method of MobiusApp

    Appearance createMaterialAppearance(java.awt.Color c) {

        Appearance materialAppear = new Appearance();
        PolygonAttributes polyAttrib = new PolygonAttributes();
        polyAttrib.setCullFace(PolygonAttributes.CULL_NONE);
        materialAppear.setPolygonAttributes(polyAttrib);
        Material material = new Material();
        material.setDiffuseColor(this.getColor3f(c));
        materialAppear.setMaterial(material);
        if (c.getAlpha() < 255) {
            TransparencyAttributes ta = new TransparencyAttributes();
            ta.setTransparencyMode(TransparencyAttributes.FASTEST);
            ta.setTransparency(1 - (new Float(c.getAlpha()) / 255));
            materialAppear.setTransparencyAttributes(ta);
        }
        return materialAppear;
    }

    Appearance createWireFrameAppearance(java.awt.Color c) {

        Appearance materialAppear = new Appearance();
        PolygonAttributes polyAttrib = new PolygonAttributes();
        polyAttrib.setPolygonMode(PolygonAttributes.POLYGON_LINE);
        materialAppear.setPolygonAttributes(polyAttrib);
        ColoringAttributes matColoring = new ColoringAttributes();
        matColoring.setColor(this.getColor3f(c));
        materialAppear.setColoringAttributes(matColoring);
        if (c.getAlpha() < 255) {
            TransparencyAttributes ta = new TransparencyAttributes();
            ta.setTransparencyMode(TransparencyAttributes.FASTEST);
            ta.setTransparency(1 - (new Float(c.getAlpha()) / 255));
            materialAppear.setTransparencyAttributes(ta);
        }
        return materialAppear;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jRadioButton1 = new javax.swing.JRadioButton();

        jRadioButton1.setText("jRadioButton1");

        setLayout(new java.awt.GridLayout(1, 0));
    }// </editor-fold>//GEN-END:initComponents

    /*   if (simpleU==null){
    Canvas3D canvas3D = new Canvas3D(screen.getGraphicsConfiguration());
    add("Center", canvas3D);
    simpleU = new SimpleUniverse(canvas3D);
    simpleU.getViewingPlatform().setNominalViewingTransform();
    }
    BranchGroup objRoot = new BranchGroup();
    TransformGroup objRotate = new TransformGroup();
    for (int courbe = 0; courbe < main.getcourbsSize(); courbe++) {
    Donnees vals = main.getcourb(courbe);
    BranchGroup scene = createSceneGraph(false, vals);

    simpleU.addBranchGraph(scene);
    }*/
    // }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton jRadioButton1;
    // End of variables declaration//GEN-END:variables
}

class Axis extends Shape3D {

    /**
    
    create axis visual object
     */
    public Axis() {
        Appearance materialAppear = new Appearance();
        ColoringAttributes matColoring = new ColoringAttributes();
        matColoring.setColor(new Color3f(0.0f, 0.0f, 0.0f));
        materialAppear.setColoringAttributes(matColoring);
        this.setAppearance(materialAppear);
        for (String axe : new String[]{"x", "y", "z"}) {
            this.insertGeometry(createGeometry(axe), 0);
        }

    }

    private Geometry createGeometry(String label) {
        // create line for X axis
        Color3f axecol = new Color3f(1.0f, 0.0f, 0.0f);
        Point3f extpt = new Point3f(1.0f, 0.0f, 0.0f);
        if (label.startsWith("y")) {
            axecol = new Color3f(0.0f, 1.0f, 0.0f);
            extpt = new Point3f(0.0f, 1.0f, 0.0f);
        } else if (label.startsWith("z")) {
            axecol = new Color3f(0.0f, 0.0f, 1.0f);
            extpt = new Point3f(0.0f, 0.0f, 1.0f);
        }
        // construct object to represent the X/Y or Z axis
        LineArray axisLines = new LineArray(2, LineArray.COORDINATES | LineArray.COLOR_3);

        axisLines.setCoordinate(0, new Point3f(0.0f, 0.0f, 0.0f));
        axisLines.setCoordinate(1, extpt);
        axisLines.setColor(0, axecol);
        axisLines.setColor(1, axecol);

        return axisLines;

    } // end of Axis createGeometry()
} // end of class Axis

