/*
 * Donnees.java
 *
 * Created on 18 mai 2007, 10:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package com.jdcm.charts;

import java.io.Serializable;
import java.util.List;
import java.awt.Color;
import java.awt.Shape;

/**
 *
 * @author Marc GIBOIN
 */
public class Donnees implements Serializable {
// for serializable interface

    private static final long serialVersionUID = 1L;
        private final javax.swing.JMenuItem citem;
        
    private List<Mesure> mesures = null;
    private Color Gmaincol = Color.GREEN;
    private Color Gseccol = new java.awt.Color(0, 255, 0, 100);
    private Color Gptcol = Color.GREEN;
    private String Glabel = "";
    private Double Goffset = 0.0;
    // result of the delaunay triangulation
    com.jdcm.charts.A_Delaunay delaunay = null;
    java.util.List<ValuedPoint2D[]> edges = null;
    private boolean delaunayupd = false;
    private boolean delaunayrefresh = false;
    private boolean isvisible = true;
    public static int CURB_POINTS = 0;
    public static int CURB_LINES = 1;
    public static int CURB_SQR = 2;
    private String[] labels = {"x", "y", "z"};
    //0 point; 1 wire; 2 surface; 3 meshed
    int Gtype = -1;
    private boolean is3D = false;

    /**
     * create a new list of datas (curb)
     * @param axes arry of axes names (2 or 3 items) default is {"x", "y", "z"};
     * @param col color of the displayed curb
     * @param colpt color of displayed points of this curb
     * @param feelcol the color used to feel triangles 
     * @param typ type of curb drawing (0 points, 1 curb, 2 squared/filled, 3 ?/meshed
     * @param ofst the 0 position in the curb drawing (see serials)
     * @param lbl the label of the curb
     */
    public Donnees(String[] axes, Color col, Color colpt, Color feelcol, int typ, Double ofst, String lbl) {
        mesures = new java.util.ArrayList<>();
        if (axes != null) {
            labels = axes;
        }
        Gtype = typ;
        Goffset = ofst;
        Glabel = lbl;
        if (colpt != null) {
            Gptcol = colpt;
        }
        if (col != null) {
            Gmaincol = col;
        }
        if (col != null) {
            Gseccol = feelcol;
        }
        citem = new javax.swing.JMenuItem();
        citem.setText(Glabel);
        citem.addActionListener(new java.awt.event.ActionListener()     {

            @Override
            public void actionPerformed(java.awt.event.ActionEvent e) {
                java.awt.Color c = javax.swing.JColorChooser.showDialog(new javax.swing.JFrame(), "Select Color", getcurbcolor());
                if (c != null) {
                    setcurbcolor(c);
                }
            }
        });
    }

    @Override
    public String toString() {
        return this.Glabel;
    }

    /**
     * get curb values
     * @return a List filled with the curb mesurments
     */
    public List<Mesure> getmesures() {
        return mesures;
    }

    public int[] stripData() {
        if (edges != null) {
            int strips[] = new int[edges.size()];
            if (edges == null || edges.isEmpty()) {
                return null;
            }
            for (int i = 0; i < edges.size(); i++) {
                strips[i] = edges.get(i).length;
            }
            return strips;
        } else {
            return new int[]{2 * this.getmesures().size()};
        }
    }

    public float[] createCoordinateData() {
        //OpenGL (Java3D) use (for SimpleUnivers...) ?Y<=>Z?=> keep X,Y & Z
        java.util.List<Float> coords = new java.util.ArrayList<>();
        if (is3D == false) {
            if (mesures.size() > 1) {
                for (int i = 0; i < mesures.size() - 1; i++) {
                    Mesure p1 = mesures.get(i);
                    Mesure p2 = mesures.get(i + 1);
                    coords.add(new Float(p1.getposition()));
                    //on Y infinite +/- should be managed with Univers limite !=0!!
                    if (Double.isNaN(p1.getval()) || Double.isInfinite(p1.getval())) {
                        coords.add(0.0f);
                    } else {
                        coords.add(new Float(p1.getval()));
                    }
                    coords.add(0.0f); //on Z
                    coords.add(new Float(p2.getposition()));
                    if (Double.isNaN(p2.getval()) || Double.isInfinite(p2.getval())) {
                        coords.add(0.0f);
                    } else {
                        coords.add(new Float(p2.getval()));
                    }
                    coords.add(0.0f); //on Z
                }
            }
        } else {
            if (edges == null || edges.isEmpty()) {
                this.getdelaunay();
                if (edges == null) {
                    return null;
                }
            }
            for (ValuedPoint2D[] vpoints : edges) {
                for (ValuedPoint2D vpoint : vpoints) {
                    Mesure mes = (Mesure) vpoint.getvalue();
                    coords.add(new Float(vpoint.getX()));
                    coords.add(new Float(vpoint.getY()));
                    //on Z : infinite +/- should be managed with Univers limite !=0!!
                    if (Double.isNaN(mes.getval()) || Double.isInfinite(mes.getval())) {
                        coords.add(0.0f);
                    } else {
                        coords.add(new Float(mes.getval()));
                    }
                }
            }
        }

        float[] res = new float[coords.size()];
        for (int i = 0; i < res.length; i++) {
            res[i] = coords.get(i);
        }
        return res;

    }

    /**
     * set curb axes labels
     * "time" will display values as date,time,ms
     * @param txt array of string for x label,y label(z if nececary)
     * 
     * 
     */
    public void setAxislabel(String[] txt) {
        if (txt == null || txt.length < 2) {
            return;
        }
        labels = txt;
    }

    public String getAxislabel(String axisname) {
        if (labels == null) {
            return "-";
        }
        String res = null;
        if (axisname.toLowerCase().compareTo("x") == 0 && labels.length > 0) {
            res = labels[0];
        }
        if (axisname.toLowerCase().compareTo("y") == 0 && labels.length > 1) {
            res = labels[1];
        }
        if (axisname.toLowerCase().compareTo("z") == 0 && labels.length > 2) {
            res = labels[2];
        }
        if (res == null) {
            res = "";
        }
        return res;
    }

    public void setserialisable() {
        if (is3D()) {
            delaunay = null;
            edges = null;
            delaunayrefresh = true;
            delaunayupd = true;
        }
    }

    public boolean is3D() {
        return is3D;
    }

    private void set3D(boolean bool) {
        if (bool != is3D()) {
            is3D = bool;
            if (bool) {
                delaunay = new com.jdcm.charts.A_Delaunay();
            } else {
                edges = null;
                delaunay = null;
            }
        }
    }

    public boolean isVisible() {
        return isvisible;
    }

    public void setVisible(boolean bool) {
        isvisible = bool;
    }

    public Color getcurbcolor() {
        return Gmaincol;
    }

    public void setcurbcolor(Color c) {
        Gmaincol = c;
    }

    public Color getfeelcolor() {
        return Gseccol;
    }

    public void setfeelcolor(Color c) {
        Gseccol = c;
    }

    public Color getptcolor() {
        return Gptcol;
    }

    public void setptcolor(Color c) {
        Gptcol = c;
    }

    public int gettype() {
        return Gtype;
    }

    public void settype(int val) {
        if (gettype() != val) {
            if (this.is3D()) {
                delaunayupd = true;
            }
            Gtype = val;
        }

    }

    public Double getoffset() {
        return Goffset;
    }

    public void setoffset(Double val) {
        Goffset = val;
    }

    public String getlabel() {
        return Glabel;
    }

    public void setlabel(String txt) {
        Glabel = txt;
    }

    public void cleardata() {
        mesures.clear();
    }

    public javax.swing.JMenuItem getItemcol() {
        return citem;
    }

    public java.util.List<ValuedPoint2D[]> getdelaunay() {
        if (delaunayrefresh) {
            delaunay = null;
            delaunay = new A_Delaunay();
            for (Mesure m : mesures) {
                delaunay.insertPoint(new ValuedPoint2D(m.getpoint(), m));
            }
        }
        if (delaunayupd) {
            if (this.gettype() < 2) {
                // if point or wire graphic type
                edges = delaunay.computeEdges();
            } else {
                //if surface or meshed graphic type
                edges = delaunay.computeTriangles();
            }
            delaunayupd = false;
        }
        return edges;
    }

    public Double getPosAt(int i) {
        Mesure m;
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
            m = mesures.get(i);
            if (m != null) {
                return m.getposition();
            }
        } catch (IndexOutOfBoundsException ex) {
        }
        return null;

    }

    public void setPosAt(int i, Double pos) {
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
            mesures.get(i).setposition(pos);
        } catch (IndexOutOfBoundsException ex) {
        }
    }

    public java.awt.geom.Point2D getPointAt(int i) {
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
            Mesure m = mesures.get(i);
            if (m != null) {
                return m.getpoint();
            }
        } catch (IndexOutOfBoundsException ex) {
        }
        return null;//new java.awt.geom.Point2D.Double();

    }

    public void setPointAt(int i, java.awt.geom.Point2D pos) {
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
           mesures.get(i).setpoint(pos.getX(), pos.getY());
        } catch (IndexOutOfBoundsException ex) {
        }

    }

    public String getTagAt(int i) {
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
           Mesure m = mesures.get(i);
            if (m != null) {
                return m.tag;
            }
        } catch (IndexOutOfBoundsException ex) {
        }
        return null;
    }

    public void setTagAt(int i, String txt) {
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
            Mesure m = mesures.get(i);
            if (m != null) {
                m.tag = txt;
            }
        } catch (IndexOutOfBoundsException ex) {
        }

    }

    public Double getValAt(int i) {
        Mesure m = null;
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
            m = mesures.get(i);
        } catch (IndexOutOfBoundsException ex) {
        }
        /// care 
        if (m == null) {
            return null;
        }
        return m.getval();
    }

    public void setValAt(int i, Double val) {
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
            Mesure m = mesures.get(i);
            if (m != null) {
                m.setval(val);
            }
        } catch (IndexOutOfBoundsException ex) {
        }

    }

    public Shape getShapeAt(int i) {
        Mesure m = null;
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
            m = mesures.get(i);
        } catch (IndexOutOfBoundsException ex) {
        }
        if (m == null) {
            return null;
        }
        return m.shape;
    }

    public void setShapeAt(int i, Shape shp) {
        //try...catch to use checkrange in ArrayList (instead of double control)
        try {
           Mesure m = mesures.get(i);
            m.shape = shp;
        } catch (IndexOutOfBoundsException ex) {
        }
    }

    public void add(Double pos, Double value, String coment) {
        if (is3D == false && mesures!=null) {
            Mesure m = new Mesure(pos, value, coment);
            m.settParent(this);
            Mesure lastmes=null;
            if (mesures.isEmpty()==false){
                lastmes=mesures.get(mesures.size() - 1);
            }
            if (mesures.isEmpty() || (lastmes != null && pos > lastmes.getposition())) {
                try {
                    mesures.add(m);
                } catch (Exception ex) {
                    System.out.println("=>"+ex);
                }
            } else {
                int i = 0;
                while (i < mesures.size() && mesures.get(i) != null && pos > mesures.get(i).getposition()) {
                    i++;
                }
                mesures.add(i, m);
            }
        }
    }

    public void add(int idx, java.awt.geom.Point2D p, Double value, String coment) {
        Mesure m = new Mesure(p.getX(), p.getY(), value, coment);
        m.settParent(this);
        if (idx < 0) {
            idx = mesures.size();
        }
        mesures.add(idx, m);
        // see how order value with 3D
        set3D(true);
        delaunay.insertPoint(new ValuedPoint2D(m.getpoint(), m));
        delaunayupd = true;
    }

    public int size() {
        return mesures.size();
    }

    public void add(int idx, Double posx, Double posy, Double value, String coment) {
        add(idx, new java.awt.geom.Point2D.Double(posx, posy), value, coment);
    }

    public void mesure_update() {
        delaunayrefresh = true;
        delaunayupd = true;
    }

    public void removeAll() {
        mesures = new java.util.ArrayList<>();
        delaunayrefresh = true;
        delaunayupd = true;
    }

    public void remove(int idx) {
        try{
            mesures.remove(idx);
            delaunayrefresh = true;
            delaunayupd = true;
        } catch (IndexOutOfBoundsException ex) {
            
        }
    }
}
