package com.jdcm.charts;

import com.jdcm.common.CharSequenceCompilerException;
import java.net.URLClassLoader;
import com.jdcm.common.D_Utils;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;

//see http://webgraphing.com/examples_levelsurface3d.jsp
//http://mathplotter.lawrenceville.org/mathplotter/mathPage/derivative.htm
//http://www.vis.uni-stuttgart.de/~kraus/LiveGraphics3D/index.html
//http://www.javaview.de/index.html

/*f(x,y) = (-1)^montagne*hauteur*exp(-etal_x*(x-centre_x)^2-etal_y*(y-centre_y)^2)
 * montagne est un boolean donnant l'effet concave ou convexe de la courbe
 * hauteur est la hauteur maximale de l'exponentielle en valeur absolue
 * etal_x et etal_y sont les degres d'aplatissements dans chacune des deux directions
 * (centre_x,centre_y) sont les coordonnees du centre de l'exponentielle, c'est en ces positions que la fonction f atteint son maximum en valeur absolue
 */

/*
 * F_Test.java
 *
 * Created on 10 mai 2007, 11:48
 */
/**
 *
 * @author Marc GIBOIN
 */
public class F_charts extends javax.swing.JFrame {
// for serializable interface

    private static final long serialVersionUID = 1L;
    private final java.awt.Color coul_courb = new java.awt.Color(0, 0, 255, 200);
    private final java.awt.Color coul_pt = java.awt.Color.GREEN;
    private final D_Utils TUtils = new D_Utils();
    //private I_functions cal = null;
    private Object cal = null;
    private int loadcount = 0;
    private com.jdcm.common.CharSequenceCompiler<I_functions> compiler = null;
    private java.util.Timer scrolltim;

    /**
     * Creates new form F_Test
     */
    public F_charts() {
        initComponents();
        chkTools();
        initialisation();
    }

    public F_charts(boolean isaplet) {
        initComponents();
        chkTools();
        setVisible(isaplet == false);
        jButton7.setEnabled(isaplet == false);
        p_Chartplus1.showToolBar(true);
        initialisation();
    }

    private void initialisation() {
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"z=Math.pow(1-Math.pow(x,2)-Math.pow(y,2),0.5)", "y=Math.sin(x)", "y=Math.sqrt(x)", "y=x/(Math.pow(x,2)+1)", "y=Math.pow(x,2)", "y=2*x/(x-1)", "z=2*Math.exp(-Math.pow(x-0.5,2)-2*Math.pow(y-0.5,2))", "z=Math.pow(x,2)", "z=Math.sin(Math.sin(x*y))", "z=Math.log(1+Math.pow(x,2)+Math.pow(y,2))", "z=Math.sqrt(9*(Math.pow(y,2)/4-1+Math.pow(x,2)))", "z=Math.sin(Math.pow(x,2)+Math.pow(y,2))/(Math.pow(x,2)+Math.pow(y,2))", "z=Math.random();", "y=", "z="}));
        jToggleButton1.setIcon(TUtils.getIcon("distrib_on.gif"));
        jToggleButton1.setSelectedIcon(TUtils.getIcon("distrib_off.gif"));
        jButton3.setIcon(TUtils.getIcon("complete_on.gif"));
        this.setIconImage(TUtils.getImage("graph.gif"));
        //initial rectange (x,y,w,h)
        jCB_ObjectEditor1.setValue(new java.awt.geom.Rectangle2D.Double(-1.0, -1.0, 2.0, 2.0));
        jCB_ObjectEditor1.setEditable(true);
        setView((java.awt.geom.Rectangle2D) jCB_ObjectEditor1.getValue());
    }

    /**
     * made because NB6.9=>Out warnings
     *
     * @param message message to add to out standard stream
     */
    public void tolog(String message) {
        System.out.println("F_Chart : " + message);
    }

    private void chkTools() {
        // int ti=1/0;
        com.jdcm.common.CharSequenceCompiler<I_functions> comp = null;
        try {
            // comp = new com.jdcm.common.CharSequenceCompiler<I_functions>();  //=> was ok in 1.5
            String vers = "1.7";
            comp = new com.jdcm.common.CharSequenceCompiler<>(getClass().getClassLoader(), java.util.Arrays.asList(new String[]{"-source", vers, "-target", vers, "-verbose"}));
            // comp = null;
        } catch (Exception ex) {
            tolog("Pb with simple try : " + ex.getMessage());
        }
        compiler = comp;
        tolog("compiler : " + compiler);
        if (compiler == null) {
            try {
                tolog("==>try web ... ");
                java.net.URL[] u = null;
                try {
                    //  u=java.util.Arrays.copyOf(url2,url2.length+1);
                    java.net.URL u1 = new java.net.URL("http://sgiboin.free.fr/lib/tools.jar");
                    u = new java.net.URL[]{u1};
                    //   u[url2.length]= u1;
                } catch (java.net.MalformedURLException eri) {
                    //tolog("==> URL Nok "+eri.getReason()+ "- "+ eri.getInput());
                    tolog("==> URL Nok " + eri);
                } 
                tolog("==> URL OK");
                java.net.URLClassLoader b = URLClassLoader.newInstance(u, null);
                Thread.currentThread().setContextClassLoader(b);

                for (java.net.URL ur : ((java.net.URLClassLoader) Thread.currentThread().getContextClassLoader()).getURLs()) {
                    tolog("M context urls=>" + ur.toString());
                    java.io.File r = new java.io.File(ur.toString());
                    if (r.listFiles()!=null) {
                        for (java.io.File f : r.listFiles()) {
                            tolog("===>" + f.getName());
                        }
                    }
                }
                /*  for (java.net.URL ur : ((java.net.URLClassLoader) this.getClass().getClassLoader()).getURLs()) {
                 tolog("M class urls=>" + ur.toString());
                 }*/
                com.jdcm.common.CharSequenceCompiler<I_functions> comp2 = 
                        (com.jdcm.common.CharSequenceCompiler<I_functions>) com.jdcm.common.CharSequenceCompiler.class.newInstance();
                      //  (com.jdcm.common.CharSequenceCompiler<I_functions>) Thread.currentThread().getContextClassLoader().loadClass("com.jdcm.common.CharSequenceCompiler").newInstance();
                compiler = comp2;
                tolog("==> WWW URL compiler : " + compiler);
                tolog("==> added classloader on : " + Thread.currentThread().getName());
            } catch (InstantiationException | IllegalAccessException e) {
                tolog("==> Pb  " + e.getMessage() + "-" + e.getLocalizedMessage());
                //e.printStackTrace();
            }
            // compiler = new com.jdcm.common.CharSequenceCompiler();
            //  compiler = new com.jdcm.common.CharSequenceCompiler(getClass().getClassLoader(), java.util.Arrays.asList(new String[]{"-target", "1.5"}));

        }

        if (compiler == null) {
            jComboBox1.setEnabled(false);
            jButton1.setEnabled(false);
        }
    }

    private Double getminx() {
        java.awt.geom.Rectangle2D r = (java.awt.geom.Rectangle2D) jCB_ObjectEditor1.getValue();
        return r.getX();
    }

    private boolean isRandom() {
        return jToggleButton1.isSelected();
    }

    private Double getmaxx() {
        java.awt.geom.Rectangle2D r = (java.awt.geom.Rectangle2D) jCB_ObjectEditor1.getValue();
        return r.getX() + r.getWidth();
    }

    private Double getminy() {
        java.awt.geom.Rectangle2D r = (java.awt.geom.Rectangle2D) jCB_ObjectEditor1.getValue();
        return r.getY();
    }

    private Double getmaxy() {
        java.awt.geom.Rectangle2D r = (java.awt.geom.Rectangle2D) jCB_ObjectEditor1.getValue();
        return r.getY() + r.getHeight();
    }

    private void setView(java.awt.geom.Rectangle2D rect) {
        p_Chartplus1.setADMPosAt("RangeI", rect.getMinX());
        p_Chartplus1.setADMPosAt("RangeS", rect.getMaxX());
        p_Chartplus1.setADMValAt("RangeI", rect.getMinY());
        p_Chartplus1.setADMValAt("RangeS", rect.getMaxY());
        p_Chartplus1.getRange();
        p_Chartplus1.Update();
    }

    private String getEquation() {
        return jComboBox1.getSelectedItem().toString();
    }

    private void setEquation(String equationtext) {
        String eq = equationtext;
        if (eq == null) {
            return;
        }
        eq = eq.trim();
        if (eq.startsWith("z=") || eq.startsWith("y=")) {
            for (int i = 0; i < jComboBox1.getItemCount(); i++) {
                if (eq.compareTo(jComboBox1.getItemAt(i).toString()) == 0) {
                    return;
                }
            }
            jComboBox1.addItem(eq);
            jComboBox1.setSelectedItem(eq);
        }
    }

    /**
     * Return the Plotter function Java source, substituting the given package
     * name, class name, and double expression
     *
     * @param packageName a valid Java package name
     * @param className a valid Java class name
     * @param expression text for a double expression, using double x
     * @return source for the new class implementing Function interface using
     * the expression
     * @throws IOException
     */
    private String fillTemplate(String packageName, String className, String expression)
            throws java.io.IOException {
        String exp = expression;
        String source = readTemplate();
        // simplest "template processor":
        exp += ";";
        String expression3d = exp;
        if (getEquation().startsWith("z=")) {
            exp = "";
        } else {
            expression3d = "";
        }
        source = source.replace("$packageName", packageName)//
                .replace("$className", className)//
                .replace("eq2d$", exp).replace("eq3d$", expression3d);
        return source;
    }

    /**
     * Read the Function source template
     *
     * @return a source template
     * @throws IOException
     */
    private String readTemplate() throws java.io.IOException {
        java.io.InputStream is = D_Utils.getFileStream("C_function.java.template", "com/jdcm/charts", getClass().getClassLoader());
        int size = is.available();

        byte bytes[] = new byte[size];
        if (size != is.read(bytes, 0, size)) {
            throw new IOException();
        }
        return new String(bytes, "US-ASCII");
    }

    public void loadfunction(String equation) {
        //  p_Chartplus1.removeallcurbs(false);
        if (compiler == null) {
            return;
        }
        if (equation.compareTo(this.getEquation()) != 0) {
            setEquation(equation);
        }
        if (getEquation().startsWith("z=") == false && getEquation().startsWith("y=") == false) {
            tolog(" should start with z=...x..y.. OR y=...x...");
            return;
        }
        ///----------------------------------- ON THE FLY CLASS  in memory--------------------------
        /**
         * Generate Java source for a Function which computes f(x)=expr
         *
         * @param expr String representation of Java expression that returns a
         * double value for an input value x. The class in which this expression
         * is embedded uses static import for all the members of the
         * java.lang.Math class so they can be accessed without qualification.
         * @return an object which computes the function denoted by expr
         */
        try {
            this.getClass().getClassLoader().loadClass("com.jdcm.charts.I_functions");
        } catch (ClassNotFoundException e) {
            tolog("could not load interface");
        }
        final String packageName = "com.jdcm.charts";
        final String className = "Function_" + loadcount;
        String source = "";
        final String qName = packageName + '.' + className;
        try {
            source = fillTemplate(packageName, className, getEquation());
            // compile the generated Java source
            final javax.tools.DiagnosticCollector<javax.tools.JavaFileObject> errs = new javax.tools.DiagnosticCollector<>();
            Class<?> compiledClass = compiler.compile(qName, source, errs, new Class<?>[]{});
            if (compiledClass == null) {
                printDiag(errs, source);
            } else {
                cal = compiledClass.newInstance();
            }
        } catch (CharSequenceCompilerException e) {
            printDiag(e.getDiagnostics(), source);
        } catch (InstantiationException | IllegalAccessException | IOException e) {
            tolog(e.getMessage());
        }
        loadcount++;
    }

    private void printDiag(javax.tools.DiagnosticCollector<?> errs, String source) {
        tolog("=================SOURCE=================\r\n" + source + "\r\n======================================");
        for (int i = 0; i < errs.getDiagnostics().size(); i++) {
            javax.tools.Diagnostic<?> a = (javax.tools.Diagnostic<?>) errs.getDiagnostics().get(i);

            tolog("[" + a.getLineNumber() + "]" + a.getMessage(java.util.Locale.getDefault()));
        }
    }

    private Object getMethod(String fct, Object[] os) {
        Class<?>[] cs = new Class<?>[os.length];
        for (int i = 0; i < os.length; i++) {
            cs[i] = os[i].getClass();//.getGenericSuperclass();
        }
        try {
            return cal.getClass().getMethod(fct, cs).invoke(cal, os);
            //  return cal.getClass().getMethods()[1].invoke(cal, os);
        } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            return null;
        }
    }

    private void scrollmem(String label) {
        final String lab = label;
        final long val;
        if (label.startsWith("mem_total")) {
            val = Runtime.getRuntime().totalMemory();
        } else if (label.startsWith("mem_free")) {
            val = Runtime.getRuntime().freeMemory();
        } else if (label.startsWith("mem_max")) {
            val = Runtime.getRuntime().maxMemory();
        } else {
            val = 0;
        }
        if (scrolltim == null) {
            scrolltim = new java.util.Timer();
        }
        scrolltim.schedule(new java.util.TimerTask() {
            @Override
            public void run() {
                p_Chartplus1.addval(p_Chartplus1.getcourbidx(lab), System.currentTimeMillis(), val, "memory");
                scrollmem(lab);
            }
        }, 500);
    }

    private void drawloaded(int crbidx) {
        if (cal == null) {
            return;
        }
        int crbtype = 1;
        boolean is3D = getEquation().startsWith("z=");
        if (is3D) {
            crbtype = 2;
        }
        if (crbidx < 0) {
            crbidx = p_Chartplus1.addcourbe(new String[]{"x", "y", "z"}, null, coul_pt, null, crbtype, 0.0, getEquation());
        }
        if (crbidx == -1) {
            return;
        }
        double z, stepx, stepy;
        try {
            stepx = Double.parseDouble(jTextField6.getText());
            stepy = Double.parseDouble(jTextField6.getText());
        } catch (java.lang.NumberFormatException ex) {
            tolog(" Pb parsing numbers : " + jTextField6.getText());
            return;
        }
        if (stepx <= 0 || stepy <= 0) {
            return;
        }
        if (isRandom() == false) {

            for (double x = getminx(); x <= getmaxx(); x += stepx) {
                boolean follow = true;
                for (double y = getminy(); follow && y <= getmaxy(); y += stepy) {
                    if (is3D) {
                        z = (Double) getMethod("getZ", new Object[]{(Double) x, (Double) y});
                        p_Chartplus1.addval(crbidx, new java.awt.geom.Point2D.Double(x, y), z, "=>" + p_Chartplus1.getcourb(crbidx).size());
                    } else {
                        z = (Double) getMethod("getY", new Object[]{(Double) x});
                        p_Chartplus1.addval(crbidx, x, z, "=>" + p_Chartplus1.getcourb(crbidx).size());
                        follow = false;
                    }
                }
            }
        } else {
            double nb = (getmaxx() - getminx()) / stepx;
            if (is3D) {
                nb *= nb;
            }
            for (double n = 0; n < nb; n++) {
                double x = getminx() + (Math.random() * (getmaxx() - getminx()));
                double y = getminy() + (Math.random() * (getmaxy() - getminy()));
                if (is3D) {
                    z = (Double) getMethod("getZ", new Object[]{(Double) x, (Double) y});
                    p_Chartplus1.addval(crbidx, new java.awt.geom.Point2D.Double(x, y), z, "=>" + p_Chartplus1.getcourb(crbidx).size());
                } else {
                    z = (Double) getMethod("getY", new Object[]{(Double) x});
                    p_Chartplus1.addval(crbidx, x, z, "=>" + p_Chartplus1.getcourb(crbidx).size());
                }
            }
        }

        if (is3D && p_Chartplus1.getMode() == P_Chartplus.MODE_2D) {
            p_Chartplus1.setMode(P_Chartplus.MODE_3D);
        } else if (is3D == false && p_Chartplus1.getMode() != P_Chartplus.MODE_2D) {
            p_Chartplus1.setMode(P_Chartplus.MODE_2D);
        }
        p_Chartplus1.setzoom(-1);
        p_Chartplus1.Update();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        jComboBox1 =  new javax.swing.JComboBox<>();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jToggleButton1 = new javax.swing.JToggleButton();
        jButton3 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jTextField6 = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jToolBar2 = new javax.swing.JToolBar();
        jButton4 = new javax.swing.JButton();
        jSlider2 = new javax.swing.JSlider();
        jSlider1 = new javax.swing.JSlider();
        p_Chartplus1 = new com.jdcm.charts.P_Chartplus();
        jPanel1 = new javax.swing.JPanel();
        jToggleButton2 = new javax.swing.JToggleButton();
        jPanel2 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("TEST : Graph");
        setMinimumSize(new java.awt.Dimension(243, 100));
        setPreferredSize(new java.awt.Dimension(456, 250));
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jToolBar1.setRollover(true);
        jToolBar1.setToolTipText("3D toolsbar");
        jToolBar1.setMaximumSize(new java.awt.Dimension(2147483647, 40));

        jComboBox1.setEditable(true);
        jComboBox1.setMinimumSize(new java.awt.Dimension(105, 10));
        jComboBox1.setPreferredSize(new java.awt.Dimension(300, 10));
        jToolBar1.add(jComboBox1);

        jCB_ObjectEditor1.setMinimumSize(new java.awt.Dimension(2, 10));
        jCB_ObjectEditor1.setPreferredSize(new java.awt.Dimension(2, 10));
        jCB_ObjectEditor1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jCB_ObjectEditor1);

        jToggleButton1.setToolTipText("randomize points");
        jToggleButton1.setBorderPainted(false);
        jToggleButton1.setFocusable(false);
        jToggleButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jToggleButton1);

        jButton3.setBorderPainted(false);
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jLabel3.setText("step:");
        jToolBar1.add(jLabel3);

        jTextField6.setText("0.1");
        jTextField6.setMaximumSize(new java.awt.Dimension(2147483647, 40));
        jTextField6.setMinimumSize(new java.awt.Dimension(30, 10));
        jTextField6.setPreferredSize(new java.awt.Dimension(22, 10));
        jToolBar1.add(jTextField6);

        jButton2.setText("upd");
        jButton2.setMinimumSize(new java.awt.Dimension(25, 10));
        jButton2.setPreferredSize(new java.awt.Dimension(40, 10));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton1.setText("Load");
        jButton1.setMinimumSize(new java.awt.Dimension(29, 10));
        jButton1.setPreferredSize(new java.awt.Dimension(40, 10));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        getContentPane().add(jToolBar1);

        jToolBar2.setRollover(true);
        jToolBar2.setToolTipText("2D toolsbar");

        jButton4.setText("add");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar2.add(jButton4);

        jSlider2.setMaximum(1);
        jSlider2.setMinimum(-1);
        jSlider2.setValue(0);
        jSlider2.setEnabled(false);
        jSlider2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jSlider2MouseReleased(evt);
            }
        });
        jToolBar2.add(jSlider2);

        jSlider1.setMaximum(10);
        jSlider1.setMinimum(-10);
        jSlider1.setValue(0);
        jSlider1.setEnabled(false);
        jSlider1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jSlider1MouseReleased(evt);
            }
        });
        jToolBar2.add(jSlider1);

        getContentPane().add(jToolBar2);
        getContentPane().add(p_Chartplus1);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jToggleButton2.setText("memory");
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jToggleButton2);
        jPanel1.add(jPanel2);

        jButton7.setText("close");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton7);

        getContentPane().add(jPanel1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        String label = "CURB_A";
        if (p_Chartplus1.getcourb(label) != null) {
            label = "CURB_B";
        }
        int idx = p_Chartplus1.addcourbe(new String[]{"time", label.substring(label.length() - 1)}, coul_courb, coul_pt, null, 1, 1.0, label);
        if (idx < 0) {
            return;
        }
        if (label.startsWith("CURB_A")) {
            jSlider2.setEnabled(true);
        } else {
            jSlider1.setEnabled(true);
        }

    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        if (this.getDefaultCloseOperation() == javax.swing.JFrame.EXIT_ON_CLOSE) {
            System.exit(0);
        } else {
            this.setVisible(false);
        }
    }//GEN-LAST:event_jButton7ActionPerformed

    private void jSlider2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jSlider2MouseReleased
        p_Chartplus1.addval(p_Chartplus1.getcourbidx("CURB_A"), System.currentTimeMillis(), jSlider2.getValue(), "SET_A");
    }//GEN-LAST:event_jSlider2MouseReleased

    private void jSlider1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jSlider1MouseReleased
        p_Chartplus1.addval(p_Chartplus1.getcourbidx("CURB_B"), System.currentTimeMillis(), jSlider1.getValue(), "SET_B");
    }//GEN-LAST:event_jSlider1MouseReleased

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    java.awt.Cursor cursor_curent = this.getCursor();
    this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
    loadfunction(getEquation());
    drawloaded(-1);
    this.setCursor(cursor_curent);
}//GEN-LAST:event_jButton1ActionPerformed

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    java.awt.Cursor cursor_curent = this.getCursor();
    this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
    p_Chartplus1.removeallcurbs(false);
    drawloaded(-1);
    this.setCursor(cursor_curent);
}//GEN-LAST:event_jButton2ActionPerformed

private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
    if (jToggleButton2.isSelected()) {
        int idx = p_Chartplus1.addcourbe(new String[]{"time", "o"}, java.awt.Color.green, coul_pt, null, 1, 1.0, "mem_free");
        if (idx < 0) {
            return;
        }
        scrollmem(p_Chartplus1.getcourb(idx).getlabel());
        int idx2 = p_Chartplus1.addcourbe(new String[]{"time", "o"}, java.awt.Color.red, coul_pt, null, 1, 1.0, "mem_total");
        scrollmem(p_Chartplus1.getcourb(idx2).getlabel());
        int idx3 = p_Chartplus1.addcourbe(new String[]{"time", "o"}, java.awt.Color.BLUE, coul_pt, null, 1, 1.0, "mem_max");
        scrollmem(p_Chartplus1.getcourb(idx3).getlabel());
        int idx4 = p_Chartplus1.addcourbe(new String[]{"time", "o"}, java.awt.Color.black, coul_pt, null, 1, 1.0, "mem_flor");
        scrollmem(p_Chartplus1.getcourb(idx4).getlabel());
    } else {
        scrolltim.cancel();
        scrolltim = null;

    }
}//GEN-LAST:event_jToggleButton2ActionPerformed

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
    if (p_Chartplus1.getAera() == null) {
        return;
    }
    jCB_ObjectEditor1.setValue(p_Chartplus1.getAera());
    for (int idx = 0; idx < p_Chartplus1.getcourbsSize(); idx++) {
        Donnees vals = p_Chartplus1.getcourb(idx);
        if (vals.getlabel().startsWith("y=")) {
            while (vals.getmesures().size() > 0) {
                vals.remove(0);
            }
            loadfunction(vals.getlabel());
            drawloaded(idx);
        }

    }
}//GEN-LAST:event_jButton3ActionPerformed

private void jCB_ObjectEditor1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor1ActionPerformed
    p_Chartplus1.setzoom(3);
    setView((java.awt.geom.Rectangle2D) jCB_ObjectEditor1.getValue());
}//GEN-LAST:event_jCB_ObjectEditor1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                F_charts f = new F_charts(false);

            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton7;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JSlider jSlider2;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JToolBar jToolBar2;
    private com.jdcm.charts.P_Chartplus p_Chartplus1;
    // End of variables declaration//GEN-END:variables
}
