/*
 * P_Chartplus.java
 *
 * Created on 12 mai 2007, 11:23
 */
package com.jdcm.charts;

import java.awt.Color;
import com.jdcm.common.D_Utils;
import java.awt.event.AdjustmentEvent;
import javax.swing.JOptionPane;
import java.awt.geom.*;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.lang.reflect.InvocationTargetException;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * Panel with full Chart implmentation
 *
 * @author Marc GIBOIN Need Interfaces ....=> change management of all...
 */
public class P_Chartplus extends javax.swing.JPanel {
// for serializable interface

    private static final long serialVersionUID = 1L;
    private final int MAXCOLOR = 50;
    public static final int MODE_2D = 0;
    public static final int MODE_3D = 1;
    public static final int MODE_OGL = 2;
    public static final int AXIS_NONE = 0;
    public static final int AXIS_SIMPLE = 1;
    public static final int AXIS_INTERVALS = 2;
    public static final int AXIS_ONLYX = 3;
    private final int ptsize = 3;
    private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>();
    private final D_Utils UTils = new D_Utils();

    private Color cools[] = new Color[MAXCOLOR];
    private java.util.List<Donnees> courbs = null;
    private Donnees ValsADM = null;
    // private int rule = -1;
    private Rectangle2D SelRect = null;
    // inittial point for all selections/mouvements/(zooms/rotations/...)
    private Point initSelPt = null;
    //point for steps in zoom /mouvment/...
    private Point tempPt = null;
    private Point initstatuspos = null;
    private int selectedcourb = 0;
    private I_Graphic gpanel;
    private java.awt.Color backcol = java.awt.Color.white;
    private java.util.Timer scrolltim;
    private A_LineOGL oglApplet = null;
    private javax.swing.JFrame oglFrame = null;
    private com.jdcm.eltrx.F_Terminal Parent = null;
    private boolean isZoomYFix = false;
    private boolean isZoomXFix = false;

    /**
     * Creates new form Chart with Edition/visual functions ValsADM is a
     * unvisible data for initialisation of axes...
     */
    public P_Chartplus() {
        initComponents();
        init();

    }

    public P_Chartplus(com.jdcm.eltrx.F_Terminal term) {
        Parent = term;
        initComponents();
        init();
    }

    private void init() {
        courbs = new java.util.ArrayList<>();
        addADM();
        Color couleur[] = {Color.black, Color.BLUE, Color.GREEN, Color.RED, Color.ORANGE, Color.PINK, Color.GRAY, Color.MAGENTA, Color.cyan, Color.RED.darker(), Color.orange, Color.GREEN.darker(), Color.MAGENTA.darker()};
        cools = java.util.Arrays.copyOf(couleur, cools.length);
        for (int i = couleur.length; i < cools.length; i++) {
            cools[i] = Color.BLACK;
        }
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"2D", "3D"}));
        showToolBar(false);
        setMode(getMode());
        //  jPanel4.setComponentZOrder(jScrollPane1, 0);
        jPanel3.setBackground(backcol);
        //jScrollPane1.setOpaque(true);//
        java.awt.Color ctcol = new java.awt.Color(backcol.getRed(), backcol.getGreen(), backcol.getBlue(), Math.round(backcol.getAlpha() / 2));
        jPanel6.setOpaque(false);
        jTree1.setBackground(ctcol);
        setAxis(AXIS_INTERVALS);
        //jPanel6.setBackground(ctcol);
        //jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getNode(this))); ...unusefull...
        jTree1.setCellRenderer(render);//new CourbRender());
        jTree1.setCellEditor(editor);
        jTree1.setEditable(true);
        setEditTree(false);
        setdrawpt(false);
        setbar(false);
        jButton1.setIcon(UTils.getIcon("Save.gif"));
        jButton2.setIcon(UTils.getIcon("Empty.gif"));
        jButton3.setIcon(UTils.getIcon("Open.gif"));
        jRollingButton1.addValuedItem(UTils.getIcon("zoomx.gif"), 0);
        jRollingButton1.addValuedItem(UTils.getIcon("zoomy.gif"), 1);
        jRollingButton1.addValuedItem(UTils.getIcon("zoomxy.gif"), 2);
        jRollingButton1.addValuedItem(UTils.getIcon("move_on.gif"), 4);
        jToggleButton5.setIcon(UTils.getIcon("zoomall.gif"));
        jToggleButton6.setIcon(UTils.getIcon("pointsoff.gif"));
        jToggleButton6.setSelectedIcon(UTils.getIcon("pointson.gif"));
        jToggleButton7.setIcon(UTils.getIcon("rule_off.gif"));
        jToggleButton7.setSelectedIcon(UTils.getIcon("rule_on.gif"));
        jButton4.setIcon(UTils.getIcon("axis_intervals.gif"));
        jToggleButton9.setSelectedIcon(UTils.getIcon("Scrollv_on.gif"));
        jToggleButton9.setIcon(UTils.getIcon("Scrollv_off.gif"));
        jToggleButton11.setIcon(UTils.getIcon("elevation_off.gif"));
        jToggleButton11.setSelectedIcon(UTils.getIcon("elevation_on.gif"));
        jToggleButton13.setIcon(UTils.getIcon("nan_off.gif"));
        jToggleButton13.setSelectedIcon(UTils.getIcon("nan_on.gif"));
        jToggleButton14.setIcon(UTils.getIcon("xeqy_off.gif"));
        jToggleButton14.setSelectedIcon(UTils.getIcon("xeqy_on.gif"));
        jToggleButton15.setIcon(UTils.getIcon("build_on.gif"));
        jToggleButton10.setIcon(UTils.getIcon("3d_off.gif"));
        jToggleButton10.setSelectedIcon(UTils.getIcon("3d_on.gif"));
        setzoom(-1);
        java.awt.event.AdjustmentListener e = new java.awt.event.AdjustmentListener() {
            @Override
            public void adjustmentValueChanged(AdjustmentEvent e) {
                jPanel1.repaint();
            }
        };
        jScrollPane1.getVerticalScrollBar().addAdjustmentListener(e);
        try {
            java.lang.Class.forName("javax.media.j3d.Appearance");
            jComboBox1.addItem("OGL");
        } catch (ClassNotFoundException th) {
            System.out.println("P_Chartplus():java 3D is disabled  " + th.getMessage());
        }
        try {
            Class.forName("com.sun.j3d.utils.applet.JMainFrame");
        } catch (ClassNotFoundException ex) {
            jToggleButton10.setEnabled(false);
        }

    }

    /**
     * Provide a tree of the graphics use for editions
     *
     * @param obj an object to be addes (null for root)
     * @return the node with object to disply as UserObject
     */
    public final DefaultMutableTreeNode getNode(Object obj) {
        DefaultMutableTreeNode res = new DefaultMutableTreeNode();
        if (obj == null) {
            res.setUserObject("root");
            res.add(getNode(this));
            return res;
        }
        if (obj instanceof P_Chartplus) {
            P_Chartplus par = (P_Chartplus) obj;
            res.setUserObject(obj);
            for (int i = 0; i < par.length(); i++) {
                res.add(getNode(par.getcourb(i)));
            }
            return res;
        }
        if (obj instanceof Donnees) {
            Donnees par = (Donnees) obj;
            res.setUserObject(obj);
            for (int i = 0; i < par.getmesures().size(); i++) {
                res.add(getNode(par.getmesures().get(i)));
            }
            return res;
        }
        if (obj instanceof Mesure) {
            res.setUserObject(obj);
        }
        return res;
    }

    /**
     * add Adminitrative courb with zoom/rule/... datas
     */
    private void addADM() {
        ValsADM = new Donnees(new String[]{"x", "y", "z"}, null, null, null, 1, 0.0, "ADM");
        ValsADM.add(-1, -10.0, -10.0, -10.0, "RangeI");
        ValsADM.add(-1, 10.0, 10.0, -10.0, "RangeS");
        ValsADM.setVisible(false);
        courbs.add(ValsADM);
    }

    public final void setZoomXFix(boolean bool) {
        isZoomXFix = bool;
    }

    public final void setZoomYFix(boolean bool) {
        isZoomYFix = bool;
    }

    /**
     * show/hide the graphic toolsbar
     *
     * @param bool true to display the toolbar
     */
    public final void showToolBar(boolean bool) {
        if (jCheckBoxMenuItem2.isSelected() != bool) {
            jCheckBoxMenuItem2.setSelected(bool);
        }
        if (bool) {
        }
        jToolBar1.setVisible(bool);
    }

    /**
     * get the selected aera of the graphics
     *
     * @return a 2DRectangle of the selected (shadowed) aera in screen
     * coordinates
     */
    public java.awt.geom.Rectangle2D getSelection() {
        return SelRect;
    }

    /**
     * set the selected (shadowed) aera of the graphics
     *
     * @param rect Rectangle in screen coordinates
     */
    public void setSelection(java.awt.geom.Rectangle2D rect) {
        SelRect = rect;
    }

    public boolean isOGL() {
        return jToggleButton10.isSelected();
    }

    public void setOGL(boolean bool) {
        if (isOGL() != bool) {
            jToggleButton10.setSelected(bool);
        }
        if (bool) {
            if (oglApplet == null) {
                oglApplet = new A_LineOGL(this);
                java.lang.reflect.Constructor<?> co;
                Object[] obj = new Object[]{oglApplet, 300, 300};
                // bellow to avoid 3d librari loading as mandatory
                try {
                    Class<?> cl = Class.forName("com.sun.j3d.utils.applet.JMainFrame");
                    //jPanel3.add(this) 
                    // warning: [unchecked] unchecked call to getConstructor(java.lang.Class<?>...) as a member of the raw type java.lang.Class
                    co = cl.getConstructor(new Class<?>[]{java.applet.Applet.class, Integer.TYPE, Integer.TYPE});
                    oglFrame = (javax.swing.JFrame) co.newInstance(obj);
                } catch (ClassNotFoundException | NoSuchMethodException | SecurityException | InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                    System.out.println("P_Chartplus.getOGL(): not able to load JFrame 3D=>" + ex.getMessage());
                }
                //oglFrame = new com.sun.j3d.utils.applet.JMainFrame(oglApplet, 300, 300);

                oglFrame.setTitle("OGL frame");
                oglFrame.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
                // oglFrame.setIconImage(UTils.("axes_on.gif"));
                oglApplet.Update();
            }
        } else {
            oglApplet.stop();
            oglFrame.setVisible(false);
            oglApplet = null;
            oglFrame = null;
        }
    }

    /**
     * report if axes of the curbs should be displayed
     *
     * @return true if axes are displayed.
     */
    public int getAxis() {
        try {
            return Integer.parseInt(jButton4.getActionCommand());
        } catch (NumberFormatException ex) {
            return P_Chartplus.AXIS_INTERVALS;
        }

    }

    /**
     * show/hide axes of the curbs
     *
     * @param mode AXIS_NONE/AXIS_SIMPLE/..axes are displayed.
     */
    //@SuppressWarnings("fallthrough")
    public void setAxis(int mode) {
        if (getAxis() != mode) {
            jButton4.setActionCommand("" + mode);
            switch (mode) {
                case AXIS_NONE:
                    jButton4.setIcon(UTils.getIcon("axis_none.gif"));
                    break;
                case AXIS_SIMPLE:
                    jButton4.setIcon(UTils.getIcon("axis_simple.gif"));
                    break;
                case AXIS_INTERVALS:
                    jButton4.setIcon(UTils.getIcon("axis_intervals.gif"));
                    break;
                case AXIS_ONLYX:
                    jButton4.setIcon(UTils.getIcon("axis_onlyx.gif"));
                    break;
                default:
                    setAxis(AXIS_NONE);
            }
        }
        repaint();
    }

    private void setbar(boolean bool) {
        if (bool != isbar()) {
            jCheckBoxMenuItem4.setSelected(bool);
        }
        jPanel6.setBackground(new java.awt.Color(50, 50, 50, 50));
        jPanel6.setOpaque(true);
        jPanel6.setVisible(bool);
    }

    private boolean isbar() {
        return jCheckBoxMenuItem4.isSelected();
    }
    /*  private void updatestatus(){
     if (this.is)
     }*/

    private void setstatusbar(String x, String y) {
        jLabel2.setText(x);
        jLabel4.setText(y);
        jPanel1.repaint(jPanel6.getVisibleRect());
    }

    /**
     * provide the background color of the graphics
     *
     * @return a color that should be opaque
     */
    @Override
    public Color getBackground() {
        return backcol;
    }

    /**
     * change the back ground color
     *
     * @param c the new background color of the graphic
     */
    @Override
    public void setBackground(Color c) {
        if (c != null && c.equals(backcol) == false) {
            backcol = c;
            if (gpanel != null) {
                // gpanel.setBackground(backcol); //NOT OK WHY, HOW??????
                jPanel3.setBackground(backcol);
            }
        }
    }

    /**
     * report if x and y should hav the same pixel value
     *
     * @return true if x and y scale value are the same
     */
    public boolean isxeqy() {
        return jToggleButton14.isSelected();
    }

    /**
     * if true display graphics with x and y with the same scale else ajust to
     * get all mesurments in the screen.
     *
     * @param bool true to equal x and y scale
     */
    public void setxeqy(boolean bool) {
        if (isxeqy() != bool) {
            jToggleButton14.setSelected(bool);
        }
        repaint(10);
    }

    /**
     * report if edition tree is displayed
     *
     * @return true if the edition tree should be displayed
     */
    public boolean isEditTree() {
        return jToggleButton15.isSelected();
    }

    public void setscroll(boolean bool) {
        if (jToggleButton9.isSelected() != bool) {
            jToggleButton9.setSelected(bool);
        }
        if (bool) {
            if (scrolltim == null) {
                scrolltim = new java.util.Timer();
            }
            scrolltim.schedule(new java.util.TimerTask() {
                @Override
                public void run() {
                    repaint();
                    //  updatestatus();
                    setscroll(true);
                }
            }, 100);
        } else {
            if (scrolltim != null) {
                scrolltim.cancel();
            }
            scrolltim = null;
        }

    }

    public boolean isscroll() {
        return jToggleButton9.isSelected();
    }

    /**
     * display/hide the edition tree
     *
     * @param bool true to display the tree
     */
    public final void setEditTree(boolean bool) {
        if (isEditTree() != bool) {
            jToggleButton15.setSelected(bool);
        }
        if (jCheckBoxMenuItem5.isSelected() != bool) {
            jCheckBoxMenuItem5.setSelected(bool);
        }
        if (jCheckBoxMenuItem6.isSelected() != bool) {
            jCheckBoxMenuItem6.setSelected(bool);
        }
        jScrollPane1.setVisible(bool);
        jScrollPane1.setBounds(jPanel4.getBounds());
        if (bool) {
            jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getNode(null)));
            jPanel4.setComponentZOrder(jScrollPane1, 0);
            // jPanel4.setComponentZOrder(jPanel1, jPanel4.getComponentCount()-1);
        } else {
            jTree1.setModel(null);
            jPanel4.setComponentZOrder(jPanel1, 0);
            if (oglApplet != null) {
                oglApplet.Update();
            }
            //   jPanel4.setComponentZOrder(jScrollPane1, jPanel4.getComponentCount()-1);
        }
        //could not find a logical way to show tree on windows
        if (this.getTopLevelAncestor() != null) {
            java.awt.Rectangle r = this.getTopLevelAncestor().getBounds();
            this.getTopLevelAncestor().setBounds(r.x, r.y, r.width + 1, r.height);
            this.getTopLevelAncestor().setBounds(r.x, r.y, r.width, r.height);
        }
    }

    /**
     * report if Double NAN value should be displayed (as 0.0)
     *
     * @return true if NaNs are displayed
     */
    public boolean isNaN() {
        return jToggleButton13.isSelected();
    }

    /**
     * Diplay/hide Double NaN values
     *
     * @param bool true to display NaN values
     */
    public void setNaN(boolean bool) {
        if (isNaN() != bool) {
            jToggleButton13.setSelected(bool);
        }
        if (getzoom() == -1) {
            gpanel.initzoom(-1);
        }
        repaint(10);
    }

    /**
     * for 3D visualisaion report if elevation rotation is enabled
     *
     * @return true if elevation rotation id enabled
     */
    public boolean iselevrot() {
        return jToggleButton11.isSelected();
    }

    /**
     * for 3D enable elevation rotation for visualisaion
     *
     * @param bool true to enable elevation rotation
     */
    public void setelevrot(boolean bool) {
        if (iselevrot() != bool) {
            jToggleButton11.setSelected(bool);
        }
    }

    /**
     * provide the drawing mode of the curb 2D/3D
     *
     * @return integer value for the mode is MODE_3D or MODE_2D or MODE_COM?
     */
    public final int getMode() {
        return jComboBox1.getSelectedIndex();
    }

    /**
     * set the drawing mode of the curbs 2D/3D
     *
     * @param mode is MODE_3D or MODE_2D or MODE_COM?
     */
    public final void setMode(int mode) {
        if (getMode() != mode) {
            jComboBox1.setSelectedIndex(mode);
        }
        if (gpanel != null) {
            jPanel3.remove((javax.swing.JPanel) gpanel);
        }
        if (oglApplet != null) {
            oglApplet.Update();
            oglApplet.repaint();
        }
        if (mode == MODE_3D) {
            gpanel = new P_Line3D();
            setrule(false);
            setxeqy(true);
        } else if (mode == MODE_2D) {
            gpanel = new P_Lines2D();
            setelevrot(false);
            setxeqy(false);
        } else if (mode == MODE_OGL) {
            /*gpanel = new P_LineOGL();
             //javax.swing.JFrame f=new javax.swing.JFrame();
             //f.add((java.awt.Panel)gpanel);
             //f.setVisible(true);
             setelevrot(false);
             setxeqy(false);*/
        }
        if (gpanel != null) {
            gpanel.setMain(this);
            ((javax.swing.JPanel) gpanel).addKeyListener(new java.awt.event.KeyAdapter() {
                @Override
                public void keyPressed(KeyEvent e) {
                    super.keyPressed(e);
                    if (e.getKeyCode() == java.awt.event.KeyEvent.VK_ESCAPE) {
                        showToolBar(!jToolBar1.isVisible());
                    }
                }
            });

            jPanel3.setBackground(backcol);
            jPanel3.add((javax.swing.JPanel) gpanel);
            boolean bool = mode == MODE_3D;
            jToggleButton11.setEnabled(bool);
            jCheckBoxMenuItem1.setEnabled(bool == false);
            jToggleButton7.setEnabled(bool == false);
            repaint();
        }
    }

    /**
     * report if mesurments shapes (points) should be displayed
     *
     * @return true id points are displayed
     */
    public boolean isdrawpt() {
        return jToggleButton6.isSelected();
    }

    /**
     * show/hide mesurments shapes
     *
     * @param bool true to show mesurments shapes (points)
     */
    public final void setdrawpt(boolean bool) {
        if (isdrawpt() != bool) {
            jToggleButton6.setSelected(bool);
        }
        if (jCheckBoxMenuItem3.isSelected() != bool) {
            jCheckBoxMenuItem3.setSelected(bool);
        }
        repaint(10);
    }

    /**
     * get the mesurment point size
     *
     * @return in pixel the size of the square to assign as mesurment shapes
     */
    public int getptsize() {
        return ptsize;
    }

    /**
     * for visualisation, get the zoom mode value (-1=> auto,0=> x,1=>y,2,3=>
     * fixe,4=>move...)
     *
     * @return an integer as zoom mode
     */
    public int getzoom() {
        if (jToggleButton5.isSelected()) {
            return -1;
        }
        return (Integer) jRollingButton1.getValue();
    }

    /**
     * set the zoom border of the screen
     *
     * @param rect the rectangle to show
     */
    public void setzoom(java.awt.geom.Rectangle2D rect) {
        setADMPosAt("RangeI", rect.getMinX());
        setADMPosAt("RangeS", rect.getMaxX());
        setADMValAt("RangeI", rect.getMinY());
        setADMValAt("RangeS", rect.getMaxY());
    }

    /**
     * set the zoom mode (-1=> auto,0=> x,1=>y,2,3=> fixe,4=>move...)
     *
     * @param nb integer to fix the zoom mode
     */
    public void setzoom(int nb) {
        if (nb < 0) {
            jToggleButton5.setSelected(true);
        } else {
            jToggleButton5.setSelected(false);
            jRollingButton1.setValue(nb);
        }

        initSelPt = null;
        SelRect = null;
        if (nb < 5) {
            setrule(false);
        }
        jToggleButton14.setEnabled(false);
        if (nb == 0) {
            //x
            jRadioButtonMenuItem4.setSelected(false);
            jRadioButtonMenuItem1.setSelected(true);
            jRadioButtonMenuItem3.setSelected(false);
            jRadioButtonMenuItem2.setSelected(false);
            jRadioButtonMenuItem5.setSelected(false);
            jToggleButton9.setEnabled(false);
        }
        if (nb == 1) {
            //y
            jRadioButtonMenuItem2.setSelected(true);
            jRadioButtonMenuItem4.setSelected(false);
            jRadioButtonMenuItem1.setSelected(false);
            jRadioButtonMenuItem3.setSelected(false);
            jRadioButtonMenuItem5.setSelected(false);
            jToggleButton9.setEnabled(false);
        }
        if (nb == 2) {
            //square
            jRadioButtonMenuItem3.setSelected(true);
            jRadioButtonMenuItem4.setSelected(false);
            jRadioButtonMenuItem2.setSelected(false);
            jRadioButtonMenuItem1.setSelected(false);
            jRadioButtonMenuItem5.setSelected(false);
            jToggleButton9.setEnabled(false);
        }
        if (nb == -1) {
            //all
            jRadioButtonMenuItem4.setSelected(true);
            jRadioButtonMenuItem2.setSelected(false);
            jRadioButtonMenuItem1.setSelected(false);
            jRadioButtonMenuItem3.setSelected(false);
            jRadioButtonMenuItem5.setSelected(false);
            jToggleButton5.setSelected(true);
            jToggleButton14.setEnabled(true);
            jToggleButton9.setEnabled(true);
        }
        if (nb == 4) {
            //move
            jRadioButtonMenuItem4.setSelected(false);
            jRadioButtonMenuItem2.setSelected(false);
            jRadioButtonMenuItem1.setSelected(false);
            jRadioButtonMenuItem3.setSelected(false);
            jRadioButtonMenuItem5.setSelected(true);
            jToggleButton9.setEnabled(false);
        }

        if (nb == -1) {
            gpanel.initzoom(nb);
        }
        gpanel.repaint();
    }

    @Override
    public void paintComponent(java.awt.Graphics g) {
        ((javax.swing.JPanel) gpanel).setBounds(jPanel3.getBounds());
        super.paintComponent(g);
    }

    /**
     * for 2D : report id rule mesurments is activated
     *
     * @return true if rule is activated
     */
    public boolean isrule() {
        return jToggleButton7.isSelected();
    }

    /* public void setrule(int nb) {
     rule = nb;
     }
     public int getrule() {
     return rule;
     }*/
    /**
     * for 2D : activate the rule mesuments
     *
     * @param bool true to activate rule
     */
    public void setrule(boolean bool) {
        if (bool != isrule()) {
            jToggleButton7.setSelected(bool);
        }
        if (jCheckBoxMenuItem1.isSelected() != bool) {
            jCheckBoxMenuItem1.setSelected(bool);
        }
        if (bool) {
            if (getzoom() > 0) {
                setzoom(4);
            }
            ValsADM.add(-1, -1.0, -1.0, 0.0, "rule_wait");
        } else {
            while (getADMidx("rule_wait") >= 0) {
                ValsADM.setTagAt(getADMidx("rule_wait"), "old_rule");
            }
            while (getADMidx("rule_point") >= 0) {
                ValsADM.setTagAt(getADMidx("rule_point"), "old_rule");
            }
            //  rule = -1;
        }
        repaint();
    }

    public int getADMidx(String tag) {
        for (int i = 0; i < ValsADM.getmesures().size(); i++) {
            if (ValsADM.getTagAt(i).compareTo(tag) == 0) {
                return i;
            }
        }
        return -1;
    }

    public void setADMPosAt(String label, Double tag) {
        ValsADM.setPosAt(getADMidx(label), tag);
    }

    public Double getADMPosAt(String label) {
        return ValsADM.getPosAt(getADMidx(label));
    }

    public void setADMValAt(String label, Double tag) {

        ValsADM.setValAt(getADMidx(label), tag);
    }

    public Double getADMValAt(String label) {
        return ValsADM.getValAt(getADMidx(label));
    }

    public void setADMTagAt(String label, String tag) {
        ValsADM.setTagAt(getADMidx(label), tag);
    }

    public String getADMTagAt(String label) {
        return ValsADM.getTagAt(getADMidx(label));
    }

    public void setADMShapeAt(String label, java.awt.Shape s) {
        ValsADM.setShapeAt(getADMidx(label), s);
    }

    public java.awt.Shape getADMShapeAt(String label) {
        return ValsADM.getShapeAt(getADMidx(label));
    }

    /**
     * Remove all curb (exept admin)
     *
     * @param confirm
     */
    public void removeallcurbs(boolean confirm) {
        if (confirm) {
            if (1 == javax.swing.JOptionPane.showConfirmDialog(this, "Do you want to delete all statistics data ?\r\n", "Statistics", javax.swing.JOptionPane.YES_NO_OPTION)) {
                return;
            }
        }
        courbs.removeAll(courbs);
        addADM();
        ValsADM.remove(getADMidx("rule_wait"));
        Update();
    }

    /**
     * keep curbs (ofsret...) but remove all datas
     *
     * @param confirm
     */
    public void removealldata(boolean confirm) {
        if (confirm) {
            if (1 == javax.swing.JOptionPane.showConfirmDialog(this, "Do you want to delete all statistics data ?\r\n", "Statistics", javax.swing.JOptionPane.YES_NO_OPTION)) {
                return;
            }
        }
        for (Donnees d : courbs) {
            if (d.getlabel().startsWith("ADM") == false) {
                d.removeAll();
            }
        }
        Update();
    }

    /**
     * Provide the curb with its index
     *
     * @param nb index of the curb (! 0 is the ADM curb)
     * @return a Donnees type curb else null
     */
    public Donnees getcourb(int nb) {
        try {
            return courbs.get(nb);
        } catch (Exception ex) {
            return null;
        }
    }

    public int getcourbsSize() {
        try {
            return courbs.size();
        } catch (Exception ex) {
            return -1;
        }
    }

    /**
     * Provide the curb from its label
     *
     * @param label the label of the asked curb
     * @return the Donnees type curb or null if not found
     */
    public Donnees getcourb(String label) {
        //null => no courb found with this label
        for (int courbe = 0; courbe < courbs.size(); courbe++) {
            Donnees vals = courbs.get(courbe);
            if (vals.getlabel().compareTo(label) == 0) {
                return vals;
            }
        }
        return null;
    }

    /**
     * Provide the curb index from its label
     *
     * @param label the label of the asked curb
     * @return the Donnees type curb or null if not found
     */
    public int getcourbidx(String label) {
        //null => no courb found with this label
        for (int courbe = 0; courbe < courbs.size(); courbe++) {
            Donnees vals = courbs.get(courbe);
            if (vals.getlabel().compareTo(label) == 0) {
                return courbe;
            }
        }
        return -1;
    }

    public void Open() {
        java.io.File res;
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        if (ch.showDialog(this, "Open") == javax.swing.JFileChooser.APPROVE_OPTION) {
            res = ch.getSelectedFile();
        } else {
            return;
        }
        Open(res);
    }

    public void Open(java.io.File file) {
        if (file == null) {
            return;
        }
        try {
            try {
                java.io.FileInputStream fis = new java.io.FileInputStream(file);
                try (java.io.ObjectInputStream infile = new java.io.ObjectInputStream(fis)) {
                    Object obj = infile.readObject();
                    if (obj instanceof java.util.List) {//
                        java.util.List<Donnees> c = (java.util.List<Donnees>) obj;
                        courbs = c;
                    }
                }
            } catch (java.io.IOException ex) {
                // ex.printStackTrace();
            }
        } catch (java.lang.ClassNotFoundException ex) {
            //ex.printStackTrace();
        }
        gpanel.initzoom(-1);
    }

    public void Save() {
        String res;
        if (this.isVisible() == false) {
            return;
        }
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        if (ch.showDialog(this, "Save") == javax.swing.JFileChooser.APPROVE_OPTION) {
            res = ch.getSelectedFile().toString();
        } else {
            return;
        }
        java.io.ObjectOutputStream outfile;
        try {
            java.io.FileOutputStream fos = new java.io.FileOutputStream(res);
            outfile = new java.io.ObjectOutputStream(fos);
            for (int i = 0; i < courbs.size(); i++) {
                courbs.get(i).setserialisable();
            }
            outfile.writeObject(courbs);
            outfile.close();
        } catch (java.io.IOException ex) {
            // ex.printStackTrace();
        }
    }

    public javax.swing.ImageIcon getIcon(String img) {
        // simple copy of Utils because not avalable to be inserted as panel in Betbean with call of com.jdcm.common.Utils
        img = "images/" + img;
        java.net.URLClassLoader urlLoader = (java.net.URLClassLoader) this.getClass().getClassLoader();
        java.net.URL fileLoc = urlLoader.findResource(img);
        return new javax.swing.ImageIcon(fileLoc);

    }

    public int length() {
        if (courbs == null) {
            return -1;
        } else {
            return courbs.size();
        }
    }
    /*
     *donne les valeures extremes de la serie de donnees
     */

    public void getRange() {
        //find the Max & Min on X & Y axes => store in ValsADM./zoomx & ValsADM./zoomy
        /// init value to MAX
        double[] resx = new double[2];
        double[] resy = new double[2];
        double MAX = Double.POSITIVE_INFINITY;
        resx[0] = MAX;
        resy[0] = MAX;//min
        resx[1] = -MAX;
        resy[1] = -MAX;//max

        for (int courbe = 0; courbe < length(); courbe++) {
            Donnees vals = getcourb(courbe);
            if (vals.isVisible()) {
                // browse all value of concerned courbs
                if (vals.getmesures().size() > 0) {
                    for (int i = 0; i < vals.getmesures().size(); i++) {
                        Point2D pt = null;
                        Mesure mes = vals.getmesures().get(i);
                        if (mes != null) {
                            if (getMode() == P_Chartplus.MODE_3D) {
                                pt = gpanel.project2D(mes.getpoint().getX(), mes.getpoint().getY(), mes.getval());
                            } else {
                                pt = gpanel.project2D(mes.getposition(), mes.getval() + vals.getoffset());
                            }
                        }
                        if (pt != null) {
                            resx[0] = Math.min(pt.getX(), resx[0]);
                            resx[1] = Math.max(pt.getX(), resx[1]);
                            resy[0] = Math.min(pt.getY(), resy[0]);
                            resy[1] = Math.max(pt.getY(), resy[1]);
                        }
                        if (isscroll() && vals.getAxislabel("x").startsWith("time")) {
                            resx[1] = System.currentTimeMillis();
                            if (vals.gettype() == 2) {
                                //square=> "memory"=> folow line unitl now
                                int last = vals.size() - 1;
                                Point2D point = vals.getPointAt(last);
                                if (point != null) {
                                    String tagtxt = vals.getTagAt(last);
                                    if (tagtxt != null && tagtxt.compareTo("-scroll-") == 0) {
                                        point.setLocation(System.currentTimeMillis(), point.getY());
                                    } else {
                                        vals.add(new Double(System.currentTimeMillis()), point.getY(), "-scroll-");
                                    }
                                }
                            }
                        }
                    }

                } else {
                    if (vals.getoffset() != 0 && vals.getoffset() > resy[1]) {
                        resy[1] = vals.getoffset();
                    }
                    if (vals.getoffset() != 0 && vals.getoffset() < resy[0]) {
                        resy[0] = vals.getoffset();
                    }
                }
            }
        }
        if (!isZoomXFix) {
            if (resx[0] != Double.POSITIVE_INFINITY) {
                setADMPosAt("RangeI", resx[0]);
            }
            if (resx[1] > -Double.POSITIVE_INFINITY) {
                setADMPosAt("RangeS", resx[1]);
            }
            if (resx[0] == resx[1]) {
                setADMPosAt("RangeI", resx[1] - 1);
            }
        }
        if (!isZoomYFix) {
            if (resy[0] != Double.POSITIVE_INFINITY) {
                setADMValAt("RangeI", resy[0]);
            }
            if (resy[1] > -Double.POSITIVE_INFINITY) {
                setADMValAt("RangeS", resy[1]);
            }
            if (resy[0] == resy[1]) {
                setADMValAt("RangeI", resy[1] - 1);
            }
        }

        //  p_3D1.setdeplacement();
        //String msg = "" + (System.nanoTime() - start);
        //JOptionPane.showMessageDialog(this,msg, "Value box",   JOptionPane.INFORMATION_MESSAGE);
    }

    private String formatvalue(String type, double x) {
        Double x2 = x;
        String pos = "" + x2;
        if (type == null) {
            return pos;
        }
        if (type.startsWith("time")) {
            java.util.Date d = new java.util.Date(x2.longValue());
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("HH:mm:ss.S");
            pos = format.format(d);
        }
        if (type.startsWith("timestanp")) {
            java.util.Date d = new java.util.Date(x2.longValue());
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("yy-MM-dd HH:mm:ss.S");
            pos
                    = format.format(d);
        }
        if (type.startsWith("date")) {
            java.util.Date d = new java.util.Date(x2.longValue());
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("yy-MM-dd");
            pos
                    = format.format(d);
        }
        return pos;
    }

    public java.awt.geom.Rectangle2D getAera() {
        if (getMode() == MODE_2D) {
            java.awt.geom.Point2D p0 = gpanel.graph2real(0, 0);
            java.awt.geom.Point2D p1 = gpanel.graph2real(jPanel1.getWidth(), jPanel1.getHeight());
            Double w = Math.abs(p1.getX() - p0.getX());
            Double h = Math.abs(p1.getY() - p0.getY());
            return new java.awt.geom.Rectangle2D.Double(p0.getX(), p0.getY(), w, h);
        } else {
            return null;
        }

    }

    /**
     * add a value to a curb
     *
     * @param courbidx the idex of the curb 0 is administrativ curb
     * @param pos is the absiss value
     * @param value is the ordonate value
     * @param coment is the tag of this mesurment
     */
    public void addval(int courbidx, Double pos, Double value, String coment) {
        if (length() <= courbidx) {
            return;
        }
        Donnees Vals = getcourb(courbidx);
        if (Vals != null) {
            if (Vals.size() > 0 && Vals.getTagAt(Vals.getmesures().size() - 1) != null) {
                Mesure mes = Vals.getmesures().get(Vals.getmesures().size() - 1);
                if (mes.tag.compareTo("-scroll-") == 0) {
                    Vals.getmesures().remove(mes);
                }
            }
            Vals.add(pos, value, coment);
            Double ofset = Vals.getoffset();
            if ((getcourb(courbidx)).getmesures().size() < 2) {
                getRange();
                repaint();
            } else {
                if (Vals.isVisible()) {
                    Point2D p = gpanel.project2D(pos, value + ofset);
                    setADMPosAt("RangeI", Math.min(p.getX(), getADMPosAt("RangeI")));
                    setADMPosAt("RangeS", Math.max(p.getX(), getADMPosAt("RangeS")));
                    setADMValAt("RangeI", Math.min(p.getY(), getADMValAt("RangeI")));
                    setADMValAt("RangeS", Math.max(p.getY(), getADMValAt("RangeS")));
                    repaint();
                }
            }
        }
    }

    public void setlastColor(String courbename, java.awt.Color col) {
        Donnees Vals = getcourb(getindexof(courbename));
        Vals.getmesures().get(Vals.getmesures().size() - 1).color = col;
    }

    public void addval(int courbidx, Point2D pos, Double value, String coment) {
        if (length() <= courbidx) {
            return;
        }
        Donnees Vals = getcourb(courbidx);
        Vals.add(-1, pos, value, coment);
        if ((getcourb(courbidx)).getmesures().size() < 2) {
            getRange();
            repaint();
        } else {
            if (Vals.isVisible()) {
                Point2D p = gpanel.project2D(pos.getX(), pos.getY(), value);
                if (p != null) {
                    setADMPosAt("RangeI", Math.min(p.getX(), getADMPosAt("RangeI")));
                    setADMPosAt("RangeS", Math.max(p.getX(), getADMPosAt("RangeS")));
                    setADMValAt("RangeI", Math.min(p.getY(), getADMValAt("RangeI")));
                    setADMValAt("RangeS", Math.max(p.getY(), getADMValAt("RangeS")));
                }
                this.repaint();

            }
        }
    }

    public void addval(int courbe, long pos, long value, String coment) {
        addval(courbe, new Double(pos), new Double(value), coment);
    }

    public void addval(int courbe, long posx, long posy, long value, String coment) {
        addval(courbe, new java.awt.geom.Point2D.Double(new Double(posx), new Double(posy)), new Double(value), coment);
    }

    public void addval(String courbename, long posx, long posy, long value, String coment) {
        addval(getindexof(courbename), new java.awt.geom.Point2D.Double(new Double(posx), new Double(posy)), new Double(value), coment);
    }

    public void addval(String courbename, long pos, long value, String coment) {
        addval(getindexof(courbename), new Double(pos), new Double(value), coment);
    }

    public void addval(String courbename, long pos, double value, String coment) {
        addval(getindexof(courbename), new Double(pos), value, coment);
    }

    public void addval(String courbename, Point2D pos, Double value, String coment) {
        addval(getindexof(courbename), pos, value, coment);
    }

    public void addval(String courbname, Double pos, Double value, String coment) {
        addval(getindexof(courbname), pos, value, coment);
    }

    private int getindexof(String txt) {
        for (int i = 0; i < this.length(); i++) {
            if (getcourb(i).getlabel().compareTo(txt) == 0) {
                return i;
            }
        }
        return -1;
    }

    /**
     * add a courb (list of mesues) in the chart
     *
     * @param axes array of string with axes labels
     * @param Gcol : curb color
     * @param ptcol point color
     * @param feelcol the color used to feel triangles
     * @param typ : 0=> lines 1=> squares
     * @param ofset : shift of the X axes (EX : RS232)
     * @param label : title of the curb
     * 
     * @return the number of the curb, -1 if abborted
     */
    public int addcourbe(String[] axes, java.awt.Color Gcol, java.awt.Color ptcol, java.awt.Color feelcol, int typ, Double ofset, String label) {
        if (Gcol == null) {
            Gcol = cools[length()];
        }
        if (ptcol == null) {
            ptcol = Color.GREEN;
        }
        if (feelcol == null) {
            feelcol = cools[length()];
            feelcol = new java.awt.Color(feelcol.getRed(), feelcol.getGreen(), feelcol.getBlue(), 100);
        }
        if (label == null) {
            label = "-label-";
        }
        if (getcourb(label) != null) {
            courbs.remove(getcourb(label));
            //  JOptionPane.showMessageDialog(this, "Creation aborted :\r\n" + label + "already exist", "Statistics", JOptionPane.INFORMATION_MESSAGE);
            // return -1;
        }
        Donnees vals = new Donnees(axes, Gcol, ptcol, feelcol, typ, ofset, label);
        courbs.add(vals);

        selectedcourb = courbs.size() - 1;
        this.jMenu3.add(vals.getItemcol());
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getNode(null)));
        return courbs.indexOf(vals);
    }

    public void Update() {
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getNode(null)));
        repaint();
        this.setEditTree(this.isEditTree());
        if (oglApplet != null && oglApplet.isVisible()) {
            // The OGL Panel is not managed with repaint()
            oglApplet.Update();
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jCheckBoxMenuItem1 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem3 = new javax.swing.JCheckBoxMenuItem();
        jMenu1 = new javax.swing.JMenu();
        jRadioButtonMenuItem1 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem2 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem3 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem4 = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem5 = new javax.swing.JRadioButtonMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem5 = new javax.swing.JMenuItem();
        jCheckBoxMenuItem2 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem4 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem5 = new javax.swing.JCheckBoxMenuItem();
        jPopupMenu2 = new javax.swing.JPopupMenu();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jCheckBoxMenuItem6 = new javax.swing.JCheckBoxMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jRollingButton1 = new com.jdcm.common.G_JRollingButton();
        jToggleButton5 = new javax.swing.JToggleButton();
        jToggleButton6 = new javax.swing.JToggleButton();
        jToggleButton7 = new javax.swing.JToggleButton();
        jButton4 = new javax.swing.JButton();
        jComboBox1 =  new javax.swing.JComboBox<>();
        jToggleButton11 = new javax.swing.JToggleButton();
        jToggleButton13 = new javax.swing.JToggleButton();
        jToggleButton14 = new javax.swing.JToggleButton();
        jToggleButton15 = new javax.swing.JToggleButton();
        jToggleButton10 = new javax.swing.JToggleButton();
        jToggleButton9 = new javax.swing.JToggleButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanel1 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();

        jCheckBoxMenuItem1.setText("Rule");
        jCheckBoxMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jCheckBoxMenuItem1);

        jCheckBoxMenuItem3.setSelected(true);
        jCheckBoxMenuItem3.setText("Points");
        jCheckBoxMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem3ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jCheckBoxMenuItem3);

        jMenu1.setText("Zoom");

        jRadioButtonMenuItem1.setText("Zoom X");
        jRadioButtonMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem1);

        jRadioButtonMenuItem2.setText("Zoom Y");
        jRadioButtonMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem2);

        jRadioButtonMenuItem3.setText("Zoom");
        jRadioButtonMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem3);

        jRadioButtonMenuItem4.setText("Zoom all");
        jRadioButtonMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem4ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem4);

        jRadioButtonMenuItem5.setText("Move");
        jRadioButtonMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem5ActionPerformed(evt);
            }
        });
        jMenu1.add(jRadioButtonMenuItem5);

        jPopupMenu1.add(jMenu1);

        jMenuItem2.setText("Clear");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem2);

        jMenu3.setText("Colors");

        jMenuItem5.setText("Background");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem5);

        jPopupMenu1.add(jMenu3);

        jCheckBoxMenuItem2.setSelected(true);
        jCheckBoxMenuItem2.setText("Toolbar");
        jCheckBoxMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jCheckBoxMenuItem2);

        jCheckBoxMenuItem4.setSelected(true);
        jCheckBoxMenuItem4.setText("showStatus");
        jCheckBoxMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem4ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jCheckBoxMenuItem4);

        jCheckBoxMenuItem5.setText("Edit");
        jCheckBoxMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem5ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jCheckBoxMenuItem5);

        jMenuItem3.setText("add");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jMenuItem3);

        jMenuItem6.setText("remove");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jMenuItem6);

        jCheckBoxMenuItem6.setSelected(true);
        jCheckBoxMenuItem6.setText("Edit");
        jCheckBoxMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem6ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jCheckBoxMenuItem6);

        setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);

        jButton1.setToolTipText("Save");
        jButton1.setBorderPainted(false);
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton1.setMaximumSize(new java.awt.Dimension(20, 20));
        jButton1.setMinimumSize(null);
        jButton1.setPreferredSize(new java.awt.Dimension(30, 30));
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jButton3.setToolTipText("Open");
        jButton3.setBorderPainted(false);
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton3.setMaximumSize(new java.awt.Dimension(20, 20));
        jButton3.setMinimumSize(null);
        jButton3.setPreferredSize(new java.awt.Dimension(30, 30));
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jButton2.setToolTipText("Clear");
        jButton2.setBorderPainted(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton2.setMaximumSize(new java.awt.Dimension(20, 20));
        jButton2.setMinimumSize(null);
        jButton2.setPreferredSize(new java.awt.Dimension(30, 30));
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jRollingButton1.setBorderPainted(false);
        jRollingButton1.setFocusable(false);
        jRollingButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRollingButton1.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jRollingButton1.setMaximumSize(new java.awt.Dimension(20, 20));
        jRollingButton1.setMinimumSize(new java.awt.Dimension(20, 20));
        jRollingButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jRollingButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRollingButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jRollingButton1);

        jToggleButton5.setSelected(true);
        jToggleButton5.setToolTipText("zoom all");
        jToggleButton5.setBorderPainted(false);
        jToggleButton5.setFocusable(false);
        jToggleButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton5.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton5.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton5.setMinimumSize(null);
        jToggleButton5.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton5);

        jToggleButton6.setToolTipText("show points");
        jToggleButton6.setBorderPainted(false);
        jToggleButton6.setFocusable(false);
        jToggleButton6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton6.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton6.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton6.setMinimumSize(null);
        jToggleButton6.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton6.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton6ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton6);

        jToggleButton7.setToolTipText("rule");
        jToggleButton7.setBorderPainted(false);
        jToggleButton7.setFocusable(false);
        jToggleButton7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton7.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton7.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton7.setMinimumSize(null);
        jToggleButton7.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton7.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton7);

        jButton4.setToolTipText("display axis");
        jButton4.setActionCommand("-1");
        jButton4.setBorderPainted(false);
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton4.setMaximumSize(new java.awt.Dimension(20, 20));
        jButton4.setMinimumSize(null);
        jButton4.setPreferredSize(new java.awt.Dimension(30, 30));
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton4);

        jComboBox1.setEditable(true);
        jComboBox1.setMinimumSize(new java.awt.Dimension(10, 10));
        jComboBox1.setPreferredSize(new java.awt.Dimension(20, 10));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jComboBox1);

        jToggleButton11.setToolTipText("3d evlevation");
        jToggleButton11.setBorderPainted(false);
        jToggleButton11.setEnabled(false);
        jToggleButton11.setFocusable(false);
        jToggleButton11.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton11.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton11.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton11.setMinimumSize(null);
        jToggleButton11.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton11.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jToggleButton11);

        jToggleButton13.setSelected(true);
        jToggleButton13.setToolTipText("see NaN & infinite");
        jToggleButton13.setBorderPainted(false);
        jToggleButton13.setFocusable(false);
        jToggleButton13.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton13.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton13.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton13.setMinimumSize(null);
        jToggleButton13.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton13.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton13ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton13);

        jToggleButton14.setSelected(true);
        jToggleButton14.setToolTipText("set X=Y");
        jToggleButton14.setBorderPainted(false);
        jToggleButton14.setFocusable(false);
        jToggleButton14.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton14.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton14.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton14.setMinimumSize(null);
        jToggleButton14.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton14.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton14ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton14);

        jToggleButton15.setToolTipText("Edit courbs");
        jToggleButton15.setBorderPainted(false);
        jToggleButton15.setFocusable(false);
        jToggleButton15.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton15.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton15.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton15.setMinimumSize(null);
        jToggleButton15.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton15.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton15ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton15);

        jToggleButton10.setToolTipText("OGL");
        jToggleButton10.setBorderPainted(false);
        jToggleButton10.setFocusable(false);
        jToggleButton10.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton10.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton10.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton10.setMinimumSize(null);
        jToggleButton10.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton10.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton10ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton10);

        jToggleButton9.setToolTipText("Scroll time courbs");
        jToggleButton9.setBorderPainted(false);
        jToggleButton9.setFocusable(false);
        jToggleButton9.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton9.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton9.setMaximumSize(new java.awt.Dimension(20, 20));
        jToggleButton9.setMinimumSize(null);
        jToggleButton9.setPreferredSize(new java.awt.Dimension(30, 30));
        jToggleButton9.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton9ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton9);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        jPanel2.setOpaque(false);
        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel4.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanel4ComponentResized(evt);
            }
        });
        jPanel4.setLayout(null);

        jScrollPane1.setOpaque(false);

        jTree1.setCellRenderer(null);
        jTree1.setComponentPopupMenu(jPopupMenu2);
        jTree1.setEditable(true);
        jTree1.addMouseWheelListener(new java.awt.event.MouseWheelListener() {
            public void mouseWheelMoved(java.awt.event.MouseWheelEvent evt) {
                jTree1MouseWheelMoved(evt);
            }
        });
        jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTree1MouseReleased(evt);
            }
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTree1MouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTree1MousePressed(evt);
            }
        });
        jTree1.addTreeExpansionListener(new javax.swing.event.TreeExpansionListener() {
            public void treeCollapsed(javax.swing.event.TreeExpansionEvent evt) {
                jTree1TreeCollapsed(evt);
            }
            public void treeExpanded(javax.swing.event.TreeExpansionEvent evt) {
                jTree1TreeExpanded(evt);
            }
        });
        jTree1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                jTree1MouseDragged(evt);
            }
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                jTree1MouseMoved(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        jPanel4.add(jScrollPane1);
        jScrollPane1.setBounds(0, 0, 400, 330);

        jPanel1.setComponentPopupMenu(jPopupMenu1);
        jPanel1.setOpaque(false);
        jPanel1.addMouseWheelListener(new java.awt.event.MouseWheelListener() {
            public void mouseWheelMoved(java.awt.event.MouseWheelEvent evt) {
                jPanel1MouseWheelMoved(evt);
            }
        });
        jPanel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jPanel1MouseReleased(evt);
            }
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPanel1MouseClicked(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                jPanel1MouseExited(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jPanel1MousePressed(evt);
            }
        });
        jPanel1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                jPanel1MouseDragged(evt);
            }
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                jPanel1MouseMoved(evt);
            }
        });
        jPanel1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jPanel1KeyReleased(evt);
            }
        });
        jPanel1.setLayout(null);

        jPanel6.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPanel6MouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jPanel6MousePressed(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jPanel6MouseReleased(evt);
            }
        });
        jPanel6.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                jPanel6MouseDragged(evt);
            }
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                jPanel6MouseMoved(evt);
            }
        });

        jLabel1.setText("x : ");
        jPanel6.add(jLabel1);

        jLabel2.setText("-x-");
        jPanel6.add(jLabel2);

        jLabel3.setText("y : ");
        jPanel6.add(jLabel3);

        jLabel4.setText("-y-");
        jPanel6.add(jLabel4);

        jPanel1.add(jPanel6);
        jPanel6.setBounds(1, 310, 400, 20);

        jPanel4.add(jPanel1);
        jPanel1.setBounds(0, 0, 400, 335);

        jPanel3.setBackground(new java.awt.Color(204, 204, 255));
        jPanel3.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jPanel3.setLayout(new java.awt.BorderLayout());
        jPanel4.add(jPanel3);
        jPanel3.setBounds(0, 0, 400, 340);

        jPanel2.add(jPanel4, java.awt.BorderLayout.CENTER);

        add(jPanel2, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jToggleButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton5ActionPerformed
        if (jToggleButton5.isSelected()) {
            setzoom(-1);
        }
    }//GEN-LAST:event_jToggleButton5ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Save();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        removeallcurbs(true);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        Open();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jToggleButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton6ActionPerformed
        setdrawpt(isdrawpt());
    }//GEN-LAST:event_jToggleButton6ActionPerformed

    private void jToggleButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton7ActionPerformed
        setrule(isrule());
    }//GEN-LAST:event_jToggleButton7ActionPerformed

    private void jCheckBoxMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem1ActionPerformed
        setrule(jCheckBoxMenuItem1.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem1ActionPerformed

    private void jCheckBoxMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem3ActionPerformed
        setdrawpt(jCheckBoxMenuItem3.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem3ActionPerformed

    private void jRadioButtonMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem4ActionPerformed
        if (jRadioButtonMenuItem4.isSelected()) {
            setzoom(-1);
        }
    }//GEN-LAST:event_jRadioButtonMenuItem4ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        removeallcurbs(true);
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        java.awt.Color c = javax.swing.JColorChooser.showDialog(this, "Select Color", this.getBackground());
        if (c != null) {
            setBackground(c);
        }
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jCheckBoxMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem2ActionPerformed
        showToolBar(jCheckBoxMenuItem2.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem2ActionPerformed

    private void jPanel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseClicked
        String res = "";
        tempPt = null;
        if (getADMidx("rule_wait") >= 0) {
            Point2D np = gpanel.graph2real(evt.getPoint().x, evt.getPoint().y);
            setADMPosAt("rule_wait", np.getX());
            setADMValAt("rule_wait", np.getY());
            setADMTagAt("rule_wait", "rule_point");
            //   setrule(getADMidx("rule_wait") );
            java.awt.Shape point = new Rectangle2D.Double(evt.getPoint().getX() - ptsize, evt.getPoint().getY() - jPanel3.getHeight() - ptsize, 2 * ptsize, 2 * ptsize);
            setADMShapeAt("rule_point", point);
            gpanel.repaint();
            return;
        }

        if (getADMidx("rule_point") >= 0 && SelRect == null) {
            Point2D np = gpanel.graph2real(evt.getPoint().x, evt.getPoint().y);
            res
                    = "----Rule----\r\n Delta position : " + (np.getX() - getADMPosAt("rule_point")) + "\r\n Delta value : " + (np.getY() - getADMValAt("rule_point"));
            JOptionPane.showMessageDialog(this, res, "Value box", JOptionPane.INFORMATION_MESSAGE);
            return;

        }

        if (SelRect != null) {
            return;
        }

        // display detail of point of mesurement
        java.awt.Point clickpoint = evt.getPoint();
        if (getMode() != MODE_3D) {
            clickpoint.translate(0, -jPanel3.getSize().height);
        }
        java.util.List<com.jdcm.common.C_Packet> packlist = new java.util.ArrayList<>();
        for (int courbe = 0; courbe < length(); courbe++) {
            Donnees vals = getcourb(courbe);
            for (int i = 0; i < vals.getmesures().size(); i++) {
                //Mesure m=vals.getPointAt(i);
                if (vals.getShapeAt(i) != null) {
                    if (vals.getShapeAt(i).contains(clickpoint)) {
                        //        String pos = "" + vals.getPosAt(i).doubleValue();
                        //         if (vals.getPointAt(i) != null) {
                        //            pos = "(" + vals.getPointAt(i).getX() + " , " + vals.getPointAt(i).getY() + ")";
                        //         }
                        String s = vals.getAxislabel("x");
                        String pos = this.formatvalue(s, vals.getPointAt(i).getX());
                        if (isEditTree()) {
                            try {
                                DefaultMutableTreeNode node1 = (DefaultMutableTreeNode) ((DefaultMutableTreeNode) jTree1.getModel().getRoot()).getLastChild();
                                DefaultMutableTreeNode node_crb = (DefaultMutableTreeNode) node1.getChildAt(courbe);
                                DefaultMutableTreeNode node3 = (DefaultMutableTreeNode) node_crb.getLastChild();
                                DefaultMutableTreeNode node_mes = (DefaultMutableTreeNode) node3.getChildAt(i);
                                if (node_mes != null) {
                                    jTree1.setSelectionPath(new javax.swing.tree.TreePath(node_mes.getPath()));
                                    int r = jTree1.getSelectionRows()[0];

                                    if (jTree1.getVisibleRect().contains(jTree1.getRowBounds(r)) == false) {
                                        jScrollPane1.getViewport().setViewPosition(jTree1.getRowBounds(r).getLocation());
                                    }
                                }
                            } catch (Exception ex) {
                            }
                        } else {
                            if (Parent != null && vals.getTagAt(i) != null) {
                                try {
                                    int nb = new Integer(vals.getTagAt(i));
                                    packlist.add(Parent.getModelPackets().get(nb));
                                } catch (NumberFormatException ex) {
                                     System.out.println("jPanel1MouseClicked()=>" +ex.getMessage());
                                }
                            }
                            res = res + "Courbe/Mesure : " + courbe + " / " + i + "\r\n"
                                    + "Position = " + pos + "\r\n"
                                    + "Value = " + vals.getValAt(i).doubleValue() + "\r\n"
                                    + "Tag : " + (vals.getTagAt(i))
                                    + "\r\n----------------------------------\r\n";
                        }
                    }

                }
            }

        }
        if (Parent == null && res != null && res.length() > 0) {//Parent==null &&
            JOptionPane.showMessageDialog(this, res, "Value box", JOptionPane.INFORMATION_MESSAGE);
        } else if (Parent != null && packlist.isEmpty() == false) {
            if (evt.isAltGraphDown() == false && evt.isShiftDown() == false) {
                Parent.setSelectedPackets(new com.jdcm.common.C_Packet[]{});
            }
            Parent.setSelectedPackets(packlist.toArray(new com.jdcm.common.C_Packet[]{}));
        }

    }//GEN-LAST:event_jPanel1MouseClicked

    private void jPanel1MouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseMoved
        if (isbar()) {
            if (getADMidx("rule_point") >= 0) {
                Point2D np = gpanel.graph2real(evt.getPoint().x, evt.getPoint().y);
                setstatusbar(
                        "" + formatvalue(courbs.get(selectedcourb).getAxislabel("x"), np.getX() - getADMPosAt("rule_point")),
                        "" + formatvalue(courbs.get(selectedcourb).getAxislabel("y"), np.getY() - getADMValAt("rule_point")));

            } else {
                java.awt.geom.Point2D p = gpanel.graph2real(evt.getPoint().x, evt.getPoint().y);
                setstatusbar(
                        "" + formatvalue(courbs.get(selectedcourb).getAxislabel("x"), p.getX()),
                        "" + formatvalue(courbs.get(selectedcourb).getAxislabel("y"), p.getY()));
            }
        }
        if (initSelPt != null && getSelection() != null) {
            if (getzoom() == 0) {
                //x<=>
                if (initSelPt.x > evt.getPoint().getX()) {
                    getSelection().setRect(evt.getPoint().getX(), -jPanel3.getHeight() + 1, initSelPt.x - evt.getPoint().getX(), jPanel3.getHeight() - 1);
                } else {
                    getSelection().setRect(initSelPt.x, -jPanel3.getHeight() + 1, evt.getPoint().getX() - initSelPt.x, jPanel3.getHeight() - 1);
                }

            }
            if (getzoom() == 1) {
                //y<=>
                //int posinity=initSelRect+this.getHeight();
                if (initSelPt.y > evt.getPoint().getY()) {
                    getSelection().setRect(0, evt.getPoint().getY() - jPanel3.getHeight(), jPanel3.getWidth(), initSelPt.y - evt.getPoint().getY());
                } else {
                    getSelection().setRect(0, initSelPt.y - jPanel3.getHeight(), jPanel3.getWidth(), evt.getPoint().getY() - initSelPt.y);
                }

            }
            //X&Y<=>
            if (getzoom() == 2) {
                int newX = initSelPt.x;
                int newY = initSelPt.y;
                if (initSelPt.x > evt.getPoint().getX()) {
                    newX = evt.getPoint().x;
                }

                if (initSelPt.y > evt.getPoint().getY()) {
                    newY = evt.getPoint().y;
                }
                getSelection().setRect(newX, newY - jPanel3.getHeight(), Math.abs(initSelPt.x - evt.getPoint().getX()), Math.abs(initSelPt.y - evt.getPoint().getY()));
            }

            if (getzoom() == 3) {
                //move zoom ??
            }
            repaint();
        }
        // higlight mouse move over a point
        boolean withRepaint = false;
        java.awt.Point clickpoint = evt.getPoint();
        if (getMode() != MODE_3D) {
            clickpoint.translate(0, -jPanel3.getSize().height);
        }
        for (int courbe = 0; courbe < length(); courbe++) {
            Donnees vals = getcourb(courbe);
            for (int i = 0; i < vals.getmesures().size(); i++) {
                //Mesure m=vals.getPointAt(i);
                if (vals.getShapeAt(i) != null) {
                    java.awt.Shape s = vals.getShapeAt(i);
                    if (s.contains(clickpoint)) {
                        if (s instanceof Rectangle2D) {
                            java.awt.Shape s2 = new Ellipse2D.Double(((Rectangle2D) s).getX(), ((Rectangle2D) s).getY(), ((Rectangle2D) s).getWidth(), ((Rectangle2D) s).getHeight());
                            vals.setShapeAt(i, s2);
                            withRepaint = true;
                        }
                    } else if (s instanceof Ellipse2D) {
                        java.awt.Shape s2 = new Rectangle2D.Double(((Ellipse2D) s).getX(), ((Ellipse2D) s).getY(), ((Ellipse2D) s).getWidth(), ((Ellipse2D) s).getHeight());
                        vals.setShapeAt(i, s2);
                        withRepaint = true;
                    }
                }
            }
        }
        if (withRepaint) {
            jPanel1.repaint();
        }
    }//GEN-LAST:event_jPanel1MouseMoved

    private void jRadioButtonMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem1ActionPerformed
        setzoom(0);
    }//GEN-LAST:event_jRadioButtonMenuItem1ActionPerformed

    private void jRadioButtonMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem2ActionPerformed
        setzoom(1);
    }//GEN-LAST:event_jRadioButtonMenuItem2ActionPerformed

    private void jRadioButtonMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem3ActionPerformed
        setzoom(2);
    }//GEN-LAST:event_jRadioButtonMenuItem3ActionPerformed

    private void jRadioButtonMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem5ActionPerformed
        setzoom(4);
    }//GEN-LAST:event_jRadioButtonMenuItem5ActionPerformed

    private void jPanel1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseReleased
        if (evt.getClickCount() == 2) {
            //getRange();
            gpanel.repaint();
            return;
        }
        tempPt = null;
        if (getSelection() != null) {
            if (getADMidx("rule_wait") >= 0) {
                setrule(false);
            }
            if (getzoom() == 4) {
                initSelPt = null;
                setSelection(null);
                return;
            }

            if (initSelPt.getX() != evt.getPoint().getX() && initSelPt.getY() != evt.getPoint().getY()) {
                //-Y beacuase 2D panel is Y translated
                java.awt.geom.Point2D r1 = gpanel.graph2real((int) getSelection().getMinX(), -(int) getSelection().getMaxY());
                java.awt.geom.Point2D r2 = gpanel.graph2real((int) getSelection().getMaxX(), -((int) getSelection().getMinY()));

                double zx = (gpanel.getBounds().getWidth()) / Math.abs(r1.getX() - r2.getX());
                double zy = (gpanel.getBounds().getHeight()) / Math.abs(r1.getY() - r2.getY());
                if (getzoom() == 0 || getzoom() == 2) {
                    gpanel.setzoomx(Math.abs(zx), initSelPt.x);
                    gpanel.setdepx((gpanel.getBounds().width / 2.0) - zx * (r1.getX() + r2.getX()) / 2.0);
                }
                if (getzoom() == 1 || getzoom() == 2) {
                    gpanel.setzoomy(Math.abs(zy), initSelPt.y);
                    gpanel.setdepy(-(gpanel.getBounds().height / 2.0) + zy * (r1.getY() + r2.getY()) / 2.0);
                }
                initSelPt = null;
                setSelection(null);
                setzoom(3);
                repaint();
            }
        }
    }//GEN-LAST:event_jPanel1MouseReleased

private void jPanel1MouseWheelMoved(java.awt.event.MouseWheelEvent evt) {//GEN-FIRST:event_jPanel1MouseWheelMoved
    if (getzoom() < 3 || getzoom() == 4) {
        int zidx = evt.getWheelRotation();
        setSelection(null);
        if (getzoom() == 0 || getzoom() == 2 || getzoom() == 4) {
            gpanel.setzoomx(gpanel.getzoomx() + (gpanel.getzoomx() * zidx) / 100, (int) Math.round(gpanel.getBounds().getWidth() / 2));
        }
        if (getzoom() == 1 || getzoom() == 2 || getzoom() == 4) {
            gpanel.setzoomy(gpanel.getzoomy() + (gpanel.getzoomy() * zidx) / 100, (int) Math.round(gpanel.getBounds().getHeight() / 2));
        }
        initSelPt = null;
        repaint();
    }
}//GEN-LAST:event_jPanel1MouseWheelMoved

private void jPanel1MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseDragged
    if (initSelPt == null) {
        initSelPt = evt.getPoint();
    } else {
        if (tempPt == null) {
            tempPt = initSelPt;
        }
        if (iselevrot()) {
            gpanel.setelevation(gpanel.getelevation() + ((tempPt.getY() - evt.getY()) / 100));
            gpanel.setrotation(gpanel.getrotation() + ((tempPt.getX() - evt.getX()) / 100));
            tempPt = evt.getPoint();
        } else if (getzoom() == 4) {
            gpanel.setdepx(gpanel.getdepx() + evt.getPoint().getX() - tempPt.getX());
            gpanel.setdepy(gpanel.getdepy() + evt.getPoint().getY() - tempPt.getY());

            //   gpanel.movedraw(evt.getPoint().getX()-initSelPt.getX(),evt.getPoint().getY()-initSelPt.getY());
            tempPt = evt.getPoint();
        } else if (getzoom() < 3) {
            int zidx = (evt.getPoint().x - tempPt.x) + (tempPt.y - evt.getPoint().y);
            SelRect = null;
            if (getzoom() == 0 || getzoom() == 2) {
                gpanel.setzoomx(gpanel.getzoomx() + (gpanel.getzoomx() * zidx) / 100, initSelPt.x);
            }
            if (getzoom() == 1 || getzoom() == 2) {
                gpanel.setzoomy(gpanel.getzoomy() + (gpanel.getzoomy() * zidx) / 100, initSelPt.y);
            }
            tempPt = evt.getPoint();
        }
    }
    repaint();

}//GEN-LAST:event_jPanel1MouseDragged

private void jPanel1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MousePressed
    if (this.getSelection() == null && getzoom() != 3 && getzoom() >= 0 && getzoom() < 5 && evt.getButton() == java.awt.event.MouseEvent.BUTTON1) {
        initSelPt = evt.getPoint();
        setSelection(new Rectangle2D.Double(0.0, 0.0, 0.0, 0.0));
    }
}//GEN-LAST:event_jPanel1MousePressed

private void jToggleButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton13ActionPerformed
    setNaN(isNaN());
}//GEN-LAST:event_jToggleButton13ActionPerformed

private void jToggleButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton14ActionPerformed
    setxeqy(isxeqy());
}//GEN-LAST:event_jToggleButton14ActionPerformed

private void jToggleButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton15ActionPerformed
    setEditTree(isEditTree());
}//GEN-LAST:event_jToggleButton15ActionPerformed

private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
    if (jTree1.getSelectionPath() != null) {
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
        if (node.getUserObject() instanceof Donnees) {
            courbs.remove((Donnees) node.getUserObject());
            Update();
        } else if (node.getUserObject() instanceof Mesure) {
            DefaultMutableTreeNode list = (DefaultMutableTreeNode) node.getParent();
            int mesidx = list.getIndex(node);
            DefaultMutableTreeNode crb = (DefaultMutableTreeNode) list.getParent();
            DefaultMutableTreeNode lstcrb = (DefaultMutableTreeNode) crb.getParent();
            int crbidx = lstcrb.getIndex(crb);
            Donnees d = courbs.get(crbidx);
            d.remove(mesidx);
            Update();
            //DONT KNOW HOW TO AVOID TREE COLLAPSE
            // jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getNode(this)));
        }
    }
}//GEN-LAST:event_jMenuItem6ActionPerformed

private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
    if (jTree1.getSelectionPath() != null) {
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
        if (node.getUserObject() instanceof Donnees) {
            courbs.add(new Donnees(new String[]{"x", "y", "z"}, java.awt.Color.BLUE, java.awt.Color.GREEN, java.awt.Color.PINK, 1, 0.0, "newCurb"));
            Update();
        } else if (node.getUserObject() instanceof Mesure) {
            DefaultMutableTreeNode list = (DefaultMutableTreeNode) node.getParent();
            DefaultMutableTreeNode crb = (DefaultMutableTreeNode) list.getParent();
            DefaultMutableTreeNode lstcrb = (DefaultMutableTreeNode) crb.getParent();
            int mesidx = list.getIndex(node);
            int crbidx = lstcrb.getIndex(crb);
            Donnees d = courbs.get(crbidx);
            if (d.is3D()) {
                d.add(mesidx, 0.0, 0.0, 0.0, "added value");
            } else {
                d.add(0.0, 0.0, "added value");
            }
            //DONT KNOW HOW TO AVOID TREE COLLAPSE
            //  jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getNode(this)));
        }
    }
}//GEN-LAST:event_jMenuItem3ActionPerformed

private void jPanel1MouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel1MouseExited
    setstatusbar("-", "-");
}//GEN-LAST:event_jPanel1MouseExited

private void jCheckBoxMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem4ActionPerformed
    setbar(isbar());
}//GEN-LAST:event_jCheckBoxMenuItem4ActionPerformed

private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
    setMode(getMode());

}//GEN-LAST:event_jComboBox1ActionPerformed

private void jTree1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseClicked
    jPanel1MouseClicked(evt);
}//GEN-LAST:event_jTree1MouseClicked

private void jTree1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MousePressed
    jPanel1MousePressed(evt);
}//GEN-LAST:event_jTree1MousePressed

private void jTree1MouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseMoved
    jPanel1MouseMoved(evt);
}//GEN-LAST:event_jTree1MouseMoved

private void jTree1MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseDragged
    jPanel1MouseDragged(evt);
}//GEN-LAST:event_jTree1MouseDragged

private void jTree1TreeCollapsed(javax.swing.event.TreeExpansionEvent evt) {//GEN-FIRST:event_jTree1TreeCollapsed
    repaint();
}//GEN-LAST:event_jTree1TreeCollapsed

private void jTree1TreeExpanded(javax.swing.event.TreeExpansionEvent evt) {//GEN-FIRST:event_jTree1TreeExpanded
    repaint();
}//GEN-LAST:event_jTree1TreeExpanded

private void jTree1MouseWheelMoved(java.awt.event.MouseWheelEvent evt) {//GEN-FIRST:event_jTree1MouseWheelMoved
    jPanel1MouseWheelMoved(evt);
}//GEN-LAST:event_jTree1MouseWheelMoved

private void jTree1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseReleased
    repaint();
}//GEN-LAST:event_jTree1MouseReleased

private void jCheckBoxMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem5ActionPerformed
    setEditTree(jCheckBoxMenuItem5.isSelected());
    repaint();
}//GEN-LAST:event_jCheckBoxMenuItem5ActionPerformed

private void jPanel6MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel6MouseDragged
    if (initstatuspos != null) {
        java.awt.Rectangle r = jPanel6.getBounds();
        r.translate(evt.getPoint().x - initstatuspos.x, evt.getPoint().y - initstatuspos.y);
        jPanel6.setBounds(r);
    }
}//GEN-LAST:event_jPanel6MouseDragged

private void jPanel6MouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel6MouseMoved
}//GEN-LAST:event_jPanel6MouseMoved

private void jPanel6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel6MouseClicked
}//GEN-LAST:event_jPanel6MouseClicked

private void jPanel6MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel6MouseReleased
    initstatuspos = null;
}//GEN-LAST:event_jPanel6MouseReleased

private void jPanel6MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel6MousePressed
    initstatuspos = evt.getPoint();
}//GEN-LAST:event_jPanel6MousePressed

private void jCheckBoxMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem6ActionPerformed
    setEditTree(jCheckBoxMenuItem6.isSelected());
}//GEN-LAST:event_jCheckBoxMenuItem6ActionPerformed

private void jToggleButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton9ActionPerformed
    setscroll(jToggleButton9.isSelected());
}//GEN-LAST:event_jToggleButton9ActionPerformed

private void jToggleButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton10ActionPerformed
    setOGL(isOGL());
}//GEN-LAST:event_jToggleButton10ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
    setAxis(getAxis() + 1);
}//GEN-LAST:event_jButton4ActionPerformed

private void jRollingButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRollingButton1ActionPerformed
    setzoom((Integer) jRollingButton1.getValue());
}//GEN-LAST:event_jRollingButton1ActionPerformed

    private void jPanel1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jPanel1KeyReleased
        if (evt.getKeyCode() == 27) {
            showToolBar(!jToolBar1.isVisible());
        }
    }//GEN-LAST:event_jPanel1KeyReleased

    private void jPanel4ComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel4ComponentResized
        jPanel1.setBounds(jPanel4.getBounds());
        jPanel3.setBounds(jPanel4.getBounds());
        jScrollPane1.setBounds(jPanel4.getBounds());
    }//GEN-LAST:event_jPanel4ComponentResized
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem1;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem2;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem3;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem4;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem5;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem6;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JPopupMenu jPopupMenu2;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem1;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem2;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem3;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem4;
    private javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem5;
    private com.jdcm.common.G_JRollingButton jRollingButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JToggleButton jToggleButton10;
    private javax.swing.JToggleButton jToggleButton11;
    private javax.swing.JToggleButton jToggleButton13;
    private javax.swing.JToggleButton jToggleButton14;
    private javax.swing.JToggleButton jToggleButton15;
    private javax.swing.JToggleButton jToggleButton5;
    private javax.swing.JToggleButton jToggleButton6;
    private javax.swing.JToggleButton jToggleButton7;
    private javax.swing.JToggleButton jToggleButton9;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
