/*
 * test3D.java
 *??si necessaire (scintillement) utilisation du double buffering????
 * Created on 3 octobre 2008, 22:56
 */
package com.jdcm.charts;

import java.awt.geom.*;
import java.awt.*;

/**
 *
 * @author  Marc GIBOIN
 */
public class P_Line3D extends javax.swing.JPanel implements I_Graphic {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private double rotation = Math.PI / 4;
    private double elevation = 3.5 * Math.PI / 2;
    private double zoomx = 100;
    private double zoomy = 100;
    private double depx = 0;
    private double depy = 0;
    private P_Chartplus main = null;

    /** Creates new form test3D */
    public P_Line3D() {
        initComponents();
        this.setOpaque(false);

    }

    @Override
    public void setMain(P_Chartplus m) {
        main = m;
    }

    @Override
    public double getzoomx() {
        return zoomx;
    }

    @Override
    public double getzoomy() {
        return zoomy;
    }

    @Override
    public void setdepx(double x) {
        depx = x;
        //repaint(10);
    }

    @Override
    public void setdepy(double y) {
        depy = y;
        //repaint(10);
    }

    @Override
    public double getdepx() {
        return depx;
    }

    @Override
    public double getdepy() {
        return depy;
    }

    @Override
    public void setzoomx(double z, int pivotx) {
        Double z0 = zoomx;
        zoomx = z;
        depx = (z / z0) * (depx - pivotx) + pivotx;
        //zoomx = z;
    }

    @Override
    public void setzoomy(double z, int pivoty) {
        Double z0 = zoomy;
        zoomy = z;
        depy = (z / z0) * (depy - pivoty) + pivoty;
        //zoomy = z;

    }

    @Override
    public void initzoom(int zoommode) {
        //there should be an auto rezoom and dep for main.getzoom(-1)
        if (zoommode == -1&&main != null) {
            main.getRange();
            Point2D p1 = new Point2D.Double(main.getADMPosAt("RangeI"), main.getADMValAt("RangeI"));
            Point2D p2 = new Point2D.Double(main.getADMPosAt("RangeS"), main.getADMValAt("RangeS"));
            zoomx = getSize().width / Math.abs(p1.getX() - p2.getX());
            zoomy = getSize().height / Math.abs(p1.getY() - p2.getY());
            if ( main.isxeqy()) {
                zoomx = Math.min(zoomx, zoomy);
                zoomy = zoomx;
            }
            depx = (getSize().width / 2.0) - zoomx * (p1.getX() + p2.getX()) / 2.0;
            depy = (getSize().height / 2.0) - zoomy * (p1.getY() + p2.getY()) / 2.0;
        }
    }

    @Override
    public void setrotation(double rot) {
        rotation = rot;
        this.repaint(10);
    }

    @Override
    public double getrotation() {
        return rotation;
    }

    @Override
    public double getelevation() {
        return elevation;
    }

    @Override
    public void setelevation(double elev) {
        elevation = elev;
        this.repaint(10);
    }

    /**
     *  give the point transformed to be viewed in a 2Dpanel <br>
     * without any ofset or zoom management
     * @param x
     * @param y
     * @param z
     * @return the transformed 2D point
     */
    @Override
    public Point2D project2D(double x, double y, double z) {
        Double zplus = z;
        if (zplus.isInfinite() || zplus.isNaN()) {
            if (main.isNaN()) {
                zplus = 0.0;
            } else {
                return null;
            }
        }
        double nx = x * Math.cos(rotation) + y * Math.sin(rotation);
        double ny = x * Math.sin(rotation) * Math.cos(elevation) + y * -Math.cos(rotation) * Math.cos(elevation) + zplus * Math.sin(elevation);
        return new Point2D.Double(nx, ny);
    }

    /**
     * give the point transformed to be viewed in a 2Dpanel <br>
     * with ofset and zoom management
     * @param x
     * @param y
     * @param z
     * @return the drawable 2D point
     */
    private Point2D project2Dplus(double x, double y, double z) {
        final Point2D p = project2D(x, y, z);
        if (p != null) {
            return new Point2D.Double(p.getX() * zoomx + depx, p.getY() * zoomy + depy);
        }
        return null;
    }

    @Override
    public Point2D graph2real(int x, int y) {
        // to display statusbar
        return new Point2D.Double((x - depx) / zoomx, (y - depy) / zoomy);
    }

    private void drawAxes(Graphics2D g) {
        if (main.getAxis() == P_Chartplus.AXIS_NONE) {
            return;
        }
        for (int i = 0; i < main.length(); i++) {
            Donnees datas = main.getcourb(i);
            if (datas.isVisible() || (datas.getlabel().startsWith("ADM") && main.length() == 1)) {
                Point2D zero = project2Dplus(0, 0, 0);
                Point2D x = project2Dplus(1, 0, 0);
                Shape segmentx = new Line2D.Double(zero, x);
                g.setPaint(Color.green);
                g.draw(segmentx);
                if (this.getBounds().contains(x)) {
                    g.drawString(datas.getAxislabel("x"), Integer.parseInt("" + Math.round(x.getX())), Integer.parseInt("" + Math.round(x.getY())));
                }
                if (main.getAxis() != P_Chartplus.AXIS_ONLYX) {
                    Point2D y = project2Dplus(0, 1, 0);
                    Shape segmenty = new Line2D.Double(zero, project2Dplus(0, 1, 0));
                    g.setPaint(Color.BLUE);
                    g.draw(segmenty);
                    if (this.getBounds().contains(y)) {
                        g.drawString(datas.getAxislabel("y"), Integer.parseInt("" + Math.round(y.getX())), Integer.parseInt("" + Math.round(y.getY())));
                    }
                    Point2D z = project2Dplus(0, 0, 1);
                    Shape segmentz = new Line2D.Double(zero, project2Dplus(0, 0, 1));
                    g.setPaint(Color.RED);
                    g.draw(segmentz);
                    if (this.getBounds().contains(z)) {
                        g.drawString(datas.getAxislabel("z"), Integer.parseInt("" + Math.round(z.getX())), Integer.parseInt("" + Math.round(z.getY())));
                    }
                }
                g.setPaint(Color.black);

            }
        }
    }

    private void drawcourb(Graphics2D g) {

        if (main == null || main.length() == 0) {
            return;
        }
        for (int i = 0; i < main.length(); i++) {
            Donnees datas = main.getcourb(i);
            if (datas.isVisible()) {
                if (datas.is3D()) {
                    drawdelaunay(g, datas);
                } else {
                    drawcourbasline(g, datas);
                }
            }
        }

    }

    private void drawdelaunay(Graphics2D g, Donnees datas) {
        boolean ismeshedcol = true;
        Shape curb1;
        java.util.List<ValuedPoint2D[]> edges = datas.getdelaunay();
        if (edges == null || edges.size() < 2) {
            return;
        }
        for (int line = 0; line < edges.size(); line++) {
            ValuedPoint2D[] vpoints = edges.get(line);
            if (vpoints.length >= 2) {
                Mesure mes = (Mesure) vpoints[0].getvalue();

                Point2D p1 = project2Dplus(vpoints[0].getX(), vpoints[0].getY(), mes.getval());
                Point2D p2 = project2Dplus(vpoints[1].getX(), vpoints[1].getY(), ((Mesure) vpoints[1].getvalue()).getval());

                if (p1 != null && p2 != null && datas.gettype() < 2) {
                    g.setPaint(datas.getcurbcolor());
                    if (datas.gettype() == 0) {
                        //point
                        curb1 = new Rectangle2D.Double(p1.getX() - main.getptsize(), p1.getY() - main.getptsize(), 2 * main.getptsize(), 2 * main.getptsize());
                        g.draw(curb1);
                    } else if (datas.gettype() == 1) {
                        //wires : only Delanay edges computed
                        curb1 = new Line2D.Double(p1, p2);
                        g.draw(curb1);
                    }
                }
                if (datas.gettype() >= 2 && (p1 != null || p2 != null)) {
                    //  meshed or plans => draw Delanay triangle computed
                    if (p2 == null && p1 != null) {
                        p2 = project2Dplus(vpoints[1].getX(), vpoints[1].getY(), 0.0);
                    }
                    if (p1 == null && p2 != null) {
                        p1 = project2Dplus(vpoints[0].getX(), vpoints[0].getY(), 0.0);
                    }
                    curb1 = new Line2D.Double(p1, p2);
                    Point2D p3 = project2Dplus(vpoints[2].getX(), vpoints[2].getY(), ((Mesure) vpoints[2].getvalue()).getval() + datas.getoffset());
                    if (p3 == null) {
                        p3 = project2Dplus(vpoints[2].getX(), vpoints[2].getY(), 0.0);
                    }
                    java.awt.geom.Path2D poly = new java.awt.geom.Path2D.Double(curb1);
                    poly.lineTo(p3.getX(), p3.getY());
                    poly.closePath();
                    poly.setWindingRule(Path2D.WIND_NON_ZERO);
                    curb1 = poly;
                    if (datas.gettype() >= 2) {
                        if (datas.gettype() == 3) {
                            //meshed
                            if (ismeshedcol) {
                                g.setPaint(datas.getfeelcolor());
                                ismeshedcol = false;
                            } else {
                                g.setPaint(datas.getcurbcolor());
                                ismeshedcol = true;
                            }
                        } else {
                            g.setPaint(datas.getfeelcolor());
                        }
                        g.draw(curb1);
                        g.fill(curb1);
                    }
                }
                // draws points
                if (p1 != null && main.isdrawpt() && this.getBounds().contains(p1)) {
                    g.setPaint(datas.getptcolor());
                    Shape point = new Rectangle2D.Double(p1.getX() - main.getptsize(), p1.getY() - main.getptsize(), 2 * main.getptsize(), 2 * main.getptsize());
                    Double z = mes.getval();
                    if (z.isInfinite() || z.isNaN()) {
                        g.setPaint(java.awt.Color.red);
                    }
                    mes.shape = point;
                    g.draw(point);
                } else {
                    mes.shape = null;
                }
            }
        }
    }

    private void drawcourbasline(Graphics2D g, Donnees datas) {
        Point2D p1,p2 = null;

        for (int j = 0; j < datas.getmesures().size(); j++) {
            if (datas.getPointAt(j) != null) {
                p1 = project2Dplus(datas.getPointAt(j).getX(), datas.getPointAt(j).getY(), datas.getValAt(j));
                if (p1 != null) {
                    if (p2 == null) {
                        p2 = p1;
                    }
                    if (main.isdrawpt() && this.getBounds().contains(p1)) {
                        g.setPaint(datas.getptcolor());
                        Shape point = new Rectangle2D.Double(p1.getX() - main.getptsize(), p1.getY() - main.getptsize(), 2 * main.getptsize(), 2 * main.getptsize());
                        if (datas.getValAt(j).isInfinite() || datas.getValAt(j).isNaN()) {
                            g.setPaint(java.awt.Color.red);
                        }
                        datas.setShapeAt(j, point);
                        g.draw(point);
                        g.setPaint(java.awt.Color.black);
                    } else {
                        datas.setShapeAt(j, null);
                    }
                    g.setPaint(datas.getcurbcolor());
                    Shape curb1 = null;
                    Shape curb2 = null;
                    if (datas.gettype() == 1) {
                        //line
                        curb1 = new Line2D.Double(p1, p2);
                    } else if (datas.gettype() == 2) {
                        //Square
                        Point2D p3;
                        if (datas.getValAt(j - 1) != null) {
                            p3 = project2Dplus(datas.getPointAt(j).getX(), datas.getPointAt(j).getY(), datas.getValAt(j - 1) + datas.getoffset());
                        } else {
                            p3 = p2;
                        }
                        curb1 = new Line2D.Double(p2, p3);
                        curb2 = new Line2D.Double(p3, p1);
                    } else if (datas.gettype() == 0) {
                        //points
                        curb1 = new Rectangle2D.Double(p1.getX() - main.getptsize(), p1.getY() - main.getptsize(), 2 * main.getptsize(), 2 * main.getptsize());
                    }
                    if (curb1 != null) {
                        g.draw(curb1);
                    }
                    if (curb2 != null) {
                        g.draw(curb2);
                    }
                    p2 = p1;
                }
            }

        }
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D) g;
        if (main != null) {
            initzoom(main.getzoom());
            drawAxes(g2);
        }
        drawcourb(g2);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setLayout(new java.awt.BorderLayout());
    }// </editor-fold>//GEN-END:initComponents

    @Override
    public Point2D project2D(double x, double y) {
        //throw new UnsupportedOperationException("Not supported yet.");
        return project2D(x, 0.0, y);

    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
