/*
 * P_Lines.java
 * ??si necessaire (scintillement) utilisation du double buffering????
 * Created on 10 mai 2007, 08:03
 */
package com.jdcm.charts;

import java.awt.geom.*;
import java.awt.*;

/**
 *
 * @author Marc GIBOIN
 */
public class P_Lines2D extends javax.swing.JPanel implements I_Graphic {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    // ValsADM => values for zoom & rule managed by tag.
    private P_Chartplus main = null;
    private double zoomx = 1.0;
    private double zoomy = 1.0;
    private double depx = 0.0;
    private double depy = 0.0;

    /**
     * Creates new form P_Lines
     */
    public P_Lines2D() {
        initComponents();
        this.setOpaque(false);
    }

    @Override
    public void setMain(P_Chartplus m) {
        main = m;
    }

    public void setMask(String label) {
        Donnees Vals = main.getcourb(label);
        Vals.setVisible(true);
        main.getRange();
        repaint();
    }

    public int getzoomtype() {
        return main.getzoom();
    }

    /**
     * set the zoom to see all
     *
     * @param zoommode the mode of the zoom (-1=All;0=>x;2=Y) see main
     */
    @Override
    public void initzoom(int zoommode) {
        if (main == null) {
            return;
        }
        if (zoommode == -1) {
            main.getRange();
            Point2D p1 = new Point2D.Double(main.getADMPosAt("RangeI"), main.getADMValAt("RangeI"));
            Point2D p2 = new Point2D.Double(main.getADMPosAt("RangeS"), main.getADMValAt("RangeS"));
            zoomx = (getSize().width - 10) / Math.abs(p1.getX() - p2.getX());
            zoomy = (getSize().height - 10) / Math.abs(p1.getY() - p2.getY());
            if (main != null && main.isxeqy()) {
                zoomx = Math.min(zoomx, zoomy);
                zoomy = zoomx;
            }
            depx = ((getSize().width) / 2.0) - zoomx * (p1.getX() + p2.getX()) / 2.0;
            depy = ((getSize().height) / 2.0) - zoomy * (p1.getY() + p2.getY()) / 2.0;
        }
        // don't know why it was there
        //this.repaint(10);
    }

    public boolean isrule() {
        return main.isrule();
    }

    public int getrule() {
        return main.getADMidx("rule_point");
    }

    private AlphaComposite makeComposite(float alpha) {
        int type = AlphaComposite.SRC_OVER;
        return (AlphaComposite.getInstance(type, alpha));
    }

    /**
     * shape specials value to be visibles spécia&ls values are NaN/+ infinite/
     * -inf.
     *
     * @param x the exact real value
     * @param y the exact real value
     * @return the "visible" real value
     */
    @Override
    public Point2D project2D(double x, double y) {
        if (Double.isInfinite(y) == false && Double.isNaN(y) == false) {
            // see g2.translate in paintcomponment()
            //  y=y+(this.getSize().height - 1);
            return new Point2D.Double(x, y);
        } else {
            if (main.isNaN()) {
                return new Point2D.Double(x, 0.0);
            }
        }
        return null;
    }

    /**
     * provide a graphic point (in pixels) matching with a real position (x,y)
     *
     * @param x the real value
     * @param y the real value (care y on graph up to down)
     * @return the position on the graphic in pixels
     */
    private Point2D project2Dplus(double x, double y) {
        final Point2D p = project2D(x, y);
        if (p != null) {
            return new Point2D.Double(depx + p.getX() * (zoomx), -depy - p.getY() * (zoomy));
        }
        return null;
    }

    /**
     * provide the value matching with a graphic point (in pixels)
     *
     * @param x the x value of th point
     * @param y the y value of the point (care y&lt0)
     * @return the real value for this (x,y) on the graph)
     */
    @Override
    public Point2D graph2real(int x, int y) {
        return new Point2D.Double((x - depx) / zoomx, (y - depy) / zoomy);
    }
    /*
     *
     *      DRAW AXES
     *!!! X is OK [0...size]
     *!!! Y is [0... -height]
     *  NB : !! loop repaint()=>  //String[] fontNames = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
     *         // setFont(new Font(fontNames[0], Font.PLAIN, 10));
     *
     */

    private void drawAxes(Graphics2D g) {
        if (main.getAxis() == P_Chartplus.AXIS_NONE) {
            return;
        }
        String label_x = "[";
        String label_y = "[";
        if (main == null) {
            return;
        }
        g.setFont(new Font(g.getFont().getFontName(), Font.PLAIN, 10));
        int arrowlong = 4;
        int arrowwidth = 2;

        java.awt.geom.Point2D pmin = graph2real(0, 0);
        java.awt.geom.Point2D pmax = graph2real(getWidth(), getHeight());
        FontMetrics fontMetrics = g.getFontMetrics();
        Stroke str;
        for (int courbe = 0; courbe < main.length(); courbe++) {
            Donnees vals = main.getcourb(courbe);
            if (vals.isVisible() || (vals.getlabel().startsWith("ADM") && main.length() == 1)) {
                //------- TRACE X---------------
                str = new BasicStroke(1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f);
                g.setStroke(str);
                long posydex = Math.round(project2Dplus(0, 0).getY());
                g.setPaint(Color.BLACK);
                if (posydex > -fontMetrics.getHeight()) {
                    posydex = -fontMetrics.getHeight();
                    g.setPaint(Color.RED);
                }
                if (posydex < -getHeight() + 1) {
                    posydex = -getHeight() + 1;
                    g.setPaint(Color.RED);
                }
                // axe X and arrow
                Shape AxeX = new Line2D.Double(0, posydex, getWidth(), posydex);
                Shape AxeX1 = new Line2D.Double(getWidth(), posydex, getWidth() - arrowlong, posydex + arrowwidth);
                Shape AxeX2 = new Line2D.Double(getWidth(), posydex, getWidth() - arrowlong, posydex - arrowwidth);
                g.draw(AxeX);
                g.draw(AxeX1);
                g.draw(AxeX2);
                if (label_x.contains(vals.getAxislabel("x")) == false) {
                    label_x += vals.getAxislabel("x") + ",";
                }
                label_x = label_x.substring(0, label_x.length() - 1) + "]";
                g.drawString(label_x, getWidth() - fontMetrics.stringWidth(label_x) - 5, posydex);
                if (main.getAxis() == P_Chartplus.AXIS_INTERVALS || main.getAxis() == P_Chartplus.AXIS_ONLYX) {
                    Double[] inv = getroundedinterval(pmin.getX(), pmax.getX(), 6);
                    if (inv != null) {
                        for (Double xi : inv) {
                            if (xi != 0 || main.getAxis() == P_Chartplus.AXIS_ONLYX) {
                                int possub = (int) project2Dplus(xi, 0).getX();
                                g.drawString(ajustValue(label_x, xi), possub - fontMetrics.stringWidth("" + xi) / 2, posydex + fontMetrics.getHeight());
                                Shape subaxis = new Line2D.Double(possub, posydex, possub, posydex + 4);
                                g.draw(subaxis);
                            }
                        }
                    }
                    // draw extrem values
                    String label = ajustValue(label_x, pmax.getX());
                    g.drawString(label, getWidth() - fontMetrics.stringWidth(label) - 5, posydex + fontMetrics.getHeight());
                    g.drawString(ajustValue(label_x, pmin.getX()), 0, posydex + fontMetrics.getHeight());
                }
                //---------------------Trace Y--------------
                if (main.getAxis() != P_Chartplus.AXIS_ONLYX) {
                    long posxdey = Math.round(project2Dplus(0, 0).getX());
                    g.setPaint(Color.BLACK);
                    if (posxdey < fontMetrics.stringWidth("-0.0")) {
                        posxdey = fontMetrics.stringWidth("-0.0");
                        g.setPaint(Color.RED);
                    }
                    if (posxdey > getWidth() - 2) {
                        posxdey = getWidth() - 2;
                        g.setPaint(Color.RED);
                    }
                    Shape AxeY = new Line2D.Double(posxdey, 0, posxdey, -1 * getHeight());      // axe Y
                    Shape AxeY1 = new Line2D.Double(posxdey, -1 * getHeight(), posxdey - arrowwidth, -1 * getHeight() + arrowlong);
                    Shape AxeY2 = new Line2D.Double(posxdey, -1 * getHeight(), posxdey + arrowwidth, -1 * getHeight() + arrowlong);
                    g.draw(AxeY);
                    g.draw(AxeY1);
                    g.draw(AxeY2);
                    if (label_y.contains(vals.getAxislabel("y")) == false) {
                        label_y += vals.getAxislabel("y") + ",";
                    }
                    label_y = label_y.substring(0, label_y.length() - 1) + "]";
                    g.drawString(label_y, posxdey, -this.getHeight() + fontMetrics.getHeight());
                    if (main.getAxis() == P_Chartplus.AXIS_INTERVALS) {
                        Double[] inv = getroundedinterval(pmin.getY(), pmax.getY(), 6);
                        if (inv != null) {
                            for (Double yi : inv) {
                                if (yi != 0) {
                                    int possub = (int) project2Dplus(0, yi).getY();
                                    String labeli = ajustValue(label_y, yi);
                                    float postitle = posxdey - fontMetrics.stringWidth(labeli) - 2;
                                    if (postitle < 0) {
                                        postitle = 1;
                                    }
                                    g.drawString(labeli, postitle, possub + fontMetrics.getHeight() / 4);
                                    Shape subaxis = new Line2D.Double(posxdey, possub, posxdey - 4, possub);
                                    g.draw(subaxis);
                                }
                            }
                        }
                        String label = ajustValue(label_y, pmax.getY());
                        g.drawString(label, posxdey - fontMetrics.stringWidth(label) - 2, -getHeight() + fontMetrics.getHeight());
                        g.drawString(ajustValue(label_y, pmin.getY()), posxdey - fontMetrics.stringWidth(label) - 2, 0);
                    }
                }
                //----------TRACES Ofset dashline & ofset Labels
                if (vals.getoffset() > 0 && vals.isVisible()) {
                    g.setPaint(vals.getcurbcolor());
                    float[] dash = {1f, 5f};
                    str = new BasicStroke(1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f, dash, 0.0f);
                    g.setStroke(str);
                    //int posy2 = (int) Math.round(-1 * ((vals.getoffset() - axy[0]) * (getSize().height) - 1) / (axy[1] - axy[0]));
                    Double posy2 = -depy - (vals.getoffset() * zoomy);
                    //using "courbe" to shift dashed line
                    Shape osfaxis = new Line2D.Double(courbe, posy2, getSize().width, posy2);
                    g.draw(osfaxis);
                    g.drawString(vals.getlabel() + "(" + vals.getoffset() + ")", 0, (int) Math.round(posy2));
                }

            }
        }
        //---------- draw axis labels
        g.setPaint(Color.BLACK);


        // try sub points on axes


        // --------TRACE Borders-----------
        g.setPaint(Color.BLACK);
        str = new BasicStroke(1.0f, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER, 10.0f);
        g.setStroke(str);
        Shape point = new Rectangle2D.Double(0, -this.getHeight() + 1, getWidth() - 1, getHeight() - 1);//getWidth()-1,-getHeight()+1);
        g.draw(point);

    }

    private Double[] getroundedinterval(Double xmin, Double xmax, int nbinterv) {
        if (xmax < xmin || nbinterv < 2) {
            return null;
        }
        Double[] res = new Double[nbinterv - 1];
        Double delta = (xmax - xmin) / nbinterv;
        int exp = 0;
        if (delta < 1) {
            while (delta * Math.pow(10, exp) < 1) {
                exp++;
            }
        } else {
            while (delta * Math.pow(10, exp) < 1) {
                exp--;
            }
        }
        for (int i = 1; i < nbinterv; i++) {
            Double yi = xmin + i * delta;
            res[i - 1] = Math.round(yi * Math.pow(10, exp)) / Math.pow(10, exp);
        }
        return res;
    }

    private void drawCurbs(Graphics2D g) {
        if (main == null) {
            return;
        }
        Stroke str;
        if (getWidth() < 6 || getHeight() < 6) {
            return;
        }
        for (int courbe = 0; courbe < main.length(); courbe++) {
            Double prev_x = null;
            Double prev_y = null;
            Donnees vals = main.getcourb(courbe);
            if (vals.isVisible()) {
                for (int i = 0; i < vals.getmesures().size(); i++) {
                    /// Get point position in Panel coords system (Ys are negative(0 down) & scale=f(ranges)
                    Mesure mes = vals.getmesures().get(i);
                    if (mes != null) {
                        Point2D pt = project2Dplus(mes.getposition(), mes.getval() + vals.getoffset());
                        if (pt != null) {
                            // xd & yd for creation of squared/...curbs
                            if (prev_x == null) {
                                prev_x = pt.getX();
                            }
                            if (prev_y == null) {
                                prev_y = pt.getY();
                            }
                            //      if (this.getBounds().contains(pt)||this.getBounds().contains(xd,yd)) {
                            g.setPaint(vals.getcurbcolor());
                            str = new BasicStroke(1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f);
                            g.setStroke(str);
                            Shape curb1 = null;
                            Shape curb2 = null;
                            if (vals.gettype() == Donnees.CURB_POINTS) {
                                //point
                                curb1 = new Line2D.Double(pt.getX() - main.getptsize(), pt.getY(), pt.getX() + main.getptsize(), pt.getY());
                                curb2 = new Line2D.Double(pt.getX(), pt.getY() - main.getptsize(), pt.getX(), pt.getY() + main.getptsize());
                            } else if (vals.gettype() == Donnees.CURB_LINES) {
                                // normal
                                curb1 = new Line2D.Double(prev_x, prev_y, pt.getX(), pt.getY());
                            } else if (vals.gettype() == Donnees.CURB_SQR) {
                                //squares => change Y when change, (could change X but Y is often the mesurement)
                                curb1 = new Line2D.Double(prev_x, prev_y, pt.getX(), prev_y);
                                curb2 = new Line2D.Double(pt.getX(), pt.getY(), pt.getX(), prev_y);

                                // curb1 = new Line2D.Double(prev_x, prev_y,prev_x, pt.getY());
                                // curb2 = new Line2D.Double(pt.getX(),  pt.getY(),prev_x,pt.getY());
                            }
                            if (curb1 != null) {
                                g.draw(curb1);
                            }
                            if (curb2 != null) {
                                g.draw(curb2);
                            }
                            //--------TRACES POINTS------------------
                            if (main.isdrawpt()) {
                                if (mes.color == null) {
                                    g.setPaint(vals.getptcolor());
                                } else {
                                    g.setPaint(mes.color);
                                }
                                str = new BasicStroke(1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f);
                                g.setStroke(str);
                                if (mes.tag != null && mes.tag.compareTo("[NOSHAPE]") == 0) {
                                    mes.shape = null;
                                } else {
                                    Shape point = new Rectangle2D.Double(pt.getX() - main.getptsize(), pt.getY() - main.getptsize(), 2 * main.getptsize(), 2 * main.getptsize());
                                    if (mes.shape == null || point.getBounds().equals(mes.shape.getBounds()) == false) {
                                        mes.shape = point;
                                    }
                                    g.draw(mes.shape);
                                }
                            } else {
                                mes.shape = null;
                            }
                            //   }
                            //should not set a line at the "3Dlast"=> NOT WORKING
                            if (vals.is3D() == false) {
                                prev_x = pt.getX();
                                prev_y = pt.getY();
                            }
                        }
                    }
                }
            }
        }
    }

    private String ajustValue(String label, Double val) {
        java.text.SimpleDateFormat format;
        if (label.startsWith("[time")) {
            format = new java.text.SimpleDateFormat("HH:mm:ss.S");
        } else if (label.startsWith("[date")) {
            format = new java.text.SimpleDateFormat("yy-MM-dd");
        } else {
            String res = "" + val;
            if (res.length() > 4) {
                if (Math.abs(val) < 0.01 || Math.abs(val) > 999) {
                    java.text.NumberFormat form = new java.text.DecimalFormat("0.###E0");
                    res = form.format(val);
                } else {
                    if (val > 0) {
                        res = res.substring(0, 4);
                    } else {
                        res = res.substring(0, 5);
                    }
                }
            }
            return res;
        }
        return format.format(new java.util.Date(val.longValue()));
    }

    private void drawSelect(Graphics2D g) {
        Stroke str;
        // SelRect=new Rectangle2D.Double(150,-110,100,100);
        str = new BasicStroke(1.0f, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 10.0f);
        g.setStroke(str);
        g.setPaint(Color.LIGHT_GRAY);
        g.draw(main.getSelection());
        g.setComposite(makeComposite(0.2f));
        g.fill(main.getSelection());
        g.setComposite(makeComposite(1f));
        //------------------
    }

    @Override
    public void paintComponent(Graphics g) {
        if (g == null) {
            return;
        }
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D) g;
        g2.translate(0, this.getSize().height - 1);
        //   g2.scale(1, 1);
        if (main != null) {
            initzoom(main.getzoom());
            drawAxes(g2);

        }
        drawCurbs(g2);
        if (main == null) {
            g.drawString("line chart\r\n no courbs manager present", 10, 10);
            return;
        }
        if (main.getSelection() != null) {
            drawSelect(g2);
        }
        if (getrule() > 0) {
            g2.setPaint(Color.RED);
            g2.draw(main.getADMShapeAt("rule_point"));
        }
    }

    public void setofset(int courbe, Double ofset) {
        if (main.length() <= courbe) {
            return;
        }
        (main.getcourb(courbe)).setoffset(ofset);
        repaint();
    }

    @Override
    public void setdepx(double x) {
        depx = x;
        // this.repaint(10);
    }

    @Override
    public void setdepy(double y) {
        depy = -y;
        // this.repaint(10);
    }

    @Override
    public double getdepx() {
        return depx;
    }

    @Override
    public double getdepy() {
        return -depy;
    }

    @Override
    public Point2D project2D(double x, double y, double z) {
        //   unsupported;
        return project2D(x, z);
    }

    @Override
    public void setelevation(double elv) {
    }

    @Override
    public void setrotation(double elv) {
    }

    @Override
    public double getelevation() {
        return 0.0;
    }

    @Override
    public double getrotation() {
        return 0.0;
    }

    @Override
    public double getzoomx() {
        return zoomx;
    }

    @Override
    public double getzoomy() {
        return zoomy;
    }

    @Override
    public void setzoomx(double z, int pivotx) {
        Double z0 = zoomx;
        zoomx = z;
        depx = (z / z0) * (depx - pivotx) + pivotx;
    }

    @Override
    public void setzoomy(double z, int pivoty) {
        Double z0 = zoomy;
        zoomy = z;
        depy = (z / z0) * (depy - pivoty) + pivoty;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setBackground(new java.awt.Color(255, 255, 255));
        setLayout(new java.awt.BorderLayout());
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
