/*
 * P_Stat_P.java
 *
 * Created on 23 mai 2007, 14:23
 */
package com.jdcm.charts;

import com.jdcm.common.D_Utils;
import com.jdcm.eltrx.*;

/**
 *
 * @author  Marc GIBOIN
 */
public class P_Stat_P extends javax.swing.JPanel {
    // for serializable interface
    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
     private final java.util.List<String> curbs;
    private final static int CENTER = 0;
    private final static int MAX = 2;
    private final static double MIN = 0.1;
    private final static int MAXSIZE = 1400;
    
    private I_Port Parent;
   
    // for the traffic cab
    private F_Terminal trafficpanel = null;

    public P_Stat_P(C_Main m) {
        initComponents();
        p_Chartplus2.setEditTree(false);
        p_Chartplus2.setAxis(com.jdcm.charts.P_Chartplus.AXIS_ONLYX);
        trafficpanel = new F_Terminal(m);
        jTabbedPane1.add((javax.swing.JPanel) trafficpanel.getRootPane().getContentPane(), 0);
        jTabbedPane1.setTitleAt(0, "Traffic");
        jTabbedPane1.setSelectedIndex(0);
        trafficpanel.setlockedin(true);
        TUtils.addTabedPane2Frame(this.jTabbedPane1);
        curbs = new java.util.ArrayList<>();
        for (I_Port p : m.getPorts()) {
            curbs.add(p.getPortName());
        }
        initcourb();
    }

    public P_Stat_P(I_Port P) {
        Parent = P;
        initComponents();
        p_Chartplus2.setEditTree(false);
        p_Chartplus2.setAxis(com.jdcm.charts.P_Chartplus.AXIS_ONLYX);
        curbs = java.util.Arrays.asList("ADM", "states", "avalable", "interface", "main");
        trafficpanel = new F_Terminal(Parent.getConsole());
        jTabbedPane1.add((javax.swing.JPanel) trafficpanel.getRootPane().getContentPane(), 0);
        //trafficpanel.se;
        jTabbedPane1.setTitleAt(0, "Traffic");
        jTabbedPane1.setSelectedIndex(0);
        trafficpanel.setlockedin(true);
        TUtils.addTabedPane2Frame(this.jTabbedPane1);
        initcourb();
    }

    private void initcourb() {
        for (int i = 0; i < curbs.size(); i++) {
            Double d = 4 * (new Double(i));

            int idx = p_Chartplus2.addcourbe(new String[]{"time", curbs.get(i)}, null, null, null, 2, d, curbs.get(i));//0.0=>i
            long start = System.currentTimeMillis();
            p_Chartplus2.addval(idx, start - 2, CENTER + MAX, "initialisation");
            p_Chartplus2.addval(idx, start - 1, CENTER - MAX, "initialisation");
            p_Chartplus2.addval(idx, start, CENTER, "initialisation");
            // p_Chartplus2.setscroll(true);
        }
    }

    public void setStatsColumns(String type) {
        if(type.endsWith("Stacks")){
        trafficpanel.setColumn("Dir.", true);
        trafficpanel.setColumn("Stacks", true);
        trafficpanel.setColumn("Data (ascii)", false);
        }else  if(type.endsWith("Matr.")){
           trafficpanel.setColumn("Dst.", true); 
           trafficpanel.setColumn("Data (ascii)", false); 
        }else  if(type.endsWith("Main")){
             trafficpanel.setColumn("Dir.", true);
        }
    }

    public void addPort(I_Port p) {
        int i = p_Chartplus2.getcourbsSize();
        Double d = 4 * (new Double(i));
        int idx = p_Chartplus2.addcourbe(new String[]{"time", p.getPortName()}, null, null, null, 2, d, p.getPortName());//0.0=>i
        long start = System.currentTimeMillis();
        p_Chartplus2.addval(idx, start - 2, CENTER + MAX, "initialisation");
        p_Chartplus2.addval(idx, start - 1, CENTER - MAX, "initialisation");
        p_Chartplus2.addval(idx, start, CENTER, "initialisation");
    }

    public void changePortName(I_Port p) {
        p_Chartplus2.getcourb(p.getIndex()).setlabel(p.getPortName());
    }
/**
 * 
 * @param datas
 * @param isext if packet commes from exterior
 */
    public void store(com.jdcm.common.C_Packet datas, boolean isext) {
        if (datas != null) {
            com.jdcm.common.C_Packet c = (com.jdcm.common.C_Packet) datas.clone();
            if (isext) {
                c.setsource(null);//-2
            }
            trafficpanel.write(c);
        }
    }
    public void store(com.jdcm.common.C_Packet datas) {
            trafficpanel.write(datas);
    }
    /**
     * Store cumul value in the courbs
     * 
     * @param commment comment registred
     * @param packsize nb of bytes
     * @param curbname courb ame writtiong/reading/... states
     */
    public void store(String curbname, int packsize, String commment) {
        /* if (value != null) {
        String label=""+value.getClass().getSimpleName();
        if (value.getClass().isArray()){
        label=label+"["+java.lang.reflect.Array.getLength(value)+"]";
        }else if (value instanceof Number){
        label=""+value.toString();
        }*/
        if (packsize == -1) {
            // to aoid Exceptions...
            packsize = 1;
        }
        if (packsize > MAXSIZE) {
            packsize = MAXSIZE;
        } else if (packsize < -MAXSIZE) {
            packsize = -MAXSIZE;
        }
        double size = ((double) MAX * packsize / MAXSIZE);
        if (size >= 0 && size < MIN) {
            size = MIN;
        } else if (size < 0 && size > -MIN) {
            size = -MIN;
        }
        double nb = CENTER + size;
        long time = System.currentTimeMillis();
        p_Chartplus2.addval(curbname, time, nb, commment);
        p_Chartplus2.addval(curbname, time + 1, CENTER, "");

    }

    /**
     * Store cumul value in the courbs
     * @param txt comment registred
     */
    public void store(String txt) {
        p_Chartplus2.addval("states", System.currentTimeMillis(), 2 * CENTER, "" + txt);
        p_Chartplus2.addval("states", System.currentTimeMillis() + 10, 0, "" + txt);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        p_Chartplus2 = new com.jdcm.charts.P_Chartplus();

        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.BorderLayout());
        jPanel1.add(p_Chartplus2, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Graph", jPanel1);

        add(jTabbedPane1, java.awt.BorderLayout.CENTER);
        jTabbedPane1.getAccessibleContext().setAccessibleName("Data");
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private com.jdcm.charts.P_Chartplus p_Chartplus2;
    // End of variables declaration//GEN-END:variables
}
