/*
 * P_Stat_RS.java
 *
 * Created on 23 mai 2007, 13:18
 */
package com.jdcm.charts;

import com.jdcm.eltrx.*;
import java.awt.*;
import javax.swing.*;

/**
 * Show Serial(RS232) events on a graph
 *
 * @author Marc GIBOIN
 */
public class P_Stat_RS extends javax.swing.JPanel {

    private static final long serialVersionUID = 1L;
    /**
     * Creates new form P_Stat_RS
     */
    private final JLabel[] lights;
    private final C_Port Parent;
    private Color defaulbacktcolor = null;
    private Color defaulforcolor = null;
    

    /**
     * Creates new form F_Stats_RS
     * @param P the port managing serial slave
     */
    public P_Stat_RS(C_Port P) {
        Parent = P;
        initComponents();
        p_Chartplus1.setEditTree(false);
        p_Chartplus1.setAxis(P_Chartplus.AXIS_ONLYX);
        defaulbacktcolor = jPanel2.getBackground();
        defaulforcolor = jCheckBox28.getForeground();
        lights = getLights();
    }

    public void initcourbs() {
        double oft =  1;
        for (JLabel light : lights) {
            //.getToolTipText();
            String label = light.getText(); //.getToolTipText();
            p_Chartplus1.addcourbe(new String[]{"time", ""}, null, null, null, 1, oft, label);
            p_Chartplus1.getcourb(label).settype(2);
            oft=oft+2.0;
        }
        setLightActive(Parent.isslrunning());
        p_Chartplus1.setzoom(new java.awt.geom.Rectangle2D.Double(0.0, -1.0, 1.0, 1.0+oft));
        p_Chartplus1.setZoomYFix(true);
        p_Chartplus1.setscroll(true);
    }

    public void setUARTType(String txt) {
        jLabel1.setText(txt);
    }

    public void setLightActive(boolean bool) {
        for (JLabel light : lights) {
            light.setEnabled(bool);
        }
        java.awt.Color couleur = defaulforcolor;
        if (bool) {
            couleur = defaulforcolor.brighter().brighter();
        }
        jCheckBox28.setForeground(couleur);
        jCheckBox30.setForeground(couleur);
        jToggleButton1.setForeground(couleur);
        p_Chartplus1.setscroll(bool);
        /*jCheckBox28.setEnabled(bool);
         jCheckBox30.setEnabled(bool);
         jToggleButton1.setEnabled(bool);*/
    }

    private boolean isDTSRTSequals() {
        return jToggleButton1.isSelected();
    }

    private void setDTSRTSequals(boolean bool) {
        if (bool != isDTSRTSequals()) {
            jToggleButton1.setSelected(bool);
        }
        java.awt.Color couleur = defaulbacktcolor;
        if (bool) {
            couleur = java.awt.Color.GREEN;
        }
        if (bool) {
            Parent.setRS_RTS(Parent.isRS_DTR());
        }
        jCheckBox28.setBackground(couleur);
        jCheckBox30.setBackground(couleur);
        jToggleButton1.setBackground(couleur);
    }

    public boolean isDTR() {
        return jCheckBox28.isSelected();
    }

    public void setDTR(boolean bool) {
        jCheckBox28.setSelected(bool);
    }

    public boolean isRTS() {
        return jCheckBox30.isSelected();
    }

    public void setRTS(boolean bool) {
        jCheckBox30.setSelected(bool);
    }

    public void setlight(String name, boolean ison, String comment) {
        for (JLabel light : lights) {
            if (light.getText().compareTo(name) == 0) {
                if (ison) {
                    light.setBackground(Color.GREEN);
                } else {
                    light.setBackground(defaulbacktcolor);
                }
                storeSignal(ison, light.getText(), comment);
                if (name.compareTo("RTS") == 0) {
                    setRTS(ison);
                }
                if (name.compareTo("DTR") == 0) {
                    setDTR(ison);
                }
                return;
            }
        }
    }

    private JLabel[] getLights() {
        java.util.List<JLabel> labels = new java.util.ArrayList<>();
        for (int i = 0; i < jPanel2.getComponentCount(); i++) {
            if (jPanel2.getComponent(i) instanceof JLabel) {
                JLabel label = (JLabel) jPanel2.getComponent(i);
                if (label.getBorder() != null) {
                    labels.add(label);
                }
            }
        }
        return labels.toArray(new JLabel[]{});
        //JLabel[] res=new JLabel[labels.size()];
        // for (int j=0;j<labels.size();j++){res[j]= labels.get(j);}
        // return res;
    }

    public void storeSignal(boolean bool, String lbl, String comment) {
        int value = 0;
        if (bool) {
            value = 1;
        }
        String detail = lbl;
        if (lbl.compareTo("D") == 0 && value == 1) {
            detail = detail + "/" + Parent.available();
        }
        if (comment == null) {
            comment = "";
        }
        //+1 due to ADM??
        p_Chartplus1.addval(lbl, System.currentTimeMillis(), value, "Signal : " + detail + " " + comment);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jLabel27 = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLabel29 = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        jLabel24 = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        jLabel28 = new javax.swing.JLabel();
        jLabel31 = new javax.swing.JLabel();
        jCheckBox28 = new javax.swing.JCheckBox();
        jCheckBox30 = new javax.swing.JCheckBox();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        p_Chartplus1 = new com.jdcm.charts.P_Chartplus();

        setLayout(new java.awt.BorderLayout());

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        jLabel27.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel27.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel27.setText("OE");
        jLabel27.setToolTipText("OverrunError");
        jLabel27.setAlignmentX(0.5F);
        jLabel27.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel27.setOpaque(true);
        jPanel2.add(jLabel27);

        jLabel26.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel26.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel26.setText("BI");
        jLabel26.setToolTipText("BreakInterrupt");
        jLabel26.setAlignmentX(0.5F);
        jLabel26.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel26.setOpaque(true);
        jPanel2.add(jLabel26);

        jLabel20.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel20.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel20.setText("FE");
        jLabel20.setToolTipText("FramingError");
        jLabel20.setAlignmentX(0.5F);
        jLabel20.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel20.setOpaque(true);
        jPanel2.add(jLabel20);

        jLabel21.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel21.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel21.setText("PE");
        jLabel21.setToolTipText("ParityError");
        jLabel21.setAlignmentX(0.5F);
        jLabel21.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel21.setOpaque(true);
        jPanel2.add(jLabel21);

        jLabel22.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel22.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel22.setText("DCD");
        jLabel22.setToolTipText("109-CarrierDetect");
        jLabel22.setAlignmentX(0.5F);
        jLabel22.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel22.setOpaque(true);
        jPanel2.add(jLabel22);

        jLabel29.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel29.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel29.setText("RTS");
        jLabel29.setToolTipText("105-Request To Send");
        jLabel29.setAlignmentX(0.5F);
        jLabel29.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel29.setOpaque(true);
        jPanel2.add(jLabel29);

        jLabel23.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel23.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel23.setText("CTS");
        jLabel23.setToolTipText("106-Clear to send");
        jLabel23.setAlignmentX(0.5F);
        jLabel23.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jLabel23.setOpaque(true);
        jPanel2.add(jLabel23);

        jLabel30.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel30.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel30.setText("DTR");
        jLabel30.setToolTipText("108.2-Data Terminal Ready");
        jLabel30.setAlignmentX(0.5F);
        jLabel30.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel30.setOpaque(true);
        jPanel2.add(jLabel30);

        jLabel24.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel24.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel24.setText("DSR");
        jLabel24.setToolTipText("107-Data set ready.");
        jLabel24.setAlignmentX(0.5F);
        jLabel24.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel24.setOpaque(true);
        jPanel2.add(jLabel24);

        jLabel25.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel25.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel25.setText("RI");
        jLabel25.setToolTipText("125-RingIndicator");
        jLabel25.setAlignmentX(0.5F);
        jLabel25.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel25.setOpaque(true);
        jPanel2.add(jLabel25);

        jLabel28.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel28.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel28.setText("DRX");
        jLabel28.setToolTipText("DATA Received");
        jLabel28.setAlignmentX(0.5F);
        jLabel28.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel28.setOpaque(true);
        jPanel2.add(jLabel28);

        jLabel31.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel31.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel31.setText("OBE");
        jLabel31.setToolTipText("Output Buffer Empty");
        jLabel31.setAlignmentX(0.5F);
        jLabel31.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        jLabel31.setOpaque(true);
        jPanel2.add(jLabel31);

        jCheckBox28.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jCheckBox28.setText("DTR");
        jCheckBox28.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox28.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox28.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox28ActionPerformed(evt);
            }
        });
        jPanel2.add(jCheckBox28);

        jCheckBox30.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jCheckBox30.setText("RTS");
        jCheckBox30.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox30.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox30ActionPerformed(evt);
            }
        });
        jPanel2.add(jCheckBox30);

        jToggleButton1.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jToggleButton1.setText("=");
        jToggleButton1.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jToggleButton1);

        jToggleButton2.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jToggleButton2.setSelected(true);
        jToggleButton2.setText("||");
        jToggleButton2.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jPanel2.add(jToggleButton2);

        jButton1.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jButton1.setText("X");
        jButton1.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton1);

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel1.setText("-UART-");
        jLabel1.setToolTipText("uart definition");
        jPanel2.add(jLabel1);

        add(jPanel2, java.awt.BorderLayout.NORTH);

        p_Chartplus1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        add(p_Chartplus1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jCheckBox30ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox30ActionPerformed
        Parent.setRS_RTS(jCheckBox30.isSelected());
        if (isDTSRTSequals()) {
            Parent.setRS_DTR(jCheckBox30.isSelected());
        }
    }//GEN-LAST:event_jCheckBox30ActionPerformed

    private void jCheckBox28ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox28ActionPerformed
        Parent.setRS_DTR(jCheckBox28.isSelected());
        if (isDTSRTSequals()) {
            Parent.setRS_RTS(jCheckBox28.isSelected());
        }
    }//GEN-LAST:event_jCheckBox28ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        setDTSRTSequals(isDTSRTSequals());
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        p_Chartplus1.setscroll(jToggleButton2.isSelected());
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        p_Chartplus1.removealldata(false);
    }//GEN-LAST:event_jButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JCheckBox jCheckBox28;
    private javax.swing.JCheckBox jCheckBox30;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private com.jdcm.charts.P_Chartplus p_Chartplus1;
    // End of variables declaration//GEN-END:variables
}
