/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.common;

import com.jdcm.eltrx.C_Port;
import java.util.Objects;

/**
 *
 * @author sandrine
 */
public class C_Eventdef {

    private java.lang.reflect.Method method = null;
    private String methodName = null;
    private String srcName = null;
    private Object src = null;
    private Object parametres = null;

    public C_Eventdef(Object source, java.lang.reflect.Method methode, Object params) {
        method = methode;
        src = source;
        parametres = params;
    }

    public C_Eventdef(String srcobj, String meth, Object pars) {
        methodName = meth;
        srcName = srcobj;
        parametres = pars;
    }

    public C_Eventdef(Object pars) {
        methodName = null;
        srcName = null;
        parametres = pars;
    }

    public XMLres getXMLformat() {
        XMLres res = new XMLres("C_Eventdef");
        if (src != null || srcName != null) {
            res.addAttrVal("src");
            if (src != null) {
                res.setAttrVal("src", src);
            } else {
                res.setAttrVal("src", srcName);
            }
        }
        if (method != null || methodName != null) {
            res.addAttrVal("method");
            if (method != null) {
                res.setAttrVal("method", method.getName());
            } else {
                res.setAttrVal("method", methodName);
            }
        }
        res.addAttrVal("parametres");
        res.setAttrVal("parametres", parametres);
        return res;
    }

    public Object getSrc() {
        if (src == null) {
            return srcName;
        } else {
            return src;
        }
    }

    public String getMethodName() {
        return methodName;
    }

    public java.lang.reflect.Method getMethod() {
        return method;
    }

    public Object getParams() {
        return parametres;
    }

    /**
     * Compare receive Object to see if it 'match' with this event
     *
     *
     * @param o Object receeived to compre to this
     * /SRC ... should be overwrited in something like T_CONF
     * @return
     */
    @Override
    public boolean equals(Object o) {
        if (o instanceof C_Eventdef) {
            C_Eventdef e = (C_Eventdef) o;

            boolean portok = false;
            if (getSrc() != null && getSrc().toString().endsWith("/SRC")) {
                if (e.getSrc() instanceof com.jdcm.eltrx.C_Port) {
                    String rcvName = ((com.jdcm.eltrx.C_Port) e.getSrc()).getPortName();
                    if (rcvName.indexOf("_") > 0) {
                        String radicalevt = getSrc().toString().substring(0, getSrc().toString().length() - "/SRC".length());
                        // String radicalrcvd=rcvd;
                        portok = rcvName.substring(0, rcvName.indexOf("_")).compareTo(radicalevt) == 0;
                    }
                }
            }
            if (portok == false && src != null && e.src != null) {
                portok = src == e.src;
            } else if (portok == false && srcName != null && e.srcName != null) {
                portok = srcName.compareTo(e.srcName) == 0;
            }
            if (portok == false && e.srcName != null && src instanceof com.jdcm.eltrx.I_Command) {
                portok = ((com.jdcm.eltrx.I_Command) src).getCMDName().compareTo(e.srcName) == 0;
            }
            if (portok == false && srcName != null && e.src != null) {
                if (e.src instanceof com.jdcm.eltrx.I_Command) {
                    portok = ((com.jdcm.eltrx.I_Command) e.src).getCMDName().compareTo(srcName) == 0;
                } else {
                    portok = srcName.compareTo(e.src.toString()) == 0;
                }
            }
            if (src == null && e.src == null && srcName == null && e.srcName == null) {
                portok = true;
            }
            if (portok == false && srcName != null && srcName.endsWith("/X") && e.src instanceof C_Port) {
                if (((C_Port) e.src).getListener() != null) {
                    portok = srcName.compareTo(((C_Port) e.src).getListener().getPortName() + "/X") == 0;
                } else {
                    portok = (((C_Port) e.src).getPortName()).startsWith(srcName.substring(0, srcName.length() - 2));
                }
            }
            if (portok) {
                if (e.method == method && method != null) {
                    return compare(e.parametres, parametres);
                } else if (e.method == null && method == null && methodName == null && e.methodName == null) {
                    return compare(e.parametres, parametres);
                } else if (methodName != null && e.method != null && e.methodName == null) {
                    return e.method.getName().compareTo(methodName) == 0 && compare(e.parametres, parametres);
                } else if (method != null && e.methodName != null && methodName == null) {
                    return method.getName().compareTo(e.methodName) == 0 && compare(e.parametres, parametres);
                } else if (method == null && methodName != null && e.getMethodName() != null
                        && e.methodName.compareTo(methodName) == 0) {
                    return compare(e.parametres, parametres);
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } else {
            return compare(o, parametres);
        }
    }

    /**
     * automatly set with equal, no needs ?
     *
     * @return
     */
    @Override
    public int hashCode() {
        int hash = 7;
        hash = 43 * hash + Objects.hashCode(this.method);
        hash = 43 * hash + Objects.hashCode(this.methodName);
        hash = 43 * hash + Objects.hashCode(this.srcName);
        hash = 43 * hash + Objects.hashCode(this.src);
        hash = 43 * hash + Objects.hashCode(this.parametres);
        return hash;
    }

    /**
     * Compare 2 object to see if theyare equal check with arrays (byte[])
     *
     * @param obj1 the first Object to compare
     * @param obj2 the second Object to compare
     * @return
     */
    private boolean compare(Object obj1, Object obj2) {
        if (obj1.equals("%") || obj2.equals("%")) {
            return true;
        } else if (obj1.getClass().isArray() && obj2.getClass().isArray()) {
            if (java.lang.reflect.Array.getLength(obj1) != java.lang.reflect.Array.getLength(obj2)) {
                return false;
            }
            for (int i = 0; i < java.lang.reflect.Array.getLength(obj1); i++) {
                if (java.lang.reflect.Array.get(obj1, i).equals(java.lang.reflect.Array.get(obj2, i)) == false) {
                    return false;
                }
            }
            return true;
        } else if (obj1.getClass().isArray() == false && obj2.getClass().isArray() == false) {
            return obj1.equals(obj2);
        } else {
            return false;
        }

    }

    @Override
    public String toString() {
        String p = "";
        if (parametres == null) {
        } else if (parametres.getClass().isArray()) {
            for (int i = 0; i < java.lang.reflect.Array.getLength(parametres) && i < 10; i++) {
                try {
                    p += java.lang.reflect.Array.get(parametres, i) + ",";
                } catch (IllegalArgumentException | ArrayIndexOutOfBoundsException ex) {
                    System.out.println("reflect parametres Pb =>"+ex );
                }
            }
            if (p.length() > 1) {
                p = p.substring(0, p.length() - 1);
            }
            p = "[" + p + "]";
        } else {
            p = parametres.toString();
        }
        if (getMethod() != null) {
            return "<=[" + getSrc() + "." + getMethod().getName() + "(" + p + ")]";
        } else {
            if (this.getMethodName() != null) {
                return "<=[" + getSrc() + "." + getMethodName() + ",(" + p + ")]";
            } else {
                if (parametres == null) {
                    return "=>Empty";
                }
                return "<=[" + p + "]";
            }
        }
    }
}
