package com.jdcm.common;
/*
 * C_Format.java
 *
 * Created on 16 juillet 2004, 09:27
 */

import com.jdcm.eltrx.*;
import java.io.UnsupportedEncodingException;
import java.lang.Math.*;

/**
 * USe to display/change byte <=> String
 *
 * @author Marc GIBOIN
 */
public class C_Format {

    D_Debug TDeb;
    D_Utils TUtils = new D_Utils();
    // fourni les explication d'un type
    private boolean libelle;
    // buffer en INT (repesentant TOUJOURS des Byte de 0 a 256 !!!! )
    // posib . : Integer
    private int[] buffer;
    // chaine destinee a etre codee
    private String value;
    // TODO : WHY??
    public boolean BMap_Activ = false;
    public boolean[] BMap = new boolean[129];
    /**
     * position of the first byte of the buffer to decode
     */
    private int Offset;
    /**
     * the size of the data to analyse (from offset)
     */
    private int taille;
    /**
     * the type of the data to analyse
     */
    private String type;

    /**
     * Creates a new instance of Buffer
     */
    public C_Format() {

        TDeb = new D_Debug("Formate");
        this.libelle = false;
    }

    public void setvalue(String val) {
        value = val;
    }

    public void setbuffer(byte[] buff) {
        // transcription de byte en int car FORMAT est en int !!!why!!!
        if (buff == null) {
            return;
        }
        //   buffer = buff;
        buffer = new int[buff.length];
        for (int i = 0; i < buff.length; i++) {
            int a = buff[i];
            if (a >= 0) {
                buffer[i] = a;
            } else {
                buffer[i] = 256 + a;
            }
        }
        taille = buff.length;
    }

    public void setlibelle(boolean bool) {
        this.libelle = bool;
    }

    /**
     * convert bytes in an apropriate type to be understood
     *
     * @param Typ type of bytes to return type are
     * (ASCII,ASCII_7,DEC,DEC_I,BCD,BCD_I,BYTE,...)
     * @return a string that represent bytes in the apropriate type
     * (ASCII,hex,..)
     */
    public String B_Retire(String Typ) {
        if (Typ == null) {
            TDeb.wri("Error : Type is Null can not get equivalent String");
            return null;
        }
        Offset = 0;
        type = Typ;
        String valeur = "";
        if (taille + Offset > buffer.length) {
            return null;
        }
        if (taille > 0) {
            if (Typ.startsWith("BIT:")) {
                valeur = B_F_BIT(Typ.substring(3));
            } else if (Typ.startsWith("DEC:")) {
                valeur = B_F_DEC(Typ.substring(3));
            }
            /*   if (Typ.compareTo("BIT:4-8") == 0) {
             valeur = B_F_SUB48();
             }*/
            if (Typ.compareTo("BYTE") == 0) {
                valeur = B_F_BYTE();
            } else if (Typ.compareTo("LONG") == 0) {
                valeur = B_F_LONG();
            } else if (Typ.compareTo("BCD") == 0) {
                valeur = B_F_BCD();
            } else if (Typ.compareTo("EBCDIC") == 0) {
                valeur = B_F_EBCDIC();
            } else if (Typ.compareTo("BCD_O") == 0) {
                valeur = B_F_BCD_O();
            } else if (Typ.compareTo("BCD_B") == 0) {
                valeur = B_F_BCD_B();
            } else if (Typ.compareTo("BCD_I") == 0) {
                valeur = B_F_BCD_I();
            } else if (Typ.compareTo("DEC") == 0) {
                valeur = B_F_DEC();
            } else if (Typ.compareTo("DEC_I") == 0) {
                valeur = B_F_DEC_I();
            } else if (Typ.compareTo("DEC_B") == 0) {
                valeur = B_F_DEC_B();
            } else if (Typ.compareTo("DEC_BI") == 0) {
                valeur = B_F_DEC_BI();
            } else if (Typ.compareTo("ASCII") == 0) {
                valeur = B_F_ASCII();
            } else if (Typ.compareTo("ASCII_TRIM") == 0) {
                valeur = B_F_ASCII().trim();
            } else if (Typ.compareTo("ASCII_0") == 0) {
                valeur = B_F_ASCII_0();
            } else if (Typ.compareTo("ASCII_7") == 0) {
                valeur = B_F_ASCII_7();
            } else if (Typ.compareTo("BOOL") == 0) {
                valeur = B_F_BOOL();
            } else if (Typ.compareTo("BM") == 0) {
                valeur = B_F_BM();
            } else if (Typ.compareTo("TCPL") == 0) {
                valeur = B_F_TCPL();
            }
            if (valeur.compareTo("") == 0) {
                TDeb.wri("=>B_retire value not found for type:[" + Typ + "] for: " + TUtils.tabTostr(buffer, ",".charAt(0)));
            }

        }
        return valeur;

    }

    public byte[] B_Prend(String Typ) {
        if (Typ == null) {
            TDeb.wri("Error : Type is Null convert : " + this.value + " to byte[] ");
            return null;
        }
        this.Offset = 0;
        this.type = Typ;
        byte[] buf = null;
        if (Typ.compareTo("ASCII") == 0) {
            buf = B_G_ASCII();
        } else if (Typ.compareTo("A2HX") == 0) {
            buf = B_G_A2HX();
        } else if (Typ.compareTo("BYTE") == 0) {
            buf = B_G_BYTE();
        } else if (Typ.compareTo("BOOL") == 0) {
            buf = B_G_BOOL();
        } else if (Typ.compareTo("DEC") == 0) {
            buf = B_G_DEC();
        } else if (Typ.compareTo("INT") == 0) {
            buf = B_G_INT();
        } else if (Typ.compareTo("BCD") == 0) {
            buf = B_G_BCD();
        } else if (Typ.compareTo("DEC_I") == 0) {
            buf = B_G_DEC_I();
        } else if (Typ.compareTo("EBCDIC") == 0) {
            buf = B_G_EBCDIC();
        }

        if (buf == null) {
            TDeb.wri("=>B_Prend valeure non trouv�e:[" + Typ + "] for: " + value);
        }

        return buf;

    }

    public Object C_To_Object(String cl, String format) {
        Object res = null;
        if (cl == null) {
            return value;
        }
        if (cl.length() == 0) {
            return value;
        }
        if (cl.compareTo("Timestamp") == 0) {
            res = C_F_TIMESTAMP(format);
        }
        if (cl.compareTo("Date") == 0) {
            res = C_F_DATE(format);
        }
        if (cl.compareTo("Time") == 0) {
            res = C_F_TIME(format);
        }
        if (cl.compareTo("Boolean") == 0) {

            if (value.toLowerCase().compareTo("true") == 0 || value.compareTo("1") == 0) {
                if (format.compareTo("INV") == 0) {
                    res = Boolean.FALSE;
                } else {
                    res = Boolean.TRUE;
                }
            } else {
                if (format.compareTo("INV") == 0) {
                    res = Boolean.TRUE;
                } else {
                    res = Boolean.FALSE;
                }
            }

        }
        if (cl.compareTo("Integer") == 0) {
            res = C_F_INTEGER(format);
        }
        // choosed to use java.Date ??? if (cl.compareTo("Time")==0){res=C_F_TIME(format);}
        if (cl.compareTo("Long") == 0) {
            res = C_F_LONG();
        }
        if (cl.compareTo("String") == 0) {
            res = value;
        }
        return res;
    }

    public String C_From_Object(Class<?> cl, Object obj, String format) {
        String res = null;
        if (cl == java.sql.Timestamp.class) {
            res = C_G_TIMESTAMP(obj, format);
        }
        if (cl == java.lang.String.class) {
            res = value;
        }
        return res;
    }

    public void BM_Clear() {
        BMap_Activ = false;
        for (int i = 0; i < 129; i++) {
            BMap[i] = false;
        }
    }

    /**
     * Return buffer byte[] value of the String
     */
    private byte[] B_G_BYTE() {
        if (libelle) {
            return "0a 10=>{0x0a,0x10}".getBytes();
        }
        try {
            return TUtils.string2byte(value);
        } catch (Exception exe) {
            return null;
        }
    }

    private byte[] B_G_BCD() {
        if (libelle) {
            return "123 =01 23".getBytes();
        }
        byte[] buf = new byte[0];
        String val = value.trim();
        if (2 * (val.length() / 2) != val.length()) {
            val = "0" + val;
        }
        for (int i = 0; i < val.length(); i = i + 2) {
            int valint = 0;
            try {
                valint = Integer.parseInt(val.substring(i, i + 2), 16);
            } catch (NumberFormatException ex) {
                TDeb.wri("Bad integer value : " + val.substring(i - 2, i) + " for BCD");
            }
            byte[] buffint = new byte[1];
            if (valint < 128) {
                buffint[0] = (byte) valint;
            } else {
                buffint[0] = (byte) (valint - 256);
            }
            buf = TUtils.addtab(buf, buffint);
        }
        return buf;
    }

    /**
     * "01"=>{0x30,0x31}
     *
     * @return array of bytes of the string (as Locale)
     */
    private byte[] B_G_ASCII() {
        if (libelle) {
            return "classique : 01=>{0x30,0x31}".getBytes();
        }
        return value.getBytes();
    }

    /**
     * xc1x34=>{0xc1,0x34}
     *
     * @return array of bytes of the string (as hexastring)
     */
    private byte[] B_G_A2HX() {
        if (libelle) {
            return "classique : xc1x34=>{0xc1,0x34}".getBytes();
        }
        try {
            return TUtils.string2byte(value);
        } catch (Exception exe) {
            return null;
        }
    }

    /**
     * true=>0x01;false=>0x00
     *
     * @return array of bytes of the string (as boolean)
     */
    private byte[] B_G_BOOL() {
        if (libelle) {
            return "true=>0x01;false=>0x00".getBytes();
        }
        byte[] b_result = new byte[1];
        int b_data = buffer[Offset];
        if (value.toUpperCase().trim().compareTo("TRUE") == 0) {
            b_result[0] = 1;
        } else {
            b_result[0] = 0;
        }
        return b_result;
    }

    /**
     * 500=>{0x01,0xF4}; <0=> null
     *
     * @return array of bytes of the string (as Integer)
     */
    private byte[] B_G_DEC() {
        if (libelle) {
            return "500=>{0x01,0xf4}; <0=>??".getBytes();
        }
        int res;
        int valint;
        try {
            valint = Integer.parseInt(value);
        } catch (NumberFormatException ex) {
            TDeb.wri("Bad integer value : " + value + " for DEC");
            return null;
        }
        if (valint < 0) {
            return null;
        }
        int t = 1;
        while ((int) java.lang.Math.pow(256, t) <= valint) {
            t++;
        }
        byte[] result = new byte[t];
        //   byte[] resultinv = new byte[t];
        for (int i = 0; i < t; i++) {
            res = (valint / ((int) java.lang.Math.pow(256, t - i - 1)));
            valint = valint - (res * (int) java.lang.Math.pow(256, t - i - 1));
            if (res < 128) {
                result[i] = (byte) res;
            } else {
                result[i] = (byte) (res - 256);
            }
            //       resultinv[t - i - 1] = result[i];
        }

        return result;
    }

    /**
     * 500=>{0x00,0x00,0x01,0xF4}; <0=> {0x8X,0xXX,0xYY,0xZZ}
     *
     * @return array of 4 (+-2^64)bytes of long)
     */
    private byte[] B_G_INT() {
        if (libelle) {
            return "500=>{0x00,0x00,0x01,0xf4}; <0=> {0x8X,0xXX,0xYY,0xZZ}".getBytes();
        }
        int res;
        int valint = 0;
        boolean isneg = false;
        try {
            valint = Integer.parseInt(value);
        } catch (NumberFormatException ex) {
            TDeb.wri("Bad integer value : " + value + " for INT");
        }
        if (valint < 0) {
            isneg = true;
            valint = Integer.MAX_VALUE + valint + 1;
            byte a = Byte.MAX_VALUE;
        }
        int t = Integer.SIZE / 8;
        byte[] result = new byte[t];
        //   byte[] resultinv = new byte[t];
        for (int i = 0; i < t; i++) {
            res = (valint / ((int) java.lang.Math.pow(256, t - i - 1)));
            valint = valint - (res * (int) java.lang.Math.pow(256, t - i - 1));
            if (res < 128) {
                result[i] = (byte) res;
            } else {
                result[i] = (byte) (res - 256);
            }
            //      resultinv[t - i - 1] = result[i];
        }
        if (isneg) {
            result[0] = (byte) (result[0] + (byte) 0x80);
        }
        return result;
    }

    /**
     * 500=>{0x01,0xF4}=>{0xf4,01}; <0=> null
     *
     * @return array of bytes of the string (as Integer)
     */
    private byte[] B_G_DEC_I() {
        if (libelle) {
            return "500=>{0x01,0xf4}=>{0xf4,01} <0=> null ".getBytes();
        }
        byte[] result = B_G_DEC();
        if (result == null) {
            return null;
        }
        byte[] resultinv = new byte[result.length];
        for (int i = 0; i < result.length; i++) {
            resultinv[result.length - i - 1] = result[i];
        }
        return resultinv;
    }

    /**
     * Return String value of the Buffer byte[]
     */
    private String B_F_ASCII() {
        if (libelle) {
            return "classique : 0x30 0x31=>01";
        }
        String result = "";

        for (int i = Offset; i < Offset + taille; i++) {
            if (buffer[i] < 32) {
                result = result + ".";
            } else {
                result = result + (char) buffer[i];
            }
        }
        return result;
    }

    /**
     * sans bourrage a 0x00: {0x00,0x30,0x31,0x00}=>"01\"
     *
     * @return string
     */
    private String B_F_ASCII_0() {
        if (libelle) {
            return "classique sans bourrage a 0x00: {0x00,0x30,0x31,0x00}=>\"01\"";
        }
        String result = "";

        for (int i = Offset; i < Offset + taille; i++) {
            if (buffer[i] < 32) {
                if (buffer[i] != 0) {
                    result = result + ".";
                }
            } else {
                result = result + (char) buffer[i];
            }
        }
        return result;
    }

    private String B_F_ASCII_7() {
        if (libelle) {
            return " enleve le 8eme byte 0x85=>0x05 Ex : banierres transpac (buffer)";
        }
        String b_result = "";
        int b_val;
        for (int i = Offset; i < Offset + taille; i++) {
            if (buffer[i] < 127) {
                b_val = buffer[i];
            } else {
                b_val = buffer[i] - 128;
            }
            // rend imprimable
            if (b_val < 32) {
                b_result = b_result + ".";
            } else {
                b_result = b_result + (char) b_val;
            }
        }
        return b_result;
    }

    private String B_F_DEC(String posstr) {
        String result = "";
        if (libelle) {
            return "Ex if BIT:1-4; C2 => 12 ";
        }
        if (posstr.startsWith(":") && posstr.indexOf("-") != -1) {
            int pos1 = new Integer(posstr.substring(1, posstr.indexOf("-")));
            int pos2 = new Integer(posstr.substring(posstr.indexOf("-") + 1));
            if (8 * buffer.length < pos2) {
                return null;
            }
            String bitstr = "";
            for (int i = 0; i < buffer.length; i++) {
                String binstr = Integer.toBinaryString(buffer[i]);
                while (binstr.length() < 8) {
                    binstr = "0" + binstr;
                }
                bitstr = bitstr + binstr;
            }
            bitstr = bitstr.substring(pos1 - 1, pos2);
            result = "" + Integer.valueOf(bitstr, 2);
        }
        return result;
    }

    private String B_F_BIT(String posstr) {
        String result;
        if (libelle) {
            return "Ex if BIT:1-4; C2 => C ";
        }
        String txt = B_F_DEC(posstr);
        result = Integer.toHexString(new Integer(txt));
        return result;
    }

    private String B_F_BM() {
        String result = "";
        //  boolean a=Lbm.BM_load(this.buffe);
        if (libelle) {
            return "charge le tableau BMap avec les 8 octets � partir de  offset \r\n que 2 bitmap qui se suivent possible (max=128)";
        }
        if (!BMap_Activ) {
            if (buffer.length < 8) {
                return "";
            }
            //TDeb.wri("before formate=>" + TUtils.tabTostr(buffer));
            int Pos_b = 0;
            int j;
            BMap_Activ = true;
            for (int i = 0; i <= 7; i++) {
                for (int bit = 7; bit >= 0; bit--) {
                    Pos_b++;
                    j = (int) Math.pow(2, bit);
                    BMap[Pos_b] = j == (j & buffer[i]);
                }
            }
            if (BMap[1]) {
                for (int i = 0; i <= 7; i++) {
                    for (int bit = 7; bit >= 0; bit--) {
                        Pos_b++;
                        j = (int) Math.pow(2, bit);
                        BMap[Pos_b] = j == (j & buffer[i + 8]);
                    }
                }
            } else {
                for (int i = 64; i < 129; i++) {
                    BMap[i] = false;
                }
            }
        }
        for (int i = 0; i < 129; i++) {
            if (BMap[i]) {
                result = result + i + ":";
            }
        }
        if (result.length() > 1) {
            result = result.substring(0, result.length() - 1);
            return result;
        } else {
            TDeb.wri("=> erreur de transacription BitMap => Bit map vide");
            return "Erreur";
        }
    }

    private String B_F_BYTE() {
        if (libelle) {
            return "10 16=>0a:10";
        }
        String result = "";
        for (int i = Offset; i < Offset + taille; i++) {
            if (buffer[i] < 16) {
                result = result + "0" + Integer.toHexString(buffer[i]) + ":";
            } else {
                result = result + Integer.toHexString(buffer[i]) + ":";

            }

        }
        result = result.substring(0, result.length() - 1);
        return result;
    }

    private String B_F_BOOL() {
        if (libelle) {
            return "1=>true;0=>false";
        }
        String b_result = "";
        int b_data = buffer[Offset];
        if (b_data == 1) {
            b_result = "TRUE";
        }
        if (b_data == 0) {
            b_result = "FALSE";
        }
        if (b_data > 1) {
            b_result = "ERROR>1";
        }
        return b_result;
    }

    private String B_F_BCD() {
        if (libelle) {
            return "Ex : 0x00,0x12,0x03=>1203";
        }
        String b_result = this.B_F_BCD_O();
        // enleve les 0 sauf le dernier
        for (int i = 0; i < b_result.length(); i++) {
            if (b_result.substring(0, 1).compareTo("0") == 0) {
                b_result = b_result.substring(1);
            }
        }
        return b_result;
    }

    private String B_F_BCD_O() {
        if (libelle) {
            return " Ex :0x12->12,0x1a=>1a; 0x01->01... :iso TPE";
        }
        String b_result = "";
        for (int i = Offset; i < Offset + taille; i++) {
            if (buffer[i] < 16) {
                b_result = b_result + "0" + Integer.toHexString(buffer[i]);
            } else {
                b_result = b_result + Integer.toHexString(buffer[i]);
            }
        }
        return b_result;
    }

    private String B_F_EBCDIC() {
        if (libelle) {
            return "Ex : f1 f2 20->12,@=>''.. c1=>?a:cbsa  TPE";
        }
        byte[] ret = new byte[taille];
        for (int i = 0; i < ret.length; i++) {
            if (buffer[i] < 128) {
                ret[i] = (byte) buffer[i];
            } else {
                ret[i] = (byte) (buffer[i] - 256);
            }
        }
        try {
            return new String(ret, "IBM1047");
        } catch (UnsupportedEncodingException ex) {
            String[] ebcdic = {"00", "01", "02", "03", "37", "2D", "2E", "2F", "16", "05", "25", "0B", "0C", "0D", "0E", "0F", "10", "11", "12", "13", "3C", "3D", "32", "26", "18", "19", "3F", "27", "1C", "1D", "1E", "1F", "40", "4F", "7F", "7B", "5B", "6C", "50", "7D", "4D", "5D", "5C", "4E", "6B", "60", "4B", "61", "F0", "F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "7A", "5E", "4C", "7E", "6E", "6F", "7C", "C1", "C2", "C3", "C4", "C5", "C6", "C7", "C8", "C9", "D1", "D2", "D3", "D4", "D5", "D6", "D7", "D8", "D9", "E2", "E3", "E4", "E5", "E6", "E7", "E8", "E9", "4A", "E0", "5A", "5F", "6D", "79", "81", "82", "83", "84", "85", "86", "87", "88", "89", "91", "92", "93", "94", "95", "96", "97", "98", "99", "A2", "A3", "A4", "A5", "A6", "A7", "A8", "A9", "C0", "6A", "D0", "A1", "07", "20", "21", "22", "23", "24", "15", "06", "17", "28", "29", "2A", "2B", "2C", "09", "0A", "1B", "30", "31", "1A", "33", "34", "35", "36", "08", "38", "39", "3A", "3B", "04", "14", "3E", "E1", "41", "42", "43", "44", "45", "46", "47", "48", "49", "51", "52", "53", "54", "55", "56", "57", "58", "59", "62", "63", "64", "65", "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", "77", "78", "80", "8A", "8B", "8C", "8D", "8E", "8F", "90", "9A", "9B", "9C", "9D", "9E", "9F", "A0", "AA", "AB", "AC", "AD", "AE", "AF", "B0", "B1", "B2", "B3", "B4", "B5", "B6", "B7", "B8", "B9", "BA", "BB", "BC", "BD", "BE", "BF", "CA", "CB", "CC", "CD", "CE", "CF", "DA", "DB", "DC", "DD", "DE", "DF", "EA", "EB", "EC", "ED", "EE", "EF", "FA", "FB", "FC", "FD", "FE", "FF"};
            String result = "";
            for (int i = Offset; i < Offset + taille; i++) {
                String val = Integer.toHexString(buffer[i]);
                int nb = 0;
                while (ebcdic[nb].compareTo((val).toUpperCase()) != 0) {
                    nb++;
                }
                result = result + (char) nb;
            }

            return result;
        }
    }

    private byte[] B_G_EBCDIC() {
        if (libelle) {
            return "EBCDIC : x31x34=>{0xf1,0xf4}".getBytes();
        }
        try {
            return value.getBytes("IBM1047");
        } catch (UnsupportedEncodingException exe) {
            return null;
        }
    }

    private String B_F_BCD_B() {
        if (libelle) {
            return "Ex : 0x12->6,0x37->19... utilis� pour longeur de champ dans HYPERCOM";
        }
        String result = B_F_BCD();
        int i = new Integer(result);
        int result2 = i / 2;
        // nb de byte avec bourrage => si 0x16=>8 si 0x17=> 9.
        if (result2 != ((i + 1) / 2)) {
            result2 = result2 + 1;
        }
        String b_result = "" + result2;
        return b_result;
    }

    private String B_F_BCD_I() {
        if (libelle) {
            return "Ex : 0110=> 1001 : M20 Schlum";
        }
        String b_result = "";
        for (int i = Offset + taille - 1; i >= Offset; i--) {
            if (buffer[i] < 16) {
                b_result = b_result + "0" + Integer.toHexString(buffer[i]);
            } else {
                b_result = b_result + Integer.toHexString(buffer[i]);
            }
        }
        // enleve les 0 sauf le dernier
        for (int i = 0; i < b_result.length(); i++) {
            if (b_result.substring(0, 1).compareTo("0") == 0) {
                b_result = b_result.substring(1);
            }
        }
        return b_result;
    }

    private String B_F_DEC() {
        if (libelle) {
            return "10:=>16; FFFFF=> -1 (en neg uniquement -1 si que des FF!!!)";
        }
        int result = 0;
        for (int i = Offset; i < Offset + taille; i++) {
            result = result + (buffer[i] * (int) java.lang.Math.pow(256, Offset + taille - i - 1));
        }
        if (result == (int) java.lang.Math.pow(256, taille) - 1) {
            result = -1;
        }
        return Integer.toString(result);
    }

    private String B_F_LONG() {
        if (libelle) {
            return "10:=>16 idem DEC but long...";
        }
        long result = 0;
        if (taille > 4) {
            return "more than 4 byte foir a long ... too long";
        }
        for (int i = Offset; i < Offset + taille; i++) {
            result = result + (buffer[i] * (long) java.lang.Math.pow(256, Offset + taille - i - 1));
        }
        return "" + result;
    }

    private String B_F_TCPL() {
        if (libelle) {
            return "70:=>28 (Ex : size of TCP header /4 bit:nb de mot de 32bit)!to rebuild!!";
        }
        int result = 4 * buffer[Offset] / 16;
        return "" + result;
    }

    private String B_F_DEC_I() {
        if (libelle) {
            return "Ex : 15:27:00:00=>HEX:00:00:27:15=>DEC_I :10005=> n� Scenario Schlum";
        }
        int result = 0;
        for (int i = Offset + taille - 1; i >= Offset; i--) {
            result = result + (buffer[i] * (int) java.lang.Math.pow(256, i - Offset));
        }
        if (result == (int) java.lang.Math.pow(256, taille) - 1) {
            result = -1;
        }
        return Integer.toString(result);
    }

    private String B_F_DEC_BI() {
        if (libelle) {
            return "Ex : 1f:03=>HEX:03:1f=>DEC_I :331=> n� version Schlum";
        }
        int result = 0;
        for (int i = Offset + taille - 1; i >= Offset; i--) {
            result = result + (buffer[i] * (int) java.lang.Math.pow(100, i - Offset));
        }
        return Integer.toString(result);
    }

    private String B_F_DEC_B() {
        if (libelle) {
            return "Ex : 0x10:=>16=8; 0x11=>17=>9 CBSA : taille de champs";
        }

        int result = 0;
        for (int i = Offset; i < Offset + taille; i++) {
            result = result + (buffer[i] * (int) java.lang.Math.pow(256, Offset + taille - i - 1));
        }
        if (result == (int) java.lang.Math.pow(256, taille) - 1) {
            result = -1;
        }
        int result2 = result / 2;
        // nb de byte avec bourrage => si 16=>8 si 17=> 9.
        if (result2 != ((result + 1) / 2)) {
            result2 = result2 + 1;
        }
        String b_result = "" + result2;
        return b_result;
    }

    private Object C_F_TIMESTAMP(String format) {
        if (format.compareTo("LONG_SEC") == 0) {
            return new java.sql.Timestamp(1000 * new Long(value));
        }
        if (format.compareTo("LONG") == 0) {
            return new java.sql.Timestamp(new Long(value));
        }
        java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(format);
        try {
            return new java.sql.Timestamp(sdf.parse(value).getTime());
        } catch (java.text.ParseException ex) {
            return ex.getMessage();
        }
    }

    private Object C_F_DATE(String format) {
        if (format.compareTo("SQL") == 0) {
            java.sql.Date dt;
            try {
                dt = java.sql.Date.valueOf(value);
            } catch (java.lang.IllegalArgumentException ex) {
                TDeb.wri("date format of " + value + "should be yyyy-mm-dd");
                return null;
            }
            return dt;
        } else if (format.startsWith("DEC")) {
            java.sql.Date dt;
            try {
                long val = new Long(value);
                if (format.endsWith("SEC")) {
                    val = val * 1000;
                }
                dt = new java.sql.Date(val);
                return dt;
            } catch (NumberFormatException ex) {
                TDeb.wri("date format of " + value + "should be a long value");
                return null;
            }
        } else if (format.startsWith("BCD")) {
            // used in CB2A field 13 NB : month -1??
            int y, m, d;
            java.util.GregorianCalendar cal;
            try {
                cal = new java.util.GregorianCalendar();
                cal.setTimeZone(java.util.TimeZone.getDefault());
                if (format.endsWith("YM")) {
                    y = new Integer(value.substring(0, 2));
                    m = new Integer(value.substring(3, 5));
                    cal.set(y, m - 1, 1, 0, 0, 0);
                }
                if (format.endsWith("MD")) {
                    m = new Integer(value.substring(0, 2));
                    d = new Integer(value.substring(3, 5));
                    cal.set(1970, m - 1, d, 0, 0, 0);
                }
            } catch (NumberFormatException e) {
                return null;
            }
            return cal.getTime();
        }

        return null;
    }

    private Object C_F_TIME(String format) {
        if (format.compareTo("BCD") == 0) {
            // used in CB2A field 12
            int h = 0;
            int m = 0;
            int s = 0;
            if (value.length() >= 2) {
                h = new Integer(value.substring(0, 2));
            }
            if (value.length() >= 5) {
                m = new Integer(value.substring(3, 5));
            }
            if (value.length() >= 8) {
                s = new Integer(value.substring(6, 8));
            }
            java.util.GregorianCalendar cal = new java.util.GregorianCalendar();
            cal.set(0, 0, 0, h, m, s);
            return new java.sql.Time(cal.getTimeInMillis());
        }
        return null;
    }

    private Object C_F_INTEGER(String format) {
        //  System.err.println("val:"+value+" format:"+format);
        value = value.trim();
        if (format == null || format.length() == 0) {
            return new Integer(value);
        }
        if (format.compareTo("*4") == 0) {
            return 4 * new Integer(value);
        }
        if (format.compareTo("/4") == 0) {
            return (Integer) (new Integer(value) / 4);
        }
        return new Integer(value);
        // }catch(Exception ex){return null;}
    }

    private Object C_F_LONG() {
        return new Long(value);
    }

    private String C_G_TIMESTAMP(Object obj, String format) {
        if (format.compareTo("LONG") == 0) {
            return "" + ((java.util.Date) obj).getTime();
        }
        return null;
    }
}
