package com.jdcm.common;

import java.awt.datatransfer.*;
import javax.swing.TransferHandler;

/**
 *used for copy / paste
 * @author Marc GIBOIN
 */
public class C_TransferHandler extends TransferHandler {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    int action;
    javax.swing.JTree tree;
    D_Utils Tutil = new D_Utils();

    public C_TransferHandler(int action) {
        this.action = action;
        //tree=t;
    }

    @Override
    public int getSourceActions(javax.swing.JComponent comp) {
        return COPY;
        //COPY_OR_MOVE;
    }

    public Object getDataToExport(java.awt.Component srccomp) {
        Object res = null;
        if (srccomp instanceof javax.swing.text.JTextComponent) {
            res = ((javax.swing.text.JTextComponent) srccomp).getText();
        }
        return res;
    }

    @Override
    public java.awt.datatransfer.Transferable createTransferable(javax.swing.JComponent comp) {
        Object o = getDataToExport(comp);
        C_Packet pack = null;
        if (o instanceof C_Packet) {
            pack = (C_Packet) o;
        } else if (o instanceof C_Packet[]) {
            C_Packet[] packs = (C_Packet[]) o;
            Object[] obs = new Object[packs.length];
            for (int i = 0; i < packs.length; i++) {
                obs[i] = packs[i].getObj();
                o = obs;
            }
        }
        if (pack == null) {
            pack = new C_Packet(o, null);//-99
        }
        byte[] datas = pack.getSerial();
        if (datas != null) {
            com.jdcm.modifiers.modif_QP mod = new com.jdcm.modifiers.modif_QP(datas);
            mod.ToCode();
            return new java.awt.datatransfer.StringSelection(new String(mod.getBuffer()));
        }
        return null;
    }

    @Override
    public void exportDone(javax.swing.JComponent comp, java.awt.datatransfer.Transferable trans, int action) {
        if (action != MOVE) {
            //??
        }
    }

    @Override
    public boolean canImport(TransferHandler.TransferSupport support) {
        // for the demo, we'll only support drops (not clipboard paste)
      /*  if (!support.isDrop()) {
        return false;
        }*/

        // we only import Strings
        if (!support.isDataFlavorSupported(DataFlavor.stringFlavor)) {
            return false;
        }

        boolean actionSupported = true;
        if (support.isDrop()) {
            //if clipboard => Exception "Not a drop"
            actionSupported = (action & support.getSourceDropActions()) == action;
            support.setDropAction(action);
        }

        return actionSupported;
    }

    @Override
    public boolean importData(TransferHandler.TransferSupport support) {
        // super.importData(support);
        // if we can't handle the import, say so
        if (!canImport(support)) {
            return false;
        }
        // fetch the data and bail if this fails
        String data;
        C_Packet p;
        Object transfered;
        try {
            data = support.getTransferable().getTransferData(DataFlavor.stringFlavor).toString();
        } catch (UnsupportedFlavorException | java.io.IOException e) {
            return false;
        }
        if (support.isDrop()) {

            // !!!!!!!!!!!!! byte[] test=data.getBytes();!!!!!!!!!!!!!!!!!!!
            try {
                com.jdcm.modifiers.modif_QP mod = new com.jdcm.modifiers.modif_QP(data.getBytes());
                mod.ToClear();
                p = new C_Packet(mod.getBuffer(), null);//-99
            } catch (NumberFormatException e) {
                return false;
            }
            transfered = p.getSer2Obj();
        } else {
            transfered = data;
        }
        return setInportedData(transfered, support.getComponent());
    }

    public boolean setInportedData(Object transfered, java.awt.Component target) {
        if (transfered == null) {
            return false;
        }
        if (transfered instanceof javax.swing.tree.TreeModel) {
            //Should it be in P_XML??!!
            if (target instanceof com.jdcm.editors.P_XML) {
                com.jdcm.editors.P_XML pxml = (com.jdcm.editors.P_XML) target;
                pxml.displayTree((javax.swing.tree.TreeModel) transfered);
            }
        }
        if (target instanceof javax.swing.text.JTextComponent) {
            javax.swing.text.JTextComponent txt = (javax.swing.text.JTextComponent) target;
            txt.setText(txt.getText() + transfered.toString());
        }
        return true;
    }
}


