package com.jdcm.common;

import java.util.Arrays;

/**
 * an wrapper to get a 'Text Class' as text Element use by java text editing
 * @author Marc GIBOIN
 */
public class C_textClass extends C_textElement {

    private String Package;
    private java.io.File classFile;
    private java.util.List<String> Imports = null;
    private Class<?> Extends = null;
    private Class<?> thisClasse = null;
    private boolean isarray = false;
    private String tmpName=null;
    private java.util.ArrayList<Class<?>> Implements = new java.util.ArrayList<>();
    private java.util.ArrayList<C_textField> Fields = new java.util.ArrayList<>();
    private java.util.ArrayList<C_textMethod> Methods = new java.util.ArrayList<>();
    private java.util.ArrayList<C_textClass> Classes = new java.util.ArrayList<>();
    // to emulate an inner class

    public C_textClass(C_textClass cl, String txtcode) {
        super(txtcode.substring(0, txtcode.indexOf("{")) + "{\r\n}");
        String defcode = getHeader(txtcode);//txtcode.substring(0, txtcode.indexOf("{"));
        //txtcode=txtcode.substring(0, txtcode.indexOf("{"));
        Imports = new java.util.ArrayList<>();
        init(cl, defcode);
    }
    public C_textClass(String tmpLabel) {
        super("");
        tmpName=tmpLabel;
    }
    // to emulate a text code class
    public C_textClass(String pack, java.util.List<String> imports, C_textClass cl, String txtcode) {
        super(txtcode.substring(0, txtcode.indexOf("{")) + "{\r\n}");
        String defcode = txtcode.substring(0, txtcode.indexOf("{"));
        Imports = imports;
        Package = pack;
        init(cl, defcode);
    }
    // emulate a Real class

    public C_textClass(C_textClass cl, Class<?> c) {
        super("built without code");
        //txtcode=txtcode.substring(0, txtcode.indexOf("{"));
        if (cl == null) {
            setReleventClass(this);
        } else {
            setReleventClass(cl);
        }
        init_realClass(c);
    }
    // to emulate an exiting class but fil

    public C_textClass(String packpath, String clname, java.io.File f, Class<?> c) {
        super("built without code");
        classFile = f;
        Name =clname;
        Package=packpath;
        init_realClass(c);

    }

    public C_textClass(C_textClass cl, C_textClass c) {
        super(c.getCode());
        //txtcode=txtcode.substring(0, txtcode.indexOf("{"));
        if (cl == null) {
            setReleventClass(this);
        } else {
            setReleventClass(cl);
        }
        // clone ?!
        Package = c.Package;
        setModifiers(c.getModifiers());
        Extends = c.Extends;
        Implements = c.Implements;
        Classes = c.Classes;
        Methods = c.Methods;
        Fields = c.Fields;
        isarray = c.isarray;
        Imports = c.Imports;
        Name = c.getSimpleName();
    }

    private void init_realClass(Class<?> c) {
        if (c == null) {
            return;
        }
        if (c.getPackage() != null) {
            Package = c.getPackage().getName();
        }
        Imports = new java.util.ArrayList<>();
        Imports.add("*");
        Imports.add("java.lang.*");
        setModifiers(c.getModifiers());
        Extends = c.getSuperclass();
        Implements.addAll(Arrays.asList(c.getInterfaces()));
        Name = c.getSimpleName();
        thisClasse = c;
    }

    private void init(C_textClass cl, String defcode) {
        if (cl == null) {
            setReleventClass(this);
        } else {
            setReleventClass(cl);
        }
        if (Package!=null){
           Imports.add(Package+".*");
        }
        Imports.add("*");
        Imports.add("java.lang.*");
        defcode = setComment(defcode);
        defcode = setHead(defcode);
        setModifiers(getModifiers(defcode));
        defcode = removeModifiers(defcode);
        defcode = setExtends(defcode, "extends ");
        defcode = setExtends(defcode, "implements ");
        if (defcode.indexOf(" ")>0){
            defcode=defcode.split(" ")[1];
        }
        Name = defcode;
       // Imports.add(Package+"."+Name); //=> is not a Class but a text !!!
    }
        public String getTmpName() {
        return tmpName;
    }

    public boolean isInterface() {
        return java.lang.reflect.Modifier.isInterface(getModifiers());
    }
    @Override
    public String getSimpleName() {
        if (isarray) {
            return Name + "[]";
        }
        return Name;
    }

    public void setHeader(String pack, java.util.List<String> imports) {
        Imports.addAll(imports);
        Package += pack;
    }

    public Class<?> getThisClasse() {
        return thisClasse;
    }

    public void setThisClasse(Class<?> thisClasse) {
        this.thisClasse = thisClasse;
    }
    public java.io.File getClassFile() {
       return  classFile;
    }

    public void setarray(boolean bool) {
        isarray = bool;
    }

    public boolean isarray() {
        return isarray;
    }

    public String getPackage() {
        return Package;
    }

    @Override
    public String getName() {
        return Package +"."+ Name;
    }

    public java.util.List<String> getImports() {
        return Imports;
    }

    public void addField(C_textField val) {
        Fields.add(val);
    }

    public java.util.List<C_textField> getFields() {
        return Fields;
    }

    public void addClasse(C_textClass val) {
        Classes.add(val);
    }

    public java.util.List<C_textClass> getClasses() {
        return Classes;
    }

    public void addMethod(C_textMethod meth) {
        Methods.add(meth);
    }

    public java.util.List<C_textMethod> getMethods() {
        return Methods;
    }

    public java.util.List<C_textElement> getElements() {
        java.util.List<C_textElement> list = new java.util.ArrayList<>();
        list.addAll(Methods);
        list.addAll(Fields);
        return list;
    }

    private String setExtends(String txtcode, String hook0) {
        while (txtcode.indexOf(hook0) >= 0) {
            int pos = txtcode.indexOf(hook0);
            int posend = txtcode.length();
            if (txtcode.indexOf("{", pos) > 0) {
                posend = txtcode.indexOf("{");
            }
            if (txtcode.indexOf("implements ", pos) > txtcode.indexOf(hook0)) {
                posend = txtcode.indexOf("implements");
            }
            if (txtcode.indexOf("extends ", pos) > txtcode.indexOf(hook0)) {
                posend = txtcode.indexOf("extends");
            }
            String ext = txtcode.substring(pos + hook0.length(), posend);
            txtcode = txtcode.substring(0, pos) + txtcode.substring(posend);
            for (String clas : ext.split(",")) {
                if (hook0.startsWith("extends")) {
                    Extends = getClasse(clas);
                } else {
                    Implements.add(getClasse(clas));
                }
            }
        }
        return txtcode.trim();
    }

    public Class<?> getSuperclass() {
        return Extends;
    }

    public String getAllCode() {
        if (getCode() == null || getCode().length() == 0 || getCode().startsWith("no code")) {
            return null;
        }
        String txt = getCode().substring(0, getCode().indexOf("}"));
        for (C_textField f : getFields()) {
            txt = txt + f.getCode() + ";\r\n";
        }
        for (C_textMethod f : getMethods()) {
            txt = txt + f.getCode() + "\r\n";
        }
        for (C_textClass f : getClasses()) {
            txt = txt + f.getAllCode() + "\r\n";
        }
        return txt + "}";
    }

    private String setHead(String txtcode) {
        String hook0 = "package ";
        while (txtcode.indexOf(hook0) >= 0) {
            // should be ony one time...
            int posend = txtcode.indexOf(";", txtcode.indexOf(hook0));
            Package = txtcode.substring(txtcode.indexOf(hook0) + hook0.length(), posend);
            Imports.add(Package+".*");
            txtcode = txtcode.substring(0, txtcode.indexOf(hook0)) + txtcode.substring(posend + 1);
        }
        hook0 = "import ";
        while (txtcode.indexOf(hook0) >= 0) {
            int posend = txtcode.indexOf(";", txtcode.indexOf(hook0));
            Imports.add(txtcode.substring(txtcode.indexOf(hook0) + hook0.length(), posend));
            txtcode = txtcode.substring(0, txtcode.indexOf(hook0)) + txtcode.substring(posend + 1);
        }
        return txtcode;
    }
}
