package com.jdcm.common;

/**
 * generic clas to emulate all sort of Class/field/methode/...
 *
 * @author Marc GIBOIN
 */
public class C_textElement implements java.lang.reflect.Member {

    private final D_Utils TUtils = new D_Utils();
    public String Name;
    private String Code;
    private C_textClass relevantClass;// strange => supercall refer to chid...!!!
    //private java.util.ArrayList<String> Comments = new java.util.ArrayList<>();
    private int Modifiers;
    String Annotation;

    public C_textElement(String txtcode) {
        Code = txtcode;
    }

    public String getHeader(String code) {
        int pos = TUtils.nonCommentPos(code, "{", 0, true);
        if (pos < 0) {
            // for methor declaration in interface
            pos = TUtils.nonCommentPos(code, ";", 0, true);
        }
        return code.substring(0, pos);
    }

    public String setAnnotation(String txtcode) {
        if (txtcode.trim().startsWith("@") && txtcode.trim().indexOf("\n") > 0) {
            Annotation = txtcode.trim().substring(0, txtcode.trim().indexOf("\n"));
            return txtcode.trim().substring(txtcode.trim().indexOf("\n")).trim();
        }
        return txtcode;
    }

    public String setComment(String txtcode) {
        // to reDO with F_Compile / T_Utils / see if a java.lang.text... remplace ... 
        java.util.List<String[]> hooks = new java.util.ArrayList<>();
        hooks.add(new String[]{"/*", "*/"});
        hooks.add(new String[]{"//", "\n"});
        for (String[] hook : hooks) {
            while (txtcode.indexOf(hook[0]) >= 0) {
                int pos = txtcode.indexOf(hook[0]);
                int posend = txtcode.indexOf(hook[1], pos);
                if (posend < 0) {
                    // Comments.add(txtcode.substring(pos + hook[0].length()));
                    txtcode = txtcode.substring(0, pos);
                } else {
                    //     Comments.add(txtcode.substring(pos + hook[0].length(), posend));
                    txtcode = txtcode.substring(0, pos) + txtcode.substring(posend + hook[1].length());
                }
            }
        }
        return txtcode.trim();
    }

    public void setModifiers(int i) {
        Modifiers = i;
    }

    public String getCode() {
        return Code;
    }

    public void setCode(String txt) {
        Code = txt;
    }

    public void setReleventClass(C_textClass cl) {
        relevantClass = cl;
    }

    public C_textClass getReleventClass() {
        return relevantClass;
    }

    @Override
    public String toString() {
        return "[T]" + Name;
    }

    public int getModifiers(String txt) {
        int res = 0;
        if (txt.contains("interface")) {
            txt = "abstract " + txt;
        }
        String textes = "public/private/protected/static/final/abstract/interface";
        java.util.List<String> decls = java.util.Arrays.asList(textes.split("/"));
        int[] val = {java.lang.reflect.Modifier.PUBLIC,
            java.lang.reflect.Modifier.PRIVATE,
            java.lang.reflect.Modifier.PROTECTED,
            java.lang.reflect.Modifier.STATIC,
            java.lang.reflect.Modifier.FINAL,
            java.lang.reflect.Modifier.ABSTRACT,
            java.lang.reflect.Modifier.INTERFACE
        };
        for (String dec : decls) {
            String searched = dec + " ";
            if (txt.contains(searched)) {
                res = res | val[decls.indexOf(dec)];
            }
        }
        return res;
    }

    public String removeModifiers(String txt) {
        String textes = "public/private/protected/static/final/abstract";
        java.util.List<String> decls = java.util.Arrays.asList(textes.split("/"));
        for (String dec : decls) {
            String searched = dec + " ";
            txt = txt.replaceFirst(searched, "");
        }
        return txt;
    }

    @Override
    public Class<?> getDeclaringClass() {
        return null;
    }

    @Override
    public String getName() {
        return Name;
    }

    public String getSimpleName() {
        return Name;
    }

    @Override
    public int getModifiers() {
        return Modifiers;
    }

    @Override
    public boolean isSynthetic() {
        return false;
    }

    public Class<?> getClasse(String txt) {
        java.util.List<String> typelist = java.util.Arrays.asList("boolean/byte/int/byte/float/double/long".split("/"));
        Class<?> cl = null;
        String clname = txt.trim();
        Class<?> generic = null;
        boolean isarray = false;
        // reflecting generics =>http://www.artima.com/weblogs/viewpost.jsp?thread=208860
        // Class<? extends ImplementMe> c2 = Class.forName("com.arc90.blog.InstantiateMe").asSubclass(ImplementMe.class);  
        //The generic information is lost in runtime.

        if (clname.endsWith("[]")) {
            isarray = true;
            clname = clname.substring(0, clname.indexOf("["));
        }

        if (clname.indexOf("<") > 0 && clname.indexOf(">") > 0) {
            generic = getClasse(clname.substring(clname.indexOf("<") + 1, clname.indexOf(">")));
            clname = clname.substring(0, clname.indexOf("<"));
        }
        if (clname.compareTo("void") == 0) {
            clname = "Void";
        }
        if (typelist.indexOf(clname) >= 0) {
            Class<?>[] c = new Class<?>[]{boolean.class, byte.class, int.class, byte.class, float.class, double.class, long.class};
            cl = c[typelist.indexOf(clname)];
        }
        for (String pack : relevantClass.getImports()) {
            if (cl == null && pack != null) {
                if (pack.endsWith("*")) {
                    pack = pack.substring(0, pack.length() - 1) + clname;
                } else if (pack.endsWith("." + clname) == false) {
                    pack = null;
                }
                if (pack!=null){
                try {
                    cl = Class.forName(pack);
                } catch (ClassNotFoundException ex) {
                   // System.err.println(" C_textElement : getClasse() " + ex);
                }
                }
            }
        }

        if (isarray && cl instanceof Class) {
            cl = java.lang.reflect.Array.newInstance(cl, 0).getClass();
        }
        if (generic != null) {
            try {
                //  cl.asSubclass(generic);
            } catch (Exception ex) {
            }
        }
        return cl;
    }

    public C_textClass getTxtClass(String txt) {
        Class<?> c = getClasse(txt);
        if (c == null) {
            boolean isarray = false;
            if (txt.indexOf("[]") > 0) {
                isarray = true;
                txt = txt.substring(0, txt.indexOf("["));
            }
            C_textClass rcl = relevantClass;
            while (rcl != null) {
                for (C_textClass lcl : rcl.getClasses()) {
                    if (lcl.getSimpleName().compareTo(txt) == 0) {
                        if (isarray) {
                            C_textClass acl = new C_textClass(this.relevantClass, lcl);
                            acl.setarray(true);
                            return acl;
                        } else {
                            return lcl;
                        }
                    }
                }
                if (rcl.equals(rcl.getReleventClass()) == false) {
                    rcl = rcl.getReleventClass();
                } else {
                    rcl = null;
                }
            }
            System.out.print("Pb with " + txt);
            return new C_textClass(txt);
        } else {
            return new C_textClass(this.relevantClass, c);
        }
    }
}
