package com.jdcm.common;

/**
 * an wrapper to get a 'Text Methode' as text Element use by java text editing
 *
 * @author Marc GIBOIN
 */
public class C_textMethod extends C_textElement {

    int Modifiers;
    Class<?> returnType;
    String tmpReturn;
    Class[] paramTypes;

    class txtParameter {

        String name;
        Class<?> type;
        C_textClass intype;

        public txtParameter(String n, Class<?> t) {
            name = n;
            type = t;
            intype = null;
        }

        public txtParameter(String n, C_textClass t) {
            name = n;
            intype = t;
        }
    };
    private java.util.ArrayList<Class<?>> Exceptions = new java.util.ArrayList<>();
    private java.util.ArrayList<txtParameter> Parametres = new java.util.ArrayList<>();
    boolean isOverride = false;
    private boolean isConstructor = false;

    public C_textMethod(C_textClass c, String txtcode) {
        super(txtcode);
        txtcode = getHeader(txtcode);
        setReleventClass(c);
        txtcode = setComment(txtcode);
        txtcode = setAnnotation(txtcode);
        setModifiers(getModifiers(txtcode));
        txtcode = removeModifiers(txtcode);
        txtcode = setParametres(txtcode);
        txtcode = setAnnotationExcp(txtcode);
        txtcode = setReturn(txtcode);
        Name = txtcode;
    }

    @Override
    public String getName() {
        return Name;
    }

    public String getParametersLabel() {
        String res = "(";
        for (txtParameter par : Parametres) {
            if (par.type != null) {
                res = res + par.type.getSimpleName() + ",";
            } else if (par.intype != null) {
                res = res + par.intype.getTmpName() + ",";
            } else {
                res = res + "???,";
            }
        }
        if (res.length() > 1) {
            res = res.substring(0, res.length() - 1);
        }
        return res + ")";
    }

    public String getReturnLabel() {
        if (getReturnType() != null) {
            return getReturnType().getSimpleName();
        } else if (tmpReturn != null) {
            return tmpReturn;
        } else {
            return "???";
        }
    }

    public Class<?>[] getParameterTypes() {
        Class<?>[] cls = new Class<?>[Parametres.size()];
        for (txtParameter t : Parametres) {
            cls[Parametres.indexOf(t)] = t.type;
        }
        return cls;
    }

    public Class<?>[] getExceptionTypes() {
        Class<?>[] cls = new Class<?>[Exceptions.size()];
        for (Class<?> t : Exceptions) {
            cls[Exceptions.indexOf(t)] = t;
        }
        return cls;
    }

    public Class<?> getReturnType() {
        return returnType;
    }

    public boolean isConstructor() {
        return isConstructor;
    }

    private String setAnnotationExcp(String txtcode) {
        if (txtcode == null || txtcode.length() == 0) {
            return null;
        }
        if (txtcode.startsWith("@")) {
            txtcode = txtcode.substring(1).trim();
            String tag = txtcode.substring(0, txtcode.indexOf(" "));
            txtcode = txtcode.substring(tag.length()).trim();
        }
        if (txtcode.indexOf("throws ") > 0) {
            String ex = txtcode.substring(txtcode.indexOf("throws ") + "throws ".length());
            for (String txt : ex.split(",")) {
                Exceptions.add(getClasse(txt));
            }
            txtcode = txtcode.substring(0, txtcode.indexOf("throws "));
        }
        return txtcode;
    }

    private String setParametres(String txtcode) {
        if (txtcode.indexOf("(") < 0 || txtcode.indexOf(")") < 0 || txtcode.indexOf(")") < txtcode.indexOf("(")) {
            return null;
        }
        String params = txtcode.substring(txtcode.indexOf("(") + 1, txtcode.indexOf(")")).trim();
        if (params != null && params.length() > 0) {
            String buffer = null;
            for (String param : params.split(",")) {
                /*
                 * this is for case of public synchronized Map<String, Class<T>>
                 * compile( final Map<String, CharSequence> classes,...) =>
                 * Map<String, do an error..
                 */
                if (param != null) {
                    if (param.indexOf("<") > 0 && param.indexOf(">") == -1) {
                        buffer = param;
                    } else {
                        if (buffer != null) {
                            buffer = buffer + "," + param;
                            if (param.indexOf(">") > 0) {
                                param = buffer;
                                buffer = null;
                                param = param.trim();
                                Class<?> cl = getClasse(param.split(" ")[0]);
                                if (cl != null) {
                                    Parametres.add(new txtParameter(param.split(" ")[1], cl));
                                } else {
                                    Parametres.add(new txtParameter(param.split(" ")[1], new C_textClass(param.split(" ")[0])));
                                }
                            } else {
                                param = null;
                            }
                        }
                    }
                }
            }
        }
        txtcode = (txtcode.substring(0, txtcode.indexOf("(")) + txtcode.substring(txtcode.indexOf(")") + 1)).trim();
        return txtcode;
    }

    private String setReturn(String txtcode) {
        if (txtcode == null || txtcode.length() == 0) {
            return null;
        }
        String[] words = txtcode.split(" ");
        if (words.length < 2) {
            isConstructor = true;
        } else {
            Class<?> cl = getClasse(words[0]);
            if (cl != null) {
                returnType = getClasse(words[0]);
            } else {
                tmpReturn = words[0];
            }
            txtcode = txtcode.substring(words[0].length()).trim();
        }
        return txtcode;
    }

    private txtParameter zzTest(txtParameter txtcode) {
        return null;
    }
}
