package com.jdcm.common;

import com.jdcm.eltrx.C_Port;
import com.jdcm.eltrx.D_Debug;
import com.jdcm.eltrx.T_DB;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author M.Marc GIBOIN
 */
public class D_DBUtils {
    // the maximum default fied size =>VARCHAR(MAXTextSize)
    private final D_Utils TUtils = new D_Utils();
    private final int MAXTextSize = 45;
    private C_Port Parent;
    private D_Debug TDeb = null;
    private Connection cxDB = null;
    private String DBcontr = "";
    
    private String identQuote = null;
    // a debug compteur for log
    int dggcpt = 0;

    public D_DBUtils() {
        TDeb = new D_Debug("DBUtils [] : ");
    }

    public void setPort(C_Port p) {
        Parent = p;
        TDeb = new D_Debug("DBUtils[] : ");
        TDeb.setconsole(Parent.getConsole());
        if (Parent.getDB_CX() != null) {
            setCX(Parent.getDB_CX());
        }

    }

    public void setCX(Connection cx) {
        cxDB = cx;
        try {
            DBcontr = cxDB.getMetaData().getDatabaseProductName();
            identQuote = cxDB.getMetaData().getIdentifierQuoteString();
            // getDBquote(0, 0);
        } catch (SQLException ex) {
            TDeb.wri("gettypes : Pb getting name =>" + ex.getMessage());
        }
    }

    private int Trt_in(String sqlreq) {
        if (Parent != null && Parent.getSlave() instanceof T_DB) {
            return ((T_DB) Parent.getSlave()).Trt_in(sqlreq);
        } else if (cxDB != null) {
            try {
                Statement request = cxDB.createStatement();
                return request.executeUpdate(sqlreq);
            } catch (SQLException ex) {
                TDeb.wri("Trt_in() : Pb creating statement =>" + ex.getMessage());
                return -1;
            }
        }
        return -1;
    }

    public ResultSet Trt_out(String sqlreq) {
        if (Parent != null && Parent.getSlave() instanceof T_DB) {
            return ((T_DB) Parent.getSlave()).Trt_out(sqlreq);
        } else if (cxDB != null) {
            try {
                Statement request = cxDB.createStatement();
                return request.executeQuery(sqlreq);
            } catch (SQLException ex) {
                TDeb.wri("Trt_out() : Pb creating statement =>" + ex.getMessage());
                return null;
            }
        }
        return null;
    }
    /*
     * --------------------------------------------------------------------------------
     * Entry for 2DB insertion used by XML=>DB(mapping & build), tree2DB, ...
     */

    public int Delete_datas(String shema, String tablename, java.util.Map<String, Object> attrs, java.util.List<String> xmlkeys) {
        if (xmlkeys == null || xmlkeys.isEmpty()) {
            xmlkeys = getTableKeys(shema, tablename);
        }
        String req = "DELETE FROM " + getstdTableName(shema, tablename) + getWhereKey(shema, tablename, attrs, xmlkeys);
        int res = Trt_in(req);
        if (res <= 0) {
            TDeb.wri("delete():PB deleting " + getstdTableName(shema, tablename) + "=>" + getWhereKey(shema, tablename, attrs, xmlkeys));
        } else {
            TDeb.wri("delete():deleted " + getstdTableName(shema, tablename) + "=>" + getWhereKey(shema, tablename, attrs, xmlkeys));
        }
        dggcpt++;
        return res;
    }

    public int getCompteur() {
        return dggcpt;
    }

    public void Insert_datas(String shema, String table, java.util.Map<String, Object> attrs, java.util.List<String> xmlkeys) {
        table = table.toLowerCase();
        if (!isTable(shema, table)) {
            TDeb.wri("Insert_datas() : try to create table: " + shema + "." + table);
            createTable(shema, table, attrs, xmlkeys);
            createRow(shema, table, attrs);
        } else {
            createColumns(shema, table, getMissingColumns(shema, table, attrs));
            if (xmlkeys == null || xmlkeys.isEmpty()) {
                xmlkeys = getTableKeys(shema, table);
            }
            if (isRow(shema, table, xmlkeys, attrs)) {
                TDeb.wri("Insert_datas() : ask UpdateRow");
                UpdateRow(shema, table, attrs, xmlkeys);
            } else {

                createRow(shema, table, attrs);
            }
        }
    }

    public String getescapedString() {
        try {
            return cxDB.getMetaData().getSearchStringEscape();
        } catch (SQLException ex) {
             TDeb.wri(" D_Utils : getescapedString() " + ex.getMessage());
        }
        return "";
    }

    public java.util.List<String> getTableKeys(String shema, String table) {
        java.util.List<String> tablekeys = new java.util.ArrayList<>();
        try {
            ResultSet rs = cxDB.getMetaData().getPrimaryKeys(shema, null, table);
            // if ther is no key=> check if autoicr KEY on table
            while (rs.next()) {
                if (rs.getObject("PK_NAME").toString().compareTo("PRIMARY") == 0) {
                    tablekeys.add(rs.getObject("COLUMN_NAME").toString());
                }
            }
            return tablekeys;
        } catch (SQLException ex) {
            TDeb.wri("PB retreive KEY for " + shema + "." + table + "=>" + ex);
            return null;
        }
    }

    private java.util.Map<String, Integer> getattrTypes(String shema, String tablename, java.util.Collection<String> attrsLabels) {
        java.util.Map<String, Integer> atttypes = new java.util.HashMap<>();
        try {
            ResultSet cols = cxDB.getMetaData().getColumns(shema, null, tablename, null);
            while (cols.next()) {
                String colName = cols.getString("COLUMN_NAME");                   // avoid second reading
                if (attrsLabels.contains(colName)) {
                    atttypes.put(colName, cols.getInt("DATA_TYPE"));
                }
            }
        } catch (SQLException ex) {
            return null;
        }
        return atttypes;
    }

    private String getWhereKey(String shema, String tablename, java.util.Map<String, Object> attrs, java.util.List<String> keys) {
        java.util.Map<String, Integer> atttypes = getattrTypes(shema, tablename, keys);
        if (keys.isEmpty()) {
            return "";
        } else if (attrs != null && atttypes != null) {
            String res = " WHERE ";
            for (String key : keys) {
                String value = getstdDBvalue(attrs.get(key), atttypes.get(key));
                String colname = getstdTableName(shema, tablename) + "." + getstdColumnName(key);
                if (value.compareTo("NULL") == 0) {
                    res = res + colname + " IS " + value;
                } else {
                    res = res + colname + " = " + value;
                }
                res = res + " AND ";
            }
            res = res.substring(0, res.length() - " AND".length());
            return res;
        } else {
            return null;
        }
    }
    //an old compatibility...?? used in XML=>DB

    public void Insert_data(String shema, String table, String col, String key_id, Object key_val, Object value) {
        java.util.Map<String, Object> map = new java.util.HashMap<>();
        map.put(key_id, key_val);
        map.put(col, value);
        Insert_datas(shema, table, map, java.util.Arrays.asList(new String[]{key_id}));
    }

    /**
     * Used to check if a table existes in a shema or not
     *
     * @param shema the used shema
     * @param tablename the target tablename to check
     * @return true if the table exists
     */
    private boolean isTable(String shema, String tablename) {
        if (cxDB == null) {
            return false;
        } // error
        boolean bool = false;
        try {
            try (ResultSet rs = cxDB.getMetaData().getTables(shema, null, tablename, null)) {

                while (rs.next()) {
                    String thisname = rs.getObject("TABLE_NAME").toString();
                    String thistype = rs.getObject("TABLE_TYPE").toString();
                    if (thisname.compareTo(tablename) == 0 && thistype.compareTo("TABLE") == 0) {
                        TDeb.wri("found table : " + thisname);
                        bool = true;
                    }
                }
                rs.close();
            }
        } catch (SQLException ex) {
            TDeb.wri(dggcpt + "|Ex while checking table :" + tablename + " [" + ex.getMessage() + "]");
        }
        return bool;
    }
    /*
     * Check if colums exists ans return missings with SQLTYpe code
     */

    private java.util.Map<String, Integer> getMissingColumns(String shema, String tablename, java.util.Map<String, Object> attrs) {
        // check if attribut exist
        if (cxDB == null) {
            return null;
        }//error
        java.util.Map<String, Integer> tmp = new java.util.HashMap<>();
        java.util.Map<String, Integer> res = new java.util.HashMap<>();
        ResultSet rs = null;
        try {
            rs = cxDB.getMetaData().getColumns(shema, null, tablename, null);
            while (rs.next()) {
                tmp.put(rs.getObject("COLUMN_NAME").toString(), (Integer) rs.getObject("DATA_TYPE"));
            }
            rs.close();
            for (String att : attrs.keySet()) {
                if (!tmp.containsKey(att)) {// should check type??
                    Class<?> cl = null;
                    try {
                        cl = attrs.get(att).getClass();
                    } catch (Exception ex) {
                    }
                    res.put(att, getDBtype(cl));
                }
            }
        } catch (SQLException ex) {
            TDeb.wri(dggcpt + "|Ex while checking column : " + attrs + " in : " + tablename + " [" + ex.getMessage() + "]");
            try {
                rs.close();
            } catch (SQLException exe) {
                TDeb.wri("getMissingColumns()/rs.close()=>"+exe.getMessage());
            }
            return null;
        }
        return res;
    }
    /*
     * Used by Insert_data to check if row exists
     */

    private boolean isRow(String shema, String tablename, java.util.List<String> keys, java.util.Map<String, Object> attrs) {

        //unused => update...==0
        String req = "SELECT * FROM " + getstdTableName(shema, tablename) + getWhereKey(shema, tablename, attrs, keys);
        ResultSet ressql = Trt_out(getstdQuery(req));
        try {
            if (ressql == null) {
                return false;
            }
            if (ressql.next()) {
                ressql.close();
                return true;
            }
            ressql.close();
        } catch (SQLException ex) {
            TDeb.wri(dggcpt + "isRow(): Pb check Row :" + keys + " in table : " + tablename + " [" + ex.getMessage() + "]");
            if (ressql != null) {
                try {
                    ressql.close();
                } catch (SQLException exe) {
                }
            }
            return false;
        }
        return false;
    }
    /*
     * Used by Insert_data to (try) to create a table
     *
     * create table (shema,table,List<xmlkeys>,Map<String,Object>
     * attrs,Map<String,int>types )
     */

    private int createTable(String shema, String tablename, java.util.Map<String, Object> attrs, java.util.List<String> keys) {
        String attrstr = "";
        for (String attr : attrs.keySet()) {
            if (attrs.get(attr) == null && keys.contains(attr)) {
                // attrs.put(attr, 1L);
            } else if (attrs.get(attr) == null) {
                TDeb.wri("createTable(): null Value for attribut:" + attr + " ommitted");
            } else {
                int datatype = getDBtype(attrs.get(attr).getClass());
                String chpstr = getType2DB(datatype, DBcontr, MAXTextSize);
                if (keys.contains(attr)) {
                    //:!! very BD dependent...
                    if (DBcontr.compareTo("MySQL") == 0) {
                        if (chpstr.compareTo("TEXT") == 0) {
                            chpstr = "VARCHAR(255)";
                        }
                        chpstr = getstdColumnName(attr) + " " + chpstr;
                        if (datatype == java.sql.Types.BIGINT) {
                            chpstr += " AUTO_INCREMENT ";
                        }
                        chpstr += " NOT NULL ";
                    } else if (DBcontr.compareTo("ACCESS") == 0) {
                        // access request is 
                        // CREATE TABLE mytab ([ID] AUTOINCREMENT, [NAME] TEXT(255),[ADDY] TEXT(255), PRIMARY KEY ([ID]))
                        if (datatype == java.sql.Types.BIGINT) {
                            chpstr = getstdColumnName(attr) + " AUTOINCREMENT ";
                        } else {
                            chpstr = getstdColumnName(attr) + chpstr;
                        }
                    } else {
                        chpstr = getstdColumnName(attr) + chpstr + " PRIMARY KEY";
                        if (datatype == java.sql.Types.BIGINT) {
                            chpstr += " AUTOINCREMENT ";
                        }
                    }
                } else {
                    chpstr = getstdColumnName(attr) + " " + chpstr;
                }
                attrstr = attrstr + chpstr + ", ";
            }
        }
        if (attrstr.length() > 2) {
            attrstr = attrstr.substring(0, attrstr.length() - 2);
        }
        if (!keys.isEmpty() && (DBcontr.compareTo("MySQL") == 0 || DBcontr.compareTo("ACCESS") == 0)) {
            attrstr += ", PRIMARY KEY (";
            for (String key : keys) {
                attrstr += getstdColumnName(key) + ", ";
            }
            attrstr = attrstr.substring(0, attrstr.length() - 2) + ")";
        }
        String req = "CREATE TABLE " + getstdTableName(shema, tablename)
                + " (" + attrstr + ");";
        int res = Trt_in(getstdQuery(req));//UNSIGNED NOT NULL ,PRIMARY KEY ("+sep+key_id+sep+")
        TDeb.wri("createTable():" + res + " for " + req);
        if (res < 0) {
            TDeb.wri("createTable():Pb to create TABLE : " + tablename + " in " + shema);
            return -1;
        }
        TDeb.wri(dggcpt + "|TABLE created : " + tablename + " in " + shema);
        return 0;
    }
    /*
     * Used by Insert_data to (try) to add an attribut
     */

    private int createColumns(String shema, String tablename, java.util.Map<String, Integer> attrs) {
        int res = 0;
        for (String attr : attrs.keySet()) {
            if (attrs.get(attr) == null) {
                TDeb.wri("createColumns(): definition on a null value for:" + attr);
                return -1;
            }
            String DBtyp = getType2DB(attrs.get(attr), DBcontr, MAXTextSize);
            String deb = " ADD (";
            String end = ")";
            String tableplus = getstdTableName(shema, tablename);
            if (DBcontr.compareTo("Apache Derby") == 0) {
                deb = " ADD COLUMN ";
                end = " ";
            } else if (DBcontr.compareTo("ACCESS") == 0) {
                deb = " ADD COLUMN ";
                end = " ";
            }
            res = Trt_in(getstdQuery("ALTER TABLE " + tableplus + deb + getstdColumnName(attr) + " " + DBtyp + end));
            if (res < 0) {
                TDeb.wri(dggcpt + "createColumns() Pb column : " + attr + " as : " + DBtyp + " in : " + tablename);
                return -1;
            }
            TDeb.wri(dggcpt + "|createColumns() : " + attr + " in : " + tablename + " as DBtype: " + DBtyp);
        }
        return res;
    }
    /*
     * Used by Insert_data to (try) to create a row
     */

    private int createRow(String shema, String tablename, java.util.Map<String, Object> attrs) {
        String tableplus = getstdTableName(shema, tablename);
        String values = "";
        ResultSet cols;
        if (cxDB == null) {
            TDeb.wri(dggcpt + "|Pb create Row no DB connexion on " + Parent.getCMDName());
            return -1;
        }
        try {
            cols = cxDB.getMetaData().getColumns(shema, null, tablename, null);
            if (cols == null) {
                TDeb.wri(dggcpt + "|Pb create Row no columns on the table:" + tablename);
                return -1;
            }
            while (cols.next()) {
                String colName = cols.getString("COLUMN_NAME");
                int dataType = cols.getInt("DATA_TYPE");                         // to avoid second reading
                if (attrs.containsKey(colName)) {
                    values = values + "," + getstdDBvalue(attrs.get(colName), dataType);
                } else {
                    if (cols.getString("IS_NULLABLE").compareTo("NO") == 0) {
                        values = values + "," + getstdDBvalue("0", dataType);
                    } else {
                        values = values + ",NULL";
                    }
                }
            }
            if (values.length() > 0) {
                values = values.substring(1, values.length());
            }
            cols.close();
        } catch (SQLException ex) {
            TDeb.wri(dggcpt + "|Pb create Row :" + attrs.toString() + " in table : " + shema + "." + tablename + "=>" + ex.getMessage());
            return -1;
        }
        String request = "INSERT INTO " + tableplus + " VALUES (" + values + ")";
        int res = Trt_in(getstdQuery(request));
        TDeb.wri("createRow(): res=" + res + ",for: " + request);
        if (res < 0) {
            TDeb.wri(dggcpt + "|Pb trying to create Row : " + "INSERT INTO " + tableplus + " VALUES (" + values + ")");
            TDeb.wri(dggcpt + "|Pb trying to create Row : " + attrs + " in table : " + tableplus);
            return -1;
        }
        TDeb.wri(dggcpt + "|ROW created : " + attrs + " in : " + tablename);
        return 0;
    }
    /*
     * Used by XML=>DB building to create contrintes according to XML file
     */

    public int createextconstraint(String localtable, String localattr, String exttable, String extattr) {
        int res = -1;
        String loctableplus = getstdTableName(null, localtable);
        String exttableplus = getstdTableName(null, exttable);
        String locattrplus = getstdColumnName(localattr);
        String extattrplus = getstdColumnName(extattr);
        String keynameplus = getstdColumnName("fk_" + localtable + "_" + exttable);
        // check if constrain exist already
        // for mysql => see http://www.conandalton.net/2008/09/list-foreign-key-constraints-in-oracle.html
        String req = "select * from  information_schema.key_column_usage where  referenced_table_name='" + exttable + "' and table_name='" + localtable + "' and column_name='" + localattr + "';";
        ResultSet resu = Trt_out(req);
        if (req != null) {
            try {
                if (resu.next() == false) {
                    req = "ALTER TABLE " + loctableplus + "  ADD INDEX " + keynameplus + " (" + locattrplus + "), " + "ADD CONSTRAINT " + keynameplus + " FOREIGN KEY " + keynameplus + " (" + locattrplus
                            + ") REFERENCES " + exttableplus + " (" + extattrplus + ") ON DELETE RESTRICT ON UPDATE RESTRICT , ROW_FORMAT = DYNAMIC;";
                    res = Trt_in(getstdQuery(req));
                    TDeb.wri("createextconstraint(): res=" + res + ",for " + req);
                }
            } catch (SQLException ex) {
                TDeb.wri("createextconstraint(): Pb" + ex.getMessage());
                res = -1;
            }
        }
        return res;
    }
    /*
     * Used by Insert_data to (try) to update an existing row
     */

    public int UpdateRow(String shema, String tablename, java.util.Map<String, Object> attrs, java.util.List<String> keys) {
        //// LOOK FOR  Value separator for this column type.
        java.util.Map<String, Integer> attr_type = getattrTypes(shema, tablename, attrs.keySet());
        if (attr_type == null) {
            return -1;
        }
        //update the table
        String req = "UPDATE " + getstdTableName(shema, tablename) + " SET ";
        for (String attr : attrs.keySet()) {
            if (keys.contains(attr) == false) {
                int type = java.sql.Types.VARCHAR;
                if (attr_type.get(attr) != null) {
                    type = attr_type.get(attr);
                }
                req += getstdColumnName(attr) + " = " + getstdDBvalue(attrs.get(attr), type) + ",";
            }
        }
        req = req.substring(0, req.length() - 1);
        req += getWhereKey(shema, tablename, attrs, keys);
        int res = Trt_in(getstdQuery(req));
        //if (res<0){return -1;}//TDeb.wri(dggcpt+"|Pb ["+DBtype+"/"+getCXvalQuote(DBtype,true)+"/"+getCXvalQuote(DBtype,false)+"] trying to Update Row : "+value_id+" in table : "+tablename);return -1;}
        TDeb.wri("UpdateRow(): res=" + res + ",for: " + req);
        return res;
    }

    public String getstdQuery(Object q) {
        // futur Query normaize??
        // null=> error
        String res = "";
        if (q instanceof String) {
            res = (String) q;
        }
        if (q instanceof byte[]) {
            res = new String((byte[]) q);
        }
        if ( res.length() < 5) {
            return null;
        }
        // TDeb.wri("init getstdQuery() : '" + res + "'");
        res = res.trim();
        if (!res.endsWith(";")) {
            res = res + ";";
        }
        /*
         * if (Parent.getDB_type().startsWith("ODBC") &&
         * !Parent.getDB_type().startsWith("ODBC_xls")) { if (res.endsWith(";"))
         * { res = res.substring(0, res.length() - 1); } if
         * (Parent.getDB_type().compareTo("ODBC_xls") == 0) { // tables avec
         * tablename=>[tablename$] //insert into [Sheet1$] values('1','1')=> is
         * OK res = getexcelQuery(res); } }
         */
        TDeb.wri("getstdQuery() = '" + res + "'");
        return res;
    }

    /**
     * modufy a query to 'look like' SQL excel specificities
     *
     * @param res the initial query
     * @return the Exceel compatible query
     */
    private String getexcelQuery(String res) {
        // usefull for manual excel query
        int startpos = res.toUpperCase().indexOf(" FROM ");
        //only to
        if (startpos > 1) {
            int endpos = res.toUpperCase().indexOf(" WHERE ");
            if (endpos == -1) {
                endpos = res.length();
            }
            String tablelist = res.substring(startpos + " FROM ".length(), endpos);
            String[] tables = tablelist.trim().split(",");
            tablelist = "";
            for (String table : tables) {
                if (table.startsWith(identQuote) == false) {
                    table = getstdTableName(null, table);
                }
                tablelist += table + ",";
            }
            tablelist = tablelist.substring(0, tablelist.length() - 1);
            res = res.substring(0, startpos) + " FROM " + tablelist + res.substring(endpos);
        } else if (res.toUpperCase().startsWith("INSERT INTO ")) {
            int endpos = res.toUpperCase().indexOf(" VALUES");
            String thetable = res.substring("INSERT INTO ".length(), endpos).trim();
            res = "INSERT INTO " + getstdTableName(null, thetable) + " " + res.substring(endpos);
        } else if (res.toUpperCase().startsWith("UPDATE ")) {
            int endpos = res.toUpperCase().indexOf(" SET");
            String thetable = res.substring("UPDATE ".length(), endpos).trim();
            res = "UPDATE " + getstdTableName(null, thetable) + " " + res.substring(endpos);
        }
        return res;
    }

    public String getstdColumnName(String name) {
        return identQuote + name + identQuote;
    }

    public String getstdTableName(String shema, String name) {
        if (Parent == null || Parent.getSlave() instanceof T_DB == false) {
           if (shema!=null){
            return shema + "." + name;
           }else{
               return name;
           }
        }
        if (Parent.getDB_type().startsWith("ODBC")) {
            //ODBC => only one catalog...?...
            //NB . is OK with MSACCESS direct (ODBC_mdb)
            if (name.contains(".")) {
                name = name.substring(name.lastIndexOf(".") + 1);
            }
            if (Parent.getDB_type().startsWith("ODBC_xls2")) {
                //possibility of select ... from [table$] 
                name = name.replace("'", "");
                if (name.endsWith("$]") == false) {
                    if (name.endsWith("$") == false) {
                        name += "$";
                    }
                    name = "[" + name + "]";
                }
                // noquote for Excel..
            }

        }
        name = identQuote + name + identQuote;
        if (shema != null && shema.length() > 0 && (Parent == null || Parent.getDB_type().startsWith("ODBC_xls") == false)) {
            name = identQuote + shema + identQuote + "." + name;
        }
        return name;
    }
    /*
     *
     */

    public String getDBquote(int selector, int type) {
        String res = "";
        if (cxDB == null) {
            return "";
        }
        try {
            if (selector == 0) {
                return cxDB.getMetaData().getIdentifierQuoteString();
            }
            ResultSet typrs = cxDB.getMetaData().getTypeInfo();
            int dbt;
            while (typrs.next()) {
                dbt = typrs.getInt("DATA_TYPE");
                if (dbt == type) {
                    if (selector == 1) {
                        return typrs.getString("LITERAL_PREFIX");
                    }
                    if (selector == 2) {
                        return typrs.getString("LITERAL_SUFFIX");
                    }

                }
            }
        } catch (java.sql.SQLException ex) {
            return "";
        }

        return res;
    }

    /**
     * give the value to store in the DB (Excel is french)
     *
     * @param val : the Object received from
     * @param type : the type of the attribut column
     * @return String to set as colname='this'
     */
    public String getstdDBvalue(Object val, int type) {
        String res = null;

        if (val instanceof byte[]) {
            byte[] b = (byte[]) val;
            if (type == java.sql.Types.LONGVARCHAR) {
                res = TUtils.tabTostr(b, " ".charAt(0));
            }
            if (b.length == 1) {
                if (type == java.sql.Types.BOOLEAN || type == java.sql.Types.BIT) {
                    Boolean bool = b[0] == 0;
                    res = bool.toString();
                }
            }
        } else if (val instanceof Integer) {
            int b = (Integer) val;
            if (type == java.sql.Types.BOOLEAN || type == java.sql.Types.BIT) {
                Boolean bool = b == 0;
                res = bool.toString();
            }

        } else if (val instanceof List<?>) {
            List<?> v = (List<?>) val;
            res = "";
            for (int i = 0; i < v.size(); i++) {
                res = res + getstdDBvalue(v.get(i), 9999) + "\r\n";
            }
        } else if (val instanceof java.util.Date
                && (type == java.sql.Types.DATE || type == java.sql.Types.TIMESTAMP)) {
            final java.text.SimpleDateFormat format;
            if (DBcontr.compareTo("ACCESS") == 0 || DBcontr.compareTo("EXCEL") == 0) {
                format = new java.text.SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
            } else {
                format = new java.text.SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
            }
            res = format.format((java.util.Date) val);
        }
        if (type == java.sql.Types.TIMESTAMP && "0".compareTo(val.toString()) == 0) {
            //initial dattimestamp
            return val.toString();
        }
        if (res == null) {
            if (val == null) {
                return "NULL";
            } else {
                res = val.toString();
            }
        }
        if (type != 9999) {
            //&& DBcontr.startsWith("EXCEL")==false !! DATATYPE
            String quote1 = getDBquote(1, type);
            String quote2 = getDBquote(2, type);
            // escape the the Quote value
            if (quote1 != null && quote1.length() > 0) {
                //res = res.replaceAll(quote1, getescapedString() + quote1); KO (regular String??!!)
                if (res != null && res.contains(quote1)) {
                    int i = 0;
                    while (i <= res.length() - quote1.length()) {
                        String cars = res.substring(i, i + quote1.length());
                        // !!! Pb if last car of the string
                        if (cars.compareTo(quote1) == 0) {
                            res = res.substring(0, i) + getescapedString() + res.substring(i);
                            i++;
                        }
                        i++;
                    }
                }
                res = quote1 + res;
            }
            if (quote1 != null &&quote2 != null && quote2.length() > 0) {
                if (quote2.compareTo(quote1) != 0 && res.contains(quote2)) {
                    //     res = res.replaceAll(quote2,  getescapedString() + quote2);
                    int i = 0;
                    while (i <= res.length() - quote1.length()) {
                        if (res.substring(i, i + quote1.length()).compareTo(quote1) == 0) {
                            res = res.substring(0, i) + getescapedString() + res.substring(i);
                            i++;
                        }
                        i++;
                    }
                }
                res = res + quote2;
            }
        }

        return res;
    }

    /*
     * Used by Insert_data and DB=>DB to find a new valid Key (only on
     * Numbers!!) null if table don't exists,....
     */
    public Long getNextLong(String shema, String tablename, String attr_id) {
        boolean isPresent = false;
        String labelIncr = "IS_AUTOINCREMENT";
        try {
            ResultSet ressql = cxDB.getMetaData().getColumns(shema, null, tablename, attr_id);
            while (ressql.next()) {
                if (ressql.getObject("COLUMN_NAME").toString().compareTo(attr_id) == 0) {
                    isPresent = true;
                    for (int i = 1; i < ressql.getMetaData().getColumnCount() + 1; i++) {
                        if (ressql.getMetaData().getColumnLabel(i + 15).toUpperCase().contains("INCREMENT")) {
                            labelIncr = ressql.getMetaData().getColumnLabel(i);
                        }
                    }
                    if (ressql.getObject(labelIncr).toString().toUpperCase().compareTo("NO") == 0) {
                        TDeb.wri("PB looking for next:" + attr_id + "not autoincreent");
                        //return null;
                    }
                }
            }
        } catch (SQLException ex) {
            TDeb.wri("getNextLong() :" + attr_id + " seems not autoincrement =>" + ex.getMessage());
            // return null;
        }
        if (!isPresent) {
            return null;
        }
        Object result = getMaxVal(shema, tablename, attr_id);
        try {
            return Long.parseLong("" + result) + 1L;
        } catch (java.lang.NumberFormatException ex) {
            TDeb.wri("getNextLong : max value for " + shema + "." + tablename + "." + attr_id + "=" + result + "=>" + ex.getMessage());
            return null;
        }
    }

    private Object getMaxVal(String shema, String tablename, String attr_id) {
        ResultSet ressql;
        String req = "SELECT MAX(" + getstdColumnName(attr_id) + ") FROM " + getstdTableName(shema, tablename) + ";";
        ressql = Trt_out(req);
        Object result = null;
        try {
            if (ressql == null) {
                result = null;
            } else {
                if (ressql.first()) {
                    result = ressql.getObject(1);
                }
                ressql.close();
                return result;
            }
        } catch (SQLException ex) {
            TDeb.wri("getMaxVal : Pb searbing SQL table " + tablename + "." + attr_id + " =>" + ex);
            return null;
        }


        return result;
    }
    /*
     * Used by Insert_data to get a 'java' sql representaion of object to send
     */

    private int getDBtype(Class<?> cla) {
        if (cla == null) {
            cla = String.class;
        }
        String cl = cla.getSimpleName();
        if (cl.compareTo("String") == 0) {
            return java.sql.Types.LONGVARCHAR;
        } else if (cl.compareTo("byte[]") == 0) {
            return java.sql.Types.LONGVARCHAR;
        } else if (cl.compareTo("List") == 0) {
            return java.sql.Types.LONGVARCHAR;
        } else if (cl.compareTo("Inet4Address") == 0) {
            return java.sql.Types.VARCHAR;
        } else if (cl.compareTo("Inet6Address") == 0) {
            return java.sql.Types.VARCHAR;
        } else if (cl.compareTo("byte") == 0) {
            return java.sql.Types.SMALLINT;
        } else if (cl.compareTo("Integer") == 0) {
            return java.sql.Types.INTEGER;
        } else if (cl.compareTo("Long") == 0) {
            return java.sql.Types.BIGINT;
        } else if (cl.compareTo("Boolean") == 0) {
            return java.sql.Types.BOOLEAN;
        } else if (cl.compareTo("Timestamp") == 0) {
            return java.sql.Types.TIMESTAMP;
        } else if (cl.compareTo("Date") == 0) {
            return java.sql.Types.DATE;
        } else if (cl.compareTo("Time") == 0) {
            return java.sql.Types.TIME;
        } else if (cl.compareTo("Float") == 0) {
            return java.sql.Types.FLOAT;
        } else if (cl.compareTo("Double") == 0) {
            return java.sql.Types.DOUBLE;
        } else if (cl.compareTo("Char") == 0) {
            return java.sql.Types.CHAR;
        } else {
            return -1;
        }
    }

    /**
     * provide a string used in "CREATE"... matching with a type (java.sql.) and
     * a DB >each value should have a type in a DB
     *
     * @param cxtype the name of the DB found in connexions parametrers
     * @return the Type as String (ex : "INTEGER")
     */
    private String getType2DB(int cxtype, String DBname, int maxSize) {
        //specified one /one because SEVERAL DBTYPE=1 javaSQL TYPE (Ex : MySQL)
        if (DBname == null || cxtype == -9999) {
            return null;
        }
        if (DBname.compareTo("MySQL") == 0) {
            switch (cxtype) {
                case java.sql.Types.INTEGER:
                    return "INTEGER";
                case java.sql.Types.BOOLEAN:
                    return "BOOL";
                case java.sql.Types.BIGINT:
                    return "BIGINT";
                case java.sql.Types.DATE:
                    return "DATE";
                case java.sql.Types.TIMESTAMP:
                    return "TIMESTAMP";
                case java.sql.Types.TIME:
                    return "TIME";
                case java.sql.Types.LONGVARCHAR:
                    return "TEXT";
                case java.sql.Types.VARCHAR:
                    return "VARCHAR(" + maxSize + ")";
                default:
                    return "LONGTEXT";
            }
        } else if (DBname.compareTo("ACCESS") == 0) {
            switch (cxtype) {
                case java.sql.Types.LONGVARCHAR:
                    return "VARCHAR"; //NOTE
                case java.sql.Types.BIGINT:
                    return "COUNTER";
                case java.sql.Types.TIME:
                    return "TIME";
                case java.sql.Types.DATE:
                    return "DATE";
                case java.sql.Types.TIMESTAMP:
                    return "DATETIME";
                default:
                    return "VARCHAR(255)";
            }
        } else if (DBname.compareTo("EXCEL") == 0) {
            // Not OK because table$??...
            switch (cxtype) {
                case java.sql.Types.INTEGER:
                    return "NUMBER";
                case java.sql.Types.BOOLEAN:
                    return "LOGICAL";
                case java.sql.Types.BIGINT:
                    return "DATETIME";
                case java.sql.Types.LONGVARCHAR:
                    return "VARCHAR";
                default:
                    return "VARCHAR";
            }

        } else if (DBname.compareTo("Apache Derby") == 0) {
            switch (cxtype) {
                case java.sql.Types.BIGINT:
                    return "BIGINT";
                case java.sql.Types.INTEGER:
                    return "INTEGER";
                case java.sql.Types.LONGVARCHAR:
                    return "LONG VARCHAR";
                case java.sql.Types.DATE:
                    return "DATE";
                case java.sql.Types.TIMESTAMP:
                    return "TIMESTAMP";
                case java.sql.Types.TIME:
                    return "TIME";
                case java.sql.Types.VARCHAR:
                    return "VARCHAR";
                default:
                    return "VARCHAR";
            }
        }
        return "VARCHAR";
    }

    public static class DB_Model extends AbstractTableModel {
        // for serializable interface

        private static final long serialVersionUID = 1L;
        private com.jdcm.common.D_Utils utils = new com.jdcm.common.D_Utils();
        private List<Object[]> rows = null;
        private String[] columnNames = {};
        private boolean[] columnEditable = {};
        private String[] columnTypeName = {};
        private ResultSetMetaData metaData;
        private Statement statement;
        private String query = "";
        private ResultSet resultSet;
        private Connection dbCX;
        private boolean iswritable = false;
        private D_DBUtils dbutils = new D_DBUtils();

        public DB_Model(ResultSet rSet) {
            String ODBCmdbExc = "[Microsoft][Gestionnaire de pilotes ODBC] État de curseur non valide";
            try {
                resultSet = rSet;
                rows = new java.util.ArrayList<>();
                if (resultSet == null) {
                    Object[] newRow = new Object[1];
                    newRow[0] = "NULL resultSet";
                    rows.add(newRow);
                    fireTableChanged(null);
                    return;
                }
                try {
                    if (resultSet.isClosed()) {
                        Object[] newRow = new Object[1];
                        newRow[0] = "Closed resultSet";
                        rows.add(newRow);
                        fireTableChanged(null);
                        return;
                    }
                } catch (java.lang.UnsupportedOperationException | java.lang.AbstractMethodError ex) {
                    //          TDeb.wri("unsupported close");
                } catch (SQLException ex) {
                    Object[] newRow = new Object[1];
                    newRow[0] = "Error/Exception : " + ex.getMessage();
                    rows.add(newRow);
                    fireTableChanged(null);
                    return;
                }
                metaData = resultSet.getMetaData();
                statement = resultSet.getStatement();
                dbCX = statement.getConnection();
                dbutils.setCX(dbCX);
                int numberOfColumns = metaData.getColumnCount() + 1;
                columnNames = new String[numberOfColumns];
                columnEditable = new boolean[numberOfColumns];
                columnTypeName = new String[numberOfColumns];
                // Get the column names and cache them.
                // Then we can close the connection.
                columnNames[0] = "N";
                columnTypeName[0] = "INTEGER";
                for (int column = 1; column < columnNames.length; column++) {
                    columnNames[column] = metaData.getColumnLabel(column);
                    columnTypeName[column] = metaData.getColumnTypeName(column);
                    java.util.List<String> keys = dbutils.getTableKeys(metaData.getCatalogName(column), metaData.getTableName(column));
                    columnEditable[column] = keys == null || (keys.contains(metaData.getColumnLabel(column)) == false && metaData.isWritable(column));
                }

                ///!!!!! 100 should be the Maxrow value (newt dont return false with access
                while (resultSet.next() && (rows.size() <= resultSet.getStatement().getMaxRows() || resultSet.getStatement().getMaxRows() == 0)) {//&& iserror == false
                    Object[] newRow = new Object[columnNames.length];
                    for (int i = 0; i < columnNames.length; i++) {
                        try {
                            if (i == 0) {
                                //row number...
                                newRow[i] = rows.size() + 1;
                            } else {
                                // data
                                newRow[i] = resultSet.getObject(i);
                            }
                        } catch (SQLException ex) {
                            //OK but how to edit ?? => VERY SLOW
                            //!!MYSQL timestamp='0000-00-00 00:00:00'
                            ///URL+?zeroDateTimeBehavior=convertToNull
                            //Exemple formule xl...SQLerr :[Microsoft][Pilote ODBC Excel] D?passement d'un champ num?rique.
                            //newRow[i]=null;
                            newRow[i] = "SQLerr :" + ex.getMessage();
                        }
                        if (columnTypeName[i].compareTo("CURRENCY") == 0) {
                            if (newRow[i] instanceof java.math.BigDecimal) {
                                newRow[i] = new com.jdcm.common.O_Amount((Number) newRow[i]);
                            }
                        }
                    }
                    if (newRow.length > 1) {
                        //if ( !newRow[1].toString().contains(ODBCmdbExc)) {
                        rows.add(newRow);
                        // }

                    }
                }
                setInsertRow(false);
                // need to check if more the Maxrows() reached?
                //  close(); Need to copy the metaData, bug in jdbc:odbc driver???
                fireTableChanged(null); // Tell the listeners a new table has arrived.
                // fireTableDataChanged();
            } catch (SQLException ex) {
                //          TDeb.wri("Pb getting data [" + ex.getMessage() + "]");
            }
            // NB : !!! SELECT TOP 10 MS==WHERE ROWNUM <= 10 ORACLE==LIMIT 10 MYSQL
            // for getting following result than getMaxrows()
            try {
                resultSet.beforeFirst();
            } catch (SQLException ex) {
                //         TDeb.wri("Could not set back ResultSet before first row :" + ex.getMessage());
            }
        }

        @Override
        public String getColumnName(int column) {
            return columnNames[column];
        }

        public void setQuery(String txt) {
            query = txt;
        }

        public String getQuery() {
            return query;
        }

        public void addResults(ResultSet rSet) {
            try {
                for (int column = 0; column < rSet.getMetaData().getColumnCount(); column++) {
                    if (columnNames[column].compareTo(rSet.getMetaData().getColumnLabel(column + 1)) != 0) {
                        return;
                    }
                }
                while (rSet.next()) {//&& iserror == false
                    Object[] newRow = new Object[columnNames.length];
                    for (int i = 0; i < columnNames.length; i++) {
                        try {
                            if (i == 0) {
                                newRow[i] = rows.size();
                            } else {
                                newRow[i] = rSet.getObject(i);
                            }
                        } catch (SQLException ex) {
                            //OK but how to edit ?? => VERY SLOW
                            //!!MYSQL timestamp='0000-00-00 00:00:00'
                            ///URL+?zeroDateTimeBehavior=convertToNull
                            //newRow[i]=null;
                            newRow[i] = "SQLerr :" + ex.getMessage();

                        }
                    }
                    if (columnNames.length > 0) {
                        rows.add(newRow);
                    }
                }
            } catch (SQLException ex) {
                 System.out.println("addResults() " + ex.getMessage());
            }
        }

        @Override
        public int getColumnCount() {
            return columnNames.length;

        }

        public void close() throws SQLException {
            // System.out.println("Closing db statement");
            resultSet.close();
            statement.close();
        }

        @Override
        protected void finalize() throws Throwable {
            close();
            super.finalize();
        }

        @Override
        public int getRowCount() {
            return rows.size();
        }

        @Override
        public Object getValueAt(int aRow, int aColumn) {
            if (rows instanceof List<?> && rows.size() >= aRow) {
                Object[] row = rows.get(aRow);
                if (row.length < aColumn) {
                    return null;
                }
                return row[aColumn];
            }
            return null;
        }

        @Override
        public boolean isCellEditable(int row, int column) {
            if (column == 0) {
                return false;
            }
            return columnEditable[column];
        }

        @Override
        public Class<?> getColumnClass(int column) {
            int type;
            try {
                type = metaData.getColumnType(column + 1);
            } catch (SQLException e) {
                return super.getColumnClass(column);
            }

            switch (type) {
                case Types.CHAR:
                case Types.VARCHAR:
                case Types.LONGVARCHAR:
                    return String.class;

                case Types.BOOLEAN:
                case Types.BIT:
                    return Boolean.class;

                case Types.TINYINT:
                case Types.SMALLINT:
                case Types.INTEGER:
                    return Integer.class;

                case Types.BIGINT:
                    return Long.class;

                case Types.FLOAT:
                case Types.DOUBLE:
                    return Double.class;

                case Types.DATE:
                    return java.sql.Date.class;
                case Types.TIME:
                    return java.sql.Time.class;
                case Types.TIMESTAMP:
                    return java.sql.Timestamp.class;
                // return java.sql.Date.class;
                case Types.ARRAY:
                    return Object.class;
                case Types.BLOB:
                    return Object.class;
                case Types.CLOB:
                    return Object.class;
                case Types.NULL:
                    return Object.class;
                default:
                    return Object.class;
            }
        }

        public String getstdDBvalue(int column, Object value) {
            int type;
            try {
                type = metaData.getColumnType(column);
            } catch (SQLException e) {
                return value.toString();
            }
            return dbutils.getstdDBvalue(value, type);
        }

        public final void setInsertRow(boolean action) {
            if (iswritable) {
                // add row
                Object[] newRow = new Object[getColumnCount()];
                for (int i = 0; i < getColumnCount(); i++) {
                    try {
                        if (i == 0) {
                            newRow[i] = rows.size();
                        } else {
                            newRow[i] = utils.createObj(Class.forName(metaData.getColumnClassName(i)));
                        }
                    } catch (SQLException | ClassNotFoundException ex) {
                        //OK but how to edit ??
                        newRow[i] = null;
                    }
                }
                rows.add(newRow);
            } else {
                if (action) {
                    rows.remove(rows.size() - 1);
                }
            }
            this.fireTableDataChanged();
        }
        // should be done with T_DB??..

        public void AddInsertRow() {
            int res;
            try {
                String thequery = "INSERT INTO " + metaData.getTableName(1) + " (";
                String qut = dbutils.getDBquote(0, 0);
                /// INSERT ROWS !!!!!!
                for (int col = 0; col < getColumnCount(); col++) {
                    String colName = getColumnName(col);
                    if (colName.equals("")) {
                        continue;
                    }
                    if (col != 0) {
                        thequery = thequery + ", " + qut + colName + qut;
                    } else {
                        thequery = thequery + qut + colName + qut;
                    }
                }
                thequery += ") VALUES (";
                for (int col = 1; col < getColumnCount(); col++) {
                    String val = getstdDBvalue(col, getValueAt(rows.size() - 1, col));
                    if (col != 1) {
                        thequery = thequery + "," + val;
                    } else {
                        thequery += val;
                    }
                }
                thequery += ")";
                //       TDeb.wri("=> " + query);
                thequery = javax.swing.JOptionPane.showInputDialog("SQL Query", thequery);
                if (thequery == null) {
                    return;
                }
                res = statement.executeUpdate(query);
            } catch (SQLException e) {
                //     TDeb.wri("% " + e.getMessage());
                //      TDeb.wri("Error : adding row : " + query + "/" + e.getMessage());
                return;
            }
            //   TDeb.wri("# OK result : " + res);
            if (res > 0) {
                setInsertRow(true);
            }
        }

        public void RemoveRow(int row) {
            int res;
            String table, shema;
            try {
                table = metaData.getTableName(1);
                shema = metaData.getCatalogName(1);
                String tableName = dbutils.getstdTableName(shema, table);
                if (tableName == null) {
                    System.out.println("P_TableEditor.RemoveRow(): Table name returned null.");
                    return;
                }
                java.util.Map<String, Object> attmap = new java.util.HashMap<>();
                java.util.List<String> keys = dbutils.getTableKeys(shema, table);
                for (int col = 1; col < getColumnCount(); col++) {
                    if (keys == null || keys.isEmpty() || keys.contains(getColumnName(col))) {
                        attmap.put(getColumnName(col), getValueAt(row, col));
                    }
                }
                res = dbutils.Delete_datas(shema, table, attmap, keys);
            } catch (SQLException e) {
                //    TDeb.wri("% " + e.getMessage());
                System.err.println("delete failed =>" + e.getMessage());
                return;
            }
            System.err.println("deleted : =>" + res);
            //  TDeb.wri("# OK result : " + res);
            if (res > 0) {
                rows.remove(row);
            }
            fireTableDataChanged();
        }

        public void setEdit(boolean bool) {
            iswritable = bool;
            this.fireTableDataChanged();
        }

        public int Updatecell(Object value, int row, int column) {
            int res;
            String table, shema;
            try {
                table = metaData.getTableName(column);
                shema = metaData.getCatalogName(column);
                String tableName = dbutils.getstdTableName(shema, table);
                //   String tableName=getstdTableName(column);
                // Some of the drivers seem buggy, tableName should not be null.
                if (tableName == null) {
                    System.out.println("P_TableEditor.RemoveRow(): Table name returned null.");
                    return -1;
                }
                java.util.Map<String, Object> attmap = new java.util.HashMap<>();
                java.util.List<String> keys = dbutils.getTableKeys(shema, table);
                for (int col = 1; col < getColumnCount(); col++) {
                    if (metaData.getTableName(col).compareTo(table) == 0
                            && metaData.getCatalogName(column).compareTo(shema) == 0) {
                        if (keys == null || keys.isEmpty() || keys.contains(getColumnName(col))) {
                            if (col != column) {
                                attmap.put(getColumnName(col), getValueAt(row, col));
                            }
                        }
                        if (col == column) {
                            attmap.put(getColumnName(col), value);
                        }
                    }
                }
                res = dbutils.UpdateRow(shema, table, attmap, keys);
            } catch (SQLException e) {
                //    TDeb.wri("% " + e.getMessage());
                System.err.println("Update failed =>" + e.getMessage());
                return -1;
            }
            System.err.println("Updated : =>" + res);
            //     TDeb.wri("# OK result : " + res);
            return res;
        }

        @Override
        public void setValueAt(Object val, int row, int column) {
            Object value = val;
            if (value == null) {
                return;
            }
            if (value.toString().compareTo("null") == 0) {
                value = null;
            }
            if (iswritable) {

                if (row == rows.size() - 1) {
                    rows.get(row)[column] = value;
                } else {
                    // TODO change value in the "UPDATE row"
                    if (Updatecell(value, row, column) > 0) { // change the value
                        // in the DB table. List<Object> dataRow = rows.elementAt(row);
                        rows.get(row)[column] = value;
                    }
                }
            }

        }
    }
}
