package com.jdcm.common;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseWheelEvent;
import javax.swing.JScrollBar;
import javax.swing.event.AncestorEvent;

/**
 * 15022012
 *
 * @author Marc Giboin
 */
/**
 * Customize Scroll Bar to see isScroll();
 *
 */
public class G_AutoScrollBar extends JScrollBar {

    private static final long serialVersionUID = 1L;
    private java.awt.Color COLOR_SCROLL = new java.awt.Color(0, 255, 0, 90);
    private boolean isScrolled = false;

    public G_AutoScrollBar() {
        super();
        init();

    }

    public G_AutoScrollBar(java.awt.Color c) {
        super();
        COLOR_SCROLL = c;
        init();
    }

    private void ajustBar() {
        if (isScrolled && getValueIsAdjusting() == false) {
            setValue(getMaximum());
            return;
        }
        int valmx = getModel().getValue() + getModel().getExtent();
        boolean ismax = valmx == getMaximum();
        if (isScrolled && ismax == false) {//shouldadd something like bar position != max(different than model())
          setAutoScroll(false);
        } else if (isScrolled == false && ismax && getValueIsAdjusting()) {
            setAutoScroll(true);
        }
    }

    private void init() {

        getModel().addChangeListener(new javax.swing.event.ChangeListener() {
            @Override
            public void stateChanged(javax.swing.event.ChangeEvent e) {
                ajustBar();

            }
        });
        addAncestorListener(new javax.swing.event.AncestorListener() {
            @Override
            public void ancestorAdded(AncestorEvent event) {
                if (event.getAncestorParent() instanceof javax.swing.JScrollPane) {
                    // !! vbar='this' but 'this' seems not accessible? 
                    final javax.swing.JScrollBar vbar = ((javax.swing.JScrollPane) event.getAncestorParent()).getVerticalScrollBar();
                    if (((javax.swing.JScrollPane) event.getAncestorParent()).getViewport() != null) {
                        java.awt.Component c = ((javax.swing.JScrollPane) event.getAncestorParent()).getViewport().getView();
                        if (c != null) {
                            c.addMouseWheelListener(new java.awt.event.MouseWheelListener() {
                                @Override
                                public void mouseWheelMoved(MouseWheelEvent e) {
                                    vbar.setValueIsAdjusting(true);
                                    vbar.setValue(vbar.getValue() + e.getUnitsToScroll());
                                    vbar.setValueIsAdjusting(false);
                                }
                            });
                        }

                    }
                }
            }

            @Override
            public void ancestorRemoved(AncestorEvent event) {
                //throw new UnsupportedOperationException("Not supported yet.");
            }

            @Override
            public void ancestorMoved(AncestorEvent event) {
                // throw new UnsupportedOperationException("Not supported yet.");
            }
        });
    }

    public void setColor(Color c) {
        COLOR_SCROLL = c;
    }

    public void setAutoScroll(boolean bool) {
        isScrolled = bool;
        this.repaint();
    }

    public boolean isAutoScroll() {
        return isScrolled;
    }

    @Override
    public void paintComponent(Graphics g) {
        java.awt.Color c = COLOR_SCROLL;
        blockIncrement = getVisibleRect().height;
        Object ob = ((javax.swing.JScrollPane) this.getParent()).getViewport().getView();
        if (ob instanceof java.awt.Component) {
            unitIncrement = ((java.awt.Component) ob).getFontMetrics(((java.awt.Component) ob).getFont()).getHeight();
        }
        super.paintComponent(g);
        if (!isScrolled) {
            c = java.awt.Color.LIGHT_GRAY;
        }
        javax.swing.JButton but = null;
        for (int i = 0; i < getComponentCount(); i++) {
            if (getComponent(i) instanceof javax.swing.JButton) {
                if (getComponent(i).getY() > 0 || getComponent(i).getX() > 0) {
                    // the dicrease button is at (0,0)=> so?? increase one is not !!
                    but = (javax.swing.JButton) getComponent(i);
                }
            }
        }
        //buttons are  definided by protoceted javax.swing.plaf.metal.MetalSrollBarUI scrlui=this.getUI();
        if (but != null) {
            if (getOrientation() == JScrollBar.VERTICAL) {
                g.setColor(c);
                g.fillRect(but.getX() + 1, but.getY() - 4, but.getWidth() - 2, 4);
                g.setColor(java.awt.Color.DARK_GRAY);
                g.drawRect(but.getX() + 1, but.getY() - 4, but.getWidth() - 2, 4);
            } else if (getOrientation() == JScrollBar.HORIZONTAL) {
                g.setColor(c);
                g.fillRect(but.getX() - 4, but.getY() + 1, 4, but.getHeight() - 2);
                g.setColor(java.awt.Color.DARK_GRAY);
                g.drawRect(but.getX() - 4, but.getY() + 1, 4, but.getHeight() - 2);
            } else {
                System.err.println("ScrollBar : unknown Orientation: " + getOrientation());
            }
        }
    }
}
