package com.jdcm.common;

import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.MouseEvent;

/**
 *
 * @author M.Marc GIBOIN
 */
public class G_ButtonTabComponent extends javax.swing.JPanel {
    
    private static final long serialVersionUID = 1L;
    private javax.swing.JTabbedPane pane;
    private boolean isadd = false;
    private java.awt.Component matchingPanel;
    

    public G_ButtonTabComponent(final javax.swing.JTabbedPane p, boolean add, java.awt.Component c) {
        super(new java.awt.BorderLayout());
        isadd = add;
        pane = p;
        if (c == null && pane.getComponentCount() > 0) {
            matchingPanel = pane.getComponent(0);
        } else if (c == null) {
            matchingPanel = new javax.swing.JPanel();
        } else {
            matchingPanel = c;
        }
        setOpaque(false);
        final java.awt.Component comp = this;
        // why not a TextField with dou
        final javax.swing.JLabel label = new javax.swing.JLabel() {
            private static final long serialVersionUID = 1L;
            @Override
            public String getText() {
                int i = pane.indexOfTabComponent(comp);
                if (i != -1) {
                    return pane.getTitleAt(i)+"  ";
                }
                return null;
            }
        };
        
        final javax.swing.JTextField edit = new javax.swing.JTextField();
        edit.setFont(label.getFont());
        edit.setBorder(javax.swing.BorderFactory.createEmptyBorder());
        edit.setMargin(label.getInsets());
        label.addMouseListener(new javax.swing.event.MouseInputAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                if (e.getClickCount() == 2) {
                    remove(label);
                    edit.setText(label.getText());
                    add(edit, java.awt.BorderLayout.CENTER);
                } else if (matchingPanel != null) {
                    pane.setSelectedComponent(matchingPanel);
                }
            }
        });
        edit.addActionListener(new java.awt.event.ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                int i = pane.indexOfTabComponent(comp);
                pane.setTitleAt(i, edit.getText());
                remove(edit);
                add(label, java.awt.BorderLayout.CENTER);
                repaint();
            }
        });

        edit.addFocusListener(new java.awt.event.FocusAdapter() {

            @Override
            public void focusLost(FocusEvent e) {
                remove(edit);
                add(label, java.awt.BorderLayout.CENTER);
            }
        });
        add(label, java.awt.BorderLayout.CENTER);

        final javax.swing.JLabel button = new javax.swing.JLabel();
        if (isadd) {
            button.setText("+");
        } else {
            button.setText("-");
        }

        button.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        button.setFont(new java.awt.Font(button.getFont().getName(), 0, 8));
        //button.setMargin(new java.awt.Insets(0, 0, 0, 0));
        button.setPreferredSize(new java.awt.Dimension(15, 8 ));
        button.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        button.setFocusable(false);
        // button.setBorderPainted(true);
        button.addMouseListener(new java.awt.event.MouseAdapter() {
           // java.awt.Color col=pane.getBackgroundAt(pane.indexOfTabComponent(comp));
            @Override
            public void mouseEntered(MouseEvent e) {
                 button.setOpaque(true);
               button.setBackground(java.awt.SystemColor.scrollbar);
            }
            @Override
            public void mouseExited(MouseEvent e) {
                 button.setOpaque(false);
                 button.setBackground(pane.getBackgroundAt(pane.indexOfTabComponent(comp)));
                 button.setToolTipText(null);
            }
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                int i = pane.indexOfTabComponent(comp);
                if (i != -1 && !isadd) {
                    removeTab(i);
                } else if (isadd) {
                    addTab();
                }
            }
        });
        /*
         * @Override public void actionPerformed(ActionEvent e) {
         *
         * });
         */
        //    button.setRolloverEnabled(true);
        button.setToolTipText("close");
        if (isadd) {
            button.setToolTipText("new");
        }
        add(button, java.awt.BorderLayout.EAST);
    }

    public void addTab() {
        javax.swing.JPanel newPanel = new javax.swing.JPanel();
        pane.insertTab("Tab " + pane.getTabCount(), null, newPanel, null, pane.getTabCount() - 1);
        if (pane.getTabCount() > 1) {
            G_ButtonTabComponent tab = new G_ButtonTabComponent(pane, false, newPanel);
            pane.setTabComponentAt(pane.getTabCount() - 2, tab);
        }
        pane.setSelectedIndex(pane.getTabCount() - 2);
    }

    private void removeTab(int idx) {
        if (idx < 0 || idx >= pane.getTabCount()) {
            return;
        }
        pane.remove(idx);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setLayout(new java.awt.BorderLayout());
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
