
package com.jdcm.common;

import javax.swing.JTextPane;
import javax.swing.plaf.ComponentUI;
import java.awt.Component;
import java.awt.Graphics;
import javax.swing.text.Document;
import javax.swing.text.Element;
import javax.swing.text.JTextComponent;

/**
 *jTexte pane without LineWrap
 * Pb if long text line ??
 * 
 * @author Marc GIBOIN
 */

public class G_NonWrappingTextPane extends JTextPane {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final java.util.List<AfterPaintEventListner> evts = new java.util.ArrayList<>();
    private boolean widthMode=false;

    public G_NonWrappingTextPane() {
        super();
    }
    public boolean getwidthMode (){
        return widthMode;
    }
    public void setwidthMode(boolean bool){
        widthMode=bool;
        if (getParent()!=null){
            getParent().doLayout();
        }
    }
    public static java.awt.Point getlineof(final JTextComponent textComponent, final int offset) {// throws BadLocationException {
        final Document doc = textComponent.getDocument();
        if (offset < 0) {
            return new java.awt.Point(-1, -1);
            //  throw new BadLocationException("Can't translate offset to line", -1);
        } else if (offset > doc.getLength()) {
            return new java.awt.Point(-1, -1);
            ///  throw new BadLocationException("Can't translate offset to line", doc.getLength()+1);
        } else {
            Element map = doc.getDefaultRootElement();
            int line = map.getElementIndex(offset);
            Element lineElem = map.getElement(line);
            int col = offset - lineElem.getStartOffset();
            return new java.awt.Point(col + 1, line + 1);
        }
    }
    // Override getScrollableTracksViewportWidth
    // to preserve the full width of the text

    @Override
    public boolean getScrollableTracksViewportWidth() {
        Component parent = getParent();
        ComponentUI lui = getUI();
        try {
            if (parent != null) {
             //   return true; => display all without scroll (Ex : ethernet complete view)
                // return false => the texte width match with the texte width
                if (widthMode){
                   return true;
                }else{
                   return lui.getPreferredSize(this).width <= parent.getSize().width;
                }
            } else {
                return true;
            }
        } catch (Throwable ex) {
            return true;
        }
    }

    public void addAfterPaintListner(AfterPaintEventListner event) {
        evts.add(event);
    }

    public void removeAfterPaintListner(AfterPaintEventListner event) {
        evts.remove(event);
    }

    @Override
    public void paintComponent(Graphics g) {
        try{
        super.paintComponent(g);
        }catch (Exception ex){
            //at javax.swing.text.BoxView.paintChild(BoxView.java:161)
            System.out.print("G_NonWrappingTextPane=>"+ex);
        }

        if (evts != null && !evts.isEmpty()) {
            for (AfterPaintEventListner evt : evts) {
                evt.afterPaintComponent(g);
            }
        }
  
    }

     //need to overwrite getInputMethodRequests => InputMethodRequestsHandler =>
     // to Hard...
  
    @Override
    public java.awt.im.InputMethodRequests getInputMethodRequests() {
        Document doc = getDocument();
        //   java.awt.im.InputMethodRequests methReq=(java.awt.im.InputMethodRequests)new InputMethodRequestsHandler();

        return null;
    }

    public static class AfterPaintEventListner {

        public AfterPaintEventListner() {
            
        }

        public void afterPaintComponent(Graphics g) {
        }
    }

 }