package com.jdcm.common;

import java.util.Locale;
import java.util.Currency;

/**
 * A amount value (with curency,...) LOCAL is used only for getsymbole(), the
 * country is not used could implement - a curency change with dynamic (source?)
 * change rate - a date of value .. - list of courties for a curency
 * (EUR/USD/..)
 *
 * @author M.Marc GIBOIN
 */
public class O_Amount {

    public double AMOUNT = 0.0;
    public java.util.Locale LOCAL = Locale.getDefault();

    public O_Amount() {
    }

    public O_Amount(double d) {
        AMOUNT = d;
    }

    public O_Amount(double d, Locale l) {
        AMOUNT = d;
        LOCAL = l;
    }

    public O_Amount(Number nb) {

        if (nb instanceof java.math.BigDecimal) {
            AMOUNT = ((java.math.BigDecimal) nb).doubleValue();
        } else {
            try {
                AMOUNT = (Double) nb;
            } catch (Exception ex) {
                AMOUNT = Double.NaN;

            }
        }


    }

    public java.util.Currency getCurrency() {
        return java.util.Currency.getInstance(LOCAL);
    }

    public String getSymbol() {
        return getCurrency().getSymbol(LOCAL);
    }

    public void setAmount(double d) {
        AMOUNT = d;
    }

    public void setCurrency(int curcode) {
        for (int i = 0; i < Locale.getAvailableLocales().length; i++) {
            Locale loc = Locale.getAvailableLocales()[i];
            if (loc.getCountry() != null && loc.getCountry().length() > 0) {
                if (java.util.Currency.getInstance(loc).getNumericCode() == curcode) {
                    LOCAL = loc;
                    i = Locale.getAvailableLocales().length;
                }
            }
        }
    }

    public void setCurrency(java.util.Currency c) {
        if (c == null) {
            return;
        }
        /// !!! TODO : match with currency but country is WRONG ex : US=>Es_Pr, EUR=>fi_FI
        for (int i = 0; i < Locale.getAvailableLocales().length; i++) {
            try {
                Locale loc = Locale.getAvailableLocales()[i];
                loc.toLanguageTag();
                if (loc.getCountry() != null && loc.getCountry().length() > 0) {
                    if (c.equals(java.util.Currency.getInstance(loc))) {
                        LOCAL = Locale.getAvailableLocales()[i];
                        i = Locale.getAvailableLocales().length;
                    }
                }
            } catch (Exception ex) {
                System.out.println("O_Amount.seCurrency(): " + ex.getMessage());
            }
        }
    }
    /**
     * retreive a list of distinct currencies prensent in AvailableLocals
     * @return list currencies
     */
    public java.util.List<Currency> getCurencyList() {
        Locale[] locs = Locale.getAvailableLocales();
        java.util.ArrayList<Currency> avalableCurs = new java.util.ArrayList<>();
        for (Locale loc : locs) {
            try {
                Currency c = java.util.Currency.getInstance(loc);
                c.getCurrencyCode();
                boolean toAdd = true;
                for (int j = 0; j < avalableCurs.size(); j++) {
                    if (c.getNumericCode() == avalableCurs.get(j).getNumericCode()) {
                        toAdd = false;
                        j=avalableCurs.size();
                    }
                }
                if (toAdd) {
                    avalableCurs.add(c);
                }
            } catch (Exception ex) {
                // Currency is Exception for half of countries????
            }
        }
        return avalableCurs;
    }

    private java.util.List<Locale> getCurencyCountries() {
        Locale[] locs = Locale.getAvailableLocales();
        java.util.List<Locale> res = new java.util.ArrayList<>();
        for (Locale loc : locs) {
            if (java.util.Currency.getInstance(loc).getNumericCode() == getCurrency().getNumericCode()) {
                res.add(loc);
            }
        }
        return res;
    }

    @Override
    public String toString() {
        javax.swing.text.NumberFormatter f = new javax.swing.text.NumberFormatter(java.text.NumberFormat.getCurrencyInstance(LOCAL));
        return f.getFormat().format(AMOUNT);
    }

    public int getISO4217NumCode() {
        return this.getCurrency().getNumericCode();
        //return getISO4217NumCode(this.getCurrency());
    }
/*
    public int getISO4217NumCode(java.util.Currency c) {
        String treeCarcode = c.getCurrencyCode();
        Object[][] monList = getCurenciesList();
        for (int i = 0; i < monList.length; i++) {
            if (monList[i][2].toString().compareTo(treeCarcode) == 0) {
                return new Integer(monList[i][3].toString());
            }
        }
        return -1;
    }*/

    public String getFrechName() {

        String treeCarcode = getCurrency().getCurrencyCode();
        Object[][] monList = getCurenciesList();
        for (Object[] monList1 : monList) {
            if (monList1[2].toString().compareTo(treeCarcode) == 0) {
                return monList1[1].toString() + "[" + treeCarcode + "]";
            }
        }
        return "";
    }

    private Object[][] getCurenciesList() {
        //ISO CTRY CODE / LIBELLE / ISO421/Currency COde /TODO COUNTRY (iso??)=> Local/CTRY NAME
        Object[][] list = {{4, "Afghani", "AFA", 4, "AF", "AFGHANISTAN"},
            {8, "Lek", "ALL", 8, "AL", "ALBANIA"},
            {12, "Algerian Dinar", "DZD", 12, "DZ", "ALGERIA"},
            {16, "Dollar des Etats-unis", "USD", 840, "AS", "AMERICAN SAMOA"},
            {20, "Euro", "EUR", 978, "AD", "ANDORRA"},
            {24, "Kwanza", "AOA", 973, "AO", "ANGOLA"},
            {28, "Dollar des Caraïbes de l'Est", "XCD", 951, "AG", "ANTIGUA AND BARBUDA"},
            {31, "Azerbaijanian Manat", "AZM", 31, "AZ", "AZERBAIJAN"},
            {32, "Peso", "ARS", 32, "AR", "ARGENTINA "},
            {36, "Dollar australien", "AUD", 36, "AU", "AUSTRALIA"},
            {40, "Euro", "EUR", 978, "AT", "AUSTRIA"},
            {44, "Dollar des Bahamas", "BSD", 44, "BS", "BAHAMAS"},
            {48, "Dinar de Bahreïn", "BHD", 48, "BH", "BAHRAIN"},
            {50, "Taka", "BDT", 50, "BD", "BANGLADESH"},
            {51, "Dram", "AMD", 51, "AM", "ARMENIA "},
            {52, "Dollar de Barbade", "BBD", 52, "BB", "BARBADOS"},
            {56, "Euro", "EUR", 978, "BE", "BELGIUM"},
            {60, "Dollar des Bermudes", "BMD", 60, "BM", "BERMUDA"},
            {64, "Ngultrum", "BTN", 64, "BT", "BHUTAN"},
            {68, "Boliviano", "BOB", 68, "BO", "BOLIVIA"},
            {70, "Mark bosniaque convertible", "BAM", 977, "BA", "BOSNIA AND HERZEGOWINA"},
            {72, "Pula", "BWP", 72, "BW", "BOTSWANA"},
            {74, "Couronne norvégienne", "NOK", 578, "BV", "BOUVET ISLAND"},
            {76, "Real", "BRL", 986, "BR", "BRAZIL"},
            {84, "Dollar de Belize", "BZD", 84, "BZ", "BELIZE"},
            {86, "Dollar des Etats-unis", "USD", 840, "IO", "BRITISH INDIAN OCEAN TERRITORY "},
            {90, "Dollar des îles Salomon", "SBD", 90, "SB", "SOLOMON ISLANDS"},
            {92, "Dollar des Caraïbes orientales", "XCD", 951, "VG", "VIRGIN ISLANDS (BRITISH)"},
            {96, "Dollar de Brunéi", "BND", 96, "BN", "BRUNEI DARUSSALAM"},
            {100, "Lev", "BGN", 975, "BG", "BULGARIA"},
            {104, "Kyat", "MMK", 104, "MM", "MYANMAR"},
            {108, "Franc du Burundi", "BIF", 108, "BI", "BURUNDI"},
            {112, "Rouble biélorusse", "BYR", 974, "BY", "BELARUS"},
            {116, "Riel", "KHR", 116, "KM", "CAMBODIA"},
            {120, "Franc CFA - BEAC", "XAF", 950, "CN", "CAMEROON"},
            {124, "Dollar canadien", "CAD", 124, "CA", "CANADA"},
            {132, "Escudo du Cap-Vert", "CVE", 132, "CV", "CAPE VERDE"},
            {136, "Dollar des îles Caïmanes", "KYD", 136, "KY", "CAYMAN ISLANDS"},
            {140, "FRANC CFA-BEAC", "XAF", 950, "CF", "CENTRAL AFRICAN REPUBLIC"},
            {144, "Roupie de Sri Lanka", "LKR", 144, "LK", "SRI LANKA"},
            {148, "Franc CFA - BEAC", "XAF", 950, "TD", "CHAD"},
            {152, "Peso chilien", "CLP", 152, "CL", "CHILE"},
            {156, "Yuan Ren-Min-Bi", "CNY", 156, "CN", "CHINA"},
            {158, "Nouveau dollar de Taïwan", "TWD", 901, "CN", "CHINA"},
            {162, "Dollar australien", "AUD", 36, "CX", "CHRISTMAS ISLAND"},
            {166, "Dollar australien", "AUD", 36, "CC", "COCOS (KEELING) ISLANDS"},
            {170, "Peso colombien", "COP", 170, "CO", "COLOMBIA"},
            {174, "Franc des Comores", "KMF", 174, "KM", "COMOROS"},
            {175, "Euro", "EUR", 978, "YT", "MAYOTTE"},
            {178, "Franc CFA - BEAC", "XAF", 950, "", ""},
            {180, "FRANC DU CONGO DEMOCRATIQUE", "CDF", 976, "", ""},
            {184, "Dollar néo-zélandais", "NZD", 554, "", ""},
            {188, "Colon de Costa Rica", "CRC", 188, "", ""},
            {191, "Kuna", "HRK", 191, "", ""},
            {192, "Peso cubain", "CUP", 192, "", ""},
            {196, "Livre cypriote", "CYP", 196, "", ""},
            {203, "Couronne tchèque", "CZK", 203, "", ""},
            {204, "Franc CFA - BCEAO", "XOF", 952, "", ""},
            {208, "Couronne danoise", "DKK", 208, "", ""},
            {212, "Dollar des Caraïbes de l'Est", "XCD", 951, "", ""},
            {214, "Peso dominicain", "DOP", 214, "", ""},
            {218, "Dollar des Etats-unis", "USD", 840, "", ""},
            {222, "Colon salvadorien", "SVC", 222, "", ""},
            {226, "Franc CFA - BEAC", "XAF", 950, "", ""},
            {231, "Birr éthiopien", "ETB", 230, "", ""},
            {232, "Nafka", "ERN", 232, "", ""},
            {233, "Couronne d'Estonie", "EEK", 233, "", ""},
            {234, "Couronne danoise", "DKK", 208, "DK", ""},
            {238, "Livre de Falkland", "FKP", 238, "", ""},
            {239, "Dollar des Etats-unis", "GHC", 288, "", ""},
            {242, "Dollar des Fidji", "FJD", 242, "FJ", ""},
            {246, "Euro", "EUR", 978, "FI", ""},
            {250, "Euro", "EUR", 978, "FR", ""},
            {254, "Euro", "EUR", 978, "", ""},
            {258, "Franc du Pacifique", "XPF", 953, "", ""},
            {260, "Euro", "EUR", 978, "", ""},
            {262, "Franc de Djibouti", "DJF", 262, "", ""},
            {266, "Franc CFA - BEAC", "XAF", 950, "", ""},
            {268, "Lari", "GEL", 981, "", ""},
            {270, "Dalasie", "GMD", 270, "", ""},
            {276, "Euro", "EUR", 978, "", ""},
            {288, "Cedi", "GHC", 288, "", ""},
            {292, "Livre de Gibraltar", "GIP", 292, "", ""},
            {296, "Dollar australien", "AUD", 36, "", ""},
            {300, "Euro", "EUR", 978, "", ""},
            {304, "Couronne danoise", "DKK", 208, "", ""},
            {308, "Dollar des Caraïbes occidentales", "XCD", 951, "", ""},
            {312, "", "", -1, "GP", "GUADELOUPE"},
            {316, "Dollar des Etats-unis", "USD", 840, "", ""},
            {320, "Quetzal", "GTQ", 320, "", ""},
            {324, "Franc guinéen", "GNF", 324, "", ""},
            {328, "Dollar de Guyane", "GYD", 328, "", ""},
            {332, "Gourde", "HTG", 332, "", ""},
            {334, "Dollar australien", "AUD", 36, "", ""},
            {336, "Euro", "EUR", 978, "", ""},
            {340, "Lempira", "HNL", 340, "", ""},
            {344, "Dollar de Hong-Kong", "HKD", 344, "", ""},
            {348, "Forint", "HUF", 348, "", ""},
            {352, "Couronne islandaise", "ISK", 352, "", ""},
            {356, "Roupie indienne", "INR", 356, "", ""},
            {360, "Rupiah", "IDR", 360, "", ""},
            {364, "Rial iranien", "IRR", 364, "", ""},
            {368, "Dinar iraquien", "IQD", 368, "", ""},
            {372, "Euro", "EUR", 978, "", ""},
            {376, "Sheqel", "ILS", 376, "", ""},
            {380, "Euro", "EUR", 978, "", ""},
            {384, "Franc CFA - BCEAO", "XOF", 952, "", ""},
            {388, "Dollar jamaïcain", "JMD", 388, "", ""},
            {392, "Yen", "JPY", 392, "", ""},
            {398, "Tenge", "KZT", 398, "", ""},
            {400, "Dinar jordanien", "JOD", 400, "", ""},
            {404, "Shilling du Kenya", "KES", 404, "", ""},
            {408, "Won de la Corée du Nord", "KPW", 408, "", ""},
            {410, "Won", "KRW", 410, "", ""},
            {414, "Dinar koweïtien", "KWD", 414, "", ""},
            {417, "Som", "KGS", 417, "", ""},
            {418, "Kip", "LAK", 418, "", ""},
            {422, "Livre libanaise", "LBP", 422, "", ""},
            {426, "Loti", "LSL", 426, "", ""},
            {428, "Lats letton", "LVL", 428, "", ""},
            {430, "Dollar libérien", "LRD", 430, "", ""},
            {434, "Dinar libyen", "LYD", 434, "", ""},
            {438, "Franc suisse", "CHF", 756, "", ""},
            {440, "Litas lituanien", "LTL", 440, "", ""},
            {442, "Euro", "EUR", 978, "", ""},
            {446, "Pataca", "MOP", 446, "", ""},
            {450, "Franc malgache", "MGF", 450, "", ""},
            {454, "Kwacha", "MWK", 454, "", ""},
            {458, "Ringgit de Malaisie", "MYR", 458, "", ""},
            {462, "Rufiyaa", "MVR", 462, "", ""},
            {466, "Franc CFA - BCEAO", "XOF", 952, "", ""},
            {470, "Livre maltaise", "MTL", 470, "", ""},
            {474, "Euro", "EUR", 978, "", ""},
            {478, "Ouguija", "MRO", 478, "", ""},
            {480, "Roupie mauricienne", "MUR", 480, "", ""},
            {484, "Peso mexicain", "MXN", 484, "", ""},
            {492, "Euro", "EUR", 978, "", ""},
            {496, "Tugrik", "MNT", 496, "", ""},
            {498, "Leu de Moldave", "MDL", 498, "", ""},
            {500, "Dollar des Caraïbes de l'Est", "XCD", 951, "", ""},
            {504, "Dirham marocain", "MAD", 504, "", ""},
            {508, "Metical", "MZN", 943, "", ""},
            {512, "Rial Omani", "OMR", 512, "", ""},
            {516, "Dollar namibien", "NAD", 516, "", ""},
            {520, "Dollar Australien", "AUD", 36, "", ""},
            {524, "Roupie Népalaise", "NPR", 524, "", ""},
            {528, "Euro", "EUR", 978, "", ""},
            {530, "Florin des Antilles", "ANG", 532, "", ""},
            {533, "Florin d'Aruba", "AWG", 533, "", ""},
            {540, "Franc CFP", "XPF", 953, "", ""},
            {548, "Vatu", "VUV", 548, "", ""},
            {554, "Dollar néo-zélandais", "NZD", 554, "", ""},
            {558, "Cordoba oro", "NIO", 558, "", ""},
            {562, "Franc CFA (émis par la BCEAO)", "XOF", 952, "", ""},
            {566, "Naira", "NGN", 566, "", ""},
            {570, "Dollar néo-zélandais", "NZD", 554, "", ""},
            {574, "Dollar australien", "AUD", 36, "", ""},
            {578, "Couronne norvégienne", "NOK", 578, "", ""},
            {580, "Dollar des Etats-unis", "USD", 840, "", ""},
            {581, "Dollar des Etats-unis", "USD", 840, "", ""},
            {583, "Dollar des Etats-unis", "USD", 840, "", ""},
            {584, "Dollar des Etats-unis", "USD", 840, "", ""},
            {585, "Dollar des Etats-unis", "USD", 840, "", ""},
            {586, "Roupie pakistanaise", "PKR", 586, "", ""},
            {591, "Balboa", "PAB", 590, "", ""},
            {598, "Kina", "PGK", 598, "", ""},
            {600, "Guarani", "PYG", 600, "", ""},
            {604, "Nouveau sol", "PEN", 604, "", ""},
            {608, "Peso philippin", "PHP", 608, "", ""},
            {612, "Dollar néo-zélandais", "NZD", 554, "", ""},
            {616, "Zloty", "PLN", 985, "", ""},
            {620, "Euro", "EUR", 978, "", ""},
            {624, "Franc CFA - BCEAO", "XOF", 952, "", ""},
            {626, "Rupiah", "IDR", 360, "", ""},
            {630, "Dollar des États-Unis", "USD", 840, "", ""},
            {634, "Riyal du Qatar", "QAR", 634, "", ""},
            {638, "Euro", "EUR", 978, "", ""},
            {642, "Leu", "ROL", 642, "", ""},
            {643, "Rouble russe (nouveau)", "RUB", 643, "", ""},
            {646, "Franc du Rwanda", "RWF", 646, "", ""},
            {654, "Livre de Sainte-Hélène", "SHP", 654, "", ""},
            {659, "Dollar des Caraïbes orientales", "XCD", 951, "", ""},
            {660, "Dollar des Caraïbes de l'Est", "XCD", 951, "", ""},
            {662, "Dollar des Caraïbes orientales", "XCD", 951, "", ""},
            {666, "Euro", "EUR", 978, "", ""},
            {670, "Dollar des Caraïbes orientales", "XCD", 951, "", ""},
            {674, "Euro", "EUR", 978, "", ""},
            {678, "Dobra", "STD", 678, "", ""},
            {682, "Riyal saoudien", "SAR", 682, "", ""},
            {686, "Franc CFA - BCEAO", "XOF", 952, "", ""},
            {690, "Roupie des Seychelles", "SCR", 690, "", ""},
            {694, "Leone", "SLL", 694, "", ""},
            {702, "Dollar de Singapour", "SGD", 702, "", ""},
            {703, "Couronne slovaque", "SKK", 703, "", ""},
            {704, "Dong", "VND", 704, "", ""},
            {705, "Tolar", "SIT", 705, "SI", "SLOVENIA"},
            {706, "Shilling Somalien", "SOS", 706, "SO", "SOMALIA"},
            {710, "Rand", "ZAR", 710, "", ""},
            {716, "Dollar du Zimbabwe", "ZWD", 716, "", ""},
            {724, "Euro", "EUR", 978, "", ""},
            {732, "Dirham marocain", "MAD", 504, "", ""},
            {-1, "Slovak Koruna", "SKK", 703, "SK", "SLOVAKIA"},
            {736, "Dinar soudanais", "SDD", 736, "SD", "SUDAN"},
            {-1, "Livre soudanaise", "SDG", 938, "SD", "SUDAN"},
            {740, "Florin du suriname", "SRD", 968, "", ""},
            {748, "Lilangeni", "SZL", 748, "", ""},
            {752, "Couronne suédoise", "SEK", 752, "", ""},
            {756, "Franc suisse", "CHF", 756, "", ""},
            {760, "Livre syrienne", "SYP", 760, "", ""},
            {762, "Somoni", "TJS", 972, "", ""},
            {764, "Baht", "THB", 764, "", ""},
            {768, "Franc CFA - BCEAO", "XOF", 952, "", ""},
            {772, "Dollar néo-zélandais", "NZD", 554, "", ""},
            {776, "Pa'anga", "TOP", 776, "", ""},
            {780, "Dollar de Trinité et de Tobago", "TTD", 780, "", ""},
            {784, "Dirham des émirats arabes unis", "AED", 784, "", ""},
            {788, "Dinar tunisien", "TND", 788, "", ""},
            {792, "Livre turque", "TRL", 792, "", ""},
            {795, "Manat turkmène", "TMM", 795, "", ""},
            {796, "Dollar des Etats-unis", "USD", 840, "", ""},
            {798, "Dollar australien", "AUD", 36, "", ""},
            {800, "Shilling ougandais", "UGX", 800, "", ""},
            {804, "HRYVNIA", "UAH", 980, "", ""},
            {807, "Denar", "MKD", 807, "", ""},
            {818, "Livre égyptienne", "EGP", 818, "", ""},
            {826, "Livre sterling", "GBP", 826, "", ""},
            {834, "Shilling tanzanien", "TZS", 834, "", ""},
            {840, "Dollar des États-Unis", "USD", 840, "", ""},
            {850, "Dollar des États-Unis", "USD", 840, "US", ""},
            {854, "Franc CFA - BCEAO", "XOF", 952, "", ""},
            {858, "Nouveau Peso uruguayen", "UYU", 858, "", ""},
            {860, "Soum ouzbek", "UZS", 860, "", ""},
            {862, "Bolivar", "VEB", 862, "", ""},
            {876, "Franc CFP", "XPF", 953, "", ""},
            {882, "Tala", "WST", 882, "", ""},
            {887, "Riyal yéménite", "YER", 886, "", ""},
            {894, "Kwacha de Zambie", "ZMK", 894, "", ""},
            {-1, "Franc Francais", "FRF", 250, "F", "FRANCE"},
            {941, "Dinar Serbe", "RSD", 941, "", ""}};
        return list;
    }
}
