package com.jdcm.common;

/**
 * an X25 address (not found in java??)
 * 
 * @author M.Marc GIBOIN
 */
public class O_X25address {

    static final int SIZE_MIN = 4;
    static final int SIZE_MAX = 15;
    private String address = null;

    public O_X25address() {
        address = "196281234";
    }

    public O_X25address(String txt) throws Exception {
        try {
            txt=checkx25(txt);
            address = txt;
        } catch (Exception ex) {
            throw new Exception("can't assign " + txt + " as X25 address");
        }

    }

    public O_X25address(int nb) throws Exception {
        String txt = "" + nb;
        try {
            txt=checkx25(txt);
            address = txt;
        } catch (Exception ex) {
            throw new Exception("can't assign " + txt + " as X25 address");
        }
    }

    public String getValue() {
        return address;
    }

    public void setValue(String txt) throws Exception {
        try {
            txt=checkx25(txt);
            address = txt;
        } catch (Exception ex) {
            throw new Exception("can't assign " + txt + " as X25 address");
        }
    }
    private String checkx25(String txt) throws Exception {
        String res=txt.trim();
        if (res == null) {
            throw new Exception("can't accept null as X25 adress");
        } else if (res.length() < SIZE_MIN || res.length() > SIZE_MAX) {
            throw new Exception("can't tranlated to X25/" + res.length() + " , wainted: " + SIZE_MIN + " < x25 <" + SIZE_MAX);
        } else {
            try{
                Long l=new Long(txt);
            }catch(NumberFormatException ex){
                throw new Exception("can't tranlated to x25/" + txt.length() + " , shoult be only numeric values");
            }
        }
        return txt;
    }
    @Override
    public String toString() {
        return address;
    }
    public String getdetail() {
        String txt;
        if (address.startsWith("1")){
            // frechn??
            txt="French departement: "+ address.substring(1,3)
                    +"\r\n national address: "+address.substring(3, 9);
            if (txt.length()>10){
                txt=txt+"\r\n private address: "+address.substring(9);
            }
        }else{
            //http://support.microsoft.com/kb/123203
            txt="DNIC : country code : "+ address.substring(1,3)
                    +"\r\n DNIC : Network identifier: "+address.substring(3, 4)
                    +"\r\n Network address: "+address.substring(5, 12);
            if (txt.length()>12){
                txt=txt+"\r\n private address: "+address.substring(12);
            }
        }
        return txt;
    }
}
