package com.jdcm.common;

/**
 *  XPacket.java Created on 22 decembre 2004, 21:44
 * used to tree<=>file/tree<=>text should exist as built in in java??? 
 * Pb with locator.encoding values (EX :iso85..-1)
 * Pb on WEB  pages with <meta!!!!> 
 * @author Marc GIBOIN
 */
import com.jdcm.eltrx.D_Debug;
import java.io.IOException;
import java.io.InputStream;
import java.util.LinkedList;
import javax.swing.tree.*;
import javax.xml.parsers.ParserConfigurationException;

import org.xml.sax.*;
import org.xml.sax.ext.DefaultHandler2;
import org.xml.sax.ext.Locator2Impl;
import org.xml.sax.ext.Locator2;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;

public class XML2tree extends DefaultHandler2 {

    private D_Debug TDeb;
    private final D_Utils TUtils = new D_Utils();
    private final LinkedList<LinkedList<Object>> deep= new java.util.LinkedList<>();
    
    private LinkedList<Object> rows = new java.util.LinkedList<>();
    // to be reorganized to get only one type under List (String & XMLRES)
    private Locator2 locator;
    private XML2tree handler;
  //  private String[][] order = null;

    public XML2tree() {
    }

    /**
     * Care the stream should comes from  TUtils.getFileStream() for JAR management
     * @param instr the stream
     * @return the tree!!
     */
    public DefaultTreeModel XMLBase(java.io.InputStream instr) {
        TDeb = new D_Debug("Xfilter");
        // Use an instance of ourselves as the SAX event handler
        if (instr == null) {
            return null;
        }
        return saxer(instr);
    }

    public DefaultTreeModel XMLBase(byte[] by) {
        TDeb = new D_Debug("Xfilter");
        // Use an instance of ourselves as the SAX event handler
        if (by == null || by.length == 0) {
            return null;
        }
        InputStream instr = new java.io.ByteArrayInputStream(by);
     /*   if (instr == null) {
            TDeb.wri("file not found : " + by.toString());
            return null;
        }*/
        return saxer(instr);
    }

    /**
     * made because NB6.9=>Out warnings
     *
     * @param message he message to log (on out Standard Stream
     */
    public void tolog(String message) {
        System.out.println("XML2tree: " + message);
    }

    /**
     * Save tree to XML file
     *
     * @param mod the tree to save as XML file
     * @param out output XML stream (file)
     */
    public void savetree2XML(javax.swing.tree.TreeModel mod, java.io.OutputStream out) {
        if (out == null || mod == null) {
            return;
        }
        if (mod.isLeaf(mod.getRoot())) {
            TDeb.wri("Empty root");
            return;
        }
        if (mod.getRoot() instanceof DefaultMutableTreeNode) {
            DefaultMutableTreeNode entete = (DefaultMutableTreeNode) mod.getRoot();
            String code = null;
            if (entete.getUserObject() instanceof XMLhdr) {
                code = ((XMLhdr) entete.getUserObject()).getEncoding();
            }
            if (code == null) {
                code = "UTF-8";
            }
            node2XML(mod, entete, out, code);
        }
        try {
            out.close();
        } catch (IOException ex) {
            TDeb.wri("=>" + ex.getMessage());
        }
    }

    public String node2XML(TreeModel mod, DefaultMutableTreeNode treenode) {
        java.io.ByteArrayOutputStream o = new java.io.ByteArrayOutputStream();
        String code = null;
        if (treenode.getUserObject() instanceof XMLhdr) {
            code = ((XMLhdr) treenode.getUserObject()).getEncoding();
        }
        if (code == null) {
            code = "UTF-8";
        }
        if (node2XML(mod, treenode, o, code)) {
            return o.toString();
        } else {
            return null;
        }
    }

    /**
     * CARE recursiv => node is the parent of writted node
     *
     * @param mod the tree to writ as XML
     * @param node the parent node of writted branch/leaf
     * @param out the stream for outpout
     * @param code the ISO/UTF
     * @return
     */
    private boolean node2XML(TreeModel mod, DefaultMutableTreeNode node, java.io.OutputStream out, String code) {
        //   String type = "UTF-8";
        String entete="";
        String hdr = "";
        XMLres Obj = null;
        if (node.isRoot()) {
            entete = node.toString();
        } else {
            if (node.getUserObject() instanceof XMLres) {
                Obj = (XMLres) node.getUserObject();
            } else {
                TDeb.wri("XML node Object (resut) is null");
                return false;
            }
            char[] hdrbuff = new char[node.getLevel()-1];
            java.util.Arrays.fill(hdrbuff, "\t".charAt(0));
            hdr = new String(hdrbuff);
            if (Obj != null) {
                entete +=  "\r\n"+  hdr + "<" + Obj.toString();
                for (String name:Obj.getAttrNames()) {
                    if (Obj.getAttrVal(name) != null) {
                        entete = entete + " " + name + "=\"" + codedString(TUtils.getObj2str(Obj.getAttrVal(name)), code) + "\"";
                    }
                }
                if (mod.getChildCount(node) == 0 && Obj.length() > 0 && Obj.getValue() == null) {
                    entete += "/>";
                } else {
                    entete += ">";
                }
                if (Obj.getValue() != null) {
                    entete += codedString(Obj.getValue().toString(), code);
                }
            }
        }
        try {
            out.write(entete.getBytes());
        } catch (IOException ex) {
            TDeb.wri("XML Pb writing out");
            return false;
        }
        entete = null;
        //
        if (mod.getChildCount(node) > 0) {
            for (int i = 0; i < mod.getChildCount(node); i++) {
                if (mod.getChild(node, i) instanceof DefaultMutableTreeNode) {
                    node2XML(mod, (DefaultMutableTreeNode) mod.getChild(node, i), out, code);
                }
            }
            if (Obj != null) {
                entete = "\r\n" + hdr + "</" + Obj.toString() + ">";
            }
        } else {
            if (Obj != null && (Obj.getValue() != null || Obj.length() == 0)) {
                entete = "</" + Obj.toString() + ">";
            }
        }
        if (entete != null) {
            try {
                out.write(entete.getBytes());
            } catch (IOException ex) {
                TDeb.wri("XML Pb writing out");
                return false;
            }
        }
        return true;
    }

    private String codedString(String txt, String code) {
        String res = "";
        if (txt == null) {
            return res;
        }
        try {
            res = new String(txt.getBytes(), code);
        } catch (java.io.UnsupportedEncodingException ex) {
            TDeb.wri("Unsupported code : " + code + " : " + ex.getMessage());
            return new String(txt.getBytes());
        }
        res=res.trim();
        if (res.startsWith("<!") && res.endsWith(">")) {
            // commentaires ex: <![CDDATA...>
        } else {
            res = res.replaceAll("\"", "&quot;");
            res = res.replaceAll("'", "&apos;");
            res = res.replaceAll(">", "&gt;");
            res = res.replaceAll("<", "&lt;");
            res = res.replaceAll("&", "&amp;");
        }
        return res;
    }
/*
    public void setorder(String[][] ord) {
        order = ord;
    }
*/
    private DefaultTreeModel saxer(InputStream in) {
        handler = new XML2tree();
        /* handler.setorder(order);
         handler.rows = new java.util.LinkedList<Object>();//XMLhdr
         handler.deep = new java.util.LinkedList<LinkedList<Object>>();*/
        // locator = new Locator2Impl();
        try {
            // Set up output stream
            //      out = new OutputStreamWriter(System.out);
            handler.deep.add(handler.rows);
            // Parse the input
            SAXParserFactory factory = SAXParserFactory.newInstance();
            SAXParser saxParser = factory.newSAXParser();
            InputSource is = new InputSource(in);
            //is.setEncoding("ISO-8859-1");
            saxParser.parse(is, handler);
            handler.rows.add(0, new XMLhdr(handler.locator.getXMLVersion(), handler.locator.getEncoding()));
            in.close();
        } catch (org.xml.sax.SAXParseException exs) {
                try {
                    in.close();
                } catch (IOException exe) {
                    TDeb.wri("Pb to parse XML Stream =>" + exe.getMessage());
                }
            TDeb.wri("Pb to parse XML Stream =>" + exs.getMessage());
            TDeb.wri("       => line: " + exs.getLineNumber() + " col :" + exs.getColumnNumber());
            return null;
        } catch (IOException | ParserConfigurationException | SAXException t) {
                try {
                    in.close();
                } catch (IOException ex) {
                     TDeb.wri("Pb to parse XML Stream =>" + ex.getMessage());
                }
            TDeb.wri("Pb XML file :" + t.getMessage());
            return null;
        }
        rows = handler.rows;
        DefaultTreeModel treeModel = new DefaultTreeModel(node(rows));
        return treeModel;
    }

    private DefaultMutableTreeNode node(LinkedList<Object> v) {
        DefaultMutableTreeNode node0 = new DefaultMutableTreeNode(v.getFirst());
        DefaultMutableTreeNode node1;
        for (int i = 1; i < v.size(); i++) {
            //WARNING but eprouved...
            @java.lang.SuppressWarnings("unchecked")
            LinkedList<Object> svect = (LinkedList<Object>) v.get(i);
            node1 = node(svect);
            node0.add(node1);
        }
        return node0;
    }

    //   static private java.io.Writer out;

    //===========================================================
    // SAX DocumentHandler methods
    //===========================================================
    @Override
    public void setDocumentLocator(Locator value) {
        /* if (value instanceof Locator2 || value == null) {
         locator=(Locator2) value;
         }*/
        locator = new Locator2Impl(value);
        //(new org.xml.sax.ext.DefaultHandler2()).
    }

    @Override
    public void startDocument()
            throws SAXException {
        // TDeb.wri("Start XML document");
    }

    @Override
    public void endDocument()
            throws SAXException {
        /*   TDeb.wri("Stop XML document");
         try {
         //    out.flush();
         } catch (java.io.IOException e) {
         throw new SAXException("I/O error in Packet XML", e);
         }*/
    }

    @Override
    public void startElement(String namespaceURI,
            String sName, // simple name
            String qName, // qualified name
            Attributes attrs)
            throws SAXException {
        String eName = sName; // element name
        if ("".equals(eName)) {
            eName = qName;
        }// not namespaceAware
        //   tolog("Start > ename:"+eName+" :=>"+namespaceURI);

        LinkedList<Object> newRow = new LinkedList<>();
        XMLres res = new XMLres(eName, attrs);//eName
        for (String name:res.getAttrNames()) {
            if (res.getAttrVal(name) != null) {
                res.setAttrVal(name, TUtils.getstr2Obj(res.getAttrVal(name).toString()));
            }
        }
        newRow.add(res);
        // to organize to get one type only (XMLRES & List)
        deep.getLast().add(newRow);
        deep.add(newRow);
        //TDeb.wri(" new element : "+sName);
    }

    @Override
    public void endElement(String namespaceURI,
            String sName, // simple name
            String qName // qualified name
            )
            throws SAXException {
        /* String eName = sName;
         if ("".equals(eName)) {
         eName = qName;
         } */// not namespaceAware
        //tolog("End > eName:"+eName);
        deep.remove(deep.getLast());
    }

    @Override
    public void characters(char buf[], int offset, int len)
            throws SAXException {
        // tolog("\r\n+++"+new String(buf));
        String s = new String(buf, offset, len);
        LinkedList<Object> last = deep.getLast();
        s = s.trim();
        if (s == null || s.length() == 0) {
            return;
        }
        XMLres res = (XMLres) last.getFirst();
        //!! if & char => 2 calls to characters(...)
        if (res.getValue() != null) {
            s = res.getValue() + s;
        }
        res.setValue(s);
    }
    //----------------OPTIONS--------------------
    // COMMENT in SAX2 is NOT WORKING.???.

    @Override
    public void comment(char buf[], int start, int len)
            throws SAXException {
        tolog("! Do");
        String s = new String(buf, start, len);
        s = s.trim();
        LinkedList<XMLres> newRow = new LinkedList<>();
        XMLres res = new XMLres("!--" + s);
        newRow.add(res);
        deep.getLast().add(newRow);
    }

    @Override
    public void ignorableWhitespace(char buf[], int start, int len)
            throws SAXException {
        tolog("W");
        String s = new String(buf, start, len);
        s = s.trim();
        LinkedList<XMLres> newRow = new LinkedList<>();
        XMLres res = new XMLres("W--" + s);
        newRow.add(res);
        deep.getLast().add(newRow);
    }

    @Override
    public void notationDecl(String name, String publicID, String privateID)
            throws SAXException {
        tolog("notationDecl");
        LinkedList<XMLres> newRow = new LinkedList<>();
        XMLres res = new XMLres("D--" + name + ":" + publicID + ":" + privateID);
        newRow.add(res);
        deep.getLast().add(newRow);
    }

    @Override
    public void processingInstruction(String target, String data)
            throws SAXException {
        tolog("processingInstruction");
        LinkedList<XMLres> newRow = new LinkedList<>();
        XMLres res = new XMLres("I--" + target + ":" + data);
        newRow.add(res);
        deep.getLast().add(newRow);
        this.skippedEntity(data);
    }

    @Override
    public void skippedEntity(String data)
            throws SAXException {
        tolog("skippedEntity");
        LinkedList<XMLres> newRow = new LinkedList<>();
        XMLres res = new XMLres("S--" + data);
        newRow.add(res);
        deep.getLast().add(newRow);
    }
}
