package com.jdcm.common;

import java.util.Arrays;
import java.util.Set;
import org.xml.sax.Attributes;

/**
 * XML result with value (name/attributs/value/...<br> values are objects (could
 * be Strings for XML file)
 *
 * @author Marc GIBOIN
 */
//TODO!! XML attribut as Map<String,Object> instead of String[] & Object[],
public class XMLres implements java.io.Serializable {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    //attr=[name/val][name1/val1,name2/val2,...]
    // A data Structure should be well better but Map don't allow Map.get(idx) and ordered Values (for model)
    //private String[] attr_names = null;
   // private Object[] attr_vals = null;
    java.util.Map<String,Object> attributes=new java.util.HashMap<>();
    // juste after '<' 
    private String elt_title = "";
    //name is the "name" attribut often used as elementID
    private String Name = "";
    // typicaly the string after the element <.../>value
    private Object value = "";
    // Key is used to feel a DB
    private java.util.List<String> PrimaryKeys = new java.util.ArrayList<>();

    /**
     * Create an element from XML SAX parser<br>
     *
     * @param eltName the name of the ellement
     * @param attr attributs of this element
     */
    public XMLres(String eltName, Attributes attr) {
        String eName = eltName;
        if (eName == null || eName.length() == 0) {
            eName = "element";
        }
        elt_title = eName;
       // attr_names = new String[attr.getLength()];
       // attr_vals = new Object[attr.getLength()];
        for (int i = 0; i < attr.getLength(); i++) {
            String attname = attr.getLocalName(i);
            // ? dif Qname & localname?
            if (attname == null || attname.length() > 0) {
                attname = attr.getQName(i);
            }
            if (attname != null && attname.compareTo("name") == 0) {
                Name = attr.getValue(i);
            }
            attributes.put(attname,  attr.getValue(i));
        }
    }

    /**
     * Create an empty named element
     *
     * @param eltName Name of the element
     */
    public XMLres(String eltName) {
        String eName = eltName;
        if (eName == null || eName.length() == 0) {
            eName = "element";
        }
        elt_title = eName;
    }
    // use getEltName instead of toString

    @Override
    public String toString() {
        return elt_title;
    }

    public java.util.HashMap<String, Object> getAttrsMap() {
        java.util.HashMap<String, Object> res = new java.util.HashMap<>();
        for (String name:attributes.keySet()) {
            if (name.startsWith("lookup_")) {
                res.put(name, attributes.get(name));
            }
        }
        return res;
    }

    public String toXMLString() {
        String str = "<" + elt_title;
        for (String name:attributes.keySet()) {
            String ky = "";
            if (PrimaryKeys.contains(name)) {
                ky = "*";
            }
            if (getAttrValAsstring(name) != null) {
                String val = "\"" + getAttrValAsstring(name) + "\"";
                if (attributes.get(name) instanceof Number) {
                    val = "" + attributes.get(name);
                }
                str = str + " " + name + ky + "=" + val;
            }
        }

        str = str + "/>";
        return str;
    }    // ! getname is used for the "name attribut"

    public String getEltName() {
        return elt_title;
    }
    /**
     * return the name of the element <br> shortcut should be same as
     * getAttrVal('name')
     *
     * @return then name of the element
     */
    public String getName() {
        return Name;
    }
    // only for serialisable reason

    public void setName(String txt) {
        Name = txt;
        if (attributes.containsKey("name")){
            attributes.put("name", txt);
        }
    }

    /**
     * The key is the name of attribut used as key to feel a table
     *
     * @return the key attribute name
     */
    public java.util.List<String> getPrimaryKeys() {
        return PrimaryKeys;
    }

    public void setPrimaryKeys(String txt) {
        PrimaryKeys = java.util.Arrays.asList(txt.split(","));
    }

    public void addPrimaryKey(String txt) {
        PrimaryKeys.addAll(Arrays.asList(txt.split(",")));
    }

    /**
     * The value of the XML element<br> Normally a String for XML
     *
     * @return value of this element
     */
    public Object getValue() {
        if (value == null) {
            return null;
        }
        /*
         * NOT NORMAL !!!
         */
        if (value.toString().length() == 0) {
            return null;
        }
        return value;
    }

    public void setValue(Object val) {
        if (val != null && val.toString().length() == 0) {
            value = null;
        }
        value = val;
    }

    public int length() {
        if (attributes == null) {
            return 0;
        }
        return attributes.size();
    }

    public void setElement(String txt) {
        elt_title = txt;
    }

    /**
     * to empty this Res used for : parsing..
     */
    public void clear() {
        attributes.clear();
        Name = "";
        elt_title = "";
        value = "";

    }

    public Object getAttrVal(String name) {
        if (name == null || name.length() == 0||attributes==null) {
            return null;
        }
       if (attributes.containsKey(name)){
          return  attributes.get(name);
       }
        return null;
    }

    public String getAttrValAsstring(String name) {
        try {
            return getAttrVal(name).toString();
        } catch (NullPointerException ex) {
            return null;
        }
    }

    /**
     * Add (if !setValue) and teach AttrVal("hdr", val)
     *
     * @param hdr name of the attribut
     * @param val value to assign to the attribut
     * @return  true if added
     */
    public boolean addAttribut(String hdr, Object val) {
        if (!setAttrVal(hdr, val)) {
            addAttrVal(hdr);
            return setAttrVal(hdr, val);
        } else {
            return true;
        }
    }

    /**
     * Complete setAttrVal(i, val)
     *
     * @param hdr name of the attribut
     * @param val value to assign to the attribut
     * @return true if added
     */
    public boolean setAttrVal(String hdr, Object val) {
        if (hdr == null || hdr.length() == 0||attributes==null) {
            return false;
        }
        attributes.put(hdr, val);
        return true;
    }
    
    
    public Set<String> getAttrNames() {
        if (attributes==null) {
            return null;
        }
        return attributes.keySet();
    }
    /**
     * Add an Attribut to the XML element as las Attribut
     *
     * @param name of the attribut
     */

    /**
     * Add an Attribut to the XML element
     *
     * @param name of the attribut
     * @return true if added
     * 
     */
    public boolean addAttrVal(String name) {
        //col==-1=> first column HEAVE BUT WORKING...
        if (name == null || name.length() == 0) {
            return false;
        }
        if (attributes.containsKey(name)) {
            //Attribut already exist
            return false;
        }
        attributes.put(name, "");
        return true;
    }

    public Object removeAttribut(String name) {
              if (name == null ||name.length() == 0) {
            return null;
        }
        if (attributes.containsKey(name)) {
            //Attribut already exist
            return null;
        }
        return attributes.remove(name);
    }

}
