package com.jdcm.diagram;

import java.awt.*;
import com.jdcm.common.*;
import java.lang.reflect.Field;
import javax.swing.DefaultComboBoxModel;

/**
 * A_Element.java Created on 21 janv. 2011, 05:39:23
 * 
 * Element with tasks are used in as basic diagram data
 *
 * @author Marc GIBOIN
 */
public class A_Element extends javax.swing.JPanel {

    private static final long serialVersionUID = 1L;
    public static final int CONCUR_RAND = 0;
    public static final int CONCUR_WEIGHT = 1;
    public static final int CONCUR_FULL = 2;
    public static final int WEIGHT_DEFAULT = 1;
    public static final java.awt.Color COL_ACTIV = java.awt.Color.BLUE;
    public static final java.awt.Color COL_DEFAULT = java.awt.Color.BLACK;
    private Object obj;
    private boolean isinitial = false;
    private boolean isselected = false;
    private boolean isactive = false;
    private boolean isstate = false;
    public Rectangle recposition = null;
    //  public boolean isdown = true;
    private DefaultComboBoxModel<Field> concurent = null;
    private int weight = WEIGHT_DEFAULT;
 private java.util.List<changeStateListner> changeStateListners = new java.util.ArrayList<>();
    /**
     * Creates new form A_Element
     * @param o the Object content of this Element
     */
    public A_Element(Object o) {
        initComponents();
        obj = o;
        isstate = o instanceof C_Eventdef == false;
        if (isstate == false) {
            this.setBounds(0, 0, this.getWidth(), this.getHeight() / 2);
            java.util.List<Field> ctrls = new java.util.ArrayList<>();
            Field defconc=null;
            for (java.lang.reflect.Field fs : this.getClass().getDeclaredFields()) {
                if (fs.getName().startsWith("CONCUR_")) {
                    try {
                        ctrls.add(fs);
                    } catch (Exception ex) {
                    }
                }
                if (fs.getName().compareTo("CONCUR_FULL")==0){
                    defconc=fs;
                }
            }
            concurent = new DefaultComboBoxModel<>(ctrls.toArray(new Field[]{}));
            concurent.setSelectedItem(defconc);
        }
    }

    public A_Element() {
        initComponents();
        obj = "init";
        isstate = true;
    }

    public void setInitial(boolean isinit) {
        isinitial = isinit;
    }

    /* public void setInitial(Boolean bool) {
     setInitial(bool.booleanValue());
     }*/
    public boolean isInitial() {
        return isinitial;
    }

    public String getTitle() {
        if (isstate) {
            if (obj instanceof java.lang.reflect.Field) {
                return "[" + ((java.lang.reflect.Field) obj).getName() + "]";
            }
            return "[" + obj.toString() + "]";
        }
        return ">" + obj.toString() + "";

    }

    public javax.swing.ImageIcon getIcon() {
        String name = "event";
        if (isstate) {
            name = "state";
            if (isinitial) {
                name = "stateI";
            }
        }
        return (new com.jdcm.common.D_Utils()).getIcon(name + ".gif");
    }

    public Options_Model getOptionModel() {
        Options_Model option = new Options_Model(this);
        option.setTitle(obj.toString());
        option.addOption("State", isstate, "bool", "0/1", false, false, "isstate");
        option.addOption("content", obj, "Object", "everything", true, true, "content");
        if (isstate) {
            option.addOption("Active", isactive, "bool", "0/1", true, false, "isstate");
            option.addOption("Initial", isinitial, "bool", "0/1", true, false, "isinitial");
            option.addOption("Weight", weight, "int", "-1-100", true, false, "Weight");
        } else {
            option.addOption("Concurent", concurent, "bool", "0/1", true, false, "concurent");

        }
        return option;

    }

    public void setActive(boolean bool) {
        if (bool != isactive) {
            isactive = bool;
            repaint();
        }
    }

    public boolean isActive() {
        return isactive;
    }

    public void setWeight(int wg) {
        weight = wg;
    }

    public int getWeight() {
        return weight;
    }

    public void setSelected(boolean bool) {
        isselected = bool;
        repaint();
    }

    public boolean isSelected() {
        return isselected;
    }

    public boolean isState() {
        return isstate;
    }

    public void setConcurent(int nb) {
        for (int i = 0; i < concurent.getSize(); i++) {
            if (concurent.getElementAt(i) instanceof java.lang.reflect.Field) {
                java.lang.reflect.Field f = concurent.getElementAt(i);
                try {
                    if (f.getInt(f) == nb) {
                        concurent.setSelectedItem(f);
                        return;
                    }
                } catch (IllegalArgumentException | IllegalAccessException ex) {
                }
            }
        }
        repaint();
    }

    public String getConcurentLabel() {
        Field f = (Field) concurent.getSelectedItem();
        return f.getName();
    }

    public void setConcurent(java.lang.reflect.Field conc) {
        concurent.setSelectedItem(conc);
        repaint();
    }

    public int getConcurent() {
        if (concurent.getSelectedItem() instanceof java.lang.reflect.Field) {
            java.lang.reflect.Field f = (java.lang.reflect.Field) concurent.getSelectedItem();
            try {
                return f.getInt(f);
            } catch (IllegalArgumentException | IllegalAccessException ex) {
            }
        }
        return -1;
    }

    public Object getcontent() {
        return obj;
    }

    public void setcontent(Object newContent) {
        // should xheck that o is not in other States.
        for (changeStateListner c:changeStateListners){
            if(c.beforeNameChange(newContent)==false){
                return;
            }
        }
        obj = newContent;
    }

    public XMLres getXMLformat() {
        com.jdcm.common.D_Utils util = new com.jdcm.common.D_Utils();
        XMLres res;
        if (this.isstate) {
            res = new XMLres("state");
            res.addAttribut("value", util.getObj2str(obj));
        } else {
            res = new XMLres("event");
        }
        res.addAttribut("bounds", util.getObj2str(recposition));


        if (isstate) {
            res.addAttribut("isactive", isactive);
            res.addAttribut("isinitial", isinitial);
            res.addAttribut("weight", weight);
        } else {
            res.addAttribut("concurent", getConcurent());
        }
        return res;
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponents(g);
        int width = recposition.width;
        int height = recposition.height;

        if (isselected) {
            java.awt.Color selcol = new java.awt.Color(0, 255, 0, 100);
            g.setColor(selcol);//ava.awt.Color.green);
            g.fill3DRect(0, 0, width, height, true);
            setOpaque(true);
        } else {
            setOpaque(false);
        }
        g.setColor(COL_DEFAULT);
        if (isstate) {
            g.drawRect(width / 10, height / 10, 8 * width / 10, 8 * height / 10);
            if (isactive) {
                g.setColor(COL_ACTIV);
                g.fillOval(7 * width / 10, 7 * height / 10, 2 * height / 10, 2*height/10);
                g.setColor(COL_DEFAULT);
            }

            if (isinitial) {
                g.drawRect(1, 1, width - 2, height - 2);
            } else {
                g.drawLine(width / 2, height / 10, width / 2, 0);
                g.drawLine(width / 2, 9 * height / 10, width / 2, height);
            }

            String txt = obj.toString();
            if (obj instanceof java.lang.reflect.Field) {
                txt = ((java.lang.reflect.Field) obj).getName();
            }
            int fsize = 16;
            int st = g.getFont().getStyle();
            String name = g.getFont().getFontName();
            while (fsize > 1 && g.getFontMetrics().getStringBounds(txt, g).getBounds().width > 8*width/10) {
                fsize = fsize - 1;
                //!!! bold is NOT OK 
                g.setFont(new java.awt.Font(name, java.awt.Font.BOLD, fsize));
            }
            int w1 = g.getFontMetrics().getStringBounds(txt, g).getBounds().width;
            g.drawString(txt, width / 2 - w1 / 2, height / 2);
            g.setFont(new java.awt.Font(name, st, g.getFont().getSize()));
            // write the weight if changed
            if (weight != WEIGHT_DEFAULT) {
                txt = "" + weight;
                int w2 = g.getFontMetrics().getStringBounds(txt, g).getBounds().width;
                g.drawString(txt, width / 2 - w2 / 2, height - 4);
            }
        } else {
            
            g.drawLine(width / 2, 0, width / 2, height);
            g.fillRect(2 * width / 10, 4 * height / 10, 6 * width / 10, 2 * height / 10);
            if (getConcurent()==CONCUR_WEIGHT){
                int r=5*height/10;
                g.fillOval((width-r)/2, (height-r)/2,r, r);
            }else if(getConcurent()==CONCUR_RAND){
                g.drawLine(2 * width / 10,7 * height / 10, 8 * width / 10, 7 * height / 10);
            }

        }
    }

    @Override
    public String toString() {
        String res;
        if (isstate) {
            res = "State ";
            if (isinitial) {
                res = res + "I";
            }
        } else {
            res = "Event: ";
        }
        if (isactive) {
            res = res + "*";
        }

        res = res + " [" + this.getcontent().toString() + "]";
        return res;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setOpaque(false);
        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                formKeyPressed(evt);
            }
        });
        setLayout(new java.awt.BorderLayout());
    }// </editor-fold>//GEN-END:initComponents

    private void formKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyPressed
         if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_DELETE) {
             //is there a simple way to inherite Listner.
           if (getParent()!=null){
               for (java.awt.event.KeyListener klist:getParent().getKeyListeners()){
               klist.keyPressed(evt);
               }
           }
        }
    }//GEN-LAST:event_formKeyPressed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
            public void addChangeStateListner(A_Element.changeStateListner evt) {
            changeStateListners.add(evt);
        }

        public void removeChangeStateListner(A_Element.changeStateListner evt) {
            changeStateListners.remove(evt);
        }

    public static class changeStateListner {

        public changeStateListner() {
        }

        public boolean beforeNameChange(Object newObj) {
            return true;
        }
    }

}
