package com.jdcm.diagram;

import com.jdcm.common.C_Eventdef;
import com.jdcm.editors.ACE_ObjRenderer;
import com.jdcm.editors.I_CBObjectEditor;
import com.jdcm.editors.JCB_ObjectEditor;
import java.awt.Color;
import java.awt.Component;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

/**
 * P_Events.java Created on 8 oct. 2010, 22:00:08
 *
 * @author M.Marc GIBOIN
 */
public class P_Events extends javax.swing.JPanel implements I_CBObjectEditor {

    private static final long serialVersionUID = 1L;
    private A_Events evtmx = null;
    private boolean editing = false;


    /**
     * Creates new form P_Events
     */
    public P_Events() {
        initComponents();
    }

    /**
     * Provide an Icon if needed (asked by frames)
     *
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
            return (new com.jdcm.common.D_Utils()).getImage("event.gif");
        } catch (Exception ex) {
            return null;
        }
    }

    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        txt.setText(evtmx.getTitle() + "[" + evtmx.getStates().length + "," + evtmx.getEventlist().size() + "]");
        return txt;
    }

    @Override
    public void setValue(Object val) {
        if (val instanceof A_Events) {
            evtmx = (A_Events) val;
            evtmx.addTableModelListener(new javax.swing.event.TableModelListener() {
                EventRenderer render = new EventRenderer(evtmx);
                com.jdcm.editors.ACE_ObjEditor editor = new com.jdcm.editors.ACE_ObjEditor(true);

                @Override
                public void tableChanged(javax.swing.event.TableModelEvent e) {
                    for (int i = 0; i < jTable1.getColumnCount(); i++) {
                        if (i < 1) {
                            jTable1.getColumnModel().getColumn(i).setHeaderValue(evtmx.getTitle());
                        } else {
                            jTable1.getColumnModel().getColumn(i).setHeaderValue(evtmx.getStatuslist().get(i - 1));
                        }
                        jTable1.getColumnModel().getColumn(i).setHeaderRenderer(new headerRenderer(evtmx.getStatuslist()));
                        jTable1.getColumnModel().getColumn(i).setCellRenderer(render);
                        jTable1.getColumnModel().getColumn(i).setCellEditor(editor);
                    }
                }
            });
            jTable1.setModel(evtmx);
            jTable1.setEnabled(true);
            //jTable1.getTableHeader().setDefaultRenderer(new ACE_ObjRenderer());
            evtmx.fireTableDataChanged();
            // evtmx.fireTableStructureChanged();

        } else {
            evtmx = null;
        }
    }

    @Override
    public Object getValue() {
        // need too change evtmx with modified value before..
        return evtmx;
    }

    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        jTable1.setEnabled(evtmx != null && evtmx.isPanelButton() && bool);
        jButton7.setEnabled(evtmx != null && evtmx.isPanelButton() && bool);
        jButton1.setEnabled(evtmx != null && evtmx.isPanelButton() && bool);
        jButton2.setEnabled(evtmx != null && evtmx.isPanelButton() && bool);
        jButton4.setEnabled(evtmx != null && evtmx.isPanelButton() && bool);
        editing = bool;

    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent jtxt) {
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setPreferredSize(new java.awt.Dimension(345, 129));
        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jButton1.setText("+");
        jButton1.setToolTipText("Add Status");
        jButton1.setAlignmentY(0.0F);
        jButton1.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        jButton2.setText(">");
        jButton2.setToolTipText("Add Event");
        jButton2.setAlignmentY(0.0F);
        jButton2.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2);

        jButton4.setText("X");
        jButton4.setToolTipText("Remove");
        jButton4.setAlignmentY(0.0F);
        jButton4.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton4);

        jButton7.setText("/");
        jButton7.setToolTipText("Diagram");
        jButton7.setAlignmentY(0.0F);
        jButton7.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton7);

        jButton8.setText("O");
        jButton8.setToolTipText("Reset");
        jButton8.setAlignmentY(0.0F);
        jButton8.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton8);

        add(jPanel1, java.awt.BorderLayout.NORTH);

        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        evtmx.addStatus(new A_Element(new java.util.Date(System.currentTimeMillis())));
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        evtmx.addEvent(new A_Element(new C_Eventdef("")));
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        jTable1.editingCanceled(null);
        if (jTable1.getSelectedRow() == 0) {
            evtmx.removeStatus(evtmx.getStatuslist().get(jTable1.getSelectedColumn() - 1));
        } else if (jTable1.getSelectedRow() > 0) {
            jTable1.editingCanceled(null);
            evtmx.removeEvt(evtmx.getEventlist().get(jTable1.getSelectedRow() - 1));
        }
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        javax.swing.JFrame f = new javax.swing.JFrame();
        f.setBounds(10, 10, 400, 400);
        P_Diagram diagram = new P_Diagram(evtmx);
        diagram.setEditTable(false);
        f.add(diagram);
        f.setVisible(true);
    }//GEN-LAST:event_jButton7ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        evtmx.reset();
    }//GEN-LAST:event_jButton8ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}

class headerRenderer extends javax.swing.CellRendererPane implements TableCellRenderer {

    private static final long serialVersionUID = 1L;
    ACE_ObjRenderer<Object> a = new ACE_ObjRenderer<>();
    java.util.List<A_Element> states = null;
    java.awt.Color hdrcolor = null;

    public headerRenderer(java.util.List<A_Element> a) {
        states = a;
        hdrcolor = (new javax.swing.JLabel()).getBackground();
    }

    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {

        Component c = null;
        if (value instanceof A_Element) {
            A_Element st = (A_Element) value;
            c = a.getTableCellRendererComponent(table, st.getcontent(), isSelected, hasFocus, row, column);
            if (st.isInitial()) {
                c.setBackground(Color.WHITE);
            } else if (st.isActive()) {
                c.setBackground(Color.red);
            } else {
                c.setBackground(hdrcolor);
            }
            if (c instanceof javax.swing.JLabel) {
                ((javax.swing.JLabel) c).setOpaque(true);
                //((javax.swing.JLabel) c).setBorder(javax.swing.BorderFactory.createMatteBorder(0, 0, 1, 1,Color.black));
                ((javax.swing.JLabel) c).setBorder(javax.swing.BorderFactory.createEtchedBorder());
            }
        } else if (value instanceof String) {
            // for titre...
            javax.swing.JLabel l = new javax.swing.JLabel(value.toString());
            l.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 1, 1, Color.black));
            l.setOpaque(true);
            c = l;
        }
        return c;
    }
}

class EventRenderer extends javax.swing.CellRendererPane implements TableCellRenderer {

    private static final long serialVersionUID = 1L;
    A_Events evtmx = null;

    public EventRenderer(A_Events a) {
        evtmx = a;
    }

    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {

        JCB_ObjectEditor editor = new JCB_ObjectEditor(value, false);
        editor.setToolTipText(value.getClass().getSimpleName());
        editor.displayBorder(false);
        Component c = editor;
        if (column == 0 && row >= 0) {
            if (value.equals(evtmx.getlastrvd())) {
                c.setBackground(java.awt.Color.red);
            } else {
                c.setBackground(table.getBackground().darker());
            }
        } else if (row >= 0) {
            if (value instanceof A_Task) {
                if (((A_Task) value).isEmpty()) {
                    c = new java.awt.Label();
                }
            }

        }
        //   c.setForeground(table.getForeground());
        return c;
    }
}
