package com.jdcm.editors;

import java.awt.Component;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.tree.TreeCellEditor;
import com.jdcm.common.C_Packet;
import com.jdcm.common.O_Amount;
import java.awt.AWTEvent;
import java.awt.AWTException;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.lang.reflect.InvocationTargetException;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * ObjectEditor.java Created on 1 nov. 2007, 16:06:23
 *
 * Cell Editor to Edit user Classes not manager by default editor<br>
 *
 * @author Marc GIBOIN
 * @param <E> ??TODO??
 */
public class ACE_ObjEditor<E> extends AbstractCellEditor implements TableCellEditor, TreeCellEditor, ComboBoxEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final java.awt.Frame editFrame = null;
    private Component Compnt = null;
    private Object initObj = null;
    private javax.swing.tree.TreePath editingpath = null;
    private javax.swing.tree.TreeModel treemodel = null;
    private boolean editting = true;
    private boolean objEdit = false;
    private int initheight = -1;
    private F_Object ObjFrame = null;

    public ACE_ObjEditor() {
    }

    public ACE_ObjEditor(boolean bool) {
        editting = bool;
        objEdit = false;
    }
    /*
     public ACE_ObjEditor(javax.swing.JComboBox jcb, boolean bool) {
     editting = bool;
     objEdit = false;
     srccombo = jcb;
     }*/

    public ACE_ObjEditor(boolean bool, boolean objbool) {
        editting = bool;
        objEdit = objbool;
    }

    public ACE_ObjEditor(ACE_ObjEditor<?> o) {
        //   parent = o;
    }

    public void setEditing(boolean bool) {
        editting = bool;
    }

    public Component getEditorCoponment(Object value) {
        Compnt = getEditorCoponment(null, value);
        return Compnt;
    }

    private Component getEditorCoponment(javax.swing.JComponent source, Object value) {
        Component res = null;
        initObj = value;
        if (value != null && value.getClass() == Boolean.class) {
            javax.swing.JCheckBox box = new javax.swing.JCheckBox();
            box.setMargin(new java.awt.Insets(0, 0, 0, 0));
            box.setBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0));
            box.setSelected((Boolean) value);
            box.setEnabled(editting);
            res = box;
        } else if (value instanceof com.jdcm.diagram.A_Element) {
            com.jdcm.diagram.A_Element elt = (com.jdcm.diagram.A_Element) value;
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.FlowLayout(0, 0, 0));
            final javax.swing.JLabel label;
            label = new javax.swing.JLabel("", elt.getIcon(), 0);
            p.setOpaque(false);
            p.setBorder(null);
            JCB_ObjectEditor editor = new JCB_ObjectEditor(elt.getOptionModel());
            editor.setTitle(label.getText());
            editor.setAsButton(true);
            editor.setEditing(editting);
            p.add(editor);
            p.add(label);
            res = p;
        } else if (value instanceof java.awt.Font) {
            java.awt.Font ft = (java.awt.Font) value;
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.FlowLayout(0, 0, 0));
            javax.swing.JComboBox<java.awt.Font> cb = new javax.swing.JComboBox<>();
            java.awt.GraphicsEnvironment env = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
            String[] fontNames = env.getAvailableFontFamilyNames();
            java.awt.Font[] fonts = new java.awt.Font[fontNames.length];
            int selectedidx = 0;
            for (int i = 0; i < fontNames.length; i++) {
                if (fontNames[i].compareTo(ft.getFamily()) == 0) {
                    selectedidx = i;
                }
                fonts[i] = new java.awt.Font(fontNames[i], java.awt.Font.PLAIN, cb.getFont().getSize());
            }

            cb.setModel(new javax.swing.DefaultComboBoxModel<>(fonts));
            cb.setSelectedIndex(selectedidx);
            javax.swing.JSpinner sp = new javax.swing.JSpinner(new javax.swing.SpinnerNumberModel(ft.getSize(), 1, 500, 1));
            cb.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
            p.add(cb);
            p.add(sp);
            res = p;
        } else if (value instanceof com.jdcm.diagram.A_Task) {
            com.jdcm.diagram.A_Task a = (com.jdcm.diagram.A_Task) value;
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.GridBagLayout());
            final javax.swing.JLabel label;
            String lbl = "Empty Task";
            if (a.isEmpty() == false) {
                lbl = "Task (" + a.getNextStates().size() + ")";
            }
            label = new javax.swing.JLabel(lbl);
            label.setForeground((Color) a.getOptionModel().getValuefor("Color"));
            p.setOpaque(false);
            p.setBorder(null);
            JCB_ObjectEditor editor = new JCB_ObjectEditor(a.getOptionModel());
            editor.setTitle(label.getText());
            editor.setAsButton(true);
            editor.setEditing(editting);
            p.add(editor);
            p.add(label);
            res = p;
        } else if (value instanceof DefaultComboBoxModel<?>) {
            DefaultComboBoxModel<Object> model = (DefaultComboBoxModel<Object>) value;
            javax.swing.JComboBox<Object> cbbox = new javax.swing.JComboBox<>();
            //      cbbox.setEditor(new ACE_ObjEditor());
            cbbox.setRenderer(new ACE_ObjRenderer<>());
            cbbox.setModel(model);
            cbbox.setEditable(editting);
            res = cbbox;
        } else if (value instanceof AbstractSpinnerModel) {
            AbstractSpinnerModel model = (AbstractSpinnerModel) value;
            javax.swing.JSpinner spbox = new javax.swing.JSpinner(model);
            spbox.setEnabled(editting);
            res = spbox;
        }
        if (value instanceof javax.sound.sampled.AudioFormat
                || value instanceof javax.swing.tree.TreeModel
                || value instanceof javax.swing.tree.TreeNode) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.setEditing(editting);
            res = editor;
        } else if (value instanceof java.lang.Number) {
            if (value instanceof Float || value instanceof Double || value instanceof java.math.BigDecimal) {
                javax.swing.JTextField box = new javax.swing.JTextField();
                box.setText("" + value.toString());
                box.setEnabled(editting);
                res = box;
            } else {
                javax.swing.JSpinner box = new javax.swing.JSpinner();
                box.setValue(new Long("" + value.toString()));
                box.setEnabled(editting);
                res = box;
            }
        } else if (value instanceof O_Amount) {
            O_Amount val = (O_Amount) value;
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.GridLayout());
            javax.swing.JTextField box = new javax.swing.JTextField("" + val.AMOUNT);
            //  javax.swing.text.NumberFormatter f = new javax.swing.text.NumberFormatter(java.text.NumberFormat.getCurrencyInstance(val.LOCAL));
            //  box.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(f));
            p.add(box);
            java.util.List<java.util.Currency> list = val.getCurencyList();
            DefaultComboBoxModel<java.util.Currency> c = new DefaultComboBoxModel<>(list.toArray(new java.util.Currency[]{}));
            c.setSelectedItem(java.util.Currency.getInstance(val.LOCAL));
            javax.swing.JComboBox<java.util.Currency> combo = new javax.swing.JComboBox<>(c);
            p.add(combo);
            box.setEnabled(editting);
            combo.setEnabled(editting);
            p.setEnabled(editting);
            res = p;
        } else if (value instanceof Character) {
            javax.swing.JTextField box = new javax.swing.JTextField();
            box.setText("" + value.toString());
            box.setEnabled(editting);
            res = box;
        } else if (value instanceof com.jdcm.eltrx.I_Command) {
            com.jdcm.eltrx.I_Command port = (com.jdcm.eltrx.I_Command) value;
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.GridBagLayout());
            final javax.swing.JLabel label;
            if (port instanceof com.jdcm.eltrx.I_Port) {
                int idx = ((com.jdcm.eltrx.I_Port) port).getSIndex();
                if (idx < 0) {
                    label = new javax.swing.JLabel(((com.jdcm.eltrx.I_Port) port).getCMDOptions().getTitle(), port.getCMDIcon(), 0);
                } else {
                    label = new javax.swing.JLabel(((com.jdcm.eltrx.I_Port) port).getPortName()
                            + "/" + idx, port.getCMDIcon(), 0);
                }
            } else {
                label = new javax.swing.JLabel(port.getCMDOptions().getTitle(), port.getCMDIcon(), 0);
            }
            p.setOpaque(false);
            p.setBorder(null);
            JCB_ObjectEditor editor = new JCB_ObjectEditor(port.getCMDOptions());
            editor.setTitle(label.getText());
            editor.setAsButton(true);
            editor.setEditing(editting);
            p.add(label);
            p.add(editor);
            res = p;
        } else if (value instanceof com.jdcm.eltrx.C_Main) {
            com.jdcm.eltrx.C_Main main = (com.jdcm.eltrx.C_Main) value;
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.GridBagLayout());
            final javax.swing.JLabel label;
            label = new javax.swing.JLabel(main.toString(), main.getCMDIcon(), 0);
            p.setOpaque(false);
            p.setBorder(null);
            JCB_ObjectEditor editor = new JCB_ObjectEditor(main.getCMDOptions());
            editor.setTitle(label.getText());
            editor.setAsButton(true);
            editor.setEditing(editting);
            p.add(label);
            p.add(editor);
            res = p;
        } else if (value instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
            final com.jdcm.modifiers.stacks.I_stack_elt module = (com.jdcm.modifiers.stacks.I_stack_elt) value;
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.GridBagLayout());
            final javax.swing.JTextField label = new javax.swing.JTextField(module.toString(), 0);// add icone? see port
            label.addActionListener(new java.awt.event.ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    module.setName(e.getActionCommand());
                }
            });
            label.setMinimumSize(new java.awt.Dimension(50, 20));
            label.setBorder(null);
            label.setMargin(null);
            p.setOpaque(false);
            p.setOpaque(true);
            p.setBackground(Color.pink);
            label.setBackground(Color.pink);
            p.setBorder(null);
            JCB_ObjectEditor editor = new JCB_ObjectEditor(module.getOptions());
            editor.setTitle(label.getText());
            editor.setAsButton(true);
            editor.setEditing(editting);
            p.add(editor);
            p.add(label);
            res = p;
        } else if (value instanceof com.jdcm.diagram.A_Events || value instanceof byte[] || value instanceof java.awt.Image || value instanceof C_Packet || value instanceof java.io.File || value instanceof java.net.InetAddress || value instanceof com.jdcm.common.O_MACaddress || value instanceof com.jdcm.common.O_X25address || value instanceof java.util.Date || value instanceof javax.swing.table.AbstractTableModel || value instanceof java.sql.ResultSet) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.setEditing(editting);
            res = editor;
        } else if (value instanceof java.awt.geom.Line2D
                || value instanceof java.awt.geom.Rectangle2D || value instanceof java.awt.geom.Ellipse2D
                || value instanceof java.awt.geom.Arc2D || value instanceof java.awt.geom.Point2D
                || value instanceof java.awt.Point || value instanceof java.awt.Rectangle
                || value instanceof java.awt.Dimension) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.setEditing(editting);
            res = editor;
        } else if (res == null && value instanceof java.awt.Component) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.setEditing(editting);
            res = editor;
        } else if (value != null && (value.getClass().getName().startsWith("usb.") || value.getClass().getName().startsWith("jpcap.NetworkInterface"))) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.setEditing(editting);
            res = editor;

        } else if (value != null && value.getClass().getName().startsWith("com.jdcm.charts.")) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.setEditing(editting);
            // editor.removeborder();
            res = editor;
        } else if (value instanceof java.awt.Color) {
            java.awt.Color color = (java.awt.Color) value;
            // addedd a spinner to set Alpha
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.FlowLayout(0, 0, 0));
            p.setBorder(null);
            final javax.swing.JButton colo = new javax.swing.JButton();
            final javax.swing.JToggleButton colpick = new javax.swing.JToggleButton();
            // final javax.swing.JSpinner alpha = new javax.swing.JSpinner();
            //  alpha.setModel(new javax.swing.SpinnerNumberModel(color.getAlpha(), 0, 255, 1));
            colo.setText(color.getClass().getSimpleName());
            colo.setPreferredSize(new java.awt.Dimension(30, 15));
            colo.setBackground(color);
            colo.setEnabled(editting);
            if (editting) {

                colo.addActionListener(new java.awt.event.ActionListener() {
                    @Override
                    public void actionPerformed(java.awt.event.ActionEvent event) {
                        java.awt.Color c = javax.swing.JColorChooser.showDialog(null, "Select Color", (java.awt.Color) initObj);
                        if (c != null) {
                            colo.setBackground(c);
                        }
                    }
                });
                colpick.addActionListener(new java.awt.event.ActionListener() {
                    java.awt.event.AWTEventListener awtl;
                     java.awt.Frame w;
                    
                    //  java.awt.event.AWTEventListener[] oldawtl; would like to disable ALL mose listners while picking
                    private void clearButton() {
                        Toolkit.getDefaultToolkit().removeAWTEventListener(awtl);
                        if (colpick.isSelected()) {
                            colpick.setSelected(false);
                        }
                        for (java.awt.Frame f : java.awt.Frame.getFrames()) {
                            f.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                        }
                        w.setVisible(false);
                        w=null;
                    }

                    @Override
                    public void actionPerformed(java.awt.event.ActionEvent event) {
                        if (colpick.isSelected()) {
                            final java.awt.Robot robot;
                            try {
                                robot = new java.awt.Robot();
                            } catch (AWTException ex) {
                                colpick.setEnabled(false);
                                return;
                            }
                            java.awt.Rectangle screensz = new java.awt.Rectangle(java.awt.Toolkit.getDefaultToolkit().getScreenSize());
                            final java.awt.image.BufferedImage img = robot.createScreenCapture(screensz);
                            w=new java.awt.Frame();
                            w.setUndecorated(true);
                            w.setAlwaysOnTop(true);
                            w.setBounds(screensz);//new java.awt.Rectangle(400,400) //screensz
                           w.setBackground(new Color(255,255,255,1));
                            w.setVisible(true);
                            awtl = new java.awt.event.AWTEventListener() {
                                @Override
                                public void eventDispatched(AWTEvent awte) {
                                    if (awte.paramString().startsWith("MOUSE_MOVE")) {
                                      //  System.out.println("==>" + awte.paramString());
                                        String txt = awte.paramString().substring(awte.paramString().indexOf("),") + 2);
                                        String strx = txt.substring(txt.indexOf("(") + 1, txt.indexOf(","));
                                        String stry = txt.substring(txt.indexOf(",") + 1, txt.indexOf(")"));
                                        colo.setBackground(new java.awt.Color(img.getRGB(new Integer(strx), new Integer(stry))));
                                    } else if (awte.paramString().startsWith("MOUSE_PRESSED")) {
                                        String txt = awte.paramString().substring(awte.paramString().indexOf("),") + 2);
                                        if (txt.contains("modifiers=Button1")) {
                                            String strx = txt.substring(txt.indexOf("(") + 1, txt.indexOf(","));
                                            String stry = txt.substring(txt.indexOf(",") + 1, txt.indexOf(")"));
                                          //  System.out.println("=> " + awte.paramString());
                                            colo.setBackground(new java.awt.Color(img.getRGB(new Integer(strx), new Integer(stry))));
                                            clearButton();
                                        } else {
                                            clearButton();
                                        }
                                    }
                                }
                            };
                            // !! DONT REPORT EVENTS OUT OF FRAME (only move)
                            Toolkit.getDefaultToolkit().addAWTEventListener(awtl, java.awt.AWTEvent.MOUSE_EVENT_MASK
                                    | java.awt.AWTEvent.MOUSE_MOTION_EVENT_MASK);
                            for (java.awt.Frame f : java.awt.Frame.getFrames()) {
                                f.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
                            }
                        } else {
                            clearButton();
                        }
                    }
                });
            }
            colpick.setPreferredSize(new java.awt.Dimension(10, 15));
            p.add(colo);
            p.add(colpick);
            res = p;
        } else if (value instanceof P_ArrayHeader) {
            String name = ((P_ArrayHeader) value).toString();
            javax.swing.JTextArea lbl = new javax.swing.JTextArea(name);
            lbl.setForeground(java.awt.Color.blue);
            lbl.setEditable(false);
            res = lbl;
        } else if (value instanceof com.jdcm.common.XMLres
                || value instanceof com.jdcm.common.C_Eventdef
                || value instanceof com.jdcm.common.C_Actiondef) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.displayBorder(false);
            editor.setEditing(true);
            res = editor;
        } else if (value instanceof com.jdcm.common.C_textElement || value instanceof java.lang.reflect.AnnotatedElement || value instanceof java.lang.annotation.Annotation) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            editor.displayBorder(false);
            editor.setEditing(false);
            res = editor;
        }
        if (res instanceof JCB_ObjectEditor && value instanceof Component && value.getClass().getName().startsWith("com.jdcm.") == false) {
            //CARE with listners..=> Pb component is ONE windows opaque ??
            // need to be "at the end because :
            // - some component are managed with cutum editors (com.jdcm.charts/ChartPlus)
            // - modifications of awt Parent bellow
            java.awt.Component c = (java.awt.Component) value;
            if (c.getParent() != null) {
                c.getParent().remove(c);
            }
            javax.swing.JPanel p = new javax.swing.JPanel();
            p.setLayout(new java.awt.FlowLayout(0, 0, 0));
            JCB_ObjectEditor editor = (JCB_ObjectEditor) res;
            editor.setTitle(c.getName());
            editor.setAsButton(true);
            p.add(editor);
            p.add(c);
            res = p;
        } else if (value instanceof byte[] == false && (value instanceof java.util.List<?> || value instanceof Object[])) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            res = editor;
        } else if (value instanceof java.util.Enumeration<?>) {
            java.util.Enumeration<?> v = (java.util.Enumeration<?>) value;
            javax.swing.JList<Object> box = new javax.swing.JList<>();
            javax.swing.DefaultListModel<Object> listModel = new javax.swing.DefaultListModel<>();
            while (v.hasMoreElements()) {
                listModel.addElement(v.nextElement());
            }
            box.setModel(listModel);
            res = box;
        } else if (value instanceof java.lang.String) {
            javax.swing.text.JTextComponent box;
            if (value.toString().indexOf("\n") == -1) {
                box = new javax.swing.JTextField();
            } else {
                box = new javax.swing.JTextArea();
            }

            //-------------------------------------------------------------------------       

            /*??  if (res == null && value != null) {
             DefaultMutableTreeNode root = null;
             if (root != null) {
             javax.swing.JTree tree = new javax.swing.JTree(root);
             ACE_ObjEditor<Object> a = new ACE_ObjEditor<>(this);
             tree.setCellEditor(a);
             childs.add(a);
             tree.setCellRenderer(new ACE_ObjRenderer<>());
             tree.setEditable(true);
             tree.expandRow(1);
             res = tree;
             }
             }*/
            box.setOpaque(true);
            box.setText(value.toString());
            box.setEditable(editting);
            res = box;
        }
        if (res == null) {
            JCB_ObjectEditor editor = new JCB_ObjectEditor(value);
            //editor.displayBorder(false);
            res = editor;
        }
        if (objEdit) {
            javax.swing.JToggleButton _button2 = new javax.swing.JToggleButton();
            _button2.setMargin(new java.awt.Insets(0, 0, 0, 0));

            _button2.setText("+");
            _button2.setFont(new java.awt.Font("Courier New", java.awt.Font.PLAIN, 5));
            _button2.setVisible(true);

            java.awt.Container c = source;//this.getParent();
            while ((c != null && c instanceof java.awt.Window == false)) {
                // System.out.println("=>"+c);
                c = c.getParent();
            }
            final java.awt.Window w;
            if (c == null) {
                w = new java.awt.Frame();
            } else {
                w = (java.awt.Window) c;
            }

            _button2.addActionListener(new java.awt.event.ActionListener() {
                @Override
                public void actionPerformed(java.awt.event.ActionEvent event) {
                    /*  Object c = F_Object.showDialog(w, initObj, editting);
                     Compnt = getEditorCoponment(null, c, false);
                     initObj = c;
                     fireEditingStopped();*/
                    if (((javax.swing.JToggleButton) event.getSource()).isSelected()) {
                        ObjFrame = new F_Object(initObj);
                    } else {
                        Object c = ObjFrame.getObject();
                        Compnt = getEditorCoponment(null, c);
                        initObj = c;
                        fireEditingStopped();
                        ObjFrame.setVisible(false);
                        ObjFrame = null;
                    }

                }
            });
            java.awt.Panel p = new java.awt.Panel();
            p.setName("editting");
            p.setLayout(new java.awt.BorderLayout());
            p.add(_button2, java.awt.BorderLayout.WEST);
            p.add(res);//, java.awt.BorderLayout.LINE_END);

            res = p;
        }
        return res;
    }

    @Override

    public Component getTableCellEditorComponent(
            javax.swing.JTable table, Object value, boolean isSelected, int row, int col) {
        treemodel = null;
        // java.awt.Rectangle rec=table.getCellRect(row, col, editting);
        // Compnt=table.getParent().findComponentAt((rec.x+rec.width)/2,(rec.y+rec.height)/2);
        // is JCB_Editor???
        Compnt = getEditorCoponment(table, value);
        Compnt.setPreferredSize(table.getCellRect(row, col, isSelected).getSize());
        Compnt.setForeground(java.awt.Color.RED);
        final int r = row;
        Compnt.addComponentListener(new java.awt.event.ComponentAdapter() {
            @Override
            public void componentResized(java.awt.event.ComponentEvent evt) {
                // ComponentResized(evt, r);
            }
        });
        //   int height=max (Compnt.PreferedSize.height,Compnt.getMaximumSize().height)
        // I don't understand how works MaximumSize & PreferedSize
        int height = Compnt.getMaximumSize().height;//getPreferredSize().heigh
        if (height > 400) {
            height = Compnt.getPreferredSize().height;
        }
        if (height > table.getRowHeight(row)) {
            //  table.setRowHeight(30);
            if (initheight < 0) {
                initheight = table.getRowHeight(row);
            }
            table.setRowHeight(row, height);

        }
        int width = Compnt.getPreferredSize().width;
        if (width > table.getColumnModel().getColumn(col).getWidth()) {
            //   if (initwidth<0){  initwidth=table.getColumnModel().getColumn(col).getWidth();}
            table.getColumnModel().getColumn(col).setWidth(width);
        }
        return Compnt;
    }

    /**
     * A REVOIR !!!! implment the same Render object then the table<br> Except
     * for tree wich is inserted in the parent tree <br>
     *
     * @param tree
     * @param value
     * @param isSelected
     * @param expanded
     * @param leaf
     * @param row
     * @return
     */
    @Override
    public Component getTreeCellEditorComponent(JTree tree, Object value, boolean isSelected, boolean expanded, boolean leaf, int row) {
        Object userObj;
        //  initObj=value;
        if (value instanceof javax.swing.tree.DefaultMutableTreeNode) {
            userObj = ((javax.swing.tree.DefaultMutableTreeNode) value).getUserObject();
            editingpath = new javax.swing.tree.TreePath(((javax.swing.tree.DefaultMutableTreeNode) value).getPath());
        } else {
            userObj = value;
        }
        treemodel = tree.getModel();
        Compnt = getEditorCoponment(tree, userObj);
        if (Compnt instanceof JTree) {
            //GOOD LIKE THIS ?? chechk sizes
        }
        return Compnt;
    }

    private void ComponentResized(java.awt.event.ComponentEvent evt, int row) {

        if (evt.getComponent().getParent() instanceof javax.swing.JTable) {
            javax.swing.JTable t = (javax.swing.JTable) evt.getComponent().getParent();
            int h = t.getRowHeight();
            if (evt.getComponent() instanceof java.awt.Panel) {
                java.awt.Panel p = (java.awt.Panel) evt.getComponent();
                for (java.awt.Component c : p.getComponents()) {
                    h = Math.max(h, c.getHeight());
                }
            } else {
                h = Math.max(h, evt.getComponent().getPreferredSize().height);
            }
            //h = Math.max(h, evt.getComponent().getMinimumSize().height);
            /* for (int i=0;i<t.getColumnCount();i++){
             h=Math.max(h, t.geC)
             }*/
            t.setRowHeight(row, h);
        }
    }

    @Override
    public Object getCellEditorValue() {
        Object endObj = null;
        if (editting == false) {
            return initObj;
        }
        if (initObj == null) {
            /*   Component c=((javax.swing.JPanel) Compnt).getComponent(1);
             javax.swing.DefaultListModel list=(javax.swing.DefaultListModel)((javax.swing.JList)c).getModel();
             endObj=list.get(0);
             */
        } else {
            if (Compnt instanceof java.awt.Panel) {
                java.awt.Panel p = (java.awt.Panel) Compnt;
                if (p.getName().startsWith("editting") && p.getComponentCount() > 1) {
                    Compnt = p.getComponent(1);
                }
            }
            if (initObj instanceof P_ArrayHeader) {
                endObj = initObj;
            } else if (initObj instanceof javax.swing.tree.DefaultMutableTreeNode) {
                // initObj = ;
                ACE_ObjEditor<Object> edit = new ACE_ObjEditor<>();
                edit.getEditorCoponment(null, ((javax.swing.tree.DefaultMutableTreeNode) initObj).getUserObject());
                ((javax.swing.tree.DefaultMutableTreeNode) initObj).setUserObject(edit.getCellEditorValue());
                endObj = initObj;
            } else if (initObj.getClass() == java.lang.Boolean.class) {
                Boolean bool = ((javax.swing.JToggleButton) Compnt).isSelected();
                endObj = bool.booleanValue();
            } else if (initObj instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                JPanel p = (JPanel) Compnt;
                if (p.getComponentCount() > 1 && p.getComponent(0) instanceof javax.swing.JCheckBox) {
                    // null exception??
                    Boolean bool = ((javax.swing.JCheckBox) p.getComponent(1)).isSelected();
                    ((com.jdcm.modifiers.stacks.I_stack_elt) initObj).setfrommedia(bool);
                    bool = ((javax.swing.JCheckBox) p.getComponent(2)).isSelected();
                    ((com.jdcm.modifiers.stacks.I_stack_elt) initObj).setdebug(bool);
                    String txt = ((JTextField) p.getComponent(3)).getText();
                    ((com.jdcm.modifiers.stacks.I_stack_elt) initObj).setName(txt);

                }
                endObj = initObj;
            } else if (initObj instanceof DefaultComboBoxModel) {
                if (Compnt instanceof javax.swing.JComboBox) {
                    endObj = ((javax.swing.JComboBox) Compnt).getModel();
                } else {
                    endObj = initObj;
                }
            } else if (initObj instanceof java.awt.Font) {
                if (Compnt instanceof javax.swing.JPanel) {
                    javax.swing.JPanel p = (javax.swing.JPanel) Compnt;
                    javax.swing.JComboBox<java.awt.Font> cb = (javax.swing.JComboBox<java.awt.Font>) p.getComponent(0);
                    javax.swing.JSpinner sp = (javax.swing.JSpinner) p.getComponent(1);
                    java.awt.Font ft = (java.awt.Font) cb.getSelectedItem();
                    endObj = new java.awt.Font(ft.getFamily(), java.awt.Font.PLAIN, (int) sp.getValue());
                } else {
                    endObj = initObj;
                }
            } else if (initObj instanceof java.lang.Number) {
                if (Compnt instanceof javax.swing.JTextField) {
                    javax.swing.JTextField a = (javax.swing.JTextField) (Compnt);
                    if (initObj.getClass() == java.lang.Double.class) {
                        endObj = new java.lang.Double(a.getText());
                    } else if (initObj.getClass() == java.lang.Float.class) {
                        endObj = new java.lang.Float(a.getText());
                    } else if (initObj.getClass() == java.math.BigDecimal.class) {
                        endObj = new java.math.BigDecimal(a.getText());
                    }
                } else {
                    String res = "" + ((javax.swing.JSpinner) Compnt).getValue();
                    if (initObj.getClass() == java.lang.Byte.class) {
                        //instanceof Number but need specific for 0-256 copding
                        int i = new Integer(res);
                        if (i > 128 && i < 256) {
                            i -= 256;
                        }
                        if (i > 255 || i < -128) {
                            endObj = initObj;
                        } else {
                            endObj = new java.lang.Byte("" + i);
                        }
                    } else if (initObj.getClass() == java.lang.Integer.class) {
                        endObj = new Integer(res);
                    } else {
                        endObj = ((java.lang.Number) ((javax.swing.JSpinner) Compnt).getValue()).longValue();
                    }
                }
            }
            if (initObj instanceof javax.sound.sampled.AudioFormat) {
                JCB_ObjectEditor editor = (JCB_ObjectEditor) Compnt;
                endObj = editor.getValue();
            } else if (initObj instanceof O_Amount) {
                javax.swing.JPanel p = (javax.swing.JPanel) (Compnt);
                if (p.getComponent(0) instanceof javax.swing.JTextField && p.getComponent(1) instanceof javax.swing.JComboBox) {
                    javax.swing.JTextField a = (javax.swing.JTextField) (p.getComponent(0));
                    javax.swing.JComboBox<java.util.Currency> cur = (javax.swing.JComboBox<java.util.Currency>) p.getComponent(1);
                    try {
                        endObj = initObj;
                        ((O_Amount) endObj).AMOUNT = new Double(a.getText());
                        ((O_Amount) endObj).setCurrency((java.util.Currency) cur.getSelectedItem());
                    } catch (NumberFormatException ex) {
                        System.out.println("ObjectEditor : Amount =>" + ex.getMessage());
                    }
                }
            } else if (initObj instanceof Character) {
                String txt = ((javax.swing.JTextField) Compnt).getText();
                if (txt.length() > 0) {
                    endObj = txt.charAt(0);
                } else {
                    endObj = initObj;
                }
            } else if (initObj instanceof java.awt.Color) {
                if (Compnt instanceof javax.swing.JPanel) {
                    javax.swing.JPanel p = (javax.swing.JPanel) Compnt;
                    javax.swing.JButton col = (javax.swing.JButton) p.getComponent(0);
                    endObj = col.getBackground();
                }
            }
            if (initObj instanceof Component) {
                if (Compnt instanceof java.awt.Panel) {
                    Component c;
                    if (((javax.swing.JPanel) Compnt).getComponentCount() > 1) {
                        c = ((javax.swing.JPanel) Compnt).getComponent(1);
                    } else {
                        c = (Component) initObj;
                    }
                    if (c.getParent() != null) {
                        c.getParent().remove(c);
                    }
                    endObj = c;
                }
            }
        }
        if (Compnt instanceof JCB_ObjectEditor) {
            //Date/time/timestap/ipaddr/packet/byte[]
            endObj = ((JCB_ObjectEditor) Compnt).getValue();
        }
        if (initObj != null && initObj.getClass().isArray()) {
            if (Compnt instanceof javax.swing.JTree) {
                int lg = java.lang.reflect.Array.getLength(initObj);
                endObj = java.lang.reflect.Array.newInstance(initObj.getClass().getComponentType(), lg);
                DefaultMutableTreeNode node = (DefaultMutableTreeNode) ((javax.swing.JTree) Compnt).getModel().getRoot();
                for (int i = 0; i < lg; i++) {
                    //Pb => need to find edited value !!!!
                    java.lang.reflect.Array.set(endObj, i, ((DefaultMutableTreeNode) node.getChildAt(i)).getUserObject());
                }
            }
        }
        if (endObj == null) {
            if (Compnt instanceof javax.swing.JTextField) {
                javax.swing.JTextField a = (javax.swing.JTextField) (Compnt);
                if (a.getText().toLowerCase().compareTo("NULL") == 0) {
                    endObj = null;
                } else {
                    if (initObj != null) {
                        if (initObj.getClass() == java.lang.String.class) {
                            endObj = a.getText();
                        }
                        try {
                            if (endObj == null) {
                                endObj = initObj.getClass().cast(a.getText());
                            }
                        } catch (ClassCastException ex) {
                            endObj = initObj; //null
                        }
                    }
                }
            } else {
                endObj = initObj;
            }
        }
        if (Compnt instanceof javax.swing.JPanel) {
            // --- this is a dirty patch to hide Model of I_Ports & Modifiers & Components
            for (int i = 0; i < ((javax.swing.JPanel) Compnt).getComponentCount(); i++) {
                if (((javax.swing.JPanel) Compnt).getComponent(i) instanceof JCB_ObjectEditor) {
                    ((JCB_ObjectEditor) ((javax.swing.JPanel) Compnt).getComponent(i)).hideEditor();
                }
            }
        }
        Compnt = null;
        initObj = endObj;
        return endObj;
    }

    @Override
    public boolean stopCellEditing() {
        if (editFrame != null) {
            editFrame.setVisible(false);
        }
        if (treemodel != null && editingpath != null) {//parent!=null
            Object newo = getCellEditorValue();
            if (newo != null) {
                treemodel.valueForPathChanged(editingpath, newo);
            } else {
                treemodel.valueForPathChanged(editingpath, initObj);
            }
        }
        /*  for (int i = 0; i < childs.size(); i++) {
         childs.get(i).stopCellEditing();
         }*/

        fireEditingStopped();
        boolean bool = super.stopCellEditing();
        return bool;
    }

    @Override
    public void cancelCellEditing() {
        //BasicTreeUI cancel all exit of cell (managed bay th main cell
        //double tableaux [][]
        //see if better to change mouse & keybord listners to the sub tree
        if (editFrame != null) {
            editFrame.setVisible(false);
        }
        if (treemodel != null && editingpath != null && Compnt != null) {//parent!=null
            Object o = getCellEditorValue();
            if (o != null) {
                treemodel.valueForPathChanged(editingpath, o);
            } else {
                treemodel.valueForPathChanged(editingpath, initObj);
            }
        }
    }

    @Override
    public Component getEditorComponent() {
        if (initObj instanceof javax.swing.JComboBox) {
            javax.swing.JComboBox<?> mem = (javax.swing.JComboBox<?>) initObj;
            Component c = this.getEditorCoponment(null, mem.getSelectedItem());
            initObj = mem;
            return c;
        } else {
            return new javax.swing.JLabel("nothing");
        }
    }

    @Override
    public void setItem(Object newValue) {
        if (initObj instanceof javax.swing.JComboBox<?>) {
            javax.swing.JComboBox<?> mem = (javax.swing.JComboBox<?>) initObj;
            if (mem.getSelectedItem().equals(newValue) == false) {
                ((javax.swing.JComboBox) initObj).removeAllItems();
                // mem.insertItemAt(newValue, mem.getSelectedIndex());
            }
        }
    }

    @Override
    public Object getItem() {
        if (initObj instanceof javax.swing.JComboBox<?>) {
            javax.swing.JComboBox<?> mem = (javax.swing.JComboBox<?>) initObj;
            return mem.getSelectedItem();
        }
        return null;
    }

    @Override
    public void selectAll() {
        //ignore
    }

    private void addActionListner(java.awt.Component com, ActionListener l) {
        try {
            java.lang.reflect.Method[] ms = com.getClass().getMethods();
            for (java.lang.reflect.Method m : ms) {
                if (m.getName().compareTo("addActionListener") == 0) {
                    m.invoke(com, l);
                }
            }
        } catch (SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            System.out.println("ObjectEditor : addActionListner() =>" + ex.getMessage());
        }
    }

    @Override
    public void addActionListener(ActionListener l) {

        if (l instanceof javax.swing.JComboBox) {
            initObj = l;
        } else if (Compnt != null) {
            addActionListner(Compnt, l);
            // recursive should be better.
            if (Compnt instanceof java.awt.Container) {
                java.awt.Container ct = ((java.awt.Container) Compnt);
                for (int i = 0; i < ct.getComponentCount(); i++) {
                    addActionListner(ct.getComponent(i), l);
                }
            }
        }
    }

    @Override
    public void removeActionListener(ActionListener l) {
    }
    /* ??? perhaps usefull???
     * for ComboBoxs...
     *     
    
     public boolean isCellEditable(EventObject anEvent) {    return true;  }
     public boolean shouldSelectCell(EventObject anEvent) {    return true;  }*/
    //  public boolean stopCellEditing() {fireEditingStopped(); return super.stopCellEditing();  }
    /*public void cancelCellEditing() { ;  }*/
    //  public void addCellEditorListener(javax.swing.event.CellEditorListener l) {
    //     l.editingStopped( new javax.swing.event.ChangeEvent(Obj) );
    // }
   /* public void removeCellEditorListener(javax.swing.event.CellEditorListener l) { ; }
     protected void fireEditingStopped() {
     super.fireEditingStopped();
     }*/
};
