package com.jdcm.editors;

import java.util.Arrays;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import com.jdcm.common.O_Amount;
import com.jdcm.common.O_MACaddress;
import java.awt.AWTException;
import java.awt.event.AdjustmentEvent;
import java.net.UnknownHostException;

/**
 * F_editors.java Created on 11 novembre 2007, 17:57
 * 
 * Form used to Test/Check Editors/renders<br> ACE_ObjRenderer &
 * ACE_ObjEditor<br> TO REWRITE (SEE editting/editable/default)<br> TO REWRITE
 * fixed size and Object Table<br>
 *
 * @author Marc GIBOIN
 */
public class A_editors extends javax.swing.JFrame {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    java.util.List<Object[]> vect = new java.util.ArrayList<>();
    java.util.List<String> vectname = new java.util.ArrayList<>();
    private DefaultMutableTreeNode top;
    private P_TableEditor panel_table;

    /**
     * create the form<br>
     *
     */
    public A_editors() {
        initComponents();
        setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        initEditor();
        setVisible(true);

    }

    public A_editors(String[] labels, Object[] vals) {
        initComponents();
            setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        vectname.add("Name");
        vectname.add("Value");
        if (labels.length != vals.length) {
            return;
        }
        for (int i = 0; i < labels.length; i++) {
            Object[] row = new Object[2];
            row[0] = labels[i];
            row[1] = vals[i];
            vect.add(row);
        }
        jTable1.setModel(new com.jdcm.common.ListTableModel(vect, vectname));
        jTree1.setVisible(false);
        jCheckBox1.setVisible(false);
        jCheckBox2.setVisible(false);
        jCheckBox3.setVisible(false);
        jSplitPane1.setDividerLocation(1.0);
        jCheckBox1.setSelected(true);
        jCheckBox2.setSelected(true);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellRenderer(new ACE_ObjRenderer<>());
        jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(new ACE_ObjEditor<>(iseditting()));
        setVisible(true);
    }

    /**
     * create the form for applet/sub form<br> if isapplet then close do not
     * exit system <br>
     *
     * @param isaplet
     */
    public A_editors(boolean isaplet) {
        initComponents();
        initEditor();
        setVisible(isaplet == false);
        jButton1.setEnabled(isaplet == false);
    }

    private void seteditting(boolean bool) {
        if (bool != iseditting()) {
            jCheckBox1.setSelected(bool);
        }
        initEditor();
    }

    private boolean iseditting() {
        return jCheckBox1.isSelected();
    }

    private void seteditable(boolean bool) {
        if (bool != iseditable()) {
            jCheckBox2.setSelected(bool);
        }
        initEditor();
    }

    private boolean iseditable() {
        return jCheckBox2.isSelected();
    }

    private void setdefault(boolean bool) {
        if (bool != isdefault()) {
            jCheckBox3.setSelected(bool);
        }
        initEditor();
    }

    private boolean isObjEditor() {
        return jCheckBox4.isSelected();
    }

    private void setObjEditor(boolean bool) {
        if (bool != isObjEditor()) {
            jCheckBox4.setSelected(bool);
        }
        initEditor();
    }

    private boolean isdefault() {
        return jCheckBox3.isSelected();
    }

    private void initEditor() {
        if (panel_table==null) {
            panel_table = new P_TableEditor();
            panel_table.setValue(P_TableEditor.defaultTable());
            jTabbedPane1.add("Table", panel_table);
        }
        String exemple = "text for test editor ";
        java.util.List<String> vected = new java.util.ArrayList<>();
        vected.addAll(Arrays.asList(exemple.split(" ")));
        /*
         * for (int i = 0; i < exemple.split(" ").length; i++) {
         * vected.add(exemple.split(" ")[i]);
        }
         */
        java.util.Enumeration<String> enumer = new java.util.Enumeration<String>(){
           String[] ex = "text for test editor ".split(" ");
           int i=0;
            @Override
            public boolean hasMoreElements() {
               return i<ex.length;
            }

            @Override
            public String nextElement() {
                if (i<ex.length){
                return ex[i++];
                }
                return null;
            }
    };
        vect.clear();
        vectname.clear();
        jTree1 = new javax.swing.JTree();
        jScrollPane2.setViewportView(jTree1);
        top = new DefaultMutableTreeNode("Objects tree editor");
        vectname.add("Name");
        vectname.add("Value");
        setObjectinTable(exemple);
        setObjectinTable(vected);
        setObjectinTable(Boolean.TRUE);
        setObjectinTable(new java.util.Date((long) 1239196266));//System.currentTimeMillis()
        setObjectinTable(new java.sql.Date(System.currentTimeMillis()));
        setObjectinTable(this.getFont());
        setObjectinTable(new java.sql.Time(3660));
        setObjectinTable(new java.sql.Timestamp(new Long("1239196266000")));
        setObjectinTable(new java.awt.Color(200, 0, 0));
        setObjectinTable(new javax.swing.table.DefaultTableModel(new Object[][]{exemple.split(" "), exemple.split(" ")}, exemple.split(" ")));
        setObjectinTable(exemple.getBytes());
        setObjectinTable(new Short("2"));
        setObjectinTable(exemple.getBytes()[0]);
        setObjectinTable(123456L);
        setObjectinTable(new Integer(1));
        setObjectinTable(new Float(1.00));
        setObjectinTable(new Double(1.00));
        setObjectinTable(new O_Amount(12.34));
        setObjectinTable(getClass().getMethods()[1]);
        setObjectinTable(new Exception("Exception text"));
        try {
            setObjectinTable(new O_MACaddress(new byte[]{0, 1, 2, 3, 4, 5}));
        } catch (Exception ex) {
            setObjectinTable("MAC not OK =>" + ex.getMessage());
        }
        setObjectinTable(new java.math.BigDecimal(123456));
        setObjectinTable(new java.awt.Point(1, 2));
        setObjectinTable(new java.awt.Dimension(1, 2));
        setObjectinTable(new java.awt.geom.Line2D.Double(1.0, 2.0, 3.0, 4.0));
        setObjectinTable(new java.awt.geom.Point2D.Double(1.0, 2.0));
        float f = new Float("1");
        setObjectinTable(new java.awt.geom.Rectangle2D.Float(f, f + 1, f + 2, f + 3));
        setObjectinTable(new com.jdcm.common.C_Packet(exemple, null));
        setObjectinTable("".getClass().getConstructors()[0]);
        setObjectinTable("".getClass().getFields()[0]);
        setObjectinTable(new javax.swing.JCheckBox());
        setObjectinTable(enumer);
        try {
            setObjectinTable((new java.awt.Robot()).createScreenCapture(new java.awt.Rectangle(10, 10, 100, 100)));
        } catch (AWTException ex) {
            setObjectinTable(ex);
             System.err.println("A_editor : initEditor()=>"+ex.getMessage());
        }
        setObjectinTable(new javax.swing.DefaultComboBoxModel<>(exemple.split(" ")));
        String[] ar = exemple.split(" ");
        String[] ar1 = exemple.split("e");
        String[] ar11 = exemple.split("o");
        setObjectinTable(new java.awt.Color[]{java.awt.Color.BLUE, java.awt.Color.CYAN, java.awt.Color.RED, java.awt.Color.BLACK});
        String[][] ar2 = {ar, ar1, ar11};
        setObjectinTable(ar2);
        try {
            setObjectinTable(java.net.Inet4Address.getLocalHost());
        } catch (UnknownHostException e) {
            System.err.println("A_editor : initEditor()=>"+e.getMessage());
        }
        setObjectinTable(null);
        setObjectinTable(new java.io.File("c:\\"));
        DefaultMutableTreeNode rt = new DefaultMutableTreeNode("-tree-");
        javax.swing.tree.TreeModel tm = new DefaultTreeModel(rt);
        for (String txt : exemple.split(" ")) {
            javax.swing.tree.DefaultMutableTreeNode node = new javax.swing.tree.DefaultMutableTreeNode(txt);
            rt.add(node);
        }
        setObjectinTable(new javax.swing.JTree(tm));
        jTable1.setModel(new com.jdcm.common.ListTableModel(vect, vectname));
        DefaultTreeModel treeModel = new DefaultTreeModel(top);
        jTree1.setModel(treeModel);
        //-------------------------SET EDITORS-------------------------------// 
        javax.swing.table.TableCellEditor edta = jTable1.getCellEditor();
        javax.swing.tree.TreeCellEditor edtr = jTree1.getCellEditor();
        javax.swing.tree.TreeCellRenderer rdtr = jTree1.getCellRenderer();
        javax.swing.table.TableCellRenderer rdta = jTable1.getColumn(jTable1.getColumnName(1)).getCellRenderer();
        if (isdefault() == false) {
            edta = new ACE_ObjEditor<>(iseditting(), isObjEditor());
            edtr = new ACE_ObjEditor<>(iseditting(), isObjEditor());
            rdtr = new ACE_ObjRenderer<>();
            rdta = new ACE_ObjRenderer<>();
        }
        panel_table.setmyEditor(edta);
        panel_table.setmyRender(rdta);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellRenderer(rdta);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(edta);
        jTree1.setCellRenderer(rdtr);
        jTree1.setCellEditor(edtr);
        //--------------------------------------------------------------
        jTree1.setEditable(iseditable());
        if (iseditable() == false) {
            jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(null);
        }
        jScrollPane2.getVerticalScrollBar().addAdjustmentListener(new java.awt.event.AdjustmentListener() {

            @Override
            public void adjustmentValueChanged(AdjustmentEvent e) {
                //adjustment beetwen 2 panel size.; minimus are 0
                int val=jScrollPane2.getVerticalScrollBar().getValue();
                int max=jScrollPane2.getVerticalScrollBar().getMaximum();
                int gap=jScrollPane1.getVerticalScrollBar().getMaximum()-max;
                int delta=0;
                if (max>0){
                    delta=gap*(val/max);
                }
                jScrollPane1.getVerticalScrollBar().setValue( val+delta);
            }
        });
        jTable1.repaint();
    }

    private void setObjectinTable(Object obj) {

        Object[] row = new Object[2];
        if (obj != null) {
            row[0] = obj.getClass().getSimpleName();
        } else {
            row[0] = "null";
        }
        row[1] = obj;
        vect.add(row);
        javax.swing.tree.DefaultMutableTreeNode node = new javax.swing.tree.DefaultMutableTreeNode(obj);
        top.add(node);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    //@SuppressWarnings("serial")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jButton1 = new javax.swing.JButton();

        setTitle("Test Renders");

        jSplitPane1.setDividerLocation(300);

        jScrollPane2.setViewportView(jTree1);

        jSplitPane1.setRightComponent(jScrollPane2);

        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);
        jScrollPane1.setViewportView(jTable1);

        jSplitPane1.setLeftComponent(jScrollPane1);

        jTabbedPane1.addTab("Editors", jSplitPane1);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);
        jTabbedPane1.getAccessibleContext().setAccessibleName("Editors");

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jLabel4.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("OBJECT EDITOR");
        jPanel1.add(jLabel4);

        jCheckBox1.setSelected(true);
        jCheckBox1.setText("editting");
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        jPanel1.add(jCheckBox1);

        jCheckBox2.setSelected(true);
        jCheckBox2.setText("editable");
        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });
        jPanel1.add(jCheckBox2);

        jCheckBox3.setText("Default");
        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });
        jPanel1.add(jCheckBox3);

        jCheckBox4.setText("ObjEditor");
        jCheckBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox4ActionPerformed(evt);
            }
        });
        jPanel1.add(jCheckBox4);

        jButton1.setText("Close");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        getContentPane().add(jPanel1, java.awt.BorderLayout.NORTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        if (this.getDefaultCloseOperation() == javax.swing.JFrame.EXIT_ON_CLOSE) {
            System.exit(0);
        } else {
            this.setVisible(false);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
    seteditting(iseditting());
}//GEN-LAST:event_jCheckBox1ActionPerformed

private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox2ActionPerformed
    seteditable(iseditable());
}//GEN-LAST:event_jCheckBox2ActionPerformed

private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
    setdefault(isdefault());
}//GEN-LAST:event_jCheckBox3ActionPerformed

private void jCheckBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox4ActionPerformed
    setObjEditor(isObjEditor());
}//GEN-LAST:event_jCheckBox4ActionPerformed
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                A_editors a_editors = new A_editors();
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
