/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.editors;

import com.jdcm.common.C_Packet;
import com.jdcm.common.G_AutoScrollBar;
import com.jdcm.common.Options_Model;
import com.jdcm.eltrx.C_Main;
import com.jdcm.eltrx.C_Port;
import com.jdcm.eltrx.F_Talc;
import com.jdcm.eltrx.C_Stack;
import com.jdcm.eltrx.T_DB;
import com.jdcm.modifiers.stacks.Stack_baseStart;
import com.jdcm.tests.verifChq;
import com.jdcm.tests.verifCtra;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.swing.BorderFactory;

/**
 * Smart Frame for EFT setting test
 *
 * @author Marc GIBOIN
 */
public class B_EFTsettings extends javax.swing.JPanel implements I_ObjectReceiver {

    private static final long serialVersionUID = 25L;
    private final DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
    private final java.awt.Color GREEN = new java.awt.Color(120, 180, 120);// new java.awt.Color(170, 255, 170);
    private final java.awt.Color RED = new java.awt.Color(255, 170, 170);
    private final java.util.List<java.lang.Thread> thrds = new java.util.ArrayList<>();
    private final java.awt.Color COLOR_SCROLL = new java.awt.Color(0, 255, 0, 90);
    private final javax.swing.JCheckBoxMenuItem menuIP = new javax.swing.JCheckBoxMenuItem("FullIP");
    private final javax.swing.JCheckBoxMenuItem menuLog = new javax.swing.JCheckBoxMenuItem("Détail");

    private C_Port Parent = null;
    private C_Main main = null;
    private F_Talc talc = null;
    private C_Stack stack = null;
    private String diagtcp = null;
    private C_Port dbport;
    private Options_Model options;
    private String passAddr = "193.56.46.150";
    private int passPort = 5496;
    private boolean isSsl = true;

    /**
     * Creates new form B_EFTsettings
     */
    public B_EFTsettings() {
        initComponents();
        initField();
        setName("DOM Testeur");
        jTextPane1.setEditable(false);
        G_AutoScrollBar scrl = new G_AutoScrollBar(COLOR_SCROLL);
        jScrollPane1.setVerticalScrollBar(scrl);
        scrl.setAutoScroll(true);
        initOptions();
    }

    private void initOptions() {
        // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        options = new Options_Model(this);
        options.addOption("eft_DBname", "verifCtra", "String", "", false, false, "the name ofthe used Database");
        options.addOption("eft_DBtype", "MySQL", "MYSQL/ODBC/..", "", false, false, "Database type");
        options.addOption("eft_DBlogin", "root", "String", "", false, false, "Database login");
        options.addOption("eft_DBpwd", "ody2007", "String", "", false, false, "Database password");
        options.addOption("eft_DBhost", "192.168.121.10", "IP range or host name", "", false, false, "Database host IP address");
        options.addOption("eft_DBport", 3306, "int", ">0<64000", false, false, "Database host TCP port");
    }

    /**
     * Provide an Icon if needed (asked by frames)
     *
     * @return an Icon of this Panel
     */
    public java.awt.Image getIcon() {
        return (new com.jdcm.common.D_Utils()).getImage("mat_unkn.gif");
    }

    private String getAppType() {
        return jComboBox1.getSelectedItem().toString();
    }

    public String getVersion() {
        return "" + serialVersionUID;
    }

    public java.util.List<javax.swing.JMenuItem> getMenus() {
        talc.addDocName("10012013-DOMTesteur.pdf");
        talc.addDocName("13082013-DOMTesteur.xls");
        java.util.List<javax.swing.JMenuItem> items = new java.util.ArrayList<>();
        final javax.swing.JCheckBoxMenuItem item4 = new javax.swing.JCheckBoxMenuItem("Look");
        item4.setActionCommand("Look");
        item4.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (item4.isSelected()) {
                    com.jdcm.common.D_Utils.addOpacytyListner((javax.swing.JFrame) Parent.getSlave());
                } else {
                    com.jdcm.common.D_Utils.removeOpacytyListner((javax.swing.JFrame) Parent.getSlave());
                }
            }
        });
        final javax.swing.JMenuItem item1 = new javax.swing.JMenuItem("Infos");
        item1.setActionCommand("TCP");
        item1.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String txt = getTCPinfo();
                javax.swing.JOptionPane.showMessageDialog(null, txt, "getTCPinfo", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            }
        });
        final javax.swing.JMenuItem item2 = new javax.swing.JMenuItem("Test");
        item2.setActionCommand("TCP");
        item2.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String txt = getTCPstatus();
                javax.swing.JOptionPane.showMessageDialog(null, txt, "getTCPstatus", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            }
        });
        final javax.swing.JMenuItem item0 = new javax.swing.JMenuItem("Objectif");
        item0.setActionCommand("?");
        item0.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String txt = "Cet outils a pour objectif de vérifier un contrat commerçant (domiciliation)\r\n"
                        + "dans le système informatique de l’acquéreur (la banque).\r\n"
                        + "Cette vérification pourra être faite sur un poste informatique\r\n"
                        + "sans matériel ni compétence monétique particulière.\r\n"
                        + "\r\n"
                        + "La réalisation de ce test en amont de l’intégration doit simplifier \r\n"
                        + "les flux de production et clarifier le dialogue avec le commerçant (notre client).\r\n"
                        + "Les modalitées et limites de ce logiciels sont définies "
                        + "dans les menu ? > Doc >.. ";
                javax.swing.JOptionPane.showMessageDialog(null, txt, "Objectif", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            }
        });

        final javax.swing.JMenuItem item3 = new javax.swing.JMenuItem("Banques");
        item3.setActionCommand("Info");
        item3.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                javax.swing.JFrame f = new javax.swing.JFrame("Banques");
                f.getContentPane().setLayout(new java.awt.BorderLayout());
                P_TableEditor ed = new P_TableEditor();
                boolean found = false;
                if (dbport != null && dbport.getSlave() instanceof T_DB) {
                    java.sql.ResultSet rs = ((T_DB) dbport.getSlave()).Trt_out("SELECT * FROM acquereurs ORDER BY network ASC, acqId ASC;");
                    if (rs != null) {
                        ed.setValue(rs);
                        ed.setDBPanelsVisible(false);
                        found = true;
                    }

                }
                if (found == false) {
                    if (getAppType().startsWith("CHQ")) {
                        ed.setValue(verifChq.getBankList());
                    } else {
                        ed.setValue(verifCtra.getBankList());
                    }
                }
                // f.setPreferredSize(new java.awt.Dimension(100,200));
                /*javax.swing.JScrollPane p = new javax.swing.JScrollPane();
                 javax.swing.JTable t = new javax.swing.JTable(verifCtra.getBankList());
                 p.setViewportView(t);*/
                ed.setSorter(true);
                f.getContentPane().add(ed, java.awt.BorderLayout.CENTER);
                f.pack();
                f.setVisible(true);

            }
        });

        menuIP.setActionCommand("TCP");
        menuIP.setEnabled(false);
        menuLog.setActionCommand("Info");
        menuLog.setEnabled(true);
        items.add(item0);
        items.add(item1);
        items.add(item2);
        items.add(item3);
        items.add(menuIP);
        items.add(menuLog);
        return items;
    }

    private void verifCheque(String acq, String id, String rang, String x25, String x25sec, String cud) {
        main.setStack_Enabled(true);
        try {
            stack.addStack(Parent.getPortName(), "ZCHPN", "CHPN", 7.0);
            com.jdcm.modifiers.stacks.I_stack_elt chqstack = stack.getTarget(Parent.getPortName(), "CHPN");
            chqstack.getOptions().setValuefor("tpe_acq", acq);
            chqstack.getOptions().setValuefor("tpe_cud", cud);
            chqstack.getOptions().setValuefor("tpe_id", id);
            chqstack.getOptions().setValuefor("tpe_rang", rang);
            chqstack.getOptions().setValuefor("tpe_passip", passAddr);
            chqstack.getOptions().setValuefor("tpe_passtcp", passPort);
            chqstack.getOptions().setValuefor("tpe_ssl", isSsl);
            if (x25 != null && x25.length() > 0) {
                chqstack.getOptions().setValuefor("tpe_host", x25);
            }
            if (x25sec != null && x25sec.length() > 0) {
                chqstack.getOptions().setValuefor("tpe_host2", x25sec);
            }
            //  jTextPane1.setText(jTextPane1.getText() + "Starting...\r\n");
            jTextPane1.setBackground(Color.lightGray);
            ((com.jdcm.modifiers.stacks.Stack_baseStart) chqstack).setStack_Start(true);
        } catch (Exception ex) {
            System.err.println("error in verifCard : " + ex.getMessage());
        }
    }

    private void verifCard(String acq, String mode, String id, String rang, String x25, String x25sec, String itp) {
        main.setStack_Enabled(true);
        // main.addStacks(new String[]{"zTPE"}, 0, Parent.getIndex() + 1);
        try {
            stack.addStack(Parent.getPortName(), "zTPE", "TPE", 7.0);
            //Set TPE Stack inputs and start it
            com.jdcm.modifiers.stacks.I_stack_elt tpestack = stack.getTarget(Parent.getPortName(), "TPE");
            tpestack.getOptions().setValuefor("tpe_acq", acq);
            tpestack.getOptions().setValuefor("tpe_id", id);
            tpestack.getOptions().setValuefor("tpe_rang", rang);
            tpestack.getOptions().setValuefor("tpe_passip", passAddr);
            tpestack.getOptions().setValuefor("tpe_passtcp", passPort);
            tpestack.getOptions().setValuefor("tpe_ssl", isSsl);
            javax.swing.DefaultComboBoxModel<String> cmbspec = tpestack.getOptions().getValuefor("tpe_spec", new javax.swing.DefaultComboBoxModel<String>());
            javax.swing.DefaultComboBoxModel<String> cmbtasa = tpestack.getOptions().getValuefor("tpe_tasa", new javax.swing.DefaultComboBoxModel<String>());
            if (x25 != null && x25.length() > 0) {
                tpestack.getOptions().setValuefor("tpe_host", x25);
            }
            if (x25sec != null && x25sec.length() > 0) {
                tpestack.getOptions().setValuefor("tpe_host2", x25sec);
            }
            if (mode.compareTo("CBVAD") == 0) {
                cmbspec.setSelectedItem("CB");
                cmbtasa.setSelectedItem("20:VAD");
                tpestack.getOptions().setValuefor("tpe_itp", "143520180351");
            } else if (mode.compareTo("CBEMV") == 0) {
                cmbspec.setSelectedItem("CB");
                cmbtasa.setSelectedItem("10:MPE");
                tpestack.getOptions().setValuefor("tpe_itp", itp);
            } else if (mode.compareTo("CBCTL") == 0) {
                cmbspec.setSelectedItem("CB");
                cmbtasa.setSelectedItem("10:MPE");
                tpestack.getOptions().setValuefor("tpe_itp", itp);
                tpestack.getOptions().setValuefor("tpe_isctl", true);
            } else if (mode.compareTo("CBQCASH") == 0) {
                cmbspec.setSelectedItem("CB");
                cmbtasa.setSelectedItem("60:QuasiCash");
                tpestack.getOptions().setValuefor("tpe_itp", "143520520031");
            } else if (mode.compareTo("CBPLBS") == 0) {
                cmbspec.setSelectedItem("CB");
                cmbtasa.setSelectedItem("80:preauto&PLBS");
                tpestack.getOptions().setValuefor("tpe_itp", "143520100706");
            } else if (mode.compareTo("AMEX") == 0) {
                cmbspec.setSelectedItem("AMEX:Amex");
                cmbtasa.setSelectedItem("90:Other");
                tpestack.getOptions().setValuefor("tpe_itp", "143100320210");
            } else if (mode.compareTo("JCB") == 0) {
                cmbspec.setSelectedItem("JCB:jcb");
                cmbtasa.setSelectedItem("90:Other");
                tpestack.getOptions().setValuefor("tpe_itp", "143400170160");
                if (menuIP.isSelected()) {
                    tpestack.getOptions().setValuefor("tpe_host", "0");
                    tpestack.getOptions().setValuefor("tpe_passip", "31.210.4.122");
                    tpestack.getOptions().setValuefor("tpe_passtcp", 15074);
                }
            } else if (mode.compareTo("CUP") == 0) {
                cmbspec.setSelectedItem("CBEMV");
                cmbtasa.setSelectedItem("10:MPE");
                tpestack.getOptions().setValuefor("tpe_itp", "143221100505");
                tpestack.getOptions().setValuefor("tpe_host", "1963400688809");
            } else if (mode.startsWith("CHQ")) {
            }
            String txt = "";
            if (tpestack.getOptions().getValuefor("tpe_host") != null) {
                String host = tpestack.getOptions().getValuefor("tpe_host", "");
                if (host.compareTo("0") == 0) {
                    txt += "Adress : \t" + tpestack.getOptions().getValuefor("tpe_passip", "")
                            + " TCP " + tpestack.getOptions().getValuefor("tpe_passtcp", 0) + "\r\n";
                } else {
                    txt += "Adress : \t" + host + "\r\n";
                }
            }
            txt += "Contrat : \t[" + mode + "]"
                    + tpestack.getOptions().getValuefor("tpe_id")
                    + "/" + tpestack.getOptions().getValuefor("tpe_rang")
                    + "@" + tpestack.getOptions().getValuefor("tpe_acq")
                    + " \r\n------------                                ------------";
            jTextPane1.setText(jTextPane1.getText() + txt);
            jTextPane1.setBackground(Color.lightGray);
            ((com.jdcm.modifiers.stacks.Stack_baseStart) tpestack).setStack_Start(true);
        } catch (Exception ex) {
            System.err.println("error in verifCard : " + ex.getMessage());
        }
    }

    private java.util.List<String> getAcqIdList() {
        java.util.List<String> res = new java.util.ArrayList<>();
        if (dbport != null && dbport.getSlave() instanceof T_DB) {
            java.sql.ResultSet rs = ((T_DB) dbport.getSlave()).Trt_out("SELECT acqId FROM acquereurs;");
            if (rs != null) {
                try {
                    // int i=0;
                    while (rs.next()) {//&& i<3
                        //   i++;
                        res.add(rs.getObject("acqID").toString());
                    }
                } catch (SQLException ex) {
                }
            }
        }
        if (res.isEmpty()) {
            javax.swing.table.DefaultTableModel tbl = verifCtra.getBankList();
            for (int i = 0; i < tbl.getRowCount(); i++) {
                res.add(tbl.getValueAt(i, 0).toString());
            }
        }
        return res;
    }

    /**
     * ---------------------------
     *
     * @param acq
     * @param mode
     * @param id
     * @param isctm
     * @param net
     * @return String[]{addr/addr2/ITP/CUD} -------------------------------
     */
    private String[] getAddress(String acq, String mode, String id, boolean isctm, String net) {
        String txt = "";
        String[] res;
        if (id.startsWith("1999") && mode.startsWith("CB")) {
            txt += "Contrat de test détecté\r\n";
            jTextPane1.setText(jTextPane1.getText() + txt);
            return new String[]{"196372527", "", "143520180530"};
        } else if (isctm && mode.startsWith("CHQ") == false) {
            txt += "CTM => 1963782134043\r\n";
            jTextPane1.setText(jTextPane1.getText() + txt);
            return new String[]{"1963782134043", "", "143520180530"};
        } else {
            String addr = null;
            String itp = null;
            String cud = null;
            String addrSec = null;
            String last = "Not checked";
            String libelle = "";
            String tel = "";
            if (dbport != null && dbport.getSlave() instanceof T_DB) {
                java.sql.ResultSet rs = ((T_DB) dbport.getSlave()).Trt_out(
                        "SELECT address,addrSec,itpCBemv,lastVerif,libelle,contact,network,x25cud FROM acquereurs WHERE acqId='" + acq + "' AND network='" + net + "';");
                try {
                    if (rs != null && rs.next()) {
                        addr = rs.getObject("address").toString();
                        addrSec = rs.getObject("addrSec").toString();
                        itp = rs.getObject("itpCBemv").toString();
                        last = rs.getObject("lastVerif").toString();
                        libelle = rs.getObject("libelle").toString();
                        tel = rs.getObject("contact").toString();
                        net = rs.getObject("network").toString();
                        cud = rs.getObject("x25cud").toString();
                        txt += "Source : base repar\r\n";
                    }

                } catch (SQLException ex) {
                     System.out.println("getAddress()=>" + ex);
                }
            }
            if (addr == null) {
                javax.swing.table.DefaultTableModel bankList;
                if (mode.startsWith("CHQ")) {
                    bankList = verifChq.getBankList();
                } else {
                    bankList = verifCtra.getBankList();
                }
                for (int i = 0; i < bankList.getRowCount(); i++) {
                    if ((bankList.getValueAt(i, 0).toString().compareTo(acq) == 0
                            || bankList.getValueAt(i, 0).toString().compareTo("IMC" + acq) == 0)
                            && net.compareTo(bankList.getValueAt(i, 5).toString()) == 0) {
                        if (mode.startsWith("CB") || mode.startsWith("CHQ")) {

                            if (bankList.getValueAt(i, 1) != null) {
                                addr = bankList.getValueAt(i, 1).toString();
                            }
                            addrSec = "" + bankList.getValueAt(i, 2);
                            libelle = "" + bankList.getValueAt(i, 4);
                            net = "" + bankList.getValueAt(i, 5);
                            itp = "" + verifCtra.getBankList().getValueAt(i, 6);
                            tel = "" + bankList.getValueAt(i, 7);
                            last = "" + bankList.getValueAt(i, 8);
                            cud = "" + bankList.getValueAt(i, 9);
                            txt += "Source : Locale\r\n";
                        }
                        i = verifCtra.getBankList().getRowCount();
                    }
                }
            }
            if (addr == null) {
                return null;
            } else {
                txt += "Banque : \t" + acq + ": '" + libelle + "' via " + net;

                if (tel != null && tel.startsWith("null") == false) {
                    txt += "\r\nTel : \t" + tel.toString();
                }
                if (last != null && last.startsWith("null") == false) {
                    txt += "\r\nLast check : \t" + last + "\r\n";
                } else {
                    txt += "\r\nNot checked\r\n";
                }
                if (mode.startsWith("CBEMV")) {
                    txt += "TPE : \t" + itp + "\r\n";
                }
                if (mode.startsWith("CHQ")) {
                    txt += "CUD : \t" + cud + "\r\n";
                }
                txt += "Primary Address : \t" + addr + "\r\n";
                if (addrSec != null && addrSec.trim().length() > 0) {
                    txt += "Secondary Address : \t" + addrSec + "\r\n";
                }
                txt += "\r\n";
            }
            res = new String[]{addr, addrSec, itp, cud};
        }
        jTextPane1.setText(jTextPane1.getText() + txt);
        return res;
    }

    private void changePasserelle() {
        if (isSsl) {
            jLabel1.setBorder(BorderFactory.createLineBorder(Color.black));
            passAddr = "localhost";
            passPort = 148;
            isSsl = false;
        } else {
            jLabel1.setBorder(null);
            passAddr = "193.56.46.150";
            passPort = 5496;
            isSsl = true;
        }
    }

    private void setStarted(boolean bool) {
        if (jToggleButton1.isSelected() != bool) {
            jToggleButton1.setSelected(bool);
        }
        //CHECK input Fields
        int bq = -1;
        long id = -1;
        int rg = -1;
        jTextField1.setText(jTextField1.getText().trim());
        jTextField2.setText(jTextField2.getText().trim());
        jTextField7.setText(jTextField7.getText().trim());
        try {
            bq = Integer.parseInt(jTextField1.getText());
        } catch (NumberFormatException ex) {
             System.out.println("setStarted()=>" + ex);
        }
        try {
            id = Long.parseLong(jTextField2.getText());
        } catch (NumberFormatException ex) {
            System.out.println("setStarted()=>" + ex);
        }
        try {
            rg = Integer.parseInt(jTextField7.getText());
        } catch (NumberFormatException ex) {
            System.out.println("setStarted()=>" + ex);
        }
        if (getAppType().startsWith("CHQ")) {
            if (jTextField1.getText().compareTo("FNCI") != 0
                    && jTextField1.getText().compareTo("TRANSAX") != 0
                    && jTextField1.getText().compareTo("C/S") != 0
                    && !getAppType().startsWith("CHQIMC")) {
                jTextField1.setBackground(RED);
                jToggleButton1.setSelected(false);
                jToggleButton1.setText("Start");
                return;
            }
            // 7 char for IMC ATOS & BPOP 9 seen on KOLB
            if (jTextField2.getText().length() < 7 && jTextField2.getText().length() > 10) {
                jTextField2.setBackground(RED);
                jToggleButton1.setSelected(false);
                jToggleButton1.setText("Start");
                return;
            }
        } else if (((bq < 10000 || bq > 99999) && jTextField1.getText().length() > 0)
                || id < 0
                || (rg < 0 || rg > 999 || jTextField7.getText().length() != 3)) {
            if (id < 0) {
                jTextField2.setBackground(RED);
            }
            if ((bq < 10000 || bq > 99999) && jTextField1.getText().length() > 0) {
                jTextField1.setBackground(RED);
            }
            if (rg < 0 || rg > 999 || jTextField7.getText().length() != 3) {
                jTextField7.setBackground(RED);
            }
            jToggleButton1.setSelected(false);
            jToggleButton1.setText("Start");
            return;
        }
        if (bool) {
            // CLEAR Data Fields
            jTextField3.setText("");
            jTextField4.setText("");
            jTextField5.setText("");
            jTextField6.setText("");
            jTextPane1.setText("");
            jTextField6.setToolTipText("");
            jTextField3.setToolTipText("");
            jTextField8.setText("");
            setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
            if (jTextField1.isEnabled()) {
                jTextField1.setBackground(Color.lightGray);
            }
            jTextField2.setBackground(Color.lightGray);
            jTextField7.setBackground(Color.lightGray);
            jCheckBox1.setEnabled(false);
            jComboBox1.setEnabled(false);
            menuIP.setEnabled(false);
            jTextPane1.setBackground(Color.GRAY);
            jToggleButton1.setText("Stop");
            jTextField1.setEditable(false);
            jProgressBar1.setValue(jProgressBar1.getMinimum());
            jProgressBar1.setForeground(jTextPane1.getBackground());
            jProgressBar1.setString("started");
            jProgressBar1.setStringPainted(true);
            jTextField2.setEditable(false);
            jTextField7.setEditable(false);
            if (getAppType().startsWith("CB") || getAppType().startsWith("CUP")) {
                if (jTextField1.getText().length() > 0) {
                    // simple test
                    if (jTextPane1.getText().contains("> Parametrage ...")) {
                        thrds.clear();
                    } else {
                        jProgressBar1.setString("X25 CB simple");
                        final String[] X25 = getAddress(jTextField1.getText(), getAppType(),
                                jTextField2.getText(), jCheckBox1.isSelected(), "X25");
                        if (X25 != null) {
                            java.lang.Thread trd = new java.lang.Thread(new java.lang.Runnable() {
                                @Override
                                public void run() {
                                    jTextField1.setBackground(Color.lightGray);
                                    verifCard(jTextField1.getText(), getAppType(),
                                            jTextField2.getText(), jTextField7.getText(), X25[0], X25[1], X25[2]);
                                }
                            });
                            thrds.add(trd);
                            jProgressBar1.setString("OK - X25");
                        } else {
                            jProgressBar1.setString("KO - X25");
                            jTextPane1.setText("No address or acquirer found");
                            Ends();
                        }
                    }

                } else if (jTextField2.getText().startsWith("1999") == false && jCheckBox1.isSelected() == false) {
                    // Scann all known code banque
                    thrds.clear();
                    java.util.List<String> acqIdList = getAcqIdList();
                    for (String acquereur : acqIdList) {
                        if (jTextPane1.getText().contains("> Parametrage ...")) {
                            thrds.clear();
                        } else {
                            jProgressBar1.setString("X25 CB multiple");
                            final String acq = acquereur;
                            java.lang.Thread trd = new java.lang.Thread(new java.lang.Runnable() {
                                @Override
                                public void run() {
                                    final String[] X25 = getAddress(acq, getAppType(),
                                            jTextField2.getText(), jCheckBox1.isSelected(), "X25");

                                    if (X25 != null && X25[0].length() > 0) {
                                        verifCard(acq, getAppType(),
                                                jTextField2.getText(), jTextField7.getText(), X25[0], X25[1], X25[2]);
                                    } else {
                                        jTextPane1.setText(" no address or acquirer found");
                                        jProgressBar1.setString("KO - X25");
                                        Ends();
                                    }
                                }
                            });
                            thrds.add(trd);
                        }
                    }
                    jProgressBar1.setString("OK - X25");
                } else {
                    jTextPane1.setText(" not able to do something with : " + jTextField2.getText() + "/" + jTextField7.getText() + "@" + jTextField2.getText() + " ctm : " + jCheckBox1.isSelected());
                    jProgressBar1.setString("KO - params");
                    Ends();
                }
            } else if (getAppType().startsWith("CHQ")) {
                jProgressBar1.setString("X25 CHQ simple");
                String acq = jTextField1.getText();
                if (getAppType().compareTo("CHQIMC") == 0 && acq.startsWith("IMC") == false) {
                    acq = "IMC" + acq;
                }
                final String[] X25 = getAddress(acq, getAppType(),
                        jTextField2.getText(), jCheckBox1.isSelected(), "X25");
                verifCheque(jTextField1.getText(),
                        jTextField2.getText(), jTextField7.getText(), X25[0], X25[1], X25[3]);
                jProgressBar1.setString("OK - X25");
            } else {
                // AMEX / JCB and OTHERS
                jProgressBar1.setString("X25 PRIV simple");
                verifCard(jTextField1.getText(), getAppType(),
                        jTextField2.getText(), jTextField7.getText(), "", "", "");
                jProgressBar1.setString("OK - X25");
            }
            if (thrds.isEmpty() == false) {
                thrds.remove(0).start();
            }
            try {
                if (menuLog.isSelected()) {
                    stack.addStack(Parent.getPortName(), "Log", "Detail", 6.0);
                    com.jdcm.modifiers.stacks.Stack_Log logstack = (com.jdcm.modifiers.stacks.Stack_Log) stack.getTarget(Parent.getPortName(), "Detail");
                    if (logstack != null) {
                        logstack.setlog_outmode("OUTPUT_SCREENLOCK");
                        logstack.setStack_Start(true);
                        logstack.getlog_Terminal().configure_Shell();
                    } else {
                        menuLog.setSelected(false);
                    }
                }
            } catch (Exception ex) {
                System.out.println("=> pb while openning Logs : " + ex.getMessage());
            }
            jProgressBar1.setString("connecting");
        } else {
            jProgressBar1.setString("Stop Asked");
            try {
                if (thrds.isEmpty() == false) {
                    thrds.clear();
                }
                Ends();

            } catch (Exception ex) {
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel2 = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jTextField7 = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jToggleButton1 = new javax.swing.JToggleButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jPanel8 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jTextField3 = new javax.swing.JTextField();
        jTextField4 = new javax.swing.JTextField();
        jTextField5 = new javax.swing.JTextField();
        jTextField8 = new javax.swing.JTextField();
        jTextField6 = new javax.swing.JTextField();
        jPanel5 = new javax.swing.JPanel();
        jProgressBar1 = new javax.swing.JProgressBar();

        setPreferredSize(new java.awt.Dimension(450, 250));
        addAncestorListener(new javax.swing.event.AncestorListener() {
            public void ancestorMoved(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorRemoved(javax.swing.event.AncestorEvent evt) {
                formAncestorRemoved(evt);
            }
            public void ancestorAdded(javax.swing.event.AncestorEvent evt) {
            }
        });
        setLayout(new java.awt.BorderLayout());

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "CBEMV", "CBVAD", "CBQCASH", "CBPLBS","CBCTL", "JCB", "AMEX" ,"CUP","CHQFNCI","CHQTRX","CHQC/S","CHQIMC"}));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jPanel2.add(jComboBox1);

        jLabel1.setText("Acq : ");
        jLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel1MouseClicked(evt);
            }
        });
        jPanel2.add(jLabel1);

        jTextField1.setText("30056");
        jTextField1.setToolTipText("");
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextField1KeyPressed(evt);
            }
        });
        jPanel2.add(jTextField1);

        jLabel2.setText("Dom : ");
        jLabel2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel2MouseClicked(evt);
            }
        });
        jPanel2.add(jLabel2);

        jTextField2.setText("1999025");
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });
        jTextField2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextField2KeyPressed(evt);
            }
        });
        jPanel2.add(jTextField2);

        jTextField7.setText("001");
        jTextField7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField7ActionPerformed(evt);
            }
        });
        jTextField7.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextField7KeyPressed(evt);
            }
        });
        jPanel2.add(jTextField7);
        jPanel2.add(jPanel4);

        jCheckBox1.setText("CTM");
        jCheckBox1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jCheckBox1MousePressed(evt);
            }
        });
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        jPanel2.add(jCheckBox1);

        jToggleButton1.setText("Start");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jToggleButton1);

        add(jPanel2, java.awt.BorderLayout.NORTH);

        jScrollPane1.setOpaque(false);
        jScrollPane1.setViewportView(jTextPane1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel8.setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.GridLayout(5, 0));

        jLabel4.setText("Ensei : ");
        jPanel1.add(jLabel4);

        jLabel5.setText("Lieu :");
        jPanel1.add(jLabel5);

        jLabel6.setText("Siret : ");
        jPanel1.add(jLabel6);

        jLabel8.setText("MCC :");
        jPanel1.add(jLabel8);

        jLabel7.setText("CTC :");
        jPanel1.add(jLabel7);

        jPanel8.add(jPanel1, java.awt.BorderLayout.WEST);

        jPanel3.setLayout(new java.awt.GridLayout(5, 0));

        jTextField3.setEditable(false);
        jPanel3.add(jTextField3);

        jTextField4.setEditable(false);
        jPanel3.add(jTextField4);

        jTextField5.setEditable(false);
        jPanel3.add(jTextField5);

        jTextField8.setEditable(false);
        jPanel3.add(jTextField8);

        jTextField6.setEditable(false);
        jPanel3.add(jTextField6);

        jPanel8.add(jPanel3, java.awt.BorderLayout.CENTER);

        add(jPanel8, java.awt.BorderLayout.SOUTH);

        jPanel5.setLayout(new java.awt.BorderLayout());
        add(jPanel5, java.awt.BorderLayout.LINE_END);

        jProgressBar1.setFont(new java.awt.Font("Tahoma", 2, 10)); // NOI18N
        jProgressBar1.setOrientation(1);
        jProgressBar1.setToolTipText("progres");
        jProgressBar1.setBorderPainted(false);
        jProgressBar1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jProgressBar1.setString("0 / 30");
        jProgressBar1.setStringPainted(true);
        add(jProgressBar1, java.awt.BorderLayout.WEST);
    }// </editor-fold>//GEN-END:initComponents

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        setStarted(jToggleButton1.isSelected());
    }//GEN-LAST:event_jToggleButton1ActionPerformed
    private void initField() {
        if (jToggleButton1.isSelected()) {
            return;
        }
        jProgressBar1.setValue(jProgressBar1.getMinimum());
        jProgressBar1.setStringPainted(true);
        jProgressBar1.setForeground(jTextPane1.getBackground());
        jTextField1.setBackground(Color.WHITE);
        jTextField2.setBackground(Color.WHITE);
        jTextField7.setBackground(Color.WHITE);
        jTextPane1.setBackground(Color.lightGray);
        jTextField3.setText("");
        jTextField4.setText("");
        jTextField5.setText("");
        jTextField6.setText("");
        jTextField6.setToolTipText("");
        jTextField3.setToolTipText("");
        jTextField8.setText("");
        jTextPane1.setText("");
        if (getAppType().endsWith("JCB")) {
            jTextField1.setText("30003");
            // jTextField1.setBackground(Color.lightGray);
            jTextField1.setEnabled(false);
            jCheckBox1.setEnabled(false);
            menuIP.setEnabled(true);
        } else if (getAppType().endsWith("AMEX")) {
            jTextField1.setText("12345");
            // jTextField1.setBackground(Color.lightGray);
            jTextField1.setEnabled(false);
            menuIP.setEnabled(true);
            jCheckBox1.setEnabled(true);
        } else if (getAppType().endsWith("CUP")) {
            menuIP.setEnabled(false);
            jTextField1.setEnabled(true);
            jCheckBox1.setEnabled(false);
        } else if (getAppType().endsWith("CHQFNCI")) {
            jTextField1.setText("FNCI");
            // jTextField2.setText("BFXZE658R5");
            // jTextField2.setText("ABCDE00A99");
            jTextField1.setEnabled(false);
            menuIP.setEnabled(true);
            jCheckBox1.setEnabled(false);
        } else if (getAppType().endsWith("CHQTRX")) {
            jTextField1.setText("TRANSAX");
            // jTextField2.setText("0040241200");
            jTextField1.setEnabled(false);
            menuIP.setEnabled(true);
            jCheckBox1.setEnabled(false);
        } else if (getAppType().endsWith("CHQC/S")) {
            jTextField1.setText("C/S");
            // jTextField2.setText("0034295101");
            jTextField1.setEnabled(false);
            menuIP.setEnabled(true);
            jCheckBox1.setEnabled(false);
        } else if (getAppType().endsWith("CHQIMC")) {
            //BANK   is needed for X25  jTextField1.setText("C/S");=>11899
            // jTextField2.setText("9994236437");
            jTextField1.setEnabled(true);
            jCheckBox1.setEnabled(true);
            //  menuIP.setEnabled(true);
            if (jCheckBox1.isSelected()) {
                jTextField1.setText("IMCCTM");
                jTextField1.setEnabled(false);
            } else {
                jTextField1.setEnabled(true);
                if (jTextField1.getText().compareTo("IMCCTM") == 0) {
                    jTextField1.setText("30056");
                }
            }
        } else {
            menuIP.setEnabled(false);
            // jTextField1.setBackground(Color.WHITE);
            jTextField1.setEnabled(true);
            jCheckBox1.setEnabled(true);
        }
        if (jTextField1.getText().compareTo("IMCCTM") == 0 && getAppType().endsWith("CHQIMC") == false) {
            jTextField1.setText("30056");
        }
    }
    private void jTextField1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyPressed
        initField();
    }//GEN-LAST:event_jTextField1KeyPressed

    private void jTextField2KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField2KeyPressed
        initField();
    }//GEN-LAST:event_jTextField2KeyPressed

    private void jTextField7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField7ActionPerformed
        setStarted(true);
    }//GEN-LAST:event_jTextField7ActionPerformed

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
        setStarted(true);
    }//GEN-LAST:event_jTextField2ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        setStarted(true);
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jTextField7KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField7KeyPressed
        initField();
    }//GEN-LAST:event_jTextField7KeyPressed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        initField();
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jLabel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseClicked
        if (evt.isControlDown()) {
            changePasserelle();
        }
    }//GEN-LAST:event_jLabel1MouseClicked

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        initField();
    }//GEN-LAST:event_jCheckBox1ActionPerformed

    private void jCheckBox1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCheckBox1MousePressed
        if (jCheckBox1.isEnabled() == false) {
            initField();
        }
    }//GEN-LAST:event_jCheckBox1MousePressed

    private void jLabel2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel2MouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jLabel2MouseClicked

    private void formAncestorRemoved(javax.swing.event.AncestorEvent evt) {//GEN-FIRST:event_formAncestorRemoved
        com.jdcm.modifiers.stacks.Stack_Log logstack = (com.jdcm.modifiers.stacks.Stack_Log) stack.getTarget(Parent.getPortName(), "Detail");
        if (logstack != null) {
            logstack.setStack_Start(false);
            main.removeStack("Detail", Parent.getIndex());
        }
        Ends();
    }//GEN-LAST:event_formAncestorRemoved

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JToggleButton jToggleButton1;
    // End of variables declaration//GEN-END:variables

    public void Ends() {
        jProgressBar1.setString("Stopping");
        jTextField1.setEditable(true);
        jTextField2.setEditable(true);
        jTextField7.setEditable(true);
        jComboBox1.setEnabled(true);
        menuIP.setEnabled(true);
        com.jdcm.modifiers.stacks.I_stack_elt tpestack = stack.getTarget(Parent.getPortName(), "TPE");
        if (tpestack instanceof com.jdcm.modifiers.stacks.Stack_baseStart) {
            com.jdcm.modifiers.stacks.Stack_baseStart tpestart = (com.jdcm.modifiers.stacks.Stack_baseStart) tpestack;
            if (tpestart.isStack_isStart()) {
                tpestart.setStack_Start(false);
            }
            main.removeStack("TPE", Parent.getIndex());
        }
        tpestack = stack.getTarget(Parent.getPortName(), "CHPN");
        if (tpestack instanceof com.jdcm.modifiers.stacks.Stack_baseStart) {
            com.jdcm.modifiers.stacks.Stack_baseStart tpestart = (com.jdcm.modifiers.stacks.Stack_baseStart) tpestack;
            if (tpestart.isStack_isStart()) {
                tpestart.setStack_Start(false);
            }
            main.removeStack("CHPN", Parent.getIndex());
        }

        main.setStack_Enabled(false);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        if (thrds != null && thrds.isEmpty() == false) {
            String title = thrds.size() + "> ";
            if (jTextPane1.getText().length() == 0) {
                jTextPane1.setText(title);
            } else {
                jTextPane1.setText(jTextPane1.getText() + title);
            }
            thrds.remove(0).start();
        } else {
            jToggleButton1.setText("Start");
            jToggleButton1.setSelected(false);
            jProgressBar1.setValue(jProgressBar1.getMaximum());
            jProgressBar1.setForeground(jTextPane1.getBackground());
            jProgressBar1.setStringPainted(true);
        }
        jProgressBar1.setString("Stopped");
    }

    public String getTCPinfo() {
        String txt = "Passerelle : \r\n";
        try {
            main.addStacks(new String[]{"zTPE"}, 7, Parent.getIndex() + 1);
            main.setStack_Enabled(true);
            Stack_baseStart elt = (Stack_baseStart) stack.getTarget(Parent, "zTPE");
            txt += elt.getOptions().getValuefor("tpe_passip", "");
            txt += " tcp : " + elt.getOptions().getValuefor("tpe_passtcp", 0);
            if (elt.getOptions().getValuefor("tpe_ssl", true)) {
                txt = txt + " +SSL";
            }
            main.removeStacks(Parent.getIndex() + 1);
            main.setStack_Enabled(false);
        } catch (Exception ex) {
        }
        return txt;
    }

    public String getTCPstatus() {
        diagtcp = "Tests : \r\n";
        try {
            this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
            stack.addStack(Parent.getPortName(), "zTPE", 8.0);
            Stack_baseStart elt = (Stack_baseStart) stack.getTarget(Parent, "zTPE");
            stack.setStack_Enabled(true);
            stack.setStackOption(Parent.getPortName(), "zTPE", "tpe_acq", "");
            stack.setStackOption(Parent.getPortName(), "zTPE", "tpe_id", "");
            stack.setStackOption(Parent.getPortName(), "zTPE", "tpe_ssl", false);
            stack.setStackMethod(Parent.getPortName(), "zTPE", "setStack_Start", true);
            stack.setStackOption(Parent.getPortName(), "zTPE", "tpe_verbose", true);
            while (elt.isStack_isStart()) {
            }
            if (diagtcp.contains("=>OK")) {
                stack.setStackOption(Parent.getPortName(), "zTPE", "tpe_ssl", true);
                stack.setStackMethod(Parent.getPortName(), "zTPE", "setStack_Start", true);
                while (elt.isStack_isStart()) {
                }
            }
            main.removeStacks(Parent.getIndex() + 1);
            stack.setStack_Enabled(true);
            this.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        } catch (Exception ex) {
            System.err.println("getTCPStatus() :=>" + ex.getMessage());
        }
        String txt = diagtcp;
        diagtcp = null;
        return txt;
    }

    @Override
    public void receiveObj(Object obj) {
        String roll = "-\\|/";
        if (obj instanceof C_Port) {
            jProgressBar1.setString("Initialising...");
            Parent = (C_Port) obj;
            ((javax.swing.JFrame) Parent.slave).addWindowListener(new java.awt.event.WindowAdapter() {
                @Override
                public void windowClosing(java.awt.event.WindowEvent evt) {
                    setStarted(false);
                }
            });
            main = ((C_Main) Parent.getMain());
            stack = (C_Stack) main.getCMDChilds("Stacks").get(0);
            dbport = (C_Port) main.addCX("Port", "DBAddr", "DB");
            talc = (com.jdcm.eltrx.F_Talc) Parent.getSlave();
            if (dbport == null) {
                java.util.List<com.jdcm.eltrx.I_Command> dbs = main.getCMDChilds("DBAddr");
                if (dbs != null && dbs.isEmpty() == false) {
                    if (dbs.get(0) instanceof C_Port) {
                        dbport = (C_Port) dbs.get(0);
                    }
                }
            }
            dbport.setDB_host(options.getValuefor("eft_DBhost", ""));
            dbport.setDB_port(options.getValuefor("eft_DBport", 0));
            dbport.setDB_type(options.getValuefor("eft_DBtype", ""));
            dbport.setDB_user(options.getValuefor("eft_DBlogin", ""));
            dbport.setDB_pwd(options.getValuefor("eft_DBpwd", ""));
            dbport.setDB_name(options.getValuefor("eft_DBname", ""));
            //     dbport.setCX_Banner("select * from acquereurs".getBytes());
            jProgressBar1.setString("Ready");
            dbport.CXstart();
            jProgressBar1.setString("Initialised");
        } else if (obj instanceof String && obj.toString().compareTo("/CLOSE TALC/") == 0) {
            jProgressBar1.setString("CLOSING TALC");
            Ends();
            if (dbport != null) {
                dbport.CXstop();
                dbport.CXend();
            }
            stack.setStack_Enabled(false);
            jProgressBar1.setString("CLOSED TALC");
        } else if (jToggleButton1.isSelected() == false && diagtcp == null) {
            // Stop was asked, process should be stoped if message is still receved thrown it
            thrds.clear();
        } else if (obj instanceof C_Packet && ((C_Packet) obj).isbuffer()) {
            String txt = new String(((C_Packet) obj).getBytes());
            if (diagtcp != null) {
                if (txt.startsWith(">")) {
                    diagtcp = diagtcp + txt;
                }
            } else {
                if (jProgressBar1.getString().contains("Table :") == false) {
                    jTextPane1.setText(jTextPane1.getText() + "\r\n" + txt);
                }
                int posrol = roll.indexOf(jProgressBar1.getString().substring(0, 1));
                if (posrol == -1) {
                    jProgressBar1.setString("- " + jProgressBar1.getString());
                } else if (posrol < roll.length() - 1) {
                    jProgressBar1.setString(roll.substring(posrol + 1, posrol + 2) + jProgressBar1.getString().substring(1));
                } else {
                    jProgressBar1.setString("-" + jProgressBar1.getString().substring(1));
                }

                // receive Standard output of TPE stack then print informations
                if (txt.contains("=>OK") && !txt.startsWith("X25 ")) {
                    jTextPane1.setText(jTextPane1.getText()
                            + " \r\nDate  : \t" + dateFormat.format(new Date()) + " > Parametrage ...\r\n");
                    jTextPane1.setBackground(GREEN);
                    jProgressBar1.setString("ending");
                    if (!thrds.isEmpty()) {
                        thrds.clear();
                    }
                } else if (txt.contains("=>KO") || (txt.contains("=>OK") && txt.startsWith("X25 "))) {
                    jTextPane1.setText(jTextPane1.getText()
                            + " \r\nDate  : \t" + dateFormat.format(new Date()) + " > KO\r\n");
                    jProgressBar1.setString("ending");
                    if (txt.contains("=>OK") && txt.startsWith("X25 ")) {
                        jTextPane1.setText(jTextPane1.getText()
                                + "------------------- Unreachable X25 -----------------\r\n");
                    } else {
                        jTextPane1.setBackground(RED);
                    }
                    Ends();
                } else if (txt.startsWith("Table :")) {
                    int pos = Integer.parseInt(txt.substring("Table :".length(), txt.indexOf("-")).trim());
                    int max = Integer.parseInt(txt.substring(txt.indexOf("/") + 1).trim());
                    jProgressBar1.setMaximum(max);
                    jProgressBar1.setValue(pos);
                    jProgressBar1.setString("- Table : " + pos);
                    jProgressBar1.setForeground(jTextPane1.getBackground());
                } else if (txt.startsWith(" Bank:")) {
                    // jEditorPane1.setText(jEditorPane1.getText() + " \r\n>calling ... " );
                } else if (txt.startsWith("- Enseigne")) {
                    jTextField3.setText(txt.substring(txt.indexOf(":") + 1));
                } else if (txt.startsWith("- Lieu")) {
                    jTextField4.setText(txt.substring(txt.indexOf(":") + 1));
                } else if (txt.startsWith("- SIRET")) {
                    jTextField5.setText(txt.substring(txt.indexOf(":") + 1));
                } else if (txt.startsWith("- MCC")) {
                    jTextField8.setText(txt.substring(txt.indexOf(":") + 1));
                } else if (txt.startsWith("- telco col:") && txt.indexOf("; Apls :") > 0) {
                    jTextField6.setToolTipText("Remise : " + txt.substring(txt.indexOf("; Apls :") + "; Apls :".length()));
                } else if (txt.startsWith("- Tkt client")) {
                    jTextField3.setToolTipText("TICKET CLIENT : \r\n\"" + txt.substring(txt.indexOf(":") + 1).trim() + "\";");
                } else if (txt.startsWith("- Tkt hdr")) {
                    jTextField3.setToolTipText(jTextField3.getToolTipText()
                            + "\r\nTICKET HEAD : \r\n\""
                            + txt.substring(txt.indexOf(":") + 1).trim() + "\";");
                } else if (txt.contains("-------- [IDSA :")) {
                    jTextPane1.setText(jTextPane1.getText() + "\r\n" + txt.substring(txt.indexOf("[IDSA :") + 1, txt.indexOf("]")));
                } else if (txt.contains("-- [IMPRESSION : ")) {
                    jTextPane1.setText(jTextPane1.getText() + "\r\n" + txt.substring(txt.indexOf("-- [IMPRESSION : ") + 4, txt.indexOf("]")));
                } else if (txt.contains("--[TEST SEC")) {
                    jTextPane1.setText(jTextPane1.getText() + "\r\n" + txt.substring(txt.indexOf("--[TEST SEC") + 7, txt.indexOf("]")));
                } else if (txt.startsWith("- Tkt end")) {
                    jTextField3.setToolTipText(jTextField3.getToolTipText()
                            + "\r\nTICKET FOOT : \r\n\""
                            + txt.substring(txt.indexOf(":") + 1).trim() + "\"");
                } else if (txt.startsWith("- telco par")) {
                    jTextField6.setText(txt.substring(txt.indexOf("A]"), txt.indexOf("; Apls :")));
                    if (getAppType().startsWith("CB")// could also update CHQ  ..??
                            && jTextField2.getText().startsWith("1999") == false
                            && jCheckBox1.isSelected() == false
                            && jTextField6.getText().contains("1963782134043") == false
                            && jTextField6.getText().contains("1963782131050") == false) {
                        //"1963782134043" because acquier return CTM address even if acquiere is directly asked by TPE
                        if (dbport != null && dbport.getcxstatus().compareTo("connected") == 0) {
                            if (jTextField6.getText().indexOf(">") > 0) {
                                // Update BD if present
                                String addrPrinc = jTextField6.getText().substring(jTextField6.getText().indexOf(">") + 1, jTextField6.getText().indexOf(" B]"));
                                String addrSec = jTextField6.getText().substring(jTextField6.getText().lastIndexOf(">") + 1);
                                String AcqId = jTextField1.getText();
                                int resUpd = -1;
                                String net = "X25";
                                if (addrPrinc.indexOf(":") > 0) {
                                    net = "TCP";
                                }
                                java.sql.ResultSet rs = ((T_DB) dbport.getSlave()).Trt_out("SELECT Locked FROM acquereurs WHERE acqId='" + AcqId + "' AND network='" + net + "';");
                                boolean isLocked = false;
                                try {
                                    if (rs != null && rs.next()) {
                                        if ((Integer) rs.getObject("Locked") == 1) {
                                            isLocked = true;
                                        }
                                    }
                                } catch (SQLException ex) {
                                    System.out.println("B_EFTsettings : receiveObj()=>" + ex);
                                }
                                if (isLocked == false) {
                                    resUpd = ((T_DB) dbport.getSlave()).Trt_in("UPDATE acquereurs set address='" + addrPrinc + "' WHERE acqId='" + AcqId + "' AND network='" + net + "';");
                                    if (addrSec != null && addrSec.compareTo(addrPrinc) != 0) {
                                        resUpd += ((T_DB) dbport.getSlave()).Trt_in("UPDATE acquereurs set addrSec='" + addrSec + "' WHERE acqId='" + AcqId + "' AND network='" + net + "';");
                                    } else {
                                        addrSec = "";
                                    }
                                    if (resUpd <= 0) {
                                        resUpd = ((T_DB) dbport.getSlave()).Trt_in("INSERT INTO acquereurs (acqId,address,addrSec,libelle,network,contact,lastVerif) VALUES ('" + AcqId + "','" + addrPrinc + "','" + addrSec + "',to ajust...','" + net + "','','');");
                                    }
                                }
                                String date = (new SimpleDateFormat("dd/MM/yyyy HH:mm:ss")).format(new Date(System.currentTimeMillis()));
                                if (resUpd > 0) {
                                    resUpd += ((T_DB) dbport.getSlave()).Trt_in("Update acquereurs set lastVerif='" + date + "' where acqId='" + AcqId + "' and network='" + net + "';");
                                    //Update acquereurs set address='196370076' where  acqId='18406' and network='X25';
                                }
                            }
                        }
                    }
                } else if (txt.startsWith("CHQ X25")) {
                    jTextField6.setText(txt.substring(txt.indexOf(": ") + 2));
                } else if (txt.startsWith("CHQ ")) {
                    jTextPane1.setText(jTextPane1.getText() + txt.substring("CHQ ".length()));
                } else if (txt.contains("- [System Actif] -")) {
                    jTextPane1.setText(jTextPane1.getText() + "\r\n[System Actif]\r\n");
                    jTextPane1.setBackground(GREEN.brighter());
                    Ends();
                } else if (txt.contains("- [System NON ")
                        || txt.contains("- [ABNORMAL END")
                        || txt.contains("- [NETWORK KO")
                        || txt.contains("- [UNKNOWN ACQU")
                        || txt.contains("- [REFUSED CON")
                        || txt.contains("- [PB BANK CODE")) {
                    jTextPane1.setText(jTextPane1.getText() + "\r\n[" + txt.substring(txt.indexOf("[") + 1, txt.indexOf("]") + 1) + "\r\n");
                    jTextPane1.setBackground(Color.ORANGE);
                    Ends();
                } else if (txt.startsWith("Pb receive") || txt.startsWith("Receive")) {
                    Ends();
                }
            }
        }
    }
}
