package com.jdcm.editors;

import com.jdcm.common.*;
import com.jdcm.eltrx.D_Debug;
import java.awt.event.ComponentEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import java.lang.reflect.InvocationTargetException;
import java.net.MalformedURLException;
import javax.swing.JFrame;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.tools.DiagnosticCollector;
import javax.tools.JavaFileObject;
import javax.tools.ToolProvider;

/**
 * F_Compile.java Created on 25 oct. 2010, 20:29:57
 *
 * Propose a compilation on the fly Form... UNPROPERLY used as Text Editor...
 *
 * @author Marc GIBOIN
 * @param <T>
 */
public class F_Compile<T> extends javax.swing.JFrame implements I_FileSystem {

    private static final long serialVersionUID = 1L;
    private final D_Debug TDeb = new D_Debug("Compile");
    private final D_Utils TUtils = new D_Utils();
    private final java.util.List<Object> Objs = new java.util.ArrayList<>();
    private com.jdcm.common.CharSequenceCompiler<?> ByteCompiler = null;
    java.io.File editedFile = null;
    private java.awt.Window Parent = null;
    //java.util.List<SimpleAttributeSet> myAttributes = null;
    private String packag = null;
    private java.util.List<String> imports = null;
    private Options_Model options;
    private P_Texte p_Texte1;

    /**
     * Creates new form F_Compile
     */
    public F_Compile() {
        initComponents();
        init();
    }

    public F_Compile(String txt) {
        initComponents();
        init();
        setText(txt);
        if (txt.length() > 0) {
            jTabbedPane1.setEnabledAt(0, false);
            jButton4.setEnabled(false);
            jTabbedPane1.setSelectedIndex(1);
        }
    }

    public F_Compile(java.io.File file) {
        initComponents();
        init();
        setSelectedFile(file);
        // display file on fileSystem tree.
        p_FileSystem1.setFile(file);
    }

    private void init() {
        /*
         * this.addComponentListener(new java.awt.event.ComponentAdapter() {
         *
         * @Override public void componentResized(ComponentEvent e) {
         * jSplitPane2.setDividerLocation(getHeight()-100); } });
         */
        setIconImage(TUtils.getImage("build_on.gif"));
        // javac -version should be better !!!
        options = new Options_Model(this);
        options.addOption("isVerbose", false, "Boolean", "0/1", true, false, "send versose on the outStream");
        options.addOption("isHelp", false, "Boolean", "0/1", true, false, "Print a synopsis of standard options");
        options.addOption("nowarn", false, "Boolean", "0/1", true, false, "Disable warning messages");
        options.addOption("debugInfo", false, "Boolean", "0/1", true, false, "Generate all debugging information, including local variables.");
        options.addOption("deprecation", false, "Boolean", "0/1", true, false, "Show a description of each use or override of a deprecated member or class");
        options.addOption("SrcVersion", System.getProperty("java.specification.version"), "String", "1.X", true, false, "source java versions");
        options.addOption("DestVersion", System.getProperty("java.specification.version"), "String", "1.X", true, false, "destination class java versions");
        options.addOption("classpath", "", "String", "c:\\toto,c:\\", true, true, "Set the user class path, overriding the user class path in the CLASSPATH environment variable");
        options.addOption("destDir", "", "String", "c:\\", true, true, "Set the destination directory for class files");
        options.addOption("sourcepath", "", "String", "c:\\", true, true, "Specify the source code path to search for class or interface definitions");
        G_ButtonTabComponent bpanel = new G_ButtonTabComponent(jTabbedPane2, true, null) {
            private static final long serialVersionUID = 1L;

            @Override
            public void addTab() {
                addTextTab("NewTab");
            }
        };
        jTabbedPane2.setTabComponentAt(jTabbedPane2.getTabCount() - 1, bpanel);
        bpanel.addTab();
        jCB_ObjectEditor2.setValue(options);
        p_FileSystem1.setParent(this);
        //TODO : see .jar & for netbean JDatacom dir
        p_FileSystem1.setBaseRep("com/jdcm", ".java");
        jTree1.setCellEditor(null);//new com.jdcm.editors.ACE_ObjEditor(true)
        jTree1.setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jButton1.setIcon(TUtils.getIcon("build_on.gif"));
        jButton3.setIcon(TUtils.getIcon("Empty.gif"));
        jButton4.setIcon(TUtils.getIcon("home.gif"));
        jButton2.setIcon(TUtils.getIcon("Classes.gif"));
        jCB_ObjectEditor1.setValue(getClass().getClassLoader());
        jCB_ObjectEditor1.setAsButton(true);
        jTable1.getColumnModel().getColumn(0).setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jTable1.getColumnModel().getColumn(0).setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>());
        p_Diagram1.setToolBar(false);

    }

    public javax.swing.JPanel addTextTab(String Title) {
        final P_Texte newPanel = new P_Texte();
        newPanel.addComponentListener(new java.awt.event.ComponentAdapter() {
            @Override
            public void componentShown(ComponentEvent e) {
                p_Texte1 = newPanel;
            }
        });
        javax.swing.JTabbedPane pane = jTabbedPane2;
        pane.insertTab(Title, null, newPanel, null, pane.getTabCount() - 1);
        if (pane.getTabCount() > 1) {
            G_ButtonTabComponent tab = new G_ButtonTabComponent(pane, false, newPanel);
            pane.setTabComponentAt(pane.getTabCount() - 2, tab);
        }
        pane.setSelectedIndex(pane.getTabCount() - 2);
        newPanel.setAutoScroll(false);
        p_Texte1=newPanel;
        return newPanel;
    }

    public javax.swing.JPanel addImageTab(String Title) {
        final P_ImageEditor newPanel = new P_ImageEditor();
        newPanel.addComponentListener(new java.awt.event.ComponentAdapter() {
            @Override
            public void componentShown(ComponentEvent e) {
            }
        });
        javax.swing.JTabbedPane pane = jTabbedPane2;
        pane.insertTab("Tab " + pane.getTabCount(), null, newPanel, null, pane.getTabCount() - 1);
        if (pane.getTabCount() > 1) {
            G_ButtonTabComponent tab = new G_ButtonTabComponent(pane, false, newPanel);
            pane.setTabComponentAt(pane.getTabCount() - 2, tab);
        }
        pane.setSelectedIndex(pane.getTabCount() - 2);
        return newPanel;
    }
    
    public void setParent(java.awt.Window w) {
        Parent = w;
        Parent.setVisible(false);
    }

    public T getResult() {
        if (jTable1.getModel().getRowCount() == 0) {
            return null;
        } else if (jTable1.getModel().getRowCount() == 1) {
            if (jTable1.getValueAt(0, 0) instanceof java.lang.Class) {
                return (T) jTable1.getValueAt(0, 0);
            }
        }
        return null;
    }

    public void setClassLoader(ClassLoader l) {
        jCB_ObjectEditor1.setValue(l);
    }

    public final void setText(String name) {
        if (name == null) {
            return;
        }
        boolean found = false;
        if (found == false) {
            // jCB_ObjectEditor1.setEnabled(false);
            name = p_Texte1.insertCode(name);
            if (name != null) {
                displayStructure(name);
            }
        }
    }

    public String getAllCode() {
        String res = "";
        javax.swing.tree.DefaultMutableTreeNode root = (javax.swing.tree.DefaultMutableTreeNode) jTree1.getModel().getRoot();
        for (int i = 0; i < root.getChildCount(); i++) {
            javax.swing.tree.DefaultMutableTreeNode node = (javax.swing.tree.DefaultMutableTreeNode) root.getChildAt(i);
            if (node.getUserObject() instanceof com.jdcm.common.C_textClass) {
                res += ((com.jdcm.common.C_textClass) node.getUserObject()).getAllCode();
            }
        }
        return res;
    }
    private void seeImgFile(File file) {
        P_ImageEditor panel=(P_ImageEditor)addImageTab(file.getName());
               try {
            BufferedImage bi = javax.imageio.ImageIO.read(file);
            panel.setValue(bi);
        } catch (IOException ex) {
            System.err.println("F_Compile : seeImgFile() =>" + ex);
        }
        
    }
    private void seeTxtFile(File file) {

        //p_Diagram1.setVisible(false);
        // java.io.InputStream is = null;
        p_Texte1.setFile(file, p_FileSystem1.getClassLoader());
      //  p_Texte1.colorCode();
        jTabbedPane2.setTitleAt(jTabbedPane2.getSelectedIndex(), file.getName());
        jTabbedPane2.getTabComponentAt(jTabbedPane2.getSelectedIndex()).repaint();
        for (int i = 0; i < jTabbedPane2.getTabCount(); i++) {
            if (jTabbedPane2.getTitleAt(i).startsWith("Diagram")) {
                if (p_Texte1.getType().startsWith("JAVA") == false) {
                    jTabbedPane2.removeTabAt(i);
                }
            }
        }
        jTabbedPane1.setEnabledAt(1, p_Texte1.getType().compareTo("JAVA") == 0);
    }

    private void displayStructure(String txtcode) {
        p_Diagram1.clear();
        jTree1.setModel(null);
        if (txtcode == null || p_Texte1.getType().startsWith("JAVA") == false) {
            return;
        }

        javax.swing.tree.TreeModel model = getJavaDocTree(txtcode);
        jTree1.setModel(model);
        jTree1.setEditable(true);
        if (model != null && model.getChildCount(model.getRoot()) > 0) {
            javax.swing.tree.DefaultMutableTreeNode clnode = (javax.swing.tree.DefaultMutableTreeNode) model.getChild(model.getRoot(), 0);
            C_textClass theclass = (C_textClass) clnode.getUserObject();
            jTree1.expandPath(new javax.swing.tree.TreePath(clnode.getPath()));
            com.jdcm.diagram.A_Events evt = new com.jdcm.diagram.A_Events((java.io.InputStream) null);
            //    int idxc = 0, idxm = 0, idxt = 0;
            for (C_textElement elt : theclass.getElements()) {
                com.jdcm.diagram.A_Element status = new com.jdcm.diagram.A_Element();
                evt.addStatus(status);
                if (elt instanceof C_textMethod) {
                    C_textMethod meth = (C_textMethod) elt;
                    status.setcontent(meth);
                    if (meth.isConstructor()) {
                        // status.setBounds(10, idxc * 40, 150, 30);
                        status.setInitial(true);
                        //          idxc++;
                    } else {
                        //Fields/...
                        // fr.setBounds(330, idxm * 40, 150, 30);
                        //          idxm++;
                    }
                } else {
                    //      idxt++;
                }
            }
            p_Diagram1.setEvents(evt);
            for (com.jdcm.diagram.A_Element elt : p_Diagram1.getEvents().getStatuslist()) {
                if (elt.getcontent() instanceof C_textMethod) {
                    C_textMethod meth1 = (C_textMethod) elt.getcontent();
                    for (com.jdcm.diagram.A_Element elt2 : p_Diagram1.getEvents().getStatuslist()) {
                        if (elt2.getcontent() instanceof C_textMethod) {
                            C_textMethod meth2 = (C_textMethod) elt2.getcontent();
                            String txt = meth2.getName() + "(";
                            int pos = meth1.getCode().indexOf("{");
                            if (pos >= 0 && meth1.getCode().substring(pos).contains(txt)) {
                                p_Diagram1.getEvents().setTask(elt, elt2);
                            }
                        }

                    }
                }
            }
        }
    }

    private javax.swing.tree.TreeModel getJavaDocTree(String txtcode) {
        javax.swing.tree.DefaultMutableTreeNode root = new javax.swing.tree.DefaultMutableTreeNode("=>doc");
        if (txtcode == null || txtcode.length() == 0) {
            return null;
        }
        String txt = txtcode;
        String hook2 = "{";
        packag = null;
        imports = null;
        while (txt.trim().length() > 0) {
            int pospar = TUtils.nonCommentPos(txt, hook2, 0, true);
            //int pospar = txt.indexOf(hook2, hook1.length());
            if (pospar < 0) {
                // Pb : no start/end of class
                txt = "";
            } else {
                int endcl = p_Texte1.findPairPosition(txt, pospar);
                if (endcl >= 0) {
                    DefaultMutableTreeNode cnode = getClassTree(root, txt.substring(0, endcl));
                    C_textClass cltxt = (C_textClass) cnode.getUserObject();
                    if (root.getUserObject().toString().startsWith("=>doc")) {
                        root.setUserObject(cltxt.getSimpleName() + ".java");
                    }
                    packag = cltxt.getPackage();
                    imports = cltxt.getImports();
                    root.add(cnode);
                    txt = txt.substring(endcl + 1);
                } else {
                    // class brace is not closed...
                    txt = "";
                }
            }
        }

        return new javax.swing.tree.DefaultTreeModel(root);

    }

    private boolean isField(String txtcl) {
        // !!!need to check the ; is not inside a comment else look for next
        int ptvir = TUtils.nonCommentPos(txtcl, ";", 0, true);
        if (ptvir < 0) {
            return false;
        } else {
            txtcl = txtcl.substring(0, ptvir).trim();
            int pteg = TUtils.nonCommentPos(txtcl, "=", 0, true);
            int ptpar = TUtils.nonCommentPos(txtcl, "(", 0, true);
            int ptpart = TUtils.nonCommentPos(txtcl, "{", 0, true);
            int ptat = TUtils.nonCommentPos(txtcl, "@A_C", 0, true);
            if (ptat > 0 && ptat < ptpart) {
                System.out.print(";p;p");
            }
            if (pteg < 0) {
                if (ptpar < 0 && ptpart < 0) {
                    //private D_Debug TDeb;
                    return true;
                }
            } else {
                if (ptpar < 0 && ptpart < 0) {
                    //private D_Debug TDeb=null; =>true
                    return true;
                } else if (ptpar > 0 && pteg < ptpar) {
                    //private D_Debug TDeb = new D_Debug("Compile"); =>true
                    return true;
                } else if (ptpart > 0 && pteg < ptpart && (ptpar < 0 || pteg < ptpar)) {
                    //private byte[] head = new byte[]{0,10,1...}; => true
                    //@A_Commande(help = "try to load) public void load(){... => false
                    return true;
                }
            }
        }
        return false;
    }

    private DefaultMutableTreeNode getClassTree(DefaultMutableTreeNode relevantnode, String txtcode) {
        DefaultMutableTreeNode mcl;
        DefaultMutableTreeNode resnode;
        DefaultMutableTreeNode extnode = null;
        C_textClass relevantclass = null;
        if (relevantnode.getUserObject() instanceof C_textClass) {
            relevantclass = (C_textClass) relevantnode.getUserObject();
        }
        C_textClass txtclasse;
        if (imports == null) {
            txtclasse = new C_textClass(relevantclass, txtcode);
        } else {
            txtclasse = new C_textClass(packag, imports, relevantclass, txtcode);
        }
        // manage extends
        if (txtclasse.getSuperclass() != null) {
            extnode = new DefaultMutableTreeNode(new C_textClass(relevantclass, txtclasse.getSuperclass()));
            for (java.lang.reflect.Field f : txtclasse.getSuperclass().getDeclaredFields()) {
                extnode.add(new DefaultMutableTreeNode(f));
            }
            for (java.lang.reflect.Method m : txtclasse.getSuperclass().getDeclaredMethods()) {
                extnode.add(new DefaultMutableTreeNode(m));
            }
        }
        resnode = new DefaultMutableTreeNode(txtclasse);
        String txtcl = txtcode.substring(TUtils.nonCommentPos(txtcode, "{", 0, true) + 1);//txtcode.indexOf("{") + 1);
        while (txtcl.length() > 0) {
            int ptpart = TUtils.nonCommentPos(txtcl, "{", 0, true);
            int ptpar = TUtils.nonCommentPos(txtcl, "(", 0, true);
            int ptptvir = TUtils.nonCommentPos(txtcl, ";", 0, true);
            int ptvir = TUtils.nonCommentPos(txtcl, ",", 0, true);
            int pteg = TUtils.nonCommentPos(txtcl, "=", 0, true);
            if (isField(txtcl)) {
                String fldtxt = txtcl.substring(0, ptptvir).trim();
                if (ptvir < 0 || ptvir > ptptvir || (pteg > 0 && ptvir > pteg)) {
                    //care   private String[] columnNames = {"Label", "TypeName", "Nullable"}; 
                    C_textField val = new C_textField(txtclasse, fldtxt);
                    txtclasse.addField(val);
                    mcl = new DefaultMutableTreeNode(val);
                    resnode.add(mcl);
                } else {
                    // manage : double minx,miny,maxx,maxy as double maxx; double minx; ...
                    String type = fldtxt.substring(0, fldtxt.indexOf(" "));
                    String[] vals = fldtxt.substring(fldtxt.indexOf(" ")).split(",");
                    for (String txt : vals) {
                        C_textField val = new C_textField(txtclasse, type + " " + txt);
                        txtclasse.addField(val);
                        mcl = new DefaultMutableTreeNode(val);
                        resnode.add(mcl);
                    }
                }

                // txtclasse.addGlobal(txtcl.substring(0, ptvir));
                txtcl = txtcl.substring(ptptvir + 1);
            } else if (ptpart > 0 && (ptpart < ptptvir || ptptvir < 0)) {
                //NORMAL CLASS
                int endmeth = p_Texte1.findPairPosition(txtcl, ptpart);
                if (endmeth < 0) {
                    return null;
                } else if (ptpart > 0 && ptpart < ptpar) {
                    //inside class : class obj{....};
                    javax.swing.tree.DefaultMutableTreeNode clnode = getClassTree(resnode, txtcl.substring(0, endmeth).trim());
                    resnode.add(clnode);
                    txtclasse.addClasse((C_textClass) clnode.getUserObject());
                    txtcl = txtcl.substring(endmeth + 1).trim();
                } else {
                    // normal class public myClass(){...
                    C_textMethod meth = new C_textMethod(txtclasse, txtcl.substring(0, endmeth + 1).trim());
                    txtclasse.addMethod(meth);
                    mcl = new DefaultMutableTreeNode(meth);
                    if (meth.isConstructor()) {
                        resnode.insert(mcl, 0);
                    } else {
                        resnode.add(mcl);
                    }
                    txtcl = txtcl.substring(endmeth + 1);
                }
            } else if (ptpar >= 0 && ptpar < ptptvir && (ptpart < 0 || ptpart > ptpar)) {
                //  Class declaration in inteface
                //!!!!! pb on getHeader
                C_textMethod meth = new C_textMethod(txtclasse, txtcl.substring(0, ptptvir + 1).trim());
                txtclasse.addMethod(meth);
                mcl = new DefaultMutableTreeNode(meth);
                resnode.add(mcl);
                txtcl = txtcl.substring(ptptvir + 1);
            } else if (txtcl.trim().length() != 0) {
                txtcl = txtclasse.setComment(txtcl);
                // txtcl = "";
            } else {
                txtcl = "";
            }
            txtcl = txtcl.trim();
            if (txtcl.startsWith(";")) {
                txtcl = txtcl.substring(1);
            }
        }
        if (extnode != null) {
            resnode.insert(extnode, 0);
            // resnode = extnode;
        }

        return resnode;
    }

    private java.util.List<String> getCompileOptions() {
        java.util.List<String> res = new java.util.ArrayList<>();
        //res.addAll(java.util.Arrays.asList(new String[]{"-source", options.getValuefor("SrcVersion", ""), "-target", options.getValuefor("DestVersion", "")}));

        if (options.getValuefor("SrcVersion", "").length() > 0) {
            res.add("-source");
            res.add(options.getValuefor("SrcVersion", ""));
        }
        if (options.getValuefor("DestVersion", "").length() > 0) {
            res.add("-target");
            res.add(options.getValuefor("DestVersion", ""));
        }
        if (options.getValuefor("isVerbose", true)) {
            res.add("-verbose");
        }
        if (options.getValuefor("debugInfo", true)) {
            res.add("-g");
        }
        if (options.getValuefor("deprecation", true)) {
            res.add("-deprecation");
        }
        if (options.getValuefor("deprecation", true)) {
            res.add("-deprecation");
        }
        if (options.getValuefor("nowarn", true)) {
            res.add("-nowarn");
        }
        if (options.getValuefor("isHelp", true)) {
            res.add("-help");
        }

        if (options.getValuefor("destDir", "") != null) {
            res.add("-d");
            res.add(options.getValuefor("destDir", ""));
        }
        if (options.getValuefor("sourcepath", "") != null) {
            res.add("-sourcepath");
            res.add(options.getValuefor("sourcepath", ""));
        }
        if (options.getValuefor("classpath", "") != null) {
            res.add("-classpath");
            res.add(options.getValuefor("classpath", ""));
        }
        if (res.isEmpty()) {
            res = null;
        }
        return res;
    }

    private boolean checkTools(ClassLoader loader) {
        // CHECK tools.jar from JDK used for compilation
        try {
            Class<?> o = java.lang.Class.forName("javax.tools.ToolProvider");
            java.lang.reflect.Method m = o.getDeclaredMethod("getSystemJavaCompiler", new Class<?>[]{});
            if (m == null) {
                TDeb.wri("javax.tools.ToolProvider.getSystemJavaCompiler() not found");
                return false;
            }
            if (m.invoke(o, new Object[]{}) == null) {// 
                TDeb.wri("javax.tools.ToolProvider.getSystemJavaCompiler() KO");
                // return false;
            }
            System.out.println("==>3.3" + m.getName());
            //warning: [unchecked] unchecked call to CharSequenceCompiler(java.lang.ClassLoader,java.lang.Iterable<java.lang.String>) as a member of the raw type com.jdcm.common.CharSequenceCompiler
            //@java.lang.SuppressWarnings("[unchecked]")
            ByteCompiler = new com.jdcm.common.CharSequenceCompiler<>(loader, getCompileOptions());
        } catch (ClassNotFoundException | NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException th) {
            TDeb.wri("java Tools are disabled (! file is more than 10Mo) " + th.getMessage());
            return false;
        }
        TDeb.wri("compiler" + ByteCompiler.toString());
        return true;
    }

    private int compileClass() {
        String code = this.p_Texte1.getText();
        jTable1.setModel(new javax.swing.table.DefaultTableModel(new Object[][]{}, new Object[]{"Result"}));
        boolean isok = false;
        if (code == null) {
            return -1;
        }
///----------------------------------- ON THE FLY CLASS  in memory--------------------------

        /**
         * Generate Java source for a Function which computes f(x)=expr
         *
         * @param expr String representation of Java expression that returns a
         * double value for an input value x. The class in which this expression
         * is embedded uses static import for all the members of the
         * java.lang.Math class so they can be accessed without qualification.
         * @return an object which computes the function denoted by expr
         */
// Object o = null;
        final javax.tools.DiagnosticCollector<javax.tools.JavaFileObject> errs = new javax.tools.DiagnosticCollector<>();
        final ClassLoader theloader = (ClassLoader) jCB_ObjectEditor1.getValue();
        checkTools(theloader);
        java.util.List<String> classList = new java.util.ArrayList<>();
        try {
            //  System.gc();
            // generate UN?secure unique(?) package and class names
            // all of that could be find in the tree (checked)

            // Package
            String packageName = null;
            int posdecl = code.indexOf("public class");
            int packpos = code.lastIndexOf("package", posdecl);
            String importName;
            if (packpos >= 0) {
                packageName = code.substring(packpos + "package".length(), code.indexOf(";", packpos)).trim();
                importName = code.substring(code.indexOf(";", packpos), posdecl);
            } else {
                importName = code.substring(0, posdecl);
            }
            //IMPORT
            while (importName.indexOf("import") > 0) {
                String cl = importName.substring(importName.indexOf("import") + "import".length(), importName.indexOf(";", importName.indexOf("import")));
                classList.add(cl.trim());
                importName = importName.substring(importName.indexOf(";", importName.indexOf("import")));
            }
            // class Name
            String className = code.substring(posdecl + "public class".length()).trim();
            className = className.substring(0, className.indexOf(" ")).trim();
            /// Implement
            String fli = code.substring(posdecl, code.indexOf("{", posdecl) - 1);
            String fle = fli;
            String fl = "";
            if (fli.indexOf("implements") > 0) {
                fli = fli.substring(fli.indexOf("implements") + "implements".length()).trim();
                fle = fle.substring(0, fle.indexOf("implements"));
                // must find the end ({ ou extends or???)
                fl = fli;
            }
            if (fle.indexOf("extends") > 0) {
                fle = fle.substring(fle.indexOf("extends") + "extends".length()).trim();
                fl = fl + "," + fle;
            }

            for (String cl : fl.split(",")) {
                if (cl.trim().length() > 0) {
                    classList.add(cl.trim());
                }
            }
            for (String cl : classList) {
                try {
                    theloader.loadClass(cl.trim());
                } catch (ClassNotFoundException e) {
                }
            }
            if (packageName != null) {
                className = packageName + '.' + className;
            }
            // compile the generated Java source
            // System.out.println("==>"+code);
            Class<?> compiledClass = ByteCompiler.compile(className, code, errs, new Class<?>[]{});

            /*
             * Map<String, CharSequence> classes = new HashMap<String,
             * CharSequence>(1); classes.put("stack_base",
             * jTextPane1.getText().trim()); classes.put("stack_dump",
             * jTextPane1.getText().trim()); classes.put(className, code); Map
             * compiled = compiler.compile(classes, errs); Class<?>
             * compiledClass=(Class<?>)compiled.get(className);
             */
            //System.out.println("==>5" + compiledClass.toString());
            displayResult(errs, compiledClass, true);
        } catch (CharSequenceCompilerException | ClassCastException e) {
            displayResult(errs, null, false);
        }
//-------------------------------- OLD COMPILATION ON DISK------------------------------
        /*
         * try { FileOutputStream fos = new
         * FileOutputStream(javafile.getAbsolutePath()); OutputStreamWriter osw
         * = new OutputStreamWriter(fos, "ISO-8859-1");
         * osw.write(jTextPane1.getText()); osw.close(); } catch (IOException
         * ex) { TDeb.wri("Pb while writing java source file"); return -1; } No
         * wildcards since no command line interpreter to expand them. String[]
         * optionsAndSources = {"-source", "1.5", "-target", "1.5",
         * javafile.getAbsolutePath()}; //"....java" PrintWriter listing = new
         * PrintWriter(System.out, false); //=> TDeb.wri(" status of compilation
         * : "+com.sun.tools.javac.Main.compile( optionsAndSources, listing ));
         * //----------- To avoid compilation error if tools.jar is not
         * present--------- try { Object o = checkTools().newInstance();
         * java.lang.reflect.Method m = null; m =
         * o.getClass().getMethod("compile", optionsAndSources.getClass(),
         * listing.getClass()); Object s = m.invoke(o, (Object)
         * optionsAndSources, (Object) listing); TDeb.wri("compilation status: "
         * + s); } catch (Exception ex) { TDeb.wri("Pb during compilation : " +
         * ex.getMessage()); }
         * //------------------------------------------------------------------------------
         *
         */
        return 0;
    }

    private void displayResult(DiagnosticCollector<JavaFileObject> errs, Class<?> compiledClass, boolean compileIsOk) {
        boolean isOk = false;
        Objs.clear();
        if (compiledClass == null) {
            for (javax.tools.Diagnostic<? extends JavaFileObject> diagnostic : errs.getDiagnostics()) {
                System.out.println(diagnostic.getMessage(java.util.Locale.getDefault()));
            }
        } else {
            Objs.add(compiledClass);
            isOk = true;
            //  showCompil(false);
        }
        if (errs.getDiagnostics().isEmpty() == false) {
            for (Object o : errs.getDiagnostics()) {
                Objs.add(o);
            }
        } else if (compileIsOk && compiledClass == null) {
            Objs.add("compiled");
        }
        if (isOk == false) {
            displayDiagOnText(errs.getDiagnostics());
        }
        jTable1.setModel(new javax.swing.table.DefaultTableModel(new Object[][]{Objs.toArray()}, new Object[]{"Result"}));
        jTable1.getColumnModel().getColumn(0).setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jTable1.getColumnModel().getColumn(0).setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>());
    }

    @Override
    public void setSelectedFile(java.io.File file) {
        String txt;
        //NOT p_Texte1.setFile(file); because need to magage directories=> something to simplfy...
        editedFile = file;
        p_Texte1.clear();
        if (file == null) {
            if (p_FileSystem1.getBaseRep().length() > 0) {
                displayStructure(null);
                p_Texte1.setText("file is null\r\n-----------");
            } else if (file == null && p_FileSystem1.getBaseRep().length() == 0) {
                p_Texte1.setText("Root\r\n-----------");
            }
        } else {
            TDeb.wri("Ask for file :" + file.getName());
            String name = file.toURI().toString();
            // Manage Directories 
            if (file.isDirectory()
                    || name.endsWith(".jar")
                    || (name.contains("jar!")
                    && name.substring(name.lastIndexOf("/")).indexOf(".") == -1)) {
                txt = "";
                txt += file.getPath() + "  \r\n";
                java.util.List<java.io.File> liste = null;
                if (file.isDirectory() && file.getName().endsWith(".jar") == false) {
                    try {
                        liste = java.util.Arrays.asList(file.listFiles());
                    } catch (java.lang.NullPointerException ex) {
                        System.err.println("Utils:getFiles() no authorization! =>" + ex.getMessage());
                        liste = new java.util.ArrayList<>();
                    }
                } else {
                    try {
                        if (file.getName().endsWith(".jar")) {
                            liste = TUtils.getJarFiles("jar:" + file.toURI().toString() + "!/");
                        } else {
                            liste = TUtils.getJarFiles(TUtils.getJarFile(file.toURI().toURL()), file.toURI().toString());
                        }
                    } catch (MalformedURLException ex) {
                        System.err.println("F_Compile : setSelectedFile()=>" + ex.getMessage());
                    }
                }
                txt += liste.size() + " entries"
                        + "\r\n--------------------- \r\n";
                for (java.io.File f : liste) {
                   
                    if (f.isDirectory()) {
                        txt += "DIR"  + " \t " +new java.util.Date(f.lastModified())+ " \t <"+ f.getName() + " >\r\n";
                    } else if (f.toURI().toString().contains(".jar!")
                            || f.getName().endsWith(".jar")) {
                        //get size with element.getSize();
                        txt += "jarFile \t " + f.getName() + " \r\n";
                    } else if (f instanceof C_httpFile) {
                        txt += "" + ((C_httpFile) f).gethttpSize() + " \t " +((C_httpFile) f).gethttpDate()+ "\t" + f.getName()  + " \r\n";
                    } else {
                        long size=f.length();
                        String strsz="o";
                        if (size>1000000){
                            size=Math.abs(size/1000000);
                            strsz="Mo";
                        }else if (size>1000){
                            size=Math.abs(size/1000);
                             strsz="Ko";
                        }
                        txt += "" + size  +strsz+ "\t" + new java.util.Date(f.lastModified()) + " \t " + f.getName()+ " \r\n";
                    }
                }
                editedFile = null;
                p_Texte1.setText(txt);
            } else if (file.canRead() || file.toURI().toString().contains("jar!")) {
                String ext="";
                java.util.List<String> imgexts=java.util.Arrays.asList(".jpg,.bmp,.jpeg,.gif,.png,.tif,.tiff".split(","));
                if (file.getName().indexOf(".")>0){
                    ext=file.getName().substring(file.getName().lastIndexOf("."));
                }
                 if (imgexts.contains(ext.toLowerCase())){
                    seeImgFile(file);
                }else if (file.length() > 1000000) {
                    p_Texte1.setText("too long content");
                }else{
                     seeTxtFile(file); 
                }
            } else {
                p_Texte1.setText("no read permission");
            }
        }
        // if (java.text.Normalizer.isNormalized(txt, Form.NFD)) {
        jTabbedPane2.getTabComponentAt(jTabbedPane2.getSelectedIndex()).repaint();
        p_Texte1.setOpenedFile(file);
        if (editedFile == null) {
            if (file != null) {
                jTabbedPane2.setTitleAt(jTabbedPane2.getSelectedIndex(), file.toString());
                p_Texte1.setStatusText(file.getName());
            } else {
                jTabbedPane2.setTitleAt(jTabbedPane2.getSelectedIndex(), "");
                p_Texte1.setStatusText("");
            }
            p_Texte1.setType("DIR");

        } else if (file != null) {
            jTabbedPane2.setTitleAt(jTabbedPane2.getSelectedIndex(), file.getName());
            if (editedFile.getName().contains(".")) {
               // p_Texte1.setType(editedFile.getName().substring(editedFile.getName().lastIndexOf(".") + 1));
            }
            p_Texte1.setStatusText(editedFile.getName());
        } else {
            p_Texte1.setText("null file for edition");
        }
        displayStructure(p_Texte1.getText());

    }

    private Object getSelectedTextElement() {
        if (jTree1.getSelectionPath() != null) {
            if (jTree1.getSelectionPath().getLastPathComponent() instanceof javax.swing.tree.DefaultMutableTreeNode) {
                javax.swing.tree.DefaultMutableTreeNode node = (javax.swing.tree.DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
                if (node.getUserObject() instanceof com.jdcm.common.C_textElement) {
                    return (com.jdcm.common.C_textElement) node.getUserObject();
                } else if (node.isRoot()) {
                    return node;
                }
            }
        }
        return null;
    }

    private void displayDiagOnText(java.util.List<javax.tools.Diagnostic<? extends javax.tools.JavaFileObject>> diags) {
        for (javax.tools.Diagnostic<? extends javax.tools.JavaFileObject> diag : diags) {
            int start = (int) diag.getStartPosition();
            int stop = (int) diag.getEndPosition();
            this.p_Texte1.setErrors(start, stop);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jCB_ObjectEditor2 = new com.jdcm.editors.JCB_ObjectEditor();
        jButton2 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        p_FileSystem1 = new com.jdcm.editors.P_FileSystem();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        jScrollPane4 = new javax.swing.JScrollPane();
        p_Diagram1 = new com.jdcm.diagram.P_Diagram();

        setTitle("Compile");
        setPreferredSize(new java.awt.Dimension(750, 250));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jToolBar1.setRollover(true);

        jButton1.setToolTipText("compile");
        jButton1.setBorderPainted(false);
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jButton3.setBorderPainted(false);
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jCB_ObjectEditor1.setAsButton(true);
        jCB_ObjectEditor1.setEditable(true);
        jCB_ObjectEditor1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jCB_ObjectEditor1);

        jCB_ObjectEditor2.setAsButton(true);
        jToolBar1.add(jCB_ObjectEditor2);

        jButton2.setToolTipText("compile");
        jButton2.setBorderPainted(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton4.setToolTipText("home");
        jButton4.setBorderPainted(false);
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton4);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.NORTH);

        jSplitPane2.setDividerLocation(150);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setBorder(null);
        jSplitPane1.setDividerLocation(40);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(134, 400));
        jTabbedPane1.addTab("Files", p_FileSystem1);

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("classe");
        javax.swing.tree.DefaultMutableTreeNode treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Methodes");
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Fields");
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("Classes");
        treeNode1.add(treeNode2);
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTree1MouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTree1MousePressed(evt);
            }
        });
        jScrollPane2.setViewportView(jTree1);

        jTabbedPane1.addTab("Class", jScrollPane2);

        jSplitPane1.setBottomComponent(jTabbedPane1);
        jTabbedPane1.getAccessibleContext().setAccessibleName("Files");

        jScrollPane3.setPreferredSize(new java.awt.Dimension(452, 40));
        jScrollPane3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jScrollPane3MousePressed(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Result"
            }
        ));
        jTable1.getTableHeader().setResizingAllowed(false);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jScrollPane3.setViewportView(jTable1);

        jSplitPane1.setTopComponent(jScrollPane3);

        jPanel1.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jSplitPane2.setLeftComponent(jPanel1);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jScrollPane4.setViewportView(p_Diagram1);

        jTabbedPane2.addTab("Diagram", jScrollPane4);

        jPanel2.add(jTabbedPane2, java.awt.BorderLayout.CENTER);
        jTabbedPane2.getAccessibleContext().setAccessibleName("Code");

        jSplitPane2.setRightComponent(jPanel2);

        getContentPane().add(jSplitPane2, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        try {
            displayStructure(p_Texte1.getText());
            compileClass();
        } catch (Exception ex) {
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        if (Parent != null) {
            Parent.setVisible(true);
        }
    }//GEN-LAST:event_formWindowClosing

    private void jTree1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseClicked
        Object selected = getSelectedTextElement();
        if (selected instanceof com.jdcm.common.C_textField
                || selected instanceof com.jdcm.common.C_textMethod) {
            com.jdcm.common.C_textElement elt = (com.jdcm.common.C_textElement) selected;
            p_Texte1.clear();
            p_Texte1.insertCode(elt.getCode());
            p_Texte1.colorCode();
        } else if (selected instanceof com.jdcm.common.C_textClass) {
            com.jdcm.common.C_textClass cl = (com.jdcm.common.C_textClass) selected;
            String txt = cl.getAllCode();
            p_Texte1.clear();
            p_Texte1.insertCode(txt);
            p_Texte1.colorCode();
        } else if (selected == null) {
        } else {
            String txt = "no Code";
            p_Texte1.clear();
            p_Texte1.insertCode(txt);
            p_Texte1.colorCode();
        }
    }//GEN-LAST:event_jTree1MouseClicked

    private void jTree1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MousePressed
        Object selected = getSelectedTextElement();
        if (selected instanceof javax.swing.tree.DefaultMutableTreeNode) {
            javax.swing.tree.DefaultMutableTreeNode node = (javax.swing.tree.DefaultMutableTreeNode) selected;
            if (node.isRoot() && node.getChildCount() == 0) {
                String txtcode = p_Texte1.getText();
                if (txtcode != null) {
                    displayStructure(txtcode);
                }
            }
        }

    }//GEN-LAST:event_jTree1MousePressed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(new javax.swing.tree.DefaultMutableTreeNode("empty")));
        p_Texte1.clear();
        jTable1.setValueAt("", 0, 0);
        // p_Diagram1.setEvents(null);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jScrollPane3MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jScrollPane3MousePressed
    }//GEN-LAST:event_jScrollPane3MousePressed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        if (editedFile != null) {
            try {
                javax.tools.JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
                javax.tools.StandardJavaFileManager fileManager = compiler.getStandardFileManager(null, null, null);
                DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<>();
                Iterable<? extends javax.tools.JavaFileObject> compilationUnits1
                        = fileManager.getJavaFileObjectsFromFiles(java.util.Arrays.asList(editedFile));
                boolean isok = compiler.getTask(null, fileManager, diagnostics, getCompileOptions(), null, compilationUnits1).call();
                displayResult(diagnostics, null, isok);
            } catch (Throwable ex) {
                TDeb.wri("PB while compiling file =>" + ex.getMessage());
            }
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        p_FileSystem1.setBaseRep("", "");
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jCB_ObjectEditor1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor1ActionPerformed
        p_FileSystem1.setLoader((java.lang.ClassLoader)jCB_ObjectEditor1.getValue());
    }//GEN-LAST:event_jCB_ObjectEditor1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                F_Compile f=new F_Compile();
                f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                f.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTabbedPane jTabbedPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    private com.jdcm.diagram.P_Diagram p_Diagram1;
    private com.jdcm.editors.P_FileSystem p_FileSystem1;
    // End of variables declaration//GEN-END:variables
}
