package com.jdcm.editors;

import java.awt.Color;
import javax.swing.JFrame;
import java.awt.event.*;

/**
 * versatile Windows for Editors & copmpletions
 *
 * @author Marc GIBOIN
 */
public class F_PopUp extends JFrame {

    private static final long serialVersionUID = 1L;
    private javax.swing.JPanel Panel = null;
    private java.awt.Rectangle initposition = null;
    public boolean isParentActivating = false;
    /*private java.awt.event.WindowAdapter parentFront = new java.awt.event.WindowAdapter() {
     @Override
     public void windowActivated(WindowEvent we) {
     super.windowActivated(we);
     toFront();
     }
     };*/

    public F_PopUp() {
        javax.swing.JPanel p = new javax.swing.JPanel();
        p.setBounds(0, 0, 200, 200);
        p.add(new javax.swing.JTextField("titi"));
        setTitle("test");
        setPanel(p);
    }

    public F_PopUp(javax.swing.JPanel p, String title) {
        setTitle(title);
        setPanel(p);
    }

    public F_PopUp(javax.swing.JPanel p) {
        setTitle("Editor");
        setPanel(p);
    }

    private boolean isToResize(java.awt.Point mpoint) {
        if (mpoint.x < 0 || mpoint.y < 0 || Panel.getWidth() < 12 || Panel.getWidth() < 12) {
            return false;
        }
        return mpoint.x >= Panel.getWidth() - 12 && mpoint.y >= Panel.getHeight() - 12;
    }

    private boolean isToFrame(java.awt.Point mpoint) {
        if (isToResize(mpoint) || mpoint.x < 0 || mpoint.y < 0) {
            return false;
        } else {
            return mpoint.x >= Panel.getWidth() - 10 && mpoint.y <= 10;
        }
    }

    private void setResizeFlag(boolean flag) {
        if (Panel.getBorder() instanceof com.jdcm.common.G_coinBorder) {
            com.jdcm.common.G_coinBorder c = (com.jdcm.common.G_coinBorder) Panel.getBorder();
            c.setResize(flag);
        }
    }

    private boolean getResizeFlag() {
        if (Panel.getBorder() instanceof com.jdcm.common.G_coinBorder) {
            com.jdcm.common.G_coinBorder c = (com.jdcm.common.G_coinBorder) Panel.getBorder();
            return c.isResize();
        }
        return false;
    }

    private void manageBorder(java.awt.Point mpoint) {
        if (isAsFrame() == false) {
            if (isToFrame(mpoint)) {
                Panel.setBorder(new javax.swing.border.LineBorder(Color.BLUE.darker(), 4));
                Panel.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
            } else if (Panel.getCursor().equals(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR))){
                Panel.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black, 1));
                Panel.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
            }else{
                if (isToResize(mpoint) && Panel.getBorder() instanceof com.jdcm.common.G_coinBorder == false) {
                    Panel.setBorder(new com.jdcm.common.G_coinBorder(Color.BLUE.darker(), 4));
                    Panel.setCursor(new java.awt.Cursor(java.awt.Cursor.SE_RESIZE_CURSOR));
                } else if (Panel.getBorder() instanceof com.jdcm.common.G_coinBorder && !isToResize(mpoint) && !getResizeFlag()) {
                    Panel.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
                    Panel.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black, 1));
                }
            }
        } else {
            Panel.setBorder(javax.swing.BorderFactory.createLineBorder(Color.DARK_GRAY, 1));
        }
    }

    public final void setFocusAsFrame(javax.swing.JFrame parentframe) {
        setAlwaysOnTop(false);
        //   parentFrame.addWindowListener(parentFront);
    }

    public final void setPanel(javax.swing.JPanel p) {
        setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
        addComponentListener(new java.awt.event.ComponentAdapter() {
            @Override
            public void componentHidden(ComponentEvent e) {
                super.componentHidden(e);
                Panel.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.black, 1));
                getRootPane().setWindowDecorationStyle(javax.swing.JRootPane.NONE);
                if (initposition != null) {
                    Panel.setBounds(initposition);
                    initposition = null;
                }
                //setVisible(true);
            }
        });

        getRootPane().setWindowDecorationStyle(javax.swing.JRootPane.NONE);
        setUndecorated(true);
        setAlwaysOnTop(true);
        Panel = p;
        setBounds(Panel.getBounds());
        add(Panel);
        Panel.setBorder(new javax.swing.border.LineBorder(Color.BLACK, 1));
        Panel.addComponentListener(new java.awt.event.ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);
                if (Panel.getBounds().height + Panel.getBounds().width == 0) {
                    return;
                }
                if (isAsFrame() == false) {
                    setSize(Panel.getBounds().getSize());
                    validate();
                }
            }

            @Override
            public void componentMoved(ComponentEvent e) {
                super.componentMoved(e);
                if (Panel.getBounds().x == 0 && Panel.getBounds().y == 0) {
                    return;
                }
                if (isAsFrame() == false) {
                    setLocation(Panel.getLocation());
                    validate();
                }
            }

            @Override
            public void componentHidden(ComponentEvent e) {
                super.componentHidden(e);
                setVisible(false);
            }

            @Override
            public void componentShown(ComponentEvent e) {
                super.componentShown(e);
                setVisible(true);
            }
        });

        Panel.addMouseListener(new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent me) {
                super.mousePressed(me);
                if (isToFrame(me.getPoint())) {
                    createFrame(me);
                } else {
                    setResizeFlag(true);
                }
            }

            @Override
            public void mouseReleased(MouseEvent me) {
                super.mouseReleased(me);
                setResizeFlag(false);
            }

            @Override
            public void mouseExited(MouseEvent e) {
                super.mouseExited(e);
                manageBorder(e.getPoint());
            }
        });

        Panel.addMouseMotionListener(new MouseMotionAdapter() {
            @Override
            public void mouseMoved(MouseEvent e) {
                super.mouseMoved(e);
                manageBorder(e.getPoint());
            }

            @Override
            public void mouseDragged(MouseEvent e) {
                super.mouseDragged(e);
                if (isAsFrame()) {
                    return;
                }
                 if (getResizeFlag()) {
                    int w = e.getXOnScreen() - getLocationOnScreen().x;
                    int h = e.getYOnScreen() - getLocationOnScreen().y;
                    if (w > 10 && h > 10) {
                        setBounds(getLocationOnScreen().x, getLocationOnScreen().y, e.getXOnScreen() - getLocationOnScreen().x, e.getYOnScreen() - getLocationOnScreen().y);
                    }
                } else if(!isToFrame(e.getPoint())){
                    manageBorder(e.getPoint());
                }
            }
        });
    }

    private void createFrame(java.awt.event.MouseEvent e) {
        if (isAsFrame() || !isToFrame(e.getPoint()) || isToResize(e.getPoint())) {
            return;
        }
        initposition = getBounds();
        getRootPane().setWindowDecorationStyle(javax.swing.JRootPane.FRAME);
    }

    public boolean isAsFrame() {
        return getRootPane().getWindowDecorationStyle() == javax.swing.JRootPane.FRAME;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new F_PopUp().setVisible(true);
            }
        });
    }
}
