package com.jdcm.editors;

import com.jdcm.diagram.P_Events;
import com.jdcm.common.C_Packet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Rectangle;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.event.AncestorEvent;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.datatransfer.*;
import java.lang.reflect.InvocationTargetException;

/**
 * This Class creates a ComboBox for selecting Objects. If pressed, it shows a
 * Popup that contains a JObjectPanel.
 *
 * You can add a ChangeListener to this ComboBox to receive change events. NO
 * DEBUG on IT !!
 */
public class JCB_ObjectEditor extends JPanel implements ActionListener, ChangeListener, SwingConstants {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    /**
     * Where should be the Popup
     */
    private int popupLocation = LEFT;
    /**
     * If the Window looses Focus and the ToggleButton get's it, don't popup the
     * Window again...
     */
    private final boolean objectWindowFocusLost = false;
    /**
     * set if this component is lanched for a frame false if tree/table/applet
     */
    private final boolean isPanel;
    /**
     * The ToggleButton for hiding/showing the JObjectPanel
     */
    private javax.swing.JToggleButton _button;
    private javax.swing.text.JTextComponent _Textfld;//
    private JLabel _iconlabel;
    //   private javax.swing.JTextPane _BoxPane = null;
    /**
     * The Editor inside the PopUp
     */
    private I_CBObjectEditor EditorPanel;
    /**
     * The list of ChangeListeners
     */
    private final ArrayList<ChangeListener> _changeListener = new ArrayList<>();
    /**
     * Currently firing an ChangeEvent?
     */
    private boolean _fireingChangeEvent = false;
    private boolean _fireingActionEvent = false;
    private F_PopUp PopUp = null;
    /**
     * Display the button and allow to see detailled contents
     */
    private boolean editable = true;
    /**
     * Allow editting contents (detailled or not)
     */
    private boolean editing = true;
    /**
     * The list of ActionListeners
     */
    private final ArrayList<ActionListener> _actionListener = new ArrayList<>();
    private String txtbeforeedit = "";
    private String title = null;

    /**
     * present a lot of object with panel
     */
    public JCB_ObjectEditor() {
        createGUI();
        editable = true;
        setEditable(editable);
        isPanel = true;

    }

    /**
     * Creates an Oject editor.
     *
     * @param ob Object implemented by constructor
     */
    public JCB_ObjectEditor(Object ob) {
        createGUI();
        setValue(ob);
        isPanel = true;
        setEditable(editable);
    }

    public JCB_ObjectEditor(Object ob, boolean iseditable) {
        createGUI();
        setValue(ob);
        isPanel = true;
        setEditable(iseditable);
    }

    /**
     * Creates the GUI for the JObjectComboBox
     */
    private void createGUI() {

        setLayout(new java.awt.BorderLayout());
        setOpaque(false);
        _Textfld = new JTextField();
        _Textfld.setEditable(false);
        _Textfld.setOpaque(false);
        _Textfld.setTransferHandler(new ToValueTransferHandler(TransferHandler.COPY, this));
        _Textfld.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(50, 50, 50)));
        _Textfld.addKeyListener(new KeyAdapter() {
            @Override
            public void keyReleased(KeyEvent e) {
                setText(_Textfld.getText());
            }
        });

        addAncestorListener(new javax.swing.event.AncestorListener() {
            @Override
            public void ancestorAdded(AncestorEvent event) {
                //  nothing to do
            }

            @Override
            public void ancestorRemoved(AncestorEvent event) {
                hideEditor();
            }

            @Override
            public void ancestorMoved(AncestorEvent event) {
                if (isVisible() && EditorPanel != null) {
                    try {
                        EditorPanel.setBounds(getPanelBounds());
                    } catch (java.awt.IllegalComponentStateException e) {
                    }
                }
            }
        });
        _Textfld.addFocusListener(new FocusAdapter() {
            @Override
            public void focusGained(FocusEvent e) {
                txtbeforeedit = _Textfld.getText();
            }

            @Override
            public void focusLost(FocusEvent e) {
                setText(_Textfld.getText());
            }
        });
        _Textfld.setOpaque(true);
        _button = new javax.swing.JToggleButton();
        _button.setIcon((new com.jdcm.common.D_Utils()).getIcon("arrow_dwngrey.gif"));
        _button.setSelectedIcon((new com.jdcm.common.D_Utils()).getIcon("arrow_dwnblue.gif"));
        java.awt.Insets insets = new java.awt.Insets(_button.getMargin().top, 0, _button.getMargin().bottom, 0);
        _button.setMargin(insets);
        _button.addActionListener(this);
        _button.setEnabled(true);
        _button.setVisible(false);

        _Textfld.addKeyListener(new java.awt.event.KeyAdapter() {
            @Override
            public void keyPressed(java.awt.event.KeyEvent evt) {
                //     super.keyPressed(evt);
                if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
                    setText(_Textfld.getText());
                }
                if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ESCAPE) {
                    setText(txtbeforeedit);
                }
                /*
                 * int w =
                 * _Textfld.getFontMetrics(_Textfld.getFont()).stringWidth(_Textfld.getText());
                 * if (w>_Textfld.getSize().width){
                 * _Textfld.setBounds(0,0,_Textfld.getSize().height,
                 * w);//+_button.getSize().width _Textfld.repaint();
                 }
                 */

            }
        });
        _iconlabel = new JLabel();
        _iconlabel.setOpaque(false);

//add(_button);add(_iconlabel);add(_Textfld);
        add(_iconlabel, BorderLayout.WEST);
        add(_Textfld, BorderLayout.CENTER);
        add(_button, BorderLayout.EAST);
    }

    /**
     * Creates the ObjectWindow-Popup
     */
    /* private void createEditorWindow() {
     ObjectWindow = null;
     //    ObjectWindow2 = null;;
     this.addHierarchyListener(new java.awt.event.HierarchyListener() {
     public void hierarchyChanged(HierarchyEvent e) {
     hideEditor();
     }
     }); 
     if (this.getParent() instanceof JTable || this.getParent() instanceof JTree) {
     isPanel = false;      
     }
     if (this.getTopLevelAncestor() instanceof java.awt.Window) {
     ObjectWindow = new JWindow((java.awt.Window) this.getTopLevelAncestor()); 
     }
     if (this.getTopLevelAncestor() instanceof java.applet.Applet) {
     ObjectWindow = new JWindow(((java.applet.Applet) this.getTopLevelAncestor()).getGraphicsConfiguration());
     //I DON NOT KNOW WHY!!! if applet => close on Parent (tree or table)focus
     if (isPanel == false) {
     this.getParent().addFocusListener(new java.awt.event.FocusAdapter() {

     @Override
     public void focusGained(FocusEvent e) {
     hideEditor();
     }
     });

     }
     }
     */
    /**
     *  get the Objected edited value
     * @return 
     */
    public Object getValue() {
        if (EditorPanel != null) {
            return EditorPanel.getValue();
        }
        return null;
    }

    public I_CBObjectEditor getEditor() {
        return EditorPanel;
    }

    /**
     * Sets the current selected Object
     *
     * @param val Object to select
     */
    public final void setValue(Object val) {
        getLFObject(val);
        if (val instanceof java.lang.reflect.Method || val instanceof com.jdcm.common.C_textMethod) {
            EditorPanel = new P_MethodEditor();
        } else if (val instanceof java.lang.reflect.AnnotatedElement
                || val instanceof java.lang.annotation.Annotation
                || val instanceof com.jdcm.common.C_textElement) {
            EditorPanel = new P_ReflectEditor();
        } else if (val instanceof java.sql.ResultSet && !(EditorPanel instanceof P_TableEditor)) {
            EditorPanel = new P_TableEditor();
        } else if (val instanceof javax.swing.table.AbstractTableModel) {
            if (val instanceof com.jdcm.diagram.A_Events && !(EditorPanel instanceof P_Events)) {
                EditorPanel = new P_Events();
            } else if (!(EditorPanel instanceof P_TableEditor) && !(EditorPanel instanceof P_Events)) {
                EditorPanel = new P_TableEditor();
                ((P_TableEditor) EditorPanel).sethdrcol(true);
            }
            if (val instanceof com.jdcm.common.Options_Model) {
                setTitle(((com.jdcm.common.Options_Model) val).getTitle());
            }
        } else if (val instanceof byte[] && !(EditorPanel instanceof P_HexaEditor)) {
            EditorPanel = new P_HexaEditor();
        } else if ((val instanceof java.util.List || val instanceof Object[]) && !(EditorPanel instanceof P_ListEditor)) {
            EditorPanel = new P_ListEditor();
        }  else if (val instanceof javax.swing.tree.TreeModel && !(EditorPanel instanceof P_TreeEditor)) {
            EditorPanel = new P_TreeEditor();
        } else if (val instanceof javax.swing.tree.TreeNode && !(EditorPanel instanceof P_TreeEditor)) {
            EditorPanel = new P_TreeEditor();
        }else if ((val instanceof com.jdcm.common.C_Actiondef || val instanceof com.jdcm.common.C_Eventdef) && !(EditorPanel instanceof P_Actiondef)) {
            EditorPanel = new P_Actiondef();
        } else if ((val instanceof java.awt.geom.Ellipse2D || val instanceof java.awt.geom.Arc2D || val instanceof java.awt.Rectangle || val instanceof java.awt.geom.Rectangle2D || val instanceof java.awt.geom.Point2D || val instanceof java.awt.geom.Line2D || val instanceof java.awt.Point || val instanceof java.awt.Dimension) && !(EditorPanel instanceof P_GeomEditor)) {
            EditorPanel = new P_GeomEditor();
        } else if (val instanceof java.util.Date && !(EditorPanel instanceof P_DateEditor)) {
            EditorPanel = new P_DateEditor();
        } else if (val instanceof java.awt.Image && !(EditorPanel instanceof P_ImageEditor)) {
            EditorPanel = new P_ImageEditor();
        } else if ((val instanceof com.jdcm.common.O_MACaddress || val instanceof com.jdcm.common.O_X25address || val instanceof java.net.InetAddress) && !(EditorPanel instanceof P_AdresseEditor)) {
            EditorPanel = new P_AdresseEditor();
        } else if (val instanceof com.jdcm.common.XMLres && !(EditorPanel instanceof P_XMLEditor)) {
            EditorPanel = new P_XMLEditor();
        } else if (val instanceof java.net.URLClassLoader && !(EditorPanel instanceof P_LoaderEditor)) {
            EditorPanel = new P_LoaderEditor();
        } else if (val instanceof java.io.File && !(EditorPanel instanceof P_FileEditor)) {
            EditorPanel = new P_FileEditor();
        } else if (val instanceof com.jdcm.common.C_Packet && !(EditorPanel instanceof P_PacketEditor)) {
            EditorPanel = new P_PacketEditor();
        } else if (val instanceof javax.tools.Diagnostic && !(EditorPanel instanceof P_DiagEditor)) {
            EditorPanel = new P_DiagEditor();
        } else if (val instanceof javax.sound.sampled.AudioFormat && !(EditorPanel instanceof P_AudioFormatEditor)) {
            EditorPanel = new P_AudioFormatEditor();
        } else if (val instanceof java.awt.Component && !(EditorPanel instanceof P_ComponentEditor)) {
            EditorPanel = new P_ComponentEditor();
        }

        try {
            if (val != null) {
                if (val.getClass().getName().startsWith("usb.") && !(EditorPanel instanceof P_USBEditor)) {
                    EditorPanel = new P_USBEditor();
                } else if (val.getClass().getName().startsWith("jpcap.NetworkInterface") && !(EditorPanel instanceof P_ETHEditor)) {
                    EditorPanel = new P_ETHEditor();
                } else if (val.getClass().getName().startsWith("com.jdcm.charts.") && !(EditorPanel instanceof P_ChartEditor)) {
                    EditorPanel = new P_ChartEditor();
                }
            }
        } catch (java.lang.NoClassDefFoundError er) {
            //System.out.println("usb seems not managed: " + er.getMessage());
        } catch (Throwable ex) {
            // System.out.println("unmanaged: " + ex.getMessage());
        }
        if (EditorPanel == null && !(EditorPanel instanceof P_ChartEditor)) { //&& val instanceof Object
            EditorPanel = new P_ObjectEditor();
        }
        /*
         * if (val instanceof java.lang.reflect.Method) { EditorPanel = new
         * P_reflect_Meth();
         }
         */

        if (EditorPanel instanceof java.awt.Component) {
            EditorPanel.setVisible(false);
            EditorPanel.setValue(val);
            ((java.awt.Component) EditorPanel).doLayout();
            EditorPanel.setEditing(isEditing());
            //   System.out.println("==>"+EditorPanel.getClass().getSimpleName());

            retrieveLabel();
            _Textfld.setCaretPosition(0);

        }

    }

    private void getLFObject(Object val) {

        ImageIcon ico = null;
       // ico= (new com.jdcm.common.D_Utils()).getIcon(val); //.. but NOT static...
        try {
            java.lang.reflect.Method m = val.getClass().getMethod("getIcon", (java.lang.Class<?>[]) null);
            ico = (ImageIcon) m.invoke(val, (java.lang.Object[]) null);
        } catch (NullPointerException | NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            //  System.out.println("=>"+ex.getMessage());
        }
        java.awt.Color col = null;
        try {
            java.lang.reflect.Method m = val.getClass().getMethod("getColor", (java.lang.Class<?>[]) null);
            col = (java.awt.Color) m.invoke(val, (java.lang.Object[]) null);
        } catch (NullPointerException | NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            //  System.out.println("=>"+ex.getMessage());
        }
        if (col != null) {
            _Textfld.setForeground(col);
        }
        if (ico == null || val instanceof javax.swing.JComponent) {
            ico = (new com.jdcm.common.D_Utils()).getIcon(val);
        }
        if (ico != null) {
            _iconlabel.setIcon(ico);
            if (val instanceof Class) {
                _iconlabel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 1));
            }
            if (ico.getDescription() != null) {
                String libelle = ico.getDescription();
                _iconlabel.setToolTipText(libelle);
                if (this.getToolTipText() != null) {
                    libelle = libelle + ":" + this.getToolTipText();
                }
                this.setToolTipText(libelle);
            }
        }
    }

    private void retrieveLabel() {
        if (EditorPanel == null) {
            return;
        }
        _Textfld = EditorPanel.getLabel(_Textfld);
        if (EditorPanel instanceof P_ObjectEditor || EditorPanel instanceof P_ComponentEditor) {
            if (EditorPanel.getValue() != null) {
                try {
                    java.lang.reflect.Method m = EditorPanel.getValue().getClass().getMethod("getTitle", (java.lang.Class<?>[]) null);
                    _Textfld.setText(m.invoke(EditorPanel.getValue(), (java.lang.Object[]) null).toString());
                } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                }
            }
        }
    }

    /**
     * Handles the ToggleButton events for hidding / showing the PopUp
     *
     * @param e the ActionEvent
     * @see
     * java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        if (!editable || EditorPanel == null) {
            return;
        }
        if (EditorPanel.isVisible()) {
            hideEditor(); //hided by Panel focus lost 
            fireActionEvent();
        } else {
            showPanel();
        }
    }

    public void displayBorder(boolean bool) {
        if (bool) {
            _Textfld.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 0));
        } else {
            _Textfld.setBorder(null);
        }
    }

    public void displayIconandText(boolean bool) {
        _Textfld.setVisible(bool);
        _iconlabel.setVisible(bool);

    }

    public void setSelectable(boolean bool) {
        _Textfld.setOpaque(bool);
        _iconlabel.setOpaque(bool);
    }

    public void setTitle(String txt) {
        title = txt;
        if (title == null) {
            if (getValue() != null && getValue().getClass() != null) {
                title = getValue().getClass().getSimpleName();
            } else {
                title = "Table";
            }
        }
        /*
         * if (ObjectWindow2 != null) { ObjectWindow2.setTitle(title);
         }
         */
    }

    private java.awt.Rectangle getPanelBounds() {
        java.awt.Point location = getLocationOnScreen();
        int x;
        java.awt.Dimension editRect = EditorPanel.getPreferredSize();

        if (popupLocation == RIGHT) {
            x = (int) location.getX() + _button.getSize().width - editRect.width;
        } else if (popupLocation == CENTER) {
            x = (int) location.getX() + ((_button.getSize().width - editRect.width) / 2);
        } else {
            x = (int) location.getX();
        }

        int y = (int) location.getY() + _button.getHeight();
        Rectangle screenSize = getDesktopBounds();
        if (x < 0) {
            x = 0;
        }
        if (y < 0) {
            y = 0;
        }

        if (x + editRect.width > screenSize.width) {
            x = screenSize.width - editRect.width;
        } else if (editRect.width < _Textfld.getWidth()) {
            // editRect.width=_Textfld.getWidth();
        }

        if (y + 30 + editRect.height > screenSize.height) {
            y = (int) location.getY() - editRect.height;
        }
        return new java.awt.Rectangle(x, y, editRect.width, editRect.height);
    }

    /**
     * Hides the Object PopUp and fires a ChangeEvent if a change was made
     */
    public void hideEditor() {
        /*   if (PopUp!=null){
         PopUp.setVisible(false);
         }*/

        if (EditorPanel != null && EditorPanel.isVisible()) {
            if (!PopUp.isAsFrame()) {
                //leave itopen is as Frame
                EditorPanel.setVisible(false);
            }
            retrieveLabel();
            fireChangeEvent();
        }
    }

    /**
     * Shows the Object PopUp
     */
    public void showPanel() {
        if (PopUp == null) {
            if (EditorPanel instanceof java.awt.Panel) {
                System.out.println("JCBEditor Pb : with " + EditorPanel.getClass().toString());
            }
            PopUp = new F_PopUp((javax.swing.JPanel) EditorPanel, title);
            PopUp.setIconImage(EditorPanel.getIcon());
            PopUp.addComponentListener(new java.awt.event.ComponentAdapter() {
                @Override
                public void componentHidden(ComponentEvent e) {
                    //  super.componentHidden(e); //To change body of generated methods, choose Tools | Templates.
                    _button.setSelected(false);
                    hideEditor();
                }
            });
        }
        EditorPanel.setBounds(getPanelBounds());
        EditorPanel.setVisible(true);
    }

    /**
     * Gets the screensize. Takes into account multi-screen displays.
     *
     * @return a union of the bounds of the various screen devices present
     */
    private Rectangle getDesktopBounds() {
        final java.awt.GraphicsEnvironment ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
        Rectangle desktopBounds = new Rectangle();
        for (java.awt.GraphicsDevice gd : ge.getScreenDevices()) {
            desktopBounds = desktopBounds.union(gd.getDefaultConfiguration().getBounds());
        }
        return desktopBounds;
    }

    @Override
    public void setForeground(java.awt.Color col) {
        if (_Textfld != null) {
            _Textfld.setForeground(col);
        }
    }

    /**
     * care if opaque is not set, it has no effect...
     *
     * @param col
     */
    @Override
    public void setBackground(java.awt.Color col) {
        if (_Textfld != null) {
            _Textfld.setBackground(col);
        }
        if (_iconlabel != null) {
            _iconlabel.setBackground(col);
        }
        // _button.setBackground(col);

    }

    /**
     * Listens to ChangeEvents of the JObjectPanel and rembers if something was
     * changed.
     *
     * If the Day was changed, the PopUp is closed.
     *
     * @param e ChangeEvent
     * @see
     * javax.swing.event.ChangeListener#stateChanged(javax.swing.event.ChangeEvent)
     */
    @Override
    public void stateChanged(ChangeEvent e) {
        hideEditor();
    }

    /**
     * Adds a Changelistener to this JObjectComboBox.
     *
     * It will be called everytime the ComboBox is closed and the Date was
     * changed
     *
     * @param listener ChangeListener
     */
    public void addChangeListener(ChangeListener listener) {
        _changeListener.add(listener);
    }

    public void addActionListener(ActionListener listener) {
        _actionListener.add(listener);
    }

    /**
     * Removes a ChangeListener from this JObjectComboBox
     *
     * @param listener listener to remove
     */
    public void removeChangeListener(ChangeListener listener) {
        _changeListener.remove(listener);
    }

    public void removeActionListener(ActionListener listener) {
        _actionListener.remove(listener);
    }

    /**
     * Gets all ChangeListeners
     *
     * @return all ChangeListeners
     */
    public ChangeListener[] getChangeListener() {
        return (ChangeListener[]) _changeListener.toArray();
    }

    public ActionListener[] getActionListener() {
        return (ActionListener[]) _actionListener.toArray();
    }

    /**
     * Fires the ChangeEvent
     */
    protected void fireChangeEvent() {
        if (!_fireingChangeEvent) {
            _fireingChangeEvent = true;
            ChangeEvent event = new ChangeEvent(this);

            for (int i = 0; i < _changeListener.size(); i++) {
                (_changeListener.get(i)).stateChanged(event);
            }
            _fireingChangeEvent = false;
        }

    }

    /**
     * Fires the ActionEvent
     */
    protected void fireActionEvent() {
        if (!_fireingActionEvent) {
            _fireingActionEvent = true;
            ActionEvent event = new java.awt.event.ActionEvent(this, 1, "Object changed");

            for (int i = 0; i < _actionListener.size(); i++) {
                (_actionListener.get(i)).actionPerformed(event);
            }
            _fireingActionEvent = false;
        }

    }

    /**
     * Enables/Disables the ComboBox
     *
     * @param enabled Enabled ?
     */
    @Override
    public void setEnabled(boolean enabled) {

        if (EditorPanel != null && EditorPanel.isVisible()) {
            hideEditor();
        }
        if (_button != null) {
            _button.setEnabled(enabled);
        }
        if (_Textfld != null) {
            if (enabled) {
                _Textfld.setForeground(Color.BLACK);
            } else {
                _Textfld.setForeground(Color.lightGray);
                _Textfld.setDisabledTextColor(Color.lightGray);
            }
            _Textfld.setEnabled(enabled);
            _Textfld.setEditable(enabled);
        }
        _iconlabel.setEnabled(enabled);
    }

    /**
     * Set Editables/NOT the ComboBox
     *
     * @param enabled Enabled ?
     */
    final public void setEditable(boolean enabled) {
        editable = enabled;
        _button.setVisible(editable);
    }
    /*
     * Represent thos editoras a simple button
     * 
     */

    public void setAsButton(boolean enabled) {
        if (enabled) {
            setMinimumSize(_button.getPreferredSize());
            setMaximumSize(_button.getPreferredSize());
            setPreferredSize(_button.getPreferredSize());
        } else {
            setMinimumSize(new java.awt.Dimension(10,10));
            setMaximumSize(new java.awt.Dimension(1000, 1000));
            setPreferredSize(new java.awt.Dimension(100, 15));
        }
        _Textfld.setVisible(enabled == false);
        _iconlabel.setVisible(enabled == false);
        _button.setVisible(enabled);
    }

    public boolean isEditing() {
        return editing;
    }

    public void setEditing(boolean bool) {
        editing = bool;
        if (EditorPanel == null) {
            return;
        }
        EditorPanel.setEditing(bool);
        _Textfld.setEditable(bool);
        retrieveLabel();
    }

    /**
     * change the Textbox content of the editor
     *
     * @param txt
     */
    public void setText(String txt) {
        if (_Textfld.isEditable()) {
            if (_Textfld.getText().compareTo(txt) != 0) {
                _Textfld.setText(txt);
            }
            EditorPanel.TextManager(_Textfld);
            fireActionEvent();
        }
    }

    /**
     * Is the ComboBox enabled ?
     *
     * @return enabled ?
     */
    @Override
    public boolean isEnabled() {
        return _button.isEnabled();
    }

    /**
     * Gets the Popup Location
     *
     * @return location of the Popup
     */
    public int getPopupLocation() {
        return popupLocation;
    }

    /**
     * Sets the Location of the Popup (LEFT, CENTER or RIGHT)
     *
     * @param location Location of the PopUp
     */
    public void setPopupLocation(int location) {
        popupLocation = location;
    }

    class ToValueTransferHandler extends TransferHandler {
        // for serializable interface

        private static final long serialVersionUID = 1L;
        private final int action;
        private com.jdcm.editors.JCB_ObjectEditor Parent = null;

        public ToValueTransferHandler(int action, com.jdcm.editors.JCB_ObjectEditor p) {
            this.action = action;
            Parent = p;
        }

        @Override
        public boolean canImport(TransferHandler.TransferSupport support) {
            // for the demo, we'll only support drops (not clipboard paste)
            if (!support.isDrop()) {
                return false;
            }

            // we only import Strings
            if (!support.isDataFlavorSupported(DataFlavor.stringFlavor)) {
                return false;
            }

            boolean actionSupported = (action & support.getSourceDropActions()) == action;
            if (actionSupported) {
                support.setDropAction(action);
                return true;
            }

            return false;
        }

        @Override
        public boolean importData(TransferHandler.TransferSupport support) {
            // if we can't handle the import, say so
          /*
             * if (!canImport(support)) { return false;
             }
             */

            // fetch the drop location


            // fetch the data and bail if this fails
            String data;
            try {
                data = (String) support.getTransferable().getTransferData(DataFlavor.stringFlavor);
            } catch (UnsupportedFlavorException | java.io.IOException e) {
                return false;
            }
            C_Packet p = new C_Packet(data.getBytes(), null);//-99
            Object o = p.getSer2Obj();
            if (o != null && Parent != null) {
                if (o.getClass().isInstance(Parent.getValue().getClass())) {
                    Parent.setValue(o);
                }
            }
            return true;
        }
    }
}
