package com.jdcm.editors;

import com.jdcm.common.C_Actiondef;
import com.jdcm.common.C_Eventdef;
import javax.swing.JWindow;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.JList;
import java.awt.Rectangle;

/**
 * P_DateEditor.java Created on 31 octobre 2007, 21:26
 * 
 *Used to Edit/display Date & Times
 * @author  Marc GIBOIN
 */
public class P_Actiondef extends javax.swing.JPanel implements I_CBObjectEditor, SwingConstants {
    // for serializable interface

    private final int popupLocation = LEFT;
        private JWindow ObjectWindow;
    private static final long serialVersionUID = 1L;
    private C_Actiondef action = null;
    private C_Eventdef event = null;
    private boolean editing = true;

    /**
     *create a panel <br>
     * is used by JCB_ObjectEditor<br>
     * 
     */
    public P_Actiondef() {
        initComponents();
        jTextField1.setText("");
        jTable1.setTableHeader(null);
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
                new Object[][]{
                    {null}
                },
                new String[]{
                    null
                }));
    }
 /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("Actiodef.gif");
        }catch(Exception ex){
            return null;
        }
    }
    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        editing = bool;
        ObjectWindow = null;
        jTextField1.setEditable(bool);
        jTable1.setEnabled(bool);
        jTable1.getColumnModel().getColumn(0).setCellRenderer(new ACE_ObjRenderer<>());
        jTable1.getColumnModel().getColumn(0).setCellEditor(new ACE_ObjEditor<>(true, bool));
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }

    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        if (action != null) {
            txt.setText(action.toString());
        } else if (event != null) {
            txt.setText(event.toString());
        } else {
            txt.setText("null event/action");
        }
        return txt;
    }

    @Override
    public Object getValue() {
        String obj = null;
        String meth = null;

        int index = jTextField1.getText().indexOf(".");

        if (jTextField1.getText().length() > 0) {
            if (index > 0) {
                obj = jTextField1.getText().substring(0, index);
                meth = jTextField1.getText().substring(index + 1);
            } else {
                obj = jTextField1.getText();
                meth = null;
            }
        }

       Object pars = jTable1.getValueAt(0, 0);
        if (action != null) {
            return new C_Actiondef(obj, meth, pars);
        } else if (event != null) {
            return new C_Eventdef(obj, meth, pars);
        } else {
            return null;
        }
    }

    @Override
    public void setValue(Object val) {
        jTextField1.setText("");
        jTable1.setValueAt(null, 0, 0);
        String res = ".";
        if (val instanceof C_Actiondef) {
            jTextField1.setToolTipText("destination");
            action = (C_Actiondef) val;
            if (action.getDest() != null) {
                res = action.getDest().toString() + res;
            }

            if (action.getMethodName() != null) {
                res = res + action.getMethodName().toString();
            }
            jTextField1.setText(res);
            if (action.getParamList() != null) {
                jTable1.setValueAt(action.getParamList(), 0, 0);
            }
        } else if (val instanceof C_Eventdef) {
            jTextField1.setToolTipText("source");
            event = (C_Eventdef) val;
            if (event.getSrc() != null) {
                res = event.getSrc().toString() + res;
            }
            if (event.getMethodName() != null) {
                res = res + event.getMethodName().toString();
            }
            jTextField1.setText(res);
            if (event.getParams() != null) {
                jTable1.setValueAt(event.getParams(), 0, 0);
            }
        }
        //jTextField1.setVisible(jTextField1.getText().length() > 0);
        // jTable1.setVisible(jTable1.getValueAt(0, 0) != null);
    }

    /**!!!!!!!!!copy of JCBObjectEditor()
     * Gets the screensize. Takes into account multi-screen displays.
     * 
     * @return a union of the bounds of the various screen devices present
     */
    private Rectangle getDesktopBounds() {
        final java.awt.GraphicsEnvironment ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();
        Rectangle desktopBounds = new Rectangle();
        for (java.awt.GraphicsDevice gd : ge.getScreenDevices()) {
            desktopBounds = desktopBounds.union(gd.getDefaultConfiguration().getBounds());
        }
        return desktopBounds;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTextField1 = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setPreferredSize(new java.awt.Dimension(242, 84));
        setLayout(new java.awt.BorderLayout());

        jTextField1.setText("jTextField1");
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField1KeyReleased(evt);
            }
        });
        add(jTextField1, java.awt.BorderLayout.NORTH);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jTextField1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyReleased
        if (evt.getKeyChar() == ".".charAt(0)){//) {

            ObjectWindow = new JWindow((java.awt.Window) this.getTopLevelAncestor());
            ObjectWindow.setAlwaysOnTop(true);
            JPanel contentPanel = (JPanel) ObjectWindow.getContentPane();
            JList<javax.swing.JLabel> liste = new JList<>();
            liste.add(new javax.swing.JLabel("toto"));
            contentPanel.add(liste);
            java.awt.Point location = getLocationOnScreen();
            int x;
            java.awt.Component parent = jTextField1;
            if (popupLocation == RIGHT) {
                x = (int) location.getX() + parent.getSize().width - ObjectWindow.getSize().width;
            } else if (popupLocation == CENTER) {
                x = (int) location.getX() + ((parent.getSize().width - ObjectWindow.getSize().width) / 2);
            } else {
                x = (int) location.getX();
            }

            int y = (int) location.getY() + parent.getHeight();

            Rectangle screenSize = getDesktopBounds();
            if (x < 0) {
                x = 0;
            }
            if (y < 0) {
                y = 0;
            }

            if (x + ObjectWindow.getWidth() > screenSize.width) {
                x = screenSize.width - ObjectWindow.getWidth();
            }
            if (ObjectWindow.getWidth() < this.getWidth()) {
                Rectangle temp = ObjectWindow.getBounds();
                temp.width = this.getWidth();
                ObjectWindow.setBounds(temp);
            }
            if (y + 30 + ObjectWindow.getHeight() > screenSize.height) {
                y = (int) location.getY() - ObjectWindow.getHeight();
            }

            ObjectWindow.setBounds(x, y, ObjectWindow.getWidth(), ObjectWindow.getHeight());
            //----------------------------
            ObjectWindow.setVisible(true);
        }
    }//GEN-LAST:event_jTextField1KeyReleased
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}
