package com.jdcm.editors;

/**
 * P_ChartEditor.java Created on 17 sept. 2009, 21:43:00
 *
 * Specific List Editor to Edit Charts with curbs of Mesures and datas
 *
 * @author Marc GIBOIN
 */
public class P_ChartEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final java.util.List<Object[]> vectdata = new java.util.ArrayList<>();
    private final java.util.List<String> vectname = new java.util.ArrayList<>();
    private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>();
    private com.jdcm.common.ListTableModel model = null;
    private com.jdcm.charts.Donnees donnees = null;
    private com.jdcm.charts.P_Chartplus chart = null;
    private com.jdcm.charts.Mesure mesure = null;
    private boolean isedit = false;

    private Object otherobj = null;

    /**
     * Creates new form P_ChartEditor
     */
    public P_ChartEditor() {
        initComponents();
        vectname.add("Name");
        vectname.add("Value");
    }

    /**
     * Provide an Icon if needed (asked by frames)
     *
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
            return (new com.jdcm.common.D_Utils()).getImage("Donnees.gif");
        } catch (Exception ex) {
            return null;
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setLayout(new java.awt.BorderLayout());

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Title 1", "Titre 2"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        if (donnees != null) {
            txt.setText(donnees.getlabel());
        } else if (mesure != null) {
            txt.setText(mesure.tag);
        } else if (chart != null) {
            txt.setText("this chart");
        } else {
            txt.setText("unknown : " + otherobj);
        }
        return txt;
    }

    @Override
    public void setValue(Object val) {
        vectdata.clear();
        if (val instanceof com.jdcm.charts.Donnees) {
            donnees = (com.jdcm.charts.Donnees) val;
            setObjectinTable("label", donnees.getlabel());
            javax.swing.DefaultComboBoxModel<String> typ = new javax.swing.DefaultComboBoxModel<>(new String[]{"Points", "Wires", "Sqrt/Plan", "Meshed"});
            typ.setSelectedItem(typ.getElementAt(donnees.gettype()));
            setObjectinTable("Type", typ);
            setObjectinTable("isVisible", donnees.isVisible());
            setObjectinTable("offset", donnees.getoffset());
            setObjectinTable("Courbcolor", donnees.getcurbcolor());
            setObjectinTable("Pointcolor", donnees.getptcolor());
            setObjectinTable("feelcolor", donnees.getfeelcolor());
        } else if (val instanceof com.jdcm.charts.Mesure) {
            mesure = (com.jdcm.charts.Mesure) val;
            setObjectinTable("Point", mesure.getpoint());
            setObjectinTable("Value", mesure.getval());
            setObjectinTable("Shape", mesure.shape);
            setObjectinTable("Tag", mesure.tag);
        } else if (val instanceof com.jdcm.charts.P_Chartplus) {
            chart = (com.jdcm.charts.P_Chartplus) val;
            setObjectinTable("bgcolor", chart.getBackground());
            setObjectinTable("scroll", chart.isscroll());
            setObjectinTable("NaN", chart.isNaN());
            setObjectinTable("points", chart.isdrawpt());
            setObjectinTable("x=y", chart.isxeqy());
            javax.swing.DefaultComboBoxModel<String> c = new javax.swing.DefaultComboBoxModel<>(new String[]{"NONE", "ONLYX", "SIMPLE", "INTERVALS"});
            int nb = chart.getAxis();
            if (nb == com.jdcm.charts.P_Chartplus.AXIS_INTERVALS) {
                c.setSelectedItem("INETRVALS");
            } else if (nb == com.jdcm.charts.P_Chartplus.AXIS_NONE) {
                c.setSelectedItem("NONE");
            } else if (nb == com.jdcm.charts.P_Chartplus.AXIS_ONLYX) {
                c.setSelectedItem("ONLYX");
            } else if (nb == com.jdcm.charts.P_Chartplus.AXIS_SIMPLE) {
                c.setSelectedItem("SIMPLE");
            }
            setObjectinTable("axes", c);
            c = new javax.swing.DefaultComboBoxModel<>(new String[]{"2D", "3D", "OGL"});
            nb = chart.getMode();
            if (nb == com.jdcm.charts.P_Chartplus.MODE_2D) {
                c.setSelectedItem("2D");
            } else if (nb == com.jdcm.charts.P_Chartplus.MODE_OGL) {
                c.setSelectedItem("OGL");
            } else if (nb == com.jdcm.charts.P_Chartplus.MODE_3D) {
                c.setSelectedItem("3D");
            }
            setObjectinTable("mode", c);
        } else {
            otherobj = val;
        }
        model = new com.jdcm.common.ListTableModel(vectdata, vectname);
        jTable1.setModel(model);

        jTable1.getColumn(vectname.get(1)).setCellRenderer(render);
        jTable1.getColumn(vectname.get(1)).setCellEditor(editor);
    }

    @Override
    public Object getValue() {
        if (donnees != null) {
            javax.swing.DefaultComboBoxModel<String> typ = getObjectinTable("Type", new javax.swing.DefaultComboBoxModel<String>());
            donnees.settype(typ.getIndexOf(typ.getSelectedItem()));
            donnees.setVisible((Boolean) getObjectinTable("isVisible"));
            donnees.setoffset((Double) getObjectinTable("offset"));
            donnees.setcurbcolor((java.awt.Color) getObjectinTable("Courbcolor"));
            donnees.setfeelcolor((java.awt.Color) getObjectinTable("feelcolor"));
            donnees.setptcolor((java.awt.Color) getObjectinTable("Pointcolor"));
            return donnees;
        } else if (mesure != null) {
            java.awt.geom.Point2D p = (java.awt.geom.Point2D) getObjectinTable("Point");
            mesure.setpoint(p.getX(), p.getY());
            mesure.setval((Double) getObjectinTable("Value"));
            mesure.tag = getObjectinTable("Tag").toString();

            return mesure;
        } else if (chart != null) {
            chart.setBackground((java.awt.Color) getObjectinTable("bgcolor"));
            chart.setscroll((Boolean) getObjectinTable("scroll"));
            String txt = getObjectinTable("axes", new javax.swing.DefaultComboBoxModel<String>()).getSelectedItem().toString();
            if (txt.compareTo("NONE") == 0) {
                chart.setAxis(com.jdcm.charts.P_Chartplus.AXIS_NONE);
            } else if (txt.compareTo("ONLYX") == 0) {
                chart.setAxis(com.jdcm.charts.P_Chartplus.AXIS_ONLYX);
            } else if (txt.compareTo("SIMPLE") == 0) {
                chart.setAxis(com.jdcm.charts.P_Chartplus.AXIS_SIMPLE);
            } else if (txt.compareTo("INTERVALS") == 0) {
                chart.setAxis(com.jdcm.charts.P_Chartplus.AXIS_INTERVALS);
            }
            txt = ((javax.swing.DefaultComboBoxModel) getObjectinTable("mode")).getSelectedItem().toString();
            if (txt.compareTo("2D") == 0) {
                chart.setMode(com.jdcm.charts.P_Chartplus.MODE_2D);
            } else if (txt.compareTo("3D") == 0) {
                chart.setMode(com.jdcm.charts.P_Chartplus.MODE_3D);
            } else if (txt.compareTo("OGL") == 0) {
                chart.setMode(com.jdcm.charts.P_Chartplus.MODE_OGL);
            }
            chart.setNaN((Boolean) getObjectinTable("NaN"));
            chart.setdrawpt((Boolean) getObjectinTable("points"));
            chart.setxeqy((Boolean) getObjectinTable("x=y"));
            return chart;
        } else {
            return otherobj;
        }
    }

    @Override
    public boolean isEditing() {
        return isedit;
    }

    @Override
    public void setEditing(boolean bool) {
        isedit = bool;
        model.setEditable(new boolean[]{false, isedit});
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }

    private void setObjectinTable(String title, Object obj) {
        Object[] row = new Object[2];
        row[0] = title;
        row[1] = obj;
        vectdata.add(row);
    }

    private <U> U getObjectinTable(String title, U obj) {
        return (U) getObjectinTable(title);
    }

    private Object getObjectinTable(String title) {
        for (int i = 0; i < jTable1.getRowCount(); i++) {
            if (jTable1.getValueAt(i, 0).toString().compareTo(title) == 0) {
                return jTable1.getValueAt(i, 1);
            }
        }
        return null;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
