package com.jdcm.editors;
/**
 *  P_ComponentEditor.java Created on 24 août 2009, 08:44:49
 * 
 * USED TO PRESENT ALL COMPONENTS (no stable, depend of needs, not fixed...)
 * @author Marc GIBOIN
 */
public class P_ComponentEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
        private final ACE_ObjRenderer<Object> render = new ACE_ObjRenderer<>();
    // if true => need to manage 'set...()' on Component => Option Model...??
    private final ACE_ObjEditor<Object> editor = new ACE_ObjEditor<>(true);
    private java.awt.Component value = null;
    private com.jdcm.common.Options_Model options = null;


    /** Creates new form P_ComponentEditor */
    public P_ComponentEditor() {
        initComponents();

    }
        /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("JDesktopPane.gif");
        }catch(Exception ex){
            return null;
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));
        setLayout(new java.awt.BorderLayout());

        jTable1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Name", "Value"
            }
        ));
        jTable1.setShowHorizontalLines(false);
        jTable1.setShowVerticalLines(false);
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent inittxt) {
        javax.swing.text.JTextComponent txt = inittxt;
        java.awt.Container cont = txt.getParent();
        javax.swing.JTextPane box1 = null;
        //value.createImage(WIDTH, WIDTH)
        if (txt instanceof javax.swing.JTextField) {
            box1 = new javax.swing.JTextPane();
            box1.setMargin(new java.awt.Insets(0, 2, 0, 0));
            box1.setEditable(false);
            box1.setOpaque(true);
            if (value != null) {
                // box1.setText(value.getClass().getSimpleName());
                if (value.isEnabled()) {
                    box1.setBorder(new javax.swing.border.EtchedBorder(javax.swing.border.EtchedBorder.LOWERED));
                }else{
                    box1.setBorder(new javax.swing.border.EtchedBorder(javax.swing.border.EtchedBorder.RAISED));
                }
            }
            txt.remove(cont);
            for (java.awt.event.FocusListener fl : txt.getFocusListeners()) {
                box1.addFocusListener(fl);
            }
            cont.add(box1, java.awt.BorderLayout.CENTER);

        } else if (txt instanceof javax.swing.JTextPane) {
            box1 = (javax.swing.JTextPane) txt;
        }

        return box1;
    }

    @Override
    public void setValue(Object val) {
        options = new com.jdcm.common.Options_Model(val);
        if (val instanceof java.awt.Component) {
            value = (java.awt.Component) val;
            options.autoDiscover();
        }
        jTable1.setModel(options);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellRenderer(render);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(editor);
        //   jTable1.repaint();
    }

    @Override
    public Object getValue() {
        if (value != null) {
            return value;
        }
        return null;
    }

    @Override
    public boolean isEditing() {
        return false;
    }

    @Override
    public void setEditing(boolean bool) {
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
        txt.setEditable(false);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
