package com.jdcm.editors;

import java.util.Locale;
import com.jdcm.common.D_Utils;

/**
 *  P_DateEditor.java Created on 31 octobre 2007, 21:26
 * 
 *Used to Edit/display Diagostics (for javax.tools.compiler)
 * 
 * @author  Marc GIBOIN
 */
public class P_DiagEditor extends javax.swing.JPanel implements I_CBObjectEditor {

    private final D_Utils TUtils = new D_Utils();
    // for serializable interface
    private static final long serialVersionUID = 1L;
    private javax.tools.Diagnostic<?> diag = null;
    private boolean editing = false;

    /**
     *create a panel <br>
     * is used by JCB_ObjectEditor<br>
     *
     */
    public P_DiagEditor() {
        initComponents();
        jButton1.setIcon(TUtils.getIcon("Obj_edit.gif"));
    }
        /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("diagnostic.gif");
        }catch(Exception ex){
            return null;
        }
    }
    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        editing = false;
        jScrollPane1.setEnabled(false);
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }

    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        String res = "";
        if (diag != null) {
            String msg = diag.getMessage(Locale.FRENCH);
            String src=diag.getSource().toString();
            if (diag.getSource() instanceof javax.tools.JavaFileObject){
                src=((javax.tools.JavaFileObject)diag.getSource()).getName();
            }
            if (msg.length()>30){
                msg=msg.substring(0, 27)+"...";
            }
            res = msg +":" +src+"("+ diag.getEndPosition()+ ")";
        }
        txt.setText(res);
        return txt;
    }

    @Override
    public javax.tools.Diagnostic<?> getValue() {
        jButton1.setVisible(diag.getSource() != null);
        return diag;
    }

    @Override
    public void setValue(Object val) {
        if (val instanceof javax.tools.Diagnostic) {
            diag = (javax.tools.Diagnostic) val;
            String msg=diag.getKind().toString()+"\r\n"+diag.getMessage(Locale.getDefault());
            if (diag.getCode() != null) {
               msg+="\r\n- Code " + diag.getCode();
            }
            msg+="\r\n\tLigne"+diag.getLineNumber()+"\r\n\tColumn"+diag.getColumnNumber();
                    jTextPane1.setText(msg);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jButton1 = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        jScrollPane1.setViewportView(jTextPane1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        add(jButton1, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Object ob = com.jdcm.editors.F_Object.showDialog(new java.awt.Frame(), diag.getSource(), false);
    }//GEN-LAST:event_jButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane jTextPane1;
    // End of variables declaration//GEN-END:variables
}
