package com.jdcm.editors;

import javax.swing.JPanel;
import com.jdcm.common.D_Utils;
import com.jdcm.common.O_MACaddress;
import jpcap.*;

/**
 *  P_ETH.java  Created on 21 juin 2008, 17:05
 * 
 * Used to Display/edit Ethernet Interface<br>
 * 
 * @author  Marc GIBOIN 
 */
public class P_ETHEditor extends javax.swing.JPanel implements I_CBObjectEditor {
        // for serializable interface
    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    private final  com.jdcm.editors.ACE_ObjRenderer<Object> render=new com.jdcm.editors.ACE_ObjRenderer<>();
    
    private NetworkInterface device = null;
    /** Creates new form P_ETH */
    public P_ETHEditor() {
        initComponents();
    }
        /**
     * return the basic label to be displayed as editor
     * @param txt the initial Text
     * @return the label to be displayed for this editor
     */
    @Override
     public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        if (device==null){
            txt.setText("null device");
        }else{
            txt.setText(device.name);
        }
        return txt;
    }
        /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("eth.gif");
        }catch(Exception ex){
            return null;
        }
    }
    @Override
    public void setValue(Object val) {
        if (val instanceof NetworkInterface) {
            device = (NetworkInterface) val;
            majinfo();
        }
    }

    @Override
    public NetworkInterface getValue() {
        return device;
    }

    public JPanel getPanel() {
        return this;
    }

    @Override
    public boolean isEditing() {
        return false;
    }

    @Override
    public void setEditing(boolean bool) {
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }
    private void majinfo() {
        if (device == null) {
            jLabel50.setText("");
            jCB_ObjectEditor1.setValue(new byte[0]);
            jLabel61.setText("");
            jCheckBox25.setEnabled(false);
            jComboBox1.removeAllItems();
        } else {
            jCheckBox25.setEnabled(true);
            jCheckBox25.setSelected(device.loopback);
            java.net.InetAddress[] ipadds=new java.net.InetAddress[device.addresses.length];
            for (int i=0;i<ipadds.length;i++){
                ipadds[i]=device.addresses[i].address;
            }
            jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(ipadds));
            if (jComboBox1.getModel().getSize() >= 0) {
                jComboBox1.setSelectedIndex(0);
                majinfoinet(device.addresses[jComboBox1.getSelectedIndex()]);
            }
          //  jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new java.awt.Color[]{java.awt.Color.BLUE,java.awt.Color.GREEN}));
           // jComboBox1.setEditable(true);
          //  jComboBox1.setEditor(new com.jdcm.editors.ACE_ObjEditor(jComboBox1,false));//=> need to advance ACE_Editor
            jComboBox1.setRenderer(render);
            try{
            jCB_ObjectEditor1.setValue(new O_MACaddress(device.mac_address));
            }catch(Exception ex){
                
            }
            jLabel50.setText(device.datalink_description);
            jLabel61.setText(device.datalink_name);
        }

    }

    private void majinfoinet(NetworkInterfaceAddress addr) {
        if (addr != null) {
            jCB_ObjectEditor2.setValue(addr.subnet);
            jCB_ObjectEditor3.setValue(addr.broadcast);
            jCB_ObjectEditor4.setValue(addr.destination);
        } else {
            jCB_ObjectEditor2.setValue(null);
            jCB_ObjectEditor3.setValue(null);
            jCB_ObjectEditor4.setValue(null);
        }

    }

    public void Add_interface() {
        try {
            byte[] addr = TUtils.string2byte("c0 a8 01 02"); // 192.168.1.2
            byte[] mask = TUtils.string2byte("ff ff ff 00"); // 255.255.255.0
            byte[] broad = TUtils.string2byte("ff ff ff ff"); // 255.255.255.255
            byte[] dest = TUtils.string2byte("c0 a8 01 01");
            jpcap.NetworkInterfaceAddress NIaddr = new jpcap.NetworkInterfaceAddress(addr, mask, broad, dest);
            jpcap.NetworkInterfaceAddress[] NIadd = new jpcap.NetworkInterfaceAddress[1];
            NIadd[0] = NIaddr;
            boolean loop = false;
            byte[] mac = TUtils.string2byte("00 1b fc 00 00 01"); // MAC test
            jpcap.NetworkInterface NI = new jpcap.NetworkInterface("-name-", "-description-", loop, "-datalink_name-", "-datalink_description-", mac, NIadd);
            //NI.????=> add to the system.
            jCB_ObjectEditor5.setValue(NI);
        } catch (Exception e) {
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel4 = new javax.swing.JPanel();
        jLabel55 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jPanel3 = new javax.swing.JPanel();
        jLabel44 = new javax.swing.JLabel();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel2 = new javax.swing.JPanel();
        jLabel57 = new javax.swing.JLabel();
        jCB_ObjectEditor3 = new com.jdcm.editors.JCB_ObjectEditor();
        jLabel59 = new javax.swing.JLabel();
        jCB_ObjectEditor4 = new com.jdcm.editors.JCB_ObjectEditor();
        jLabel56 = new javax.swing.JLabel();
        jCB_ObjectEditor2 = new com.jdcm.editors.JCB_ObjectEditor();
        jButton2 = new javax.swing.JButton();
        jCB_ObjectEditor5 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel1 = new javax.swing.JPanel();
        jLabel50 = new javax.swing.JLabel();
        jLabel61 = new javax.swing.JLabel();
        jCheckBox25 = new javax.swing.JCheckBox();

        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS));

        jPanel4.setLayout(new javax.swing.BoxLayout(jPanel4, javax.swing.BoxLayout.LINE_AXIS));

        jLabel55.setText("@:");
        jPanel4.add(jLabel55);

        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jPanel4.add(jComboBox1);

        add(jPanel4);

        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.LINE_AXIS));

        jLabel44.setText("MAC :");
        jPanel3.add(jLabel44);

        jCB_ObjectEditor1.setEditable(true);
        jCB_ObjectEditor1.setEditing(false);
        jPanel3.add(jCB_ObjectEditor1);

        add(jPanel3);

        jPanel2.setLayout(new java.awt.GridLayout(4, 0));

        jLabel57.setText("Brdcst:");
        jPanel2.add(jLabel57);

        jCB_ObjectEditor3.setEditable(true);
        jPanel2.add(jCB_ObjectEditor3);

        jLabel59.setText("Dest. :");
        jPanel2.add(jLabel59);

        jCB_ObjectEditor4.setEditable(true);
        jPanel2.add(jCB_ObjectEditor4);

        jLabel56.setText("Mask:");
        jPanel2.add(jLabel56);

        jCB_ObjectEditor2.setEditable(true);
        jPanel2.add(jCB_ObjectEditor2);

        jButton2.setText("Add");
        jButton2.setEnabled(false);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton2);

        jCB_ObjectEditor5.setEditable(true);
        jCB_ObjectEditor5.setEditing(false);
        jCB_ObjectEditor5.setEnabled(false);
        jPanel2.add(jCB_ObjectEditor5);

        add(jPanel2);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jLabel50.setText("-Media-");
        jPanel1.add(jLabel50);

        jLabel61.setText("-capacities-");
        jPanel1.add(jLabel61);

        jCheckBox25.setText("isloopback");
        jCheckBox25.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox25.setEnabled(false);
        jCheckBox25.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox25);

        add(jPanel1);
    }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    Add_interface();
}//GEN-LAST:event_jButton2ActionPerformed

private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
     majinfoinet(device.addresses[jComboBox1.getSelectedIndex()]);
}//GEN-LAST:event_jComboBox1ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor2;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor3;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor4;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor5;
    private javax.swing.JCheckBox jCheckBox25;
    private javax.swing.JComboBox<java.net.InetAddress> jComboBox1;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel50;
    private javax.swing.JLabel jLabel55;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel57;
    private javax.swing.JLabel jLabel59;
    private javax.swing.JLabel jLabel61;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    // End of variables declaration//GEN-END:variables
}
