package com.jdcm.editors;

import com.jdcm.common.D_Utils;

/**
 * 
 *Used to Display/edit Files & directories<br>
 * 
 * 
 * @author  Marc GIBOIN 
 */
public class P_FileEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
        private final D_Utils TUtils = new D_Utils();
    private final java.util.List<Object[]> vectdata = new java.util.ArrayList<>();
    private final java.util.List<String> vectname = new java.util.ArrayList<>();
    private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>(false);
    
    private java.io.File file = null;
    private boolean editing = false;
    private javax.swing.text.JTextComponent labelText=null;

    /** Creates new form P_adresses */
    public P_FileEditor() {
        initComponents();
        p_HexaEditor1.setEditing(false);
        vectname.add("Name");
        vectname.add("Value");
    }

    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        //  jButton1.setEnabled(bool);
        editing = bool;
    }
        /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("File.gif");
        }catch(Exception ex){
            return null;
        }
    }
    /**
     * return the basic label to be displayed as editor
     * @param txt the initial Text
     * @return the label to be displayed for this editor
     */
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        txt.setText(file.getName().toString());
        labelText=txt;
        return txt;
    }
    /**
     * set the file to edit
     * @param val the new file
     */
    @Override
    public void setValue(Object val) {
        if (val instanceof java.io.File) {
            file = (java.io.File) val;
        }
        majFILE_info();
        setEditing(isEditing());
    }
    /**
     * provide the edited File
     * @return the edited file
     */
    @Override
    public java.io.File getValue() {
        return file;
    }
    /**
     * Update File info in Pannel
     */
    public void majFILE_info() {
        if (file == null) {
            jLabel8.setText("-- no file --");
            setObjectinTable("file ", "null");
            p_HexaEditor1.setValue(new byte[0]);
        } else {
            if (labelText!=null){
                labelText.setText(file.getName());
            }
            jLabel8.setText(file.getName());
            setObjectinTable("Class", file.getClass());
            setObjectinTable("exists", file.exists());
            setObjectinTable("canWrite", file.canWrite());
            setObjectinTable("canExecute", file.canExecute());
            setObjectinTable("isAbsolute", file.isAbsolute());
            setObjectinTable("isDirectory", file.isDirectory());
            setObjectinTable("isFile", file.isFile());
            setObjectinTable("isHidden", file.isHidden());
            setObjectinTable("length", file.length());
            setObjectinTable("getFreeSpace", file.getFreeSpace());
            setObjectinTable("getAbsolutePath", file.getAbsolutePath());
            setObjectinTable("getTotalSpace", file.getTotalSpace());
            setObjectinTable("getUsableSpace", file.getUsableSpace());
            try {
                setObjectinTable("getCanonicalPath", file.getCanonicalPath());
            } catch (java.io.IOException ex) {
                setObjectinTable("getCanonicalPath", ex.getMessage());
            }
            setObjectinTable("getName", file.getName());
            setObjectinTable("getParent", file.getParent());
            setObjectinTable("getPath", file.getPath());
            if (file.lastModified() > 0) {
                jCB_ObjectEditor1.setValue(new java.util.Date(file.lastModified()));
            } else {
                jCB_ObjectEditor1.setValue(new java.util.Date(0));
                jCB_ObjectEditor1.setEnabled(false);
                jCB_ObjectEditor1.setEditable(false);
            }
            // need to be ajust,ex: isdirecory is not a "writable" information...
            jTable1.setModel(new javax.swing.table.DefaultTableModel(
                    new Object[0][0], new String[]{"Items", "Values"})  {
                private static final long serialVersionUID = 1L;       
                boolean[] canEdit = new boolean[]{
                    false, true
                };
                
                @Override
                public boolean isCellEditable(int rowIndex, int columnIndex) {
                    return canEdit[columnIndex];
                }
            });
            jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(editor);
        }

        jTable1.setModel(new com.jdcm.common.ListTableModel(vectdata, vectname));
        jTable1.getColumn(jTable1.getColumnName(1)).setCellRenderer(render);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(editor);
        jTable1.setEditingColumn(1);
        if (file != null) {
            if (TUtils.canRead(file)) {
                try {
                    try (java.io.InputStream in = TUtils.getFileStream(file)) {
                        byte[] buff = null;
                        int waited = in.available();
                        while (waited > 0) {
                            if (waited <= 1000) {
                                byte[] dinit = new byte[waited];
                                int res = in.read(dinit, 0, waited);
                                if (res < waited) {
                                    byte[] d = java.util.Arrays.copyOfRange(dinit, 0, res);
                                    buff = TUtils.addtab(buff, d);
                                } else {
                                    buff = dinit;
                                }
                                waited = in.available();
                                jTabbedPane1.setEnabledAt(1, true);
                                p_HexaEditor1.setValue(buff);
                            } else {
                                p_HexaEditor1.setValue(new byte[0]);
                                jTabbedPane1.setEnabledAt(1, false);
                                waited = -1;
                            }
                        }
                    }
                } catch (Exception ex) {
                }
            }
        }

    }

    private void setObjectinTable(String title, Object obj) {
        Object[] row = new Object[2];
        row[0] = title;
        row[1] = obj;
        vectdata.add(row);
    }
/**
 * Manage the changes of the text if editied directly
 * @param Jtxt the TextComponent modified to treate
 */
    @Override
    public void TextManager(javax.swing.text.JTextComponent Jtxt) {
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jButton1 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        p_HexaEditor1 = new com.jdcm.editors.P_HexaEditor();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setPreferredSize(new java.awt.Dimension(217, 133));
        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.GridLayout(3, 0));

        jLabel6.setText("getName :");
        jPanel1.add(jLabel6);

        jLabel8.setText("-getName-");
        jPanel1.add(jLabel8);

        jLabel21.setText("lastModified : ");
        jPanel1.add(jLabel21);
        jPanel1.add(jCB_ObjectEditor1);

        jButton1.setText("Change File");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        jTabbedPane1.addTab("Acces", jPanel1);

        jPanel4.setLayout(new java.awt.BorderLayout());
        jPanel4.add(p_HexaEditor1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("View", jPanel4);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jScrollPane2.setViewportView(jTable1);

        jPanel2.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Info", jPanel2);

        add(jTabbedPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
    ch.setCurrentDirectory(file.getParentFile());
    ch.setDialogTitle("change selected File");
    ch.setFileSelectionMode(javax.swing.JFileChooser.FILES_AND_DIRECTORIES);
    if (ch.showDialog(this, "Change") == javax.swing.JFileChooser.APPROVE_OPTION) {
        setValue(ch.getSelectedFile());
    }
}//GEN-LAST:event_jButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private com.jdcm.editors.P_HexaEditor p_HexaEditor1;
    // End of variables declaration//GEN-END:variables
}
