package com.jdcm.editors;

import com.jdcm.common.D_Utils;
import java.net.MalformedURLException;
import java.util.Arrays;
import javax.swing.JFrame;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * P_FileSysteme.java Created on 24 sept. 2011, 07:36:45
 * 
 * Display a FileSystem as a tree (includnig files)
 * 
 * @author sandrine
 */
public class P_FileSystem extends javax.swing.JPanel {

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
       private final java.util.List<String> hidedfiles = new java.util.ArrayList<>();//java.util.Arrays.asList(new String[]{"testfile.txt","testdir"});
       
    private I_FileSystem Parent;
    // private String BaseRep = null;
    int nbDirLevel;
 
 
    /**
     * Creates new form P_FileSysteme
     */
    public P_FileSystem() {
        initComponents();
        init();
    }
    /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("JMenuBar.gif");
        }catch(Exception ex){
            return null;
        }
    }
    public void setLoader(java.lang.ClassLoader cl){
        jCB_ObjectEditor1.setValue(cl);
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getFileNode(null)));
    }
    public void setBaseRep(String base) {
        String fs = System.getProperty("file.separator");
        ClassLoader cl=(ClassLoader)jCB_ObjectEditor1.getValue();

        java.util.ArrayList<java.io.File> files = new java.util.ArrayList<> ();
        if (cl instanceof java.net.URLClassLoader){
            for (java.net.URL url:((java.net.URLClassLoader)cl).getURLs()){
             files.addAll(TUtils.getFiles(url));
            }
        }else{
             files = TUtils.getURLLoaderFiles(cl);
        }
                    
       
        String base2 = base;
        // if base include a URLSloader part then remove it : c:\its\already\in\loader\config=>\config
        if (base2.contains(".jar!" + fs) && base2.startsWith("jar:file:" + fs)) {
            base2 = base2.substring("jar:file:".length() + fs.length());
            base2 = base2.replaceAll(".jar!", ".jar");
        }
        for (java.io.File file : files) {
            if (base2.startsWith(file.getAbsolutePath())) {
                base = base2.substring(file.getAbsolutePath().length());
            }
        }
    /**
     * add file that are not findable by computer (http:...)
     * @param txt the name of the file, directories ends with '/'
     */

        // only fs=> empty=> file systeme root
        if (base.startsWith(fs)) {
            base = base.substring(fs.length());
        }
        // set Text & update
        jTextField2.setText(base);
        nbDirLevel = 0;
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getFileNode(null)));
        jTree1.setCellRenderer(new ACE_ObjRenderer<>());
    }
    public void addHidedFile(String txt){
        hidedfiles.add(txt);
    }
        public void clearHidedFile(){
        hidedfiles.clear();
    }
    public void setBaseRep(String base, String filter) {
        if (getFilter().compareTo(filter) != 0) {
            jTextField1.setText(filter);
        }
        setBaseRep(base);
    }

    public String getBaseRep() {
        return jTextField2.getText();
    }

    public void setFile(java.io.File file) {
        String fs = System.getProperty("file.separator");
        String rep = file.getPath().substring(0, file.getPath().lastIndexOf(fs));
        if (file.getName().lastIndexOf(".") > 0 && file.getName().endsWith(".") == false) {
            setBaseRep(rep, file.getName().substring(file.getName().lastIndexOf(".")));
        } else {
            setBaseRep(rep);
        }
    }

    public void setFilter(String filter) {
        if (getFilter().compareTo(filter) != 0) {
            jTextField1.setText(filter);
        }
        init();
    }

    public String getFilter() {
        return jTextField1.getText();

    }

    public void setParent(I_FileSystem parent) {
        Parent = parent;
    }

    public ClassLoader getClassLoader() {
        Object ob = jCB_ObjectEditor1.getValue();
        if (ob instanceof ClassLoader) {
            return (ClassLoader) ob;
        }
        return null;
    }

    private void init() {
        nbDirLevel = 0;
        jCB_ObjectEditor1.setAsButton(true);
        jCB_ObjectEditor1.setValue(this.getClass().getClassLoader());
        String srcdir = "file:/" + System.getProperty("user.dir") + System.getProperty("file.separator") + "src" + System.getProperty("file.separator");
        if (jCB_ObjectEditor1.getEditor() instanceof P_LoaderEditor) {
            ((P_LoaderEditor) jCB_ObjectEditor1.getEditor()).addURL(srcdir);
        }
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getFileNode(null)));
        jTree1.setCellRenderer(new ACE_ObjRenderer<>());
    }



    /**
     * recurcive return a node with file of this directory. ask null for
     * starting
     *
     * @param dir
     * @return
     */
    private DefaultMutableTreeNode getFileNode(java.io.File dir) {
        //  System.out.println("scan : "+dir);
        DefaultMutableTreeNode root = new DefaultMutableTreeNode();
        java.util.List<java.io.File> files = null;
        if (dir == null) {
            if (getBaseRep() == null) {
                root.setUserObject("no files asked");
            } else if (getBaseRep().length() == 0) {
                root.setUserObject("root && Loader FileSystem");
                files = new java.util.ArrayList<>();
                files.addAll(java.util.Arrays.asList(java.io.File.listRoots()));
                files.add(new java.io.File("URLLoader"));
            } else {
                root.setUserObject("Asking for : " + getBaseRep());
                files = TUtils.getFiles(getBaseRep(), getClassLoader());
               
        for (String txt:hidedfiles){
            if (txt.startsWith("http:")){
           files.add(new com.jdcm.common.C_httpFile(txt,txt.endsWith("/")));
            }else{
                 files.add(new java.io.File(txt));
            }
        }
            }
        }else if (dir instanceof com.jdcm.common.C_httpFile) {
            root.setUserObject(dir);
           java.io.File[] fs=((com.jdcm.common.C_httpFile)dir).listFiles();
           if (fs!=null){
                files=Arrays.asList(fs);
           }
        } else if (dir.getName().endsWith(".jar")) {
            root.setUserObject(dir);
             files = TUtils.getJarFiles("jar:" + dir.toURI() + "!/");
        }  else if (dir.getName().endsWith("URLLoader")) {
            root.setUserObject(dir);
            try {
                  files = new java.util.ArrayList<> ();
                 ClassLoader cl=(ClassLoader)jCB_ObjectEditor1.getValue();
                for (java.net.URL url:((java.net.URLClassLoader)cl).getURLs()){
             files.addAll(TUtils.getFiles(url));
            }
            }catch(Exception ex){}
        } else {
            root.setUserObject(dir);
            if (nbDirLevel < 2) {
                // allow large tre event if 'big file system' BUT need jTree1TreeWillExpand() management
                try {
                    files = TUtils.getFiles(dir.toURI().toURL());
                } catch (MalformedURLException ex) {
                    System.out.println("P_FileSystem.getFileNode()=>" + ex);
                }
                if (files == null||files.isEmpty()) {
                    files = TUtils.getFiles(dir.getAbsolutePath(), getClassLoader());
                }
            }
        }
        if (files != null) {
            for (java.io.File file : files) {
                //        System.out.println("=>"+file.toString());

                // TODO : !!!! in JAR, directory are not isDirectory()
                if (file.isDirectory()
                        || file.getName().endsWith(".jar")
                        || file.getName().endsWith("URLLoader")
                        || (file.getName().indexOf(".") < 0
                        && file.getAbsolutePath().contains(".jar!\\")
                        && file.length() == 0 //&& getFileNode(file).isLeaf()==false
                        )) {
                    nbDirLevel++;
                    root.add(getFileNode(file));
                    nbDirLevel--;
                } else {
                    if (getFilter() == null || getFilter().length() == 0
                            || file.getName().endsWith(getFilter())
                            || getFilter().endsWith(".*")
                            || getFilter().trim().length() == 0) {
                        DefaultMutableTreeNode fileNode = new DefaultMutableTreeNode(file);
                        root.add(fileNode);
                    }
                }
            }
        }
        return root;
    }

    public java.io.File getSelectedFile() {
        if (jTree1.getSelectionCount() > 0) {
            if (jTree1.getSelectionPath().getLastPathComponent() instanceof DefaultMutableTreeNode) {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
                if (node.getUserObject() instanceof java.io.File) {
                    java.io.File file = (java.io.File) node.getUserObject();
                    return file;
                }
            }
        }
        return null;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                javax.swing.JFrame f = new javax.swing.JFrame();
                f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                P_FileSystem p = new P_FileSystem();
                p.setBaseRep("");
                f.add(p);
                f.setBounds(new java.awt.Rectangle(0, 0, 100, 400));
                f.setVisible(true);
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jToolBar1 = new javax.swing.JToolBar();
        jTextField2 = new javax.swing.JTextField();
        jTextField1 = new javax.swing.JTextField();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();

        setLayout(new java.awt.BorderLayout());

        jTree1.addTreeWillExpandListener(new javax.swing.event.TreeWillExpandListener() {
            public void treeWillCollapse(javax.swing.event.TreeExpansionEvent evt)throws javax.swing.tree.ExpandVetoException {
                jTree1TreeWillCollapse(evt);
            }
            public void treeWillExpand(javax.swing.event.TreeExpansionEvent evt)throws javax.swing.tree.ExpandVetoException {
                jTree1TreeWillExpand(evt);
            }
        });
        jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTree1MousePressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jToolBar1.setRollover(true);

        jTextField2.setToolTipText("Initial Rep");
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jTextField2);

        jTextField1.setToolTipText("Filter (*.java)");
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jTextField1);

        jCB_ObjectEditor1.setAsButton(true);
        jCB_ObjectEditor1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jCB_ObjectEditor1);

        add(jToolBar1, java.awt.BorderLayout.NORTH);
    }// </editor-fold>//GEN-END:initComponents

    private void jTree1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MousePressed
        //should be better as ActionPerform on P_FileSystem
        if (evt.isShiftDown()){
            com.jdcm.common.C_httpFile file=(com.jdcm.common.C_httpFile)getSelectedFile();
          Object name = javax.swing.JOptionPane.showInputDialog(null,
                  file.getURL().toString(), "New File Name", 
                  javax.swing.JOptionPane.QUESTION_MESSAGE, null,
                  new String[]{"http:/sgiboin.free.fr/helloWorld.java", 
                      "com.jdcm.tests.helloWorld"},
                  "http:/sgiboin.free.fr/helloWorld");
         if (name != null && name.toString().length() > 0) {
             addHidedFile(name.toString());
            jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getFileNode(null)));
         }
        }
        if (Parent != null && getSelectedFile() != null) {
            setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
            Parent.setSelectedFile(getSelectedFile());
            setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        }
    }//GEN-LAST:event_jTree1MousePressed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        setFilter(jTextField1.getText());
        if (Parent != null) {
            Parent.setSelectedFile(null);
        }
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
        setBaseRep(jTextField2.getText());
        if (Parent != null) {
            Parent.setSelectedFile(null);
        }
    }//GEN-LAST:event_jTextField2ActionPerformed

    private void jTree1TreeWillExpand(javax.swing.event.TreeExpansionEvent evt) throws javax.swing.tree.ExpandVetoException {//GEN-FIRST:event_jTree1TreeWillExpand
        if (evt.getPath().getLastPathComponent() instanceof DefaultMutableTreeNode) {
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) evt.getPath().getLastPathComponent();
            if (node.getUserObject() instanceof java.io.File) {
                java.io.File file = (java.io.File) node.getUserObject();
                nbDirLevel = 0;
                /*
                 * if (node.getParent() instanceof DefaultMutableTreeNode){
                 * DefaultMutableTreeNode
                 * par=(DefaultMutableTreeNode)node.getParent(); int
                 * idx=par.getIndex(node); par.insert( getFileNode(file), idx);
                 * }
                 */
                DefaultMutableTreeNode child = getFileNode(file);
                node.removeAllChildren();
                for (int i = child.getChildCount() - 1; child.getChildCount() > 0; i++) {
                    node.add((DefaultMutableTreeNode) child.getChildAt(0));
                }
                jTree1.repaint();
            }
        }
    }//GEN-LAST:event_jTree1TreeWillExpand

    private void jTree1TreeWillCollapse(javax.swing.event.TreeExpansionEvent evt) throws javax.swing.tree.ExpandVetoException {//GEN-FIRST:event_jTree1TreeWillCollapse
        /*
         * if (evt.getPath().getLastPathComponent() instanceof
         * DefaultMutableTreeNode) { DefaultMutableTreeNode node =
         * (DefaultMutableTreeNode) evt.getPath().getLastPathComponent(); for
         * (int chdidx = 0; chdidx < node.getChildCount(); chdidx++) {
         * DefaultMutableTreeNode child = (DefaultMutableTreeNode)
         * node.getChildAt(chdidx); // for (int i = 0; i <
         * child.getChildCount(); i++) { // should be great but if remoevd then
         * Pb of re drawing node childs??? child.removeAllChildren(); // } }
         }
         */
    }//GEN-LAST:event_jTree1TreeWillCollapse

    private void jCB_ObjectEditor1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor1ActionPerformed
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(getFileNode(null)));
    }//GEN-LAST:event_jCB_ObjectEditor1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
