package com.jdcm.editors;

import java.awt.Color;
import java.awt.Component;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import javax.swing.JComponent;
import javax.swing.TransferHandler;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * P_HexaEditor.java Created on 28 octobre 2007, 21:10
 *
 * Display and Edit a Byte array with values (CRC/LRC/SUM/....)
 *
 * @author Marc GIBOIN
 */
public class P_HexaEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    /**
     * Creates new form P_HexaEditor
     */
    private Hex_Model mod = null;
    /*
     * MIN & MAX are limite of the selection -1 if not selection
     */
    private final String hexahdr = "H:";
    private final com.jdcm.common.Options_Model options = new com.jdcm.common.Options_Model(this);
    private final java.util.List<selectionEventListner> selEvts = new java.util.ArrayList<>();
    private final java.util.zip.CRC32 crc32 = new java.util.zip.CRC32();
    private final java.util.List<Integer> selection = new java.util.ArrayList<>();
     private final java.util.List<colorRange> colRanges = new java.util.ArrayList<>();
    private int MIN = -1;
    private int MAX = -1;

    private int selecting = -1;
    private boolean editing = false;
    private java.awt.Dimension initsize = null;
    // header used to identify hexa byte array

    class colorRange {

        int start, stop;
        java.awt.Color col;

        public colorRange(int begin, int end, java.awt.Color color) {
            start = begin;
            stop = end;
            col = color;
        }
    }
   

    /**
     * Creates new form F_HexaEditor
     */
    public P_HexaEditor() {
        initComponents();
        initsize = this.getPreferredSize();
        init();

    }

    public P_HexaEditor(byte[] buff) {
        initComponents();
        initsize = this.getPreferredSize();
        init();
        setValue(buff);
    }

    private void init() {
        mod = new Hex_Model(new byte[0]);

        jTable1.setModel(mod);
        jTable1.setRowHeight(getFontMetrics(jTable1.getFont()).getHeight());
        jTable1.setAlignmentX(CENTER_ALIGNMENT);
        jTable1.getColumn(jTable1.getColumnName(0)).setCellRenderer(new ObjHexRenderer(this));
        for (int i = 1; i < jTable1.getColumnCount(); i++) {
            jTable1.getColumn(jTable1.getColumnName(i)).setCellRenderer(new ObjHexRenderer(this));
            jTable1.getColumn(jTable1.getColumnName(i)).setPreferredWidth(20);
        }

        // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        options.addOption("hex_sum", 0, "byte", "", false, true, "Sum of cars modulo FF");
        options.addOption("hex_dif", 0, "byte", "", false, true, "difference of cars modulo FF intiby 7f");
        options.addOption("hex_xor", 0, "byte", "", false, true, "xor initialized at 0");
        options.addOption("hex_sel", "[]", "string", "", true, true, "selection interval & length");
        options.addOption("hex_chars", "[]", "string", "", true, true, "selection interval & length");
        javax.swing.DefaultComboBoxModel<java.nio.charset.Charset> com = new javax.swing.DefaultComboBoxModel<>(
                new java.nio.charset.Charset[]{
                    java.nio.charset.Charset.forName("ISO-8859-1"),
                    java.nio.charset.Charset.forName("UTF-8"),
                    java.nio.charset.Charset.forName("IBM1047")});
        com.setSelectedItem(java.nio.charset.Charset.defaultCharset());
        options.addOption("hex_chars", com, "combo<charset>", "", true, true, "charSet used to display 'char' display selection");
        javax.swing.JButton b = new javax.swing.JButton("src");
        b.setMargin(new java.awt.Insets(0, 0, 0, 0));
        b.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                java.nio.charset.Charset cs = (java.nio.charset.Charset) options.getValuefor("hex_chars", new javax.swing.DefaultComboBoxModel()).getSelectedItem();
                java.util.List<java.nio.charset.Charset> l = new java.util.ArrayList<>(java.nio.charset.Charset.availableCharsets().values());
                javax.swing.DefaultComboBoxModel<java.nio.charset.Charset> com = new javax.swing.DefaultComboBoxModel<>(l.toArray(new java.nio.charset.Charset[]{}));
                com.setSelectedItem(cs);
                options.setValuefor("hex_chars", com);
            }
        });
        TransferHandler copyhdl = new TransferHandler() {
            private static final long serialVersionUID = 1L;

            @Override
            public int getSourceActions(JComponent c) {
                return COPY_OR_MOVE;
            }

            @Override
            public java.awt.datatransfer.Transferable createTransferable(javax.swing.JComponent comp) {
                //   getVisualRepresentation(super.createTransferable(comp));
                return new StringSelection(getSelectedasString());
                // Should try to transfert a table like default JTable implmentation ..
            }

            @Override
            public void exportToClipboard(JComponent comp, Clipboard clip, int action) throws IllegalStateException {
                super.exportToClipboard(comp, clip, action);
            }
        };
        jTable1.setTransferHandler(copyhdl);
        options.addOption("hex_charAll", b, "button", "", true, true, "get all available Charset");
        javax.swing.JButton b1 = new javax.swing.JButton("crc");
        b1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        b1.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                if (options.isPresent("hex_crc16_ker")) {
                    options.getValuefor("hex_crc16_ker");
                    options.removeOption("hex_crc16_ker");
                    options.removeOption("hex_crc16_ffff");
                    options.removeOption("hex_crc32");
                } else {
                    options.addOption("hex_crc16_ker", 0, "byte", "", false, true, "CRC16 to check");
                    options.addOption("hex_crc16_ffff", 0, "byte", "", false, true, "CRC16 to check");
                    options.addOption("hex_crc32", 0, "byte", "", false, true, "CRC32 to check");
                }
                displaySelected();
                options.fireTableDataChanged();
            }
        });
        options.addOption("hex_CRC", b1, "button", "", true, true, "get CRC information");
        mod.setcharSet((java.nio.charset.Charset) com.getSelectedItem());
        javax.swing.DefaultComboBoxModel<String> cop = new javax.swing.DefaultComboBoxModel<>(new String[]{"[TABLE]", "LONG", "BCD", "BCD_O", "BCD_B", "BCD_I", "DEC_I", "DEC_B", "DEC_BI", "ASCII_0", "ASCII_7"});
        options.addOption("hex_type", cop, "combo<charset>", "", true, true, "type used to pick data");
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"Hexa", "Octal", "Decimal", "Dec128", "Binary", "Char", "c0c1", "EBCDIC"}));
        setmode("Char");
        plugModifiers();
        jLabel3.setEnabled(false);
        jCB_ObjectEditor1.setValue(options);
        jCB_ObjectEditor1.setVisible(true);
    }

    /**
     * Provide an Icon if needed (asked by frames)
     *
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
            return (new com.jdcm.common.D_Utils()).getImage("com.gif");
        } catch (Exception ex) {
            return null;
        }
    }

    public javax.swing.JTable getTable() {
        return jTable1;
    }

    public void addSelectionEventListner(selectionEventListner e) {
        if (e != null) {
            selEvts.add(e);
        }
    }

    public void removeSelectionEventListner(selectionEventListner e) {
        selEvts.remove(e);
    }

    public java.util.List<selectionEventListner> getSelectionEventListner() {
        return selEvts;
    }

    /**
     * Propose Modifiers in Popup menu to code/decode the entire buffer
     *
     */
    public final void plugModifiers() {
        try {
            com.jdcm.common.D_Utils TUtils = new com.jdcm.common.D_Utils();
            java.util.List<String> mods = TUtils.getFileNames("com/jdcm/modifiers", null, false);
            // String[] mods = {"modif_Base64", "modif_QP", "modif_DLE", "modif_MD5", "modif_uuencode", "modif_PPP", "modif_scrambler", "modif_deflater"};
            if (mods.size() > 0) {
                for (String modName : mods) {
                    getSelectionStart();
                    try {
                        final Class<?> modifClass = Class.forName("com.jdcm.modifiers." + modName);
                        if (modifClass != null
                                && modifClass.isInterface() == false
                                && com.jdcm.modifiers.I_modifiers.class.isAssignableFrom(modifClass)) {
                            javax.swing.JMenuItem codeJMI = new javax.swing.JMenuItem(modName);
                            codeJMI.addActionListener(new java.awt.event.ActionListener() {
                                @Override
                                public void actionPerformed(java.awt.event.ActionEvent evt) {
                                    int[] sel = getSelectingPos();
                                    com.jdcm.modifiers.I_modifiers be;
                                    try {
                                        be = (com.jdcm.modifiers.I_modifiers) modifClass.newInstance();
                                        if (be != null) {
                                            if (sel == null) {
                                                be.setBuffer(mod.getbuffer());
                                                be.ToCode();
                                                mod.setbuffer(be.getBuffer());
                                            } else {
                                                be.setBuffer(getSelectedasBuff());
                                                be.ToCode();
                                                mod.removeBuffer(sel[0], sel[1] - sel[0] + 1);
                                                mod.insertBuffer(be.getBuffer(), sel[0]);
                                                setSelectedPos(sel[0], sel[0] + be.getBuffer().length);
                                            }
                                            jTable1.repaint();
                                        }
                                    } catch (InstantiationException | IllegalAccessException ex) {
                                    }
                                }
                            });
                            jMenu1.add(codeJMI);
                            javax.swing.JMenuItem uncodeJMI = new javax.swing.JMenuItem(modName);
                            uncodeJMI.addActionListener(new java.awt.event.ActionListener() {
                                @Override
                                public void actionPerformed(java.awt.event.ActionEvent evt) {
                                    int[] sel = getSelectingPos();
                                    com.jdcm.modifiers.I_modifiers be;
                                    try {
                                        be = (com.jdcm.modifiers.I_modifiers) modifClass.newInstance();
                                        if (be != null) {
                                            if (sel == null) {
                                                be.setBuffer(mod.getbuffer());
                                                be.ToClear();
                                                mod.setbuffer(be.getBuffer());
                                            } else {
                                                be.setBuffer(getSelectedasBuff());
                                                be.ToClear();
                                                mod.removeBuffer(sel[0], sel[1] - sel[0] + 1);
                                                mod.insertBuffer(be.getBuffer(), sel[0]);
                                                setSelectedPos(sel[0], sel[0] + be.getBuffer().length);
                                            }
                                            jTable1.repaint();
                                        }
                                    } catch (InstantiationException | IllegalAccessException | NumberFormatException ex) {
                                        System.out.println("HXEditor : Menu actionPerformed =>"+ex.getMessage());
                                    }
                                }
                            });
                            jMenu2.add(uncodeJMI);
                        }
                    } catch (ClassNotFoundException ex) {
                        // stacks & modif are directories => KO
                        // System.out.println("HXEditor : plugModifiers =>"+ex.getMessage());
                    }
                }
                return;
            }
        } catch (Exception ex) {
            //error somwhere???
        }
        this.setComponentPopupMenu(null);
    }

    public void addColorRange(int start, int stop, java.awt.Color col) {
        colRanges.add(new colorRange(start, stop, col));
    }

    public void insertColorRange(int start, int stop, java.awt.Color col) {
        colRanges.add(0, new colorRange(start, stop, col));
    }

    public void clearColorRange() {
        colRanges.clear();
    }

    public java.awt.Color getCellColor(int pos) {
        java.awt.Color res = java.awt.Color.WHITE;
        if (colRanges != null && colRanges.isEmpty() == false) {
            for (int i = 0; i < colRanges.size(); i++) { // else ConcurrentModificationException
                if (pos >= colRanges.get(i).start && pos <= colRanges.get(i).stop) {
                    //  java.awt.Color c=new java.awt.Color(rg.col.getRed(), rg.col.getGreen(), rg.col.getBlue(), 50);
                    if (colRanges.get(i) != null) {
                        return colRanges.get(i).col;
                    }
                }
            }
        }
        return res;
    }

    public int getBuffPosition(int row, int column) {
        int res = -(row + 1) + column + 17 * row;
        if (res == getValue().length) {
            return -1;
        }
        if (res > getValue().length - 1) {
            return -2;
        }

        return res;
    }

    public void sethex_chars(java.nio.charset.Charset cs) {
        javax.swing.DefaultComboBoxModel<java.nio.charset.Charset> cbm = options.getValuefor("hex_chars", new javax.swing.DefaultComboBoxModel<java.nio.charset.Charset>());
        if (cbm.getSelectedItem().equals(cs) == false) {
            cbm.setSelectedItem(cs);
        }
        mod.setcharSet(cs);
    }
    /*
     * used because Option_model don't manage directly File type but need a ComboBoxModel
     */

    public void sethex_chars(javax.swing.ComboBoxModel<java.nio.charset.Charset> csm) {
        sethex_chars((java.nio.charset.Charset) csm.getSelectedItem());
    }

    public void sethex_sel(String txt) {
        if (txt.startsWith("[") && txt.indexOf("-") > txt.indexOf("[") && txt.indexOf("]") > txt.indexOf("-")) {
            String seltxt = txt.substring(1, txt.indexOf("]"));
            int start = new Integer(seltxt.substring(0, seltxt.indexOf("-")));
            int stop = new Integer(seltxt.substring(seltxt.indexOf("-") + 1));
            if (start < stop) {
                // Dangerous !!! loop on mouse event
                // must be perferct with [-,] and check not already selected
                //   setSelectedPos(start, stop);
            }
        }
        displaySelected();
    }

    private void displaySelected() {
        byte[] buff = getSelectedasBuff();
        if (buff == null) {
            options.setDefault("hex_crc16_ker");
            options.setDefault("hex_crc16_ffff");
            options.setDefault("hex_crc23");
            options.setDefault("hex_xor");
            options.setDefault("hex_sum");
            options.setTitle("byte[] is NULL");
        } else {
            if (MIN < 0) {
                options.setValuefor("hex_sel", "[]:0/" + mod.getbuffer().length);
                buff = mod.getbuffer();
            } else {
                // provide a Selection String ex : [1-3,5,7,10-15]
                String seltxt = "[";
                for (int i = 0; i < selection.size(); i++) {
                    if (i == 0 || selection.get(i) > selection.get(i - 1) + 1) {
                        seltxt += selection.get(i);
                    } else if (i == selection.size() - 1 || selection.get(i + 1) > selection.get(i) + 1) {
                        seltxt += selection.get(i);
                    }
                    if (seltxt.endsWith("-") == false && i < selection.size() - 1) {
                        if (selection.get(i + 1) == selection.get(i) + 1) {
                            seltxt += "-";
                        } else {
                            seltxt += ",";
                        }
                    }
                }
                seltxt += "]:";
                options.setValuefor("hex_sel", seltxt + (MAX - MIN + 1) + "/" + mod.getbuffer().length);
            }

            /*
             * int lrc = 0; for (byte oct : buff) { lrc ^= oct; }
             * luhn...
             */
            options.setTitle("byte[" + mod.getbuffer().length + "]");
            options.setValuefor("hex_xor", feelzero(Integer.toHexString(lrc(buff) & 0xff), 2));
            if (options.isPresent("hex_crc16_ker")) {
                options.setValuefor("hex_crc16_ffff", ajustCRC(crc16ffff(buff)));//crc16ffff  crc16_ccitt
                options.setValuefor("hex_crc16_ker", ajustCRC(crc16_ker(buff)));//crc16ffff  crc16_ccitt
                crc32.update(buff);
                options.setValuefor("hex_crc32", feelzero(Long.toHexString(crc32.getValue()), 8));
                crc32.reset();
            }
            options.setValuefor("hex_sum", feelzero(Integer.toHexString(sumff(buff) & 0xff), 2));
            options.setValuefor("hex_dif", feelzero(Integer.toHexString(difff(buff) & 0xff), 2));
        }
    }

    private String ajustCRC(int crc) {
        String crcstr = Integer.toHexString(crc);
        if (crcstr.endsWith("ffff")) {
            crcstr = crcstr.substring(crcstr.length() - 4);
        }
        return feelzero(crcstr, 4);
    }

    private String feelzero(String txt, int nb) {
        // it should be a simple format or padding function.
        while (txt.length() < nb) {
            txt = "0" + txt;
        }
        return "0x" + txt;
    }

    public boolean isSelectedPos(int position) {
        return selection.contains(position);
    }

    public boolean isSelectingPos(int position) {
        if (selecting >= 0) {
            return position >= MIN && position <= MAX;
        } else {
            return false;
        }
    }

    public int getSelectionStart() {
        return MIN;
    }

    public void viewSelected() {
        java.awt.Point p1 = jTable1.getCellRect((MIN / 16), MIN - ((MIN / 16) * 16) + 1, true).getLocation();
        java.awt.Point p2 = jTable1.getCellRect((MAX / 16), MAX - ((MAX / 16) * 16) + 1, true).getLocation();
        //show endof buffer if possible 
        if (jTable1.getHeight() - p2.y < jScrollPane1.getHeight()) {
            p1.y = jTable1.getHeight() - jScrollPane1.getHeight();
            if (p1.y < 0) {
                p1.y = 0;
            }
        }
        //!!!!!!!!!!!!!Pb position is not good???=>setViewport is not ok
        javax.swing.JViewport viewport = jScrollPane1.getViewport();
        if (viewport.getBounds().contains(p1) == false) {
            viewport.setViewPosition(p1);
            jScrollPane1.repaint();
        }
    }

    public int[] getSelectingPos() {
        if (MIN == -1 || MAX == -1) {
            return null;
        }
        int[] res = new int[2];
        res[0] = MIN;
        res[1] = MAX;
        return res;
    }

    public void setSelectedPos(int posmin, int oldposmax) {
        int posmax = oldposmax;
        if (posmin > posmax || posmin < 0 || posmax < 0) {
            return;
        }
        if (posmax >= mod.getbuffer().length) {
            posmax = mod.getbuffer().length - 1;
        }
        MIN = posmin;
        MAX = posmax;
        //int row2 = MAX / 16;
        selection.clear();
        for (int i = MIN; i <= MAX; i++) {
            selection.add(i);
        }
        displaySelected();
        repaint();
        for (selectionEventListner e : getSelectionEventListner()) {
            e.selectedPerformed(null);
        }
    }

    public String getSelectedasString() {

        //  DataFlavor htmlFlavor = new DataFlavor("text/html", "HTML table");
        //  String res = "<html><body><table border=1><tr>";
        String res = "";
        if (MIN == -1 || MAX == -1) {
            return null;
        }
        for (int i = MIN; i <= MAX; i++) {
            int row = Math.round(i / 16);
            int column = (i - 16 * row) + 1;
            if ((i - MIN) != 0 && ((i - MIN) % 16 == 0)) {
                res += "\r\n";//"</tr><tr>";
            }
            // res = res + "<td>"+mod.getValueAt(row, column) + "</td>";
            res = res + "" + mod.getValueAt(row, column) + "\t";
        }
        res = res.substring(0, res.length() - 1);
        /* res=res+"</body></html>";
         try{
         htmlFlavor.readExternal(new java.io.ObjectInputStream(new java.io.ByteArrayInputStream(res.getBytes())));
         }catch(IOException | ClassNotFoundException ex){}
         */
        return res;
    }

    public byte[] getSelectedasBuff() {

        if (selection.isEmpty()) {
            return null;
        }
        try {
            byte[] res = new byte[selection.size()];
            int i = 0;
            for (int pos : selection) {
                res[i++] = getValue()[pos];
            }
            return res;
        } catch (Exception ex) {
            return null;
        }
    }

    private String getradical(String txt) {
        String radix = " ";
        if (txt.compareTo("Octal") == 0) {
            radix = " ox";
        }
        if (txt.compareTo("Hexa") == 0) {
            radix = " 0x";
        }
        if (txt.compareTo("Binary") == 0) {
            radix = " bx";
        }
        if (txt.compareTo("c0c1") == 0) {
            radix = " cx";
        }
        if (txt.compareTo("EBCDIC") == 0) {
            radix = " ex";
        }
        if (txt.compareTo("Base64") == 0) {
            radix = "6x";
        }
        if (txt.compareTo("quotedprint") == 0) {
            radix = "qx";
        }
        if (txt.compareTo("Char") == 0) {
            radix = "";
        }
        return radix;
    }

    private String getSelectedFormated() {
        if (getSelectedasBuff() == null) {
            return null;
        }
        String res = "";
        javax.swing.DefaultComboBoxModel<String> cbm = options.getValuefor("hex_type", new javax.swing.DefaultComboBoxModel<String>());
        if (cbm != null && cbm.getSelectedItem().toString().compareTo("[TABLE]") != 0) {
            String type = cbm.getSelectedItem().toString();
            try {
                com.jdcm.common.C_Format f = new com.jdcm.common.C_Format();
                f.setbuffer(getSelectedasBuff());
                res = f.B_Retire(type);
            } catch (Exception ex) {
                javax.swing.JOptionPane.showMessageDialog(this, "Pb whith " + type + "=>" + ex.getMessage(), "Format box", javax.swing.JOptionPane.WARNING_MESSAGE);
            }
        } else {
            String radix = getradical(getmode());
            for (int pos : selection) {
                res = res + radix + mod.getValueAt(pos);
            }
        }

        return res;
    }

    public void setEdit(String txt) {
        jTextField1.setText(txt);
    }

    public void setEditbutton(boolean bool) {
        jTextField1.setVisible(bool);
        jLabel3.setVisible(bool);
        jLabel4.setVisible(bool);
        jLabel5.setVisible(bool);
        jMenu1.setVisible(bool);
        jMenu2.setVisible(bool);
        mod.setloked(true);
    }

    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        jLabel3.setVisible(bool);
        jLabel4.setVisible(bool);
        mod.setloked(bool == false);
        editing = bool;
    }

    /**
     * used to set the buffer directly from un combo-textbox
     *
     * @param txtfield the text field to manage
     */
    @Override
    public void TextManager(javax.swing.text.JTextComponent txtfield) {
        java.awt.Color cko = java.awt.Color.GRAY;
        java.awt.Color cok = java.awt.Color.green.brighter();
        String txt = txtfield.getText();
        byte[] by;
        if (txt.length() == 0 || txt.compareTo(hexahdr) == 0) {
            by = new byte[0];
        } else {
            if (txt.startsWith("byte[") && txt.endsWith("]")) {
                return;
            }
            if (txt.startsWith(hexahdr)) {
                txt = txt.substring(hexahdr.length());
            }
            by = string2byte(txt);
        }
        if (by == null) {
            by = txt.getBytes();
        }
        if (by == null) {
            txtfield.setBackground(cko);
            return;
        }
        mod.setbuffer(by);
        ajustsize();
        txtfield.setBackground(cok);
    }

    /**
     * return the basic label to be displayed as editor
     *
     * @param txt the initial Text
     * @return the label to be displayed for this editor
     */
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        String res = "";
        if (getValue().length == 0 || getValue().length > 10) {
            res = "byte[" + getValue().length + "]";
        } else {
            for (int i = 0; i < getValue().length; i++) {
                int oct;
                if (getValue()[i] < 0) {
                    oct = 256 + getValue()[i];
                } else {
                    oct = getValue()[i];
                }
                String by = Integer.toHexString(oct);
                if (by.length() == 1) {
                    by = "0" + by;
                }
                res = res + " " + by;
            }
            res = hexahdr + res;
            /*
             * if
             * (txt.getFontMetrics(txt.getFont()).stringWidth(res)>txt.getPreferredSize().width){
             * res = "byte[" + getValue().length + "]";
             }
             */
        }
        txt.setText(res);
        return txt;
    }

    @Override
    public byte[] getValue() {
        return mod.getbuffer();
    }

    @Override
    public final void setValue(Object val) {
        if (val instanceof byte[]) {
            byte[] buff = (byte[]) val;
            mod.setbuffer(buff);
            options.setTitle("byte[" + mod.getbuffer().length + "]");
            displaySelected();
        }
        ajustsize();
    }

    private void ajustsize() {
        if (1 == 1) {
            // return;
        }
        if (this.getParent() instanceof javax.swing.JSplitPane
                || this.getParent() instanceof javax.swing.JViewport
                || this.getTopLevelAncestor() instanceof javax.swing.JFrame) {
            return;
        }
        jTable1.doLayout();
        int a = 2 * jComboBox1.getPreferredSize().height;
        //16 for header
        int b = jTable1.getRowHeight() * jTable1.getRowCount();
        int c = 0;
        c += 18;//gaps
        int d = 30; //Scrollbar
        d += jTable1.getPreferredSize().width;
        if (getParent() != null) {
            c = +30;
            getTopLevelAncestor().setSize(new java.awt.Dimension(
                    Math.max(initsize.width, d), Math.min(a + b + c, initsize.height)));
        } else {
            setPreferredSize(new java.awt.Dimension(
                    Math.max(initsize.width, d), Math.min(a + b + c, initsize.height)));
        }

    }

    public String getmode() {
        return jComboBox1.getSelectedItem().toString();
    }

    public void setmode(String txt) {
        if (getmode().compareTo(txt) != 0) {
            jComboBox1.setSelectedItem(txt);
        }

        if (txt.startsWith("EBCDIC")) {
            if (java.nio.charset.Charset.isSupported("IBM1047")) {
                sethex_chars(java.nio.charset.Charset.forName("IBM1047"));
                txt = "Char";
            } else {
                System.out.println("=> no IBM1047(EBCDIC) font on the system");
                jComboBox1.removeItem("EBCDIC");
                setmode("Char");
                return;
            }
        }
        options.setused("hex_type", txt.compareTo("Char") == 0);
        options.setused("hex_chars", txt.compareTo("Char") == 0);
        mod.setmode(txt);
        jComboBox1.setToolTipText(mod.getcomment());
        jTextField1.setToolTipText(".." + getradical(getmode()) + "NN..");
        // otherwise keep the size of previous mode if bigger
        for (int i = 1; i < jTable1.getColumnCount(); i++) {
            jTable1.getColumn(jTable1.getColumnName(i)).setPreferredWidth(20);
        }
        doLayout();
    }

    /**
     * Calc 16-bit CRC with CCITT method.
     * http://www.lammertbies.nl/comm/info/crc-calculation.html => ??? * Used to
     * Display/edit byte[]<br> CCITT-32: 0x04C11DB7 = x32 + x26 + x23 + x22 +
     * x16 + x12 + x11 + x10 + x8 + x7 + x5 + x4 + x2 + x + 1
     *
     * CRC-16: 0x8005 = x16 + x15 + x2 + 1
     *
     * CRC-CCITT: 0x1021 = x16 + x12 + x5 + 1
     *
     * CRC-XMODEM: 0x8408 = x16 + x15 + x10 + x3
     *
     * 12bit-CRC: 0x80f = x12 + x11 + x3 + x2 + x + 1
     *
     * 10bit-CRC: 0x233 = x10 + x9 + x5 + x4 + x + 1
     *
     * 8bit-CRC: 0x07 = x8 + x2 + x + 1
     *
     * @param bytes byte array to compute CRC on This is an implementation of the
     * CRC-16 algorithm described in ISO/IEC standard ISO 3309.
     * @return 16-bit CRC, unsigned
     * 
     */
    public int crc16_ker(byte[] bytes) {
        //http://iris.dot.state.mn.us/hg/index.cgi/iris/file/c7c01ab8b2b6/src/us/mn/state/dot/tms/server/comm/ntcip/CRC16.java
        final int[] TABLE = {
            0x0000, 0x1189, 0x2312, 0x329b, 0x4624, 0x57ad, 0x6536, 0x74bf,
            0x8c48, 0x9dc1, 0xaf5a, 0xbed3, 0xca6c, 0xdbe5, 0xe97e, 0xf8f7,
            0x1081, 0x0108, 0x3393, 0x221a, 0x56a5, 0x472c, 0x75b7, 0x643e,
            0x9cc9, 0x8d40, 0xbfdb, 0xae52, 0xdaed, 0xcb64, 0xf9ff, 0xe876,
            0x2102, 0x308b, 0x0210, 0x1399, 0x6726, 0x76af, 0x4434, 0x55bd,
            0xad4a, 0xbcc3, 0x8e58, 0x9fd1, 0xeb6e, 0xfae7, 0xc87c, 0xd9f5,
            0x3183, 0x200a, 0x1291, 0x0318, 0x77a7, 0x662e, 0x54b5, 0x453c,
            0xbdcb, 0xac42, 0x9ed9, 0x8f50, 0xfbef, 0xea66, 0xd8fd, 0xc974,
            0x4204, 0x538d, 0x6116, 0x709f, 0x0420, 0x15a9, 0x2732, 0x36bb,
            0xce4c, 0xdfc5, 0xed5e, 0xfcd7, 0x8868, 0x99e1, 0xab7a, 0xbaf3,
            0x5285, 0x430c, 0x7197, 0x601e, 0x14a1, 0x0528, 0x37b3, 0x263a,
            0xdecd, 0xcf44, 0xfddf, 0xec56, 0x98e9, 0x8960, 0xbbfb, 0xaa72,
            0x6306, 0x728f, 0x4014, 0x519d, 0x2522, 0x34ab, 0x0630, 0x17b9,
            0xef4e, 0xfec7, 0xcc5c, 0xddd5, 0xa96a, 0xb8e3, 0x8a78, 0x9bf1,
            0x7387, 0x620e, 0x5095, 0x411c, 0x35a3, 0x242a, 0x16b1, 0x0738,
            0xffcf, 0xee46, 0xdcdd, 0xcd54, 0xb9eb, 0xa862, 0x9af9, 0x8b70,
            0x8408, 0x9581, 0xa71a, 0xb693, 0xc22c, 0xd3a5, 0xe13e, 0xf0b7,
            0x0840, 0x19c9, 0x2b52, 0x3adb, 0x4e64, 0x5fed, 0x6d76, 0x7cff,
            0x9489, 0x8500, 0xb79b, 0xa612, 0xd2ad, 0xc324, 0xf1bf, 0xe036,
            0x18c1, 0x0948, 0x3bd3, 0x2a5a, 0x5ee5, 0x4f6c, 0x7df7, 0x6c7e,
            0xa50a, 0xb483, 0x8618, 0x9791, 0xe32e, 0xf2a7, 0xc03c, 0xd1b5,
            0x2942, 0x38cb, 0x0a50, 0x1bd9, 0x6f66, 0x7eef, 0x4c74, 0x5dfd,
            0xb58b, 0xa402, 0x9699, 0x8710, 0xf3af, 0xe226, 0xd0bd, 0xc134,
            0x39c3, 0x284a, 0x1ad1, 0x0b58, 0x7fe7, 0x6e6e, 0x5cf5, 0x4d7c,
            0xc60c, 0xd785, 0xe51e, 0xf497, 0x8028, 0x91a1, 0xa33a, 0xb2b3,
            0x4a44, 0x5bcd, 0x6956, 0x78df, 0x0c60, 0x1de9, 0x2f72, 0x3efb,
            0xd68d, 0xc704, 0xf59f, 0xe416, 0x90a9, 0x8120, 0xb3bb, 0xa232,
            0x5ac5, 0x4b4c, 0x79d7, 0x685e, 0x1ce1, 0x0d68, 0x3ff3, 0x2e7a,
            0xe70e, 0xf687, 0xc41c, 0xd595, 0xa12a, 0xb0a3, 0x8238, 0x93b1,
            0x6b46, 0x7acf, 0x4854, 0x59dd, 0x2d62, 0x3ceb, 0x0e70, 0x1ff9,
            0xf78f, 0xe606, 0xd49d, 0xc514, 0xb1ab, 0xa022, 0x92b9, 0x8330,
            0x7bc7, 0x6a4e, 0x58d5, 0x495c, 0x3de3, 0x2c6a, 0x1ef1, 0x0f78
        };
        int crc = 0x0000;
        for (byte b : bytes) {
            crc = (crc >> 8) ^ TABLE[(b ^ crc) & 0xff];
        }
        int b1 = crc & 0x0000ff00;
        int b2 = crc & 0x000000ff;
        return b1 / 256 + (256 * b2);

    }

    private byte[] txt2bytes(String byttxt) {
        String txt = byttxt;
        byte[] val;
        if (getmode().compareTo("Char") == 0) {
            javax.swing.DefaultComboBoxModel<java.nio.charset.Charset> cbm = options.getValuefor("hex_chars", new javax.swing.DefaultComboBoxModel<java.nio.charset.Charset>());
            javax.swing.DefaultComboBoxModel<String> cbn = options.getValuefor("hex_type", new javax.swing.DefaultComboBoxModel<String>());
            val = txt.getBytes((java.nio.charset.Charset) cbm.getSelectedItem());
            if (cbn != null && cbn.getSelectedItem().toString().compareTo("[TABLE]") != 0) {
                try {
                    com.jdcm.common.C_Format f = new com.jdcm.common.C_Format();
                    f.setvalue(txt);
                    val = f.B_Prend(cbn.getSelectedItem().toString());
                } catch (Exception ex) {
                }
            }
        } else if (getmode().compareTo("Hexa") == 0) {
            val = string2byte(txt);
        } else {
            java.util.List<Byte> buf = new java.util.ArrayList<>();
            String rad = getradical(getmode());
            txt = txt.trim();
            if (rad.startsWith(" ")) {
                txt = " " + txt;
            }
            while (txt.length() > 0) {
                int posnxt = txt.indexOf(rad, rad.length() + 1);
                String value = txt.substring(rad.length(), posnxt).trim();
                //value is without redical.
                if (value != null && value.length() > 0) {
                    try {
                        buf.add(mod.getbyte(value, getmode()));
                    } catch (Exception ex) {
                        return new byte[0];
                    }
                    txt = txt.substring(posnxt);
                } else {
                    return new byte[0];
                }
            }
            val = new byte[buf.size()];
            //val=buf.toArray(new Byte[0]);
            for (int i = 0; i < buf.size(); i++) {
                val[i] = buf.get(i);
            }
        }
        return val;
    }

    private String insertText(String txt) {
        if (txt == null || txt.length() == 0) {
            return "";
        }
        int inspos = MAX;
        if (inspos < 0) {
            inspos = mod.getbuffer().length;
        }
        if (mod != null) {
            byte[] buff = txt2bytes(txt);
            if (buff == null || buff.length == 0) {
                return txt;
            }
            mod.insertBuffer(buff, inspos);
            ajustsize();
            return "";
        }
        return txt;
    }

    /**
     * Provide a byte[] form a String<br> Ex "30 31 32"=>{0x30,0x31,0x32}<br> Ex
     * "x30 x31 \r\n x32"=> idem
     * @param initHXstr then String to get as bytes buffe
     * @return the buffer
     */
    public byte[] string2byte(String initHXstr) {
        String HXstr = initHXstr;
        // transfomr 01 02 d1 d2 to byte array or
        java.util.List<Byte> c = new java.util.ArrayList<>();
        if (HXstr == null) {
            return null;
        }
        HXstr = HXstr.toLowerCase().replaceAll("\r\n", " ");
        HXstr = HXstr.toLowerCase().replaceAll(":", " ");
        HXstr = HXstr.toLowerCase().replaceAll(",", " ");
        HXstr = HXstr.toLowerCase().replaceAll("\n", " ");
        HXstr = HXstr.replaceAll("\\..", " ");
        HXstr = HXstr.trim();
        HXstr = HXstr.replaceAll("0x", " ");// added on 01/2008
        //HXstr = HXstr.replaceAll("0x", " ");
        //traces axis
        if (HXstr.startsWith("x")) {
            HXstr = HXstr.replaceAll("x", " ");
        }
        String temp = HXstr;
        HXstr += " ";
        while (HXstr.length() > temp.length()) {
            HXstr = temp;
            temp = HXstr.replaceAll("  ", " ");
        }
        HXstr = HXstr.trim();
        if (HXstr.length() == 0) {
            return new byte[0];
        }

        if (HXstr.length() < 2) {
            //"Hex data is least 2 caracteres Ex: 0a";
            return new byte[0];
        }
        for (int i = 0; i < HXstr.length(); i += 3) {
            if (i < HXstr.length() - 1) {
                String text2 = "0x" + HXstr.substring(i, i + 2);
                try {
                    int ity = Integer.decode(text2);
                    c.add((byte) ity);
                } catch (NumberFormatException e) {
                    // System.err.println("Hex data '" + HXstr + "' can't tranlated to Hexa Ex:(as 0a 01 ff)");
                    return null;
                }
            }
        }
        byte[] d = new byte[c.size()];
        for (int i = 0; i < c.size(); i++) {
            d[i] = c.get(i);
        }
        return d;
    }

    private int lrc(byte[] buff) {
        if (buff == null) {
            return -1;
        } else {
            int lrc = 0;//127;
            for (byte oct : buff) {
                lrc ^= oct;
            }
            return lrc;
        }
    }

    private int sumff(byte[] buff) {
        int sum = 0; //0x7f;
        for (byte oct : buff) {
            sum += oct;
        }
        return sum % 0xff;
    }

    private int difff(byte[] buff) {
        int sum = 0;//0x7f;
        for (byte oct : buff) {
            sum -= oct;
        }
        return sum % 0xff;
    }

    /**
     * Calc 16-bit CRC with CCITT method.
     *
     * @param bytes byte array to compute CRC on
     *
     * @return 16-bit CRC, unsigned
     */
    public int crc16ffff(byte[] bytes) {
        /*
         * 0x8408 used in European X.25
         */
        int crc = 0xFFFF;          // initial value
        int polynomial = 0x1021;   // 0001 0000 0010 0001  (0, 5, 12)

        // byte[] testBytes = "123456789".getBytes("ASCII");
        for (byte b : bytes) {
            for (int i = 0; i < 8; i++) {
                boolean bit = ((b >> (7 - i) & 1) == 1);
                boolean c15 = ((crc >> 15 & 1) == 1);
                crc <<= 1;
                if (c15 ^ bit) {
                    crc ^= polynomial;
                }
            }
        }
        return crc;
        //      return crc &= 0xffff;

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenu1 = new javax.swing.JMenu();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jTextField1 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();

        jMenu1.setText("Encode");
        jPopupMenu1.add(jMenu1);

        jMenu2.setText("Decode");
        jPopupMenu1.add(jMenu2);

        jMenuItem1.setText("Copy");
        jMenuItem1.setToolTipText("Copy");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        setLayout(new java.awt.BorderLayout());

        jScrollPane1.setInheritsPopupMenu(true);

        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.setComponentPopupMenu(jPopupMenu1);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable1MouseReleased(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTable1MousePressed(evt);
            }
        });
        jTable1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                jTable1MouseDragged(evt);
            }
        });
        jTable1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTable1KeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        jComboBox1.setToolTipText("display format");
        jComboBox1.setInheritsPopupMenu(true);
        jComboBox1.setMinimumSize(new java.awt.Dimension(60, 20));
        jComboBox1.setPreferredSize(new java.awt.Dimension(60, 20));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jPanel2.add(jComboBox1);

        jTextField1.setToolTipText("pick text");
        jTextField1.setInheritsPopupMenu(true);
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jPanel2.add(jTextField1);

        jLabel4.setText("x");
        jLabel4.setToolTipText("Delete selected bytes");
        jLabel4.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel4.setMaximumSize(new java.awt.Dimension(16, 18));
        jLabel4.setMinimumSize(new java.awt.Dimension(13, 18));
        jLabel4.setPreferredSize(new java.awt.Dimension(13, 18));
        jLabel4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jLabel4MouseReleased(evt);
            }
        });
        jPanel2.add(jLabel4);

        jLabel3.setText(">");
        jLabel3.setToolTipText("add text after selection / at end");
        jLabel3.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel3.setMaximumSize(new java.awt.Dimension(16, 18));
        jLabel3.setMinimumSize(new java.awt.Dimension(13, 18));
        jLabel3.setName(""); // NOI18N
        jLabel3.setPreferredSize(new java.awt.Dimension(13, 18));
        jLabel3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jLabel3MouseReleased(evt);
            }
        });
        jPanel2.add(jLabel3);

        jLabel5.setText("<");
        jLabel5.setToolTipText("pick selected bytes");
        jLabel5.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabel5.setMaximumSize(new java.awt.Dimension(16, 18));
        jLabel5.setMinimumSize(new java.awt.Dimension(13, 18));
        jLabel5.setPreferredSize(new java.awt.Dimension(13, 18));
        jLabel5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jLabel5MouseReleased(evt);
            }
        });
        jPanel2.add(jLabel5);

        jCB_ObjectEditor1.setAsButton(true);
        jCB_ObjectEditor1.setEditable(true);
        jPanel2.add(jCB_ObjectEditor1);

        add(jPanel2, java.awt.BorderLayout.PAGE_START);
    }// </editor-fold>//GEN-END:initComponents
    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        if (jComboBox1.getSelectedItem().toString().compareTo(("Char")) == 0) {
            sethex_chars(java.nio.charset.Charset.defaultCharset());
        }
        setmode(getmode());
        ajustsize();
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jTable1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseReleased
        //!! not ready
        if (evt.isControlDown() == false && selection.isEmpty() == false) {
            selection.clear();
        }

        for (int pos = MIN; pos <= MAX; pos++) {
            if (selection.contains(pos) == false) {
                if (selection.isEmpty()) {
                    selection.add(pos);
                } else {
                    if (pos > selection.get(selection.size() - 1)) {
                        selection.add(pos);
                    } else if (pos < selection.get(0)) {
                        selection.add(0, pos);
                    } else {
                        boolean placed = false;
                        for (int i = 0; i < selection.size() - 1 && placed == false; i++) {
                            if (pos > selection.get(i)
                                    && pos < selection.get(i + 1)) {
                                selection.add(i + 1, pos);
                                placed = true;
                            }
                        }

                    }
                }
            }
        }
        for (selectionEventListner e : getSelectionEventListner()) {
            e.selectedPerformed(evt);
        }
        jTable1.repaint();
        displaySelected();
        selecting = -1;
    }//GEN-LAST:event_jTable1MouseReleased
    private void jTable1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MousePressed
        if (evt.getButton() == 1) {
            int row = jTable1.rowAtPoint(evt.getPoint());
            int column = jTable1.columnAtPoint(evt.getPoint());
            int pos = getBuffPosition(row, column);
            if (column == 0) {
                MIN = pos + 1;
                MAX = 15 + row * 16;
            } else if (pos >= 0) {
                MIN = pos;
                MAX = pos;

            } else if (pos < 0) {
                MIN = -1;
                MAX = -1;
            }
            selecting = MIN;
        }
    }//GEN-LAST:event_jTable1MousePressed

    private void jTable1MouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseDragged
/// Button is 0 when dragging
        int row = jTable1.rowAtPoint(evt.getPoint());
        int column = jTable1.columnAtPoint(evt.getPoint());
        int curent = getBuffPosition(row, column);
        if (selecting < 0) {
            if (curent < 0) {
                MIN = -1;
                MAX = -1;
                jTable1.repaint();
                displaySelected();
            }
            return;
        }
        if (curent < 0) {
            return;
        }
        if (column == 0) {
            MAX = 15 + row * 16;
        } else {
            if (curent <= selecting) {
                MIN = curent;
                if (selecting < MAX) {
                    MAX = selecting;
                }
            } else {
                MAX = curent;
                if (selecting > MIN) {
                    MIN = selecting;
                }
            }
        }
        jTable1.repaint();

    }//GEN-LAST:event_jTable1MouseDragged

    private void jLabel3MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel3MouseReleased
        setEdit(insertText(jTextField1.getText()));
        jLabel3.setEnabled(jTextField1.getText().length() > 0);
    }//GEN-LAST:event_jLabel3MouseReleased

    private void jLabel4MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel4MouseReleased
        if (MIN < 0 || MAX < 0) {
            return;
        }
        if (mod != null) {
            mod.removeBuffer(MIN, MAX - MIN + 1);
            selection.clear();
            selection.add(MIN);
            MAX = MIN;
        }
        ajustsize();
    }//GEN-LAST:event_jLabel4MouseReleased

    private void jLabel5MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel5MouseReleased
        setEdit(getSelectedFormated());
    }//GEN-LAST:event_jLabel5MouseReleased
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*  byte[] buff=new byte[]{4};

         for ( int i=0;i<0xff;i++){
 
         int lrc = i;
         for (byte oct : buff) {
         lrc ^= oct;
         }
         System.out.println("=>"+i+":"+ Integer.toHexString(lrc & 0xff));
         }*/
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                javax.swing.JFrame f = new javax.swing.JFrame("Banques");
                f.getContentPane().setLayout(new java.awt.BorderLayout());
                // f.setPreferredSize(new java.awt.Dimension(100,200));
                P_HexaEditor p = new P_HexaEditor(("Si tu peux voir détruit l ouvrage de ta vie Et sans dire un seul mot te mettre à rebâtir,"
                        + "Ou, perdre d'un seul coup le gain de cent parties Sans un geste et sans un soupir ;"
                        + "Si tu peux être amant sans être fou d'amour, Si tu peux être fort sans cesser d'être tendre"
                        + "Et, te sentant haï sans haïr à ton tour,Pourtant lutter et te défendre ;"
                        + "Si tu peux supporter d'entendre tes parolesTravesties par des gueux pour exciter des sots,"
                        + "Et d'entendre mentir sur toi leur bouche folle,Sans mentir toi-même d un seul mot "
                        + "Si tu peux rester digne en étant populaire,Si tu peux rester peuple en conseillant les rois"
                        + "Et si tu peux aimer tous tes amis en frèreSans qu'aucun d'eux soit tout pour toi ;"
                        + "Si tu sais méditer, observer et connaître Sans jamais devenir sceptique ou destructeur ;"
                        + "Rêver, mais sans laisser ton rêve être ton maître,Penser sans n'être qu'un penseur ;"
                        + "Si tu peux être dur sans jamais être en rage,Si tu peux être brave et jamais imprudent,"
                        + "Si tu sais être bon, si tu sais être sage Sans être moral ni pédant ;"
                        + "Si tu peux rencontrer Triomphe après Défaite Et recevoir ces deux menteurs d un même front,"
                        + "Si tu peux conserver ton courage et ta têteQuand tous les autres les perdront,"
                        + "Alors, les Rois, les Dieux, la Chance et la Victoire Seront à tout jamais tes esclaves soumis"
                        + "Et, ce qui vaut mieux que les Rois et la Gloire, Tu seras un Homme, mon fils. ").getBytes());
                p.addColorRange(16, 43, Color.red);
                f.getContentPane().add(p, java.awt.BorderLayout.CENTER);
                f.pack();
                f.setVisible(true);
                f.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
                f.setIconImage(p.getIcon());
            }
        });

    }

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        jLabel3MouseReleased(null);
        jLabel3.setEnabled(jTextField1.getText().length() > 0);
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        //COPY
        //jTable1.set
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jTable1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTable1KeyPressed
        if (evt.isControlDown() && evt.getKeyCode() == java.awt.event.KeyEvent.VK_A) {
            this.setSelectedPos(0, mod.getbuffer().length);
        } else if (evt.isControlDown() == false && evt.getKeyCode() == java.awt.event.KeyEvent.VK_DELETE) {
            jLabel4MouseReleased(null);
        }
    }//GEN-LAST:event_jTable1KeyPressed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables

    /**
     * Used for Code model ti move row & tree with Hexa editor selected byte
     */
    public static class selectionEventListner {

        public selectionEventListner() {
        }

        public void selectedPerformed(java.awt.event.MouseEvent evt) {
        }
    }

    /**
     * Render that use P_HexaEditor specific selection mode & resize
     *
     */
    class ObjHexRenderer extends DefaultTableCellRenderer {

        // for serializable interface
        private static final long serialVersionUID = 1L;
        private final P_HexaEditor Parent;

        public ObjHexRenderer(P_HexaEditor p) {
            Parent = p;
        }

        @Override
        public Component getTableCellRendererComponent(
                javax.swing.JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
            javax.swing.JLabel box = new javax.swing.JLabel();
            box.setOpaque(true);
            if (value != null) {
                box.setText(value.toString());
            }
            box.setAlignmentX(javax.swing.JLabel.CENTER_ALIGNMENT);
            Component Compnt = box;
            int position = Parent.getBuffPosition(row, col);
            if (col == 0) {
                box.setOpaque(true);
                box.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 0, 0, java.awt.Color.white));
            } else {
                if (position < 0) {
                    if (position == -2) {
                        Compnt.setBackground(table.getGridColor());
                    }
                    if (position == -1) {
                        Compnt.setBackground(java.awt.Color.YELLOW);
                        if (Parent.isSelectedPos(position) || Parent.isSelectingPos(position)) {
                            Compnt.setBackground(java.awt.Color.YELLOW.darker());
                        }
                    }
                } else {
                    if (Parent.isSelectingPos(position)) {
                        java.awt.Color c = table.getSelectionBackground();
                        Compnt.setBackground(new java.awt.Color(c.getBlue(), c.getGreen(), c.getRed(), 200));
                    } else if (isSelectedPos(position)) {
                        Compnt.setBackground(table.getSelectionBackground());
                    } else {
                        box.setBackground(Parent.getCellColor(position));
                        // Compnt.setBackground(table.getBackground());
                    }
                }
            }
            if (Compnt.getPreferredSize().width > table.getColumn(table.getColumnName(col)).getWidth()) {
                table.getColumn(table.getColumnName(col)).setPreferredWidth(Compnt.getPreferredSize().width + 3);
            }
            return Compnt;
        }
    }
}

/**
 * Specific Model for buffer display
 *
 */
class Hex_Model extends javax.swing.table.AbstractTableModel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final String[] columnNames = {"Row", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"};
    private final String[] c0 = {"NUL", "SOH", "STX", "ETX", "EOT", "ENQ", "ACK", "BEL", "BS", "HT", "LF", "VT", "FF", "CR", "SO", "SI", "DLE", "C1", "C2", "C3", "C4", "NAK", "SYN", "ETB", "CAN", "EN", "SUB", "ESC", "FS", "GS", "RS", "US"};
    private final String[] c1 = {"DEL", "PAD", "HOP", "BPH", "NBH", "IND", "NEL", "SSA", "ESA", "HTS", "HTJ", "VTS", "PLD", "PLU", "RI", "SS2", "SS3", "DCS", "PU1", "PU2", "STS", "CCH", "MW", "SPA", "EPA", "SOS", "SGCI", "SCI", "CSI", "ST", "OSC", "PM", "APC"};
    private byte[] Buff;
    private String mode = "Hexa";
    private boolean locked = false;
    private java.nio.charset.Charset charset = null;

    public Hex_Model(byte[] buff) {
        Buff = buff;
    }

    public void setloked(boolean bool) {
        locked = bool;
    }

    public void setcharSet(java.nio.charset.Charset chs) {
        charset = chs;
        this.fireTableDataChanged();
    }

    public String getcomment() {
        String txt = "no comment";
        if (mode.compareTo("Char") == 0) {
            txt = "texte with charSet Selection";
        }
        if (mode.compareTo("Base64") == 0) {
            txt = "Used in Mail (MIME) and certificats (PEM) RFC3548";
        }
        if (mode.compareTo("quotedprint") == 0) {
            txt = "Used in Mail (MIME)0x80=>'=80'";
        }
        if (mode.compareTo("c0c1") == 0) {
            txt = "Used to provide control codes Ascii & ISO 8859";
        }
        if (mode.compareTo("binary") == 0) {
            txt = "Used by computer as information base";
        }
        if (mode.compareTo("Octal") == 0) {
            txt = "Base 8 not so used?";
        }
        if (mode.compareTo("EBCDIC") == 0) {
            txt = "Extended Binary Coded Decimal (IBM1047) Interchange Code";
        }
        if (mode.compareTo("Hexa") == 0) {
            txt = "Base 16 well used for computing";
        }
        if (mode.compareTo("Decimal") == 0) {
            txt = "Base 10 currently used";
        }
        return txt;
    }

    public byte[] getbuffer() {
        return Buff;
    }

    public void setbuffer(byte[] buf) {
        Buff = buf;
        this.fireTableDataChanged();
    }

    public void setmode(String txt) {
        mode = txt;
        this.fireTableDataChanged();
    }

    /**
     * remove a part of the buffer
     *
     * @param Start the first byte to remove
     * @param len the length to remove after Start
     */
    public void removeBuffer(int Start, int len) {
        // CARE with Modifiers
        if (Start < 0 || len < 0 || len > Buff.length) {
            return;
        }
        if (Start > Buff.length) {
            return;
        }
        byte[] res = new byte[Buff.length - len];
        System.arraycopy(Buff, 0, res, 0, Start);
        for (int i = Start + len; i < Buff.length; i++) {
            res[i - len] = Buff[i];
        }
        Buff = res;
        fireTableDataChanged();
    }

    /**
     * Insert a byte[] in the buffer
     *
     * @param buf the byte[] to insert
     * @param pos the pos after wich the byte[] is inserted
     */
    public void insertBuffer(byte[] buf, int initpos) {
        int pos = initpos;
        if (pos < 0) {
            pos = 0;
        }
        if (pos > Buff.length) {
            return;
        }
        byte[] res = new byte[Buff.length + buf.length];
        System.arraycopy(Buff, 0, res, 0, pos);
        System.arraycopy(buf, 0, res, pos, buf.length);
        System.arraycopy(Buff, pos, res, pos + buf.length, Buff.length - pos);
        /*   for (int i = pos; i < pos + buf.length; i++) {
         res[i] = buf[i - pos];
         }
         System.arraycopy(Buff, pos, res, pos + buf.length, Buff.length - pos);*/
        Buff = res;
        fireTableDataChanged();
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;

    }

    @Override
    public int getRowCount() {
        if (Buff == null) {
            return 0;
        }
        int res = 1 + Buff.length / 16;
        // add a ligne to the last byte of the row
        if (Buff.length == res * 16) {
            res += 1;
        }
        return res;
    }

    public Object getValueAt(int position) {
        if (position < 0) {
            return null;
        }
        int row = position / 16;
        int col = 1 + position % 16;
        return getValueAt(row, col);
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        if (aColumn == 0) {
            // Num de ligne en dec
            String res = Integer.toHexString(aRow);
            for (int i = res.length(); i < 7; i++) {
                res = "0" + res;
            }
            return res + "0";
        }
        int cellidx = 16 * (aRow) + aColumn - 1;
        if (cellidx >= Buff.length) {
            return "";
        }
        if (mode.compareTo("Hexa") == 0) {
            String val = Integer.toHexString(Buff[16 * (aRow) + aColumn - 1]);
            if (val == null) {
                return "!!";
            }
            if (val.length() == 0) {
                return "!!";
            }
            if (val.length() == 1) {
                val = "0" + val;
            }
            return val.substring(val.length() - 2);
        } else if (mode.compareTo("Dec128") == 0) {
            return "" + Buff[cellidx];
        }

        int nb = Buff[cellidx];
        if (nb < 0) {
            nb = 256 + nb;
        }
        if (mode.compareTo("Octal") == 0) {
            String txt = Integer.toOctalString(nb);
            while (txt.length() < 3) {
                txt = "0" + txt;
            }
            return txt;
        } else if (mode.compareTo("Decimal") == 0) {
            String txt = "" + nb;
            while (txt.length() < 3) {
                txt = "0" + txt;
            }
            return txt;
        } else if (mode.compareTo("Binary") == 0) {
            String bin = Integer.toBinaryString(nb);
            if (bin.length() < 8) {
                for (int i = bin.length(); i < 8; i++) {
                    bin = "0" + bin;
                }
            }
            return bin;
        } else if (mode.compareTo("Char") == 0) {
            byte[] a = new byte[1];
            a[0] = Buff[16 * (aRow) + aColumn - 1];
            return new java.lang.String(a, charset);
        } else if (mode.compareTo("c0c1") == 0) {
            return getC0C1(nb);
        }
        return "";
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        if (locked) {
            return false;
        }
        if (column > 0) {
            // editable if before end of buffer+1
            int res = -(row + 1) + column + 17 * row;
            return res <= Buff.length;

        } else {
            return false;
        }
    }

    public byte getbyte(String val, String mod) throws Exception {
        //base64 managed setValueAt()
        int nb = -1;
        byte res;
        try {
            if (mod.compareTo("Hexa") == 0) {
                nb = Integer.parseInt("" + val, 16);
            } else if (mod.compareTo("Octal") == 0) {
                nb = Integer.parseInt("" + val, 8);
            } else if (mod.compareTo("Decimal") == 0) {
                nb = Integer.parseInt("" + val, 10);
            } else if (mod.compareTo("Dec128") == 0) {
                nb = Integer.parseInt("" + val, 10);
            } else if (mod.compareTo("Binary") == 0) {
                nb = Integer.parseInt("" + val, 2);
            } else if (mod.compareTo("Char") == 0) {
                nb = val.getBytes(charset)[0];
            } else if (mod.compareTo("c0c1") == 0) {
                nb = getC0C1(("" + val).toUpperCase());
            }
            if (nb >= 128) {
                res = (byte) (nb - 256);
            } else {
                res = (byte) nb;
            }
        } catch (NumberFormatException ex) {
            throw new Exception("Impossible " + val + " as " + mod);
        }
        return res;
    }

    @Override
    public void setValueAt(Object value, int row, int column) {
        int cellidx = 16 * row + column - 1;
        if (cellidx > Buff.length) {
            return;
        }
        if (cellidx == Buff.length) {
            // add an "empty" byte to the Array
            byte[] b = new byte[Buff.length + 1];
            System.arraycopy(Buff, 0, b, 0, Buff.length);
            b[Buff.length] = (byte) 0;
            Buff = b;
        }
        if (cellidx == Buff.length - 1 && value.toString().length() == 0) {
            // remove a byte to the Array
            byte[] b = new byte[Buff.length - 1];
            System.arraycopy(Buff, 0, b, 0, Buff.length - 1);
            Buff = b;
        }
        if (value.toString().length() == 0) {
            return;
        }

        /*
         * if (mode==0){ int i=-1; try{i=Integer.parseInt(""+value,
         * 16);}catch(NumberFormatException ex){} if(i<0||i>255){return;} if
         * (i>128){i=i-256;} Buff[16*row+column-1]=(byte)i; }
         */
        try {
            Buff[16 * row + column - 1] = getbyte(value.toString(), mode);

        } catch (Exception ex) {
        }
        fireTableCellUpdated(row, this.getColumnCount() - 1);
        //if (column==15){this.fireTableDataChanged();}
    }

    private String getC0C1(int nb) {
        if (nb < 32) {
            return c0[nb];
        }
        if (nb > 126 && nb < 160) {
            return c1[nb - 127];
        }
        return Integer.toHexString(nb);
    }

    private int getC0C1(String c0c1) {
        int res = 1000;
        for (int i = 0; i < c0.length; i++) {
            if (c0[i].compareTo(c0c1) == 0) {
                res = i;
            }
        }
        for (int j = 0; j < c1.length; j++) {
            if (c1[j].compareTo(c0c1) == 0) {
                res = j + 127;
            }
        }
        if (res == 1000) {
            res = Integer.parseInt("" + c0c1, 16);
        }
        return res;
    }
}
