package com.jdcm.editors;

import java.util.List;
import javax.swing.event.TableModelEvent;

/**
 * 
 *Used to Edit/display Lists OR Arrays
 * 
 * @author  Marc GIBOIN
 */
public class P_ListEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private java.util.List<Object> col = null;
    private Object arr = null;
    private List<Object> aslist = null;
    private boolean editing = true;
    private ACE_ObjEditor<Object> editor = null;
    private ACE_ObjRenderer<Object> render = null;

    /**
     *create a panel <br>
     * is used by JCB_ObjectEditor<br>
     * 
     */
    public P_ListEditor() {
        initComponents();
        
        render = new ACE_ObjRenderer<>();
    }
 /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("JList.gif");
        }catch(Exception ex){
            return null;
        }
    }
    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        editing = bool;
        jTable1.setEnabled(bool);
    }
/**
 * Manage the changes of the text if editied directly
 * @param txt the TextComponent modified to treate
 */
    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }
    /**
     * return the basic label to be displayed as editor
     * @param txt the initial Text
     * @return the label to be displayed for this editor
     */
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        if (col != null) {
            txt.setText(col.toString());
        } else if (arr != null) {
            txt.setText(arr.getClass().toString());
        }
        return txt;
    }

    @Override
    public Object getValue() {
        List<Object> tblaslist = new java.util.ArrayList<>();
        for (int i = 0; i < jTable1.getRowCount(); i++) {
            tblaslist.add(jTable1.getValueAt(i, 1));
        }
        if (col != null) {
            col = tblaslist;
            return col;
        } else if (arr != null) {
            return tblaslist.toArray();
        } else {
            return null;
        }
    }

    @Override
    public void setValue(Object val) {
        String[] titles = new String[]{"idx", "Values"};
        if (val == null) {
            return;
        } else if (val instanceof List<?>) {
            col = (List<Object>) val;
            aslist = col;
            jButton1.setVisible(isEditing());
            jButton2.setVisible(isEditing());
        } else if (val.getClass().isArray()) {
            // Class<?> cl=val.getClass().getComponentType();
            int size = java.lang.reflect.Array.getLength(val);
            //   arr=java.lang.reflect.Array.newInstance(cl, size);
            arr = val;
            aslist = new java.util.ArrayList<>();
            for (int i = 0; i < size; i++) {
                aslist.add(java.lang.reflect.Array.get(val, i));
                jButton1.setVisible(false);
                jButton2.setVisible(false);
            }
        } else {
            aslist = null;
            col = null;
            arr = null;
            return;

        }
        Object[][] tblval = new Object[aslist.size()][2];
        for (int i = 0; i < aslist.size(); i++) {
            tblval[i][0] = i;
            tblval[i][1] = aslist.get(i);
        }
        javax.swing.table.DefaultTableModel t = new javax.swing.table.DefaultTableModel(tblval, titles);
        jTable1.setModel(t);
        jTable1.getModel().addTableModelListener(new javax.swing.event.TableModelListener() {

            @Override
            public void tableChanged(TableModelEvent e) {
                setValue(getValue());
            }
        });
        //jTable1.getModel().
        if (isEditing()) {
            if (jTable1.getRowCount()==1 && "new Item".equals(jTable1.getValueAt(0, 1))){
                editor=new ACE_ObjEditor<>(true,true);
            }else{
                editor = new ACE_ObjEditor<>(true);
            }
            jTable1.getColumnModel().getColumn(1).setCellEditor(editor);
        }
        jTable1.getColumnModel().getColumn(1).setCellRenderer(render);
        jTable1.getColumnModel().getColumn(0).setPreferredWidth(10);
        jTable1.getColumnModel().getColumn(0).setWidth(10);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setPreferredSize(new java.awt.Dimension(127, 166));
        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jButton1.setText("+");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        jButton2.setText("-");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2);

        add(jPanel1, java.awt.BorderLayout.NORTH);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        if (col == null) {
            return; // don't manage arrays
        }
        int idx = jTable1.getSelectedRow();
        if (idx == -1) {
            return;
        }
        if (col.isEmpty() == false) {
            col.remove(idx);
        }
        setValue(col);

    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (col == null) {
            return; // don't manage arrays
        }
        int idx = jTable1.getSelectedRow();
        Object ob;
        if (idx == -1) {
            if (col.isEmpty() == false) {
                ob = col.get(col.size() - 1);// at the end
                idx = col.size() - 1;
            }else{
               ob="new Item";
               idx=0;
            }
        } else {
            ob = col.get(idx);
        }
        if (ob != null) {
            col.add(idx, ob);
        }
        setValue(col);

    }//GEN-LAST:event_jButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
