package com.jdcm.editors;

/**
 *  P_Methode.java Created on 1 sept. 2011, 10:52:18
 * 
 * Used to Display a java reflect Method .. (on ..Work)
 *
 * @author Marc GIBOIN
 */
public class P_MethodEditor extends P_ReflectEditor implements I_CBObjectEditor {

    private static final long serialVersionUID = 1L;
    //  java.lang.reflect.Method meth = null;
    boolean editing = false;
    private ACE_ObjRenderer<Class<?>> render = new ACE_ObjRenderer<>();

    /** Creates new form P_Methode */
    public P_MethodEditor() {
        initComponents();
        jList1.setModel(new javax.swing.AbstractListModel<Class<?>>() {

            private static final long serialVersionUID = 1L;
            Class[] clas = {java.lang.String.class};

            @Override
            public int getSize() {
                return clas.length;
            }

            @Override
            public Class<?> getElementAt(int i) {
                return clas[i];
            }
        });
        jList2.setModel(new javax.swing.AbstractListModel<Class<?>>() {

            private static final long serialVersionUID = 1L;
            Class[] clas = {java.lang.Exception.class};

            @Override
            public int getSize() {
                return clas.length;
            }

            @Override
            public Class<?> getElementAt(int i) {
                return clas[i];
            }
        });
    }

    public P_MethodEditor(Object val) {
        initComponents();
        setValue(val);
    }
 /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("Method.gif");
        }catch(Exception ex){
            return null;
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jToggleButton3 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton4 = new javax.swing.JToggleButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList<>();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList2 = new javax.swing.JList<>();

        setLayout(new java.awt.GridLayout(4, 0));

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel1.setText("- name -");
        jLabel1.setMaximumSize(new java.awt.Dimension(500, 14));
        jPanel1.add(jLabel1);

        jToggleButton3.setSelected(true);
        jToggleButton3.setText("V");
        jToggleButton3.setToolTipText("isVarArg");
        jToggleButton3.setAlignmentY(0.0F);
        jToggleButton3.setEnabled(false);
        jToggleButton3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jToggleButton3);

        jToggleButton2.setSelected(true);
        jToggleButton2.setText("S");
        jToggleButton2.setToolTipText("isSynthetic");
        jToggleButton2.setAlignmentY(0.0F);
        jToggleButton2.setEnabled(false);
        jToggleButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jToggleButton2);

        jToggleButton1.setSelected(true);
        jToggleButton1.setText("B");
        jToggleButton1.setToolTipText("isBridge");
        jToggleButton1.setAlignmentY(0.0F);
        jToggleButton1.setEnabled(false);
        jToggleButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jToggleButton1);

        jToggleButton4.setSelected(true);
        jToggleButton4.setText("A");
        jToggleButton4.setToolTipText("isAccessible");
        jToggleButton4.setAlignmentY(0.0F);
        jToggleButton4.setEnabled(false);
        jToggleButton4.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jToggleButton4);

        add(jPanel1);

        jList1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 255), 2));
        jScrollPane2.setViewportView(jList1);

        add(jScrollPane2);

        jCB_ObjectEditor1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(204, 0, 0), 2));
        jCB_ObjectEditor1.setEditable(true);
        add(jCB_ObjectEditor1);

        jScrollPane1.setViewportView(jList2);

        add(jScrollPane1);
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JList<Class<?>> jList1;
    private javax.swing.JList<Class<?>> jList2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton4;
    // End of variables declaration//GEN-END:variables

    @Override
    public final void setValue(Object val) {
        super.setValue(val);
        if (val instanceof java.lang.reflect.Method) {
            // for introspection method
            java.lang.reflect.Method meth = (java.lang.reflect.Method) val;
            jToggleButton1.setVisible(meth.isBridge());
            jToggleButton2.setVisible(meth.isSynthetic());
            jToggleButton3.setVisible(meth.isVarArgs());
            jToggleButton4.setVisible(meth.isAccessible());
            // jLabel1.setIcon((new com.jdcm.common.D_Utils()).getIcon(val));
            jLabel1.setText(meth.getName());
            jLabel1.setToolTipText(java.lang.reflect.Modifier.toString(meth.getModifiers()));
            jCB_ObjectEditor1.setValue(meth.getReturnType());
            jScrollPane1.setVisible(false);
            jScrollPane2.setVisible(false);
            if (meth.getParameterTypes().length > 0) {
                javax.swing.DefaultListModel<Class<?>> model = new javax.swing.DefaultListModel<>();
                for (Class<?> cl : meth.getParameterTypes()) {
                    model.addElement(cl);
                }
                jList1.setModel(model);
                jList1.setCellRenderer(render);
                jScrollPane2.setVisible(true);
            }
            if (meth.getExceptionTypes().length > 0) {
                javax.swing.DefaultListModel<Class<?>> model = new javax.swing.DefaultListModel<>();
                for (Class<?> cl : meth.getExceptionTypes()) {
                    model.addElement(cl);
                }
                jList2.setModel(model);
                jList2.setCellRenderer(render);
                jScrollPane1.setVisible(true);
            }
        } else if (val instanceof com.jdcm.common.C_textMethod) {
            // for Text method
            com.jdcm.common.C_textMethod meth = (com.jdcm.common.C_textMethod) super.getValue();
            jToggleButton1.setVisible(false);
            jToggleButton2.setVisible(false);
            jToggleButton3.setVisible(false);
            jToggleButton4.setVisible(false);
            jLabel1.setIcon((new com.jdcm.common.D_Utils()).getIcon(meth));
            jLabel1.setText(meth.getName());
            jLabel1.setToolTipText(java.lang.reflect.Modifier.toString(meth.getModifiers()));
            jCB_ObjectEditor1.setVisible(meth.getReturnType() != null);
            jCB_ObjectEditor1.setValue(meth.getReturnType());
            jScrollPane1.setVisible(false);
            jScrollPane2.setVisible(false);
            if (meth.getParameterTypes().length > 0) {
                javax.swing.DefaultListModel<Class<?>> model = new javax.swing.DefaultListModel<>();
                for (Class<?> cl : meth.getParameterTypes()) {
                    model.addElement(cl);
                }
                jList1.setModel(model);
                jList1.setCellRenderer(render);
                jScrollPane2.setVisible(true);
            }
            if (meth.getExceptionTypes().length > 0) {
                javax.swing.DefaultListModel<Class<?>> model = new javax.swing.DefaultListModel<>();
                for (Class<?> cl : meth.getExceptionTypes()) {
                    model.addElement(cl);
                }
                jList2.setModel(model);
                jList2.setCellRenderer(render);
                jScrollPane1.setVisible(true);
            }
        }
    }
}
