package com.jdcm.editors;

import javax.swing.DefaultComboBoxModel;

/**
 * USED TO PRESENT ALL Object (not well designed need definitions)
 *
 * @author Marc GIBOIN
 */
public class P_ObjectEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
        private final ACE_ObjRenderer<Object> render = new ACE_ObjRenderer<>();
    private final ACE_ObjEditor<Object> editor = new ACE_ObjEditor<>(true);
    
    private Object value = null;
    private com.jdcm.common.Options_Model options = null;


    /**
     * Creates new form P_ReflectMember
     */
    public P_ObjectEditor() {
        initComponents();

    }
 /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("Object.gif");
        }catch(Exception ex){
            return null;
        }
    }
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setLayout(new java.awt.BorderLayout());

        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        add(jButton1, java.awt.BorderLayout.SOUTH);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Object ob = com.jdcm.editors.F_Object.showDialog(new java.awt.Frame(), value, false);
        setValue(ob);
}//GEN-LAST:event_jButton1ActionPerformed
    /**
     * return the basic label to be displayed as editor
     *
     * @param initial the initial Text
     * @return the label to be displayed for this editor
     */
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent initial) {
        javax.swing.text.JTextComponent txt = initial;
        java.awt.Container cont = txt.getParent();
        javax.swing.JTextPane box1;
        if (txt instanceof javax.swing.JTextField) {
            ///WHY ??? should be deleted?  
            box1 = new javax.swing.JTextPane();
            box1.setMargin(new java.awt.Insets(0, 2, 0, 0));
            box1.setEditable(false);
            box1.setForeground(txt.getForeground());
            box1.setOpaque(false);
            txt.remove(cont);
            for (java.awt.event.FocusListener fl : txt.getFocusListeners()) {
                box1.addFocusListener(fl);
            }
            cont.add(box1, java.awt.BorderLayout.CENTER);

        } else if (txt instanceof javax.swing.JTextPane) {
            box1 = (javax.swing.JTextPane) txt;
        } else {
            box1 = null;
        }
        if (box1 != null) {
            javax.swing.text.StyledDocument st = box1.getStyledDocument();
            try {
                st.remove(0, st.getLength());
            } catch (javax.swing.text.BadLocationException ex) {
            }
            if (value != null) {
                String par = classestoString(value.getClass().getClasses());
                addtext(st, value.toString() + " ", box1.getForeground(), 0);
                addtext(st, par, java.awt.Color.blue, 0);
                addtext(st, " [" + value.getClass().getSimpleName() + "]", java.awt.Color.red, 0);
                addtext(st, " ", box1.getForeground(), 0);
            } else {
                addtext(st, "null", box1.getForeground(), 1);
            }
            if (box1.getPreferredSize().height > cont.getPreferredSize().height) {
                //  java.awt.Dimension editordim = new java.awt.Dimension(cont.getPreferredSize().width, box1.getPreferredSize().height);
                //  cont.setPreferredSize(editordim);
            }
            return box1;
        } else {
            return new javax.swing.JTextField("no label foud");
        }
    }

    private String classestoString(Class<?>[] cls) {
        String par = "(";
        for (Class<?> cl : cls) {
            par = par + cl.getSimpleName() + ",";
        }
        if (par.length() > 1) {
            par = par.substring(0, par.length() - 1);
        }
        par += ")";
        if (par.length() < 3) {
            par = "";
        }
        return par;
    }

    @Override
    public void setValue(Object val) {
        value = val;
        options = new com.jdcm.common.Options_Model(value);
        options.autoDiscover();
        if (value != null) {
            options.addOption("Class", value.getClass(), "", "", true, false, "");
            options.addOption("Object", "" + value, "", "", true, false, "");
            options.addOption("Hash", value.hashCode(), "", "", true, false, "");
            String sc = value.getClass().getSimpleName();
            Class<?> cl = value.getClass();
            while (cl.getSuperclass() != null) {
                sc = cl.getSuperclass().getSimpleName() + "." + sc;
                cl = cl.getSuperclass();
            }
            options.addOption("Superclass", sc, "", "", true, false, "");
            options.addOption("Methodes", new DefaultComboBoxModel<>(cl.getDeclaredMethods()), "", "", true, false, "");
            options.addOption("Fields", new DefaultComboBoxModel<>(cl.getDeclaredFields()), "", "", true, false, "");
        }
        // jTable1.setValue(options);
        jTable1.setModel(options);
        //TODO : should be from P_TableEditor render to get header column 
        jTable1.getColumn(jTable1.getColumnName(0)).setCellRenderer(render);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellRenderer(render);
        jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(editor);

    }

    @Override
    public Object getValue() {
        return value;
    }

    @Override
    public boolean isEditing() {
        return false;
    }

    @Override
    public void setEditing(boolean bool) {
    }

    /**
     * Manage the changes of the text if editied directly
     *
     * @param txt the TextComponent modified to treate
     */
    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
        // txt.setEditable(false);
    }

    /**
     * implment the table Objects render for a list
     *
     * @param st
     * @param texte
     * @param c
     * @param style
     */
    private void addtext(javax.swing.text.StyledDocument st, String texte, java.awt.Color c, int style) {
        javax.swing.text.SimpleAttributeSet myAttributeSet = new javax.swing.text.SimpleAttributeSet();
        javax.swing.text.StyleConstants.setForeground(myAttributeSet, c);
        javax.swing.text.StyleConstants.setBold(myAttributeSet, style == 1);
        javax.swing.text.StyleConstants.setItalic(myAttributeSet, style == 2);
        try {
            st.insertString(st.getLength(), texte, myAttributeSet);
        } catch (javax.swing.text.BadLocationException ex) {
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
