package com.jdcm.editors;

import com.jdcm.common.C_Packet;

/**
 *  P_View_Packet.java Created on 2 juin 2007, 14:59
 * 
 *Used to Display/edit JDataCom Packets<br>
 * 
 * @author  Marc GIBOIN 
 */
public class P_PacketEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
        private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>();
    
    private C_Packet Pack;
    private boolean editing = false;


    public P_PacketEditor() {
        initComponents();
    }

    /** Creates new form P_View_Packet 
     *
     * @param p Packet to Edit
     */
    public P_PacketEditor(C_Packet p) {
        initComponents();
        Pack = p;
        EditNewObj();
    }
    /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("Packet.gif");
        }catch(Exception ex){
            return null;
        }
    }
    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        editing = bool;
    }
/**
 * Manage the changes of the text if editied directly
 * @param txt the TextComponent modified to treate
 */
    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }
    /**
     * return the basic label to be displayed as editor
     * @param txt the initial Text
     * @return the label to be displayed for this editor
     */
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        txt.setText("Packet<" + getValue().getClass().getSimpleName() + ">");
        return txt;
    }

    @Override
    public C_Packet getValue() {
        return Pack;
    }

    @Override
    public void setValue(Object val) {
        if (val instanceof C_Packet) {
            C_Packet p = (C_Packet) val;
            Pack = p;
            EditNewObj();
        }
    }

    private void EditNewObj() {
        String[] items = {"Source","Source_idx", "Destination","Dest_idx", "Creation Time ", "transit",
            "Stored Time", "Value", "type", "Serial", "SQL req.", "SQL start", "SQL delai", "SQL upd"};
        String[] notes = {"port","int", "port","int", "entry", "E/S time", "?", "ex:byte[]", "java..", "contants",
            "request", "start time", "DB delai", "update"};
        Object[] values = {Pack.getsource(),Pack.getsourceidx(), Pack.getdestination(), Pack.getdestidx(),Pack.getCreatetime(), Pack.getTransittime(), Pack.getStoredtime(), Pack.getObj(), Pack.getObj().getClass().getCanonicalName(), Pack.getSerial(), Pack.getSQLReq(), Pack.getSQLstart(), Pack.getSQLdelay(), Pack.getSQL_upd()};
        for (int i = 0; i < items.length; i++) {
            jTable6.setValueAt(items[i], i, 0);
            jTable6.setValueAt(values[i], i, 1);
            jTable6.setValueAt(notes[i], i, 2);
        }
        jTable6.getColumn("Values").setCellRenderer(render);
        jTable6.getColumn("Values").setCellEditor(editor);
        jTable6.repaint();
    }

    private void hideEditor() {
        if (Pack==null){
            return;
        }
        Pack.setstore_srcidx(Integer.parseInt(""+jTable6.getValueAt(1, 1)));
         Pack.setstore_dstidx(Integer.parseInt(""+jTable6.getValueAt(3, 1)));
        Pack.setCreatetime((java.util.Date) jTable6.getValueAt(4, 1));
        Pack.setTransittime((Integer) jTable6.getValueAt(5, 1));
        Pack.setStoredtime((java.util.Date) jTable6.getValueAt(6, 1));
        Pack.setObj(jTable6.getValueAt(7, 1));
        if (jTable6.getValueAt(11, 1) != null) {
            Pack.setSQLReq(jTable6.getValueAt(10, 1).toString());
            if (jTable6.getValueAt(11, 1) instanceof java.util.Date) {
                Pack.setSQLstart((java.util.Date) jTable6.getValueAt(11, 1));
            }
            if (jTable6.getValueAt(12, 1) instanceof Integer) {
                Pack.setSQLdelay((Integer) jTable6.getValueAt(12, 1));
            }
            if (jTable6.getValueAt(13, 1) instanceof Integer) {
                Pack.setSQL_upd((Integer) jTable6.getValueAt(13, 1));
            }
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane9 = new javax.swing.JScrollPane();
        jTable6 = new javax.swing.JTable();

        addAncestorListener(new javax.swing.event.AncestorListener() {
            public void ancestorMoved(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorAdded(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorRemoved(javax.swing.event.AncestorEvent evt) {
                formAncestorRemoved(evt);
            }
        });
        setLayout(new java.awt.BorderLayout());

        jTable6.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "Items", "Values", "Remarks"
            }
        ));
        jScrollPane9.setViewportView(jTable6);

        add(jScrollPane9, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void formAncestorRemoved(javax.swing.event.AncestorEvent evt) {//GEN-FIRST:event_formAncestorRemoved
        hideEditor();
    }//GEN-LAST:event_formAncestorRemoved
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JTable jTable6;
    // End of variables declaration//GEN-END:variables
}
