package com.jdcm.editors;

/**
 * P_ReflectMember.java Created JCB_ObjectEditoron 24 août 2009, 08:44:49
 *
 * USED TO PRESENT ALL REFLECT METHODS/FIELDS/...
 *
 * @author Marc GIBOIN
 */
public class P_ReflectEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final java.util.List<Object[]> vectdata = new java.util.ArrayList<>();
    private final java.util.List<String> vectname = new java.util.ArrayList<>();
    //private D_Utils utils = new D_Utils();
    private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>(false);

    private java.lang.reflect.AnnotatedElement value = null;
    private com.jdcm.common.C_textElement txtvalue = null;
    private java.lang.annotation.Annotation annvalue = null;

    /**
     * Creates new form P_ReflectMember
     */
    public P_ReflectEditor() {
        initComponents();
        vectname.add("Name");
        vectname.add("Value");
    }

    /**
     * Provide an Icon if needed (asked by frames)
     *
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
            return (new com.jdcm.common.D_Utils()).getImage("File_class.gif");
        } catch (Exception ex) {
            return null;
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setLayout(new java.awt.BorderLayout());

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Name", "Value"
            }
        ));
        jTable1.setShowHorizontalLines(false);
        jTable1.setShowVerticalLines(false);
        jScrollPane1.setViewportView(jTable1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * return the basic label to be displayed as editor
     *
     * @param inittxt the initial Text
     * @return the label to be displayed for this editor
     */
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent inittxt) {
        javax.swing.text.JTextComponent txt = inittxt;
        java.awt.Container cont = txt.getParent();
        javax.swing.JTextPane box1;
        if (txt instanceof javax.swing.JTextField) {
            box1 = new javax.swing.JTextPane();
            box1.setMargin(new java.awt.Insets(0, 2, 0, 0));
            box1.setEditable(false);
            box1.setOpaque(true);
            txt.remove(cont);
            for (java.awt.event.FocusListener fl : txt.getFocusListeners()) {
                box1.addFocusListener(fl);
            }
            cont.add(box1, java.awt.BorderLayout.CENTER);

        } else if (txt instanceof javax.swing.JTextPane) {
            box1 = (javax.swing.JTextPane) txt;
        } else {
            box1 = null;
        }
        if (box1 != null) {
            java.awt.Color forcol = box1.getForeground();
            javax.swing.text.StyledDocument st = box1.getStyledDocument();
            try {
                st.remove(0, st.getLength());
            } catch (javax.swing.text.BadLocationException ex) {
            }
            if (value instanceof java.lang.reflect.AnnotatedElement) {
                if (value instanceof java.lang.Class<?>) {
                    java.lang.Class<?> cl = (java.lang.Class<?>) value;
                    addtext(st, cl.getSimpleName(), forcol, 1);// see "(class)"
                } else if (value instanceof java.lang.Package) {
                    java.lang.Package pak = (java.lang.Package) value;
                    addtext(st, pak.getName() + " ", forcol, 1);
                    addtext(st, pak.getImplementationVersion(), java.awt.Color.blue, 0);
                } else if (value instanceof java.lang.reflect.Method) {
                    java.lang.reflect.Method m = (java.lang.reflect.Method) value;
                    String par = classestoString(m.getParameterTypes());
                    addtext(st, m.getName() + " ", forcol, 1);
                    addtext(st, par, java.awt.Color.blue, 0);
                    addtext(st, " => " + m.getReturnType().getSimpleName(), java.awt.Color.red, 0);
                } else if (value instanceof java.lang.reflect.Field) {
                    java.lang.reflect.Field f = (java.lang.reflect.Field) value;
                    addtext(st, f.getName() + " ", forcol, 1);
                    addtext(st, f.getType().getSimpleName(), java.awt.Color.red, 0);
                } else if (value instanceof java.lang.reflect.Constructor<?>) {
                    java.lang.reflect.Constructor<?> c = (java.lang.reflect.Constructor<?>) value;
                    String SimpleName = c.getName();
                    if (SimpleName.indexOf(".") > 0) {
                        SimpleName = SimpleName.substring(SimpleName.lastIndexOf(".") + 1);
                    }
                    addtext(st, SimpleName + " ", forcol, 1);
                    addtext(st, classestoString(c.getParameterTypes()), java.awt.Color.blue, 0);
                } else {
                    addtext(st, value.toString() + ": NOT MANAGED ", java.awt.Color.black, 1);
                }
            } else if (annvalue instanceof java.lang.annotation.Annotation) {
                addtext(st, annvalue.toString() + " ", forcol, 1);
                addtext(st, annvalue.annotationType().getSimpleName(), java.awt.Color.blue, 0);
            } else if (txtvalue instanceof com.jdcm.common.C_textElement) {
                if (txtvalue instanceof com.jdcm.common.C_textMethod) {
                    com.jdcm.common.C_textMethod m = (com.jdcm.common.C_textMethod) txtvalue;
                    String par = m.getParametersLabel();
                    addtext(st, m.getSimpleName() + " ", forcol, 1);
                    addtext(st, par, java.awt.Color.blue, 0);
                    if (m.isConstructor() == false) {
                        addtext(st, " => " + m.getReturnLabel(), java.awt.Color.red, 0);
                    }
                } else if (txtvalue instanceof com.jdcm.common.C_textClass) {
                    com.jdcm.common.C_textClass cl = (com.jdcm.common.C_textClass) txtvalue;
                    addtext(st, cl.getSimpleName(), forcol, 1);// see "(class)"
                } else if (txtvalue instanceof com.jdcm.common.C_textField) {
                    com.jdcm.common.C_textField typ = (com.jdcm.common.C_textField) txtvalue;
                    addtext(st, typ.getSimpleName() + " ", forcol, 1);
                    if (typ.getType() != null) {
                        addtext(st, typ.getType().getSimpleName(), java.awt.Color.red, 0);
                    } else {
                        addtext(st, "???", java.awt.Color.red, 0);
                    }
                }
            }
            if (box1.getPreferredSize().height > cont.getPreferredSize().height) {
                java.awt.Dimension editordim = new java.awt.Dimension(cont.getPreferredSize().width, box1.getPreferredSize().height);
                cont.setPreferredSize(editordim);
            }
            return box1;
        } else {
            return new javax.swing.JTextField("no label foud");
        }
    }

    private String classestoString(Class<?>[] cls) {
        String par = "(";
        for (Class<?> cl : cls) {
            if (cl != null) {
                par = par + cl.getSimpleName() + ",";
            } else {
                par = par + "???,";
            }
        }
        if (par.length() > 1) {
            par = par.substring(0, par.length() - 1);
        }
        return par + ")";
    }

    @Override
    public void setValue(Object val) {
        vectdata.clear();
        if (val instanceof java.lang.annotation.Annotation) {
            txtvalue = null;
            annvalue = (java.lang.annotation.Annotation) val;
            setObjectinTable("String", annvalue.toString());
            setObjectinTable("String", annvalue.annotationType().getSimpleName());
        } else if (val instanceof java.lang.reflect.AnnotatedElement) {
            txtvalue = null;
            value = (java.lang.reflect.AnnotatedElement) val;
            if (value instanceof java.lang.Class<?>) {
                java.lang.Class<?> cl = (java.lang.Class<?>) value;
                setObjectinTable("Name", cl.getName());
                setObjectinTable("CannonicalName", cl.getCanonicalName());
                setObjectinTable("Modifiers", java.lang.reflect.Modifier.toString(cl.getModifiers()));
                setObjectinTable("SimpleName", cl.getSimpleName());
                setObjectinTable("SuperClass", cl.getSuperclass());
                setObjectinTable("IsAnnotation", cl.isAnnotation());
                setObjectinTable("IsAnnonymousClass", cl.isAnonymousClass());
                setObjectinTable("IsArray", cl.isArray());
                setObjectinTable("IsEnum", cl.isEnum());
                setObjectinTable("IsInterface", cl.isInterface());
                setObjectinTable("IsLocalClass", cl.isLocalClass());
                setObjectinTable("IsMemberClass", cl.isMemberClass());
                setObjectinTable("IsPrimitive", cl.isPrimitive());
                setObjectinTable("IsSynthetic", cl.isSynthetic());
                try {
                    if (cl.getClassLoader() == null) {
                        setObjectinTable("ClassLoader", "Bootstrap loader");
                    } else {
                        setObjectinTable("ClassLoader", cl.getClassLoader());
                    }
                } catch (SecurityException ex) {
                    setObjectinTable("ClassLoader", ex);
                }
                String sc = value.getClass().getSimpleName();
                Class<?> cl2 = cl;
                while (cl2.getSuperclass() != null) {
                    sc = cl2.getSuperclass().getSimpleName() + "." + sc;
                    cl2 = cl2.getSuperclass();
                }
                setObjectinTable("Superclass", sc);
            } else if (value instanceof java.lang.Package) {
                java.lang.Package pak = (java.lang.Package) value;
                setObjectinTable("Name", pak.getName());
                setObjectinTable("ImplementationTitle", pak.getImplementationTitle());
                setObjectinTable("ImplementationVendor", pak.getImplementationVendor());
                setObjectinTable("ImplementationVersion()", pak.getImplementationVersion());
                setObjectinTable("SpecificationTitle", pak.getSpecificationTitle());
                setObjectinTable("SpecificationVendor", pak.getSpecificationVendor());
                setObjectinTable("SpecificationVersion", pak.getSpecificationVersion());
                setObjectinTable("hashCode", pak.hashCode());
                setObjectinTable("isSealed", pak.isSealed());
            } else if (value instanceof java.lang.reflect.Method) {
                java.lang.reflect.Method m = (java.lang.reflect.Method) value;
                setObjectinTable("Name", m.getName());
                setObjectinTable("Modifiers", java.lang.reflect.Modifier.toString(m.getModifiers()));
                setObjectinTable("default", m.getDefaultValue());
                setObjectinTable("Bridge", m.isBridge());
                setObjectinTable("VarArgs", m.isVarArgs());
                setObjectinTable("Synthetic", m.isSynthetic());
                setObjectinTable("Generic String", m.toGenericString());
                if (m.getGenericReturnType() != null) {
                    setObjectinTable("return type", m.getGenericReturnType().toString());
                } else {
                    setObjectinTable("return type", "void");
                }
                setObjectinTable("params", classestoString(m.getParameterTypes()));
                setObjectinTable("Exception type", classestoString(m.getExceptionTypes()));
                setObjectinTable("Hashcode", m.hashCode());
            } else if (value instanceof java.lang.reflect.Constructor<?>) {
                java.lang.reflect.Constructor<?> c = (java.lang.reflect.Constructor<?>) value;
                setObjectinTable("Name", c.getName());
                setObjectinTable("Modifiers", java.lang.reflect.Modifier.toString(c.getModifiers()));
                setObjectinTable("Hashcode", c.hashCode());
                setObjectinTable("VarArgs", c.isVarArgs());
                setObjectinTable("Synthetic", c.isSynthetic());
                setObjectinTable("Generic String", c.toGenericString());
                setObjectinTable("params", classestoString(c.getParameterTypes()));
                setObjectinTable("Exception type", classestoString(c.getExceptionTypes()));
            } else if (value instanceof java.lang.reflect.Field) {
                java.lang.reflect.Field f = (java.lang.reflect.Field) value;
                setObjectinTable("Name", f.getName());
                setObjectinTable("Modifiers", java.lang.reflect.Modifier.toString(f.getModifiers()));
                setObjectinTable("Hashcode", f.hashCode());
                setObjectinTable("Type", f.getType().getSimpleName());
                setObjectinTable("EnumConstant", f.isEnumConstant());
                setObjectinTable("Generic String", f.toGenericString());
                try {
                    setObjectinTable("Value", f.get(value));
                } catch (IllegalArgumentException | IllegalAccessException ex) {
                    //can't access if 'static final'
                    // System.out.println("P_ReflectEditor.setValue():=>"+ex);
                }
            } else {
                setObjectinTable("Not managed: ", value.toString());
            }
        } else if (val instanceof com.jdcm.common.C_textElement) {
            txtvalue = (com.jdcm.common.C_textElement) val;
            value = null;
            if (txtvalue instanceof com.jdcm.common.C_textClass) {
                com.jdcm.common.C_textClass cl = (com.jdcm.common.C_textClass) txtvalue;
                setObjectinTable("Name", cl.getName());
                // setObjectinTable("CannonicalName", cl.getCanonicalName());
                setObjectinTable("Modifiers", java.lang.reflect.Modifier.toString(cl.getModifiers()));
                setObjectinTable("SimpleName", cl.getSimpleName());
                setObjectinTable("Package", cl.getPackage());
                //setObjectinTable("SuperClass", cl.getSuperclass());
                // setObjectinTable("IsAnnotation", cl.isAnnotation());
                // setObjectinTable("IsAnnonymousClass", cl.isAnonymousClass());
                //setObjectinTable("IsArray", cl.isArray());
                // setObjectinTable("IsEnum", cl.isEnum());
                //setObjectinTable("IsInterface", cl.isInterface());
                //setObjectinTable("IsLocalClass", cl.isLocalClass());
                //setObjectinTable("IsMemberClass", cl.isMemberClass());
                //setObjectinTable("IsPrimitive", cl.isPrimitive());
                //setObjectinTable("IsSynthetic", cl.isSynthetic());
                /*try {
                 if (cl.getClassLoader() == null) {
                 setObjectinTable("ClassLoader", "Bootstrap loader");
                 } else {
                 setObjectinTable("ClassLoader", cl.getClassLoader());
                 }
                 } catch (SecurityException ex) {
                 setObjectinTable("ClassLoader", ex);
                 }*/
                /*    String sc = value.getClass().getSimpleName();
                 Class cl2 = cl;
                 while (cl2.getSuperclass() != null) {
                 sc = cl2.getSuperclass().getSimpleName() + "." + sc;
                 cl2 = cl2.getSuperclass();
                 }*/
                setObjectinTable("Superclass", cl.getSuperclass());
            }
            jTable1.setModel(new com.jdcm.common.ListTableModel(vectdata, vectname));
            jTable1.getColumn(jTable1.getColumnName(1)).setCellRenderer(render);
            jTable1.getColumn(jTable1.getColumnName(1)).setCellEditor(editor);
            //   jTable1.repaint();

        }

    }

    @Override
    public Object getValue() {
        if (value != null) {
            return value;
        } else if (txtvalue != null) {
            return txtvalue;
        }
        return null;
    }

    @Override
    public boolean isEditing() {
        return false;
    }

    @Override
    public void setEditing(boolean bool) {
    }

    /**
     * Manage the changes of the text if editied directly
     *
     * @param txt the TextComponent modified to treate
     */
    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
        // txt.setEditable(false);
    }

    /**
     * implment the table Objects render for a list
     *
     * @param st
     * @param texte
     * @param c
     * @param style
     */
    private void addtext(javax.swing.text.StyledDocument st, String texte, java.awt.Color c, int style) {
        javax.swing.text.SimpleAttributeSet myAttributeSet = new javax.swing.text.SimpleAttributeSet();
        javax.swing.text.StyleConstants.setForeground(myAttributeSet, c);
        javax.swing.text.StyleConstants.setBold(myAttributeSet, style == 1);
        javax.swing.text.StyleConstants.setItalic(myAttributeSet, style == 2);
        try {
            st.insertString(st.getLength(), texte, myAttributeSet);
        } catch (javax.swing.text.BadLocationException ex) {
        }
    }

    private void setObjectinTable(String title, Object obj) {
        Object[] row = new Object[2];
        row[0] = title;
        row[1] = obj;
        vectdata.add(row);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
