package com.jdcm.editors;

import com.jdcm.common.D_DBUtils;
import com.jdcm.common.C_Packet;
import com.jdcm.common.D_Utils;
import com.jdcm.common.cellDataModel;
import java.awt.Color;
import java.awt.event.KeyEvent;
import java.lang.reflect.InvocationTargetException;
import java.net.UnknownHostException;
import java.util.EventObject;
import javax.swing.event.CellEditorListener;
import javax.swing.table.*;
import java.util.List;
import java.sql.*;
import javax.swing.AbstractCellEditor;
import javax.swing.table.AbstractTableModel;

/**
 * P_table2.java Created on 4 août 2009, 21:08:28
 *
 * Panel used to display 'all' sort of tables..(very heavy, need t be dre
 * designed)
 *
 * @author Marc GIBOIN
 */
public class P_TableEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private ResultSet rset = null;
    private ResultSetMetaData rsetm = null;
    private C_Packet Pack;
    private D_Utils TUtils = new D_Utils();
    private AbstractTableModel model = null;
    private java.awt.Dimension initsize = null;
    private javax.swing.JTable worktable = null;
    // private boolean enable = false;
    private TBL_Renderer render = null;
    private TBL_Editor editor = null;
    private boolean ishdrcol = false;

    /**
     * Creates new form P_table2
     */
    public P_TableEditor() {
        initComponents();
        worktable = this.jTable1;
        jScrollPane5.setVisible(false);
        init();
    }

    public P_TableEditor(ResultSet resultset) {
        if (resultset == null) {
            return;
        }
        initComponents();
        init();
        rset = resultset;
        try {
            rsetm = rset.getMetaData();
        } catch (SQLException ex) {
            return;
        }
        jToolBar1.setVisible(false);
        setValue(rset);

    }

    public P_TableEditor(javax.swing.table.AbstractTableModel tablemodel) {
        initComponents();
        init();
        setValue(tablemodel);
    }

    /**
     * Provide an Icon if needed (asked by frames)
     *
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
            return (new com.jdcm.common.D_Utils()).getImage("JTable.gif");
        } catch (Exception ex) {
            return null;
        }
    }

    private void init() {
        // System.setProperty("file.encoding", "ISO-8859-1");
        setEnable(true);
        jComboBox1.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jComboBox2.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        try {
            //jComboBox1.addItem((Class<? extends javax.swing.table.TableCellRenderer>)Class.forName("com.jdcm.editors.ACE_ObjRenderer"));
            jComboBox1.addItem(com.jdcm.editors.ACE_ObjRenderer.class);
            jComboBox1.addItem(javax.swing.table.DefaultTableCellRenderer.class);
            jComboBox2.addItem(com.jdcm.editors.ACE_ObjEditor.class);
            jComboBox2.addItem(javax.swing.DefaultCellEditor.class);
        } catch (Exception ex) {
        }
        initsize = this.getPreferredSize();
        setmyEditor(new com.jdcm.editors.ACE_ObjEditor<>());
        setmyRender(getmyRender());
        setmyEditor(getmyEditor());
        update();
        dislpayControl(false);
        jButton4.setEnabled(false);
        jButton1.setIcon(TUtils.getIcon("Add.gif"));
        jButton2.setIcon(TUtils.getIcon("Remove.gif"));
        jButton3.setIcon(TUtils.getIcon("refresh.gif"));
        jToggleButton1.setIcon(TUtils.getIcon("Viewoff.gif"));
        jToggleButton1.setSelectedIcon(TUtils.getIcon("Vew.gif"));
        jToggleButton2.setSelectedIcon(TUtils.getIcon("build_on.gif"));
        jToggleButton2.setIcon(TUtils.getIcon("build_off.gif"));
        jToggleButton3.setIcon(TUtils.getIcon("Obj_build.gif"));
        if (rset != null) {
            try {
                displayDBresult();
            } catch (Exception ex) {
            }
        }
    }

    public String getDataSelectedColumnIntem() {
        String res = null;
        if (jTable1.getSelectedColumn() >= 0) {
            res = jTable1.getColumnName(jTable1.getSelectedColumn());
        }
        return res;
    }

    public void setSorter(boolean bool) {
        worktable.setAutoCreateRowSorter(bool);
    }

    public String getDataSelectedValue() {
        String res = null;
        if (jTable1.getSelectedColumn() >= 0 && jTable1.getSelectedRow() >= 0) {
            res = jTable1.getValueAt(jTable1.getSelectedRow(), jTable1.getSelectedColumn()).toString();
        }
        return res;
    }

    public void sethdrcol(boolean bool) {
        ishdrcol = bool;
        setmyRender(getmyRender());
    }

    public void setDBPanelsVisible(boolean bool) {
        for (int i = 1; i < jTabbedPane1.getTabCount(); i++) {
            jTabbedPane1.setEnabledAt(i, bool);
        }
    }

    private void setValidation(boolean bool) {
        if (getValue() instanceof com.jdcm.common.ListTableModel) {
            com.jdcm.common.ListTableModel listmodel = (com.jdcm.common.ListTableModel) getValue();
            if (listmodel.isvalidated != isValidation()) {
                listmodel.isvalidated = bool;
                jButton4.setEnabled(bool);
            }
        }
    }

    private void commit() {
        if (getValue() instanceof com.jdcm.common.ListTableModel) {
            com.jdcm.common.ListTableModel listmodel = (com.jdcm.common.ListTableModel) getValue();
            listmodel.commit();
        }
    }

    private boolean isValidation() {
        if (getValue() instanceof com.jdcm.common.ListTableModel) {
            return jToggleButton5.isSelected();
        } else {
            return false;
        }
    }

    private Class<?> getmyEditor() {
        if (jComboBox2.getSelectedItem().getClass().isAssignableFrom(Class.class)) {
            return (Class<?>) jComboBox2.getSelectedItem();
        }
        return null;
    }

    private void setmyEditor(Class<?> cl) {
        Object rd = null;
        try {
            // for ACE_Editor
            rd = cl.getConstructor(boolean.class, boolean.class).newInstance(isEditing(), jToggleButton3.isSelected());
        } catch (NoSuchMethodException | SecurityException | InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex2) {
            try {
                // for DefaultEditor
                rd = cl.getConstructor(javax.swing.JTextField.class).newInstance(new javax.swing.JTextField());
            } catch (NoSuchMethodException | SecurityException | InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex3) {
            }

        }
        if (rd instanceof javax.swing.table.TableCellEditor) {
            setmyEditor((javax.swing.table.TableCellEditor) rd);
        }
    }

    public void setmyEditor(TableCellEditor ed) {
        if (ed == null) {
            return;
        }
        if (worktable != null) {
            worktable.editingCanceled(new javax.swing.event.ChangeEvent(this));
        }
        if (editor == null) {
            editor = new TBL_Editor(ed);
        } else {
            editor.setNewEditor(ed);
        }

    }
//<?> could be managed near  "Render" ... and checked

    private Class<? extends javax.swing.table.TableCellRenderer> getmyRender() {
        if (jComboBox1.getSelectedItem() instanceof Class<?>) {
            return (Class<? extends javax.swing.table.TableCellRenderer>) jComboBox1.getSelectedItem();
        }
        return null;
    }

    private void setmyRender(Class<? extends javax.swing.table.TableCellRenderer> cl) {
        //p_Table1.setRender(new TBL_Renderer());
        Object rd = null;
        try {
            rd = cl.newInstance();
        } catch (InstantiationException | IllegalAccessException ex2) {
        }

        if (rd instanceof javax.swing.table.TableCellRenderer) {
            setmyRender((javax.swing.table.TableCellRenderer) rd);
        }
    }

    public void setmyRender(TableCellRenderer rd) {
        if (rd == null) {
            return;
        }
        if (render == null) {
            render = new TBL_Renderer(rd, ishdrcol);
        } else {
            render.setNewRenderer(rd, ishdrcol);
        }
        repaint();

    }

    private void update() {
        if (worktable != null && worktable.getColumnModel() != null) {
            for (int i = 0; i < worktable.getColumnCount(); i++) {
                worktable.getColumnModel().getColumn(i).setCellEditor(editor);
                worktable.getColumnModel().getColumn(i).setCellRenderer(render);
            }
        }
        repaint();
    }

    public AbstractTableModel getModel() {
        if (rset != null) {
            return (AbstractTableModel) worktable.getModel();
        }
        if (model != null) {
            return model;
        }
        return null;
    }

    /**
     * for edition return selected rows
     *
     * @return
     */
    public int[] getSelectedRows() {
        return worktable.getSelectedRows();
    }

    /**
     * public int Updatecell(Object value, int row, int column) { int res = -1;
     * try { rset.absolute(row + 1); rset.updateObject(column + 1, value);
     * rset.updateRow(); displayrow(); res = 1; } catch (SQLException ex) {
     * TDeb.wri("Update : error during exceution : " + ex.getMessage());
     * TDeb.wri("Update : try SQL "); DB_Model dbm = (DB_Model)
     * jTable1.getModel(); res = dbm.Updatecell(value, row, column); } return
     * res; }
     */
    private void displayDBresult() {
        gettabledef();
        int conc = -1;
        jTextField2.setEnabled(false);
        /*
         * try { jTextField2.setText(rset.getCursorName()); } catch (Throwable
         * ex) { jTextField2.setEnabled(false); }
         */
        // try{jCheckBox3.setSelected(rset.isClosed());        } catch (SQLException ex) {jCheckBox3.setEnabled(false) ;}
        try {
            jCheckBox4.setSelected(rset.isAfterLast());
        } catch (SQLException ex) {
            jCheckBox4.setEnabled(false);
        }
        try {
            jCheckBox5.setSelected(rset.isBeforeFirst());
        } catch (SQLException ex) {
            jCheckBox5.setEnabled(false);
        }
        try {
            jCheckBox6.setSelected(rset.isFirst());
        } catch (SQLException ex) {
            jCheckBox6.setEnabled(false);
        }
        try {
            jCheckBox7.setSelected(rset.isLast());
        } catch (SQLException ex) {
            jCheckBox7.setEnabled(false);
        }
        try {
            jTextField3.setText("" + rset.getStatement().getMaxRows());
        } catch (SQLException ex) {
            jTextField3.setEnabled(false);
            addLogs("couldn't get getMaxRows [" + ex.getMessage() + "]");
        }
        try {
            if (rset.getWarnings() == null) {
                jTextField4.setText(" No warning");
            } else {
                jTextField4.setText(rset.getWarnings().getMessage());
            }
        } catch (SQLException ex) {
            jTextField4.setEnabled(false);
            addLogs("couldn't get getWarnings [" + ex.getMessage() + "]");
        }
        try {
            jTextField5.setText("" + rset.getStatement().getFetchDirection());
        } catch (SQLException ex) {
            jTextField5.setEnabled(false);
            addLogs("couldn't get Statment getFetchDirection [" + ex.getMessage() + "]");
        }
        try {
            jTextField6.setText("" + rset.getStatement().getFetchSize());
        } catch (SQLException ex) {
            jTextField6.setEnabled(false);
            addLogs("couldn't get Statement getFetchSize [" + ex.getMessage() + "]");
        }
        try {
            jTextField7.setText("" + rset.getStatement().getMaxFieldSize());
        } catch (SQLException ex) {
            jTextField7.setEnabled(false);
            addLogs("couldn't get getMaxFieldSize [" + ex.getMessage() + "]");
        }
        try {
            jTextField8.setText("" + rset.getStatement().getQueryTimeout());
        } catch (SQLException ex) {
            jTextField8.setEnabled(false);
            addLogs("couldn't get getQueryTimeout [" + ex.getMessage() + "]");
        }
        try {
            jTextField9.setText("" + rset.getStatement().getUpdateCount());
        } catch (SQLException ex) {
            jTextField9.setEnabled(false);
            addLogs("couldn't get getUpdateCount [" + ex.getMessage() + "]");
        }
        try {
            jTextField10.setText("" + rset.getFetchDirection());
        } catch (SQLException ex) {
            jTextField10.setEnabled(false);
            addLogs("couldn't get getFetchDirection [" + ex.getMessage() + "]");
        }
        try {
            jTextField11.setText("" + rset.getFetchSize());
        } catch (SQLException ex) {
            jTextField11.setEnabled(false);
            addLogs("couldn't get getFetchSize [" + ex.getMessage() + "]");
        }
        try {
            if (rset.getType() == ResultSet.TYPE_FORWARD_ONLY) {
                jTextField13.setText("TYPE_FORWARD_ONLY");
            }
            if (rset.getType() == ResultSet.TYPE_SCROLL_INSENSITIVE) {
                jTextField13.setText("TYPE_SCROLL_INSENSITIVE");
            }
            if (rset.getType() == ResultSet.TYPE_SCROLL_SENSITIVE) {
                jTextField13.setText("TYPE_SCROLL_SENSITIVE");
            }
        } catch (SQLException ex) {
            jTextField13.setEnabled(false);
        }
        try {
            if (rset.getStatement().getConnection() != null) {
                jTextField12.setText(rset.getStatement().getConnection().toString());
            }
        } catch (SQLException ex) {
            jTextField12.setEnabled(false);
        }
        try {
            conc = rset.getConcurrency();
        } catch (SQLException ex) {
            addLogs("couldn't get concurency [" + ex.getMessage() + "]");
        }
        if (conc == ResultSet.CONCUR_READ_ONLY) {
            this.jTextField1.setText("CONCUR_READ_ONLY");
        }
        if (conc == ResultSet.CONCUR_UPDATABLE) {
            this.jTextField1.setText("CONCUR_UPDATABLE");
        }
        if (conc == -1) {
            this.jTextField1.setEnabled(false);
        }
        //try{  jCheckBox1.setSelected(rset.getStatement().isClosed());        } catch (SQLException ex) {jCheckBox1.setEnabled(false) ;}
        //try{  jCheckBox2.setSelected(rset.getStatement().isPoolable());        } catch (SQLException ex) {jCheckBox2.setEnabled(false) ;}
        // request not found in resultset =>  will be teached by parent...
        setSQLRequest(null);
    }

    private void addTab(javax.swing.JPanel p, String title, javax.swing.Icon i) {
        jTabbedPane1.add(title, p);
        jTabbedPane1.setIconAt(jTabbedPane1.getTabCount() - 1, i);
    }

    private void removeTab(javax.swing.JPanel p) {
        jTabbedPane1.remove(p);
    }

    public void removeRows(int[] ints) {
        if (this.isEnable() == false) {
            return;
        }
        if (worktable.getModel() instanceof com.jdcm.common.ListTableModel) {
            ((com.jdcm.common.ListTableModel) worktable.getModel()).removeRows(ints);
        } else {
            for (int line : ints) {
                if (line == -1) {
                    return;
                }
                if (rset != null) {
                    try {
                        rset.absolute(line + 1);
                        rset.deleteRow();
                    } catch (SQLException ex) {
                        if (getModel() instanceof D_DBUtils.DB_Model) {
                            D_DBUtils.DB_Model dbm = (D_DBUtils.DB_Model) getModel();
                            dbm.RemoveRow(line);
                        }
                    }
                }
            }
        }
        refresh();

    }

    public void insert_row() {
        if (this.isEnable()) {
            if (rset != null) {
                try {
                    rset.moveToInsertRow();
                    for (int col = 0; col < getModel().getColumnCount(); col++) {
                        Object o = getModel().getValueAt(getModel().getRowCount() - 1, col);
                        rset.updateObject(col + 1, o);
                    }
                    rset.insertRow();
                    rset.moveToCurrentRow();
                } catch (SQLException ex) {
                    if (getModel() instanceof D_DBUtils.DB_Model) {
                        D_DBUtils.DB_Model dbm = (D_DBUtils.DB_Model) getModel();
                        dbm.AddInsertRow();
                    }
                }
            } else if (worktable.getModel() instanceof com.jdcm.common.ListTableModel) {
                ((com.jdcm.common.ListTableModel) worktable.getModel()).insertRow();
            }
            refresh();
        }
    }

    public void setSQLRequest(String reqtxt) {
        jTextField14.setEnabled(reqtxt != null);
        jLabel22.setEnabled(reqtxt != null);
        if (reqtxt == null) {
            jTextField14.setText("");
        } else {
            jTextField14.setText(reqtxt);
        }
    }

    private String getSQLRequest() {
        if (jTextField14.isEnabled() == false) {
            return null;
        } else {
            return jTextField14.getText();
        }
    }

    public void refresh() {
        if (worktable.getModel() instanceof com.jdcm.common.ListTableModel) {
            worktable.repaint();
        } else if (rset == null) {
        } else {
            java.sql.Connection dbcx = null;
            try {
                dbcx = rset.getStatement().getConnection();
            } catch (SQLException exe) {
                //   dbcx = getCX();
                addLogs("try to refresh, couldn't get Connexion");
            }
            try {
                rset.close();
            } catch (SQLException ex) {
                addLogs("try to close Resultset");
            }
            if (dbcx != null) {
                try {
                    Statement st;
                    if (isEnable()) {
                        st = dbcx.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_UPDATABLE);
                    } else {
                        st = dbcx.createStatement();
                    }
                    long start = System.currentTimeMillis();

                    st.execute(Pack.getSQLReq());
                    long stop = System.currentTimeMillis();
                    rset = st.getResultSet();
                    Pack.setSQL(Pack.getSQLReq(), new java.util.Date(start), new java.util.Date(stop));
                    Pack.setObj(rset);
                } catch (SQLException ex) {
                    return;
                }
                try {
                    displayDBresult();
                } catch (Exception ex) {
                    addLogs("Pb DB Table");
                }
            }
        }
        addLogs("Refreshed DB Table");
    }

    public void addLogs(String txt) {
        if (jTextPane1.getText().trim().length() == 0) {
            jTextPane1.setText(txt);
        } else {
            jTextPane1.setText(jTextPane1.getText() + "\r\n" + txt);
        }
    }

    public void dislpayControl(boolean bool) {
        jToolBar1.setVisible(bool);
    }

    public boolean isdislpayControl() {
        return jToolBar1.isVisible();
    }

    private void gettabledef() {
        if (rsetm == null) {
            return;
        }
        int column;
        try {
            column = rsetm.getColumnCount();
        } catch (SQLException ex) {
            addLogs("couldn't get number of colums [" + ex.getMessage() + "]");
            return;
        }
        if (column == 0) {
            addLogs("no colums founds");
        }
        final Object[][] data = new Object[19][column + 1];
        final String[] header = new String[column + 1];
        header[0] = "Titles";
        for (int i = 1; i <= column; i++) {
            try {
                header[i] = rsetm.getColumnName(i);
            } catch (SQLException ex) {
                header[i] = "";
                addLogs("=>" + ex.getMessage());
            }
        }
        data[0][0] = "getTableName";
        data[1][0] = "getColumnLabel";
        data[2][0] = "getCatalogName";
        data[3][0] = "getColumnClassName";
        data[4][0] = "getColumnDisplaySize";
        data[5][0] = "getColumnType";
        data[6][0] = "getColumnTypeName";
        data[7][0] = "getPrecision";
        data[8][0] = "getScale";
        data[9][0] = "getSchemaName";
        data[10][0] = "isAutoIncrement";
        data[11][0] = "isCaseSensitive";
        data[12][0] = "isCurrency";
        data[13][0] = "isDefinitelyWritable";
        data[14][0] = "isReadOnly";
        data[15][0] = "isSearchable";
        data[16][0] = "isSigned";
        data[17][0] = "isWritable";
        data[18][0] = "isNullable";
        for (int i = 1; i <= column; i++) {
            try {
                data[0][i] = rsetm.getTableName(i);
            } catch (SQLException ex) {
                data[0][i] = "N/A";
            }
            try {
                data[1][i] = rsetm.getColumnLabel(i);
            } catch (SQLException ex) {
                data[1][i] = "N/A";
            }
            try {
                data[2][i] = rsetm.getCatalogName(i);
            } catch (SQLException ex) {
                data[2][i] = "N/A";
            }
            try {
                data[3][i] = rsetm.getColumnClassName(i);
            } catch (SQLException ex) {
                data[3][i] = "N/A";
            }
            try {
                data[4][i] = rsetm.getColumnDisplaySize(i);
            } catch (SQLException ex) {
                data[4][i] = "N/A";
            }
            try {
                data[5][i] = rsetm.getColumnType(i);
            } catch (SQLException ex) {
                data[5][i] = "N/A";
            }
            try {
                data[6][i] = rsetm.getColumnTypeName(i);
            } catch (SQLException ex) {
                data[6][i] = "N/A";
            }
            try {
                data[7][i] = rsetm.getPrecision(i);
            } catch (SQLException ex) {
                data[7][i] = "N/A";
            }
            try {
                data[8][i] = rsetm.getScale(i);
            } catch (SQLException ex) {
                data[8][i] = "N/A";
            }
            try {
                data[9][i] = rsetm.getSchemaName(i);
            } catch (SQLException ex) {
                data[9][i] = "N/A";
            }
            try {
                data[10][i] = rsetm.isAutoIncrement(i);
            } catch (SQLException ex) {
                data[10][i] = "N/A";
            }
            try {
                data[11][i] = rsetm.isCaseSensitive(i);
            } catch (SQLException ex) {
                data[11][i] = "N/A";
            }
            try {
                data[12][i] = rsetm.isCurrency(i);
            } catch (SQLException ex) {
                data[12][i] = "N/A";
            }
            try {
                data[13][i] = rsetm.isDefinitelyWritable(i);
            } catch (SQLException ex) {
                data[13][i] = "N/A";
            }
            try {
                data[14][i] = rsetm.isReadOnly(i);
            } catch (SQLException ex) {
                data[14][i] = "N/A";
            }
            try {
                data[15][i] = rsetm.isSearchable(i);
            } catch (SQLException ex) {
                data[15][i] = "N/A";
            }
            try {
                data[16][i] = rsetm.isSigned(i);
            } catch (SQLException ex) {
                data[16][i] = "N/A";
            }
            try {
                data[17][i] = rsetm.isWritable(i);
            } catch (SQLException ex) {
                data[17][i] = "N/A";
            }
            int a = -1;
            try {
                a = rsetm.isNullable(i);
            } catch (SQLException ex) {
                data[18][i] = "N/A";
            }
            if (a == -1) {
                data[18][i] = "N/A";
            }
            if (a == ResultSetMetaData.columnNoNulls) {
                data[18][i] = "NoNulls";
            }
            if (a == ResultSetMetaData.columnNullable) {
                data[18][i] = "Nullable";
            }
            if (a == ResultSetMetaData.columnNullableUnknown) {
                data[18][i] = "NullableUnknown";
            }
        }
        TableModel dataModel = new javax.swing.table.DefaultTableModel(data, header);
        jTable2.setModel(dataModel);
        for (int i = 0; i < jTable2.getColumnCount(); i++) {
            jTable2.getColumnModel().getColumn(i).setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
            jTable2.getColumnModel().getColumn(i).setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>(false));
        }
        //  jTable2.setEnabled(false);
        List<Object> tables = new java.util.ArrayList<>();
        for (int i = 1; i < dataModel.getColumnCount(); i++) {
            if (tables.contains(dataModel.getValueAt(0, i)) == false) {
                tables.add(dataModel.getValueAt(0, i));
            }
        }
    }

    /**
     * NOT USED ... Display a resultset as byte=> CANCELED too long
     *
     * @param tab the resultset to
     * @return the byte array representing th resultset
     */
    private byte[] tab2bytes(ResultSet tab) {
        //!!! may be too long !!!
        // TDeb.wri("Write on Terminal detailled SQL Resultset: " + tab.toString());
        byte[] res = null;
// ResultSet tab = (ResultSet) o;
// display as text =>XML + XML schema???
//javax.xml.XMLConstants.
        String sqlres = TUtils.getSQLcsv(tab, "|", true);
        res = TUtils.addtab(res, sqlres.getBytes());
        // tab.
        try {
            while (tab.next() && res.length < 10000) {
                sqlres = TUtils.getSQLcsv(tab, "|", false);
                res = TUtils.addtab(res, sqlres.getBytes());
            }

        } catch (SQLException ex) {
            System.out.println("P_TableEditor.tab2bytes():=>" + ex.getMessage());
        }

        if (res.length >= 10000) {
            res = "too long (>10000 char)".getBytes();
        }

        try {
            tab.beforeFirst();
        } catch (SQLException ex) {
            //   TDeb.wri("Could not set back ResultSet before first row :" + ex.getMessage());
        }

        return res;
    }

    public static Object[][] defaultTable() {
        Object[][] datas = new Object[10][13];
        for (int i = 0; i < 10; i++) {
            String txt = "\"" + i + "\"";
            datas[i][0] = 0L + i;
            datas[i][1] = null;
            datas[i][2] = txt.getClass().getMethods()[i];
            datas[i][3] = txt.getBytes();
            datas[i][4] = i / 2 == Math.floor(i / 2);
            datas[i][5] = new java.sql.Time(System.currentTimeMillis() + i * 60000);
            datas[i][6] = new java.util.Date(System.currentTimeMillis() + i * 24 * 3600000);
            datas[i][7] = new java.awt.Rectangle(i, i, i, i);
            datas[i][8] = new Float(i);
            datas[i][9] = txt;
            try {
                datas[i][10] = java.net.Inet4Address.getByName("192.168.1." + i);
            } catch (UnknownHostException ex) {
                System.out.println("defaultTable()=>"+ex.getMessage());
            }
            int col = 25;
            datas[i][11] = new java.awt.Color(i * col, i * col, (10 - i) * col);
            datas[i][12] = new com.jdcm.common.O_Amount(new Double(i));
        }
        return datas;
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                javax.swing.JFrame f = new javax.swing.JFrame();
                P_TableEditor p = new P_TableEditor();
                p.setValue(defaultTable());
                f.add(p);
                f.setBounds(new java.awt.Rectangle(0, 0, 400, 100));
                f.setVisible(true);
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        jToggleButton5 = new javax.swing.JToggleButton();
        jButton4 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jToggleButton3 = new javax.swing.JToggleButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        jComboBox2 = new javax.swing.JComboBox<>();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTable4 = new javax.swing.JTable();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jPanel11 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox9 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();
        jPanel10 = new javax.swing.JPanel();
        jTextField4 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        jTextField1 = new javax.swing.JTextField();
        jTextField10 = new javax.swing.JTextField();
        jTextField14 = new javax.swing.JTextField();
        jTextField13 = new javax.swing.JTextField();
        jTextField11 = new javax.swing.JTextField();
        jPanel4 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jLabel21 = new javax.swing.JLabel();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jPanel8 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextField6 = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel19 = new javax.swing.JLabel();
        jTextField12 = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        jPanel5 = new javax.swing.JPanel();
        p_PacketEditor1 = new com.jdcm.editors.P_PacketEditor();

        setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);

        jToggleButton5.setText("v");
        jToggleButton5.setToolTipText("validate");
        jToggleButton5.setFocusable(false);
        jToggleButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton5);

        jButton4.setText("Commit");
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton4);

        jButton3.setToolTipText("refresh");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jButton2.setToolTipText("Remove");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton1.setToolTipText("Add");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jToggleButton1.setToolTipText("enable");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        jToggleButton2.setToolTipText("editing");
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton2);

        jToggleButton3.setToolTipText("Objediting");
        jToggleButton3.setFocusable(false);
        jToggleButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton3);

        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jComboBox1);

        jComboBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jComboBox2);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        jPanel6.setMinimumSize(new java.awt.Dimension(66, 202));
        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.Y_AXIS));

        jScrollPane5.setPreferredSize(new java.awt.Dimension(452, 102));

        jTable4.setToolTipText("");
        jTable4.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        jTable4.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTable4KeyPressed(evt);
            }
        });
        jScrollPane5.setViewportView(jTable4);

        jPanel6.add(jScrollPane5);

        jTabbedPane1.setPreferredSize(new java.awt.Dimension(424, 309));

        jPanel1.setLayout(new java.awt.BorderLayout());

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Empty"
            }
        ));
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTable1KeyReleased(evt);
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("DATA", jPanel1);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jLabel10.setText("Colums definitions : ");
        jPanel2.add(jLabel10, java.awt.BorderLayout.NORTH);

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null}
            },
            new String [] {
                "Title 1"
            }
        ));
        jTable2.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane2.setViewportView(jTable2);

        jPanel2.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Colums", jPanel2);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel11.setLayout(new java.awt.GridLayout(7, 0));

        jLabel9.setText("Warning : ");
        jPanel11.add(jLabel9);

        jLabel7.setText("Cursor name :");
        jPanel11.add(jLabel7);

        jLabel6.setText("Concurency : ");
        jPanel11.add(jLabel6);

        jLabel16.setText("getFetchDirection :");
        jPanel11.add(jLabel16);

        jLabel22.setText("Requette : ");
        jLabel22.setEnabled(false);
        jPanel11.add(jLabel22);

        jLabel20.setText("Type : ");
        jPanel11.add(jLabel20);

        jLabel17.setText("getFetchSize : ");
        jPanel11.add(jLabel17);

        jPanel3.add(jPanel11, java.awt.BorderLayout.WEST);

        jPanel9.setLayout(new java.awt.GridLayout(6, 0));

        jCheckBox3.setForeground(new java.awt.Color(153, 153, 0));
        jCheckBox3.setText("isClosed");
        jCheckBox3.setToolTipText("Pb error Abstract Method?");
        jCheckBox3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox3.setEnabled(false);
        jCheckBox3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel9.add(jCheckBox3);

        jCheckBox9.setText("jCheckBox9");
        jCheckBox9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox9ActionPerformed(evt);
            }
        });
        jPanel9.add(jCheckBox9);

        jCheckBox4.setForeground(new java.awt.Color(153, 153, 0));
        jCheckBox4.setText("isAfterLast");
        jCheckBox4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox4.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel9.add(jCheckBox4);

        jCheckBox5.setForeground(new java.awt.Color(153, 153, 0));
        jCheckBox5.setText("isBeforeFirst");
        jCheckBox5.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox5.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel9.add(jCheckBox5);

        jCheckBox6.setForeground(new java.awt.Color(153, 153, 0));
        jCheckBox6.setText("isFirst");
        jCheckBox6.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox6.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel9.add(jCheckBox6);

        jCheckBox7.setForeground(new java.awt.Color(153, 153, 0));
        jCheckBox7.setText("isLast");
        jCheckBox7.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox7.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel9.add(jCheckBox7);

        jPanel3.add(jPanel9, java.awt.BorderLayout.EAST);

        jPanel10.setLayout(new java.awt.GridLayout(7, 1));

        jTextField4.setText("-warning-");
        jPanel10.add(jTextField4);

        jTextField2.setText("-cursor-");
        jPanel10.add(jTextField2);

        jTextField1.setText("-conc-");
        jPanel10.add(jTextField1);

        jTextField10.setText("-getFetchDirection-");
        jPanel10.add(jTextField10);

        jTextField14.setEditable(false);
        jTextField14.setText("-Requette");
        jTextField14.setEnabled(false);
        jPanel10.add(jTextField14);

        jTextField13.setText("-gettype-");
        jPanel10.add(jTextField13);

        jTextField11.setText("-getFetchSize-");
        jPanel10.add(jTextField11);

        jPanel3.add(jPanel10, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("prop.", jPanel3);

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel7.setLayout(new java.awt.GridLayout(4, 1));

        jCheckBox1.setForeground(new java.awt.Color(153, 153, 0));
        jCheckBox1.setText("isClosed");
        jCheckBox1.setToolTipText("Pb error Abstract Method?");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setEnabled(false);
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel7.add(jCheckBox1);

        jCheckBox2.setForeground(new java.awt.Color(153, 153, 0));
        jCheckBox2.setText("isPoolable");
        jCheckBox2.setToolTipText("Pb error Abstract Method?");
        jCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox2.setEnabled(false);
        jCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel7.add(jCheckBox2);

        jLabel21.setText("Packet : ");
        jPanel7.add(jLabel21);
        jPanel7.add(jCB_ObjectEditor1);

        jPanel4.add(jPanel7, java.awt.BorderLayout.EAST);

        jScrollPane3.setPreferredSize(new java.awt.Dimension(452, 52));

        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "NO_GENERATED_KEYS"
            }
        ));
        jTable3.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane3.setViewportView(jTable3);

        jPanel4.add(jScrollPane3, java.awt.BorderLayout.SOUTH);

        jPanel8.setLayout(new java.awt.GridLayout(7, 2));

        jLabel11.setText("getFetchDirection :");
        jPanel8.add(jLabel11);

        jTextField5.setText("-fetch dir-");
        jPanel8.add(jTextField5);

        jLabel15.setText("getUpdateCount :");
        jPanel8.add(jLabel15);

        jTextField9.setText("-getUpdateCount-");
        jPanel8.add(jTextField9);

        jLabel14.setText("getQueryTimeout :");
        jPanel8.add(jLabel14);

        jTextField8.setText("-getQueryTimeout-");
        jPanel8.add(jTextField8);

        jLabel12.setText("getFetchSize :");
        jPanel8.add(jLabel12);

        jTextField6.setText("-fetch size-");
        jPanel8.add(jTextField6);

        jLabel13.setText("getMaxFieldSize :");
        jPanel8.add(jLabel13);

        jTextField7.setText("- getMaxFieldSize-");
        jPanel8.add(jTextField7);

        jLabel19.setText("getConnection : ");
        jPanel8.add(jLabel19);

        jTextField12.setText("-getConnection-");
        jTextField12.setToolTipText("see connexion on port");
        jPanel8.add(jTextField12);

        jLabel8.setText("Max rows : ");
        jPanel8.add(jLabel8);

        jTextField3.setText("-Max rows-");
        jPanel8.add(jTextField3);

        jPanel4.add(jPanel8, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Statement", jPanel4);

        jTextPane1.setEditable(false);
        jScrollPane4.setViewportView(jTextPane1);

        jTabbedPane1.addTab("Logs", jScrollPane4);

        jPanel5.setToolTipText("");
        jPanel5.setLayout(new java.awt.BorderLayout());
        jPanel5.add(p_PacketEditor1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Packet", jPanel5);

        jPanel6.add(jTabbedPane1);

        add(jPanel6, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jTable4KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTable4KeyPressed
        if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
            dislpayControl(isdislpayControl() == false);
        }
    }//GEN-LAST:event_jTable4KeyPressed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (this.isEnable()) {
            if (worktable.getModel() instanceof com.jdcm.common.ListTableModel) {
                ((com.jdcm.common.ListTableModel) worktable.getModel()).insertRow();
            }
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        removeRows(getSelectedRows());
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        refresh();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        setEnable(jToggleButton1.isSelected());
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
        setmyEditor(getmyEditor());
    }//GEN-LAST:event_jToggleButton3ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        setmyRender(getmyRender());
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jComboBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox2ActionPerformed
        setmyEditor(getmyEditor());
    }//GEN-LAST:event_jComboBox2ActionPerformed

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        setmyEditor(getmyEditor());
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jToggleButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton5ActionPerformed
        setValidation(isValidation());
    }//GEN-LAST:event_jToggleButton5ActionPerformed

    private void jTable1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTable1KeyReleased
        if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
            dislpayControl(isdislpayControl() == false);
        }

    }//GEN-LAST:event_jTable1KeyReleased

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        commit();
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jCheckBox9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox9ActionPerformed
        try {
            if (getSQLRequest() == null || rset.getStatement() == null) {
                return;
            }
            if (jCheckBox9.isSelected()) {
                try {
                    //not working because rset is closed...
                    rset.getStatement().execute(getSQLRequest(), Statement.RETURN_GENERATED_KEYS);
                    ResultSet r = rset.getStatement().getResultSet();
                    setValue(r);
                    TUtils.resultset2Table(r.getStatement().getGeneratedKeys(), jTable3);
                } catch (SQLException ex) {
                    addLogs("couldn't get getGeneratedKeys [" + ex.getMessage() + "]");
                }
            } else {
                rset.getStatement().execute(getSQLRequest(), Statement.NO_GENERATED_KEYS);
                jTable3.setModel(new javax.swing.table.DefaultTableModel(
                        new Object[][]{},
                        new String[]{
                    "NO_GENERATED_KEYS"
                }));
            }
        } catch (UnsupportedOperationException | SQLException ex) {
            this.jTable3.setEnabled(false);
        }

    }//GEN-LAST:event_jCheckBox9ActionPerformed

    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        if (worktable.getModel() instanceof com.jdcm.common.Options_Model) {
            txt.setText(((com.jdcm.common.Options_Model) worktable.getModel()).getTitle());
        } else {
            String label = "empty";
            if (this.getValue() != null) {
                label = this.getValue().getClass().getSimpleName();
            }
            txt.setText(label + " [" + worktable.getModel().getRowCount() + "*" + worktable.getModel().getColumnCount() + "]");
        }
        return txt;
    }

    public void addValue(Object contents) {
        if (contents instanceof ResultSet && jTable1.getModel() instanceof D_DBUtils.DB_Model) {
            ((D_DBUtils.DB_Model) jTable1.getModel()).addResults((ResultSet) contents);
        }
    }

    @Override
    public final void setValue(Object value) {
        Object contents = value;
        if (contents == null) {
            worktable.setModel(new javax.swing.table.DefaultTableModel(new Object[]{"Empty Table"}, 0));
        } else {
            if (contents instanceof C_Packet) {
                Pack = (C_Packet) contents;
                p_PacketEditor1.setVisible(true);
                p_PacketEditor1.setValue(Pack);
                contents = ((C_Packet) contents).getObj();
            } else {
                this.removeTab(jPanel5);
            }
            if (contents instanceof ResultSet) {
                jScrollPane5.setVisible(false);
                worktable = jTable1;
                rset = (ResultSet) contents;
                if (rset == null) {
                    return;
                }
                try {
                    rsetm = rset.getMetaData();
                } catch (SQLException ex) {
                    addLogs("init SQL Table : couldn't get Metatdata [" + ex.getMessage() + "]");
                }
                if (rsetm == null) {
                    return;
                }
                sethdrcol(true);
                displayDBresult();
                jTable1.setModel(new D_DBUtils.DB_Model(rset));
                try {
                    // DON' Understand how it WORK ... Fetch /max size/ TO do nothing => Drivers?
                    // CALLABLE STATEMENT ...
                    while (rset.getStatement().getMoreResults()) {
                        addValue(rset.getStatement().getMoreResults());
                    }
                } catch (SQLException ex) {
                }
                int size = 10 + jTable1.getFontMetrics(jTable1.getFont()).stringWidth("" + jTable1.getRowCount());
                if (jTable1.getColumnCount() > 0) {
                    jTable1.getColumnModel().getColumn(0).setPreferredWidth(size);
                }
            } else if (contents instanceof javax.swing.table.AbstractTableModel) {
                model = (javax.swing.table.AbstractTableModel) contents;
                worktable = jTable4;
                jTabbedPane1.setVisible(false);
                jScrollPane5.setVisible(true);
                worktable.setModel(model);
                if (contents instanceof com.jdcm.common.Options_Model) {
                    jTable4.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
                } else {
                    jTable4.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
                }
            } else if (contents.getClass().isArray() && contents.getClass().getComponentType().isArray()) {
                //java.util.List datas=java.util.Arrays.asList(contents);
                Object[][] obj = (Object[][]) contents;
                worktable = jTable4;
                jTabbedPane1.setVisible(false);
                jScrollPane5.setVisible(true);
                java.util.List<Object[]> datas = java.util.Arrays.asList(obj);
                model = new com.jdcm.common.ListTableModel(datas, null);
                ((com.jdcm.common.ListTableModel) model).ishdrcol = true;
                worktable.setModel(model);
            }
        }
        setEnable(isEnable());
        update();
        ajustsize();
    }

    @Override
    public Object getValue() {
        if (rset != null) {
            return rset;
        } else if (model != null) {
            return model;
        } else {
            return null;
        }
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }

    //@Override
    public boolean isEnable() {
        return jToggleButton1.isSelected();


    }

    // @Override
    public void setEnable(boolean bool) {
        if (bool != isEnable()) {
            jToggleButton1.setSelected(bool);
        }
        if (worktable != null) {
            if (worktable.getModel() instanceof D_DBUtils.DB_Model) {
                ((D_DBUtils.DB_Model) worktable.getModel()).setEdit(bool);
            } else if (worktable.getModel() instanceof com.jdcm.common.ListTableModel) {
                boolean[] edit = new boolean[worktable.getModel().getColumnCount()];
                for (int i = 0; i
                        < edit.length; i++) {
                    edit[i] = bool;
                }
                ((com.jdcm.common.ListTableModel) worktable.getModel()).setEditable(edit);
            }
            worktable.repaint();
        }
    }

    @Override
    public boolean isEditing() {
        return jToggleButton2.isSelected();
    }

    @Override
    public void setEditing(boolean bool) {
        if (bool != isEditing()) {
            jToggleButton2.setSelected(bool);
        }
        // Editor schould implment editing functions
        setmyEditor(getmyEditor());
        worktable.repaint();
    }

    private void ajustsize() {
        if (this.getParent() instanceof javax.swing.JSplitPane || this.getParent() instanceof javax.swing.JScrollPane) {
            return;
        }
        int d = 10;
        int h = 30;// scrollbar
        d += worktable.getPreferredSize().width;
        h += worktable.getPreferredSize().height;
        if (this.getParent() != null) {
            this.getTopLevelAncestor().setSize(new java.awt.Dimension(
                    Math.min(initsize.width, d), Math.min(initsize.height, h)));
        } else {
            this.setPreferredSize(new java.awt.Dimension(
                    Math.min(initsize.width, d), Math.min(initsize.height, h)));
        }

    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JCheckBox jCheckBox9;
    private javax.swing.JComboBox<Class<? extends javax.swing.table.TableCellRenderer>> jComboBox1;
    private javax.swing.JComboBox<Class<? extends javax.swing.table.TableCellEditor>> jComboBox2;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTable jTable3;
    private javax.swing.JTable jTable4;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField10;
    private javax.swing.JTextField jTextField11;
    private javax.swing.JTextField jTextField12;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField jTextField14;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextField jTextField9;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton5;
    private javax.swing.JToolBar jToolBar1;
    private com.jdcm.editors.P_PacketEditor p_PacketEditor1;
    // End of variables declaration//GEN-END:variables
}

class TBL_Renderer implements TableCellRenderer {

    private static final long serialVersionUID = 1L;
    private javax.swing.table.TableCellRenderer base = null;
    public boolean ishdrcol = false;
    private static java.awt.Color hdrcolor = null;

    public TBL_Renderer(javax.swing.table.TableCellRenderer rdr, boolean bool) {
        base = rdr;
        ishdrcol = bool;
        hdrcolor = (new javax.swing.JLabel()).getBackground();
    }

    public void setNewRenderer(javax.swing.table.TableCellRenderer rdr, boolean bool) {
        base = rdr;
        ishdrcol = bool;
    }

    @Override
    public java.awt.Component getTableCellRendererComponent(
            javax.swing.JTable table, Object val, boolean isSelected, boolean hasFocus, int row, int col) {
        cellDataModel cell = null;
        Object value = val;
        if (value instanceof cellDataModel) {
            cell = (cellDataModel) value;
            value = cell.newValue;
        }
        java.awt.Component res = base.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, col);
        if (cell != null && cell.getStatusColor() != null) {
            res.setBackground(cell.getStatusColor());
        }
        if (col == 0 && ishdrcol) {
            if (res instanceof javax.swing.JLabel) {
                ((javax.swing.JLabel) res).setOpaque(true);
                if (isSelected) {
                    ((javax.swing.JLabel) res).setBackground(table.getSelectionBackground());
                } else {
                    ((javax.swing.JLabel) res).setBackground(hdrcolor);
                }
                ((javax.swing.JLabel) res).setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 0, 0, Color.white));
                ((javax.swing.JLabel) res).setEnabled(true);
            }
        }
        return res;
    }

    /*
     * @Override public java.awt.Component
     * getTreeCellRendererComponent(javax.swing.JTree tree, Object value,
     * boolean selected, boolean expanded, boolean leaf, int row, boolean
     * hasFocus) { return new javax.swing.JLabel("tree render not implemented");
     * } public Component getListCellRendererComponent(JList list, Object value,
     * int index, boolean isSelected, boolean cellHasFocus) { return
     * list,value,index,isSelected,cellHasFocus); }
     */
}

class TBL_Editor extends AbstractCellEditor implements javax.swing.table.TableCellEditor {

    private static final long serialVersionUID = 1L;
    private javax.swing.table.TableCellEditor base = null;

    public TBL_Editor(javax.swing.table.TableCellEditor ed) {
        base = ed;
    }

    @Override
    public Object getCellEditorValue() {
        return base.getCellEditorValue();
    }

    public void setNewEditor(javax.swing.table.TableCellEditor ed) {
        this.fireEditingCanceled();
        base = ed;
    }

    @Override
    public java.awt.Component getTableCellEditorComponent(javax.swing.JTable table, Object val, boolean isSelected, int row, int column) {
        cellDataModel cell = null;
        Object value = val;
        if (value instanceof cellDataModel) {
            cell = (cellDataModel) value;
            value = cell.newValue;
        }
        java.awt.Component res = base.getTableCellEditorComponent(table, value, isSelected, row, column);
        if (cell != null) {
            res.setBackground(cell.getStatusColor());
        }
        return res;
    }

    @Override
    public boolean isCellEditable(EventObject anEvent) {
        return base.isCellEditable(anEvent);
    }

    @Override
    public boolean shouldSelectCell(EventObject anEvent) {
        return base.shouldSelectCell(anEvent);
    }

    @Override
    public boolean stopCellEditing() {
        return base.stopCellEditing();
    }

    @Override
    public void cancelCellEditing() {
        base.cancelCellEditing();
    }

    @Override
    public void addCellEditorListener(CellEditorListener l) {
        base.addCellEditorListener(l);
    }

    @Override
    public void removeCellEditorListener(CellEditorListener l) {
        base.removeCellEditorListener(l);
    }
}
