package com.jdcm.editors;

import com.jdcm.common.G_AutoScrollBar;
import com.jdcm.common.G_NonWrappingTextPane;
import javax.swing.text.*;
import java.awt.*;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.MouseEvent;
import java.beans.*;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map.Entry;
import javax.swing.*;
import javax.swing.event.*;

/**
 * P_Texte.java Created on 1 oct. 2011, 15:45:31
 *
 * Offer a full functions Text Panel implementation
 *
 * @author Marc GIBOIN
 */
public class P_Texte extends javax.swing.JPanel {

    private static final long serialVersionUID = 1L;
    private static int TYPE_NORMAL = 0;
    private static int TYPE_COMENT = 1;
    private static int TYPE_KEYWORD = 2;
    private static int TYPE_ANNOT = 3;
    private static int TYPE_STRING = 4;
    private static int TYPE_TYPE = 5;
    private static int TYPE_VALUE = 6;
    private static int TYPE_CLASS = 7;
    private static int TYPE_MYMETHOD = 8;
    private static int TYPE_METHOD = 9;
    private static int TYPE_OBJECT = 10;
    private static int TYPE_XMLFIELD = 20;
    private static int TYPE_XMLATTR = 21;
    private static int TYPE_SQLFUNCTION = 30;
    private static int TYPE_SQLTABLE = 30;
    private static int TYPE_EXTNONE = 100;
    private static int TYPE_EXTBRACEOK = 101;
    private static int TYPE_EXTBRACENOK = 102;
    private static int TYPE_EXTFIND = 110;
    private static int TYPE_EXTERR = 120;
    private java.awt.Color[] COLORS_MARK = new java.awt.Color[]{
        new java.awt.Color(255, 0, 0, 90), new java.awt.Color(0, 170, 0, 90), new java.awt.Color(0, 0, 170, 90), new java.awt.Color(100, 0, 100, 90), new java.awt.Color(0, 100, 100, 90), new java.awt.Color(100, 100, 0, 90), new java.awt.Color(100, 100, 100, 90)
    };
    private java.awt.Color COLOR_SCROLL = new java.awt.Color(0, 255, 0, 90);
    private StyledDocument StyledConsole = null;
    private StyleContext sc = null;
    private F_Completion frameCompletion = null;
    private String DocColorType = "";
    private String escapString = null;
    private java.util.List<int[]> txtlist = null;
    private java.util.LinkedList<Integer> foundSearchedList = new java.util.LinkedList<>();
    private java.sql.Connection dbcx = null;
    private java.io.File defaultFile = null;
    //  private com.jdcm.common.D_Debug TDeb = new com.jdcm.common.D_Debug("Compile");
    private com.jdcm.common.D_Utils TUtils = new com.jdcm.common.D_Utils();
    private java.util.HashMap<Integer, java.awt.Color> markedLines = new java.util.HashMap<>();

    /**
     * Creates new form NewJPanel
     */
    public P_Texte() {
        initComponents();
        init();
    }

    public P_Texte(java.io.File file) {
        initComponents();
        init();
    }

    public java.io.ByteArrayOutputStream getOutStream() {
        return new TextOutputStream();
    }

    private boolean isSearchWord() {
        return jCheckBox1.isSelected();
    }

    private boolean isSearchCase() {
        return jCheckBox2.isSelected();
    }

    private void init() {
        jComboBox1.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(getFonts()));
        jComboBox1.setSelectedItem(g_NonWrappingTextPane1.getFont());
        StyledConsole = g_NonWrappingTextPane1.getStyledDocument();
        // should be better with a JPanel2 Componemnt
        initTextAttribute();
        jButton1.setIcon(TUtils.getIcon("Save.gif"));
        jButton2.setIcon(TUtils.getIcon("build_on.gif"));
        jButton3.setIcon(TUtils.getIcon("arrow_rightblue.gif"));
        jButton4.setIcon(TUtils.getIcon("arrow_leftblue.gif"));
        jToggleButton1.setIcon(TUtils.getIcon("forceWrap_off.gif"));
        jToggleButton1.setSelectedIcon(TUtils.getIcon("forceWrap_on.gif"));
        jToggleButton2.setIcon(TUtils.getIcon("GlobalBar_off.gif"));
        jToggleButton2.setSelectedIcon(TUtils.getIcon("GlobalBar_on.gif"));
        jToggleButton3.setIcon(TUtils.getIcon("LineBar_off.gif"));
        jToggleButton3.setSelectedIcon(TUtils.getIcon("LineBar_on.gif"));
        jToggleButton4.setIcon(TUtils.getIcon("StatusBar_off.gif"));
        jToggleButton4.setSelectedIcon(TUtils.getIcon("StatusBar_on.gif"));
        jButton5.setIcon(TUtils.getIcon("Close.gif"));
        jLabel1.setText("[0,0]/0");
        jScrollPane1.setVerticalScrollBar(new G_AutoScrollBar(COLOR_SCROLL));
        setTootbox(false);
        setStatusBar(false);
        g_NonWrappingTextPane1.addCaretListener(new javax.swing.event.CaretListener() {
            @Override
            public void caretUpdate(CaretEvent e) {
                // Update Statu Label
                java.awt.Point p = G_NonWrappingTextPane.getlineof(g_NonWrappingTextPane1, e.getDot());
                java.awt.Point pmax = G_NonWrappingTextPane.getlineof(g_NonWrappingTextPane1, StyledConsole.getLength());
                jLabel1.setText("pos: "
                        + e.getDot() + " / " + StyledConsole.getLength()
                        + "-(" + p.x + "," + p.y + "/" + pmax.y + ")");
                if (g_NonWrappingTextPane1.getSelectionStart() != g_NonWrappingTextPane1.getSelectionEnd()) {
                    int lg = g_NonWrappingTextPane1.getSelectionEnd() - g_NonWrappingTextPane1.getSelectionStart();
                    jLabel1.setText(jLabel1.getText() + ", sel: [" + lg + "]@" + g_NonWrappingTextPane1.getSelectionStart());
                }
                //recolor at the end of a world
                try {
                    if (" ,;)]}\"}\r\n".contains(StyledConsole.getText(e.getDot() - 1, 1))) {
                        (new java.lang.Thread() {
                            @Override
                            public void run() {
                                colorCode();
                                g_NonWrappingTextPane1.repaint();
                            }
                        }).start();
                    }
                } catch (BadLocationException ex) {
                    // System.out.println("caretUpdate()=>"+ex.getMessage());
                    // the P_Text is locked, append when clear()@780
                }
            }
        });

        g_NonWrappingTextPane1.addMouseWheelListener(new java.awt.event.MouseWheelListener() {
            @Override
            public void mouseWheelMoved(java.awt.event.MouseWheelEvent evt) {
                if (evt.isControlDown()) {
                    // change the font Size
                    int fsize = g_NonWrappingTextPane1.getFont().getSize() + evt.getWheelRotation();
                    //    if (fsize>10){
                    int st = g_NonWrappingTextPane1.getFont().getStyle();
                    String name = g_NonWrappingTextPane1.getFont().getFontName();
                    g_NonWrappingTextPane1.setFont(new java.awt.Font(name, st, fsize));
                    ((TextLineNumber) jPanel5).setBorderGap(((TextLineNumber) jPanel5).getBorderGap());
                    initTextAttribute();
                    doLayout();
                }
            }
        });
        //  jSplitPane1.setDividerLocation(this.getPreferredSize().width-150);
    }

    public java.awt.Font[] getFonts() {
        GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
        String[] fontNames = env.getAvailableFontFamilyNames();
        java.awt.Font[] fonts = new java.awt.Font[fontNames.length];
        for (int i = 0; i < fontNames.length; i++) {
            fonts[i] = new java.awt.Font(fontNames[i], java.awt.Font.PLAIN, jComboBox1.getFont().getSize());
        }
        return fonts;
    }

    /**
     * set the Vertical Scrollbar default position is down
     *
     * @param bool if Scroll bar is locked down
     */
    public void setAutoScroll(boolean bool) {
        if (jScrollPane1.getVerticalScrollBar() instanceof G_AutoScrollBar) {
            ((G_AutoScrollBar) jScrollPane1.getVerticalScrollBar()).setAutoScroll(bool);
        } else {
            // no auScrollBar=> not auto Scrolled...
        }
    }

    public boolean isAutoScroll() {
        if (jScrollPane1.getVerticalScrollBar() instanceof G_AutoScrollBar) {
            return ((G_AutoScrollBar) jScrollPane1.getVerticalScrollBar()).isAutoScroll();
        } else {
            // no auScrollBar=> not auto Scrolled...
            return false;
        }
    }

    private int getMaxsize() {
        return (Integer) jSpinner1.getValue();
    }

    public void setEditable(boolean bool) {
        g_NonWrappingTextPane1.setEditable(bool);

    }

    public boolean isEditable() {
        return g_NonWrappingTextPane1.isEditable();
    }

    @Override
    public void setEnabled(boolean bool) {
        g_NonWrappingTextPane1.setEnabled(bool);
        jToolBar1.setEnabled(bool);
        jPanel5.setEnabled(bool);
        jPanel2.setEnabled(bool);
        jLabel2.setEnabled(bool);
    }

    @Override
    public boolean isEnabled() {
        return g_NonWrappingTextPane1.isEditable();
    }

    public void setGlobalBar(boolean bool) {
        if (jToggleButton2.isSelected() != bool) {
            jToggleButton2.setSelected(bool);
        }
        jPanel2.setVisible(bool);
    }

    public boolean isGlobalBar() {
        return jToggleButton2.isSelected();
    }

    public void setLineBar(boolean bool) {
        if (jToggleButton3.isSelected() != bool) {
            jToggleButton3.setSelected(bool);
        }
        jPanel5.setVisible(bool);
    }

    public boolean isLineBar() {
        return jToggleButton3.isSelected();
    }

    public void setStatusBar(boolean bool) {
        if (jToggleButton4.isSelected() != bool) {
            jToggleButton4.setSelected(bool);
        }
        jPanel6.setVisible(bool);
    }

    public boolean isStatusBar() {
        return jToggleButton4.isSelected();
    }

    public void setStatusText(String txt) {
        jLabel2.setText("[" + DocColorType + "]-" + txt);
        jSplitPane1.setDividerLocation(
                jSplitPane1.getWidth()
                - (jLabel1.getFontMetrics(jLabel1.getFont()).stringWidth(jLabel1.getText())
                + 20));
    }

    public void setFile(java.io.File f, ClassLoader cl) {
        if (f == null) {
            setText("Pb null file");
            return;
        }
        int lg = 0;
        try {
            String dir = f.getParent();
            String filename = f.getName();
            java.io.InputStream str = com.jdcm.common.D_Utils.getFileStream(filename, dir, (java.net.URLClassLoader) cl);
            if (str == null) {
                str = TUtils.getFileStream(f);
                if (str == null) {
                    setText("Pb openning file: " + f.toString());
                    return;
                }
            }
            String txt = "";
            try {
                //  int lg = str.available();
                while (str.available() > 0) {
                    byte[] buff = new byte[str.available()];
                    int red = str.read(buff);
                    try {
                        txt += new String(java.util.Arrays.copyOf(buff, red), "US-ASCII");
                    } catch (UnsupportedEncodingException ex) {
                        txt += new String(java.util.Arrays.copyOf(buff, red));
                    }
                }
                setType("");
                setText(txt);
            } catch (IOException ex) {
                setText("Pb reading stream" + ex);
            }
        } catch (Exception ex) {
            setText("Pb openning file[" + lg + "]: " + f.toString() + "=>" + ex.getMessage());
        }
        //DONT  Manage extention
       /* if (f.getName().lastIndexOf(".") > 0 && f.getName().endsWith(".") == false) {
         setType(f.getName().substring(f.getName().lastIndexOf(".") + 1));
         } else {
         setType("");
         }*/
        defaultFile = f;
    }

    public void setFile(java.io.File f) {
        setFile(f, this.getClass().getClassLoader());
    }

    public void setOpenedFile(java.io.File f) {
        defaultFile = f;
    }

    public void setText(String txt) {
        clear();

        insertCode(txt);
        colorCode();
    }

    public javax.swing.JTextPane getTextePane() {
        return g_NonWrappingTextPane1;
    }

    public String getText() {
        try {
            String code = StyledConsole.getText(0, StyledConsole.getLength());
            if (code.length() == 0) {
                return null;
            }
            return code;
        } catch (BadLocationException ex) {
            return null;
        }

    }

    public int getLength() {
        return StyledConsole.getLength();
    }

    private void setTootbox(boolean bool) {
        jToolBar1.setVisible(bool);
    }

    private boolean isTootbox() {
        return jToolBar1.isVisible();
    }

    public void setErrors(int start, int stop) {
        if (start == stop) {
            if (start > 0) {
                start--;
            }
            if (stop < StyledConsole.getLength() - 1) {
                stop++;
            }
        }
        StyledConsole.setCharacterAttributes(start, stop - start, sc.getStyle(getStringType(TYPE_EXTERR)), true);
    }

    public void setDataBase(java.sql.Connection db) {
        dbcx = db;
    }

    private java.util.List<int[]> findZones_SQL(String txtcode) {
        int pos = 0;
        java.util.List<int[]> res = new java.util.ArrayList<>();
        java.util.List<Object[]> hooks = new java.util.ArrayList<>();
        hooks.add(new Object[]{"--", "\n", TYPE_COMENT});
        hooks.add(new Object[]{"/*!", "*/;", TYPE_COMENT});
        hooks.add(new Object[]{"\"", "\"", TYPE_STRING});
        try {
            hooks.add(new Object[]{dbcx.getMetaData().getIdentifierQuoteString(), dbcx.getMetaData().getIdentifierQuoteString(), TYPE_SQLTABLE});
        } catch (SQLException ex) {
            hooks.add(new Object[]{"'", "'", TYPE_SQLTABLE});
        }
        String[] kw = new String[]{"SELECT", "FROM", "WHERE", "JOIN", "ON",
            "GROUP BY", "ORDER BY", "HAVING", "UNION", "PREPARE", "MERGE",
            "DELETE", "CREATE", "INSERT", "UPDATE", "ALTER", "DROP",
            "CONSTRAINT", "LIKE", "ASC", "DESC", "THEN", "WHEN",
            "EXISTS", "AND", "OR", "NOT", "NULL", "AS", "IN"};
        try {
            kw = TUtils.addtab(kw, dbcx.getMetaData().getSQLKeywords().split(","));
        } catch (SQLException ex) {
            System.out.println("findZones_SQL()1=>" + ex.getMessage());
        }
        String[] functions = new String[]{"DISTINCT", "COUNT", "ABS"};
        try {
            functions = TUtils.addtab(functions, dbcx.getMetaData().getStringFunctions().split(","));
            functions = TUtils.addtab(functions, dbcx.getMetaData().getNumericFunctions().split(","));
            functions = TUtils.addtab(functions, dbcx.getMetaData().getSystemFunctions().split(","));
            functions = TUtils.addtab(functions, dbcx.getMetaData().getTimeDateFunctions().split(","));
        } catch (SQLException ex) {
            System.out.println("findZones_SQL()2=>" + ex.getMessage());
        }

        while (pos < txtcode.length()) {
            int newpos = getHooks(hooks, txtcode, pos, res);
            boolean found = newpos != pos;
            pos = newpos;
            String sign = " }{().,;=\n\t";
            for (String key : kw) {
                if (txtcode.length() > pos + key.length() + 1) {
                    if (txtcode.toUpperCase().substring(pos, pos + key.length()).compareTo(key) == 0) {
                        String sub1 = txtcode.toUpperCase().substring(pos + key.length(), pos + key.length() + 1);
                        String sub0 = " ";
                        if (pos > 0) {
                            sub0 = txtcode.toUpperCase().substring(pos - 1, pos);
                        }
                        if (sign.indexOf(sub1) >= 0 && sign.indexOf(sub0) >= 0) {
                            res.add(new int[]{pos, pos + key.length() + 1, TYPE_KEYWORD});
                            pos = pos + key.length() + 1;
                            found = true;
                        }
                    }
                }
            }
            for (String val : functions) {
                if (val != null && val.trim().length() > 0 && txtcode.length() > pos + val.length() + 1) {
                    if (txtcode.toUpperCase().substring(pos, pos + val.length()).compareTo(val) == 0) {
                        String sub1 = txtcode.toUpperCase().substring(pos + val.length(), pos + val.length() + 1);
                        if (sub1.endsWith("(") || sub1.endsWith(" ")) {
                            res.add(new int[]{pos, pos + val.length(), TYPE_SQLFUNCTION});
                            pos = pos + val.length();
                            found = true;
                        }
                    }
                }
            }
            if (found == false) {
                pos++;
            }
        }
        return res;
    }

    private java.util.List<int[]> findZones_INI(String txtcode) {
        int pos = 0;
        txtcode = txtcode + "\r\n";
        java.util.List<int[]> res = new java.util.ArrayList<>();
        while (pos < txtcode.length()) {
            if (pos < txtcode.length() - 2
                    && txtcode.substring(pos, pos + 1).compareTo("[") == 0
                    && txtcode.indexOf("]\r\n", pos) > 0
                    && txtcode.indexOf("]\r\n", pos) < txtcode.indexOf("\r\n", pos)) {
                res.add(new int[]{pos, txtcode.indexOf("\r\n", pos), TYPE_CLASS});
                pos = txtcode.indexOf("]\r\n", pos) + 3;
            } else if (txtcode.indexOf("\r\n", pos) > 0
                    && txtcode.indexOf("=", pos) > 0
                    && txtcode.indexOf("=", pos) < txtcode.indexOf("\r\n", pos)) {
                res.add(new int[]{pos, txtcode.indexOf("=", pos), TYPE_KEYWORD});
                res.add(new int[]{txtcode.indexOf("=", pos), txtcode.indexOf("\r\n", pos), TYPE_VALUE});
                pos = txtcode.indexOf("\r\n", pos) + 2;
            } else if (txtcode.indexOf("\r\n", pos) > 0
                    && txtcode.indexOf("=", pos) < 0) {
                res.add(new int[]{pos, txtcode.indexOf("\r\n", pos), TYPE_KEYWORD});
                pos = txtcode.indexOf("\r\n", pos) + 2;
            } else {
                pos++;
            }
        }
        return res;
    }

    private java.util.List<int[]> findZones_DIR(String txtcode) {
        int pos = 0;
        java.util.List<Object[]> hooks = new java.util.ArrayList<>();
        hooks.add(new Object[]{"DIR", "\r\n", TYPE_XMLATTR});
        String sep = "---------------------";
        java.util.List<int[]> res = new java.util.ArrayList<>();
        while (pos < txtcode.length()) {
            if (pos == 0) {
                if (txtcode.indexOf("\r\n") > 0) {
                    res.add(new int[]{0, txtcode.indexOf("\r\n"), TYPE_CLASS});
                    pos = txtcode.indexOf("\r\n");
                } else {
                    res.add(new int[]{0, txtcode.length() - 1, TYPE_CLASS});
                    pos = txtcode.length();
                }
            } else if (txtcode.indexOf(sep, pos) > 0 && txtcode.substring(0, pos).indexOf(sep) < 0) {
                res.add(new int[]{pos, txtcode.indexOf(sep), TYPE_STRING});
                pos = txtcode.indexOf(sep) + sep.length();
            } else if (txtcode.indexOf("\r\n", pos) > 0) {
                getHooks(hooks, txtcode, pos, res);
                pos = txtcode.indexOf("\r\n", pos) + 2;
            } else {
                pos++;
            }
        }
        return res;
    }

    /**
     * find colorized zones according to - Hooks (ex : //.... - keywords :
     * if/then,... - type int/long... - value :true/false/null/void - other...
     *
     * @param txtcode
     * @return list of zones as int[]:{start, stop , type}
     */
    private int embeddedProto(String htmltag, String proto, int pos, java.util.List<int[]> res, String txtcode) {
        if (pos < txtcode.length() - ("<" + htmltag + ">").length()
                && txtcode.substring(pos, pos + htmltag.length() + 1).toLowerCase().compareTo("<" + htmltag) == 0
                && txtcode.indexOf(">", pos) > 0
                && txtcode.toLowerCase().indexOf("</" + htmltag, pos) > 0) {
            res.add(new int[]{pos + 1, pos + htmltag.length() + 1, TYPE_XMLFIELD});
            int ofset = txtcode.indexOf(">", pos);
            int end = txtcode.toLowerCase().indexOf("</" + htmltag, pos);
            String sprototxt = txtcode.substring(ofset, end);
            java.util.List<int[]> resj;
            if (proto.compareTo("JAVA") == 0) {
                resj = findZones_Java(sprototxt);
            } else if (proto.compareTo("CSS") == 0) {
                resj = findZones_CSS(sprototxt);
            } else {
                resj = new java.util.ArrayList<>();
            }
            for (int[] re : resj) {
                re[0] = re[0] + ofset;
                re[1] = re[1] + ofset;
                res.add(re);
            }
            return end;
        }
        return pos;

    }

    private java.util.List<int[]> findZones_XML(String txtcode) {
        int pos = 0;
        java.util.List<Object[]> hooks = new java.util.ArrayList<>();
        hooks.add(new Object[]{"<!--", "-->", TYPE_COMENT});
        hooks.add(new Object[]{"'", "'", TYPE_STRING});
        hooks.add(new Object[]{"\"", "\"", TYPE_STRING});
        //   hooks.add(new Object[]{"<SCRIPT", "</SCRIPT>", TYPE_ANNOT});
        //   hooks.add(new Object[]{"<script", "</script>", TYPE_ANNOT});
        hooks.add(new Object[]{":", ";", TYPE_VALUE});
        hooks.add(new Object[]{"{", "}", TYPE_VALUE});
        java.util.List<int[]> res = new java.util.ArrayList<>();
        while (pos < txtcode.length()) {
            int newpos = getHooks(hooks, txtcode, pos, res);
            boolean found = newpos != pos;
            pos = newpos;
            if (txtcode.toLowerCase().substring(pos).startsWith("<script")) {
                pos = embeddedProto("script", "JAVA", pos, res, txtcode);
            } else if (txtcode.toLowerCase().substring(pos).startsWith("<style")) {
                pos = embeddedProto("style", "CSS", pos, res, txtcode);
            }
            if (txtcode.substring(pos, pos + 1).compareTo("<") == 0
                    && txtcode.substring(pos, pos + 2).compareTo("<!") != 0) {
                if (txtcode.substring(pos, pos + 2).compareTo("<?") == 0
                        || txtcode.substring(pos, pos + 2).compareTo("</") == 0) {
                    pos = pos + 2;
                } else {
                    pos = pos + 1;
                }
                newpos = pos + 1;
                while (newpos < txtcode.length()
                        && txtcode.substring(newpos, newpos + 1).compareTo(" ") != 0
                        && txtcode.substring(newpos, newpos + 1).compareTo(">") != 0) {
                    newpos++;
                }
                if (newpos < txtcode.length()) {
                    res.add(new int[]{pos, newpos, TYPE_XMLFIELD});
                    found = true;
                    pos = newpos;
                }
            }
            if (txtcode.substring(pos, pos + 1).compareTo(" ") == 0) {
                //               pos=pos+1;
                newpos = pos + 1;
                while (newpos < txtcode.length()
                        && txtcode.substring(newpos, newpos + 1).compareTo("=") != 0
                        && "<>/?".indexOf(txtcode.substring(newpos, newpos + 1)) < 0) {
                    newpos++;
                }
                if (newpos < txtcode.length() && "<>/?".indexOf(txtcode.substring(newpos, newpos + 1)) < 0) {
                    res.add(new int[]{pos, newpos, TYPE_XMLATTR});
                    found = true;
                    pos = newpos;
                }
            }
            if (found == false) {
                pos++;
            }
        }
        return res;
    }

    private java.util.List<int[]> findZones_CSS(String txtcode) {
        int pos = 0;
        java.util.List<int[]> res = new java.util.ArrayList<>();
        while (pos < txtcode.length()) {
            int nxtpar=txtcode.indexOf("{",pos);
            int nxtval=txtcode.indexOf(":",pos);
             int nxtend=txtcode.indexOf(";",pos);
            if (nxtpar>0 &&(nxtpar<nxtval||nxtval<0)
                    &&(nxtpar<nxtend||nxtend<0)){
                res.add(new int[]{pos,nxtpar,TYPE_XMLFIELD});
                pos=nxtpar+1;
            }else if (nxtval>0 &&(nxtval<nxtpar||nxtpar<0)
                &&(nxtval<nxtend||nxtend<0)){
                 res.add(new int[]{pos,nxtval,TYPE_XMLATTR});
                 pos=nxtval+1;
            }else if (nxtend>0&&(nxtend<nxtval||nxtval<0)
                   && (nxtend<nxtpar||nxtpar<0)){
                res.add(new int[]{pos,nxtend,TYPE_VALUE});
                pos=nxtend+1;
            }else{
                pos++;
            }
        }
        return res;
    }

    private java.util.List<int[]> findZones_Java(String txtcode) {
        int pos = 0;
        java.util.List<Object[]> hooks = new java.util.ArrayList<>();
        hooks.add(new Object[]{"/*", "*/", TYPE_COMENT});
        hooks.add(new Object[]{"//", "\n", TYPE_COMENT});
        hooks.add(new Object[]{"@", "\n", TYPE_ANNOT});
        hooks.add(new Object[]{"\"", "\"", TYPE_STRING});
        hooks.add(new Object[]{"\'", "\'", TYPE_STRING});
        final String[] kw = new String[]{"import", "package",
            "extends", "instanceof",
            "public", "private", "static", "final",
            "try", "catch", "private", "import", "return", "throw", "throws", "new",
            "if", "then", "else", "while", "until", "for",
            "this", "instanceof", "super"};
        final String[] types = new String[]{"int", "byte", "long", "char", "var",
            "double", "float", "boolean", "void", "null", "class", "interface"
        };
        final String[] values = new String[]{"true", "false"};
        java.util.List<int[]> res = new java.util.ArrayList<>();

        while (pos < txtcode.length()) {
            int newpos = getHooks(hooks, txtcode, pos, res);
            boolean found = newpos != pos;
            pos = newpos;
            String sign = " }{().,;=\n\t";
            for (String key : kw) {
                if (txtcode.length() > pos + key.length() + 1) {
                    if (txtcode.substring(pos, pos + key.length()).compareTo(key) == 0) {
                        String sub1 = txtcode.substring(pos + key.length(), pos + key.length() + 1);
                        String sub0 = " ";
                        if (pos > 0) {
                            sub0 = txtcode.substring(pos - 1, pos);
                        }
                        if (sign.indexOf(sub1) >= 0 && sign.indexOf(sub0) >= 0) {
                            res.add(new int[]{pos, pos + key.length() + 1, TYPE_KEYWORD});
                            pos = pos + key.length() + 1;
                            found = true;
                        }
                    }
                }
            }
            for (String val : values) {
                if (txtcode.length() > pos + val.length() + 1) {
                    if (txtcode.substring(pos, pos + val.length()).compareTo(val) == 0) {
                        String sub1 = txtcode.substring(pos + val.length(), pos + val.length() + 1);
                        if (sub1.endsWith(";") || sub1.endsWith(" ") || sub1.endsWith(")") || sub1.endsWith(",")) {
                            res.add(new int[]{pos, pos + val.length(), TYPE_VALUE});
                            pos = pos + val.length();
                            found = true;
                        }
                    }
                }
            }
            for (String type : types) {
                if (txtcode.length() > pos + type.length() + 1) {
                    if (txtcode.substring(pos, pos + type.length()).compareTo(type) == 0) {

                        String sub0 = " ", sub1 = " ";
                        if (pos > 0 && pos + type.length() + 1 < txtcode.length()) {
                            sub0 = txtcode.substring(pos - 1, pos);
                            sub1 = txtcode.substring(pos + type.length(), pos + type.length() + 1);
                        }
                        if ((sub0.startsWith("(") && sub1.startsWith(")"))
                                || (sub0.startsWith("(") && sub1.startsWith(" "))
                                || (sub0.startsWith("=") && sub1.startsWith(" "))
                                || sub1.startsWith(" ") || sub1.startsWith(";")) {
                            res.add(new int[]{pos, pos + type.length(), TYPE_TYPE});
                            pos = pos + type.length();
                            found = true;
                        }
                        if (sub1.startsWith("[")) {
                            res.add(new int[]{pos, pos + type.length(), TYPE_TYPE});
                            pos = pos + type.length();
                            found = true;
                        }
                    }
                }
            }
            if (found == false && ((pos > " class ".length() && txtcode.substring(pos - " class ".length(), pos).compareTo(" class ") == 0)
                    || (pos > " interface ".length() && txtcode.substring(pos - " interface ".length(), pos).compareTo(" interface ") == 0))) {
                int end = Math.min(txtcode.substring(pos).indexOf(" "), txtcode.substring(pos).indexOf("{"));
                if (end > 0) {
                    res.add(new int[]{pos, pos + end, TYPE_CLASS});
                    pos = pos + end;
                    found = true;
                }
            }
            if (found == false && pos > 0 && txtcode.indexOf("(", pos) > pos
                    && txtcode.substring(pos, txtcode.indexOf("(", pos)).indexOf(" ") < 0
                    && txtcode.substring(pos, txtcode.indexOf("(", pos)).indexOf("}") < 0
                    && txtcode.substring(pos, txtcode.indexOf("(", pos)).indexOf(")") < 0
                    && txtcode.substring(pos, txtcode.indexOf("(", pos)).indexOf("\"") < 0) {
                int openpar = txtcode.indexOf("(", pos);
                int pos2 = findPairPosition(txtcode, openpar);
                if (pos2 > 0 && txtcode.indexOf("{", pos2) >= 0) {

                    if (txtcode.substring(pos2 + 1, txtcode.indexOf("{", pos2)).trim().length() == 0
                            || (txtcode.indexOf("throws", pos2) > 0
                            && txtcode.substring(pos2 + 1, txtcode.indexOf("throws", pos2)).trim().length() == 0)) {
                        // is an public void meth(){...
                        res.add(new int[]{pos, openpar, TYPE_MYMETHOD});
                    } else {
                        // is an obj.meth()==...
                        String meth = txtcode.substring(pos, openpar);
                        if (meth.split("\\.").length == 0) {
                            res.add(new int[]{pos, openpar, TYPE_METHOD});
                        } else {
                            int start = pos;
                            for (int i = 0; i < meth.split("\\.").length; i++) {
                                int size = meth.split("\\.")[i].length();
                                if (i < meth.split("\\.").length - 1) {
                                    res.add(new int[]{start, start + size, TYPE_OBJECT});
                                    res.add(new int[]{start + size, start + size + 1, TYPE_NORMAL});
                                    start += size + 1;
                                } else {
                                    res.add(new int[]{start, start + size, TYPE_METHOD});
                                    start += size;
                                }

                            }
                        }
                    }
                    pos = openpar;
                    found = true;
                }
            }

            if (found == false) {
                // search for methodes

                // normal
                if (res.isEmpty() || res.get(res.size() - 1)[2] != TYPE_NORMAL) {
                    res.add(new int[]{pos, pos + 1, TYPE_NORMAL});
                } else {
                    res.get(res.size() - 1)[1] = pos + 1;
                }
                pos++;
            }
        }
        return res;
    }

    private int getHooks(java.util.List<Object[]> hooks, String txtcode, int pos, java.util.List<int[]> res) {
        boolean found = false;
        for (Object[] hook : hooks) {
            // to reDO with C_txtClass / T_Utils / see if a java.lang.text... remplace ...
            if (txtcode.length() > pos + hook[0].toString().length()) {
                if (txtcode.substring(pos, pos + hook[0].toString().length()).compareTo(hook[0].toString()) == 0) {
                    int posend = pos + hook[0].toString().length();
                    while (found == false) {
                        if (txtcode.length() < posend + hook[1].toString().length()) {
                            //exit
                            posend = txtcode.length() + 1;
                            found = true;
                            // look for next hook[1] that is not after escape ecpet if an other escape is just before 
                        } else if ((txtcode.substring(posend, posend + hook[1].toString().length()).compareTo(hook[1].toString()) == 0
                                && (escapString == null || (posend > 2 * escapString.length()
                                && (txtcode.substring(posend - escapString.length(), posend).compareTo(escapString) != 0
                                || txtcode.substring(posend - 2 * escapString.length(), posend - escapString.length()).compareTo(escapString) == 0))))
                                || posend == txtcode.length()) {
                            posend = posend + hook[1].toString().length();
                            found = true;
                        } else {
                            posend++;
                        }
                    }
                    if (posend <= txtcode.length()) {
                        res.add(new int[]{pos, posend, (Integer) hook[2]});
                        pos = posend;
                    }
                }
            }
        }
        return pos;
    }

    public String getType() {
        return DocColorType;
    }

    public void setType(String txt) {
        DocColorType = txt.toUpperCase();
        if (DocColorType.endsWith("HTML") || DocColorType.endsWith("XSD")) {
            DocColorType = "XML";
        }
        colorCode();
    }

    public void detectType(String txt) {
        if (DocColorType != null && DocColorType.length() > 0) {
            return;
        }
        if (txt.trim().startsWith("[")
                && txt.trim().indexOf("]\r\n") > 0
                && txt.trim().indexOf("]\r\n") < txt.trim().indexOf("\r\n")) {
            DocColorType = "INI";
        } else if ((txt.trim().startsWith("<?xml")
                || txt.trim().startsWith("<!--"))
                && txt.trim().endsWith(">")) {
            DocColorType = "XML";
        } else if (txt.indexOf(" class ") > 0
                || ((txt.indexOf("{") > 0
                && txt.indexOf("}") > 0))) {
            DocColorType = "JAVA";
            frameCompletion = new F_Completion(DocColorType, g_NonWrappingTextPane1);
        } else if (dbcx != null || txt.toUpperCase().trim().startsWith("SELECT ")) {
            DocColorType = "SQL";
        } else {
            DocColorType = "";
        }
    }

    public String insertCode(String txt) {
        if (StyledConsole == null || g_NonWrappingTextPane1 == null) {
            return null;
        }
        if (txt == null) {
            txt = "no code found";
        }

        try {
            StyledConsole.setLogicalStyle(0, sc.getStyle("TYPE_NORMAL"));
            StyledConsole.insertString(StyledConsole.getLength(), txt, sc.getStyle("TYPE_NORMAL"));
            g_NonWrappingTextPane1.setCaretPosition(0);
            //  if (DocColorType == null || DocColorType.length() == 0) {
            detectType(txt);
            //}
            colorCode();
            return StyledConsole.getText(0, StyledConsole.getLength());
        } catch (BadLocationException ex) {
            try {
                StyledConsole.remove(0, StyledConsole.getLength());
            } catch (BadLocationException exe) {
            }
            //    TDeb.wri("error while displaing text:" + txt);
            return null;
        }
    }

    public void colorCode() {
        if (getText() == null || DocColorType == null) {
            return;
        }
        String txt = getText();
        if (DocColorType.length() == 0) {
            txtlist = new java.util.ArrayList<>();
            txtlist.add(new int[]{0, txt.length(), TYPE_NORMAL});
        } else if (DocColorType.compareTo("STREAM") == 0) {
            return;
        } else if (DocColorType.compareTo("PACK") == 0) {
            return;
        } else if (DocColorType.compareTo("DIR") == 0) {
            txtlist = findZones_DIR(txt);
        } else if (DocColorType.compareTo("INI") == 0) {
            txtlist = findZones_INI(txt);
        } else if (DocColorType.compareTo("XML") == 0) {
            escapString = "\\";
            txtlist = findZones_XML(txt);
        } else if (DocColorType.compareTo("JAVA") == 0) {
            escapString = "\\";
            txtlist = findZones_Java(txt);
        } else if (DocColorType.compareTo("SQL") == 0) {
            escapString = "\\";
            txtlist = findZones_SQL(txt);
        } else {
            txtlist = new java.util.ArrayList<>();
            txtlist.add(new int[]{0, txt.length(), TYPE_NORMAL});

        }
        try {
            for (int[] zone : txtlist) {
                StyledConsole.setCharacterAttributes(zone[0], zone[1] - zone[0], sc.getStyle(getStringType(zone[2])), true);
            }
        } catch (Exception ex) {
            System.err.println("P_Texte : colorCode()" + ex);
        }

    }

    @Override
    public java.awt.Font getFont() {
        if (g_NonWrappingTextPane1 != null) {
            return g_NonWrappingTextPane1.getFont();
        } else {
            return super.getFont();
        }
    }

    public void clear() {
        try {
            StyledConsole.remove(0, StyledConsole.getLength());
            // this.g_NonWrappingTextPane1.setText("");
        } catch (BadLocationException ex) {
            System.err.println("P_Texte:clear()=>" + ex);
        }
    }

    private String getStringType(int val) {
        for (java.lang.reflect.Field fs : this.getClass().getDeclaredFields()) {
            if (fs.getName().startsWith("TYPE_")) {
                try {
                    if (fs.getInt(fs) == val) {
                        return fs.getName();
                    }
                } catch (IllegalArgumentException | IllegalAccessException ex) {
                }
            }
        }
        return "TYPE_NORMAL";
    }

    public int findPairPosition(String txt, int pos) {
        int dir = +1;
        String list = "{([<\"\">])}";
        String open = txt.substring(pos, pos + 1);
        String close;
        int idx = list.indexOf(open);
        if (idx < 0) {
            return -2;
        } else if (idx < list.length() / 2) {
            close = list.substring(list.length() - idx - 1, list.length() - idx);
        } else {
            close = open;
            dir = 0;
            open = list.substring(list.length() - idx - 1, list.length() - idx);
        }
        int res = pos + dir;
        int nb = 1;
        while (nb > 0 && (dir > 0 && res < txt.length()) || (dir == 0 && res >= 0)) {
            int nextisopen = TUtils.nonCommentPos(txt, open, res, dir > 0);
            int nextisclose = TUtils.nonCommentPos(txt, close, res, dir > 0);
            if (nextisopen < 0) {
                nextisopen = dir * (txt.length() + 1);
            }
            if (nextisclose < 0) {
                nextisclose = dir * (txt.length() + 1);
            }
            if (dir > 0) {
                res = Math.min(nextisopen, nextisclose);
            } else {
                res = Math.max(nextisopen, nextisclose);
            }
            if ((res > txt.length() && dir > 0) || (res < 0 && dir == 0)) {
                return -1;
            }
            if ((nextisopen < nextisclose)) {
                nb++;
            } else {
                nb--;
            }
            if (nb == 0) {
                return res;
            }
            res = res + dir;
        }

        return -1;
    }

    private void searchText(String searched) {
        foundSearchedList.clear();
        jTextField1.setForeground(Color.BLACK);
        final String limitcars = "\";,:()<>{}[] =&|.?@\t\r\n+*-/ ";
        if (searched != null & searched.length() > 0 && searched.indexOf("(){}[]<>") < 0) {
            supressExtStyle();
            String txt;
            if (jTextField1.getText().compareTo(searched) != 0) {
                jTextField1.setText(searched);
            }
            int pos = 0;
            try {
                txt = StyledConsole.getText(0, StyledConsole.getLength());
            } catch (BadLocationException ex) {
                return;
            }
            if (!isSearchCase()) {
                txt = txt.toUpperCase();
                searched = searched.toUpperCase();
            }
            while (pos >= 0 && pos < txt.length()) {
                pos = txt.indexOf(searched, pos);
                if (pos >= 0) {
                    if (!isSearchWord()
                            || ((pos == 0 || limitcars.indexOf(txt.substring(pos - 1, pos)) >= 0)
                            && (pos + searched.length() == txt.length()
                            || limitcars.indexOf(txt.substring(pos + searched.length(), pos + searched.length() + 1)) >= 0))) {
                        StyledConsole.setCharacterAttributes(pos, searched.length(), sc.getStyle("TYPE_EXTFIND"), false);
                        foundSearchedList.add(pos);
                    }
                    //if 'aa' in 'aaaaaaa'=> 3 or 6? (for pos++) ?found or distinct found?
                    pos = pos + searched.length();

                }
            }
        } else {
            StyledConsole.setCharacterAttributes(0, g_NonWrappingTextPane1.getText().length(), sc.getStyle("TYPE_EXTNONE"), false);
        }
        jButton3.setEnabled(!foundSearchedList.isEmpty());
        jButton4.setEnabled(!foundSearchedList.isEmpty());
        if (foundSearchedList.isEmpty()) {
            jTextField1.setForeground(Color.red);
        }
    }

    private void supressExtStyle() {
        try {
            StyledConsole.setCharacterAttributes(0, g_NonWrappingTextPane1.getText().length(), sc.getStyle("TYPE_EXTNONE"), false);
        } catch (Exception ex) {
        }
    }

    private void initTextAttribute() {
        sc = StyleContext.getDefaultStyleContext();
        // Create and add the main document style
        Style defaultStyle = sc.getStyle(StyleContext.DEFAULT_STYLE);
        //  final Style mainStyle = sc.addStyle("MainStyle", defaultStyle);
        // StyleConstants.setLeftIndent(mainStyle, 16);
        // StyleConstants.setRightIndent(mainStyle, 16);
        //StyleConstants.setFirstLineIndent(mainStyle, 16);
        StyleConstants.setFontFamily(defaultStyle, g_NonWrappingTextPane1.getFont().getFamily());
        StyleConstants.setFontSize(defaultStyle, g_NonWrappingTextPane1.getFont().getSize());

        for (java.lang.reflect.Field fs : this.getClass().getDeclaredFields()) {
            int type = -1;
            if (fs.getName().startsWith("TYPE_")) {
                final Style theStyle = sc.addStyle(fs.getName(), defaultStyle);
                StyleConstants.setAlignment(theStyle, StyleConstants.ALIGN_LEFT);
                try {
                    type = fs.getInt(fs);
                    // while (type >= myStyles.size()) {
                    // myStyles.add(new SimpleAttributeSet());
                    // }
                } catch (IllegalArgumentException | IllegalAccessException ex) {
                }
                if (type >= TYPE_EXTNONE) {
                    if (type == TYPE_EXTNONE) {
                        StyleConstants.setBackground(theStyle, g_NonWrappingTextPane1.getBackground());
                    } else if (type == TYPE_EXTBRACEOK) {
                        StyleConstants.setBackground(theStyle, java.awt.Color.yellow);
                    } else if (type == TYPE_EXTBRACENOK) {
                        StyleConstants.setBackground(theStyle, java.awt.Color.red);
                    } else if (type == TYPE_EXTFIND) {
                        StyleConstants.setBackground(theStyle, java.awt.Color.ORANGE);
                    } else if (type == TYPE_EXTERR) {
                        StyleConstants.setBackground(theStyle, java.awt.Color.red.brighter());
                    }
                } else {
                    //defaut : TYPE_NORMAL
                    StyleConstants.setBold(theStyle, false);
                    StyleConstants.setItalic(theStyle, false);
                    StyleConstants.setForeground(theStyle, g_NonWrappingTextPane1.getForeground());
                    if (type == TYPE_COMENT) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.gray);
                    } else if (type == TYPE_KEYWORD || type == TYPE_XMLFIELD) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.blue);
                    } else if (type == TYPE_ANNOT) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.YELLOW.darker());
                    } else if (type == TYPE_XMLATTR) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.green.darker());
                    } else if (type == TYPE_STRING) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.ORANGE.darker());
                    } else if (type == TYPE_TYPE || type == TYPE_SQLFUNCTION) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.blue.darker());
                    } else if (type == TYPE_VALUE) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.blue.darker());
                    } else if (type == TYPE_MYMETHOD || type == TYPE_SQLTABLE) {
                        StyleConstants.setBold(theStyle, true);
                    } else if (type == TYPE_METHOD) {
                        StyleConstants.setItalic(theStyle, true);

                        //   StyleConstants.setIcon(myAttributeSet, TUtils.getIcon("Classes.gif"));
                    } else if (type == TYPE_OBJECT) {
                        //  StyleConstants.setUnderline(myAttributeSet, true);
                        StyleConstants.setForeground(theStyle, java.awt.Color.black);
                        StyleConstants.setItalic(theStyle, true);
                    } else if (type == TYPE_CLASS) {
                        StyleConstants.setForeground(theStyle, java.awt.Color.MAGENTA.darker());
                        StyleConstants.setBold(theStyle, true);
                    }
                }
            }
        }
    }

    final class globalPanel extends JPanel {

        private static final long serialVersionUID = 1L;

        public globalPanel() {
            super();
        }

        @Override
        public void paintComponent(Graphics g) {
            java.awt.Rectangle rect = jScrollPane1.getViewport().getBounds();
            int margt = rect.y;
            int margb = jScrollPane1.getHeight() - rect.height; // include vertical scrollbar
            if (jScrollPane1.getVerticalScrollBar().isVisible()) {
                // find up & down button height for bar calliber
                Component btn = jScrollPane1.getVerticalScrollBar().getComponentAt(0, 0);
                if (btn != null) {
                    margt = btn.getHeight();
                }
                btn = jScrollPane1.getVerticalScrollBar().getComponentAt(1, jScrollPane1.getVerticalScrollBar().getHeight() - 1);
                if (btn != null) {
                    margb = margb + btn.getHeight();
                }
            }
            int global_width = getWidth();
            int cliph = getHeight() - (margt + margb);
            if (cliph < 0) {
                return;
            }
            g.clearRect(0, 0, global_width, getHeight());
            g.setColor(SystemColor.scrollbar);
            g.fillRect(0, 0, global_width, margt);
            g.fillRect(0, cliph + margt, global_width, getHeight() - (cliph + margt));
            g.setColor(SystemColor.windowBorder);
            g.drawLine(0, margt, 0, getHeight() - margb);
            g.drawLine(0, margt - 1, global_width, margt - 1);
            if (!markedLines.isEmpty()) {
                int maxline = g_NonWrappingTextPane1.getDocument().getDefaultRootElement().getElementCount();
                // int maxline = StyledConsole.getDefaultRootElement().getElementCount();
                if (maxline > 1) {
                    for (int line : markedLines.keySet()) {
                        try {
                            float interv = ((float) cliph) / (maxline);
                            int marky = margt + Math.round((line - 1) * interv);
                            g.setColor(markedLines.get(line));
                            int hbar = 2;
                            if (interv > hbar) {
                                hbar = Math.round(interv);
                            }
                            g.fillRect(0, marky, global_width, hbar);
                        } catch (Exception ex) {
                            System.out.println("P_Texte.GlobalPanel.PaintCompnent() : test");
                        }
                    }
                }
            }
        }
    }

    /**
     * http://tips4java.wordpress.com/2009/05/23/text-component-line-number/
     *
     */
    final class TextLineNumber extends JPanel implements CaretListener, DocumentListener, PropertyChangeListener {

        private static final long serialVersionUID = 1L;
        private final static int HEIGHT = Integer.MAX_VALUE - 1000000;
        public final static float LEFT = 0.0f;
        public final static float CENTER = 0.5f;
        public final static float RIGHT = 1.0f;
        //private final static Border OUTER = new MatteBorder(0, 0, 0, 2, Color.GRAY);
        //  Text component this TextTextLineNumber component is in sync with
        //  Properties that can be changed
        private boolean updateFont;
        private int borderGap;
        private Color currentLineForeground;
        private float digitAlignment;
        private int minimumDisplayDigits;
        //  Keep history information to reduce the number of times the component
        //  needs to be repainted
        private int lastDigits;
        private int lastHeight;
        private int lastLine;
        private HashMap<String, FontMetrics> fonts;
        Rectangle clip = null;

        /**
         * Create a line number component for a text component. This minimum
         * display width will be based on 3 digits.
         *
         * @param component the related text component
         */
        public TextLineNumber() {
            this(2);
        }

        /**
         * Create a line number component for a text component.
         *
         * @param component the related text component
         * @param minimumDisplayDigits the number of digits used to calculate
         * the minimum width of the component
         */
        public TextLineNumber(int minimumDisplayDigits) {

            setFont(g_NonWrappingTextPane1.getFont());

            setBorderGap(5);
            setCurrentLineForeground(Color.RED);
            setDigitAlignment(RIGHT);
            setMinimumDisplayDigits(minimumDisplayDigits);

            g_NonWrappingTextPane1.getDocument().addDocumentListener(this);
            g_NonWrappingTextPane1.addCaretListener(this);
            jScrollPane1.getViewport().addChangeListener(new javax.swing.event.ChangeListener() {
                @Override
                public void stateChanged(ChangeEvent e) {
                    //   System.out.print("property:");
                    jPanel5.repaint();
                }
            });
            /*
             * g_NonWrappingTextPane1.addPropertyChangeListener(new
             * PropertyChangeListener() { public void
             * propertyChange(PropertyChangeEvent e) {
             * System.out.println("property:"+e.getPropertyName()+":
             * "+e.getOldValue()+"=>"+e.getNewValue()); }});
             */

            g_NonWrappingTextPane1.addPropertyChangeListener("font", this);
            addMouseListener(new java.awt.event.MouseAdapter() {
                int mousePressed = -1;

                @Override
                public void mousePressed(MouseEvent evt) {
                    mousePressed = evt.getY();
                    setMark(getLine(evt.getY()), evt.getButton());
                    repaint();
                }

                @Override
                public void mouseDragged(MouseEvent evt) {
                    // MOUSE DRAG DON'T WORKS ??? !!!
                    if (mousePressed >= 0) {
                        setMarks(mousePressed, evt.getY(), -1);
                        repaint();
                    }
                }

                @Override
                public void mouseReleased(MouseEvent evt) {
                    if (mousePressed >= 0) {
                        setMarks(mousePressed, evt.getY(), evt.getButton());
                        repaint();
                        mousePressed = -1;
                    }
                }
            });

            g_NonWrappingTextPane1.addAfterPaintListner(
                    new com.jdcm.common.G_NonWrappingTextPane.AfterPaintEventListner() {
                        @Override
                        public void afterPaintComponent(Graphics g) {
                            drawMarks(g);
                        }
                    });

        }

        /**
         * Gets the update font property
         *
         * @return the update font property
         */
        public boolean getUpdateFont() {
            return updateFont;
        }

        /**
         * Set the update font property. Indicates whether this Font should be
         * updated automatically when the Font of the related text component is
         * changed.
         *
         * @param updateFont when true update the Font and repaint the line
         * numbers, otherwise just repaint the line numbers.
         */
        public void setUpdateFont(boolean updateFont) {
            this.updateFont = updateFont;
        }

        /**
         * Gets the border gap
         *
         * @return the border gap in pixels
         */
        public int getBorderGap() {
            return borderGap;
        }

        /**
         * The border gap is used in calculating the left and right insets of
         * the border. Default value is 5.
         *
         * @param borderGap the gap in pixels
         */
        public void setBorderGap(int borderGapval) {
            borderGap = borderGapval;
            javax.swing.border.Border inner = new javax.swing.border.EmptyBorder(0, borderGap, 0, borderGap);
            setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.MatteBorder(0, 0, 0, 2, Color.GRAY), inner));
            lastDigits = 0;
            setPreferredWidth();
        }

        /**
         * Gets the current line rendering Color
         *
         * @return the Color used to render the current line number
         */
        public Color getCurrentLineForeground() {
            return currentLineForeground == null ? getForeground() : currentLineForeground;
        }

        /**
         * The Color used to render the current line digits. Default is
         * Coolor.RED.
         *
         * @param currentLineForeground the Color used to render the current
         * line
         */
        public void setCurrentLineForeground(Color currentLineForeground) {
            this.currentLineForeground = currentLineForeground;
        }

        /**
         * Gets the digit alignment
         *
         * @return the alignment of the painted digits
         */
        public float getDigitAlignment() {
            return digitAlignment;
        }

        /**
         * Specify the horizontal alignment of the digits within the component.
         * Common values would be: <ul> <li>TextLineNumber.LEFT
         * <li>TextLineNumber.CENTER <li>TextLineNumber.RIGHT (default) </ul>
         *
         * @param currentLineForeground the Color used to render the current
         * line
         */
        public void setDigitAlignment(float digitAlignment) {
            this.digitAlignment
                    = digitAlignment > 1.0f ? 1.0f : digitAlignment < 0.0f ? -1.0f : digitAlignment;
        }

        /**
         * Gets the minimum display digits
         *
         * @return the minimum display digits
         */
        public int getMinimumDisplayDigits() {
            return minimumDisplayDigits;
        }

        /**
         * Specify the mimimum number of digits used to calculate the preferred
         * width of the component. Default is 3.
         *
         * @param minimumDisplayDigits the number digits used in the preferred
         * width calculation
         */
        public void setMinimumDisplayDigits(int minimumDisplayDigits) {
            this.minimumDisplayDigits = minimumDisplayDigits;
            setPreferredWidth();
        }

        /**
         * Calculate the width needed to display the maximum line number
         */
        private void setPreferredWidth() {
            Element root = g_NonWrappingTextPane1.getDocument().getDefaultRootElement();
            int lines = root.getElementCount();
            int digits = Math.max(String.valueOf(lines).length(), minimumDisplayDigits);
            //  Update sizes when number of digits in the line number changes
            if (lastDigits != digits) {
                lastDigits = digits;
                FontMetrics fontMetrics = getFontMetrics(g_NonWrappingTextPane1.getFont());
                int width = fontMetrics.charWidth('0') * digits;
                Insets insets = getInsets();
                int preferredWidth = insets.left + insets.right + width;
                Dimension d = getPreferredSize();
                d.setSize(preferredWidth, HEIGHT);
                setPreferredSize(d);
                if (getParent() != null) {
                    getParent().doLayout();
                }
            }
        }

        public void setMark(int linenb, int button) {
            if (linenb < 0) {
                return;
            }
            if (button == -1 && markedLines.containsKey(linenb) == false) {
                markedLines.put(linenb, Color.ORANGE);
                repaint();
                return;
            }
            if (markedLines.containsKey(linenb)) {
                markedLines.remove(linenb);
                g_NonWrappingTextPane1.repaint();
            } else {
                if (button > COLORS_MARK.length) {
                    markedLines.put(linenb, COLORS_MARK[COLORS_MARK.length - 1]);
                } else {
                    markedLines.put(linenb, COLORS_MARK[button - 1]);
                }
            }
            repaint();
        }

        public void drawMarks(Graphics g) {
            Color temp = g.getColor();
            for (int line : markedLines.keySet()) {
                try {
                    int pos1 = g_NonWrappingTextPane1.modelToView(g_NonWrappingTextPane1.getDocument().getDefaultRootElement().getElement(line - 1).getStartOffset()).y;
                    int pos2 = pos1 + g_NonWrappingTextPane1.getFontMetrics(g_NonWrappingTextPane1.getFont()).getHeight();
                    if (line < g_NonWrappingTextPane1.getDocument().getDefaultRootElement().getElementCount()) {
                        pos2 = g_NonWrappingTextPane1.modelToView(g_NonWrappingTextPane1.getDocument().getDefaultRootElement().getElement(line).getStartOffset()).y;
                    }
                    g.setColor(markedLines.get(line));
                    g.fillRoundRect(g.getClipBounds().x, pos1, g.getClipBounds().width, pos2 - pos1, 4, 4);
                } catch (BadLocationException ex) {
                    System.out.println("P_Texte : drawMarks()=>" + ex.getMessage());
                }
            }
            g.setColor(temp);
        }

        public int getLine(int yClick) {
            if (clip == null || g_NonWrappingTextPane1.getText().length() == 0) {
                return -1;
            }
            //  Determine the rows to draw within the clipped bounds.
            int index = g_NonWrappingTextPane1.viewToModel(new Point(0, clip.y + yClick));
            return this.getTextLineNumber(index);
        }

        @Override
        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            //	Determine the width of the space available to draw the line number
            FontMetrics fontMetrics = g_NonWrappingTextPane1.getFontMetrics(g_NonWrappingTextPane1.getFont());
            Insets insets = getInsets();
            int availableWidth = getSize().width - insets.left - insets.right;

            //  Determine the rows to draw within the clipped bounds.
            clip = jScrollPane1.getViewport().getViewRect();
            // Pb null exception with FlowStrategie??...
            int rowStartOffset, endOffset, theLine, stopLine;
            try {
                rowStartOffset = g_NonWrappingTextPane1.viewToModel(new Point(0, clip.y));
                endOffset = g_NonWrappingTextPane1.viewToModel(new Point(0, clip.y + clip.height));
            } catch (Exception ex) {
                System.err.println("Pb while ViewToModel()");
                return;
            }
            if (rowStartOffset >= 0 && endOffset >= 0 && rowStartOffset <= endOffset) {
                java.awt.Font f = g_NonWrappingTextPane1.getFont();
                java.awt.Font f_bold = new java.awt.Font(f.getFontName(), java.awt.Font.BOLD, f.getSize());
                theLine = getTextLineNumber(rowStartOffset);
                stopLine = getTextLineNumber(endOffset);
                while (theLine <= stopLine) {
                    try {
                        if (isCurrentLine(theLine)) {
                            g.setColor(getCurrentLineForeground());
                            g.setFont(f_bold);
                        } else {
                            g.setColor(getForeground());
                            g.setFont(f);
                        }
                        if (!isEnabled()) {
                            g.setColor(java.awt.Color.gray);
                        }
                        //get psition of the number
                        int stringWidth = fontMetrics.stringWidth("" + theLine);
                        int x = getOffsetX(availableWidth, stringWidth) + insets.left;
                        int y = getOffsetY(theLine, fontMetrics);
                        g.drawString("" + theLine, x, y);
                        if (markedLines.containsKey(theLine)) {
                            g.setColor(markedLines.get(theLine));
                            g.fillRoundRect(g.getClipBounds().x, y - fontMetrics.getAscent(), getInsets().left, fontMetrics.getHeight(), getInsets().left, getInsets().left);
                        }
                        theLine++;
                    } catch (BadLocationException ex) {
                        System.out.println("P_Texte : paintComponent()=>" + ex.getMessage());
                    }
                }
            }
            g.setColor(this.getBackground().darker());
            g.drawLine(0, g.getClip().getBounds().height - 1, g.getClip().getBounds().width, g.getClip().getBounds().height - 1);
            g_NonWrappingTextPane1.repaint();
            jPanel2.repaint();
        }

        /*
         * We need to know if the caret is currently positioned on the line we
         * are about to paint so the line number can be highlighted.
         */
        private boolean isCurrentLine(int lineNumber) {
            int caretPosition = g_NonWrappingTextPane1.getCaretPosition();
            Element root = g_NonWrappingTextPane1.getDocument().getDefaultRootElement();
            return lineNumber == root.getElementIndex(caretPosition) + 1;
        }

        /*
         * Get the line number (starting with 1) to be drawn. The empty string will be returned
         * when a line of text has wrapped.
         */
        protected int getTextLineNumber(int rowStartOffset) {
            Element root = g_NonWrappingTextPane1.getDocument().getDefaultRootElement();
            int res = root.getElementIndex(rowStartOffset);
            if (res >= 0) {
                return res + 1;
            } else {
                return res;
            }
        }

        /*
         * Determine the X offset to properly align the line number when drawn
         */
        private int getOffsetX(int availableWidth, int stringWidth) {
            return (int) ((availableWidth - stringWidth) * digitAlignment);
        }

        /*
         * Determine the Y offset for the current row
         */
        private int getOffsetY(int lineNumber, FontMetrics fontMetrics)
                throws BadLocationException {
            //  Get the bounding rectangle of the row
            Element root = g_NonWrappingTextPane1.getDocument().getDefaultRootElement();
            int rowStartOffset = root.getElement(lineNumber - 1).getStartOffset();

            Rectangle r = g_NonWrappingTextPane1.modelToView(rowStartOffset);
            int lineHeight = fontMetrics.getHeight();
            clip = jScrollPane1.getViewport().getViewRect();
            int y = r.y + r.height - clip.y;
            int descent = 0;

            //  The text needs to be positioned above the bottom of the bounding
            //  rectangle based on the descent of the font(s) contained on the row.
            if (r.height == lineHeight) { // default font is being used
                descent = fontMetrics.getDescent();
            }
            return y - descent;
        }

//
//  Implement CaretListener interface
//
        @Override
        public void caretUpdate(CaretEvent e) {
            //  Get the line the caret is positioned on

            int caretPosition = g_NonWrappingTextPane1.getCaretPosition();
            Element root = g_NonWrappingTextPane1.getDocument().getDefaultRootElement();
            int currentLine = root.getElementIndex(caretPosition);

            //  Need to repaint so the correct line number can be highlighted
            if (lastLine != currentLine) {
                lastLine = currentLine;
                repaint();

            }
        }

//
//  Implement DocumentListener interface
//
        @Override
        public void changedUpdate(DocumentEvent e) {
            documentChanged();
        }

        @Override
        public void insertUpdate(DocumentEvent e) {
            documentChanged();
        }

        @Override
        public void removeUpdate(DocumentEvent e) {
            documentChanged();
        }

        /*
         * A document change may affect the number of displayed lines of text.
         * Therefore the lines numbers will also change.
         */
        private void documentChanged() {
            //  Preferred size of the component has not been updated at the time
            //  the DocumentEvent is fired
            SwingUtilities.invokeLater(new Runnable() {
                @Override
                public void run() {
                    int preferredHeight;
                    try {
                        preferredHeight = g_NonWrappingTextPane1.getPreferredSize().height;
                    } catch (Exception ex) {
                        return;
                    }
                    //  Document change has caused a change in the number of lines.
                    //  Repaint to reflect the new line numbers

                    if (preferredHeight > 0 && lastHeight != preferredHeight) {
                        setPreferredWidth();// => care cut line
                        repaint();
                        lastHeight = preferredHeight;
                    }
                }
            });
        }

//
//  Implement PropertyChangeListener interface
//
        @Override
        public void propertyChange(PropertyChangeEvent evt) {
            if (evt.getNewValue() instanceof Font) {
                if (updateFont) {
                    Font newFont = (Font) evt.getNewValue();
                    setFont(newFont);
                    lastDigits = 0;
                    // setPreferredWidth();// => care cut line
                } else {
                    repaint();
                }
            }
        }

        private void setMarks(int pressedY1, int pressedY2, int btn) {
            int line1 = getLine(pressedY1);
            int line2 = getLine(pressedY2);
            if (line1 > line2) {
                int tmp = line1;
                line1 = line2;
                line2 = tmp;
            }
            // CLEAR ALL TEMP 
            for (Entry<Integer, Color> e : markedLines.entrySet()) {
                if (e.getValue().equals(Color.ORANGE)) {
                    markedLines.remove(e.getKey());
                }
            }
            //DRAW NEW TEMP OR FINALS
            for (int i = line1; i <= line2; i++) {
                if (i != getLine(pressedY1)) {
                    setMark(i, btn);
                }
            }

        }
    }

    private void gotoPosition(int pos, int size) {
        g_NonWrappingTextPane1.setSelectionStart(pos);
        g_NonWrappingTextPane1.setSelectionEnd(pos + size);
    }

    private void findNext(boolean bool) {
        if (foundSearchedList.isEmpty() || jTextField1.getText() == null || jTextField1.getText().length() == 0) {
            return;
        }
        int initpos = g_NonWrappingTextPane1.getCaretPosition();
        if (g_NonWrappingTextPane1.getSelectionStart() >= 0 && g_NonWrappingTextPane1.getSelectionStart() < initpos) {
            initpos = g_NonWrappingTextPane1.getSelectionStart();
        }
        if (bool) {
            if (initpos >= foundSearchedList.getLast()) {
                gotoPosition(foundSearchedList.getFirst(), jTextField1.getText().length());
                return;
            }
        } else {
            if (initpos <= foundSearchedList.get(0)) {
                gotoPosition(foundSearchedList.getLast(), jTextField1.getText().length());
                return;
            } else if (initpos > foundSearchedList.getLast()) {
                gotoPosition(foundSearchedList.getLast(), jTextField1.getText().length());
                return;
            }
        }
        for (int i : foundSearchedList) {
            if (bool && i > initpos) {
                gotoPosition(i, jTextField1.getText().length());
                return;
            } else if (!bool && i >= initpos) {
                int prev = foundSearchedList.get(foundSearchedList.indexOf(i) - 1);
                gotoPosition(prev, jTextField1.getText().length());
                return;
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jTextField1 = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jButton2 = new javax.swing.JButton();
        jToggleButton3 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jToggleButton4 = new javax.swing.JToggleButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        jSpinner1 = new javax.swing.JSpinner();
        jButton5 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        g_NonWrappingTextPane1 = new com.jdcm.common.G_NonWrappingTextPane();
        jPanel2 = new globalPanel();
        jPanel5 = new TextLineNumber();
        jPanel6 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        jMenuItem1.setText("Copy");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        jMenuItem2.setText("Cut");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem2);

        jMenuItem3.setText("Paste");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem3);

        jMenuItem4.setText("Detect");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem4);

        setPreferredSize(new java.awt.Dimension(479, 187));
        setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);

        jButton1.setToolTipText("Save");
        jButton1.setBorderPainted(false);
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jTextField1.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jTextField1.setToolTipText("Search");
        jTextField1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jTextField1.setMaximumSize(new java.awt.Dimension(100, 20));
        jTextField1.setMinimumSize(new java.awt.Dimension(100, 14));
        jTextField1.setPreferredSize(new java.awt.Dimension(2, 10));
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField1KeyReleased(evt);
            }
        });
        jToolBar1.add(jTextField1);

        jButton4.setToolTipText("previous");
        jButton4.setBorderPainted(false);
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setMargin(new java.awt.Insets(1, 2, 1, 2));
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton4);

        jButton3.setToolTipText("next");
        jButton3.setBorderPainted(false);
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setMargin(new java.awt.Insets(1, 2, 1, 2));
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jCheckBox1.setText("word");
        jCheckBox1.setFocusable(false);
        jCheckBox1.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        jCheckBox1.setMaximumSize(new java.awt.Dimension(81, 20));
        jCheckBox1.setMinimumSize(new java.awt.Dimension(20, 16));
        jCheckBox1.setPreferredSize(new java.awt.Dimension(30, 23));
        jCheckBox1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jCheckBox1);

        jCheckBox2.setText("case");
        jCheckBox2.setFocusable(false);
        jCheckBox2.setMaximumSize(new java.awt.Dimension(81, 20));
        jCheckBox2.setMinimumSize(new java.awt.Dimension(20, 16));
        jCheckBox2.setPreferredSize(new java.awt.Dimension(30, 23));
        jCheckBox2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jCheckBox2);

        jButton2.setToolTipText("Colors");
        jButton2.setBorderPainted(false);
        jButton2.setEnabled(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jToggleButton3.setSelected(true);
        jToggleButton3.setToolTipText("LineBar");
        jToggleButton3.setBorderPainted(false);
        jToggleButton3.setFocusable(false);
        jToggleButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton3.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton3);

        jToggleButton2.setSelected(true);
        jToggleButton2.setToolTipText("GlobalBar");
        jToggleButton2.setBorderPainted(false);
        jToggleButton2.setFocusable(false);
        jToggleButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton2);

        jToggleButton4.setToolTipText("StatusBar");
        jToggleButton4.setBorderPainted(false);
        jToggleButton4.setFocusable(false);
        jToggleButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton4.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jToggleButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton4);

        jToggleButton1.setToolTipText("Word Wrap");
        jToggleButton1.setBorderPainted(false);
        jToggleButton1.setFocusable(false);
        jToggleButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        jComboBox1.setToolTipText("Font selection");
        jComboBox1.setMaximumSize(new java.awt.Dimension(150, 20));
        jComboBox1.setMinimumSize(new java.awt.Dimension(50, 20));
        jComboBox1.setPreferredSize(new java.awt.Dimension(100, 20));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jComboBox1);

        jSpinner1.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(100000), null, null, Integer.valueOf(1000)));
        jSpinner1.setToolTipText("max size");
        jSpinner1.setMaximumSize(new java.awt.Dimension(100, 20));
        jSpinner1.setMinimumSize(new java.awt.Dimension(62, 16));
        jSpinner1.setPreferredSize(new java.awt.Dimension(62, 16));
        jToolBar1.add(jSpinner1);

        jButton5.setBorderPainted(false);
        jButton5.setFocusable(false);
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton5.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton5);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        g_NonWrappingTextPane1.setComponentPopupMenu(jPopupMenu1);
        g_NonWrappingTextPane1.addMouseWheelListener(new java.awt.event.MouseWheelListener() {
            public void mouseWheelMoved(java.awt.event.MouseWheelEvent evt) {
                g_NonWrappingTextPane1MouseWheelMoved(evt);
            }
        });
        g_NonWrappingTextPane1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                g_NonWrappingTextPane1MouseClicked(evt);
            }
        });
        g_NonWrappingTextPane1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                g_NonWrappingTextPane1KeyReleased(evt);
            }
        });
        jScrollPane1.setViewportView(g_NonWrappingTextPane1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel2.setMaximumSize(new java.awt.Dimension(7, 32767));
        jPanel2.setMinimumSize(new java.awt.Dimension(7, 100));
        jPanel2.setPreferredSize(new java.awt.Dimension(7, 100));
        jPanel2.setLayout(new java.awt.BorderLayout());
        add(jPanel2, java.awt.BorderLayout.EAST);

        jPanel5.setMinimumSize(new java.awt.Dimension(15, 0));
        jPanel5.setPreferredSize(new java.awt.Dimension(30, 5));
        jPanel5.setLayout(new java.awt.BorderLayout());
        add(jPanel5, java.awt.BorderLayout.WEST);

        jPanel6.setMaximumSize(new java.awt.Dimension(32767, 25));
        jPanel6.setPreferredSize(new java.awt.Dimension(548, 20));
        jPanel6.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setBorder(null);
        jSplitPane1.setDividerLocation(400);

        jLabel1.setText("[X,Y]/p");
        jLabel1.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jSplitPane1.setRightComponent(jLabel1);

        jLabel2.setText("Status");
        jLabel2.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        jSplitPane1.setLeftComponent(jLabel2);

        jPanel6.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        add(jPanel6, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        String filename = TUtils.getUIsaveFile(this, true, defaultFile);
        if (filename == null || filename.length() == 0) {
            return;
        }
        try {
            try (java.io.FileOutputStream o = new java.io.FileOutputStream(filename)) {
                o.write(this.getText().getBytes());
            }
        } catch (IOException ex) {
            System.out.println("P_Texte : jButton1ActionPerformed()=>" + ex.getMessage());
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        searchText(jTextField1.getText());
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // colors  should be a style definition panel...:
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        findNext(false);
        searchText(jTextField1.getText());//???
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        findNext(true);
        searchText(jTextField1.getText());//???
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jTextField1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyReleased
        searchText(jTextField1.getText());
    }//GEN-LAST:event_jTextField1KeyReleased

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        searchText(jTextField1.getText());
    }//GEN-LAST:event_jCheckBox1ActionPerformed

    private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox2ActionPerformed
        searchText(jTextField1.getText());
    }//GEN-LAST:event_jCheckBox2ActionPerformed

    private void g_NonWrappingTextPane1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_g_NonWrappingTextPane1KeyReleased
        if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ESCAPE) {
            setTootbox(!isTootbox());
        } else if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_F && evt.isControlDown()) {
            setTootbox(true);
            // just for focus : jTextField1.?
        }
    }//GEN-LAST:event_g_NonWrappingTextPane1KeyReleased

    private void g_NonWrappingTextPane1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_g_NonWrappingTextPane1MouseClicked
        if (evt.getClickCount() == 2) {
            String txt = g_NonWrappingTextPane1.getSelectedText();
            if (txt != null && txt.trim().length() > 0) {
                searchText(txt);
            }
        }
    }//GEN-LAST:event_g_NonWrappingTextPane1MouseClicked

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        setGlobalBar(isGlobalBar());
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
        setLineBar(isLineBar());
    }//GEN-LAST:event_jToggleButton3ActionPerformed

    private void jToggleButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton4ActionPerformed
        setStatusBar(isStatusBar());
    }//GEN-LAST:event_jToggleButton4ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        if (jComboBox1.getSelectedItem() != null && jComboBox1.getSelectedItem() instanceof java.awt.Font) {
            java.awt.Font ft = (java.awt.Font) jComboBox1.getSelectedItem();
            g_NonWrappingTextPane1.setFont(new java.awt.Font(ft.getFamily(), g_NonWrappingTextPane1.getFont().getStyle(), g_NonWrappingTextPane1.getFont().getSize()));
            initTextAttribute();
            doLayout();
        }
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        setTootbox(false);
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        java.awt.datatransfer.Clipboard clip = Toolkit.getDefaultToolkit().getSystemClipboard();
        java.awt.datatransfer.StringSelection sl = new java.awt.datatransfer.StringSelection(g_NonWrappingTextPane1.getSelectedText());
        clip.setContents(sl, null);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        java.awt.datatransfer.Clipboard clip = Toolkit.getDefaultToolkit().getSystemClipboard();
        java.awt.datatransfer.StringSelection sl = new java.awt.datatransfer.StringSelection(g_NonWrappingTextPane1.getSelectedText());
        clip.setContents(sl, null);
        g_NonWrappingTextPane1.setText(g_NonWrappingTextPane1.getText().substring(0,
                g_NonWrappingTextPane1.getSelectionStart())
                + g_NonWrappingTextPane1.getText().substring(g_NonWrappingTextPane1.getSelectionEnd()));
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        java.awt.datatransfer.Clipboard clip = Toolkit.getDefaultToolkit().getSystemClipboard();
        java.awt.datatransfer.Transferable tr = clip.getContents(null);
        String txt;
        try {
            txt = (String) tr.getTransferData(java.awt.datatransfer.DataFlavor.stringFlavor);
        } catch (UnsupportedFlavorException | IOException ex) {
            return;
        }
        g_NonWrappingTextPane1.setText(g_NonWrappingTextPane1.getText().substring(0,
                g_NonWrappingTextPane1.getSelectionStart())
                + txt
                + g_NonWrappingTextPane1.getText().substring(g_NonWrappingTextPane1.getSelectionEnd()));
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        g_NonWrappingTextPane1.setwidthMode(jToggleButton1.isSelected());
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void g_NonWrappingTextPane1MouseWheelMoved(java.awt.event.MouseWheelEvent evt) {//GEN-FIRST:event_g_NonWrappingTextPane1MouseWheelMoved
        if (evt.isControlDown()) {
            // managed as Zoom by  g_NonWrappingTextPane1()
        } else {
            JScrollBar j = jScrollPane1.getVerticalScrollBar();
            if (evt.getScrollType() == java.awt.event.MouseWheelEvent.WHEEL_UNIT_SCROLL) {
                j.setValue(j.getValue() + evt.getWheelRotation() * j.getUnitIncrement());
            } else if (evt.getScrollType() == java.awt.event.MouseWheelEvent.WHEEL_UNIT_SCROLL) {
                j.setValue(j.getValue() + evt.getWheelRotation() * j.getBlockIncrement());
            } else {
                // should be unused
                j.setValue(j.getValue() + evt.getWheelRotation() * j.getUnitIncrement());
            }
        }
    }//GEN-LAST:event_g_NonWrappingTextPane1MouseWheelMoved

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        DocColorType = "";
        detectType(getText());
        setType(DocColorType);
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.jdcm.common.G_NonWrappingTextPane g_NonWrappingTextPane1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JComboBox<java.awt.Font> jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton4;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables

    class TextOutputStream extends java.io.ByteArrayOutputStream {

        public TextOutputStream() {
            super();
        }

        @Override
        public void write(byte[] d) {
            try {
                int idx = g_NonWrappingTextPane1.getStyledDocument().getLength();
                // if (idx < getMaxsize()) {
                String txt;
                try {
                    txt = new String(d, "US-ASCII");
                } catch (UnsupportedEncodingException ex) {
                    txt = new String(d);
                }
                g_NonWrappingTextPane1.getStyledDocument().insertString(idx, txt, null);
                g_NonWrappingTextPane1.update(g_NonWrappingTextPane1.getGraphics());
                //   }
            } catch (BadLocationException ex) {
                System.out.println("P_Texte.TextOutputStream.write() : Pb in text Stream");
            }
        }
    }
}
