package com.jdcm.editors;


/**
 * P_DateEditor.java Created on 31 octobre 2007, 21:26
 *
 * Used to Edit/display Tree
 *
 * @author Marc GIBOIN
 */
public class P_TreeEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private boolean editing = true;
    private javax.swing.tree.TreeModel tree;
    private javax.swing.tree.TreeNode treeNode;

    /**
     * create a panel <br>
     * is used by JCB_ObjectEditor<br>
     *
     */
    public P_TreeEditor() {
        initComponents();
    }

    /**
     * Provide an Icon if needed (asked by frames)
     *
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
            return (new com.jdcm.common.D_Utils()).getImage("tree.gif");
        } catch (Exception ex) {
            return null;
        }
    }

    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public void setEditing(boolean bool) {
        editing = bool;
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
    }
    /**
     * recursive provide deep of a tree and nuber of nodes
     * @param t the tree 
     * @param obj the object (root for start)
     * @param level (the level (0 for start)
     * @return an int array {nb childs, deep}
     */
    private int[] getNbNode(javax.swing.tree.TreeModel t,Object obj,int level){
        int nbchld=t.getChildCount(obj);
        int lvl=level;
        for (int i=0;i<t.getChildCount(obj);i++){
            int[] r=getNbNode(t,t.getChild(obj, i),level+1);
            nbchld+=r[0];
            lvl=Math.max(lvl, r[1]);
        }
        return new int[]{nbchld,lvl};
       }
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent txt) {
        if (tree == null && treeNode == null) {
            txt.setText("null tree");
        } else {
            if (tree != null) {
                int nb[]=getNbNode(tree,tree.getRoot(),0);
                txt.setText("tree : " + tree.getChildCount(tree.getRoot())+"/"+nb[1]+"/"+nb[0]);
                
            } else if (treeNode != null) {
                int nb[]=getNbNode(new javax.swing.tree.DefaultTreeModel(treeNode),treeNode,0);
                if (treeNode instanceof javax.swing.tree.DefaultMutableTreeNode){
                    Object Obj=(javax.swing.tree.DefaultMutableTreeNode)treeNode;
                    txt.setText("mutTreeNode : (" + treeNode.getChildCount()+","+nb[1]+","+nb[0]+") ["+Obj.toString()+"]");
                }else{
                    txt.setText("treeNode : (" + treeNode.getChildCount()+","+nb[1]+","+nb[0]+")");
                }
            }
        }
        return txt;
    }

    @Override
    public Object getValue() {
        if (tree != null) {
            return tree;
        } else if (treeNode != null) {
            return treeNode;
        } else {
            return null;
        }
    }

    @Override
    public void setValue(Object val) {
        javax.swing.JTree jtree = null;
        if (val instanceof javax.swing.tree.TreeModel) {
            tree = (javax.swing.tree.TreeModel) val;
            jtree = new javax.swing.JTree(tree);
        } else if (val instanceof javax.swing.tree.TreeNode) {
            treeNode = (javax.swing.tree.TreeNode) val;
            jtree = new javax.swing.JTree(new javax.swing.tree.DefaultTreeModel(treeNode));
        }
        if (jtree != null) {
            jtree.setVisible(true);
            jtree.setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
            jtree.setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>());
            jtree.setEditable(true);
            jScrollPane1.setViewportView(jtree);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();

        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));
        add(jPanel1);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jLabel4.setText("Tree");
        jPanel2.add(jLabel4, java.awt.BorderLayout.PAGE_START);
        jPanel2.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        add(jPanel2);

        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.LINE_AXIS));
        jPanel3.add(jLabel3);

        add(jPanel3);
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
