package com.jdcm.editors;

import com.jdcm.common.XMLres;
import com.jdcm.common.XMLhdr;
import com.jdcm.common.XML2tree;
import com.jdcm.common.D_Utils;
import com.jdcm.eltrx.D_Debug;
import java.awt.HeadlessException;
import java.io.*;
import javax.swing.tree.*;
import javax.swing.*;

/**
 * P_XML.java Created on 15 octobre 2008, 21:15
 *
 * Used to Display/edit XML Files<br>
 *
 * @author Marc GIBOIN
 */
public class P_XML extends javax.swing.JPanel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Debug TDeb;
    private final D_Utils TUtils;
    private XML2tree Totree = null;
    javax.swing.JFrame frame = null;
    boolean isApplet=false;

    public P_XML() {
        initComponents();
        TDeb = new D_Debug("F_XML");
        TUtils = new D_Utils();
        Totree = new com.jdcm.common.XML2tree();
        initialisation();
    }

    public P_XML(boolean applet) {
        initComponents();
        TDeb = new D_Debug("F_XML");
        TUtils = new D_Utils();
        Totree = new com.jdcm.common.XML2tree();
        initialisation();
        isApplet=applet;
    }

    private void initialisation() {
        jTextPane1.setVisible(false);
        setToolsBar(false);
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("Empty");
        DefaultTreeModel model = new DefaultTreeModel(root);
        jTree1.setModel(model);
        jTree1.setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jTree1.setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>());
        setEdit(isEdit());
    }
public void openFrame() {
            if (frame == null) {
            frame = new javax.swing.JFrame("XML Editor");
            frame.setIconImage(getIcon());
            frame.setVisible(isApplet==false);
            if (isApplet) {
                frame.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
            }else{
                frame.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
            }
            frame.setSize(this.getPreferredSize());
            frame.setContentPane(this);
        }
}
    public javax.swing.JFrame getFrame() {
        return frame;
    }

    public void setToolsBar(boolean bool) {
        if (jCheckBoxMenuItem1.isSelected() != bool) {
            jCheckBoxMenuItem1.setSelected(bool);
        }
        if (bool) {
            jButton4.setIcon(TUtils.getIcon("X_Add_child.gif"));
            jButton8.setIcon(TUtils.getIcon("Add.gif"));
            jButton5.setIcon(TUtils.getIcon("Remove.gif"));
            jButton6.setIcon(TUtils.getIcon("up.gif"));
            jButton7.setIcon(TUtils.getIcon("down.gif"));
            jButton2.setIcon(TUtils.getIcon("Save.gif"));
            jButton9.setIcon(TUtils.getIcon("Empty.gif"));
            jToggleButton1.setIcon(TUtils.getIcon("Xbuild.gif"));
            jToggleButton3.setIcon(TUtils.getIcon("Dec_out.gif"));
            jToggleButton3.setSelectedIcon(TUtils.getIcon("Xedit.gif"));
            jButton3.setIcon(TUtils.getIcon("Open.gif"));
            jToggleButton2.setIcon(TUtils.getIcon("X_elt_edit.gif"));
        }
        jToolBar1.setVisible(bool);
    }

    private void setFilename(String txt) {
        jTextField1.setText(txt);
    }

    public java.awt.Image getIcon() {
        return TUtils.getImage("Xedit.gif");
    }

    public void displayFile(java.io.File file) {
        java.io.InputStream str = TUtils.getFileStream(file);
        displayFile(str);
        if (str == null) {
            setFilename("test.xml");
        } else {
            setFilename(file.getName());
        }
    }

    public void displayFile(java.io.InputStream fileStream) {
        DefaultTreeModel treemodel;
        if (fileStream != null) {
            treemodel = Totree.XMLBase(fileStream);
            if (treemodel == null) {
                treemodel = new DefaultTreeModel(new DefaultMutableTreeNode("Error reading file see console"));
                setFilename("");
            }
        } else {
            treemodel = new DefaultTreeModel(new DefaultMutableTreeNode(new XMLhdr("1.0", "UTF-8")));
            setFilename("test.xml");
        }
        displayTree(treemodel);
    }

    public void displayFile(String fname, String dir) {
        displayFile(D_Utils.getFileStream(fname, dir, getClass().getClassLoader()));
        setFilename(fname);
    }

    public void displayTree(TreeModel treemodel) {
        jTree1.setModel(treemodel);
        if (isTxtMode()) {
            setTxtMode(true);
        } else {
            expandTree(jTree1);
        }
    }

    public TreeModel getTreeModel() {
        if (isTxtMode()) {
            return Totree.XMLBase(getXMLtext().getBytes());
        } else {
            if (jTree1.getModel().getRoot() instanceof DefaultMutableTreeNode) {
                DefaultMutableTreeNode entete = (DefaultMutableTreeNode) jTree1.getModel().getRoot();
                return Totree.XMLBase(Totree.node2XML(jTree1.getModel(), entete).getBytes());
            }
        }
        return null;
    }

    private boolean isEdit() {
        return jToggleButton1.isSelected();
    }

    private void setXMLtext(String text) {
        jTextPane1.setText(text);
        jTextPane1.getTextePane().setCaretPosition(0);
    }

    private String getXMLtext() {
        return jTextPane1.getText();
    }

    public void setTxtMode(boolean bool) {
        if (bool != isTxtMode()) {
            jToggleButton3.setSelected(bool);
        }
        jTextPane1.setEnabled(bool);
        jTextPane1.setVisible(bool);
        jTree1.setVisible(bool == false);
        jTree1.setEnabled(bool == false);
        if (Totree != null) {
            if (bool) {
                jScrollPane1.setViewportView(jTextPane1);
                if (jTree1.getModel().getRoot() instanceof DefaultMutableTreeNode) {
                    DefaultMutableTreeNode entete = (DefaultMutableTreeNode) jTree1.getModel().getRoot();
                    setXMLtext(Totree.node2XML(jTree1.getModel(), entete));
                }
            } else {
                jScrollPane1.setViewportView(jTree1);
                jTree1.setModel(Totree.XMLBase(getXMLtext().getBytes()));
                expandTree(jTree1);
            }
        }
    }

    private Boolean isTxtMode() {
        return jToggleButton3.isSelected();
    }

    private String getencoding() {
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getModel().getRoot();
        if (node.getUserObject() instanceof XMLhdr) {
            XMLhdr hdr = (XMLhdr) node.getUserObject();
            return hdr.getEncoding();
        } else {
            return "";
        }
    }

    private void setencoding(String code) {
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getModel().getRoot();
        if (node.getUserObject() instanceof XMLhdr) {
            XMLhdr hdr = (XMLhdr) node.getUserObject();
            if (code.compareTo(hdr.getEncoding()) != 0) {
                hdr.setEncoding(code);
            }
        }
    }

    private void setEdit(boolean bool) {
        if (isEdit() != bool) {
            jToggleButton1.setSelected(bool);
        }
        jButton4.setEnabled(bool);
        jMenuItem2.setEnabled(bool);
        jMenuItem3.setEnabled(bool);
        jMenuItem4.setEnabled(bool);
        jButton5.setEnabled(bool);
        jButton6.setEnabled(bool);
        jButton7.setEnabled(bool);
        jButton8.setEnabled(bool);
        jButton9.setEnabled(bool);
        jToggleButton2.setEnabled(bool);
        jTree1.setEditable(bool);
        jTextPane1.setEditable(bool);
        if (bool == false) {
            jToggleButton2.setSelected(false);
        }
    }

    /**
     * Save tree to XML file
     *
     * @param tree the tree to save as XML file
     */
    private void saveXML(javax.swing.JTree tree) {
        FileOutputStream out;
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        if (ch.showDialog(this, "Save") == JFileChooser.APPROVE_OPTION) {
            try {
                out = new FileOutputStream(ch.getSelectedFile().toString());
                setFilename(ch.getSelectedFile().toString());
            } catch (FileNotFoundException exe) {
                return;
            }
        } else {
            return;
        }
        Totree.savetree2XML(tree.getModel(), out);
    }

    /**
     * Use for CSV Expot
     *
     * @param paths
     * @param out : output stream used for the export
     * @param node
     */
    private void scantree(String[] paths, java.io.OutputStream out, DefaultMutableTreeNode node) {
        try {
            out.write("\r\n".getBytes());
            for (String path : paths) {
                TreePath p = new TreePath(node.getPath());
                // System.out.println("==+"+p.toString());
                if (path.compareTo(p.toString()) == 0) {
                    XMLres res = (XMLres) node.getUserObject();
                    out.write(res.getValue().toString().getBytes());
                    out.write(";".getBytes());
                }
            }
            for (int i = 0; i < node.getChildCount(); i++) {
                scantree(paths, out, (DefaultMutableTreeNode) node.getChildAt(i));
            }
        } catch (IOException ex) {
            TDeb.wri("P_XML : scantree()=>"+ex.getMessage());
        }
    }

    private void up_elt() {
        TreePath path = jTree1.getSelectionPath();
        if (path == null) {
            return;
        }
        if (jTree1.getEditingPath() != null) {
            jTree1.stopEditing();
        }
        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) path.getLastPathComponent();
        DefaultMutableTreeNode parent = (DefaultMutableTreeNode) node0.getParent();
        if (parent != null) {
            int pos = parent.getIndex(node0);
            if (pos > 0) {
                DefaultTreeModel tm = (DefaultTreeModel) jTree1.getModel();
                tm.removeNodeFromParent(node0);
                tm.insertNodeInto(node0, parent, pos - 1);
            }
        }
        jTree1.setSelectionPath(path);
        jTree1.repaint();
    }

    private void down_elt() {
        TreePath path = jTree1.getSelectionPath();
        if (path == null) {
            return;
        }
        if (jTree1.getEditingPath() != null) {
            jTree1.stopEditing();
        }
        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) path.getLastPathComponent();
        DefaultMutableTreeNode parent = (DefaultMutableTreeNode) node0.getParent();
        if (parent != null) {
            int pos = parent.getIndex(node0);
            if (pos < parent.getChildCount() - 1) {
                DefaultTreeModel tm = (DefaultTreeModel) jTree1.getModel();
                tm.removeNodeFromParent(node0);
                tm.insertNodeInto(node0, parent, pos + 1);
            }
        }
        jTree1.setSelectionPath(path);
        jTree1.repaint();
    }

    public void setEditable(boolean bool) {
        if (jToggleButton2.isSelected() != bool) {
            jToggleButton2.setSelected(bool);
        }
        jTree1.setEditable(bool);
        jTextPane1.setEditable(bool);
    }

    private void rename_elt() {
        TreePath path = jTree1.getSelectionPath();
        if (path == null) {
            return;
        }
        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) path.getLastPathComponent();
        XMLres Obj = (XMLres) node0.getUserObject();
        String eltname = Obj.toString();
        while (eltname.indexOf(" ") != -1) {
            eltname = JOptionPane.showInputDialog("New element Name :", eltname).trim();
            if (eltname == null) {
                return;
            }
        }
        Obj.setElement(eltname);
        repaint();
    }

    private void add_child() {
        TreePath path = jTree1.getSelectionPath();
        if (path == null) {
            return;
        }
        if (jTree1.getEditingPath() != null) {
            jTree1.stopEditing();
        }
        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) path.getLastPathComponent();
        String eltname = "New Elt";
        while (eltname.indexOf(" ") != -1) {
            eltname = JOptionPane.showInputDialog(this, "New Element :", eltname);
            if (eltname == null) {
                return;
            }
        }
        XMLres Obj = new XMLres(eltname);
        DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(Obj);
        DefaultTreeModel tm = (DefaultTreeModel) jTree1.getModel();
        tm.insertNodeInto(node1, node0, 0);
        jTree1.expandPath(path);
        repaint();
    }

    private void add_elt() {
        TreePath path = jTree1.getSelectionPath();
        if (path == null) {
            return;
        }
        if (jTree1.getEditingPath() != null) {
            jTree1.stopEditing();
        }
        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) path.getLastPathComponent();
        DefaultMutableTreeNode parent = (DefaultMutableTreeNode) node0.getParent();
        if (parent != null) {
            String eltname = "New Elt";
            while (eltname.indexOf(" ") != -1) {
                eltname = JOptionPane.showInputDialog(this, "New Element :", eltname);
                if (eltname == null) {
                    return;
                }
            }
            XMLres Obj = new XMLres(eltname);
            DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(Obj);
            DefaultTreeModel tm = (DefaultTreeModel) jTree1.getModel();
            tm.insertNodeInto(node1, parent, parent.getIndex(node0));
            repaint();
        }
    }

    private void remove_elt() {
        TreePath path = jTree1.getSelectionPath();
        if (path == null) {
            return;
        }
        DefaultMutableTreeNode node0 = (DefaultMutableTreeNode) path.getLastPathComponent();
        DefaultTreeModel tm = (DefaultTreeModel) jTree1.getModel();
        if (node0.getParent() != null) {
            tm.removeNodeFromParent(node0);
        }
        repaint();
    }

    private void expandTree(JTree jTree) {
        for (int i = 0; i < jTree.getRowCount(); i++) {
            jTree.expandRow(i);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                javax.swing.JFrame f = new javax.swing.JFrame();
                P_XML p = new P_XML();
                p.setXMLtext("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><mapping attr1=\"toto\">    <file>    </file></mapping>");
                p.setEdit(true);
                p.setToolsBar(true);
                f.add(p);
                f.setBounds(new java.awt.Rectangle(0, 0, 100, 400));
                f.setVisible(true);
            }
        });
    }
    /*private void jTree1MouseClicked(java.awt.event.MouseEvent evt) {                                    
     if (evt.getClickCount() == 1 && jTree1.getSelectionPath() != null) {
     jTree1.startEditingAtPath(jTree1.getSelectionPath());
     }
     }  */

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu2 = new javax.swing.JPopupMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jCheckBoxMenuItem1 = new javax.swing.JCheckBoxMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jButton9 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jToggleButton3 = new javax.swing.JToggleButton();
        jButton10 = new javax.swing.JButton();
        jTextField1 = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new P_Texte();
        jTree1 = new javax.swing.JTree();

        jMenuItem2.setText("Remove");
        jMenuItem2.setEnabled(false);
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jMenuItem2);

        jMenuItem3.setText("Insert");
        jMenuItem3.setEnabled(false);
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jMenuItem3);

        jMenuItem4.setText("Rename");
        jMenuItem4.setEnabled(false);
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jMenuItem4);

        jCheckBoxMenuItem1.setText("Toolsbar");
        jCheckBoxMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu2.add(jCheckBoxMenuItem1);

        jPopupMenu2.getAccessibleContext().setAccessibleParent(this);

        setComponentPopupMenu(jPopupMenu2);
        setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);
        jToolBar1.setInheritsPopupMenu(true);
        jToolBar1.setMinimumSize(new java.awt.Dimension(119, 16));
        jToolBar1.setPreferredSize(new java.awt.Dimension(119, 20));

        jButton2.setToolTipText("Save");
        jButton2.setBorderPainted(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton3.setToolTipText("Open");
        jButton3.setBorderPainted(false);
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jToggleButton1.setToolTipText("Editable");
        jToggleButton1.setBorderPainted(false);
        jToggleButton1.setFocusable(false);
        jToggleButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        jToggleButton2.setToolTipText("open element");
        jToggleButton2.setBorderPainted(false);
        jToggleButton2.setFocusable(false);
        jToggleButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton2);

        jButton9.setToolTipText("Clear");
        jButton9.setBorderPainted(false);
        jButton9.setFocusable(false);
        jButton9.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton9.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton9);

        jButton4.setToolTipText("Add Child");
        jButton4.setBorderPainted(false);
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton4);

        jButton8.setToolTipText("Add Element");
        jButton8.setBorderPainted(false);
        jButton8.setFocusable(false);
        jButton8.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton8.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton8);

        jButton5.setToolTipText("Remove Element");
        jButton5.setBorderPainted(false);
        jButton5.setFocusable(false);
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton5);

        jButton6.setToolTipText("Up Element");
        jButton6.setBorderPainted(false);
        jButton6.setFocusable(false);
        jButton6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton6.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton6);

        jButton7.setToolTipText("Down Element");
        jButton7.setBorderPainted(false);
        jButton7.setFocusable(false);
        jButton7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton7.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton7);

        jToggleButton3.setToolTipText("Text/Tree");
        jToggleButton3.setBorderPainted(false);
        jToggleButton3.setFocusable(false);
        jToggleButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton3);

        jButton10.setText("csv");
        jButton10.setToolTipText("Select nodes to export values as csv[;/\\r\\n]");
        jButton10.setBorderPainted(false);
        jButton10.setFocusable(false);
        jButton10.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton10.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton10);
        jToolBar1.add(jTextField1);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        jScrollPane1.setComponentPopupMenu(jPopupMenu2);

        jTextPane1.setEditable(false);
        jTextPane1.setText("XML as text");
        jTextPane1.setComponentPopupMenu(jPopupMenu2);
        jTextPane1.setInheritsPopupMenu(true);
        jTextPane1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextPane1KeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTextPane1);

        jTree1.setComponentPopupMenu(jPopupMenu2);
        jTree1.setInheritsPopupMenu(true);
        jTree1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTree1KeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    saveXML(this.jTree1);
}//GEN-LAST:event_jButton2ActionPerformed

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
    javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
    if (ch.showDialog(this, "Open") == JFileChooser.APPROVE_OPTION) {
        //     DefaultTreeModel tm = (DefaultTreeModel) jTree1.getModel();

        DefaultTreeModel tm = Totree.XMLBase(TUtils.getFileStream(ch.getSelectedFile()));
        if (tm != null) {
            jTree1.setModel(tm);
            jTree1.repaint();
        } else {
            javax.swing.JOptionPane.showMessageDialog(this, "File :  Should not be a valite XML file.", "XML file openning ", javax.swing.JOptionPane.INFORMATION_MESSAGE);
        }
    }
}//GEN-LAST:event_jButton3ActionPerformed

private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
    if (jTree1.getModel() != null) {
        int rep = javax.swing.JOptionPane.showConfirmDialog(this, "File  save it ?.", "XML closing", javax.swing.JOptionPane.YES_NO_CANCEL_OPTION);
        if (rep == 0) {
            saveXML(this.jTree1);
        }
        if (rep == 2) {
            return;
        }
    }
    displayFile("", "");
}//GEN-LAST:event_jButton9ActionPerformed

private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
    setEdit(isEdit());
}//GEN-LAST:event_jToggleButton1ActionPerformed

private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
    setEditable(jToggleButton2.isSelected());
}//GEN-LAST:event_jToggleButton2ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
    add_child();
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
    add_elt();
}//GEN-LAST:event_jButton8ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
    remove_elt();
}//GEN-LAST:event_jButton5ActionPerformed

private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
    up_elt();
}//GEN-LAST:event_jButton6ActionPerformed

private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
    down_elt();
}//GEN-LAST:event_jButton7ActionPerformed

private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
    setTxtMode(isTxtMode());
}//GEN-LAST:event_jToggleButton3ActionPerformed

private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
    if (jTree1.getSelectionCount() <= 0) {
        return;
    }
    String[] paths = new String[jTree1.getSelectionCount()];
    try {
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        if (ch.showDialog(this, "Save") == JFileChooser.APPROVE_OPTION) {
            try (java.io.OutputStream out = new FileOutputStream(ch.getSelectedFile().toString())) {
                for (int i = 0; i < jTree1.getSelectionCount(); i++) {
                    String col = jTree1.getSelectionPaths()[i].getLastPathComponent().toString();
                    paths[i] = jTree1.getSelectionPaths()[i].toString();
                    out.write(col.getBytes());
                    out.write(";".getBytes());
                }
                out.write("\r\n".getBytes());
                // get data
                scantree(paths, out, (DefaultMutableTreeNode) jTree1.getPathForRow(0).getLastPathComponent());
            }
        }
    } catch (HeadlessException | IOException ex) {
        TDeb.wri("P_XML.tocvs()Pb open file");
    }
}//GEN-LAST:event_jButton10ActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
//remove tree
    remove_elt();
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
//insert in tree
    add_child();
}//GEN-LAST:event_jMenuItem3ActionPerformed

private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
//rename tree
    rename_elt();
}//GEN-LAST:event_jMenuItem4ActionPerformed

private void jCheckBoxMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem1ActionPerformed
    setToolsBar(jCheckBoxMenuItem1.isSelected());
}//GEN-LAST:event_jCheckBoxMenuItem1ActionPerformed

private void jTree1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTree1KeyPressed
    if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ESCAPE) {
        jCheckBoxMenuItem1.setSelected(jCheckBoxMenuItem1.isSelected() == false);
        setToolsBar(jCheckBoxMenuItem1.isSelected());
    }
}//GEN-LAST:event_jTree1KeyPressed

private void jTextPane1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextPane1KeyPressed
    if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ESCAPE) {
        jCheckBoxMenuItem1.setSelected(jCheckBoxMenuItem1.isSelected() == false);
        setToolsBar(jCheckBoxMenuItem1.isSelected());
    }
}//GEN-LAST:event_jTextPane1KeyPressed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JPopupMenu jPopupMenu2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTextField1;
    private com.jdcm.editors.P_Texte jTextPane1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
}
