package com.jdcm.editors;

import com.jdcm.common.XMLres;
import com.jdcm.common.XMLhdr;
import javax.swing.table.AbstractTableModel;
import com.jdcm.common.D_Utils;

/**
 *Used to Display/edit XML Elements<br>
 * @author  Marc GIBOIN 
 */
public class P_XMLEditor extends javax.swing.JPanel implements I_CBObjectEditor {
    // for serializable interface

    private static final long serialVersionUID = 1L;
        private final D_Utils TUtils = new D_Utils();
    private final ACE_ObjEditor <Object> editor = new ACE_ObjEditor<>(true, true);
    private final ACE_ObjRenderer<Object> render = new ACE_ObjRenderer<>();
    
    private boolean editing = false;
    private ATT_Model Tmodel = null;
    private ELT_Model Xmodel = null;


    /** Creates new form P_XML */
    public P_XMLEditor() {
        initComponents();
        setEditing(false);
        // should set ACE_ObjEdotr/Render for jTable2 & jTable1 ?
        jToggleButton1.setIcon(TUtils.getIcon("Add.gif"));
        jToggleButton2.setIcon(TUtils.getIcon("Remove.gif"));
        jToggleButton3.setIcon(TUtils.getIcon("rename.gif"));
        jTextField1.setVisible(false);
    }
   /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    @Override
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("X_elt_edit.gif");
        }catch(Exception ex){
            return null;
        }
    }
    @Override
    public javax.swing.text.JTextComponent getLabel(javax.swing.text.JTextComponent initjtxt) {
        javax.swing.text.JTextComponent txt = initjtxt;
        javax.swing.JTextPane box = new javax.swing.JTextPane();
        if (txt instanceof javax.swing.JTextField) {
            /// java.awt.Rectangle rect = txt.getBounds();
            java.awt.Container cont = txt.getParent();
            //txt.setVisible(false);
            txt.remove(cont);
            for (java.awt.event.FocusListener fl : txt.getFocusListeners()) {
                box.addFocusListener(fl);
            }
            cont.add(box, java.awt.BorderLayout.CENTER);
        } else if (txt instanceof javax.swing.JTextPane) {
            box = (javax.swing.JTextPane) txt;
        }

        javax.swing.text.StyledDocument st = box.getStyledDocument();

        try {
            st.remove(0, st.getLength());
        } catch (javax.swing.text.BadLocationException ex) {
        }
        if (Tmodel.getXMLRes() instanceof XMLhdr) {
            XMLhdr Xh = (XMLhdr) Tmodel.getXMLRes();
            addtext(st, "<?xml ", java.awt.Color.black, 1);
            for (String name:Xh.getAttrNames()) {
                addtext(st, " " + name, java.awt.Color.red, 0);
                addtext(st, "=", java.awt.Color.black, 0);
                addtext(st, "\"" + Xh.getAttrVal(name) + "\" ", java.awt.Color.DARK_GRAY, 0);
            }
            addtext(st, "?>", java.awt.Color.black, 1);
        } else {
            XMLres Xr = Tmodel.getXMLRes();
            addtext(st, "< ", java.awt.Color.black, 1);
            addtext(st, Xr.getEltName() + " ", java.awt.Color.BLUE, 0);
            for (String name:Xr.getAttrNames()) {
                if (Xr.getAttrVal(name) != null) {
                    addtext(st, " " +name, java.awt.Color.red, 0);//new java.awt.Color(0, 150, 0)
                    addtext(st, "=", java.awt.Color.black, 1);
                    addtext(st, "\"" + TUtils.getObj2str(Xr.getAttrVal(name)) + "\"", new java.awt.Color(150, 0, 150), 0);
                    addtext(st, " ", java.awt.Color.black, 1);
                }
            }
            addtext(st, ">", java.awt.Color.BLACK, 1);
            if (Xr.getValue() != null) {
                addtext(st, "" + Xr.getValue(), java.awt.Color.black, 0);
            }
        }
        return box;
    }

    @Override
    public void setValue(Object val) {
        XMLres res = null;
        if (val instanceof XMLres) {
            res = (XMLres) val;
        }
        if (res != null) {
            Tmodel = new ATT_Model(res);
            jTable1.setModel(Tmodel);
            Tmodel.setEdit(editing);
            if (res instanceof com.jdcm.common.XMLhdr == false) {
                Xmodel = new ELT_Model(res);
                jTable2.setModel(Xmodel);
                Xmodel.setEdit(editing);
            } else {
                jTable2.setVisible(false);
            }
            for (int i = 0; i < jTable1.getColumnCount(); i++) {
                jTable1.getColumnModel().getColumn(i).setCellEditor(editor);
                jTable1.getColumnModel().getColumn(i).setCellRenderer(render);
            }
        }
    }

    @Override
    public XMLres getValue() {
        return Tmodel.getXMLRes();
    }

    @Override
    public boolean isEditing() {
        return editing;
    }

    @Override
    public final void setEditing(boolean bool) {
        editing = bool;
        if (Tmodel != null) {
            Tmodel.setEdit(editing);
        }
        if (Xmodel != null) {
            Xmodel.setEdit(editing);
        }
        jToggleButton1.setEnabled(bool);
        jToggleButton2.setEnabled(bool);
        jToggleButton3.setEnabled(bool);
    }

    private void rename_attr() {
        if (this.jTable1.getSelectedColumn() == -1) {
            jToggleButton3.setSelected(false);
            return;
        }
        if (jToggleButton3.isSelected()) {
              jTextField1.setText(jTable1.getColumnName(jTable1.getSelectedColumn()));
            maskbutt(jToggleButton3, true);
            jTable1.setEnabled(false);
        } else {
            if (checkAttrName(jTextField1)) {
                maskbutt(jToggleButton3, false);
                Tmodel.addAttribut(jTextField1.getText());
                jTable1.setEnabled(true);
                repaint();
            }
        }
    }

    private void add_attr() {
        if (jToggleButton1.isSelected()) {
            maskbutt(jToggleButton1, true);
            jTable1.setEnabled(false);
        } else {
            if (checkAttrName(jTextField1)) {
                maskbutt(jToggleButton1, false);
                Tmodel.addAttribut(jTextField1.getText());
                jTextField1.setText("");
                jTable1.setEnabled(true);
                repaint();
            }
        }


    }

    private void maskbutt(javax.swing.JToggleButton on, boolean bool) {
        for (java.awt.Component c : this.getComponents()) {
            if (c instanceof javax.swing.JToggleButton && on != c) {
                c.setVisible(bool == false);
            }
            on.setEnabled(bool == false);
            jTextField1.setVisible(bool);
            jTextField1.setBackground(java.awt.Color.white);
        }
    }

    private boolean checkAttrName(javax.swing.JTextField txtfld) {
        boolean res = true;
        String txt = txtfld.getText();
        if (txt.indexOf(" ") != -1) {
            res = false;
        }
        for (int i = 0; i < txt.getBytes().length; i++) {
            if (txt.getBytes()[i] < 48 || txt.getBytes()[i] > 123) {
                res = false;
            }
        }
        if (res) {
            txtfld.setBackground(java.awt.Color.white);
        } else {
            txtfld.setBackground(java.awt.Color.red);
        }
        if (jToggleButton1.isSelected()) {
            jToggleButton1.setEnabled(res);
        }
        if (jToggleButton3.isSelected()) {
            jToggleButton3.setEnabled(res);
        }
        return res;
    }

    private void remove_attr() {
        //remove att in elts
        if (this.jTable1.getSelectedColumn() == -1) {
            return;
        }

        Tmodel.removeAttribut(jTable1.getSelectedColumn());
        repaint();
    }

    @Override
    public void TextManager(javax.swing.text.JTextComponent txt) {
        try {
            if (this.getValue() instanceof com.jdcm.common.XMLhdr) {
                parseheader(txt.getText());
            } else {
                parseElement(txt.getText());
            }
        } catch (Exception ex) {
            getLabel(txt);
            txt.setBackground(java.awt.Color.RED);
        }
//        Tmodel.setXMLRes(res);
        txt.setBackground(java.awt.Color.GREEN);
    }

    /**
     * analyse the txt  box to buid a new Element.
     * 
     */
    private void parseElement(String inittxt) throws Exception {
        String txt = inittxt;
        if (inittxt != null) {
            txt = txt.trim();
        } else {
            return;
        }
        if (txt.startsWith("<") == false || txt.indexOf(">") == -1) {
            throw new Exception(" Unable to parse");
        }
        String eltname = null;
        java.util.List<String[]> vect = new java.util.ArrayList<>();
        String value = null;
        try {
            txt = txt.substring(1).trim(); //"<"
            int endname = txt.indexOf(" ");
            if (endname == -1) {
                endname = txt.indexOf(">");
            }
            eltname = txt.substring(0, endname);
            txt = txt.substring(endname).trim();
            while (txt.startsWith(">") == false && txt.indexOf(">") != -1) {
                String attrname = txt.substring(0, txt.indexOf("="));
                txt = txt.substring(txt.indexOf("=") + 1).trim();
                String attrval = txt.substring(1, txt.indexOf("\"", 1));
                txt = txt.substring(txt.indexOf("\"", 1) + 1).trim();
                vect.add(new String[]{attrname, attrval});
            }
            txt = txt.substring(1);//">"
            // trim()=>Pb if value end with CRLF or spaces..
            value = txt;
        } catch (Exception ex) {
            throw new Exception(" Unable to parse " + txt);
        }
        XMLres res = Xmodel.getXMLRes();
        res.clear();
        res.setElement(eltname);
        res.setValue(value);
        for (int i = 0; i < vect.size(); i++) {
            res.addAttribut(vect.get(i)[0],TUtils.getstr2Obj(vect.get(i)[1]));
        }
        this.setValue(res);
    }

    /**
     * analyse the txt  box to buid a new Element.
     *
     */
    private void parseheader(String inittxt) throws Exception {
        if (inittxt == null) {
            return;
        } 
         String txt = inittxt.trim();
        if (txt.startsWith("<?xml") == false || txt.indexOf("?>") == -1) {
            throw new Exception(" Unable to parse");
        }
        java.util.List<String[]> vect = new java.util.ArrayList<>();
        try {
            txt = txt.substring(1).trim(); //"<"
            int endname = txt.indexOf(" ");
            if (endname == -1) {
                endname = txt.indexOf("?>");
            }
            txt = txt.substring(endname).trim();
            while (txt.startsWith("?>") == false && txt.indexOf("?>") != -1) {
                String attrname = txt.substring(0, txt.indexOf("="));
                txt = txt.substring(txt.indexOf("=") + 1).trim();
                String attrval = txt.substring(1, txt.indexOf("\"", 1));
                txt = txt.substring(txt.indexOf("\"", 1) + 1).trim();
                vect.add(new String[]{attrname, attrval});
            }
         //unused   txt = txt.substring(1);//">"
            // trim()=>Pb if value end with CRLF or spaces..
        } catch (Exception ex) {
            throw new Exception(" Unable to parse " + txt);
        }
        XMLhdr res = new XMLhdr(null, null);
        res.setElement("HEADER");
        for (int i = 0; i < vect.size(); i++) {
            res.addAttribut(vect.get(i)[0],vect.get(i)[1]);
        }
        this.setValue(res);
    }

    /**
     *  implment the table Objects render for a list
     *!!!also a COPY in reflect member editor
     * @param st
     * @param texte
     * @param c
     * @param style
     */
    private void addtext(javax.swing.text.StyledDocument st, String texte, java.awt.Color c, int style) {
        javax.swing.text.SimpleAttributeSet myAttributeSet = new javax.swing.text.SimpleAttributeSet();
        javax.swing.text.StyleConstants.setForeground(myAttributeSet, c);
        javax.swing.text.StyleConstants.setBold(myAttributeSet, style == 1);
        javax.swing.text.StyleConstants.setItalic(myAttributeSet, style == 2);
        try {
            st.insertString(st.getLength(), texte, myAttributeSet);
        } catch (javax.swing.text.BadLocationException ex) {
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jToggleButton3 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jTextField1 = new javax.swing.JTextField();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();

        jMenuItem1.setText("Remove");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        jMenuItem5.setText("Add");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem5);

        jMenuItem6.setText("Rename");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem6);

        setPreferredSize(new java.awt.Dimension(273, 139));
        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS));

        jScrollPane2.setComponentPopupMenu(jPopupMenu1);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable1.setCellSelectionEnabled(true);
        jTable1.setComponentPopupMenu(jPopupMenu1);
        jScrollPane2.setViewportView(jTable1);

        add(jScrollPane2);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setText("Attributs : ");
        jPanel1.add(jLabel1);

        jToggleButton3.setToolTipText("rename Atribut");
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jPanel1.add(jToggleButton3);

        jToggleButton2.setToolTipText("remove Atribut");
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jToggleButton2);

        jToggleButton1.setToolTipText("Add Atribut");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jToggleButton1);

        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField1KeyReleased(evt);
            }
        });
        jPanel1.add(jTextField1);

        add(jPanel1);

        jTable2.setCellSelectionEnabled(true);
        jTable2.setComponentPopupMenu(jPopupMenu1);
        jScrollPane3.setViewportView(jTable2);

        add(jScrollPane3);
    }// </editor-fold>//GEN-END:initComponents
    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        remove_attr();
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        //insert att in elt
        add_attr();
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
        //modify attr
        rename_attr();
    }//GEN-LAST:event_jMenuItem6ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        if (checkAttrName(jTextField1)) {
            if (jToggleButton1.isSelected()) {
                jToggleButton1.setSelected(false);
                add_attr();
            }
            if (jToggleButton3.isSelected()) {
                jToggleButton3.setSelected(false);
                rename_attr();
            }
        }
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        add_attr();
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        remove_attr();
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
        rename_attr();
    }//GEN-LAST:event_jToggleButton3ActionPerformed

    private void jTextField1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyReleased
        checkAttrName(jTextField1);
    }//GEN-LAST:event_jTextField1KeyReleased

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    // End of variables declaration//GEN-END:variables
}
/*
 *Table model of name/value/key/name/.. for Eletment
 *
 * ELT_Model use XMLres...
 */

class ELT_Model extends AbstractTableModel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private XMLres Elt = null;
    private boolean edit = false;

    public ELT_Model(XMLres res) {
        Elt = res;
        fireTableChanged(null);
    }

    public void setEdit(boolean bool) {
        edit = bool;
    }

    public XMLres getXMLRes() {
        return Elt;
    }

    public void setXMLRes(XMLres res) {
        Elt = res;
        fireTableChanged(null);
    }

    @Override
    public int getRowCount() {
        return 1;
    }

    @Override
    public int getColumnCount() {
        return 3;
    }

    @Override
    public String getColumnName(int column) {
        String[] res = {"Name", "Value", "Name_Att"};
        return res[column];
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        switch (columnIndex) {
            case 0:
                return Elt.getEltName();
            case 1:
                return Elt.getValue();
            case 2:
                return Elt.getName();
        }
        return "-";
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return edit;
    }

    @Override
    public void setValueAt(Object value, int row, int column) {
        switch (column) {
            case 0:
                Elt.setElement(value.toString());
                break;
            case 1:
                Elt.setValue(value);
                break;
            case 2:
                if (value == null || value.toString().length() == 0) {
                    Elt.setName(null);
                } else {
                    Elt.setName(value.toString());
                }

        }
    }
}
/*
 *Table model of Attributs for Eletment
 *
 * ATT_Model use XMLres...
 */

class ATT_Model extends AbstractTableModel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private XMLres Att = null;
    private boolean edit = false;

    public ATT_Model(XMLres res) {
        Att = res;
        fireTableChanged(null);
    }

    public XMLres getXMLRes() {
        return Att;
    }

    public void setEdit(boolean bool) {
        edit = bool;
    }

    public void setXMLRes(XMLres res) {
        Att = res;
        fireTableChanged(null);
    }

    public void setelement(String txt) {
        if (txt == null) {
            return;
        }
        if (txt.length() == 0) {
            return;
        }
        Att.setElement(txt);
        fireTableChanged(null);
    }

    public void setValue(Object obj) {
        Att.setValue(obj);
        fireTableChanged(null);
    }

    public void setcolName(String txt) {
        if (txt==null ||txt.length() == 0) {
            return;
        }
        Object o=Att.removeAttribut(txt);
        Att.addAttribut(txt, o);
        fireTableChanged(null);
    }
    public void addAttribut(int col) {
        addAttribut(getColumnName(col));
    }
    public void addAttribut(String txt) {
        if (txt.length() == 0) {
            return;
        }
        //col==-1 managed in XMLRes
        Att.addAttribut(txt, "");
        fireTableChanged(null);
    }
    public void removeAttribut(int col) {
        removeAttribut(getColumnName(col));
    }
    public void removeAttribut(String name) {
        if (name==null||name.length()==0 ) {
            return;
        }
        Att.removeAttribut(name);
        fireTableChanged(null);
    }

    @Override
    public String getColumnName(int column) {
        if (Att == null ||column> Att.length()) {
            return null;
        }
        return Att.getAttrNames().toArray(new String[]{})[column];
    }

    @Override
    public int getColumnCount() {
        if (Att == null) {
            return 0;
        }
        return Att.length();
    }

    @Override
    public int getRowCount() {
        return 1;
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        String name=getColumnName(aColumn);
        return Att.getAttrVal(name);
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return edit;
    }

    @Override
    public void setValueAt(Object value, int row, int column) {
         String name=getColumnName(column);
        Att.setAttrVal(name, value);
    }
}
