package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;
import com.jdcm.common.A_Commande;
import com.jdcm.common.Options_Model;
import com.jdcm.common.C_Actiondef;
import javax.swing.DefaultComboBoxModel;
import com.jdcm.common.D_Utils;
import com.jdcm.common.XMLres;
import com.jdcm.diagram.A_Events;
import java.sql.ResultSet;
import com.jdcm.charts.P_Stat_P;
import java.lang.reflect.InvocationTargetException;
import java.sql.SQLException;

/**
 * Machine is a port that is 'doing' something with imputs
 *
 * @author Marc GIBOIN
 */
public class C_Machine implements I_Port, I_Command {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Debug TDeb;
    private final D_Utils TUtils = new D_Utils();
    private I_Main Parent = null;
    public C_PScan scan = null;
    private I_Command cmdeobj;
    private P_Stat_P stat_P = null;
    private String bufcmde = null;
    private java.awt.Color sparecolor = java.awt.Color.BLACK;
    private ResultSet scanRange = null;
    // option & F_option are model & table for options (SCN/MSG/...)
    private Options_Model option;
    // the Componement displayed to see this port (typical IF_Machine)
    private java.awt.Component skin;
    // for system ports (capture reading/shell/...) identification
    private int system_index = -1;

    /**
     * Creates new form IF_Machine
     */
    public C_Machine() {
        initOptions();
        system_index = 100;
        TDeb = new D_Debug("Machine : [-1]");
        //---MSG_pool--
        option.setValuefor("MSG_pool", false);
        setscaned();
        setcxstatus("new");
        cmdeobj = this;
        option.setValuefor("Events", new A_Events());
    }

    public C_Machine(I_Main P, I_Console c, int idx) {
        initOptions();
        Parent = P;
        system_index = idx;
        TDeb = new D_Debug("Machine : [" + P.getPorts().indexOf(this) + "]");
        if (c != null) {
            TDeb.setconsole(c);

        }
        option.setValuefor("EVT_table", new A_Events(c));
        initsourcesboxes();
        option.setValuefor("MSG_pool", false);
        setscaned();
        setcxstatus("new");
        if (Parent instanceof C_Main) {
            cmdeobj = (C_Main) Parent;
        } else {
            cmdeobj = this;
        }

    }

    public C_Machine(I_Main P, I_Console c) {
        initOptions();
        Parent = P;
        TDeb = new D_Debug("Machine : [" + P.getPorts().indexOf(this) + "]");
        if (c != null) {
            TDeb.setconsole(c);
        }
        option.setValuefor("EVT_table", new A_Events(c));
        initsourcesboxes();
        option.setValuefor("MSG_pool", false);
        setscaned();
        setcxstatus("new");
        if (Parent instanceof C_Main) {
            cmdeobj = (C_Main) Parent;
        } else {
            cmdeobj = this;
        }
    }

    @Override
    public int getSIndex() {
        return -1;
    }

    @Override
    public java.awt.Component getSkin() {
        return skin;
    }

    @Override
    public int getOsiLevel() {
        return -1;
    }

    @Override
    public void setSkin(java.awt.Component o) {
        if (skin != null) {
            skin.setVisible(false);
            skin.getParent().remove(skin);
            skin = null;
        }
        skin = o;
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setMSG_pool(this.isMSG_pool());
            ((IF_Machine) skin).setIndex(getIndex());
            ((IF_Machine) skin).setColor(getColor());
        }
    }

    private void initOptions() {
        option = new Options_Model(this);
        // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        option.addOption("CLI_enable", false, "bool", "0/1", false, false, "acttivate the Command Line Interactiv");
        I_Command[] vide = {};
        option.addOption("source", new DefaultComboBoxModel<>(vide), "port", "present ports", true, false, "Cli  source port(term)");
        option.addOption("destination", new DefaultComboBoxModel<>(vide), "port", "present ports", true, false, "Scanning destination port");
        option.addOption("SCN_toxml", false, "bool", "0/1", false, false, "activate the Scanning exporrt to xml after cycle");
        XMLres SCNstore = new com.jdcm.common.XMLres("table");
        SCNstore.addAttribut("attr_result", "");
        SCNstore.addAttribut("attr_time", "");
        option.addOption("SCN_MaxCycle", 0, "int", "0/1", false, false, "pool output each timevalues");
        option.addOption("SCN_inStore", SCNstore, "XML result", "infos", false, false, "the results parameters");
        option.addOption("SCN_view", "pool_view", "String", "table name", false, false, "the table to look for scan params");
        option.addOption("SCN_key", "id", "String", "table id column", false, false, "the id to use for select scanning and write");
        option.addOption("SCN_datafld", "command", "String", "view column", false, false, "Thee column to extract scaaning commands");
        // option.addOption("SCN_timefld", "date", "String", "table column", false, false, "the column name for timestamp writing");
        // option.addOption("SCN_rsfld", "result", "String", "table column", false, false, "column name for result writing");
        // option.addOption("SCN_inDB", "results", "String", "table", false, false, "name of the table to return result");
        option.addOption("SCN_cycle", 0, "integer", ">=0", false, false, "number off cycles since starting");
        option.addOption("SCN_pos", 0, "integer", ">=0", false, false, "position of the row in the cycle");
        option.addOption("method", new DefaultComboBoxModel<>(new String[]{}), "methods", "port methods", true, false, "the method to use fro scanning");
        String[] typ = {"Status", "Admin", "Type"};
        option.addOption("MSG_type", new DefaultComboBoxModel<>(typ), "Strings", "Status/Admin/Type", false, false, "type of messagge waited");
        option.addOption("MSG_waited", new byte[0], "bytes", "byte[0]", false, false, "the message waited on soure port");
        option.addOption("MSG_pool", false, "bool", "0/1", false, false, "pool output each timevalues");
        option.addOption("MSG_poolval", 1000, "integer", ">0", false, false, "set the pool interval value");
        option.addOption("MSG_date", false, "bool", "0/1", false, false, "add date to output");
        option.addOption("MSG_banner", new byte[0], "bytes", "byte[]", false, false, "banner to send on output");
        option.addOption("Par_mxgrp", "", "String", "AAZZEE", true, false, "selector for group matrix");
        option.addOption("PortName", "Machine", "String", "", false, false, "name of the machine");
        option.addOption("cxstatus", "state", "String", "", false, false, "staus of the machine");
        option.addOption("ModeName", "MSG", "String", "0", false, false, "mode of the machine");
        option.addOption("EVT_table", null, "events table", "0", false, false, "state machine table");
        option.addOption("stop2end", false, "bool", "0/1", true, true, "end the machine after stoped ");
        option.setTitle(getTitle());
    }

    @Override
    public String toString() {
        return this.getPortName();
    }

    public String getTitle() {
        return getPortName() + "[" + getModeName() + "]";
    }

    @Override
    public I_Console getConsole() {
        return TDeb.getconsole();
    }

    @A_Commande(help = "set the machine to end after stopped")
    @Override
    public void setstop2end(boolean bool) {
        option.setValuefor("stop2end", bool);
    }

    @Override
    public boolean getstop2end() {
        return (Boolean) option.getValuefor("stop2end");
    }

    @Override
    public boolean isPort_Stat() {
        return stat_P != null;
    }

    @Override
    public void setPort_Stat(boolean bool) {
        if (isPort_Stat() == bool) {
            return;
        }
        if (bool) {
            stat_P = new P_Stat_P(this);
            stat_P.setVisible(true);
            //!! port Name should be updated if changed
            Parent.addTab((javax.swing.JPanel) stat_P, this.getPortName(), TUtils.getIcon("traffic_on.gif"));

        } else {
            Parent.removeTab(stat_P);
            stat_P = null;
        }

    }

    public P_Stat_P getPort_Stat() {
        return stat_P;
    }

    public Object get_destination() {
        DefaultComboBoxModel<Object> box = option.getValuefor("destination", new DefaultComboBoxModel<>());
        return box.getSelectedItem();
    }

    @A_Commande(help = "set the destination port for Machine")
    public void set_destination(String txt) {
        setLists(txt, "destination");
        initmethodsbox(true, option.getValuefor("method", new DefaultComboBoxModel<String>()), (I_Command) get_destination());
    }

    @A_Commande(help = "set the source port for Machine")
    public void set_source(String txt) {
        setLists(txt, "source");
    }

    @A_Commande(help = "get the source port of the Machine")
    public C_Port get_source() {
        DefaultComboBoxModel<I_Command> box = option.getValuefor("source", new DefaultComboBoxModel<I_Command>());
        if (box.getSelectedItem() instanceof C_Port) {
            return (C_Port) box.getSelectedItem();
        }
        return null;

    }
// !!!! USE of TUtils.getMethode...//

    public java.lang.reflect.Method get_method(Class<?> cl) {
        DefaultComboBoxModel<java.lang.reflect.Method> box = option.getValuefor("method", new DefaultComboBoxModel<java.lang.reflect.Method>());
        if (box.getSelectedItem().toString().startsWith("N/A") || get_destination() == null) {
            return null;
        }
        if (get_destination() != null) {
            try {
                return get_destination().getClass().getMethod(box.getSelectedItem().toString(), cl);
            } catch (NoSuchMethodException | SecurityException ex) {
                try {
                    return get_destination().getClass().getMethod(box.getSelectedItem().toString(), new Class<?>[]{});
                } catch (NoSuchMethodException | SecurityException x) {
                    return null;
                }
                // return null;
            }
        }
        return null;
    }

    @A_Commande(help = "set method for in destination port updating")
    public void set_method(String txt) {
        setLists(txt, "method");
    }

    @A_Commande(help = "set route selector for group_matrix")
    @Override
    public void setPar_mxgrp(String txtval) {
        option.setValuefor("Par_mxgrp", txtval);
    }

    @A_Commande(help = "return route selector for group matrix")
    @Override
    public String getPar_mxgrp() {
        Object Obj = option.getValuefor("Par_mxgrp");
        return Obj.toString();
    }

    @A_Commande(help = "set the SCAN method to update in destination port")
    public void setSCN_method(String txt) {
        set_method(txt);
    }

    @A_Commande(help = "return true if CLI is activated")
    public boolean isCLI_enable() {
        return (Boolean) option.getValuefor("CLI_enable");
    }

    @A_Commande(help = "activate the CLI mode")
    public void setCLI_enable(boolean bool) {
        if (isCLI_enable() != bool) {
            option.setValuefor("CLI_enable", bool);
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setCLI_enable(bool);
        }
        if (Parent instanceof I_Console && bool == false) {
            ((I_Console) Parent).removeconsole(get_source());
        }
    }
    // set list for source/dest/methode/type/..

    public void setLists(String txt, String type) {
        if (txt == null || txt.length() == 0) {
            return;
        }
        DefaultComboBoxModel<Object> box = option.getValuefor(type, new DefaultComboBoxModel<>());

        if (txt.compareTo(box.getSelectedItem().toString()) != 0) {
            int idx = -1;
            for (int i = 0; i < box.getSize(); i++) {
                if (box.getElementAt(i).toString().compareTo(txt) == 0) {
                    idx = i;
                }
            }
            if (idx == -1) {
                return;
            }
            box.setSelectedItem(box.getElementAt(idx));
            option.setValuefor(type, box);
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).repaintLists();
        }
    }

    @A_Commande(help = "true if the SCAN continiusly loop")
    public int getSCN_MaxCycle() {
        return (Integer) option.getValuefor("SCN_MaxCycle");
    }

    public void setSCN_MaxCycle(int nb) {
        if (getSCN_MaxCycle() != nb) {
            option.setValuefor("SCN_MaxCycle", nb);
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_MaxCycle(nb);
        }
    }

    @A_Commande(help = "true if the SCAN toxml")
    public boolean isSCN_toxml() {
        return (Boolean) option.getValuefor("SCN_toxml");
    }

    @A_Commande(help = "set the SCAN toxml option")
    public void setSCN_toxml(boolean bool) {
        if (isSCN_toxml() != bool) {
            option.setValuefor("SCN_toxml", bool);
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_toxml(bool);
        }
    }

    @A_Commande(help = "return the SCAN view name for the scann list")
    public String getSCN_view() {
        return option.getValuefor("SCN_view").toString();
    }

    @A_Commande(help = "set the SCAN view for the scann list")
    public void setSCN_view(String txt) {
        option.setValuefor("SCN_view", txt);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_view(txt);
        }
    }

    @A_Commande(help = "return the SCAN key to write into DB")
    public String getSCN_key() {
        if (((XMLres) option.getValuefor("SCN_inStore")).getPrimaryKeys().isEmpty()) {
            return null;
        }
        return ((XMLres) option.getValuefor("SCN_inStore")).getPrimaryKeys().get(0);
    }

    @A_Commande(help = "set the SCAN key to write into DB")
    public void setSCN_key(String txt) {
        ((XMLres) option.getValuefor("SCN_inStore")).setPrimaryKeys(txt);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_store((XMLres) option.getValuefor("SCN_inStore"));
        }
    }

    @A_Commande(help = "return the SCAN name of the data field to update into the DB")
    public String getSCN_datafld() {
        return option.getValuefor("SCN_datafld").toString();
    }

    @A_Commande(help = "set the SCAN name of the data field to update into the DB")
    public void setSCN_datafld(String txt) {
        option.setValuefor("SCN_datafld", txt);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_datafld(txt);
        }
    }

    @A_Commande(help = "return the SCAN name of the timestamp field to update into the DB")
    public String getSCN_timefld() {
        return ((XMLres) option.getValuefor("SCN_inStore")).getAttrValAsstring("attr_time");
    }

    public XMLres getSCN_store() {
        return (XMLres) option.getValuefor("SCN_inStore");
    }

    public void setSCN_store(XMLres res) {
        option.setValuefor("SCN_inStore", res);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_store(res);
        }
    }

    @A_Commande(help = "set the SCAN name of the timestamp field to update into the DB")
    public void setSCN_timefld(String txt) {
        ((XMLres) option.getValuefor("SCN_inStore")).setAttrVal("attr_time", txt);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_store((XMLres) option.getValuefor("SCN_inStore"));
        }
    }

    @A_Commande(help = "return the SCAN name of the table to update in DB")
    public String getSCN_inDB() {
        return ((XMLres) option.getValuefor("SCN_inStore")).getEltName();
    }

    @A_Commande(help = "set the SCAN name of the table to update in DB")
    public void setSCN_inDB(String txt) {
        ((XMLres) option.getValuefor("SCN_inStore")).setElement(txt);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_store((XMLres) option.getValuefor("SCN_inStore"));
        }
    }

    @A_Commande(help = "return the SCAN name of the resfld to update in DB")
    public String getSCN_resfld() {
        return ((XMLres) option.getValuefor("SCN_inStore")).getAttrValAsstring("attr_result");
    }

    @A_Commande(help = "set the SCAN name of the resfld to update in DB")
    public void setSCN_resfld(String txt) {
        ((XMLres) option.getValuefor("SCN_inStore")).setAttrVal("attr_result", txt);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_store((XMLres) option.getValuefor("SCN_inStore"));
        }
    }

    public void displaySCN_cnt() {
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setSCN_cnt("" + getSCN_cyle() + "/" + getSCN_pos());
        }
    }

    public int getSCN_cyle() {
        return (Integer) option.getValuefor("SCN_cycle");
    }

    public int getSCN_pos() {
        return (Integer) option.getValuefor("SCN_pos");
    }

    public void setSCN_pos(int nb) {
        option.setValuefor("SCN_pos", nb);
        if (this.getSkin() instanceof IF_Machine) {
            ((IF_Machine) this.getSkin()).setSCN_cnt("0/" + nb);
        }
    }

    public void set_CLIPort(C_Port port) {
        update_Port(port);
        setCLI_source(port.getPortName());
        if (Parent instanceof I_Console) {
            //((I_Console) Parent).addconsole(port);
        }
        bufcmde = null;
        port.setEcho(true);
    }

    /**
     * graphical update of src & dest boxes
     *
     * @param port
     */
    private void update_Port(I_Port port) {
        for (String listname : new String[]{"source", "destination"}) {
            DefaultComboBoxModel<I_Command> box = option.getValuefor(listname, new DefaultComboBoxModel<I_Command>());
            int idx = -1;
            for (int i = 0; i < box.getSize(); i++) {
                if (box.getElementAt(i) == port) {
                    idx = i;
                }
            }
            if (idx == -1) {
                box.addElement((I_Command) port);
            } else if (port.getcxstatus().compareTo("closed") == 0) {
                box.removeElement(port);
            }
            option.setValuefor(listname, box);
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).repaintLists();
        }
    }

    @A_Commande(help = "set the source port of the CLI")
    public void setCLI_source(String txt) {
        setLists(txt, "source");
    }

    @A_Commande(help = "return the type of waited massages")
    public String getMSG_type() {
        DefaultComboBoxModel<String> box = option.getValuefor("MSG_type", new DefaultComboBoxModel<String>());
        return box.getSelectedItem().toString();

    }

    @A_Commande(help = "set the type of waited massages")
    public void setMSG_type(String txt) {
        setLists(txt, "type");
    }

    @A_Commande(help = "set the value of waited massages")
    public void setMSG_waited(String texte) {

        byte[] buff;
        try {
            buff = TUtils.string2byte(texte);
        } catch (Exception exe) {
            buff = texte.getBytes();
        }
        setMSG_waited(buff);
    }

    public void setMSG_waited(byte[] buff) {
        option.setValuefor("MSG_waited", buff);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setMSG_waited(buff);
        }
    }

    @A_Commande(help = "get the value of waited massages")
    public byte[] getMSG_waited() {
        return (byte[]) option.getValuefor("MSG_waited");
    }

    @A_Commande(help = "return true if Message pool is activated")
    public boolean isMSG_pool() {
        return (Boolean) option.getValuefor("MSG_pool");
    }

    @A_Commande(help = "activate Message pool")
    public void setMSG_pool(boolean bool) {
        option.setValuefor("MSG_pool", bool);
        setscaned();
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setMSG_pool(bool);
        }
    }

    @A_Commande(help = "get the pool time (ms) for Messsages")
    public Integer getMSG_poolval() {
        return (Integer) option.getValuefor("MSG_poolval");
    }

    public void setMSG_poolval(int nbms) {
        option.setValuefor("MSG_poolval", nbms);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setMSG_poolval(nbms);
        }
    }

    @A_Commande(help = "set the pool time (ms) for Messsages")
    public void setMSG_poolval(String nbms) {
        setMSG_poolval(Integer.parseInt(nbms));
    }

    @A_Commande(help = "return true if date should be send in output messages")
    public boolean isMSG_date() {
        return (Boolean) option.getValuefor("MSG_date");
    }

    @A_Commande(help = "set if date should be send in output messages")
    public void setMSG_date(boolean bool) {
        if (isMSG_date() != bool) {
            option.setValuefor("MSG_date", bool);
            if (skin instanceof IF_Machine) {
                ((IF_Machine) skin).setMSG_date(bool);
            }
        }
    }

    @A_Commande(help = "set banner to send")
    public byte[] getMSG_banner() {
        return (byte[]) option.getValuefor("MSG_banner");

    }

    @A_Commande(help = "get banner to send")
    public void setMSG_banner(String txt) {
        if (txt == null) {
            return;
        }
        byte[] buff;
        try {
            buff = TUtils.string2byte(txt);
        } catch (Exception ex) {
            buff = txt.getBytes();
        }
        setMSG_banner(buff);
    }

    public void setMSG_banner(byte[] buff) {
        option.setValuefor("MSG_banner", buff);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setMSG_banner(buff);
        }
    }

    public void asktoxml() {
        TDeb.wri("ask to XML from : " + get_source().getPortName());
        (get_source()).setlocked(false);
        (get_source()).DB2XML();
    }

    public boolean askSCNview() {
        if (this.get_source() != null && this.getModeName().compareTo("SCAN") == 0
                && ((I_Port) this.get_source()).getModeName().compareTo("DB") == 0
                && this.get_destination() instanceof C_Port) {
            if (this.get_source().getcxstatus().compareTo("connected") != 0) {
                get_source().CXstart();
            }
            if (((I_Port) this.get_destination()).getcxstatus().compareTo("connected") != 0) {
                ((I_Port) this.get_destination()).CXstart();
            }
            TDeb.wri("askSCNview for : " + getSCN_view());
            if (this.getSkin() instanceof IF_Machine) {
                ((IF_Machine) getSkin()).setSCN_cnt("0/0");
            }
            //!!!!!!!!!!!!!!!!!!!!;
            //((I_Port) this.get_destination()).CXstop();
            //start DB if not started
            (get_source()).setDB_maxrows("0");
            (get_source()).setlocked(false);
            //get_source().CXstart();
            // communique only with DB !!! should try(develop) with file/...??
            String requete = getSCN_view();
            if (requete.startsWith("SELECT") == false) {
                requete = "SELECT * FROM " + getSCN_view() + ";";//+" WHERE place_id='000';"=> create a view...;
            }
            C_Packet d = new C_Packet(requete.getBytes(), this);
            get_source().read_out(d);
            if (this.getSkin() instanceof IF_Machine) {
                // one other for displaying...
                get_source().read_out(d);
            }
            option.setValuefor("SCN_cycle", getSCN_cyle() + 1);
            option.setValuefor("SCN_pos", 0);
            return true;

        }
        return false;
    }

    public void askSCNnext() {
        if (scanRange == null) {
            return;
        }
        try {
            scanRange.next();
            if (scanRange.isAfterLast()) {
                // finish the scan and ask an other (loop)
                scanRange.close();
                scanRange = null;
                if (isSCN_toxml()) {
                    asktoxml();
                }
                if (getSCN_MaxCycle() >= 0) {
                    if (getSCN_MaxCycle() == 0 || getSCN_MaxCycle() > getSCN_cyle()) {
                        TDeb.wri("DBSan ask an other LOOP : " + getSCN_cyle() + "/" + getSCN_MaxCycle());
                        setcxstatus("opened");
                        askSCNview();
                    } else {
                        TDeb.wri("DBSan reached end of cycle: " + getSCN_MaxCycle() + " .. asking stopped ");
                        CXstop();
                    }
                }
            } else {
                // change destination port parameter
                if (getModeName().startsWith("SCAN") && getcxstatus().startsWith("connected")) {
                    setSCN_pos(scanRange.getRow());
                    displaySCN_cnt();
                    try {
                        String arg = scanRange.getString(getSCN_datafld());
                        get_method(C_Packet.class).invoke(get_destination(), new C_Packet(arg.getBytes(), this));
                        TDeb.wri("DB started: " + getSCN_cyle() + " pos :" + getSCN_pos()
                                + " on " + get_destination().toString()
                                + " launch: " + get_method(C_Packet.class).getName()
                                + " with: " + arg);
                    } catch (SQLException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                        TDeb.wri("Null data for :" + getSCN_datafld() + "=>" + ex.getMessage());
                        //try next
                        this.CXstop();
                    }
                }
            }
        } catch (SQLException ex) {
             System.out.println("C_Machine : askSCNnext() =>"+ex.getMessage());
        }
    }

    private void askSCNstore(Object result) {
        if (scanRange == null || getSCN_resfld() == null | getSCN_resfld().length() == 0 || getSCN_inDB() == null || getSCN_inDB().length() == 0) {
            return;
        }
        String key_val;
        try {
            key_val = scanRange.getString(getSCN_key());
            TDeb.wri("DBSan Addr for : " + getSCN_key() + "=" + key_val);
        } catch (SQLException ex) {
            TDeb.wri("No key found for : " + getSCN_key() + " ... stop...");
            return;
        }
        com.jdcm.common.XMLres res = new com.jdcm.common.XMLres(getSCN_inDB());
        res.setPrimaryKeys(getSCN_key());
        res.addAttribut(getSCN_key(), key_val);
        res.addAttribut(getSCN_resfld(), result);
        if (getSCN_timefld().length() > 0) {
            res.addAttribut(getSCN_timefld(), new java.util.Date(System.currentTimeMillis()));
            // java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("yy-MM-dd HH:mm:ss.S");
        }
        //   String req="UPDATE "+this.getSCN_table()+ " SET "+this.getSCN_resfld()+"="+re+" WHERE "+this.getSCN_datafld()+"='"+key_val+"';";
        TDeb.wri("SCN Store " + key_val + "=>" + result);
        C_Packet d = new C_Packet(res, this);
        ((I_Port) this.get_source()).read_out(d);
        askSCNnext();
    }// </editor-fold>

    private void askSCNstop() {
        scanRange = null;
        if (get_source() != null && get_source().getcxstatus().compareTo("connected") != 0) {
            get_source().CXstop();
        }
        if (this.get_destination() instanceof I_Port) {
            // could be a Main..
            if (((I_Port) this.get_destination()).getcxstatus().compareTo("connected") != 0) {
                ((I_Port) this.get_destination()).CXstop();
            }
        }
    }

    public A_Events getEVT_matrice() {
        return (A_Events) option.getValuefor("EVT_table");
    }

    @Override
    public String getPortName() {
        return option.getValuefor("PortName").toString();
    }

    @A_Commande(help = "set the name of the port")
    @Override
    public void setPortName(String name) {
        if (name == null) {
            return;
        }
        option.setValuefor("PortName", name);
        option.setTitle(getTitle());
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setPortName(name);
        }
        Parent.Arcv(this, "PortName", "Type");
    }

    @Override
    public String[] getcxStatusList() {
        String[] res = {"new", "creating", "created", "starting", "started",
            "connected", "closing", "closed", "stopping", "stopped", "error"
        };
        return res;
    }

    public String[] getcxModeList() {
        String[] res = {"MSG", "SCAN", "CLI", "EVT"
        };
        return res;
    }

    @Override
    public void setColor(java.awt.Color c) {
        int idx = getIndex();
        if (getConsole() != null && idx >= 0 && getConsole().getColor(idx) != c) {
            getConsole().setColor(idx, c);
        } else {
            sparecolor = c;
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setColor(c);
        }
    }

    @Override
    public java.awt.Color getColor() {
        if (isSystem()) {
            return sparecolor;
        } else if (getConsole() != null) {
            return getConsole().getColor(this.getIndex());
        } else {
            return java.awt.Color.BLACK;
        }
    }

    @Override
    public int getIndex() {
        if (Parent != null && isSystem() == false) {
            return Parent.getPorts().indexOf(this);
        } else if (system_index < -1) {
            return system_index;
        }
        return -1;
    }

    @Override
    public boolean isSystem() {
        return system_index != -1;
    }

    public void setIndex(int port) {
        // option.setValuefor("Index", port);
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setIndex(port);
        }
    }

    /**
     * Manage Function (Param) part cabs
     *
     * @return true if scan is launched
     */
    public boolean isscaned() {
        return scan != null;
    }

    public final void setscaned() {
        boolean bool;
        bool = isMSG_pool() || this.getModeName().compareTo("SCAN") == 0;
        if (bool && scan == null) {
            TDeb.wri("Scan port : Starting...");
            scan = new C_PScan(this);
        }
        if (bool) {
            scan.scanning();
        }
        if (bool == false) {
            if (scan != null) {
                TDeb.wri("Scan port : Stopping..");
                scan.close();
                // !! if packet are stored what append??
                scan = null;
            }
        }
    }

    @A_Commande(help = "return status of the Machine")
    @Override
    public String getcxstatus() {
        return option.getValuefor("cxstatus").toString();
        // return cxstatus;
    }

    @A_Commande(help = "set status of the Machine")
    public final void setcxstatus(String status) {
        if (getcxstatus().compareTo(status) == 0) {
            // already set to this status !!!
            TDeb.wri("no new status : " + status);
            return;
        }
        TDeb.wri("cxstatus : " + getcxstatus() + " => " + status);
        option.setValuefor("cxstatus", status);
        // cxstatus=status;
        if (Parent != null) {
            Parent.Arcv(this, status, "Status");
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setcxstatus(status);
        }
    }

    /**
     * provide the name of the activ mode
     *
     * @return the mode
     */
    @A_Commande(help = "return the mode of the Machine")
    @Override
    public String getModeName() {
        return option.getValuefor("ModeName").toString();
    }

    /**
     * Change the mode for this machine
     *
     * @param txt the name of the mode to set
     */
    @A_Commande(help = "set the Mode of the port (Message/SCAN/CLI/EVT")
    @Override
    public void setModeName(String txt) {
        if (txt == null) {
            return;
        }
        TDeb.wri("Mode setting : " + txt);
        int idx = -1;
        for (int i = 0; i < this.getcxModeList().length; i++) {
            if (this.getcxModeList()[i].compareTo(txt) == 0) {
                idx = i;
            }
        }
        if (idx == -1) {
            TDeb.wri("Setmode : Unknown tab:" + txt + "=> stop program");
            return;
        }
        setModeidx(idx);
        option.setTitle(getTitle());
    }

    /**
     * Change the mode of this machine
     *
     * @param i the Number of the mode (fistr is 0)
     */
    public void setModeidx(int i) {
        // inti => 0 => IPL4=>initIPL4=> Nothing to do!!!
        TDeb.wri("Mode setting cab : " + i);
        if (i >= getcxModeList().length || i < 0) {
            TDeb.wri("cabs [0..." + getcxModeList().length + "]; Le mode " + i + " n'existe pas");
            return;
        }
        option.setValuefor("ModeName", getcxModeList()[i]);
        if (getcxModeList()[i].startsWith("CLI")) {
            setCLI_enable(true);
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).setModeidx(i);
        }
    }

    @Override
    public void init_Port() {
        // setbtn_stop(false);
    }

    @Override
    public boolean isEcho() {
        // port Echo ??
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * execute the command and send answer main function of CLI
     *
     * @param cmdeLine the command to execute (? => help)
     *
     *
     */
    public void doCLI(String cmdeLine) {
        TDeb.wri("=>" + cmdeLine);
        String txtcmde = cmdeLine;
        String prompt = "(" + cmdeobj.getCMDName() + ")>";
        if (txtcmde == null || this.isCLI_enable() == false) {
            return;
        }
        if (txtcmde.startsWith(prompt)) {
            txtcmde = txtcmde.substring(prompt.length());
        }
        //// SHOULD BE BETTER BY UNDERSTANDING MESSAGES...
      /*  while (txtcmde.startsWith("\n"+prompt)) {
         txtcmde = txtcmde.substring(1+prompt.length());
         }*/

        if (bufcmde == null) {
            TDeb.wri("< BANNER");
            bufcmde = "";
            String init = "---------------------------------------------\r\n";
            init = init + "   +++   " + Parent.toString() + "   +++ \r\n";
            init += "   +++     ? for help     +++ \r\n";
            init += "---------------------------------------------\r\n";
            get_source().read_out(new C_Packet(init + prompt, this));
            return;
        }
        bufcmde += txtcmde;
        // manage BackSpaces (0x08)
        while (bufcmde.contains("\b")) {
            int idx = bufcmde.indexOf("\b");
            if (idx == 0) {
                bufcmde = bufcmde.substring(1);
            } else {
                bufcmde = bufcmde.substring(0, idx - 1) + bufcmde.substring(idx + 1);
            }
        }
        //PAD with \r\n
        if (txtcmde.endsWith("\r\n") == false && txtcmde.endsWith("\n") == false) {
            return;
        }
        bufcmde = bufcmde.trim();
        while (bufcmde.indexOf("\b") > 0) {
            bufcmde = bufcmde.substring(0, bufcmde.indexOf("\b") - 1) + bufcmde.substring(bufcmde.indexOf("\b") + 1);
        }
        if (bufcmde.length() == 0) {
            get_source().read_out(new C_Packet(prompt, this));
            // bufcmde = "";=>  =0!!!
            return;
        }

        if (bufcmde.endsWith("?") || bufcmde.compareTo("help") == 0 || bufcmde.compareTo("h") == 0) {
            //--------------------help--------------------
            if (bufcmde.startsWith("?") || bufcmde.compareTo("help") == 0 || bufcmde.compareTo("h") == 0) {
                TDeb.wri("< HELP");
                String res = " - ?     : This help\r\n";
                res += " -. ?    : list commands on current object\r\n";
                res += " - int ? : View/list child/s objects\r\n";
                res += " - cmde ? : return the value of the object\r\n";
                res += " - A? : list commands begining wtih A\r\n";
                res += " - sh .  : description of this object\r\n";
                res += " - cmde=X: assign X to commande 'cmde'\r\n";
                res += " - exit  : return to parent/stop if main\r\n";
                res += " pronmpt is (current obj)>\r\n";
                get_source().read_out(new C_Packet(res + prompt, this));
                bufcmde = "";
                return;
            }
            //---------list of the commands for this objects--------------------
            if (bufcmde.startsWith(". ?") || bufcmde.startsWith(".?")) {
                String res = "";
                /* java.util.List<java.lang.reflect.Method> meths = Parent.getmethodes(cmdeobj);*/
                //java.util.List<java.lang.reflect.Method> meths =java.util.Arrays.asList(cmdeobj.getClass().getMethods());
                for (int i = 0; i < cmdeobj.getCMDOptions().getRowCount(); i++) {
                    String opt_label = cmdeobj.getCMDOptions().getLabelAt(i);
                    if (cmdeobj.getCMDOptions().isDefault(opt_label) == false) {
                        opt_label = "*" + opt_label;
                    }
                    if (opt_label.length() >= 12) {
                        opt_label += "\t";
                    } else {
                        opt_label += "\t\t";
                    }
                    res += opt_label + TUtils.getObj2str(cmdeobj.getCMDOptions().getValueAt(i, 1)) + "\t" + cmdeobj.getCMDOptions().getValueAt(i, 7) + "\r\n";
                }
                get_source().read_out(new C_Packet(res + prompt, this));
                bufcmde = "";
                return;

            } else if (bufcmde.startsWith("int ")) {
                //---------list of the childrens for this objects--------------------
                String res = "list of: " + cmdeobj.getCMDName() + "\r\n";
                java.util.List<I_Command> childs = cmdeobj.getCMDChilds("");
                if (childs == null || childs.isEmpty()) {
                    res += "No childs founds \r\n";
                } else {
                    for (I_Command chld : childs) {
                        res = res + "=> " + chld.getCMDdesc() + "\r\n";
                    }
                }
                TDeb.wri("< INTERFACE " + res);
                get_source().read_out(new C_Packet(res + prompt, this));
                bufcmde = "";
                return;
            } else if (bufcmde.endsWith(" ?")) {
                //----------------- GET A value of option----------------------------------//
                String res = "";
                String txtcmd = bufcmde.substring(0, bufcmde.length() - 1).trim();
                Object obj = cmdeobj.getCMDOptions().getValuefor(txtcmd);
                res += txtcmd + " = " + TUtils.getObj2str(obj) + "\r\n";
                get_source().read_out(new C_Packet(res + prompt, this));
                bufcmde = "";
                return;

            }
            //--------------list of commands beginig with...-------
            /// TO REDO WITH =>  TUtils. for =X and ' ?'
            String res = "";
            java.util.List<java.lang.reflect.Method> meths = Parent.getmethodes(cmdeobj);
            if (meths == null) {
                bufcmde = "";
                return;
            }
            String cmde = bufcmde.substring(0, bufcmde.length() - 1);
            int nb = -1;
            int first = -1;
            for (java.lang.reflect.Method meth : meths) {
                if (meth.getName().toString().startsWith(cmde)) {
                    String sep = "\t\t";
                    if (meth.getName().toString().length() >= 8) {
                        sep = "\t";
                    }
                    res = res + meth.getName() + sep + meth.getAnnotation(com.jdcm.common.A_Commande.class).help() + "\r\n";
                    nb++;
                    if (first == -1) {
                        first = meths.lastIndexOf(meth);
                    }
                }
            }
            if (nb == -1 || nb >= 1) {
                bufcmde = "";
            }
            if (nb == 0) {
                java.lang.reflect.Method meth = meths.get(first);
                if (meth.getParameterTypes().length == 0) {
                    try {
                        res += "=>" + Parent.command(cmdeobj, meth, null) + "\r\n";
                    } catch (Exception ex) {
                        res += "ERROR\r\n";
                    }
                } else {
                    res = meth.getName() + "\t" + meth.getParameterTypes()[0] + "\t" + meth.getAnnotation(com.jdcm.common.A_Commande.class).help() + "\r\n";
                }
                bufcmde = "";
                cmde = "";
                // cmde = meth[0].toString();
            }
            get_source().read_out(new C_Packet(res + prompt + cmde, this));
            return;
        }
        //----------------      DETAILS OF Current Object --------------
        if (bufcmde.compareTo("sh .") == 0 || bufcmde.compareTo("sh.") == 0) {
            get_source().read_out(new C_Packet(cmdeobj.getCMDdetails() + prompt, this));
            bufcmde = "";
            return;
        } else if (bufcmde.startsWith("int ")) {
            //---------access to a childrens of this objects--------------------
            String name = bufcmde.substring("int ".length()).trim();
            String res = "";
            java.util.List<I_Command> childs = cmdeobj.getCMDChilds("");
            if (childs == null || childs.isEmpty()) {
                res += "No childs founds \r\n";
            } else {
                for (I_Command chld : childs) {
                    if (chld.getCMDName().compareTo(name) == 0) {
                        cmdeobj = chld;
                    }
                }
            }
            prompt = "(" + cmdeobj.getCMDName() + ")>";
            get_source().read_out(new C_Packet(res + prompt, this));
            bufcmde = "";
            return;
        } else if (bufcmde.startsWith("exit")) {
            //--------------------   EXIT curent Object----------------//
            TDeb.wri("< exit ");
            if (cmdeobj == Parent) {
                get_source().CXstop();
                if (Parent.isShell()) {
                    Parent.setShell(false, "Term");
                }
                bufcmde = "";
                return;
            }
            cmdeobj = cmdeobj.getCMDParent();
            prompt = "(" + cmdeobj.getCMDName() + ")>";
            get_source().read_out(new C_Packet(prompt, this));
            bufcmde = "";
            return;

        } else if (bufcmde.indexOf("=") != -1) {
            //----------------------------- SET a Value--------------------/
            String opt_label = bufcmde;
            String valtxt;
            opt_label = bufcmde.split("=")[0].trim();
            valtxt = bufcmde.split("=")[1].trim();
            String res;
            String result = "OK\t";
            try {
                cmdeobj.getCMDOptions().setValuefor(opt_label, TUtils.getstr2Obj(valtxt));
            } catch (Exception ex) {
                result = "ERROR\t";
            }
            Object obj = cmdeobj.getCMDOptions().getValuefor(opt_label);
            res = opt_label + " = " + TUtils.getObj2str(obj) + "\r\n";
            get_source().read_out(new C_Packet(result + res + prompt, this));
        } else {
            return;
        }
        bufcmde = "";
    }

    public void Send_msg() {
        if (this.getcxstatus().compareTo("connected") != 0) {
            return;
        }
        if (this.getModeName().startsWith("MSG") == false || get_destination() == null) {
            return;
        }
        if (get_method(String.class) != null) {
            try {
                //   banner is used as arg in method!!!
                Parent.command(get_destination(), get_method(String.class).getName().toString(), new String(this.getMSG_banner()));
            } catch (Exception ex) {
                TDeb.wri("Pb send Msg : " + ex.getMessage());
            }
        } else if (getMSG_banner().length > 0) {// && getMSG_function().compareTo("N/A") == 0) {
            byte[] dt = null;
            if (isMSG_date()) {
                java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("yy-MM-dd HH:mm:ss.S");
                dt = (format.format(new java.util.Date(System.currentTimeMillis())) + "\t").getBytes();
            }
            // create & send packet
            C_Packet d = new C_Packet(TUtils.addtab(dt, getMSG_banner()), this);
            //   d.setWItime(new java.util.Date(System.currentTimeMillis()));
            if (get_destination() instanceof I_Port) {
                ((I_Port) get_destination()).read_out(d);
            } else {
                Parent.read(d);
            }
        }
    }

    @Override
    public void CXArcv(I_Port src, String message, String type) {
        // update boxes
        if (type.compareTo("Status") == 0 && message.compareTo("new") == 0) {
            update_Port(src);
        }
        if (type.compareTo("Status") == 0 && message.compareTo("closed") == 0) {
            update_Port(src);
        }
        if (getcxstatus().compareTo("connected") != 0) {
            return;
        }
        if (type.compareTo("Status") == 0 && message.compareTo("stopped") == 0) {
            // receive stop of the CLI client (!!source)
            if (isCLI_enable() && (I_Port) get_source() == src) {
                bufcmde = null;
                if (Parent instanceof F_Main) {
                    ((F_Main) Parent).setShell(false);
                }
            }

        }
        if (getMSG_type().compareTo(type) == 0) {
            //status :created/stopped/closing...
            //Type : IPL4/Term...
            //Admin :functionName
            if (src.equals(get_source())) {
                if (TUtils.ismatchto(message.getBytes(), getMSG_waited())) {
                    Send_msg();
                }
            }
        }
    }

    @Override
    public void CXnew() {
        //TDeb = new D_Debug("Machine : [" + getIndex() + "]");
    }

    @Override
    public boolean CXcreate(String methode, String value) {
        boolean res = true;
        Class<?> mclas = java.lang.String.class;
        Object ob1 = value;
        if (value.compareTo("true") == 0 || value.compareTo("false") == 0) {
            mclas = boolean.class;
            ob1 = Boolean.valueOf(value).booleanValue();
        }
        java.lang.reflect.Method m = TUtils.getMethod(this.getClass(), "set" + methode, mclas);
        /*try {
         m = this.getClass().getMethod("set" + mclas);
         } catch (Exception e) {
         }
         if (m == null) {
         try {
         m = this.getClass().getDeclaredMethod("set" + methode, mclas);
         } catch (Exception e) {
         }
         }*/
        if (m != null) {
            try {
                if (ob1 == null) {
                    m.invoke(this);
                } else {
                    m.invoke(this, ob1);
                }
            } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
                res = false;
            }
        } else {
            res = false;
        }
        if (res == false) {
            TDeb.wri("Pb : " + methode + " NOT SET TO " + value);
        }
        return res;
    }

    @Override
    public void CXstart() {
        setcxstatus("opened");

        if (this.getModeName().compareTo("SCAN") == 0) {
            if (askSCNview()) {
                TDeb.wri("Waiting for scanning range");
            } else {
                TDeb.wri("could not reach database");
                CXstop();
            }
        } else {
            setcxstatus("connected");
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).CXstart();
        }
    }

    @Override
    public void CXend() {
        if (getcxstatus().compareTo("closed") == 0) {
            return;
        }
        if (getcxstatus().compareTo("stopped") != 0) {
            CXstop();
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).CXend();
        }
        setModeidx(0);
        //port keep his name for event detection after deth
        // setPortName("---");
        setcxstatus("closed");
        Parent.CXremove(this);
    }

    @Override
    public void CXstop() {
        setcxstatus("stopping");

        askSCNstop();
        option.setValuefor("SCN_cycle", 0);
        option.setValuefor("SCN_pos", 0);
        if (Parent instanceof I_Console && isCLI_enable()) {
            ((I_Console) Parent).addconsole(get_source());
        }
        if (skin instanceof IF_Machine) {
            ((IF_Machine) skin).CXstop();
        }
        setcxstatus("stopped");
    }

    /**
     * Receiving packet from Main :<br> - send to process CLI/MSG/SCAN/..
     *
     * @param pack packet to transmit to Main
     */
    @Override
    public void read_out(C_Packet pack) {
        if (stat_P != null) {
            String txt = pack.getObj().getClass().getSimpleName();
            int size = 1;
            if (pack.getBytes() != null) {
                size = pack.getBytes().length;
                txt = "byte[" + size + "]";

            }
            stat_P.store("machine", -size, txt + " receied from main");
            stat_P.store(pack, false);
        }
        if (this.getModeName().startsWith("CLI")) {
            if (pack.getsource() == (I_Port) get_source()) {
                if (isCLI_enable() && cmdeobj != null) {
                    doCLI(new String(pack.getBytes()));

                }
            }
        } else if (this.getModeName().startsWith("MSG")) {
            if (pack.getBytes() != null && getMSG_waited().length > 0) {
                if (pack.getsource() == (I_Port) get_source()) {
                    if (TUtils.ismatchto(pack.getBytes(), getMSG_waited())) {
                        Send_msg();
                    }
                }
            }
        } else if (this.getModeName().startsWith("SCAN")) {
            if (pack.getObj() instanceof java.sql.ResultSet && pack.getsource() == get_source()) {
                //scan.DBscanning((java.sql.ResultSet) d.getObj());
                setcxstatus("connected");
                if (scanRange == null) {
                    scanRange = (java.sql.ResultSet) pack.getObj();
                    this.askSCNnext();
                } else if (this.getSkin() instanceof IF_Machine) {
                    ((IF_Machine) getSkin()).setSCN_Range((java.sql.ResultSet) pack.getObj());
                }
                if (this.getSCN_resfld() == null || this.getSCN_resfld().length() == 0) {
                    (get_source()).setlocked(true);
                }
            } else {
                if (pack.getsource() == (I_Port) get_destination()) {
                    TDeb.wri("Store : " + pack.getObj() + " into " + getSCN_key());
                    askSCNstore(pack.getObj());
                }
            }
        }
        if (this.getModeName().startsWith("EVT")) {
            if (pack.getObj() != null && getEVT_matrice() != null) {
                java.util.List<C_Actiondef> list = getEVT_matrice().getTask(pack.getObj());
                if (list != null) {
                    for (C_Actiondef action : list) {
                        if (action.getDest() == null && action.getMethod() == null) {
                            for (Object obj : action.getParamList()) {
                                C_Packet packet = new C_Packet(obj, this);
                                Parent.read(packet);
                            }
                        } else {
                            try {
                                action.getMethod().invoke(action.getDest(), action.getParamList().toArray());
                            } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                                TDeb.wri("EVENT : could not do Action :" + action.toString());
                            }
                        }
                    }
                }
            }
        }
    }

    @Override
    public void setslreading(boolean bool) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void initmethodsbox(boolean bool, DefaultComboBoxModel<String> combo, I_Command source) {
        if (source == null || combo == null) {
            return;
        }
        if (bool) {
            combo.removeAllElements();
            java.util.List<java.lang.reflect.Method> mets_msg = Parent.getmethodes(source);

            if (mets_msg == null) {
                combo.removeAllElements();// = new javax.swing.DefaultComboBoxModel(new String[0]);
                return;
            }
            combo.addElement("N/A");
            for (java.lang.reflect.Method meth : mets_msg) {
                combo.addElement(meth.getName());//.toString();
            }
            //combo = new javax.swing.DefaultComboBoxModel(res);
        } else {
            combo.removeAllElements();// = new javax.swing.DefaultComboBoxModel(new String[0]);
        }
    }

    private void initsourcesboxes() {
        if (Parent == null) {
            return;
        }
        //  jComboBox1.addItem(Parent);
        I_Command[] src = new I_Command[Parent.getPorts().size()];
        I_Command[] dest = new I_Command[Parent.getPorts().size() + 1];
        dest[0] = (I_Command) Parent;
        for (int i = 0; i < Parent.getPorts().size(); i++) {
            src[i] = (I_Command) Parent.getPorts().get(i);
            dest[i + 1] = (I_Command) Parent.getPorts().get(i);
        }
        DefaultComboBoxModel<I_Command> sources = new DefaultComboBoxModel<>(src);
        DefaultComboBoxModel<I_Command> dests = new DefaultComboBoxModel<>(dest);
        option.setValuefor("source", sources);
        option.setValuefor("destination", dests);
        initmethodsbox(true, option.getValuefor("method", new DefaultComboBoxModel<String>()), (I_Command) get_destination());
    }

    @Override
    public javax.swing.ImageIcon getCMDIcon() {
        return TUtils.getIcon("Mach_" + getcxstatus() + ".gif");
    }

    @Override
    public void setCMDOptions(Options_Model r) {
        option = r;
    }

    @Override
    public Options_Model getCMDOptions() {
        return option;
    }

    @Override
    public String getCMDdetails() {
        String res = "";
        res = res + "Name : " + this.getCMDName() + " Type : " + this.getModeName() + " Status :" + this.getcxstatus() + "\r\n";
        return res;
    }

    @Override
    public java.util.List<I_Command> getCMDChilds(String child) {
        java.util.List<I_Command> res = new java.util.ArrayList<>();
        java.util.List<I_Command> fulllist = new java.util.ArrayList<>();// no childs
        for (I_Command ch : fulllist) {
            if (ch.getCMDName().compareTo(child) == 0) {
                res.add(ch);
            }
        }

        return res;
    }

    @Override
    public String getCMDName() {
        return this.getPortName();
    }

    @Override
    public I_Command getCMDParent() {
        if (Parent instanceof I_Command) {
            return (I_Command) Parent;
        }
        return null;
    }

    @Override
    public String getCMDdesc() {
        return getCMDName() + "\t" + this.getClass().getSimpleName() + "\t" + getModeName();
    }
    // Variables declaration - do not modify
    // End of variables declaration
}
