package com.jdcm.eltrx;

import com.jdcm.common.*;
import com.jdcm.diagram.A_Events;
import com.jdcm.modifiers.stacks.I_stack_elt;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.io.*;
//console
import java.io.IOException;
import java.io.OutputStream;
import javax.swing.text.*;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Collections;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.ButtonModel;
import javax.swing.DefaultComboBoxModel;

import javax.swing.JPanel;
import javax.swing.JTextPane;
import javax.swing.Icon;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 * The Main support port
 *
 * @author Marc GIBOIN
 */
public class C_Main implements I_Main, I_Console, I_Command {

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    private final String base_cxname = "Port";
    private final java.util.List<I_Port> CXsys = new java.util.ArrayList<>();
    // for terminals
    private final int MAXCOLOR = 50;
    private final Color cool[] = new Color[MAXCOLOR];

    private D_Debug TDeb;
    private long starttime;
    private T_CONF config;
    private C_Stack stacks;
    private java.util.List<I_Port> Ports = null; // Store all ports
    private I_Port selectedPort = null;
    private java.util.List<C_Port> consolePorts = null; // Store all ports
    private java.util.List<String> checkedmedia = new java.util.ArrayList<>();
    private T_Matrice Mat = null;
    private OutputStream LogStream; // for log file (console output)
    private OutputStream PackStream; // for Packets detailed file
    private OutputStream outStream; //log cab
    private OutputStream errStream; // log cab
    private String progName = "JDataCom-0.321"; // displayedName
    private javax.swing.ButtonModel[] chks = null;
    private PrintStream default_out = null;
    private PrintStream default_err = null;

    // Used for config
    public java.util.concurrent.Semaphore sem = new java.util.concurrent.Semaphore(0);
    private javax.swing.table.AbstractTableModel stack_protos = null;
    private javax.swing.table.AbstractTableModel conf_protos = null;
    private javax.swing.table.AbstractTableModel mat_protos = null;
    private javax.swing.table.AbstractTableModel stack_values = new javax.swing.table.DefaultTableModel(new Object[]{"no module", "Values"}, 0);
    private Object mainSkin = null;
    private Options_Model option;

    /**
     * Creates new form Main_CX used to manage Ports/stack/debug/matrix/...
     */
    public C_Main() {
        tolog(progName + " is starting on: " + System.getProperty("os.name") + "-" + System.getProperty("os.arch") + ";" + System.getProperty("java.version"));
        setOption();
        //option.setValuefor("isaplet", true); //for test
        initialisation();
        tolog("Main is started");

    }

    public C_Main(String[] args) {
        tolog(progName + " is starting on: " + System.getProperty("os.name") + "-" + System.getProperty("os.arch") + ";" + System.getProperty("java.version"));
        setOption();
        //option.setValuefor("isaplet", true); //for test
        initialisation();
        tolog("Main is started");
        if (args != null && args.length > 0) {
            //              javax.swing.JOptionPane.showMessageDialog(null, "=>"+args[0], "autoexecute", javax.swing.JOptionPane.ERROR_MESSAGE);
            if (args[0].endsWith(".cap")) {
                /// should be able to 'Open with..." in windows? (xx.jar is not a valide application...)
                DisplayCapture2(null, new java.io.File(args[0]));
            }
        }
    }

    public C_Main(boolean isaplet) {
        tolog(progName + " is starting");
        setOption();
        option.setValuefor("isaplet", isaplet);
        initialisation();
        tolog("Main is started");
    }

    public C_Main(String config, boolean isviewed) {
        setConf_File(config);
        setOption();
        initialisation();
        setvisible(isviewed);
    }

    @Override
    public String toString() {
        return progName;
    }

    public void setName(String txt) {

        progName = txt;
        if (this.getSkin() instanceof java.awt.Frame) {
            ((java.awt.Frame) getSkin()).setTitle(txt);
        }
    }

    /**
     * made because NB6.9=>Out warnings
     *
     * @param message the message to log (standard out stream)
     */
    public final void tolog(String message) {
        System.out.println(message);
    }

    private void setOption() {
        // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        option = new Options_Model(this);
        option.setTitle(this.getCMDName());
        option.addOption("isaplet", false, "bool", "false", false, false, "is launched as an aplet");
        option.addOption("nextPortName", "Port_0", "String", "PortXX", false, false, "name of the next port name");
        option.addOption("Main_Stat", false, "bool", "false", false, false, "is Main Statistics collected/displayed");
        option.addOption("Main_Look", "Metal", "bool", "false", false, false, "set Look and feel for GUI interface");
        String[] lfclasses = {"com.seaglasslookandfeel.SeaGlassLookAndFeel",
            "com.nilo.plaf.nimrod.NimRODLookAndFeel"};
        option.addOption("Main_addLnF", new DefaultComboBoxModel<>(lfclasses), "look", "class", true, true, "set L n F");
        option.addOption("Shell_Enabled", false, "bool", "false", false, false, "is shell started");
        option.addOption("islog", false, "bool", "false", false, false, "is log are stored");
        option.addOption("log_val", "", "text", "false", false, true, "is log filename");
        option.addOption("ispacket", false, "bool", "false", false, false, "is packets are stored");
        option.addOption("packet_val", "", "text", "false", false, true, "packets filename");
        option.addOption("keepstdout", true, "bool", "", false, false, "display the standard out flow");
        option.addOption("keepstderr", true, "bool", "", false, false, "disply the standard err flow");
        option.addOption("Conf_Stop", true, "bool", "false", false, false, "stops after startup (ex: a bridge don't stops)");
        option.addOption("Conf_ErrExit", true, "bool", "false", false, false, "Stops on error while running");
        option.addOption("Conf_Matrix", null, "config", "false", false, true, "the event matrix used for Config");
        option.addOption("Conf_Enabled", false, "bool", "false", false, false, "set if XML config is active");
    }

    public void setSkin(Object obj) {
        mainSkin = obj;
    }

    public Object getSkin() {
        // for WEB frame in ACY
        return mainSkin;
    }

    public String getHelpText() {
        return "M.Marc GIBOIN \n " + progName
                + "\r\n * Copyright (C) 2013 Marc Giboin"
                + "\r\n*"
                + "\r\n* This program is free software; you can redistribute it and/or modify"
                + "\r\n* it under the terms of the GNU Lesser General Public License as"
                + "\r\n* published by the Free Software Foundation; either version 2.1 of the"
                + "\r\n* License, or (at your option) any later version."
                + "\r\n*"
                + "\r\n* This program is distributed in the hope that it will be useful,"
                + "\r\n* but WITHOUT ANY WARRANTY; without even the implied warranty of"
                + "\r\n* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the"
                + "\r\n* GNU Lesser General Public License for more details."
                + "\r\n* You should have received a copy of the GNU Lesser General Public"
                + "\r\n* License along with this program; if not, write to the Free Software"
                + "\r\n* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA"
                + "\r\nThanks to :"
                + "\r\n   - http://users.frii.com/jarvi/rxtx/index.html"
                + "\r\n   - http://www.eden.rutgers.edu/~muscarim/jpcap/index.html"
                + "\r\n(http://netresearch.ics.uci.edu/kfujii/jpcap/doc/download.html)"
                + "\r\n   - http://jusb.sourceforge.net/"
                + "\r\n";
    }

    public void setFocus(String txt) {
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).setFocusTab(txt);
        }
    }

    public javax.swing.table.AbstractTableModel getstack_protos() {
        return stack_protos;
    }

    public javax.swing.table.AbstractTableModel getconf_protos() {
        return conf_protos;
    }

    public javax.swing.table.AbstractTableModel getmat_protos() {
        return mat_protos;
    }

    public java.util.List<String> getmedias() {
        return Collections.unmodifiableList(checkedmedia);
    }

    public javax.swing.table.AbstractTableModel getstack_values() {
        return stack_values;
    }

    public javax.swing.table.AbstractTableModel getstack_model() {
        return stacks.getmodel();
    }

    /**
     * get the Matrix type (RING/FULL/GROUP/BUS/FREE/..)
     *
     * @return the activ type of matrix
     */
    public String getMat_Type() {
        if (Mat != null && Mat.getMatType() != null) {
            return Mat.getMatType().getClass().getSimpleName().substring("mat_".length());
        } else {
            return null;
        }
    }

    /**
     * set the active Matrix type
     *
     * @param txt the type of matrix (RING/FULL/GROUP/BUS/FREE)
     */
    public void setMat_Type(String txt) {
        if (Mat != null) {// for TCP_ltransit need to setmat  && Mat.getType().startsWith(txt) == false
            try {
                Mat.setMatType(txt);
                refresh_table("Type", "Matr", null);
            } catch (Exception ex) {
            }
        }
    }

    public void setMat_Type(Class<?> cl) {
        if (Mat != null) {// for TCP_ltransit need to setmat  && Mat.getType().startsWith(txt) == false
            try {
                com.jdcm.modifiers.matrix.mat_base res = (com.jdcm.modifiers.matrix.mat_base) cl.getConstructor(Mat.getClass()).newInstance(Mat);
                Mat.setMatType(res);

                refresh_table("Type", "Matr", null);
            } catch (Exception ex) {
            }
        }
    }

    public void setMat_Bidir(boolean bool) {
        if (Mat != null && Mat.isMat_Bidir() != bool) {
            Mat.setMat_Bidir(bool);
        }
        refresh_table("Type", "Mat_Bidir", null);
    }

    public void setMat_Echo(boolean bool) {
        if (Mat != null && Mat.isMat_Echo() != bool) {
            Mat.setMat_Echo(bool);
        }
        refresh_table("Status", "Mat_Echo", null);
    }

    public Object getoption(String txt) {
        return option.getValuefor(txt);
    }

    private void initialisation() {
        // Fonctions D_Debug & systeme
        starttime = System.currentTimeMillis();
        default_out = System.out;
        default_err = System.err;
        errStream = new jTextPaneOutputStream("styleerr");
        outStream = new jTextPaneOutputStream("styleout");
        TDeb = new D_Debug("Main");
        Ports = new java.util.ArrayList<>();
        consolePorts = new java.util.ArrayList<>();
        // Used for the console (else output)
        //chks = new boolean[jPanel8.getComponents().length];
        String[] dbgnames = {"Main", "Term", "Port", "Machine", "Matrice", "Code", "Stacks", "Sys", "Scan",
            "T-IP", "T-File", "T-SYS", "T-WIN", "T-LPT", "T-ETH", "T-RS", "T-USB", "T-SND", "T-Conf", "T-DB", "DBUtils",
            "DB-CX", "DB-Tab", "CModel", "F-USB", "F-Obj", "FDec", "Xfilter", "Events"};
        chks = new javax.swing.ButtonModel[dbgnames.length];
        for (int i = 0; i < dbgnames.length; i++) {
            chks[i] = new javax.swing.DefaultButtonModel();
            chks[i].setActionCommand(dbgnames[i]);
        }
        TDeb.setconsole(this);
        checklib();
        Color couleur[] = {Color.BLUE, new Color(0, 102, 0), Color.RED, new Color(100, 0, 255), Color.ORANGE.darker(), Color.PINK, Color.GRAY, Color.MAGENTA, Color.cyan, Color.GREEN, Color.yellow.darker(), Color.red.darker(), Color.DARK_GRAY};
        for (int i = 0; i < cool.length; i++) {
            if (i < couleur.length) {
                cool[i] = couleur[i];
            } else {
                cool[i] = Color.BLACK;
            }
        }
        stack_protos = initStackList();
        mat_protos = initMatList();
        conf_protos = initConfList();
        //initialise functions
        stacks = new C_Stack(this, this);
        setStack_Enabled(isStack_Enabled());
        setnextPortName(base_cxname + "_" + Ports.size());
        Mat = new T_Matrice(this, this);
        Mat.start();
        setMat_Type("GRP");
        autorun();
        //setvisible(true);// to hemlp
        tolog("Started in : " + (System.currentTimeMillis() - starttime) + "ms");
        System.gc();
    }

    private com.jdcm.common.ListTableModel initMatList() {
        java.util.List<String> names = TUtils.getFileNames("com/jdcm/modifiers/matrix", null, false);
        java.util.List<Object[]> mat_pros = new java.util.ArrayList<>();
        for (String name : names) {

            if (name.startsWith("mat_")) {
                try {
                    Class<? extends com.jdcm.modifiers.matrix.mat_base> clmod = (Class<? extends com.jdcm.modifiers.matrix.mat_base>) Class.forName("com.jdcm.modifiers.matrix." + name);
                    // if (clmod instanceof com.jdcm.modifiers.mat_base){
                    // does it exist a Class Cast (asSubClass()...)
                    //   ((com.jdcm.modifiers.mat_base)clmod).getcomment();
                    //  }
                    String comment;
                    javax.swing.Icon icon;
                    try {
                        java.lang.reflect.Method m = clmod.getMethod("getComment", new Class<?>[]{});
                        comment = (String) m.invoke(clmod, new Object[]{});
                        m = clmod.getMethod("getIcon", new Class<?>[]{});
                        icon = (javax.swing.Icon) m.invoke(clmod, new Object[]{});
                    } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                        return null;
                    }
                    Object[] row = new Object[4];
                    row[0] = clmod;
                    row[1] = icon;
                    row[2] = comment;
                    row[3] = getCreateStackButton(clmod, null, null);
                    mat_pros.add(row);
                } catch (ClassNotFoundException ex) {
                    TDeb.wri("Mat element :" + name + "not implemented");
                }
            }
        }
        java.util.List<String> headers = new java.util.ArrayList<>();
        headers.addAll(java.util.Arrays.asList("Module/Icon/Comment".split("/")));
        boolean[] editable = new boolean[]{true, false, false};
        if (this.ismedia_loaded("TOOL")) {
            headers.add("Code");
            editable = new boolean[]{true, false, false, true};
        }
        com.jdcm.common.ListTableModel model = new com.jdcm.common.ListTableModel(mat_pros, headers);
        model.setEditable(editable);
        return model;
    }

    /**
     * create a stack list including class and implementation (for
     * findPacketstack())
     *
     * @return
     */
    private com.jdcm.common.ListTableModel initStackList() {
        // list protocols to set in a TableModel
        java.util.List<String> names = TUtils.getFileNames("Descriptors", null, false);
        java.util.List<Object[]> stack_pros = new java.util.ArrayList<>();
        for (String name : names) {
            try {
                Class<? extends com.jdcm.modifiers.stacks.Stack_base> clmod = (Class<? extends com.jdcm.modifiers.stacks.Stack_base>) Class.forName("com.jdcm.modifiers.stacks.Stack_" + name);
                double osi;
                com.jdcm.modifiers.stacks.I_stack_elt res;
                String comment;
                try {
                    res = getNewStackElt(clmod);
                    java.lang.reflect.Method m = clmod.getMethod("getosi", new Class<?>[]{});
                    osi = (Double) m.invoke(clmod, new Object[]{});
                    m = clmod.getMethod("getComment", new Class<?>[]{});
                    comment = (String) m.invoke(clmod, new Object[]{});
                } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                    return null;
                }
                Object[] row = new Object[5];
                row[0] = clmod;
                row[1] = osi;
                row[2] = comment;
                row[3] = getCreateStackButton(clmod, null, null);
                row[4] = res;
                stack_pros.add(row);
            } catch (ClassNotFoundException ex) {
                TDeb.wri("Stack element :" + name + "not implemented");
            }
        }
        java.util.List<String> headers = new java.util.ArrayList<>();
        boolean[] editable = new boolean[]{true, false, false};
        headers.addAll(java.util.Arrays.asList("Module/Level/Comment".split("/")));
        if (this.ismedia_loaded("TOOL")) {
            headers.add("Code");
            editable = new boolean[]{true, false, false, true};
        }
        com.jdcm.common.ListTableModel model = new com.jdcm.common.ListTableModel(stack_pros, headers);
        // column 0 are class, if diable then grayed...
        model.setEditable(editable);
        return model;
    }

    public com.jdcm.common.ListTableModel initConfList() {
        java.util.List<java.io.File> fileList = TUtils.getFiles("config", null);
        String descr = null, name = null;
        if (fileList != null && fileList.size() > 0) {
            java.util.List<Object[]> rowlist = new java.util.ArrayList<>();
            for (File f : fileList) {
                final A_Events evts = new A_Events(this);
                evts.createfromStream(TUtils.getFileStream(f));
                if (evts.getStatuslist().isEmpty() == false) {
                    evts.reset();
                    try {
                        final javax.swing.JToggleButton b = new javax.swing.JToggleButton();
                        try {
                            //  System.err.println("=> list conf 0 : "+b.getName());
                            b.setIcon(TUtils.getIcon("Bt_off_CX.gif"));
                            b.setSelectedIcon(TUtils.getIcon("Bt_on_CX.gif"));
                            b.setMargin(new java.awt.Insets(0, 0, 0, 0));
                            confActionListener al = new confActionListener() {
                                @Override
                                public void actionPerformed(ActionEvent e) {
                                    super.actionPerformed(e);
                                    setConf(setConf_Enabled(b.isSelected(), conf, evts));
                                }
                            };
                            b.addActionListener(al);
                            descr = evts.getDescription();
                        } catch (Exception ex) {
                            System.out.println("PB config miss title or description : " + name + "," + descr);
                        }
                        rowlist.add(new Object[]{f, descr, evts, b});//getCreateStackButton(null, f, null)
                    } catch (Exception ex) {
                        TDeb.wri("Pb with file :" + f + "=>" + ex);
                    }
                }
            }
            java.util.List<String> headers = new java.util.ArrayList<>();
            headers.addAll(java.util.Arrays.asList("File/Description/Events/Start".split("/")));
            boolean[] editable = new boolean[]{false, false, true, true};
            com.jdcm.common.ListTableModel conftm = new com.jdcm.common.ListTableModel(rowlist, headers);
            conftm.setEditable(editable);
            return conftm;
        }
        return null;
    }

    /*
     * create a stack button to edit code of the stack MUST not be null
     * (comparable Pb with row sorter)
     */
    private javax.swing.JToggleButton getCreateStackButton(Class<? extends com.jdcm.modifiers.modif_base> clelt, java.io.File f, String code) {
        final javax.swing.JToggleButton b = new javax.swing.JToggleButton(" ");
        b.setMargin(new java.awt.Insets(0, 0, 0, 0));
        try {
            if (code == null && clelt != null) {
                java.lang.reflect.Method m = clelt.getMethod("getCode", new Class<?>[]{String.class, Class.class});
                Object codeobj = m.invoke(clelt, new Object[]{clelt.getSimpleName(), clelt});
                if (codeobj != null) {
                    code = codeobj.toString();
                }
            } else if (f != null) {
                code = "";
                try {
                    java.io.InputStream reader = TUtils.getFileStream(f);
                    int i;
                    byte by;
                    while (reader.available() > 0) {
                        i = reader.read();
                        if (i < 127) {
                            by = (byte) i;
                        } else {
                            by = (byte) (256 + i);
                        }
                        code = code + new String(new byte[]{by});
                    }
                } catch (IOException ex) {
                    code = null;
                }
            }
            final String codetxt = code;
            b.setToolTipText(codetxt);
            //final String codetxt = clelt.getCode(clelt.getSimpleName());
            final java.io.File file = f;
            if (codetxt != null && codetxt.length() > 0) {
                b.addActionListener(new java.awt.event.ActionListener() {
                    @Override
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        if (getSkin() instanceof F_Main) {
                            if (b.isSelected()) {
                                if (file != null) {
                                    if (file.getName().toUpperCase().endsWith(".XML")) {
                                        com.jdcm.editors.P_XML p = new com.jdcm.editors.P_XML(false);
                                        p.displayFile(file);
                                        p.openFrame();
                                    } else {
                                        ((F_Main) getSkin()).setCompiler(file);
                                    }
                                } else {
                                    ((F_Main) getSkin()).setCompiler(b.getToolTipText());
                                }
                            } else {
                                // b.setToolTipText(((F_Main) getSkin()).getCompilerCode());
                                ((F_Main) getSkin()).setCompiler((String) null);
                            }
                        }
                    }
                });
            } else {
                if (clelt != null) {
                    TDeb.wri("no code for this class" + clelt.getName());
                }
                b.setEnabled(false);
            }
        } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            TDeb.wri("Exception creating stacks buttons" + ex.getMessage());
            b.setEnabled(false);
        }
        return b;
    }

    /**
     * Lauch the XML config file
     *
     *
     */
    private void autorun() {
        tolog("autorun try index.xml..");
        setConf_File("index");
        String src = this.getClass().getProtectionDomain().getCodeSource().getLocation().toString();
        if (getConf_Matrix() != null) {
            tolog("index.xml is present and OK");
            setConf_Enabled(true);
        }
        if (getConf_Matrix() == null && src.contains(".jar") && src.contains("/")) {
            tolog("try ... trying start.xml..");
            setConf_File("start-" + src.substring(src.lastIndexOf("/") + 1, src.indexOf(".jar")));
            setConf_Enabled(true);
        }
        if (getConf_Matrix() == null) {
            tolog("autorun trying start.xml..");
            setConf_File("start");
            setConf_Enabled(true);
            if (isConf_Enabled() == false) {
                tolog("Abnormal terminaison for start.xml");
                System.exit(-1);
            }
            if (option.getValuefor("Conf_Stop", true)) {
                setConf_Enabled(false);
            }
        }
    }

    @Override
    public java.awt.Color[] getColors() {
        return cool;
    }

    /**
     * Assign the color to a port
     *
     * @param portidx index of the port
     * @param col the color to assign
     */
    @Override
    public void setColor(int portidx, Color col) {
        if (portidx >= 0) {
            cool[portidx] = col;
            if (getPorts().size() > portidx) {
                getPorts().get(portidx).setColor(col);
                if (this.getSkin() instanceof java.awt.Component) {
                    ((java.awt.Component) getSkin()).repaint();
                }
            }
        }
    }

    /**
     * Provide the color of a port
     *
     * @param portIdx index of the port
     * @return the color for this portIdx
     */
    @Override
    public java.awt.Color getColor(int portIdx) {
        if (portIdx < 0) {
            for (I_Port port : CXsys) {
                if (port != null && port.getIndex() == portIdx) {
                    return port.getColor();
                }
            }
        } else {
            return cool[portIdx];
        }
        return java.awt.Color.BLACK;
    }

    private void checklib() {
        // default javax.net/java.io/Runtime/java.sql/javax.sound
        checkedmedia.add("IPL4");
        checkedmedia.add("File");
        checkedmedia.add("SYS");
        checkedmedia.add("DB");
        checkedmedia.add("SND");
        checkedmedia = ((new C_Start("libcheck", this)).checklib(checkedmedia));
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).checklib();
        }
    }

    public void displayPort(I_Port p) {
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).displayPort(p);
        }
    }

    /**
     * return a array {String,Class,String} of {Name,attribut class,desc}
     *
     * @param comanded the object commanded
     * @return the describe array
     */
    @Override
    public java.util.List<java.lang.reflect.Method> getmethodes(I_Command comanded) {
        java.lang.reflect.Method[] m = comanded.getClass().getMethods();
        int size = 0;
        for (Method m1 : m) {
            if (m1.getAnnotation(com.jdcm.common.A_Commande.class) != null) {
                if (m1.getParameterTypes().length <= 1) {
                    size++;
                }
            }
        }
        if (size == 0) {
            return null;
        }
        java.util.List<java.lang.reflect.Method> res = new java.util.ArrayList<>();
        for (Method m1 : m) {
            if (m1.getAnnotation(com.jdcm.common.A_Commande.class) != null) {
                if (m1.getParameterTypes().length <= 1) {
                    java.lang.reflect.Method newmeth = m1;
                    /*
                     * if (m[i].getParameterTypes().length == 1) { newmeth[1] =
                     * m[i].getParameterTypes()[0]; } newmeth[2] =
                     * m[i].getAnnotation(com.jdcm.common.A_Commande.class).help();
                     */
                    res.add(newmeth);
                }
            }
        }
        return res;
    }

    /**
     *
     * Manage menu
     *
     * @return the next port default name
     */
    public String getnextPortName() {
        String txt = (String) option.getValuefor("nextPortName");
        return txt;
    }

    public void setnextPortName(String cxname) {
        if (cxname != null) {
            option.setValuefor("nextPortName", cxname);
        }
    }

    public void setMain_addLnF(String txt) {
        if (txt != null & txt.length() > 0) {
            String name = txt;
            if (name.contains(".")) {
                name = txt.substring(txt.lastIndexOf(".") + 1);
            }
            if (name.endsWith("LookAndFeel")) {
                name = name.substring(0, name.length() - "LookAndFeel".length());
            }
            UIManager.installLookAndFeel(name, txt);
            if (this.mainSkin instanceof F_Main) {
                ((F_Main) mainSkin).InitLF();
            }
        }
    }

    /**
     * Set the asked Look&Feel TODO ALL Frame siiuld beupdated when L&F change
     * set the name of the L&F or the class name (but should be on the system)
     *
     * @param txt the asked Look & Feel
     */
    public void setMain_Look(String txt) {
        if (txt != null && option.getValuefor("Main_Look", "").compareTo(txt) != 0) {
            String uiclass = null;
            if (txt.indexOf(".") > 0) {
                setMain_addLnF(txt);
                uiclass = txt;
            }
            for (int i = 0; i < UIManager.getInstalledLookAndFeels().length; i++) {
                if (UIManager.getInstalledLookAndFeels()[i].getName().compareTo(txt) == 0) {
                    uiclass = UIManager.getInstalledLookAndFeels()[i].getClassName();
                    i = UIManager.getInstalledLookAndFeels().length;
                }
            }

            try {
                UIManager.setLookAndFeel(uiclass);
                option.setValuefor("Main_Look", UIManager.getLookAndFeel().getName());
            } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex) {
                TDeb.wri("Pb while changinglook to : " + txt + "=>" + uiclass);
            }
        }
        if (mainSkin instanceof F_Main && ((F_Main) mainSkin).getLook().compareTo(txt) != 0) {
            // for Menubuttons
            ((F_Main) mainSkin).setLook(UIManager.getLookAndFeel().getName());
        }
    }

    public boolean isvisible() {
        if (mainSkin instanceof F_Main) {
            return ((F_Main) mainSkin).isVisible();
        }
        return false;
    }

    public final void setvisible(boolean bool) {
        if (bool && java.awt.GraphicsEnvironment.isHeadless()) {
            tolog("No graphic env. continue hided");
            return;
        }
        if (bool && mainSkin == null) {
            //      if (((new C_Start(true)).load_Module("swing-layout-1.0.4.jar", null) < 0)) {
            //          tolog("C_Main : swing-layout-1.0.4.jar not found and not load");
            // javax.swing.JOptionPane.showMessageDialog(new java.awt.Frame(), "GUI Main needs swing-layout-1.0.4 \r\n not found !");
            // System.exit(0);
            //   }
            tolog("open GUI");
            mainSkin = new F_Main(this);
        } else if (!bool && mainSkin != null) {
            if (mainSkin instanceof F_Main) {
                ((F_Main) mainSkin).setVisible(false);
            }
            mainSkin = null;
        }
        setConsoleOut(bool);
        setConsoleErr(bool);
        // System.out.println("=> aplet : "+option.getValuefor("isaplet",true));
        if (mainSkin instanceof F_Main && !option.getValuefor("isaplet", true)) {
            ((F_Main) mainSkin).setVisible(bool);
        }
    }

    public boolean isStack_Stat() {
        if (stacks != null && stacks.getCMDOptions() != null) {
            return stacks.getCMDOptions().getValuefor("Stack_Stat", true);
        } else {
            return false;
        }
    }

    public void setStack_Stat(boolean bool) {
        if (bool != isStack_Stat() && stacks != null) {
            stacks.getCMDOptions().setValuefor("Stack_Stat", bool);
        }
        if (this.getSkin() instanceof F_Main) {
            ((F_Main) this.getSkin()).setStack_Stat(bool);
        }
    }

    public boolean isMat_Stat() {
        if (Mat == null) {
            return false;
        } else {
            return Mat.getCMDOptions().getValuefor("Mat_Stat", true);
        }
    }

    public void setMat_Stat(boolean bool) {
        if (bool != isMat_Stat() && Mat != null) {
            Mat.getCMDOptions().setValuefor("Mat_Stat", bool);
        }
        if (this.getSkin() instanceof F_Main) {
            ((F_Main) this.getSkin()).setMat_Stat(bool);
        }
    }

    public boolean isMain_Stat() {
        return option.getValuefor("Main_Stat", true);
    }

    public void setMain_Stat(boolean bool) {
        if (bool != isMain_Stat()) {
            option.setValuefor("Main_Stat", bool);
        }
        if (this.getSkin() instanceof F_Main) {
            ((F_Main) this.getSkin()).setMain_Stat(bool);
        }
    }

    @Override
    public boolean isShell() {
        return option.getValuefor("Shell_Enabled", true);
    }

    @Override
    public void setShell(boolean bool, String type) {
        if (isShell() != bool) {
            option.setValuefor("Shell_Enabled", bool);
            if (bool) {
                addShell(type);
            } else {
                if (CXsys.get(1) != null) {
                    CXsys.get(1).CXstop();
                    CXsys.get(1).CXend();
                }
                if (CXsys.get(0) != null) {
                    if (CXsys.get(0).getModeName().startsWith("SYS") && mainSkin == null) {
                        // the CLI is routed to a shll?
                        System.exit(0);
                    }
                    CXsys.get(0).CXstop();
                    CXsys.get(0).CXend();
                }
            }
        }
        if (mainSkin instanceof F_Main) {
            if (((F_Main) mainSkin).isShell() != bool) {
                ((F_Main) mainSkin).setShell(bool);
            }

        }
    }

    /**
     * add a System CLI machine and terminal
     */
    private void addShell(String type) {

        C_Port pterm = new C_Port(this, this, -98);
        // check the asked Type (TERM/SYS/...) is known
        int idx = (pterm).getModesNames().indexOf(type);
        if (idx < 0) {
            return;
        }
        C_Machine shell = new C_Machine(this, this, -99);
        CXsys.clear();
        CXsys.add(pterm);
        CXsys.add(shell);
        pterm.setcxstatus("creating");
        shell.setcxstatus("creating");
        pterm.setModeName(type);
        pterm.setPortName("SHELL");
        pterm.setTerm_Type("");
        pterm.setColor(Color.blue);
        pterm.getCMDOptions().setValuefor("SYS_stdinout", true);
        shell.setModeName("CLI");
        shell.setCLI_enable(true);
        pterm.setCX_Banner("[ENTER TO START]".getBytes());
        pterm.CXstart();
        pterm.setTerm_outMode("OUTPUT_SCREEN");
        ((F_Terminal) pterm.getSlave()).configure_Shell();
        shell.set_CLIPort(pterm);
        shell.CXstart();
        pterm.setlog(true);
        final F_Terminal f = ((F_Terminal) pterm.getSlave());
        f.addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                if (e.getSource() == f) {
                    setShell(false, "Term");
                }
                super.windowClosing(e);
            }
        });
    }

    public final void DisplayCapture2(C_Port pterm, File file) {
        if (file == null || file.canRead() == false) {
            return;
        }
        if (pterm == null) {
            pterm = new C_Port(this, this, -99);
            pterm.setcxstatus("creating");
            pterm.setModeName("Term");
            pterm.setPortName(file.getName());
            pterm.setlockin(true);
        }
        CXsys.add(pterm);
        pterm.CXstart();
        byte[] buff = new byte[0];
        byte[] b = new byte[4000];
        int red = 1;
        try {
            try (java.io.InputStream f = TUtils.getFileStream(file)) {
                while (red > 0) {
                    red = f.read(b);
                    if (red > 0 && red <= b.length) {
                        buff = TUtils.addtab(buff, java.util.Arrays.copyOf(b, red));
                    }
                }
            }
        } catch (IOException ex) {
            TDeb.wri("Pb while reading capture => " + ex.getMessage());
        }
        final byte[] buffer = buff;
        try {

            final com.jdcm.modifiers.stacks.Stack_base eth = new com.jdcm.modifiers.stacks.Stack_ETHII() {
                @Override
                public void getReceivedPacket(C_Packet p) {
                    byte[] prot = getOptions().getValuefor("eth2_sproto", new byte[]{});
                    O_MACaddress macsrc = getOptions().getValuefor("eth2_src", new O_MACaddress());
                    O_MACaddress macdst = getOptions().getValuefor("eth2_dest", new O_MACaddress());
                    if (java.util.Arrays.equals(prot, new byte[]{0x10, 0})) {
                        // String macstr = mod.getValueAt(rowdsrc, "Value").toString();
                        String[] mac = macsrc.toString().split(":");
                        String[] mac2 = macdst.toString().split(":");
                        int src, dest;
                        if (macsrc.toString().substring(macsrc.toString().length() - 6, macsrc.toString().length() - 1).endsWith(":ff:f")) {
                            src = Integer.parseInt(mac[mac.length - 1], 16) - 256;
                        } else {
                            src = Integer.parseInt(mac[mac.length - 1], 16) + 255 * Integer.parseInt(mac[mac.length - 2], 16);
                        }
                        if (macdst.toString().substring(macdst.toString().length() - 6, macdst.toString().length() - 1).endsWith(":ff:f")) {
                            dest = Integer.parseInt(mac2[mac2.length - 1], 16) - 256;
                        } else {
                            dest = Integer.parseInt(mac2[mac2.length - 1], 16) + 255 * Integer.parseInt(mac2[mac2.length - 2], 16);
                        }
                        p.setstore_srcidx(src);
                        p.setstore_dstidx(dest);
                    }

                }
            };
            eth.getOptions().setValuefor("eth2_copy", true);
            final F_Terminal pterm2 = (F_Terminal) pterm.getSlave();
            pterm.setlockin(false);
            pterm2.setTerm_autoScroll(false);
            final com.jdcm.modifiers.stacks.Stack_base dmp = new com.jdcm.modifiers.stacks.Stack_Dump() {
                java.util.List<String> macs = new java.util.ArrayList<>();

                @Override
                public void getReceivedPacket(C_Packet p) {
                    if (p.isbuffer() == false) {
                        return;
                    }

                    try {
                        if (p.getBytes().length >= 14 && p.getBytes()[12] == 0x10 && p.getBytes()[13] == 0) {
                            pterm2.getModelPackets().addAll(eth.receive(p));
                        } else {
                            if (p.getBytes().length >= 14) {
                                String mac = "" + new com.jdcm.common.O_MACaddress(java.util.Arrays.copyOf(p.getBytes(), 6));
                                if (macs.contains(mac) == false) {
                                    macs.add(mac);
                                }
                                p.setstore_srcidx(macs.indexOf(mac));
                            } else {

                            }
                            pterm2.getModelPackets().add(p);
                        }
                        pterm2.fireDataChange();
                    } catch (Exception ex) {
                    }
                }
            };
            final Timer timerSys = new Timer();
            timerSys.schedule(new TimerTask() {

                @Override
                public void run() {
                    try {
                        dmp.receive(new C_Packet(buffer, -1));
                    } catch (Exception ex) {
                    }
                }

            }, 0);

        } catch (Exception ex) {
            TDeb.wri("Pb while analyse capture => " + ex.getMessage());
        }

    }

    public void DisplayCapture(C_Port pterm, File file) {
        if (file == null || file.canRead() == false) {
            return;
        }
        if (pterm == null) {
            pterm = new C_Port(this, this, -99);
            pterm.setcxstatus("creating");
            pterm.setModeName("Term");
            pterm.setPortName(file.getName());
            pterm.setlockin(true);
        }
        C_Port pfile = (C_Port) addCX("Port", "Capture", "File");
        pfile.setcxstatus("creating");
        pfile.setFile_addr(file);
        pfile.setFile_write(false);
        pfile.setCX_openbyslave(true);
        pfile.setFile_EOFstop(false);
        pterm.setlockin(true);
        //pfile.setstop2end(true);
        stacks.setStack_Enabled(true);
        try {
            stacks.addStack("Capture", "DESC", "CaptDump", 7.0);
        } catch (Exception ex) {
        }
        com.jdcm.modifiers.stacks.Stack_DESC desc = (com.jdcm.modifiers.stacks.Stack_DESC) stacks.getTarget(pfile, "CaptDump");
        desc.setDESC_Protofirst("Dump.xml");
        desc.setDESC_Protolast("ETHII.xml");
        desc.setDESC_EOFstop(true);
        desc.setfrommedia(false);
        desc.setDESC_sendas("ModelTa");
        desc.setDESC_PadTO(false);
        CXsys.clear();
        CXsys.add(pterm);
        CXsys.add(pfile);
        pterm.setTERM_capReader(true);
        if (pterm.getcxstatus().compareTo("creating") == 0
                || pterm.getcxstatus().startsWith("stop")) {
            pterm.CXstart();
            ((F_Terminal) pterm.getSlave()).setTerm_autoScroll(false);
        }
        pfile.CXstart();
        //----------------
        //that should be a CXStop() overwrite or a StatusEvent on Port or thread watchdog
       /*   java.lang.Thread t=new java.lang.Thread(){
      
         }*/
        final I_Port p = pfile;
        final Timer timerSys = new Timer();
        timerSys.schedule(new TimerTask() {
            @Override
            public void run() {
                checkSys(p, timerSys);

            }
        }, 50);
    }

    public void checkSys(I_Port port, Timer timerSys) {
        if (port.getcxstatus().startsWith("stopped")) {
            for (I_Port p : CXsys) {
                if (p.getModeName().startsWith("Term")) {
                    ((C_Port) p).setTERM_capReader(false);
                } else {
                    p.CXend();
                }
            }
            CXsys.clear();
            timerSys.purge();
        } else {
            final I_Port p = port;
            final Timer tS = timerSys;
            timerSys.schedule(new TimerTask() {
                @Override
                public void run() {
                    checkSys(p, tS);
                }
            }, 50);
        }
    }
    /*
     * save all messages in a Tcpdump trace file
     */

    public boolean ispacket() {
        return option.getValuefor("ispacket", true);
    }

    public void setpacket(boolean bool) {
        if (ispacket() != bool) {
            option.setValuefor("ispacket", bool);
        }
        try {
            if (PackStream != null) {
                PackStream.close();
                PackStream = null;
            }
        } catch (IOException ex) {
            TDeb.wri("Log : Pb closing Packet file");
            // setcapture (false);
            return;
        }
        if (ispacket() && option.getValuefor("packet_val") != null) {
            PackStream = TUtils.getstream(option.getValuefor("packet_val").toString());
            if (PackStream == null) {
                setpacket(false);
            }
            String head = "-----Packet file---- ";
            settxtheader(LogStream, head);
        }
    }

    public void setpackval(String filename) {
        if (ispacket()) {
            TDeb.wri("change Packet file to : " + filename + " aborted because log is running ");
            return;
        }
        if (filename.equals(option.getValuefor("packet_Val"))) {
            option.setValuefor("packet_Val", filename);
        }
    }

    /**
     * Add a packet in Packet Stat (Stats are not so used)
     *
     * @param pack
     * @param time
     * @param pos
     * @param type
     */
    @Override
    public void addpacket(String pack, long time, String pos, String type) {
        if (PackStream == null) {
            return;
        }
        String text = pack + "\t" + time + "\t" + pos + "\t" + type + "\r\n";
        try {
            PackStream.write(text.getBytes());
        } catch (IOException ex) {
            TDeb.wri("Add Packet : PB writing packet in packet details file");
        }
    }
    /*
     * Save all debug mesages in a text file
     *
     */

    @A_Commande(help = "try to load module : COM/MySQL/USB/ETH/JNA/derby/Oracle/SQLServer/ODBC/Tools")
    public void loadModule(String module) {
        C_Start lo = new C_Start(module, this);
        lo.start();
        checklib();
    }

    public boolean islog() {
        return option.getValuefor("islog", true);
    }

    @A_Commande(help = "activate logs to file")
    public void setlog(boolean bool) {
        if (islog() != bool) {
            option.setValuefor("islog", bool);
        }
        try {
            if (LogStream != null) {
                LogStream.close();
                LogStream = null;
            }
        } catch (IOException ex) {
            TDeb.wri("Log : Pb closing log file");
            // setcapture (false);
            return;
        }
        if (islog() && option.getValuefor("log_val") != null) {
            LogStream = TUtils.getstream(option.getValuefor("log_val").toString());
            if (LogStream == null) {
                setlog(false);
            }

            String head = "-----log file---- ";
            settxtheader(LogStream, head);
        }
    }

    public void setlogval(String filename) {
        if (islog()) {
            TDeb.wri("change log file to : " + filename + " aborted because log is running ");
            return;
        }
        option.setValuefor("log_val", filename);
    }

    public void settxtheader(OutputStream out, String hdr) {
        String head = hdr + "\r\n "
                + "Date : " + System.currentTimeMillis() + "\r\n"
                + "-----------------------\r\n\r\n";
        try {
            out.write(head.getBytes());
        } catch (IOException ex) {
            TDeb.wri("FILE : could not write Log header");
        }
    }

    /**
     * tocheck but should be only used to check DB capabilities see
     * C_Port.getDB_driver
     *
     * @param dbname
     * @return the name of the java jdbc driver
     */
    @Override
    public String getDB_drivername(String dbname) {
        String res = null;
        //http://developers.sun.com/product/jdbc/drivers
        if (dbname.startsWith("Oracle")) {
            res = "oracle.jdbc.driver.OracleDriver";
        }
        if (dbname.compareTo("SQLServer") == 0) {
            res = "net.sourceforge.jtds.jdbc.Driver";
            // res = "com.microsoft.sqlserver.jdbc.SQLServerDriver"; with MS file
        }
        if (dbname.compareTo("MySQL") == 0) {
            res = "org.gjt.mm.mysql.Driver";
        }
        if (dbname.startsWith("ODBC")) {
            res = "sun.jdbc.odbc.JdbcOdbcDriver";
            // http://www.oracle.com/technology/software/tech/java/sqlj_jdbc/htdocs/jdbc9201.html
        }
        if (dbname.startsWith("HSQL")) {
            res = "org.hsqldb.jdbcDriver";
        }
        if (dbname.compareTo("Sybase") == 0) {
            res = "connect.sybase.SybaseDriver";
            //jtds (SQLServer should work
        }
        if (dbname.compareTo("Derby") == 0) {
            res = "org.apache.derby.jdbc.ClientDriver";
        }
        return res;
    }

    @Override
    public boolean ismedia_loaded(String media) {
        // javax.swing.DefaultComboBoxModel range = (javax.swing.DefaultComboBoxModel) option.getValuefor("medialoaded");
        if (media == null) {
            return false;
        } else {
            return checkedmedia.indexOf(media) >= 0;
        }
    }

    @Override
    public void addconsole(C_Port port) {
        if (port == null || consolePorts.indexOf(port) != -1) {
            return;
        }
        consolePorts.add(port);
    }

    @Override
    public void removeconsole(C_Port port) {
        if (port == null) {
            return;
        }
        if (consolePorts.indexOf(port) == -1) {
            return;
        }
        consolePorts.remove(port);
    }

    @Override
    public void addlog(String message) {
        String text = message + "\r\n";
        if (consolePorts.size() > 0) {
            for (int i = 0; i < consolePorts.size(); i++) {
                consolePorts.get(i).write_out(new C_Packet(text, null));//-99
            }
        }
        try {
            if (LogStream != null) {
                LogStream.write(text.getBytes());
            }
        } catch (IOException ex) {
            TDeb.wri("Exception : " + ex.getMessage());
        }
    }

    /*
     * Manage systems Out & err Streams
     *
     */
    @Override
    public boolean isConsoleErr() {
        return option.getValuefor("keepstderr", true);
    }

    @Override
    public boolean isConsoleOut() {
        return option.getValuefor("keepstdout", true);
    }

    @Override
    public void addTextPaneConsole(JTextPane textpane) {

        if (outStream instanceof jTextPaneOutputStream) {
            ((jTextPaneOutputStream) outStream).addTextPane(textpane);
        }
        if (errStream instanceof jTextPaneOutputStream) {
            ((jTextPaneOutputStream) errStream).addTextPane(textpane);
        }

    }

    @Override
    public void removeTextPaneConsole(JTextPane textpane) {
        if (outStream instanceof jTextPaneOutputStream) {
            ((jTextPaneOutputStream) outStream).removeTextPane(textpane);
        }
        if (errStream instanceof jTextPaneOutputStream) {
            ((jTextPaneOutputStream) errStream).removeTextPane(textpane);
        }
    }

    @Override
    public void setConsoleOut(boolean bool) {
        if (isConsoleOut() != bool) {
            option.setValuefor("keepstdout", bool);

        }
        if (bool) {
            System.setOut(new PrintStream(outStream));
        } else {
            System.setOut(default_out);
        }
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).setConsoleOut(bool);
        }
    }

    @Override
    public void setConsoleErr(boolean bool) {
        if (isConsoleErr() != bool) {
            option.setValuefor("keepstderr", bool);
        }
        if (bool) {
            System.setErr(new PrintStream(errStream));
        } else {
            System.setErr(default_err);
        }
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).setConsoleErr(bool);
        }
    }

    public void setStackdebug(boolean bool) {
        stacks.setlocaldebug(bool);
        this.setdbg("Stacks", bool);
    }

    public boolean isStackdebug() {
        return stacks.islocaldebug();
    }

    @A_Commande(help = "True if Stacks are enabled")
    public boolean isStack_Enabled() {
        if (stacks != null && stacks.getCMDOptions() != null) {
            return stacks.getCMDOptions().getValuefor("Stack_Enabled", true);
        } else {
            return false;
        }
    }

    @A_Commande(help = "Enable Stacks")
    public void setStack_Enabled(boolean bool) {
        if (stacks != null && isStack_Enabled() != bool) {
            stacks.getCMDOptions().setValuefor("Stack_Enabled", bool);
        }
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).setStack_Enabled(bool);
        }
    }
    /*
     * Manage config file
     */

    public boolean isConf_Stop() {
        return option.getValuefor("Conf_Stop", true);
    }

    public void setConf_Stop(boolean bool) {
        if (bool != isConf_Stop()) {
            option.setValuefor("Conf_Stop", bool);
        }
        if (isConf_Enabled()) {
            if (bool) {
                // stop config if running
                setConf_Enabled(false);
            }
        } else {
            /*Could Stop line running config
             * // WARNING will stop all runings config an not ONLY "conf_stop" order config
             * int col = conf_protos.findColumn("Start");
             for (int i = 0; i < conf_protos.getRowCount(); i++) {
                
             if (conf_protos.getValueAt(i, col) instanceof javax.swing.JToggleButton) {
             javax.swing.JToggleButton b = (javax.swing.JToggleButton) conf_protos.getValueAt(i, col);
             if (b.isSelected()) {
             b.setSelected(bool);
             for (java.awt.event.ActionListener a : b.getActionListeners()) {
             if (a instanceof confActionListener) {
             if (((confActionListener) a).getConf() != null) {
             T_CONF thisconf = ((confActionListener) a).getConf();
             setConf_Enabled(false, thisconf, thisconf.getEvents());
             b.setSelected(false);
             }
             }
             }
             }
             }
             }*/
        }
    }

    public void moveMatrixCol(int col, boolean isUp) {
        Mat.moveMatrixCol(col, isUp);
    }

    public void removeMatrixCol(int col) {
        Mat.removeMatrixCol(col);
    }

    @A_Commande(help = "return the CONF Event matrix")
    public A_Events getConf_Matrix() {
        Object ob = option.getValuefor("Conf_Matrix");
        if (ob instanceof A_Events) {
            return (A_Events) ob;
        } else {
            return null;
        }
    }

    @A_Commande(help = "return the CONF Label")
    public String getConf_Name() {
        A_Events ob = getConf_Matrix();
        if (ob != null) {
            return ob.getTitle();
        } else {
            return "Empty";
        }
    }
    // add a file and set it as default (comes from open XML..)

    @A_Commande(help = "set the XML program file")
    public void setConf_File(File file) {
        TDeb.wri("Start config with: " + file);
        if (config == null) {
            config = new T_CONF(this, null);
        }
        if (file == null || config.setConfig(file) < 0) {
            option.setValuefor("Conf_Matrix", null);
        } else {
            if (this.getSkin() instanceof F_Main) {
                ((F_Main) mainSkin).setConf_Event(config.getEvents());
            }
            option.setValuefor("Conf_Matrix", config.getEvents());
        }
    }

    @A_Commande(help = "set the XML program file")
    public final void setConf_File(String filename) {
        if (isConf_Enabled()) {
            return;
        }
        TDeb.wri("try config with :" + filename);
        config = new T_CONF(this, null);
        sem.drainPermits();
        java.io.File xmlFile = TUtils.getFile(filename + ".xml", "config");
        if (xmlFile == null) {
            xmlFile = TUtils.getFile(filename + ".xml", null);
        }
        if (xmlFile != null) {
            tolog("Starting with file: " + xmlFile);
        }
        setConf_File(xmlFile);
        /*
         * if (xmlFile == null||config.setConfig(xmlFile) < 0) {
         * option.setValuefor("CONF_matrix", null); } else { if (this.getSkin()
         * instanceof F_Main) { ((F_Main)
         * mainSkin).setCONF_event(config.getEvents()); }
         * option.setValuefor("Conf_matrix", config.getEvents()); }
         */
    }

    public void setCONF_emptyconf(boolean bool) {
        if (config != null && config.isAlive()) {
            setConf_Enabled(false);
        }
        if (bool) {
            config = new T_CONF(this, null);
            setConf_File("Empty-1state");
        } else {
            setConf_Enabled(false);
        }
    }

    @A_Commande(help = "pause/start the XML program")
    public void setConf_Pause(boolean bool) {
        if (this.isConf_Enabled()) {
            config.setPause(bool);
        }
    }

    @A_Commande(help = "is CONF exit on running error occurs")
    public boolean isConf_ErrExit() {
        return option.getValuefor("Conf_ErrExit", true);
    }

    @A_Commande(help = "set aCONF stop if eror occurs while runing")
    public void setConf_ErrExit(boolean bool) {
        option.setValuefor("Conf_ErrExit", bool);
    }

    @A_Commande(help = "return true if XML program is running")
    @Override
    public boolean isConf_Enabled() {
        return option.getValuefor("Conf_Enabled", true);
    }

    @A_Commande(help = "start/stop the XML program")
    @Override
    public void setConf_Enabled(boolean bool) {
        if (config == null
                || option.getValuefor("Conf_Matrix") == null
                || isConf_Enabled() == bool) {
            return;
        }
        option.setValuefor("Conf_Enabled", bool);
        TDeb.wri("setCONF_enable : Ask enable=" + bool);
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).setConf_Enabled(isConf_Enabled());
        }
        if (bool) {
            if (config != null) {
                //  option.setValuefor("Conf_Histo",config.getEvents().ishisto());
                TDeb.wri("setCONF_enable: Ask pause Thread :" + Thread.currentThread().getClass().getName() + "/" + Thread.currentThread().getState() + " sem wil acq:" + sem.availablePermits());
                config.start();
                try {
                    //bloque jusq'a 'started' (almost needed by start config).
                    sem.acquire();
                } catch (InterruptedException ex) {
                    TDeb.wri("setCONF_enable : exception while acquire=>" + ex.getMessage());
                }
            }
        } else {
            TDeb.wri("Stop config: " + getConf_Name());
            if (config != null) {
                config.clear();
                config = new T_CONF(this, (com.jdcm.diagram.A_Events) option.getValuefor("Conf_Matrix"));
            }
        }
    }

    public T_CONF setConf_Enabled(boolean bool, T_CONF conf, A_Events evts) {
        if (evts == null) {
            return null;
        }
        if (conf == null) {
            conf = new T_CONF(this, evts);
        }
        if (bool) {
            //  option.setValuefor("Conf_Histo",config.getEvents().ishisto());
            TDeb.wri("setCONF_enable: Ask pause Thread :" + Thread.currentThread().getClass().getName() + "/" + Thread.currentThread().getState() + " sem wil acq:" + sem.availablePermits());
            conf.start();
            try {
                //bloque jusq'a 'started' (almost needed by start config).
                sem.acquire();
            } catch (InterruptedException ex) {
                TDeb.wri("setCONF_enable : exception while acquire=>" + ex.getMessage());
            }
        } else {
            TDeb.wri("Stop config: " + evts.getTitle());
            conf.clear();
            conf = new T_CONF(this, evts);
        }
        return conf;
    }
    /*
     * Manage transit beetwen listner conntected (chat) for matrix
     */

    private I_Port getPort(int i) {
        if (i >= 0 || i < Ports.size()) {
            // admin/system ports
            return Ports.get(i);
        }
        return null;
    }

    @Override
    public java.util.List<I_Port> getPorts() {
        return Ports;
    }

    public String testtime() {
        long Start = System.nanoTime();
        for (long i = 0; i < 1000;) {
            i++;
        }
        return "-" + (System.nanoTime() - Start) + "-";
    }

    /*
     * Manage in/out dataflow & in/out admin flow treat packet just after Port
     */
    @Override
    @A_Commande(help = "Send bytes directly to Main")
    public void read(C_Packet pack) {
        C_Packet d = pack;
        if (d == null) {
            return;
        }
        TDeb.wri("send : " + d.getClass().getSimpleName() + " From " + d.getsource() + " => matrix");
        java.util.List<C_Packet> pe = new java.util.ArrayList<>();
        if (isStack_Enabled() && d.getsource().getIndex() >= 0) {
            pe = stacks.modif_in(d, stacks.getmodel().getRowCount() - 1, d.getsource());
        } else {
            pe.add(d);
        }
        read(pe);
    }

    @Override
    public void read(java.util.List<C_Packet> packets) {
        for (C_Packet p : packets) {
            if (CXsys.contains(p.getsource())) {
                // manage Matrix 
                for (I_Port ps : CXsys) {
                    if (ps != p.getsource()) {
                        ps.read_out(p);
                    }
                }
            } else {
                if (mainSkin instanceof F_Main) {
                    if (isStack_Stat() && stacks.islocaldebug() == false) {
                        ((F_Main) mainSkin).stat_storeTerm(p, false, false);
                        ((F_Main) mainSkin).stat_storeCurb(p, false, false);
                    }
                    if (isMain_Stat()) {
                        ((F_Main) mainSkin).stat_storeTerm(p, false, true);
                        ((F_Main) mainSkin).stat_storeCurb(p, false, true);
                    }
                }
                if (Mat != null) {//&& Mat.getType().compareTo("OFF") != 0
                    //if OFF => Mat==null ! !
                    Mat.mx_model(p);
                }
            }

        }
    }
    /*
     * manage packet after Matrix and before port output
     *
     */

    @Override
    public void write(C_Packet d) {
        if (d == null) {
            return;
        }
        TDeb.wri("send : " + d.getClass().getName() + " From " + d.getsource() + " => " + d.getdestination());
        I_Port dest = d.getdestination();
        if (dest != null) {
            /// Packets are visible ONLY from read() =>else ... not nice.
            if (mainSkin instanceof F_Main) {
                if (isStack_Stat() && stacks.islocaldebug() == false) {
                    ((F_Main) mainSkin).stat_storeCurb(d, false, false);
                }
                if (isMain_Stat()) {
                    ((F_Main) mainSkin).stat_storeCurb(d, false, true);
                }
            }
            java.util.List<C_Packet> ps = new java.util.ArrayList<>();
            if (this.isStack_Enabled()) {
                ps = stacks.modif_out(d, 0, dest);
            } else {
                ps.add(d);
            }
            for (C_Packet p : ps) {
                dest = p.getdestination();
                dest.read_out(p);
            }
        }

    }

    /**
     * Administrative receiveption Management Ex: state modificaton
     *
     * @param src the sender port
     * @param value content transmited
     * @param msgtype type of the message : Status
     * (new/connected/...)/Admin(functionName))/Type(IPL4/Serial/USB/)
     *
     */
    @Override
    public void Arcv(Object src, Object value, String msgtype) {
        // receive state modificatin on Ports and do tasks
        String message = value.toString();
        I_Port port = (I_Port) src;
        if (CXsys.contains(port)) {
            // no admin for Sys=> no grapphic/ no config
            return;
        }
        refresh_table(msgtype, message, port);
        //to CHECK !!!! send status to module => NOT USED (need to use form upper level to lower...
        //if port creatoing : status and port not "exist in table"
        if (stacks.getmodel() != null && isStack_Enabled()) {
            if (port.getIndex() + 1 < stacks.getmodel().getColumnCount() && port.getIndex() >= 0) {
                for (int i = stacks.getmodel().getRowCount() - 1; i >= 0; i--) {
                    Object o = stacks.getmodel().getValueAt(i, port.getIndex() + 1);
                    if (o instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                        com.jdcm.modifiers.stacks.I_stack_elt stac = (com.jdcm.modifiers.stacks.I_stack_elt) o;
                        stac.StkArcv(message, msgtype);
                    }
                }
            }
        }
        if (msgtype != null) {
            if (port instanceof C_Port) {
                TDeb.wri(msgtype + ": CXPort [" + port.getIndex() + "](" + port.getPortName() + ")=> " + message);
                for (int i = 0; i < getPorts().size(); i++) {
                    if (getPort(i) instanceof C_Machine) {
                        getPort(i).CXArcv(port, message, msgtype);
                    }
                }
            }
        }
        if (value == "Slave" && "Type".equals(msgtype)) {
            // for DisplayLClientNumber in T_IP !!!
            return;
        }
        if (isConf_Enabled()) {
            if (config == null) {
                //javax.swing.JOptionPane.showMessageDialog(this, "Error with file :" + getCONF_file() + "\r\n see console for more informations", "Error loading...", javax.swing.JOptionPane.ERROR_MESSAGE);
                setConf_Enabled(false);
            } else {
                if (value != "removed" && config.checkforActions(src, value) >= 0) {
                    try {
                        // care that 'config.invoke(..)' (and no one else today..!!.)
                        if (Thread.currentThread().getClass().getName().startsWith("T_CONF") == false) {
                            //   System.err.println("Ask pause Thread :"+Thread.currentThread().getClass().getName()+"/"+Thread.currentThread().getState()+" sem wil acq:"+sem.availablePermits());
                            //      sem.acquire();
                        }
                    } catch (Exception ex) {
                        TDeb.wri("Pb while semaphore acquire");
                    }
                }

            }
        }
        // NEED TO CHECK for each individual config starter.
        // each config "start" button with a listner to get the eventMatrix...
        int col = conf_protos.findColumn("Start");
        for (int i = 0; i < conf_protos.getRowCount(); i++) {
            if (conf_protos.getValueAt(i, col) instanceof javax.swing.JToggleButton) {
                javax.swing.JToggleButton b = (javax.swing.JToggleButton) conf_protos.getValueAt(i, col);
                if (b.isSelected()) {
                    for (java.awt.event.ActionListener a : b.getActionListeners()) {
                        if (a instanceof confActionListener) {
                            if (((confActionListener) a).getConf() != null) {
                                ((confActionListener) a).getConf().checkforActions(src, value);
                            }
                        }
                    }
                }
            }
        }

    }

    private void refresh_table(String type, String message, I_Port p) {
        // impacted=Port/Status/type
        if (type.startsWith("Status") && (message.startsWith("creating") || message.startsWith("removed"))) {
            if (Mat.getmodel() instanceof Matrix_Model) {
                ((Matrix_Model) Mat.getmodel()).update();
            }
            if (stacks.getmodel() instanceof Stack_Model) {
                ((Stack_Model) stacks.getmodel()).update();
            }
        } else if (p != null && type.startsWith("Type") && message.compareTo("PortName") == 0) {
            ((Matrix_Model) Mat.getmodel()).fireTableStructureChanged();
            ((Stack_Model) stacks.getmodel()).fireTableStructureChanged();
        } else {
            ((Matrix_Model) Mat.getmodel()).fireTableDataChanged();
            ((Stack_Model) stacks.getmodel()).fireTableDataChanged();
        }

        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).refresh_table(type, message, p);
        }
    }
    // shortcut for shell

    @A_Commande(help = "add a port with Port/Machine:name:type")
    public I_Port addCX(String type) {
        if (type == null || type.length() == 0) {
            return null;
        }
        String[] def = type.split(",");
        if (def.length != 3) {
            TDeb.wri("3 parametres ex Port:Name:IPL4 are allowed and not " + def.length + " in " + type);
            return null;
        }
        return addCX(def[0], def[1], def[2]);
    }

    public I_Port addCX(String type, String name, String mode) {
        I_Port res = null;
        if (getCMDChilds(name) != null && getCMDChilds(name).isEmpty() == false) {
            TDeb.wri("Try to create port named " + name + " already existe => canceled");
            return null;
        }
        if (type != null) {
            res = addCX(null, type);
            if (name != null) {
                res.getCMDOptions().setValuefor("PortName", name);
            }
            if (mode != null) {
                res.setModeName(mode);
            }
        }
        return res;
    }

    @Override
    public void addMatStat(C_Packet pack) {
        if (isMat_Stat() && getSkin() instanceof F_Main) {
            ((F_Main) getSkin()).stat_storeTerm((C_Packet) pack.clone());

        }
    }

    public String getConfig(I_Command elt) {
        String spaces = "\t";
        I_Command tmp = elt;
        String res = this.getCMDName() + ": " + this.progName + "\r\n";
        while (tmp.getCMDParent() != tmp && tmp.getCMDParent() != null) {
            spaces += "\t";
            tmp = tmp.getCMDParent();
            res = "";
        }
        for (int i = 0; i < elt.getCMDOptions().getRowCount(); i++) {
            String opt_label = elt.getCMDOptions().getLabelAt(i);
            Object val = elt.getCMDOptions().getValueAt(i, 1);
            if (elt.getCMDOptions().isDefault(opt_label) == false) {
                res += spaces + opt_label + " = " + TUtils.getObj2str(val) + "\r\n";
            }
        }
        for (I_Command selt : elt.getCMDChilds("")) {
            if (selt instanceof C_Port) {
                res += spaces + "> port:" + selt.getCMDName() + ":" + ((I_Port) selt).getModeName() + "\r\n";
            } else if (selt instanceof C_Machine) {
                res += spaces + "> machine:" + selt.getCMDName() + ":" + ((I_Port) selt).getModeName() + "\r\n";
            } else {
                res += spaces + "> " + selt.getClass().getSimpleName() + "\r\n";
            }
            res += getConfig(selt);
        }
        return res;
    }

    public void addStackStat(java.util.List<C_Packet> packlist, I_stack_elt proto) {
        if (proto.isdebug() && isStack_Stat() && getSkin() instanceof F_Main) {
            for (C_Packet pack : packlist) {
                C_Packet newpack = (C_Packet) pack.clone();
                newpack.addProtocol(proto);
                ((F_Main) getSkin()).stat_storeTerm(newpack, false, false);
            }

        }
    }

    /**
     * Add a Ports<br> - Find an free index(ended ports) - Manage UI,TCP connect
     * param, accounting, name
     *
     * @param listner Port with socket of the futur TCP port provided by listner
     * @param type of the port Port/Machine/...
     * @return the index of the created port
     */
    @Override
    public I_Port addCX(C_Port listner, String type) {
        // look for closed port
        if (type.compareTo("Port") != 0 && type.compareTo("Machine") != 0) {
            TDeb.wri("unknown port type : " + type + " should be Port /Machine");
            return null;
        }
        ///!!!!!!!!! during short time listner port stay closed or new => delete then....
        // should not append
        try {
            for (I_Port port : Ports) {
                if (port.getcxstatus().compareTo("new") == 0) {//closed??
                    TDeb.wri("Deleting a Port new");
                    CXremove(port);
                }
            }
        } catch (Exception ex) {
        }
        TDeb.wri("Add new port");
        I_Port newport = null;
        if (type.compareTo("Port") == 0) {
            newport = new C_Port(this, this);
        } else if (type.compareTo("Machine") == 0) {
            newport = new C_Machine(this, this);
        }
        if (newport != null) {
            Ports.add(newport);
            newport.CXnew();
            if (listner != null) {
                C_Port port = (C_Port) newport;
                if (((T_IP) listner.getcxslave()).getTCPsocket() == null) {
                    System.err.println("NO SOCKET FOR CLIENT");
                }
                listner.addTCPclient(port);
                port.setListener(listner);
                port.setTCP_Mode("TCP_C");
                //  port.setCX_openbyslave(true);//Slave  is waiting for stated and manage open
                port.setcxstatus("creating");
                port.setPort_Stat(listner.isPort_Stat());
                port.SLcreate(((T_IP) listner.getcxslave()).getTCPsocket());
                port.setCMDOptions(listner.getCMDOptions());
                port.setTCP_linger(listner.isTCP_linger());
                port.setTCP_lingerTO(listner.getTCP_lingerTO());
                port.setTCP_ioBuffers(listner.getTCP_ioBuffers());
                port.setTCP_Port(((T_IP) listner.getcxslave()).getTCPsocket().getPort());
                port.setTCP_Addr(((T_IP) listner.getcxslave()).getTCPsocket().getInetAddress().getHostAddress());
                port.setPortName("S_" + port.getTCP_Port());
                port.setstop2end(true);
                if (listner.getPar_mxgrp().length() > 0) {
                    port.setPar_mxgrp(port.getPortName() + "," + listner.getPar_mxgrp() + ",");
                } else {
                    //  port.setPar_mxgrp(port.getPortName()+","+listner.getPar_mxgrp());
                }
                //----------------------FOR STACKS--------------------------------------------------------
                for (int row = 0; row < stacks.getmodel().getRowCount(); row++) {
                    if (stacks.getmodel().getValueAt(row, listner.getIndex() + 1) instanceof I_stack_elt) {
                        I_stack_elt elt = (I_stack_elt) stacks.getmodel().getValueAt(row, listner.getIndex() + 1);
                        try {
                            final I_stack_elt elt2 = (I_stack_elt) elt.getClass().newInstance();
                            elt2.setParents(port, stacks);
                            /*elt2.setdebug(elt.isdebug());
                             elt2.setfrommedia(elt.isfrommedia());*/
                            elt2.setlevel(elt.getlevel());
                            elt2.getOptions().setValues(elt.getOptions());
                            addStack(elt2, row, port.getIndex() + 1);
                            TDeb.wri("added stack for " + elt2.toString() + " port : " + port.getIndex());
                        } catch (InstantiationException | IllegalAccessException ex) {
                        }
                        //  elt.getOptions().

                    }
                }
                TDeb.wri("Starting by Main for a TCP Slave");
                port.CXstart();
                if (mainSkin instanceof F_Main) {
                    if (isMain_Stat()) {
                        ((F_Main) mainSkin).stat_add(port, true);
                    }
                    if (isStack_Stat()) {
                        ((F_Main) mainSkin).stat_add(port, false);
                    }
                }
                //Main UI maj at (env?) DisplaySocketNumbers
                port.getCMDOptions().setInitials();
                return port;
            } else {
                // this port is created out of a listner
                if (newport instanceof C_Port) {
                    ((C_Port) newport).setlocked(false);
                    ((C_Port) newport).setListener(null);
                }
                //  aleready made by constructor :  getPort(actived).CXcreate("cxstatus", "new");
            }
            selectedPort = newport;
            if (mainSkin instanceof F_Main) {
                if (((F_Main) mainSkin).isPortsDisplayed()) {
                    ((F_Main) mainSkin).displayPort(newport);
                }
            }
            boolean isnew;
            String newname = getnextPortName();
            do {
                isnew = true;
                for (int p = 0; p < Ports.size(); p++) {
                    if (Ports.get(p).getPortName().compareTo(newname) == 0) {
                        newname = "new_" + newname;
                        isnew = false;
                    }
                }
            } while (isnew == false);
            newport.getCMDOptions().setValuefor("PortName", newname);
            if (newport instanceof IF_Machine) {
                newport.CXcreate("Visible", "true");
            }
            newport.getCMDOptions().setValuefor("cxstatus", "creating");
            //newport.setcxstatus("creating");
            setnextPortName(base_cxname + "_" + Ports.size());
            if (mainSkin instanceof F_Main) {
                if (isStack_Stat()) {
                    ((F_Main) mainSkin).stat_add(newport, false);
                }
                if (isMain_Stat()) {
                    ((F_Main) mainSkin).stat_add(newport, true);
                }
            }
            newport.getCMDOptions().setInitials();
        }
        return newport;
    }

    public void startCX(int idx) {
        TDeb.wri("Asking start : " + idx);
        getPort(idx).CXstart();
    }

    public I_Port getSelectedPort() {
        return selectedPort;
    }

    @Override
    public void CXremove(I_Port port) {
        TDeb.wri("Asking removing : " + port);
        if (port.getIndex() >= 0) {
            removeStackCol(port.getIndex() + 1);
            removeMatrixCol(port.getIndex() + 1);
        }
        if (port.getcxstatus().compareTo("closed") != 0) {
            port.CXend();
        }
        if (Ports.indexOf(port) >= 0) {
            Ports.remove(port);
        }
        if (CXsys.indexOf(port) >= 0) {
            CXsys.remove(port);
        }
        Arcv(port, "removed", "Status");
    }

    /**
     * Remove all Ports<br> - check/stop XML config - ask to end each ports.
     */
    @A_Commande(help = "clear all ports")
    public void CXremoveAll() {
        TDeb.wri("Asking stop all");
        if (isConf_Enabled()) {
            TDeb.wri("XML configuration stopped by clearing ports");
            setConf_Enabled(false);
        }
        while (!Ports.isEmpty()) {
            // remove by the end else stack model error while remove ports
            CXremove(Ports.get(Ports.size() - 1));
        }
        if (stacks != null) {
            stacks.setStack_Enabled(false);
        }
        setnextPortName("Port_1");
    }

    @Override
    public javax.swing.ImageIcon getCMDIcon() {
        return TUtils.getIcon("Main_CX.gif");
    }

    @Override
    public Options_Model getCMDOptions() {
        return option;
    }

    @Override
    public String getCMDdetails() {
        String res = "";
        res = res + "-Name :\t" + getCMDName() + " \r\n-Nb port :\t" + getPorts().size() + "\r\n-XML :\t" + isConf_Enabled();
        if (this.isConf_Enabled()) {
            res = res + " => " + getConf_Name() + " activated";
        }
        return res + "\r\n";
    }

    @Override
    public java.util.List<I_Command> getCMDChilds(String childsNames) {
        java.util.List<I_Command> res = new java.util.ArrayList<>();
        for (I_Port port : getPorts()) {
            if (port instanceof I_Command) {
                res.add((I_Command) port);
            }
        }
        if (Mat instanceof I_Command) {
            res.add((I_Command) Mat);
        }
        if (config instanceof I_Command) {
            res.add((I_Command) config);
        }
        if (stacks instanceof I_Command) {
            res.add((I_Command) stacks);
        }
        if (childsNames == null || childsNames.length() == 0) {
            return res;
        } else {
            java.util.List<I_Command> res2 = new java.util.ArrayList<>();
            for (I_Command ch : res) {
                if (ch.getCMDName().compareTo(childsNames) == 0) {
                    res2.add(ch);
                }
            }
            return res2;
        }
    }

    @Override
    public I_Command getCMDParent() {
        return this;
    }

    @Override
    public String getCMDName() {
        return "Main";
    }

    @Override
    public String getCMDdesc() {
        return this.toString() + "\t" + this.getClass().getSimpleName();
    }

    @Override
    public Object command(Object dest, java.lang.reflect.Method methode, Object value) throws java.lang.Exception {
        Object res = null;
        try {
            if (value != null && methode.getGenericParameterTypes().length != 0) {
                res = methode.invoke(dest, value);
            } else {
                res = methode.invoke(dest);
            }
        } catch (java.lang.IllegalAccessException | java.lang.reflect.InvocationTargetException | IllegalArgumentException ex) {
            //  throw ex;
        }
        return res;
    }

    @Override
    public Object command(Object dest, String functName, String val) throws java.lang.Exception {
        String function = functName;
        String value = val;
        // tolog("===S>"+config.getState().toString());
        if (config != null) {
            //   config.sem.acquire();
        }
        //  tolog("===E>"+config.getState().toString());
        I_Command comanded = (I_Command) dest;
        java.lang.reflect.Method methfound = null;
        Object res = null;
        //TUtils.getMethod(dest, function, val);
        java.util.List<java.lang.reflect.Method> meths = getmethodes(comanded);
        if (meths == null || meths.isEmpty()) {
            // return -1;
            throw new java.lang.Exception("no methodes found for " + comanded.toString());
        }
        if (function.compareTo("bye") == 0 && dest == this) {
            System.exit(0);
            return res;
        }
        String states = "/start/stop/open/connect/error/end/close/";
        if (states.indexOf("/" + function + "/") != -1 && dest instanceof I_Port) {
            function = "CX" + function;
        }
        if (value == null) {
            if (function.startsWith("set ")) {
                function = function.substring(4);
                value = "true";
            }
            if (function.startsWith("unset ")) {
                function = function.substring(6);
                value = "false";
            }
        }
        for (java.lang.reflect.Method meth : meths) {
            if (meth.getName().toString().compareTo(function) == 0) {//&& String.class.isAssignableFrom((Class)meths[1][i])
                methfound = meth;
            }
        }
        if (methfound == null) {
            if (dest instanceof I_Port) {
                if (((I_Port) dest).CXcreate(function, value) == false) {
                    throw new java.lang.Exception("unable to apply on Port" + function + "(" + value + ")");
                } else {
                    return null;
                }
            } else {
                throw new java.lang.Exception("unable to apply " + function + " on " + dest.toString() + ")");
            }
        }
        Object ob1 = value;

        if (value != null && methfound.getGenericParameterTypes().length != 0) {//==1!!
            if (methfound.getParameterTypes()[0] == boolean.class
                    && (value.toLowerCase().compareTo("true") == 0 || value.toLowerCase().compareTo("false") == 0)) {
                ob1 = Boolean.valueOf(value).booleanValue();
            } else {
                if (ob1 != null && ob1.getClass() == methfound.getParameterTypes()[0]) {
                    ob1 = value;
                } else if (ob1!=null){
                    TDeb.wri("parameter:" + ob1.getClass().getSimpleName() + ",  waited: " + methfound.getParameterTypes()[0]);
                    //throw new java.lang.Exception("Pb with parametrer type : " + ob1.getClass().getSimpleName() + " should be " + meths[1][methidx]);
                }else {
                    TDeb.wri("parameter:on Null Object");
                    //throw new java.lang.Exception("Pb with parametrer type : " + ob1.getClass().getSimpleName() + " should be " + meths[1][methidx]);
                }
            }
        }

        return command(dest, methfound, ob1);
    }

    @A_Commande(help = "Asking to quit program")
    public void bye() {
        TDeb.wri("Asking bye=> exit");
        System.exit(0);
    }
    /*
     * Manage console
     *
     *
     * private void clearconsole() { System.out.flush(); System.err.flush(); }
     */

    public javax.swing.ButtonModel[] getdbg_model() {
        return chks;
    }

    @A_Commande(help = "set/unset debug for all module")
    public void setdbg_all(boolean bool) {
        for (ButtonModel chk : chks) {
            if (chk != null) {
                chk.setSelected(bool);
            }
        }
    }

    @A_Commande(help = "set debug for spcified module")
    public void adddbg(String selector) {
        setdbg(selector, true);
    }

    @A_Commande(help = "unset debug for specified module")
    public void removedbg(String selector) {
        setdbg(selector, false);
    }

    public void setdbg(String selector, boolean bool) {

        int chk = -1;
        for (int i = 0; chk < 0 || i < chks.length; i++) {
            if (chks[i] != null) {
                if (selector.length() >= chks[i].getActionCommand().length()) {

                    if (chks[i].getActionCommand().compareTo(selector.substring(0, chks[i].getActionCommand().length())) == 0) {
                        chk = i;
                    }
                }
            }
        }
        if (chk == -1) {
            TDeb.wri("debug box : [" + selector + "]  no found");
            return;
        }
        chks[chk].setSelected(bool);
    }

    @A_Commande(help = "return true if debug is on for specified module")
    @Override
    public boolean isdbgselected(String selector) {
        int chk = -1;
        for (int i = 0; chk < 0 && i < chks.length; i++) {
            if (chks[i] != null) {
                if (selector.length() >= chks[i].getActionCommand().length()) {
                    if (chks[i].getActionCommand().compareTo(selector.substring(0, chks[i].getActionCommand().length())) == 0) {
                        chk = i;
                    }
                }
            }
        }

        //default :unfounded box is selected
        if (chk == -1) {
            return true;
        }
        return chks[chk].isSelected();

    }

    /**
     * Add a cab for stat/...
     *
     * @param p pannel to Add as tab
     * @param title of the cab
     * @param i icon of the cab
     *
     */
    @Override
    public void addTab(JPanel p, String title, Icon i) {
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).addTab(p, title, i);
        }
    }

    public void removeStackCol(int removedCol) {
        // UnActive and Remove Stack on the Column
        if (removedCol > 0 && removedCol < stacks.getmodel().getColumnCount()) {
            for (int row = 0; row < stacks.getmodel().getRowCount(); row++) {
                removeStack(row, removedCol);
            }
        }
        // move all other column to math ports Index
        for (int col = removedCol + 1; col < getstack_model().getColumnCount(); col++) {
            for (int row = 0; row < getstack_model().getRowCount(); row++) {
                Object stack = getstack_model().getValueAt(row, col);
                getstack_model().setValueAt(stack, row, col - 1);
            }
        }
    }

    public void moveStackCol(int col, boolean isUp) {
        int shift = -1;
        if (isUp) {
            shift = 1;
        }
        if ((isUp && col < getstack_model().getColumnCount() - 1 && col > 0)
                || (isUp == false && col < getstack_model().getColumnCount() && col > 1)) {
            // should lock the stack
            for (int row = 0; row < getstack_model().getRowCount(); row++) {
                Object stck0 = getstack_model().getValueAt(row, col);
                Object stck1 = getstack_model().getValueAt(row, col + shift);
                getstack_model().setValueAt(stck0, row, col + shift);
                getstack_model().setValueAt(stck1, row, col);
            }
        }
    }

    public void addStackLevel(int row) {
        // adding a layer 0,5 over the selection
        stacks.getmodel().setValueAt("addlevel", row, 0);
    }

    public void removeStack(String protoName, int port_idx) {
        int col = port_idx + 1;
        int row = -1;
        for (int i = stacks.getmodel().getRowCount() - 1; i >= 0; i--) {
            if (stacks.getmodel().getValueAt(i, col) != null) {
                if (stacks.getmodel().getValueAt(i, col).toString().compareTo(protoName) == 0) {
                    row = i;
                }
            }
        }
        if (row >= 0) {
            removeStack(row, col);
        } else {
            TDeb.wri("no protocol founded for name : '" + protoName + "' on port [" + port_idx + "]");
        }
    }

    public void removeStack(int row, int col) {
        if (col < 0 || row < 0
                || col > stacks.getmodel().getColumnCount()
                || row > stacks.getmodel().getRowCount()) {
            return;
        }
        if (col == 0) {
            stacks.getmodel().setValueAt("removelevel", row, col);
        }
        if (stacks.getmodel().getValueAt(row, col) instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
            com.jdcm.modifiers.stacks.I_stack_elt elt = (com.jdcm.modifiers.stacks.I_stack_elt) stacks.getmodel().getValueAt(row, col);
            if (getSkin() instanceof F_Main) {
                ((F_Main) getSkin()).removeStack(elt);
            }
            TDeb.wri("removing stack: "
                    + elt.toString() + " row : " + row + " port : " + (col - 1));
            stacks.getmodel().setValueAt("", row, col);
            UpdateDatas(row, col);
        }
    }

    public void renameStack(int row, int col) {
        if (col == 0) {
        }
    }

    public void removeStacks(int col) {
        //remove previous protcols
        //  int col = jTable3.getSelectedColumn();
        for (int row = 0; row < stacks.getmodel().getRowCount(); row++) {
            if (stacks.getmodel().getValueAt(row, col) instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                removeStack(row, col);
            }
        }
    }

    public void addStacks(String protolist[], int row, int col) throws Exception {
        if (col < 0 || row < 0 || col >= stacks.getmodel().getColumnCount() || row > stacks.getmodel().getRowCount()) {
            return;
        }
        TDeb.wri("Ask adding stacks for " + java.util.Arrays.asList(protolist));

        //Select matching protocols
        java.util.List<String> reverse = new java.util.ArrayList<>();
        int[] idxs = new int[protolist.length];
        int pointer = 0;
        for (String pr : protolist) {
            boolean searching = true;
            if (pr.startsWith("-")) {
                pr = pr.substring(1);
                reverse.add(pr);
            }
            for (int i = 0; i < stack_protos.getRowCount() && searching; i++) {
                if (stack_protos.getValueAt(i, 0).toString().endsWith(pr)) {
                    idxs[pointer] = i;
                    searching = false;
                }
            }
            //!! if searching => NOT FOUND => idx=0=> first protocol (random?)
            pointer++;
            if (searching) {
                throw new java.lang.Exception("protocol not found " + pr);
            }
        }
        addStacks(idxs, row, col);
        for (String pr : reverse) {
            I_Port port = getPort(col - 1);
            I_stack_elt st = stacks.getTarget(port, pr);
            st.setfrommedia(false);
        }
    }

    public void addStacks(int[] stacksidx, int r, int col) {
        if (stacksidx == null || r < 0 || col <= 0) {
            return;
        }
        Class<? extends com.jdcm.modifiers.stacks.Stack_base>[] clmodules = new Class[stacksidx.length];//
        int idx = 0;
        for (int i : stacksidx) {
            Object eltclass = stack_protos.getValueAt(i, 0);
            if (eltclass instanceof Class<?>) {
                clmodules[idx] = (Class<? extends com.jdcm.modifiers.stacks.Stack_base>) eltclass;
            } else {
                TDeb.wri(" couldn't get Stack  with " + eltclass.toString());
            }
            idx++;
        }
        addStacks(clmodules, r, col);
    }

    public void addStacks(Class<? extends com.jdcm.modifiers.stacks.Stack_base>[] clmodules, int r, int c) {
        int row = r;
        int col = c;
        //jTable5.getSelectedRows()=>stacksidx
        if (col <= 0 || row < 0) {
            return;
        }
        if (clmodules.length == 0 || (row + 1) - clmodules.length < 0) {
            return;
        }
        for (Class<? extends com.jdcm.modifiers.stacks.Stack_base> ob : clmodules) {
            addStack(ob, row, col);
            row -= 1;
        }
    }

    public void addModifier(Class<? extends com.jdcm.modifiers.modif_base> clmod, String code) {
        String comment;
        javax.swing.table.AbstractTableModel model;
        Object ico;
        String objMeth;
        if (clmod.getSuperclass() == com.jdcm.modifiers.matrix.mat_base.class) {
            objMeth = "getIcon";
            model = mat_protos;
        } else {
            objMeth = "getosi";
            model = stack_protos;
        }
        try {
            java.lang.reflect.Method m = clmod.getMethod(objMeth, new Class<?>[]{});
            ico = m.invoke(clmod, new Object[]{});
            m = clmod.getMethod("getComment", new Class<?>[]{});
            comment = (String) m.invoke(clmod, new Object[]{});
        } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            return;
        }
        //should be better with : obj.clone();
        //---------------------INSERT modifier table if not present----------------------
        int pos = -1;
        // int osi=clmod.getDeclaredMethod("getosi", null);
        for (int i = 0; pos < 0 && i < model.getRowCount(); i++) {
            if (model.getValueAt(i, 0).equals(clmod)) {
                pos = 0;
            }
        }
        if (pos == -1) {
            Object[] stackrow = new Object[]{clmod, ico, comment, getCreateStackButton(clmod, null, code)};
            ((com.jdcm.common.ListTableModel) model).insertRow(stackrow);
            model.fireTableDataChanged();
        }
    }
    /*
     * public void addStack(Class<? extends com.jdcm.modifiers.stack_base>
     * clmod, String code) { double osi; String comment; try {
     * java.lang.reflect.Method m = clmod.getMethod("getosi", new Class<?>[]{});
     * osi = (Double) m.invoke(clmod, new Object[]{}); m =
     * clmod.getMethod("getComment", new Class<?>[]{}); comment = (String)
     * m.invoke(clmod, new Object[]{}); } catch (Exception ex) { return; }
     * //should be better with : obj.clone(); //---------------------INSERT
     * Stack in Stacks table if not present---------------------- int pos = -1;
     * // int osi=clmod.getDeclaredMethod("getosi", null); for (int i = 0; pos <
     * 0 && i < stack_protos.getRowCount(); i++) { if
     * (stack_protos.getValueAt(i, 0).equals(clmod)) { pos = 0; } } if (pos ==
     * -1) { Object[] stackrow = new Object[]{clmod, osi, comment,
     * getCreateStackButton(clmod, code)}; ((com.jdcm.common.ListTableModel)
     * stack_protos).insertRow(stackrow); stack_protos.fireTableDataChanged(); }
     * }
     */

    public void addStack(Class<? extends com.jdcm.modifiers.stacks.Stack_base> clmod, int row, int col) {
        if (clmod == null) {
            return;
        }
        addModifier(clmod, null);
        com.jdcm.modifiers.stacks.I_stack_elt obj;
        try {
            //Class<? extends com.jdcm.modifiers.I_stack_elt> clmod = ob.getClass();
            obj = (com.jdcm.modifiers.stacks.I_stack_elt) clmod.newInstance();
            obj.setParents(getPort(col - 1), stacks);
            obj.setlevel((Double) stacks.getmodel().getValueAt(row, 0));
            TDeb.wri("added stack for " + obj.toString() + " row : " + row + " port : " + (col - 1));
        } catch (InstantiationException | IllegalAccessException ex) {
            return;
        }
        addStack(obj, row, col);
    }

    public void addStack(com.jdcm.modifiers.stacks.I_stack_elt stack, int row, int col) {
        if (col <= 0 || row < 0) {
            return;
        }
        //--------------------check that not already exist for this port----------------------
        while (stacks.getTarget(Ports.get(col - 1), stack.toString()) != null) {
            TDeb.wri("remame because Stack already found :" + stack.toString() + "for " + Ports.get(col - 1).getPortName());
            stack.setName(stack.toString() + "*");
        }
        //---------------------INSERT Stack in PORTS table----------------------
        if (row >= 0 && col > 0 || stack.getClass() == null) {
            if (stacks.getmodel().getValueAt(row, col).equals("")) {
                stacks.getmodel().setValueAt(stack, row, col);
                //add class in list if not present
                UpdateDatas(row, col);
            }
        }
    }
    // should be in stack butt ... to much links (terminal/codeModel/...) !!!!!!!!!

    public java.util.List<C_Packet> getpayload(String proto, int portidx, C_Packet buff) {
        if (proto == null) {
            return null;
        }
        java.util.List<C_Packet> res = null;
        try {
            Class<?> cl = Class.forName("com.jdcm.modifiers.stacks.Stack_" + proto);
            com.jdcm.modifiers.stacks.I_stack_elt st;
            if (cl != null) {
                st = (com.jdcm.modifiers.stacks.I_stack_elt) cl.newInstance();
                st.setParents(getPort(portidx), this.stacks);
                res = st.receive(buff);
            }
        } catch (Exception ex) {
        }
        return res;
    }

    private com.jdcm.modifiers.stacks.I_stack_elt getNewStackElt(Class<? extends com.jdcm.modifiers.stacks.I_stack_elt> stakcl) {
        com.jdcm.modifiers.stacks.I_stack_elt res = null;
        try {
            res = (com.jdcm.modifiers.stacks.I_stack_elt) stakcl.newInstance();
            res.setCopyMode(true);
        } catch (InstantiationException | IllegalAccessException ex) {
            TDeb.wri("auto protocol discover stack instance PB for " + stakcl.toString());
        }
        return res;
    }

    public javax.swing.tree.DefaultMutableTreeNode getStacks(C_Packet pack, javax.swing.tree.DefaultMutableTreeNode prev) {
        double confiance = -1.0;
        com.jdcm.modifiers.stacks.I_stack_elt valelt = null;
        com.jdcm.modifiers.stacks.I_stack_elt elt;
        C_Packet packtmp = (C_Packet) pack.clone();
        for (int row = 0; row < getstack_protos().getRowCount(); row++) {
            // evaluation of each protocol for byte to analyse
            elt = (com.jdcm.modifiers.stacks.I_stack_elt) getstack_protos().getValueAt(row, 4);
            if (elt != null) {
                double conf = elt.matchProtocol(packtmp);
                if (conf > 0.5 && conf > confiance) {
                    valelt = elt;
                    getstack_protos().setValueAt(getNewStackElt((Class) getstack_protos().getValueAt(row, 0)), row, 4);
                    confiance = conf;
                }
            }
        }
        if (valelt != null) {
            javax.swing.tree.DefaultMutableTreeNode n1;
            java.util.List<C_Packet> l = null;
            try {
                l = valelt.receive(packtmp);
            } catch (Exception ex) {
            }
            if (l == null || l.isEmpty() || l.get(0) == null || l.get(0).isbuffer() == false
                    || java.util.Arrays.equals(pack.getBytes(), l.get(0).getBytes())
                    || l.get(0).getBytes().length == 0) {
                n1 = new javax.swing.tree.DefaultMutableTreeNode(valelt);
                prev.add(n1);
            } else {
                for (C_Packet p : l) {
                    n1 = new javax.swing.tree.DefaultMutableTreeNode(valelt);
                    prev.add(n1);
                    p.addProtocol(valelt);
                    getStacks(p, n1);
                }
            }
        } else {
            if (prev.getParent() == null) {
                javax.swing.tree.DefaultMutableTreeNode n1 = new javax.swing.tree.DefaultMutableTreeNode();
                n1.setUserObject(new com.jdcm.modifiers.stacks.Stack_0NULL());
                prev.add(n1);
            }
            // no protocols found, should be greet to add data over last (ex TCP/UDP) stack
        }
        Object stack = prev.getUserObject();
        if (pack.isbuffer() && stack instanceof com.jdcm.modifiers.stacks.Stack_base) {
            com.jdcm.modifiers.stacks.Stack_base st = (com.jdcm.modifiers.stacks.Stack_base) stack;
            st.getOptions().addOption(st.toString().toLowerCase() + "_data", pack.getBytes(), "buffer", "bytes", true, true, "Packet payload");
        }

        return prev;
    }

    /**
     * get a packet analyse to discover the procotocol stak if known Find only
     * protocol list (1 proto=> 1 proto=>...) TODO : a recurcive should be
     * easier
     *
     * @param pack the packet to get the protocols stacks by detection
     */
    public void findPacketStacks(C_Packet pack) {
        // get the tree with full develloped protocol
        pack.setProtoTree(getStacks(pack, new javax.swing.tree.DefaultMutableTreeNode("frame")));

    }

    public void UpdateDatas(int row, int col) {
        //   stacks.getmodel().fireTableDataChanged();
        if (row < 0 || col < 0) {
            stack_values = new javax.swing.table.DefaultTableModel(new Object[]{"no selection", "Values"}, 0);
            //       stack_values.fireTableDataChanged();
            return;
        }
        Object o = stacks.getmodel().getValueAt(row, col);
        if (o == null || o instanceof String) {
            stack_values = new javax.swing.table.DefaultTableModel(new Object[]{"no module", "Values"}, 0);
            //  stack_values.fireTableDataChanged();
        }
        if (o instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
            stack_values = ((com.jdcm.modifiers.stacks.I_stack_elt) o).getOptions();
            // stack_values.fireTableDataChanged();
        }
        if (mainSkin instanceof F_Main) {
            // ((F_Main) mainSkin).refresh_table("Type", "Matr", null);
        }
    }

    /**
     * Remove a cab
     *
     * @param p the panel to remove
     */
    @Override
    public void removeTab(JPanel p) {
        if (mainSkin instanceof F_Main) {
            ((F_Main) mainSkin).removeTab(p);

        }

    }
    //   public static void main(String args[]) {
    // java.awt.EventQueue.invokeLater(new Runnable() {
    //  @Override
    //   public void run() {
    //        C_Main a = new C_Main();
    //     }
    //  }
    //);
    //   }
}

class confActionListener implements java.awt.event.ActionListener {

    public confActionListener() {
        super();
    }
    T_CONF conf = null;

    @Override
    public void actionPerformed(ActionEvent e) {
    }

    public void setConf(T_CONF t) {
        conf = t;
    }

    public T_CONF getConf() {
        return conf;
    }
}

/**
 *
 * for systemout & err dedirect
 */
class jTextPaneOutputStream extends OutputStream {
 private final java.util.List<JTextPane> sorties;//JTextPane
 
    private String stylename = null;
    private boolean isscroll;

    /**
     * Creates a new instance of TextPaneOutputStream
     */
    public jTextPaneOutputStream(String style) {
        stylename = style;
        sorties = new java.util.ArrayList<>();//JTextPane
    }

    public void addTextPane(JTextPane txtpane) {//javax.swing.JScrollPane
        if (sorties.indexOf(txtpane) == -1) {
            sorties.add(txtpane);
            settxtstyle(txtpane);
        }
    }

    public void removeTextPane(JTextPane txtpane) {
        txtpane.getStyledDocument().removeStyle("styleout");
        txtpane.getStyledDocument().removeStyle("styleerr");
        sorties.remove(txtpane);
    }

    public void settxtstyle(JTextPane txtpane) {
        Style style1 = txtpane.getStyledDocument().addStyle("styleout", null);
        StyleConstants.setBackground(style1, Color.WHITE);
        StyleConstants.setForeground(style1, Color.BLUE);
        Style style2 = txtpane.addStyle("styleerr", null);
        StyleConstants.setBackground(style2, Color.WHITE);
        StyleConstants.setForeground(style2, Color.RED);
        Style style3 = txtpane.addStyle("stylecoment", null);
        StyleConstants.setBackground(style3, Color.WHITE);
        StyleConstants.setForeground(style3, Color.GREEN);
    }

    @Override
    public void write(int b) throws IOException {
        byte[] bytes = {(byte) b};
        String newText = new String(bytes);
        for (int i = 0; i < sorties.size(); i++) {
            try {
                StyledDocument sout = sorties.get(i).getStyledDocument();
                sout.insertString(sout.getLength(), newText, sout.getStyle(stylename));//
            } catch (BadLocationException ex) {
                System.err.println("----Write() : Stream Bad location----" + ex.getMessage());
            }
        }
    }

    @Override
    public final void write(byte[] arg0) throws IOException {
        if (arg0 == null) {
            return;
        }
        String txt = new String(arg0);
        for (int i = 0; i < sorties.size(); i++) {
            try {
                StyledDocument sout = sorties.get(i).getStyledDocument();
                sout.insertString(sout.getLength(), txt, sout.getStyle(stylename));
            } catch (BadLocationException ex) {
                System.err.println("----Write() : Stream Bad location----" + ex.getMessage());
            }

            if (isscroll) {
                try {
                    sorties.get(i).scrollRectToVisible(sorties.get(i).modelToView(sorties.get(i).getDocument().getLength()));
                } catch (BadLocationException ex) {
                     System.err.println("----Write() : Stream Bad location----" + ex.getMessage());
                }
            }
        }
    }
}
