package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.Timer;
import java.util.TimerTask;

/**
 *  C_PScan.java Created on 13 juillet 2006, 11:44
 * 
 * Manage every timed event (pool/pad/TO/.....)<br>
 *
 * @author Marc GIBOIN
 */
public class C_PScan extends Thread {
    ///use timer = new Timer();  timer.schedule(new TimerTask() {... from import java.util.*;
    private final com.jdcm.common.D_Utils TUtils = new com.jdcm.common.D_Utils();
    
    private D_Debug TDeb;
    private C_Port Parent;
    private C_Machine Parent2;
    private com.jdcm.modifiers.stacks.Stack_Toolkit Parent3;
    private Timer timerpad;
    private Timer timerDcom;
    private Timer timerDabs;
    private Timer timerpool;
    private int received;
    private long pool_time;
    private long TODcom_time;
    private long PAD_time;
    private long TOabs_time;
    private java.sql.ResultSet sqlresult;
    //this List store delayed packets (timer within the packet)
    private LinkedList<C_Packet> delaybuffer;
    private byte[] padbuffer;

    /**
     * Creates a new instance of C_PScan
     * @param P the port that support this Scan
     */
    public C_PScan(I_Port P) {
        if (P instanceof C_Port) {
            Parent = (C_Port) P;
            TDeb = new D_Debug("Scan [" + Parent.getIndex() + "] : ");
            TDeb.setconsole(Parent.getConsole());
        } else if (P instanceof C_Machine) {
            Parent2 = (C_Machine) P;
            TDeb = new D_Debug("Scan [" + Parent2.getIndex() + "] : ");
            TDeb.setconsole(Parent2.getConsole());
        }
        init();
    }

    public C_PScan(com.jdcm.modifiers.stacks.Stack_Toolkit toolk) {
        Parent3 = toolk;
        TDeb = new D_Debug("Scan [" + Parent3.getport().getIndex() + "] : ");
        //  TDeb.setconsole(Parent2.getConsole());
        init();
    }

    private void init() {
        received = 0;
        TODcom_time = 0;
        PAD_time = 0;
        TOabs_time = 0;
        pool_time = 0;
        delaybuffer = new java.util.LinkedList<>();
        padbuffer = new byte[0];
    }

    public void From_CX(C_Packet d) {
        if (Parent2 != null) {
            return;
        }
        if (Parent != null && Parent.isDCX_TOcom()) {
            dcx_TOcom(1);
        }
        if (Parent3 != null) {
            d.setsource(Parent3.getport());//could come from an other port
            if (Parent3.isTlk_Padt() && d.isbuffer()) {
                // by default PAD outgoing data!!
                padbuffer = TUtils.addtab(padbuffer, d.getBytes());
            } else if (Parent3.isTlk_bw() || Parent3.isTlk_latency()) {
                delayed_store(d, false);//  false=> comming from CX (out)
            } else {
                Parent3.getStack().reply_out(Parent3, d);
            }
        }
    }

    public void From_interface(C_Packet d) {
        if (Parent2 != null) {
            return;
        }
        if (Parent != null && Parent.isDCX_TOcom()) {
            dcx_TOcom(1);
        }
        if (Parent3 != null) {
            d.setsource(Parent3.getport());//could come from an other port
            if (Parent3.isTlk_bw() || Parent3.isTlk_latency()) {
                delayed_store(d, true);//  true=> comming from in
            } else {
                Parent3.getStack().reply_in(Parent3, d);
            }
        }

    }

    public void scanning() {

        if (Parent != null && Parent.isPar_PadtStr()) {
            Pad_Stream(0);
        }
        if (Parent3 != null && Parent3.isTlk_Padt()) {
            Pad_Caractere(0);
        }
        if (Parent != null && Parent.isDCX_TOcom()) {
            dcx_TOcom(0);
        }
        if (Parent != null && Parent.isDCX_TOabs()) {
            dcx_TOabs(0);
        }
        if (Parent2 != null) {
            if (Parent2.isMSG_pool()) {
                if (pool_time == 0) {
                    par_pool(0);
                } else {
                    par_pool(3);
                }// result of the pooling
            } else {
                // SCAN
                Parent2.askSCNview();
            }
        }

    }

    public String DBscanaddr(String keyname) {
        if (sqlresult != null && Parent2 != null) {
            try {
                String res = sqlresult.getString(keyname);
                TDeb.wri("DBSan Addr for : " + keyname + "=" + res);
                return res;
            } catch (SQLException ex) {
                return null;
            }
        }
        return null;
    }

    public void DBscanning(java.sql.ResultSet res) {
        TDeb.wri("DBSan next (" + res + ")");
        if (res != null) {
            sqlresult = res;
        } else if (sqlresult == null) {
            TDeb.wri("No DBscanning : sqlresult is null");
        }
    }

    private void par_pool(int state) {
        // TDeb.wri("Pool with : "+state+" time : "+pool_time);
        if (Parent2 == null) {
            return;
        }

        if (Parent2.isMSG_pool() == false) {
            //reset
            if (timerpool != null) {
                timerpool.cancel();
                timerpool =
                        null;
            }

            pool_time = 0;
            TDeb.wri("Pool Stopped");
            return;

        }


        if (state == 0 && pool_time == 0) {
            //INIT
            TDeb.wri("Pool Started");
            pool_time = System.currentTimeMillis();
            if (timerpool != null) {
                timerpool.cancel();
                timerpool = null;
            }

            timerpool = new Timer();
            timerpool.schedule(new TimerTask() {
                @Override
                public void run() {
                    par_pool(2);
                }
            }, Parent2.getMSG_poolval());
            TDeb.wri("Pool Started at :" + new java.util.Date(pool_time));
        }

        if (state == 2) {
            //ACTION
            if (timerpool != null) {
                timerpool.cancel();
                timerpool =
                        null;
            }

            TDeb.wri("Pool Sended at :" + (System.currentTimeMillis() - pool_time));
            pool_time =
                    System.currentTimeMillis();
            Parent2.Send_msg();
            ///SYNCHRO PB if TCP!!!(should wait end of cx IPthread??
            timerpool =
                    new Timer();
            timerpool.schedule(new TimerTask() {
                @Override
                public void run() {
                    par_pool(2);
                }
            }, Parent2.getMSG_poolval());
        }

    }

    private void delayed_store(C_Packet d, boolean sens) {
        if (Parent3 == null) {
            return;
        }
        long wait_time = 0;
        if (Parent3.isTlk_latency()) {
            wait_time += Parent3.getTlk_latencyval();
            if (Parent3.getTlk_latencyvar() > 0) {
                long max = Parent3.getTlk_latencyvar();
                if (delaybuffer != null && delaybuffer.size() > 0) {
                    //DO NOT ALLOW  PERMUTATION !!!
                    try {
                        long last = delaybuffer.getLast().getStoredtime().getTime() + delaybuffer.getLast().get_Pwaitedtime();
                        if (last < System.currentTimeMillis() + max) {
                            max = last - System.currentTimeMillis() - 1;
                        }
                    } catch (Exception ex) {
                        //no more lastelements (freed by timeout)=> max=max
                    }
                }
                wait_time += Math.round(Math.random() * max);
            }
        }

        if (Parent3.isTlk_bw()) {
            wait_time += (8000 * d.length() / Parent3.getTlk_bwval());
        }

        d.setdelayed(this, sens, wait_time);
        if (delaybuffer != null) {
            delaybuffer.add(d);
            TDeb.wri("delay : stored[" + delaybuffer.size() + "] :/" + d.length() + "for " + d.getPsens() + " from: " + d.getsource() + " for: " + wait_time + "ms ");
        }
    }

    public void delayed_free(C_Packet d) {
        if (Parent3 == null) {
            return;
        }
//for each record : if time>delay=> Parent.write_in(data);
        TDeb.wri("delay : free for /" + d.length() + " to :" + d.getsource() + " after: " + (System.currentTimeMillis() - d.getStoredtime().getTime()) + "ms");
        if (delaybuffer.remove(d) == false) {
            TDeb.wri("Packet not found in the List");
        }
        d.setStoredtime(null);
        if (d.getPsens()) {
            Parent3.getStack().reply_in(Parent3, d);
        } else {
            Parent3.getStack().reply_out(Parent3, d);
        }
    }

    public void dcx_TOabs(int state) {
        if (Parent == null) {
            return;
        }

        if (Parent.getcxstatus().compareTo("connected") != 0 || Parent.isDCX_TOabs() == false) {
            //reset
            if (timerDabs != null) {
                timerDabs.cancel();
                timerDabs = null;
                TDeb.wri("dcxTOabs reseted (status=" + Parent.getcxstatus() + ", TOabsEnabled=" + Parent.isDCX_TOabs() + ")");
            }
            TOabs_time = 0;
            return;

        }
        if (state == 0 && TOabs_time == 0) {
            //initialisation
            TOabs_time = System.currentTimeMillis();
            TDeb.wri("dcxTOabs init ask discx in : " + Parent.getDCX_TOabsval() + " sec");
            if (timerDabs != null) {
                timerDabs.cancel();
                timerDabs = null;
            }

            timerDabs = new Timer();
            timerDabs.schedule(new TimerTask() {
                @Override
                public void run() {
                    dcx_TOabs(2);
                }
            }, Parent.getDCX_TOabsval());
            return;

        }


        if (state == 2) {
            //action
            TDeb.wri("dcxTOabs : action disconect after: " + (System.currentTimeMillis() - TOabs_time) + " ms");
            Parent.CXdisconnect(null, 2);
            TOabs_time =
                    0;
        }

    }

    public void dcx_TOcom(int state) {
        if (Parent == null) {
            return;
        }
        if (Parent.getcxstatus().compareTo("connected") != 0 || Parent.isDCX_TOcom() == false) {
            //reset
            TDeb.wri("dcxTOcom reset ");
            if (timerDcom != null) {
                timerDcom.cancel();
                timerDcom = null;
            }
            TODcom_time = 0;
            return;
        }
        if (state == 0 && TODcom_time == 0) {
            //init
            TDeb.wri("dcxTO : starting at : " + new java.sql.Timestamp(System.currentTimeMillis()));
            TODcom_time = System.currentTimeMillis();
            if (timerDcom != null) {
                timerDcom.cancel();
                timerDcom = null;
            }

            timerDcom = new Timer();
            timerDcom.schedule(new TimerTask() {
                @Override
                public void run() {
                    dcx_TOcom(2);
                }
            }, Parent.getDCX_TOcomval());
        }

        if (state == 1) {
            //packet received
            TDeb.wri("dcxTO : data received after: " + (System.currentTimeMillis() - TODcom_time) + " ms");
            TODcom_time = System.currentTimeMillis();
            if (timerDcom != null) {
                timerDcom.cancel();
                timerDcom = null;
            }
            timerDcom = new Timer();
            timerDcom.schedule(new TimerTask() {
                @Override
                public void run() {
                    dcx_TOcom(2);
                }
            }, Parent.getDCX_TOcomval());
        }

        if (state == 2) {
            //action
            TDeb.wri("dcxTO : Asking disconect after: " + (System.currentTimeMillis() - TODcom_time) + " ms without in/out data");
            Parent.CXdisconnect(null, 2);
            TODcom_time = 0;
        }

    }

    private void resettimerpad(boolean again) {
        if (timerpad != null) {
            timerpad.cancel();
            timerpad = null;
        }

        if (again) {
            timerpad = new Timer();
        } else {
            //setpadreading();
            PAD_time = 0;
            received = 0;
            TDeb.wri("PAD : Stopping");
        }

    }

    public void Pad_Caractere(int state) {
        if (Parent3 == null) {
            return;
        }
        int avalable = padbuffer.length;
        if (Parent3.isTlk_Padt() == false) {
            //reset Pad
            resettimerpad(false);
            return;
        }
        if (avalable < received) {
            TDeb.wri("Pb with end of prevoius comm should not append");
            received = -1;
        }

        if (avalable == 0 || avalable > received) {
            //init && packet received => init timer
            if (avalable > 0) {
                if (PAD_time == 0) {
                    TDeb.wri("PAD : Starting ");
                }
                PAD_time = System.currentTimeMillis();
            }
            resettimerpad(true);
            timerpad.schedule(new TimerTask() {
                @Override
                public void run() {
                    Pad_Caractere(2);
                }
            }, Parent3.getTlk_Padtval());
            received = avalable;
            return;

        }

        if (state == 2 && received > 0) {
            //Action : Sending received data
            TDeb.wri("PAD : BYTE send : /" + received + " after " + (System.currentTimeMillis() - PAD_time) + "ms without new received data");
            Parent3.getStack().reply_out(Parent3, new C_Packet(padbuffer, Parent3.getport()));
            padbuffer = new byte[0];
            received = -1;
            PAD_time = 0;
            Pad_Caractere(0);
        }

    }

    private void setpadreading() {
        if (Parent == null) {
            return;
        }
        if (Parent.getcxstatus().compareTo("connected") == 0 || Parent.getcxstatus().compareTo("disconnected") == 0 || Parent.getcxstatus().compareTo("opened") == 0) {
            Parent.setslreading(true);
        }

    }

    public void Pad_Stream(int state) {
        if (Parent == null) {
            return;
        }
// pad  :  NO DATA ARE READED!!!
        if (Parent.getModeidx() > 3 && Parent.getModeidx() < 6) {
            //avoid : ethernet,database,USB...
            TDeb.wri("not possible to apply PAD with packet receiver : Pad set to false");
            Parent.setPar_PadtStr(false);
            PAD_time = 0;
            received = 0;
            return;

        }

        int avalable = Parent.available();
        Parent.setslreading(false);
        /* if (avalable < 0 || ((Boolean) Parent.getPort_Options().getValuefor("Par_PadtStr")) == false || (Parent.getcxstatus().compareTo("opened") != 0 && Parent.getcxstatus().compareTo("connected") != 0 && Parent.getcxstatus().compareTo("disconnected") != 0)) {
         //reset Pad
         resettimerpad(false);
         return;
        
         }*/
        if (avalable != -1 && avalable < received) {
            TDeb.wri("Pb with end of prevoius comm should not append");
            received = -1;
        } else if (avalable <= 0 || avalable > received) {
            //init && packet received => init timer

            resettimerpad(true);
            timerpad.schedule(new TimerTask() {
                @Override
                public void run() {
                    Pad_Stream(2);
                }
            }, Parent.getPar_PadtStrval());
            if (avalable > 0) {
                if (PAD_time == 0) {
                    TDeb.wri("PAD : Starting ");
                }
                PAD_time = System.currentTimeMillis();
                received = avalable;
            }
        } else if (state == 2 && received > 0) {
            //Action : Sending received data
            TDeb.wri("PAD : BYTE send : /" + received + " after " + (System.currentTimeMillis() - PAD_time) + "ms without new received data");
            PAD_time = 0;
            received = -1;
            setpadreading();
            Parent.ReadStream(avalable);
            Parent.setslreading(false);
            Pad_Stream(0);
        }

    }

    public void close() {
        resettimerpad(false);
        if (timerDcom != null) {
            timerDcom.cancel();
            timerDcom = null;
        }

        if (timerDabs != null) {
            timerDabs.cancel();
            timerDabs = null;
        }

        if (timerpool != null) {
            timerpool.cancel();
            timerpool = null;
        }
        if (delaybuffer != null) {
            if (delaybuffer.size() > 0) {
                TDeb.wri(delaybuffer.size() + "are stored at Scan closing");
            }
        }
        init();

    }
}
