package com.jdcm.eltrx;

import com.jdcm.common.A_Commande;
import com.jdcm.modifiers.stacks.I_stack_elt;
import com.jdcm.common.C_Packet;
import com.jdcm.common.Options_Model;
import java.awt.Frame;
import java.lang.reflect.InvocationTargetException;
import javax.swing.table.*;
import java.util.List;

/**
 * C_Modules.java Created on 25 juillet 2006, 23:21
 *
 * Modules should be use to modify/create/... messages in a communication<br>
 *
 * Stacks (could but) 'Do not Moves' a good initial level implementation is
 * needed. if a child port is created, stacks of the father are duplicated
 *
 * @author Marc GIBOIN
 */
public class C_Stack implements I_Command {

    private final D_Debug TDeb;
    private final Stack_Model model;
    private final I_Main Parent;
    private boolean islocaldebug = true;
    private Options_Model option;

    /**
     * Creates a new instance of C_Modules
     * @param p the Main managin this Stacks
     * @param c the console used
     */
    public C_Stack(I_Main p, I_Console c) {
        TDeb = new D_Debug("Stacks");
        Parent = p;
        TDeb.setconsole(c);
        initOptions();
        model = new Stack_Model(Parent);  //return the model of the Stack table (should be up=>down)
    }

    /**
     * initialise Options for the Stacks
     */
    private void initOptions() {
        option = new Options_Model(this);
        // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        option.addOption("Stack_Enabled", false, "bool", "0/1", true, false, "true if a port send on itself");
        option.addOption("Stack_Stat", false, "bool", "false", true, false, "are Stacks Statistics collected/displayed");
        option.setTitle(getTitle());
    }

    public String getTitle() {
        return "Stacks";
    }

    @A_Commande(help = "set Stack echo logs enabled & displayed")
    public void setStack_Stat(boolean bool) {
        if (option.getValuefor("Stack_Stat", true) != bool) {
            option.setValuefor("Stack_Stat", bool);
        }
        if (Parent instanceof C_Main) {
            ((C_Main) Parent).setStack_Stat(bool);
        }
    }

    public void setStack_Enabled(boolean bool) {
        if (option.getValuefor("Stack_Enabled", true) != bool) {
            option.setValuefor("Stack_Enabled", bool);
        }
        if (Parent instanceof C_Main) {
            ((C_Main) Parent).setStack_Enabled(bool);
        }
    }

    public AbstractTableModel getmodel() {
        return model;
    }

    public boolean islocaldebug() {
        return islocaldebug;
    }

    public void setlocaldebug(boolean bool) {
        islocaldebug = bool;
    }

    private void transmitdbg(String txt) {
        if (islocaldebug) {
            TDeb.wri(txt);
        }
    }
    //manage timeout events for each protocol NOT USED

    public void onClock() {
        System.out.print("jhh");
    }

    private I_Port getPort(String portname) {
        java.util.List<I_Command> cmdlist = this.getCMDParent().getCMDChilds(portname);
        if (cmdlist == null || cmdlist.isEmpty()) {
            TDeb.wri("getPort(): Commanded elt:" + portname + "not found");
            return null;
        } else {
            I_Port port = null;
            for (I_Command cmd : cmdlist) {
                if (cmd instanceof I_Port) {
                    return (I_Port) cmd;
                }
            }
        }
        TDeb.wri("getPort(): Commanded port :" + portname + "not found");
        return null;
    }

    public void displayStackOptions(String portname, String protolabel) {
        for (I_Port port : Parent.getPorts()) {
            if (port.getPortName().compareTo(portname) == 0) {
                displayStackOptions(port, protolabel);
            }
        }
    }

    public void displayStackOptions(I_Port port, String protolabel) {
        I_stack_elt elt;
        elt = getTarget(port, protolabel);
        if (elt != null) {
            for (Frame i : Frame.getFrames()) {
                if (i.getTitle().compareTo(elt.toString()) == 0) {
                    i.setVisible(true);
                    return;
                }
            }
            javax.swing.JFrame f = new javax.swing.JFrame(elt.toString());
            com.jdcm.editors.P_TableEditor ttable = new com.jdcm.editors.P_TableEditor(elt.getOptions());
            ttable.setEditing(true);
            f.add(ttable);
            f.setVisible(true);
            f.setBounds(0, 0, 150, 300);
            f.repaint();
        }
    }

    public void addStack(String portname, String proto) throws Exception {
        addStack(portname, proto, proto);
    }

    public void addStack(String portname, String proto, double level) throws Exception {
        addStack(portname, proto, proto, level);
    }

    /**
     * Add a Stack_element on a port starting by the buttom well used for Config
     * on the port find first lowest free lavel
     *
     * @param proto the name of the Stack Element
     * @param portname the port to be implmented
     * @param stackLabel the stack label to used
     * @throws java.lang.Exception
     */
    public void addStack(String portname, String proto, String stackLabel) throws Exception {
        I_Port port = getPort(portname);
        if (port == null) {
            String txt = "Port not found : " + portname;
            TDeb.wri(txt);
            throw new java.lang.Exception(txt);
        }
        int col = port.getIndex() + 1;
        int row = -1;
        for (int i = getmodel().getRowCount() - 1; i >= 0; i--) {
            if (row < 0 && getmodel().getValueAt(i, col) != null) {
                if (getmodel().getValueAt(i, col).toString().length() == 0) {
                    row = i;
                }
            }
            if (getmodel().getValueAt(i, col) instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                if (((com.jdcm.modifiers.stacks.I_stack_elt) getmodel().getValueAt(i, col)).toString().compareTo(stackLabel) == 0) {
                    TDeb.wri("Stack named :'" + stackLabel + "' already exist");
                    return;
                }
            }
        }
        addStack(portname, proto, stackLabel, row);

    }

    /**
     * add att specified level
     *
     * @param portname
     * @param proto
     * @param stackLabel
     * @param level
     * @throws Exception
     */
    public void addStack(String portname, String proto, String stackLabel, double level) throws Exception {
        int rowidx;
        I_Port port = getPort(portname);
        int col = port.getIndex() + 1;
        for (int i = 0; i < getmodel().getRowCount() - 1; i++) {
            if (getmodel().getValueAt(i, col) instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                if (((com.jdcm.modifiers.stacks.I_stack_elt) getmodel().getValueAt(i, col)).toString().compareTo(stackLabel) == 0) {
                    TDeb.wri("Stack named :'" + stackLabel + "' already exist");
                    return;
                }
            }
        }
        int row = 0;
        while ((double) getmodel().getValueAt(row, 0) > level) {
            row++;
        }
        if ((double) getmodel().getValueAt(row, 0) == level) {
            Object obj = getmodel().getValueAt(row, col);
            if (obj.toString().length() > 0 || obj instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                TDeb.wri("Level " + level + " already contains : '" + obj + "'");
                return;
            }
            rowidx = row;
        } else {
            getmodel().setValueAt("addlevel", row, 0);
            getmodel().setValueAt(level, row, 0);
            rowidx = row;
        }

        /* for (int row = 0; row <getmodel().getRowCount() - 1; row++) {
         if (rowidx < 0 && getmodel().getValueAt(row, col) != null) {

         }
         }*/
        addStack(portname, proto, stackLabel, rowidx);
    }

    /**
     * add at spécified row
     *
     * @param portname
     * @param proto
     * @param stackLabel
     * @param row
     * @throws Exception
     */
    public void addStack(String portname, String proto, String stackLabel, int row) throws Exception {
        I_Port port = getPort(portname);
        int col = port.getIndex() + 1;
        if (row == -1) {
            // could add it : this.addStackLevel(row);
            TDeb.wri("adding free stack box for port [" + port.getPortName() + "]");
            getmodel().setValueAt("addlevel", 0, 0);
            row = 0;
        }
        ((C_Main) Parent).addStacks(new String[]{proto}, row, col);
        try {
            setStackMethod(port.getPortName(), proto, "setName", stackLabel);
        } catch (Exception ex) {
            TDeb.wri("whille ading protocol : " + ex.getMessage());
        }
    }

    /**
     * Assign value to the protocol options. -
     *
     * @param portname
     * @param protolabel
     * @param option
     * @param value
     * @throws Exception
     */
    public void setStackOption(String portname, String protolabel, String option, Object value) throws Exception {
        I_stack_elt elt = getTarget(portname, protolabel);
        if (elt == null) {
            throw new java.lang.Exception("no protocol " + protolabel + "found on port" + portname);
        }
        Object prev_val = null;
        try {
            prev_val = elt.getOptions().getValuefor(option);
            try {
                elt.getOptions().setValuefor(option, value);
            } catch (Exception ex) {
            }
        } catch (Exception ex) {
            TDeb.wri("no label found for :" + option + " on port :" + portname + " on protocol :" + elt);
        }

    }

    public void setStackMethod(String portname, String protolabel, String option, Object value) throws Exception {
        I_stack_elt elt = getTarget(portname, protolabel);
        if (elt == null) {
            throw new java.lang.Exception("no protocol " + protolabel + "found on port" + portname);
        }
        com.jdcm.common.D_Utils d = new com.jdcm.common.D_Utils();
        java.lang.reflect.Method m = d.getMethod(elt.getClass(), option, value.getClass());
        if (m != null) {
            try {
                m.invoke(elt, value);
            } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                TDeb.wri("setStackMethod(): " + ex.getMessage());
                throw new java.lang.Exception("setStackMethod(): " + ex.getMessage());
            }
        } else {
            String txt = "Method not found on port " + portname + "=>" + protolabel + "." + option + "(" + value + ")";
            TDeb.wri(txt);
            throw new java.lang.Exception(txt);
        }
    }

    public void reply_out(I_stack_elt module, C_Packet packet) {
        if (module.isfrommedia()) {
            reply_out(packet, module.getlevel(), module.getport());
        } else {
            reply_in(packet, module.getlevel(), module.getport());
        }
    }

    public void reply_in(I_stack_elt module, C_Packet packet) {
        if (module.isfrommedia()) {
            reply_in(packet, module.getlevel(), module.getport());
        } else {
            reply_out(packet, module.getlevel(), module.getport());
        }
    }

    /**
     * send back messages on the receving port
     *
     */
    private void reply_out(C_Packet d_in, double level, I_Port port) {
        String commentaire = "" + d_in.getObj();
        if (d_in.getdestination() == null) {
            // packet relyed and destination no yet assigned
            // should be setdestination (moduleport)...
            d_in.setdestination(d_in.getsource());
        }
        if (d_in.getBytes() != null) {
            commentaire = "" + d_in.getBytes().length;
        }
        int row = model.getRowCount() - 1;
        // looking for the row of real protocol level
        while (row > 0 && ((Double) model.getValueAt(row, 0)) < level) {
            row--;
        }
        if (row < 0) {
            transmitdbg("reply_out : " + commentaire + "at level : " + level + "=> level not found");
            return;
        }
        if (model.getValueAt(row, port.getIndex() + 1) instanceof I_stack_elt) {
            I_stack_elt module = (I_stack_elt) model.getValueAt(row, port.getIndex() + 1);
            if (module.isdebug() && Parent instanceof C_Main) {
                java.util.ArrayList<C_Packet> list = new java.util.ArrayList<>();
                list.add(d_in);
                ((C_Main) Parent).addStackStat(list, module);
            }
        }
        String dbgtxt = d_in.getObj().toString();
        if (d_in.getBytes() != null) {
            dbgtxt = "byte[" + d_in.getBytes().length + "]";
        }
        transmitdbg("reply_out : " + dbgtxt + "at level : " + level + "found row : " + row);
        List<C_Packet> res = modif_out(d_in, row + 1, port);
        for (C_Packet p : res) {
            port.read_out(p);
        }
    }

    /**
     * send back messages on the receving port
     *
     */
    private void reply_in(C_Packet d_in, double level, I_Port port) {
        int row = 0;
        String commentaire = "" + d_in.getObj();
        String srcport = d_in.getsource().getcxstatus();
        if (srcport.startsWith("stop")
                || srcport.startsWith("err")
                || srcport.startsWith("clos")
                || srcport.startsWith("end")) {
            return;
        }
        if (d_in.getBytes() != null) {
            commentaire = "" + d_in.getBytes().length;
        }
        // looking for the row of real protocol level
        while (row < model.getRowCount() - 1 && ((Double) model.getValueAt(row, 0)) > level) {
            row++;
        }
        if (row == model.getRowCount() - 1) {
            transmitdbg("reply_in : " + commentaire + "at level : " + level + "=> level not found");
            return;
        }
        transmitdbg("reply_in : " + commentaire + "at level : " + level + "found row : " + row);
        if (model.getValueAt(row, port.getIndex() + 1) instanceof I_stack_elt) {
            I_stack_elt module = (I_stack_elt) model.getValueAt(row, port.getIndex() + 1);
        }
        List<C_Packet> res = modif_in(d_in, row - 1, port);
        // need to transmit after read else modif_in again...

        Parent.read(res);
    }

    /**
     * Report for Stacks logs
     *
     * @param module source Stack module
     * @param txt texte to log
     * @param isrcv if message is receed from media
     */
    public void dbgwri(I_stack_elt module, String txt, boolean isrcv) {
        if (module.isdebug()) {
            String dir = "DOWN";
            if (!(isrcv ^ module.isfrommedia())) {
                dir = "UP";
            }
            TDeb.wri("|" + module.toString() + "|" + dir + "|" + txt);
        }
    }

    /**
     * modify input in Main_CX packet with stacks
     *
     * @param d_in the Packet to modif
     * @param initRow the starting row level 
     * @param port the port on the stacks are apply
     * @return  the list of packet provided
     */
    public java.util.List<C_Packet> modif_in(C_Packet d_in, int initRow, I_Port port) {
        d_in.setStacksens(true);
        String commentaire = "" + d_in.getObj();
        if (d_in.getBytes() != null) {
            commentaire = "" + d_in.getBytes().length;
        }
        java.util.List<C_Packet> res = new java.util.ArrayList<>();
        if (model.isactif == false) {
            res.add(d_in);
            return res;
        } else {
            if (d_in.getObj() == null) {
                res.add(d_in);
            }
            transmitdbg("modif in : " + commentaire);
            int portidx = port.getIndex();
            int row = initRow;
            java.util.List<C_Packet> buf_proto = new java.util.ArrayList<>();
            java.util.List<C_Packet> buf_fin = new java.util.ArrayList<>();
            res.add(d_in);
            //only to trace the incomming from media (initRow == model.getRowCount() - 1) &&
            if (Parent instanceof C_Main) {
                buf_fin.add(d_in);
                I_stack_elt wire = new com.jdcm.modifiers.stacks.Stack_Dumy();
                wire.setParents(d_in.getsource(), null);
                wire.setdebug(true);
                ((C_Main) Parent).addStackStat(buf_fin, wire);
                buf_fin.clear();
            }
            while (row >= 0) {
                if (model.getValueAt(row, portidx + 1) instanceof I_stack_elt) {
                    I_stack_elt module = (I_stack_elt) model.getValueAt(row, portidx + 1);
                    transmitdbg("modif_in : " + commentaire + "found row : " + row + ",module :" + module.toString());
                    buf_proto.clear();
                    buf_fin.clear();
                    for (C_Packet pack : res) {
                        try {
                            if (module.isfrommedia()) {
                                buf_proto = module.receive(pack);
                            } else {
                                buf_proto = module.transmit(pack);
                            }

                        } catch (Exception ex) {
                        }
                        if (buf_proto != null) {
                            transmitdbg("modif_in : frames " + buf_proto.size() + " from: " + module.toString());
                            buf_fin.addAll(buf_proto);
                        } else {
                            buf_proto = new java.util.ArrayList<>();
                        }
                    }
                    res.clear();
                    res.addAll(buf_fin);
                    if (Parent instanceof C_Main) {
                        ((C_Main) Parent).addStackStat(buf_fin, module);
                    }
                }
                row--;
            }
            return res;
        }
    }

    /**
     * modify output in Main_CX packet with stacks
     *
     * @param d_out the packet to modify
     * @param initRow the starting row
     * @param port the port that support these modifications
     * @return  the list of packets provided
     */
    public List<C_Packet> modif_out(C_Packet d_out, int initRow, I_Port port) {
        d_out.setStacksens(false);
        String commentaire = "" + d_out.getObj();
        if (d_out.getBytes() != null) {
            commentaire = "" + d_out.getBytes().length;
        }
        List<C_Packet> res = new java.util.ArrayList<>();
        if (model.isactif == false) {
            res.add(d_out);
            return res;
        } else {
            transmitdbg("modif out : byte[" + commentaire + "]");
            int portidx = port.getIndex();
            int row = initRow;
            java.util.List<C_Packet> buf_proto = new java.util.ArrayList<>();
            java.util.List<C_Packet> buf_fin = new java.util.ArrayList<>();
            res.add(d_out);
            while (model.getValueAt(row, portidx + 1) != null || row < model.getRowCount() - 1) {
                if (model.getValueAt(row, portidx + 1) instanceof I_stack_elt) {
                    I_stack_elt module = (I_stack_elt) model.getValueAt(row, portidx + 1);
                    //  TDeb.wri("modif_out : [" + commentaire + "] found row : " + row + " : " + module.toString());
                    buf_proto.clear();
                    buf_fin.clear();
                    for (C_Packet pack : res) {
                        try {
                            if (module.isfrommedia()) {
                                buf_proto = module.transmit(pack);
                            } else {
                                buf_proto = module.receive(pack);
                            }
                        } catch (Exception ex) {
                        }
                        if (buf_proto != null) {
                            //      TDeb.wri("modif_out : frames " + buf_proto.size() + " from: " + module.toString());
                            buf_fin.addAll(buf_proto);
                        } else {
                            buf_proto = new java.util.ArrayList<>();
                        }
                    }
                    res.clear();
                    res.addAll(buf_fin);
                    if (Parent instanceof C_Main) {
                        ((C_Main) Parent).addStackStat(buf_fin, module);
                    }
                }
                row++;
            }
            return res;
        }
    }

    /**
     * get value of Option entry on a target protocol on a port
     *
     * @param portidx the port
     * @param protoType the protocol label
     * @param entrylabel the functionlabel in Options
     * @param searchdir UP or Down
     * @param startelt starting level
     * @return the value of the Option entry
     */
    public Object getinfos(I_Port portidx, String protoType, String entrylabel, boolean searchdir, I_stack_elt startelt) {
        Object res;
        int column = portidx.getIndex() + 1;
        I_stack_elt target = model.findtargetmodule(column, protoType, searchdir, startelt);
        if (target == null) {
            transmitdbg("getinfo from protocol : " + protoType + "not found port : " + portidx);
        } else {
            res = target.getOptions().getValuefor(entrylabel);
            return res;
        }
        return null;
    }

    /**
     * set value of Option entry on a target protocol on a port
     *
     * @param port the port that support 
     * @param protolabel the protocol label
     * @param issearchup UP/down search
     * @param startelt the starting level
     * @param entrylabel the functionlabel in Options
     * @param value the new value to assign to entrylabel
     */
    public void setinfos(I_Port port, String protolabel, boolean issearchup, I_stack_elt startelt, String entrylabel, Object value) {
        I_stack_elt target = getTarget(port, protolabel, issearchup, startelt);
        if (target == null) {
            transmitdbg("setinfo for target : " + protolabel + "notfound port : " + port);
        } else {
            target.getOptions().setValuefor(entrylabel, value);
        }
    }

    public I_stack_elt getTarget(String portName, String protoLabel) {
        I_Port port = getPort(portName);
        if (port == null) {
            String txt = "Port not found : " + portName;
            TDeb.wri(txt);
        }
        I_stack_elt elt = getTarget(port, protoLabel);
        if (elt == null) {
            String txt = "Protocol label not found : " + protoLabel + " on Port : " + portName;
            TDeb.wri(txt);
        }
        return elt;
    }

    public I_stack_elt getTarget(I_Port port, String protolabel) {
        return getTarget(port, protolabel, true, null);
    }

    public I_stack_elt getTarget(I_Port port, String protolabel, boolean issearchup, I_stack_elt startelt) {
        if (port == null) {
            return null;
        }
        int column = port.getIndex() + 1;
        I_stack_elt target = model.findtargetmodule(column, protolabel, issearchup, startelt);
        if (target == null) {
            TDeb.wri("Stack element not found: " + protolabel);
        }
        return target;
    }

    @Override
    public javax.swing.ImageIcon getCMDIcon() {
        return ((new com.jdcm.common.D_Utils()).getIcon("Stacks.gif"));
    }

    @Override
    public Options_Model getCMDOptions() {
        return option;
    }

    @Override
    public String getCMDdesc() {
        String st = "OFF";
        if (Parent instanceof C_Main && ((C_Main) Parent).isStack_Enabled()) {
            st = "ON";
        }
        return "Stacks\t" + st;
    }

    @Override
    public java.util.List<I_Command> getCMDChilds(String child) {
        java.util.List<I_Command> res = new java.util.ArrayList<>();
        java.util.List<I_Command> fulllist = new java.util.ArrayList<>();
        for (I_Command chld : fulllist) {
            if (chld.getCMDName().compareTo(child) == 0) {
                res.add(chld);
            }
        }
        return res;
    }

    @Override
    public I_Command getCMDParent() {
        return (I_Command) Parent;
    }

    @Override
    public String getCMDName() {
        return "Stacks";
    }

    @Override
    public String getCMDdetails() {
        return "Stacks of protocols added on port";
    }
}

class Stack_Model extends AbstractTableModel {

    private static final long serialVersionUID = 1L;
    private final I_Main Parent;
    private Object[][] table = null;
    public boolean isactif = false;

    public Stack_Model(I_Main m) {
        Parent = m;
        table = new Object[9][Parent.getPorts().size() + 1];
        for (int i = 0; i < 9; i++) {
            table[i][0] = (double) 8 - i;
        }
        filltable();
    }

    public I_stack_elt findtargetmodule(int col, String targetName, boolean isSearchUp, I_stack_elt startelt) {
        if (col <= 0 || targetName == null || targetName.length() == 0) {
            return null;
        }
        int initrow = -1;
        int step = +1;
        int endrow = table.length;
        if (startelt != null) {
            isSearchUp = isSearchUp & startelt.isfrommedia();
            for (int i = 0; i < table.length && initrow < 0; i++) {
                if (startelt == table[i][col]) {
                    initrow = i;
                }
            }
        } else {
            initrow = table.length - 1;
        }
        if (isSearchUp) {
            endrow = -1;
            step = -1;
        }
        for (int k = initrow; k != endrow; k = k + step) {
            if (table[k][col] instanceof I_stack_elt) {
                I_stack_elt m = (I_stack_elt) table[k][col];
                if (startelt == null) {
                    // no start element, searching for type of proto (getinfo())? => protocols
                    if (targetName.compareTo(m.toString()) == 0) {
                        return m;
                    }
                } else {
                    // searching for a label (getStack()) => CONF...
                    if (targetName.compareTo(m.getClass().getSimpleName().substring("Stack_".length())) == 0) {
                        return m;
                    }
                }
            }
        }
        return null;
    }

    private void filltable() {
        for (int i = 0; i < table.length; i++) {
            for (int j = 1; j < table[i].length; j++) {// should be but is not.. Parent.getPorts().size() + 1
                if (table[i][j] == null) {
                    table[i][j] = getValue(i, j - 1);
                }
            }
        }
    }

    public void update() {

        if (table[0].length != Parent.getPorts().size() + 1) {
            Object[][] bool = new Object[table.length][Parent.getPorts().size() + 1];
            for (int i = 0; i < table.length; i++) {
                for (int j = 0; j < Parent.getPorts().size() + 1; j++) {
                    try {
                        if (j == 0 || table[i][j] instanceof I_stack_elt) {
                            bool[i][j] = table[i][j];
                        } else {
                            bool[i][j] = null;
                        }
                    } catch (java.lang.ArrayIndexOutOfBoundsException ex) {
                    }
                }
            }
            table = bool;
            try {
                filltable();
            } catch (Exception ex) {

                System.err.print("Pb during Filling Stack Tables : " + ex.getMessage());
            }
        } 
    }

    private Object getValue(int row, int portidx) {
        String res = null;
        if (portidx < 0 || portidx >= Parent.getPorts().size()) {
            return null;
        } else {
            I_Port theport = Parent.getPorts().get(portidx);
            double portlevel = theport.getOsiLevel();
            if (portlevel < 0) {
                //if port is close then return all potential element (to be deleted)
                portlevel = (Double) table[table.length - 1][0];
            }
            if (theport instanceof I_Port) {
                String type = theport.getModeName();
                if (type.compareTo("IPL4") == 0) {
                    if (theport instanceof C_Port && ((C_Port) theport).isSSL_Enabled()) {
                        type = "SSL";
                    }
                }
                res = theport.getPortName() + "-" + type;
            }

            if (row == getRowFromLevel(portlevel)) {
                return res;
            }
            if (row > getRowFromLevel(portlevel)) {
                return null;
            }
            if (row >= table.length || (row > 0 && portidx + 1 >= table[0].length)) {
                return null;
            }
            if (row < getRowFromLevel(portlevel)) {
                try {
                    if (table[row][portidx + 1] instanceof I_stack_elt) {
                        return table[row][portidx + 1];
                    } else {
                        return "";
                    }
                } catch (Exception e) {
                    System.out.println("==>" + row + "," + portidx);
                }
            }
        }
        return null;
    }

    /**
     * table representation is with low level down, this provide the table row
     * number for the current level nb current level are (double) in column 0
     *
     * @param level the 'OSI' level
     * @return the row number of table representation
     */
    private int getRowFromLevel(double level) {
        int row = -1;
        for (int i = 0; i < table.length && row < 0; i++) {
            if (table[i][0] instanceof Double) {
                double lev = (Double) table[i][0];
                if (lev <= level) {
                    row = i;
                }
            }
        }
        return row;
    }

    @Override
    public String getColumnName(int column) {
        if (column == 0) {
            if (Parent.getPorts().isEmpty()) {
                return "No Ports";
            }
            return "Layer";
        }
        if (Parent.getPorts().isEmpty()) {
            return "?Empty?";
        } else if (Parent.getPorts().size() <= column - 1) {
            return "?Absent?";
        } else if (Parent.getPorts().get(column - 1) == null) {
            return "?NULL?";
        }
        return "MAIN";
    }

    @Override
    public int getColumnCount() {
        if (table == null) {
            return 0;
        }
        return table[0].length;
    }

    @Override
    public int getRowCount() {
        if (table == null || Parent.getPorts().isEmpty()) {
            return 0;
        }
        return table.length;
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        if (table == null || aRow >= table.length) {
            return null;
        }
        if (aColumn == 0) {
            return table[aRow][aColumn];
        }
        //   return "";
        return getValue(aRow, aColumn - 1);
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        if (column == 0) {
            return false;
        }
        if (getValue(row, column - 1) == null) {
            return false;
        }
        return getValue(row, column - 1) instanceof I_stack_elt;
    }

    public void insertlevel(int aRow) {
        Object[][] bool = new Object[table.length + 1][Parent.getPorts().size() + 1];
        for (int i = 0; i < table.length + 1; i++) {
            for (int j = 0; j < Parent.getPorts().size() + 1; j++) {
                if (i <= aRow) {
                    bool[i][j] = table[i][j];
                }
                if (i == aRow) {
                    if (j == 0) {
                        double elt;
                        if (aRow == 0) {
                            //level will not go over 8.999..
                            elt = 9.0;
                        } else {
                            elt = (Double) table[aRow - 1][0];
                        }
                        bool[i][j] = ((Double) table[aRow][0] + elt) / 2;
                    } else {
                        bool[i][j] = null;
                    }
                }
                if (i > aRow) {
                    bool[i][j] = table[i - 1][j];
                }
            }
        }
        table = bool;
        filltable();
        this.fireTableDataChanged();
    }

    public void removelevel(int aRow) {
        Object[][] bool = new Object[table.length - 1][Parent.getPorts().size() + 1];
        for (int i = 0; i < table.length; i++) {
            for (int j = 0; j < Parent.getPorts().size() + 1; j++) {
                if (i < aRow) {
                    bool[i][j] = table[i][j];
                }
                if (i > aRow) {
                    bool[i - 1][j] = table[i][j];
                }
            }
        }
        table = bool;
        filltable();
        this.fireTableDataChanged();
    }

    @Override
    public void setValueAt(Object value, int aRow, int aColumn) {
        if (aColumn == 0) {
            if (value.equals("addlevel")) {
                insertlevel(aRow);
            } else if (value.equals("removelevel")) {
                removelevel(aRow);
            } else if (value instanceof Double) {
                table[aRow][aColumn] = value;
            }
            return;
        }
        table[aRow][aColumn] = value;
        isactif = true;
        this.fireTableDataChanged();
    }
}
