package com.jdcm.eltrx;

import com.jdcm.common.D_Utils;
import java.awt.HeadlessException;
import java.io.*;
import java.lang.reflect.InvocationTargetException;
import java.util.Calendar;

/**
 * C_Start.java Created on 18 novembre 2006, 13:36
 *
 * Check if files/libraries/class are avalable.<br> is able to load it according
 * to OS<br>
 *
 * Checks Libs & lauch Main<br>
 *
 * @author Marc GIBOIN
 */
public class C_Start extends Thread {

    private final String str1 = "//";
    private final String str11 = "sgi";
    private final String str2 = new String(new char[]{File.separatorChar});  // widows :"\\" unix:"/"...
    private final String str3 = ".";
    private final String str4 = "http:" + str1 + str11 + "boin" + str3 + "free" + str3 + "fr";
    private final String localhome = System.getProperty("java.home");
    private C_Main Parent = null;
    private com.jdcm.editors.Z_Scroll fscrollbar = null;
    private String moduleName = null;
    private boolean createScrollOnload = false;

    /**
     * Creates a new instance of C_Start
     */
    public C_Start() {
        if (checksystemfiles() < 0) {
            if (java.awt.GraphicsEnvironment.isHeadless()) {
                tolog("Start : Error : Missing library, close & start again !");
            } else {
                javax.swing.JOptionPane.showMessageDialog(new java.awt.Frame(), "Start : End of normal installation\r\n Thanks to Restart");
            }
            System.exit(3);
        }
        //!!! better!! check org.jdesktop.layout.GroupLayout.class
        // if (load_Module("swing-layout-1.0.4.jar", null) < 0) {
        //     tolog("C_Start : swing-layout-1.0.4.jar not found and not load");
        // javax.swing.JOptionPane.showMessageDialog(new java.awt.Frame(), "GUI OS & no swing-layout-1.0.4 found\r\n run as console");
        //   System.exit(2);
        //  }
        tolog("Starting on " + System.getProperty("os.name") + "-" + System.getProperty("os.arch") + ";" + System.getProperty("java.version"));
        //javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
        // http://chuidiang.blogspot.com/2005/09/propiedades-de-systemgetproperty.html
   //==> C_Main a = new C_Main();
    }
    public C_Start(String[] args){
       super();
        C_Main a = new C_Main(args);
    }

    public C_Start(boolean bool) {
        createScrollOnload = bool;
    }

    public C_Start(String load, C_Main p) {
        Parent = p;
        if (load.compareTo("libcheck") == 0) {
            tolog("C_Start : start libchecking");
            // res=loadETH();
        } else {
            moduleName = load;
            displayScrollbar(0, 100, 0, "init load : " + moduleName);
            tolog("C_Start : teached for " + load);
        }
    }

    private void loadModule() {
        int res = 0;
        //ask to load a library
        displayScrollbar("Ask load : " + moduleName);
        if (moduleName.compareTo("ETH") == 0) {
            if (System.getProperty("os.name").startsWith("Win")) {
                res = load_Module("jpcap.jar", "Jpcap");
            } else {
                res = load_Module("jpcap.jar", "libjpcap");
            }
            // res=loadETH();
        }
        if (moduleName.compareTo("3D") == 0) {
            res = load_Module("j3dcore.jar", "j3dcore-ogl");
            res += load_Module("j3dutils.jar", "j3dcore-ogl-cg");
            res += load_Module("vecmath.jar", "j3dcore-ogl-chk");
            res += load_Module(null, "j3dcore-d3d");
            if (System.getProperty("os.name").startsWith("Win") == false) {
                //only for linux i386
                res += load_Module(null, "libj3dcore-ogl");
                res += load_Module(null, "libj3dcore-ogl-cg");
            }
        }
        if (moduleName.compareTo("COM") == 0) {
            res = load_Module("RXTXcomm.jar", null);
            if (System.getProperty("os.name").startsWith("Win")) {
                res += load_Module(null, "rxtxSerial");
                res += load_Module(null, "rxtxParallel");
            } else {
                res += load_Module(null, "librxtxSerial");
                res += load_Module(null, "librxtxParallel");
            }
        }
        if (moduleName.compareTo("JNA") == 0) {
            res = load_Module("jna.jar", null);
        }
        if (moduleName.compareTo("USB") == 0) {
            res = load_Module("jusb.jar", "jusb");
        }
        if (moduleName.compareTo("MySQL") == 0) {
            res = load_Module("mysql-connector-java-5.1.12-bin.jar", null);
        }
        if (moduleName.compareTo("Derby") == 0) {
            res = load_Module("derbyclient.jar", null);
        }
        if (moduleName.compareTo("Oracle") == 0) {
            res = load_Module("ojdbc14.jar", null);
        }
        if (moduleName.compareTo("SQLServer") == 0) {
            res = load_Module("jtds-1.2.4.jar", null);
        }
        if (moduleName.compareTo("ODBC") == 0) {
            res = load_Module("sqljdbc.jar", null);
        }
        if (moduleName.compareTo("HSQL") == 0) {
            res = load_Module("hsqldb.jar", null);
        }
        if (moduleName.compareTo("Tools") == 0) {
            res = load_Module("tools.jar", null);
        }
        if (moduleName.compareTo("Xaccess") == 0) {
            res = loadPolicy();
        }
        if (res < 0) {
            displayScrollbar("loading of " + moduleName + " Error : " + res);
        } else {
            displayScrollbar("Succesfully end of loading " + moduleName + ",");
            displayScrollbar("Restart is needed to use " + moduleName);
        }
        // displayScrollbar(-1, -1, -1, null);
    }

    private void tolog(String message) {
        // System.out.println(message);
    }

    public java.util.List<String> checklib(java.util.List<String> list) {
        if (java.awt.GraphicsEnvironment.isHeadless() == false) {
            list.add("WIN");
        } else {
            tolog("WIN is not enable");
        }
        try {
            java.lang.Class.forName("gnu.io.CommPortIdentifier");
            list.add("Serial");
            if (System.getProperty("os.name").startsWith("Lin")) {
                //UBUNTU : https://bugs.launchpad.net/ubuntu/+source/rxtx/+bug/367833
                // FreeBSD : cuaa*
                //Linux : ttyS*
                //Windows:COM*
                //netbsd:tty0*
                //Irix :ttyd*
                //HP-UX : tty0p*
                //BeOS:/dev/ports/serial*
                // other solution : #ln -S /dev/ttyACM0 /dev/ttyS20
                System.setProperty("gnu.io.rxtx.SerialPorts", "/dev/ttyACM0");
            }
        } catch (ClassNotFoundException th) { //throwable
            tolog("RS port is disabled, load RxTx Comm libary to enable it : " + th.getMessage());
        }
        try {
            java.lang.Class.forName("jpcap.JpcapCaptor");
            list.add("ETH");
        } catch (ClassNotFoundException th) { //throwable
            tolog("ETH port is disabled, load & install winPcap & jpcap to enable it : " + th.getMessage());
        }
        try {
            java.lang.Class.forName("com.sun.jna.Native");
            list.add("JNA");
       } catch (ClassNotFoundException th) { //throwable
            tolog("JNA  disabled, load jna.jar to enable it : " + th.getMessage());
        }
        try {
            java.lang.Class.forName("usb.core.Hub");
            list.add("USB");
       } catch (ClassNotFoundException th) { //throwable
            tolog("UBS port is disabled, load & install jUSB to enable it : " + th.getMessage());
        }
        try {
            Class<?> o = java.lang.Class.forName("javax.tools.ToolProvider");
            tolog("=>tools : " + o);
            if (o.getDeclaredMethod("getSystemJavaCompiler", new Class<?>[]{}).invoke(o, new Object[]{}) == null) {
                //new Class<?>[]{}, new Object[]{}
                tolog("javax.tools.ToolProvider.getSystemJavaCompiler() is null=> tools.jar");
            } else {
                list.add("TOOL");
            }
        } catch (ClassNotFoundException | NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            tolog("using javax.tools.ToolProvider =>" + ex.getMessage());
        }
        try {
            Class<?> o = java.lang.Class.forName("javax.media.j3d.Appearance");
            list.add("3D");
        } catch (ClassNotFoundException th) { //throwable
            tolog("java 3D is disabled  " + th.getMessage());
        }
        String[] dbtitles = {"MySQL", "Derby", "Oracle", "SQLServer", "ODBC", "HSQL", "Sybase"};
        for (String dbtitle : dbtitles) {
            try {
                if (Class.forName(Parent.getDB_drivername(dbtitle)) != null) {
                    list.add(dbtitle);
                }
            }catch (ClassNotFoundException ex) {
                //tolog("couldn't load driver : " + Parent.getDB_drivername(dbtitles[i]) + " for : " + dbtitles[i].toUpperCase());
            }
        }
        return list;
    }

    private int checksystemfiles() {
        //UNIX : check root system access ?? ...or... allow copy on jre/ext ...or...  use lib from web...
        int res = 0;
        System.setProperty("file.encoding", "Cp1252");
        // non effective with : System.getProperty("java.ext.dirs")=+".\\system"; !!!!
        java.net.URL[] u = new java.net.URL[1];
        try {
            u[0] = new java.net.URL(str4 + "/lib/");
            java.net.URLClassLoader cloader = new java.net.URLClassLoader(u);
            // TO avoid connexion without lib checking
            /*
             * in flag isthe limite date of update mandatory
             *
             */
            java.util.Calendar cal = java.util.Calendar.getInstance();
            cal.setTimeInMillis(System.currentTimeMillis());
            int y = cal.get(Calendar.YEAR);
            InputStream str = java.net.URLClassLoader.getSystemClassLoader().getResourceAsStream("shemas/date.xml");

            if (str != null && str.available() >= 4) {
                byte[] buff = new byte[10];
                str.read(buff, 0, 10);
                int yy = Integer.parseInt(new String(buff).trim(), 8);
                cal.setTimeInMillis(System.currentTimeMillis());
                if (yy < y && yy>y-5 ) {
                    //tryed http:\\xxx.xxx.xxx.xxx\lib\flag but not working with free (to avoid DNS Pb)
                    if (java.awt.GraphicsEnvironment.isHeadless()) {
                        //System.exit(1);
                        tolog("Could not checks needed libraries");
                    } else {
                        // System.exit(1);
                        javax.swing.JOptionPane.showMessageDialog(new java.awt.Frame(), "Could not check needed libraries", "Starting...", javax.swing.JOptionPane.ERROR_MESSAGE);
                    }
                    java.util.Timer t = new java.util.Timer();
                    t.schedule(new java.util.TimerTask() {
                        @Override
                        public void run() {
                            tolog(">>\r\n");
                            System.exit(1);
                        }
                    }, 2000);
                }
            } else {
                tolog(">\r\n");
                System.exit(1);
            }
        } catch (IOException | NumberFormatException | HeadlessException ex) {
            System.exit(2);
        }

        return res;
    }

    /**
     * load modules for interfaces
     *
     * @param extfile file to load as JRE extention (with extention (.jar)
     * @param libfile file to load as JRE lib without extention (.dll/.so/...)
     * @return
     */
    public final int load_Module(String extfile, String libfile) {
        int res = 0;
        String extpath;
        displayScrollbar("-Ask for Sytem lib : '" + libfile + "' and java extension : '" + extfile + "'");
        if (extfile != null && extfile.length() > 0) {
            extpath = str2 + "lib" + str2 + "ext";
            // 11 2011 done on JDK1.7 =>sun Bug ID:7181951
            if (extfile.startsWith("tools.jar")) {
                extpath = str2 + "lib";
            }
            res += sysfile(extfile, "", localhome + extpath);
            displayScrollbar("-load : " + extpath + str2 + extfile + " state: " + res);
        }
        if (libfile != null && libfile.length() > 0) {
            String osname = System.getProperty("os.name");
            String osarch = System.getProperty("os.arch");
            displayScrollbar("-System architecture is : " + osname + "/" + osarch);
            if (osname.startsWith("Win")) {
                extpath = str2 + "bin";
                res += sysfile(libfile + ".dll", "Win_" + System.getProperty("sun.arch.data.model") + "/", localhome + extpath);
                displayScrollbar("-load : " + extpath + str2 + extfile + " state: " + res);
            }
            if (osname.startsWith("Lin")) {
                extpath = str2 + "lib" + str2 + osarch;
                res += sysfile(libfile + ".so", "Linux-" + osarch, localhome + extpath);///usr/lib??
                displayScrollbar("-load: " + extpath + str2 + extfile + " state: " + res);
            }
        }
        return res;
    }

    private int loadPolicy() {
        int res = 0;
        res += sysfile("java.policy", "", localhome + str2 + "lib" + str2 + "security");
        return res;
    }

    private int sysfile(String srcfile, String ftpdir, String dstrep) {
        long insize = 0;
        File f = new File(dstrep + File.separator + srcfile);
        if (f.exists() && (moduleName == null || moduleName.startsWith("libcheck"))) {
            tolog("Checked file : " + srcfile + " .... OK / " + f.length());
            return 0;
        } else if (createScrollOnload) {
            displayScrollbar("createScrollOnload" + createScrollOnload);
            displayScrollbar(0, 100, 0, "init load : " + moduleName);
        }
        displayScrollbar("--try to find (on WEB): '" + srcfile + "'");
        InputStream in = D_Utils.getFileStream(srcfile, str4 + "/lib/" + ftpdir, getClass().getClassLoader());
        if (in == null) {
            displayScrollbar("--try to find on Jar: '" + srcfile + "'");
            in = D_Utils.getFileStream(srcfile, "lib", getClass().getClassLoader());
        }
        if (in == null) {
            displayScrollbar("--could NOT open source for copy : " + str4 + "/lib/" + ftpdir + srcfile + ".");
            // connection previously tested by flag, J3D for linux amd64=> only on .so needed
            return -1;
        } else {
            try {
                insize = ((FileInputStream) in).getChannel().size();
            } catch (IOException ex) {
            }
            OutputStream out;
            try {
                out = new FileOutputStream(dstrep + File.separator + srcfile);
            } catch (FileNotFoundException ex) {
                displayScrollbar("--Could not create local file : " + dstrep + File.separator + srcfile);
                displayScrollbar("--=>" + ex.getMessage());
                return -1;
            }
            displayScrollbar("--Local file creation is OK : '" + dstrep + File.separator + srcfile + "'");
            try {
                int total = 0;
                int readednb = 0;
                while (in != null && in.available() >= 0 && readednb >= 0) {
                    byte[] buff = new byte[in.available()];
                    sleep(10);
                    readednb = in.read(buff);
                    if (readednb > 0) {
                        total = total + readednb;
                        out.write(java.util.Arrays.copyOf(buff, readednb));
                        displayScrollbar(0, insize, total, "---Writing " + srcfile + " writed: " + total + " bytes");
                        displayScrollbar("=>" + total);
                    } else if (readednb == 0) {
                        displayScrollbar(".");
                    } else {
                        displayScrollbar("--Readed return " + readednb + " [EOF]");
                    }
                    //System.err.println("=>"+i+ " =>"+a.length+" :" +in.available());
                }
            } catch (IOException | InterruptedException ex) {
                displayScrollbar("--Error during coppying: " + dstrep + "\\" + srcfile + "=>" + ex.getMessage());
                displayScrollbar("--Check you rights...=>" + ex.getMessage());
                return -1;
            }
            displayScrollbar("--END of copie");
            try {
                if (in != null) {
                    in.close();
                }
                out.close();
            } catch (IOException ex) {
                displayScrollbar("--Error during Streams (in/out) close()" + ex.getMessage());
                return -1;
            }
            displayScrollbar("--Streams are closed");
            return 0;
        }

    }

    public void displayScrollbar(String txt) {
        if (fscrollbar != null) {
            displayScrollbar(-1, -1, -1, txt);
        } else {
            tolog(" C_Start : " + txt);
        }
    }

    public final void displayScrollbar(long min, long max, int val, String txt) {

        // perhaps needed : test Class.forName("com.jdcm.editors.F_Scroll")!=null
        tolog(" Scrollbar : min/max/val/txt : " + min + "/" + max + "/" + val + "/" + txt);
        if (java.awt.GraphicsEnvironment.isHeadless() == false) {
            if (fscrollbar == null) {
                fscrollbar = new com.jdcm.editors.Z_Scroll();
                fscrollbar.setValues(min, max, val, txt);
                fscrollbar.setTitle(txt);
                fscrollbar.setVisible(true);
            } else if (min == -1 && max == -1 && val == -1 && txt == null) {
                fscrollbar.setVisible(false);
                fscrollbar = null;
            } else if (min < max) {
                fscrollbar.setValues(min, max, val, txt);
            } else if (min == -1 && max == -1) {
                if (val == -1) {
                    if (txt.compareTo(".") == 0) {
                        fscrollbar.AddText(txt);
                    } else {
                        fscrollbar.AddText(txt + "\r\n");
                    }
                } else if (txt == null) {
                    fscrollbar.setValues(val);
                }
            } else {
                System.out.println("impossible Scroll values : min : " + min + " max: " + max + " val:" + val);
            }
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        C_Start a = new C_Start(args);
    }

    /**
     * Run the SYS Slave
     *
     * no listner on in strean
     *
     */
    @Override
    public void run() {
        displayScrollbar("Started Thread for " + moduleName);
        loadModule();
    }
}
