package com.jdcm.eltrx;

import com.jdcm.common.C_Format;
import java.sql.Timestamp;
import com.jdcm.common.D_Utils;

/**
 * Manage all logs & debug informations<br>
 * 
 * @author Marc GIBOIN
 */
public class D_Debug {
private final D_Utils utils;

    private C_Format formate;
    private I_Console console;
    private String S_class;
    

    public D_Debug(String source) {
        this.S_class = source;
        console = null;
        utils = new D_Utils();
        // if (source.compareTo(txt)!=0){TDeb=new D_Debug(txt);}
    }

    /**
     *find the string/byte from the byte/string in a stream
     * Ex : [0x31 0x30] Typ="ASCII"=> "10"
     * @param Typ the type to transform data to String (DEC/ASCII/BYTE/...)
     * @param buff the byte arrays data
     * @return the string matching with byuffer
     */
    public String retire(String Typ, byte[] buff) {
        if (formate == null) {
            formate = new C_Format();
        }
        formate.setbuffer(buff);
        return formate.B_Retire(Typ);
    }

    public byte[] prend(String Typ, String value) {
        if (formate == null) {
            formate = new C_Format();
        }
        formate.setvalue(value);
        return formate.B_Prend(Typ);
    }

    /**
     *return the string/Object from the Object/value from a stream
     * Ex : "2007" cl="Integer"=> <Integer>2007
     * CARE something like that un Utils...
     * 
     * @param cl the String look like a class
     * @param value the value to transform
     * @param format ex dd/mm/yy...
     * @return the Object 
     */
    public Object To_Obj(String cl, String value, String format) {
        if (formate == null) {
            formate = new C_Format();
        }
        formate.setvalue(value);
        return formate.C_To_Object(cl, format);
    }

    public Object To_Obj(String cl, String code, byte[] buffer, String format) {
        String formatage = format;
        String classe = cl;
        // to avoid to compose the string=> get directly object
        if (formatage == null) {
            formatage = "";
        }
        if (classe == null) {
            classe = "";
        }
        if (code.compareTo("BYTE") == 0 && classe.length() == 0) {
            return buffer;
        }
        if (code.compareTo("BYTE") == 0 && classe.compareTo("InetAddress") == 0) {
            try {
                return java.net.InetAddress.getByAddress(buffer);
            } catch (java.net.UnknownHostException ex) {
                try {
                    return java.net.InetAddress.getByName(new String(buffer));
                } catch (java.net.UnknownHostException exe) {
                    return exe.getMessage();
                }

            }
        }
        if (classe.compareTo("List") == 0) {
            java.util.List<Object> b = new java.util.ArrayList<>();
            Object a = null;
            if (formatage.compareTo("String") == 0) {
                a = retire(code, buffer);
            }
            b.add(a);
            return b;
        }
        //!!!!!! append a ArrayIndexExit ??
        return To_Obj(classe, retire(code, buffer), formatage);
    }

    public String From_Obj(Class<?> cl, Object obj, String format) {
        if (formate == null) {
            formate = new C_Format();
        }
        return formate.C_From_Object(cl, obj, format);
    }

    public boolean[] getBM() {
        if (formate == null) {
            return null;
        }
        return formate.BMap;
    }

    public void setformat_caption(boolean bool) {
        if (formate == null) {
            formate = new C_Format();
        }
        formate.setlibelle(bool);
    }

    public void setsource(String txt) {
        this.S_class = txt;
    }

    /**
     * to redirect the log flow (see wri()
     *
     * @param c the consle to set to this debug
     */

    public void setconsole(I_Console c) {
        console = c;
    }

    public I_Console getconsole() {
        return console;
    }

    /**
     *wri log messages to the console stream.<br>
     *   - always on err stream if begin by "Error :"<br>
     *   - always on out if there is no "crooresponding" checkbox<br>
     *   - if selected if checkbox exists<br>
     *NB : errors sometimes!!!
     */
    public void wri(String message) {
        if (message == null) {
            return;
        }
        if (System.err == null) {
            return;
        }
        if (message.length() > "Error : ".length()) {
            if (message.startsWith("Error : ")) {
                Timestamp tstamp = new Timestamp(System.currentTimeMillis());
                System.err.println("" + utils.ajustTxt(tstamp.toString(), 24) + "|" + S_class + " |" + message);
                return;
            }
        }
        if (System.out == null) {
            return;
        }
        if (message == null) {
            System.err.println("Error : try to print a null log String");
            return;
        }
        try {
            Timestamp tstamp = new Timestamp(System.currentTimeMillis());
            String txt = "" + utils.ajustTxt(tstamp.toString(), 24) + "|" + S_class + " |" + message;
            if (console == null) {
                  System.out.println(txt);
                   } else {
                if (console.isdbgselected(S_class)) {
                    console.addlog(txt); //for all port debug redirection
                    System.out.println(txt); // for GUI/System in/out
                }
            }

        } catch (Throwable ex) {
            System.out.println("CONSOLE ERROR for :" + message + " [" + ex.getMessage() + "]");
        }
    }
}
