package com.jdcm.eltrx;

import java.sql.*;
import javax.swing.table.*;
import java.util.List;

/**
 *  F_DBEditTable.java Created on 2 septembre 2007, 14:23
 * 
 * Create / Edit Table in Database
 *
 * @author Marc GIBOIN
 */
public class F_DBEditTable extends javax.swing.JFrame {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final Connection CX;
    private final F_DBConnexion Parent;
    private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>();

    /**
     * Creates new form F_DBEditTable
     * @param F the UI frame used to get this connexion
     * @param cx the connexion to Edit
     */
    public F_DBEditTable(F_DBConnexion F, Connection cx) {
        Parent = F;
        CX = cx;
        initComponents();
        feelfields();
        this.setVisible(true);
    }

    private void createTable() {
        // check datas
        if (jTextField1.getText().length() == 0) {
            return;
        }
        if (jTextField1.getText().indexOf(" ") != -1) {
            return;
        }
        if (jTable1.getRowCount() == 0) {
            return;
        }
        for (int i = 0; i < jTable1.getRowCount(); i++) {
            if (((String) jTable1.getValueAt(i, 0)).length() == 0) {
                return;
            }
        }
        // construct request
        String cat = jComboBox1.getSelectedItem().toString();
        if (cat != null) {
            if (cat.length() > 0) {
                cat += ".";
            }
        } else {
            cat = "";
        }
        String req = "CREATE TABLE " + cat + jTextField1.getText() + " (";
        for (int i = 0; i < jTable1.getRowCount(); i++) {
            String col = ((String) jTable1.getValueAt(i, 0));
            String typ = ((javax.swing.JComboBox) jTable1.getValueAt(i, 1)).getSelectedItem().toString();
            String nul = "NOT NULL";
            if ((Boolean) jTable1.getValueAt(i, 2)) {
                nul = "NULL";
            }
            // String autoincr="";
            //if ((Boolean)jTable1.getValueAt(i,10)){autoincr="AUTO_INCREMENT";}
            req = req + " " + col + " " + typ + " " + nul + " ,";//+autoincr+" ,";
        }
        req = req.substring(0, req.length() - 1); // remove last ","
        req += " )";
        // execute
        int res = -1;
        try {
            Statement request = CX.createStatement();
            long start = System.currentTimeMillis();
            res = request.executeUpdate(req);
            long stop = System.currentTimeMillis();
        } catch (SQLException e) {
            javax.swing.JOptionPane.showMessageDialog(this, req + "\r\n provided : [" + e.getMessage() + "]", "View error", javax.swing.JOptionPane.ERROR_MESSAGE);
            System.out.println("Pb with CREATING Table : " + e.getMessage());
            return;
        }
        Parent.feelFrames();
        this.setVisible(false);
    }

    private void feelfields() {
        try {
            jTable1.setModel(new DB_Table_Model(CX.getMetaData()));
        } catch (SQLException ex) {
            System.err.println("[" + ex.getMessage() + "]");
        }
        jComboBox1.setModel(((DB_Table_Model) jTable1.getModel()).getshema().getModel());
        try {
            jComboBox1.setSelectedItem(CX.getCatalog());
        } catch (SQLException ex) {
            System.err.println("[" + ex.getMessage() + "]");
        }

        for (int i = 0; i < jTable1.getColumnCount(); i++) {
            jTable1.getColumnModel().getColumn(i).setCellRenderer(render);
            jTable1.getColumnModel().getColumn(i).setCellEditor(editor);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel4 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setTitle("DB Table Editting");

        jPanel4.setLayout(new javax.swing.BoxLayout(jPanel4, javax.swing.BoxLayout.Y_AXIS));

        jLabel3.setText("DB TABLE EDITING");
        jPanel4.add(jLabel3);

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setText("Table Name : ");
        jPanel2.add(jLabel1);
        jPanel2.add(jTextField1);

        jPanel4.add(jPanel2);

        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.LINE_AXIS));

        jLabel2.setText("Catalog :");
        jPanel3.add(jLabel2);

        jPanel3.add(jComboBox1);

        jPanel4.add(jPanel3);

        getContentPane().add(jPanel4, java.awt.BorderLayout.NORTH);

        jScrollPane1.setViewportView(jTable1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jButton1.setText("Add Column");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        jButton2.setText("Remove Column");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2);

        jButton3.setText("Create Table");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton3);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        createTable();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        int i = jTable1.getSelectedRow();
        if (i > 0) {
            ((DB_Table_Model) jTable1.getModel()).remove(i);
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        ((DB_Table_Model) jTable1.getModel()).add();
    }//GEN-LAST:event_jButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables
}

class DB_Table_Model extends AbstractTableModel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final List<Object[]> rows;
    private final String[] columnNames = {"Label", "TypeName", "Nullable"};//"ReadOnly", "CaseSensitive", "Currency", "DefinitelyWritable", "Searchable", "Signed", "Writable","AutoIncrement"};
    private final Class<?>[] types = new Class<?>[]{
        java.lang.String.class, java.lang.Object.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.Boolean.class, java.lang.String.class, java.lang.Boolean.class
    };
    private final java.sql.DatabaseMetaData CXmd;

    public DB_Table_Model(java.sql.DatabaseMetaData cxmd) {
        CXmd = cxmd;
        rows = new java.util.ArrayList<>();
        rows.add(getnewrow());
    }

    public javax.swing.JComboBox<String> getshema() {
        javax.swing.JComboBox<String> JCBsch = new javax.swing.JComboBox<>();
        ResultSet cat = null;
        try {
            cat = CXmd.getCatalogs();
        } catch (SQLException ex) {
            System.err.println("[" + ex.getMessage() + "]");
        }
        rs2combobox(cat, 1, JCBsch);
        try {
            JCBsch.setSelectedItem(CXmd.getConnection().getCatalog());
        } catch (SQLException ex) {
            System.err.println("[" + ex.getMessage() + "]");
        }
        return JCBsch;
    }

    public void add() {
        rows.add(getnewrow());
        this.fireTableDataChanged();
    }

    public void remove(int row) {
        rows.remove(row);
        this.fireTableDataChanged();
    }

    private Object[] getnewrow() {
        javax.swing.JComboBox<Object> JCBtypes = new javax.swing.JComboBox<>();
        ResultSet typ = null;
        try {
            typ = CXmd.getTypeInfo();
        } catch (SQLException ex) {
            System.err.println("[" + ex.getMessage() + "]");
        }
        rs2combobox(typ, 1, JCBtypes);
        Object[] row = new Object[3];
        row[0] = "";
        row[1] = JCBtypes;
        row[2] = Boolean.TRUE;// nullable
        //  row.add(new Boolean("false"));//readonly
        //  row.add(new Boolean("false"));
        //  row.add(new Boolean("false"));
        //  row.add(new Boolean("false"));
        //  row.add(new Boolean("false"));
        //  row.add(new Boolean("false"));//signed
        //  row.add(new Boolean("false"));//writtable
        // JCBnull.addItem("NoNulls");JCBnull.addItem("Nullable");JCBnull.addItem("NullableUnknown");
        // row.add(JCBnull);
        //  row.add(new Boolean("false"));
        return row;
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;

    }

    @Override
    public int getRowCount() {
        return rows.size();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        Object res = rows.get(aRow)[aColumn];
        return res;
    }

    @Override
    public void setValueAt(Object value, int aRow, int aColumn) {
        rows.get(aRow)[aColumn] = value;
    }

    @Override
    public Class<?> getColumnClass(int column) {
        return types[column];
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return true;
    }

    private <U> void rs2combobox(ResultSet rs, int col, javax.swing.JComboBox<U> jcb) {
        jcb.removeAllItems();
        if (rs == null) {
            return;
        }
        try {
            while (rs.next()) {
                Object ob = rs.getObject(col);
                jcb.addItem((U) ob);
            }
        } catch (SQLException ex) {
            System.err.println("[" + ex.getMessage() + "]");
        }
    }
}
