package com.jdcm.eltrx;

import com.jdcm.common.D_Utils;
import java.io.File;

/**
 * Used to do Mappings tests between XML & DB
 *
 * @author Marc GIBOIN
 */
public class F_DBMap extends javax.swing.JFrame {

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    
   private  C_Port Parent = null;
    

    /**
     * Creates new form F_DBMap
     */
    public F_DBMap() {
        initComponents();
        init();
        setVisible(true);
    }
    // with port used to find DB

    public F_DBMap(C_Port p) {
        initComponents();
        Parent = p;
        init();
    }
// initialise the GUI part.

    private void init() {
        jButton1.setIcon(TUtils.getIcon("refresh.gif"));
        jButton2.setIcon(TUtils.getIcon("Empty.gif"));
        jSplitPane2.setDividerLocation(0.5);
        java.io.File f;
        if (Parent == null) {
            f = TUtils.getFile("dep_base.xml", "mapping");
        } else {
            f = Parent.getDB_mapfile();
        }
        p_Texte1.setFile(f);
        jComboBox1.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<File>());
        if (Parent != null) {
            jComboBox1.setModel(Parent.getCMDOptions().getValuefor("DB_mapfile",
                    new javax.swing.DefaultComboBoxModel<File>()));
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        jSplitPane1 = new javax.swing.JSplitPane();
        jSplitPane2 = new javax.swing.JSplitPane();
        p_Texte1 = new com.jdcm.editors.P_Texte();
        p_Texte2 = new com.jdcm.editors.P_Texte();
        p_Texte3 = new com.jdcm.editors.P_Texte();

        setTitle("DB_Map");
        setPreferredSize(new java.awt.Dimension(700, 350));

        jToolBar1.setRollover(true);

        jButton1.setBorderPainted(false);
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jButton2.setToolTipText("Empty");
        jButton2.setBorderPainted(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jComboBox1);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.NORTH);

        jSplitPane1.setDividerLocation(100);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jSplitPane2.setDividerLocation(300);
        jSplitPane2.setLeftComponent(p_Texte1);
        jSplitPane2.setRightComponent(p_Texte2);

        jSplitPane1.setLeftComponent(jSplitPane2);
        jSplitPane1.setRightComponent(p_Texte3);

        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (p_Texte2.getText() == null || p_Texte2.getText().trim().length() == 0) {
            java.io.ByteArrayOutputStream o = new java.io.ByteArrayOutputStream();
            if (Parent != null && Parent.getSlave() instanceof T_DB) {
                ((T_DB) Parent.getSlave()).getQuickMap(
                        new java.io.ByteArrayInputStream(p_Texte1.getTextePane().getText().trim().getBytes()),
                        o, null, true);
            }
            p_Texte2.setText(o.toString());
            p_Texte2.setType("XML");
        } else {
            ((T_DB) Parent.getSlave()).getQuickMap(
                    new java.io.ByteArrayInputStream(p_Texte1.getText().trim().getBytes()),
                    p_Texte3.getOutStream(), p_Texte2.getText(), false);
            p_Texte3.setType("XML");
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        p_Texte1.setText("");
        p_Texte2.setText("");
        p_Texte3.setText("");
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
         if (Parent != null) {
            Parent.setDB_mapfile((File) jComboBox1.getSelectedItem());
            p_Texte1.setFile(Parent.getDB_mapfile());
        }
    }//GEN-LAST:event_jComboBox1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(F_DBMap.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new F_DBMap().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JComboBox<File> jComboBox1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JToolBar jToolBar1;
    private com.jdcm.editors.P_Texte p_Texte1;
    private com.jdcm.editors.P_Texte p_Texte2;
    private com.jdcm.editors.P_Texte p_Texte3;
    // End of variables declaration//GEN-END:variables
}
