package com.jdcm.eltrx;

import com.jdcm.analyse.P_CodeEditor;
import com.jdcm.common.D_Utils;
import com.jdcm.diagram.P_Diagram;
import com.jdcm.charts.P_Stat_P;
import javax.swing.RowSorter;
import javax.swing.UIManager;
import javax.swing.JDialog;
import javax.swing.SortOrder;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.AbstractButton;
import javax.swing.JPanel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JFileChooser;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;
// pour UI
import java.beans.*;
import java.io.IOException;
import javax.swing.ButtonModel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.table.AbstractTableModel;
import javax.swing.tree.TreePath;

/**
 * Main_CX.java Created on 12 juillet 2006, 23:05
 *
 * UI Pad to receive ports, stacks, matrix, ...
 *
 * @author Marc GIBOIN
 */
public class F_Main extends javax.swing.JFrame {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    // for tables renders/editors
    private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editortree = new com.jdcm.editors.ACE_ObjEditor<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editorstack = new com.jdcm.editors.ACE_ObjEditor<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editorconf = new com.jdcm.editors.ACE_ObjEditor<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editormat = new com.jdcm.editors.ACE_ObjEditor<>();


    // for Main statisitcs Panel
    private P_Stat_P StackStat;
    private P_Stat_P MainStat;
    private P_Stat_P MatStat;
    // for Stack edition 
    private com.jdcm.editors.F_Compile<Class<? extends com.jdcm.modifiers.modif_base>> compiler = null;
    // PCom & PEth are panel for com and Eth interfaces listings
    private P_ComEth PComEth;

    private C_Main Parent = null;
    // for Opacity pointer
    java.awt.event.AWTEventListener awtListner = null;

    /**
     * Creates new form Main_CX
     *
     * @param P the Main supporting this UI
     */
    public F_Main(C_Main P) {
        //   System.out.println("F_Main(C_Main P) START");
        Parent = P;
        initialisation();
        //   System.out.println("F_Main(C_Main P) 1");
        setTitle(Parent.toString());
        if (!Parent.getPorts().isEmpty()) {
            displayPort(Parent.getPorts().get(0));
        }
    }

    private void manageDimension() {
        int width = 0;
        int height = 5;
        for (int i = 0; i < jPanel7.getComponentCount(); i++) {
            width += jPanel7.getComponent(i).getPreferredSize().width;
            height = jPanel7.getComponent(i).getPreferredSize().height;
        }
        jPanel7.setPreferredSize(new Dimension(width, height));
        jScrollPane8.setPreferredSize(new Dimension(jScrollPane8.getWidth(),
                height + 5 + jScrollPane8.getHorizontalScrollBar().getPreferredSize().height));
        repaint();

    }

    private void initialisation() {
        // graphic interface   (remove windows management => see for applet)
        setUndecorated(false);
        initComponents();
        InitLF();
        if (Parent != null && Parent.getoption("Main_Look") != null) {
            setLook(Parent.getoption("Main_Look").toString());
        }
        for (Window ownerlessWindow : javax.swing.JFrame.getOwnerlessWindows()) {
            if (ownerlessWindow instanceof java.applet.AppletContext) {
                this.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
            }
        }
        for (ButtonModel dbg_model : Parent.getdbg_model()) {
            javax.swing.JToggleButton toggle = new javax.swing.JToggleButton();
            toggle.setMargin(new java.awt.Insets(1, 5, 1, 5));
            toggle.setText(dbg_model.getActionCommand());
            toggle.setModel(dbg_model);
            toggle.addActionListener(new java.awt.event.ActionListener() {
                @Override
                public void actionPerformed(ActionEvent e) {
                    javax.swing.AbstractButton b = (javax.swing.AbstractButton) e.getSource();
                    b.setSelected(!b.isSelected());
                }
            });
            jPanel7.add(toggle);
        }
        manageDimension();
        checklib();
        //  jTree1.setOpaque(false);
        jTextField3.setVisible(false);
        jSpinner1.setVisible(false);
        jToggleButton22.setEnabled(false);
        jTextField6.setVisible(false);
        jCheckBox30.setBackground(java.awt.Color.DARK_GRAY);
        setIconImage(TUtils.getImage("Main_CX.gif"));
        jButton16.setIcon(TUtils.getIcon("Obj_edit.gif"));
        jButton27.setIcon(TUtils.getIcon("JTable.gif"));
        jButton19.setIcon(TUtils.getIcon("graph.gif"));
        jButton21.setIcon(TUtils.getIcon("Decode.gif"));
        jButton10.setIcon(TUtils.getIcon("DBsimple.gif"));
        jToggleButton24.setIcon(TUtils.getIcon("rename.gif"));
        jButton12.setIcon(TUtils.getIcon("Class.gif"));
        jToggleButton2.setIcon(TUtils.getIcon("transp_off.gif"));
        jToggleButton2.setSelectedIcon(TUtils.getIcon("transp_on.gif"));
        jToggleButton21.setIcon(TUtils.getIcon("play.gif"));
        jToggleButton21.setSelectedIcon(TUtils.getIcon("stop.gif"));
        jButton5.setIcon(TUtils.getIcon("down.gif"));
        jButton17.setIcon(TUtils.getIcon("up.gif"));
        jButton31.setIcon(TUtils.getIcon("Port_term.gif"));
        jMenuItem69.setIcon(TUtils.getIcon("com.gif"));
        jMenuItem70.setIcon(TUtils.getIcon("eth.gif"));
        jMenuItem71.setIcon(TUtils.getIcon("USB.gif"));
        jMenuItem4.setIcon(TUtils.getIcon("3d_on.gif"));
        jMenuItem1.setIcon(TUtils.getIcon("build_on.gif"));
        jToggleButton1.setIcon(TUtils.getIcon("Bt_off_CX.gif"));
        jToggleButton1.setSelectedIcon(TUtils.getIcon("Bt_on_CX.gif"));
        jToggleButton3.setIcon(TUtils.getIcon("panelMove.gif"));
        jToggleButton3.setSelectedIcon(TUtils.getIcon("panelFix.gif"));
        jToggleButton7.setIcon(TUtils.getIcon("oneport_on.gif"));
        jToggleButton7.setSelectedIcon(TUtils.getIcon("oneport_off.gif"));
        jToggleButton18.setIcon(TUtils.getIcon("Bt_off_CX.gif"));
        jToggleButton18.setSelectedIcon(TUtils.getIcon("Bt_on_CX.gif"));
        jToggleButton19.setIcon(TUtils.getIcon("eth.gif"));
        jToggleButton8.setIcon(TUtils.getIcon("shell.gif"));
        jToggleButton9.setIcon(TUtils.getIcon("mat_full.gif"));
        jToggleButton10.setIcon(TUtils.getIcon("mat_ring.gif"));
        jToggleButton11.setIcon(TUtils.getIcon("mat_off.gif"));
        jToggleButton12.setIcon(TUtils.getIcon("mat_bus.gif"));
        jToggleButton20.setIcon(TUtils.getIcon("mat_grp.gif"));
        jToggleButton13.setIcon(TUtils.getIcon("mat_free.gif"));
        jButton11.setIcon(TUtils.getIcon("Empty.gif"));
        jButton28.setIcon(TUtils.getIcon("Open.gif"));
        jToggleButton23.setIcon(TUtils.getIcon("traffic_off.gif"));
        jToggleButton23.setSelectedIcon(TUtils.getIcon("traffic_on.gif"));
        jToggleButton15.setIcon(TUtils.getIcon("Viewoff.gif"));
        jToggleButton15.setSelectedIcon(TUtils.getIcon("View.gif"));
        jButton13.setIcon(TUtils.getIcon("Save.gif"));
        jButton1.setIcon(TUtils.getIcon("Port_creating-50.gif"));
        jButton15.setIcon(TUtils.getIcon("Mach_new.gif"));
        jButton30.setIcon(TUtils.getIcon("Port_creating-50.gif"));
        jButton14.setIcon(TUtils.getIcon("Add.gif"));
        jToggleButton22.setIcon(TUtils.getIcon("rename.gif"));
        jButton22.setIcon(TUtils.getIcon("Remove.gif"));
        jButton23.setIcon(TUtils.getIcon("Socket.gif"));
        jButton24.setIcon(TUtils.getIcon("udp.gif"));
        jButton25.setIcon(TUtils.getIcon("icmp.gif"));
        jButton26.setIcon(TUtils.getIcon("pad.gif"));
        jToggleButton4.setIcon(TUtils.getIcon("Events.gif"));
        jToggleButton16.setIcon(TUtils.getIcon("play.gif"));
        jToggleButton16.setSelectedIcon(TUtils.getIcon("pause.gif"));
        jToggleButton17.setIcon(TUtils.getIcon("Add.gif"));
        jToggleButton17.setSelectedIcon(TUtils.getIcon("Remove.gif"));
        jButton2.setIcon(TUtils.getIcon("DB_table.gif"));
        jTabbedPane1.setIconAt(3, TUtils.getIcon("event.gif"));
        jTabbedPane1.setIconAt(2, TUtils.getIcon("Stacks.gif"));
        jTabbedPane1.setIconAt(1, TUtils.getIcon("Matrix.gif"));
        jTabbedPane1.setIconAt(0, TUtils.getIcon("Port.gif"));
        jTabbedPane1.setIconAt(4, TUtils.getIcon("View.gif"));
        jTabbedPane1.setIconAt(5, TUtils.getIcon("Obj_edit.gif"));
        jToggleButton16.setVisible(true);
        jTable3.setModel(Parent.getstack_model());
        if (Parent.getCMDChilds("Matrix").size() > 0) {
            jTable1.setModel(((T_Matrice) Parent.getCMDChilds("Matrix").get(0)).getmodel());
        }
        //MATRIX Table
        if (Parent.getmat_protos() != null) {
            jTable2.setModel(Parent.getmat_protos());
            jTable2.getColumnModel().getColumn(0).setCellRenderer(render);
            if (jTable2.getColumnCount() > 3) {
                jTable2.getColumnModel().getColumn(3).setCellRenderer(new F_MainRenderer());
                jTable2.getColumnModel().getColumn(3).setCellEditor(editormat);
            }
            jTable2.getColumnModel().getColumn(0).setPreferredWidth(150);
            jTable2.getColumnModel().getColumn(2).setPreferredWidth(400);
            jTable2.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
            // select activ Matrix
            String title = Parent.getMat_Type();
            for (int i = 0; i < jTable2.getRowCount(); i++) {
                if (jTable2.getValueAt(i, 0).toString().endsWith("mat_" + title)) {
                    jTable2.setRowSelectionInterval(i, i);
                }
            }
        }
        // CONFIG table
        jTable6.setModel(Parent.getconf_protos());
        jTable6.getColumnModel().getColumn(0).setCellRenderer(render);
        jTable6.getColumnModel().getColumn(3).setCellRenderer(new F_MainRenderer());
        jTable6.getColumnModel().getColumn(3).setCellEditor(editorconf);
        jTable6.getColumnModel().getColumn(2).setCellRenderer(render);
        jTable6.getColumnModel().getColumn(2).setCellEditor(editorconf);
        jTable6.getColumnModel().getColumn(0).setPreferredWidth(10);
        jTable6.getColumnModel().getColumn(1).setPreferredWidth(400);
        jTable6.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        // select active config
        if (Parent.getConf_Matrix() != null) {
            String title = Parent.getConf_Matrix().getTitle();
            for (int i = 0; i < jTable6.getRowCount(); i++) {
                if (jTable6.getValueAt(i, 1).toString().compareTo(title) == 0) {
                    jTable6.setRowSelectionInterval(i, i);
                }
            }
        }
        // could dis-allow multiple rows selection
        //STACKS Table
        jTable5.setModel(Parent.getstack_protos());
        java.util.List<RowSorter.SortKey> sortKeys = new ArrayList<>();
        sortKeys.add(new RowSorter.SortKey(1, SortOrder.ASCENDING));
        sortKeys.add(new RowSorter.SortKey(0, SortOrder.ASCENDING));
        jTable5.getRowSorter().setSortKeys(sortKeys);
        jTable5.getColumnModel().getColumn(0).setCellRenderer(render);
        if (jTable5.getColumnCount() > 3) {
            jTable5.getColumnModel().getColumn(3).setCellRenderer(new F_MainRenderer());
            jTable5.getColumnModel().getColumn(3).setCellEditor(editormat);
        }
        jTable5.getColumnModel().getColumn(0).setPreferredWidth(150);
        jTable5.getColumnModel().getColumn(2).setPreferredWidth(400);
        jTable5.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        //jTree1.setModel(new MainTreeModel(Parent));
        //jTree1.setModel(new javax.swing.tree.DefaultTreeModel(new javax.swing.tree.DefaultMutableTreeNode(Parent)));
        jTree1.setRootVisible(true);
        jTree1.setCellRenderer(render);
        jTree1.setCellEditor(editortree);
        ((MainTreeModel) jTree1.getModel()).fireTreeStructureChanged(Parent);
        setConsoleOut(Parent.isConsoleOut());
        setConsoleErr(Parent.isConsoleErr());
        p_Texte1.setAutoScroll(true);
        p_Texte1.setType("STREAM");
        TUtils.addTabedPane2Frame(jTabbedPane1);
        setPortsDisplayed(isPortsDisplayed());
        jToggleButton15.setSelected(Parent.isStackdebug());
        java.util.Enumeration<AbstractButton> buts = buttonGroup1.getElements();
        while (buts.hasMoreElements()) {
            AbstractButton but = buts.nextElement();
            if (Parent.getMat_Type() != null && Parent.getMat_Type().compareTo(but.getActionCommand()) == 0) {
                but.setSelected(true);
            }
        }
        refresh_table("Type", "Matr", null);
        p_Diagram1.setEvents(Parent.getConf_Matrix());
        jToggleButton1.setSelected(Parent.isConf_Enabled());
        jToggleButton2.setVisible(D_Utils.isOpacitySupported());
        setLockPanel(isLockPanel());
    }

    /**
     * manage the Port Edting Panel
     *
     * @param port the port to hide
     */
    public void hide_port(I_Port port) {
        if (port.getSkin() == null) {
            return;
        }
        if (java.util.Arrays.asList(jPanel2.getComponents()).indexOf(port.getSkin()) > 0) {
            port.getSkin().setVisible(false);
            jPanel2.remove(port.getSkin());
        }
        port.setSkin(null);
    }

    /**
     * manage the Port Edting Panel
     *
     * @param port the port to Display
     */
    final public void displayPort(I_Port port) {
        if (port.getcxstatus().startsWith("clos")) {
            return;
        }
        if (jTabbedPane1.getTitleAt(jTabbedPane1.getSelectedIndex()).startsWith("Ports") == false) {
            return;
        }
        java.awt.Point prev = null;
        if (jPanel2.getComponentCount() > 0 && isPortsDisplayed() == false) {
            if (jPanel2.getComponent(0) instanceof javax.swing.JInternalFrame) {
                prev = jPanel2.getComponent(0).getLocation();
            }
            jPanel2.removeAll();
        }
        // jPanel2.setPreferredSize(jPanel2.getParent().getPreferredSize());
        if (port.getSkin() != null) {
            if ((java.util.Arrays.asList(jPanel2.getComponents())).contains(port.getSkin()) == false) {
                jPanel2.add(port.getSkin());
            }
            port.getSkin().setVisible(true);
            if (isPortsDisplayed() == false) {
                if (prev == null) {
                    port.getSkin().setLocation(10, 5);
                    // port.getSkin().setBounds(10, 5, panel_width - 10, 300);
                } else {
                    port.getSkin().setLocation(prev);
                }
            }
        } else {
            java.awt.Component p_comp;
            if (port instanceof C_Port) {
                p_comp = new IF_Port((C_Port) port);
            } else if (port instanceof C_Machine) {
                p_comp = new IF_Machine((C_Machine) port);
            } else {
                return;
            }
            port.setSkin(p_comp);
            int xfarestpoint = 10;
            for (Component p : jPanel2.getComponents()) {
                xfarestpoint += p.getWidth() + 10;
            }
            xfarestpoint += p_comp.getWidth();
            if (xfarestpoint > jPanel2.getPreferredSize().width) {
                jPanel2.setPreferredSize(new java.awt.Dimension(xfarestpoint + 10, jPanel2.getPreferredSize().height));
            }
            jPanel2.add(p_comp);
            p_comp.doLayout();
        }
        jPanel2.repaint();
    }

    private void setLockPanel(boolean bool) {

        if (bool) {
            for (java.awt.Component c : jPanel2.getComponents()) {
                if (c instanceof IF_Port) {
                    ((IF_Port) c).setPortBounds(bool);
                } else if (c instanceof IF_Machine) {
                    ((IF_Machine) c).setPortBounds(bool);
                }
            }
            jPanel2.setLayout(new java.awt.GridLayout(1, 0));
        } else {
            jPanel2.setLayout(null);
            for (java.awt.Component c : jPanel2.getComponents()) {
                if (c instanceof IF_Port) {
                    ((IF_Port) c).setPortBounds(bool);
                } else if (c instanceof IF_Machine) {
                    ((IF_Machine) c).setPortBounds(bool);
                }
            }
        }
        jPanel2.doLayout();
        jPanel2.repaint();
    }

    private boolean isLockPanel() {
        return jToggleButton3.isSelected();
    }

    /**
     * Set the tab with title txt selected if not found, try to find the frame
     * with its name
     *
     * @param txt the title of the tab to select
     */
    public void setFocusTab(String txt) {
        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
            if (jTabbedPane1.getTitleAt(i).compareTo(txt) == 0) {
                jTabbedPane1.setSelectedIndex(i);
                return;
            }
        }
        for (java.awt.Frame f : java.awt.Frame.getFrames()) {
            if (f.getTitle().compareTo(txt) == 0) {
                f.requestFocus();
            }
        }
    }

    /**
     * Overwrite the setVisible() methode to manage the hide button
     *
     * @param bool
     */
    @Override
    public void setVisible(boolean bool) {
        //   System.out.println(" F_main.setVisible("+bool+")!");
        try {
            super.setVisible(bool);
        } catch (Exception ex) {
        }
        if (isVisible() != bool) {
            jCheckBoxMenuItem7.setSelected(bool == false);
        }
    }

    /**
     * Manage UI for Look & Feel
     */
    public void InitLF() {
        for (UIManager.LookAndFeelInfo installedLookAndFeel : UIManager.getInstalledLookAndFeels()) {
            String lfName = installedLookAndFeel.getName();
            Enumeration<AbstractButton> e = buttonGroup_Menu.getElements();
            boolean found = false;
            while (e.hasMoreElements()) {
                if (e.nextElement().getText().compareTo(lfName) == 0) {
                    found = true;
                }
            }
            if (found == false) {
                JRadioButtonMenuItem jm = new JRadioButtonMenuItem(lfName);
                buttonGroup_Menu.add(jm);
                jm.addActionListener(new java.awt.event.ActionListener() {
                    @Override
                    public void actionPerformed(java.awt.event.ActionEvent evt) {
                        setLook(evt.getActionCommand());
                    }
                });
                jMenu19.add(jm);
            }
        }
        try {
            UIManager.put("swing.boldMetal", Boolean.FALSE);
            Toolkit.getDefaultToolkit().setDynamicLayout(true);
            JDialog.setDefaultLookAndFeelDecorated(true);
            JFrame.setDefaultLookAndFeelDecorated(true);
            // getRootPane().setWindowDecorationStyle(JRootPane.FRAME);
            UIManager.addPropertyChangeListener(new UISwitchListener((JComponent) getRootPane()));
        } catch (HeadlessException ex) {
            System.err.println("initLF()=>" + ex.getMessage());
        }
    }

    @Override
    public String toString() {
        return this.getTitle();
    }

    private void setPortsDisplayed(boolean bool) {
        if (isPortsDisplayed() != bool) {
            jToggleButton7.setSelected(bool);
        }
        if (bool) {
            jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
            jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
        } else {
            jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);

        }
        jPanel2.removeAll();
        jPanel2.setLayout(new java.awt.FlowLayout(10, 10, 2));
        if (bool) {
            for (I_Port p : Parent.getPorts()) {
                p.setSkin(null);
                displayPort(p);
            }
        } else {
            if (Parent.getPorts().size() > 0) {
                displayPort(Parent.getPorts().get(0));
            }
            jTree1MouseReleased(null);
        }
        jPanel2.doLayout();
        jPanel2.repaint();
    }
    // public because Main need to know if display is needed for creation.

    public boolean isPortsDisplayed() {
        return jToggleButton7.isSelected();
    }

    public String getLook() {
        return UIManager.getLookAndFeel().getName();
    }

    public void setLook(String model) {
        if (Parent != null && Parent instanceof C_Main) {
            Parent.setMain_Look(model);
        }
        Enumeration<AbstractButton> r = buttonGroup_Menu.getElements();
        while (r.hasMoreElements()) {
            AbstractButton b = r.nextElement();
            if (b.getText().compareTo(model) == 0 && b.isSelected() == false) {
                b.setSelected(true);
            }
        }

        if (Parent != null && Parent instanceof C_Main) {
            Parent.setMain_Look(UIManager.getLookAndFeel().getName());
        }
        manageDimension();
    }

    @Override
    public boolean isVisible() {
        return super.isVisible();
    }

    public void stat_add(I_Port p, boolean isMain) {
        if (isMain && MainStat != null) {
            MainStat.addPort(p);
        } else if (StackStat != null && isMain == false) {
            StackStat.addPort(p);
        }
    }

    public void stat_storeTerm(com.jdcm.common.C_Packet pack) {
        if (MatStat != null) {
            MatStat.store(pack);
        }
    }

    /**
     *
     * @param pack
     * @param isext
     * @param isMain
     */
    public void stat_storeTerm(com.jdcm.common.C_Packet pack, boolean isext, boolean isMain) {
        if (StackStat != null && isMain == false) {
            StackStat.store(pack, isext);
        } else if (MainStat != null && isMain) {
            MainStat.store(pack, isext);
        }
    }

    public void stat_storeCurb(com.jdcm.common.C_Packet pack, boolean isext, boolean isMain) {

        //-------------------------for the curbe --------------------     
        I_Port p = null;
        String txt = pack.getObj().getClass().getSimpleName();
        int size = 1;
        if (pack.getBytes() != null) {
            size = pack.getBytes().length;
            txt = "byte[" + size + "]";
        }
        try {
            if (pack.getdestination() == null) {
                p = pack.getsource();
            } else {
                p = pack.getdestination();
                size = -size;
            }
        } catch (Exception ex) {
            //
        }
        if (p != null) {
            if (isMain == false && StackStat != null) {
                StackStat.store(p.getPortName(), size, txt + " writed to interface");
            } else if (isMain && MainStat != null) {
                MainStat.store(p.getPortName(), size, txt + " writed to interface");
            }
        }
    }

    public void checklib() {
        jMenuItem69.setEnabled(Parent.getmedias().contains("Serial") == false);
        jMenuItem70.setEnabled(Parent.getmedias().contains("ETH") == false);
        jMenuItem71.setEnabled(Parent.getmedias().contains("USB") == false);
        jMenuItem1.setEnabled(Parent.getmedias().contains("TOOL") == false);
        jMenuItem4.setEnabled(Parent.getmedias().contains("3D") == false);
        jMenuItem5.setEnabled(Parent.getmedias().contains("JNA") == false);
        for (int i = 0; i < jMenu22.getItemCount(); i++) {
            String dbname = jMenu22.getItem(i).getText();
            jMenu22.getItem(i).setEnabled(Parent.getmedias().contains(dbname) == false);
        }
    }


    /*
     * Manage menu
     *
     */
    public boolean isStack_Stat() {
        return StackStat != null;
    }

    public void setStack_Stat(boolean bool) {
        if (bool != isStack_Stat()) {
            StackStat = setStat(StackStat, "Stacks");
            Parent.setStack_Stat(bool);
        }
    }

    public boolean isMat_Stat() {
        return MatStat != null;
    }

    public void setMat_Stat(boolean bool) {
        if (bool != isMat_Stat()) {
            MatStat = setStat(MatStat, "Matr.");
            Parent.setMat_Stat(bool);
            //   jToggleButton23.repaint();
        }
    }

    public boolean isMain_Stat() {
        return Parent.isMain_Stat();
    }

    public void setMain_Stat(boolean bool) {
        if (bool != isMain_Stat()) {
            MainStat = setStat(MainStat, "Main");
            Parent.setMain_Stat(bool);
        }
    }

    private P_Stat_P setStat(P_Stat_P pstat, String title) {
        if (pstat == null) {
            pstat = new P_Stat_P(Parent);
            pstat.setVisible(true);
            pstat.setStatsColumns(title);
            addTab((javax.swing.JPanel) pstat, title, TUtils.getIcon("traffic_on.gif"));
        } else {
            pstat.setVisible(false);
            removeTab(pstat);
            pstat = null;
        }
        if (getTreeSelection() instanceof C_Stack) {
            jToggleButton23.setSelected(pstat != null);
        }
        return pstat;
    }
    /*
     * set or return if a shell display (see CLI Machine) is open
     *
     */

    public boolean isShell() {
        return jToggleButton8.isSelected();
    }

    public void setShell(boolean bool) {
        if (bool != isShell()) {
            jToggleButton8.setSelected(bool);
        }
        if (bool != Parent.isShell()) {
            Parent.setShell(bool, "Term");
        }
    }

    /*
     * set or return if a system access Panel is display
     *
     */
    public boolean isPComEth() {
        return jToggleButton19.isSelected();
    }

    private void setPComEth(boolean bool) {
        if (bool != isPComEth()) {
            jToggleButton19.setSelected(bool);
        }
        if (bool) {
            PComEth = new P_ComEth();
            PComEth.setVisible(true);
            addTab((javax.swing.JPanel) PComEth, "Eth/Com Interfaces", TUtils.getIcon("eth.gif"));
            jTabbedPane1.setSelectedComponent(PComEth);
        } else {
            PComEth.setVisible(false);
            removeTab(PComEth);
            PComEth = null;
        }

    }

    /*
     * a sub-program to display Tcpdump trace in a terminal
     *
     */
    private void DisplayCapture(java.io.File filename) {
        if (filename == null) {
            return;
        }
        // old one with DESC : Parent.DisplayCapture2(null, filename);
        Parent.DisplayCapture2(null, filename);
    }


    /*
     * Save all debug mesages in a text file
     *
     */
    public boolean ispacket() {
        return jToggleButton6.isSelected();
    }

    public void setpacket(boolean bool) {
        if (ispacket() != bool) {
            jToggleButton6.setSelected(bool);
        }
        if (Parent.ispacket() != bool) {
            Parent.setpacket(bool);
        }
    }

    public void setpackval(String filename) {
        if (ispacket()) {
            javax.swing.JOptionPane.showMessageDialog(this, "Packet is already running, stop it before changing file", "Packet file", javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }
        if (filename.compareTo(jTextField5.getText()) != 0) {
            jTextField5.setText(filename);
        }
        Parent.setpackval(filename);
    }

    /*
     * Manage systems Out & err Streams
     *
     */
    public void setConsoleOut(boolean bool) {
        if (jToggleButton26.isSelected() != bool) {
            jToggleButton26.setSelected(bool);
        }
        if (Parent.isConsoleOut() != bool) {
            Parent.setConsoleOut(bool);
        }
        if (bool) {
            Parent.addTextPaneConsole(p_Texte1.getTextePane());
        } else {
        }
    }

    public void setConsoleErr(boolean bool) {
        if (jToggleButton25.isSelected() != bool) {
            jToggleButton25.setSelected(bool);
        }
        if (Parent.isConsoleErr() != bool) {
            Parent.setConsoleErr(bool);
        }
        if (bool) {
            Parent.addTextPaneConsole(p_Texte1.getTextePane());
        }
    }

    public boolean isStack_Enabled() {
        return jCheckBox30.isSelected();
    }

    public void setStack_Enabled(boolean bool) {
        if (isStack_Enabled() != bool) {
            jCheckBox30.setSelected(bool);
        }
        if (Parent.isStack_Enabled() != bool) {
            Parent.setStack_Enabled(bool);
        }
        if (bool) {
            jCheckBox30.setBackground(java.awt.Color.GREEN);
            ((MainTreeModel) jTree1.getModel()).add(Parent.getCMDChilds("Stacks").get(0));
        } else {
            jCheckBox30.setBackground(java.awt.Color.DARK_GRAY);
            ((MainTreeModel) jTree1.getModel()).remove(Parent.getCMDChilds("Stacks").get(0));
        }
        jTable3.repaint();
    }
    /*
     * Manage config file
     */

    public void setXMLfile(String txt) {
        if (txt == null) {
            return;
        }
        for (int i = 0; i < jTable6.getRowCount(); i++) {
            java.io.File f = (java.io.File) jTable6.getValueAt(i, 0);
            if (f.getName().compareTo(txt) == 0 || f.getName().compareTo(txt + ".xml") == 0) {
                jTable6.getSelectionModel().setSelectionInterval(i, i);
                return;
            }
        }

        if (txt.compareTo(Parent.getConf_Name()) != 0) {
            Parent.setConf_File(txt);
        }
    }

    public com.jdcm.diagram.A_Events getConf_Event() {
        return p_Diagram1.getEvents();
    }

    public void setConf_Event(com.jdcm.diagram.A_Events evt) {
        jToggleButton1.setEnabled(evt != null);
        jToggleButton16.setEnabled(Parent.isConf_Enabled());
        p_Diagram1.setEvents(evt);
    }

    public void setConf_Enabled(boolean bool) {
        // care null is for stop config
        jTable6.setEnabled(bool == false);
        jToggleButton16.setEnabled(bool);
        if (jToggleButton1.isSelected() != bool) {
            jToggleButton1.setSelected(bool);
        }
        if (jToggleButton18.isSelected() != bool) {
            jToggleButton18.setSelected(bool);
        }
        if (jCheckBoxMenuItem6.isSelected() != bool) {
            jCheckBoxMenuItem6.setSelected(bool);
        }
        for (I_Command conf : Parent.getCMDChilds("Conf")) {
            if (bool) {
                ((MainTreeModel) jTree1.getModel()).add(conf);
            } else {
                jToggleButton4.setSelected(bool);
                ((MainTreeModel) jTree1.getModel()).remove(conf);
            }
        }
        jTable6.setEnabled(bool == false);
        if (Parent.isConf_Enabled() != bool) {
            Parent.setConf_Enabled(bool);
        }

        if (bool) {
            p_Diagram1.setHisto(p_Diagram1.getEvents().isHisto());
        }
    }

    private String getXMLfile() {
        if (jTable6.getSelectedRow() == -1) {
            return null;
        }
        return jTable6.getValueAt(jTable6.getSelectedRow(), 0).toString();
    }

    private void openXMLconfig() {
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        if (ch.showDialog(this, "Open") == javax.swing.JFileChooser.APPROVE_OPTION) {
            java.io.File fi = ch.getSelectedFile();
            Parent.setConf_File(fi);
        }
    }
    /*
     * Manage buttom part
     */

    public void UpdateUI() {
        this.jPanel2.updateUI();
    }

    public javax.swing.JFrame getframe() {
        return (javax.swing.JFrame) this;
    }

    public void selectPort(I_Port p) {
        //---------------------MAJ TREE---------------------------------------
        if (jTree1.getSelectionPath() == null || (p != null && p.equals(jTree1.getSelectionPath().getLastPathComponent())) == false) {
            Object r = jTree1.getModel().getRoot();
            for (int i = 0; i < jTree1.getModel().getChildCount(r); i++) {
                Object port = jTree1.getModel().getChild(r, i);
                if (port.equals(p)) {
                    javax.swing.tree.TreePath path = new javax.swing.tree.TreePath(new Object[]{r, port});
                    jTree1.setSelectionPath(path);
                }
            }
        }
        jTree1MouseReleased(null);
    }

    private void refresh_mxstack(String name, String unSelectedCabs) {
        if (unSelectedCabs.contains(name) == false) {//then selected or in PopUp Frame
            javax.swing.JTable table;
            if (name.compareTo("Stack") == 0) {
                table = jTable3;
            } else if (name.compareTo("Matrix") == 0) {
                table = jTable1;
            } else {
                return;
            }
            ((AbstractTableModel) table.getModel()).fireTableStructureChanged();
            ((AbstractTableModel) table.getModel()).fireTableDataChanged();
            for (int i = 0; i < table.getColumnCount(); i++) {
                if (i == 0 || name.compareTo("Stack") == 0) {
                    table.getColumnModel().getColumn(i).setCellRenderer(new Module_ObjRenderer(jCheckBox30));
                }
                if (name.compareTo("Matrix") == 0) {
                    if (i != 0) {
                        table.getColumnModel().getColumn(i).setCellRenderer(render);
                    }
                    table.getColumnModel().getColumn(i).setCellEditor(editormat);
                } else if (name.compareTo("Stack") == 0) {
                    table.getColumnModel().getColumn(i).setCellEditor(editorstack);
                }
            }
        }
    }

    public void refresh_table(String type, String message, I_Port p) {
        String cabsUnselected = "";
        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
            if (i != jTabbedPane1.getSelectedIndex()) {
                cabsUnselected += jTabbedPane1.getTitleAt(i) + "/";
            }
        }
        try {
            if (type.startsWith("Status") && message.startsWith("Mat_")) {
                java.util.List<I_Command> list = Parent.getCMDChilds("Matrix");
                if (list.isEmpty() == false && list.get(0) instanceof T_Matrice) {
                    if (message.startsWith("Mat_Echo")) {
                        jToggleButton14.setSelected(((T_Matrice) list.get(0)).isMat_Echo());
                    } else if (message.startsWith("Mat_Bidir")) {
                        jToggleButton5.setSelected(((T_Matrice) list.get(0)).isMat_Bidir());
                    }
                }
            }
            if (type.startsWith("move")) {
                refresh_mxstack("Matrix", cabsUnselected);
                refresh_mxstack("Stack", cabsUnselected);
                type = "Type";
                message = "Matr";

            }
            if (type.startsWith("Status") && p != null) {
                if (p == getTreeSelection()) {
                    jToggleButton21.setSelected((message.startsWith("stop") || message.startsWith("err")) == false);
                }
            }
            if (type.startsWith("Status") && (message.startsWith("creating") || message.startsWith("removed"))) {
                if (message.startsWith("creating") && p != null) {
                    ((MainTreeModel) jTree1.getModel()).add(p);
                } else if (message.startsWith("removed") && p != null) {
                    ((MainTreeModel) jTree1.getModel()).remove(p);
                    jTree1.repaint();
                }
            } else if (type.startsWith("Type")) {
                if (message.startsWith("Matr") || message.startsWith("PortName")) {
                    if (MainStat != null && message.startsWith("PortName")) {
                        MainStat.changePortName(p);
                    }
                    if (p instanceof C_Port && ((C_Port) p).getPort_Stat() != null) {
                        // Update Stat Tab Titles
                        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
                            if (jTabbedPane1.getComponentAt(i) == ((C_Port) p).getPort_Stat()) {
                                jTabbedPane1.setTitleAt(i, p.getPortName());
                            }
                        }
                    }
                    if (message.startsWith("Matr")) {
                        ((MainTreeModel) jTree1.getModel()).fireTreeStructureChanged(Parent);
                        if (this.buttonGroup1.getSelection().getActionCommand().startsWith(Parent.getMat_Type()) == false) {
                            Enumeration<AbstractButton> en = buttonGroup1.getElements();
                            while (en.hasMoreElements()) {
                                AbstractButton b = en.nextElement();
                                if (b.getActionCommand().startsWith(Parent.getMat_Type())) {
                                    this.buttonGroup1.setSelected(b.getModel(), true);
                                }
                            }
                        }
                    }

                    boolean bool = Parent.getMat_Type().startsWith("FREE");
                    jToggleButton14.setEnabled(!bool);
                    jToggleButton5.setEnabled(bool);
                }
                //STACK & MATRIX TABLE
                refresh_mxstack("Matrix", cabsUnselected);
                refresh_mxstack("Stack", cabsUnselected);
                // echo/bidir/Mattype => Type...
                jTree1.repaint();
                jTable1.repaint();
            } else {
                if (jTree1.isEditing()) {
                    jTree1.stopEditing();
                }
                jTree1.repaint();
            }
            if ((type.startsWith("Status") && (message.startsWith("creating") || message.startsWith("removed")))
                    || (type.startsWith("Type") && message.startsWith("Matr"))) {
                ((MainTreeModel) jTree1.getModel()).fireTreeStructureChanged(Parent);
                //STACK & MATRIX TABLE
                refresh_mxstack("Matrix", cabsUnselected);
                refresh_mxstack("Stack", cabsUnselected);
            }
            if (PComEth != null) {
                PComEth.repaint();
            }
            updateTreeToolbar();
            //?? to be checked
            // Parent.UpdateDatas(jTable3.getSelectedRow(), jTable3.getSelectedColumn());
        } catch (Exception ex) {
            // ex.printStackTrace();
            // to avoid Pb this is just graphical
            //....table.DefaultTableColumnModel.getColumn(DefaultTableColumnModel.java:294)

            System.err.println("graphical error while refreshing tables");
        }
    }

    /**
     * Remove all Ports<br> - check/stop XML config - ask to end each ports.
     */
    private void removeallCX() {
        if (Parent.isConf_Enabled()) {
            if (this.isVisible()) {
                if (1 == javax.swing.JOptionPane.showConfirmDialog(this, "A configuration is started \r\n Do you want to stop it ?", "Configuration is running...", javax.swing.JOptionPane.YES_NO_OPTION)) {
                    return;
                }
            }
            Parent.setConf_Enabled(false);
        }
        Parent.CXremoveAll();
    }

    /*
     * Manage console
     *
     */
    private void clearconsole() {
        p_Texte1.setText("");
    }

    /**
     * Add a cab for stat/...
     *
     * @param paneltoTab pannel to Add as tab
     * @param tabtitle of the cab
     * @param i icon of the cab
     *
     */
    public void addTab(JPanel paneltoTab, String tabtitle, javax.swing.Icon i) {
        String title = tabtitle;
        if (title == null) {
            title = "New";
        }
        jTabbedPane1.add(title, paneltoTab);
        if (i != null) {
            jTabbedPane1.setIconAt(jTabbedPane1.getTabCount() - 1, i);
        }

    }

    private void addSelectedStacks() {
        int[] idxs = new int[jTable5.getSelectedRows().length];
        for (int i = 0; i < jTable5.getSelectedRows().length; i++) {
            idxs[i] = jTable5.getRowSorter().convertRowIndexToModel(jTable5.getSelectedRows()[i]);
        }
        Parent.addStacks(idxs, jTable3.getSelectedRow(), jTable3.getSelectedColumn());
        // jButton2.setEnabled(true);
        //  jToggleButton22.setEnabled(true);
    }

    private void renameSelectedStack() {

        Parent.renameStack(jTable3.getSelectedRow(), jTable3.getSelectedColumn());
    }
    /*
     * public void UpdateDatas() { jTable3.repaint(); int row =
     * jTable3.getSelectedRow(); int col = jTable3.getSelectedColumn(); if (col
     * < 0 || row < 0) { jTable4.setModel(new
     * javax.swing.table.DefaultTableModel(new Object[]{"no selection",
     * "Values"}, 0)); return; } Object o = jTable3.getValueAt(row, col); if (o
     * == null || o instanceof String) { jTable4.setModel(new
     * javax.swing.table.DefaultTableModel(new Object[]{"no module", "Values"},
     * 0)); return; } if (o instanceof com.jdcm.modifiers.I_stack_elt) {
     * jTable4.setModel(((com.jdcm.modifiers.I_stack_elt) o).getoptions()); }
     * for (int i = 0; i < jTable4.getColumnCount(); i++) {
     * jTable4.getColumn(jTable4.getColumnName(i)).setCellRenderer(new
     * com.jdcm.editors.ACE_ObjRenderer());
     * jTable4.getColumn(jTable4.getColumnName(i)).setCellEditor(new
     * com.jdcm.editors.ACE_ObjEditor()); } }
     */

    /**
     * Remove a cab
     *
     * @param p panel to remove
     */
    public void removeTab(JPanel p) {
        if (p != null && p.getAccessibleContext() != null) {
            if (java.util.Arrays.asList(jTabbedPane1.getComponents()).indexOf(p) >= 0) {
                jTabbedPane1.remove(p);
                setFocusTab("Ports");
            } else {
                for (Frame comp : Frame.getFrames()) {
                    if (("DOCK:" + comp.getTitle()).compareTo(p.getAccessibleContext().getAccessibleName()) == 0) {
                        comp.setVisible(false);
                        comp.removeNotify();
                    }
                }
            }
        }
    }

    public String getCompilerCode() {
        if (compiler != null) {
            return compiler.getAllCode();
        }
        return null;
    }

    public Object getCompilerResult() {
        if (compiler != null) {
            return compiler.getResult();
        }
        return null;
    }

    public void setCompiler(java.io.File f) {

        if (compiler == null && f != null) {
            compiler = new com.jdcm.editors.F_Compile<>(f);
            compiler.setVisible(true);
        } else {
        }
    }

    public void setCompiler(String txt) {

        if (compiler == null && txt != null) {
            compiler = new com.jdcm.editors.F_Compile<>(txt);
            compiler.setVisible(true);
        } else if (compiler != null) {
            Class<? extends com.jdcm.modifiers.modif_base> cl;
            if (compiler.getResult() instanceof Class) {
                try {
                    cl = (Class<? extends com.jdcm.modifiers.modif_base>) compiler.getResult();
                    //this.getClass().getClassLoader().
                    // if class name is/has been loaded => no way(?!) to "overwrite" this class (delete & reload)
                    Parent.addModifier(cl, this.getCompilerCode());
                    if (cl.getSuperclass() == com.jdcm.modifiers.stacks.Stack_base.class) {
                        //   Parent.addStack(cl, this.getCompilerCode());
                        com.jdcm.modifiers.stacks.I_stack_elt o = (com.jdcm.modifiers.stacks.I_stack_elt) cl.newInstance();
                        if (o instanceof com.jdcm.modifiers.stacks.Stack_base) {
                            ((com.jdcm.modifiers.stacks.Stack_base) o).setCode(compiler.getAllCode());
                        }
                        try {
                            java.io.FileOutputStream f = new java.io.FileOutputStream(o.getClass().getSimpleName());
                            f.write(compiler.getAllCode().getBytes());
                        } catch (IOException ex) {
                        }
                        Parent.addStack(o, jTable3.getSelectedRow(), jTable3.getSelectedColumn());
                        //  Parent.addStack((Class<? extends com.jdcm.modifiers.I_stack_elt>) cl, jTable3.getSelectedRow(), jTable3.getSelectedColumn());
                    }
                } catch (InstantiationException | IllegalAccessException ex) {
                }
            }
            compiler.setVisible(false);
            compiler = null;
        }
    }

    /**
     * for global tree update & reterive data
     *
     * @return could be ports or Machine or Main or stack ... <br>null if
     * nothing selected
     */
    private Object getTreeSelection() {
        if (jTree1.getSelectionPath() == null) {
            return null;
        }
        Object node = jTree1.getSelectionPath().getLastPathComponent();
        return node;
    }

    private void setTreeSelection(Object treeelt) {
        Object root = jTree1.getModel().getRoot();
        javax.swing.tree.TreePath tp = null;
        if (treeelt == Parent) {
            tp = new javax.swing.tree.TreePath(new Object[]{root});
        } else {
            //recurssif should be better but 1 levels selected only (todays) (see slibbing nodes...)
            for (int n = 0; n < jTree1.getModel().getChildCount(root); n++) {
                Object obj = jTree1.getModel().getChild(root, n);
                if (obj == treeelt) {
                    tp = new javax.swing.tree.TreePath(new Object[]{root, obj});
                }
            }
        }
        if (tp != null) {
            jTree1.setSelectionPath(tp);
            updateTreeToolbar();
        }
    }

    private void updateTreeToolbar() {
        jToggleButton21.setEnabled(false);
        jToggleButton23.setEnabled(false);
        jButton17.setEnabled(false);
        jButton5.setEnabled(false);
        jToggleButton24.setEnabled(false);
        Object node = getTreeSelection();
        if (node == null) {
            return;
        }
        /*
         * if (evt != null &&
         * jTree1.getPathBounds(jTree1.getSelectionPath()).contains(evt.getPoint())
         * == false) { jTree1.clearSelection(); return; }
         */
        if (node instanceof I_Port) {
            // setFocusTab("Ports");
            displayPort((I_Port) node);
            jToggleButton23.setEnabled(true);
            jToggleButton24.setEnabled(true);
            jToggleButton23.setSelected(((I_Port) node).isPort_Stat());
            jToggleButton21.setEnabled(true);
            if (Parent.getPorts().get(0).equals(node) == false) {
                jButton17.setEnabled(true);
            }
            if (Parent.getPorts().get(Parent.getPorts().size() - 1).equals(node) == false) {
                jButton5.setEnabled(true);
            }
            String txt = ((I_Port) node).getcxstatus();
            jToggleButton21.setSelected((txt.startsWith("stop") || txt.startsWith("err") || txt.startsWith("crea")) == false);
        } else if (node instanceof C_Main) {
            jToggleButton24.setEnabled(true);
            jToggleButton23.setEnabled(true);
            jToggleButton23.setSelected(isMain_Stat());
        } else if (node instanceof C_Stack) {
            setFocusTab("Stack");
            jToggleButton23.setEnabled(true);
            jToggleButton23.setSelected(isStack_Stat());
        } else if (node instanceof T_Matrice) {
            setFocusTab("Matrix");
            jToggleButton23.setEnabled(true);
            jToggleButton23.setSelected(isMat_Stat());
        } else if (node instanceof T_CONF && jTabbedPane1.indexOfTab("Conf") >= 0) {
            jTabbedPane1.setSelectedIndex(jTabbedPane1.indexOfTab("Conf"));
        } else if (node instanceof F_Terminal) {
            ((F_Terminal) node).requestFocus();
        }
    }

    public void removeStack(com.jdcm.modifiers.stacks.I_stack_elt stack) {
        for (java.awt.Frame f : javax.swing.JFrame.getFrames()) {
            // should be better by checking the option Parent or the content= stack inside the frame..
            if (f instanceof JFrame && f.getTitle().compareTo(stack.toString()) == 0) {
                f.setVisible(false);
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem53 = new javax.swing.JMenuItem();
        jMenuItem54 = new javax.swing.JMenuItem();
        jMenuItem55 = new javax.swing.JMenuItem();
        buttonGroup1 = new javax.swing.ButtonGroup();
        jToolBar5 = new javax.swing.JToolBar();
        jToolBar6 = new javax.swing.JToolBar();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTable4 = new javax.swing.JTable();
        buttonGroup_Menu = new javax.swing.ButtonGroup();
        jToolBar1 = new javax.swing.JToolBar();
        jButton11 = new javax.swing.JButton();
        jButton30 = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JSeparator();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton8 = new javax.swing.JToggleButton();
        jSeparator8 = new javax.swing.JToolBar.Separator();
        jButton28 = new javax.swing.JButton();
        jToggleButton19 = new javax.swing.JToggleButton();
        jSeparator5 = new javax.swing.JToolBar.Separator();
        jToggleButton2 = new javax.swing.JToggleButton();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel12 = new javax.swing.JPanel();
        jToolBar8 = new javax.swing.JToolBar();
        jToggleButton21 = new javax.swing.JToggleButton();
        jButton5 = new javax.swing.JButton();
        jButton17 = new javax.swing.JButton();
        jToggleButton23 = new javax.swing.JToggleButton();
        jTextField6 = new javax.swing.JTextField();
        jToggleButton24 = new javax.swing.JToggleButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel9 = new javax.swing.JPanel();
        jToolBar7 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jButton15 = new javax.swing.JButton();
        jButton31 = new javax.swing.JButton();
        jSeparator9 = new javax.swing.JToolBar.Separator();
        jToggleButton7 = new javax.swing.JToggleButton();
        jToggleButton3 = new javax.swing.JToggleButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel2 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jToolBar2 = new javax.swing.JToolBar();
        jToggleButton14 = new javax.swing.JToggleButton();
        jToggleButton5 = new javax.swing.JToggleButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        jToggleButton11 = new javax.swing.JToggleButton();
        jToggleButton10 = new javax.swing.JToggleButton();
        jToggleButton9 = new javax.swing.JToggleButton();
        jToggleButton12 = new javax.swing.JToggleButton();
        jToggleButton13 = new javax.swing.JToggleButton();
        jToggleButton20 = new javax.swing.JToggleButton();
        jSplitPane3 = new javax.swing.JSplitPane();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jPanel6 = new javax.swing.JPanel();
        jToolBar3 = new javax.swing.JToolBar();
        jCheckBox30 = new javax.swing.JCheckBox();
        jSeparator7 = new javax.swing.JToolBar.Separator();
        jButton14 = new javax.swing.JButton();
        jButton22 = new javax.swing.JButton();
        jToggleButton22 = new javax.swing.JToggleButton();
        jButton2 = new javax.swing.JButton();
        jTextField3 = new javax.swing.JTextField();
        jSpinner1 = new javax.swing.JSpinner();
        jSeparator4 = new javax.swing.JToolBar.Separator();
        jButton24 = new javax.swing.JButton();
        jButton23 = new javax.swing.JButton();
        jButton25 = new javax.swing.JButton();
        jButton26 = new javax.swing.JButton();
        jSeparator6 = new javax.swing.JToolBar.Separator();
        jToggleButton15 = new javax.swing.JToggleButton();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTable5 = new javax.swing.JTable();
        jPanel11 = new javax.swing.JPanel();
        jToolBar4 = new javax.swing.JToolBar();
        jToggleButton18 = new javax.swing.JToggleButton();
        jToggleButton16 = new javax.swing.JToggleButton();
        jToggleButton17 = new javax.swing.JToggleButton();
        jSplitPane4 = new javax.swing.JSplitPane();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTable6 = new javax.swing.JTable();
        p_Diagram1 = new com.jdcm.diagram.P_Diagram();
        jPanel4 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jPanel7 = new javax.swing.JPanel();
        jPanel16 = new javax.swing.JPanel();
        jButton4 = new javax.swing.JButton();
        jToggleButton26 = new javax.swing.JToggleButton();
        jToggleButton25 = new javax.swing.JToggleButton();
        jPanel13 = new javax.swing.JPanel();
        jButton7 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        p_Texte1 = new com.jdcm.editors.P_Texte();
        jPanel3 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel14 = new javax.swing.JPanel();
        jButton12 = new javax.swing.JButton();
        jToggleButton4 = new javax.swing.JToggleButton();
        jButton21 = new javax.swing.JButton();
        jButton10 = new javax.swing.JButton();
        jPanel15 = new javax.swing.JPanel();
        jButton27 = new javax.swing.JButton();
        jButton19 = new javax.swing.JButton();
        jButton16 = new javax.swing.JButton();
        jButton18 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jToggleButton6 = new javax.swing.JToggleButton();
        jTextField5 = new javax.swing.JTextField();
        jButton13 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jMenuBar6 = new javax.swing.JMenuBar();
        jMenu17 = new javax.swing.JMenu();
        jMenuItem56 = new javax.swing.JMenuItem();
        jMenuItem57 = new javax.swing.JMenuItem();
        jMenuItem58 = new javax.swing.JMenuItem();
        jMenu21 = new javax.swing.JMenu();
        jMenuItem69 = new javax.swing.JMenuItem();
        jMenuItem70 = new javax.swing.JMenuItem();
        jMenuItem71 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenu22 = new javax.swing.JMenu();
        jMenuItem73 = new javax.swing.JMenuItem();
        jMenuItem74 = new javax.swing.JMenuItem();
        jMenuItem75 = new javax.swing.JMenuItem();
        jMenuItem76 = new javax.swing.JMenuItem();
        jMenuItem77 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenu18 = new javax.swing.JMenu();
        jMenuItem59 = new javax.swing.JMenuItem();
        jMenuItem60 = new javax.swing.JMenuItem();
        jCheckBoxMenuItem6 = new javax.swing.JCheckBoxMenuItem();
        jMenu19 = new javax.swing.JMenu();
        jCheckBoxMenuItem7 = new javax.swing.JCheckBoxMenuItem();
        jMenu20 = new javax.swing.JMenu();
        jMenuItem68 = new javax.swing.JMenuItem();

        jMenuItem53.setText("Set all debug");
        jMenuItem53.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem13ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem53);

        jMenuItem54.setText("Clear alll debug");
        jMenuItem54.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem14ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem54);

        jMenuItem55.setText("Clear console");
        jMenuItem55.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem12ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem55);

        jToolBar5.setRollover(true);

        jToolBar6.setRollover(true);

        jTable4.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane7.setViewportView(jTable4);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("JDataCom-0.287");
        setPreferredSize(new java.awt.Dimension(650, 470));
        setState(3);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jToolBar1.setName("JDataCom toolbar"); // NOI18N

        jButton11.setToolTipText("Clear All");
        jButton11.setAlignmentY(0.2F);
        jButton11.setBorderPainted(false);
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton11);

        jButton30.setToolTipText("new Port");
        jButton30.setAlignmentY(0.2F);
        jButton30.setBorderPainted(false);
        jButton30.setFocusable(false);
        jButton30.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton30.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton30ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton30);

        jSeparator2.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jSeparator2.setPreferredSize(new java.awt.Dimension(50, 0));
        jToolBar1.add(jSeparator2);

        jToggleButton1.setToolTipText("Start config");
        jToggleButton1.setAlignmentY(0.2F);
        jToggleButton1.setBorderPainted(false);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        jToggleButton8.setToolTipText("command line");
        jToggleButton8.setAlignmentY(0.2F);
        jToggleButton8.setBorderPainted(false);
        jToggleButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton8ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton8);

        jSeparator8.setPreferredSize(new java.awt.Dimension(30, 0));
        jToolBar1.add(jSeparator8);

        jButton28.setToolTipText("open File");
        jButton28.setAlignmentY(0.2F);
        jButton28.setBorderPainted(false);
        jButton28.setFocusable(false);
        jButton28.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton28.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton28.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton28ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton28);

        jToggleButton19.setToolTipText("interfaces");
        jToggleButton19.setAlignmentY(0.2F);
        jToggleButton19.setBorderPainted(false);
        jToggleButton19.setFocusable(false);
        jToggleButton19.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton19.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton19ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton19);
        jToolBar1.add(jSeparator5);

        jToggleButton2.setToolTipText("command line");
        jToggleButton2.setAlignmentY(0.2F);
        jToggleButton2.setBorderPainted(false);
        jToggleButton2.setFocusable(false);
        jToggleButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton2);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.PAGE_START);

        jSplitPane2.setDividerLocation(150);

        jPanel12.setLayout(new java.awt.BorderLayout());

        jToolBar8.setRollover(true);
        jToolBar8.setName("Edit toolbar"); // NOI18N

        jToggleButton21.setToolTipText("start/stop");
        jToggleButton21.setAlignmentY(0.2F);
        jToggleButton21.setBorderPainted(false);
        jToggleButton21.setEnabled(false);
        jToggleButton21.setFocusable(false);
        jToggleButton21.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton21.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton21ActionPerformed(evt);
            }
        });
        jToolBar8.add(jToggleButton21);

        jButton5.setToolTipText("Move Down");
        jButton5.setAlignmentY(0.2F);
        jButton5.setBorderPainted(false);
        jButton5.setFocusable(false);
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jToolBar8.add(jButton5);

        jButton17.setToolTipText("Move Up");
        jButton17.setAlignmentY(0.2F);
        jButton17.setBorderPainted(false);
        jButton17.setFocusable(false);
        jButton17.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton17.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton17ActionPerformed(evt);
            }
        });
        jToolBar8.add(jButton17);

        jToggleButton23.setToolTipText("Traffic");
        jToggleButton23.setAlignmentY(0.2F);
        jToggleButton23.setBorderPainted(false);
        jToggleButton23.setEnabled(false);
        jToggleButton23.setFocusable(false);
        jToggleButton23.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton23.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton23.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton23ActionPerformed(evt);
            }
        });
        jToolBar8.add(jToggleButton23);

        jTextField6.setAlignmentY(0.2F);
        jTextField6.setMaximumSize(new java.awt.Dimension(500, 18));
        jTextField6.setMinimumSize(new java.awt.Dimension(6, 16));
        jTextField6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField6ActionPerformed(evt);
            }
        });
        jTextField6.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField6FocusLost(evt);
            }
        });
        jTextField6.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextField6KeyPressed(evt);
            }
        });
        jToolBar8.add(jTextField6);

        jToggleButton24.setToolTipText("Rename");
        jToggleButton24.setAlignmentY(0.2F);
        jToggleButton24.setBorderPainted(false);
        jToggleButton24.setEnabled(false);
        jToggleButton24.setFocusable(false);
        jToggleButton24.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton24.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton24.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton24ActionPerformed(evt);
            }
        });
        jToolBar8.add(jToggleButton24);

        jPanel12.add(jToolBar8, java.awt.BorderLayout.NORTH);

        jTree1.setModel(new MainTreeModel(Parent));
        jTree1.setEditable(true);
        jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTree1MouseReleased(evt);
            }
        });
        jScrollPane4.setViewportView(jTree1);

        jPanel12.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        jSplitPane2.setLeftComponent(jPanel12);

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane1.setMinimumSize(new java.awt.Dimension(50, 70));
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(500, 250));
        jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jTabbedPane1StateChanged(evt);
            }
        });

        jPanel9.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                jPanel9ComponentHidden(evt);
            }
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel9ComponentShown(evt);
            }
        });
        jPanel9.setLayout(new java.awt.BorderLayout());

        jToolBar7.setName("Main toolbar"); // NOI18N
        jToolBar7.setPreferredSize(new java.awt.Dimension(101, 25));

        jButton1.setToolTipText("Add port");
        jButton1.setBorderPainted(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar7.add(jButton1);

        jButton15.setToolTipText("Add Machine");
        jButton15.setBorderPainted(false);
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });
        jToolBar7.add(jButton15);

        jButton31.setToolTipText("Add TERM");
        jButton31.setBorderPainted(false);
        jButton31.setFocusable(false);
        jButton31.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton31.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton31.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton31ActionPerformed(evt);
            }
        });
        jToolBar7.add(jButton31);

        jSeparator9.setMinimumSize(new java.awt.Dimension(100, 0));
        jSeparator9.setPreferredSize(new java.awt.Dimension(60, 0));
        jToolBar7.add(jSeparator9);

        jToggleButton7.setToolTipText("onePort Displayed");
        jToggleButton7.setBorderPainted(false);
        jToggleButton7.setFocusable(false);
        jToggleButton7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton7.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton7ActionPerformed(evt);
            }
        });
        jToolBar7.add(jToggleButton7);

        jToggleButton3.setToolTipText("lock Ports frames");
        jToggleButton3.setBorderPainted(false);
        jToggleButton3.setFocusable(false);
        jToggleButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jToolBar7.add(jToggleButton3);

        jPanel9.add(jToolBar7, java.awt.BorderLayout.NORTH);

        jScrollPane1.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER);

        jPanel2.setMinimumSize(new java.awt.Dimension(100, 100));
        jPanel2.setPreferredSize(new java.awt.Dimension(300, 200));
        jPanel2.setLayout(null);
        jScrollPane1.setViewportView(jPanel2);

        jPanel9.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Ports", null, jPanel9, "Ports");

        jPanel10.setLayout(new java.awt.BorderLayout());

        jToolBar2.setRollover(true);
        jToolBar2.setName("Matrix toolbar"); // NOI18N

        jToggleButton14.setText("Echo");
        jToggleButton14.setToolTipText("Matrix echo");
        jToggleButton14.setFocusable(false);
        jToggleButton14.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton14.setMaximumSize(new java.awt.Dimension(40, 15));
        jToggleButton14.setMinimumSize(new java.awt.Dimension(27, 15));
        jToggleButton14.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton14ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton14);

        jToggleButton5.setText("bidir");
        jToggleButton5.setToolTipText("set bidir connexions");
        jToggleButton5.setFocusable(false);
        jToggleButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton5.setMaximumSize(new java.awt.Dimension(40, 15));
        jToggleButton5.setMinimumSize(new java.awt.Dimension(27, 15));
        jToggleButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton5ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton5);
        jToolBar2.add(jSeparator3);

        buttonGroup1.add(jToggleButton11);
        jToggleButton11.setToolTipText("set matrix OFF");
        jToggleButton11.setActionCommand("OFF");
        jToggleButton11.setBorderPainted(false);
        jToggleButton11.setFocusable(false);
        jToggleButton11.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton11.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton11ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton11);

        buttonGroup1.add(jToggleButton10);
        jToggleButton10.setToolTipText("Ring matrix");
        jToggleButton10.setActionCommand("RING");
        jToggleButton10.setBorderPainted(false);
        jToggleButton10.setFocusable(false);
        jToggleButton10.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton10.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton10ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton10);

        buttonGroup1.add(jToggleButton9);
        jToggleButton9.setToolTipText("full matrix");
        jToggleButton9.setActionCommand("FULL");
        jToggleButton9.setBorderPainted(false);
        jToggleButton9.setFocusable(false);
        jToggleButton9.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton9.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton9ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton9);

        buttonGroup1.add(jToggleButton12);
        jToggleButton12.setToolTipText("bus matrix");
        jToggleButton12.setActionCommand("BUS");
        jToggleButton12.setBorderPainted(false);
        jToggleButton12.setFocusable(false);
        jToggleButton12.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton12.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton12ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton12);

        buttonGroup1.add(jToggleButton13);
        jToggleButton13.setToolTipText("free matrix");
        jToggleButton13.setActionCommand("FREE");
        jToggleButton13.setBorderPainted(false);
        jToggleButton13.setFocusable(false);
        jToggleButton13.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton13.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton13ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton13);

        buttonGroup1.add(jToggleButton20);
        jToggleButton20.setSelected(true);
        jToggleButton20.setToolTipText("group_matrix");
        jToggleButton20.setActionCommand("GRP");
        jToggleButton20.setBorderPainted(false);
        jToggleButton20.setFocusable(false);
        jToggleButton20.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton20.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton20ActionPerformed(evt);
            }
        });
        jToolBar2.add(jToggleButton20);

        jPanel10.add(jToolBar2, java.awt.BorderLayout.NORTH);

        jSplitPane3.setDividerLocation(200);
        jSplitPane3.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.setCellSelectionEnabled(true);
        jScrollPane3.setViewportView(jTable1);

        jSplitPane3.setLeftComponent(jScrollPane3);

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable2MouseReleased(evt);
            }
        });
        jScrollPane2.setViewportView(jTable2);

        jSplitPane3.setRightComponent(jScrollPane2);

        jPanel10.add(jSplitPane3, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Matrix", null, jPanel10, "Matrix");

        jPanel6.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                jPanel6ComponentHidden(evt);
            }
        });
        jPanel6.setLayout(new java.awt.BorderLayout());

        jToolBar3.setRollover(true);
        jToolBar3.setName("Stack toolbar"); // NOI18N

        jCheckBox30.setToolTipText("Enable stacks");
        jCheckBox30.setFocusable(false);
        jCheckBox30.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jCheckBox30.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jCheckBox30.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox30ActionPerformed(evt);
            }
        });
        jToolBar3.add(jCheckBox30);
        jToolBar3.add(jSeparator7);

        jButton14.setToolTipText("add selected protocol");
        jButton14.setBorderPainted(false);
        jButton14.setFocusable(false);
        jButton14.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton14.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });
        jToolBar3.add(jButton14);

        jButton22.setToolTipText("remove selected stacks");
        jButton22.setBorderPainted(false);
        jButton22.setFocusable(false);
        jButton22.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton22.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton22ActionPerformed(evt);
            }
        });
        jToolBar3.add(jButton22);

        jToggleButton22.setToolTipText("Rename");
        jToggleButton22.setBorderPainted(false);
        jToggleButton22.setFocusable(false);
        jToggleButton22.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton22.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton22.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton22ActionPerformed(evt);
            }
        });
        jToolBar3.add(jToggleButton22);

        jButton2.setToolTipText("display proto args");
        jButton2.setBorderPainted(false);
        jButton2.setEnabled(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar3.add(jButton2);

        jTextField3.setMaximumSize(new java.awt.Dimension(80, 20));
        jToolBar3.add(jTextField3);

        jSpinner1.setMaximumSize(new java.awt.Dimension(40, 20));
        jToolBar3.add(jSpinner1);
        jToolBar3.add(jSeparator4);

        jButton24.setToolTipText("Insert UDP stack");
        jButton24.setBorderPainted(false);
        jButton24.setFocusable(false);
        jButton24.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton24.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton24.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton24ActionPerformed(evt);
            }
        });
        jToolBar3.add(jButton24);

        jButton23.setToolTipText("insert TCP stack");
        jButton23.setBorderPainted(false);
        jButton23.setFocusable(false);
        jButton23.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton23.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton23.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton23ActionPerformed(evt);
            }
        });
        jToolBar3.add(jButton23);

        jButton25.setToolTipText("insert ICMP stack");
        jButton25.setBorderPainted(false);
        jButton25.setFocusable(false);
        jButton25.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton25.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton25ActionPerformed(evt);
            }
        });
        jToolBar3.add(jButton25);

        jButton26.setToolTipText("insert PAD stack");
        jButton26.setBorderPainted(false);
        jButton26.setFocusable(false);
        jButton26.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton26.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton26.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton26ActionPerformed(evt);
            }
        });
        jToolBar3.add(jButton26);
        jToolBar3.add(jSeparator6);

        jToggleButton15.setToolTipText("Logs");
        jToggleButton15.setBorderPainted(false);
        jToggleButton15.setFocusable(false);
        jToggleButton15.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton15.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton15ActionPerformed(evt);
            }
        });
        jToolBar3.add(jToggleButton15);

        jPanel6.add(jToolBar3, java.awt.BorderLayout.NORTH);

        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null},
                {null},
                {null},
                {null},
                {null},
                {null},
                {null}
            },
            new String [] {
                "Title 1"
            }
        ));
        jTable3.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable3.setCellSelectionEnabled(true);
        jTable3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable3MouseClicked(evt);
            }
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable3MouseReleased(evt);
            }
        });
        jTable3.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTable3KeyPressed(evt);
            }
        });
        jScrollPane5.setViewportView(jTable3);

        jSplitPane1.setLeftComponent(jScrollPane5);

        jTable5.setAutoCreateRowSorter(true);
        jTable5.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable5MouseClicked(evt);
            }
        });
        jScrollPane6.setViewportView(jTable5);

        jSplitPane1.setRightComponent(jScrollPane6);

        jPanel6.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Stack", null, jPanel6, "Stack");

        jPanel11.setLayout(new java.awt.BorderLayout());

        jToolBar4.setRollover(true);
        jToolBar4.setName("Conf toolbar"); // NOI18N

        jToggleButton18.setToolTipText("Start config");
        jToggleButton18.setBorderPainted(false);
        jToggleButton18.setFocusable(false);
        jToggleButton18.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton18.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton18ActionPerformed(evt);
            }
        });
        jToolBar4.add(jToggleButton18);

        jToggleButton16.setToolTipText("pause");
        jToggleButton16.setBorderPainted(false);
        jToggleButton16.setFocusable(false);
        jToggleButton16.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton16.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton16ActionPerformed(evt);
            }
        });
        jToolBar4.add(jToggleButton16);

        jToggleButton17.setToolTipText("more");
        jToggleButton17.setBorderPainted(false);
        jToggleButton17.setFocusable(false);
        jToggleButton17.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton17.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton17ActionPerformed(evt);
            }
        });
        jToolBar4.add(jToggleButton17);

        jPanel11.add(jToolBar4, java.awt.BorderLayout.NORTH);

        jSplitPane4.setBorder(null);
        jSplitPane4.setDividerLocation(180);
        jSplitPane4.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jTable6.setAutoCreateRowSorter(true);
        jTable6.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable6MouseReleased(evt);
            }
        });
        jScrollPane9.setViewportView(jTable6);

        jSplitPane4.setBottomComponent(jScrollPane9);

        p_Diagram1.setToolBar(false);
        jSplitPane4.setLeftComponent(p_Diagram1);

        jPanel11.add(jSplitPane4, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Conf", null, jPanel11, "Conf");

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel8.setLayout(new java.awt.BorderLayout());

        jPanel7.setMaximumSize(new java.awt.Dimension(32767, 30));
        jPanel7.setMinimumSize(new java.awt.Dimension(20, 30));
        jPanel7.setPreferredSize(new java.awt.Dimension(20, 30));
        jPanel7.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 0, 0));
        jScrollPane8.setViewportView(jPanel7);

        jPanel8.add(jScrollPane8, java.awt.BorderLayout.CENTER);

        jPanel16.setLayout(new javax.swing.BoxLayout(jPanel16, javax.swing.BoxLayout.LINE_AXIS));

        jButton4.setText("Clear");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel16.add(jButton4);

        jToggleButton26.setText("out");
        jToggleButton26.setToolTipText("display out sandard output");
        jToggleButton26.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton26ActionPerformed(evt);
            }
        });
        jPanel16.add(jToggleButton26);

        jToggleButton25.setText("err");
        jToggleButton25.setToolTipText("display err sandard output");
        jToggleButton25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton25ActionPerformed(evt);
            }
        });
        jPanel16.add(jToggleButton25);
        jPanel16.add(jPanel13);

        jButton7.setText("unselect all");
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jPanel16.add(jButton7);

        jButton6.setText("select all");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jPanel16.add(jButton6);

        jPanel8.add(jPanel16, java.awt.BorderLayout.PAGE_START);

        jPanel4.add(jPanel8, java.awt.BorderLayout.NORTH);
        jPanel4.add(p_Texte1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Debug", null, jPanel4, "Debug");

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("view"));
        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel14.setLayout(new java.awt.GridLayout(1, 0));

        jButton12.setText("Compile");
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });
        jPanel14.add(jButton12);

        jToggleButton4.setText("CONF");
        jToggleButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton4ActionPerformed(evt);
            }
        });
        jPanel14.add(jToggleButton4);

        jButton21.setText("Decode");
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });
        jPanel14.add(jButton21);

        jButton10.setText("DB");
        jButton10.setToolTipText("DB Editor");
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jPanel14.add(jButton10);

        jPanel1.add(jPanel14, java.awt.BorderLayout.SOUTH);

        jPanel15.setLayout(new java.awt.GridLayout(1, 0));

        jButton27.setText("Editors");
        jButton27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton27ActionPerformed(evt);
            }
        });
        jPanel15.add(jButton27);

        jButton19.setText("Graph");
        jButton19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton19ActionPerformed(evt);
            }
        });
        jPanel15.add(jButton19);

        jButton16.setText("OBJ");
        jButton16.setToolTipText("Edit XML");
        jButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton16ActionPerformed(evt);
            }
        });
        jPanel15.add(jButton16);

        jButton18.setText("System");
        jButton18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton18ActionPerformed(evt);
            }
        });
        jPanel15.add(jButton18);

        jPanel1.add(jPanel15, java.awt.BorderLayout.NORTH);

        jPanel3.add(jPanel1, java.awt.BorderLayout.SOUTH);
        jPanel1.getAccessibleContext().setAccessibleName("Views");

        jPanel5.setLayout(new javax.swing.BoxLayout(jPanel5, javax.swing.BoxLayout.LINE_AXIS));

        jToggleButton6.setText("Packets");
        jToggleButton6.setToolTipText("Start/Stop log to file");
        jToggleButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton6ActionPerformed(evt);
            }
        });
        jPanel5.add(jToggleButton6);

        jTextField5.setText("c:\\\\Packets.txt");
        jPanel5.add(jTextField5);

        jButton13.setToolTipText("Change log file");
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton13);

        jButton3.setText("config");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton3);

        jPanel3.add(jPanel5, java.awt.BorderLayout.PAGE_START);

        jTabbedPane1.addTab("Edit", null, jPanel3, "Edit");

        jSplitPane2.setRightComponent(jTabbedPane1);

        getContentPane().add(jSplitPane2, java.awt.BorderLayout.CENTER);

        jMenu17.setText("File");

        jMenuItem56.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem56.setText("Open Config");
        jMenuItem56.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem15ActionPerformed(evt);
            }
        });
        jMenu17.add(jMenuItem56);

        jMenuItem57.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem57.setText("Read capture ..");
        jMenuItem57.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu17.add(jMenuItem57);

        jMenuItem58.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F4, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem58.setText("Close");
        jMenuItem58.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu17.add(jMenuItem58);

        jMenu21.setText("Load libs");

        jMenuItem69.setText("COM");
        jMenuItem69.setEnabled(false);
        jMenuItem69.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem69ActionPerformed(evt);
            }
        });
        jMenu21.add(jMenuItem69);

        jMenuItem70.setText("ETH");
        jMenuItem70.setEnabled(false);
        jMenuItem70.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem70ActionPerformed(evt);
            }
        });
        jMenu21.add(jMenuItem70);

        jMenuItem71.setText("USB");
        jMenuItem71.setEnabled(false);
        jMenuItem71.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem71ActionPerformed(evt);
            }
        });
        jMenu21.add(jMenuItem71);

        jMenuItem1.setText("Tools");
        jMenuItem1.setEnabled(false);
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed1(evt);
            }
        });
        jMenu21.add(jMenuItem1);

        jMenuItem4.setText("3D");
        jMenuItem4.setEnabled(false);
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed1(evt);
            }
        });
        jMenu21.add(jMenuItem4);

        jMenuItem5.setText("JNA");
        jMenuItem5.setEnabled(false);
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu21.add(jMenuItem5);

        jMenu17.add(jMenu21);

        jMenu22.setText("Load jdbc");

        jMenuItem73.setText("MySQL");
        jMenuItem73.setToolTipText("JDBC driver");
        jMenuItem73.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem73ActionPerformed(evt);
            }
        });
        jMenu22.add(jMenuItem73);

        jMenuItem74.setText("Derby");
        jMenuItem74.setToolTipText("appache DB JDBC drivers");
        jMenuItem74.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem74ActionPerformed(evt);
            }
        });
        jMenu22.add(jMenuItem74);

        jMenuItem75.setText("Oracle");
        jMenuItem75.setToolTipText("tns & thinJDBC drivers");
        jMenuItem75.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem75ActionPerformed(evt);
            }
        });
        jMenu22.add(jMenuItem75);

        jMenuItem76.setText("SQLServer");
        jMenuItem76.setToolTipText("JDBC driver");
        jMenuItem76.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem76ActionPerformed(evt);
            }
        });
        jMenu22.add(jMenuItem76);

        jMenuItem77.setText("ODBC");
        jMenuItem77.setToolTipText("JDBC driver");
        jMenu22.add(jMenuItem77);

        jMenuItem2.setText("HSQL");
        jMenuItem2.setToolTipText("odb files JDBC driver");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed1(evt);
            }
        });
        jMenu22.add(jMenuItem2);

        jMenuItem3.setText("Sybase");
        jMenu22.add(jMenuItem3);

        jMenu17.add(jMenu22);

        jMenuBar6.add(jMenu17);

        jMenu18.setText("Edit");
        jMenu18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenu2ActionPerformed(evt);
            }
        });

        jMenuItem59.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_CLEAR, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem59.setText("Clear all");
        jMenuItem59.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu18.add(jMenuItem59);

        jMenuItem60.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.ALT_MASK));
        jMenuItem60.setText("Add Port");
        jMenuItem60.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu18.add(jMenuItem60);

        jCheckBoxMenuItem6.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.ALT_MASK));
        jCheckBoxMenuItem6.setText("Run XML");
        jCheckBoxMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem1ActionPerformed(evt);
            }
        });
        jMenu18.add(jCheckBoxMenuItem6);

        jMenuBar6.add(jMenu18);

        jMenu19.setText("Look");

        jCheckBoxMenuItem7.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F4, java.awt.event.InputEvent.CTRL_MASK));
        jCheckBoxMenuItem7.setText("Hide");
        jCheckBoxMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem7ActionPerformed(evt);
            }
        });
        jMenu19.add(jCheckBoxMenuItem7);

        jMenuBar6.add(jMenu19);

        jMenu20.setText("help");

        jMenuItem68.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        jMenuItem68.setText("About");
        jMenuItem68.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem11ActionPerformed(evt);
            }
        });
        jMenu20.add(jMenuItem68);

        jMenuBar6.add(jMenu20);

        setJMenuBar(jMenuBar6);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem15ActionPerformed
        openXMLconfig();
    }//GEN-LAST:event_jMenuItem15ActionPerformed

    private void jMenuItem14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem14ActionPerformed
        Parent.setdbg_all(false);
    }//GEN-LAST:event_jMenuItem14ActionPerformed

    private void jMenuItem13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem13ActionPerformed
        Parent.setdbg_all(true);
    }//GEN-LAST:event_jMenuItem13ActionPerformed

    private void jMenuItem12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem12ActionPerformed
        clearconsole();
    }//GEN-LAST:event_jMenuItem12ActionPerformed

    private void jMenuItem11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem11ActionPerformed
        //   http://java.sun.com/docs/books/tutorial/uiswing/components/dialog.html
        JOptionPane.showMessageDialog(this, Parent.getHelpText() + Parent.testtime(), "About box", JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_jMenuItem11ActionPerformed

    private void jCheckBoxMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem1ActionPerformed
        Parent.setConf_Enabled(jCheckBoxMenuItem6.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem1ActionPerformed

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        Parent.addCX(null, "Port");
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        java.io.File file = TUtils.getUIreadFile(this, JFileChooser.FILES_AND_DIRECTORIES, null, true);
        DisplayCapture(file);
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        removeallCX();
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        System.exit(0);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenu2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenu2ActionPerformed
    }//GEN-LAST:event_jMenu2ActionPerformed

    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
        removeallCX();
    }//GEN-LAST:event_jButton11ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        selectPort(Parent.addCX(null, "Port"));
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        Parent.setConf_Enabled(jToggleButton1.isSelected());
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jCheckBoxMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem7ActionPerformed
        setVisible(false);
    }//GEN-LAST:event_jCheckBoxMenuItem7ActionPerformed

    private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton15ActionPerformed
        Parent.addCX(null, "Machine");
    }//GEN-LAST:event_jButton15ActionPerformed

    private void jToggleButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton8ActionPerformed
        setShell(isShell());
    }//GEN-LAST:event_jToggleButton8ActionPerformed

    private void jToggleButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton9ActionPerformed
        if (Parent != null) {
            Parent.setMat_Type(evt.getActionCommand());
        }
    }//GEN-LAST:event_jToggleButton9ActionPerformed

    private void jMenuItem69ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem69ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem69ActionPerformed

    private void jMenuItem70ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem70ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem70ActionPerformed

    private void jMenuItem71ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem71ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem71ActionPerformed

    private void jMenuItem73ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem73ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem73ActionPerformed

    private void jMenuItem74ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem74ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem74ActionPerformed

    private void jMenuItem75ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem75ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem75ActionPerformed

    private void jMenuItem76ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem76ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem76ActionPerformed

private void jToggleButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton10ActionPerformed
    if (Parent != null) {
        Parent.setMat_Type(evt.getActionCommand());
    }
}//GEN-LAST:event_jToggleButton10ActionPerformed

private void jToggleButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton11ActionPerformed
    if (Parent != null) {
        Parent.setMat_Type(evt.getActionCommand());
    }
}//GEN-LAST:event_jToggleButton11ActionPerformed

private void jMenuItem2ActionPerformed1(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed1
    if (Parent != null) {
        Parent.loadModule(evt.getActionCommand());
    }

}//GEN-LAST:event_jMenuItem2ActionPerformed1

private void jMenuItem1ActionPerformed1(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed1
    if (Parent != null) {
        Parent.loadModule(evt.getActionCommand());
    }

}//GEN-LAST:event_jMenuItem1ActionPerformed1

private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton21ActionPerformed
    P_CodeEditor ce = new P_CodeEditor(false, new com.jdcm.analyse.Code_Model(null, ("this is line1\r\nand line 2\r\nand line 3").getBytes(), "CSV"));
    javax.swing.JFrame fr = new javax.swing.JFrame("Decoder");
    fr.add(ce);
    fr.setSize(ce.getPreferredSize());
    fr.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
    fr.setVisible(true);
    //should be beter managed by widos ! applet
}//GEN-LAST:event_jButton21ActionPerformed

private void jButton19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton19ActionPerformed
    com.jdcm.charts.F_charts a = new com.jdcm.charts.F_charts();
    //should be beter managed by widos ! applet
    a.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
    a.setVisible(true);
}//GEN-LAST:event_jButton19ActionPerformed

private void jButton18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton18ActionPerformed
    Enumeration<?> p = System.getProperties().propertyNames();
    java.util.List<String[]> vals = new java.util.ArrayList<>();
    while (p.hasMoreElements()) {
        String lbl = p.nextElement().toString();
        vals.add(new String[]{lbl, System.getProperty(lbl)});
        System.out.println("Property :  " + lbl + " = " + System.getProperty(lbl));
    }
    Object[][] obs = new Object[vals.size()][2];
    for (int i = 0; i < vals.size(); i++) {
        obs[i] = vals.get(i);
    }
    javax.swing.table.DefaultTableModel a = new javax.swing.table.DefaultTableModel(obs, new Object[]{"Label", "Value"});
    javax.swing.JFrame f = new javax.swing.JFrame("Properties");
    f.add(new com.jdcm.editors.P_TableEditor(a));
    f.setBounds(0, 0, 200, 200);
    f.setVisible(true);
}//GEN-LAST:event_jButton18ActionPerformed

private void jButton16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton16ActionPerformed
    com.jdcm.editors.F_Object e = new com.jdcm.editors.F_Object(Parent);
}//GEN-LAST:event_jButton16ActionPerformed

private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton12ActionPerformed
    com.jdcm.editors.F_Compile<Object> f = new com.jdcm.editors.F_Compile<>();
    f.setVisible(true);
}//GEN-LAST:event_jButton12ActionPerformed

private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
    javax.swing.JFrame t = new javax.swing.JFrame("SQLEditor");
    javax.swing.JPanel p = new com.jdcm.editors.P_SQLTables(Parent);
    t.add(p);
    t.setBounds(0, 0, p.getPreferredSize().width, p.getPreferredSize().height);
    t.setIconImage(TUtils.getImage("DBsimple.gif"));
    t.setVisible(true);
}//GEN-LAST:event_jButton10ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
    clearconsole();
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
    Parent.setdbg_all(false);
}//GEN-LAST:event_jButton7ActionPerformed

private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
    Parent.setdbg_all(true);
}//GEN-LAST:event_jButton6ActionPerformed

private void jToggleButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton13ActionPerformed
    if (Parent != null) {
        Parent.setMat_Type(evt.getActionCommand());
    }
}//GEN-LAST:event_jToggleButton13ActionPerformed

private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton14ActionPerformed
    if (jTable3.getSelectedColumn() == 0) {
        Parent.addStackLevel(jTable3.getSelectedRow());
    } else {
        addSelectedStacks();
    }
}//GEN-LAST:event_jButton14ActionPerformed
private void jButton22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton22ActionPerformed
    if (jTable3.getSelectedColumns().length > 0 && jTable3.getSelectedRows().length > 0) {
        // selection is destroyed while removing stacks
        jTable3.editingCanceled(null);
        int[] rs = jTable3.getSelectedRows();
        int[] cs = jTable3.getSelectedColumns();
        for (int row : rs) {
            for (int col : cs) {
                Parent.removeStack(row, col);
            }
        }
    }
}//GEN-LAST:event_jButton22ActionPerformed

private void jButton23ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton23ActionPerformed
    try {
        Parent.removeStacks(jTable3.getSelectedColumn());
        Parent.addStacks(new String[]{"ETHII", "ARP", "IP", "ICMP", "TCP"}, jTable3.getSelectedRow(), jTable3.getSelectedColumn());
    } catch (Exception ex) {
    }
}//GEN-LAST:event_jButton23ActionPerformed

private void jButton24ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton24ActionPerformed
    try {
        Parent.removeStacks(jTable3.getSelectedColumn());
        Parent.addStacks(new String[]{"ETHII", "ARP", "IP", "ICMP", "UDP"}, jTable3.getSelectedRow(), jTable3.getSelectedColumn());
    } catch (Exception ex) {
    }
}//GEN-LAST:event_jButton24ActionPerformed

private void jButton25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton25ActionPerformed
    try {
        Parent.removeStacks(jTable3.getSelectedColumn());
        Parent.addStacks(new String[]{"ETHII", "ARP", "IP", "ICMP"}, jTable3.getSelectedRow(), jTable3.getSelectedColumn());
    } catch (Exception ex) {
    }
}//GEN-LAST:event_jButton25ActionPerformed

private void jCheckBox30ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox30ActionPerformed
    Parent.setStack_Enabled(jCheckBox30.isSelected());
}//GEN-LAST:event_jCheckBox30ActionPerformed

private void jButton27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton27ActionPerformed
    com.jdcm.editors.A_editors a = new com.jdcm.editors.A_editors();
    //should be beter managed by widos ! applet
    a.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
    a.setVisible(true);
}//GEN-LAST:event_jButton27ActionPerformed

private void jToggleButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton12ActionPerformed
    if (Parent.getCMDChilds("Matrix").size() > 0) {
        if (((T_Matrice) Parent.getCMDChilds("Matrix").get(0)).getmodel() != null) {
            Parent.setMat_Type(evt.getActionCommand());
        }
    }
}//GEN-LAST:event_jToggleButton12ActionPerformed

private void jTree1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseReleased
    //start/stop & traffic & up/down
    updateTreeToolbar();
}//GEN-LAST:event_jTree1MouseReleased

private void jMenuItem4ActionPerformed1(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed1
    if (Parent != null) {
        Parent.loadModule(evt.getActionCommand());
    }
}//GEN-LAST:event_jMenuItem4ActionPerformed1

    private void jTable5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable5MouseClicked
        if (evt.getClickCount() == 2) {
            addSelectedStacks();
        }
    }//GEN-LAST:event_jTable5MouseClicked

    private void jPanel9ComponentHidden(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel9ComponentHidden
        jTree1.stopEditing();
    }//GEN-LAST:event_jPanel9ComponentHidden

    private void jPanel6ComponentHidden(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel6ComponentHidden
        // jTable4.stopEditing() ?? how to do ??
    }//GEN-LAST:event_jPanel6ComponentHidden

    private void jTable3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable3MouseClicked
        int row = jTable3.getSelectedRow();
        int column = jTable3.getSelectedColumn();
        if (evt.getClickCount() == 2) {
            if (row < 0 && column < 0) {
                return;
            }
            if (column == 0) {
                Parent.addStackLevel(row);
            } else {
                addSelectedStacks();
            }
        }
    }//GEN-LAST:event_jTable3MouseClicked

    private void jTable3MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable3MouseReleased
        final int row = jTable3.getSelectedRow();
        final int column = jTable3.getSelectedColumn();
        if (row >= 0 && column >= 0 && jTable3.isEnabled()) {
            boolean bool = jTable3.getValueAt(row, column) instanceof com.jdcm.modifiers.stacks.I_stack_elt;
            jButton2.setEnabled(bool);
            jToggleButton22.setEnabled(column == 0 || bool);
        }
        Parent.UpdateDatas(row, column);
    }//GEN-LAST:event_jTable3MouseReleased

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        // system.exit dont properly close streams
        setConf_Enabled(false);
        try {
            for (I_Port p : Parent.getPorts()) {
                if (p instanceof C_Port && (p.getcxstatus().compareTo("stopped") != 0 || p.getcxstatus().compareTo("creating") != 0)) {
                    p.CXstop();
                }
            }
        } catch (java.util.ConcurrentModificationException ex) {
            //occurs if TCP connect/listner stopped=> removed=> no more in Ports list
        }
        System.exit(0);

    }//GEN-LAST:event_formWindowClosing

    private void jToggleButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton15ActionPerformed
        Parent.setStackdebug(jToggleButton15.isSelected());
    }//GEN-LAST:event_jToggleButton15ActionPerformed

    private void jToggleButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton4ActionPerformed
        javax.swing.JFrame a = P_Diagram.getasFrame();
        //should be beter managed by widos ! applet
        a.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
        a.addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                jToggleButton4.setSelected(false);
            }
        });
        a.setVisible(true);
    }//GEN-LAST:event_jToggleButton4ActionPerformed

    private void jToggleButton16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton16ActionPerformed
        Parent.setConf_Pause(jToggleButton16.isSelected());
    }//GEN-LAST:event_jToggleButton16ActionPerformed

    private void jToggleButton17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton17ActionPerformed
        p_Diagram1.setToolBar(jToggleButton17.isSelected());
    }//GEN-LAST:event_jToggleButton17ActionPerformed

    private void jButton26ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton26ActionPerformed
        Parent.removeStacks(jTable3.getSelectedColumn());
        try {
            Parent.addStacks(new String[]{"Modem", "PAD", "-X25", "-RFC1086"}, jTable3.getSelectedRow(), jTable3.getSelectedColumn());
        } catch (Exception ex) {
        }
    }//GEN-LAST:event_jButton26ActionPerformed

    private void jToggleButton18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton18ActionPerformed
        Parent.setConf_Enabled(jToggleButton18.isSelected());
    }//GEN-LAST:event_jToggleButton18ActionPerformed

    private void jButton28ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton28ActionPerformed
        java.io.File file = TUtils.getUIreadFile(this, JFileChooser.FILES_AND_DIRECTORIES, null, true);
        if (file != null) {
            byte[] b = new byte[4];
            int red = -1;
            try {
                try (java.io.InputStream f = TUtils.getFileStream(file)) {
                    red = f.read(b);
                }
            } catch (IOException ex) {
            }
            if (red == -1) {
                javax.swing.JOptionPane.showMessageDialog(this, "File empty or reading error", "File View", javax.swing.JOptionPane.ERROR_MESSAGE);
                return;
            }
            // capture signature file
            if (Arrays.equals(b, new byte[]{-44, -61, -78, -95})) {
                DisplayCapture(file);
            } else {
                com.jdcm.editors.F_Compile<Object> ed = new com.jdcm.editors.F_Compile<>(file);
                ed.setVisible(true);
            }
        }
    }//GEN-LAST:event_jButton28ActionPerformed

    private void jToggleButton19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton19ActionPerformed
        setPComEth(isPComEth());
    }//GEN-LAST:event_jToggleButton19ActionPerformed

    private void jToggleButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton7ActionPerformed
        setPortsDisplayed(isPortsDisplayed());
    }//GEN-LAST:event_jToggleButton7ActionPerformed

    private void jToggleButton20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton20ActionPerformed
        if (Parent.getCMDChilds("Matrix").size() > 0) {
            if (((T_Matrice) Parent.getCMDChilds("Matrix").get(0)).getmodel() != null) {
                Parent.setMat_Type(evt.getActionCommand());
            }
        }
    }//GEN-LAST:event_jToggleButton20ActionPerformed

    private void jToggleButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton21ActionPerformed
        if (getTreeSelection() instanceof I_Port) {
            I_Port port = (I_Port) getTreeSelection();
            if (port.getcxstatus().startsWith("stop")
                    || port.getcxstatus().startsWith("err")
                    || port.getcxstatus().startsWith("crea")) {
                port.CXstart();
            } else {
                port.CXstop();
            }
            setTreeSelection(port);
            updateTreeToolbar();
        }

    }//GEN-LAST:event_jToggleButton21ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        //MOVE DOWN
        Object node = getTreeSelection();
        if (node != null && node instanceof I_Port) {
            int idx = Parent.getPorts().indexOf(node);
            // should lock the stack & matrix
            Parent.moveStackCol(idx + 1, true);
            // Parent.moveMatrixCol(idx + 1, true);
            Parent.getPorts().remove((I_Port) node);
            Parent.getPorts().add(idx + 1, (I_Port) node);
            Parent.moveMatrixCol(idx + 1, false);
            ((MainTreeModel) jTree1.getModel()).fireTreeStructureChanged(Parent);
            jTree1MouseReleased(null);
            // ((Matrix_Model) Parent.getmat_protos()).update();
            refresh_table("move", null, null);
            setTreeSelection(node);
        }
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jButton17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton17ActionPerformed
        //MOVE UP
        Object node = getTreeSelection();
        if (node != null && node instanceof I_Port) {
            int idx = Parent.getPorts().indexOf(node);
            //should lock & matrix
            Parent.moveStackCol(idx + 1, false);
            //  Parent.moveMatrixCol(idx + 1, false);
            Parent.getPorts().remove((I_Port) node);
            Parent.getPorts().add(idx - 1, (I_Port) node);
            Parent.moveMatrixCol(idx + 1, true);
            ((MainTreeModel) jTree1.getModel()).fireTreeStructureChanged(Parent);
            jTree1MouseReleased(null);
            refresh_table("move", null, null);
            setTreeSelection(node);

        }
    }//GEN-LAST:event_jButton17ActionPerformed

    private void jButton30ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton30ActionPerformed
        Parent.addCX(null, "Port");
    }//GEN-LAST:event_jButton30ActionPerformed

    private void jToggleButton22ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton22ActionPerformed
        final int col = jTable3.getSelectedColumn();
        final int row = jTable3.getSelectedRow();
        Object selob = jTable3.getValueAt(row, col);
        jButton14.setVisible(!jToggleButton22.isSelected());
        jButton22.setVisible(!jToggleButton22.isSelected());
        jTable3.setEnabled(!jToggleButton22.isSelected());
        if (!jToggleButton22.isSelected()) {
            if (jSpinner1.isVisible()) {
                Parent.getstack_model().setValueAt(jSpinner1.getValue(), row, col);
                jSpinner1.setVisible(false);
            } else if (jTextField3.isVisible()) {
                if (selob instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                    ((com.jdcm.modifiers.stacks.I_stack_elt) selob).setName(jTextField3.getText());
                }
                /*  jTextField3.addActionListener(new java.awt.event.ActionListener() {

                 @Override
                 public void actionPerformed(ActionEvent e) {
                 jToggleButton22.setSelected(false);
                 }
                 });*/
                jTextField3.setVisible(false);
                jTable3.editingStopped(null);
            }

            //!!!!!!!NOK!!!!!!!!!!
            //jToolBar3.setUI(jToolBar3.getUI());
            jToolBar3.repaint();
        } else {
            if (col == -1) {
                jToggleButton22.setSelected(false);
            } else if (col == 0 && row < jTable3.getRowCount() - 1) {

                jSpinner1.setVisible(true);
                double val = (Double) selob;
                double min = (Double) jTable3.getValueAt(row + 1, col);
                double max = 9.0;
                if (row > 0) {
                    max = (Double) jTable3.getValueAt(row - 1, col);
                }
                double step = (max - min) / 10;
                min = min + step;
                max = max - step;
                jSpinner1.setModel(new javax.swing.SpinnerNumberModel(val, min, max, step));
            } else {
                if (selob instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                    com.jdcm.modifiers.stacks.I_stack_elt elt = (com.jdcm.modifiers.stacks.I_stack_elt) selob;
                    // NOT WORKING??
                    //   jTable3.setEnabled(false);
                    jTextField3.setVisible(true);
                    jTextField3.setText(elt.toString());
                    jToolBar3.setUI(jToolBar3.getUI());
                }
            }
        }
    }//GEN-LAST:event_jToggleButton22ActionPerformed

    private void jToggleButton23ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton23ActionPerformed
        Object target = getTreeSelection();
        if (target instanceof I_Port) {
            ((I_Port) target).setPort_Stat(jToggleButton23.isSelected());
        } else if (target instanceof C_Stack) {
            setStack_Stat(jToggleButton23.isSelected());
        } else if (target instanceof T_Matrice) {
            setMat_Stat(jToggleButton23.isSelected());
        } else if (target instanceof C_Main) {
            setMain_Stat(jToggleButton23.isSelected());
        }
    }//GEN-LAST:event_jToggleButton23ActionPerformed

    private void jToggleButton24ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton24ActionPerformed
        Object target = getTreeSelection();
        if (target instanceof I_Port || target instanceof C_Main) {
            if (jToggleButton24.isSelected()) {
                jTextField6.setVisible(true);
                if (target instanceof I_Port) {
                    jTextField6.setText(((I_Port) target).getPortName());
                } else {
                    jTextField6.setText(((C_Main) target).toString());
                }
                jTextField6.requestFocus();
                jTextField6.setSelectionStart(0);
                jTextField6.setSelectionStart(jTextField6.getText().length());
                jButton5.setVisible(false);
                jButton17.setVisible(false);
                jToggleButton23.setVisible(false);
                jToggleButton21.setVisible(false);
            } else {
                jButton5.setVisible(true);
                jButton17.setVisible(true);
                jToggleButton23.setVisible(true);
                jToggleButton21.setVisible(true);
                jTextField6.setVisible(false);
                if (evt != null) {
                    if (target instanceof I_Port) {
                        ((I_Port) target).setPortName(jTextField6.getText());
                    } else {
                        ((C_Main) target).setName(jTextField6.getText());
                    }
                }
                jTree1.cancelEditing();
            }
        }
    }//GEN-LAST:event_jToggleButton24ActionPerformed

    private void jTextField6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField6ActionPerformed
        jToggleButton24.setSelected(false);
        jToggleButton24ActionPerformed(evt);
    }//GEN-LAST:event_jTextField6ActionPerformed

    private void jTextField6KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField6KeyPressed
        if (evt.getKeyCode() == 27) {
            jTextField6FocusLost(null);
        }
    }//GEN-LAST:event_jTextField6KeyPressed

    private void jTextField6FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField6FocusLost
        jToggleButton24.setSelected(false);
        jToggleButton24ActionPerformed(null);
    }//GEN-LAST:event_jTextField6FocusLost

    private void jButton31ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton31ActionPerformed
        C_Port portterm = (C_Port) Parent.addCX(null, "Port");
        portterm.setModeName("Term");
        String name = "VIEW_";
        int i = 0;
        while (!Parent.getCMDChilds(name + i).isEmpty()) {
            i++;
        }
        portterm.setPortName(name + i);
        portterm.setPar_mxgrp("<");
        portterm.setlockin(true);
        portterm.setstop2end(true);
        portterm.CXstart();
    }//GEN-LAST:event_jButton31ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        int col = jTable3.getSelectedColumn();
        int row = jTable3.getSelectedRow();
        Object selob = jTable3.getValueAt(row, col);
        if (selob instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
            com.jdcm.modifiers.stacks.I_stack_elt elt = (com.jdcm.modifiers.stacks.I_stack_elt) selob;
            java.util.List<I_Command> cmds = Parent.getCMDChilds("Stacks");
            if (elt.getOptions() != null && cmds != null && !cmds.isEmpty() && cmds.get(0) instanceof C_Stack) {
                ((C_Stack) (cmds.get(0))).displayStackOptions(elt.getport(), elt.toString());
            }
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        if (Parent != null) {
            Parent.loadModule(evt.getActionCommand());
        }
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        com.jdcm.editors.F_Compile<?> f = new com.jdcm.editors.F_Compile<>(Parent.getConfig((I_Command) Parent));
        f.setVisible(true);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
        this.setpackval(TUtils.getUIsaveFile(this, true, null));
    }//GEN-LAST:event_jButton13ActionPerformed

    private void jToggleButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton6ActionPerformed
        this.setpacket(ispacket());
    }//GEN-LAST:event_jToggleButton6ActionPerformed

    private void jTable6MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable6MouseReleased
        if (jTable6.isEnabled() && jTable6.getSelectedRow() != -1) {
            if (evt.getClickCount() == 1) {
                if (jTable6.getValueAt(jTable6.getSelectedRow(), 0) instanceof java.io.File) {
                    java.io.File f = (java.io.File) jTable6.getValueAt(jTable6.getSelectedRow(), 0);
                    Parent.setConf_File(f);
                }
            } else if (evt.getClickCount() == 2) {
                Parent.setConf_Enabled(true);
            }
        }
    }//GEN-LAST:event_jTable6MouseReleased

    private void jTable2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable2MouseReleased
        if (evt.getClickCount() == 1 && jTable2.getSelectedRow() >= 0) {
            Class<?> cl = (Class<?>) jTable2.getValueAt(jTable2.getSelectedRow(), 0);
            if (cl != null) {
                Parent.setMat_Type(cl);
            }
        }
    }//GEN-LAST:event_jTable2MouseReleased

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        if (jToggleButton2.isSelected() && awtListner == null) {
            awtListner = new java.awt.event.AWTEventListener() {
                @Override
                public void eventDispatched(AWTEvent event) {
                    if (event.paramString().contains("PRESSED")
                            && event.getSource() instanceof JFrame) {
                        if (D_Utils.isOpacytyListner((JFrame) event.getSource())) {
                            D_Utils.removeOpacytyListner((JFrame) event.getSource());
                        } else {
                            D_Utils.addOpacytyListner((JFrame) event.getSource());
                        }
                        Toolkit.getDefaultToolkit().removeAWTEventListener(awtListner);
                        awtListner = null;
                        jToggleButton2.setSelected(false);
                    }
                }
            };
            Toolkit.getDefaultToolkit().addAWTEventListener(awtListner, AWTEvent.MOUSE_EVENT_MASK);
        } else {
            Toolkit.getDefaultToolkit().removeAWTEventListener(awtListner);
            awtListner = null;
        }
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
        setLockPanel(jToggleButton3.isSelected());
    }//GEN-LAST:event_jToggleButton3ActionPerformed

    private void jPanel9ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel9ComponentShown
        if (getTreeSelection() instanceof I_Port) {
            I_Port port = (I_Port) getTreeSelection();
            displayPort(port);
        }
    }//GEN-LAST:event_jPanel9ComponentShown

    private void jTable3KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTable3KeyPressed
        if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_DELETE) {
            jButton22ActionPerformed(null);
        }
    }//GEN-LAST:event_jTable3KeyPressed

    private void jTabbedPane1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jTabbedPane1StateChanged
        String cabsUnselected = "";
        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
            if (i != jTabbedPane1.getSelectedIndex()) {
                cabsUnselected += jTabbedPane1.getTitleAt(i) + "/";
            }
        }
        refresh_mxstack(jTabbedPane1.getTitleAt(jTabbedPane1.getSelectedIndex()), cabsUnselected);
    }//GEN-LAST:event_jTabbedPane1StateChanged

    private void jToggleButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton5ActionPerformed
       if (Parent != null) {
        Parent.setMat_Bidir(jToggleButton5.isSelected());
    }
    }//GEN-LAST:event_jToggleButton5ActionPerformed

    private void jToggleButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton14ActionPerformed
           if (Parent != null) {
        Parent.setMat_Echo(jToggleButton14.isSelected());
    }
    }//GEN-LAST:event_jToggleButton14ActionPerformed

    private void jToggleButton25ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton25ActionPerformed
          Parent.setConsoleErr(jToggleButton25.isSelected());
    }//GEN-LAST:event_jToggleButton25ActionPerformed

    private void jToggleButton26ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton26ActionPerformed
    Parent.setConsoleOut(jToggleButton26.isSelected());
    }//GEN-LAST:event_jToggleButton26ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup_Menu;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton14;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton18;
    private javax.swing.JButton jButton19;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton21;
    private javax.swing.JButton jButton22;
    private javax.swing.JButton jButton23;
    private javax.swing.JButton jButton24;
    private javax.swing.JButton jButton25;
    private javax.swing.JButton jButton26;
    private javax.swing.JButton jButton27;
    private javax.swing.JButton jButton28;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton30;
    private javax.swing.JButton jButton31;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JCheckBox jCheckBox30;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem6;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem7;
    private javax.swing.JMenu jMenu17;
    private javax.swing.JMenu jMenu18;
    private javax.swing.JMenu jMenu19;
    private javax.swing.JMenu jMenu20;
    private javax.swing.JMenu jMenu21;
    private javax.swing.JMenu jMenu22;
    private javax.swing.JMenuBar jMenuBar6;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem53;
    private javax.swing.JMenuItem jMenuItem54;
    private javax.swing.JMenuItem jMenuItem55;
    private javax.swing.JMenuItem jMenuItem56;
    private javax.swing.JMenuItem jMenuItem57;
    private javax.swing.JMenuItem jMenuItem58;
    private javax.swing.JMenuItem jMenuItem59;
    private javax.swing.JMenuItem jMenuItem60;
    private javax.swing.JMenuItem jMenuItem68;
    private javax.swing.JMenuItem jMenuItem69;
    private javax.swing.JMenuItem jMenuItem70;
    private javax.swing.JMenuItem jMenuItem71;
    private javax.swing.JMenuItem jMenuItem73;
    private javax.swing.JMenuItem jMenuItem74;
    private javax.swing.JMenuItem jMenuItem75;
    private javax.swing.JMenuItem jMenuItem76;
    private javax.swing.JMenuItem jMenuItem77;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JToolBar.Separator jSeparator4;
    private javax.swing.JToolBar.Separator jSeparator5;
    private javax.swing.JToolBar.Separator jSeparator6;
    private javax.swing.JToolBar.Separator jSeparator7;
    private javax.swing.JToolBar.Separator jSeparator8;
    private javax.swing.JToolBar.Separator jSeparator9;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane3;
    private javax.swing.JSplitPane jSplitPane4;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTable jTable3;
    private javax.swing.JTable jTable4;
    private javax.swing.JTable jTable5;
    private javax.swing.JTable jTable6;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton10;
    private javax.swing.JToggleButton jToggleButton11;
    private javax.swing.JToggleButton jToggleButton12;
    private javax.swing.JToggleButton jToggleButton13;
    private javax.swing.JToggleButton jToggleButton14;
    private javax.swing.JToggleButton jToggleButton15;
    private javax.swing.JToggleButton jToggleButton16;
    private javax.swing.JToggleButton jToggleButton17;
    private javax.swing.JToggleButton jToggleButton18;
    private javax.swing.JToggleButton jToggleButton19;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton20;
    private javax.swing.JToggleButton jToggleButton21;
    private javax.swing.JToggleButton jToggleButton22;
    private javax.swing.JToggleButton jToggleButton23;
    private javax.swing.JToggleButton jToggleButton24;
    private javax.swing.JToggleButton jToggleButton25;
    private javax.swing.JToggleButton jToggleButton26;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton4;
    private javax.swing.JToggleButton jToggleButton5;
    private javax.swing.JToggleButton jToggleButton6;
    private javax.swing.JToggleButton jToggleButton7;
    private javax.swing.JToggleButton jToggleButton8;
    private javax.swing.JToggleButton jToggleButton9;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JToolBar jToolBar2;
    private javax.swing.JToolBar jToolBar3;
    private javax.swing.JToolBar jToolBar4;
    private javax.swing.JToolBar jToolBar5;
    private javax.swing.JToolBar jToolBar6;
    private javax.swing.JToolBar jToolBar7;
    private javax.swing.JToolBar jToolBar8;
    private javax.swing.JTree jTree1;
    private com.jdcm.diagram.P_Diagram p_Diagram1;
    private com.jdcm.editors.P_Texte p_Texte1;
    // End of variables declaration//GEN-END:variables

    private class Module_ObjRenderer implements javax.swing.table.TableCellRenderer {//extends com.jdcm.editors.ACE_ObjRenderer {
        // for serializable interface

        private static final long serialVersionUID = 1L;
        private Component Compnt = null;
        javax.swing.JCheckBox isEnable;

        public Module_ObjRenderer(javax.swing.JCheckBox chbox) {
            isEnable = chbox;
        }

        @Override
        public Component getTableCellRendererComponent(
                javax.swing.JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
            Compnt = null;
            java.awt.Color color = null;
            if (value == null) {
                javax.swing.JLabel box = new javax.swing.JLabel();
                box.setOpaque(true);
                box.setBackground(table.getGridColor());
                Compnt = box;
            } else if (col == 0) {
                javax.swing.JLabel box = new javax.swing.JLabel();
                java.awt.Color ui_col = box.getBackground();
                box.setOpaque(true);
                if (col == 0) {
                    if (hasFocus) {
                        box.setBackground(ui_col.darker());
                    } else {
                        box.setBackground(ui_col);
                    }
                    box.setText("" + value);
                    box.setBorder(javax.swing.BorderFactory.createMatteBorder(1, 1, 0, 0, Color.white));
                }
                Compnt = box;
            } else if (value instanceof String) {
                javax.swing.JLabel box = new javax.swing.JLabel();
                box.setOpaque(true);
                String str = (String) value;
                if (str.length() == 0) {
                    if (isEnable.isSelected()) {
                        color = java.awt.Color.GREEN;
                    } else {
                        color = new java.awt.Color(220, 220, 220);
                    }
                } else {
                    box.setBackground(java.awt.Color.lightGray);
                }

                box.setText(value.toString());
                Compnt = box;
            } else if (value instanceof com.jdcm.modifiers.stacks.I_stack_elt) {
                javax.swing.JLabel box = new javax.swing.JLabel();
                box.setOpaque(true);
                box.setText(value.toString());
                com.jdcm.modifiers.stacks.I_stack_elt module = (com.jdcm.modifiers.stacks.I_stack_elt) value;
                if (module.isfrommedia()) {
                    if (module.isdebug()) {
                        box.setIcon(TUtils.getIcon("down_dbg.gif"));
                    } else {
                        box.setIcon(TUtils.getIcon("down.gif"));
                    }
                } else {
                    if (module.isdebug()) {
                        box.setIcon(TUtils.getIcon("up_dbg.gif"));
                    } else {
                        box.setIcon(TUtils.getIcon("up.gif"));
                    }
                }
                color = java.awt.Color.pink;
                Compnt = box;
            }
            if (color != null && Compnt != null) {
                if (isSelected) {
                    if (hasFocus) {
                        Compnt.setBackground(color.darker().darker());
                    } else {
                        Compnt.setBackground(color.darker());
                    }
                } else {
                    Compnt.setBackground(color);
                }
            }
            return Compnt;
        }
    }
}

/**
 * This will be a tree model manage Ports , stacks,?.. change
 *
 * @version 1.10 07/26/04
 * @author Marc GIBOIN
 */
class MainTreeModel implements javax.swing.tree.TreeModel {

    private final C_Main Parent;
    private final java.util.List<javax.swing.event.TreeModelListener> addtreeModelListeners = new java.util.ArrayList<>();
    private final java.util.List<javax.swing.event.TreeModelListener> removetreeModelListeners = new java.util.ArrayList<>();
    private java.util.List<Object> utils = new java.util.ArrayList<>();

    public MainTreeModel(C_Main main) {
        Parent = main;
    }

    public void remove(Object o) {
        if (utils.indexOf(o) >= 0) {
            utils.remove(o);
        }

        javax.swing.event.TreeModelEvent e = new javax.swing.event.TreeModelEvent(this, new Object[]{o});//Parent
        for (javax.swing.event.TreeModelListener tml : removetreeModelListeners) {
            tml.treeNodesRemoved(e);
        }
        //else conf is not removed at start...??? but null pointrs on remove...
        try {
            fireTreeStructureChanged(Parent);
        } catch (Exception ex) {
        }
    }

    public void add(Object o) {
        if (utils.indexOf(o) < 0) {
            utils.add(o);
        }
        javax.swing.event.TreeModelEvent e = new javax.swing.event.TreeModelEvent(this, new Object[]{o});//Parent,Parent.getPorts(), utils
        for (javax.swing.event.TreeModelListener tml : addtreeModelListeners) {
            tml.treeNodesInserted(e);
        }
        try {
            this.fireTreeStructureChanged(Parent);
        } catch (Exception ex) {
        }
    }

    private void initTree() {
        // !!part of fireTreeStructureChanged
        utils = new java.util.ArrayList<>();
        if (Parent.getMat_Type().compareTo("OFF") != 0) {
            utils.addAll(Parent.getCMDChilds("Matrix"));
        }
        if (Parent.isConf_Enabled()) {
            utils.addAll(Parent.getCMDChilds("Conf"));
        }
        if (Parent.isStack_Enabled()) {
            utils.addAll(Parent.getCMDChilds("Stacks"));
        }
    }

    @Override
    public Object getRoot() {
        return Parent;
    }

    protected void fireTreeStructureChanged(C_Main main) {
        initTree();
        javax.swing.event.TreeModelEvent e = new javax.swing.event.TreeModelEvent(this, new Object[]{main});
        for (javax.swing.event.TreeModelListener tml : addtreeModelListeners) {
            tml.treeStructureChanged(e);
        }
        for (javax.swing.event.TreeModelListener tml : removetreeModelListeners) {
            tml.treeStructureChanged(e);
        }
    }

    @Override
    public Object getChild(Object o, int i) {
        if (o == Parent) {
            if (i < utils.size()) {
                return utils.get(i);
            } else if (i < utils.size() + Parent.getPorts().size()) {
                int res = utils.size();
                for (I_Port p : Parent.getPorts()) {
                    if (p instanceof C_Port && ((C_Port) p).getListener() == null) {
                        if (res == i) {
                            return p;
                        }
                        res++;
                    }
                }
            }
        } else if (o instanceof C_Port && i == 0) {
            if (((C_Port) o).getSlave() instanceof I_Command) {
                return ((C_Port) o).getSlave();
            }
            int target = 0;
            for (I_Port p : Parent.getPorts()) {
                if (p instanceof C_Port && ((C_Port) p).getListener() == o) {
                    if (target == i) {
                        return p;
                    }
                    target++;
                }
            }
        }
        return null;
    }

    @Override
    public int getChildCount(Object o) {
        if (o == Parent) {
            int res = 0;
            for (I_Port p : Parent.getPorts()) {
                if (p instanceof C_Port && ((C_Port) p).getListener() == null) {
                    res++;
                }
            }
            //      System.out.println("__main : "+(utils.size() +res));
            return utils.size() + res;
        } else if (o instanceof C_Port) {
            if (((C_Port) o).getSlave() instanceof I_Command) {
                return 1;
            } else if (((C_Port) o).getModeName().startsWith("IPL4") && ((C_Port) o).getTCP_Mode().compareTo("TCP_L") == 0) {
                int res = 0;
                for (int k = 0; k < Parent.getPorts().size(); k++) {
                    if (Parent.getPorts().get(k) instanceof C_Port && ((C_Port) Parent.getPorts().get(k)).getListener() == o) {
                        res++;
                    }
                }
                //           System.out.println("__port : "+((C_Port) o).getCMDName()+":"+res);
                return res;
            } else {
                return 0;
            }
        } else if (utils.contains(o)) {
            return 0;
        }
        return -1;
    }

    @Override
    public int getIndexOfChild(Object o, Object o1) {
        if (o == Parent) {
            if (o1 instanceof I_Port && ((I_Port) o1).getModeName().startsWith("IPL4")) {
                int res = 0;
                for (I_Port p : Parent.getPorts()) {
                    if (p instanceof C_Port && ((C_Port) p).getListener() == null) {
                        if (p == o1) {
                            //   System.out.println("port : "+p+ (utils.size() + res));
                            return utils.size() + res;
                        }
                        res++;
                    }
                }
            } else {
                // System.out.println("util : "+o1+ ( utils.indexOf(o1)));
                return utils.indexOf(o1);
            }
        } else if (o1 instanceof C_Port && ((C_Port) o1).getListener() == o) {
            int res = 0;
            for (I_Port p : Parent.getPorts()) {
                if (p instanceof C_Port && ((C_Port) p).getListener() == o) {
                    if (p == o1) {
                        //                     System.out.println("port L : "+o1+ res);
                        return res;
                    }
                    res++;
                }
            }
        } else if (o instanceof C_Port && ((C_Port) o).getSlave() == o1) {
            return 0;
        }
        return -1;
    }

    @Override
    public boolean isLeaf(Object o) {
        if (o == Parent) {
            return utils.isEmpty() && Parent.getPorts().isEmpty();
        } else if (utils.contains(o)) {
            return true;
        } else if (o instanceof C_Port && ((C_Port) o).getListener() != null) {
            return true;
        } else if (o instanceof C_Port && ((C_Port) o).getSlave() == null) {
            return true;
        } else if (o instanceof F_Terminal) {
            return true;
        }
        return getChildCount(o) == 0;
    }

    @Override
    public void valueForPathChanged(TreePath tp, Object o) {
    }

    @Override
    public void addTreeModelListener(TreeModelListener tl) {
        addtreeModelListeners.add(tl);
    }

    @Override
    public void removeTreeModelListener(TreeModelListener tl) {
        removetreeModelListeners.add(tl);
    }
}

/**
 * This class listens for UISwitches, and updates a given component.
 *
 * @version 1.10 07/26/04
 * @author Marc GIBOIN
 */
class UISwitchListener implements PropertyChangeListener {

    private final JComponent componentToSwitch;

    public UISwitchListener(JComponent c) {
        componentToSwitch = c;
    }

    @Override
    public void propertyChange(PropertyChangeEvent e) {
        String name = e.getPropertyName();
        if (name.equals("lookAndFeel")) {
            javax.swing.SwingUtilities.updateComponentTreeUI(componentToSwitch);
            componentToSwitch.invalidate();
            componentToSwitch.validate();
            componentToSwitch.repaint();
        }
    }
}

class F_MainRenderer extends javax.swing.CellRendererPane implements TableCellRenderer {

    private static final long serialVersionUID = 1L;

    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        if (value instanceof Component) {
            Component comp = (Component) value;
            if (!table.isCellEditable(row, column)) {
                comp.setEnabled(false);
            }
            return comp;
        }
        javax.swing.JLabel lb = new javax.swing.JLabel(value.getClass().toString());
        return lb;
    }
}
