package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;
import com.jdcm.editors.I_ObjectReceiver;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.io.*;
import java.lang.reflect.InvocationTargetException;
import java.util.Arrays;
import javax.swing.JOptionPane;

/**
 * Created on 9 novembre 2007, 22:01
 *
 * SIMPLE TERMINAL for planned Tasks<br> never used on ..build (work?)...<br>
 *
 * @author Marc GIBOIN
 */
public class F_Talc extends javax.swing.JFrame implements I_Terminal {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Debug TDeb;
    private final java.util.List<String> docnames = new java.util.ArrayList<>();

    private C_Port Parent;
    private java.util.List<Byte> Streambuff;
    boolean cont = true;
    private javax.swing.JPanel panel = null;

    /**
     * Creates new form NewJFrame
     */
    public F_Talc() {
        initComponents();
        // should be something to switch UI when Main ask new UILook&Feel
        //  UIManager.addPropertyChangeListener(new UISwitchListener((JComponent) getRootPane()));
        this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        TDeb = new D_Debug("Talc");
    }

    public F_Talc(C_Port P) {
        Parent = P;
        initComponents();

        /*         addComponentListener(new ComponentAdapter() {
         // Give the window an RoundRectangle2D shape.
         // If the window is resized, the shape is recalculated here.
         @Override
         public void componentResized(ComponentEvent e) {
         setShape(new java.awt.geom.RoundRectangle2D.Double(0,0,getWidth(),getHeight(),50,50));
         }
            
         });*/
        TDeb = new D_Debug("Talc : [" + Parent.getIndex() + "]");
        TDeb.setconsole(Parent.getConsole());
    }

    /**
     * Start the slave<br>
     *
     * @return 0 if slave is started correctly
     */
    @Override
    public int sl_start() {
        return 0;
    }

    /**
     * Open the slave<br>
     *
     * @return 0 if slave is Opened correctly
     */
    @Override
    public int sl_open() {
        try {
            Parent.setin(getInputStream());
            Parent.setout(getOutputStream());
        } catch (IOException e) {
            Parent.CXerror("TALC : Couldn't get the connection to the 'in/out' stream.");
            return -1;
        }
        setVisible(true);
        setSize(new java.awt.Dimension(
                panel.getPreferredSize().width + 5,
                panel.getPreferredSize().height + 30 + jMenuBar1.getHeight()));
        try {
            com.jdcm.common.D_Utils.addOpacytyListner((javax.swing.JFrame) Parent.getSlave());
            ((javax.swing.JFrame) Parent.getSlave()).setOpacity(1.0f);
        } catch (Exception ex) {
        }
        return 0;
    }

    /**
     * Stop the slave<br>
     *
     * @return 0 if slave is Stoped correctly
     */
    @Override
    public int sl_close() {
        if (panel != null) {
            if (panel != null && panel instanceof I_ObjectReceiver) {
                ((I_ObjectReceiver) panel).receiveObj("/CLOSE TALC/");
            }
        }
        setVisible(false);
        return 0;
    }

    private String getPanelVersion() {
        String ver = "" + serialVersionUID;
        try {
            java.lang.reflect.Method m = (new com.jdcm.common.D_Utils()).getMethod(panel.getClass(), "getVersion", new Class<?>[]{});
            if (m != null) {
                try {
                    ver = m.invoke(panel, new Object[]{}).toString();
                } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                }
            }
        } catch (Exception ex) {
        }
        return ver;
    }

    public String getDocName(int i) {
        String name = docnames.get(i);
        int pos = name.lastIndexOf(".");
        if (pos >= 0) {
            return name.substring(0, pos) + "-v" + getPanelVersion() + name.substring(pos);
        } else {
            return name + "-v" + getPanelVersion();
        }
    }

    public void addDocName(String txt) {
        docnames.add(txt);
    }

    private javax.swing.JMenuItem[] getDocItemBoxes() {
        if (docnames == null || docnames.isEmpty()) {
            return null;
        } else {
            javax.swing.JMenuItem[] items = new javax.swing.JMenuItem[docnames.size()];
            for (int docidx = 0; docidx < docnames.size(); docidx++) {
                final int idx = docidx;
                final javax.swing.JMenuItem item = new javax.swing.JMenuItem("Doc-" + getDocName(docidx));
                item.setActionCommand("?");
                item.addActionListener(new java.awt.event.ActionListener() {
                    @Override
                    public void actionPerformed(ActionEvent e) {
                        com.jdcm.common.D_Utils TUtils = new com.jdcm.common.D_Utils();
                        java.io.File src = TUtils.getFile(getDocName(idx), "Doc");
                        if (src != null) {
                            try {
                                java.io.InputStream srcstr = TUtils.getFileStream(src);
                                java.io.File dumy = new java.io.File(getDocName(idx));
                                String dstname = TUtils.getUIsaveFile(null, true, dumy);
                                if (dstname != null && srcstr != null) {
                                    java.io.OutputStream deststr = TUtils.getstream(dstname);
                                    if (deststr != null) {
                                        byte[] buffer = new byte[512 * 1024];
                                        int nblecture;

                                        while ((nblecture = srcstr.read(buffer)) != -1) {
                                            deststr.write(buffer, 0, nblecture);
                                        }
                                        deststr.close();
                                        srcstr.close();

                                    }
                                }
                            } catch (IOException ex) {
                                 System.out.println("F_Talc : getDocItemBoxes()=>" + ex);
                            }
                        }
                    }
                });
                items[docidx] = item;
            }
            return items;
        }
    }

    public void addPanel(String txt) {
        try {
            String classeName = txt;
            if (!txt.startsWith("com.")) {
                classeName = "com.jdcm.editors." + txt;
            }
            Class<?> cl = Class.forName(classeName);
            if (cl != null && javax.swing.JPanel.class.isAssignableFrom(cl) && com.jdcm.editors.I_ObjectReceiver.class.isAssignableFrom(cl)) {
                panel = (javax.swing.JPanel) cl.newInstance();
                panel.setVisible(true);
                java.awt.Dimension d = panel.getPreferredSize();
                jPanel1.add(BorderLayout.CENTER, panel);
                if (panel instanceof I_ObjectReceiver) {
                    ((I_ObjectReceiver) panel).receiveObj(Parent);
                }
                setTitle(panel.getName());
                //SET ICONE if a getIcon() is present in panel(B_....)
                java.lang.reflect.Method m = (new com.jdcm.common.D_Utils()).getMethod(panel.getClass(), "getIcon", new Class<?>[]{});
                if (m != null) {
                    try {
                        setIconImage((java.awt.Image) m.invoke(panel, new Object[]{}));
                    } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                    }
                }

                java.lang.reflect.Method m2 = (new com.jdcm.common.D_Utils()).getMethod(panel.getClass(), "getMenus", new Class<?>[]{});
                if (m2 != null) {
                    try {
                        Object ob = m2.invoke(panel, new Object[]{});
                        if (ob != null && java.util.List.class.isAssignableFrom(ob.getClass())) {
                            setMenus((java.util.List<javax.swing.JMenuItem>) ob);
                        }
                    } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                    }
                }
                // should be a beter way with FrameInsets? or decoratio size?..??
                setPreferredSize(new java.awt.Dimension(
                        panel.getPreferredSize().width + 5,
                        panel.getPreferredSize().height + 30 + jMenuBar1.getHeight()));
                setMaximumSize(new java.awt.Dimension(
                        panel.getMaximumSize().width + 5,
                        panel.getMaximumSize().height + 30 + jMenuBar1.getHeight()));
                setMinimumSize(new java.awt.Dimension(
                        panel.getMinimumSize().width + 5,
                        panel.getMinimumSize().height + 30 + jMenuBar1.getHeight()));

                // not working on stand alone configuration ??
                // com.jdcm.common.D_Utils.addOpacytyListner(this);
                // setOpacity(1.0f);
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException ex) {
            System.out.println("TALC =>" + ex.getMessage());
        }
    }

    private void setMenus(java.util.List<javax.swing.JMenuItem> items) {
        if (items != null) {
            javax.swing.JMenuItem[] docitems = getDocItemBoxes();
            if (docitems != null && docitems.length > 0) {
                items.addAll(Arrays.asList(docitems));
            }
            for (javax.swing.JMenuItem item : items) {
                if (item != null) {
                    String title = item.getActionCommand();
                    for (int i = 0; i < jMenuBar1.getMenuCount(); i++) {
                        if (jMenuBar1.getMenu(i).getText().compareTo(title) == 0) {
                            jMenuBar1.getMenu(i).add(item);
                            title = "";
                        }
                    }
                    if (title.length() > 0) {
                        javax.swing.JMenu menu = new javax.swing.JMenu(title);
                        jMenuBar1.add(menu, 0);
                        menu.add(item);
                    }
                }
            }
        }
    }

    @Override
    public int getinsize() {
        return 0;
    }

    @Override
    public int StreambuffSize() {
        if (Streambuff == null) {
            return -1;
        }
        return Streambuff.size();
    }

    @Override
    public int write(C_Packet d) {
        if (d == null) {
            return 0;
        }
        if (panel != null && panel instanceof I_ObjectReceiver) {
            ((I_ObjectReceiver) panel).receiveObj(d);
        }
        return 0;
    }

    @Override
    public int readStreambuff() {
        if (Streambuff.isEmpty()) {
            return -9999;
        }
        return (int) Streambuff.remove(0);
    }

    @Override
    public InputStream getInputStream() throws java.io.IOException {
        if (Parent.getin() == null) {
            return new TermInputStream2(this);
        } else {
            return Parent.getin();
        }
    }

    @Override
    public OutputStream getOutputStream() throws java.io.IOException {
        if (Parent.getout() == null) {
            return new TermOutputStream2(this);
        } else {
            return Parent.getout();
        }
    }

    @Override
    public void setextTitle(String exttitle) {
        this.setTitle(this.getTitle() + " " + exttitle);
    }

    private long getGlobalHash() {
        long res = this.hashCode();
        if (Parent != null) {
            if (Parent.getMain() != null) {
                res += Parent.getMain().hashCode();
            }
            if (Parent.getMain().getPorts() != null) {
                res += Parent.getMain().getPorts().hashCode();
            }
        }
        if (panel != null) {
            res += panel.hashCode();
        }
        return res;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();

        jPanel1.setLayout(new java.awt.BorderLayout());
        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        jMenu1.setText("?");

        jMenuItem1.setText("Help");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        String txt = " Terminal A La Con ";

        if (Parent != null && Parent.getMain() instanceof C_Main) {
            txt = ((C_Main) Parent.getMain()).getHelpText();
        }
        if (panel != null) {
            txt += "-----------------------------------------------\r\n"
                    + "Application : " + panel.getName() + "\r\n"
                    + "-----------------------------------------------\r\n"
                    + "Hash :\t " + getGlobalHash() + "\r\n"
                    + "Class \t: " + panel.getClass().toString() + "\r\n"
                    + "Version \t: " + getPanelVersion() + "\r\n"
                    + "-----------------------------------------------";
        } else {
            txt += "-----------------------------------------------\r\n"
                    + "Hash :\t" + getGlobalHash() + "\r\n";
        }
        JOptionPane.showMessageDialog(this, txt, "About box", JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new F_Talc().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables

    @Override
    public void start() {
        // throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
}
