package com.jdcm.eltrx;

import com.jdcm.analyse.P_CodeEditor;
import com.jdcm.analyse.Code_Model;
import com.jdcm.common.C_Packet;
import com.jdcm.charts.P_Chartplus;
import com.jdcm.common.*;
import java.awt.event.KeyEvent;
import javax.swing.RowSorter;
import javax.swing.SortOrder;
import java.io.*;
import java.awt.*;
import java.util.*;
import javax.swing.JTextPane;
import javax.swing.text.*;
import java.sql.SQLException;
import javax.swing.table.*;
import com.jdcm.editors.*;
import java.awt.event.ComponentEvent;
import java.awt.event.MouseEvent;
import java.lang.reflect.Field;
import javax.swing.DefaultComboBoxModel;
import com.jdcm.modifiers.stacks.Stack_base;

/**
 * F_terminal.java Created on 23 juillet 2006, 19:22
 *
 * Display a complete byte[]/object stream visualisation<br> with panel for
 * analyse/graph
 *
 * @author Marc GIBOIN
 */
public class F_Terminal extends javax.swing.JFrame implements I_Terminal, I_Command {
    // for serializable interface

    public static final String[] outModes = {"OUTPUT_PACKET", "OUTPUT_TRAME", "OUTPUT_SCREEN", "OUTPUT_CONSOLE", "OUTPUT_SCREENLOCK"};
    private static final long serialVersionUID = 1L;
    private static final int INPUT_ASCII = 0;
    private static final int INPUT_HEX = 1;
    private static final int INPUT_OBJ = 2;
    private final D_Debug TDeb;
    private final D_Utils TUtils = new D_Utils();
    //the port using this terminal
    private C_Port Parent = null;
    //the console used by this terminal
    private I_Console Console = null;
    private P_CodeEditor deceditor = null;
    private F_PopUp fdecode = null;
    private P_Chartplus termgraph = null;
    private F_PopUp fgraph = null;
    private P_TableEditor table = null;
    private java.util.List<Byte> Streambuff;
    private Term_Model2 model;
    private C_Packet[] clipboard = null;
    // for Standalone mode
    private InputStream local_in = null;
    private OutputStream local_out = null;
    private java.awt.Color local_col = java.awt.Color.BLACK;
    private boolean oldEcho = false;
    // the screen/console texte Editor
    private P_Texte jTexte1 = null;
    //color used for additionel packet information => Purple
    private Options_Model option;

    /**
     * Construc a stand alone Termainal
     */
    public F_Terminal() {
        TDeb = new D_Debug("Terminal");
        initComponents();
        setTitle("Terminal");
        try {
            local_in = getInputStream();
            local_out = getOutputStream();
        } catch (IOException ex) {
        }
        initialisation();
        setVisible(true);
        // no reasons but NOT WORKING (Port Parent mandatory for decode/encode)
        setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
    }

    /**
     * Creates new form F_terminal as Port in/ou
     *
     * @param P the port managing terminal
     */
    public F_Terminal(C_Port P) {
        Parent = P;
        Console = Parent.getConsole();
        TDeb = new D_Debug("Term.: [" + Parent.getIndex() + "]");
        TDeb.setconsole(Console);
        initComponents();
        Parent.setslreading(true);
        oldEcho = Parent.isEcho();
        Parent.setEcho(true);
        setTitle("Terminal");
        initialisation();
        setVisible(true);
        if (Parent.getIndex() < 0) {
            // disable edition because routing to Main is not available.
            jToggleButton6.setEnabled(false);
        }
        setlockedin(Parent.islockin());
        //doskey = new List<byte[]>();
    }

    /**
     * Creates new form F_terminal for Main(traffic panel)
     *
     * @param P the console that link Terminal
     */
    public F_Terminal(I_Console P) {
        Console = P;
        TDeb = new D_Debug("Term.: [traffic]");
        TDeb.setconsole(Console);
        initComponents();
        setTitle("Traffic");
        try {
            local_in = getInputStream();
            local_out = getOutputStream();
        } catch (IOException ex) {
        }
        initialisation();
        setVisible(false);
        setlockedin(false);
        setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
    }

    /**
     * create the form for applet/sub form<br> if isapplet then close do not
     * exit system <br>
     *
     * @param isaplet true if usedin appelt (close && stream)
     */
    public F_Terminal(boolean isaplet) {
        TDeb = new D_Debug("Terminal");
        initComponents();
        setTitle("Terminal");
        try {
            local_in = getInputStream();
            local_out = getOutputStream();
        } catch (IOException ex) {
        }
        initialisation();
        setVisible(isaplet == false);
    }

    /**
     * Start the slave<br>
     *
     * @return 0 if slave is started correctly
     */
    @Override
    public int sl_start() {
        return 0;
    }

    /**
     * Open the slave<br>
     *
     * @return 0 if slave is Opened correctly
     */
    @Override
    public int sl_open() {
        setextTitle(Parent.getPortName());
        // for aplet needeed in constructor  : setVisible(true);
        try {
            Parent.setin(getInputStream());
            Parent.setout(getOutputStream());
        } catch (IOException e) {
            Parent.CXerror("Terminal : Couldn't get the connection to the 'in/out' stream.");
            return -1;
        }
        return 0;
    }

    /**
     * Stop the slave<br>
     *
     * @return 0 if slave is Stoped correctly
     */
    @Override
    public int sl_close() {
        setVisible(false);
        if (Parent != null) {
            Parent.setEcho(oldEcho);
        }
        return 0;
    }

    @Override
    public void start() {
        throw new UnsupportedOperationException("Not supported yet.");
        //Managed by frame, for compatibility with Thread slaves
    }

    /**
     * Initialise the GUI Part with Mouses listner
     */
    private void initialisation() {
        setLocation(200, 10);
        initOptions();
        setIconImage(TUtils.getImage("Terminal.gif"));
        jButton7.setIcon(TUtils.getIcon("Save.gif"));

        jButton3.setIcon(TUtils.getIcon("Empty.gif"));
        jButton9.setIcon(TUtils.getIcon("return.gif"));
        jButton10.setIcon(TUtils.getIcon("Open.gif"));
        jRollingButton1.addValuedItem(TUtils.getIcon("bytes.gif"), "OUTPUT_PACKET");
        jRollingButton1.addValuedItem(TUtils.getIcon("Object.gif"), "OUTPUT_TRAME");
        jRollingButton1.addValuedItem(TUtils.getIcon("Console.gif"), "OUTPUT_CONSOLE");
        jRollingButton1.addValuedItem(TUtils.getIcon("Screen.gif"), "OUTPUT_SCREEN");
        //  jRollingButton1.addValuedItem(TUtils.getIcon("ScreenLock.gif"), "OUTPUT_SRCREENLOCK");
        jRollingButton2.addValuedItem(TUtils.getIcon("Screen.gif"), "Text");
        jRollingButton2.addValuedItem(TUtils.getIcon("bytes.gif"), "Byte");
        jRollingButton3.addValuedItem(TUtils.getIcon("send_btn.gif"), "BTN");
        jRollingButton3.addValuedItem(TUtils.getIcon("send_key.gif"), "KEY");
        jRollingButton3.addValuedItem(TUtils.getIcon("send_enter.gif"), "ENTER");
        jRollingButton4.addValuedItem(TUtils.getIcon("Ascii.gif"), INPUT_ASCII);
        jRollingButton4.addValuedItem(TUtils.getIcon("Hexa.gif"), INPUT_HEX);
        jRollingButton4.addValuedItem(TUtils.getIcon("Object.gif"), INPUT_OBJ);
        g_JRollingButton1.addValuedItem(TUtils.getIcon("time_hour.gif"), "HOUR");
        g_JRollingButton1.addValuedItem(TUtils.getIcon("time_day.gif"), "DAY");
        g_JRollingButton1.addValuedItem(TUtils.getIcon("time_delta.gif"), "DELTA");
        g_JRollingButton1.addValuedItem(TUtils.getIcon("time_first.gif"), "FIRST");
        jToggleButton1.setSelectedIcon(TUtils.getIcon("build_on.gif"));
        jToggleButton1.setIcon(TUtils.getIcon("locked.gif"));
        setSendbt("BTN");
        jToggleButton8.setIcon(TUtils.getIcon("graph.gif"));
        jToggleButton2.setIcon(TUtils.getIcon("BackSpaceOff.gif"));
        jToggleButton2.setSelectedIcon(TUtils.getIcon("BackSpaceOn.gif"));
        jToggleButton3.setIcon(TUtils.getIcon("echo_off.gif"));
        jToggleButton3.setSelectedIcon(TUtils.getIcon("echo_on.gif"));
        jToggleButton4.setIcon(TUtils.getIcon("Entry_clear.gif"));
        jToggleButton4.setSelectedIcon(TUtils.getIcon("Entry_keep.gif"));
        jToggleButton6.setIcon(TUtils.getIcon("Viewoff.gif"));
        jToggleButton6.setSelectedIcon(TUtils.getIcon("View.gif"));
        jToggleButton7.setIcon(TUtils.getIcon("dir_bidir.gif"));
        jToggleButton7.setSelectedIcon(TUtils.getIcon("dir_out.gif"));
        jToggleButton9.setIcon(TUtils.getIcon("Decode.gif"));
        jToggleButton9.setSelectedIcon(TUtils.getIcon("Decode.gif"));
        if (Parent == null) {
            jButton10.setEnabled(false);
        }
        setTecho(oldEcho);
        setTerm_inMode(INPUT_ASCII);
        setclear(true);
        jTable3.setEditingColumn(0);
        jTable3.setValueAt(null, 0, 0);
        // getColumnEditor
        jTable3.getColumnModel().getColumn(0).setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jTable3.getColumnModel().getColumn(0).setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>(true, true));
        if (Parent != null) {
            model = new Term_Model2(Parent.getMain());
        } else {
            model = new Term_Model2(null);
        }
        jTable1.setModel(model);
        jTable1.setRowHeight((new javax.swing.JTextArea()).getPreferredSize().height);//heigther, will be ajust wih Text UI prefered height of the render    
        //----------------- TRANSFERT CLIPBOARD-----------------------
        jTable1.setTransferHandler(new C_TransferHandler(javax.swing.TransferHandler.COPY) {
            // for serializable interface
            private static final long serialVersionUID = 1L;

            @Override
            public Object getDataToExport(java.awt.Component srccomp) {
                C_Packet[] packs = getselectedpackets();
                if (packs == null || packs.length == 0) {
                    return null;
                } else if (packs.length == 1) {
                    return packs[0];
                } else {
                    return packs;
                }
            }
        });
        C_TransferHandler copyhdl = new C_TransferHandler(javax.swing.TransferHandler.COPY) {
            //avoid the default serialisation for system copy/cut & paste
            // for serializable interface
            private static final long serialVersionUID = 1L;

            @Override
            public java.awt.datatransfer.Transferable createTransferable(javax.swing.JComponent comp) {
                String txt = ((javax.swing.text.JTextComponent) comp).getText();
                return new java.awt.datatransfer.StringSelection(txt);
            }

            @Override
            public boolean setInportedData(Object transfered, java.awt.Component target) {
                javax.swing.text.JTextComponent txt = (javax.swing.text.JTextComponent) target;
                String ajout = null;
                if (transfered instanceof byte[]) {
                    if (getTerm_inMode() == INPUT_HEX) {
                        ajout = TUtils.Formate_Hexa((byte[]) transfered, true);
                    } else if (getTerm_inMode() == INPUT_ASCII) {
                        ajout = TUtils.Formate_toString((byte[]) transfered);
                    } else if (getTerm_inMode() == INPUT_OBJ) {
                        jTable3.setValueAt(transfered, 0, 0);
                    }
                } else if (transfered instanceof String) {
                    if (getTerm_inMode() == INPUT_HEX) {
                        ajout = transfered.toString();
                        //TUtils.Formate_Hexa(transfered.toString().getBytes(), true);
                    } else if (getTerm_inMode() == INPUT_ASCII) {
                        ajout = transfered.toString();
                    } else if (getTerm_inMode() == INPUT_OBJ) {
                        jTable3.setValueAt(transfered, 0, 0);
                    }
                } else {
                    setInput(transfered);
                    return true;
                }
                if (ajout != null) {
                    int poscurs = txt.getCaretPosition();
                    if (txt.getSelectionStart() < txt.getSelectionEnd()) {
                        txt.setText(txt.getText().substring(0, txt.getSelectionStart())
                                + txt.getText().substring(txt.getSelectionEnd()));
                    }
                    txt.setText(txt.getText().substring(0, poscurs) + ajout + txt.getText().substring(poscurs));
                }
                if (txt.getKeyListeners().length > 0) {
                    txt.getKeyListeners()[0].keyReleased(null);
                }
                return true;
            }
        };
        jTable1.getTableHeader().setToolTipText(
                "Click to sort; Shift-Click to sort in reverse order");
        //----------------- TEXTE EVENTS LISTNERS-----------------------
        jTexte1 = new P_Texte();
        jTexte1.setType("PACK");
        jTexte1.setVisible(true);
        jTexte1.setStatusBar(true);
        javax.swing.ActionMap am = new javax.swing.ActionMap();
        // Unused ?: am.put("copy", jTexte1.getTextePane().getActionMap().get("copy"));
        // TODO : C_TransferHandler for 
        //=> NOT WORKING :  am.put("paste", jTexte1.getTextePane().getActionMap().get("paste"));
        am.put("copy-to-clipboard", jTexte1.getTextePane().getActionMap().get(DefaultEditorKit.copyAction));
        /*  am.put("paste", jTexte1.getTextePane().getActionMap().get(DefaultEditorKit.pasteAction));
         am.put("back", jTexte1.getTextePane().getActionMap().get(DefaultEditorKit.backwardAction));*/

        jTexte1.getTextePane().setActionMap(am);
        jTexte1.setStatusText("");
        for (java.awt.event.MouseListener m : jTexte1.getTextePane().getMouseListeners()) {
            //          jTexte1.getTextePane().removeMouseListener(m);
        }
        jTexte1.getTextePane().setComponentPopupMenu(jPopupMenu1);
        ((G_NonWrappingTextPane) jTexte1.getTextePane()).addAfterPaintListner(
                new com.jdcm.common.G_NonWrappingTextPane.AfterPaintEventListner() {
                    @Override
                    public void afterPaintComponent(Graphics g) {
                        if (isEditing()) {
                            drawPackets(g);
                        }
                    }
                });

        jTexte1.getTextePane().addMouseListener(new java.awt.event.MouseAdapter() {
            @Override
            public void mouseReleased(MouseEvent e) {
                //  super.mouseReleased(e);
                if (e.getButton() == 1) {
                    selectPacket(e);
                    jTexte1.setStatusText(getPacketToolTip(e.getPoint()));
                    if (isAutoDecode()) {
                        groupAndDecodeRows();
                    }

                }
            }
        });
        /*
         * Only set the Caret at the end
         */
        jTexte1.getTextePane().addKeyListener(new java.awt.event.KeyAdapter() {
            @Override
            public void keyPressed(java.awt.event.KeyEvent evt) {
                javax.swing.JTextPane jTextPane1 = jTexte1.getTextePane();
                if (evt.getKeyCode() != 16 && evt.getKeyCode() != 27
                        && evt.isControlDown() == false && evt.isAltDown() == false
                        && evt.isAltGraphDown() == false) {
                    //Pb it seems that CRLF(/paragraphe??) are not managed in setCaretPosition
                    //TODO: ALT0001=>0x01... CtrlC=>0x03
                    if (jTextPane1.getCaretPosition() < jTextPane1.getText().length()) {
                        int pos = jTextPane1.getText().length();
                        boolean isok = false;
                        while (isok == false) {
                            try {
                                jTextPane1.setCaretPosition(pos);
                                isok = true;
                            } catch (Exception ex) {
                                pos -= 1;
                                isok = false;
                            }
                        }
                    }
                }
            }

            /**
             * Manage Key input ESC= consolescreen BS(08) erase last car
             */
            @Override
            public void keyReleased(java.awt.event.KeyEvent evt) {
                if (getTerm_outMode().compareTo("OUTPUT_CONSOLE") == 0) {
                    if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
                        setTerm_outMode("OUTPUT_SCREEN");
                    }
                } else if (getTerm_outMode().compareTo("OUTPUT_SCREEN") == 0) {
                    if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
                        setTerm_outMode("OUTPUT_CONSOLE");
                    } else if (!islockedin()) {
                        int code = evt.getKeyCode();
                        if (code == KeyEvent.VK_ENTER) {
                            // to avoid Pb with DOS should be a parameter \r or\r\n
                            readTerm("\r\n".getBytes());
                            if (getSendbt().compareTo("ENTER") == 0) {
                                Parent.ReadStream(-1);
                            }
                        } else if (code == KeyEvent.VK_BACK_SPACE) {
                            //BS is managed on reception 
                            readTerm(("" + evt.getKeyChar()).getBytes());
                            // }
                        } else if (evt.isActionKey() == false && code != KeyEvent.VK_SHIFT
                                && code != KeyEvent.VK_ALT && code != KeyEvent.VK_CONTROL) {
                            readTerm(("" + evt.getKeyChar()).getBytes());
                        }
                        if (getSendbt().compareTo("KEY") == 0) {
                            Parent.ReadStream(-1);
                        }
                    }
                }
            }
        });
        setEditing(false);
        jTextPane2.setTransferHandler(copyhdl);
        jTable3.setTransferHandler(copyhdl);
        jTable1.setDragEnabled(true);
        Streambuff = new java.util.ArrayList<>();
        jScrollPane2.setVerticalScrollBar(new G_AutoScrollBar());
        jTexte1.setAutoScroll(isTerm_autoScroll());
        setTerm_autoScroll(isTerm_autoScroll());
        if (Parent != null) {
            setTerm_outMode(Parent.getTerm_outMode());
        } else {
            setTerm_outMode("OUTPUT_PACKET");
        }
    }

    public void setTerm_autoScroll(boolean bool) {
        G_AutoScrollBar ascr = ((G_AutoScrollBar) jScrollPane2.getVerticalScrollBar());
        if (ascr.isAutoScroll() != bool) {
            ascr.setAutoScroll(bool);
        }
        if (jTexte1.isAutoScroll() != bool) {
            jTexte1.setAutoScroll(bool);
        }
        jTexte1.setAutoScroll(isTerm_autoScroll());
        if (option.getValuefor("Term_autoScroll", true) != bool) {
            option.setValuefor("Term_autoScroll", bool);
        }
    }

    public void setSelectedPackets(C_Packet[] packs) {
        if (packs == null || packs.length == 0) {
            jTable1.removeRowSelectionInterval(0, model.getTraces().size() - 1);
        } else {
            for (C_Packet pack : packs) {
                int row = model.getTraces().indexOf(pack);
                if (row >= 0) {
                    jTable1.addRowSelectionInterval(row, row);
                }
            }
        }
    }

    public boolean isTerm_autoScroll() {
        return option.getValuefor("Term_autoScroll", true);
    }

    public void setTerm_statusBar(boolean bool) {
        jTexte1.setStatusBar(bool);
    }

    public void setTerm_globalBar(boolean bool) {
        jTexte1.setGlobalBar(bool);
    }

    private void initOptions() {
        option = new Options_Model(this);
        // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        option.setTitle(getTitle());
        option.addOption("Term_BS", false, "bool", "0/1", true, false, "true if a port send on itself");
        option.addOption("Term_autoScroll", true, "bool", "0/1", true, false, "true if autoScroll is set on Vertical ScrollBar");
        option.addOption("Term_MarkCol", new java.awt.Color(150, 80, 150), "color", "col", true, false, "Color used for marked Packets");
        try {
            Field[] inMode = {getClass().getDeclaredField("INPUT_ASCII"),
                getClass().getDeclaredField("INPUT_HEX"), getClass().getDeclaredField("INPUT_OBJ")};
            option.addOption("Term_inMode", new DefaultComboBoxModel<>(inMode), "int", "0-2", true, false, "Mode for input {ASCII/HEX/OBJ}");
            option.addOption("Term_outMode", new DefaultComboBoxModel<>(outModes), "int", "0-2", true, false, "Mode for output{PACKET/TRAME/SCREEN/CONSOLE}");
        } catch (NoSuchFieldException | SecurityException ex) {
            TDeb.wri("Pb during initialisation: =>" + ex.getMessage());
        }
    }

    /**
     * proite the Port of this terminal
     *
     * @return a C_Port(Term) or null if standalone terminal
     */
    public C_Port getport() {
        return Parent;
    }

    /**
     * provide the color of a port
     *
     * @param portidx the port index or its memory index if dead. //TODO : why
     * not the port Obj, because if it is dead...
     * @return the color managed by the console for this port
     */
    public Color getPortColor(int portidx) {
        if (Console != null) {
            return Console.getColor(portidx);
        }
        return local_col;
    }

    /**
     * set the Terminal packet List
     *
     * @param tr the list of C_Packet to display
     */
    public void setModelPackets(java.util.List<C_Packet> tr) {
        model.setTraces(tr);
    }

    public java.util.List<C_Packet> getModelPackets() {
        return model.getTraces();
    }

    /**
     * get the time&Date format used to displayed in this terminal
     *
     * @return
     */
    public String getTimeFormat() {
        return g_JRollingButton1.getValue().toString();
    }

    /**
     * get(/create if null) the Input Stream for this Terminal
     *
     * @return the inputStream
     * @throws java.io.IOException
     */
    @Override
    public final InputStream getInputStream() throws java.io.IOException {
        if (Parent == null) {
            if (local_in == null) {
                return new TermInputStream2(this);
            } else {
                return local_in;
            }

        }
        if (Parent.getin() == null) {
            return new TermInputStream2(this);
        } else {
            return Parent.getin();
        }
    }

    public void setInputStream(InputStream istr) throws java.io.IOException {
        local_in = istr;
    }

    /**
     * get(/create if null) the Output Stream for this Terminal
     *
     * @return the outputStream
     * @throws java.io.IOException
     */
    @Override
    public final OutputStream getOutputStream() throws java.io.IOException {
        if (Parent == null) {
            if (local_out == null) {

                return new TermOutputStream2(this);
            } else {
                return local_out;
            }

        }
        if (Parent.getout() == null) {
            return new TermOutputStream2(this);
        } else {
            return Parent.getout();
        }

    }

    @Override
    public int StreambuffSize() {
        if (Streambuff == null) {
            return -1;
        }
        //  String txt=new String((byte[])Streambuff.toArray());
        return Streambuff.size();
    }

    public boolean isEditing() {
        return this.jToggleButton1.isSelected();

    }

    public void setEditing(boolean bool) {
        if (isEditing() != bool) {
            jToggleButton1.setSelected(bool);
        }
        jCheckBoxMenuItem9.setEnabled(bool);
        jButton3.setEnabled(bool);
        jButton10.setEnabled(bool);
        if (Parent != null) {
            jButton9.setEnabled(bool);
        }
        jMenu3.setEnabled(bool);
        jMenu2.setEnabled(bool);
        int[] tmp = jTable1.getSelectedRows();
        jTable1.setAutoCreateRowSorter(bool);
        int colnb = -1;
        for (int col = 0; col < model.getColumnCount(); col++) {
            if (model.getColumnName(col).compareTo("N") == 0) {
                colnb = col;
            }
        }
        if (bool) {
            java.util.List<RowSorter.SortKey> sortKeys = new ArrayList<>();
            sortKeys.add(new RowSorter.SortKey(colnb, SortOrder.ASCENDING));
            TDeb.wri("setEditing() => colnb: " + colnb);
            jTable1.getRowSorter().setSortKeys(sortKeys);
        } else {
            jTable1.setRowSorter(null);
            jTable1.repaint();
        }
        // row sorter disable row selection
        for (int row : tmp) {
            jTable1.addRowSelectionInterval(row, row);
        }
        jTexte1.getTextePane().repaint();
    }

    public void setStreambuff(byte[] data) {
        Streambuff.clear();
        for (int i = 0; i < data.length; i++) {
            Streambuff.add(data[i]);
        }

    }

    @Override
    public int readStreambuff() {
        if (Streambuff.isEmpty()) {
            return -9999;
        }

        return (int) Streambuff.remove(0);
    }

    @Override
    public void setextTitle(String exttitle) {
        if (getTitle().indexOf(": ") == -1) {
            setTitle(this.getTitle() + ": " + exttitle);
        } else {
            setTitle(getTitle().substring(0, getTitle().indexOf(": ") + 2) + exttitle);
        }

    }

    private String getintxt() {
        return jTextPane2.getText();
    }

    /**
     * was made to do a input ia system (shell/conf/...)=>for tuto...
     *
     * @param txt
     */
    private void setInput(Object obj) {
        if (this.isVisible()) {
            if (obj instanceof String) {
                jTextPane2.setText(obj.toString());
            } else if (obj instanceof byte[]) {
                setTerm_inMode(INPUT_HEX);
                jTextPane2.setText(TUtils.Formate_Hexa((byte[]) obj, true));
            } else {
                setTerm_inMode(INPUT_OBJ);
                jTable3.setValueAt(obj, 0, 0);
            }
        } else {
            //System.out.print("Details : " + txt);
        }

    }

    @A_Commande(help = "set Baskspace Management")
    public void setKeyBS(boolean bool) {
        if (isKeyBS() != bool) {
            option.setValuefor("Term_BS", bool);
        }
        if (jToggleButton2.isSelected() != bool) {
            jToggleButton2.setSelected(bool);
        }
    }

    @A_Commande(help = "return Baskspace Management")
    private boolean isKeyBS() {
        return option.getValuefor("Term_BS", true);
    }

    @A_Commande(help = "set MarkedPacked Color")
    public void setKeyBS(Color col) {
        if (getMarkedColor() == null || getMarkedColor() != col) {
            option.setValuefor("Term_MarkCol", col);
        }
    }

    @A_Commande(help = "return Marked Parcket Color")
    private Color getMarkedColor() {
        return option.getValuefor("Term_MarkCol", java.awt.Color.BLACK);
    }

    /**
     * manage BaskSpace (\b) to remove 'previous' caracter is previous packet if
     * necessary
     *
     * @param buff
     * @return
     */
    private byte[] getManageBS(byte[] buff) {
        String bufcmde = TUtils.Formate_toString(buff);
        //!! care 0d 0a=> "ef bf bd"
        while (bufcmde.contains("\b")) {
            int idx = bufcmde.indexOf("\b");
            if (idx == 0) {
                //  checks that a packet commes from term
                int nb = model.getRowCount() - 1;
                while (nb >= 0 && model.getPacket(nb).getsourceidx() != this.getport().getIndex()) {
                    nb--;
                }
                if (nb >= 0) {
                    Object o = model.getPacket(nb).getObj();
                    if (o instanceof byte[] && ((byte[]) o).length > 1) {
                        // remove last byte on the last sent packet managering CRLF
                        byte[] newbuff = (byte[]) o;
                        if (newbuff[newbuff.length - 1] == 10 && newbuff[newbuff.length - 2] == 13) {
                            newbuff = java.util.Arrays.copyOf(newbuff, newbuff.length - 2);
                        } else {
                            newbuff = java.util.Arrays.copyOf(newbuff, newbuff.length - 1);
                        }
                        model.getPacket(nb).setObj(newbuff);
                        refreshConsoleText();
                    } else {
                        // the last packet is only one byte, delete it
                        removePacketConsole(model.getPacket(nb));
                        model.removerow(model.getRowCount() - 1);
                    }
                }
                bufcmde = bufcmde.substring(1);
            } else {
                bufcmde = bufcmde.substring(0, idx - 1) + bufcmde.substring(idx + 1);
            }
        }
        if (bufcmde.length() == 0) {
            return null;
        } else {
            return bufcmde.getBytes();
        }
    }

    private boolean displayAsit() {
        return jTexte1.getFont().getName().startsWith("SexyHexy") || isKeyBS() == false;
    }

    public void configure_Shell() {
        setTecho(false);
        setKeyBS(true);
        jTexte1.setAutoScroll(true);
        jTexte1.setEditable(true);
        jTexte1.setGlobalBar(false);
        jTexte1.setLineBar(false);
        jTexte1.setStatusBar(false);
        jToolBar1.setVisible(false);
    }

    @A_Commande(help = "set log Management")
    public void setlog(boolean bool) {
        if (islog() != bool) {
            jToggleButton6.setSelected(true);
        }

        if (Parent != null && Parent.islog() != bool) {
            Parent.setlog(bool);
        }

    }

    @A_Commande(help = "return log Management")
    public boolean islog() {
        return jToggleButton6.isSelected();
    }

    private void clearouttxt() {
        model.clear();
        jTexte1.clear();
        jTextPane2.requestFocus();
    }

    private void clearintxt() {
        jTextPane2.setText("");
        jTable3.setValueAt(new byte[0], 0, 0);
    }

    private Object getsendmsg() {
        Object res = null;
        int mode = getTerm_inMode();
        if (mode == INPUT_HEX) {
            try {
                res = TUtils.string2byte(jTextPane2.getText());
            } catch (Exception ex) {
                return null;
            }
        } else if (mode == INPUT_ASCII || mode == -1) {
            res = jTextPane2.getText().getBytes();
        }
        /*
         * if (res instanceof byte[] || res instanceof String) { res = new
         * String(((byte[]) res)); }
         */
        if (mode == INPUT_OBJ) {
            res = jTable3.getValueAt(0, 0);
        }
        // sendingmsg = res;
        return res;
    }

    /**
     * change the INPUT box Mode for sending data (hex/ascii/...)
     *
     * @param inputMode the index of the input Mode ('0:ASCII/1:HEX/2:OBJ')
     */
    @A_Commande(help = "set termnal input type '0:ASCII/1:HEX/2:OBJ'")
    public void setTerm_inMode(int inputMode) {
        jTable3.editingStopped(null);
        Object tosend = getsendmsg();
        jTextPane2.setEnabled(true);
        jTextPane2.setEditable(true);
        if (inputMode == INPUT_ASCII && tosend instanceof String) {
            jTextPane2.setText(tosend.toString());
        } else if (inputMode == INPUT_ASCII && tosend instanceof byte[]) {
            jTextPane2.setText(TUtils.Formate_toString((byte[]) tosend));
        } else if (inputMode == INPUT_HEX && tosend instanceof String) {
            jTextPane2.setText(TUtils.tabTostr(tosend.toString().getBytes(), " ".charAt(0)));
        } else if (inputMode == INPUT_HEX && tosend instanceof byte[]) {
            jTextPane2.setText(TUtils.tabTostr(((byte[]) tosend), " ".charAt(0)));
        } else if (inputMode == INPUT_OBJ) {
            jTable3.setValueAt(tosend, 0, 0);
        } else {
            jTextPane2.setText("[OBJECT]");
            jTextPane2.setEnabled(false);
            jTextPane2.setEditable(false);
        }

        switch (inputMode) {
            case INPUT_HEX:
                jButton1.setEnabled(getSendbt().compareTo("BTN") == 0);
                jTable3.setEnabled(false);
                jTable3.setVisible(false);
                jScrollPane1.setViewportView(jTextPane2);
                jTextPane2.setVisible(true);
                jTextPane2.setBackground(java.awt.Color.green);
                break;
            case INPUT_ASCII:
                jButton1.setEnabled(getSendbt().compareTo("BTN") == 0);
                jTable3.setEnabled(false);
                jTable3.setVisible(false);
                jScrollPane1.setViewportView(jTextPane2);
                jTextPane2.setVisible(true);
                jTextPane2.setBackground(java.awt.Color.white);
                break;
            case INPUT_OBJ:
                jButton1.setEnabled(true);
                jTextPane2.setVisible(false);
                jTextPane2.setEditable(false);
                jScrollPane1.setViewportView(jTable3);
                jTable3.setEnabled(true);
                jTable3.setVisible(true);
                break;
            default:
                inputMode = INPUT_ASCII;//for later setActionCommand(..)
                setTerm_inMode(INPUT_ASCII);

        }
        DefaultComboBoxModel<Field> cbox = option.getValuefor("Term_inMode", new DefaultComboBoxModel<Field>());
        for (int i = 0; i < cbox.getSize(); i++) {
            try {
                if (cbox.getElementAt(i).getInt(cbox.getElementAt(i)) == inputMode) {
                    cbox.setSelectedItem(cbox.getElementAt(i));
                }
            } catch (IllegalArgumentException | IllegalAccessException ex) {
            }
        }
        jScrollPane1.repaint();
    }

    public int getTerm_inMode() {
        DefaultComboBoxModel<Field> cbox = option.getValuefor("Term_inMode", new DefaultComboBoxModel<Field>());
        try {
            Field f = (Field) cbox.getSelectedItem();
            return f.getInt(f);
        } catch (IllegalArgumentException | IllegalAccessException ex) {
            return INPUT_ASCII;
        }
    }

    public String getSendbt() {
        return jRollingButton3.getValue().toString();
    }

    /**
     * set the sending trigger.
     *
     * @param txt 'BTN' | 'KEY' | 'ENTER'
     */
    public void setSendbt(String txt) {
        if (getSendbt().startsWith(txt) == false) {
            jRollingButton3.setValue(txt);
        }
        jToggleButton7.setToolTipText("Input Type : " + txt);
        jButton1.setEnabled(txt.compareTo("BTN") == 0 && islockedin() == false);
        //   jButton1.setEnabled(true);
    }

    public void setColumn(String name, boolean bool) {

        if (bool) {
            addColumn(name);
        } else {
            removeColumn(name);
        }
        /*
         * if (getTermType().compareTo("Console") == 0) { updateConsoleText(); }
         */

    }

    public void setloopedout(boolean bool) {
        jToggleButton7.setEnabled(bool == false);
        jToggleButton3.setEnabled(bool == false);
        /*
         * jTextPane2.setEnabled(bool==false); jTable3.setEnabled(bool==false);
         * jTextPane1.setEnabled(bool==false); jTable1.setEnabled(bool==false);
         */
    }

    public boolean islockedin() {
        return jToggleButton7.isSelected();
    }

    public final void setlockedin(boolean bool) {
        if (Parent != null && Parent.islockin() != bool) {
            Parent.setlockin(bool);
        }
        if (islockedin() != bool) {
            jToggleButton7.setSelected(bool);
        }
        jToggleButton7.setToolTipText("Allow input: " + TUtils.getSetString(bool));
        jToggleButton3.setEnabled(bool == false);
        jPanel1.setVisible(bool == false);
        jRollingButton3.setEnabled(bool == false);
        int h = 0;
        if (bool == false && !getTerm_outMode().startsWith("OUTPUT_SCREEN")) {
            h = jPanel1.getPreferredSize().height;
        }
        jSplitPane2.setDividerLocation(h);
        jSplitPane2.setEnabled(bool == false);
    }

    /**
     * change the OUTPUT view table : 'packet' or Objects(trame) or texte with
     * input box (console) or as input box
     *
     * @param oMode the name or the display to use
     */
    @A_Commande(help = "set Terminal output type 'OUTPUT_SCREEN/OUTPUT_CONSOLE/OUTPUT_TRAME/OUTPUT_PACKET/OUTPUT_SCREENLOCK'")
    public void setTerm_outMode(String oMode) {
        // ----- Ajust Buttons----
        if (getTerm_outMode().compareTo(oMode) != 0) {
            DefaultComboBoxModel<String> cbox = option.getValuefor("Term_outMode", new DefaultComboBoxModel<String>());
            for (int i = 0; i < cbox.getSize(); i++) {
                if (cbox.getElementAt(i).toString().compareTo(oMode) == 0) {
                    cbox.setSelectedItem(oMode);
                }
            }
        }
        if (Parent != null && Parent.getTerm_outMode().compareTo(oMode) != 0) {
            Parent.setTerm_outMode(oMode);
        }
        if (jRollingButton1.getValue().toString().compareTo(oMode) != 0) {
            jRollingButton1.setValue(oMode);
        }
        jRollingButton1.setToolTipText("Output as : " + oMode);
        //----- DO the JOB------
        boolean bool = oMode.startsWith("OUTPUT_SCREENLOCK") == false;
        DecodeMenuItem.setEnabled(bool);
        GraphMenuItem.setEnabled(bool);
        if (oMode.startsWith("OUTPUT_SCREEN")) {
            //misc
            jRollingButton3.setName(getSendbt());
            setSendbt("KEY");
            jRollingButton2.setVisible(true);
            setTerm_inMode(INPUT_ASCII);
            if (jSplitPane2.isEnabled()) {
                jSplitPane2.setName("" + jSplitPane2.getDividerLocation());
            }
            jPanel1.setVisible(false);
            jSplitPane2.setDividerLocation(0);
            jSplitPane2.setEnabled(false);
            //update    
            refreshConsoleText();
        } else {
            if (jSplitPane2.getName() != null && islockedin() == false) {
                jSplitPane2.setEnabled(true);
                jToolBar1.setVisible(true);
                jPanel1.setVisible(true);
                jSplitPane2.setDividerLocation(new Integer(jSplitPane2.getName()));
                jSplitPane2.setName(null);
            }
            if (jRollingButton3.getName() != null) {
                setSendbt(jRollingButton3.getName());
                jRollingButton3.setName(null);
            }
            setTerm_inMode(getTerm_inMode());
            jRollingButton2.setVisible(false);
            setTecho(true);
        }
        if (oMode.compareTo("OUTPUT_CONSOLE") == 0 || oMode.startsWith("OUTPUT_SCREEN")) {
            if (jSplitPane2.getBottomComponent() != jTexte1) {
                jSplitPane2.remove(jScrollPane2);
                jSplitPane2.setBottomComponent(jTexte1);
            }
            refreshConsoleText();
        } else {
            if (jSplitPane2.getBottomComponent() != jScrollPane2) {
                jSplitPane2.remove(jTexte1);
                jSplitPane2.setBottomComponent(jScrollPane2);
            }
            jTexte1.clear();
        }
        if (oMode.compareTo("OUTPUT_CONSOLE") == 0) {
            jTexte1.setEditable(false);
            jTexte1.setEnabled(true);
            jRollingButton2.setVisible(true);
        } else {
            int[] sels = jTable1.getSelectedRows();
            removeAllColumn();
            if (oMode.compareTo("OUTPUT_PACKET") == 0) {
                if (getSendbt().compareTo("KEY") == 0) {
                    setSendbt("BTN");
                }
                addColumn("N");
                addColumn("Storetime");
                addColumn("Src.");
                addColumn("Size");
                addColumn("Data (Hex)");
                addColumn("Data (ascii)");
            } else if (oMode.compareTo("OUTPUT_TRAME") == 0) {
                addColumn("N");
                addColumn("Storetime");
                addColumn("Src.");
                addColumn("Size");
                addColumn("Data (Obj)");
                addColumn("Stacks");
            }
            jCheckBoxMenuItem1.setSelected(false);
            jCheckBoxMenuItem2.setSelected(false);
            for (int sel : sels) {
                if (sel < jTable1.getRowCount()) {
                    jTable1.setRowSelectionInterval(sel, sel);
                }
            }
        }
        repaint();
    }

    public String getTerm_outMode() {
        DefaultComboBoxModel<String> cbox = option.getValuefor("Term_outMode", new DefaultComboBoxModel<String>());
        return cbox.getSelectedItem().toString();
    }

    public void setSubType(String txt) {
        jRollingButton2.setValue(txt);
        jRollingButton2.setToolTipText("Input as : " + txt);
        refreshConsoleText();
    }

    public String getSubType() {
        return jRollingButton2.getValue().toString();
    }

    private void refreshPopups() {
        int graphHeigh = 0;
        if (fgraph != null && fgraph.isAsFrame() == false) {
            int h = 150;
            if (fgraph.getHeight() > 20) {
                h = fgraph.getHeight();
            }
            fgraph.setBounds(getX(), getY() + getHeight(), getWidth(), h);
            graphHeigh = fgraph.getHeight();
            if (this.isActive()) {
                fgraph.toFront();
            }
        }
        if (fdecode != null && fdecode.isAsFrame() == false) {
            int w = 500;
            if (fdecode.getWidth() > 20) {
                w = fdecode.getWidth();
            }
            fdecode.setBounds(getX() + getWidth(), getY(), w, getHeight() + graphHeigh);
            if (this.isActive()) {
                fdecode.toFront();
            }
        }

    }

    private void refresh() {
        if (jTable1.isVisible()) {
            for (int i = 0; i < jTable1.getColumnCount(); i++) {
                jTable1.getColumnModel().getColumn(i).setCellRenderer(getColumnRender(jTable1.getColumnName(i)));
                jTable1.getColumnModel().getColumn(i).setCellEditor(getColumnEditor(jTable1.getColumnName(i)));
                jTable1.getColumnModel().getColumn(i).setPreferredWidth(getColumnRealSize(jTable1.getColumnName(i)));
            }
            for (int i = 0; i < jMenu1.getItemCount(); i++) {
                if (jMenu1.getItem(i) instanceof javax.swing.JCheckBoxMenuItem) {
                    javax.swing.JCheckBoxMenuItem m = (javax.swing.JCheckBoxMenuItem) jMenu1.getItem(i);
                    try {
                        if (jTable1.getColumn(m.getText()) != null) {
                            m.setSelected(true);
                        } else {
                            m.setSelected(false);
                        }

                    } catch (Exception ex) {
                        m.setSelected(false);
                    }

                }
            }
        }
    }

    /**
     * add the column and keep activated row
     *
     * @param col_name the column title label
     */
    private void addColumn(String col_name) {
        model.addColumn(col_name);
        refresh();

        int[] selecteds = jTable1.getSelectedRows();
        for (int selected : selecteds) {
            jTable1.setRowSelectionInterval(selected, selected);
        }
        activrow(jTable1);

    }

    /**
     * get the Terminal column render for each column title label
     *
     * @param name the column title label
     * @return the render
     */
    public TableCellRenderer getColumnRender(String name) {
        java.awt.Color[] col = null;
        if (Parent != null && Console != null) {
            col = Console.getColors();
        }

        if (col == null) {
            col = new java.awt.Color[1];
            col[0] = local_col;
        }

        if (name.compareTo("Storetime") == 0) {
            return new DateRenderer2(this);
        } else if (name.compareTo("Create") == 0) {
            return new DateRenderer2(this);
        } else if (name.compareTo("Data (Hex)") == 0) {
            return new byteRenderer2(this);
        } else if (name.compareTo("Data (ascii)") == 0) {
            return new byteRenderer2(this);
        } else if (name.compareTo("Edit") == 0) {
            return new ACE_ObjRenderer<>();
        } else if (name.compareTo("Data (Obj)") == 0) {
            return new PacketRenderer2(this);
        } else if (name.compareTo("Dir.") == 0) {
            return new byteRenderer2(this);
        }/*else if (name.compareTo("Stacks") == 0) {
         return new stackRenderer();
         }*/

        int idx = -1;
        if (Parent != null) {
            idx = Parent.getIndex();
        }
        return new IntRenderer2(this, idx);
    }

    /**
     * return the Table Editor for each column title
     *
     * @param name the column title label
     * @return the editor to apply on this column
     */
    public TableCellEditor getColumnEditor(String name) {
        if (name.compareTo("Edit") == 0) {
            return new ACE_ObjEditor<>();
        }

        if (name.compareTo("Data (Obj)") == 0) {
            try {
                return new PacketEditor2(this);
            } catch (Exception ex) {
                TDeb.wri("Could not find com.jdcm.editors.ACE_ObjRenderer()");
                return null;
            }

        }
        if (name.compareTo("Edit (Obj)") == 0 || name.compareTo("Stacks") == 0) {
            try {
                return new ACE_ObjEditor<>(true, true);
            } catch (Exception ex) {
                TDeb.wri("Could not find com.jdcm.editors.ACE_ObjRenderer()");
                return null;
            }
        }
        return null;
    }

    public int getColumnRealSize(String name) {
        int sum = 0;
        int res;
        for (int i = 0; i < jTable1.getColumnCount(); i++) {
            sum += getColumnSize(jTable1.getColumnName(i));
        }

        res = (jScrollPane2.getViewport().getWidth()) * getColumnSize(name) / sum;
        //!!!!!!!!!!!!!!!!!!!!!!!!!!!!Pb
        if (res < getColumnSize(name)) {
            return getColumnSize(name);
        }

        return res;
    }

    public int getColumnSize(String name) {
        int def = -1;
        if (name.compareTo("Storetime") == 0) {
            def = 14;
        } else if (name.compareTo("Create") == 0) {
            def = 12;
        } else if (name.compareTo("Data (Hex)") == 0) {
            def = 52;
        } else if (name.compareTo("Data (ascii)") == 0) {
            def = 19;
        } else if (name.compareTo("Data (Obj)") == 0) {
            def = 69;
        } else if (name.compareTo("N") == 0) {
            def = 4;
        } else if (name.compareTo("Src.") == 0) {
            def = 4;
        } else if (name.compareTo("Dst.") == 0) {
            def = 4;
        } else if (name.compareTo("Size") == 0) {
            def = 8;
        } else if (name.compareTo("Edit") == 0) {
            def = 8;
        } else if (name.compareTo("Delai") == 0) {
            def = 4;
        } else if (name.compareTo("Stacks") == 0) {
            def = 30;
        } else if (name.compareTo("Dir.") == 0) {
            def = 4;
        }
        if (def == -1) {
            return 50;/*
             * default
             */

        }

        return (def);

    }

    private void removeColumn(String col_name) {
        if (model != null) {
            model.removeColumn(col_name);
            refresh();
        }

    }

    private void removeAllColumn() {
        for (int i = jTable1.getColumnCount() - 1; i >= 0; i--) {
            String col_name = jTable1.getColumnName(i);
            removeColumn(col_name);
        }

//model.removeColumn(col_name);
    }

    /**
     * Add a Packet at the packpos position on the TextPane Mode
     *
     * @param pack the packet to insert
     * @param packpos the position to insert packet, -1 if at the end
     */
    public void addConsoleText(C_Packet pack, int packpos) {
        addConsoleText(jTexte1.getTextePane().getStyledDocument(), pack, packpos);
    }

    /**
     * Add a packet to the console
     *
     * @param pack the packet to add
     * @param packpos the packet position (in the packet list) of the packet to
     * add
     * @param doc the styled document used as Console
     */
    public void addConsoleText(StyledDocument doc, C_Packet pack, int packpos) {
        int pos = doc.getLength();
        if (model != null) {
            if (packpos >= 0) {
                pos = 0;
                for (int i = 0; i < packpos; i++) {
                    pos += model.getPacketAsString(model.getTraces().get(i), getSubType(), displayAsit(), Parent).length();
                }
            }

            String txt = model.getPacketAsString(pack, getSubType(), displayAsit(), Parent);
            SimpleAttributeSet att = packAttibutSrc(pack);
            try {
                doc.insertString(pos, txt, att);
            } catch (BadLocationException ex) {
                TDeb.wri("addConsoleText =>" + ex.getMessage());
            }
        } else {
            TDeb.wri("addConsoleText => model is null ");
        }
    }

    /**
     * set attibutes for all visible texte
     *
     * @param touchedPack the list of packets selected or unselected
     */
    private void updateConsole(java.util.List<C_Packet> touchedPack) {
        int pos = 0;
        int caretpos = jTexte1.getTextePane().getCaretPosition();
        String packAsString;
        StyledDocument st = jTexte1.getTextePane().getStyledDocument();
        jTexte1.getTextePane().setDocument(new DefaultStyledDocument());
        // java.util.List rlist=java.util.Arrays.asList(jTable1.getSelectedRows());
        try {
            C_Packet pack;
            for (int i = 0; i < model.getTraces().size() && !touchedPack.isEmpty(); i++) {
                pack = model.getTraces().get(i);
                packAsString = model.getPacketAsString(pack, getSubType(), displayAsit(), Parent);
                try {
                    if (touchedPack.contains(pack)) {
                        st.setCharacterAttributes(pos, packAsString.length(), packAttibutSrc(pack), true);
                        touchedPack.remove(pack);
                    }
                } catch (Exception ex) {
                    TDeb.wri("updateConsole()=>" + ex.getMessage());
                }
                pos = pos + packAsString.length();
            }
        } catch (Exception ex) {
            // at java.util.ArrayList$Itr.checkForComodification(ArrayList.java:819) =>java.util.ConcurrentModificationException
        }
        jTexte1.getTextePane().setDocument(st);
        if (caretpos <= jTexte1.getTextePane().getDocument().getLength()) {
            jTexte1.getTextePane().setCaretPosition(caretpos);
        }

    }

    /**
     * provide attibut for a packet according source
     *
     * @param pack the packet
     * @return the attibutset for this packet
     */
    private SimpleAttributeSet packAttibutSrc(C_Packet pack) {
        java.awt.Color fcol = getPortColor(pack.getsourceidx());
        SimpleAttributeSet myAttributeSet = new SimpleAttributeSet();
        StyleConstants.setForeground(myAttributeSet, fcol);
        if (jTable1.isRowSelected(model.getTraces().indexOf(pack))) {
            StyleConstants.setBackground(myAttributeSet, jTable1.getSelectionBackground());
        }
        return myAttributeSet;
    }

    /**
     * Remove a packet from a the Terminal, ajust model
     *
     * @param pack the packet to remove
     */
    private void removePacketConsole(C_Packet pack) {
        int pos = 0;
        String packAsString;
        StyledDocument st = jTexte1.getTextePane().getStyledDocument();
        if (st.getLength() == 0) {
            // document is empty (ex : displayed by table)
            return;
        }
        for (C_Packet p : model.getTraces()) {
            packAsString = model.getPacketAsString(p, getSubType(), displayAsit(), Parent);
            if (p == pack) {
                try {
                    st.remove(pos, packAsString.length());
                } catch (BadLocationException ex) {
                    TDeb.wri("removePacketConsole()=>" + ex.getMessage());
                }
            } else {
                pos = pos + packAsString.length();
            }
        }
    }

    /**
     * provide the JTextPane of the terminal console
     *
     * @return
     */
    public JTextPane getconsolescreen() {
        return jTexte1.getTextePane();
    }

    /**
     * clear the console of Terminal
     */
    /*  public void clearConsoleText() {
        
     }*/
    public void refreshConsoleText() {
        StyledDocument doc = new DefaultStyledDocument();
        for (C_Packet p : model.getTraces()) {
            addConsoleText(doc, p, -1);
        }
        jTexte1.getTextePane().setDocument(doc);
    }

    /**
     * Find the packet at a Texte position
     *
     * @param mousepos
     * @return
     */
    private C_Packet getPacketAt(java.awt.Point mousepos) {
        int clickcar = jTexte1.getTextePane().viewToModel(mousepos);
        try {
            Rectangle rect = jTexte1.getTextePane().modelToView(clickcar);
            if (clickcar >= 0 && mousepos.y >= rect.y && mousepos.y <= rect.y + rect.height) {
                int pos = 0;
                for (C_Packet pack : model.getTraces()) {
                    String packstr = model.getPacketAsString(pack, getSubType(), displayAsit(), Parent);
                    if (pos + packstr.length() < clickcar) {
                        pos = pos + packstr.length();
                    } else {
                        return pack;
                    }
                }
            }
        } catch (BadLocationException ex) {
            TDeb.wri("getPacket() : " + ex.getMessage());
        }
        return null;
    }

    /**
     * Set the selection packets rules for TextPane
     *
     * @param evt
     */
    public void selectPacket(MouseEvent evt) {
        C_Packet pack = getPacketAt(evt.getPoint());
        java.util.ArrayList<C_Packet> rowList = new java.util.ArrayList<>();
        for (int idx : jTable1.getSelectedRows()) {
            rowList.add(model.getTraces().get(idx));
        }
        if (pack == null) {
            jTable1.clearSelection();
        } else {
            int idx = model.getTraces().indexOf(pack);
            int end_idx = idx;
            //  same as Table
            if (evt.isShiftDown() && jTable1.getSelectedRows().length > 0) {
                end_idx = jTable1.getSelectedRows()[jTable1.getSelectedRows().length - 1];
            }
            if (evt.isControlDown()) {
                jTable1.removeRowSelectionInterval(idx, idx);
                updateConsole(rowList);
                return;

            } else {
                for (int row : jTable1.getSelectedRows()) {
                    jTable1.removeRowSelectionInterval(row, row);
                }
            }
            jTable1.addRowSelectionInterval(idx, end_idx);
        }
        for (int idx : jTable1.getSelectedRows()) {
            C_Packet pa = model.getTraces().get(idx);
            if (!rowList.contains(pa)) {
                rowList.add(pa);
            }
        }
        updateConsole(rowList);
    }

    public String getPacketToolTip(java.awt.Point mousepos) {
        C_Packet pack = getPacketAt(mousepos);
        if (pack != null) {
            return "Packet : " + model.getConsoleHeaderText(pack, Parent);
        }
        return "";
    }

    /**
     * Draw the marks of parkets on the textPane asked by the 'Afterpaint' call
     *
     * @param g
     */
    public void drawPackets(Graphics g) {

        if (getMarkedColor() == jTexte1.getTextePane().getBackground()) {
            return;
        }
        StyledDocument st = jTexte1.getTextePane().getStyledDocument();
        Rectangle clip = ((javax.swing.JViewport) getconsolescreen().getParent()).getViewRect();
        int startcar = getconsolescreen().viewToModel(new Point(0, clip.y));
        FontMetrics fontMetrics = getFontMetrics(getconsolescreen().getFont());
        int pos = 0;
        g.setColor(getMarkedColor());
        try {
            for (C_Packet pack : model.getTraces()) {
                String packstr = model.getPacketAsString(pack, getSubType(), displayAsit(), Parent);
                if (pos + packstr.length() < startcar) {
                    pos = pos + packstr.length();
                } else {
                    if (pack.ismarked()) {
                        Graphics2D g2 = (Graphics2D) g;
                        final float dash1[] = {1.0f};
                        final BasicStroke dashed = new BasicStroke(1.0f,
                                BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1.0f, dash1, 0.0f);
                        g2.setStroke(dashed);
                        for (int idx = pos; idx < pos + packstr.length(); idx++) {
                            try {
                                Rectangle r = getconsolescreen().modelToView(idx);
                                int width = fontMetrics.charWidth(packstr.charAt(packstr.length() - 1));
                                if (idx == pos) {
                                    g2.draw(new java.awt.geom.Line2D.Double(r.x, r.y + 1, r.x, r.y + r.height - 1));
                                }
                                if (idx == pos + packstr.length() - 1) {
                                    g2.draw(new java.awt.geom.Line2D.Double(r.x + width, r.y + 1, r.x + width, r.y + r.height - 1));
                                }
                                // should be better withreal line from =< management of folowings caaracters
                                g2.draw(new java.awt.geom.Line2D.Double(r.x, r.y + r.height - 1, r.x + width, r.y + r.height - 1));
                                g2.draw(new java.awt.geom.Line2D.Double(r.x, r.y + 1, r.x + width, r.y + 1));
                            } catch (BadLocationException ex) {
                                TDeb.wri("drawPackets() 1=>" + ex.getMessage());
                            }
                        }
                    } else {
                        // set Packet smals markers
                        g.setColor(jTexte1.getTextePane().getSelectionColor());
                        if (pos >= startcar) {
                            try {
                                int width = fontMetrics.charWidth(packstr.charAt(0));
                                Rectangle r = getconsolescreen().modelToView(pos);
                                g.drawLine(r.x, r.y + 1, r.x + (width / 4), r.y);
                                g.drawLine(r.x, r.y + 1, r.x, r.y + 2);
                            } catch (BadLocationException ex) {
                                TDeb.wri("drawPackets() smals markers=>" + ex.getMessage());
                            }
                        }
                        if (pos + packstr.length() <= st.getLength()) {
                            try {
                                Rectangle r = getconsolescreen().modelToView(pos + packstr.length());
                                int width = fontMetrics.charWidth(packstr.charAt(packstr.length() - 1));
                                g.drawLine(r.x, r.y + 1, r.x - (width / 4), r.y);
                                g.drawLine(r.x, r.y + 1, r.x, r.y + 2);
                            } catch (BadLocationException ex) {
                                TDeb.wri("drawPackets() 3=>" + ex.getMessage());
                            }
                        }
                    }
                    pos = pos + packstr.length();
                }
            }
        } catch (Exception ex) {
            //java.util.ConcurrentModificationException @ F_Terminal.drawPackets(F_Terminal.java:1349)
        }
    }

    public void activrow(javax.swing.JTable table) {
        if (getTerm_outMode().compareTo("OUTPUT_PACKET") != 0) {
            return;
        }
        byteRenderer2 byter;
        TableColumn c;
//table.validate();
        int row = table.getSelectedRow();
        if (row < 0) {
            return;
        }
        c = table.getColumn("Data (Hex)");
        if (c != null && c.getCellRenderer() instanceof byteRenderer2) {
            byter = (byteRenderer2) c.getCellRenderer();
            // set big & get big height
            byter.changestate(jTable1, row);
        }

    }

    public void setclear(boolean bool) {
        if (isclear() != bool) {
            jToggleButton4.setSelected(bool == false);
        }
        jToggleButton4.setToolTipText("Clear on send : " + TUtils.getSetString(bool));
    }

    public boolean isclear() {
        return jToggleButton4.isSelected() == false;
    }

    public void setTecho(boolean bool) {
        //Terminal echo == Port echo !
        if (isTecho() != bool) {
            jToggleButton3.setSelected(bool);
        }
        jToggleButton3.setToolTipText("Echo: " + TUtils.getSetString(bool));
        if (Parent != null) {
            if (Parent.isEcho() != bool) {
                Parent.setEcho(bool);
            }
        }
    }

    public boolean isTecho() {
        return jToggleButton3.isSelected();
    }

    /**
     * save frames into file
     *
     * @param packList packets to saveboolean addPseudo,
     * @param addPseudo add pseudo Eth overload
     */
    private void SaveTerm(java.util.List<C_Packet> packList, boolean addPseudo) {

        if (packList == null || packList.isEmpty()) {
            javax.swing.JOptionPane.showMessageDialog(this, "No packets to save", "Save Terminal", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            TDeb.wri("SaveTerm : No displayed Packets");
            return;
        }
        String filename;
        filename = TUtils.getUIsaveFile(this, true, null);
        if (filename == null) {
            TDeb.wri("asked to save terminal abborted : null file");
            return;

        }
        OutputStream cap_stream;
        cap_stream = TUtils.getstream(filename);
        if (cap_stream == null) {
            TDeb.wri("asked to save terminal abborted : stream not openned");
            return;
        }
        TUtils.setcapheader(cap_stream);
        for (C_Packet pack : packList) {
            byte[] buff = pack.getBytes();
            if (buff != null) {
                long t = pack.getStoredtime().getTime();
                if (!addPseudo) {
                    TUtils.addcapture(cap_stream, buff, null, 0, null, 0, t);
                } else {
                    int src = pack.getsourceidx();
                    int dest = -1;
                    if (Parent != null) {
                        dest = Parent.getIndex();
                    }
                    if (dest < 0) {
                        dest = pack.getdestidx();
                        if (dest < 0) {
                            dest = 0;
                        }
                    }
                    String srcmode = "UNKNOWN";
                    if (Parent != null && Parent.getMain() != null
                            && Parent.getMain().getPorts().size() > src && src >= 0) {
                        srcmode = Parent.getMain().getPorts().get(src).getModeName();
                    }
                    TUtils.addcapture(cap_stream, buff, srcmode, src, "Term", dest, t);
                }
            }
        }
        // Parent.getMain().setcapture(false);

    }

    private void showObject(int row) {
        if (row == -1) {
            // create an object
            F_Object fo = new F_Object(null);
            return;

        }
        // show the object in the table

        C_Packet d = (C_Packet) jTable1.getValueAt(row, -1);
        if (d == null) {
            return;
        }

        F_Object fo = new F_Object(d.getObj());
        fo.addPanel(new P_PacketEditor(d));
    }

    /**
     * Display the content of the Packet as frame or as tree or as Image or
     *
     * @param d the packet with content
     * @param default_proto the default protocol to use (for frames)
     * @param isnewframe delete previous edited value before display new
     */
    private void displayPacket(C_Packet d, String default_proto) {

        if (d.getObj() == null) {
            return;
        }
        if (d.getObj() instanceof java.awt.Image) {
            deceditor = null;
            table = null;
            javax.swing.JPanel pan;
            /*  if (jSplitPane1.getBottomComponent() instanceof javax.swing.JPanel) {
             pan = (javax.swing.JPanel) jSplitPane1.getBottomComponent();
             } else {*/
            pan = new javax.swing.JPanel();
            //  }
            // jSplitPane1.setBottomComponent(new javax.swing.JScrollPane(pan));
            pan.getGraphics().drawImage((java.awt.Image) d.getObj(), 0, 0, null);
            pan.setVisible(true);

        } else if (d.getObj() instanceof javax.swing.tree.TreeModel) {
            deceditor = null;
            table = null;
            javax.swing.JTree tr;
            /*  if (jSplitPane1.getBottomComponent() instanceof javax.swing.JTree) {
             tr = (javax.swing.JTree) jSplitPane1.getBottomComponent();
             } else {*/
            tr = new javax.swing.JTree();
            //  }
            tr.setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
            tr.setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>());
            //  jSplitPane1.setBottomComponent(new javax.swing.JScrollPane(tr));
            tr.setModel((javax.swing.tree.TreeModel) d.getObj());
            tr.setVisible(true);
        } else if (d.getObj() instanceof java.sql.ResultSet) {
            deceditor = null;
            java.sql.ResultSet rset = (java.sql.ResultSet) d.getObj();
            if (table == null) {
                table = new P_TableEditor(rset);
                table.getRootPane().getContentPane().setVisible(true);
            } else {
                table.setValue(rset);
            }
        } else if (d.getObj() instanceof Code_Model
                || d.isbuffer()
                || d.getObj().getClass().getName().startsWith("jpcap.packet")) {
            table = null;
            if (deceditor == null) {
                deceditor = new P_CodeEditor(this);
                deceditor.setVisible(true);
                repaint();
            }
            if (d.getObj() instanceof Code_Model) {
                deceditor.setModel((Code_Model) d.getObj());
            } else if (d.isbuffer()) {
                deceditor.setPacket(d, default_proto, true);
            }
            java.util.List<C_Packet> packs = model.getTraces();
            if (packs != null
                    && packs.isEmpty() == false
                    && deceditor.isActive() == false
                    && deceditor.isConvOn()) {
                deceditor.initConversation();
            }
        } else {
            deceditor.askStop();
            deceditor = null;
            table = null;
            F_Object fo = new F_Object(true); //=> true isAplet
            fo.setObject(d.getObj());
            fo.addPanel(new P_PacketEditor(d));
        }

    }

    public void groupAndDecodeRows() {
        byte[] buff = new byte[0];
        C_Packet[] packs = getselectedpackets();
        if (packs == null || packs.length == 0) {
            TDeb.wri("no row selected");
            return;
        }
        if (packs.length == 1) {
            displayPacket(packs[0], null);
        } else {
            for (C_Packet p : packs) {
                //if a stack is known for the packet, no need to aggregate with other?!!
                if (p.isbuffer() && (p.getProtocols() == null
                        || p.getProtocols().isEmpty())
                        || (p.getProtocols().size() == 1
                        && p.getProtocols().get(0) != null
                        && p.getProtocols().get(0).getClass().getSimpleName().contains("0NULL"))) {
                    buff = TUtils.addtab(buff, p.getBytes());
                } else {
                    displayPacket(p, null);
                }
            }
        }
        if (buff.length > 0) {//&& Parent != null
            C_Packet p = new C_Packet(buff, Parent);
            ((C_Main) Parent.getMain()).findPacketStacks(p);
            displayPacket(p, null);
        }
    }

    public C_Packet[] getselectedpackets() {
        if (jTable1.getSelectedRow() < 0) {
            TDeb.wri("no row selected");
            return null;
        }
        C_Packet[] res = new C_Packet[jTable1.getSelectedRows().length];
        for (int i = 0; i < jTable1.getSelectedRows().length; i++) {
            int row = jTable1.getSelectedRows()[i];
            res[i] = (C_Packet) jTable1.getValueAt(row, -1);
        }
        return res;
    }

    @Override
    public int getinsize() {
        String text = getintxt();
        if (text == null) {
            return 0;
        }
        if (getTerm_inMode() == INPUT_HEX) {
            return (text.trim().length() + 1) / 3;
        } else {
            return text.length();
        }

    }

    public byte[] instantreadTerm() {
        if (Parent != null) {
            boolean isreading = Parent.isslreading();
            Parent.setslreading(true);
            Object tosend = getsendmsg();
            byte[] b = null;
            if (tosend instanceof byte[]) {
                b = ((byte[]) tosend);
            }
            readTerm(b);
            int waited = Parent.available();
            byte[] res = new byte[waited];
            int readed = -1;
            try {
                readed = Parent.getin().read(res, 0, Parent.available());
            } catch (IOException e) {
            }
            Parent.setslreading(isreading);
            if (readed < waited) {
                res = java.util.Arrays.copyOfRange(res, 0, readed);
            }
            return res;
        } else {
            Object obj = getsendmsg();
            if (obj instanceof byte[]) {
                return (byte[]) obj;
            } else {
                return null;
            }
        }
    }

    public void readTerm() {
        Object tosend = getsendmsg();
        if (tosend == null) {
            return;
        }
        if (Console == null) {
            write(new C_Packet(tosend, null));
            if (isclear()) {
                clearintxt();
            }
            return;
        } else if (Console instanceof I_Main && Parent == null) {
            I_Main m = (I_Main) Console;
            for (I_Port p : m.getPorts()) {
                C_Packet pack = new C_Packet(tosend, null);
                TDeb.wri("packet readTerm() : " + p);
                pack.setdestination(p);
                m.write(pack);
            }
        } else if (tosend instanceof byte[]) {
            readTerm((byte[]) tosend);
            if (Parent != null) {
                Parent.ReadStream(-1);
            } else {
                try {
                    ((TermOutputStream2) getOutputStream()).setPack(new C_Packet("", null));
                    byte[] transfert = new byte[getInputStream().available()];
                    getInputStream().read(transfert, 0, transfert.length);
                    if (transfert.length > 0) {
                        getOutputStream().write(transfert);
                    }
                } catch (IOException ex) {
                }
            }
        } else {
            C_Packet pack = new C_Packet(tosend, Parent);
            Parent.read_in(pack);
        }
        if (isclear()) {
            clearintxt();
        }
        jTextPane2.requestFocus();
    }

    public void readTerm(byte[] datas) {
        if (datas == null) {
            TDeb.wri("Null text : not sended");
        } else if (datas.length == 0) {
            TDeb.wri("Empty Text : not sended");
        } else {
            int start = Streambuff.size();
            for (int i = 0; i < datas.length; i++) {
                Streambuff.add(datas[i]);
            }
            // readTerm(start);
        }
    }

    /*    public void readTerm(int start) {
     int taille = Streambuff.size() - start;
     if (taille <= 0) {
     TDeb.wri("Null buffer : not sended");
     return;
     }
     byte[] ret = new byte[taille];
     for (int i = 0; i < taille; i++) {
     ret[i] = Streambuff.get(i + start);
     }
     }*/
    private void writeCaptureModel(C_Packet d) {

        if (Parent != null && Parent.isTERM_capReader() == false) {
            return;
        }
        if (d.getObj() instanceof Code_Model == false) {
            return;
        }
        Code_Model mod = (Code_Model) d.getObj();
        int rowsec = -1;
        int rowdsrc = -1;
        int rowms = -1;
        int rowdata = -1;
        boolean istcpdump = true;
        String dumpDescr = "Dump.";
        String encapDescr = "ETHI.";
        for (int i = 0; i < mod.getRowCount(); i++) {
            String proto = (String) mod.getValueAt(i, "Proto");
            String tag = proto + "." + mod.getValueAt(i, "Name");
            if (proto.length() > 4) {
                tag = proto.substring(0, 4) + "." + mod.getValueAt(i, "Name");
            }
            if (tag.compareTo(dumpDescr + "data") == 0) {
                rowdata = i;
            } else if (tag.compareTo(encapDescr + "tp") == 0) {
                if (mod.getValueAt(i, "Value").toString().compareTo("10:00") == 0
                        || mod.getValueAt(i, "Value").toString().compareTo("65:58") == 0) {
                    istcpdump = false;
                } else {
                    istcpdump = true;
                }
            } else if (istcpdump == false && tag.compareTo(encapDescr + "data") == 0) {
                rowdata = i;
            } else if (tag.compareTo(dumpDescr + "time_sec") == 0) {
                rowsec = i;
            } else if (tag.compareTo(dumpDescr + "time_ms") == 0) {
                rowms = i;
            } else if (tag.compareTo(encapDescr + "src") == 0) {
                rowdsrc = i;
            }

        }
        byte[] buffer = (byte[]) mod.getValueAt(rowdata, "Value");
        int ms = (Integer) mod.getValueAt(rowms, "Value");
        long sec = ((java.util.Date) mod.getValueAt(rowsec, "Value")).getTime();
        Date dat = new Date(sec + (ms / 1000));
        int src = 0;
        if (istcpdump == false) {
            try {
                String macstr = mod.getValueAt(rowdsrc, "Value").toString();
                String[] mac = macstr.split(":");
                if (macstr.substring(macstr.length() - 6, macstr.length() - 1).endsWith(":ff:f")) {
                    src = Integer.parseInt(mac[mac.length - 1], 16) - 256;
                } else {
                    src = Integer.parseInt(mac[mac.length - 1], 16) + 255 * Integer.parseInt(mac[mac.length - 2], 16);
                }
            } catch (NumberFormatException ex) {
                src = 99;
            }

        }
        C_Packet pa = new C_Packet(buffer, src);
        pa.setStoredtime(dat);
        writebyteterm(pa);
    }

    private byte[] Ethpack2bytes(Object o) {
        // TDeb.wri("Write on Terminal detailled ETHERNET packet: " + o.toString());
        //waiting uncode
        jpcap.packet.Packet Pack = (jpcap.packet.Packet) o;
        // res= Pack.toString()+"\r\n"; => interpreted packet by jpcap
        byte[] buff = Pack.data;
        /*
         * if (buff.length==46){ int newl=buff.length; while (buff[newl-1]==0 &&
         * newl>0){ newl--; } buff=java.util.Arrays.copyOf(buff, newl); }
         */
        return TUtils.addtab(Pack.header, buff);

    }

    public void fireDataChange() {
        model.fireTableDataChanged();
    }

    public int writebyteterm(C_Packet pack) {
        int res = 0;
        if (pack == null) {
            return -1;
        } else {
            TDeb.wri("Write on Terminal : " + pack.length() + " bytes  ");
        }
        int[] sels = jTable1.getSelectedRows();
        if (pack.getBytes() != null) {
            final C_Packet e = (C_Packet) pack.clone();
            e.store();
            final byte[] buff = java.util.Arrays.copyOf(e.getBytes(), e.getBytes().length);
            if (isKeyBS()) {
                e.setObj(getManageBS(buff));
                if (e.getObj() == null) {
                    return 0;
                }
            }

            model.addrow(e);
            res = pack.getBytes().length;
            if (termgraph != null) {
                termgraph.addval("term", e.getStoredtime().getTime(), buff.length, "" + model.getTraces().indexOf(pack));
                if (Parent != null && Parent.getConsole() != null) {
                    termgraph.setlastColor("term", Parent.getConsole().getColor(pack.getsourceidx()));
                }
                termgraph.addval("term", e.getStoredtime().getTime() + 1, 0, "[NOSHAPE]");
            }
            if (getTerm_outMode().startsWith("OUTPUT_SCREEN")
                    || getTerm_outMode().compareTo("OUTPUT_CONSOLE") == 0) {
                addConsoleText(e, -1);
            }
        } else {
            model.addrow(pack);
            if (termgraph != null) {
                termgraph.addval("term", pack.getStoredtime().getTime(), 1, "" + model.getTraces().indexOf(pack));
                if (Parent != null && Parent.getConsole() != null) {
                    termgraph.setlastColor("term", Parent.getConsole().getColor(pack.getsourceidx()));
                }
                termgraph.addval("term", pack.getStoredtime().getTime() + 1, 0, "[NOSHAPE]");
            }
            if (getTerm_outMode().startsWith("OUTPUT_SCREEN")
                    || getTerm_outMode().compareTo("OUTPUT_CONSOLE") == 0) {
                addConsoleText(pack, -1);
            }
        }
        for (int sel : sels) {
            jTable1.addRowSelectionInterval(sel, sel);
        }
        return res;
    }

    /**
     * Receive the data to print from Main
     *
     * @param d the packet to print
     * @return the length (byte) printed
     */
    @Override
    public int write(C_Packet d) {
        if (d == null) {
            return 0;
        }
        if (Parent != null) {
            Parent.getMain().addpacket("" + d.hashCode(), System.currentTimeMillis(), "Term_Writing", d.toString());
            if (Parent.isTERM_capReader() && d.getObj() instanceof Code_Model) {
                writeCaptureModel(d);
                return 0;
            }
        }
        return writebyteterm(d);
    }

    /**
     * get byte from Object to byte for printing - sort of .toString()
     *
     * @param o the object to print
     * @return the 'equivalent' byte
     */
    public byte[] Obj2bytes(Object o) {

        if (o instanceof byte[]) {
            return (byte[]) o;
        }
        if (o instanceof Boolean) {
            if ((Boolean) o) {
                return new byte[]{0x00};
            } else {
                return new byte[]{0x01};
            }
        }
        if (o == null) {
            return null;
        } else {
            try {
                if (o.getClass().getName().startsWith("jpcap.packet")) {
                    return Ethpack2bytes(o);
                }
            } catch (NoClassDefFoundError er) {
            }
        }
        if (o instanceof Code_Model) {
            // sholud not be serializable (if asking serial => Pb)
            return "[codeModel]".getBytes();
        } else {
            return o.toString().getBytes();
        }
    }

    /**
     * Decode lead to a Panel for showing objects
     *
     * @return true if DecodeMenu is set
     */
    public boolean isAutoDecode() {
        return jToggleButton9.isSelected();
    }

    /**
     * Show Panel with traffic
     *
     * @return true if GraphMenu is set
     */
    public boolean isAutoGraph() {
        return jToggleButton8.isSelected();
    }

    /**
     * set Decode that lead to a Panel for showing objects
     *
     * @param bool tru if decode is set
     */
    public void setAutoDecode(boolean bool) {
        if (bool != isAutoDecode()) {
            jToggleButton9.setSelected(bool);
        }
        if (DecodeMenuItem.isSelected() != bool) {
            DecodeMenuItem.setSelected(bool);
        }
        if (bool) {
            groupAndDecodeRows();
            if (deceditor == null) {
                setAutoDecode(false);
            } else {
                fdecode = new F_PopUp(deceditor);
                fdecode.addComponentListener(new java.awt.event.ComponentAdapter() {
                    @Override
                    public void componentHidden(ComponentEvent ce) {
                        setAutoDecode(false);
                    }
                });
                fdecode.setTitle("Terminal decoder");
                refreshPopups();
                fdecode.setFocusAsFrame(this);
                fdecode.setVisible(true);
                jTable1MouseReleased(null);
                repaint();
            }
        } else {
            if (fdecode != null) {
                fdecode.setVisible(false);
                fdecode = null;
            }
            deceditor = null;
            table = null;
            GraphMenuItem.setEnabled(true);
        }
    }

    /**
     * Display and set the graph (time/lenght/source) of the stream
     *
     * @param bool
     */
    private void setAutoGraph(boolean bool) {
        if (bool != isAutoGraph()) {
            jToggleButton8.setSelected(bool);
        }
        if (GraphMenuItem.isSelected() != bool) {
            GraphMenuItem.setSelected(bool);
        }
        if (bool) {
            termgraph = new P_Chartplus(this);
            termgraph.addcourbe(new String[]{"time", "bytes"}, local_col, null, null, 2, 0.0, "term");
            termgraph.setdrawpt(true);
            fgraph = new F_PopUp(termgraph);
            fgraph.addComponentListener(new java.awt.event.ComponentAdapter() {
                @Override
                public void componentHidden(ComponentEvent ce) {
                    setAutoGraph(false);
                }
            });
            fgraph.setTitle("Terminal Graph");
            fgraph.setFocusAsFrame(this);
            refreshPopups();
            termgraph.setVisible(true);
            fgraph.setVisible(true);
            repaint();
            if (model.getTraces().isEmpty()) {
                termgraph.addval("term", System.currentTimeMillis(), 0, "init");
            } else {
                termgraph.addval("term", model.getTraces().get(0).getStoredtime().getTime() - 1, 0, "init");
            }
            for (C_Packet pack : model.getTraces()) {
                if (pack.getBytes() != null) {
                    termgraph.addval("term", pack.getStoredtime().getTime(), pack.getBytes().length, "" + model.getTraces().indexOf(pack));
                } else {
                    termgraph.addval("term", pack.getStoredtime().getTime(), 1, "" + model.getTraces().indexOf(pack));
                }
                if (Parent != null) {
                    termgraph.setlastColor("term", Parent.getConsole().getColor(pack.getsourceidx()));
                }
                termgraph.addval("term", pack.getStoredtime().getTime() + 1, 0, "[NOSHAPE]");
            }
        } else {
            if (fgraph != null) {
                fgraph.setVisible(false);
                fgraph = null;
            }
            termgraph = null;
            table = null;
            DecodeMenuItem.setEnabled(true);
        }
        this.repaint();
    }

    /**
     * return packets selected in the table
     */
    private void sendbackSelection() {
        for (int row : jTable1.getSelectedRows()) {
            C_Packet pac = model.getPacket(row);
            if (pac.isbuffer()) {
                readTerm((byte[]) pac.getObj());
                readTerm();
            } else if (Parent != null) {
                Parent.read_in(new C_Packet(pac.getObj(), Parent));
            }
        }
    }

    /**
     * join, in selection order, ONLY byte packet to the first (time) packet
     */
    private void aggregateSelection() {
        //AGGREGATE
        long aggTime = 0;
        byte[] aggBuff = new byte[0];
        int aggRow = -1;
        C_Packet aggPack = null;
        java.util.ArrayList<C_Packet> rowList = new java.util.ArrayList<>();
        for (int idx : jTable1.getSelectedRows()) {
            int rowModel = jTable1.convertRowIndexToModel(idx);
            rowList.add(model.getTraces().get(rowModel));
        }
        // seach the first one and aggregate
        for (int row : jTable1.getSelectedRows()) {
            int rowModel = jTable1.convertRowIndexToModel(row);
            C_Packet pac = model.getPacket(rowModel);
            if (pac.getStoredtime().getTime() < aggTime || aggTime == 0) {
                aggTime = pac.getStoredtime().getTime();
                aggRow = row;
                aggPack = pac;
            }
            if (pac.isbuffer()) {
                aggBuff = TUtils.addtab(aggBuff, pac.getBytes());
            } else {
                jTable1.removeRowSelectionInterval(row, row);
            }
        }
        // set and print the result packet, 
        if (aggTime > 0 && aggPack != null) {
            removeAtSelection();
            aggPack.setObj(aggBuff);
            addConsoleText(aggPack, aggRow);
            model.addrow(aggPack, aggRow);
            jTable1.setRowSelectionInterval(aggRow, aggRow);
        }
        updateConsole(rowList);
    }

    /**
     * insert a packet (table & console) at the first packet of selection OR at
     * end if no selection
     *
     * @param pack the packet to insert
     */
    private void addAtSelection(C_Packet pack) {
        int start = -1;
        if (jTable1.getSelectedRow() >= 0) {
            start = jTable1.convertRowIndexToModel(jTable1.getSelectedRow());
        }
        if (start == -1) {
            model.addrow(pack);
            addConsoleText(pack, -1);
        } else {
            model.addrow(pack, start);
            addConsoleText(pack, start);
            int pos = jTable1.convertRowIndexToView(start);
            jTable1.setRowSelectionInterval(pos, pos);
        }
    }

    /**
     * Remove (table & console) selected packet
     */
    private void removeAtSelection() {
        if (isEditing() && model != null && jTable1.getSelectedRow() != -1) {
            final int[] rows = jTable1.getSelectedRows();
            int next_select = rows[0];
            java.util.Arrays.sort(rows);
            for (int j = rows.length - 1; j >= 0; j--) {
                int viewidx = jTable1.convertRowIndexToModel(rows[j]);
                removePacketConsole(model.getPacket(viewidx));
                model.removerow(viewidx);
            }
            if (next_select >= model.getRowCount()) {
                next_select = model.getRowCount() - 1;
            }
            if (next_select >= 0) {
                jTable1.setRowSelectionInterval(next_select, next_select);
            }
        }
    }

    private boolean checkSignature(String sgn1, String sgn2) {
        //si'...TCP:80,5000' et 'TCP:5000,80,NDC' => same stream => true
        boolean res = true;
        java.util.LinkedList<String> lst2 = new java.util.LinkedList<>();
        lst2.addAll(Arrays.asList(sgn2.split(",")));
        for (int i = 0; i < lst2.size(); i++) {
            if (lst2.get(i).contains("#")) {
                lst2.add(lst2.get(i).split("#")[1]);
                lst2.set(i, lst2.get(i).split("#")[0]);
            }
        }
        //!!! NEED to manage ":".
        for (String txt1 : sgn1.split(",")) {
            for (String txt2 : txt1.split("#")) {
                if (lst2.contains(txt2) == false && !lst2.isEmpty()) {
                    res = false;
                } else {
                    lst2.remove(txt2);
                }
            }
        }
        return res;
    }

    @Override
    public javax.swing.ImageIcon getCMDIcon() {
        return ((new com.jdcm.common.D_Utils()).getIcon("Terminal.gif"));
    }

    @Override
    public Options_Model getCMDOptions() {
        return option;
    }

    @Override
    public String getCMDdetails() {
        String res = "";
        res += "Name : " + this.getCMDName() + " Type : " + this.getType() + " Nb line :" + model.getRowCount() + "\r\n";
        return res;
    }

    @Override
    public java.util.List<I_Command> getCMDChilds(String child) {
        return new java.util.ArrayList<>();
    }

    @Override
    public String getCMDName() {
        return "Terminal";
    }

    @Override
    public I_Command getCMDParent() {
        if (Parent instanceof I_Command) {
            return (I_Command) Parent;
        }

        return null;
    }

    @Override
    public String getCMDdesc() {
        return getCMDName() + " \t" + this.getType() + "\t" + this.getTitle();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenu1 = new javax.swing.JMenu();
        jCheckBoxMenuItem1 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem2 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem3 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem4 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem11 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem5 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem6 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem7 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem8 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem9 = new javax.swing.JCheckBoxMenuItem();
        jCheckBoxMenuItem10 = new javax.swing.JCheckBoxMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jMenuItem11 = new javax.swing.JMenuItem();
        jMenuItem13 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem10 = new javax.swing.JMenuItem();
        DecodeMenuItem = new javax.swing.JCheckBoxMenuItem();
        GraphMenuItem = new javax.swing.JCheckBoxMenuItem();
        jMenuItem12 = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem14 = new javax.swing.JMenuItem();
        jMenuItem15 = new javax.swing.JMenuItem();
        jMenuItem16 = new javax.swing.JMenuItem();
        buttonGroup1 = new javax.swing.ButtonGroup();
        jToolBar1 = new javax.swing.JToolBar();
        jButton7 = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        jRollingButton1 = new com.jdcm.common.G_JRollingButton();
        jRollingButton2 = new com.jdcm.common.G_JRollingButton();
        g_JRollingButton1 = new com.jdcm.common.G_JRollingButton();
        jSeparator4 = new javax.swing.JToolBar.Separator();
        jToggleButton3 = new javax.swing.JToggleButton();
        jToggleButton7 = new javax.swing.JToggleButton();
        jRollingButton3 = new com.jdcm.common.G_JRollingButton();
        jToggleButton4 = new javax.swing.JToggleButton();
        jSeparator5 = new javax.swing.JToolBar.Separator();
        jToggleButton6 = new javax.swing.JToggleButton();
        jButton3 = new javax.swing.JButton();
        jButton9 = new javax.swing.JButton();
        jButton10 = new javax.swing.JButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jToggleButton8 = new javax.swing.JToggleButton();
        jToggleButton9 = new javax.swing.JToggleButton();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane2 = new com.jdcm.common.G_NonWrappingTextPane();
        jTable3 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jRollingButton4 = new com.jdcm.common.G_JRollingButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        jMenu1.setText("Colums");

        jCheckBoxMenuItem1.setText("Delai");
        jCheckBoxMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem1);

        jCheckBoxMenuItem2.setText("Create");
        jCheckBoxMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem2);

        jCheckBoxMenuItem3.setText("N");
        jCheckBoxMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem3);

        jCheckBoxMenuItem4.setText("Src.");
        jCheckBoxMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem4ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem4);

        jCheckBoxMenuItem11.setSelected(true);
        jCheckBoxMenuItem11.setText("Dst.");
        jCheckBoxMenuItem11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem11ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem11);

        jCheckBoxMenuItem5.setText("Storetime");
        jCheckBoxMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem5ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem5);

        jCheckBoxMenuItem6.setText("Size");
        jCheckBoxMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem6ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem6);

        jCheckBoxMenuItem7.setText("Data (Hex)");
        jCheckBoxMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem7ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem7);

        jCheckBoxMenuItem8.setText("Data (ascii)");
        jCheckBoxMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem8ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem8);

        jCheckBoxMenuItem9.setText("Edit");
        jCheckBoxMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem9ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem9);

        jCheckBoxMenuItem10.setText("Stacks");
        jCheckBoxMenuItem10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBoxMenuItem10ActionPerformed(evt);
            }
        });
        jMenu1.add(jCheckBoxMenuItem10);

        jPopupMenu1.add(jMenu1);
        jPopupMenu1.add(jSeparator2);

        jMenuItem3.setText("Color");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem3);

        jMenuItem4.setText("mark");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem4);

        jMenu3.setText("Modify");

        jMenuItem8.setText("src++");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem8);

        jMenuItem9.setText("src--");
        jMenuItem9.setActionCommand("Src--");
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem9);

        jMenuItem11.setText("Aggregate");
        jMenuItem11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem11ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem11);

        jMenuItem13.setText("Clear Proto");
        jMenuItem13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem13ActionPerformed(evt);
            }
        });
        jMenu3.add(jMenuItem13);

        jPopupMenu1.add(jMenu3);

        jMenu2.setText("Packet");

        jMenuItem5.setText("Add");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem5);

        jMenuItem6.setText("Remove");
        jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem6ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem6);

        jMenuItem1.setText("copy");
        jMenuItem1.setToolTipText("");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem1);

        jMenuItem2.setText("cut");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuItem7.setText("paste");
        jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem7ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem7);

        jMenuItem10.setText("sendBack");
        jMenuItem10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem10ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem10);

        jPopupMenu1.add(jMenu2);

        DecodeMenuItem.setText("Detail");
        DecodeMenuItem.setToolTipText("decode/see elt");
        DecodeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DecodeMenuItemActionPerformed(evt);
            }
        });
        jPopupMenu1.add(DecodeMenuItem);

        GraphMenuItem.setText("Graph");
        GraphMenuItem.setToolTipText("graphic view");
        GraphMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                GraphMenuItemActionPerformed(evt);
            }
        });
        jPopupMenu1.add(GraphMenuItem);

        jMenuItem12.setText("ExportSelected");
        jMenuItem12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem12ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem12);

        jMenu4.setText("Stack");

        jMenuItem14.setText("FollowStream");
        jMenuItem14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem14ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem14);

        jMenuItem15.setText("reset");
        jMenuItem15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem15ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem15);

        jMenuItem16.setText("PPPAgregate");
        jMenuItem16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem16ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem16);

        jPopupMenu1.add(jMenu4);

        setTitle("Terminal");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowDeiconified(java.awt.event.WindowEvent evt) {
                formWindowDeiconified(evt);
            }
            public void windowIconified(java.awt.event.WindowEvent evt) {
                formWindowIconified(evt);
            }
        });
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                formComponentHidden(evt);
            }
            public void componentMoved(java.awt.event.ComponentEvent evt) {
                formComponentMoved(evt);
            }
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });

        jToolBar1.setRollover(true);
        jToolBar1.setToolTipText("Terminal Option bar");
        jToolBar1.setName("Terminal Options"); // NOI18N

        jButton7.setToolTipText("Save capture");
        jButton7.setBorderPainted(false);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton7);
        jToolBar1.add(jSeparator3);

        jRollingButton1.setToolTipText("output mode");
        jRollingButton1.setBorderPainted(false);
        jRollingButton1.setFocusable(false);
        jRollingButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRollingButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jRollingButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRollingButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jRollingButton1);

        jRollingButton2.setToolTipText("tex/hexa");
        jRollingButton2.setBorderPainted(false);
        jRollingButton2.setFocusable(false);
        jRollingButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRollingButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jRollingButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRollingButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jRollingButton2);

        g_JRollingButton1.setToolTipText("time display mode");
        g_JRollingButton1.setBorderPainted(false);
        g_JRollingButton1.setFocusable(false);
        g_JRollingButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        g_JRollingButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        g_JRollingButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                g_JRollingButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(g_JRollingButton1);
        jToolBar1.add(jSeparator4);

        jToggleButton3.setToolTipText("Echo");
        jToggleButton3.setBorderPainted(false);
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton3);

        jToggleButton7.setToolTipText("Allow input");
        jToggleButton7.setBorderPainted(false);
        jToggleButton7.setFocusable(false);
        jToggleButton7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton7.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton7);

        jRollingButton3.setToolTipText("send method");
        jRollingButton3.setBorderPainted(false);
        jRollingButton3.setFocusable(false);
        jRollingButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRollingButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jRollingButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRollingButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jRollingButton3);

        jToggleButton4.setToolTipText("Clear/Keep input");
        jToggleButton4.setBorderPainted(false);
        jToggleButton4.setFocusable(false);
        jToggleButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton4);
        jToolBar1.add(jSeparator5);

        jToggleButton6.setToolTipText("SetLog");
        jToggleButton6.setBorderPainted(false);
        jToggleButton6.setFocusable(false);
        jToggleButton6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton6.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton6ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton6);

        jButton3.setToolTipText("Clear Output");
        jButton3.setBorderPainted(false);
        jButton3.setEnabled(false);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jButton9.setToolTipText("sendback");
        jButton9.setBorderPainted(false);
        jButton9.setEnabled(false);
        jButton9.setFocusable(false);
        jButton9.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton9.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton9);

        jButton10.setToolTipText("open Capture");
        jButton10.setBorderPainted(false);
        jButton10.setEnabled(false);
        jButton10.setFocusable(false);
        jButton10.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton10.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton10);

        jToggleButton1.setToolTipText("lock/unlock");
        jToggleButton1.setBorderPainted(false);
        jToggleButton1.setFocusable(false);
        jToggleButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        jToggleButton2.setToolTipText("backspace");
        jToggleButton2.setBorderPainted(false);
        jToggleButton2.setFocusable(false);
        jToggleButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton2);

        jToggleButton8.setToolTipText("See graph");
        jToggleButton8.setBorderPainted(false);
        jToggleButton8.setFocusable(false);
        jToggleButton8.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton8.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton8ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton8);

        jToggleButton9.setToolTipText("See decode");
        jToggleButton9.setBorderPainted(false);
        jToggleButton9.setFocusable(false);
        jToggleButton9.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton9.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton9ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton9);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.PAGE_START);

        jSplitPane2.setDividerLocation(40);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane2.setPreferredSize(new java.awt.Dimension(652, 300));

        jPanel1.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setPreferredSize(new java.awt.Dimension(8, 50));

        jTextPane2.setEditable(false);
        jTextPane2.setComponentPopupMenu(jPopupMenu1);
        jTextPane2.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextPane2KeyReleased(evt);
            }
        });
        jScrollPane1.setViewportView(jTextPane2);

        jTable3.setFont(new java.awt.Font("Courier New", 0, 12)); // NOI18N
        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"Value"}
            },
            new String [] {
                "Edit (Obj)"
            }
        ));
        jTable3.setToolTipText("Terminal Output");
        jTable3.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        jTable3.setAutoscrolls(false);
        jTable3.setComponentPopupMenu(jPopupMenu1);
        jScrollPane1.setViewportView(jTable3);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.GridLayout(1, 0));

        jButton1.setText("Send");
        jButton1.setAlignmentY(0.0F);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton1);

        jRollingButton4.setToolTipText("input type");
        jRollingButton4.setFocusable(false);
        jRollingButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jRollingButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jRollingButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRollingButton4ActionPerformed(evt);
            }
        });
        jPanel2.add(jRollingButton4);

        jPanel1.add(jPanel2, java.awt.BorderLayout.EAST);

        jSplitPane2.setTopComponent(jPanel1);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable1.setComponentPopupMenu(jPopupMenu1);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable1MouseReleased(evt);
            }
        });
        jTable1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTable1KeyPressed(evt);
            }
        });
        jScrollPane2.setViewportView(jTable1);

        jSplitPane2.setRightComponent(jScrollPane2);

        getContentPane().add(jSplitPane2, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        // showObject(jTable1.getSelectedRow());
        java.util.ArrayList<C_Packet> rowList = new java.util.ArrayList<>();
        for (int row : jTable1.getSelectedRows()) {
            C_Packet pack = model.getPacket(row);
            pack.setmarked(!pack.ismarked());
            rowList.add(pack);
        }
        jTable1.repaint();
        updateConsole(rowList);
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        int row = jTable1.getSelectedRow();
        if (row >= 0) {
            jTable1.setRowSelectionInterval(row, row);
            int portidx = ((C_Packet) jTable1.getValueAt(row, -1)).getsourceidx();
            Color oldCol = java.awt.Color.BLACK;
            if (Parent != null && Parent.getConsole() != null) {
                oldCol = getPortColor(portidx);
            }

            Color newCol = javax.swing.JColorChooser.showDialog(this, "Change port color", oldCol);
            if (newCol != null && newCol != oldCol) {

                activrow(jTable1);
                if (Console != null) {
                    Console.setColor(portidx, newCol);
                } else {
                    local_col = newCol;
                    refresh();
                }
            }
        }
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jCheckBoxMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem8ActionPerformed
        setColumn("Data (ascii)", jCheckBoxMenuItem8.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem8ActionPerformed

    private void jCheckBoxMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem6ActionPerformed
        setColumn("Size", jCheckBoxMenuItem6.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem6ActionPerformed

    private void jCheckBoxMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem7ActionPerformed
        setColumn("Data (Hex)", jCheckBoxMenuItem7.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem7ActionPerformed

    private void jCheckBoxMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem5ActionPerformed
        setColumn("Storetime", jCheckBoxMenuItem5.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem5ActionPerformed

    private void jCheckBoxMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem4ActionPerformed
        setColumn("Src.", jCheckBoxMenuItem4.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem4ActionPerformed

    private void jCheckBoxMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem3ActionPerformed
        setColumn("N", jCheckBoxMenuItem3.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem3ActionPerformed

    private void jCheckBoxMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem2ActionPerformed

        setColumn("Create", jCheckBoxMenuItem2.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem2ActionPerformed

    private void jCheckBoxMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem1ActionPerformed
        setColumn("Delai", jCheckBoxMenuItem1.isSelected());

    }//GEN-LAST:event_jCheckBoxMenuItem1ActionPerformed

    private void jCheckBoxMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem9ActionPerformed
        setColumn("Edit", jCheckBoxMenuItem9.isSelected());
    }//GEN-LAST:event_jCheckBoxMenuItem9ActionPerformed

    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        //ADD
        if (isEditing() && model != null) {
            C_Packet npack = new C_Packet("[New data]", null);//0!!
            npack.setCreatetime(new Date(System.currentTimeMillis()));
            addAtSelection(npack);
        }
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    private void jMenuItem6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem6ActionPerformed
        //REMOVE
        removeAtSelection();
    }//GEN-LAST:event_jMenuItem6ActionPerformed

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        refresh();
        refreshPopups();
    }//GEN-LAST:event_formComponentResized

    private void DecodeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DecodeMenuItemActionPerformed
        setAutoDecode(DecodeMenuItem.isSelected());
    }//GEN-LAST:event_DecodeMenuItemActionPerformed

private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
    //COPY
    if (isEditing() && model != null && jTable1.getSelectedRow() != -1) {
        clipboard = new C_Packet[jTable1.getSelectedRowCount()];
        int idx = 0;
        for (int i : jTable1.getSelectedRows()) {
            int pos = jTable1.convertRowIndexToModel(i);
            clipboard[idx++] = (C_Packet) model.getPacket(pos).clone();
        }
    }

}//GEN-LAST:event_jMenuItem1ActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
    //CUT
    if (isEditing() && model != null && jTable1.getSelectedRow() != -1) {
        clipboard = new C_Packet[jTable1.getSelectedRowCount()];
        int idx = 0;
        for (int i : jTable1.getSelectedRows()) {
            int pos = jTable1.convertRowIndexToModel(i);
            clipboard[idx++] = (C_Packet) model.getPacket(pos).clone();
        }
        removeAtSelection();
    }
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
    //PASTE
    int start = jTable1.getSelectedRow();
    if (clipboard != null) {
        if (isEditing() && model != null && clipboard != null) {
            for (int i = clipboard.length - 1; i >= 0; i--) {
                //  clipboard[i].setStoredtime(new java.util.Date(System.currentTimeMillis()));
                addAtSelection(clipboard[i]);
            }
            jTable1.removeRowSelectionInterval(0, jTable1.getRowCount() - 1);
            jTable1.addRowSelectionInterval(start, start + clipboard.length - 1);
        }

        // converRow to view and multiple to manage...
        //  jTable1.setRowSelectionInterval(start + 1, start + clipboard.length);
    }

}//GEN-LAST:event_jMenuItem7ActionPerformed

private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
    if (model.getTraces().isEmpty() == false) {
        SaveTerm(model.getTraces(), true);
    }
}//GEN-LAST:event_jButton7ActionPerformed

private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
    setTecho(isTecho());
}//GEN-LAST:event_jToggleButton3ActionPerformed

private void jToggleButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton6ActionPerformed
    setlog(jToggleButton6.isSelected());
}//GEN-LAST:event_jToggleButton6ActionPerformed

private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
    if (jTable1.isVisible() == false || jTable1.getSelectedRowCount() == 0) {
        clearouttxt();
        setAutoDecode(false);
    } else {
        removeAtSelection();
        //ctrl A => select all
        //    jTable1.clearSelection();
    }
}//GEN-LAST:event_jButton3ActionPerformed

private void jToggleButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton4ActionPerformed
    setclear(isclear());
}//GEN-LAST:event_jToggleButton4ActionPerformed

private void jToggleButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton7ActionPerformed
    setlockedin(islockedin());
}//GEN-LAST:event_jToggleButton7ActionPerformed

private void jTextPane2KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextPane2KeyReleased
    byte[] d = new byte[0];
    if (getTerm_inMode() == INPUT_ASCII) {
        d = jTextPane2.getText().getBytes();
    } else if (getTerm_inMode() == INPUT_HEX) {
        try {
            d = TUtils.string2byte(jTextPane2.getText());
            jTextPane2.setBackground(java.awt.Color.green);
        } catch (Exception ex) {
            d = new byte[0];
            jTextPane2.setBackground(java.awt.Color.red);
        }
    } else {
        //Object
    }
    if (d != null && d.length > 0) {
        if (getSendbt().compareTo("KEY") == 0) {
            readTerm();
        } else if (getSendbt().compareTo("ENTER") == 0) {
            if (evt.getKeyCode() == KeyEvent.VK_ENTER) {
                readTerm();
            }
        }
    }
}//GEN-LAST:event_jTextPane2KeyReleased

private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
//SRC +1
    java.util.ArrayList<C_Packet> rowList = new java.util.ArrayList<>();
    for (int row : jTable1.getSelectedRows()) {
        C_Packet pack = model.getPacket(row);
        if (pack.getsourceidx() < 0) {
            pack.setstore_srcidx(0);
        } else {
            pack.setstore_srcidx(pack.getsourceidx() + 1);
        }
        pack.setsource(null);
        model.fireTableDataChanged();
        rowList.add(pack);
    }
    updateConsole(rowList);
}//GEN-LAST:event_jMenuItem8ActionPerformed

private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
//SRC -1
    java.util.ArrayList<C_Packet> rowList = new java.util.ArrayList<>();
    for (int row : jTable1.getSelectedRows()) {
        C_Packet pack = model.getPacket(row);
        if (pack.getsourceidx() > 0) {
            pack.setstore_srcidx(pack.getsourceidx() - 1);
        } else if (pack.getsourceidx() == 0) {
            pack.setstore_srcidx(-99);
        }
        pack.setdestination(null);
        model.fireTableDataChanged();
        rowList.add(pack);
    }
    updateConsole(rowList);
}//GEN-LAST:event_jMenuItem9ActionPerformed

private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
    // matrix needed to avoid traces everywhere
    if (Parent == null && Console == null) {
        return;
    }
    java.io.File file = TUtils.getUIreadFile(this, javax.swing.JFileChooser.FILES_AND_DIRECTORIES, null, true);
    if (file != null) {
        byte[] b = new byte[4];
        int red = -1;
        try {
            try (java.io.InputStream f = TUtils.getFileStream(file)) {
                red = f.read(b);
            }
        } catch (IOException ex) {
            TDeb.wri("File not red =>" + ex.getMessage());
        }
        C_Main main;
        if (red == -1) {
            javax.swing.JOptionPane.showMessageDialog(this, "File empty or reading error", "File View", javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }
        if (Parent != null && Parent.getMain() instanceof C_Main) {
            main = (C_Main) Parent.getMain();
        } else if (Console instanceof C_Main) {
            main = (C_Main) Console;
        } else {
            return;
        }
        if (Arrays.equals(b, new byte[]{-44, -61, -78, -95}) && getport().getMain() instanceof C_Main) {
            // capture file signature...
            main.DisplayCapture(Parent, file);
        } else {
            // read like that
            C_Port port0 = (C_Port) main.addCX(null, "Port");
            port0.setcxstatus("creating");
            port0.setModeName("File");
            port0.setFile_addr(file);
            port0.setFile_read(true);
            port0.setFile_write(false);
            port0.setFile_EOFstop(true);
            port0.CXstart();
            while (port0.getcxstatus().startsWith("stopped") == false) {
                try {
                    Thread.sleep(5);
                } catch (InterruptedException ex) {
                }
            }
            Parent.setTERM_capReader(false);
            port0.CXend();
        }
    }
}//GEN-LAST:event_jButton10ActionPerformed

private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
    setEditing(jToggleButton1.isSelected());
}//GEN-LAST:event_jToggleButton1ActionPerformed

private void jRollingButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRollingButton1ActionPerformed
    setTerm_outMode(jRollingButton1.getValue().toString());
}//GEN-LAST:event_jRollingButton1ActionPerformed

private void jRollingButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRollingButton2ActionPerformed
    setSubType(getSubType());
}//GEN-LAST:event_jRollingButton2ActionPerformed

private void jToggleButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton8ActionPerformed
    setAutoGraph(jToggleButton8.isSelected());
}//GEN-LAST:event_jToggleButton8ActionPerformed

private void GraphMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_GraphMenuItemActionPerformed
    setAutoGraph(GraphMenuItem.isSelected());
}//GEN-LAST:event_GraphMenuItemActionPerformed

private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
    sendbackSelection();
}//GEN-LAST:event_jButton9ActionPerformed

private void jMenuItem10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem10ActionPerformed
    sendbackSelection();
}//GEN-LAST:event_jMenuItem10ActionPerformed

private void jMenuItem11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem11ActionPerformed
    aggregateSelection();
}//GEN-LAST:event_jMenuItem11ActionPerformed

private void jCheckBoxMenuItem10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem10ActionPerformed
    setColumn("Stacks", jCheckBoxMenuItem10.isSelected());
}//GEN-LAST:event_jCheckBoxMenuItem10ActionPerformed

private void jRollingButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRollingButton3ActionPerformed
    setSendbt(getSendbt());
}//GEN-LAST:event_jRollingButton3ActionPerformed

private void jCheckBoxMenuItem11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBoxMenuItem11ActionPerformed
    setColumn("Dst.", jCheckBoxMenuItem11.isSelected());
}//GEN-LAST:event_jCheckBoxMenuItem11ActionPerformed

    private void jTable1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseReleased
        if (evt != null && evt.getButton() == java.awt.event.MouseEvent.BUTTON1 && evt.getClickCount() == 2) {
            activrow(jTable1);
        } else if (jToggleButton9.isSelected()) {
            groupAndDecodeRows();
        }
    }//GEN-LAST:event_jTable1MouseReleased

    private void jTable1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTable1KeyPressed
        if (evt.getKeyCode() == KeyEvent.VK_SPACE) {
            jTable1MouseReleased(new java.awt.event.MouseEvent(evt.getComponent(), 0, System.currentTimeMillis(), 0, 0, 0, 2, false, java.awt.event.MouseEvent.BUTTON1));
        } else if (evt.getKeyCode() == KeyEvent.VK_DOWN || evt.getKeyCode() == KeyEvent.VK_UP) {
            jTable1MouseReleased(new java.awt.event.MouseEvent(evt.getComponent(), 0, System.currentTimeMillis(), 0, 0, 0, 1, false, java.awt.event.MouseEvent.BUTTON1));
        } else if (evt.getKeyCode() == KeyEvent.VK_DELETE) {
            jMenuItem6ActionPerformed(null);
        } else if (evt.getKeyCode() == KeyEvent.VK_INSERT) {
            jMenuItem5ActionPerformed(null);
        } else if (evt.getKeyCode() == KeyEvent.VK_COPY
                || (evt.isControlDown() && evt.getKeyCode() == KeyEvent.VK_C)) {
            jMenuItem1ActionPerformed(null);
        } else if (evt.getKeyCode() == KeyEvent.VK_CUT
                || (evt.isControlDown() && evt.getKeyCode() == KeyEvent.VK_X)) {
            jMenuItem2ActionPerformed(null);
        } else if (evt.getKeyCode() == KeyEvent.VK_PASTE
                || (evt.isControlDown() && evt.getKeyCode() == KeyEvent.VK_V)) {
            jMenuItem7ActionPerformed(null);
        }
    }//GEN-LAST:event_jTable1KeyPressed

    private void g_JRollingButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_g_JRollingButton1ActionPerformed
        jTable1.repaint();
    }//GEN-LAST:event_g_JRollingButton1ActionPerformed

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        setKeyBS(jToggleButton2.isSelected());
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        readTerm();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jMenuItem12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem12ActionPerformed
        if (jTable1.getSelectedRowCount() >= 0) {
            java.util.List<C_Packet> packs = new java.util.ArrayList<>();
            for (int srow : jTable1.getSelectedRows()) {
                packs.add((C_Packet) model.getValueAt(srow, -1));
            }
            SaveTerm(packs, false);
        }
    }//GEN-LAST:event_jMenuItem12ActionPerformed

    private void formComponentMoved(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentMoved
        refreshPopups();
    }//GEN-LAST:event_formComponentMoved

    private void formComponentHidden(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentHidden
        setAutoDecode(false);
        setAutoGraph(false);
    }//GEN-LAST:event_formComponentHidden

    private void jToggleButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton9ActionPerformed
        setAutoDecode(jToggleButton9.isSelected());
    }//GEN-LAST:event_jToggleButton9ActionPerformed

    private void jRollingButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRollingButton4ActionPerformed
        setTerm_inMode((Integer) jRollingButton4.getValue());
        jTextPane2.requestFocus();
    }//GEN-LAST:event_jRollingButton4ActionPerformed

    private void jMenuItem13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem13ActionPerformed
        for (int idx : jTable1.getSelectedRows()) {
            int rowModel = jTable1.convertRowIndexToModel(idx);
            model.getTraces().get(rowModel).setProtoTree(null);
        }
    }//GEN-LAST:event_jMenuItem13ActionPerformed

    private void jMenuItem14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem14ActionPerformed

        //streams is the stack of target protocols
        String refsgn = "";
        if (jTable1.getSelectedRow() == -1) {
            return;
        }
        java.util.Map<String, Stack_base> bases = new java.util.HashMap<>();
        int src = jTable1.convertRowIndexToModel(jTable1.getSelectedRow());
        javax.swing.tree.DefaultMutableTreeNode n = model.getTraces().get(src).getProtoTree();
        while (n != null && !n.isLeaf()) {
            // trees with several branches are not managed
            n = n.getNextNode();
            if (n != null && n.getUserObject() instanceof Stack_base) {
                Stack_base base = (Stack_base) n.getUserObject();
                String sgn = base.getStackSignature();
                if (sgn != null && sgn.length() > 0) {
                    sgn = base.toString() + "#" + sgn;
                } else {
                    sgn = base.toString();
                }
                refsgn += "," + sgn;
                bases.put(sgn, base);
            }
        }
        if (refsgn.startsWith(",")) {
            refsgn = refsgn.substring(1);
        }
        String selSgn = (String) javax.swing.JOptionPane.showInputDialog(this,
                "stack", "Follow Stack", javax.swing.JOptionPane.QUESTION_MESSAGE,
                TUtils.getIcon("Stacks.gif"), bases.keySet().toArray(), bases.keySet().size() - 1);
        //  int idx = bases.indexOf(bases);
        if (refsgn.length() == 0 || selSgn == null) {
            javax.swing.JOptionPane.showMessageDialog(this,
                    "no signed selected protocols found", "Follow Stack",
                    javax.swing.JOptionPane.ERROR_MESSAGE);
        } else {
            int pos = refsgn.indexOf(selSgn) + selSgn.length();
            refsgn = refsgn.substring(0, pos);
            F_Terminal f = new F_Terminal(Console);
            // No Main() access, if Treminal => PB with setOUTPUT... apply also on real Terminal F_Term..
            f.setTitle(refsgn);
            f.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
            f.setlockedin(true);
            f.setVisible(true);
            for (C_Packet p : getModelPackets()) {
                n = p.getProtoTree();
                if (n == null) {
                    //should add protocol
                } else {
                    String targetSgn = "";
                    Stack_base candidate = null;
                    while (n != null) {
                        n = n.getNextNode();
                        if (n != null && n.getUserObject() instanceof Stack_base) {
                            candidate = (Stack_base) n.getUserObject();
                            if (candidate.getOptions().isPresent(candidate.toString().toLowerCase() + "_data")) {
                                targetSgn += "," + candidate.toString() + "#" + candidate.getStackSignature();
                            } else {
                                n = null;
                            }
                            if (candidate.getClass() == bases.get(selSgn).getClass()) {
                                n = null;
                            }
                        }
                    }
                    if (targetSgn.startsWith(",")) {
                        targetSgn = targetSgn.substring(1);
                    }
                    //signature string Exemple :  ETHII#94:db:c9:47:bf:6c,f4:ca:e5:48:3a:ae,IP#/192.168.110.119,/195.214.243.12,TCP#80,49399
                    if (candidate != null && checkSignature(targetSgn, refsgn)
                            && candidate.getOptions().isPresent(candidate.toString().toLowerCase() + "_data")) {
                        C_Packet outPack = (C_Packet) p.clone();
                        outPack.setObj(candidate.getOptions().getValuefor(candidate.toString().toLowerCase() + "_data", new byte[]{}));
                        outPack.setProtoTree(null);
                        //  '...TCP,80,5000' et 'TCP,5000,80,NDC'
                        if (targetSgn.contains(refsgn) || refsgn.contains(targetSgn)) {
                            outPack.setstore_srcidx(0);
                        } else {
                            outPack.setstore_srcidx(1);
                        }
                        f.write(outPack);
                    }
                }
            }
        }
    }//GEN-LAST:event_jMenuItem14ActionPerformed

    private void jMenuItem15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem15ActionPerformed
        for (C_Packet p : getModelPackets()) {
            p.setProtoTree(null);

        }
        model.fireTableDataChanged();
        for (C_Packet p : getModelPackets()) {
            final C_Packet pack = p;
            new java.lang.Thread(new java.lang.Runnable() {
                @Override
                public void run() {
                    ((C_Main) Parent.getMain()).findPacketStacks(pack);
                    model.fireTableDataChanged();
                }
            }).start();
        }
        /*to performe scan as Thread intead on repaint()
         */
    }//GEN-LAST:event_jMenuItem15ActionPerformed

    private void jMenuItem16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem16ActionPerformed
        for (int i = 0; i < getModelPackets().size() - 1; i++) {
            C_Packet pack = getModelPackets().get(i);
            byte[] buff = pack.getBytes();
            if (buff != null && buff.length > 5// avoid CLIENT at start but keep CLIENSERVER
                    && (buff[0] == 0x7e || (buff.length > 15 && buff[0] == 0x43 && buff[1] == 0x4c && buff[2] == 0x49 && buff[15] == 0x7e))
                    && buff[pack.getBytes().length - 1] != 0x7e) {
                for (int j = i + 1; j < getModelPackets().size(); j++) {
                    C_Packet pack2 = getModelPackets().get(j);
                    if (pack2.getsourceidx() == pack.getsourceidx()) {
                        pack.setObj(TUtils.addtab(pack.getBytes(), pack2.getBytes()));
                        model.removerow(j);
                        if (pack.getBytes()[pack.getBytes().length - 1] == 0x7e) {
                            j = getModelPackets().size();
                        } else {
                            j = j - 1;
                        }
                    }
                    /*      if (j == i + 4) {
                     javax.swing.JOptionPane.showMessageDialog(this, "Error on frame "+i, "PPP AGregate Error", javax.swing.JOptionPane.ERROR_MESSAGE);
                     return;
                     }*/
                }

            }
        }
    }//GEN-LAST:event_jMenuItem16ActionPerformed

    private void formWindowIconified(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowIconified
        if (fdecode != null && fdecode.isAsFrame() == false) {
            fdecode.setState(this.getState());
        }
        if (fgraph != null && fgraph.isAsFrame() == false) {
            fgraph.setState(this.getState());
        }
    }//GEN-LAST:event_formWindowIconified

    private void formWindowDeiconified(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowDeiconified
        if (fdecode != null && fdecode.isAsFrame() == false) {
            fdecode.setExtendedState(this.getState());
        }
        if (fgraph != null && fgraph.isAsFrame() == false) {
            fgraph.setExtendedState(this.getState());
        }
    }//GEN-LAST:event_formWindowDeiconified

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                F_Terminal f = new F_Terminal();
                f.setVisible(true);
                f.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBoxMenuItem DecodeMenuItem;
    private javax.swing.JCheckBoxMenuItem GraphMenuItem;
    private javax.swing.ButtonGroup buttonGroup1;
    private com.jdcm.common.G_JRollingButton g_JRollingButton1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton9;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem1;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem10;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem11;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem2;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem3;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem4;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem5;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem6;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem7;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem8;
    private javax.swing.JCheckBoxMenuItem jCheckBoxMenuItem9;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem10;
    private javax.swing.JMenuItem jMenuItem11;
    private javax.swing.JMenuItem jMenuItem12;
    private javax.swing.JMenuItem jMenuItem13;
    private javax.swing.JMenuItem jMenuItem14;
    private javax.swing.JMenuItem jMenuItem15;
    private javax.swing.JMenuItem jMenuItem16;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPopupMenu jPopupMenu1;
    private com.jdcm.common.G_JRollingButton jRollingButton1;
    private com.jdcm.common.G_JRollingButton jRollingButton2;
    private com.jdcm.common.G_JRollingButton jRollingButton3;
    private com.jdcm.common.G_JRollingButton jRollingButton4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JToolBar.Separator jSeparator4;
    private javax.swing.JToolBar.Separator jSeparator5;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable3;
    private javax.swing.JTextPane jTextPane2;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton4;
    private javax.swing.JToggleButton jToggleButton6;
    private javax.swing.JToggleButton jToggleButton7;
    private javax.swing.JToggleButton jToggleButton8;
    private javax.swing.JToggleButton jToggleButton9;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
}

/*
 *
 *
 * TERMINAL STREAMS IN & OUT
 *
 *
 *
 */
class TermInputStream2 extends java.io.InputStream {

    private I_Terminal term = null;
    private final D_Debug TDeb;

    public TermInputStream2(I_Terminal t) {
        super();
        TDeb = new D_Debug("TermInStream");
        term = t;
    }

    @Override
    public int available() {
        if (term == null) {
            return -1;
        }
        return term.StreambuffSize();
    }

    @Override
    public int read() throws IOException {
        //read() return byte beetwen 0 and 255 (-1 is error)
        if (term == null) {
            throw new IOException("Terminal not available");
        }
        int i = term.readStreambuff();
        if (i == -9999) {
            throw new IOException("Read Termainal Stream Error");
        }
        if (i < 0) {
            i += 256;
        }
        return i;
    }
}

class TermOutputStream2 extends java.io.OutputStream {
    // bypassed in C_port.writeout()

    private I_Terminal term = null;
    private C_Packet pack;

    public TermOutputStream2(I_Terminal t) {
        super();
        term = t;
    }

    public void setPack(C_Packet d) {
        pack = d;
    }

    @Override
    public void write(int d) {
        //should not be used
        byte[] b = new byte[1];
        b[0] = (byte) d;
        write(b, 0, b.length);

    }

    @Override
    public void write(byte[] d, int ofset, int len) {
        if (d == null) {
            return;
        }
        pack.setObj(d);
        term.write(pack);
    }
}

/**
 * TERMINAL MODEL
 *
 *
 */
class Term_Model2 extends AbstractTableModel {
    // for serializable interface

    private final D_Utils TUtils = new D_Utils();
    private static final long serialVersionUID = 1L;
    private java.util.List<C_Packet> traces = new java.util.ArrayList<>();
    private String[] columnNames = {};
    private final I_Main Parent;

    public Term_Model2(I_Main p) {
        // removed because not serialisable.. and not used
        Parent = p;
    }

    /**
     * Add a new Packet in the terminal
     *
     * @param pack the packet to add
     */
    public void addrow(C_Packet pack) {
        addrow(pack, -1);
    }

    /**
     * Insert a packet in the terminal
     *
     * @param idx the index of the packet to insert
     */
    public void addrow(C_Packet pack, int idx) {
        if (idx > traces.size() || pack == null || idx < -1) {
            return;
        }

        if (pack.getStoredtime() == null) {
            // if reading capture => storedtime is alredy fixed (not null)
            pack.setStoredtime(new java.util.Date(System.currentTimeMillis()));
        }
        if (idx < 0) {
            //   traces ( should check => error during add indexoutof bounds...???)
            traces.add(pack);
        } else {
            traces.add(idx, pack);
            // if insertions, ajust row number(?used for?) in the packets
           /*
             * for (int i = 0; i < traces.size(); i++) { //!!!!!!!possible :
             * null in traces.get(i) // try{ traces.get(i).setrow(i);
             * }catch(NullPointerException ex){
             * System.out.println("==>"+traces.size()+":"+lastpos+":"+i
             * );//traces.get(i)+traces.get(traces.size()-1)); } }
             */
        }

        if (columnNames != null) {
            fireTableDataChanged();
        }
    }

    /**
     * remove a packet for terminal
     *
     * @param idx the idex of the packet to remove
     */
    public void removerow(int idx) {
        traces.remove(idx);
        fireTableDataChanged();
    }

    public java.util.List<C_Packet> getTraces() {
        return traces;
    }

    public C_Packet getPacket(int idx) {
        return traces.get(idx);
    }

    public void setTraces(java.util.List<C_Packet> tr) {
        traces = tr;
        fireTableDataChanged();
    }

    public void clear() {
        traces = new java.util.ArrayList<>();
        //fireTableChanged(null);
        this.fireTableDataChanged();
    }

    public void setColumns(String[] cols) {
        columnNames = cols;
        fireTableChanged(null);
    }

    @Override
    public String getColumnName(int column) {
        if (columnNames.length > 0) {
            return columnNames[column];
        }
        return null;
    }

    public void addColumn(String name) {
        columnNames = addtab(columnNames, new String[]{name});
        this.fireTableStructureChanged();
    }

    public void removeColumn(String name) {
        String[] res = new String[columnNames.length - 1];
        boolean removed = false;
        for (int i = 0; i < columnNames.length; i++) {
            if (columnNames[i].compareTo(name) == 0) {
                removed = true;
            } else {
                if (removed == false) {
                    res[i] = columnNames[i];
                }
                if (removed) {
                    res[i - 1] = columnNames[i];
                }
            }
        }
        columnNames = res;
        this.fireTableStructureChanged();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;

    }

    public void close() throws SQLException {
        System.out.println("Closing Terminal table");

    }

    @Override
    protected void finalize() throws Throwable {
        close();
        super.finalize();
    }

    public String getPacketAsString(C_Packet pack, String subOutMode, boolean displayAsit, I_Port port) {

        if (pack == null) {
            return "";
        } else if (pack.getBytes() != null) {
            if (subOutMode.startsWith("Text")) {
                //if <20 (&& > 7F??) => ask for an Hexa Font?? ! ä=[C3 a4],ê
                // see SexyHex Font = Care previous data are  '.....'
                // return new String(pack.getBytes()); 
                if (displayAsit) {
                    return TUtils.Formate_toString(pack.getBytes());
                } else {
                    byte[] by = new byte[pack.getBytes().length];
                    for (int i = 0; i < by.length; i++) {
                        if (pack.getBytes()[i] >= 10 && pack.getBytes()[i] > 0) { //!!BS used in shell
                            by[i] = pack.getBytes()[i];
                        } else {
                            by[i] = 46;//"."
                        }
                    }
                    return TUtils.Formate_toString(by);
                }
            } else {
                String res = "#" + getConsoleHeaderText(pack, port);
                if (isColumn("Data (Obj)") || isColumn("Data (ascii)") || isColumn("Data (Hex)")) {
                    res = res + " " + TUtils.Formate_Hexa(pack.getBytes(), true).replaceAll("\r\n", "\r\n ") + "\r\n";
                }
                return res;
            }
        } else {
            return pack.toString();
        }
    }

    public String getConsoleHeaderText(C_Packet pack, I_Port port) {
        int index = -1;
        if (port != null) {
            index = port.getIndex();
        }
        if (pack == null) {
            return "#### Pb null for pack: " + pack + "/Parent: " + Parent;
        }
        String res = "";
        if (isColumn("N")) {
            res += "/" + getTraces().indexOf(pack) + "/";
        }
        if (isColumn("Src.")) {
            if (pack.getsourceidx() == index) {
                res += "/T/";
            } else {
                res += "/" + pack.getsourceidx() + "/";
            }
        }

        if (isColumn("Storetime")) {
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("yy-MM-dd HH:mm:ss.SSS");
            res += "/" + format.format(pack.getStoredtime()) + "/";
        }
        if (isColumn("Size")) {
            if (pack.isbuffer()) {
                res += "/" + pack.getBytes().length + "/";
            } else {
                res += "/-1/";
            }
        }
        if (res.length() > 1) {
            res = res.substring(0, res.length() - 1);
            res = res.substring(1, res.length());
            res = res.replace("//", "/");
            res = res + "\r\n";
        } else {
            res = " ";
        }
        return res;
    }

    /**
     * true if column with this title is Displayed
     *
     * @param col_name then column title
     * @return true if displayed
     */
    private boolean isColumn(String col_name) {
        for (String title : columnNames) {
            if (title.compareTo(col_name) == 0) {
                return true;
            }
        }
        return false;
    }

    @Override
    public int getRowCount() {
        if (columnNames.length > 1) {
            return traces.size();
        }
        return 1;
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        // column=-1 isthe packet , 0, the row,....
        if (aRow < 0 || aColumn < -1) {
            return null;
        }
        C_Packet pack = traces.get(aRow);
        if (aColumn == -1) {
            return pack;
        } else {
            String colname = getColumnName(aColumn);
            if (colname.compareTo("N") == 0) {
                return aRow;//traces.indexOf(pack);//!!!!! why does it sort as String???
            } else if (colname.compareTo("Size") == 0) {
                return pack.length();
            } else if (colname.compareTo("Src.") == 0) {
                return pack.getsourceidx();
            } else if (colname.compareTo("Dst.") == 0) {
                return pack.getdestidx();
            } else if (colname.compareTo("Delai") == 0) {
                return pack.getSQLdelay();
            } else if (colname.compareTo("Storetime") == 0) {
                return pack.getStoredtime();
            } else if (colname.compareTo("Dir.") == 0) {
                if (pack.getStacksens()) {
                    return "I";
                } else {
                    return "O";
                }
            } else if (colname.compareTo("Create") == 0) {
                return pack.getCreatetime().getTime();
            } else if (colname.compareTo("Stacks") == 0) {
                javax.swing.tree.DefaultMutableTreeNode prots = pack.getProtoTree();
                if (prots == null) {
                    if (Parent != null && Parent instanceof C_Main) {

                        ((C_Main) Parent).findPacketStacks(traces.get(aRow));
                        return pack.getProtoTree();
                    } else {
                        return "no Packet Protocol";
                    }
                } else if (prots.getChildCount() > 0) {
                    return prots;
                } else {
                    return "";
                }
            } else if (colname.compareTo("Edit") == 0) {
                return pack;
            } else if (colname.startsWith("Data")) {
                return pack.getObj();
            }
        }
        return "bug!";
    }

    @Override
    public void setValueAt(Object value, int row, int column) {
        if (getColumnName(column).compareTo("Edit") == 0) {
            traces.set(row, (C_Packet) value);
        } else if (getColumnName(column).compareTo("Data (Obj)") == 0) {
            traces.get(row).setObj(value);
        }
        this.fireTableDataChanged();
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        if (getColumnName(column).compareTo("Edit") == 0
                || getColumnName(column).compareTo("Stacks") == 0) {
            return true;
        } else if (getColumnName(column).compareTo("Data (Obj)") == 0) {
            return true;
        }
        return false;
    }

    @Override
    public Class<?> getColumnClass(int column) {
        /* if (column == 0) {
         return C_Packet.class;
         }*/
        String colname = this.getColumnName(column);
        if (colname.compareTo("N") == 0
                || colname.compareTo("Size") == 0
                || colname.compareTo("Src.") == 0
                || colname.compareTo("Dst.") == 0
                || colname.compareTo("Delai") == 0) {
            return Integer.class;
        } else if (colname.compareTo("Storetime") == 0
                || colname.compareTo("Create") == 0) {
            return Date.class;
        } else if (colname.startsWith("Data")) {
            return Object.class;
        }
        return String.class;

    }
    // reported from DEBUG to avoid serialization...

    public String[] addtab(String[] a, String[] b) {
        if (a == null) {
            return b;
        }
        if (a.length == 0) {
            return b;
        }
        if (b == null) {
            return a;
        }
        if (b.length == 0) {
            return a;
        }
        String[] res = new String[a.length + b.length];
        if (a[0] == null) {
            return null;
        }
        System.arraycopy(a, 0, res, 0, a.length);
        for (int i = a.length; i < res.length; i++) {
            res[i] = b[i - a.length];
        }
        return res;
    }
}

/*
 *
 * TERMINALS RENDERS
 *Text Aera Mandatory for Multi Line...??
 *
 */
class byteRenderer2 extends javax.swing.JTextArea implements TableCellRenderer {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    private final F_Terminal term;
    private int DEFAULTHROWEIGHT = -1;

    public byteRenderer2(F_Terminal t) {
        term = t;
    }

    @Override
    public Component getTableCellRendererComponent(
            javax.swing.JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
        //INIT
        if (DEFAULTHROWEIGHT == -1) {
            // 1.5 to allow a componement bigger than text butlest than 2* text (getallrow)
            //  DEFAULTHROWEIGHT = Math.round(new Float(1.2 * getFontMetrics(getFont()).getHeight())); //table.getRowHeight(row);
            DEFAULTHROWEIGHT = this.getPreferredSize().height;
        }
        setFont(new Font("Courier New", Font.PLAIN, 12));
        C_Packet p = (C_Packet) table.getValueAt(row, -1);
        if (value == null) {
            //should not append
            setText("!null!");
            return this;
        } else if (value instanceof String) {
            setText(value.toString());
        }
        if (term.getTerm_outMode().startsWith("OUTPUT_TRAME")) {
            // console removed because managed by ACE_Render/editpor
            if (table.getColumnName(col).compareTo("Data (Hex)") == 0) {
                com.jdcm.editors.ACE_ObjRenderer<Object> a = new com.jdcm.editors.ACE_ObjRenderer<>();
                return a.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, col);
            }
            if (table.getColumnName(col).compareTo("Data (ascii)") == 0) {
                setText(value.toString());
            }
        } else if (term.getTerm_outMode().startsWith("OUTPUT_PACKET")) {
            byte[] bytar = null;
            try {
                bytar = term.Obj2bytes(value);
            } catch (NullPointerException ex) {
                System.out.println("getTableCellRendererComponent()=>" + value + " : " + ex.getMessage());
            }
            // console removed because managed by ACE_Render/editpor
            if (table.getColumnName(col).compareTo("Data (ascii)") == 0) {
                if (bytar != null) {
                    setText(TUtils.Formate_ASCII(bytar, p.getallrow()));
                } else {
                    setText("null");
                }

            }
            if (table.getColumnName(col).compareTo("Data (Hex)") == 0) {
                if (bytar == null && value instanceof java.io.Serializable) {
                    bytar = p.getSerial();
                }
                if (bytar != null) {
                    if (p.isbuffer()) {
                        setText(TUtils.Formate_Hexa(bytar, p.getallrow()));
                    } else {
                        setText("[* " + TUtils.Formate_Hexa(bytar, p.getallrow()) + " *]");
                    }
                } else {
                    if (p.getObj() instanceof java.io.Serializable) {
                        setText("Unserializable Object");
                    } else {
                        setText("Unserializable Object");
                    }
                }

            }
        }
// ajust row size to the componment if all row else rows height=DEFAULTHROWEIGHT
        int si = getPreferredSize().height;
        if (p.getallrow() && table.getRowHeight(row) < si) {
            table.setRowHeight(row, si);
        }
        if (p.getallrow() == false && table.getRowHeight(row) > DEFAULTHROWEIGHT) {
            table.setRowHeight(row, DEFAULTHROWEIGHT);
        }
        setForeground(term.getPortColor(p.getsourceidx()));
        if (p.ismarked()) {
            setBackground(java.awt.Color.BLACK);
        } else {
            if (isSelected) {
                setBackground(table.getSelectionBackground());
            } else {
                setBackground(table.getBackground());
            }
        }
        return this;
    }

    public void changestate(javax.swing.JTable table, int row) {
        C_Packet p = (C_Packet) table.getValueAt(row, -1);
        p.setallrow(p.getallrow() == false);
        table.repaint();
    }
}

class IntRenderer2 extends DefaultTableCellRenderer {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final F_Terminal term;
    private final int index;

    public IntRenderer2(F_Terminal t, int i) {
        term = t;
        index = i;
    }

    @Override
    public Component getTableCellRendererComponent(
            javax.swing.JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
        this.setVerticalAlignment(DefaultTableCellRenderer.NORTH);
        setFont(new Font("Courier New", Font.PLAIN, 12));
        C_Packet p = (C_Packet) table.getValueAt(row, -1);
        setForeground(term.getPortColor(p.getsourceidx()));
        String columnName = table.getColumnName(col);
        if (columnName.compareTo("Src.") == 0) {
            int srce = (Integer) value;
            if (srce == index) {
                setText("T");
            } else if (srce == -2) {
                setText("Ext");
            } else if (srce < 0) {
                setText("S");
            } else {
                setText("" + srce);
            }
        } else if (columnName.compareTo("Dst.") == 0) {
            setForeground(term.getPortColor(p.getdestidx()));
            int srce = (Integer) value;
            setText("" + srce);
        } else if (columnName.compareTo("Stacks") == 0 && value instanceof javax.swing.tree.DefaultMutableTreeNode) {
            javax.swing.tree.DefaultMutableTreeNode node = (javax.swing.tree.DefaultMutableTreeNode) value;

            javax.swing.tree.DefaultMutableTreeNode last = node.getLastLeaf();
            if (last.getUserObject() instanceof com.jdcm.modifiers.stacks.Stack_base) {
                com.jdcm.modifiers.stacks.Stack_base st = (com.jdcm.modifiers.stacks.Stack_base) last.getUserObject();
                java.awt.Color color = st.getStackColor();
                if (color != null) {
                    //   setBackground(color);
                    setBackground(new java.awt.Color(color.getRed(), color.getGreen(), color.getBlue(), 100));
                }
            }
            setText("" + com.jdcm.common.D_Utils.getTreeAsString(node));
        } else {
            setText("" + value);
        }
        if (p.ismarked()) {
            setBackground(java.awt.Color.BLACK);
        } else if (isSelected) {
            setBackground(table.getSelectionBackground());
        } else if (columnName.compareTo("Stacks") != 0) {
            setBackground(table.getBackground());
        }
        return this;
    }
};

class DateRenderer2 extends DefaultTableCellRenderer {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final F_Terminal term;

    public DateRenderer2(F_Terminal t) {
        term = t;
    }

    @Override
    public Component getTableCellRendererComponent(
            javax.swing.JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
        this.setVerticalAlignment(DefaultTableCellRenderer.NORTH);
        setFont(new Font("Courier New", Font.PLAIN, 12));
        String tf;
        if (term.getTimeFormat().compareTo("DAY") == 0) {
            tf = "yy-MM-dd HH:mm:ss.SSS";
        } else if (term.getTimeFormat().compareTo("HOUR") == 0) {
            tf = "HH:mm:ss.SSS";
        } else {
            tf = "HH:mm:ss.SSS";
        }
        java.text.SimpleDateFormat format = new java.text.SimpleDateFormat(tf);
        if (value instanceof Date) {
            Date dt = (Date) value;
            if (term.getTimeFormat().compareTo("DELTA") == 0 || term.getTimeFormat().compareTo("FIRST") == 0) {
                int shift = Calendar.getInstance().getTimeZone().getRawOffset();
                if (row == 0 || table.getValueAt(row - 1, col) instanceof Date == false) {
                    dt = new Date(0 - shift);
                } else {
                    if (term.getTimeFormat().compareTo("DELTA") == 0) {
                        dt = new Date(dt.getTime() - ((Date) table.getValueAt(row - 1, col)).getTime() - shift);
                    } else if (term.getTimeFormat().compareTo("FIRST") == 0) {
                        dt = new Date(dt.getTime() - ((Date) table.getValueAt(0, col)).getTime() - shift);
                    }
                }
            }
            setText(format.format(dt));
        } else {
            setText("!NULL!");
        }
        C_Packet p = (C_Packet) table.getValueAt(row, -1);
        setForeground(term.getPortColor(p.getsourceidx()));
        if (p.ismarked()) {
            setBackground(java.awt.Color.BLACK);
        } else {
            if (isSelected) {
                setBackground(table.getSelectionBackground());
            } else {
                setBackground(table.getBackground());
            }
        }
        return this;
    }
}

class PacketRenderer2 extends com.jdcm.editors.ACE_ObjRenderer<Object> {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final F_Terminal term;

    public PacketRenderer2(F_Terminal f) {
        term = f;
    }

    @Override
    public Component getTableCellRendererComponent(
            javax.swing.JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
        C_Packet p = (C_Packet) table.getValueAt(row, -1);
        Component comp = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, col);
        comp.setForeground(term.getPortColor(p.getsourceidx()));
        return comp;
    }
}

class PacketEditor2 extends com.jdcm.editors.ACE_ObjEditor<Object> {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private F_Terminal term_window = null;
    // private C_Packet pack = null;

    public PacketEditor2(F_Terminal term) {
        super(true, true);
        term_window = term;
    }

    @Override
    public Component getTableCellEditorComponent(
            javax.swing.JTable table, Object value, boolean isSelected, int row, int col) {
        //pack = (C_Packet) table.getValueAt(row, -1);
        setEditing(term_window.isEditing());
        Component comp = super.getTableCellEditorComponent(table, value, isSelected, row, col);
        return comp;
    }

    @Override
    public Object getCellEditorValue() {
        // pack.setObj(super.getCellEditorValue());
        return super.getCellEditorValue();
    }
}
