package com.jdcm.eltrx;

import com.jdcm.common.XMLres;
import com.jdcm.common.D_Utils;
import java.awt.Color;
import javax.swing.JPanel;
import java.util.Date;
import com.jdcm.diagram.A_Events ;
import java.awt.event.ComponentListener;
import java.lang.reflect.InvocationTargetException;

/**
 *  IF_Machine.java Created on 3 mars 2008, 21:11
 * 
 * UI for displaying C_Marchine
 * 
 * @author  Marc GIBOIN
 */
public class IF_Machine extends javax.swing.JInternalFrame {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private D_Utils TUtils = new D_Utils();
    private C_Machine Parent = null;
     private java.awt.Frame diagramFrame = null;
     private java.awt.Rectangle portBounds=null;
    //status of the port(see label1)

    /** Creates new form IF_Machine (makes no sens)*/
    public IF_Machine() {
        initComponents();
        init();
    }

    /** Creates new form IF_Machine for port type Machine
     * @param p Port supporting this UI
     */
    public IF_Machine(C_Machine p) {
        initComponents();
        Parent = p;
        init();
        setColor(p.getColor());
        // setcxstatus(p.getcxstatus());
        // p.setModeidx(jTabbedPane1.getSelectedIndex());
        for (int i = 0; i < p.getCMDOptions().getRowCount(); i++) {
            Class<?> cl = null;
            if (p.getCMDOptions().getValueAt(i, 1) != null) {
                cl = p.getCMDOptions().getValueAt(i, 1).getClass();
            }

            java.lang.reflect.Method m = TUtils.getMethod(this.getClass(), "set" + p.getCMDOptions().getLabelAt(i), cl);
            if (m != null) {
                try {
                    m.invoke(this, p.getCMDOptions().getValueAt(i, 1));
                } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
                }
            }
        }
        // should be setSCN_cnt();
        jLabel16.setText("" + p.getSCN_cyle() + "/" + p.getSCN_pos());
        setVisible(true);
        //this.setcxstatus("new");
    }

    private void init() {
         jComboBox2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Status", "Admin", "Type" }));
        jCB_ObjectEditor3.setValue(new byte[0]);
        if(Parent !=null){
        jCB_ObjectEditor4.setValue(Parent.getEVT_matrice());
        }
           portBounds=getBounds();
    }
     public void setEVT_matrice(A_Events  evt){
         jCB_ObjectEditor4.setValue(evt);
     }
    public void repaintLists() {
        jComboBox1.repaint();
        jComboBox8.repaint();
        jComboBox7.repaint();
        jComboBox3.repaint();
    }
    public final void setPortBounds(boolean bool){
      if (bool){
          portBounds=getBounds();
      }else{
          setBounds(portBounds);
      }
    }
    public void setAcc_startdate(Date dt) {
        String res;
        if (dt.getTime() == 0) {
            res = "On: --:--:--.----";
        } else {
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("HH:mm:ss S");
            res = format.format(dt);
        }
        jLabel84.setText(res);
    }

    public void setAcc_stopdate(Date dt) {
        String res;
        if (dt.getTime() == 0) {
            res = "Off: --:--:--.----";
        } else {
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("HH:mm:ss S");
            res = format.format(dt);
        }
        jLabel85.setText(res);
    }

    public void setsource(javax.swing.DefaultComboBoxModel<I_Command> c) {
        jComboBox1.setModel(c);
    }

    public void setdestination(javax.swing.DefaultComboBoxModel<I_Command>  c) {
        jComboBox8.setModel(c);
    }

    public void setmethod(javax.swing.DefaultComboBoxModel<String> c) {
        jComboBox3.setModel(c);
        jComboBox7.setModel(c);
    }

    public void setSCN_inStore(com.jdcm.common.XMLres r) {
        jCB_ObjectEditor1.setValue(r);
    }
    public void setSCN_Range(java.sql.ResultSet rs){
        jCB_ObjectEditor5.setValue(rs);
    }
    public void setCLI_enable(boolean bool) {
        if (jCheckBox2.isSelected() != bool) {
            jCheckBox2.setSelected(bool);
        }
    }

    public void setSCN_MaxCycle(int nb) {
        if ((Integer) jSpinner2.getValue() != nb) {
            jSpinner2.setValue(nb);
        }
    }

    public void setSCN_toxml(boolean bool) {
        if (jCheckBox5.isSelected() != bool) {
            jCheckBox5.setSelected(bool);
        }
    }

    public void setSCN_view(String txt) {
        jTextField5.setText(txt);
    }

    public void setSCN_store(XMLres res) {
        jCB_ObjectEditor1.repaint();
    }

    public void setSCN_datafld(String txt) {
        jTextField4.setText(txt);
    }

    public void setSCN_cnt(String cntxt) {
        jLabel16.setText(cntxt);
    }

    public void setMSG_type(javax.swing.DefaultComboBoxModel<String> box) {
        jComboBox2.setModel(box);
    }

    public void setMSG_waited(byte[] octs) {
        jCB_ObjectEditor2.setValue(octs);
    }

    public void setMSG_pool(boolean bool) {
        jCheckBox3.setSelected(bool);
        jSpinner1.setEnabled(bool);
        jCB_ObjectEditor2.setEnabled(bool == false);
        jLabel4.setEnabled(bool == false);
        jLabel8.setEnabled(bool == false);
        jComboBox2.setEnabled(bool == false);
    }

    public void setMSG_poolval(int nbms) {
        jSpinner1.setValue(nbms);
    }

    public void setMSG_poolval(String nbms) {
        setMSG_poolval(Integer.parseInt(nbms));
    }

    public void setMSG_date(boolean bool) {
        if (jCheckBox1.isSelected() != bool) {
            jCheckBox1.setSelected(bool);
        }
    }

    public void setMSG_banner(byte[] octs) {
        if (octs != jCB_ObjectEditor3.getValue()) {
            jCB_ObjectEditor3.setValue(octs);
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel8 = new javax.swing.JPanel();
        jButton21 = new javax.swing.JButton();
        jTextField3 = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jLabel7 = new javax.swing.JLabel();
        jComboBox8 = new javax.swing.JComboBox<>();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jCB_ObjectEditor2 = new com.jdcm.editors.JCB_ObjectEditor();
        jCheckBox3 = new javax.swing.JCheckBox();
        jSpinner1 = new javax.swing.JSpinner();
        jLabel9 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jCB_ObjectEditor3 = new com.jdcm.editors.JCB_ObjectEditor();
        jLabel6 = new javax.swing.JLabel();
        jComboBox3 = new javax.swing.JComboBox<>();
        jLabel8 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox<>();
        jCheckBox1 = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jPanel11 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jComboBox7 = new javax.swing.JComboBox<>();
        jSpinner2 = new javax.swing.JSpinner();
        jPanel12 = new javax.swing.JPanel();
        jLabel14 = new javax.swing.JLabel();
        jCB_ObjectEditor5 = new com.jdcm.editors.JCB_ObjectEditor();
        jLabel16 = new javax.swing.JLabel();
        jPanel13 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel4 = new javax.swing.JPanel();
        jCheckBox2 = new javax.swing.JCheckBox();
        jPanel6 = new javax.swing.JPanel();
        jPanel9 = new javax.swing.JPanel();
        jToggleButton1 = new javax.swing.JToggleButton();
        jCB_ObjectEditor4 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel5 = new javax.swing.JPanel();
        jLabel84 = new javax.swing.JLabel();
        jLabel85 = new javax.swing.JLabel();

        setClosable(true);
        setIconifiable(true);
        setResizable(true);
        setTitle("Machine");
        setAutoscrolls(true);
        setMinimumSize(new java.awt.Dimension(273, 310));
        setPreferredSize(new java.awt.Dimension(273, 310));
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameClosed(evt);
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jPanel8.setLayout(new java.awt.GridLayout(1, 0));

        jButton21.setBackground(new java.awt.Color(0, 0, 0));
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });
        jPanel8.add(jButton21);

        jTextField3.setEditable(false);
        jTextField3.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jTextField3.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        jTextField3.setText("0");
        jTextField3.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        jPanel8.add(jTextField3);

        jLabel1.setText("State");
        jPanel8.add(jLabel1);

        jButton1.setText("Start");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel8.add(jButton1);

        getContentPane().add(jPanel8);

        jPanel7.setLayout(new javax.swing.BoxLayout(jPanel7, javax.swing.BoxLayout.LINE_AXIS));

        jLabel2.setText("src :");
        jPanel7.add(jLabel2);

        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jPanel7.add(jComboBox1);

        jLabel7.setText("=>");
        jPanel7.add(jLabel7);

        jComboBox8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox8ActionPerformed(evt);
            }
        });
        jPanel7.add(jComboBox8);

        getContentPane().add(jPanel7);

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);

        jPanel2.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel2ComponentShown(evt);
            }
        });
        jPanel2.setLayout(new java.awt.GridLayout(7, 2));

        jLabel4.setText("Waited :");
        jPanel2.add(jLabel4);

        jCB_ObjectEditor2.setEditable(true);
        jCB_ObjectEditor2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor2ActionPerformed(evt);
            }
        });
        jPanel2.add(jCB_ObjectEditor2);

        jCheckBox3.setText("pool");
        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });
        jPanel2.add(jCheckBox3);

        jSpinner1.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(1000), null, null, Integer.valueOf(1)));
        jSpinner1.setToolTipText("msec");
        jSpinner1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinner1StateChanged(evt);
            }
        });
        jPanel2.add(jSpinner1);

        jLabel9.setText("=>");
        jPanel2.add(jLabel9);

        jLabel3.setText("=>");
        jPanel2.add(jLabel3);

        jLabel5.setText("Banner :");
        jPanel2.add(jLabel5);

        jCB_ObjectEditor3.setEditable(true);
        jCB_ObjectEditor3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor3ActionPerformed(evt);
            }
        });
        jPanel2.add(jCB_ObjectEditor3);

        jLabel6.setText("Method :");
        jPanel2.add(jLabel6);

        jComboBox3.setEditable(true);
        jPanel2.add(jComboBox3);

        jLabel8.setText("State :");
        jPanel2.add(jLabel8);
        jPanel2.add(jComboBox2);

        jCheckBox1.setText("Date");
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        jPanel2.add(jCheckBox1);

        jTabbedPane1.addTab("MSG", jPanel2);

        jPanel1.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel1ComponentShown(evt);
            }
        });
        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));

        jPanel10.setLayout(new javax.swing.BoxLayout(jPanel10, javax.swing.BoxLayout.LINE_AXIS));

        jLabel10.setText("view :");
        jPanel10.add(jLabel10);

        jTextField5.setText("cmde_view");
        jTextField5.setToolTipText("view with scan source element");
        jTextField5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField5ActionPerformed(evt);
            }
        });
        jPanel10.add(jTextField5);

        jLabel13.setText("data attr :");
        jPanel10.add(jLabel13);

        jTextField4.setText("commande");
        jTextField4.setToolTipText("string to send to the dest. Port Methode");
        jTextField4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField4ActionPerformed(evt);
            }
        });
        jPanel10.add(jTextField4);

        jPanel1.add(jPanel10);

        jPanel11.setLayout(new javax.swing.BoxLayout(jPanel11, javax.swing.BoxLayout.LINE_AXIS));

        jLabel12.setText("Method :");
        jPanel11.add(jLabel12);

        jComboBox7.setEditable(true);
        jComboBox7.setToolTipText("methon used on Scan");
        jPanel11.add(jComboBox7);

        jSpinner2.setModel(new javax.swing.SpinnerNumberModel());
        jSpinner2.setToolTipText("Number of scan cycles");
        jSpinner2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinner2StateChanged(evt);
            }
        });
        jPanel11.add(jSpinner2);

        jPanel1.add(jPanel11);

        jPanel12.setLayout(new javax.swing.BoxLayout(jPanel12, javax.swing.BoxLayout.LINE_AXIS));

        jLabel14.setText("range :");
        jPanel12.add(jLabel14);

        jCB_ObjectEditor5.setToolTipText("range DB result Model");
        jCB_ObjectEditor5.setEditable(true);
        jCB_ObjectEditor5.setEditing(false);
        jPanel12.add(jCB_ObjectEditor5);

        jLabel16.setText("0");
        jPanel12.add(jLabel16);

        jPanel1.add(jPanel12);

        jPanel13.setLayout(new java.awt.GridLayout(1, 0));

        jLabel17.setText("=> result as (use view key attr) :");
        jPanel13.add(jLabel17);

        jCheckBox5.setText("Export as XML");
        jCheckBox5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox5ActionPerformed(evt);
            }
        });
        jPanel13.add(jCheckBox5);

        jPanel1.add(jPanel13);

        jCB_ObjectEditor1.setToolTipText("XML result to use ");
        jCB_ObjectEditor1.setEditable(true);
        jPanel1.add(jCB_ObjectEditor1);

        jTabbedPane1.addTab("SCAN", jPanel1);

        jPanel4.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel4ComponentShown(evt);
            }
        });
        jPanel4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jCheckBox2.setText("Enable");
        jCheckBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox2ActionPerformed(evt);
            }
        });
        jPanel4.add(jCheckBox2);

        jTabbedPane1.addTab("CLI", jPanel4);

        jPanel6.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel6ComponentShown(evt);
            }
        });
        jPanel6.setLayout(new java.awt.GridLayout(4, 0));

        jPanel9.setLayout(new javax.swing.BoxLayout(jPanel9, javax.swing.BoxLayout.LINE_AXIS));

        jToggleButton1.setText("Diagram");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel9.add(jToggleButton1);

        jCB_ObjectEditor4.setEditable(true);
        jPanel9.add(jCB_ObjectEditor4);

        jPanel6.add(jPanel9);

        jTabbedPane1.addTab("EVENT", jPanel6);

        getContentPane().add(jTabbedPane1);
        jTabbedPane1.getAccessibleContext().setAccessibleName("");

        jPanel5.setLayout(new java.awt.BorderLayout());

        jLabel84.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel84.setText("on : --:--:-- ----");
        jPanel5.add(jLabel84, java.awt.BorderLayout.WEST);

        jLabel85.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel85.setText("off : --:--:-- ----");
        jPanel5.add(jLabel85, java.awt.BorderLayout.EAST);

        getContentPane().add(jPanel5);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton21ActionPerformed

        Color couleur = javax.swing.JColorChooser.showDialog(this, "Change port color", Parent.getColor());
        if (couleur != null) {
            Parent.setColor(couleur);
        }
    }//GEN-LAST:event_jButton21ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (jButton1.getText().compareTo("Stop") == 0) {
            Parent.CXstop();
        } else {
            Parent.CXstart();
        }
    }//GEN-LAST:event_jButton1ActionPerformed

private void jComboBox8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox8ActionPerformed
    Parent.set_destination(jComboBox8.getSelectedItem().toString());
}//GEN-LAST:event_jComboBox8ActionPerformed

private void jPanel6ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel6ComponentShown
    Parent.setModeidx(jTabbedPane1.getSelectedIndex());
}//GEN-LAST:event_jPanel6ComponentShown

private void jPanel4ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel4ComponentShown
    Parent.setModeidx(jTabbedPane1.getSelectedIndex());
}//GEN-LAST:event_jPanel4ComponentShown

private void jCheckBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox2ActionPerformed
    Parent.setCLI_enable(jCheckBox2.isSelected());
}//GEN-LAST:event_jCheckBox2ActionPerformed

private void jPanel1ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel1ComponentShown
    Parent.setModeidx(jTabbedPane1.getSelectedIndex());
}//GEN-LAST:event_jPanel1ComponentShown

private void jCheckBox5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox5ActionPerformed
    Parent.setSCN_toxml(jCheckBox5.isSelected());
}//GEN-LAST:event_jCheckBox5ActionPerformed

private void jTextField5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField5ActionPerformed
    Parent.setSCN_view(jTextField5.getText());
}//GEN-LAST:event_jTextField5ActionPerformed

private void jTextField4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField4ActionPerformed
    Parent.setSCN_datafld(jTextField4.getText());
}//GEN-LAST:event_jTextField4ActionPerformed

private void jPanel2ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel2ComponentShown
//    Parent.setModeidx(jTabbedPane1.getSelectedIndex());
}//GEN-LAST:event_jPanel2ComponentShown

private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
    Parent.setMSG_date(jCheckBox1.isSelected());
}//GEN-LAST:event_jCheckBox1ActionPerformed

private void jCB_ObjectEditor3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor3ActionPerformed
    Parent.setMSG_banner((byte[]) jCB_ObjectEditor3.getValue());
}//GEN-LAST:event_jCB_ObjectEditor3ActionPerformed

private void jSpinner1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSpinner1StateChanged
    Parent.setMSG_poolval((Integer) jSpinner1.getValue());
}//GEN-LAST:event_jSpinner1StateChanged

private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
    Parent.setMSG_pool(jCheckBox3.isSelected());
}//GEN-LAST:event_jCheckBox3ActionPerformed

private void jCB_ObjectEditor2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor2ActionPerformed
    Parent.setMSG_waited((byte[]) jCB_ObjectEditor2.getValue());
}//GEN-LAST:event_jCB_ObjectEditor2ActionPerformed

private void jSpinner2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSpinner2StateChanged
    Parent.setSCN_MaxCycle((Integer) jSpinner2.getValue());
}//GEN-LAST:event_jSpinner2StateChanged

private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
  if (jToggleButton1.isSelected()){
      if (diagramFrame==null){
          diagramFrame=new java.awt.Frame();
          com.jdcm.diagram.P_Diagram diag=new  com.jdcm.diagram.P_Diagram(Parent.getEVT_matrice());
          diagramFrame.add(diag);
          diagramFrame.setIconImage(new D_Utils().getImage("Events.gif"));
          diagramFrame.setBounds(this.getX(),this.getY(),diag.getPreferredSize().width,diag.getPreferredSize().height);
          diagramFrame.setTitle(this.title+":Diag");
          diagramFrame.setVisible(true);
      }else{
          diagramFrame.setVisible(true);
      }
      
  }else{
      //hide diagram
      diagramFrame.setVisible(false);
  }
}//GEN-LAST:event_jToggleButton1ActionPerformed

private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
  if (jComboBox1.getSelectedItem()!=null){
    Parent.set_source(jComboBox1.getSelectedItem().toString());
  }
}//GEN-LAST:event_jComboBox1ActionPerformed

private void formInternalFrameClosed(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameClosed
   Parent.CXend();
}//GEN-LAST:event_formInternalFrameClosed

    /**
     *  Manage the color used for the Port
     *  final cause used in constructor
     * @param c the new color of the Machine
     */
    public final void setColor(Color c) {
        jButton21.setBackground(c);
    }

    /**
     *  Manage the name used for the Port
     *  final cause used in constructor
     * @param name the new name of the Machine
     */
    public void setPortName(String name) {
        if (name == null) {
            return;
        }
        this.setTitle(name);
    }

    public void setIndex(int port) {
        jTextField3.setText("" + port);
    }

    public void setcxstatus(String status) {
        this.jLabel1.setText(status);
        this.setFrameIcon(Parent.getCMDIcon());
        this.jLabel1.setText(status);
        if (status.startsWith("stopped") || status.startsWith("error") || status.startsWith("creating") || status.startsWith("new")) {
            jButton1.setText("Start");
        } else if (status.startsWith("closed")) {
            setVisible(false);
        } else {
            jButton1.setText("Stop");
        }
    }

    public void setModeidx(String txt) {
        int idx = -1;
        for (int i = 0; idx < 0 && i < jTabbedPane1.getTabCount(); i++) {
            if (jTabbedPane1.getTitleAt(i).compareTo(txt) == 0) {
                idx = i;
            }
        }
        setModeidx(idx);
    }

    /**
     * Change the mode of this machine
     * @param i the Number of the mode (first is 0)
     */
    public void setModeidx(int i) {
        JPanel pan = (JPanel) jTabbedPane1.getComponentAt(i);
        java.awt.event.ComponentListener[] a = pan.getComponentListeners();
        for (ComponentListener a1 : a) {
            pan.removeComponentListener(a1);
        }
        jTabbedPane1.setSelectedIndex(i);
        for (ComponentListener a1 : a) {
            pan.addComponentListener(a1);
        }
        jComboBox8.setEnabled(Parent.getModeName().compareTo("CLI") != 0);
    }

    public void CXstart() {
        jButton1.setText("Stop");
        setAcc_startdate(new java.util.Date(System.currentTimeMillis()));
        setAcc_stopdate(new java.util.Date(0));
    }

    public void CXend() {
        setVisible(false);
    }

    public void CXstop() {
        jButton1.setText("Start");
        setAcc_stopdate(new java.util.Date(System.currentTimeMillis()));
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton21;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor2;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor3;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor4;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor5;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JComboBox<I_Command> jComboBox1;
    private javax.swing.JComboBox<String> jComboBox2;
    private javax.swing.JComboBox<String> jComboBox3;
    private javax.swing.JComboBox<String> jComboBox7;
    private javax.swing.JComboBox<I_Command> jComboBox8;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel84;
    private javax.swing.JLabel jLabel85;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JSpinner jSpinner2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JToggleButton jToggleButton1;
    // End of variables declaration//GEN-END:variables
}
