package com.jdcm.eltrx;

import com.jdcm.common.D_Utils;
import com.jdcm.common.A_Commande;
import com.jdcm.common.Options_Model;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ComponentListener;
import java.lang.reflect.InvocationTargetException;
import java.util.*;
import javax.swing.*;
//import com.sun.comm.Win32Driver;

/**
 * IF_Port.java Created on 6 aout 2006, 16:05
 *
 * UI to display C_Port <br>
 *
 * @author Marc GIBOIN
 */
public class IF_Port extends javax.swing.JInternalFrame {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    private java.awt.Rectangle portBounds=null;
    private Options_Model options = null;
    private C_Port Parent = null;

    /**
     * Creates new (makes no sens)
     */
    public IF_Port() {
        initComponents();
        init();
    }

    /**
     * Creates new from Port (used)
     * @param p the Port supporting this UI
     */
    public IF_Port(C_Port p) {
        Parent = p;
        initComponents();
        init();
        setVisible(true);
    }

    private void init() {
        jComboBox10.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"Local file system", "http", "ftp"}));
        jComboBox4.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"EJCCM (CORBA)", "OpenJMS(ActivMQ)"}));
        jComboBox11.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"0ntp.cap", "0CB1.cap", "0test_IP.cap"}));
        jComboBox17.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"ANY", "ECP", "EPP", "NIBBLE", "PS2", "SPP"}));
        options = Parent.getCMDOptions();
        setcxstatus(Parent.getcxstatus());
        setModeName(Parent.getModeName());
        setTitle(Parent.getPortName());
        for (int i = 0; i < options.getRowCount(); i++) {
            Class<?> cl = null;
            if (options.getValueAt(i, 1) != null) {
                cl = options.getValueAt(i, 1).getClass();
            }
            java.lang.reflect.Method m = TUtils.getMethod(this.getClass(), "set" + options.getLabelAt(i), cl);
            if (m != null) {
                try {
                    m.invoke(this, options.getValueAt(i, 1));
                } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
                }
            }

        }

        jComboBox11.setRenderer(new javax.swing.ListCellRenderer<Object>() {
            @Override
            public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                javax.swing.JLabel res = new javax.swing.JLabel();
                if (value == null) {
                    res.setText("null");
                } else if (value instanceof java.io.File) {
                    res.setText(((java.io.File) value).getName());
                } else {
                    res.setText(value.toString());
                }
                return res;
            }
        });
        jComboBox20.setModel(options.getValuefor("Term_Type", new DefaultComboBoxModel<String>()));
        jComboBox1.setModel(options.getValuefor("RS_interfaces", new DefaultComboBoxModel<>()));
        jComboBox1.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jComboBox5.setModel(new javax.swing.DefaultComboBoxModel<>(new Integer[]{8, 7, 6, 5}));
        jComboBox6.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"None", "Even", "Odd", "Mark", "Space"}));
        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"1", "1.5", "2"}));
        jComboBox7.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"None", "RTS/CTS In", "even", "odd", "Xon/Xoff In"}));
        jComboBox8.setModel(options.getValuefor("DB_interfaces", new DefaultComboBoxModel<String>()));
        jComboBox18.setModel(options.getValuefor("LPT_interfaces", new DefaultComboBoxModel<>()));
        jComboBox16.setModel(options.getValuefor("ETH_Pack", new DefaultComboBoxModel<String>()));
        jButton6.setIcon(TUtils.getIcon("maj.gif"));
        jButton7.setIcon(TUtils.getIcon("Socket.gif"));
        jToggleButton6.setIcon(TUtils.getIcon("dir_in.gif"));
        jButton3.setIcon(TUtils.getIcon("File.gif"));
        jToggleButton6.setSelectedIcon(TUtils.getIcon("lockin.gif"));
        jToggleButton7.setSelectedIcon(TUtils.getIcon("lockout.gif"));
        jToggleButton7.setIcon(TUtils.getIcon("dir_out.gif"));
        jToggleButton8.setIcon(TUtils.getIcon("loopin_off.gif"));
        jToggleButton8.setSelectedIcon(TUtils.getIcon("loopin_on.gif"));
        jToggleButton15.setIcon(TUtils.getIcon("loopout_off.gif"));
        jToggleButton15.setSelectedIcon(TUtils.getIcon("loopout_on.gif"));
        jToggleButton9.setIcon(TUtils.getIcon("echo_off.gif"));
        jToggleButton9.setSelectedIcon(TUtils.getIcon("echo_on.gif"));
        jToggleButton10.setIcon(TUtils.getIcon("Viewoff.gif"));
        jToggleButton10.setSelectedIcon(TUtils.getIcon("View.gif"));
        jButton2.setIcon(TUtils.getIcon("maj.gif"));
        jButton11.setIcon(TUtils.getIcon("DB_table.gif"));
        jButton10.setIcon(TUtils.getIcon("Xbuild.gif"));
        jButton13.setIcon(TUtils.getIcon("DBbuild.gif"));
        jToggleButton1.setIcon(TUtils.getIcon("stat.gif"));
        jToggleButton3.setIcon(TUtils.getIcon("mouse_out.gif"));
        jToggleButton4.setIcon(TUtils.getIcon("mouse_in.gif"));
        jToggleButton11.setIcon(TUtils.getIcon("kbd_out.gif"));
        jToggleButton12.setIcon(TUtils.getIcon("kbd_in.gif"));
        jToggleButton13.setIcon(TUtils.getIcon("scr_out.gif"));
        jToggleButton14.setIcon(TUtils.getIcon("scr_in.gif"));
        jComboBox14.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<javax.sound.sampled.Line>());
        jComboBox15.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<javax.sound.sampled.Line>());
        jComboBox12.setModel(Parent.getWIN_kbdModel());
        //SYS librairie
        jCB_ObjectEditor6.setValue(new java.io.File("."));// for exemple just to set the type
        jCB_ObjectEditor6.setEnabled(false);
        jToggleButton7.setSelected(Parent.islockout());
        jToggleButton6.setSelected(Parent.islockin());
        jToggleButton8.setSelected(Parent.isloopedin());
        jToggleButton15.setSelected(Parent.isloopedout());
        jToggleButton3.setSelected(Parent.isWIN_sendmousmv());
        jToggleButton3.setSelected(Parent.isWIN_rcvmousmv());
        jToggleButton11.setSelected(Parent.isWIN_sendkeys());
        jToggleButton12.setSelected(Parent.isWIN_rcvkeys());

        setColor(Parent.getColor());
        setDB_type(Parent.getDB_type());
        setTerm_Type(Parent.getTerm_Type());
        // SEE checklib in Main (MAIN should manage it ?!
        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
            if (Parent.getModesNames().contains(jTabbedPane1.getTitleAt(i))) {
                jTabbedPane1.setEnabledAt(i, true);
            } else {
                jTabbedPane1.setEnabledAt(i, false);
            }
        }
        //set the mode on Tabbed chnge, here to avoid on start mode re-initialisation on .getIndex(0) (default) 
        jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener() {
            @Override
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                Parent.setModeName(jTabbedPane1.getTitleAt(jTabbedPane1.getSelectedIndex()));
            }
        });
        portBounds=getBounds();

    }

    @Override
    public String toString() {
        return "IF_" + Parent.getPortName();
    }

    /**
     * Manage the color used for the Port final cause used in constructor
     * @param c the new port color
     */
    public final void setColor(Color c) {
        if (Parent.getColor().equals(c) == false) {
            Parent.setColor(c);
        }
        jLabel1.setForeground(c);
    }
    public final void setPortBounds(boolean bool){
      if (bool){
          portBounds=getBounds();
      }else{
          setBounds(portBounds);
      }
    }
    /**
     * Manage the name of the Port final cause used in constructor
     * @param name the new port name
     */
    public void setPortName(String name) {
        if (name == null) {
            return;
        }
        if (Parent.getPortName().compareTo(name) != 0) {
            Parent.setPortName(name);
        }
        setTitle(Parent.getPortName());
    }
    
    public void setcxstatus(String status) {
        jLabel1.setText(status);
        setFrameIcon(Parent.getCMDIcon());
        if (status.startsWith("stopped") || status.startsWith("error") || status.startsWith("creating") || status.startsWith("new")) {
            setboxenable(true);
            jButton7.setEnabled(false);
            jButton1.setText("Start");
        } else if (status.startsWith("closed")) {
            setVisible(false);
        } else if (status.startsWith("connected")) {
            setboxenable(false);
            jButton1.setText("Stop"); //used if not displayed before
            if (Parent.getModeName().startsWith("IPL4")
                    && Parent.getTCP_Mode().startsWith("TCP_L") == false) {
                jButton7.setEnabled(true);
            }
        } else {
            jButton1.setText("Stop");
            setboxenable(false);
        }
    }

    public int getAcc_initsize() {
        return jProgressBar1.getMaximum();
    }

    public void setAcc_initsize(int x) {
        if (x > 0) {
            jProgressBar1.setMaximum(x);
            jProgressBar1.setEnabled(true);
            jProgressBar1.setToolTipText("" + x);
        } else {
            jProgressBar1.setValue(0);
            jProgressBar1.setMaximum(0);
            jProgressBar1.setEnabled(false);
            jProgressBar1.setToolTipText("");
        }

    }

    public void setAcc_position(int x) {
        if (x > getAcc_initsize()) {
            setAcc_initsize(x);
        }
        jProgressBar1.setValue(x);
        jProgressBar1.setToolTipText(x + "/" + getAcc_initsize());
    }

    public void setAcc_startdate(Date dt) {
        String resh, resd;
        if (dt.getTime() == 0) {
            resh = "on: --:--:--.----";
            resd = null;
        } else {
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("HH:mm:ss S");
            java.text.SimpleDateFormat format2 = new java.text.SimpleDateFormat("dd/MM/yy");
            resh = format.format(dt);
            resd = format2.format(dt);
        }
        jLabel84.setText("on: " + resh);
        jLabel84.setToolTipText(resd);
        Parent.setAcc_startdate(dt);
    }

    public void setAcc_stopdate(Date dt) {
        String resh, resd;
        if (dt.getTime() == 0) {
            resh = "off: --:--:--.----";
            resd = null;
        } else {
            java.text.SimpleDateFormat format = new java.text.SimpleDateFormat("HH:mm:ss S");
            java.text.SimpleDateFormat format2 = new java.text.SimpleDateFormat("dd/MM/yy");
            resh = format.format(dt);
            resd = format2.format(dt);
        }
        jLabel85.setText("off:" + resh);
        jLabel85.setToolTipText(resd);
        Parent.setAcc_stopdate(dt);
    }

    public void setModeName(String txt) {
        if (txt == null) {
            return;
        }
        int idx = Parent.getModeidx();
        if (idx == -1) {
            try {
                idx = new Integer(txt);
            } catch (NumberFormatException ex) {
                return;
            }
        }
        setModeidx(idx);
        if (Parent.getModeidx() != idx) {
            Parent.setModeName(txt);
        }
    }

    public void setModeidx(int idx) {
        // inti => 0 => IPL4=>initIPL4=> Nothing to do!!!
        if (idx >= Parent.getModesNames().size()) {
            return;
        }
        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
            if (jTabbedPane1.getTitleAt(i).compareTo(Parent.getModesNames().get(idx)) == 0) {
                JPanel pan = (JPanel) jTabbedPane1.getComponentAt(i);
                java.awt.event.ComponentListener[] a = pan.getComponentListeners();
                for (ComponentListener a1 : a) {
                    pan.removeComponentListener(a1);
                }
                jTabbedPane1.setSelectedIndex(i);
                for (ComponentListener a1 : a) {
                    pan.addComponentListener(a1);
                }
            }
        }
    }

    public void setEcho(String txt) {
        Boolean bool = Boolean.parseBoolean(txt);
        setEcho(bool);
    }

    /**
     * Manage the top part of the port.
     *
     * @param bool true set echo on the port
     * */
    public void setEcho(boolean bool) {
        if (jToggleButton9.isSelected() != bool) {
            jToggleButton9.setSelected(bool);
        }
        if (Parent.isEcho() != bool) {
            Parent.setEcho(bool);
        }
        jToggleButton9.setToolTipText("echo: " + TUtils.getSetString(bool));
    }

    public void setlog(boolean bool) {
        if (jToggleButton10.isSelected() != bool) {
            jToggleButton10.setSelected(bool);
        }
        if (Parent.islog() != bool) {
            Parent.setlog(bool);
        }
        jToggleButton10.setToolTipText("log: " + TUtils.getSetString(bool));
    }

    public void setloopedin(String txt) {
        Boolean bool = Boolean.parseBoolean(txt);
        setloopedin(bool);
    }

    public void setloopedout(String txt) {
        Boolean bool = Boolean.parseBoolean(txt);
        setloopedout(bool);
    }

    public void setloopedin(boolean bool) {
        if (jToggleButton8.isSelected() != bool) {
            jToggleButton8.setSelected(bool);
        }
        if (Parent.isloopedin() != bool) {
            Parent.setloopedin(bool);
        }
        jToggleButton8.setToolTipText("looped in: " + TUtils.getSetString(bool));
        setboxunlock();
    }

    public void setloopedout(boolean bool) {
        if (jToggleButton15.isSelected() != bool) {
            jToggleButton15.setSelected(bool);
        }
        if (Parent.isloopedout() != bool) {
            Parent.setloopedout(bool);
        }
        if (Parent.getSlave() instanceof F_Terminal) {
            ((F_Terminal) Parent.getSlave()).setloopedout(bool);
        }
        jToggleButton15.setToolTipText("looped out: " + TUtils.getSetString(bool));
        setboxunlock();
    }

    public void setlockout(String txt) {
        Boolean bool = Boolean.parseBoolean(txt);
        setlockout(bool);
    }

    public void setlockout(boolean bool) {
        if (jToggleButton7.isSelected() != bool) {
            jToggleButton7.setSelected(bool);
        }
        if (Parent.islockout() != bool) {
            Parent.setlockout(bool);
        }
        jToggleButton7.setToolTipText("Locked out: " + TUtils.getSetString(bool));
    }

    public void setlockin(boolean bool) {
        if (jToggleButton6.isSelected() != bool) {
            jToggleButton6.setSelected(bool);
        }
        jToggleButton6.setToolTipText("Locked in: " + TUtils.getSetString(bool));
        if (Parent.islockin() != bool) {
            Parent.setlockin(bool);
        }

    }

    public void setlocked(boolean bool) {
        setlockin(bool);
        setlockout(bool);
    }
    /*
     * public void setCX_autocx(boolean bool) { if (Parent.isCX_autocx() !=
     * bool) { options.setValuefor("CX_autocx", bool); } setboxCXenable(bool ==
     * false); // si rien ds boite=> autocx sinon attente getcxstrin
     }
     */

    public void setCX_autoopen(boolean bool) {
        if (Parent.isCX_autoopen() != bool) {
            options.setValuefor("CX_autoopen", bool);
        }
    }

    public void setTerm_Type(String txt) {
        if (getTerm_Type().compareTo(txt) != 0) {
            jComboBox20.setSelectedItem(txt);
        }
        if (Parent.getTerm_Type().compareTo(txt) != 0) {
            Parent.setTerm_Type(txt);
        }
    }

    public String getTerm_Type() {
        return jComboBox20.getSelectedItem().toString();
    }

    public void setTCP_Mode(String txt) {
        if (Parent.getTCP_Mode().compareTo(txt) != 0) {
            Parent.setTCP_Mode(txt);
        }
        if (txt.compareTo("UDP") == 0) {
            setboxtcpenable(true);
            if (jRadioButton3.isSelected() != true) {
                jRadioButton3.setSelected(true);
                jRadioButton2.setSelected(false);
                jRadioButton1.setSelected(false);
            }
        } else if (txt.compareTo("TCP_C") == 0) {
            setboxtcpenable(true);
            if (jRadioButton2.isSelected() != true) {
                jRadioButton2.setSelected(true);
                jRadioButton1.setSelected(false);
                jRadioButton3.setSelected(false);
            }
        } else if (txt.compareTo("TCP_L") == 0) {
            setboxtcpenable(false);
            if (jRadioButton1.isSelected() != true) {
                jRadioButton1.setSelected(true);
                jRadioButton2.setSelected(false);
                jRadioButton3.setSelected(false);
            }
        } else {
        }
    }

    public void setTCP_Port(String port) {
        setTCP_Port(new Integer(port));
    }

    public void setTCP_Port(int port) {
        if (jTextField1.getText().compareTo("" + port) != 0) {
            jTextField1.setText("" + port);
        }
        if (Parent.getTCP_Port() != port) {
            Parent.setTCP_Port(port);
        }
    }
    // should not existe but getmethod(name, class) is "too" accurate in UTIL

    public void setTCP_Addr(java.net.Inet4Address addr) {
        setTCP_Addr((java.net.InetAddress) addr);
    }

    public void setTCP_Addr(java.net.InetAddress addr) {
        if (jCB_ObjectEditor2.getValue() == null || jCB_ObjectEditor2.getValue().equals(addr) == false) {
            jCB_ObjectEditor2.setValue(addr);
        }
        if (Parent.getTCP_Addr().equals(addr) == false) {
            Parent.setTCP_Addr(addr);
        }
    }

    public void setTCP_SoTO(int sotimeout) {
        if (jTextField4.getText().compareTo("" + sotimeout) != 0) {
            jTextField4.setText("" + sotimeout);
        }
        if (Parent.getTCP_SoTO() != sotimeout) {
            Parent.setTCP_SoTO(sotimeout);
        }
    }

    public void setTCP_keepalive(boolean bool) {
        if (bool != jCheckBox1.isSelected()) {
            jCheckBox1.setSelected(bool);
        }
        if (Parent.isTCP_keepalive() != bool) {
            Parent.setTCP_keepalive(bool);
        }
    }

    public void setTCP_nodelay(boolean bool) {
        if (bool != jCheckBox3.isSelected()) {
            jCheckBox3.setSelected(bool);
        }
        if (bool != Parent.isTCP_nodelay()) {
            Parent.setTCP_nodelay(bool);
        }
    }

    public int getTCP_Lmax() {
        int res = -1;
        try {
            res = new Integer(jSpinner1.getValue().toString());
        } catch (NumberFormatException a) {
        }
        return res;
    }

    public void setTCP_Lmax(String nbcxmax) {
        if (nbcxmax == null) {
            return;
        }
        jSpinner1.setValue(new Integer(nbcxmax));
    }

    /**
     * Ask to print the number of tcp client connected
     * @param nb display number of TCP Listner client
     */
    public void DisplayLclientNumber(int nb) {
        jLabel49.setText("" + nb);
    }

    /**
     * Manage Serial Async part of the port
     * @param port set the serial interface (COMX/sd0..) for this port
     */
    public void setRS_Port(Object port) {
        if (port == null) {
            return;
        }
        if (Parent.getRS_Port() != jComboBox1.getSelectedItem()) {
            setCombobox(jComboBox1, port);
        }
    }

    public void setRS_Rate(DefaultComboBoxModel<Integer> rates) {
        jComboBox2.setModel(rates);
    }

    public void setRS_Rate(String rate) {
        if (rate == null) {
            return;
        }
        int i = 0;
        try {
            i = Integer.parseInt(rate);
        } catch (NumberFormatException ex) {
        }
        setRS_Rate(i);
    }

    public void setRS_Rate(int rate) {
        // used for config via XML
        jComboBox2.setSelectedItem("" + rate);
    }

    public void setRS_FlowCtrl(String txt) {
        jComboBox7.setSelectedItem(txt);
    }

    public void setRS_Databit(String txt) {
        setRS_Databit(Integer.parseInt(txt));
    }

    public void setRS_Databit(int nb) {
        jComboBox5.setSelectedItem(nb);
        if (nb == 8) {
            Parent.setRS_Parity("None");
            jComboBox6.setEnabled(false);
        } else {
            Parent.setRS_Parity("Even");
            jComboBox6.setEnabled(true);
        }
    }

    public void setRS_Parity(String txt) {
        jComboBox6.setSelectedItem(txt);
    }

    public void setRS_Stopbit(String txt) {
        jComboBox3.setSelectedItem(txt);
    }

    public void setRS_DTR(boolean bool) {
        jCheckBox11.setSelected(bool);
    }

    public void setRS_RTS(boolean bool) {
        jCheckBox8.setSelected(bool);
    }

    /**
     * Manage File part of the port
     * @param model
     */
    public void setFile_traces(DefaultComboBoxModel<String> model) {
        jComboBox11.setModel(model);
    }

    public void setFile_read(boolean bool) {
        jCheckBox17.setEnabled(bool);
        if (jCheckBox5.isSelected() != bool) {
            jCheckBox5.setSelected(bool);
        }
    }

    public void setFile_write(boolean bool) {
        jCheckBox18.setEnabled(bool);

        if (jCheckBox4.isSelected() != bool) {
            jCheckBox4.setSelected(bool);
        }
    }

    public void setFile_addr(java.io.File fi) {
        if (fi == null) {//|| fi.isFile()==false){
            //TDeb.wri("file: "+fi.toString()+" is not a 'normal' file (should be directory");
            return;
        }
        if (jComboBox11.getSelectedItem() == null || jComboBox11.getSelectedItem().equals(fi) == false) {
            jComboBox11.setSelectedItem(fi);
        }
        if (fi.equals(jCB_ObjectEditor4.getValue()) == false) {
            jCB_ObjectEditor4.setValue(fi);
        }
        if (fi.equals(Parent.getFile_addr()) == false) {
            Parent.setFile_addr(fi);
        }
        jCheckBox4.setEnabled(TUtils.canWrite(fi));
        jCheckBox5.setEnabled(TUtils.canRead(fi));
    }

    public void setFile_EOFstop(boolean bool) {
        if (Parent.isFile_EOFstop() != bool) {
            jCheckBox17.setSelected(bool);
        }
    }

    public void setFile_ClearatStart(boolean bool) {
        if (jCheckBox18.isSelected() != bool) {
            jCheckBox18.setSelected(bool);
        }
        if (Parent.isFile_ClearatStart() != bool) {
            Parent.setFile_ClearatStart(bool);
        }
    }

    public void setFile_xml2tree(boolean bool) {
        if (bool != Parent.isFile_xml2tree()) {
            jCheckBox6.setSelected(bool);
        }
    }

    /**
     * Manage DB part of the port
     * @param idx set the type Mysql/Odbc/... of the DB
     */
    public void setDB_type(int idx) {
        setDB_type(jComboBox8.getItemAt(idx).toString());
    }

    public void setDB_type(String txt) {
        if (Parent.getDB_type().compareTo(txt) != 0) {
            setCombobox(jComboBox8, txt);
        }
        jButton3.setVisible(txt.startsWith("ODBC_mdb") || txt.startsWith("ODBC_xls"));
        boolean bool = (txt.startsWith("ODBC_") || txt.compareTo("Oracle_tns") == 0 || txt.startsWith("HSQL_"));
        jTextField23.setEnabled(bool == false);
        jTextField18.setEnabled(bool == false);
    }

    public void setDB_host(String txt) {
        if (jTextField23.getText().compareTo(txt) != 0) {
            jTextField23.setText(txt);
        }
    }

    public void setDB_port(String txt) {
        try {
            int port = new Integer(txt);
            setDB_port(port);
        } catch (NumberFormatException ex) {
        }

    }

    public void setDB_port(int portnb) {
        if (jTextField18.getText().compareTo("" + portnb) != 0) {
            jTextField18.setText("" + portnb);
        }
    }

    public void setDB_name(String name) {
        String txt = name;
        if (txt == null) {
            txt = "";
        }
        if (jTextField21.getText().compareTo(txt) != 0) {
            jTextField21.setText(txt);
        }

    }

    public void setDB_user(String txt) {
        if (jTextField19.getText().compareTo(txt) != 0) {
            jTextField19.setText(txt);
        }
    }

    public void setDB_pwd(String txt) {
        if (jTextField20.getText().compareTo(txt) != 0) {
            jTextField20.setText(txt);
        }
    }

    /**
     * Manage Jpcap part of the port
     */
    public void setETHcreate() {
        if (Parent.getSlave() instanceof T_ETH) {
            ((T_ETH) Parent.getSlave()).setdevice();
        }
    }

    public void setETH_interfaceidx(String txt) {
        setETH_interfaceidx(Integer.parseInt(txt));
    }

    public void setETH_interfaces(DefaultComboBoxModel<String> model) {
        jComboBox9.setModel(model);
    }

    public void setETH_interfaceidx(int idx) {
        if (jComboBox9.getSelectedIndex() != idx) {
            jComboBox9.setSelectedIndex(idx);
        }
        jCB_ObjectEditor5.setValue(new T_ETH(Parent).getdevice(idx));
    }

    public void setETH_promiscuous(boolean bool) {
        if (jCheckBox20.isSelected() != bool) {
            jCheckBox20.setSelected(bool);
        }
    }

    public void setETH_state(boolean bool) {
        java.awt.Color col = java.awt.Color.RED;
        if (bool) {
            col = java.awt.Color.GREEN;
        }
        this.jLabel62.setBackground(col);
    }

    public void setETH_filter(String txt) {
        if (jTextField27.getText().compareTo(txt) != 0) {
            jTextField27.setText(txt);
        }
    }

    private void display_ETH_msg() {
        String CR = "\r\n";
        String txt = "[src][dst]host 'host'\t\t=> host 10.10.10.10";
        txt = txt + CR + "[src][dst]port 'port'\t\t=> src port 80";
        txt = txt + CR + "[src][dst]net 'net' \t\t=> dst net 192.168";
        txt = txt + CR + "ether proto [\\ip][\\arp][\\rarp ] ";
        txt = txt + CR + "ip proto[\\tcp][\\udp][\\icmp]";
        txt = txt + CR + "Negation:'!' or 'not'";
        txt = txt + CR + "Concatenation:'&&' or 'and'";
        txt = txt + CR + "Alternation:'||' or 'or' ";
        txt = txt + CR + "\t=> host 10.10.10.10 && !net 192.168";
        txt = txt + CR + "ip[8] = 1: Capture all IP packets where the TTL is 1 ";
        txt = txt + CR + "tcp[0:2] = 80: Capture all tcp segments (packets) where 80 is the source port. ";
        JOptionPane.showMessageDialog(this, txt, "TCPdump filter help", JOptionPane.INFORMATION_MESSAGE);

    }

    private void setLPT_Port(String name) {
        if (jComboBox18.getSelectedItem().toString().compareTo(name) != 0) {
            jComboBox18.setSelectedItem(name);
        }
        if (Parent.getLPT_Port().compareTo(name) != 0) {
            Parent.setLPT_Port(name);
        }
    }

    private void setLPT_Mode(String name) {
        if (jComboBox17.getSelectedItem().toString().compareTo(name) != 0) {
            jComboBox17.setSelectedItem(name);
        }
        if (Parent.getLPT_Mode().compareTo(name) != 0) {
            Parent.setLPT_Mode(name);
        }
    }

    public void setMEM_wire(int wirenb) {
        jSpinner4.setValue(wirenb);
        if (Parent.getMEM_wire() != wirenb) {
            Parent.setMEM_wire(wirenb);
        }
    }

    public void setUSB_Element(Object intf) {
        if (intf != null) {
            if (intf.getClass().getCanonicalName().startsWith("usb.")) {
                jCB_ObjectEditor3.setValue(intf);
            }
            if (Parent.getUSB_Element().equals(intf) == false) {
                Parent.setUSB_Element(intf);
            }
        }
    }

    public void setSYS_lib(String txt) {
        if (txt != null && txt.length() > 0) {
            jCheckBox12.setSelected(true);
            jCB_ObjectEditor6.setValue(new java.io.File(txt));
        } else {
            jCheckBox12.setSelected(false);
        }
        if (Parent.getSYS_lib().compareTo(txt) != 0) {
            Parent.setSYS_lib(txt);
        }
    }

    public void setSYS_nbmup(int nb) {
        jLabel12.setText("" + nb);
        if (Parent.getSYS_nbmup() != nb) {
            Parent.setSYS_nbmup(nb);
        }
    }

    public void setSYS_status(String txt) {
        jLabel16.setText(txt);
        if (Parent.getSYS_status().compareTo(txt) != 0) {
            Parent.setSYS_status(txt);
        }
    }

    public void setSYS_DCXatend(boolean bool) {
        if (jCheckBox13.isSelected() != bool) {
            jCheckBox13.setSelected(bool);
        }
        if (Parent.isSYS_DCXatend() != bool) {
            Parent.setSYS_DCXatend(bool);
        }
    }

    public void setSYS_CheckSM(boolean bool) {
        if (jCheckBox2.isSelected() != bool) {
            jCheckBox2.setSelected(bool);
        }
        if (Parent.isSYS_CheckSM() != bool) {
            Parent.setSYS_CheckSM(bool);
        }
    }

    @A_Commande(help = "transfert input bytes to runnning process")
    public void setSYS_intoproc(boolean bool) {
        if (Parent.isSYS_intoproc() != bool) {
            jCheckBox15.setSelected(bool);
        }
    }

    public void setSYS_sendExit(boolean bool) {
        if (jCheckBox19.isSelected() != bool) {
            jCheckBox19.setSelected(bool);
        }
        jCheckBox14.setEnabled(jCheckBox19.isSelected());
        setSYS_exitasbyte(isSYS_exitasbyte());
        if (Parent.isSYS_sendExit() != bool) {
            Parent.setSYS_sendExit(bool);
        }

    }

    public void setSYS_sendOut(boolean bool) {
        if (jCheckBox16.isSelected() != bool) {
            jCheckBox16.setSelected(bool);
        }
        if (Parent.isSYS_sendOut() != bool) {
            Parent.setSYS_sendOut(bool);
        }

    }

    public boolean isSYS_exitasbyte() {
        return jCheckBox14.isSelected();
    }

    public void setSYS_exitasbyte(boolean bool) {
        if (Parent.isSYS_exitasbyte() != bool) {
            Parent.setSYS_exitasbyte(bool);
        }
        if (isSYS_exitasbyte() != bool) {
            jCheckBox14.setSelected(bool);
        }
    }

    public void setSYS_stdinout(boolean bool) {
        if (jRadioButton11.isSelected() != bool) {
            jRadioButton11.setSelected(bool);
        }
        if (jRadioButton6.isSelected() == bool) {
            jRadioButton6.setSelected(!bool);
        }
        if (Parent.isSYS_stdinout() != bool) {
            Parent.setSYS_stdinout(bool);
        }
        jLabel16.setEnabled(bool == false);
        jLabel11.setEnabled(bool == false);
        jCheckBox14.setEnabled(bool == false && jCheckBox19.isSelected());
        jCheckBox16.setEnabled(bool == false);
        jCheckBox19.setEnabled(bool == false);
        jCheckBox2.setEnabled(bool == false);
        jCheckBox15.setEnabled(bool == false);
        jCheckBox12.setEnabled(bool == false);
        jCheckBox13.setEnabled(bool == false);
        jCB_ObjectEditor6.setEnabled(bool == false);
    }

    public void setSND_linesin(DefaultComboBoxModel<javax.sound.sampled.Line> lines) {
        jComboBox14.setModel(lines);
    }

    public void setSND_linesout(DefaultComboBoxModel<javax.sound.sampled.Line> lines) {
        jComboBox15.setModel(lines);
    }

    public void setSND_formatin(javax.sound.sampled.AudioFormat format) {
        jCB_ObjectEditor1.setValue(format);
    }

    public void setSND_formatout(javax.sound.sampled.AudioFormat format) {
        jCB_ObjectEditor7.setValue(format);
    }

    public void setboxunlock() {
        boolean bool = jToggleButton8.isSelected() || jToggleButton15.isSelected();
        jToggleButton6.setEnabled(!bool);
        jToggleButton9.setEnabled(!bool);
        jToggleButton7.setEnabled(!bool);
        jToggleButton10.setEnabled(!bool);
    }

    private void setboxtcpenable(boolean bool) {
        //jButton7.setEnabled(bool);
        jCheckBox1.setEnabled(bool);
        jCheckBox3.setEnabled(bool);
        //  jLabel15.setEnabled(bool);

        /*
         * if (bool) { try { setTCP_Addr(java.net.InetAddress.getLocalHost()); }
         * catch (Exception ex) { try {
         * setTCP_Addr(java.net.InetAddress.getByName("0.0.0.0")); } catch
         * (Exception e) { } } }
         */
        jSpinner1.setEnabled(bool == false);
        jLabel86.setEnabled(bool == false);
        jLabel48.setEnabled(bool == false);
        jLabel49.setEnabled(bool == false);
    }

    public void setboxenableRS(boolean bool) {
        //RS
        jComboBox2.setEnabled(bool & jComboBox1.getSelectedItem() != null);
        jComboBox3.setEnabled(bool & jComboBox1.getSelectedItem() != null);
        jComboBox5.setEnabled(bool & jComboBox1.getSelectedItem() != null);
        jComboBox6.setEnabled(bool & jComboBox1.getSelectedItem() != null);
        jComboBox7.setEnabled(bool & jComboBox1.getSelectedItem() != null);
        jCheckBox8.setEnabled(jComboBox1.getSelectedItem() != null);
        jCheckBox11.setEnabled(jComboBox1.getSelectedItem() != null);
        // stat must be enable while running
        //jToggleButton1.setEnabled(bool & jComboBox1.getSelectedItem() != null);
        jButton2.setEnabled(bool);
    }

    private void setboxenable(boolean bool) {
        setboxenableRS(bool);
        //
        jComboBox20.setEnabled(bool);
        jTabbedPane1.setEnabled(bool);
        jButton3.setEnabled(bool);
        jRadioButton11.setEnabled(bool);
        jRadioButton6.setEnabled(bool);
        jComboBox14.setEnabled(bool);
        jComboBox15.setEnabled(bool);
        jCB_ObjectEditor1.setEditable(bool);
        jCB_ObjectEditor7.setEditable(bool);
        jTabbedPane1.setEnabledAt(10, false);//MODE_LPT
        jTabbedPane1.setEnabledAt(11, false);//MODE_MEM
        jTabbedPane1.setEnabledAt(12, false);//MODE_MOM
        jButton6.setEnabled(bool);
        /*  if (Parent.getTCP_Mode().startsWith("TCP_L") == false) {
         jButton7.setEnabled(bool == false);
         }*/
        jCheckBox12.setEnabled(bool);
        jCB_ObjectEditor6.setEnabled(bool && jCheckBox12.isSelected());
        jButton11.setEnabled(bool == false);
        jButton10.setEnabled(bool == false);
        jButton13.setEnabled(bool == false);
        jRadioButton1.setEnabled(bool);
        jRadioButton2.setEnabled(bool);
        //jCheckBox35.setEnabled(bool);
        options.setused("SSL_enabled", bool);
        jRadioButton3.setEnabled(bool);
        jTextField1.setEditable(bool);
        jCB_ObjectEditor2.setEditing(bool);
        jTextField5.setEditable(bool);
        jTextField6.setEditable(bool);
        jComboBox11.setEditable(bool);
        jButton15.setEnabled(bool);
        jTextField18.setEditable(bool);
        jTextField19.setEditable(bool);
        jTextField20.setEditable(bool);
        jTextField21.setEditable(bool);
        jTextField23.setEditable(bool);
        jTextField27.setEditable(bool);
        //jTextField32.setEditable(bool); Max row could be use to perform long request
        jComboBox1.setEnabled(bool);
        jComboBox9.setEnabled(bool);

        jCheckBox4.setEnabled(bool);
        jCheckBox5.setEnabled(bool);
        jCheckBox20.setEnabled(bool);
        jComboBox11.setEnabled(bool);
        // setboxDescenable(bool); DESC is enable only by DESC_Enable
        jLabel31.setEnabled(bool == false);
        jLabel26.setEnabled(bool == false);
        jCheckBox9.setEnabled(bool == false);
        jButton12.setEnabled(bool == false);
        jSpinner3.setEnabled(bool == false);
        jCB_ObjectEditor5.setEnabled(bool);
    }
    /*
     * private void setrsboxenable(boolean bool) { for (int i = 0; i <
     * P_Serial.getComponentCount(); i++) {
     * P_Serial.getComponent(i).setEnabled(bool); } }
     *
     * private void setlptboxenable(boolean bool) { for (int i = 0; i <
     * P_LPT.getComponentCount(); i++) { P_LPT.getComponent(i).setEnabled(bool);
     * } }
     *
     * private void setethboxenable(boolean bool) { for (int i = 0; i <
     * P_LPT.getComponentCount(); i++) {
     * jPanel3.getComponent(i).setEnabled(bool); } }
     */

    /**
     * Set a combobox item with actionListner disabled
     *
     * @param cb the combobox to change
     * @param txt the item to select
     */
    private <U> void setCombobox(javax.swing.JComboBox<U> cb, U Obj) {
        //remove listners to avoid action after setlect commands
        java.awt.event.ActionListener[] a = cb.getActionListeners();
        for (ActionListener a1 : a) {
            cb.removeActionListener(a1);
        }
        boolean search = true;
        for (int i = 0; search && i < cb.getItemCount(); i++) {
            if (cb.getItemAt(i) instanceof java.io.File) {
                if (((java.io.File) cb.getItemAt(i)).getName().compareTo(Obj.toString()) == 0) {
                    cb.setSelectedIndex(i);
                    search = false;
                }
            } else {
                if (cb.getItemAt(i) == Obj) {
                    cb.setSelectedIndex(i);
                    search = false;
                }
            }
        }
        for (ActionListener a1 : a) {
            cb.addActionListener(a1);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup_IP = new javax.swing.ButtonGroup();
        buttonGroup_File = new javax.swing.ButtonGroup();
        buttonGroup_Term = new javax.swing.ButtonGroup();
        buttonGroup_SYS2 = new javax.swing.ButtonGroup();
        buttonGroup_SYS1 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jProgressBar1 = new javax.swing.JProgressBar();
        jButton1 = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        P_IPL4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jCB_ObjectEditor2 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel6 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jButton7 = new javax.swing.JButton();
        jPanel7 = new javax.swing.JPanel();
        jLabel48 = new javax.swing.JLabel();
        jLabel49 = new javax.swing.JLabel();
        jLabel86 = new javax.swing.JLabel();
        jSpinner1 = new javax.swing.JSpinner();
        jPanel39 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jPanel40 = new javax.swing.JPanel();
        jCheckBox3 = new javax.swing.JCheckBox();
        jPanel8 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        P_Serial = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox<>();
        jComboBox2 = new javax.swing.JComboBox<>();
        jLabel6 = new javax.swing.JLabel();
        jComboBox5 = new javax.swing.JComboBox<>();
        jComboBox6 = new javax.swing.JComboBox<>();
        jLabel8 = new javax.swing.JLabel();
        jComboBox7 = new javax.swing.JComboBox<>();
        jComboBox3 = new javax.swing.JComboBox<>();
        jLabel9 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jTextField6 = new javax.swing.JTextField();
        jPanel11 = new javax.swing.JPanel();
        jCheckBox8 = new javax.swing.JCheckBox();
        jCheckBox11 = new javax.swing.JCheckBox();
        jToggleButton1 = new javax.swing.JToggleButton();
        jButton2 = new javax.swing.JButton();
        P_FILE = new javax.swing.JPanel();
        jPanel12 = new javax.swing.JPanel();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jPanel41 = new javax.swing.JPanel();
        jCheckBox17 = new javax.swing.JCheckBox();
        jCheckBox18 = new javax.swing.JCheckBox();
        jComboBox11 = new javax.swing.JComboBox<>();
        jPanel14 = new javax.swing.JPanel();
        jCB_ObjectEditor4 = new com.jdcm.editors.JCB_ObjectEditor();
        jButton15 = new javax.swing.JButton();
        jCheckBox6 = new javax.swing.JCheckBox();
        jPanel13 = new javax.swing.JPanel();
        jLabel34 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jTextField10 = new javax.swing.JTextField();
        jComboBox10 = new javax.swing.JComboBox<>();
        P_TERM = new javax.swing.JPanel();
        jComboBox20 = new javax.swing.JComboBox<>();
        P_DB = new javax.swing.JPanel();
        jComboBox8 = new javax.swing.JComboBox<>();
        jPanel17 = new javax.swing.JPanel();
        jLabel66 = new javax.swing.JLabel();
        jTextField21 = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jPanel38 = new javax.swing.JPanel();
        jLabel65 = new javax.swing.JLabel();
        jTextField23 = new javax.swing.JTextField();
        jTextField18 = new javax.swing.JTextField();
        jPanel37 = new javax.swing.JPanel();
        jLabel37 = new javax.swing.JLabel();
        jTextField19 = new javax.swing.JTextField();
        jTextField20 = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        jButton10 = new javax.swing.JButton();
        jButton13 = new javax.swing.JButton();
        jPanel42 = new javax.swing.JPanel();
        jButton11 = new javax.swing.JButton();
        P_ETH = new javax.swing.JPanel();
        jPanel18 = new javax.swing.JPanel();
        jLabel62 = new javax.swing.JLabel();
        jButton6 = new javax.swing.JButton();
        jComboBox9 = new javax.swing.JComboBox<>();
        jCB_ObjectEditor5 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel19 = new javax.swing.JPanel();
        jLabel63 = new javax.swing.JLabel();
        jTextField27 = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jPanel20 = new javax.swing.JPanel();
        jLabel25 = new javax.swing.JLabel();
        jLabel31 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        jPanel43 = new javax.swing.JPanel();
        jButton12 = new javax.swing.JButton();
        jPanel21 = new javax.swing.JPanel();
        jCheckBox9 = new javax.swing.JCheckBox();
        jLabel32 = new javax.swing.JLabel();
        jSpinner3 = new javax.swing.JSpinner();
        jPanel22 = new javax.swing.JPanel();
        jCheckBox20 = new javax.swing.JCheckBox();
        jComboBox16 = new javax.swing.JComboBox<>();
        P_WIN = new javax.swing.JPanel();
        jPanel23 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jToggleButton3 = new javax.swing.JToggleButton();
        jSpinner5 = new javax.swing.JSpinner();
        jToggleButton4 = new javax.swing.JToggleButton();
        jPanel24 = new javax.swing.JPanel();
        jLabel15 = new javax.swing.JLabel();
        jToggleButton13 = new javax.swing.JToggleButton();
        jSpinner6 = new javax.swing.JSpinner();
        jToggleButton14 = new javax.swing.JToggleButton();
        jPanel25 = new javax.swing.JPanel();
        jLabel27 = new javax.swing.JLabel();
        jToggleButton11 = new javax.swing.JToggleButton();
        jComboBox12 = new javax.swing.JComboBox<>();
        jToggleButton12 = new javax.swing.JToggleButton();
        P_SYS = new javax.swing.JPanel();
        jPanel26 = new javax.swing.JPanel();
        jRadioButton6 = new javax.swing.JRadioButton();
        jRadioButton11 = new javax.swing.JRadioButton();
        jPanel30 = new javax.swing.JPanel();
        jCheckBox13 = new javax.swing.JCheckBox();
        jCheckBox15 = new javax.swing.JCheckBox();
        jPanel31 = new javax.swing.JPanel();
        jCheckBox16 = new javax.swing.JCheckBox();
        jCheckBox19 = new javax.swing.JCheckBox();
        jCheckBox14 = new javax.swing.JCheckBox();
        jPanel29 = new javax.swing.JPanel();
        jLabel16 = new javax.swing.JLabel();
        jPanel27 = new javax.swing.JPanel();
        jCheckBox12 = new javax.swing.JCheckBox();
        jCB_ObjectEditor6 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel28 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jCheckBox2 = new javax.swing.JCheckBox();
        P_USB = new javax.swing.JPanel();
        jCB_ObjectEditor3 = new com.jdcm.editors.JCB_ObjectEditor();
        P_SND = new javax.swing.JPanel();
        jPanel32 = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        jComboBox14 = new javax.swing.JComboBox<>();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel33 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();
        jComboBox15 = new javax.swing.JComboBox<>();
        jCB_ObjectEditor7 = new com.jdcm.editors.JCB_ObjectEditor();
        P_LPT = new javax.swing.JPanel();
        jPanel35 = new javax.swing.JPanel();
        jLabel22 = new javax.swing.JLabel();
        jComboBox18 = new javax.swing.JComboBox<>();
        jLabel24 = new javax.swing.JLabel();
        jComboBox17 = new javax.swing.JComboBox<>();
        jLabel18 = new javax.swing.JLabel();
        jTextField40 = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        jTextField41 = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        jTextField42 = new javax.swing.JTextField();
        jLabel23 = new javax.swing.JLabel();
        jTextField43 = new javax.swing.JTextField();
        jPanel34 = new javax.swing.JPanel();
        jLabel29 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        jLabel35 = new javax.swing.JLabel();
        jLabel36 = new javax.swing.JLabel();
        jLabel79 = new javax.swing.JLabel();
        jCheckBox10 = new javax.swing.JCheckBox();
        P_MEM = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jSpinner4 = new javax.swing.JSpinner();
        P_MOM = new javax.swing.JPanel();
        jComboBox4 = new javax.swing.JComboBox<>();
        P_JNA = new javax.swing.JPanel();
        jPanel36 = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel33 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jLabel38 = new javax.swing.JLabel();
        jComboBox19 = new javax.swing.JComboBox<>();
        jLabel39 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList<>();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jToggleButton6 = new javax.swing.JToggleButton();
        jToggleButton7 = new javax.swing.JToggleButton();
        jToggleButton15 = new javax.swing.JToggleButton();
        jToggleButton10 = new javax.swing.JToggleButton();
        jToggleButton9 = new javax.swing.JToggleButton();
        jToggleButton8 = new javax.swing.JToggleButton();
        jPanel4 = new javax.swing.JPanel();
        jLabel84 = new javax.swing.JLabel();
        jLabel85 = new javax.swing.JLabel();

        setClosable(true);
        setResizable(true);
        setTitle("Port");
        setAutoscrolls(true);
        setFrameIcon(null);
        setPreferredSize(new java.awt.Dimension(250, 300));
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameClosed(evt);
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
            }
        });

        jPanel2.setMinimumSize(new java.awt.Dimension(100, 23));
        jPanel2.setPreferredSize(new java.awt.Dimension(150, 15));
        jPanel2.setLayout(new java.awt.GridLayout(1, 0, 2, 2));

        jLabel1.setText("status");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(jLabel1);

        jProgressBar1.setMaximum(0);
        jProgressBar1.setVerifyInputWhenFocusTarget(false);
        jPanel2.add(jProgressBar1);

        jButton1.setText("Start");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton1);

        getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane1.setToolTipText("port type");
        jTabbedPane1.setMinimumSize(new java.awt.Dimension(30, 130));
        jTabbedPane1.setOpaque(true);

        P_IPL4.setEnabled(false);
        P_IPL4.setLayout(new java.awt.GridLayout(6, 0, 0, 2));

        jPanel5.setMinimumSize(new java.awt.Dimension(100, 15));
        jPanel5.setPreferredSize(new java.awt.Dimension(100, 15));
        jPanel5.setLayout(new java.awt.BorderLayout());

        buttonGroup_IP.add(jRadioButton1);
        jRadioButton1.setText("List.");
        jRadioButton1.setToolTipText("connection mode : wait for connect");
        jRadioButton1.setActionCommand("TCP_L");
        jRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton1.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });
        jPanel5.add(jRadioButton1, java.awt.BorderLayout.CENTER);

        buttonGroup_IP.add(jRadioButton2);
        jRadioButton2.setText("TCP Cx");
        jRadioButton2.setToolTipText("connection mode : connect to a listener ");
        jRadioButton2.setActionCommand("TCP_C");
        jRadioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton2.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });
        jPanel5.add(jRadioButton2, java.awt.BorderLayout.WEST);

        buttonGroup_IP.add(jRadioButton3);
        jRadioButton3.setText("UDP/mcast");
        jRadioButton3.setToolTipText("Connection for UDP and MultiCast");
        jRadioButton3.setActionCommand("UDP");
        jRadioButton3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton3.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jRadioButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton3ActionPerformed(evt);
            }
        });
        jPanel5.add(jRadioButton3, java.awt.BorderLayout.LINE_END);

        P_IPL4.add(jPanel5);

        jCB_ObjectEditor2.setToolTipText("IP adresse of remote");
        jCB_ObjectEditor2.setEditable(true);
        jCB_ObjectEditor2.setMinimumSize(new java.awt.Dimension(13, 10));
        jCB_ObjectEditor2.setPreferredSize(new java.awt.Dimension(13, 10));
        jCB_ObjectEditor2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor2ActionPerformed(evt);
            }
        });
        P_IPL4.add(jCB_ObjectEditor2);

        jPanel6.setLayout(new java.awt.BorderLayout());

        jLabel2.setText("Port : ");
        jPanel6.add(jLabel2, java.awt.BorderLayout.WEST);

        jTextField1.setText("2000");
        jTextField1.setToolTipText("TCP port (1 to 1024 reserved see IANA) 0=> any free port");
        jTextField1.setMinimumSize(new java.awt.Dimension(6, 10));
        jTextField1.setPreferredSize(new java.awt.Dimension(30, 10));
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField1KeyReleased(evt);
            }
        });
        jPanel6.add(jTextField1, java.awt.BorderLayout.CENTER);

        jButton7.setEnabled(false);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jPanel6.add(jButton7, java.awt.BorderLayout.EAST);

        P_IPL4.add(jPanel6);

        jPanel7.setMinimumSize(new java.awt.Dimension(100, 20));
        jPanel7.setPreferredSize(new java.awt.Dimension(104, 28));
        jPanel7.setLayout(new java.awt.GridLayout(1, 0));

        jLabel48.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel48.setText("Nb Sock: ");
        jLabel48.setEnabled(false);
        jPanel7.add(jLabel48);

        jLabel49.setText("0");
        jLabel49.setToolTipText("cx numberl");
        jLabel49.setEnabled(false);
        jPanel7.add(jLabel49);

        jLabel86.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel86.setText("Max : ");
        jLabel86.setEnabled(false);
        jPanel7.add(jLabel86);

        jSpinner1.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(-1), null, null, Integer.valueOf(1)));
        jSpinner1.setToolTipText("listner cx limit");
        jSpinner1.setEnabled(false);
        jSpinner1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinner1StateChanged(evt);
            }
        });
        jPanel7.add(jSpinner1);

        P_IPL4.add(jPanel7);

        jPanel39.setLayout(new javax.swing.BoxLayout(jPanel39, javax.swing.BoxLayout.LINE_AXIS));

        jCheckBox1.setText("Keepalive");
        jCheckBox1.setToolTipText("detect cut");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        jPanel39.add(jCheckBox1);
        jPanel39.add(jPanel40);

        jCheckBox3.setText("NoDelay");
        jCheckBox3.setToolTipText("Nagle Algo");
        jCheckBox3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });
        jPanel39.add(jCheckBox3);

        P_IPL4.add(jPanel39);

        jPanel8.setMinimumSize(new java.awt.Dimension(100, 50));
        jPanel8.setPreferredSize(new java.awt.Dimension(100, 50));
        jPanel8.setLayout(new javax.swing.BoxLayout(jPanel8, javax.swing.BoxLayout.LINE_AXIS));

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel4.setText("SoTO : ");
        jPanel8.add(jLabel4);

        jTextField4.setText("100");
        jTextField4.setToolTipText("TO (ms) for waiting a connexion for the tcp/udp listner (if 0=>listner blocked)");
        jTextField4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField4ActionPerformed(evt);
            }
        });
        jTextField4.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField4KeyReleased(evt);
            }
        });
        jPanel8.add(jTextField4);

        P_IPL4.add(jPanel8);

        jTabbedPane1.addTab("IPL4", P_IPL4);

        P_Serial.setToolTipText("see comm.jar");
        P_Serial.setEnabled(false);
        P_Serial.setVerifyInputWhenFocusTarget(false);
        P_Serial.setLayout(new javax.swing.BoxLayout(P_Serial, javax.swing.BoxLayout.Y_AXIS));

        jPanel10.setMinimumSize(new java.awt.Dimension(50, 82));
        jPanel10.setName(""); // NOI18N
        jPanel10.setPreferredSize(new java.awt.Dimension(50, 64));
        jPanel10.setLayout(new java.awt.GridLayout(4, 3, 2, 2));

        jLabel5.setText("Port/Rate :");
        jPanel10.add(jLabel5);

        jComboBox1.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jComboBox1.setToolTipText("COM port of the host to use ");
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jPanel10.add(jComboBox1);

        jComboBox2.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jComboBox2.setToolTipText("serial normalized rate");
        jComboBox2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox2ActionPerformed(evt);
            }
        });
        jPanel10.add(jComboBox2);

        jLabel6.setText("Dta/Prty :");
        jLabel6.setFocusable(false);
        jLabel6.setInheritsPopupMenu(false);
        jLabel6.setOpaque(true);
        jPanel10.add(jLabel6);

        jComboBox5.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jComboBox5.setToolTipText("Databits");
        jComboBox5.setFocusable(false);
        jComboBox5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox5ActionPerformed(evt);
            }
        });
        jPanel10.add(jComboBox5);

        jComboBox6.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jComboBox6.setToolTipText("Parity");
        jComboBox6.setFocusable(false);
        jComboBox6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox6ActionPerformed(evt);
            }
        });
        jPanel10.add(jComboBox6);

        jLabel8.setText("Ctrl/Stop : ");
        jLabel8.setFocusable(false);
        jLabel8.setInheritsPopupMenu(false);
        jLabel8.setOpaque(true);
        jPanel10.add(jLabel8);

        jComboBox7.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jComboBox7.setToolTipText("Ctrls");
        jComboBox7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox7ActionPerformed(evt);
            }
        });
        jPanel10.add(jComboBox7);

        jComboBox3.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jComboBox3.setToolTipText("Stopbit");
        jComboBox3.setFocusable(false);
        jComboBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox3ActionPerformed(evt);
            }
        });
        jPanel10.add(jComboBox3);

        jLabel9.setText("Sysl/op.TO  :");
        jPanel10.add(jLabel9);

        jTextField5.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jTextField5.setText("CX");
        jTextField5.setToolTipText("system Label of the program using the serial port");
        jPanel10.add(jTextField5);

        jTextField6.setFont(new java.awt.Font("Arial", 0, 10)); // NOI18N
        jTextField6.setText("1000");
        jTextField6.setToolTipText("TO for opening the port.");
        jPanel10.add(jTextField6);

        P_Serial.add(jPanel10);

        jPanel11.setMinimumSize(new java.awt.Dimension(50, 33));
        jPanel11.setPreferredSize(new java.awt.Dimension(50, 23));

        jCheckBox8.setText("RTS");
        jCheckBox8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox8ActionPerformed(evt);
            }
        });
        jPanel11.add(jCheckBox8);

        jCheckBox11.setText("DTR");
        jCheckBox11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox11ActionPerformed(evt);
            }
        });
        jPanel11.add(jCheckBox11);

        jToggleButton1.setToolTipText("UART stat.");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel11.add(jToggleButton1);

        jButton2.setToolTipText("update ports");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel11.add(jButton2);

        P_Serial.add(jPanel11);

        jTabbedPane1.addTab("Serial", P_Serial);

        P_FILE.setEnabled(false);
        P_FILE.setMinimumSize(new java.awt.Dimension(50, 50));
        P_FILE.setPreferredSize(new java.awt.Dimension(50, 50));
        P_FILE.setLayout(new java.awt.GridLayout(5, 0, 2, 2));

        jPanel12.setMinimumSize(new java.awt.Dimension(50, 15));
        jPanel12.setPreferredSize(new java.awt.Dimension(50, 15));
        jPanel12.setLayout(new javax.swing.BoxLayout(jPanel12, javax.swing.BoxLayout.LINE_AXIS));

        jCheckBox5.setText("r");
        jCheckBox5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox5ActionPerformed(evt);
            }
        });
        jPanel12.add(jCheckBox5);

        jCheckBox4.setText("w");
        jCheckBox4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox4ActionPerformed(evt);
            }
        });
        jPanel12.add(jCheckBox4);
        jPanel12.add(jPanel41);

        jCheckBox17.setSelected(true);
        jCheckBox17.setText("EOF Stop");
        jCheckBox17.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox17ActionPerformed(evt);
            }
        });
        jPanel12.add(jCheckBox17);

        jCheckBox18.setSelected(true);
        jCheckBox18.setText("Clear");
        jCheckBox18.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jPanel12.add(jCheckBox18);

        P_FILE.add(jPanel12);

        jComboBox11.setEditable(true);
        jComboBox11.setMinimumSize(new java.awt.Dimension(50, 20));
        jComboBox11.setPreferredSize(new java.awt.Dimension(50, 20));
        jComboBox11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox11ActionPerformed(evt);
            }
        });
        P_FILE.add(jComboBox11);

        jPanel14.setMinimumSize(new java.awt.Dimension(50, 20));
        jPanel14.setPreferredSize(new java.awt.Dimension(50, 20));
        jPanel14.setLayout(new java.awt.BorderLayout(2, 2));

        jCB_ObjectEditor4.setEditable(true);
        jCB_ObjectEditor4.setEditing(false);
        jCB_ObjectEditor4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor4ActionPerformed(evt);
            }
        });
        jPanel14.add(jCB_ObjectEditor4, java.awt.BorderLayout.CENTER);

        jButton15.setText("...");
        jButton15.setToolTipText("Edit config");
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });
        jPanel14.add(jButton15, java.awt.BorderLayout.EAST);

        P_FILE.add(jPanel14);

        jCheckBox6.setText("xml2tree");
        jCheckBox6.setMaximumSize(new java.awt.Dimension(50, 23));
        jCheckBox6.setMinimumSize(new java.awt.Dimension(50, 23));
        jCheckBox6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox6ActionPerformed(evt);
            }
        });
        P_FILE.add(jCheckBox6);

        jPanel13.setMinimumSize(new java.awt.Dimension(50, 20));
        jPanel13.setPreferredSize(new java.awt.Dimension(50, 20));
        jPanel13.setLayout(new java.awt.GridLayout(1, 0, 2, 0));

        jLabel34.setText("User/Pwd : ");
        jLabel34.setEnabled(false);
        jPanel13.add(jLabel34);

        jTextField9.setToolTipText("user");
        jTextField9.setEnabled(false);
        jPanel13.add(jTextField9);

        jTextField10.setToolTipText("pwd");
        jTextField10.setEnabled(false);
        jPanel13.add(jTextField10);

        jComboBox10.setToolTipText("SystemType");
        jComboBox10.setEnabled(false);
        jPanel13.add(jComboBox10);

        P_FILE.add(jPanel13);

        jTabbedPane1.addTab("File", P_FILE);

        P_TERM.setEnabled(false);
        P_TERM.setLayout(new java.awt.GridLayout(7, 1));

        jComboBox20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox20ActionPerformed(evt);
            }
        });
        P_TERM.add(jComboBox20);

        jTabbedPane1.addTab("Term", P_TERM);

        P_DB.setEnabled(false);
        P_DB.setLayout(new java.awt.GridLayout(5, 0, 2, 2));

        jComboBox8.setToolTipText("Manage JDBC driver & URL");
        jComboBox8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox8ActionPerformed(evt);
            }
        });
        P_DB.add(jComboBox8);

        jPanel17.setLayout(new javax.swing.BoxLayout(jPanel17, javax.swing.BoxLayout.LINE_AXIS));

        jLabel66.setText("Schema : ");
        jPanel17.add(jLabel66);

        jTextField21.setToolTipText("dbfile or dbname");
        jTextField21.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField21KeyReleased(evt);
            }
        });
        jPanel17.add(jTextField21);

        jButton3.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel17.add(jButton3);

        P_DB.add(jPanel17);

        jPanel38.setLayout(new javax.swing.BoxLayout(jPanel38, javax.swing.BoxLayout.LINE_AXIS));

        jLabel65.setText("Host/port : ");
        jPanel38.add(jLabel65);

        jTextField23.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField23KeyReleased(evt);
            }
        });
        jPanel38.add(jTextField23);

        jTextField18.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField18KeyReleased(evt);
            }
        });
        jPanel38.add(jTextField18);

        P_DB.add(jPanel38);

        jPanel37.setLayout(new javax.swing.BoxLayout(jPanel37, javax.swing.BoxLayout.LINE_AXIS));

        jLabel37.setText("login/pwd : ");
        jPanel37.add(jLabel37);

        jTextField19.setToolTipText("User");
        jTextField19.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField19KeyReleased(evt);
            }
        });
        jPanel37.add(jTextField19);

        jTextField20.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField20KeyReleased(evt);
            }
        });
        jPanel37.add(jTextField20);

        P_DB.add(jPanel37);

        jPanel9.setLayout(new javax.swing.BoxLayout(jPanel9, javax.swing.BoxLayout.LINE_AXIS));

        jButton10.setToolTipText("DB=>XML");
        jButton10.setEnabled(false);
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jPanel9.add(jButton10);

        jButton13.setToolTipText("XML => DB");
        jButton13.setEnabled(false);
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });
        jPanel9.add(jButton13);
        jPanel9.add(jPanel42);

        jButton11.setToolTipText("Table");
        jButton11.setEnabled(false);
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jPanel9.add(jButton11);

        P_DB.add(jPanel9);

        jTabbedPane1.addTab("DB", P_DB);

        P_ETH.setToolTipText("see jpcap");
        P_ETH.setEnabled(false);
        P_ETH.setLayout(new java.awt.GridLayout(7, 0, 2, 2));

        jPanel18.setLayout(new java.awt.BorderLayout());

        jLabel62.setBackground(new java.awt.Color(102, 102, 102));
        jLabel62.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel62.setText("ETH");
        jLabel62.setOpaque(true);
        jPanel18.add(jLabel62, java.awt.BorderLayout.WEST);

        jButton6.setToolTipText("Update boxes");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jPanel18.add(jButton6, java.awt.BorderLayout.EAST);

        P_ETH.add(jPanel18);

        jComboBox9.setToolTipText("Ethernet devices");
        jComboBox9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox9ActionPerformed(evt);
            }
        });
        P_ETH.add(jComboBox9);

        jCB_ObjectEditor5.setEditable(true);
        jCB_ObjectEditor5.setEditing(false);
        P_ETH.add(jCB_ObjectEditor5);

        jPanel19.setLayout(new java.awt.BorderLayout());

        jLabel63.setText("Filter : ");
        jPanel19.add(jLabel63, java.awt.BorderLayout.WEST);

        jTextField27.setToolTipText("TCPDump filter expression");
        jTextField27.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField27ActionPerformed(evt);
            }
        });
        jTextField27.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField27KeyReleased(evt);
            }
        });
        jPanel19.add(jTextField27, java.awt.BorderLayout.CENTER);

        jButton4.setText("...");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel19.add(jButton4, java.awt.BorderLayout.EAST);

        P_ETH.add(jPanel19);

        jPanel20.setLayout(new javax.swing.BoxLayout(jPanel20, javax.swing.BoxLayout.LINE_AXIS));

        jLabel25.setText("Rx/Drp : ");
        jPanel20.add(jLabel25);

        jLabel31.setText("- rcved - ");
        jLabel31.setEnabled(false);
        jPanel20.add(jLabel31);

        jLabel7.setText("/");
        jPanel20.add(jLabel7);

        jLabel26.setText("- Drped -");
        jLabel26.setEnabled(false);
        jPanel20.add(jLabel26);
        jPanel20.add(jPanel43);

        jButton12.setText("...");
        jButton12.setEnabled(false);
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });
        jPanel20.add(jButton12);

        P_ETH.add(jPanel20);

        jPanel21.setLayout(new java.awt.BorderLayout());

        jCheckBox9.setText("NBlkMode");
        jCheckBox9.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox9.setEnabled(false);
        jCheckBox9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox9ActionPerformed(evt);
            }
        });
        jPanel21.add(jCheckBox9, java.awt.BorderLayout.WEST);

        jLabel32.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel32.setText("Read TO : ");
        jPanel21.add(jLabel32, java.awt.BorderLayout.CENTER);

        jSpinner3.setEnabled(false);
        jSpinner3.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinner3StateChanged(evt);
            }
        });
        jPanel21.add(jSpinner3, java.awt.BorderLayout.EAST);

        P_ETH.add(jPanel21);

        jPanel22.setLayout(new javax.swing.BoxLayout(jPanel22, javax.swing.BoxLayout.LINE_AXIS));

        jCheckBox20.setSelected(true);
        jCheckBox20.setText("promisc.");
        jCheckBox20.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox20ActionPerformed(evt);
            }
        });
        jPanel22.add(jCheckBox20);

        jComboBox16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox16ActionPerformed(evt);
            }
        });
        jPanel22.add(jComboBox16);

        P_ETH.add(jPanel22);

        jTabbedPane1.addTab("ETH", P_ETH);

        P_WIN.setLayout(new java.awt.GridLayout(4, 0));

        jPanel23.setLayout(new java.awt.BorderLayout(2, 2));

        jLabel17.setText("Mouse : ");
        jPanel23.add(jLabel17, java.awt.BorderLayout.PAGE_START);

        jToggleButton3.setToolTipText("muse evt in");
        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jPanel23.add(jToggleButton3, java.awt.BorderLayout.LINE_END);

        jSpinner5.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(10), Integer.valueOf(1), null, Integer.valueOf(1)));
        jSpinner5.setToolTipText("mouse frecq");
        jSpinner5.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinner5StateChanged(evt);
            }
        });
        jPanel23.add(jSpinner5, java.awt.BorderLayout.CENTER);

        jToggleButton4.setToolTipText("mouse evt out");
        jPanel23.add(jToggleButton4, java.awt.BorderLayout.LINE_START);

        P_WIN.add(jPanel23);

        jPanel24.setLayout(new java.awt.BorderLayout(2, 2));

        jLabel15.setText("Screen : ");
        jPanel24.add(jLabel15, java.awt.BorderLayout.PAGE_START);

        jToggleButton13.setToolTipText("screen evt out");
        jToggleButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton13ActionPerformed(evt);
            }
        });
        jPanel24.add(jToggleButton13, java.awt.BorderLayout.WEST);

        jSpinner6.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(100), Integer.valueOf(1), null, Integer.valueOf(1)));
        jSpinner6.setToolTipText("screen frecq");
        jSpinner6.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinner6StateChanged(evt);
            }
        });
        jPanel24.add(jSpinner6, java.awt.BorderLayout.CENTER);

        jToggleButton14.setToolTipText("screen in?");
        jToggleButton14.setEnabled(false);
        jPanel24.add(jToggleButton14, java.awt.BorderLayout.EAST);

        P_WIN.add(jPanel24);

        jPanel25.setLayout(new java.awt.BorderLayout(2, 2));

        jLabel27.setText("Keyboard : ");
        jPanel25.add(jLabel27, java.awt.BorderLayout.PAGE_START);

        jToggleButton11.setToolTipText("key out");
        jToggleButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton11ActionPerformed(evt);
            }
        });
        jPanel25.add(jToggleButton11, java.awt.BorderLayout.WEST);

        jComboBox12.setToolTipText("key layout");
        jComboBox12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox12ActionPerformed(evt);
            }
        });
        jPanel25.add(jComboBox12, java.awt.BorderLayout.CENTER);

        jToggleButton12.setToolTipText("key in");
        jToggleButton12.setEnabled(false);
        jToggleButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton12ActionPerformed(evt);
            }
        });
        jPanel25.add(jToggleButton12, java.awt.BorderLayout.EAST);

        P_WIN.add(jPanel25);

        jTabbedPane1.addTab("WIN", P_WIN);

        P_SYS.setEnabled(false);
        P_SYS.setLayout(new java.awt.GridLayout(6, 0, 2, 2));

        jPanel26.setMinimumSize(new java.awt.Dimension(50, 20));
        jPanel26.setPreferredSize(new java.awt.Dimension(50, 20));
        jPanel26.setLayout(new java.awt.BorderLayout());

        buttonGroup_SYS1.add(jRadioButton6);
        jRadioButton6.setText("Shell");
        jRadioButton6.setToolTipText("");
        jRadioButton6.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jRadioButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton6ActionPerformed(evt);
            }
        });
        jPanel26.add(jRadioButton6, java.awt.BorderLayout.EAST);

        buttonGroup_SYS1.add(jRadioButton11);
        jRadioButton11.setText("Std");
        jRadioButton11.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jRadioButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton11ActionPerformed(evt);
            }
        });
        jPanel26.add(jRadioButton11, java.awt.BorderLayout.WEST);

        P_SYS.add(jPanel26);

        jPanel30.setLayout(new javax.swing.BoxLayout(jPanel30, javax.swing.BoxLayout.LINE_AXIS));

        jCheckBox13.setText("DCX at end");
        jCheckBox13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox13ActionPerformed(evt);
            }
        });
        jPanel30.add(jCheckBox13);

        jCheckBox15.setText("in to process");
        jPanel30.add(jCheckBox15);

        P_SYS.add(jPanel30);

        jPanel31.setLayout(new javax.swing.BoxLayout(jPanel31, javax.swing.BoxLayout.LINE_AXIS));

        jCheckBox16.setText("output");
        jCheckBox16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox16ActionPerformed(evt);
            }
        });
        jPanel31.add(jCheckBox16);

        jCheckBox19.setText("exit int.");
        jCheckBox19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox19ActionPerformed(evt);
            }
        });
        jPanel31.add(jCheckBox19);

        jCheckBox14.setText("as byte[]");
        jCheckBox14.setToolTipText("SYS_exitasbyte");
        jCheckBox14.setEnabled(false);
        jPanel31.add(jCheckBox14);

        P_SYS.add(jPanel31);

        jPanel29.setLayout(new java.awt.GridLayout(3, 0, 2, 0));

        jLabel16.setText("cmde :");
        jLabel16.setToolTipText("cmde &result ( 0=> normal exit)");
        jPanel29.add(jLabel16);

        P_SYS.add(jPanel29);

        jPanel27.setLayout(new javax.swing.BoxLayout(jPanel27, javax.swing.BoxLayout.LINE_AXIS));

        jCheckBox12.setText("Library :");
        jCheckBox12.setToolTipText("SYS_lib");
        jCheckBox12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox12ActionPerformed(evt);
            }
        });
        jPanel27.add(jCheckBox12);

        jCB_ObjectEditor6.setToolTipText("SYS_lib");
        jCB_ObjectEditor6.setEditable(true);
        jCB_ObjectEditor6.setEnabled(false);
        jPanel27.add(jCB_ObjectEditor6);

        P_SYS.add(jPanel27);

        jPanel28.setLayout(new java.awt.BorderLayout());

        jLabel12.setText("0");
        jLabel12.setToolTipText("always >0");
        jPanel28.add(jLabel12, java.awt.BorderLayout.CENTER);

        jLabel11.setText("VM proc nb :");
        jPanel28.add(jLabel11, java.awt.BorderLayout.WEST);

        jCheckBox2.setSelected(true);
        jCheckBox2.setText("Check SM");
        jPanel28.add(jCheckBox2, java.awt.BorderLayout.EAST);

        P_SYS.add(jPanel28);

        jTabbedPane1.addTab("SYS", P_SYS);

        P_USB.setToolTipText("see jusb");
        P_USB.setEnabled(false);
        P_USB.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jCB_ObjectEditor3.setEditable(true);
        jCB_ObjectEditor3.setEditing(false);
        jCB_ObjectEditor3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor3ActionPerformed(evt);
            }
        });
        P_USB.add(jCB_ObjectEditor3);

        jTabbedPane1.addTab("USB", P_USB);

        P_SND.setToolTipText("see jusb");
        P_SND.setEnabled(false);
        P_SND.setLayout(new java.awt.GridLayout(2, 0));

        jPanel32.setLayout(new java.awt.BorderLayout());

        jLabel10.setText("INPUT");
        jPanel32.add(jLabel10, java.awt.BorderLayout.PAGE_START);

        jComboBox14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox14ActionPerformed(evt);
            }
        });
        jPanel32.add(jComboBox14, java.awt.BorderLayout.CENTER);

        jCB_ObjectEditor1.setEditable(true);
        jPanel32.add(jCB_ObjectEditor1, java.awt.BorderLayout.EAST);

        P_SND.add(jPanel32);

        jPanel33.setLayout(new java.awt.BorderLayout());

        jLabel13.setText("OUTPUT");
        jPanel33.add(jLabel13, java.awt.BorderLayout.PAGE_START);
        jPanel33.add(jComboBox15, java.awt.BorderLayout.CENTER);

        jCB_ObjectEditor7.setEditable(true);
        jPanel33.add(jCB_ObjectEditor7, java.awt.BorderLayout.EAST);

        P_SND.add(jPanel33);

        jTabbedPane1.addTab("SND", P_SND);

        P_LPT.setEnabled(false);
        P_LPT.setLayout(new java.awt.GridLayout(2, 0));

        jPanel35.setLayout(new java.awt.GridLayout(3, 4));

        jLabel22.setText("Port : ");
        jPanel35.add(jLabel22);

        jComboBox18.setToolTipText("Port");
        jPanel35.add(jComboBox18);

        jLabel24.setText("Mode : ");
        jPanel35.add(jLabel24);

        jComboBox17.setToolTipText("Mode");
        jPanel35.add(jComboBox17);

        jLabel18.setText("Framing : ");
        jPanel35.add(jLabel18);

        jTextField40.setToolTipText("Framong");
        jPanel35.add(jTextField40);

        jLabel20.setText("Trhld : ");
        jPanel35.add(jLabel20);

        jTextField41.setToolTipText("Threshold");
        jPanel35.add(jTextField41);

        jLabel21.setText("TO : ");
        jPanel35.add(jLabel21);

        jTextField42.setText("1000");
        jTextField42.setToolTipText("Timeout");
        jPanel35.add(jTextField42);

        jLabel23.setText("Sys Lbl :");
        jPanel35.add(jLabel23);

        jTextField43.setText("CX");
        jTextField43.setToolTipText("System Label");
        jPanel35.add(jTextField43);

        P_LPT.add(jPanel35);

        jLabel29.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel29.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel29.setText("PO");
        jLabel29.setToolTipText("PaperOut");
        jLabel29.setAlignmentX(0.5F);
        jLabel29.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 0));
        jLabel29.setOpaque(true);
        jPanel34.add(jLabel29);

        jLabel30.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel30.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel30.setText("PB");
        jLabel30.setToolTipText("PrinterBusy");
        jLabel30.setAlignmentX(0.5F);
        jLabel30.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 0));
        jLabel30.setOpaque(true);
        jPanel34.add(jLabel30);

        jLabel35.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel35.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel35.setText("PE");
        jLabel35.setToolTipText("PrinterError");
        jLabel35.setAlignmentX(0.5F);
        jLabel35.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 0));
        jLabel35.setOpaque(true);
        jPanel34.add(jLabel35);

        jLabel36.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel36.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel36.setText("PS");
        jLabel36.setToolTipText("PrinterSelected");
        jLabel36.setAlignmentX(0.5F);
        jLabel36.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 0));
        jLabel36.setOpaque(true);
        jPanel34.add(jLabel36);

        jLabel79.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel79.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel79.setText("PTO");
        jLabel79.setToolTipText("PrinterTimeout");
        jLabel79.setAlignmentX(0.5F);
        jLabel79.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 0));
        jLabel79.setOpaque(true);
        jPanel34.add(jLabel79);

        jCheckBox10.setText("AutoTransmit");
        jCheckBox10.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jPanel34.add(jCheckBox10);

        P_LPT.add(jPanel34);

        jTabbedPane1.addTab("LPT", P_LPT);

        P_MEM.setEnabled(false);
        P_MEM.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jLabel3.setText("Wire : ");
        P_MEM.add(jLabel3);

        jSpinner4.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(0), Integer.valueOf(0), null, Integer.valueOf(1)));
        jSpinner4.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSpinner4StateChanged(evt);
            }
        });
        P_MEM.add(jSpinner4);

        jTabbedPane1.addTab("MEM", P_MEM);

        P_MOM.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));
        P_MOM.add(jComboBox4);

        jTabbedPane1.addTab("MOM", P_MOM);

        P_JNA.setLayout(new java.awt.BorderLayout());

        jPanel36.setLayout(new java.awt.GridLayout(4, 0));

        jLabel19.setText("Library : ");
        jPanel36.add(jLabel19);

        jTextField3.setText("- DLL file - ");
        jPanel36.add(jTextField3);

        jLabel33.setText("Methode Name : ");
        jPanel36.add(jLabel33);

        jTextField2.setText("-MethodName-");
        jPanel36.add(jTextField2);

        jLabel38.setText("Result Type : ");
        jPanel36.add(jLabel38);

        jComboBox19.setModel(new javax.swing.DefaultComboBoxModel<String>(new String[] { "void", "boolean", "short", "int" }));
        jPanel36.add(jComboBox19);

        jLabel39.setText("Args :");
        jPanel36.add(jLabel39);

        jScrollPane1.setViewportView(jList1);

        jPanel36.add(jScrollPane1);

        P_JNA.add(jPanel36, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("JNA", P_JNA);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new java.awt.GridLayout(2, 1));

        jToggleButton6.setToolTipText("lockin");
        jToggleButton6.setAlignmentY(0.0F);
        jToggleButton6.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton6ActionPerformed(evt);
            }
        });
        jPanel3.add(jToggleButton6);

        jToggleButton7.setToolTipText("lockout");
        jToggleButton7.setAlignmentY(0.0F);
        jToggleButton7.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton7ActionPerformed(evt);
            }
        });
        jPanel3.add(jToggleButton7);

        jToggleButton15.setToolTipText("loop outside");
        jToggleButton15.setAlignmentY(0.0F);
        jToggleButton15.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton15ActionPerformed(evt);
            }
        });
        jPanel3.add(jToggleButton15);

        jToggleButton10.setToolTipText("Log stream");
        jToggleButton10.setAlignmentY(0.0F);
        jToggleButton10.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton10ActionPerformed(evt);
            }
        });
        jPanel3.add(jToggleButton10);

        jToggleButton9.setToolTipText("Echo");
        jToggleButton9.setAlignmentY(0.0F);
        jToggleButton9.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton9ActionPerformed(evt);
            }
        });
        jPanel3.add(jToggleButton9);

        jToggleButton8.setToolTipText("loop inside");
        jToggleButton8.setAlignmentY(0.0F);
        jToggleButton8.setMargin(new java.awt.Insets(1, 1, 1, 1));
        jToggleButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton8ActionPerformed(evt);
            }
        });
        jPanel3.add(jToggleButton8);

        jPanel1.add(jPanel3);

        jPanel4.setLayout(new java.awt.GridLayout(1, 0));

        jLabel84.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel84.setText("--:--:-- ----");
        jPanel4.add(jLabel84);

        jLabel85.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jLabel85.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel85.setText("--:--:-- ----");
        jPanel4.add(jLabel85);

        jPanel1.add(jPanel4);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBox11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox11ActionPerformed
        if (Parent.getFile_addr().equals(jComboBox11.getSelectedItem()) == false) {
            Parent.setFile_addr((java.io.File) jComboBox11.getSelectedItem());
        }
    }//GEN-LAST:event_jComboBox11ActionPerformed

    private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton15ActionPerformed
        java.io.File fi = TUtils.getUIreadFile(this, JFileChooser.FILES_ONLY, Parent.getFile_addr(), false);
        if (fi != null) {
            //should be parent. => but no return on reflect function
            setFile_addr(fi);
        }
    }//GEN-LAST:event_jButton15ActionPerformed

    private void jCheckBox17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox17ActionPerformed
        Parent.setFile_EOFstop(jCheckBox17.isSelected());
    }//GEN-LAST:event_jCheckBox17ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        if (Parent.getSlave() instanceof T_IP) {
            Object s = null;
            if (((T_IP) Parent.getSlave()).getSSLsocket() != null && s == null) {
                s = ((T_IP) Parent.getSlave()).getSSLsocket();
            }
            if (((T_IP) Parent.getSlave()).getTCPsocket() != null && s == null) {
                s = ((T_IP) Parent.getSlave()).getTCPsocket();
            }
            if (((T_IP) Parent.getSlave()).getUDPsocket() != null && s == null) {
                s = ((T_IP) Parent.getSlave()).getUDPsocket();
            }
            if (s != null) {
                F_Socket winsock = new F_Socket(Parent, s);
                if (((T_IP) Parent.getSlave()).getContext() != null) {
                    winsock.setcontxt(((T_IP) Parent.getSlave()).getContext());
                }
                winsock.setVisible(true);
            }
        }

    }//GEN-LAST:event_jButton7ActionPerformed

    private void jTextField18KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField18KeyReleased
        int port = -1;
        try {
            port = new Integer(jTextField18.getText());
        } catch (NumberFormatException ex) {
        }
        Parent.setDB_port(port);
    }//GEN-LAST:event_jTextField18KeyReleased

    private void jTextField19KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField19KeyReleased
        Parent.setDB_user(jTextField19.getText());
    }//GEN-LAST:event_jTextField19KeyReleased

    private void jTextField20KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField20KeyReleased
        Parent.setDB_pwd(jTextField20.getText());
    }//GEN-LAST:event_jTextField20KeyReleased

    private void jTextField23KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField23KeyReleased
        Parent.setDB_host(jTextField23.getText());
    }//GEN-LAST:event_jTextField23KeyReleased

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        display_ETH_msg();
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jTextField4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField4ActionPerformed
        if (Parent != null & jTextField4.getText().compareTo("" + Parent.getTCP_SoTO()) != 0) {
            Parent.setTCP_SoTO(jTextField4.getText());
        }
    }//GEN-LAST:event_jTextField4ActionPerformed

    private void jComboBox9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox9ActionPerformed
        Parent.setETH_interfaceidx(jComboBox9.getSelectedIndex());
    }//GEN-LAST:event_jComboBox9ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        //initETHbox(-1);
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jRadioButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton3ActionPerformed
        Parent.setTCP_Mode(evt.getActionCommand());
    }//GEN-LAST:event_jRadioButton3ActionPerformed

    private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
        Parent.setTCP_Mode(evt.getActionCommand());
    }//GEN-LAST:event_jRadioButton2ActionPerformed

    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        Parent.setTCP_Mode(evt.getActionCommand());
    }//GEN-LAST:event_jRadioButton1ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (jButton1.getText().compareTo("Stop") == 0) {
            Parent.CXstop();
        } else {
            Parent.CXstart();
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
        Parent.setTCP_nodelay(jCheckBox3.isSelected());
    }//GEN-LAST:event_jCheckBox3ActionPerformed

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        Parent.setTCP_keepalive(jCheckBox1.isSelected());
    }//GEN-LAST:event_jCheckBox1ActionPerformed

private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton12ActionPerformed
    if (Parent.getSlave() instanceof T_ETH) {
        jLabel31.setText("" + ((T_ETH) Parent.getSlave()).getrcv());
        jLabel26.setText("" + ((T_ETH) Parent.getSlave()).getdrp());
        jCheckBox9.setSelected(((T_ETH) Parent.getSlave()).isnonblocking());
        jSpinner3.setBackground(java.awt.Color.white);
        jSpinner3.setValue(((T_ETH) Parent.getSlave()).getrdTO());
        if (((T_ETH) Parent.getSlave()).geterrMsg() != null) {
            jSpinner3.setBackground(java.awt.Color.ORANGE);
            jSpinner3.setToolTipText(((T_ETH) Parent.getSlave()).geterrMsg());
        }
    }
}//GEN-LAST:event_jButton12ActionPerformed

private void jCheckBox9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox9ActionPerformed
    if (Parent.getSlave() instanceof T_ETH) {
        ((T_ETH) Parent.getSlave()).setnonblocking(jCheckBox9.isSelected());
    }
}//GEN-LAST:event_jCheckBox9ActionPerformed

private void jSpinner3StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSpinner3StateChanged
    if (Parent.getSlave() instanceof T_ETH) {
        ((T_ETH) Parent.getSlave()).setrdTO((Integer) jSpinner3.getValue());
    }

}//GEN-LAST:event_jSpinner3StateChanged

private void jTextField21KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField21KeyReleased
    Parent.setDB_name(jTextField21.getText());
}//GEN-LAST:event_jTextField21KeyReleased

private void jComboBox8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox8ActionPerformed
    jButton3.setVisible(jComboBox8.getSelectedItem().toString().startsWith("ODBC_"));
    Parent.setDB_name("");
    Parent.setDB_type(jComboBox8.getSelectedItem().toString());
}//GEN-LAST:event_jComboBox8ActionPerformed

private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
    Parent.DB2XML();
}//GEN-LAST:event_jButton10ActionPerformed

private void jCheckBox12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox12ActionPerformed
    jCB_ObjectEditor6.setEnabled(jCheckBox12.isSelected());
}//GEN-LAST:event_jCheckBox12ActionPerformed

private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
    javax.swing.JFrame t = new javax.swing.JFrame("SQLEditor");
    javax.swing.JPanel p = new com.jdcm.editors.P_SQLTables(Parent, null);
    t.add(p);
    t.setBounds(0, 0, p.getPreferredSize().width, p.getPreferredSize().height);
    t.setIconImage(TUtils.getImage("DBsimple.gif"));
    t.setVisible(true);
}//GEN-LAST:event_jButton11ActionPerformed

private void jCheckBox13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox13ActionPerformed
    Parent.setSYS_DCXatend(jCheckBox13.isSelected());
}//GEN-LAST:event_jCheckBox13ActionPerformed

private void jToggleButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton6ActionPerformed
    Parent.setlockin(jToggleButton6.isSelected());
}//GEN-LAST:event_jToggleButton6ActionPerformed

private void jToggleButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton8ActionPerformed
    Parent.setloopedin(jToggleButton8.isSelected());
}//GEN-LAST:event_jToggleButton8ActionPerformed

private void jToggleButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton9ActionPerformed
    Parent.setEcho(jToggleButton9.isSelected());
}//GEN-LAST:event_jToggleButton9ActionPerformed

private void jToggleButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton10ActionPerformed
    Parent.setlog(jToggleButton10.isSelected());
}//GEN-LAST:event_jToggleButton10ActionPerformed

private void jCB_ObjectEditor2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor2ActionPerformed
    Parent.setTCP_Addr((java.net.InetAddress) jCB_ObjectEditor2.getValue());
}//GEN-LAST:event_jCB_ObjectEditor2ActionPerformed

private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
    Parent.setTCP_Port(jTextField1.getText());
}//GEN-LAST:event_jTextField1ActionPerformed

private void jRadioButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton11ActionPerformed
    setSYS_stdinout(jRadioButton11.isSelected());
}//GEN-LAST:event_jRadioButton11ActionPerformed

private void jRadioButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton6ActionPerformed
    setSYS_stdinout(jRadioButton6.isSelected() == false);
}//GEN-LAST:event_jRadioButton6ActionPerformed

private void jTextField1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyReleased
    Parent.setTCP_Port(jTextField1.getText());
}//GEN-LAST:event_jTextField1KeyReleased

private void jTextField4KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField4KeyReleased
    if (Parent != null & jTextField4.getText().compareTo("" + Parent.getTCP_SoTO()) != 0) {
        Parent.setTCP_SoTO(jTextField4.getText());
    }
}//GEN-LAST:event_jTextField4KeyReleased

private void jToggleButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton7ActionPerformed
    Parent.setlockout(jToggleButton7.isSelected());
}//GEN-LAST:event_jToggleButton7ActionPerformed

private void jCheckBox20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox20ActionPerformed
    Parent.setETH_promiscuous(jCheckBox20.isSelected());
}//GEN-LAST:event_jCheckBox20ActionPerformed

private void jCheckBox6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox6ActionPerformed
    Parent.setFile_xml2tree(jCheckBox6.isSelected());
}//GEN-LAST:event_jCheckBox6ActionPerformed

private void jSpinner1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSpinner1StateChanged
    Parent.setTCP_Lmax((Integer) jSpinner1.getValue());
}//GEN-LAST:event_jSpinner1StateChanged

private void jCheckBox5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox5ActionPerformed
    Parent.setFile_read(jCheckBox5.isSelected());
}//GEN-LAST:event_jCheckBox5ActionPerformed

private void jCheckBox4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox4ActionPerformed
    Parent.setFile_write(jCheckBox4.isSelected());
}//GEN-LAST:event_jCheckBox4ActionPerformed

private void jCB_ObjectEditor4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor4ActionPerformed
    Parent.setFile_addr((java.io.File) jCB_ObjectEditor4.getValue());
}//GEN-LAST:event_jCB_ObjectEditor4ActionPerformed

private void jSpinner4StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSpinner4StateChanged
    setMEM_wire((Integer) jSpinner4.getValue());
}//GEN-LAST:event_jSpinner4StateChanged

private void formInternalFrameClosed(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameClosed
    Parent.CXend();
}//GEN-LAST:event_formInternalFrameClosed

private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
    Parent.setWIN_sendmousmv(jToggleButton3.isSelected());
    Parent.setWIN_sendmousmvTO((Integer) jSpinner5.getValue());
}//GEN-LAST:event_jToggleButton3ActionPerformed

private void jToggleButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton11ActionPerformed
    Parent.setWIN_sendkeys(jToggleButton11.isSelected());
}//GEN-LAST:event_jToggleButton11ActionPerformed

private void jToggleButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton12ActionPerformed
    Parent.setWIN_rcvkeys(jToggleButton12.isSelected());
}//GEN-LAST:event_jToggleButton12ActionPerformed

private void jToggleButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton13ActionPerformed
    Parent.setWIN_sendscreen(jToggleButton13.isSelected());
    Parent.setWIN_sendscreenTO((Integer) jSpinner6.getValue());
}//GEN-LAST:event_jToggleButton13ActionPerformed

private void jSpinner5StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSpinner5StateChanged
    Parent.setWIN_sendmousmvTO((Integer) jSpinner5.getValue());
}//GEN-LAST:event_jSpinner5StateChanged

private void jSpinner6StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSpinner6StateChanged
    Parent.setWIN_sendscreenTO((Integer) jSpinner6.getValue());
}//GEN-LAST:event_jSpinner6StateChanged

private void jComboBox12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox12ActionPerformed
    Parent.setWIN_kbd(jComboBox12.getSelectedItem().toString());
}//GEN-LAST:event_jComboBox12ActionPerformed

private void jCheckBox11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox11ActionPerformed
    Parent.setRS_DTR(jCheckBox11.isSelected());
}//GEN-LAST:event_jCheckBox11ActionPerformed

private void jCheckBox8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox8ActionPerformed
    Parent.setRS_RTS(jCheckBox8.isSelected());
}//GEN-LAST:event_jCheckBox8ActionPerformed

private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
    Parent.initRSbox();
}//GEN-LAST:event_jButton2ActionPerformed

private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
    Parent.setRS_lights(jToggleButton1.isSelected());
}//GEN-LAST:event_jToggleButton1ActionPerformed

private void jComboBox7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox7ActionPerformed
    Parent.setRS_FlowCtrl(jComboBox7.getSelectedItem().toString());
}//GEN-LAST:event_jComboBox7ActionPerformed

private void jComboBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox3ActionPerformed
    Parent.setRS_Stopbit(jComboBox3.getSelectedItem().toString());
}//GEN-LAST:event_jComboBox3ActionPerformed

private void jComboBox6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox6ActionPerformed
    Parent.setRS_Parity(jComboBox6.getSelectedItem().toString());
}//GEN-LAST:event_jComboBox6ActionPerformed

private void jComboBox5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox5ActionPerformed
    Parent.setRS_Databit(Integer.parseInt(jComboBox5.getSelectedItem().toString()));
}//GEN-LAST:event_jComboBox5ActionPerformed

private void jComboBox2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox2ActionPerformed
    Parent.setRS_Rate((Integer) jComboBox2.getSelectedItem());
}//GEN-LAST:event_jComboBox2ActionPerformed

private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
    Parent.setRS_Port(jComboBox1.getSelectedItem());
}//GEN-LAST:event_jComboBox1ActionPerformed

private void jComboBox14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox14ActionPerformed
}//GEN-LAST:event_jComboBox14ActionPerformed

private void jCB_ObjectEditor3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor3ActionPerformed
    this.setUSB_Element(jCB_ObjectEditor3.getValue());
}//GEN-LAST:event_jCB_ObjectEditor3ActionPerformed

private void jCheckBox16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox16ActionPerformed
    Parent.setSYS_sendOut(jCheckBox16.isSelected());
}//GEN-LAST:event_jCheckBox16ActionPerformed

private void jCheckBox19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox19ActionPerformed
    Parent.setSYS_sendExit(jCheckBox19.isSelected());

}//GEN-LAST:event_jCheckBox19ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        javax.swing.filechooser.FileFilter ff;
        if (Parent.getDB_type().compareTo("ODBC_mdb") == 0) {
            ch.setFileSelectionMode(javax.swing.JFileChooser.FILES_AND_DIRECTORIES);
            ff = TUtils.getFileFilter("MS-Access (*.mdb)", ".mdb");
            
        } else {
            ch.setFileSelectionMode(javax.swing.JFileChooser.FILES_ONLY);
            ff = TUtils.getFileFilter("MS-Excel (*.xls)", ".xls");
        }
        ch.addChoosableFileFilter(ff);
        ch.setFileFilter(ff);
        if (ch.showDialog(this, "Open") == javax.swing.JFileChooser.APPROVE_OPTION) {
            if (ch.getSelectedFile() != null) {
                Parent.setDB_name(ch.getSelectedFile().getAbsolutePath());
            }
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
        Parent.XML2DB();
    }//GEN-LAST:event_jButton13ActionPerformed

    private void jToggleButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton15ActionPerformed
        Parent.setloopedout(jToggleButton15.isSelected());
    }//GEN-LAST:event_jToggleButton15ActionPerformed

    private void jTextField27ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField27ActionPerformed
        Parent.setETH_filter(jTextField27.getText());
    }//GEN-LAST:event_jTextField27ActionPerformed

    private void jComboBox16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox16ActionPerformed
        Parent.setETH_Pack(jComboBox16.getSelectedItem().toString());
    }//GEN-LAST:event_jComboBox16ActionPerformed

    private void jTextField27KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField27KeyReleased
        Parent.setETH_filter(jTextField27.getText());
    }//GEN-LAST:event_jTextField27KeyReleased

    private void jComboBox20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox20ActionPerformed
        Parent.setTerm_Type(getTerm_Type());
    }//GEN-LAST:event_jComboBox20ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel P_DB;
    private javax.swing.JPanel P_ETH;
    private javax.swing.JPanel P_FILE;
    private javax.swing.JPanel P_IPL4;
    private javax.swing.JPanel P_JNA;
    private javax.swing.JPanel P_LPT;
    private javax.swing.JPanel P_MEM;
    private javax.swing.JPanel P_MOM;
    private javax.swing.JPanel P_SND;
    private javax.swing.JPanel P_SYS;
    private javax.swing.JPanel P_Serial;
    private javax.swing.JPanel P_TERM;
    private javax.swing.JPanel P_USB;
    private javax.swing.JPanel P_WIN;
    private javax.swing.ButtonGroup buttonGroup_File;
    private javax.swing.ButtonGroup buttonGroup_IP;
    private javax.swing.ButtonGroup buttonGroup_SYS1;
    private javax.swing.ButtonGroup buttonGroup_SYS2;
    private javax.swing.ButtonGroup buttonGroup_Term;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor2;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor3;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor4;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor5;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor6;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor7;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox10;
    private javax.swing.JCheckBox jCheckBox11;
    private javax.swing.JCheckBox jCheckBox12;
    private javax.swing.JCheckBox jCheckBox13;
    private javax.swing.JCheckBox jCheckBox14;
    private javax.swing.JCheckBox jCheckBox15;
    private javax.swing.JCheckBox jCheckBox16;
    private javax.swing.JCheckBox jCheckBox17;
    private javax.swing.JCheckBox jCheckBox18;
    private javax.swing.JCheckBox jCheckBox19;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox20;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox8;
    private javax.swing.JCheckBox jCheckBox9;
    private javax.swing.JComboBox<Object> jComboBox1;
    private javax.swing.JComboBox<String> jComboBox10;
    private javax.swing.JComboBox<String> jComboBox11;
    private javax.swing.JComboBox<String> jComboBox12;
    private javax.swing.JComboBox<javax.sound.sampled.Line> jComboBox14;
    private javax.swing.JComboBox<javax.sound.sampled.Line> jComboBox15;
    private javax.swing.JComboBox<String> jComboBox16;
    private javax.swing.JComboBox<String> jComboBox17;
    private javax.swing.JComboBox<Object> jComboBox18;
    private javax.swing.JComboBox<String> jComboBox19;
    private javax.swing.JComboBox<Integer> jComboBox2;
    private javax.swing.JComboBox<String> jComboBox20;
    private javax.swing.JComboBox<String> jComboBox3;
    private javax.swing.JComboBox<String> jComboBox4;
    private javax.swing.JComboBox<Integer> jComboBox5;
    private javax.swing.JComboBox<String> jComboBox6;
    private javax.swing.JComboBox<String> jComboBox7;
    private javax.swing.JComboBox<String> jComboBox8;
    private javax.swing.JComboBox<String> jComboBox9;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel49;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel62;
    private javax.swing.JLabel jLabel63;
    private javax.swing.JLabel jLabel65;
    private javax.swing.JLabel jLabel66;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel79;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel84;
    private javax.swing.JLabel jLabel85;
    private javax.swing.JLabel jLabel86;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JList<String> jList1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel24;
    private javax.swing.JPanel jPanel25;
    private javax.swing.JPanel jPanel26;
    private javax.swing.JPanel jPanel27;
    private javax.swing.JPanel jPanel28;
    private javax.swing.JPanel jPanel29;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel30;
    private javax.swing.JPanel jPanel31;
    private javax.swing.JPanel jPanel32;
    private javax.swing.JPanel jPanel33;
    private javax.swing.JPanel jPanel34;
    private javax.swing.JPanel jPanel35;
    private javax.swing.JPanel jPanel36;
    private javax.swing.JPanel jPanel37;
    private javax.swing.JPanel jPanel38;
    private javax.swing.JPanel jPanel39;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel40;
    private javax.swing.JPanel jPanel41;
    private javax.swing.JPanel jPanel42;
    private javax.swing.JPanel jPanel43;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton11;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JRadioButton jRadioButton6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JSpinner jSpinner3;
    private javax.swing.JSpinner jSpinner4;
    private javax.swing.JSpinner jSpinner5;
    private javax.swing.JSpinner jSpinner6;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField10;
    private javax.swing.JTextField jTextField18;
    private javax.swing.JTextField jTextField19;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField20;
    private javax.swing.JTextField jTextField21;
    private javax.swing.JTextField jTextField23;
    private javax.swing.JTextField jTextField27;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField40;
    private javax.swing.JTextField jTextField41;
    private javax.swing.JTextField jTextField42;
    private javax.swing.JTextField jTextField43;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField9;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton10;
    private javax.swing.JToggleButton jToggleButton11;
    private javax.swing.JToggleButton jToggleButton12;
    private javax.swing.JToggleButton jToggleButton13;
    private javax.swing.JToggleButton jToggleButton14;
    private javax.swing.JToggleButton jToggleButton15;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton4;
    private javax.swing.JToggleButton jToggleButton6;
    private javax.swing.JToggleButton jToggleButton7;
    private javax.swing.JToggleButton jToggleButton8;
    private javax.swing.JToggleButton jToggleButton9;
    // End of variables declaration//GEN-END:variables
}
