package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;

/**
 *All elements used by ports for input/output datas (T_IP/T_RS/T_...)
 * 
 * @author Marc GIBOIN
 */
public interface I_Slave {

    /**
     * Write a packet content on the interface
     * @param p the CXpacket to be write on interface
     * @return the number of byte writed
     */
    public int write(C_Packet p);

    /**
     * Start the slave<br>
     * @return 0 if slave is started correctly
     */
    public int sl_start();

    /**
     * Open the slave<br>
     * @return 0 if slave is Opened correctly
     */
    public int sl_open();

    /**
     * Stop the slave<br>
     * @return 0 if slave is Stoped correctly
     */
    public int sl_close();

    /**
     * Start the slave<br>
     * this often overwrite Thread start
     *
     */
    public void start();
}
