package com.jdcm.eltrx;

import com.jdcm.common.D_Utils;
import javax.swing.table.*;
import java.util.List;
import java.util.Enumeration;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.TimerTask;

/**
 * P_Com.java Created on 26 mai 2007, 22:24
 * 
 * Panel to display systems serial & Ethernet interfaces
 * @author Marc GIBOIN http://christophej.developpez.com/tutoriel/java/javacomm/
 */
public class P_ComEth extends javax.swing.JPanel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private ETH_Model modelEth;
    private COM_Model modelCom;
    private com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>();
    private D_Utils TUtils = new D_Utils();
    private java.util.Timer timer;

    /**
     * Creates new form F_COM
     */
    public P_ComEth() {
        initComponents();
        jButton1.setIcon(TUtils.getIcon("refresh.gif"));
        try {
            modelCom = new COM_Model();
            jTable2.setModel(modelCom);
        } catch (Throwable e) {
            jTable2.setEnabled(false);
        }
        try {
            modelEth = new ETH_Model();
            jTable1.setModel(modelEth);
            java.util.List<String> editTitles = java.util.Arrays.asList(new String[]{"IPAddr", "Hwd_Addr"});
            for (int i = 0; i < jTable1.getColumnCount(); i++) {
                jTable1.getColumnModel().getColumn(i).setCellRenderer(render);
                if (editTitles.contains(jTable1.getColumnModel().getColumn(i).getIdentifier().toString())) {
                    jTable1.getColumnModel().getColumn(i).setCellEditor(editor);
                } else {
                    jTable1.getColumnModel().getColumn(i).setCellEditor(null);
                }
            }
        } catch (Throwable e) {
            jTable1.setEnabled(false);
        }
        setTimer(true);
    }

    private void setTimer(boolean bool) {
        if (jToggleButton1.isSelected() != bool) {
            jToggleButton1.setSelected(bool);
        }
        if (bool && timer == null) {
            timer = new java.util.Timer();
            timer.schedule(new TimerTask() {

                @Override
                public void run() {
                    repaint();
                }
            }, 50, 200);
        } else {
            if (timer != null) {
                timer.purge();
                timer.cancel();
            }
            timer = null;
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jToggleButton1 = new javax.swing.JToggleButton();

        setToolTipText("java.net.NetworkInterface.getNetworkInterfaces();");
        setLayout(new java.awt.BorderLayout());

        jSplitPane1.setDividerLocation(150);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ETH Ports"
            }
        ));
        jTable1.setToolTipText("");
        jScrollPane1.setViewportView(jTable1);

        jSplitPane1.setTopComponent(jScrollPane1);

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "COM Ports"
            }
        ));
        jScrollPane2.setViewportView(jTable2);

        jSplitPane1.setRightComponent(jScrollPane2);

        add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jToolBar1.setRollover(true);

        jButton1.setBorderPainted(false);
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jToggleButton1.setFocusable(false);
        jToggleButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        add(jToolBar1, java.awt.BorderLayout.PAGE_START);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (modelEth != null) {
            modelEth.updateComs();
        }
        if (modelCom != null) {
            modelCom.updateComs();
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed

        setTimer(jToggleButton1.isSelected());

    }//GEN-LAST:event_jToggleButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
}

class ETH_Model extends AbstractTableModel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final List<NetworkInterface> eth;
    private final String[] columnNames = {"N", "DisplayName", "Name", "IPAddr", "Hwd_Addr", "MTU", "Mother", "Loopback", "UP", "PPP", "suportMcast", "Virtual"};
    private final java.util.List<javax.swing.ComboBoxModel<java.net.InetAddress>> addressesList = new java.util.ArrayList<>();

    public ETH_Model() {
        eth = new java.util.ArrayList<>();
        updateComs();
    }

    public final void updateComs() {
        NetworkInterface neth;
        Enumeration<NetworkInterface> ent = null;
        eth.clear();
        try {
            ent = NetworkInterface.getNetworkInterfaces();
        } catch (java.net.SocketException ex) {
        }
        while (ent.hasMoreElements()) {
            neth = ent.nextElement();
            if (!isstored(neth.getName())) {
                eth.add(neth);
                Enumeration<NetworkInterface> sent = neth.getSubInterfaces();
                addressesList.add(getadressesComboModel(neth));
                if (sent != null) {
                    while (sent.hasMoreElements()) {
                        NetworkInterface sneth = sent.nextElement();
                        eth.add(sneth);
                        addressesList.add(getadressesComboModel(sneth));
                    }
                }
            }
//TO DO... what ???
        }
        this.fireTableDataChanged();
    }

    private javax.swing.DefaultComboBoxModel<java.net.InetAddress> getadressesComboModel(NetworkInterface neth) {
        List<java.net.InetAddress> addrs = new java.util.ArrayList<>();
        Enumeration<java.net.InetAddress> saddr = neth.getInetAddresses();
        if (saddr != null) {
            while (saddr.hasMoreElements()) {
                addrs.add(saddr.nextElement());
            }
            return new javax.swing.DefaultComboBoxModel<>(addrs.toArray(new java.net.InetAddress[]{}));
        } else {
            return (new javax.swing.DefaultComboBoxModel<>());
        }
    }

    private boolean isstored(String portlbl) {
        for (int i = 0; i < eth.size(); i++) {
            if (eth.get(i).getName().compareTo(portlbl) == 0) {
                return true;
            }
        }
        return false;
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;

    }

    @Override
    protected void finalize() throws Throwable {
        super.finalize();
    }

    @Override
    public int getRowCount() {
        return eth.size();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        if (aColumn == 0) {
            return "" + aRow;
        }
        NetworkInterface Port = eth.get(aRow);
        if (aColumn == 1) {
            return Port.getDisplayName();
        }
        if (aColumn == 2) {
            return Port.getName();
        }
        if (aColumn == 3) {
            return addressesList.get(aRow);
            // return Port.getInetAddresses();
        }
        if (aColumn == 4) {
            try {
                return new com.jdcm.common.O_MACaddress(Port.getHardwareAddress());
            } catch (Exception e) {
                return "=>" + e.getMessage();
            }
        }
        if (aColumn == 5) {
            try {
                return Port.getMTU();
            } catch (SocketException e) {
                return "=>" + e.getMessage();
            }
        }
        if (aColumn == 6) {
            if (Port.getParent() != null) {
                return Port.getParent().getName();
            } else {
                return "N/A";
            }
        }
        if (aColumn == 7) {
            try {
                return Port.isLoopback();
            } catch (SocketException e) {
                return "=>" + e.getMessage();
            }
        }
        if (aColumn == 8) {
            try {
                return Port.isUp();
            } catch (SocketException e) {
                return "=>" + e.getMessage();
            }
        }
        if (aColumn == 9) {
            try {
                return Port.isPointToPoint();
            } catch (SocketException e) {
                return "=>" + e.getMessage();
            }
        }
        if (aColumn == 10) {
            try {
                return Port.supportsMulticast();
            } catch (SocketException e) {
                return "=>" + e.getMessage();
            }
        }
        if (aColumn == 11) {
            return Port.isVirtual();
        }
        return null;
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return true;
        // false;
    }

    @Override
    public Class<?> getColumnClass(int column) {
        return String.class;

    }
}

class COM_Model extends AbstractTableModel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final List<gnu.io.CommPortIdentifier> com;
    private final String[] columnNames = {"N", "Type", "Label", "isOwned", "Owner"};

    public COM_Model() {
        com = new java.util.ArrayList<>();
        updateComs();
    }

    public final void updateComs() {
        gnu.io.CommPortIdentifier portId;
        Enumeration<?> en = gnu.io.CommPortIdentifier.getPortIdentifiers();
        com.clear();
        // iterate through the ports.
        while (en.hasMoreElements()) {
            portId = (gnu.io.CommPortIdentifier) en.nextElement();
            if (isStored(portId.getName()) == false) {
                com.add(portId);
            }
        }
        this.fireTableDataChanged();
    }

    private boolean isStored(String portlbl) {
        for (int i = 0; i < com.size(); i++) {
            if (com.get(i).getName().compareTo(portlbl) == 0) {
                return true;
            }
        }
        return false;
    }

    @Override
    public String getColumnName(int column) {
        return columnNames[column];
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    protected void finalize() throws Throwable {
        super.finalize();
    }

    @Override
    public int getRowCount() {
        return com.size();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        if (aColumn == 0) {
            return "" + aRow;
        }
        gnu.io.CommPortIdentifier Port = com.get(aRow);
        if (aColumn == 1) {
            if (Port.getPortType() == gnu.io.CommPortIdentifier.PORT_PARALLEL) {
                return "PARALLELE";
            }
            if (Port.getPortType() == gnu.io.CommPortIdentifier.PORT_SERIAL) {
                return "SERIAL";
            }
            if (Port.getPortType() == gnu.io.CommPortIdentifier.PORT_I2C) {
                return "I2C";
            }
            if (Port.getPortType() == gnu.io.CommPortIdentifier.PORT_RAW) {
                return "RAW";
            }
            if (Port.getPortType() == gnu.io.CommPortIdentifier.PORT_RS485) {
                return "RS485";
            }
        }
        if (aColumn == 2) {
            return Port.getName();
        }
        if (aColumn == 3) {
            //TODO :  not working using RXTX-2.1-7 & Java7
            if (Port.isCurrentlyOwned()) {
                return "busy";
            } else {
                return "free";
            }
        }
        if (aColumn == 4) {
            //TODO :  not working using RXTX-2.1-7 & Java7
            return Port.getCurrentOwner();
        }
        return null;
    }

    @Override
    public boolean isCellEditable(int row, int column) {

        return false;
    }

    @Override
    public Class<?> getColumnClass(int column) {
        return String.class;

    }
}
