package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;
import java.net.*;
import javax.net.ssl.*;
import java.security.KeyStore;
import java.io.*;
import java.security.*;
import java.security.cert.CertificateException;
import java.util.List;

/**
 * P_Threads.java Created on 10 juillet 2006, 22:16
 *
 * Slave used by IP Port chacked IPV4 & IPV6
 *
 * @author Marc GIBOIN no way to manage IP traffic class & local port =>see
 * ETH&winpcap
 */
public class T_IP extends Thread implements I_Slave {

    private final C_Port Parent;
    private final com.jdcm.common.D_Utils util;
    private final D_Debug TDeb;
    private final List<C_Port> TCPClients;// list of TCP client index of a listener  for MAX connextions
    private final int MAX_DATAIN = 65451; // max UDP datagram lenght??? Pb with bloking methode??

    private Socket clientSocket = null;
    private SSLSocket SSLsock = null;
    private SSLContext ctx = null;
    private SSLServerSocket SSLserverSocket = null;
    private DatagramSocket socketUDP;
    private DatagramPacket UDPtosend = null;

    //Use List instead of limited dataaray !!!
    /**
     * Creates a new instance of P_Threads
     *
     * @param P The port supporting this slave
     */
    public T_IP(C_Port P) {
        util = new com.jdcm.common.D_Utils();
        Parent = P;
        TDeb = new D_Debug("T-IP [" + Parent.getIndex() + "] : ");
        TDeb.setconsole(Parent.getConsole());
        TCPClients = new java.util.ArrayList<>();
        setName(this.getClass().getSimpleName() + ":" + getName());
        //No_TCPclient=-1;
    }

    /**
     * Start the slave<br> - set boxes editables or not<br> - if listner, lock
     * in/out & set client box<br>
     *
     * @return 0 if slave is started correctly
     */
    @Override
    public int sl_start() {
        if (Parent.getTCP_Mode().startsWith("TCP_L")) {
            Parent.DisplayLclientNumber();
        }
        return 0;
    }

    /**
     * Open the slave<br>
     *
     * @return 0 if slave is Opened correctly
     */
    @Override
    public int sl_open() {
        if (Parent.getTCP_Mode().startsWith("TCP_C") == false) {
            //for Listner & UDP
            return 0;
        }
        // TCP connect
        Parent.setscaned();
        // if slave is not runnning=> stop waiting
        // TODO : HERE SHOULD BE A THREAD TO AVOID STOP OF MAIN() = > see openbyslave()
        // added !isconnect() later!!
        while ((getTCPsocket() == null || !getTCPsocket().isConnected()) && isAlive()) {
            try {
                sleep(1);
            } catch (InterruptedException ex) {
            }
        }
        if (getTCPsocket() == null) {
            Parent.CXerror("No valid TCP socket");
            return -1;
        }
        try {
            // on ouvre les flux des connect
            Parent.setin(getTCPsocket().getInputStream());
            Parent.setout(getTCPsocket().getOutputStream());
        } catch (IOException e) {
            Parent.CXerror("TCP Couldn't get I/O for TCP stream =>" + e.getMessage());
            return -1;
        }
        return 0;
    }

    /**
     * Close the TCP / UDP socket <br>
     *
     * @return 0 if slave is Stoped correctly
     */
    @Override
    public int sl_close() {
        TDeb.wri("Aking for close socket");

        if (socketUDP != null) {
            TDeb.wri("UDP : Stopping Reader");
            socketUDP.close();
        }
        socketUDP = null;
        try {
            if (getTCPsocket() != null) {
                TDeb.wri("TCP : Stopping socket : " + getTCPsocket().getInetAddress() + " tcp#" + getTCPsocket().getPort());
                getTCPsocket().close();
            }
            setTCPsocket(null);
            if (SSLsock != null) {
                SSLsock.close();
                SSLsock = null;
            }
            if (SSLserverSocket != null) {
                SSLserverSocket.close();
                SSLserverSocket = null;
            }
        } catch (IOException ex) {
            TDeb.wri("TCP : Pb closing TCP socket =>" + ex.getMessage());
            // ex.printStackTrace();
        }
        return 0;
    }

    public void addTCPclient(C_Port p) {
        TCPClients.add(p);
    }

    public void removeTCPclient(int closedclient) {
        try {

            if (TCPClients.remove(getTCPclient(closedclient))) {
                //(long) closedclient)) {// long to avoid int=> idx
                // Parent.DisplayLclientNumber();
            } else {
                TDeb.wri("" + getTCPclient(closedclient).getCMDName() + " seems absent of TCP client Listing");
            }
        } catch (Exception ex) {
            TDeb.wri("client TCP not found : " + closedclient + " =>" + ex.getMessage());
        }
    }

    public boolean removeTCPclient(C_Port port) {
        boolean res = true;
        TCPClients.remove(port);
        Parent.DisplayLclientNumber();
        return res;
    }

    public List<C_Port> getTCPclients() {
        return TCPClients;
    }

    public C_Port getTCPclient(int idx) throws Exception {
        if (idx < TCPClients.size()) {
            return TCPClients.get(idx);
        } else {
            throw new Exception("client not found");
        }
    }

    public SSLContext getContext() {
        return ctx;
    }

    public void setTCPsocket(Socket sock) {
        this.clientSocket = sock;
    }

    public Socket getTCPsocket() {
        return this.clientSocket;
    }

    public SSLSocket getSSLsocket() {
        return this.SSLsock;
    }

    public DatagramSocket getUDPsocket() {
        return this.socketUDP;
    }

    public int StartUDP() {
        //TDeb.wri("UDP : Try to open port : "+Parent.getTCP_Port()+" for reading");
        if (Parent.getTCP_Addr().isMulticastAddress()) {
            try {
                try {
                    MulticastSocket socket = new MulticastSocket(Parent.getTCP_Port()); // must bind receive side
                    socket.joinGroup(Parent.getTCP_Addr());
                    socketUDP = socket;
                    TDeb.wri("Multicast :Port joined to :" + Parent.getTCP_Addr().toString());
                } catch (IOException ex) {
                    TDeb.wri("Pb creating Multicast socket =>" + ex.getMessage());
                    socketUDP = null;
                }
            } catch (SecurityException ex) {
                TDeb.wri("Pb creating Multicast socket for Security =>" + ex.getMessage());
                socketUDP = null;
            }
            return 0;
        }
        try {
            socketUDP = new java.net.DatagramSocket(Parent.getTCP_Port());
        } catch (SocketException ex) {
            TDeb.wri("UDP Could not open Reading port (already used)=>" + ex.getMessage());
            socketUDP = null;
            return -1;
        }
        if (socketUDP != null) {
            try {
                socketUDP.setSoTimeout(Parent.getTCP_SoTO());
                try {
                    socketUDP.setTrafficClass(Parent.getTCP_class());
                } catch (SocketException ex) {
                    TDeb.wri("UDP Coudn't fix Traffic Class =>" + ex.getMessage());
                }
            } catch (SocketException ex) {
                TDeb.wri("UDP Coudn't fix SoTimeout =>" + ex.getMessage());
                socketUDP = null;
                return -1;
            }
        }
        return 0;
    }

    private int readUDP() {
        byte[] UDPd = new byte[MAX_DATAIN];
        byte[] donnees;
        TDeb.wri("UDP : Start reading ");
        while (Parent.isslrunning()) {
            if (socketUDP != null) {
                while (Parent.isslreading()) {
                    boolean recv = false;
                    DatagramPacket recept = new DatagramPacket(UDPd, UDPd.length);
                    // bloquant : .receive()

                    try {
                        try {
                            socketUDP.receive(recept);
                            recv = true;
                        } catch (SocketTimeoutException ex) {
                            TDeb.wri("UDP :receive =>" + ex.getMessage());
                        }
                    } catch (IOException ex) {
                        TDeb.wri("UDP : Pb I/O while reading =>" + ex.getMessage());
                        if (Parent.isslreading()) {
                            return -1;
                        }
                    }
                    //  pool.ntp.org udp#123
                    if (UDPtosend != null) {
                        try {
                            try {
                                try {
                                    socketUDP.send(UDPtosend);
                                    TDeb.wri("UDP : Sended byte to :" + UDPtosend.getAddress() + "#" + UDPtosend.getPort() + " /" + UDPtosend.getLength());
                                    UDPtosend = null;
                                } catch (IOException ex) {
                                    TDeb.wri("UDP : Pb IO writing =>" + ex.getMessage());
                                    return -1;
                                }
                            } catch (SecurityException ex) {
                                TDeb.wri("UDP : Pb Security writing =>" + ex.getMessage());
                                return -1;
                            }
                            //} catch (PortUnreachableException ex) { TDeb.wri("UDP : Pb Port Unreachable writing ["+ex.getMessage()+"]");   return -1;}
                        } catch (java.nio.channels.IllegalBlockingModeException ex) {
                            TDeb.wri("UDP : Pb Chanels writing =>" + ex.getMessage());
                            return -1;
                        }

                    }
                    if (recv) {
                        TDeb.wri("UDP reception from " + recept.getAddress().getHostName() + "#" + recept.getPort() + "/" + recept.getLength());
                        donnees = new byte[recept.getLength()];
                        /*
                         * for (int i = 0; i < recept.getLength(); i++) {
                         * donnees[i] = recept.getData()[i];
                         }
                         */
                        System.arraycopy(recept.getData(), 0, donnees, 0, recept.getLength());
                        Parent.read_in(new C_Packet(donnees, Parent));
                    }
                }
            }
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                TDeb.wri("sleep error: =>" + ex.getMessage());
                //  ex.printStackTrace();
            }
        }
        return 0;
    }

    public int createUDPD(byte[] donnees) {
        if (donnees == null) {
            return 0;
        }
        InetAddress adresse;
        try {
            adresse = Parent.getTCP_Addr();
            //  UDPtosend = new DatagramPacket(donnees, donnees.length, adresse, Parent.getTCP_Port());
            UDPtosend = new java.net.DatagramPacket(donnees, donnees.length, adresse, Parent.getTCP_Port());
        } catch (Exception ex) {
            TDeb.wri("UDP : Pb creating datagram =>" + ex.getMessage());
            // ex.printStackTrace();
            return -1;
        }
        return 0;
    }

    private int TCP_listen() {
        TCPClients.clear();
        ServerSocket serverSocket = null;
        SSLserverSocket = null;
        SSLsock = null;
        int Lport = Parent.getTCP_Port();
        boolean new_socket;
        if (Parent.getTCP_Addr().isMulticastAddress()) {
            TDeb.wri("Multicast:" + Parent.getTCP_Addr().toString() + " should be open as UDP");
            return -1;
        }
        /*
         * java.lang.SecurityManager sm =new java.lang.SecurityManager(){
         * checkAccept(){... } // CHECK ADRESSES... SM should be in main, is
         * owned by System };
         System.setSecurityManager(sm);
         */
        while (Parent.isslrunning()) {
            try {
                sleep(1);
            } catch (InterruptedException ex) {
                TDeb.wri("sleep error =>" + ex.getMessage());
                //  ex.printStackTrace();
            }
            if (serverSocket == null) {
                try {
                    InetAddress bindaddr = Parent.getTCP_Addr();
                    // if (Parent.getTCP_Addr()!=null){bindaddr=InetAddress.getByName(Parent.getTCP_Addr());}
                    if (bindaddr.getHostAddress().compareTo("0.0.0.0") == 0) {
                        bindaddr = null;
                    }
                    if (Parent.isSSL_Enabled()) {
                        SSLServerSocketFactory SSLfact;

                        ctx = getSSLcontext();
                        if (ctx == null) {
                            return -1;
                        }
                        SSLfact = ctx.getServerSocketFactory();

                        serverSocket = SSLfact.createServerSocket(Lport, -1, bindaddr);
                        TDeb.wri("TCP SSL =>Listening on port# " + Lport + "...");
                        SSLserverSocket = (SSLServerSocket) serverSocket;
                        SSLserverSocket.setNeedClientAuth(Parent.isSSL_CltAuth());
                        SSLserverSocket.setReuseAddress(Parent.isTCP_ReuseAddr());
                    } else {
                        serverSocket = new ServerSocket(Lport, -1, bindaddr);
                        //The backlog number (hear -1 disable) is the number of incoming connections that will be queued up while your server is busy accepting earlier connections.

                        TDeb.wri("TCP =>Continue listening on port# " + Lport + "...");
                    }
                } catch (IOException e) {
                    TDeb.wri("TCP : Could not listen on port# " + Lport + " /SSL: " + Parent.isSSL_Enabled() + " =>" + e.getMessage());
                    return -1;
                }
            }
            if (serverSocket == null) {
                return -1;
            }
            while (Parent.isslrunning() && serverSocket != null) {
                try {
                    serverSocket.setSoTimeout(Parent.getTCP_SoTO());
                } catch (SocketException e) {
                    TDeb.wri("TCP : ListenSocket exception SoTO =>" + e.getMessage());
                    return -1;
                }
                new_socket = true;
                try {
                    try {
                        try {
                            if (Parent.isSSL_Enabled() && SSLserverSocket != null) {
                                clientSocket = (SSLSocket) SSLserverSocket.accept();
                                SSLsock = (SSLSocket) clientSocket;
                                SSLsock.setNeedClientAuth(Parent.isSSL_CltAuth());
                                SSLsock.setWantClientAuth(Parent.isSSL_CltAuth());
                                SSLsock.setUseClientMode(false);
                                SSLsock.startHandshake();
                            } else {
                                clientSocket = serverSocket.accept();
                            }
                            TDeb.wri("TCP => listner accept connection on tcp#" + Lport + ".from (" + getTCPsocket().getInetAddress() + "," + getTCPsocket().getPort() + ")+SSL :" + Parent.isSSL_Enabled());
                        } catch (SocketTimeoutException ex) {
                            // TDeb.wri("TCP => NO new sowket");
                            new_socket = false;
                        }
                    } catch (SecurityException ex) {
                        TDeb.wri("TCP : ListenSocket SECURITY Exception =>" + ex.getMessage());
                        return -1;
                    }

                } catch (IOException e) {
                    TDeb.wri("TCP : ListenSocket exception during accept() =>" + e.getMessage());
                    // debug rapide...
                    if (e.getMessage().compareTo("No available certificate or key corresponds to the SSL cipher suites which are enabled.") == 0) {
                        return -1;
                    }
                    if (Parent.getcxstatus().compareTo("stopping") == 0) {
                        return 0;
                    } else {
                        new_socket = false;
                        //?? return -1;
                    }
                }
                if (new_socket) {
                    try {
                        if (Parent.getTCP_ioBuffers().x > 0) {
                            TDeb.wri("TCP =>set receive buffer size: " + Parent.getTCP_ioBuffers().x);
                            clientSocket.setReceiveBufferSize(Parent.getTCP_ioBuffers().x);
                        }
                        if (Parent.getTCP_ioBuffers().y > 0) {
                            TDeb.wri("TCP =>set sending buffer size: " + Parent.getTCP_ioBuffers().y);
                            clientSocket.setSendBufferSize(Parent.getTCP_ioBuffers().y);
                        }
                    } catch (SocketException ex) {
                        TDeb.wri("TCP =>PB durring setting buffer size: =>" + ex.getMessage());
                    }
                    if (Parent.getTCP_Lmax() < 0 || getTCPclients().size() < Parent.getTCP_Lmax()) {
                        // create the child
                        TDeb.wri("TCP  => Listener asking for child");
                        if (SSLsock != null) {
                            TDeb.wri("Created Socket : " + SSLsock.toString());
                            TDeb.wri("Listen SSL session portocol: " + SSLsock.getSession().getProtocol());
                            TDeb.wri("Listen socket SSL Client Mode: " + SSLsock.getUseClientMode());
                            TDeb.wri("Listen socket SSL need Client Auth: " + SSLsock.getNeedClientAuth());
                        }
                        Parent.addTCPclient();
                        TDeb.wri("Client created");
                        Parent.DisplayLclientNumber();
                    } else {
                        try {
                            //A REVOIR
                            clientSocket.close();
                            clientSocket = null;
                            //SSLserverSocket.close();SSLserverSocket=null;
                            TDeb.wri("TCP  => Listener stop child beacause client limit reach : " + Parent.getTCP_Lmax());
                        } catch (IOException ex) {
                            TDeb.wri("sleep error: " + ex.getMessage());
                            //  ex.printStackTrace();
                        }
                    }
                }
            }
        }
        TDeb.wri("TCP =>Listner Stopped...");
        try {
            if (serverSocket != null) {
                serverSocket.close();
            }
        } catch (IOException ex) {
            TDeb.wri("sleep error: " + ex.getMessage());
            // ex.printStackTrace();
        }
        return 0;
    }

    private int TCP_connect() {
        //http://java.sun.com/j2se/1.5.0/docs/guide/security/jsse/JSSERefGuide.html;http://doc.java.sun.com/DocWeb/about.html
        //if non bloking I/O => ssl engine & Socketshannel
        // if SSLtunnel => dotunnelhandshake()...
        SSLsock = null;
        InetAddress Cx_Addr = Parent.getTCP_Addr();
        int Cx_Port = Parent.getTCP_Port();
        if (getTCPsocket() != null) {
            return 0;
        }
        try {
            //ouverture du client
            if (Parent.isSSL_Enabled()) {
                SSLSocketFactory SSLfact;
                if (Parent.isSSL_SrvAuth()) {
                    ctx = getSSLcontext();
                    if (ctx == null) {
                        return -1;
                    }
                    SSLfact = ctx.getSocketFactory();

                } else {
                    SSLfact = (SSLSocketFactory) SSLSocketFactory.getDefault();
                }
                TDeb.wri("TCP SSL =>Connection to (" + Cx_Addr + "," + Cx_Port + ")...");
                SSLsock = (SSLSocket) SSLfact.createSocket(Cx_Addr, Cx_Port);
                SSLsock.setUseClientMode(true);
                SSLsock.startHandshake();
                clientSocket = (Socket) SSLsock;
            } else {
                TDeb.wri("TCP =>Connection to (" + Cx_Addr + "," + Cx_Port + ")...");
                clientSocket = new Socket();
                if (Parent.getTCP_ioBuffers().x > 0) {
                    TDeb.wri("TCP =>set receive buffer size: " + Parent.getTCP_ioBuffers().x);
                    clientSocket.setReceiveBufferSize(Parent.getTCP_ioBuffers().x);
                }
                if (Parent.getTCP_ioBuffers().y > 0) {
                    TDeb.wri("TCP =>set sending buffer size: " + Parent.getTCP_ioBuffers().y);
                    clientSocket.setSendBufferSize(Parent.getTCP_ioBuffers().y);
                }
                clientSocket.connect(new java.net.InetSocketAddress(Cx_Addr, Cx_Port));
            }

        } catch (UnknownHostException e) {
            TDeb.wri("TCP Don't know about host: " + Cx_Addr);
            return -1;
        } catch (SecurityException ex) {
            TDeb.wri("TCP : ListenSocket SECURITY Exception =>" + ex.getMessage());
            return -1;
        } catch (IOException e) {
            String ssl = "";
            if (Parent.isSSL_Enabled()) {
                ssl = "with SSL";
            }
            TDeb.wri("TCP Couldn't get socket for connect to :(" + Cx_Addr + "#" + Cx_Port + ")" + ssl + " =>" + e.getMessage());
            return -1;
        }
        if (updateTCPsocket() < 0) {
            Parent.CXerror("Error during TCP Update");
            return -1;
        }
        if (SSLsock != null) {
            TDeb.wri("Created Socket : " + SSLsock.toString());
            TDeb.wri("Connect SSL session portocol: " + SSLsock.getSession().getProtocol());
            TDeb.wri("Connect socket SSL Client Mode: " + SSLsock.getUseClientMode());
            TDeb.wri("Connect socket SSL need Client Auth: " + SSLsock.getNeedClientAuth());
        }
        if (getTCPsocket() == null || getTCPsocket().isClosed()) {
            TDeb.wri("TCP socket is null after creation");
            return -1;
        }
        return 0;
    }

    private SSLContext getSSLcontext() {
        com.jdcm.common.D_Utils TUtils = new com.jdcm.common.D_Utils();
        SSLContext cotx;
        KeyStore ks;
        KeyStore ts;
        KeyManagerFactory kmf;
        TrustManagerFactory tmf;
        try {
            // set up key manager to do server authentication
            char[] passphraseK = Parent.getSSL_Kpwd().toCharArray();
            char[] passphraseT = Parent.getSSL_Tpwd().toCharArray();
            try {
                //ctx.getProvider().
                cotx = SSLContext.getInstance(Parent.getSSL_Proto());
                kmf = KeyManagerFactory.getInstance(Parent.getSSL_KAlgo());
                tmf = TrustManagerFactory.getInstance(Parent.getSSL_TAlgo());
            } catch (java.security.NoSuchAlgorithmException e) {
                TDeb.wri("Invalid Algorithm or protocol =>" + e.getMessage());
                return null;
            }
            try {
                ks = KeyStore.getInstance(Parent.getSSL_KType());
                ts = KeyStore.getInstance(Parent.getSSL_TType());
            } catch (java.security.KeyStoreException e) {
                TDeb.wri("Invalid Keystor Type =>" + e.getMessage());
                return null;
            }
            try {
                ks.load(TUtils.getFileStream(Parent.getSSL_Kfile()), passphraseK);
                ts.load(TUtils.getFileStream(Parent.getSSL_Tfile()), passphraseT);
            } catch (IOException ex) {
                TDeb.wri("Pb while getting stream from SSL KEY file "
                        + Parent.getSSL_Kfile().getName() + "/" + Parent.getSSL_Tfile().getName() + " =>" + ex.getMessage());
            }
            kmf.init(ks, passphraseK);
            tmf.init(ts);
            cotx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
            // see if possible to customize tmf to allow/refuse cert (ex : as microsoft)
            //Interface ManagerFactoryParameters
            //CertPathParameters
        } catch (NoSuchAlgorithmException | CertificateException | KeyStoreException | UnrecoverableKeyException | KeyManagementException e) {
            TDeb.wri("Pb creating SSL context =>" + e.getMessage());
            return null;
        }
        return cotx;
    }

    public int updateTCPsocket() {
        if (getTCPsocket() == null) {
            TDeb.wri("updatTCPsocket() : socket is null");
            return -1;
        }
        TDeb.wri("TCP option : Aking for Update socket option...");
        try {
            //for read() si ici Pb with SSL??
            getTCPsocket().setSoTimeout(Parent.getTCP_SoTO());
            if (Parent.isTCP_ReuseAddr() != getTCPsocket().getReuseAddress()) {
                getTCPsocket().setReuseAddress(Parent.isTCP_ReuseAddr());
                TDeb.wri("TCP option : setReuseAddress  : " + getTCPsocket().getReuseAddress());
            }
            // 
            //sending urgent data is not supported by SSLSockets
            if (SSLsock == null && Parent.isTCP_OOBinline() != getTCPsocket().getOOBInline()) {
                getTCPsocket().setOOBInline(Parent.isTCP_OOBinline());
                TDeb.wri("TCP option : isTCP_OOBinline :" + getTCPsocket().getOOBInline());
            }
            // 
            if (getTCPsocket().getSoLinger() >= 0 != Parent.isTCP_linger()) {
                getTCPsocket().setSoLinger(Parent.isTCP_linger(), Parent.getTCP_lingerTO());
                TDeb.wri("TCP option : setSoLinger :" + getTCPsocket().getSoLinger());
            } else if (Parent.isTCP_linger() && getTCPsocket().getSoLinger() != Parent.getTCP_lingerTO()) {
                getTCPsocket().setSoLinger(Parent.isTCP_linger(), Parent.getTCP_lingerTO());
                TDeb.wri("TCP option : setSoLinger :" + getTCPsocket().getSoLinger());
            }
            //  TDeb.wri("TCP option :getSoLinger .. OK");
            // to be tested
            if (getTCPsocket().getTrafficClass() != Parent.getTCP_class()) {
                getTCPsocket().setTrafficClass(Parent.getTCP_class());
                TDeb.wri("TCP option=>  Traffic class asked : " + Parent.getTCP_class() + " changed to : " + getTCPsocket().getTrafficClass());
                // TDeb.wri("for windows see HKEY_LOCAL_MACHINE\\System\\CurrentControlSet\\Services\\Tcpip\\Parameters\\DisableUserTOSSetting to 0");
            }
            if (getTCPsocket().getKeepAlive() != Parent.isTCP_keepalive()) {
                getTCPsocket().setKeepAlive(Parent.isTCP_keepalive());
                TDeb.wri("TCP option=>  Keepalive changed to : " + getTCPsocket().getKeepAlive());
            }
            if (getTCPsocket().getTcpNoDelay() != Parent.isTCP_nodelay()) {
                getTCPsocket().setTcpNoDelay(Parent.isTCP_nodelay());
                TDeb.wri("TCP option=> No_delay Changed to : " + getTCPsocket().getTcpNoDelay());
            }
        } catch (SocketException e) {
            TDeb.wri("TCP option Pb fixing options keepalive,nodelay or SoTimeout =>" + e.getMessage());
            // e.printStackTrace();
            return -1;
        } catch (NullPointerException e) {
            TDeb.wri("TCP Socket become null =>" + e.getMessage());
            // e.printStackTrace();
            return -1;
        }
        return 0;
    }

    private int readTCP() {
        //Specific because BLOKING read
        // res=1 =>end ou stop selon listner
        //res=0=> rien??
        byte[] donnees;
        byte[] Imputdat = new byte[MAX_DATAIN];
        int size = 0;
        while (Parent.isslrunning()) {
            if (getTCPsocket() != null) {
                //PAD will use non blocant methode
                while (Parent.isslrunning() && Parent.isPar_PadtStr()) {
                    //Create an event "Data avalable" for Pad
                    if (Parent.available() > size) {
                        size = Parent.available();
                        Parent.ReadStream(-1);
                    }
                    if (Parent.available() == 0) {
                        size = 0;
                    }
                    try {
                        sleep(1);
                    } catch (InterruptedException ex) {
                        TDeb.wri("sleep error: =>" + ex.getMessage());

                        // ex.printStackTrace();
                    }
                }
                while (Parent.isslreading()) {

                    if (Parent.isPar_PadtStr()) {
                        //closure ?should be ? managed with available in ReadStream
                        Parent.ReadStream(-1);
                        try {
                            sleep(1);
                        } catch (InterruptedException ex) {
                            TDeb.wri("Exception while sleep waiting Par_PadStr :" + ex.getMessage());
                        }
                    } else {
                        size = -2;
                        try {
                            try {
                                size = Parent.getin().read(Imputdat);
                            } catch (IOException ex) {
                                // no data received => So timeout
                                // TDeb.wri(" TCP reading : {" + ex.getMessage() + "}");
                            }
                        } catch (NullPointerException e) {
                            if (Parent.getin() == null) {
                                TDeb.wri("Reading : InStream is null =>" + e.getMessage());
                            } else {
                                TDeb.wri("Reading : InStream is NOT null ?? =>" + e.getMessage());
                            }
                            // TDeb.wri("Reading : Port should be Stopped ??");
                            return 1;
                        }
                        if (size == -1) {
                            TDeb.wri("Reading : other side TCP closure");
                            return 1;
                        }
                        if (size >= 0 && size != MAX_DATAIN) {
                            donnees = new byte[size];
                            System.arraycopy(Imputdat, 0, donnees, 0, size);
                            TDeb.wri("Reading : " + donnees.length + "bytes");
                            Parent.read_in(new C_Packet(donnees, Parent));
                        }
                        size = 0; // init size for new byte detection
                    }
                }
            }

            try {
                sleep(1);
            } catch (InterruptedException ex) {
                TDeb.wri("Exception while waiting for TCP blocking mode =>" + ex.getMessage());
            }
        }
        return 0;
    }

    /**
     * Send a packet content as a socket/datagram
     *
     * @param p the CXpacket to be write on interface
     * @return the number of byte writed
     */
    @Override
    public int write(C_Packet p) {
        if (Parent.getTCP_Mode().startsWith("TCP_L") || p.isbuffer() == false) {
            return 0;
        }
        TDeb.wri(Parent.getTCP_Mode() + " write [" + p.getBytes().length + "]" + util.Formate_ASCII(p.getBytes(), true));
        if (Parent.getTCP_Mode().startsWith("UDP")) {
            if (p.getsource() != null) {
                TDeb.wri("UDP : Prepare Datagram for " + Parent.getTCP_Addr().getHostAddress() + "#" + Parent.getTCP_Port() + " message size :" + p.getBytes().length);
            }
            createUDPD(p.getBytes());
        }
        // idem write serial // term//file
        byte[] res = null;
        if (p.getObj() instanceof byte[]) {
            res = (byte[]) p.getObj();
        }
        if (res == null || Parent.getout() == null) {
            return 0;
        }
        try {
            Parent.getout().write(res, 0, res.length);
        } catch (IOException ex) {
            if (p.getsource() != null) {
                TDeb.wri("Write_out error => closing port. =>" + ex.getMessage());
            }
            Parent.CXstop();
            return res.length;
        }
        return res.length;
    }

    public int init() {
        TDeb.wri("Aking for init Slave IP");
        if (Parent.getTCP_Mode().startsWith("UDP")) {
            TDeb.wri("Aking to start UDP...");
            if (StartUDP() < 0) {
                Parent.CXerror("UDP Socket creation error");
                return -1;
            }
        } else {
            TDeb.wri("Aking for start TCP...");
            if (Parent.getTCP_Mode().startsWith("TCP_L") == false) {
                if (TCP_connect() < 0) {
                    Parent.CXerror("Error during TCP connecting");
                    return -1;
                }
            }
        }
        return 0;
    }

    public int wait_State(String state) {
        String nowstate = Parent.getcxstatus();
        while (nowstate.compareTo(state) != 0) {
            nowstate = Parent.getcxstatus();
            if (nowstate.startsWith("clos") || nowstate.startsWith("stop")) {
                return -1;
            }
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                TDeb.wri("sleep error =>" + ex.getMessage());
                return -1;
            }
        }
        return 0;
    }

    @Override
    public void run() {
        TDeb.wri("Start Slave IP");
        if (Parent.getModeidx() != 0) {
            return;
        }
        //--Started LISTNER--
        if (Parent.getTCP_Mode().startsWith("TCP_L")) {
            if (TCP_listen() < 0) {
                Parent.CXerror("Error during TCP listnening");
            }
            return;
        }
        // start connexions
        if (getTCPsocket() == null && getUDPsocket() == null && getSSLsocket() == null) {
            if (init() == -1) {
                Parent.CXerror("Error during Init TCP ");
                return;
            }
        }
        if (Parent.isCX_autoopen() && Parent.isCX_openbyslave()) {
            if (wait_State("started") == 0) {
                TDeb.wri("started reached => try to open");
                try {
                    Parent.CXopen();
                } catch (Exception ex) {
                    //set for RST Excpetion? management (chiness)
                    Parent.CXerror("Abnormal IP slave terminaison: while openning =>" + ex.getMessage());
                }
            } else {
                Parent.CXerror("Abnormal IP slave terminaison while waiting for started");
                return;
            }
        }

        // check state to avoid IP&XML open order
        //--need to wait for OPENED to get streams && status OK (reading/runing)--
        while (Parent.isslrunning() == false) {
            String nowstate = Parent.getcxstatus();
            if (nowstate.startsWith("clos") || nowstate.startsWith("stop")) {
                return;
            }
            try {
                sleep(10);
            } catch (InterruptedException ex) {
            }
        }
        // follow by reading data
        if (Parent.getTCP_Mode().startsWith("UDP")) {
            TDeb.wri("Start running UDP run/read :" + Parent.isslrunning() + "/" + Parent.isslreading());
            if (readUDP() < 0) {
                Parent.CXerror("Error from UDP Thread");
            }
            return;
        } else {
            try {
                if (Parent.getTCP_Mode().startsWith("TCP_C")) {
                    TDeb.wri("Start running TCP run/read :" + Parent.isslrunning() + "/" + Parent.isslreading());
                    int result = readTCP();
                    if (result < 0) {
                        Parent.CXerror("Error from TCP Thread");
                    } else if (result == 1) {
                        if (Parent.getListener() != null) {
                            Parent.CXend();
                        } else {
                            Parent.CXstop();
                        }
                    }
                }
            } catch (Exception ex) {
                //set for RST Excpetion? management (chiness)
                // ex.printStackTrace();
                Parent.CXerror("Abnormal IP slave terminaison : made for RST Pb =>" + ex.getMessage());
            }
        }
        TDeb.wri("Stop Slave IP");

    }
}
/*
 *http://www.developpez.net/forums/showthread.php?t=47270
 class MySSLSocketFactory implements ProtocolSocketFactory
 {
 private SSLContext sslcontext = null;

 public MySSLSocketFactory() {
 }

 private static SSLContext createEasySSLContext()
 {
 try {
 SSLContext context = SSLContext.getInstance("SSL");
 context.init(null,new TrustManager[]{new MyX509TrustManager()},null);
 return context;
 } catch (Exception e) {
 throw new HttpClientError(e.toString());
 }
 }

 private SSLContext getSSLContext()
 {
 if (this.sslcontext == null)
 this.sslcontext = createEasySSLContext();
 return this.sslcontext;
 }

 public Socket createSocket( String host, int port, InetAddress clientHost, int clientPort)
 throws IOException, UnknownHostException
 {
 return getSSLContext().getSocketFactory().createSocket(host, port, clientHost, clientPort);
 }

 public Socket createSocket(String host,int port,InetAddress localAddress,
 int localPort, HttpConnectionParams params)
 throws IOException, UnknownHostException
 {
 return createSocket(host, port, localAddress, localPort);
 }

 public Socket createSocket(String host, int port)
 throws IOException, UnknownHostException
 {
 return getSSLContext().getSocketFactory().createSocket(host,port);
 }

 public boolean equals(Object obj) {
 return ((obj != null) && obj.getClass().equals(MySSLSocketFactory.class));
 }

 public int hashCode() {
 return MySSLSocketFactory.class.hashCode();
 }

 public static class MyX509TrustManager implements X509TrustManager
 {
 public MyX509TrustManager() {}
 public X509Certificate[] getAcceptedIssuers() {return null;}
 public void checkClientTrusted(X509Certificate[] chain, String authType){}
 public void checkServerTrusted(X509Certificate[] chain, String authType){}
 }
 }
 **/
