package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;

/**
 *
 * TO DO !
 *
 * @author Marc GIBOIN comme from SYS => RPC/COM/...? / transmit to memory
 */
public class T_MEM extends Thread implements I_Slave {

    private final D_Debug TDeb;
    private final C_Port Parent;
    
    private byte[] input_buffer = null;

    public T_MEM(C_Port P) {
        Parent = P;
        TDeb = new D_Debug("T-MEM [" + Parent.getIndex() + "] : ");
        TDeb.setconsole(Parent.getConsole());
        setName(this.getClass().getSimpleName() + ":" + getName());
    }

    @Override
    public int write(C_Packet p) {
        java.util.List<I_Port> ports = Parent.getMain().getPorts();
        if (p.isbuffer()) {
            for (I_Port port : ports) {
                if (port != Parent) {
                    if (port instanceof C_Port && port.getModeName().compareTo("MEM") == 0) {
                        if (((C_Port) port).getMEM_wire() == Parent.getMEM_wire()) {
                            if (((C_Port) port).getSlave() instanceof T_MEM) {
                                ((T_MEM) ((C_Port) port).getSlave()).adddata(p.getBytes());
                            }
                        }
                    }
                }
            }
        }
        return 0;
    }

    public void adddata(byte[] b) {
        if (input_buffer == null || input_buffer.length == 0) {
            input_buffer = b;
        } else {
            // input_buffer=
        }
    }

    @Override
    public int sl_start() {
        //define MEM
        return 0;
    }

    @Override
    public int sl_open() {
        Parent.setin(new java.io.ByteArrayInputStream(input_buffer));

        return 0;
    }

    @Override
    public int sl_close() {
        //clear & close MEM
        Parent.setin(null);
        input_buffer = null;
        return 0;
    }

    public void wait_State(String state) {
        while (Parent.getcxstatus().compareTo(state) == 0) {
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                //  ex.printStackTrace();
            }
        }
    }

    /**
     * Run the SYS Slave
     *
     * no listner on in strean
     *
     */
    @Override
    public void run() {
        boolean resistrue = false;
        wait_State("starting");
        if (Parent.isCX_autoopen() && Parent.isCX_openbyslave()) {
            Parent.CXopen();
        }
        // wait_State("opening");
        TDeb.wri("---Start of SYS thread file---");
        while (Parent.isslrunning()) {
            try {
                sleep(5);
            } catch (InterruptedException ex) {
                TDeb.wri("SYS slave running/ Pb during waiting [" + ex.getMessage() + "]");
            }
            while (Parent.isslrunning() && (Boolean) Parent.getCMDOptions().getValuefor("Par_PadtStr")) {
                //Create an event "Data avalable" FOR PAD
                try {
                    sleep(1);
                } catch (InterruptedException ex) {
                    // ex.printStackTrace();
                }
            }
            while (Parent.isslreading()) {
                while (Parent.isslreading()) {
                    try {
                        sleep(1);
                        Parent.ReadStream(-1);
                    } catch (InterruptedException ex) {
                        Parent.CXerror("error while reding: " + ex.getMessage());
                        return;
                    }

                }
                Parent.setslreading(false);
                Parent.setslrunning(false);

            }
        }
        //sl_close();
        Parent.CXstop();
        TDeb.wri("---End of SYS thread---");
    }
}
