package com.jdcm.modifiers.matrix;

import com.jdcm.eltrx.I_Port;
import com.jdcm.eltrx.T_Matrice;

/**
 * This GROUP matrix route all data of a GROUP to other ports of its group. -
 * Groups are defined by port.getPar_mxgrp() labels
 *
 * @author M.Marc GIBOIN
 */
public class mat_GRP extends mat_base {

    public mat_GRP(T_Matrice p) {
        Parent = p;
    }

    public static String getComment() {
        return "Group matrix";
    }

    public static javax.swing.Icon getIcon() {
        return (new com.jdcm.common.D_Utils()).getIcon("mat_grp.gif");
    }

    @Override
    public void mx_init() {
        for (int i = 0; i < Parent.getmodel().getRowCount() - 1; i++) {
            for (int j = 0; j < Parent.getmodel().getRowCount() - 1; j++) {
                if (i != j) {
                    boolean bool = true;
                    boolean isacx = false;
                     if (i < Parent.getPorts().size()) {
                    String list = Parent.getPorts().get(i).getPar_mxgrp();
                    if (j < Parent.getPorts().size()) {
                        I_Port port=Parent.getPorts().get(j);
                        if (port.getPar_mxgrp().compareTo("<") == 0) {
                            isacx = true;
                        } else if (list.length() == 0) {
                            isacx =port.getPar_mxgrp().length() == 0;
                        } else {
                            for (String txt : list.split(",")) {
                                java.util.List<String> list2 = java.util.Arrays.asList(port.getPar_mxgrp().split(","));
                                if (list2.contains(txt)) {
                                    isacx = true;
                                }
                            }
                        }
                    }
                    }
                    // set booleans only (1 row after..)
                    Parent.getmodel().setValueAt(bool && isacx, i + 1, j + 1);
                } else {
                    Parent.getmodel().setValueAt(Parent.isMat_Echo(), i + 1, j + 1);
                }
            }
        }
        Parent.getmodel().fireTableDataChanged();
    }

    @Override
    public void setConnection(int src, int dest, boolean bool) {
        String tag = getValueAt(0, src + 1).toString();
        // would be great to implment a separator in group matrix :12:13... then matched if :12 is found
        if (bool) {
            if (tag.length() == 0) {
                setValueAt("" + dest, 0, src + 1);
            } else if (tag.endsWith(",")) {
                setValueAt(tag + dest, 0, src + 1);
            } else {
                setValueAt(tag + "," + dest, 0, src + 1);
            }
        } else {
            if (tag.compareTo("" + dest) == 0) {
                setValueAt("", 0, src + 1);
            } else if (tag.indexOf("," + dest) > 0) {
                setValueAt(tag.replace("," + dest, ""), 0, src + 1);
            } else if (tag.indexOf(dest + ",") >= 0) {
                setValueAt(tag.replaceAll(dest + ",", ""), 0, src + 1);
            }
        }
    }

    @Override
    public int getRowCount(boolean[][] boolArray) {
        return boolArray.length + 1;
    }

    @Override
    public void update(boolean[][] oldBools, boolean[][] newBools) {
        if (newBools != null) {
            Parent.setmodelbools(newBools);
        }
        mx_init();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        if (aRow == 0) {
            if (aColumn == 0) {
                return "Tags";
            } else {
                return Parent.getPorts().get(aColumn - 1).getPar_mxgrp();
            }
        }
        return null;
    }

    @Override
    public void setValueAt(Object value, int aRow, int aColumn) {
        if (aRow == 0 && aColumn > 0) {
            Parent.getPorts().get(aColumn - 1).setPar_mxgrp(value.toString());
        }
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        if (row == 0) {
            return column > 0;
        } else {
            return false;
        }
    }
}
