package com.jdcm.modifiers;

/**
 * Scamble and Unscramble a Buffer
 * http://mindprod.com/jgloss/xor.html
 * 
 *  @author Marc GIBOIN
 */
public class modif_scrambler implements I_modifiers{
    private byte[] buffer;

   /**
    * This is NOT the password. This is a scrambler phrase for the password.
    * The key used both to scramble and unscramble the password.
    * Just some pass phrase ideally
    * that blends into your program that looks like nothing special e.g.
    ( "error 576 : Token stack initialiser error."
    */
   static final char[] scrambler = "The universe is made of stories not atoms.".toCharArray();

   /**
    * You run this code once ahead of time to find out the string to embed
    * to represent the password. You later embed some of the code it generates
    * in your own program.
    *
    * @param put your real case-sensitive password
    * on the command line IN QUOTES!
    */

   /**
    * display the magic numbers representing your scrambled password.
    * @param realPassword your actual password or passphrase you want to
    * scramble so you can more safely embed it in a program.
    * @return scrambled password as a String. Not much use since it
    * contains gibberish characters. See console for the
    * java code for a char[] representation
    */
   public static String scramble( String realPassword )
      {
      char[] thePasswordYouEmbed = xor( realPassword.toCharArray(), scrambler );

      // the scrambled password is full of gibberish non-printing chars .
      // We need to convert it to something human readable so we
      // print it out as code to insert with a list of ints, one per char
      System.out.println();
      System.out.println ( "char[] scrambledPassword = new char[] {" );

      for ( int i=0; i<thePasswordYouEmbed.length; i++ )
         {
         System.out.println ( (int)thePasswordYouEmbed[i] + "," );
         }
      System.out.println ( "};" );
      System.out.println ( "String reconstitutedPassword = unscramble( scrambledPassword );" );
      System.out.println();
      return new String( thePasswordYouEmbed );
      }

   /**
    * reconstitute a scrambled password
    * @param scrambledPassword an array of chars mostly unprintable.
     * @return 
    */
   public static String unscramble( char[] scrambledPassword )
      {
      // note you cannot use char[].toString()
      return new String ( xor( scrambledPassword, scrambler ) );
      }

   /**
     * @param a
     * @param b
    * @return xor of arrays a and b
    */
   public static char[] xor ( char[] a, char[] b )
      {
      int length = Math.min (a.length, b.length );
      char[] result = new char[length];
      for ( int i=0; i<length ; i++ )
         {
         // ^ is the xor operator
         // see http://mindprod.com/jgloss/xor.html
         result[i] = (char) ( a[i] ^ b[i] );
         }
      return result;
      }

    @Override
    public void setBuffer(byte[] b){buffer=b;}
    @Override
    public byte[] getBuffer(){return buffer;}
    @Override
    public void ToClear() {
        buffer=unscramble((new String(buffer)).toCharArray()).getBytes();
    }

    @Override
    public void ToCode() {
        buffer=scramble(new String(buffer)).getBytes();
    }


}
