package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * * provide simple authetication layer (as login/password)
 * ?? wht's about prompt & stop (should be managed by upper layer?)
 * 
 * @author Marc GIBOIN
 */
public class Stack_AUTH extends Stack_base {

    private String login = "";
    private String authbuffer = "";

    public Stack_AUTH() {
                super();
        getOptions().addOption("auth_waitlog", "a", "String", "", true, true, "the waited login answer");
        getOptions().addOption("auth_msglog", "\r\nLogin:".getBytes(), "byte[]", "", true, true, "the login prompt");
        getOptions().addOption("auth_msgpwd", "\r\nPassword:".getBytes(), "byte[]", "", true, true, "the password prompt");
        getOptions().addOption("auth_waitpwd", "a", "String", "", true, true, "the waited password answer");
        getOptions().addOption("auth_stop", "bye", "String", "", true, true, "stop the session (back to login?)");
        getOptions().addOption("auth_status", "log", "String", "", true, true, "athentication level log/pass/conct");
    }
    public  static String getComment() {
        return "provide a simple bintec emmulation";
    }

    public  static double getosi() {
        return 4.0;
    }
    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), true);
        if (pack == null || pack.length == 0) {
            return null;
        }
        String auth = getOptions().getValuefor("auth_status").toString();
        if (auth.startsWith("cnt") == false) {
            authbuffer = authbuffer + new String(pack);
            if (authbuffer.endsWith("\n") == false) {
                return null;
            }
        } else {
            if ((new String(pack)).compareTo(getOptions().getValuefor("auth_stop").toString()) == 0) {

                getStack().reply_out(this, new C_Packet(getOptions().getValuefor("auth_msglog"), getport()));
                getOptions().setValuefor("auth_status", "log");
            } else {
                //  Parent.reply_out(this,new C_Packet(("\r\n"+options.getValuefor("auth_prompt")).getBytes(), portidx));
                res.add(packet);
            }
        }
        if (authbuffer.endsWith("\n")) {
            authbuffer = authbuffer.trim();
            if (auth.startsWith("log")) {
                login = authbuffer;
                getStack().reply_out(this, new C_Packet(getOptions().getValuefor("auth_msgpwd"), getport()));
                getOptions().setValuefor("auth_status", "pwd");
                authbuffer = "";
            } else if (auth.startsWith("pwd")) {
                if (login.compareTo(getOptions().getValuefor("auth_waitlog").toString()) == 0
                        && authbuffer.compareTo(getOptions().getValuefor("auth_waitpwd").toString()) == 0) {

                    //       Parent.reply_out(this,new C_Packet(("\r\n" + options.getValuefor("auth_prompt").toString()).getBytes(), portidx));
                    getOptions().setValuefor("auth_status", "cnt");
                    I_stack_elt target = getStack().getTarget(getport(), "Shell");
                    if (target != null) {
                        ((Stack_Shell) target).setStack_isStart(false);
                        ((Stack_Shell) target).setStack_isStart(true);
                    }
                } else {
                    getStack().reply_out(this, new C_Packet(getOptions().getValuefor("auth_msglog"), getport()));
                    getOptions().setValuefor("auth_status", "log");
                }
                login = "";
                authbuffer = "";
            }
        }
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), false);
        if (getOptions().getValuefor("auth_status").toString().startsWith("cnt")) {
            res.add(packet);
        } else {
            //   return new java.util.ArrayList<C_Packet>();
        }
        return res;
    }


    @Override
    public void StkArcv(String message, String type) {
        if (message.compareTo("stopped") == 0 && type.compareTo("Status") == 0) {
            getOptions().setValuefor("auth_status", "log");
        }
        if (message.compareTo("connected") == 0 && type.compareTo("Status") == 0) {
            getOptions().setValuefor("auth_status", "log");
            getStack().reply_out(this, new C_Packet(getOptions().getValuefor("auth_msglog"), getport()));
        }
    }

    @Override
    public double matchProtocol(C_Packet pack) {
        if (pack.isbuffer() && pack.getBytes().length>0){
            String txt=new String(pack.getBytes());
            if (txt.startsWith(getOptions().getValuefor("auth_msglog").toString())){
                return 0.8;
            }
        }
        return 0.0;
    }
}
