package com.jdcm.modifiers.stacks;

import com.jdcm.common.D_Utils;
import com.jdcm.common.C_Packet;
import java.util.Arrays;
import java.util.List;
import javax.swing.DefaultComboBoxModel;

/**
 *TODO : get a Dynamic Host Configuration Protocol (DHCP) as client or server
 * 
 * !! see faille de Fernando Gont
 * http://www.frameip.com/dhcp/
 *  local port (udp 68) management needed!!
 * 
 * @author Marc Giboin
 */
public class Stack_BOOTP extends Stack_base {

    private final D_Utils util = new D_Utils();
    // on udp 67/68, ip; eth , broadcast to manage
    private final java.util.List<C_Packet> buffer= new java.util.ArrayList<>();


    public Stack_BOOTP() {
                super();
        byte[] clientmac= new byte[]{1,2,3,4,5,6};
        byte[] trans_id=new byte[]{1,2,3,4};

        //byte[] broadcastip= new byte[]{-1,-1,-1,-1};
        byte[] clientip= new byte[]{0,0,0,0};
        byte[] myip= new byte[]{0,0,0,0};
        int type= 1;
          getOptions().addOption("btstrp_server",false, "boolean", "", true, true, "DHCP Client/server ");
         //options.addOption("btstrp_brdhwd", broadcasteth, "byte", "", true, true, "Hardware broacast address");
        DefaultComboBoxModel<String> c = new DefaultComboBoxModel<> (new String[]{"Ethernet",
	"Experimental Ethernet","Amateur Radio AX.25",
	"Proteon ProNET Token Ring","Chaos","IEEE 802",
	"ARCNET","Hyperchannel","Lanstar","Autonet Short Address",
	"LocalTalk","LocalNet (IBM PCNet or SYTEK LocalNET)",
	"Ultra link","SMDS","Frame Relay","ATM, Asynchronous Transmission Mode",
	"HDLC",	"Fibre Channel","ATM, Asynchronous Transmission Mode",
	"Serial Line","ATM, Asynchronous Transmission Mode",
	"MIL-STD-188-220","Metricom","IEEE 1394.1995","MAPOS","Twinaxial",
	"EUI-64","HIPARP"});
         getOptions().addOption("btstrp_hwdtyp", c, "Combobox model", "", true, true, "Hardware type (Eth)");
          getOptions().addOption("btstrp_hwdsize", 6, "int", "", true, true, "Hardware address size");
        //options.addOption("btstrp_brdip", broadcastip, "byte", "", true, true, "IP Broadcast address");
        getOptions().addOption("btstrp_hops", 0, "int", "", true, true, "Hops");
        getOptions().addOption("btstrp_trsid", trans_id, "int", "", true, true, "transaction ID"); //too see
        getOptions().addOption("btstrp_clientip", clientip, "byte[]", "", true, true, "Client IP address");
        getOptions().addOption("btstrp_myip", myip, "byte[]", "", true, true, "My IP address");
        getOptions().addOption("btstrp_nxtsrvip", myip, "byte[]", "", true, true, "Next Server IP address");
        getOptions().addOption("btstrp_relaisrvip", myip, "IPaddr", "", true, true, "Relai server IP address");
        getOptions().addOption("btstrp_clientmac", clientmac, "ETHaddr", "", true, true, "Client ETH address");
        getOptions().addOption("btstrp_srvname", "", "string", "", true, false, "Server Hostname max 64");
        getOptions().addOption("btstrp_bootfile", "", "string", "", true, false, "boot filme name max 128");
    }

    public static String getComment() {
        return "Bootstrap Protocol (used for DHCP)";
    }


    public static double getosi() {
        return 7;
    }

    /**
     * check packet change MAC ? according to route
     * Answer to request for my IP
     * @param packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        // routting protocol => do nothing except if routing protocol ...
        byte[] pack = packet.getBytes();
        if ((Boolean)getOptions().getValuefor("btstrp_server")==false){
            if (getOptions().getValuefor("btstrp_myip") == new byte[]{0, 0, 0, 0}){
                //reply ??
                byte typ=java.util.Arrays.copyOfRange(pack, 0, 1)[0];
                byte[] trid=java.util.Arrays.copyOfRange(pack,4, 4);
                byte[] eth=java.util.Arrays.copyOfRange(pack,28, 4);
                if (typ==2
                        && trid==(byte[])getOptions().getValuefor("btstrp_trsid")
                        && eth==(byte[])getOptions().getValuefor("btstrp_clientmac")){
                 byte[] claddr=java.util.Arrays.copyOfRange(pack,16, 4);
                 byte[] srvadd=java.util.Arrays.copyOfRange(pack,20, 4);
                 getOptions().setValuefor("btstrp_myip", claddr);
                 getOptions().setValuefor("btstrp_nxtsrvip", srvadd);
                }
            }
        }
        return null;
    }

    /**
     *
     *
     * @param data
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public List<C_Packet> transmit(C_Packet data) throws Exception {
        //Pb : if UDP or TCP > How to simply formard packet here ??
        // need store data before look for address
        List<C_Packet> res = new java.util.ArrayList<>();
        if ((Boolean)getOptions().getValuefor("btstrp_server")==false){
            if (Arrays.equals((byte[])getOptions().getValuefor("btstrp_myip"),new byte[]{0, 0, 0, 0})){
                //request
                byte[] pl=createframe((byte)1,(byte[])getOptions().getValuefor("btstrp_trsid"));
                C_Packet pa=new C_Packet(pl,data.getsource());
                pa.setdestination(data.getdestination());
                res.add(pa);
            }
        }
        return res;
    //need to way answer and send packet

    }
    private byte[] createframe(byte msgtype,byte[] trxid){
        byte[] res=new byte[]{msgtype};
         byte[] buff=new byte[3];
         byte[] magic =new byte[]{99,126,83,99};// magic cooke (4)99, 130, 83 and 99 (dec)
        DefaultComboBoxModel<String> hw= getOptions().getValuefor("btstrp_hwdtyp",new DefaultComboBoxModel<String>());
        int hwt=hw.getIndexOf(hw.getSelectedItem())+1;
        int hwl= getOptions().getValuefor("btstrp_hwdsize",0);
        int hop= getOptions().getValuefor("btstrp_hops",0);
        if (hwt<128 && hwl<128 && hop<128){
            buff[0]=(byte)hwt;
            buff[1]=(byte)hwl;
            buff[2]=(byte)hop;
        }else{
            return null;
        }
        res = util.addtab(res, buff);
        res = util.addtab(res, trxid);
        res = util.addtab(res, new byte[]{0});// time elapsed to look with trxid?
        res = util.addtab(res, new byte[]{0,0});// bootp flags to look with trxid?
        res = util.addtab(res, getOptions().getValuefor("btstrp_clientip",new byte[]{}));
        res = util.addtab(res, getOptions().getValuefor("btstrp_myip",new byte[]{}));
        res = util.addtab(res, getOptions().getValuefor("btstrp_nxtsrvip",new byte[]{}));
         res = util.addtab(res, getOptions().getValuefor("btstrp_relaisrvip",new byte[]{}));
         byte[] eth= getOptions().getValuefor("btstrp_clientmac",new byte[]{});
         buff=new byte[16-eth.length];
         java.util.Arrays.fill(buff, (byte)0);
         eth=util.addtab(eth, buff);
         res = util.addtab(res,eth);
         byte[] srv= getOptions().getValuefor("btstrp_srvname").toString().getBytes();
         buff=new byte[64-eth.length];
         java.util.Arrays.fill(buff, (byte)0);
         srv=util.addtab(srv, buff);
         res = util.addtab(res, srv);
         byte[] file= getOptions().getValuefor("btstrp_bootfile").toString().getBytes();
         buff=new byte[128-file.length];
         java.util.Arrays.fill(buff, (byte)0);
         file=util.addtab(file, buff);
         res = util.addtab(res, file);
         res = util.addtab(res, magic);
         //options
         res = util.addtab(res, new byte[]{-1});//end
        return res;
    }
    @Override
      public double matchProtocol(C_Packet pack) {
        double res=0.0;
        byte[] mc=new byte[]{99,-126,83,99}; //magic cookie
            if (pack.isbuffer()){
                if (pack.getBytes().length>38){ //until MAC receiver
                    byte[] frame=pack.getBytes();
                    if ((frame[0]==1 || frame[0]==2) && frame[1]==1 && frame[2]==6){
                        res=0.998;
                        int cook=182;
                        if (frame[cook]==mc[0] && frame[cook+1]==mc[1] 
                                && frame[cook+2]==mc[2] && frame[cook+3]==mc[3]  ){
                                     res=0.99943977;
                                }
                    }
                }
            }
        return res;
    }

}
