package com.jdcm.modifiers.stacks;

import com.jdcm.analyse.I_Code_Parent;
import com.jdcm.analyse.Code_Model;
import com.jdcm.common.*;
import com.jdcm.eltrx.*;
import java.io.File;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 * A stacks that use decode to convert stream within the port
 * this module is fully based on CodeModel (a result model) and T_Code (a thread for Analysing)
 * @author Marc Giboin
 */
public class Stack_DESC extends Stack_base implements I_Code_Parent {

    private D_Utils TUtils = new D_Utils();
    // initpacket i the first packet if one oacket => many packet (ex:tcpdump)
    C_Packet initDescPack = null;
    private final DefaultComboBoxModel<String> CBstrModel = new DefaultComboBoxModel<>();
    Code_Model codeModel = null;

    public Stack_DESC() {
        super();
          // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        //   getOptions().addOption("DESC_autostack", false, "bool", "", true, false, "ask to set automaticly stack");
        getOptions().addOption("DESC_PadTO", false, "bool", "0/1", true, false, "Enable waiting protocol specified byte");
        getOptions().addOption("DESC_Blocks", false, "bool", "0/1", true, false, "Allow to transmit rom Main(media) side");
        String[] descproto = {"Dump"};
        getOptions().addOption("DESC_ProtoCustom", new DefaultComboBoxModel<>(), "Desc proto Custom", "", true, false, "Define protocol descriptor editing file");
        getOptions().addOption("DESC_Protofirst", new DefaultComboBoxModel<>(descproto), "Desc proto", "", true, false, "Define first protocol descriptor file");
        getOptions().addOption("DESC_Protolast", new DefaultComboBoxModel<>(descproto), "Desc proto upper limit", "", false, false, "Define last protocol descriptor file");
        String[] dataf = {"-field-"};
        getOptions().addOption("DESC_fdata", new DefaultComboBoxModel<>(dataf), "fields", "", false, false, "Define the field to send as message");
        String[] descondf = {"-cond-"};
        getOptions().addOption("DESC_fcond", new DefaultComboBoxModel<>(descondf), "fields", "", false, false, "Define the filed checked before a field should be sended");
        getOptions().addOption("DESC_PadTOval", 1000, "msec", ">0", false, false, "Define the time to wait for protocol specified byte");
        getOptions().addOption("DESC_panel", false, "bool", "0/1", true, false, "Define if DESC Panel should be visible");
        String[] asby = {"ModelTa", "ModelTr", "as_buffer", "as_objval", "as_strval", "val2byte","ModelKeep"};
        getOptions().addOption("DESC_sendas", new DefaultComboBoxModel<>(asby), "fields", "", true, false, "define how a field is sended as message");
        getOptions().addOption("DESC_fcondval", new byte[0], "byte[]", "", true, true, "Define the value of the conditional field(%)");
        getOptions().addOption("DESC_CheckAnsw", false, "bool", "0/1", false, false, "!!!check answer after receved");
        getOptions().addOption("DESC_WaitAnsw", false, "bool", "0/1", false, false, "if a answer is analysed, wait for it");
         getOptions().addOption("DESC_WaitLimit", false, "bool", "0/1", true, false, "if active then a frame will be send after the waiting time on Waiting");
         getOptions().addOption("DESC_WaitLimitval", 3000, "int", "ms", true, false, "limite time waited befor send a frame ");
        getOptions().addOption("DESC_EOL", false, "bool", "0/1", false, false, "Enable sending specific messages on EOL field");
        getOptions().addOption("DESC_EOLval", "", "txt", "", false, false, "Secify  message to send on EOL field");
        getOptions().addOption("DESC_Offset", 0, "nb bytes", ">=0", false, false, "remove n byte before analyse");
        getOptions().addOption("DESC_TIT", false, "bool", "0/1", false, false, "Time inter trame!!");
        getOptions().addOption("DESC_TITval", 1000, "msec", "intertrame", false, false, "specify TIT");
        getOptions().addOption("DESC_EOFstop", false, "bool", "0/1", false, false, "if port should stop after decode ends");
        java.util.List<File> files = TUtils.getFiles("Descriptors", null);
        if (files != null) {
            files.add(0, new File("none"));
            getOptions().setValuefor("DESC_Protofirst", new javax.swing.DefaultComboBoxModel<>(files.toArray(new File[]{})));
            getOptions().setValuefor("DESC_Protolast", new javax.swing.DefaultComboBoxModel<>(files.toArray(new File[]{})));
            if (files.size() > 1) {
                setDESC_Protofirst(files.get(1));
            }
        }
        // option.setused("DESC_Sproto", bool);
        javax.swing.JButton b = new JButton();
        b.setIcon(TUtils.getIcon("Open.gif"));
        // b.setSelectedIcon(TUtils.getIcon("File_xml.gif"));
        b.setMargin(new java.awt.Insets(0, 0, 0, 0));
        b.setToolTipText("Add cutom protocol file to test while editing ");
        b.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                java.io.File f = TUtils.getUIreadFile(null, JFileChooser.FILES_ONLY, null, true);
                addFile(f);
            }
        });
    }

    public static String getComment() {
        return "protocol analyser stack";
    }

    public static double getosi() {
        return 8.0;
    }

    public void addFile(java.io.File f) {
        if (f != null) {
            javax.swing.DefaultComboBoxModel<java.io.File> cb1 = getOptions().getValuefor("DESC_Protofirst", new javax.swing.DefaultComboBoxModel<java.io.File>());
            javax.swing.DefaultComboBoxModel<java.io.File> cb2 = getOptions().getValuefor("DESC_Protolast", new javax.swing.DefaultComboBoxModel<java.io.File>());
            javax.swing.DefaultComboBoxModel<java.io.File> cb3 = getOptions().getValuefor("DESC_ProtoCustom", new javax.swing.DefaultComboBoxModel<java.io.File>());
            cb1.addElement(f);
            cb2.addElement(f);
            cb3.addElement(f);
        }
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.ArrayList<C_Packet> list = new java.util.ArrayList<>();
        if (getOptions().getValuefor("DESC_Blocks", true)) {
            list.add(packet);
        }
        if (packet.isbuffer()) {
            if (initDescPack != null) {
              Code_Model cm=  (Code_Model) initDescPack.getObj();
                cm.setrcved_buff(TUtils.addtab(cm.getrcvedbuff(), packet.getBytes()));
            } else if (codeModel != null) {
                codeModel.setrcved_buff(TUtils.addtab(codeModel.getrcvedbuff(), packet.getBytes()));
            }
        }
        return list;
    }

    /**
     * encapsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packet
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        DESC_send(packet, false);
        return new java.util.ArrayList<>();
    }

    /**
     * for ompatibility with C_Port DESC
     *
     * @return
     */


    public boolean isDESC_enable() {
        DefaultComboBoxModel<File> cbox = getOptions().getValuefor("DESC_Protofirst", new DefaultComboBoxModel<File>());
        boolean auto = false;
        return auto || ((File) cbox.getSelectedItem()).getName().compareTo("none") != 0;
    }

    @A_Commande(help = "return the first protocol file name")
    public File getDESC_Protofirst() {
        DefaultComboBoxModel<File> cbox = getOptions().getValuefor("DESC_Protofirst", new DefaultComboBoxModel<File>());
        if (!isDESC_enable()) {
            return null;
        }
        return (File) cbox.getSelectedItem();
    }

    @A_Commande(help = "set the first descriptor file name")
    public void setDESC_Protofirst(String txt) {
        if (getDESC_Protofirst() == null || getDESC_Protofirst().getName().compareTo(txt) != 0) {
            DefaultComboBoxModel<File> cbox = getOptions().getValuefor("DESC_Protofirst", new DefaultComboBoxModel<File>());
            for (int i = 0; i < cbox.getSize(); i++) {
                if (cbox.getElementAt(i).getName().compareTo(txt) == 0
                        || cbox.getElementAt(i).getName().compareTo(txt + ".xml") == 0) {
                    setDESC_Protofirst(cbox.getElementAt(i));
                }
            }
        }
    }

    @A_Commande(help = "set the first descriptor file")
    public final void setDESC_Protofirst(File fi) {
        if (getDESC_Protofirst() == null || getDESC_Protofirst() != fi) {
            DefaultComboBoxModel<File> cbox = getOptions().getValuefor("DESC_Protofirst", new DefaultComboBoxModel<File>());
            cbox.setSelectedItem(fi);
            setboxDescenable(isDESC_enable());
        }
        // even if same because of second proto
          if (getDESC_Protofirst() != null) {
                // for a "none" selection
                init_DESCbox(0);
           }
    }

    public void setDESC_Protofirst(javax.swing.DefaultComboBoxModel<File> cbox) {
        setDESC_Protofirst((File) cbox.getSelectedItem());
    }

    @A_Commande(help = "return the last protocol file name")
    public File getDESC_Protolast() {
        DefaultComboBoxModel<File> cbox = getOptions().getValuefor("DESC_Protolast", new DefaultComboBoxModel<File>());
        if (((File) cbox.getSelectedItem()).getName().compareTo("none") == 0) {
            return null;
        }
        return (File) cbox.getSelectedItem();
    }

    @A_Commande(help = "set the last descriptor file (not decoded after)")
    public void setDESC_Protolast(String txt) {
        if (getDESC_Protolast() == null || getDESC_Protolast().getName().compareTo(txt) != 0) {
            DefaultComboBoxModel<File> cbox = getOptions().getValuefor("DESC_Protolast", new DefaultComboBoxModel<File>());
            for (int i = 0; i < cbox.getSize(); i++) {
                if (cbox.getElementAt(i).getName().compareTo(txt) == 0
                        || cbox.getElementAt(i).getName().compareTo(txt + ".xml") == 0) {
                    setDESC_Protolast(cbox.getElementAt(i));
                }
            }
        }
    }

    @A_Commande(help = "set the last descriptor file (not decoded after)")
    public void setDESC_Protolast(File fi) {
        if (getDESC_Protolast() == null || getDESC_Protolast() != fi) {
            DefaultComboBoxModel<File> cbox = getOptions().getValuefor("DESC_Protolast", new DefaultComboBoxModel<File>());
            cbox.setSelectedItem(fi);
            if (getDESC_sendas().startsWith("Model") == false) {
                setDESC_fdata(fi.getName().substring(0, fi.getName().length() - 4) + ".data");
            }
        }
    }

    public void setDESC_Protolast(javax.swing.DefaultComboBoxModel<String> cbox) {
        setDESC_Protolast(cbox.getSelectedItem().toString());
    }

    public void DESC_send(C_Packet pack, boolean isIn) {
        if (getOptions().getValuefor("DESC_PadTO", true) && initDescPack != null) {
            ((Code_Model) initDescPack.getObj()).addInitbuffer(pack.getBytes());
        } else {
            codeModel = new Code_Model(this, pack);
            javax.swing.DefaultComboBoxModel<java.io.File> cb3 = getOptions().getValuefor("DESC_ProtoCustom", new javax.swing.DefaultComboBoxModel<java.io.File>());
            for (int i = 0; i < cb3.getSize(); i++) {
                codeModel.addpCustomProto(cb3.getElementAt(i));
            }
            codeModel.setbuffer(pack.getBytes());
            codeModel.setinitbuffer();
            pack.setObj(codeModel);
            codeModel.createDec();
        }
        toLog(this, "packet DESC sent in port", true);
    }

    @A_Commande(help = "return the fdata value")
    public String getDESC_fdata() {
        DefaultComboBoxModel<String> cbox = getOptions().getValuefor("DESC_fdata", CBstrModel);
        if (cbox.getSelectedItem() == null) {
            return null;
        }
        return cbox.getSelectedItem().toString();
    }

    @A_Commande(help = "set the field to transmit data for bytes mode")
    public void setDESC_fdata(String txt) {
        if (txt != null) {
            if (txt.compareTo(getDESC_fdata()) != 0) {
                DefaultComboBoxModel<String> cbox = getOptions().getValuefor("DESC_fdata", CBstrModel);
                cbox.setSelectedItem(txt);
                //need to update option combo box
            }
        }
    }

    public void setDESC_fdata(javax.swing.DefaultComboBoxModel<String> cbox) {
        setDESC_fdata(cbox.getSelectedItem().toString());
    }

    @A_Commande(help = "return the DESC fcond value")
    public String getDESC_fcond() {
        DefaultComboBoxModel<String> cbox = getOptions().getValuefor("DESC_fcond", CBstrModel);
        if (cbox.getSelectedItem() == null) {
            return "-N/A-";
        }
        return cbox.getSelectedItem().toString();
    }

    public void setDESC_fcond(String txt) {
        if (getDESC_fcond().compareTo(txt) != 0) {
            DefaultComboBoxModel<String> cbox = getOptions().getValuefor("DESC_fcond", CBstrModel);
            cbox.setSelectedItem(txt);
//            option.setValuefor("DESC_fcond", txt);
        }
        boolean bool = getDESC_fcond().compareTo("-N/A-") != 0;
        getOptions().setused("DESC_fcondval", bool);
    }

    public void setDESC_fcond(javax.swing.DefaultComboBoxModel<String> cbox) {
        setDESC_fcond(cbox.getSelectedItem().toString());
    }

    @A_Commande(help = "return the DESC fcondval value")
    public byte[] getDESC_fcondval() {
        return getOptions().getValuefor("DESC_fcondval", new byte[]{});
    }
    @A_Commande(help = "set the DESC fcondval value with % for matching")
    public void setDESC_fcondval(byte[] by) {
         getOptions().setValuefor("DESC_fcondval",by);
    }
    @A_Commande(help = "return the DESC EOL value")
    public boolean isDESC_EOL() {
        Object Obj = getOptions().getValuefor("DESC_EOL");
        return (Boolean) Obj;
    }

    public void setDESC_EOL(boolean bool) {
        if (isDESC_EOL() != bool) {
            getOptions().setValuefor("DESC_EOL", bool);
        }
        getOptions().setused("DESC_EOLval", bool);

    }

    @A_Commande(help = "set data and activate EOL for data transmision for each EOL field")
    public void setDESC_EOL(String txt) {
        if (getDESC_EOLval().compareTo(txt) != 0) {
            getOptions().setValuefor("DESC_EOL", true);
            getOptions().setValuefor("DESC_EOLval", txt);
        }
    }

    public String getDESC_EOLval() {
        Object Obj = getOptions().getValuefor("DESC_EOLval");
        if (Obj != null) {
            return Obj.toString();
        } else {
            return null;
        }
    }

    @A_Commande(help = "return the DESC offset")
    public int getDESC_Offset() {
        return getOptions().getValuefor("DESC_Offset",1);
    }

    public boolean isDESC_TIT() {
       return getOptions().getValuefor("DESC_TIT",true);
    }

    public void setDESC_TIT(boolean bool) {
        if (isDESC_TIT() != bool) {
            getOptions().setValuefor("DESC_TIT", bool);
        }
        getOptions().setused("DESC_TITval", bool);
    }

    public int getDESC_TITval() {
        return getOptions().getValuefor("DESC_TITval",0);
    }

    public void setDESC_TITval(Integer nb) {
        if (getDESC_TITval() != nb) {
            getOptions().setValuefor("DESC_TITval", nb);
        }
    }

    public boolean isDESC_WaitAnsw() {
        return getOptions().getValuefor("DESC_WaitAnsw",true);
    }

    public void setDESC_WaitAnsw(boolean bool) {
        if (getDESC_sendas().startsWith("Model") != bool) {
            getOptions().setValuefor("DESC_WaitAnsw", bool);
        }
        getOptions().setused("DESC_CheckAnsw", bool);
    }
    public boolean isDESC_WaitLimit() {
       return getOptions().getValuefor("DESC_WaitLimit",true);
    }

    public void setDESC_WaitLimit(boolean bool) {
            getOptions().setValuefor("DESC_WaitLimit", bool);

    }
        public int getDESC_WaitLimitval() {
        return getOptions().getValuefor("DESC_WaitLimitval",1);
        
    }

    public void setDESC_WaitLimitval(int nb) {
        getOptions().setValuefor("DESC_WaitLimitval", nb);
    }
    public boolean isDESC_CheckAnsw() {
        Object Obj = getOptions().getValuefor("DESC_CheckAnsw");
        return (Boolean) Obj;
    }

    public boolean isDESC_treeModel() {
        Object Obj = getOptions().getValuefor("DESC_treeModel");
        return (Boolean) Obj;
    }

    @A_Commande(help = "if mod is not a byte mode send model as tree")
    public void setDESC_treeModel(boolean bool) {
        if (isDESC_treeModel() != bool) {
            getOptions().setValuefor("DESC_treeModel", bool);
        }
    }

    public String getDESC_sendas() {
        DefaultComboBoxModel<String> cbox = getOptions().getValuefor("DESC_sendas", CBstrModel);
        if (cbox.getSelectedItem() == null) {
            return null;
        }
        return cbox.getSelectedItem().toString();
    }

    @A_Commande(help = "set the mode ModelTa/ModelTr/as_objval/as_buffer/as_strval/val2byte")
    public void setDESC_sendas(String txt) {
        DefaultComboBoxModel<String> cbox = getOptions().getValuefor("DESC_sendas", CBstrModel);
        if (cbox.getSelectedItem().toString().compareTo(txt) != 0) {
            cbox.setSelectedItem(txt);
        }
        boolean bool = getDESC_sendas().startsWith("Model");
        boolean act = (bool == false) && isDESC_enable();
        getOptions().setused("DESC_EOL", act);
        getOptions().setused("DESC_EOLval", act && getOptions().getValuefor("DESC_EOL", true));
        getOptions().setused("DESC_fcond", act);
        getOptions().setused("DESC_treeModel", act == false);
        getOptions().setused("DESC_fcondval", act);
        getOptions().setused("DESC_fdata", act);
        getOptions().setused("DESC_Offset", act);
        getOptions().setused("DESC_TIT", act);
        getOptions().setused("DESC_TITval", act && getOptions().getValuefor("DESC_TIT", true));
        getOptions().setused("DESC_WaitAnsw", act);
        getOptions().setused("DESC_CheckAnsw", act && getOptions().getValuefor("DESC_WaitAnsw", true));
    }

    public void setDESC_sendas(DefaultComboBoxModel<String> cbm) {
        setDESC_sendas(cbm.getSelectedItem().toString());
    }

    public boolean isDESC_PadTO() {
        Object Obj = getOptions().getValuefor("DESC_PadTO");
        return (Boolean) Obj;
    }

    @A_Commande(help = "activate the waiting for data if requiered by descriptor")
    public void setDESC_PadTO(boolean bool) {
        if (isDESC_PadTO() != bool) {
            getOptions().setValuefor("DESC_PadTO", bool);
        }
        getOptions().setused("DESC_PadTOval", bool);
    }

    public int getDESC_PadTOval() {
        Object Obj = getOptions().getValuefor("DESC_PadTOval");
        return (Integer) Obj;
    }

    @A_Commande(help = "set maximum time (ms) to wait if byte are waited by descriptor")
    public void setDESC_PadTOval(String TO) {
        if (TO == null) {
            return;
        }
        setDESC_PadTOval(new Integer(TO));
    }

    public void setDESC_PadTOval(int TO) {
        if (getDESC_PadTOval() != TO) {
            getOptions().setValuefor("DESC_PadTOval", TO);
        }
    }

    private void init_DESCbox(int state) {
        File descriptor = getDESC_Protofirst();
        if (descriptor == null) {
            System.err.println("try to decode with null Protofirst file");
        } else if (state == 0) {
            this.setDESC_slid(0);
            if (isDESC_enable() == false) {
                // TDeb.wri("=> descriptor is OFF");
                return;
            }
            //fell boxes with descriptor information (fields,...)
            XML2tree a = new XML2tree();

            DefaultTreeModel tm = a.XMLBase(TUtils.getFileStream(descriptor));

            if (tm == null) {
                // TDeb.wri("No XML descriptor for : " + descriptor);
                return;
            }
            String[] fields = getFieldNames((DefaultMutableTreeNode) tm.getRoot(), descriptor.getName());
            if (fields == null) {
                return;
            }
            java.util.Arrays.sort(fields);
            // remove same values (from a protocol to an other)
            java.util.List<String> list = new java.util.ArrayList<>();
            list.add("-N/A-");
            for (int i = 1; i < fields.length; i++) {
                if (fields[i].compareTo(fields[i - 1]) != 0) {
                    list.add(fields[i - 1]);
                }
            }
            list.add(fields[fields.length - 1]);
            fields = new String[list.size()];
            for (int i = 0; i < list.size(); i++) {
                fields[i] = list.get(i).toString();
            }
            //set combo box
            getOptions().setValuefor("DESC_fdata", new javax.swing.DefaultComboBoxModel<>(fields));
            getOptions().setValuefor("DESC_fcond", new javax.swing.DefaultComboBoxModel<>(fields));
            // TDeb.wri("Normal end for Init_DESCbox for " + descriptor);
        } else if (state == 2) {
            this.setDESC_slid(0);
            /*
             * jComboBox20.removeAllItems();
             */
        }
    }
// Used  for for setting DESC field boxes 

    public String[] getFieldNames(DefaultMutableTreeNode node, String decriptor) {
        String descr = decriptor;
        if (descr.lastIndexOf(".") >= 0) {
            descr = descr.substring(0, descr.lastIndexOf("."));
        }
        if (descr.length() > 4) {
            descr = descr.substring(0, 4);
        }
        // get a staring array with all fields names of the tree
        String[] res = new String[1];//offset for "N/A"
        for (int i = 0; i < node.getChildCount(); i++) {
            String[] res1 = new String[1];
            DefaultMutableTreeNode snode = (DefaultMutableTreeNode) node.getChildAt(i);
            XMLres xmlres = (XMLres) snode.getUserObject();
            String nproto = xmlres.getAttrValAsstring("nproto");
            if (xmlres.toString().compareTo("field") == 0) {
                //"type" exist => field and not value...
                res1[0] = descr + "." + xmlres.getName();
                res = TUtils.addtab(res, res1);
            }
            if (snode.getChildCount() > 0) {
                String[] res2 = getFieldNames(snode, descr);
                res = TUtils.addtab(res, res2);
            }
            if (nproto != null) {
                XML2tree a = new XML2tree();
                if (nproto.endsWith(".xml") == false) {
                    nproto += ".xml";
                }
                DefaultTreeModel tm = a.XMLBase(D_Utils.getFileStream(nproto, "Descriptors", getClass().getClassLoader()));
                if (tm != null) {
                    String[] res3 = getFieldNames((DefaultMutableTreeNode) tm.getRoot(), nproto);
                    res = TUtils.addtab(res, res3);
                } else {
                    //TDeb.wri("getfieldname : Could not find descritor : " + nproto);
                }
            }

        }
        // to avoid null fields...
        res = TUtils.trimtab(res);
        return res;

    }
    private void setboxDescenable(boolean bool) {
        //jSlider1.setEnabled(bool);
        getOptions().setused("DESC_Protolast", bool);
        getOptions().setused("DESC_PadTO", bool);
        getOptions().setused("DESC_panel", bool);
        getOptions().setused("DESC_autostack", bool);
    }

    @Override
    public boolean isDESC_EOFstop() {
        return getOptions().getValuefor("DESC_EOFstop", true);
    }

    public void setDESC_EOFstop(boolean bool) {
        getOptions().setValuefor("DESC_EOFstop", bool);
    }

    @Override
    public Options_Model getCMDOptions() {
        return getOptions();
    }

    @Override
    public void setinitDESCPack(C_Packet p) {
        initDescPack = p;
    }

    @Override
    public void CXstop() {
        this.getport().CXstop();
    }

    @Override
    public void read_in(C_Packet packet) {
        getStack().reply_out(this, packet);
    }

    @Override
    public void read_out(C_Packet packet) {
        // in/out managed by Stack 'from_media'
        getStack().reply_out(this, packet);
    }

    @Override
    public void write_out(C_Packet packet) {
        getStack().reply_out(this, packet);
    }

    @Override
    public I_Console getConsole() {
        if ( getStack()!=null){
        return (I_Console) getStack().getCMDParent();
        }
        return null;
    }

    @Override
    public I_Main getMain() {
        if ( getStack()!=null){
        return (I_Main) getStack().getCMDParent();
        }
        return null;
    }

    @Override
    public void setAcc_position(int pos) {
    }

    @Override
    public void setAcc_initsize(int pos) {
    }

    @Override
    public void setDESC_slid(int pos) {
    }

    @Override
    public int getAcc_initsize() {
        return -1;
    }
}
