package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * get a simple DHCPV6 protocol 
 * today only for autodetect 
 * 
 * @author Marc GIBOIN
 * 
 */
public class Stack_DHCPV6 extends Stack_base {


    public Stack_DHCPV6() {
                super();
    }
    public static String getComment() {
        return "Empty DHCP V6 Stack  for matching";
    }

    public static double getosi() {
        return 5.0;
    }
    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
      List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer()==false ||packet.getBytes().length==0){
          return res;
      }
      res.add(packet);
      return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();

        res.add(packet);
        return res;

    }



    @Override
    public double matchProtocol(C_Packet pack) {
          double res = 0.0;
            if (pack.isbuffer()) {
                java.util.List<I_stack_elt> prots=pack.getProtocols();
                if (prots!=null && prots.size()>0 && prots.get(prots.size()-1) instanceof Stack_UDP){
                   Stack_UDP udp=(Stack_UDP) prots.get(prots.size()-1);
                   int src=udp.getOptions().getValuefor("udp_src",1);
                   int dst=udp.getOptions().getValuefor("udp_dest",1);
                   if ((src==546 && dst==547) ||(src==547 && dst==546)){
                       res= 0.9;
                   }
                }
            }
        return res;
    }

}
