package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.Arrays;
import com.jdcm.common.D_Utils;
import java.util.Timer;

/**
 * A stack that convert bytes array stream to tcpdump capture format.
 *
 *
 * @author Marc GIBOIN this dummy may be use to create simple modifiers
 */
public class Stack_Dump extends Stack_base {

    private final D_Utils TUtils = new D_Utils();
    private final com.jdcm.eltrx.I_Port[] ports = new com.jdcm.eltrx.I_Port[2];
    private final byte[] head = new byte[]{(byte) 0xd4, (byte) 0xc3, (byte) 0xb2, (byte) 0xa1, (byte) 0x03, (byte) 0x00,
        (byte) 0x04, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00,
        (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0x00, (byte) 0xff, (byte) 0xff,
        (byte) 0x00, (byte) 0x00, (byte) 0x01, (byte) 0x00, (byte) 0x00, (byte) 0x00
    };

    private long starttime = -1;
    //ports[0]=> source; port[1] destination

    public Stack_Dump() {
        super();
        getOptions().addOption("dump_addeth", false, "boolean", "", true, true, "if transmit add pseudo eth data on the strean to be readable with oth soft");
        getOptions().addOption("dump_waittime", false, "boolean", "", true, true, "if receive, wait for stream delai");
    }

    public static String getComment() {
        return "byte dump format as tcpdump";
    }

    public static double getosi() {
        return 0.0;
    }

    @Override
    public void StkArcv(String message, String type) {
        if (message.compareTo("connected") == 0 && type.compareTo("Status") == 0) {
            getStack().reply_out(this, new C_Packet(head, getport()));
        }
    }

    public boolean isdump_addeth() {
        return (Boolean) getOptions().getValuefor("dump_addeth");
    }

    public void setdump_addeth(boolean bool) {
        if (isdump_addeth() != bool) {
            getOptions().setValuefor("dump_addeth", bool);
        }
    }

    public byte[] createframe(byte[] donnees, long time) {
        if (donnees == null || donnees.length == 0) {
            return null;
        }
//date sec/4
        long time_sec = time / 1000;
        int time_us = (int) (time - (time_sec * 1000)) * 1000;
        byte[] date_sec = TUtils.prend("DEC_I", "" + time_sec);
        date_sec = TUtils.fill_right(date_sec, (byte) 0x00, 4);
        //date mil/4
        byte[] date_mil = TUtils.prend("DEC_I", "" + time_us);
        date_mil = TUtils.fill_right(date_mil, (byte) 0x00, 4);
        // 2 * size / 4
        int frame_size = donnees.length;
        byte[] eth = null;
        if (isdump_addeth() && ports[0] != null && ports[1] != null) {
            frame_size = frame_size + 14;
            // ethernet pour 6scr+6dst+2type=14
            byte[] src = TUtils.prend("DEC", "" + ports[0].getIndex());
            src = TUtils.fill_left(src, (byte) 0x00, 2);
            src = TUtils.addtab(ports[0].getModeName().substring(0, 4).getBytes(), src);
            byte[] dst = TUtils.prend("DEC", "" + ports[1].getIndex());
            dst = TUtils.fill_left(dst, (byte) 0x00, 2);
            dst = TUtils.addtab(ports[1].getModeName().substring(0, 4).getBytes(), dst);
            //type 0x6558/2=> Ethernet transparent bridging
            // te 0x10000=> UNKNOWN
            byte[] type = TUtils.prend("BYTE", "10 00");
            eth = TUtils.addtab(eth, dst);
            eth = TUtils.addtab(eth, src);
            eth = TUtils.addtab(eth, type);
        }
        byte[] taille = TUtils.prend("DEC_I", "" + frame_size);
        taille = TUtils.fill_right(taille, (byte) 0x00, 4);
        byte[] tot = TUtils.addtab(date_sec, date_mil);
        tot = TUtils.addtab(tot, taille);
        tot = TUtils.addtab(tot, taille);
        tot = TUtils.addtab(tot, eth);
        return TUtils.addtab(tot, donnees);
    }

    @Override
    public void onClock() {
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    final public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> res = new java.util.ArrayList<>();
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), true);
        if (pack != null) {
            // remove header if deteceted with forth first byte(?)
            byte[] h = Arrays.copyOfRange(head, 0, 4);
            if (pack.length >= 24) {
                byte[] r = java.util.Arrays.copyOfRange(pack, 0, h.length);
                if (Arrays.equals(h, r)) {
                    pack = java.util.Arrays.copyOfRange(pack, 24, pack.length);
                    starttime = -1;
                }
            }
            //treat packets
            while (pack.length > 0) {
                //dates
                byte[] ms = java.util.Arrays.copyOfRange(pack, 0, 4);
                byte[] us = java.util.Arrays.copyOfRange(pack, 4, 8);
                long timeus = Long.parseLong(TUtils.retire("DEC_I", ms)) * 1000;
                //   java.util.Date dt = new java.util.Date(timeus);
                timeus += (Long.parseLong(TUtils.retire("DEC_I", us)) / 1000);
                java.util.Date dr = new java.util.Date(timeus);
                if (starttime < 0) {
                    starttime = timeus;
                }
                // timein us have to be in ms forTimer, Should NOT be negative but file come from....
                timeus = Math.abs(timeus - starttime);
                pack = java.util.Arrays.copyOfRange(pack, 8, pack.length);
                //size
                int sz = new Integer(TUtils.retire("DEC_I", java.util.Arrays.copyOfRange(pack, 0, 4)));
                byte[] data = java.util.Arrays.copyOfRange(pack, 8, 8 + sz);
                final C_Packet packt = new C_Packet(data, packet.getsource());
                //  packt.setCreatetime(dr);
                // ajouete pour lecture des capture 
                packt.setStoredtime(dr);
                final long delai = timeus;
                final I_stack_elt st = this;
                if ((Boolean) getOptions().getValuefor("dump_waittime") && res.size() > 0) {
                    // perhaps need to be in a Thread?..!?
                    final Timer tim = new java.util.Timer();
                    tim.schedule(new java.util.TimerTask() {
                        @Override
                        public void run() {
                            getStack().reply_in(st, packt);
                        }
                    }, delai);
                } else {
                    getReceivedPacket(packt);
                    res.add(packt);
                }
                pack = java.util.Arrays.copyOfRange(pack, 8 + sz, pack.length);
            }
        }
        return res;
    }

    public void getReceivedPacket(C_Packet p) {
    }

    /**
     * encpsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packets
     * @throws java.lang.Exception
     */
    @Override
    final public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> finalres = new java.util.ArrayList<>();
        toLog(this, "" + packet, false);
        byte[] pack = packet.getBytes();
        if (pack != null) {
            //--- transmit byte[]
            if (isdump_addeth() && getStack() != null && packet.getsource() != null) {
                ports[0] = packet.getsource();
                if (packet.getdestination() != null) {
                    ports[1] = packet.getdestination();
                }
            }
            packet.setObj(createframe(pack, System.currentTimeMillis()));
        } else if (packet.getObj().getClass().getCanonicalName().startsWith("jpcap.packet.")) {
            // ------------JPCAP CAPTURE PACKET------------------------
            if (packet.getObj() instanceof jpcap.packet.Packet) {
                jpcap.packet.Packet eth = (jpcap.packet.Packet) packet.getObj();
                packet.setObj(createframe(TUtils.addtab(eth.header, eth.data), (eth.sec * 1000) + (eth.usec / 1000)));
            }
        }

        finalres.add(packet);
        return finalres;
    }

    @Override
    public double matchProtocol(C_Packet pack) {
        byte[] h = Arrays.copyOfRange(head, 0, 4);

        if (pack.isbuffer()) {
            if (pack.getBytes().length >= 24) {
                byte[] res = java.util.Arrays.copyOfRange(pack.getBytes(), 0, h.length);
                if (Arrays.equals(h, res)) {
                    return 0.99;
                }
            }
        }
        return 0.0;
    }
}
/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
