package com.jdcm.modifiers.stacks;

import com.jdcm.common.D_Utils;
import java.util.Arrays;
import java.net.NetworkInterface;
import com.jdcm.eltrx.I_Port;
import com.jdcm.common.C_Packet;
import com.jdcm.common.O_MACaddress;

/**
 * Curent Etherent protocol
 *
 * @author Marc GIBOIN http://www.frameip.com/
 *
 */
public class Stack_ETHII extends Stack_base {

    private D_Utils TUtils = new D_Utils();
    private java.util.zip.CRC32 crc32 = new java.util.zip.CRC32();

    public Stack_ETHII() {
        byte[] ethsrc = {0x00, 0x1b, -4, 0x33, 0x55, 0x47};
        byte[] ethdst = {0x00, 0x0f, 0x1f, -90, -59, 0x68};
        byte[] ethprot = {0x08, 0x06};
        try {
            getOptions().addOption("eth2_src", new O_MACaddress(ethsrc), "MAC address", "", true, true, "source MAC adress");
            getOptions().addOption("eth2_dest", new O_MACaddress(ethdst), "MAC address", "", true, true, "destination MAC adress");
        } catch (Exception ex) {
        }
        // no sense except for local com???
        getOptions().addOption("eth2_sproto", ethprot, "Byte[]", "", true, true, "Level3 protocol reference");
        getOptions().addOption("eth2_copy", false, "Boolean", "", true, true, "will copy msg dest mac & proto on stack");
        getOptions().addOption("eth2_chksrc", false, "Boolean", "", true, true, "chk msg dest MAC with eth2_src");
        getOptions().addOption("eth2_chkdest", false, "boolean", "", true, true, "filter by eth2_dest");
        getOptions().addOption("eth2_chksproto", false, "boolean", "", true, true, "filter by eth proto");
        javax.swing.JButton b = new javax.swing.JButton("src");
        b.setMargin(new java.awt.Insets(0, 0, 0, 0));
        b.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                getsystemsinfo();
            }
        });
        getOptions().addOption("eth_loadSys", b, "button", "", true, true, "ask for System ETH up adress");
    }

    public static String getComment() {
        return "Ethernet II";
    }

    public static double getosi() {
        return 2.0;
    }

    /**
     * set the PC eth interface UP in eth2_src
     */
    private void getsystemsinfo() {
        NetworkInterface neth;
        java.util.Enumeration<NetworkInterface> ent = null;
        try {
            ent = NetworkInterface.getNetworkInterfaces();
        } catch (java.net.SocketException ex) {
        }
        if (ent != null) {
            while (ent.hasMoreElements()) {
                neth = ent.nextElement();
                try {
                    if (neth.isUp()) {
                        byte[] addr = neth.getHardwareAddress();
                        if (addr != null && addr.length == ((O_MACaddress) getOptions().getValuefor("eth2_src")).getValue().length) {
                            getOptions().setValuefor("eth2_src", new O_MACaddress(addr));
                        }
                    }
                } catch (java.net.SocketException ex) {
                } catch (Exception t) {
                }
            }
        }

    }

    @Override
    public void setParents(I_Port idx, com.jdcm.eltrx.C_Stack modmangt) {
        super.setParents(idx, modmangt);
        if (getport().getModeName().compareTo("ETH") == 0) {
            if (getport().getClass().getName().endsWith("IF_Port")) {
                com.jdcm.eltrx.C_Port p = (com.jdcm.eltrx.C_Port) getport();
                try {
                    byte[] mac = p.getETH_MAC();
                    if (mac != null) {
                        getOptions().setValuefor("eth2_src", new O_MACaddress(mac));
                    }
                } catch (Exception ex) {
                }
            }
        }
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param  packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        byte[] pack = packet.getBytes();
        if (pack == null || pack.length < 15) {
            toLog(this, "size < 15 " + new String(pack), true);
            return null;
            // throw new java.lang.Exception("packet lenght is to short to be an ETHII Packet, size : " + packet.length + "");
        }
        byte[] msgdst = java.util.Arrays.copyOfRange(pack, 0, 6);
        byte[] msgsrc = java.util.Arrays.copyOfRange(pack, 6, 12);
        byte[] msgprot = java.util.Arrays.copyOfRange(pack, 12, 14);
        byte[] msgdata = java.util.Arrays.copyOfRange(pack, 14, pack.length);
        if (msgdata.length == 46 &&msgdata[msgdata.length-1] ==0x00) {// <46??
            // remove null at the end of packet (before at the beginnning???
            //!!!!! if packet lentgh less than 46 and starting by 0X00 !!!!!!!!!=> at the end !!!
            int pos = -1;
            for (int i = msgdata.length-1; msgdata[i] == 0 && i >0; i--) {
                pos = i;
            }
            if (pos!=-1){
            msgdata = java.util.Arrays.copyOfRange(msgdata, 0, pos);
            }
        }
        toLog(this, "dst:" + TUtils.Formate_Hexa(msgdst, true) + ",src:" + TUtils.Formate_Hexa(msgsrc, true) + ",prot:"
                + TUtils.Formate_Hexa(msgprot, true) + ",data:" + TUtils.Formate_Hexa(msgdata, true), true);
        // check dest of tho packet is the source of the module (Reception) : ismy || is brdcast || not checked
        boolean bool = getOptions().getValuefor("eth2_chkdest", true);
        byte[] ethsrc = ((O_MACaddress) getOptions().getValuefor("eth2_src")).getValue();
        byte[] ethdst = ((O_MACaddress) getOptions().getValuefor("eth2_dest")).getValue();
        if (Arrays.equals(msgdst, ethsrc) || Arrays.equals(msgdst, new byte[]{-1, -1, -1, -1, -1, -1}) || bool == false) {
            if (getOptions().getValuefor("eth2_chksrc", true) == false || Arrays.equals(msgsrc, ethdst)) {
                // if (Arrays.equals(res, (byte[]) options.getValuefor("eth2_dest")) ) {
                packet.setObj(msgdata);
                if (msgprot[0] * 256 + msgprot[1] <= 1500) {
                    // trame ETHERNET1 "Xerox"=> packet size
                }

                if (getOptions().getValuefor("eth2_chksproto", true) == false
                        || Arrays.equals(msgprot, (byte[]) getOptions().getValuefor("eth2_sproto"))) {
                    if (getOptions().getValuefor("eth2_copy", true)) {
                        getOptions().setValuefor("eth2_dest", new O_MACaddress(msgdst));
                        getOptions().setValuefor("eth2_src", new O_MACaddress(msgsrc));
                        getOptions().setValuefor("eth2_sproto", msgprot);
                    }
                    // if ARP 0x0806=> OK, if 0x0800=> IP OK also...
                    getReceivedPacket(packet);
                    liste.add(packet);
                    return liste;
                }
            }
        }
        return liste;
    }
    public void getReceivedPacket(C_Packet p){
 
    }
    /**
     * encpsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packets
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) {
        //encapsule
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), false);
        int i = 0;
        //building fragments in fragments List if trame > 1500 (datagram max size)
        java.util.List<byte[]> fragments = new java.util.ArrayList<>();
        while (i < pack.length) {
            int mtu = 1500;
            if (mtu > pack.length - i) {
                fragments.add(Arrays.copyOfRange(pack, i, pack.length));
                i = pack.length;
            } else {
                fragments.add(Arrays.copyOfRange(pack, i, i + mtu));
                i += mtu;
            }
        }
        java.util.List<C_Packet> finalres = new java.util.ArrayList<>();
        for (byte[] data : fragments) {
            if (data.length < 46) {
                // minimum size = 46 => foirreux car les 00 sont mis en debut du dernier paquet.
                // pas de bourrages plus malin ??
                byte[] buff = new byte[46 - data.length];
                java.util.Arrays.fill(buff, (byte) 0x00);
                data = TUtils.addtab(data, buff);
                // data = filltosize(data, 46);
            }
            //preambule : 7 octets of 10101010
            //Start delimiter : 1 octet of 10101011
            byte[] res = null;
            res = TUtils.addtab(res, ((O_MACaddress) getOptions().getValuefor("eth2_dest")).getValue());
            res = TUtils.addtab(res, ((O_MACaddress) getOptions().getValuefor("eth2_src")).getValue());
            res = TUtils.addtab(res, (byte[]) getOptions().getValuefor("eth2_sproto"));
            res = TUtils.addtab(res, data);
            toLog(this, "dst: " + TUtils.Formate_Hexa(((O_MACaddress) getOptions().getValuefor("eth2_dest")).getValue(), true)
                    + ",src: " + TUtils.Formate_Hexa(((O_MACaddress) getOptions().getValuefor("eth2_src")).getValue(), true)
                    + ",prot: " + TUtils.Formate_Hexa((byte[]) getOptions().getValuefor("eth2_sproto"), true)
                    + ",data: " + TUtils.Formate_Hexa(data, false), false);
            /* crc32.update(res);
             byte[] crc=util.prend("DEC", crc32.getValue());
             if (crc.length < 4) {
             crc=filltosize(crc,4);
             }
             res = util.addtab(res, crc );*/
            packet.setObj(res);
            finalres.add(packet);
        }
        return finalres;
    }

    /**
     * fill whith 0x00 before initbuff
     *
     */
    private byte[] filltosize(byte[] initbuff, int newsize) {
        if (initbuff.length < newsize) {
            byte[] buff = new byte[newsize - initbuff.length];
            java.util.Arrays.fill(buff, (byte) 0x00);
            initbuff = TUtils.addtab(buff, initbuff);
        }
        return initbuff;
    }

    /**
     * Apply Options() modification to store receved data and disable checks
     *
     * @param bool
     */
    @Override
    public void setCopyMode(boolean bool) {
        getOptions().setValuefor("eth2_copy", bool);
        getOptions().setValuefor("eth2_chksrc", !bool);
        getOptions().setValuefor("eth2_chkdest", !bool);
        getOptions().setValuefor("eth2_chksproto", !bool);

    }
    /**
     * User for all java byte[-128-128] instead of [0-255]
     *
     * @param by
     * @return
     */
    public int getInt(byte by) {
        return (by >= 0) ? by : 256 + by;
    }
    /**
     * evaluate if the packet list match with this protocol
     *
     * @param pack the list of messages to test 1 is OK
     * @return the 'probabilitie to
     */
    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer()) {
            byte[] frame = pack.getBytes();
            if (frame.length < 14) {
                res = 0.0;
            } else if (pack.getProtocols() != null && pack.getProtocols().isEmpty()==false) {
                res = 0.1;
            } else {
                byte[] prot = java.util.Arrays.copyOfRange(frame, 12, 14);
                int protid=256 * getInt(prot[0]) + getInt(prot[1]);
                if (protid>1500){
                    res=0.8;
                }
                if (frame.length > 1514) {
                    res =  0.2;
                }else {
                    if (prot[0] == 8) {
                        if (frame.length >= 46 && prot[1] == 0 && frame[14] >= 0x45 && frame[14] <= 0x4f) {
                            //IPV4 ..08 00 | 45..
                            res = 0.9986;
                        } else if (frame.length > 30 && prot[1] == 6 && frame[14] == 0 && frame[15] == 1) {
                            //ARP ..08 06 | 00 01 (ETh)..
                            res = 0.9990;
                        }
                    } else if (frame.length ==60 
                            && prot[0] == 0x88 - 0x100 && prot[1] == 0xe1 - 0x100
                            &&frame[14]<8&&frame[14]>=0) {
                        // 0x88 0xe1 => HomePlug AV 
                        // version is only last bit other are 0
                        res = 0.9986;
                    }  else if (frame.length >= 54 && frame.length <= 1514
                            && prot[0] == 0x86 - 0x100 && prot[1] == 0xdd - 0x100
                            && (frame[14] >= 0x60 && frame[14] < 0x70)) {
                        // 0X86 0xdd=>IPV6
                        res = 0.9986;
                    } else if (frame.length ==60
                            && prot[0] == 0x90 - 0x100 && prot[1] == 0x00 // CiSCO loop
                            && frame[0]==0 && frame[1]==5 && frame[2]==0x5e) { // MAC CISCO 
                        // 0X86 0xdd=>IPV6
                        res = 0.9986;
                    }else {
                        res = 0.1;
                    }
                } 
            }
        }
        return res;
    }
}
