package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import com.jdcm.common.D_Utils;
import com.jdcm.common.XML2tree;
import com.jdcm.common.XMLres;
import java.io.File;
import java.io.FileNotFoundException;
import javax.swing.DefaultComboBoxModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 *Used to do some things form a file of expect commands send/receve/... 
 * @author Marc Giboin
 */
public class Stack_Expect extends Stack_baseStart {

    private final D_Utils TUtils = new D_Utils();
    java.util.List<DefaultMutableTreeNode> waitList = null;

    public Stack_Expect() {
        super();
        java.util.List<java.io.File> files = TUtils.getFiles("expect", null);
        getOptions().addOption("exp_file", new DefaultComboBoxModel<>(files.toArray(new File[0])), "file", "", true, true, "the Expect script");
       // getOptions().addOption("exp_timeout", 10, "int", "second", true, true, "timeout for expect");
    }

    @Override
    public boolean onStart() {
        try {
            File f = (File) getOptions().getValuefor("exp_file", new DefaultComboBoxModel<File>()).getSelectedItem();
            XML2tree t = new XML2tree();
            DefaultTreeModel tree = t.XMLBase(new java.io.FileInputStream(f));
            //?? set the tree as A_Event or execute tree?
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree.getRoot();
            if (node.getChildCount() > 0 && ((DefaultMutableTreeNode) node.getChildAt(0)).getUserObject().toString().compareTo("root") == 0) {
                execute(((DefaultMutableTreeNode) node.getChildAt(0)));
            } else {
                return false;
            }
        } catch (FileNotFoundException ex) {
            toLog(this, ex.getMessage(), false);
            return false;
        }
        return true;
    }

    public static String getComment() {
        return "expect-like implementation";
    }

    public static double getosi() {
        return 8.0;
    }

    private void execute(DefaultMutableTreeNode basenode) {
        if (basenode.getUserObject() instanceof XMLres) {
            XMLres name = (XMLres) basenode.getUserObject();
            if (name.getEltName().startsWith("expect")) {
                if (waitList == null) {
                    waitList = new java.util.ArrayList<>();
                    for (int i = 0; i < basenode.getChildCount(); i++) {
                        if (((DefaultMutableTreeNode) basenode.getChildAt(i)).getUserObject().toString().startsWith("receive")) {
                            waitList.add((DefaultMutableTreeNode) basenode.getChildAt(i));
                        }
                    }
                    return;
                }
            } else if (name.getEltName().startsWith("receive")) {
                waitList=null;
            }else if (name.getEltName().startsWith("send")) {
                if (name.getAttrVal("value") instanceof String) {
                    getStack().reply_out(this, new C_Packet(name.getAttrVal("value").toString().getBytes(), getport()));
                }

            } else if (name.getEltName().startsWith("eof")) {
            } else if (name.getEltName().startsWith("exit")) {
                waitList=null;
                this.setStack_isStart();
            } else {
                toLog(this, "unknown : " + name.getName(), false);
            }
            for (int i = 0; i < basenode.getChildCount(); i++) {
                execute((DefaultMutableTreeNode) basenode.getChildAt(i));
            }
        }
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        if (waitList != null) {
            for (DefaultMutableTreeNode waitnode : waitList) {
                if (waitnode.getUserObject() instanceof XMLres) {
                    String waited = ((XMLres) waitnode.getUserObject()).getAttrVal("value").toString();
                    if (waited != null && waited.length() > 0) {
                        if (TUtils.ismatchto(packet.getBytes(), waited.getBytes())) {
                            execute(waitnode);
                            break;
                        }
                    }
                }
            }
        }
        return liste;
    }

    /**
     * encapsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packet
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        liste.add(packet);
        return liste;
    }
}
