package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Simple Generic Routing Encapsulation (GRE) implmentation
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_GRE extends Stack_base {

    public Stack_GRE() {
        super();
    }

    public static String getComment() {
        return "provide a simple GRE";
    }

    public static double getosi() {
        return 5.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), true);
        byte[] flag = java.util.Arrays.copyOfRange(pack, 0, 2);
        byte[] protocol = java.util.Arrays.copyOfRange(pack, 2, 4);
        byte[] length = java.util.Arrays.copyOfRange(pack, 4, 6);
        byte[] callid = java.util.Arrays.copyOfRange(pack, 6, 8);
        byte[] numseq = java.util.Arrays.copyOfRange(pack, 8, 12);
        byte[] data = java.util.Arrays.copyOfRange(pack, 12, pack.length);
        packet.setObj(data);
        res.add(packet);
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), false);
        byte[] flag = new byte[]{3, 1};// change!
        byte[] protocol = new byte[]{3, 1};//88 8B ) > PPPP
        int l = pack.length;
        byte[] length = new byte[]{0, 0};// do not inclus >this data only!!
        byte[] callid = new byte[]{3, 1};// c???
        byte[] numseg = new byte[]{0, 0, 0, 1};// increment
        res.add(packet);
        return res;

    }

    @Override
    public void StkArcv(String message, String type) {
        if (message.compareTo("stopped") == 0 && type.compareTo("Status") == 0) {
        }
        if (message.compareTo("connected") == 0 && type.compareTo("Status") == 0) {
        }
    }

    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer()) {
            if (pack.getBytes().length >= 12) {
                res = 0.2;
                byte[] frame = pack.getBytes();
                byte[] buff = java.util.Arrays.copyOfRange(frame, 4, 6);
                if (256 * buff[0] + buff[1] == frame.length - 12) {
                    res = 0.98;
                    buff = java.util.Arrays.copyOfRange(frame, 2, 4);
                    if (Arrays.equals(buff, new byte[]{8, 11})) { //08 0b => PPP
                        res = 0.99;
                    }
                }
            }
        }
        return res;
    }
}
