package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * TODO : get a simple HTTP protocol today only for autodetect
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_HTTP extends Stack_base {

    public Stack_HTTP() {
        super();
    }

    public static String getComment() {
        return "Empty HTTP Stack  for matching";
    }

    public static double getosi() {
        return 5.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer() == false || packet.getBytes().length == 0) {
            return res;
        }
        int endhdr = (new String(packet.getBytes())).indexOf("\r\n\r\n");
        byte[] hdr = java.util.Arrays.copyOf(packet.getBytes(), endhdr);
         byte[] data;
        int sz= (new String(hdr)).indexOf("Content-Lenght");
        if (sz>0 && sz+endhdr<=packet.getBytes().length){ // whats about fragmentation here
            data = java.util.Arrays.copyOfRange(packet.getBytes(), endhdr+4, endhdr+sz);
        }else{
            data = java.util.Arrays.copyOfRange(packet.getBytes(), endhdr+4, packet.getBytes().length);
        }
        if (data!=null && data.length>0){
            packet.setObj(data);
        }
        res.add(packet);
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();

        res.add(packet);
        return res;

    }

    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer()) {
            java.util.List<I_stack_elt> prots = pack.getProtocols();
            if (prots != null && prots.size() > 0 && prots.get(prots.size() - 1) instanceof Stack_TCP) {
                Stack_TCP tcp = (Stack_TCP) prots.get(prots.size() - 1);
                if (tcp.getOptions().getValuefor("tcp_src", 1) == 80
                        || tcp.getOptions().getValuefor("tcp_dest", 1) == 80
                        || tcp.getOptions().getValuefor("tcp_src", 1) == 8080
                        || tcp.getOptions().getValuefor("tcp_dest", 1) == 8080) {
                  // if i accepte that I will have no TCP data
                   //res = 0.999;
                }
            }
            String txt = new String(pack.getBytes());
            if (txt.length() > 12) {
                int space = txt.indexOf(" ", "HTTP/1.1X ".length());
                int cr = txt.indexOf("\r\n", "HTTP/1.1X ".length());
                if (space < cr && cr > 0 && space > 0) {
                    if (txt.startsWith("HTTP/1.")) {
                        res = 0.99999;
                    } else if (txt.startsWith("GET /") || txt.startsWith("POST /")||txt.startsWith("PUT /")) {
                        //OPTION/TRACE/HEAD/CONNECT/DELETE
                        if (txt.substring(space + 1, space + 6).startsWith("HTTP/")) {
                            res = 0.99999;
                        }
                    }
                }
            }
        }
        return res;
    }
}
