package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import com.jdcm.eltrx.F_Terminal;
import java.awt.event.WindowEvent;
import java.util.List;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFrame;

/**
 * Display a Terminal window to see traffic on a port
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_Log extends Stack_baseStart {

    F_Terminal term = null;

    public Stack_Log() {
        super();
        getOptions().addOption("log_autoScroll", true, "list of string", "", true, true, "set Terminal scrolBar as auto Scroll");
        // create & feel defaults NAME/VAL (&DEFAULT)/TYPE/DESC/USED/NULLONEMPTY/COMMENT
        getOptions().addOption("log_outmode", new DefaultComboBoxModel<>(F_Terminal.outModes), "list of string", "", true, true, "default mode for output");
        getOptions().addOption("log_keep", false, "Boolean", "", true, true, "keep the log screen after port close");
        getOptions().addOption("log_exit", false, "Boolean", "", true, true, "exit process on log close");
    }

    public F_Terminal getlog_Terminal() {
        return term;
    }

    public void setlog_autoScroll(boolean bool) {
        if (term != null && term.isTerm_autoScroll() != bool) {
            term.setTerm_autoScroll(bool);
        }
    }

    public static String getComment() {
        return "log interface for a level";
    }

    public static double getosi() {
        return 0.0;
    }
     public void setlog_exit(boolean bool) {
         if (bool != getOptions().getValuefor("log_exit", true)){
             getOptions().setValuefor("log_exit", bool);
         }
                         if (getOptions().getValuefor("log_exit", true)) {
                    term.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                } else {
                    term.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
                }
     }
     public boolean getlog_exit(){
         return getOptions().getValuefor("log_exit", true);
     }
    public void setlog_outmode(String txt) {
        DefaultComboBoxModel<String> cmd = getOptions().getValuefor("log_outmode", new DefaultComboBoxModel<String>());
        for (int i = 0; i < cmd.getSize(); i++) {
            if (cmd.getElementAt(i).compareTo(txt) == 0) {
                cmd.setSelectedItem(txt);
                if (term != null && term.getTerm_outMode().compareTo(txt) != 0) {
                    term.setTerm_outMode(txt);
                }
            }
        }

    }

    public String getlog_outmode() {
        DefaultComboBoxModel<String> cmd = getOptions().getValuefor("log_outmode", new DefaultComboBoxModel<String>());
        return cmd.getSelectedItem().toString();
    }

    @Override
    public boolean onStart() {
        try {
            if (term == null) {
                term = new F_Terminal(getport().getConsole());
                term.setlockedin(true);
                term.setTitle(toString() + " : " + getport().getModeName() + " [" + this.getlevel() + "]");
                //TODO : NOT WORKING, everything is closed !!!
                term.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
                //not working if F_Main is not Visible??..
                com.jdcm.common.D_Utils.addOpacytyListner(term);
                term.setTerm_outMode(this.getlog_outmode());
                term.setTerm_autoScroll(true);
                term.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowClosing(WindowEvent e) {
                        //  super.windowClosed(e);
                        setStack_isStart(false);
                    }
                });
                setlog_exit(getlog_exit());
                term.setVisible(true);
            }
        } catch (Exception ex) {
            return false;
        }
        return true;
    }

    @Override
    public boolean onStop() {
        if (term != null) {
            term.setVisible(false);
            term = null;
        }
        return true;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        liste.add(packet);
        C_Packet p = (C_Packet) packet.clone();
        if (term != null) {
            if (getOptions().getValuefor("_FromMedia", true)) {
                p.setsource(null);
                p.setstore_srcidx(-1);
            }
            term.write(p);
        }
        return liste;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        liste.add(packet);
        C_Packet p = (C_Packet) packet.clone();
        if (term != null) {
            if (getOptions().getValuefor("_FromMedia", true) == false) {
                p.setsource(null);
                p.setstore_srcidx(-1);
            }
            term.write(p);
        }
        return liste;
    }

    @Override
    public void StkArcv(String message, String type) {
    }
}
