package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;
import com.jdcm.modifiers.modif_PPP;

/**
 * TODO : get a simple PPP protocol today for autodetect and quiqly receive
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_PPP extends Stack_base {

    modif_PPP modifPPP = new modif_PPP();

    public Stack_PPP() {
        super();
        getOptions().addOption("ppp_sproto", -1, "Byte", "", true, true, "Level2/Level3 protocol reference");
        getOptions().addOption("ppp_fcs", -1, "Byte[]", "", true, true, "CheckSumm CCITT16");
    }

    public static String getComment() {
        return "Empty PPP Stack  for matching";
    }

    public static double getosi() {
        return 1.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer() ) {
            byte[] buff = packet.getBytes();
            java.util.List<int[]> frames=new java.util.ArrayList<>();
            for (int i=0;i<buff.length;i++){
                if (buff[i]==0x7e){
                    if (frames.isEmpty()|| frames.get(frames.size()-1)[1]>0){
                        frames.add(new int[]{i,-1});
                    }else{
                         frames.get(frames.size()-1)[1]=i;
                    }
                }
            }
           for (int[] frame:frames){
                    byte[] sbuff = java.util.Arrays.copyOfRange(buff,frame[0]+1, frame[1]);
                    modifPPP.setBuffer(sbuff);
                    modifPPP.ToClear();
                    sbuff = modifPPP.getBuffer();
                    getOptions().setValuefor("ppp_sproto", sbuff[0]);
                    getOptions().setValuefor("ppp_fcs", new Byte[]{sbuff[sbuff.length - 2], sbuff[sbuff.length - 1]});
                 //   if (sbuff[0] == 0x21) {
                         sbuff = java.util.Arrays.copyOfRange(sbuff,1, buff.length-2);
                        C_Packet p = (C_Packet) packet.clone();
                        p.setObj(sbuff);
                        res.add(p);
                    //}
            
        }
        }
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();

        return res;

    }

    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer() && pack.getBytes().length > 5
                && (pack.getBytes()[0] == 0x7e || pack.getBytes()[0] == 0x43)) {
            if (pack.getBytes()[0] == 0x7e && pack.getBytes()[pack.getBytes().length - 1] == 0x7e) {
                res = 0.9;
            }
            // check starting by CLIENT / CLIENTSERVEUR
            if (pack.getBytes()[0] == 0x43 && pack.getBytes()[1] == 0x4c
                    && pack.getBytes()[2] == 0x49 && pack.getBytes()[3] == 0x45
                    && pack.getBytes()[4] == 0x4e && pack.getBytes()[5] == 0x54) {
                String txt = new String(pack.getBytes());
                if (txt.startsWith("CLIENT")) {
                    if (pack.getBytes().length == 6) {
                        res = 0.9;
                    } else if (txt.startsWith("CLIENTSERVER\r\n")) {
                        if (pack.getBytes().length == 14) {
                            // does 0x00 include?
                            res = 0.9;
                        } else {
                            //0x00 after CLIENTSERVEUR
                            byte[] buff = java.util.Arrays.copyOfRange(pack.getBytes(), 15, pack.length());
                            res = matchProtocol(new C_Packet(buff));
                        }
                    }
                }
            }
        }
        return res;
    }
}
