package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;

/**
 * TODO : Spanning Tree Protocol
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_STP extends Stack_baseIP {

    public Stack_STP() {
        super();
        getOptions().addOption("stp_copy", false, "boolean", "", true, true, "will copy msg informations");
    }

    public static String getComment() {
        return "Spanning Tree Protocol";
    }

    public static double getosi() {
        return 2.0;
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param  packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        byte[] frame = packet.getBytes();
        if (frame == null || frame.length == 42) {
            toLog(this, "size < 8 " + new String(frame), true);
        }
        return null;
    }

    /**
     * encpsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packets
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) {
        //encapsule
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), false);
        int i = 0;
        //building fragments in fragments List if trame > 1500 (datagram max size)

        return null;
    }

    /**
     * Apply Options() modification to store receved data and disable checks
     *
     * @param bool
     */
    @Override
    public void setCopyMode(boolean bool) {
        getOptions().setValuefor("stp_copy", bool);
    }

    /**
     * evaluate if the packet list match with this protocol
     *
     * @param data the list of messages to test 1 is OK
     * @return the 'probabilitie to
     */
    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer()) {
            byte[] frame = pack.getBytes();
            if (frame.length < 8) {
                res = 0.0;
            } else {
                if (pack.getProtocols() != null && pack.getProtocols().isEmpty() == false) {
                    if (pack.getProtocols().get(pack.getProtocols().size() - 1) instanceof Stack_IP) {
                        Stack_IP elt = (Stack_IP) pack.getProtocols().get(pack.getProtocols().size() - 1);
                        try {
                            if (elt.getOptions().getValuefor("eth1_src") != null) {
                                res = 0.9999;
                            }
                        } catch (Exception ex) {
                        }
                    } else if (pack.getProtocols().get(pack.getProtocols().size() - 1) instanceof Stack_LLC) {
                        Stack_LLC elt = (Stack_LLC) pack.getProtocols().get(pack.getProtocols().size() - 1);
                        try {
                            if (elt.getOptions().getValuefor("llc_pid", 1) == 267) {
                                res = 0.9999;
                            }
                        } catch (Exception ex) {
                        }
                    }
                } else if (frame.length == 42 && frame[0] == 0 && frame[1] == 0 && frame[2] == 0) {
                    //  protocol identifier STP
                    res = 0.7;
                }
            }
        }
        return res;
    }
}
