package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import com.jdcm.common.D_Utils;

/**
 * Provide a lot of small functions (latency/BER/Pad...)
 *
 * @author Marc GIBOIN
 */
public class Stack_Toolkit extends Stack_base {

    private final D_Utils TUtils = new D_Utils();
    public com.jdcm.eltrx.C_PScan scan = null;
    // buffer only for padtcar carecter buffer could not be treated durring reading so treated with this buffer
    private byte[] padcbuffer = new byte[0];
    private byte[] hdrSzbuffer = null;
    private int buffHdrSz = -1;

    public Stack_Toolkit() {
        super();
        getOptions().addOption("Tlk_EndOfBuff", new byte[0], "Byte[]", "", true, true, "added to each byte[] packets");
        getOptions().addOption("Tlk_BER", false, "bool", "0/1", true, false, "Enable Bit Error Rate");
        getOptions().addOption("Tlk_BERval", -2, "10 minus", "0/1", true, false, "Set Bit Error Rate");
        getOptions().addOption("Tlk_latency", false, "bool", "0/1", true, false, "Enable waiting delay before transmit");
        getOptions().addOption("Tlk_latencyval", 1000, "msec", ">0", true, false, "define waiting delai before transmit");
        getOptions().addOption("Tlk_latencyvar", 0, "msec", ">0", true, false, "define waiting delai variance before transmit");
        getOptions().addOption("Tlk_bw", false, "bool", "0/1", true, false, "enable bandwith limitation");
        getOptions().addOption("Tlk_bwval", 2400, "b/s", ">0", true, false, "define bandwith limitation");
        getOptions().addOption("Tlk_Padt", false, "bool", "0/1", true, false, "Enable Pading message received within time interval");
        getOptions().addOption("Tlk_Padtval", 40, "msec", ">0", true, false, "define PAD time interval");
        getOptions().addOption("Tlk_Padcval", new byte[0], "byte[]", "", true, true, "define PAD caracteres empty if not used");
        getOptions().addOption("Tlk_Padckeep", false, "bool", "O/1", true, false, "define if PAD caractere is send with data");
        getOptions().addOption("Tlk_sendfalse", new byte[0], "byte[]", ">0", true, true, "if received on dcx/stop=> false");
        getOptions().addOption("Tlk_sendtrue", new byte[0], "byte[]", ">0", true, true, "if received on dcx/stop=>true ");
        getOptions().addOption("Tlk_hdrSz", false, "bool", "0/1", true, false, "enable addring of Headerwith Size as binary");
        getOptions().addOption("Tlk_hdrSzsz", 4, "int", ">0", true, true, "the size of the size field before the frame");
        getOptions().addOption("Tlk_hdrSzTot", false, "bool", "0/1", true, true, "true if size include size field");
        getOptions().addOption("Tlk_copyPort", "", "String", "Port Name", true, true, "the name of the port to copy or empty");
    }

    public static String getComment() {
        return "BER/lat/bw/pad/toBool";
    }

    public static double getosi() {
        return 0.0;
    }

    /**
     * return End Of Buffer bytes added to each byte[] packets
     * @return  the end of Buffer value
     */
    public byte[] getTlk_EndOfBuff() {
        //result is banner txtx as byte "31 32 33" (=>"123")
        return getOptions().getValuefor("Tlk_EndOfBuff", new byte[]{});
    }

    /**
     * set return End Of Buffer bytes added to each byte[] packets
     * @param txt
     */
    public void setTlk_EndOfBuff(String txt) {
        try {
            getOptions().setValuefor("Tlk_EndOfBuff", TUtils.string2byte(txt));
        } catch (Exception exe) {
        }
    }

    public void setTlk_EndOfBuff(byte[] tab) {
        getOptions().setValuefor("Tlk_EndOfBuff", tab);
    }

    /**
     * RUFreturn Par_BER value
     * @return true if active
     */
    public boolean isTlk_BER() {
        return getOptions().getValuefor("Tlk_BER", true);
    }

    /**
     * RUFactive Bit Error Rate on interface
     *
     * @param bool
     */
    public void setTlk_BER(boolean bool) {
        if (isTlk_BER() != bool) {
            getOptions().setValuefor("Tlk_BER", bool);
        }
    }

    /**
     * @return value of Bit Error Rate (10-n)
     */
    public int getTlk_BERval() {
        return getOptions().getValuefor("Tlk_BERval", 1);
    }

    /**
     * @return true if Par_latency is activated
     */
    public boolean isTlk_latency() {
        return getOptions().getValuefor("Tlk_latency", true);
    }

    /**
     * active latency function
     * @param bool true if activ
     */
    public void setTlk_latency(boolean bool) {
        if (isTlk_latency() != bool) {
            getOptions().setValuefor("Tlk_latency", bool);
        }
        setscaned();
    }

    /**
     * @return if the BandWidth option is activated
     */
    public boolean isTlk_bw() {
        return getOptions().getValuefor("Tlk_bw", true);
    }

    /**
     * @return latency value (in ms)
     */
    public int getTlk_latencyval() {
        return getOptions().getValuefor("Tlk_latencyval", 1);
    }

    /**
     * set the time (ms) waitted before sending (in and out) a packet
     * @param txtval in milli second
     */
    public void setTlk_latencyval(String txtval) {
        getOptions().setValuefor("Tlk_latencyval", Integer.parseInt(txtval));
    }

    /**
     * @return latency variance
     */
    public int getTlk_latencyvar() {
        return getOptions().getValuefor("Tlk_latencyvar", 1);
    }

    /**
     * set the time varianve (ms) waitted before sending (in and out) a packet
     * @param txtval
     */
    public void setTlk_latencyvar(String txtval) {
        getOptions().setValuefor("Tlk_latencyvar", Integer.parseInt(txtval));
    }

    /**
     * active bandwith limitation
     * @param bool true if active
     */
    public void setPar_bw(boolean bool) {
        getOptions().setValuefor("Par_bw", bool);
        setscaned();
    }

    /**
     * @return Par_bwval value
     */
    public int getTlk_bwval() {
        return getOptions().getValuefor("Tlk_bwval", 1);
    }

    /**
     * set the value in b/s of the bandwith limitation
     * @param txtval b/s bandwith 
     */
    public void setTlk_bwval(String txtval) {
        getOptions().setValuefor("Tlk_bwval", Integer.parseInt(txtval));
    }

    /**
     * @return Padt value
     */
    public boolean isTlk_Padt() {
        return getOptions().getValuefor("Tlk_Padt", true);
    }

    /**
     * @param bool Packet assembly on TO function
     */
    public void setTlk_Padt(boolean bool) {
        if (isTlk_Padt() != bool) {
            getOptions().setValuefor("Tlk_Padt", bool);
        }
        setscaned();
    }

    /**
     * @return Padtval value
     */
    public int getTlk_Padtval() {
        Object Obj = getOptions().getValuefor("Tlk_Padtval");
        return (Integer) Obj;
    }

    /**
     * @param txtval mixumum time (ms) waiting for datas befor sendin packet
     */
    public void setTlk_Padtval(String txtval) {
        getOptions().setValuefor("Tlk_Padtval", Integer.parseInt(txtval));
    }

    /**
     * @return the String waited to send packet of byte (ex : crlf)
     */
    public byte[] getTlk_Padcval() {
        Object o = getOptions().getValuefor("Tlk_Padcval");
        if (o == null) {
            return null;
        } else {
            return (byte[]) o;
        }
    }

    /**
     * @param txtval caracter waitied for byte packet, empty String if none
     */
    public void setTlk_Padcval(String txtval) {
        getOptions().setValuefor("Tlk_Padcval", txtval);
    }

    public void setTlk_Padckeep(boolean bool) {
        getOptions().setValuefor("Tlk_Padckeep", bool);
    }

    /**
     * @return true if par_padckeep is activated
     */
    public boolean isTlk_Padckeep() {
        return getOptions().getValuefor("Tlk_Padckeep", true);
    }

    public byte[] getTlk_sendtrue() {
        return getOptions().getValuefor("Tlk_sendtrue", new byte[]{});
    }

    public void setTlk_sendtrue(String hxtxt) {
        byte[] by = null;
        try {
            by = TUtils.string2byte(hxtxt);
        } catch (Exception exe) {
        }
        if (by == null && hxtxt != null) {
            by = hxtxt.getBytes();
        }
        if (by != null) {
            setTlk_sendtrue(by);
        }
    }

    public void setTlk_sendtrue(byte[] cxstr) {
        getOptions().setValuefor("Tlk_sendtrue", cxstr);
    }

    public byte[] getTlk_sendfalse() {
        return getOptions().getValuefor("Tlk_sendfalse", new byte[]{});
    }

    public void setTlk_sendfalse(String hxtxt) {
        byte[] by = null;
        try {
            by = TUtils.string2byte(hxtxt);
        } catch (Exception exe) {
        }
        if (by == null && hxtxt != null) {
            by = hxtxt.getBytes();
        }
        if (by != null) {
            setTlk_sendfalse(by);
        }
    }

    public void setTlk_sendfalse(byte[] cxstr) {
        getOptions().setValuefor("Tlk_sendfalse", cxstr);
    }

    /**
     * @return true if Header size field adding is activated
     */
    public boolean isTlk_hdrSz() {
        return getOptions().getValuefor("Tlk_hdrSz", true);
    }

    /**
     * @return header Size field size
     */
    public int getTlk_hdrSzsz() {
        return getOptions().getValuefor("Tlk_hdrSzsz", 1);
    }
    public boolean isTlk_hdrSzTot() {
        return getOptions().getValuefor("Tlk_hdrSzTot", true);
    }
    private byte[] procedBER(byte[] data, double berval) {
        if (data == null || berval <= 0) {
            return data;
        }
        for (int i = 0; i
                < data.length; i++) {
            if (Math.random() / berval < 1) {
                int a = data[i];
                double val = 8 * Math.random();
                int bit = 1 << Math.round(val);
                int b = a & bit;
                if (b == 0) {
                    data[i] = (byte) (data[i] | bit);
                } else {
                    data[i] = (byte) (data[i] ^ bit);
                } //System.out.println("===>"+val+">"+bit+":=>"+data[i]);
            }
        }
        return data;
    }

    public boolean isscaned() {
        return scan != null;
    }

    public void setscaned() {
        boolean bool;
        bool = isTlk_Padt() || isTlk_bw() || isTlk_latency();
        if (bool && scan == null) {
            scan = new com.jdcm.eltrx.C_PScan(this);
        }
        if (bool) {
            scan.scanning();
        }
        if (bool == false) {
            if (scan != null) {
                scan.close();
                // !! if packet are stored what append??
                scan = null;
            }
        }
    }

    @Override
    public void StkArcv(String message, String type) {
        if (message.compareTo("connected") == 0 && type.compareTo("Status") == 0) {
        }
        if (message.compareTo("disconnected") == 0 && type.compareTo("Status") == 0) {
        }
    }

    @Override
    public void onClock() {
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param  packet
     * @return the payloads
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> res = new java.util.ArrayList<>();
        toLog(this, "transmit=> " + packet, true);

        //-----------------Lantency / BandWidth => NO only ONE way (well enough difficult like that) -----------------
      /*  if (isscaned()) {
         //scan must be at the last instr. because reply_out
         scan.From_interface(packet);
         } else {*/
        //----------------Header Size remove -----------------
        if (isTlk_hdrSz() && packet.isbuffer()) {
            int hdrLocalSz = -1;
            byte[] szLocalFld = new byte[0];
            if (packet.getBytes().length >= getTlk_hdrSzsz()) {
                szLocalFld = new byte[getTlk_hdrSzsz()];
                System.arraycopy(packet.getBytes(), 0, szLocalFld, 0, szLocalFld.length);
                hdrLocalSz = Integer.parseInt(TUtils.retire("DEC", szLocalFld));
                if (hdrLocalSz > 0 && buffHdrSz == -1) {
                    buffHdrSz = hdrLocalSz;
                }
            }
            if (buffHdrSz == -1 && hdrSzbuffer.length >= getTlk_hdrSzsz()) {
                byte[] fld = new byte[getTlk_hdrSzsz()];
                System.arraycopy(hdrSzbuffer, 0, fld, 0, fld.length);
                buffHdrSz = Integer.parseInt(TUtils.retire("DEC", szLocalFld));
            }
            hdrSzbuffer = TUtils.addtab(hdrSzbuffer, packet.getBytes());
            int dataSize=buffHdrSz;
             int frameSize=buffHdrSz+getTlk_hdrSzsz();
            if (this.isTlk_hdrSzTot()){
                dataSize=buffHdrSz-getTlk_hdrSzsz();
                frameSize=buffHdrSz;
            }
            if (hdrSzbuffer.length == frameSize) {
                byte[] data = new byte[dataSize];
                System.arraycopy(hdrSzbuffer, getTlk_hdrSzsz(), data, 0, data.length);
                packet.setObj(data);
                hdrSzbuffer = null;
                buffHdrSz = -1;
            } else if (packet.getBytes().length == hdrLocalSz + getTlk_hdrSzsz()||
                    (isTlk_hdrSzTot()&&packet.getBytes().length==hdrLocalSz)) {
                // Packet OK, remove size and clear buffer
                byte[] data = new byte[packet.getBytes().length - szLocalFld.length];
                System.arraycopy(packet.getBytes(), szLocalFld.length, data, 0, data.length);
                packet.setObj(data);
                hdrSzbuffer = null;
                buffHdrSz = -1;
            } else if (buffHdrSz > 0 && hdrSzbuffer.length > frameSize) {
                // Do not recursive receve() else unmanageable with other options..
                while (hdrSzbuffer.length >=frameSize) {
                    byte[] next = new byte[hdrSzbuffer.length - frameSize];
                    System.arraycopy(hdrSzbuffer,frameSize, next, 0, next.length);
                    byte[] data = new byte[dataSize];
                    System.arraycopy(hdrSzbuffer, getTlk_hdrSzsz(), data, 0, data.length);
                    C_Packet dataPacket = (C_Packet) packet.clone();
                    dataPacket.setObj(data);
                    getStack().reply_in(this, dataPacket);
                    hdrSzbuffer = next;
                    byte[] fld = new byte[getTlk_hdrSzsz()];
                    System.arraycopy(hdrSzbuffer, 0, fld, 0, fld.length);
                    buffHdrSz = Integer.parseInt(TUtils.retire("DEC", szLocalFld));
                }
                return null;
            } else {
                packet = null;
            }

        }
        //----------------- Copy packet on other port ----------------
       String targetPort=getOptions().getValuefor("Tlk_copyPort","");
        if (targetPort!=null &&targetPort.length()>0){
            Object parent=getStack().getCMDParent();
            if (parent instanceof com.jdcm.eltrx.C_Main){
                 com.jdcm.eltrx.C_Main main=(com.jdcm.eltrx.C_Main)parent;
                 java.util.List childs=main.getCMDChilds(targetPort);
                 for (Object child:childs){
                 if (child instanceof com.jdcm.eltrx.I_Port){
                     ((com.jdcm.eltrx.I_Port)child).read_out(packet);
                 }
                 }
            }
        }
        res.add(packet);
        return res;
        /*}
         return null;*/
    }

    /**
     * encpsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packets
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> res = new java.util.ArrayList<>();
        toLog(this, "transmit=> " + packet, true);
        //-------------End Of Buffeur--------------------------
        if (getTlk_EndOfBuff() != null && packet.isbuffer()) {
            packet.setObj(TUtils.addtab(packet.getBytes(), getTlk_EndOfBuff()));
        }
        //-------------Bit Error Rate--------------------------
        if (isTlk_BER() && packet.isbuffer()) {
            packet.setObj(procedBER(packet.getBytes(), Math.pow(10, getTlk_BERval())));
        }
        //---------------------PAD Caractere--------------------------
        if (getTlk_Padcval() != null && packet.isbuffer()) {
            String endstr = new String(getTlk_Padcval());
            String recvd = new String(packet.getBytes());
            // reading() is mandatory because last byte must be known.
            //check pad carateres in packet to be split if necessary
            while (recvd.indexOf(endstr) != -1 && recvd.indexOf(endstr) != recvd.length() - 1) {
                int pos = recvd.indexOf(endstr);
                byte[] subp = java.util.Arrays.copyOfRange(recvd.getBytes(), 0, pos + 1);
                recvd = recvd.substring(pos + 1);
                receive(new C_Packet(subp, packet.getsource()));
            }
            padcbuffer = TUtils.addtab(padcbuffer, recvd.getBytes());
            if (recvd.endsWith(endstr)) {
                if (isTlk_Padckeep() == false) {
                    padcbuffer = java.util.Arrays.copyOfRange(padcbuffer, 0, padcbuffer.length - getTlk_Padcval().length);
                }
                packet.setObj(padcbuffer);
                padcbuffer = null;
            } else {
                return new java.util.ArrayList<>();
            }
        }

        //--------------Header Size true/false-----------------
        if (isTlk_hdrSz() && packet.isbuffer()) {
            int size=packet.getBytes().length;
            if (isTlk_hdrSzTot()){
                size+=getTlk_hdrSzsz();
            }
                    
            byte[] szField = TUtils.prend("DEC", size);
            if (szField.length > getTlk_hdrSzsz()) {
                toLog(this, "HeaderSize packet too big : for packet size= " + packet.getBytes().length + ", Hdrsz=" + szField.length + " Fieldsize=" + getTlk_hdrSzsz(), true);
                packet = null;
            } else {
                while (szField.length < this.getTlk_hdrSzsz()) {
                    szField = TUtils.addtab(new byte[]{0}, szField);
                }
                packet.setObj(TUtils.addtab(szField, packet.getBytes()));
            }
        }
        //--------------Return true/false-----------------
        if ((getTlk_sendtrue() != null || getTlk_sendfalse() != null) && packet.isbuffer()) {
            if (TUtils.ismatchto(packet.getBytes(), getTlk_sendtrue())) {
                //true priority??
                toLog(this, "found TRUE value: " + new String(getTlk_sendtrue()) + " in: " + new String(packet.getBytes()), true);
                packet.setObj(true);
            } else if (TUtils.ismatchto(packet.getBytes(), getTlk_sendfalse())) {
                toLog(this, "found FALSE value: " + new String(getTlk_sendfalse()) + " in: " + new String(packet.getBytes()), true);
                packet.setObj(false);
            } else {
                packet = null;
            }
        }
        //----------------- Copy packet on other port ----------------
       String targetPort=getOptions().getValuefor("Tlk_copyPort","");
        if (targetPort!=null &&targetPort.length()>0){
            Object parent=getStack().getCMDParent();
            if (parent instanceof com.jdcm.eltrx.C_Main){
                 com.jdcm.eltrx.C_Main main=(com.jdcm.eltrx.C_Main)parent;
                 java.util.List childs=main.getCMDChilds(targetPort);
                 for (Object child:childs){
                 if (child instanceof com.jdcm.eltrx.I_Port){
                     ((com.jdcm.eltrx.I_Port)child).read_out(packet);
                 }
                 }
            }
        }
         //-----------------Lantency / BandWidth / PAD T----------------
        if (isscaned()) {
            //scan must be at the last instr. because reply_out
            scan.From_CX(packet);
        } else {
            res.add(packet);
            return res;
        }
        return null;
    }
}
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
