package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * TODO : get a simple HTTP protocol today only for autodetect
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_VRRP extends Stack_base {

    public Stack_VRRP() {
        super();
    }

    public static String getComment() {
        return "empty VRRP Stack for matching";
    }

    public static double getosi() {
        return 6.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer() == false || packet.getBytes().length == 0) {
            return res;
        }
        res.add(packet);
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();

        res.add(packet);
        return res;

    }

    @Override
    public double matchProtocol(C_Packet pack) {
        // TODO why 0,999 is never reached???
        double res = 0.0;
        if (pack.isbuffer()) {
            java.util.List<I_stack_elt> prots = pack.getProtocols();
            if (prots != null && prots.size() > 0 && prots.get(prots.size() - 1) instanceof Stack_IP) {
                Stack_IP ip = (Stack_IP) prots.get(prots.size() - 1);
                if (ip.getOptions().getValuefor("ip_sproto", 1) == 0x70) {
                    res = 0.999;
                }
            }
        }
        return res;
    }
}
