package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * TODO : get a simple HTTP protocol today only for autodetect
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_ZCB2A extends Stack_base {

    public Stack_ZCB2A() {
        super();
        getOptions().addOption("cb2a_msg", 0, "dec", "", true, true, "the message type");
        setName("CB2A");
    }

    public static String getComment() {
        return "empty CB2A Stack for matching";
    }

    public static double getosi() {
        return 6.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer() == false || packet.getBytes().length < 8) {
            return res;
        } else {
            byte[] frame = packet.getBytes();
            getOptions().setValuefor("cb2a_msg", getBCD(new byte[]{frame[0], frame[1]}));
            if ((frame[0] == 1 || frame[0] == 2)
                    ||(frame[1] == 0|| frame[1] == 1)) {// messages 01:00/01:10 && 02:00/02:10 => CB2A_Auto
                byte[] dest = new byte[frame.length - 2];
                System.arraycopy(frame, 2, dest, 0, dest.length);
                packet.setObj(dest);
                res.add(packet);
            }
        }
        return res;
    }

    private String getBCD(byte b) {
        int i = b;
        if (i < 0) {
            i = i + 256;
        }
        String res = Integer.toHexString(i);
        if (res.length() < 2) {
            res = "0" + res;
        }
        return res;
    }

    private String getBCD(byte ba[]) {
        String res = "";
        for (byte b : ba) {
            res += getBCD(b);
        }
        while (res.startsWith("0") && res.length() > 1) {
            res = res.substring(1);
        }
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();

        res.add(packet);
        return res;

    }

    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer() && pack.getProtocols() != null) {
            boolean isCBCOM = false;
            for (I_stack_elt prot : pack.getProtocols()) {
                if (prot instanceof Stack_ZCBCOM) {
                    isCBCOM = true;
                }
            }

            if (pack.getBytes().length > 12 // message_type & BitMAP
                    && pack.getBytes()[0] != -109 //93=>-109=>FNCI
                    && pack.getBytes()[0] > 0 && pack.getBytes()[0] <= 8
                    && pack.getBytes()[1] >= 0 && pack.getBytes()[1] < 0x80) {//message type are 01:00 to 08:xx;03:70
                if (isCBCOM) {
                    res = 0.999;
                } else {
                    res = 0.6;
                }
            }

        }
        return res;
    }
}
