/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import com.jdcm.tests.verifChq;
import java.lang.reflect.InvocationTargetException;
import javax.swing.DefaultComboBoxModel;

/**
 *Manage verifChq and defini protole CHPN autodetect function
 * @author Marc GIBOIN
 */
public class Stack_ZCHPN extends Stack_zTPE {

    verifChq prochq = null;

    public Stack_ZCHPN() {
        String[] rep = new String[]{"-:NONE","V:FNCI", "T:TRANSAX"};
        DefaultComboBoxModel<String> cmdes = new DefaultComboBoxModel<>(rep);
        getOptions().addOption("chq_spec", cmdes, "raccorcis", "string", true, true, "set tests configurationsfor cheque");
         setName("CHPN");
    }

    public static String getComment() {
        return "Test CHEQUE settings";
    }

    @Override
    public boolean onStart() {
        try {
            Class<?> cl = Class.forName("com.jdcm.tests.verifChq");
            java.util.ArrayList<String> args = new java.util.ArrayList<>();
            DefaultComboBoxModel<String> cmdes = getOptions().getValuefor("chq_spec", new DefaultComboBoxModel<String>());
            String cmd = cmdes.getSelectedItem().toString();
            if (cmd.toUpperCase().contains("NONE")){
                cmd=null;
            }
            if (getOptions().getValuefor("tpe_acq") != null) {
                args.add("-a" + getOptions().getValuefor("tpe_acq"));
            }
             if (getOptions().getValuefor("tpe_cud") != null) {
                args.add("-D" + getOptions().getValuefor("tpe_cud"));
            }
            if (getOptions().getValuefor("tpe_passip") != null) {
                args.add("-b" + getOptions().getValuefor("tpe_passip"));
            }
            if (getOptions().getValuefor("tpe_passtcp") != null) {
                args.add("-p" + getOptions().getValuefor("tpe_passtcp"));
            }
            if (getOptions().getValuefor("tpe_id") != null) {
                args.add("-i" + getOptions().getValuefor("tpe_id"));
            }
            if (getOptions().getValuefor("tpe_host") != null) {
                args.add("-hp" + getOptions().getValuefor("tpe_host"));
            }
            if (getOptions().getValuefor("tpe_host2") != null) {
                args.add("-hs" + getOptions().getValuefor("tpe_host2"));
            }
            if (getOptions().getValuefor("tpe_rang") != null) {
                args.add("-r" + getOptions().getValuefor("tpe_rang"));
            }
            if (getOptions().getValuefor("tpe_cerf") != null) {
                args.add("-cf" + getOptions().getValuefor("tpe_cerf"));
            }
            if (getOptions().getValuefor("tpe_cerf") != null) {
                args.add("-cp" + getOptions().getValuefor("tpe_cerp"));
            }
            if (getOptions().getValuefor("tpe_ssl", true)) {
                args.add("-ssl");
            }
            if (getOptions().getValuefor("tpe_verbose", true)) {
                args.add("-v");
            }
            if (cmd != null) {
                args.add("-" + cmd.substring(0, cmd.indexOf(":")));
            }
            try {
                Object[] objs = verifChq.getArguments(args.toArray(new String[0]));
                for (java.lang.reflect.Constructor<?> c : cl.getConstructors()) {
                    if (c.getParameterTypes().length == objs.length) {
                        prochq = (verifChq) c.newInstance(objs);
                        prochq.setWMethod(this, this.getClass().getMethod("sendLog", String.class));
                        prochq.start();
                    }
                }
            } catch (SecurityException | InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException ex) {
                System.out.println("==>" + ex.getMessage());
            }
        } catch (ClassNotFoundException ex) {
            System.out.println("==>" + ex.getMessage());
            return false;
        }
        return true;
    }

    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer() && pack.getBytes().length > 2) {
            if (pack.getBytes()[0] == -109 || pack.getBytes()[0] == -111) {
                if (pack.getBytes()[1] == 0 || pack.getBytes()[1] == 0x10) {//9300...9110
                    return 0.99;
                }
            }
        }
        return res;
    }
    
}
