package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * TODO : get a simple CHPR protocol today only for autodetect
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_ZCHPR extends Stack_base {

    public Stack_ZCHPR() {
        super();
         setName("CHPR");
    }

    public static String getComment() {
        return "empty IMCHQ for autodetect";
    }

    public static double getosi() {
        return 6.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer() == false || packet.getBytes().length == 0) {
            return res;
        }
        res.add(packet);
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();

        res.add(packet);
        return res;

    }

    @Override
    public double matchProtocol(C_Packet pack) {
        // CHPR is 7 bit + parity protocol with SOH,STX,EOT/ETX,LRC
        
       ///TODO separate C0C1 (!!!7bit) with CHPR???
        double res = 0.0;
        if (pack.isbuffer()) {
            if (pack.getBytes().length>0){ //ends with 03lrc
                if (pack.getBytes()[0]==-127
                        ||pack.getBytes()[0]==-126){
                    if (pack.getBytes().length>2 && pack.getBytes().length<700 && pack.getBytes()[pack.getBytes().length-2]==0x03){
                      // shoud check LRC, check parity  
                    return 0.9;
                }
                }else if (pack.getBytes().length==2&&pack.getBytes()[0]==0x04&& pack.getBytes()[1]==0x7b){
                    //EOT LRC
                     return 0.9;
                }else if (pack.getBytes().length==3&&pack.getBytes()[0]==0x06&& pack.getBytes()[1]==0x03&& pack.getBytes()[2]==-6){
                    //ACK ETX LRC
                     return 0.9;
                }else{
                    //header
                    if ((new String(pack.getBytes())).startsWith("CHEQUE")
                             &&pack.getBytes()[pack.getBytes().length-1]==0x0d){
                        return 0.999;
                    }else if (pack.getBytes()[0]==-115&&pack.getBytes()[1]==0x0a //8d,0a
                            &&pack.getBytes()[pack.getBytes().length-4]==-115
                            &&pack.getBytes()[pack.getBytes().length-3]==0x0a){
                       return 0.8;
                    }
                }
            }
        }
        return res;
    }
}
