package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * TODO : get a simple HTTP protocol today only for autodetect
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_ZNDC extends Stack_base {

    public Stack_ZNDC() {
        super();
         setName("NDC");
    }

    public static String getComment() {
        return "NDC protocol for ATM";
    }

    public static double getosi() {
        return 8.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer() == false || packet.getBytes().length == 0) {
            return res;
        }
        return res;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
        List<C_Packet> res = new ArrayList<>();

        res.add(packet);
        return res;

    }

    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer() && pack.getBytes().length > 3) {
            byte[] frame = pack.getBytes();
            if (frame.length==262){
                System.out.println();
            }
            int sz=frame[1];
            if (sz<0){
                sz=sz+256;
            }
            if (frame[0] * 256 + sz + 2 == frame.length) {
                //aptra : 2 byte for size over NDC
                frame = java.util.Arrays.copyOfRange(frame, 2, frame.length);
            }
            if (frame[2] == 0x1c) {
                /*  java.util.List<I_stack_elt> prots = pack.getProtocols();
                 if (prots != null && prots.size() > 0 && prots.get(prots.size() - 1) instanceof Stack_TCP) {
                 Stack_TCP tcp = (Stack_TCP) prots.get(prots.size() - 1);
                 if (tcp.getOptions().getValuefor("tcp_dest", 1) == 7777) {
                 res = 0.9;
                 }else   if (tcp.getOptions().getValuefor("tcp_src", 1) == 7777) {
                 res = 0.9;
                 }
                 }*/
                boolean sevenbitok = true;
                boolean fspresentok = false;
                for (int i = 0; i < frame.length; i++) {
                    if (frame[i] == 0x1c) {
                        fspresentok = true;
                    } else if (frame[i] < 0x03) {
                        sevenbitok = false;
                    }
                }
                if (sevenbitok && fspresentok) {
                    return 0.9;
                }
            }
        }
        return res;
    }
}
