package com.jdcm.modifiers.stacks;

import com.jdcm.common.D_Utils;
import javax.swing.JToggleButton;

/**
 *  Abstract Basic implementation of a stack protocol (implment a start button)
 * 
 * @author Marc GIBOIN 
 */
public abstract class Stack_baseStart extends Stack_base {
private final D_Utils TUtils = new D_Utils();
    public Stack_baseStart() {
        javax.swing.JToggleButton b = new JToggleButton();
        b.setIcon(TUtils.getIcon("Bt_off_CX.gif"));
        b.setToolTipText("Stop/Start this protocol according to onStart()/onStop()");
        b.setSelectedIcon(TUtils.getIcon("Bt_on_CX.gif"));
        b.setMargin(new java.awt.Insets(0, 0, 0, 0));
        b.setActionCommand(""+b.isSelected());
        b.addActionListener(new java.awt.event.ActionListener() {

            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setStack_isStart();
            }
        });
        getOptions().addOption("stack_start", b, "button", "", true, true, "ask to start session");
    }

    public boolean isStack_isStart() {
        return (getOptions().getValuefor("stack_start",new javax.swing.JToggleButton())).isSelected();
    }
    /**
     * for Options set 
     * @param start
     * @return 
     */
     public boolean setStack_Start(boolean start) {
         return setStack_isStart(start);
     }
    public boolean setStack_isStart() {
        return setStack_isStart(isStack_isStart());
    }

    public boolean setStack_isStart(boolean start) {
        javax.swing.JToggleButton b =getOptions().getValuefor("stack_start",new javax.swing.JToggleButton());
        if ((""+start).compareTo(b.getActionCommand())==0){
            // used to avoid to 'start on started' or 'stop on stoped'...
            return start;
        }
        b.setActionCommand(""+start);
        getOptions().setValuefor("stack_start",b);
        boolean actionOK;
        if (start) {
           actionOK = onStart();
        } else {
            actionOK = onStop();
        }
        if (b.isSelected() != start && actionOK) {
            b.setSelected(start);
        } else if (b.isSelected() == start && actionOK == false) {
            b.setSelected(!start);
        }
        b.setActionCommand(""+b.isSelected());
        b.setToolTipText(""+b.isSelected()); // just for info
        return b.isSelected();
    }

    public boolean onStart() {
        return true;
    }

    public boolean onStop() {
        return true;
    }
}

/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
