package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import com.jdcm.tests.verifCtra;
import java.lang.reflect.InvocationTargetException;
import javax.swing.DefaultComboBoxModel;

/**
 * used as interface with test.verifCtra for frech EFT settings
 *
 * @author Marc GIBOIN
 */
public class Stack_zTPE extends Stack_baseStart {

    verifCtra process = null;

    public Stack_zTPE() {
        super();
        String[] rep = new String[]{"A:test_ctra", "B:test_x25", "AMEX: Amex", "JCB:Jcb", "CB"};
        DefaultComboBoxModel<String> cmdes = new DefaultComboBoxModel<>(rep);
        cmdes.setSelectedItem("CB");
        String[] tasas = new String[]{"10:MPE", "20:VAD", "60:QuasiCash", "80:preauto&PLBS", "90:Other"};
        getOptions().addOption("tpe_acq", "30056", "Banque", "int", true, true, "Code banque");
        getOptions().addOption("tpe_host", "", "X25 adress", "String", true, true, "adresse of the paiement system");
        getOptions().addOption("tpe_host2", "", "X25 adress", "String", true, true, "sec adresse of the paiement system");
        getOptions().addOption("tpe_rang", "001", "rang", "String", true, true, "number of the paiement system in the store");
        getOptions().addOption("tpe_id", "1999025", "Domiciliation", "int", true, true, "Dominicilation TPE ID");
        getOptions().addOption("tpe_itp", "143520180530", "Acceptation point type", "int", true, true, "ITP TPE ID");
        DefaultComboBoxModel<String> tcmdes = new DefaultComboBoxModel<>(tasas);
        getOptions().addOption("tpe_tasa", tcmdes, "type of application", "int", true, true, "type of application of the acaptation point");
        getOptions().addOption("tpe_ssl", true, "isSSL", "boolean", true, true, "set SSL or not");
        getOptions().addOption("tpe_spec", cmdes, "raccorcis", "string", true, true, "set specials configurations");
        getOptions().addOption("tpe_isctl", false, "0/1", "boolean", true, true, "true if tpe is ContactLess");
        getOptions().addOption("tpe_verbose", false, "verb", "boolean", true, true, "set verbose mode");
        getOptions().addOption("tpe_cerf", "Keys/otikfr.jks", "file", "String", true, true, "certificats file");
        getOptions().addOption("tpe_cerp", "123456", "Password", "String", true, true, "Certificats file password");
        getOptions().addOption("tpe_passip", "193.56.46.150", "passerelle", "adresseIP", true, true, "adresse IP de la passerelle IP/X25");
        getOptions().addOption("tpe_passtcp", 5496, "tcpPort", "int", true, true, "port tcp de la passerelle IP/X25");
        getOptions().addOption("tpe_banks", verifCtra.getBankList(), "banks table", "Table<String[]>", true, true, "banks List");
        getOptions().addOption("tpe_cud", "", "String", "cud execept 1000XXXX", true, true, "X25 User Data");
    }

    public static String getComment() {
        return "Test EFT settings";
    }

    public static double getosi() {
        return 6.0;
    }

    public void settpe_tasa(String txt) {
        DefaultComboBoxModel<String> cmdes = getOptions().getValuefor("tpe_tasa", new DefaultComboBoxModel<String>());
        for (int i = 0; i < cmdes.getSize(); i++) {
            if (cmdes.getElementAt(i).startsWith(txt)) {
                cmdes.setSelectedItem(cmdes.getElementAt(i));
            }
        }
    }

    public void settpe_acq(String bq) {
        getOptions().setValuefor("tpe_host", "");
    }

    public void settpe_spec(String txt) {
        if (txt.contains("AMEX") || txt.contains("JCB")) {
            getOptions().setValuefor("tpe_acq", "");
            getOptions().setValuefor("tpe_host", "");
            if (txt.contains("AMEX")) {
                getOptions().setValuefor("tpe_id", "949");
            } else {
                getOptions().setValuefor("tpe_id", "");
            }
            getOptions().setValuefor("tpe_tasa", "90");
        } else if (txt.contains("test_x25") || txt.contains("test_ctra")) {
            getOptions().setValuefor("tpe_id", "");
            getOptions().setValuefor("tpe_host", "");
            getOptions().setValuefor("tpe_acq", "");
        }
    }

    @Override
    public boolean onStop() {
        try {
            if (process != null && process.isAlive()) {
                process.askStop();
            }
            if (getport().getcxstatus().compareTo("stopped") != 0) {
                //      getport().CXstop();
            }
        } catch (Exception ex) {
            return false;
        }
        return true;
    }

    @Override
    public boolean onStart() {
        try {
            Class<?> cl = Class.forName("com.jdcm.tests.verifCtra");
            java.util.ArrayList<String> args = new java.util.ArrayList<>();
            DefaultComboBoxModel<String> cmdes = getOptions().getValuefor("tpe_spec", new DefaultComboBoxModel<String>());
            String cmd = cmdes.getSelectedItem().toString();
            if (cmd != null && cmd.startsWith("CB") == false) {
                args.add("-" + cmd.substring(0, cmd.indexOf(":")));
            } else {
                cmdes = getOptions().getValuefor("tpe_tasa", new DefaultComboBoxModel<String>());
                cmd = cmdes.getSelectedItem().toString();
                args.add("-tasa" + cmd.substring(0, cmd.indexOf(":")));
                if (getOptions().getValuefor("tpe_isctl", true)) {
                    args.add("-cl");
                }
            }
            if (getOptions().getValuefor("tpe_acq") != null) {
                args.add("-a" + getOptions().getValuefor("tpe_acq"));
            }
            if (getOptions().getValuefor("tpe_passip") != null) {
                args.add("-b" + getOptions().getValuefor("tpe_passip"));
            }
             if (getOptions().getValuefor("tpe_cud") != null) {
                args.add("-D" + getOptions().getValuefor("tpe_cud"));
            }
            if (getOptions().getValuefor("tpe_itp") != null) {
                args.add("-itp" + getOptions().getValuefor("tpe_itp"));
            }
            if (getOptions().getValuefor("tpe_passtcp") != null) {
                args.add("-p" + getOptions().getValuefor("tpe_passtcp"));
            }
            if (getOptions().getValuefor("tpe_id") != null) {
                args.add("-i" + getOptions().getValuefor("tpe_id"));
            }
            if (getOptions().getValuefor("tpe_host") != null) {
                args.add("-hp" + getOptions().getValuefor("tpe_host"));
            }
            if (getOptions().getValuefor("tpe_host2") != null) {
                args.add("-hs" + getOptions().getValuefor("tpe_host2"));
            }
            if (getOptions().getValuefor("tpe_rang") != null) {
                args.add("-r" + getOptions().getValuefor("tpe_rang"));
            }
            if (getOptions().getValuefor("tpe_cerf") != null) {
                args.add("-cf" + getOptions().getValuefor("tpe_cerf"));
            }
            if (getOptions().getValuefor("tpe_cerf") != null) {
                args.add("-cp" + getOptions().getValuefor("tpe_cerp"));
            }
            if (getOptions().getValuefor("tpe_ssl", true)) {
                args.add("-ssl");
            }
            if (getOptions().getValuefor("tpe_verbose", true)) {
                args.add("-v");
            }
            try {
                Object[] objs = verifCtra.getArguments(args.toArray(new String[0]));
                for (java.lang.reflect.Constructor<?> c : cl.getConstructors()) {
                    if (c.getParameterTypes().length == objs.length) {
                        process = (verifCtra) c.newInstance(objs);
                        process.setWMethod(this, this.getClass().getMethod("sendLog", String.class));
                        process.start();
                    }
                }
            } catch (SecurityException | InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException | NoSuchMethodException ex) {
                System.out.println("==>" + ex.getMessage());
            }
        } catch (ClassNotFoundException ex) {
            System.out.println("==>" + ex.getMessage());
            return false;
        }
        return true;
    }

    public void sendLog(String txt) {
        if (txt.startsWith("--END--")) {
            setStack_Start(false);
        } else {
            try {
                getStack().reply_out(this, new C_Packet((txt + "\r\n").getBytes()));
            } catch (Exception ex) {
            }
        }
    }

    @Override
    public void StkArcv(String message, String type) {
        if (message.compareTo("connected") == 0 && type.compareTo("Status") == 0) {
        }
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param  packet
     * @return the payloads
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
       // java.util.List<C_Packet> res = new java.util.ArrayList<>();
        byte[] pack = packet.getBytes();
        if (pack != null) {
            toLog(this, new String(pack), true);
        } else {
            toLog(this, "" + packet.getObj(), true);
        }
        if (pack != null) {
            packet.setObj(pack);
        }
    //    res.add(packet);
        return null;
    }

    /**
     * encpsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packets
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> finalres = new java.util.ArrayList<>();
        byte[] pack = packet.getBytes();
        toLog(this, new String(pack), false);
        if (pack != null) {
            packet.setObj(pack);
        }
        finalres.add(packet);
        return finalres;
    }
}
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
