package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import com.jdcm.common.O_Amount;
import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultComboBoxModel;
import javax.swing.SpinnerNumberModel;
import com.jdcm.analyse.Code_Model;
import com.jdcm.eltrx.C_Port;
import com.jdcm.eltrx.C_Stack;
import com.jdcm.eltrx.I_Port;
import java.net.UnknownHostException;

/**
 * Used as ECR simulator for EFT transmissions TODO : isecr=false => manage as
 * an EFT.
 *
 * @author Marc GIBOIN
 */
public class Stack_zconcert extends Stack_baseStart {

    private final String fld3 = "0000000000";

    public Stack_zconcert() {
        super();
        getOptions().addOption("trs_isECR", true, "boolean", "", true, true, "set ECR or EFT role");
        String[] rep = new String[]{"NULL", "CodeModel"};
        getOptions().addOption("trs_isOutput", rep, "String", "", true, true, "return as received 'null' or 'CodeModel'");
        SpinnerNumberModel spm = new SpinnerNumberModel(1, 0, 99, 1);
        getOptions().addOption("trs_ecrNb", spm, "int", "", true, true, "Ecr number 0<x<99");
        // should check that amont >0
        getOptions().addOption("trs_amount", new O_Amount(12.34), "double", "", true, true, "transaction amount for the transaction");
        rep = new String[]{"NONE", "CMC7/PAN", "SHORT"};
        getOptions().addOption("trs_rep", new DefaultComboBoxModel<>(rep), "rep select.", "", true, true, "indicateur de chp de reponse");
        rep = new String[]{"0:CARTE", "C:CHEQUE"};
        getOptions().addOption("trs_ecrMode", new DefaultComboBoxModel<>(rep), "mode select.", "", true, true, "mode de transactions demandées");
        rep = new String[]{"Debit(achat)", "Credit(Remb)", "Annulation", "Duplicata", "Pre Autor"};
        getOptions().addOption("trs_ecrTrsType", new DefaultComboBoxModel<>(rep), "type selet.", "", true, true, "type de transaction");
        rep = new String[]{"Serial", "IPL4"};
        getOptions().addOption("trs_phy", new DefaultComboBoxModel<>(rep), "media", "", true, true, "media utilisé");
        java.net.InetAddress inet = null;
        try {
            inet = java.net.InetAddress.getByName("localhost");
        } catch (UnknownHostException ex) {
            try {
                inet = java.net.InetAddress.getByName("1.1.1.1");
            } catch (UnknownHostException exe) {
                 System.out.println("Stack_zconcert : Pb creatinf IP =>"+ex.getMessage());
            }
        }
        getOptions().addOption("trs_IPaddr", inet, "IPaddr", "", true, true, "adresse du TPE");
        getOptions().addOption("trs_TCPport", 9599, "int", "", true, true, "TCp port du TPE");
        getOptions().addOption("trs_RSport", new DefaultComboBoxModel<>(new String[]{}), "PortCOM list", "", true, true, "used serial port");
        rep = new String[]{"-1:NONE", "0:fin de transaction", "1:immédiate (sans statut)"};
        getOptions().addOption("trs_~ecrDelai", new DefaultComboBoxModel<>(rep), "type selet.", "", true, true, "moment de la réponse du TPE");
        rep = new String[]{"-1:NONE", "0:Carte Demande ", "1:CHQ FNCI", "2:CHQ Garantie"};
        getOptions().addOption("trs_~ecrAuto", new DefaultComboBoxModel<>(rep), "type selet.", "", true, true, "Demande (forcage) une autorisation");
        //--------------- EFT side -------------------------
        rep = new String[]{"0:Effectuee", "7:NonAboutie", "8:Impossible", "9:ReqAck"};
        getOptions().addOption("trs_eftResult", new DefaultComboBoxModel<>(rep), "Status", "", true, true, "Reponses TPE");
        rep = new String[]{"0:Indifferent", "1:Bancaire", "2:AMEX", "3:Aurore", "4:Cetelem", "5:Cofinoga",
            "6:Diners", "7:Pass", "8:Franfinance", "9:JCB", "A:Accord", "C:Cheque", "F:Finaref", "M:Modeus", "O:Moneo", "P:Carte PPR", "X:Mondex"};
        getOptions().addOption("trs_eftIssuer", new DefaultComboBoxModel<>(rep), "modes de paiemnt", "", true, true, "Emmeteur du moyen de paiement");
        setbasics();
    }

    @Override
    public void setParents(I_Port idx, C_Stack modmangt) {
        super.setParents(idx, modmangt);
        DefaultComboBoxModel<Object> cb = ((C_Port) getport()).getCMDOptions().getValuefor("RS_interfaces", new DefaultComboBoxModel<>());
        if (cb != null && cb.getSize() >= 0) {
            getOptions().setValuefor("trs_RSport", cb);
        }
                    settrs_IPaddr((java.net.InetAddress) getOptions().getValuefor("trs_IPaddr"));
            settrs_TCPport(getOptions().getValuefor("trs_TCPport", 1));
    }

    public void settrs_isECR(boolean bool) {
        getStack().setinfos(getport(), "C0C1", SEARCH_DOWN, this, "c0c1_cxbyPort", bool);
    }

    public void settrs_IPaddr(java.net.InetAddress addr) {
        ((C_Port) getport()).setTCP_Addr(addr);
    }

    public void settrs_TCPport(int port) {
        ((C_Port) getport()).setTCP_Port(port);
    }

    public void settrs_RSport(Object port) {
        DefaultComboBoxModel<Object> cb = getOptions().getValuefor("trs_RSport", new DefaultComboBoxModel<>());
        ((C_Port) getport()).setRS_Port(cb.getSelectedItem());
    }

    public String gettrs_phy() {
        DefaultComboBoxModel<String> cmb = getOptions().getValuefor("trs_phy", new DefaultComboBoxModel<String>());
        return cmb.getSelectedItem().toString();
    }

    public void settrs_phy(String portMode) {
        DefaultComboBoxModel<String> cmb = getOptions().getValuefor("trs_phy", new DefaultComboBoxModel<String>());
        if (cmb.getIndexOf(portMode) < 0 || getport().getSIndex() != -1) {// the protocol is over a TPE listner port => don't change
            return;
        }
        if (getport().getcxstatus().compareTo("stopped")!=0&&getport().getcxstatus().compareTo("created")!=0){
            getport().CXstop();
        }
        if (portMode.compareTo(getport().getModeName()) != 0) {
            getport().setModeName(portMode);
        }
        if (portMode.compareTo("IPL4") == 0) {
            ((C_Port) getport()).setTCP_Listner(getOptions().getValuefor("trs_isECR", true) == false);
            ((C_Port) getport()).setTCP_Addr((java.net.InetAddress) getOptions().getValuefor("trs_IPaddr"));
            ((C_Port) getport()).setTCP_Port(getOptions().getValuefor("trs_TCPport", 9599));
        } else if (portMode.compareTo("Serial") == 0) {
            ((C_Port) getport()).setRS_Databit(1200);
            ((C_Port) getport()).setRS_Databit(7);
            ((C_Port) getport()).setRS_Parity("Even");
            ((C_Port) getport()).setRS_FlowCtrl("None");
            ((C_Port) getport()).setRS_Stopbit("1");
        }
        cmb.setSelectedItem(portMode);
        if (getOptions().getValuefor("trs_isECR", true)==false){
            getport().CXstart();
        }
    }

    public static String getComment() {
        return "Provide ECR currency message for french POS";
    }

    public static double getosi() {
        return 8.0;
    }

    private void setbasics() {
        if (getStack() != null && getport() != null) {
            getStack().setinfos(getport(), "C0C1", SEARCH_DOWN, this, "c0c1_maxrcvd", 1);
            getStack().setinfos(getport(), "C0C1", SEARCH_DOWN, this, "c0c1_maxsent", 1);
            getStack().setinfos(getport(), "C0C1", SEARCH_DOWN, this, "c0c1_ManageDLE", false);
        }
    }

    @Override
    public boolean onStart() {
        try {
            if (getport() instanceof C_Port == false) {
                this.setStack_Start(false);
                return false;
            } else {
                setbasics();
                String portstate = getport().getcxstatus();
                if (portstate.compareTo("stopped") == 0 || portstate.compareTo("creating") == 0) {
                    if (getport().getSIndex() == -1) {// the protocol is over a TPE listner port => don't change
                        getport().CXstart();
                    }

                }
                if (getOptions().getValuefor("trs_isECR", true)) {
                    C_Packet d = new C_Packet(getFormatedTransaction(true), getport());
                    d.setdestination(getport());
                    getStack().reply_out(this, d);
                } else {
                    C_Packet d = new C_Packet(getFormatedTransaction(false), getport());
                    d.setdestination(getport());
                    getStack().reply_out(this, d);
                }
            }
        } catch (Exception ex) {
            return false;
        }
        return true;
    }

    @Override
    public boolean onStop() {
        try {
            //TODO : if END is asked by ECR (Cancel) then should stop properly (send a frame?)
            if (getport().getcxstatus().compareTo("stopped") != 0) {
                getport().CXstop();
            }
        } catch (Exception ex) {
            return false;
        }
        return true;
    }

    public byte[] getFormatedTransaction(boolean isAsk) {
        java.text.NumberFormat form = new java.text.DecimalFormat("00");
        int ecr = (Integer) ((SpinnerNumberModel) getOptions().getValuefor("trs_ecrNb")).getValue();
        String ercstr = form.format(ecr);
        O_Amount montant = getOptions().getValuefor("trs_amount", new O_Amount());
        form = new java.text.DecimalFormat("00000000");
        String montantstr = form.format(montant.AMOUNT * 100);
        int monaicode = montant.getISO4217NumCode();
        if (monaicode < 0) {
            monaicode = 978;
        }
        form = new java.text.DecimalFormat("000");
        String monaiestr = form.format(monaicode);
        DefaultComboBoxModel<String> c = getOptions().getValuefor("trs_rep", new DefaultComboBoxModel<String>());
        int rep = c.getIndexOf(c.getSelectedItem());
        c = getOptions().getValuefor("trs_ecrMode", new DefaultComboBoxModel<String>());
        String mode = c.getSelectedItem().toString().substring(0, c.getSelectedItem().toString().indexOf(":"));
        c = getOptions().getValuefor("trs_ecrTrsType", new DefaultComboBoxModel<String>());
        int typ = c.getIndexOf(c.getSelectedItem());
        c = getOptions().getValuefor("trs_~ecrDelai", new DefaultComboBoxModel<String>());
        String delai = c.getSelectedItem().toString().substring(0, c.getSelectedItem().toString().indexOf(":"));
        if (delai.startsWith("-1")) {
            delai = "";
        } else {
            delai = "A01" + delai;
        }
        c = getOptions().getValuefor("trs_~ecrAuto", new DefaultComboBoxModel<String>());
        String auto = c.getSelectedItem().toString().substring(0, c.getSelectedItem().toString().indexOf(":"));
        if (auto.startsWith("-1")) {
            auto = "";
        } else {
            auto = "B01" + auto;
        }
        //--------------EFT implementation-------------
        c = getOptions().getValuefor("trs_eftResult", new DefaultComboBoxModel<String>());
        String result = c.getSelectedItem().toString().substring(0, c.getSelectedItem().toString().indexOf(":"));
        c = getOptions().getValuefor("trs_eftIssuer", new DefaultComboBoxModel<String>());
        String emetteur = c.getSelectedItem().toString().substring(0, c.getSelectedItem().toString().indexOf(":"));
        String res = ercstr;
        if (isAsk) {
            res += montantstr + rep + mode + typ + monaiestr + fld3 + delai + auto;
        } else {
            res += result + montantstr + emetteur;
            if (rep == 1) {
                res += "12345657890123456789012345678901234567890123456789012345";
            }
            res += monaiestr;
            res += "12345657890";
        }
        return res.getBytes();
    }

    private void AssignComboValue(DefaultComboBoxModel<String> cbm, String txt) {
        if (txt == null || txt.length() == 0 || cbm == null || cbm.getSize() == 0) {
            return;
        }
        for (int i = 0; i < cbm.getSize(); i++) {
            int idx = cbm.getElementAt(i).toString().indexOf(":");
            if (idx > 0) {
                String mode = cbm.getElementAt(i).toString().substring(0, idx);
                if (mode.compareTo(txt) == 0) {
                    cbm.setSelectedItem(cbm.getElementAt(i));
                    return;
                }
            }
        }
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        List<C_Packet> res = new ArrayList<>();
        Code_Model code = null;
        if (getOptions().getValuefor("trs_isOutput", "").toLowerCase().startsWith("null")) {
            return null;
        }
        if (packet.isbuffer()) {
            byte[] pack = packet.getBytes();
            toLog(this, new String(pack), true);
            if (getOptions().getValuefor("trs_isECR", true)) {
                // message comes from EFT
                String concertstr = new String(packet.getBytes());
                O_Amount mnt = getOptions().getValuefor("trs_amount", new O_Amount());
                mnt.setCurrency(new Integer(concertstr.substring(12, 15)));
                mnt.setAmount(Double.parseDouble(concertstr.substring(3, 11)) / Math.pow(10.0, new Double(mnt.getCurrency().getDefaultFractionDigits())));
                getOptions().setValuefor("trs_amount", mnt);
                AssignComboValue(getOptions().getValuefor("trs_eftResult", new DefaultComboBoxModel<String>()), concertstr.substring(2, 3));
                AssignComboValue(getOptions().getValuefor("trs_eftIssuer", new DefaultComboBoxModel<String>()), concertstr.substring(11, 12));
                code = new Code_Model(null, ("FT" + concertstr).getBytes(), "zconcert");
            } else if (pack.length > 16) {
                //message comes from ECR
                String ecrnb = new String(java.util.Arrays.copyOfRange(pack, 0, 2));
                getOptions().setValuefor("trs_ecrNb", new javax.swing.SpinnerNumberModel((int) new Integer(ecrnb), 1, 99, 1));
                String mntstr = new String(java.util.Arrays.copyOfRange(pack, 2, 10));
                String cur = new String(java.util.Arrays.copyOfRange(pack, 13, 16));
                O_Amount mnt = getOptions().getValuefor("trs_amount", new O_Amount());
                mnt.setCurrency(new Integer(cur));
                mnt.setAmount(Double.parseDouble(mntstr) / Math.pow(10.0, new Double(mnt.getCurrency().getDefaultFractionDigits())));
                getOptions().setValuefor("trs_amount", mnt);
                String rep = new String(new byte[]{pack[10]});
                String mod = new String(new byte[]{pack[11]});
                String type = new String(new byte[]{pack[12]});
                DefaultComboBoxModel<String> c = (getOptions().getValuefor("trs_rep", new DefaultComboBoxModel<String>()));
                c.setSelectedItem(c.getElementAt(new Integer(rep)));
                AssignComboValue(getOptions().getValuefor("trs_ecrMode", new DefaultComboBoxModel<String>()), mod);
                c = getOptions().getValuefor("trs_ecrTrsType", new DefaultComboBoxModel<String>());
                c.setSelectedItem(c.getElementAt(new Integer(type)));
                String concertstr = "CR" + new String(pack);
                code = new Code_Model(null, concertstr.getBytes(), "zconcert");
            }
        }
        if (code != null) {
            packet.setObj(code);
            res.add(packet);
            return res;
        }
        return null;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols...
        return null;
    }

    @Override
    public void StkArcv(String message, String type) {
        if (message.compareTo("stopped") == 0 && type.compareTo("Status") == 0) {
            setStack_isStart(false);
        }
        setbasics();
        getOptions().setused("trs_IPaddr", getport().getSIndex() == -1);
        getOptions().setused("trs_TCPport", getport().getSIndex() == -1);
        getOptions().setused("trs_phy", getport().getSIndex() == -1);
    }

    @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0;
        if (pack == null || pack.isbuffer() == false || pack.getBytes().length < 10 || pack.getBytes().length > 80) {
            return res;
        }
        String mesg = new String(pack.getBytes());
        int i = 0;
        char z = '0';
        char esp = ' ';
        while (i < mesg.length()) {
            if (i < 11 && (mesg.charAt(i) < z || mesg.charAt(i) > z + 10)) {
                return 0;
            } else if (i > 11 && mesg.charAt(i) != esp && (mesg.charAt(i) < z || mesg.charAt(i) > z + 10)) {
                return 0;
            }
            i++;
        }
        res = 0.81;
        return res;
    }
}
