package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.AWTEventListener;
import java.util.HashSet;
import java.util.Set;
import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.Timer;
// could be use : import java.awt.Toolkit;

/**
 *
 * WINDOWS slave for Window PORT (mouse moves/keyboard input/output...)
 *MOUS CLICK / PRESSED & RELEASE are KO
 * @author Marc GIBOIN
 *
 *
 */
public class T_WIN extends Thread implements I_Slave, java.awt.event.AWTEventListener {

    D_Debug TDeb;
    private final C_Port Parent;
    long started_time = 0;
    com.jdcm.common.D_Utils TUtils = new com.jdcm.common.D_Utils();
    java.awt.Robot robot = null;
    Component source = null;
    MouseObserver mobs = null;
    AWTObserver eobs = null;
    int modif = -1;
    java.awt.Dimension screensz = null;
    Timer scrtimer = null;
    /*MouseObserver is better than ???  BUT concerne ONLY JAVA frames*/
    /* to try : create a fulls screen windows 'always on top', get the clicks and provide them bellow (to the desktop)???
    /*  Toolkit.getDefaultToolkit().addAWTEventListener(new java.awt.event.AWTEventListener() {

     @Override
     public void eventDispatched(AWTEvent event) {
     System.out.println("=> "+event.paramString());
     }
     },java.awt.AWTEvent.MOUSE_EVENT_MASK
     |java.awt.AWTEvent.MOUSE_MOTION_EVENT_MASK
     |java.awt.AWTEvent.MOUSE_WHEEL_EVENT_MASK);
     */


    public T_WIN(C_Port P) {
        Parent = P;
        TDeb = new D_Debug("T-WIN [" + Parent.getIndex() + "] : ");
        TDeb.setconsole(Parent.getConsole());
        source = new JFrame();
        setName(this.getClass().getSimpleName() + ":" + getName());
    }

    @Override
    public int write(C_Packet p) {
        if (Parent.isWIN_sendkeys() == false) {
            return 0;
        }
        try {
            if (p == null || p.getObj() == null) {
                return 0;
            } else if (p.getObj() instanceof String || p.isbuffer()) {
                String txt = p.getObj().toString();
                if (p.isbuffer()) {
                    txt = new String(p.getBytes());
                }
                type(txt);
                return txt.length();
            } else if (p.getObj() instanceof MouseEvent && Parent.isWIN_rcvmousmv()) {
                MouseEvent e = (MouseEvent) p.getObj();
                if (e.getID() == MouseEvent.MOUSE_MOVED) {
                    robot.mouseMove(0, 0);
                } else if (e.getID() == MouseEvent.MOUSE_PRESSED) {
                    robot.mousePress(e.getButton());
                } else if (e.getID() == MouseEvent.MOUSE_RELEASED) {
                    robot.mouseRelease(e.getButton());
                } else if (e.getID() == MouseEvent.MOUSE_WHEEL) {
                    robot.mouseWheel(1);
                }
            } else if (p.getObj() instanceof KeyEvent) {
                KeyEvent e = (KeyEvent) p.getObj();
                if (e.getID() == KeyEvent.KEY_PRESSED) {
                    robot.keyPress(e.getKeyCode());
                } else if (e.getID() == KeyEvent.KEY_RELEASED) {
                    robot.keyRelease(e.getKeyCode());
                } else if (e.getID() == KeyEvent.KEY_TYPED) {
                    robot.keyPress(e.getKeyCode());
                    robot.keyRelease(e.getKeyCode());
                }
            }
        } catch (Throwable ex) {
        }
        return 0;
    }

    private void type(String s) {
        //  byte[] bytes = s.getBytes();
        java.util.ArrayList<Integer> codes;
        if (Parent.getWIN_kbd().endsWith("France")) {
            codes = KeystoSend_FR(s);
        } else if (Parent.getWIN_kbd().endsWith("Basic")) {
            codes = KeystoSend_XX(s);
        } else {
            TDeb.wri("Keyboard not present: " + java.util.Locale.getDefault().getDisplayCountry());
            codes = KeystoSend_XX(s);
        }
        boolean isshifted = false;
        boolean isalt = false;
        boolean isctrl = false;
        for (int code : codes) {
            robot.delay(10);
            try {
                robot.keyPress(code);
                if (code != KeyEvent.VK_SHIFT && code != KeyEvent.VK_ALT && code != KeyEvent.VK_CONTROL) {
                    robot.keyRelease(code);
                    if (isshifted) {
                        robot.keyRelease(KeyEvent.VK_SHIFT);
                        isshifted = false;
                    }
                    if (isalt) {
                        robot.keyRelease(KeyEvent.VK_ALT);
                        isalt = false;
                    }
                    if (isctrl) {
                        robot.keyRelease(KeyEvent.VK_CONTROL);
                        isctrl = false;
                    }
                } else if (code == KeyEvent.VK_SHIFT) {
                    isshifted = true;
                } else if (code == KeyEvent.VK_ALT) {
                    isalt = true;
                } else if (code == KeyEvent.VK_CONTROL) {
                    isctrl = true;
                }
            } catch (Exception ex) {
                TDeb.wri("Pb try to press key for: " + code);
            }
        }
    }

    /**
     * Ftrench Keyboard String to Key translator for unknown local DONOT include
     * ôâ...ä
     *
     * @param txt the text to translate
     * @return the list of key to press
     */
    private java.util.ArrayList<Integer> KeystoSend_FR(String txt) {
        byte[] bytes = txt.getBytes();
        String normal = "<:!*$)^";
        String special = "&é\"'(-è_ç";
        String shifted = ">?./§µ£+";
        String altgr = "@~#{[|`\\]}";
        int[] normalcode = {KeyEvent.VK_LESS, KeyEvent.VK_COLON, KeyEvent.VK_EXCLAMATION_MARK, KeyEvent.VK_MULTIPLY, KeyEvent.VK_DOLLAR, KeyEvent.VK_RIGHT_PARENTHESIS, KeyEvent.VK_DEAD_CIRCUMFLEX};
        int[] shiftedcode = {KeyEvent.VK_LESS, KeyEvent.VK_COMMA, KeyEvent.VK_SEMICOLON, KeyEvent.VK_COLON, KeyEvent.VK_EXCLAMATION_MARK, KeyEvent.VK_MULTIPLY, KeyEvent.VK_DOLLAR, KeyEvent.VK_EQUALS};
        int[] altgrcode = {KeyEvent.VK_0, KeyEvent.VK_2, KeyEvent.VK_3, KeyEvent.VK_4, KeyEvent.VK_5, KeyEvent.VK_6, KeyEvent.VK_7, KeyEvent.VK_8, KeyEvent.VK_RIGHT_PARENTHESIS, KeyEvent.VK_EQUALS};
        java.util.ArrayList<Integer> codes = new java.util.ArrayList<>();
        boolean iscapslock = java.awt.Toolkit.getDefaultToolkit().getLockingKeyState(java.awt.event.KeyEvent.VK_CAPS_LOCK);
        for (int i = 0; i < bytes.length; i++) {
            if (bytes[i] > 96 && bytes[i] < 123) {
                //a..z
                if (iscapslock) {
                    codes.add(16);
                }
                codes.add(bytes[i] - 32);
            } else if (bytes[i] >= 48 && bytes[i] <= 57) {
                // 0...9 via Numeric PAD 
                codes.add(bytes[i] + 48);
            } else if (bytes[i] >= 65 && bytes[i] <= 90) {
                //A..Z
                if (iscapslock == false) {
                    codes.add(KeyEvent.VK_SHIFT);
                }
                codes.add(bytes[i] + 0);
            } else if (special.contains(new java.lang.String(new byte[]{bytes[i]}))) {
                // shifted 1..9
                if (iscapslock) {
                    codes.add(KeyEvent.VK_SHIFT);
                }
                codes.add(49 + special.indexOf(bytes[i]));
            } else if (normal.contains(new java.lang.String(new byte[]{bytes[i]}))) {
                if (iscapslock) {
                    codes.add(16);
                }
                codes.add(normalcode[normal.indexOf(bytes[i])]);
            } else if (altgr.contains(new java.lang.String(new byte[]{bytes[i]}))) {
                codes.add(KeyEvent.VK_CONTROL);
                codes.add(KeyEvent.VK_ALT);
                codes.add(altgrcode[altgr.indexOf(bytes[i])]);
            } else if (shifted.contains(new java.lang.String(new byte[]{bytes[i]}))) {
                if (iscapslock == false) {
                    codes.add(KeyEvent.VK_SHIFT);
                }
                codes.add(shiftedcode[shifted.indexOf(bytes[i])]);
            } else {
                codes.add(bytes[i] + 0);
            }
        }
        return codes;
    }

    /**
     * Basic String to Key translator for unknown local
     *
     * @param txt the text to translate
     * @return the list of key to press
     */
    private java.util.ArrayList<Integer> KeystoSend_XX(String txt) {
        byte[] bytes = txt.getBytes();
        java.util.ArrayList<Integer> codes = new java.util.ArrayList<>();

        for (int i = 0; i < bytes.length; i++) {
            if (bytes[i] > 96 && bytes[i] < 123) {
                codes.add(bytes[i] - 32);
            } else if (bytes[i] >= 48 && bytes[i] <= 57) {
                codes.add(bytes[i] + 48);
            } else {
                codes.add(bytes[i] + 0);
            }
        }
        return codes;
    }

    @Override
    public int sl_start() {
        try {
            robot = new java.awt.Robot();
            screensz = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        } catch (AWTException | HeadlessException ex) {
            return -1;
        }

        return 0;
    }

    @Override
    public int sl_open() {
        if (Parent.isWIN_sendscreen()) {
            scrtimer = new Timer(Parent.getWIN_sendscreenTO(), new ActionListener() {
                @Override
                public synchronized void actionPerformed(ActionEvent e) {
                    java.awt.Image img = robot.createScreenCapture(new java.awt.Rectangle(screensz));
                    Parent.read_in(new C_Packet(img, Parent));

                }
            });
            scrtimer.start();
        }
        //  java.util.EventListener
        if (Parent.isWIN_sendmousmv()) {
            mobs = new MouseObserver(source, Parent.getWIN_sendmousmvTO());
            mobs.addMouseMotionListener(new MouseMotionListener() {
                @Override
                public void mouseMoved(MouseEvent me) {
                    if (Parent.isWIN_sendmousmv()) {
                        Parent.read_in(new C_Packet(me, Parent));
                    }
                }

                @Override
                public void mouseDragged(MouseEvent me) {
                    if (Parent.isWIN_sendmousmv()) {
                        Parent.read_in(new C_Packet(me, Parent.getIndex()));
                    }
                }
            });
            mobs.addMouseEventListener(new MouseListener() {

                @Override
                public void mouseClicked(MouseEvent me) {
                    if (Parent.isWIN_sendmousmv()) {
                        Parent.read_in(new C_Packet(me, Parent.getIndex()));
                    }
                }

                @Override
                public void mousePressed(MouseEvent me) {
                    if (Parent.isWIN_sendmousmv()) {
                        Parent.read_in(new C_Packet(me, Parent.getIndex()));
                    }
                }

                @Override
                public void mouseReleased(MouseEvent me) {
                    if (Parent.isWIN_sendmousmv()) {
                        Parent.read_in(new C_Packet(me, Parent.getIndex()));
                    }
                }

                @Override
                public void mouseEntered(MouseEvent me) {
                    if (Parent.isWIN_sendmousmv()) {
                        Parent.read_in(new C_Packet(me, Parent.getIndex()));
                    }
                }

                @Override
                public void mouseExited(MouseEvent me) {
                    if (Parent.isWIN_sendmousmv()) {
                        Parent.read_in(new C_Packet(me, Parent.getIndex()));
                    }
                }

            });
            mobs.start();
        }
        if (Parent.isWIN_rcvkeys()) {
            eobs = new AWTObserver(source);
            eobs.addAWTListener(new AWTEventListener() {
                @Override
                public void eventDispatched(AWTEvent e) {
                    if (Parent.isWIN_rcvkeys()) {
                        Parent.read_in(new C_Packet(e, Parent));
                    }
                }
            });
            eobs.start();
        }
        return 0;
    }

    @Override
    public int sl_close() {
        if (mobs != null) {
            mobs.stop();
            mobs = null;
        }
        if (eobs != null) {
            eobs.stop();
            eobs = null;
        }
        if (scrtimer != null) {
            scrtimer.stop();
            scrtimer = null;
        }
        robot = null;
        return 0;
    }

    public void wait_State(String state) {
        while (Parent.getcxstatus().compareTo(state) != 0) {
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                //ex.printStackTrace();
            }
        }
    }

    /**
     * Run the SYS Slave
     *
     * no listner on in strean
     *
     */
    @Override
    public void run() {
        wait_State("started");
        if (Parent.isCX_autoopen() && Parent.isCX_openbyslave()) {
            Parent.CXopen();
        }
        // wait_State("opening");
        TDeb.wri("---Start of SYS thread file---");
        while (Parent.isslrunning()) {
            while (Parent.isslreading()) {
                try {
                    sleep(1);
                } catch (InterruptedException ex) {
                }

            }
        }
        //sl_close();
        Parent.CXdisconnect();
        TDeb.wri("---End of SYS thread---");
    }

    @Override
    public void eventDispatched(AWTEvent event) {
        TDeb.wri("T_Win.event.eventDispatched():" + toString());
    }
}

class AWTObserver {
    /* the resolution of the keyboard motion  tracking => NOT WORKING...*/

    private static final int DELAY = 10;
    private Component component;
    private Timer timer;
    final private Set<AWTEventListener> awtListeners;
    private boolean[] states = new boolean[256];

    protected AWTObserver(Component compt) {
        if (compt == null) {
            throw new IllegalArgumentException("Null component not allowed.");
        }

        this.component = compt;

        /* poll mouse coordinates at the given rate */
        timer = new Timer(DELAY, new ActionListener() {

            /* called every DELAY milliseconds to fetch the
             * current mouse coordinates */
            @Override
            public synchronized void actionPerformed(ActionEvent e) {
                // seems to be used in the form...
                // java.awt.EventQueue evtq = java.awt.Toolkit.getDefaultToolkit().getSystemEventQueue();
                for (int i = 1; i < 256; i++) {
                    // NOT OK ONLY FOR : VK_CAPS_LOCK, VK_NUM_LOCK, VK_SCROLL_LOCK, and VK_KANA_LOCK.
                    boolean bool = java.awt.Toolkit.getDefaultToolkit().getLockingKeyState(i);
                    if (bool != states[i]) {
                        states[i] = bool;
                        fireAWTEvent(i);

                    }
                }
            }
        });
        awtListeners = new HashSet<>();
    }

    public Component getComponent() {
        return component;
    }

    public void start() {
        timer.start();
    }

    public void stop() {
        timer.stop();
    }

    public void addAWTListener(AWTEventListener listener) {
        synchronized (awtListeners) {
            awtListeners.add(listener);
        }
    }

    public void removeAWTListener(AWTEventListener listener) {
        synchronized (awtListeners) {
            awtListeners.remove(listener);
        }
    }

    protected void fireAWTEvent(int keycode) {//AWTEvent evt) {
        synchronized (awtListeners) {
            for (final AWTEventListener listener : awtListeners) {
                int id = java.awt.event.KeyEvent.KEY_RELEASED;
                if (states[keycode]) {
                    id = java.awt.event.KeyEvent.KEY_PRESSED;
                }
                int modif = 0;

                final java.awt.event.KeyEvent keyevt = new java.awt.event.KeyEvent(component, id, System.currentTimeMillis(), modif, keycode, " ".charAt(1));
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {
                        listener.eventDispatched(keyevt);
                    }
                });
            }
        }
    }
}

class MouseObserver {
    /* the resolution of the mouse motion */

    private static int DELAY = 10;
    private Component component;
    private Timer timer;
    final private Set<MouseMotionListener> mouseMotionListeners;
    final private Set<MouseListener> mouseEventListeners;

    protected MouseObserver(Component component, int periodms) {
        DELAY = periodms;
        if (component == null) {
            throw new IllegalArgumentException("Null component not allowed.");
        }

        this.component = component;

        /* poll mouse coordinates at the given rate */
        timer = new Timer(DELAY, new ActionListener() {
            private Point lastPoint = MouseInfo.getPointerInfo().getLocation();

            /* called every DELAY milliseconds to fetch the
             * current mouse coordinates */
            @Override
            public synchronized void actionPerformed(ActionEvent e) {
                Point point = MouseInfo.getPointerInfo().getLocation();
                if (!point.equals(lastPoint)) {
                    fireMouseMotionEvent(point);
                } else {
                }
                lastPoint = point;
            }
        });
        mouseMotionListeners = new HashSet<>();
        mouseEventListeners = new HashSet<>();
    }

    public Component getComponent() {
        return component;
    }

    public void start() {
        timer.start();
    }

    public void stop() {
        timer.stop();
    }

    public void addMouseMotionListener(MouseMotionListener listener) {
        synchronized (mouseMotionListeners) {
            mouseMotionListeners.add(listener);
        }
    }

    public void removeMouseMotionListener(MouseMotionListener listener) {
        synchronized (mouseMotionListeners) {
            mouseMotionListeners.remove(listener);
        }
    }

    public void addMouseEventListener(MouseListener listener) {
        synchronized (mouseEventListeners) {
            mouseEventListeners.add(listener);
        }
    }

    public void removeMouseEventListener(MouseListener listener) {
        synchronized (mouseEventListeners) {
            mouseEventListeners.remove(listener);
        }
    }

    protected void fireMouseMotionEvent(Point point) {
        synchronized (mouseMotionListeners) {
            for (final MouseMotionListener listener : mouseMotionListeners) {
                final MouseEvent event = new MouseEvent(component, MouseEvent.MOUSE_MOVED,
                               System.currentTimeMillis(),  0, point.x, point.y, 0, false);
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {
                        listener.mouseMoved(event);
                    }
                });
            }
        }
    }

    protected void fireMouseEvent(Point point) {
        synchronized (mouseEventListeners) {
            for (final MouseListener listener : mouseEventListeners) {
                final MouseEvent event= new java.awt.event.MouseEvent(component, MouseEvent.MOUSE_CLICKED,
                                System.currentTimeMillis(), 0, point.x, point.y, 0, false);
                SwingUtilities.invokeLater(new Runnable() {
                    @Override
                    public void run() {
                        listener.mouseClicked(event);
                    }
                });
            }
        }
    }
}
